/* Application.c generated by valac 0.56.0, the Vala compiler
 * generated from Application.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <handy.h>
#include <granite.h>
#include <locale.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <libgda/libgda.h>
#include <gst/gst.h>

#define GETTEXT_PACKAGE "io.elementary.music"
#define LOCALEDIR "/usr/share/locale"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_APP (music_app_get_type ())
#define MUSIC_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_APP, MusicApp))
#define MUSIC_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_APP, MusicAppClass))
#define MUSIC_IS_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_APP))
#define MUSIC_IS_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_APP))
#define MUSIC_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_APP, MusicAppClass))

typedef struct _MusicApp MusicApp;
typedef struct _MusicAppClass MusicAppClass;
typedef struct _MusicAppPrivate MusicAppPrivate;

#define MUSIC_TYPE_LOCAL_LIBRARY (music_local_library_get_type ())
#define MUSIC_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibrary))
#define MUSIC_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibraryClass))
#define MUSIC_IS_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LOCAL_LIBRARY))
#define MUSIC_IS_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LOCAL_LIBRARY))
#define MUSIC_LOCAL_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibraryClass))

typedef struct _MusicLocalLibrary MusicLocalLibrary;
typedef struct _MusicLocalLibraryClass MusicLocalLibraryClass;
enum  {
	MUSIC_APP_0_PROPERTY,
	MUSIC_APP_NUM_PROPERTIES
};
static GParamSpec* music_app_properties[MUSIC_APP_NUM_PROPERTIES];

#define MUSIC_TYPE_PLAYBACK_MANAGER (music_playback_manager_get_type ())
#define MUSIC_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager))
#define MUSIC_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))
#define MUSIC_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))

typedef struct _MusicPlaybackManager MusicPlaybackManager;
typedef struct _MusicPlaybackManagerClass MusicPlaybackManagerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define MUSIC_TYPE_LIBRARY_WINDOW (music_library_window_get_type ())
#define MUSIC_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow))
#define MUSIC_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))
#define MUSIC_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))

typedef struct _MusicLibraryWindow MusicLibraryWindow;
typedef struct _MusicLibraryWindowClass MusicLibraryWindowClass;

#define MUSIC_TYPE_MEDIA_KEY_LISTENER (music_media_key_listener_get_type ())
#define MUSIC_MEDIA_KEY_LISTENER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_MEDIA_KEY_LISTENER, MusicMediaKeyListener))
#define MUSIC_MEDIA_KEY_LISTENER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_MEDIA_KEY_LISTENER, MusicMediaKeyListenerClass))
#define MUSIC_IS_MEDIA_KEY_LISTENER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_MEDIA_KEY_LISTENER))
#define MUSIC_IS_MEDIA_KEY_LISTENER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_MEDIA_KEY_LISTENER))
#define MUSIC_MEDIA_KEY_LISTENER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_MEDIA_KEY_LISTENER, MusicMediaKeyListenerClass))

typedef struct _MusicMediaKeyListener MusicMediaKeyListener;
typedef struct _MusicMediaKeyListenerClass MusicMediaKeyListenerClass;
typedef struct _Block1Data Block1Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MusicApp {
	GtkApplication parent_instance;
	MusicAppPrivate * priv;
};

struct _MusicAppClass {
	GtkApplicationClass parent_class;
};

struct _MusicAppPrivate {
	MusicLocalLibrary* _library_manager;
};

struct _Block1Data {
	int _ref_count_;
	MusicApp* self;
	GraniteSettings* granite_settings;
	GtkSettings* gtk_settings;
};

static gint MusicApp_private_offset;
static gpointer music_app_parent_class = NULL;
static GSettings* music_app__equalizer_settings;
static GSettings* music_app__equalizer_settings = NULL;
static GSettings* music_app__settings;
static GSettings* music_app__settings = NULL;
static GSettings* music_app__saved_state;
static GSettings* music_app__saved_state = NULL;
static MusicPlaybackManager* music_app__player;
static MusicPlaybackManager* music_app__player = NULL;
static MusicLibraryWindow* music_app__main_window;
static MusicLibraryWindow* music_app__main_window = NULL;

VALA_EXTERN GType music_app_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicApp, g_object_unref)
VALA_EXTERN GType music_local_library_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLocalLibrary, g_object_unref)
VALA_EXTERN GType music_playback_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPlaybackManager, g_object_unref)
VALA_EXTERN GType music_library_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLibraryWindow, g_object_unref)
static void music_app_real_open (GApplication* base,
                          GFile** files,
                          gint files_length1,
                          const gchar* hint);
static MusicLocalLibrary* music_app_get_library_manager (MusicApp* self);
VALA_EXTERN void music_local_library_play_files (MusicLocalLibrary* self,
                                     GFile** files,
                                     gint files_length1);
static void music_app_real_activate (GApplication* base);
VALA_EXTERN MusicLibraryWindow* music_app_get_main_window (void);
VALA_EXTERN MusicLocalLibrary* music_local_library_new (void);
VALA_EXTERN MusicLocalLibrary* music_local_library_construct (GType object_type);
static void music_app_set_library_manager (MusicApp* self,
                                    MusicLocalLibrary* value);
VALA_EXTERN MusicPlaybackManager* music_playback_manager_new (void);
VALA_EXTERN MusicPlaybackManager* music_playback_manager_construct (GType object_type);
static void music_app_set_player (MusicPlaybackManager* value);
VALA_EXTERN MusicLibraryWindow* music_library_window_new (GtkApplication* application);
VALA_EXTERN MusicLibraryWindow* music_library_window_construct (GType object_type,
                                                    GtkApplication* application);
static void music_app_set_main_window (MusicLibraryWindow* value);
VALA_EXTERN void music_library_window_build_ui (MusicLibraryWindow* self);
VALA_EXTERN GType music_media_key_listener_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicMediaKeyListener, g_object_unref)
VALA_EXTERN MusicMediaKeyListener* music_media_key_listener_get_instance (void);
VALA_EXTERN void music_media_key_listener_init (MusicMediaKeyListener* self);
VALA_EXTERN void music_mpris_initialize (void);
VALA_EXTERN MusicApp* music_app_new (void);
VALA_EXTERN MusicApp* music_app_construct (GType object_type);
VALA_EXTERN GSettings* music_app_get_equalizer_settings (void);
static void music_app_set_equalizer_settings (GSettings* value);
VALA_EXTERN GSettings* music_app_get_settings (void);
static void music_app_set_settings (GSettings* value);
VALA_EXTERN GSettings* music_app_get_saved_state (void);
static void music_app_set_saved_state (GSettings* value);
VALA_EXTERN MusicPlaybackManager* music_app_get_player (void);
static GObject * music_app_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void _music_app___lambda179_ (Block1Data* _data1_);
static void __music_app___lambda179__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self);
static void _music_app___lambda180_ (MusicApp* self);
static void __music_app___lambda180__g_simple_action_activate (GSimpleAction* _sender,
                                                        GVariant* parameter,
                                                        gpointer self);
static void music_app_finalize (GObject * obj);
static GType music_app_get_type_once (void);
static void _vala_music_app_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_music_app_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static gint _vala_main (gchar** args,
                 gint args_length1);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
music_app_get_instance_private (MusicApp* self)
{
	return G_STRUCT_MEMBER_P (self, MusicApp_private_offset);
}

static void
music_app_real_open (GApplication* base,
                     GFile** files,
                     gint files_length1,
                     const gchar* hint)
{
	MusicApp * self;
	MusicLocalLibrary* _tmp0_;
	MusicLocalLibrary* _tmp1_;
#line 81 "../src/Application.vala"
	self = (MusicApp*) base;
#line 81 "../src/Application.vala"
	g_return_if_fail (hint != NULL);
#line 83 "../src/Application.vala"
	_tmp0_ = self->priv->_library_manager;
#line 83 "../src/Application.vala"
	if (_tmp0_ == NULL) {
#line 84 "../src/Application.vala"
		g_application_activate ((GApplication*) self);
#line 254 "Application.c"
	}
#line 86 "../src/Application.vala"
	_tmp1_ = self->priv->_library_manager;
#line 86 "../src/Application.vala"
	music_local_library_play_files (_tmp1_, files, (gint) files_length1);
#line 260 "Application.c"
}

static void
music_app_real_activate (GApplication* base)
{
	MusicApp * self;
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	MusicLibraryWindow* _tmp21_;
	MusicLibraryWindow* _tmp22_;
#line 90 "../src/Application.vala"
	self = (MusicApp*) base;
#line 91 "../src/Application.vala"
	_tmp0_ = music_app_get_main_window ();
#line 91 "../src/Application.vala"
	_tmp1_ = _tmp0_;
#line 91 "../src/Application.vala"
	if (_tmp1_ == NULL) {
#line 279 "Application.c"
		MusicLibrariesManager* _tmp2_;
		MusicLocalLibrary* _tmp3_;
		MusicLocalLibrary* _tmp4_;
		MusicPlaybackManager* _tmp5_;
		MusicPlaybackManager* _tmp6_;
		MusicLocalLibrary* _tmp7_;
		MusicLibrariesManager* _tmp8_;
		MusicLocalLibrary* _tmp9_;
		MusicLibraryWindow* _tmp10_;
		MusicLibraryWindow* _tmp11_;
		MusicLibraryWindow* _tmp12_;
		MusicLibraryWindow* _tmp13_;
		MusicMediaKeyListener* _tmp14_;
		MusicMediaKeyListener* _tmp15_;
		MusicPluginsManager* plugins = NULL;
		MusicPluginsManager* _tmp16_;
		MusicPluginsManager* _tmp17_;
		MusicPluginsManager* _tmp18_;
		MusicLibraryWindow* _tmp19_;
		MusicLibraryWindow* _tmp20_;
#line 92 "../src/Application.vala"
		_tmp2_ = music_libraries_manager_new ();
#line 92 "../src/Application.vala"
		_g_object_unref0 (music_libraries_manager);
#line 92 "../src/Application.vala"
		music_libraries_manager = _tmp2_;
#line 94 "../src/Application.vala"
		_tmp3_ = music_local_library_new ();
#line 94 "../src/Application.vala"
		_tmp4_ = _tmp3_;
#line 94 "../src/Application.vala"
		music_app_set_library_manager (self, _tmp4_);
#line 94 "../src/Application.vala"
		_g_object_unref0 (_tmp4_);
#line 95 "../src/Application.vala"
		_tmp5_ = music_playback_manager_new ();
#line 95 "../src/Application.vala"
		_tmp6_ = _tmp5_;
#line 95 "../src/Application.vala"
		music_app_set_player (_tmp6_);
#line 95 "../src/Application.vala"
		_g_object_unref0 (_tmp6_);
#line 96 "../src/Application.vala"
		_tmp7_ = self->priv->_library_manager;
#line 96 "../src/Application.vala"
		music_library_initialize_library ((MusicLibrary*) _tmp7_);
#line 97 "../src/Application.vala"
		_tmp8_ = music_libraries_manager;
#line 97 "../src/Application.vala"
		_tmp9_ = self->priv->_library_manager;
#line 97 "../src/Application.vala"
		music_libraries_manager_add_library (_tmp8_, (MusicLibrary*) _tmp9_);
#line 98 "../src/Application.vala"
		_tmp10_ = music_library_window_new ((GtkApplication*) self);
#line 98 "../src/Application.vala"
		g_object_ref_sink (_tmp10_);
#line 98 "../src/Application.vala"
		_tmp11_ = _tmp10_;
#line 98 "../src/Application.vala"
		music_app_set_main_window (_tmp11_);
#line 98 "../src/Application.vala"
		_g_object_unref0 (_tmp11_);
#line 99 "../src/Application.vala"
		_tmp12_ = music_app_get_main_window ();
#line 99 "../src/Application.vala"
		_tmp13_ = _tmp12_;
#line 99 "../src/Application.vala"
		music_library_window_build_ui (_tmp13_);
#line 101 "../src/Application.vala"
		_tmp14_ = music_media_key_listener_get_instance ();
#line 101 "../src/Application.vala"
		_tmp15_ = _tmp14_;
#line 101 "../src/Application.vala"
		music_media_key_listener_init (_tmp15_);
#line 103 "../src/Application.vala"
		music_mpris_initialize ();
#line 105 "../src/Application.vala"
		_tmp16_ = music_plugins_manager_get_default ();
#line 105 "../src/Application.vala"
		plugins = _tmp16_;
#line 106 "../src/Application.vala"
		_tmp17_ = plugins;
#line 106 "../src/Application.vala"
		music_plugins_manager_hook_app (_tmp17_, (GtkApplication*) self);
#line 107 "../src/Application.vala"
		_tmp18_ = plugins;
#line 107 "../src/Application.vala"
		_tmp19_ = music_app_get_main_window ();
#line 107 "../src/Application.vala"
		_tmp20_ = _tmp19_;
#line 107 "../src/Application.vala"
		g_signal_emit_by_name (_tmp18_, "hook-new-window", (GtkWindow*) _tmp20_);
#line 91 "../src/Application.vala"
		_g_object_unref0 (plugins);
#line 374 "Application.c"
	}
#line 110 "../src/Application.vala"
	_tmp21_ = music_app_get_main_window ();
#line 110 "../src/Application.vala"
	_tmp22_ = _tmp21_;
#line 110 "../src/Application.vala"
	gtk_window_present ((GtkWindow*) _tmp22_);
#line 382 "Application.c"
}

MusicApp*
music_app_construct (GType object_type)
{
	MusicApp * self = NULL;
#line 29 "../src/Application.vala"
	self = (MusicApp*) g_object_new (object_type, NULL);
#line 29 "../src/Application.vala"
	return self;
#line 393 "Application.c"
}

MusicApp*
music_app_new (void)
{
#line 29 "../src/Application.vala"
	return music_app_construct (MUSIC_TYPE_APP);
#line 401 "Application.c"
}

GSettings*
music_app_get_equalizer_settings (void)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 30 "../src/Application.vala"
	_tmp0_ = music_app__equalizer_settings;
#line 30 "../src/Application.vala"
	result = _tmp0_;
#line 30 "../src/Application.vala"
	return result;
#line 415 "Application.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/Application.vala"
	return self ? g_object_ref (self) : NULL;
#line 423 "Application.c"
}

static void
music_app_set_equalizer_settings (GSettings* value)
{
	GSettings* _tmp0_;
#line 30 "../src/Application.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/Application.vala"
	_g_object_unref0 (music_app__equalizer_settings);
#line 30 "../src/Application.vala"
	music_app__equalizer_settings = _tmp0_;
#line 436 "Application.c"
}

GSettings*
music_app_get_settings (void)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 31 "../src/Application.vala"
	_tmp0_ = music_app__settings;
#line 31 "../src/Application.vala"
	result = _tmp0_;
#line 31 "../src/Application.vala"
	return result;
#line 450 "Application.c"
}

static void
music_app_set_settings (GSettings* value)
{
	GSettings* _tmp0_;
#line 31 "../src/Application.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 31 "../src/Application.vala"
	_g_object_unref0 (music_app__settings);
#line 31 "../src/Application.vala"
	music_app__settings = _tmp0_;
#line 463 "Application.c"
}

GSettings*
music_app_get_saved_state (void)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 32 "../src/Application.vala"
	_tmp0_ = music_app__saved_state;
#line 32 "../src/Application.vala"
	result = _tmp0_;
#line 32 "../src/Application.vala"
	return result;
#line 477 "Application.c"
}

static void
music_app_set_saved_state (GSettings* value)
{
	GSettings* _tmp0_;
#line 32 "../src/Application.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 32 "../src/Application.vala"
	_g_object_unref0 (music_app__saved_state);
#line 32 "../src/Application.vala"
	music_app__saved_state = _tmp0_;
#line 490 "Application.c"
}

MusicPlaybackManager*
music_app_get_player (void)
{
	MusicPlaybackManager* result;
	MusicPlaybackManager* _tmp0_;
#line 33 "../src/Application.vala"
	_tmp0_ = music_app__player;
#line 33 "../src/Application.vala"
	result = _tmp0_;
#line 33 "../src/Application.vala"
	return result;
#line 504 "Application.c"
}

static void
music_app_set_player (MusicPlaybackManager* value)
{
	MusicPlaybackManager* _tmp0_;
#line 33 "../src/Application.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 33 "../src/Application.vala"
	_g_object_unref0 (music_app__player);
#line 33 "../src/Application.vala"
	music_app__player = _tmp0_;
#line 517 "Application.c"
}

static MusicLocalLibrary*
music_app_get_library_manager (MusicApp* self)
{
	MusicLocalLibrary* result;
	MusicLocalLibrary* _tmp0_;
#line 34 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/Application.vala"
	_tmp0_ = self->priv->_library_manager;
#line 34 "../src/Application.vala"
	result = _tmp0_;
#line 34 "../src/Application.vala"
	return result;
#line 533 "Application.c"
}

static void
music_app_set_library_manager (MusicApp* self,
                               MusicLocalLibrary* value)
{
	MusicLocalLibrary* _tmp0_;
#line 34 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Application.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 34 "../src/Application.vala"
	_g_object_unref0 (self->priv->_library_manager);
#line 34 "../src/Application.vala"
	self->priv->_library_manager = _tmp0_;
#line 549 "Application.c"
}

MusicLibraryWindow*
music_app_get_main_window (void)
{
	MusicLibraryWindow* result;
	MusicLibraryWindow* _tmp0_;
#line 35 "../src/Application.vala"
	_tmp0_ = music_app__main_window;
#line 35 "../src/Application.vala"
	result = _tmp0_;
#line 35 "../src/Application.vala"
	return result;
#line 563 "Application.c"
}

static void
music_app_set_main_window (MusicLibraryWindow* value)
{
	MusicLibraryWindow* _tmp0_;
#line 35 "../src/Application.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 35 "../src/Application.vala"
	_g_object_unref0 (music_app__main_window);
#line 35 "../src/Application.vala"
	music_app__main_window = _tmp0_;
#line 576 "Application.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 43 "../src/Application.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 43 "../src/Application.vala"
	return _data1_;
#line 586 "Application.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 43 "../src/Application.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 596 "Application.c"
		MusicApp* self;
#line 43 "../src/Application.vala"
		self = _data1_->self;
#line 43 "../src/Application.vala"
		_g_object_unref0 (_data1_->gtk_settings);
#line 43 "../src/Application.vala"
		_g_object_unref0 (_data1_->granite_settings);
#line 43 "../src/Application.vala"
		_g_object_unref0 (self);
#line 43 "../src/Application.vala"
		g_slice_free (Block1Data, _data1_);
#line 608 "Application.c"
	}
}

static void
_music_app___lambda179_ (Block1Data* _data1_)
{
	MusicApp* self;
	GtkSettings* _tmp0_;
	GraniteSettings* _tmp1_;
	GraniteSettingsColorScheme _tmp2_;
	GraniteSettingsColorScheme _tmp3_;
#line 67 "../src/Application.vala"
	self = _data1_->self;
#line 68 "../src/Application.vala"
	_tmp0_ = _data1_->gtk_settings;
#line 68 "../src/Application.vala"
	_tmp1_ = _data1_->granite_settings;
#line 68 "../src/Application.vala"
	_tmp2_ = granite_settings_get_prefers_color_scheme (_tmp1_);
#line 68 "../src/Application.vala"
	_tmp3_ = _tmp2_;
#line 68 "../src/Application.vala"
	g_object_set (_tmp0_, "gtk-application-prefer-dark-theme", _tmp3_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK, NULL);
#line 632 "Application.c"
}

static void
__music_app___lambda179__g_object_notify (GObject* _sender,
                                          GParamSpec* pspec,
                                          gpointer self)
{
#line 67 "../src/Application.vala"
	_music_app___lambda179_ (self);
#line 642 "Application.c"
}

static void
_music_app___lambda180_ (MusicApp* self)
{
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
#line 73 "../src/Application.vala"
	_tmp0_ = music_app_get_main_window ();
#line 73 "../src/Application.vala"
	_tmp1_ = _tmp0_;
#line 73 "../src/Application.vala"
	if (_tmp1_ != NULL) {
#line 656 "Application.c"
		MusicLibraryWindow* _tmp2_;
		MusicLibraryWindow* _tmp3_;
#line 74 "../src/Application.vala"
		_tmp2_ = music_app_get_main_window ();
#line 74 "../src/Application.vala"
		_tmp3_ = _tmp2_;
#line 74 "../src/Application.vala"
		gtk_window_present_with_time ((GtkWindow*) _tmp3_, (guint32) g_get_monotonic_time ());
#line 665 "Application.c"
	}
}

static void
__music_app___lambda180__g_simple_action_activate (GSimpleAction* _sender,
                                                   GVariant* parameter,
                                                   gpointer self)
{
#line 72 "../src/Application.vala"
	_music_app___lambda180_ ((MusicApp*) self);
#line 676 "Application.c"
}

static GObject *
music_app_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicApp * self;
	Block1Data* _data1_;
	GApplicationFlags _tmp0_;
	GApplicationFlags _tmp1_;
	GtkIconTheme* default_theme = NULL;
	GtkIconTheme* _tmp2_;
	GtkIconTheme* _tmp3_;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp4_;
	GtkCssProvider* _tmp5_;
	GdkScreen* _tmp6_;
	GtkCssProvider* _tmp7_;
	GraniteSettings* _tmp8_;
	GraniteSettings* _tmp9_;
	GtkSettings* _tmp10_;
	GtkSettings* _tmp11_;
	GtkSettings* _tmp12_;
	GraniteSettings* _tmp13_;
	GraniteSettingsColorScheme _tmp14_;
	GraniteSettingsColorScheme _tmp15_;
	GraniteSettings* _tmp16_;
	GSimpleAction* present_action = NULL;
	GSimpleAction* _tmp17_;
	GSimpleAction* _tmp18_;
	GSimpleAction* _tmp19_;
#line 43 "../src/Application.vala"
	parent_class = G_OBJECT_CLASS (music_app_parent_class);
#line 43 "../src/Application.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 43 "../src/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_APP, MusicApp);
#line 43 "../src/Application.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 43 "../src/Application.vala"
	_data1_->_ref_count_ = 1;
#line 43 "../src/Application.vala"
	_data1_->self = g_object_ref (self);
#line 45 "../src/Application.vala"
	_tmp0_ = g_application_get_flags ((GApplication*) self);
#line 45 "../src/Application.vala"
	_tmp1_ = _tmp0_;
#line 45 "../src/Application.vala"
	g_application_set_flags ((GApplication*) self, _tmp1_ | G_APPLICATION_HANDLES_OPEN);
#line 48 "../src/Application.vala"
	g_application_set_application_id ((GApplication*) self, "io.elementary.music");
#line 50 "../src/Application.vala"
	setlocale (LC_ALL, "");
#line 51 "../src/Application.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 52 "../src/Application.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 53 "../src/Application.vala"
	textdomain (GETTEXT_PACKAGE);
#line 55 "../src/Application.vala"
	_tmp2_ = gtk_icon_theme_get_default ();
#line 55 "../src/Application.vala"
	default_theme = _tmp2_;
#line 56 "../src/Application.vala"
	_tmp3_ = default_theme;
#line 56 "../src/Application.vala"
	gtk_icon_theme_add_resource_path (_tmp3_, "/io/elementary/music");
#line 58 "../src/Application.vala"
	_tmp4_ = gtk_css_provider_new ();
#line 58 "../src/Application.vala"
	provider = _tmp4_;
#line 59 "../src/Application.vala"
	_tmp5_ = provider;
#line 59 "../src/Application.vala"
	gtk_css_provider_load_from_resource (_tmp5_, "io/elementary/music/application.css");
#line 60 "../src/Application.vala"
	_tmp6_ = gdk_screen_get_default ();
#line 60 "../src/Application.vala"
	_tmp7_ = provider;
#line 60 "../src/Application.vala"
	gtk_style_context_add_provider_for_screen (_tmp6_, (GtkStyleProvider*) _tmp7_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 62 "../src/Application.vala"
	_tmp8_ = granite_settings_get_default ();
#line 62 "../src/Application.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 62 "../src/Application.vala"
	_data1_->granite_settings = _tmp9_;
#line 63 "../src/Application.vala"
	_tmp10_ = gtk_settings_get_default ();
#line 63 "../src/Application.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 63 "../src/Application.vala"
	_data1_->gtk_settings = _tmp11_;
#line 65 "../src/Application.vala"
	_tmp12_ = _data1_->gtk_settings;
#line 65 "../src/Application.vala"
	_tmp13_ = _data1_->granite_settings;
#line 65 "../src/Application.vala"
	_tmp14_ = granite_settings_get_prefers_color_scheme (_tmp13_);
#line 65 "../src/Application.vala"
	_tmp15_ = _tmp14_;
#line 65 "../src/Application.vala"
	g_object_set (_tmp12_, "gtk-application-prefer-dark-theme", _tmp15_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK, NULL);
#line 67 "../src/Application.vala"
	_tmp16_ = _data1_->granite_settings;
#line 67 "../src/Application.vala"
	g_signal_connect_data ((GObject*) _tmp16_, "notify::prefers-color-scheme", (GCallback) __music_app___lambda179__g_object_notify, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 71 "../src/Application.vala"
	_tmp17_ = g_simple_action_new ("app.present", NULL);
#line 71 "../src/Application.vala"
	present_action = _tmp17_;
#line 72 "../src/Application.vala"
	_tmp18_ = present_action;
#line 72 "../src/Application.vala"
	g_signal_connect_object (_tmp18_, "activate", (GCallback) __music_app___lambda180__g_simple_action_activate, self, 0);
#line 78 "../src/Application.vala"
	_tmp19_ = present_action;
#line 78 "../src/Application.vala"
	g_action_map_add_action ((GActionMap*) self, (GAction*) _tmp19_);
#line 43 "../src/Application.vala"
	_g_object_unref0 (present_action);
#line 43 "../src/Application.vala"
	_g_object_unref0 (provider);
#line 43 "../src/Application.vala"
	block1_data_unref (_data1_);
#line 43 "../src/Application.vala"
	_data1_ = NULL;
#line 43 "../src/Application.vala"
	return obj;
#line 809 "Application.c"
}

static void
music_app_class_init (MusicAppClass * klass,
                      gpointer klass_data)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
#line 29 "../src/Application.vala"
	music_app_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Application.vala"
	g_type_class_adjust_private_offset (klass, &MusicApp_private_offset);
#line 29 "../src/Application.vala"
	((GApplicationClass *) klass)->open = (void (*) (GApplication*, GFile**, gint, const gchar*)) music_app_real_open;
#line 29 "../src/Application.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) music_app_real_activate;
#line 29 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_app_get_property;
#line 29 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_app_set_property;
#line 29 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->constructor = music_app_constructor;
#line 29 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->finalize = music_app_finalize;
#line 38 "../src/Application.vala"
	_tmp0_ = g_settings_new ("io.elementary.music.equalizer");
#line 38 "../src/Application.vala"
	_tmp1_ = _tmp0_;
#line 38 "../src/Application.vala"
	music_app_set_equalizer_settings (_tmp1_);
#line 38 "../src/Application.vala"
	_g_object_unref0 (_tmp1_);
#line 39 "../src/Application.vala"
	_tmp2_ = g_settings_new ("io.elementary.music.saved-state");
#line 39 "../src/Application.vala"
	_tmp3_ = _tmp2_;
#line 39 "../src/Application.vala"
	music_app_set_saved_state (_tmp3_);
#line 39 "../src/Application.vala"
	_g_object_unref0 (_tmp3_);
#line 40 "../src/Application.vala"
	_tmp4_ = g_settings_new ("io.elementary.music.settings");
#line 40 "../src/Application.vala"
	_tmp5_ = _tmp4_;
#line 40 "../src/Application.vala"
	music_app_set_settings (_tmp5_);
#line 40 "../src/Application.vala"
	_g_object_unref0 (_tmp5_);
#line 862 "Application.c"
}

static void
music_app_instance_init (MusicApp * self,
                         gpointer klass)
{
#line 29 "../src/Application.vala"
	self->priv = music_app_get_instance_private (self);
#line 871 "Application.c"
}

static void
music_app_finalize (GObject * obj)
{
	MusicApp * self;
#line 29 "../src/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_APP, MusicApp);
#line 34 "../src/Application.vala"
	_g_object_unref0 (self->priv->_library_manager);
#line 29 "../src/Application.vala"
	G_OBJECT_CLASS (music_app_parent_class)->finalize (obj);
#line 884 "Application.c"
}

static GType
music_app_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicAppClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_app_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicApp), 0, (GInstanceInitFunc) music_app_instance_init, NULL };
	GType music_app_type_id;
	music_app_type_id = g_type_register_static (gtk_application_get_type (), "MusicApp", &g_define_type_info, 0);
	MusicApp_private_offset = g_type_add_instance_private (music_app_type_id, sizeof (MusicAppPrivate));
	return music_app_type_id;
}

GType
music_app_get_type (void)
{
	static volatile gsize music_app_type_id__once = 0;
	if (g_once_init_enter (&music_app_type_id__once)) {
		GType music_app_type_id;
		music_app_type_id = music_app_get_type_once ();
		g_once_init_leave (&music_app_type_id__once, music_app_type_id);
	}
	return music_app_type_id__once;
}

static void
_vala_music_app_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	MusicApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_APP, MusicApp);
#line 29 "../src/Application.vala"
	switch (property_id) {
#line 919 "Application.c"
		default:
#line 29 "../src/Application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Application.vala"
		break;
#line 925 "Application.c"
	}
}

static void
_vala_music_app_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	MusicApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_APP, MusicApp);
#line 29 "../src/Application.vala"
	switch (property_id) {
#line 939 "Application.c"
		default:
#line 29 "../src/Application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Application.vala"
		break;
#line 945 "Application.c"
	}
}

static gint
_vala_main (gchar** args,
            gint args_length1)
{
	gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	MusicApp* app = NULL;
	MusicApp* _tmp7_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 115 "../src/Application.vala"
	gtk_init ((gint*) (&args_length1), &args);
#line 116 "../src/Application.vala"
	gda_init ();
#line 967 "Application.c"
	{
#line 119 "../src/Application.vala"
		gst_init_check ((gint*) (&args_length1), &args, &_inner_error0_);
#line 119 "../src/Application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 973 "Application.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp0_;
#line 118 "../src/Application.vala"
		err = _inner_error0_;
#line 118 "../src/Application.vala"
		_inner_error0_ = NULL;
#line 121 "../src/Application.vala"
		_tmp0_ = err->message;
#line 121 "../src/Application.vala"
		g_error ("Application.vala:121: Could not init GStreamer: %s", _tmp0_);
#line 118 "../src/Application.vala"
		_g_error_free0 (err);
#line 992 "Application.c"
	}
	__finally0:
#line 118 "../src/Application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 997 "Application.c"
		gint _tmp1_ = -1;
#line 118 "../src/Application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 118 "../src/Application.vala"
		g_clear_error (&_inner_error0_);
#line 118 "../src/Application.vala"
		return _tmp1_;
#line 1005 "Application.c"
	}
#line 124 "../src/Application.vala"
	_tmp2_ = g_strdup ("PULSE_PROP_media.role");
#line 124 "../src/Application.vala"
	_tmp3_ = g_new0 (gchar*, 1 + 1);
#line 124 "../src/Application.vala"
	_tmp3_[0] = _tmp2_;
#line 124 "../src/Application.vala"
	_tmp5_ = _tmp4_ = g_environ_setenv (_tmp3_, "audio", "true", TRUE);
#line 124 "../src/Application.vala"
	_tmp6_ = _tmp5_;
#line 124 "../src/Application.vala"
	_tmp6__length1 = _vala_array_length (_tmp4_);
#line 124 "../src/Application.vala"
	_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
#line 126 "../src/Application.vala"
	_tmp7_ = music_app_new ();
#line 126 "../src/Application.vala"
	app = _tmp7_;
#line 127 "../src/Application.vala"
	result = g_application_run ((GApplication*) app, (gint) args_length1, args);
#line 127 "../src/Application.vala"
	_g_object_unref0 (app);
#line 127 "../src/Application.vala"
	return result;
#line 1031 "Application.c"
}

int
main (int argc,
      char ** argv)
{
#line 114 "../src/Application.vala"
	return _vala_main (argv, argc);
#line 1040 "Application.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

