/* DataBase.c generated by valac 0.56.0, the Vala compiler
 * generated from DataBase.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <libgda/libgda.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <time.h>

#define MUSIC_DATABASE_PLAYLISTS_TABLE_NAME "playlists"
#define MUSIC_DATABASE_PLAYLISTS_NAME "+0"
#define MUSIC_DATABASE_PLAYLISTS_MEDIA "+1"
#define MUSIC_DATABASE_PLAYLISTS_ROWID "+2"
#define MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME "smart_playlists"
#define MUSIC_DATABASE_SMART_PLAYLISTS_NAME "+0"
#define MUSIC_DATABASE_SMART_PLAYLISTS_AND_OR "+1"
#define MUSIC_DATABASE_SMART_PLAYLISTS_QUERIES "+2"
#define MUSIC_DATABASE_SMART_PLAYLISTS_LIMITED "+3"
#define MUSIC_DATABASE_SMART_PLAYLISTS_LIMIT_AMOUNT "+4"
#define MUSIC_DATABASE_SMART_PLAYLISTS_ROWID "+5"
#define MUSIC_DATABASE_MEDIA_TABLE_NAME "media"
#define MUSIC_DATABASE_MEDIA_URI "+0"
#define MUSIC_DATABASE_MEDIA_FILE_SIZE "+1"
#define MUSIC_DATABASE_MEDIA_TITLE "+2"
#define MUSIC_DATABASE_MEDIA_ARTIST "+3"
#define MUSIC_DATABASE_MEDIA_COMPOSER "+4"
#define MUSIC_DATABASE_MEDIA_ALBUM_ARTIST "+5"
#define MUSIC_DATABASE_MEDIA_ALBUM "+6"
#define MUSIC_DATABASE_MEDIA_GROUPING "+7"
#define MUSIC_DATABASE_MEDIA_GENRE "+8"
#define MUSIC_DATABASE_MEDIA_COMMENT "+9"
#define MUSIC_DATABASE_MEDIA_LYRICS "+10"
#define MUSIC_DATABASE_MEDIA_HAS_EMBEDDED "+11"
#define MUSIC_DATABASE_MEDIA_YEAR "+12"
#define MUSIC_DATABASE_MEDIA_TRACK "+13"
#define MUSIC_DATABASE_MEDIA_TRACK_COUNT "+14"
#define MUSIC_DATABASE_MEDIA_ALBUM_NUMBER "+15"
#define MUSIC_DATABASE_MEDIA_ALBUM_COUNT "+16"
#define MUSIC_DATABASE_MEDIA_BITRATE "+17"
#define MUSIC_DATABASE_MEDIA_LENGTH "+18"
#define MUSIC_DATABASE_MEDIA_SAMPLERATE "+19"
#define MUSIC_DATABASE_MEDIA_RATING "+20"
#define MUSIC_DATABASE_MEDIA_PLAYCOUNT "+21"
#define MUSIC_DATABASE_MEDIA_SKIPCOUNT "+22"
#define MUSIC_DATABASE_MEDIA_DATEADDED "+23"
#define MUSIC_DATABASE_MEDIA_LASTPLAYED "+24"
#define MUSIC_DATABASE_MEDIA_LASTMODIFIED "+25"
#define MUSIC_DATABASE_MEDIA_ROWID "+26"
#define MUSIC_DATABASE_MEDIA_SHOW "+27"
#define MUSIC_DATABASE_DEVICES_TABLE_NAME "devices"
#define MUSIC_DATABASE_DEVICES_UNIQUE_ID "+0"
#define MUSIC_DATABASE_DEVICES_SYNC_WHEN_MOUNTED "+1"
#define MUSIC_DATABASE_DEVICES_SYNC_MUSIC "+2"
#define MUSIC_DATABASE_DEVICES_SYNC_ALL_MUSIC "+3"
#define MUSIC_DATABASE_DEVICES_MUSIC_PLAYLIST "+4"
#define MUSIC_DATABASE_DEVICES_LAST_SYNC_TIME "+5"
#define MUSIC_DATABASE_COLUMNS_TABLE_NAME "columns"
#define MUSIC_DATABASE_COLUMNS_UNIQUE_ID "+0"
#define MUSIC_DATABASE_COLUMNS_SORT_COLUMN_ID "+1"
#define MUSIC_DATABASE_COLUMNS_SORT_DIRECTION "+2"
#define MUSIC_DATABASE_COLUMNS_COLUMNS "+3"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

VALA_EXTERN GValue* music_database_query_field (gint64 rowid,
                                    GdaConnection* connection,
                                    const gchar* table,
                                    const gchar* field);
static void _vala_GValue_free (GValue* self);
static GValue* _g_value_dup (GValue* self);
VALA_EXTERN void music_database_set_field (gint64 rowid,
                               GdaConnection* connection,
                               const gchar* table,
                               const gchar* field,
                               GValue* val);
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_slist_free___vala_GValue_free0_ (GSList* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
VALA_EXTERN GdaSqlBuilderId music_database_process_smart_query (GdaSqlBuilder* builder,
                                                    MusicSmartQuery* sq);
VALA_EXTERN void music_database_create_tables (GdaConnection* connection);

static void
_vala_GValue_free (GValue* self)
{
#line 105 "../src/DataBase.vala"
	g_boxed_free (G_TYPE_VALUE, self);
#line 130 "DataBase.c"
}

static GValue*
_g_value_dup (GValue* self)
{
#line 109 "../src/DataBase.vala"
	return g_boxed_copy (G_TYPE_VALUE, self);
#line 138 "DataBase.c"
}

static gpointer
__g_value_dup0 (gpointer self)
{
#line 109 "../src/DataBase.vala"
	return self ? _g_value_dup (self) : NULL;
#line 146 "DataBase.c"
}

GValue*
music_database_query_field (gint64 rowid,
                            GdaConnection* connection,
                            const gchar* table,
                            const gchar* field)
{
	GError* _inner_error0_ = NULL;
	GValue* result;
#line 99 "../src/DataBase.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 99 "../src/DataBase.vala"
	g_return_val_if_fail (table != NULL, NULL);
#line 99 "../src/DataBase.vala"
	g_return_val_if_fail (field != NULL, NULL);
#line 163 "DataBase.c"
	{
		GdaSqlBuilder* sql = NULL;
		GdaSqlBuilder* _tmp0_;
		GdaSqlBuilder* _tmp1_;
		GdaSqlBuilder* _tmp2_;
		GdaSqlBuilder* _tmp3_;
		GdaSqlBuilderId id_field = 0U;
		GdaSqlBuilder* _tmp4_;
		GdaSqlBuilderId id_param = 0U;
		GdaSqlBuilder* _tmp5_;
		GValue* _tmp6_ = NULL;
		GdaSqlBuilderId _tmp7_;
		GdaSqlBuilderId id_cond = 0U;
		GdaSqlBuilder* _tmp8_;
		GdaSqlBuilder* _tmp9_;
		GdaStatement* _tmp10_ = NULL;
		GdaSqlBuilder* _tmp11_;
		GdaStatement* _tmp12_;
		GdaDataModel* data_model = NULL;
		GdaDataModel* _tmp13_;
		GValue* _tmp14_ = NULL;
		GdaDataModel* _tmp15_;
		GdaDataModel* _tmp16_;
		GValue* _tmp17_;
#line 101 "../src/DataBase.vala"
		_tmp0_ = gda_sql_builder_new (GDA_SQL_STATEMENT_SELECT);
#line 101 "../src/DataBase.vala"
		sql = _tmp0_;
#line 102 "../src/DataBase.vala"
		_tmp1_ = sql;
#line 102 "../src/DataBase.vala"
		gda_sql_builder_select_add_target (_tmp1_, table, NULL);
#line 103 "../src/DataBase.vala"
		_tmp2_ = sql;
#line 103 "../src/DataBase.vala"
		_tmp3_ = sql;
#line 103 "../src/DataBase.vala"
		gda_sql_builder_add_field_value_id (_tmp2_, gda_sql_builder_add_id (_tmp3_, field), (GdaSqlBuilderId) 0);
#line 104 "../src/DataBase.vala"
		_tmp4_ = sql;
#line 104 "../src/DataBase.vala"
		id_field = gda_sql_builder_add_id (_tmp4_, "rowid");
#line 105 "../src/DataBase.vala"
		_tmp5_ = sql;
#line 105 "../src/DataBase.vala"
		_tmp6_ = g_new0 (GValue, 1);
#line 105 "../src/DataBase.vala"
		g_value_init (_tmp6_, G_TYPE_INT64);
#line 105 "../src/DataBase.vala"
		g_value_set_int64 (_tmp6_, rowid);
#line 105 "../src/DataBase.vala"
		_tmp7_ = gda_sql_builder_add_expr_value (_tmp5_, NULL, _tmp6_);
#line 105 "../src/DataBase.vala"
		__vala_GValue_free0 (_tmp6_);
#line 105 "../src/DataBase.vala"
		id_param = _tmp7_;
#line 106 "../src/DataBase.vala"
		_tmp8_ = sql;
#line 106 "../src/DataBase.vala"
		id_cond = gda_sql_builder_add_cond (_tmp8_, GDA_SQL_OPERATOR_TYPE_EQ, id_field, id_param, (GdaSqlBuilderId) 0);
#line 107 "../src/DataBase.vala"
		_tmp9_ = sql;
#line 107 "../src/DataBase.vala"
		gda_sql_builder_set_where (_tmp9_, id_cond);
#line 108 "../src/DataBase.vala"
		_tmp11_ = sql;
#line 108 "../src/DataBase.vala"
		_tmp12_ = gda_sql_builder_get_statement (_tmp11_, &_inner_error0_);
#line 108 "../src/DataBase.vala"
		_tmp10_ = _tmp12_;
#line 108 "../src/DataBase.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 108 "../src/DataBase.vala"
			_g_object_unref0 (sql);
#line 238 "DataBase.c"
			goto __catch0_g_error;
		}
#line 108 "../src/DataBase.vala"
		_tmp13_ = gda_connection_statement_execute_select (connection, _tmp10_, NULL, &_inner_error0_);
#line 108 "../src/DataBase.vala"
		data_model = _tmp13_;
#line 108 "../src/DataBase.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 108 "../src/DataBase.vala"
			_g_object_unref0 (_tmp10_);
#line 108 "../src/DataBase.vala"
			_g_object_unref0 (sql);
#line 251 "DataBase.c"
			goto __catch0_g_error;
		}
#line 109 "../src/DataBase.vala"
		_tmp15_ = data_model;
#line 109 "../src/DataBase.vala"
		_tmp16_ = data_model;
#line 109 "../src/DataBase.vala"
		_tmp14_ = gda_data_model_get_value_at (_tmp15_, gda_data_model_get_column_index (_tmp16_, field), 0, &_inner_error0_);
#line 109 "../src/DataBase.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 109 "../src/DataBase.vala"
			_g_object_unref0 (data_model);
#line 109 "../src/DataBase.vala"
			_g_object_unref0 (_tmp10_);
#line 109 "../src/DataBase.vala"
			_g_object_unref0 (sql);
#line 268 "DataBase.c"
			goto __catch0_g_error;
		}
#line 109 "../src/DataBase.vala"
		_tmp17_ = __g_value_dup0 (_tmp14_);
#line 109 "../src/DataBase.vala"
		result = _tmp17_;
#line 109 "../src/DataBase.vala"
		_g_object_unref0 (data_model);
#line 109 "../src/DataBase.vala"
		_g_object_unref0 (_tmp10_);
#line 109 "../src/DataBase.vala"
		_g_object_unref0 (sql);
#line 109 "../src/DataBase.vala"
		return result;
#line 283 "DataBase.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 100 "../src/DataBase.vala"
		e = _inner_error0_;
#line 100 "../src/DataBase.vala"
		_inner_error0_ = NULL;
#line 111 "../src/DataBase.vala"
		_tmp18_ = e;
#line 111 "../src/DataBase.vala"
		_tmp19_ = _tmp18_->message;
#line 111 "../src/DataBase.vala"
		g_critical ("DataBase.vala:111: Could not query field %s: %s", field, _tmp19_);
#line 112 "../src/DataBase.vala"
		result = NULL;
#line 112 "../src/DataBase.vala"
		_g_error_free0 (e);
#line 112 "../src/DataBase.vala"
		return result;
#line 307 "DataBase.c"
	}
	__finally0:
#line 100 "../src/DataBase.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 100 "../src/DataBase.vala"
	g_clear_error (&_inner_error0_);
#line 100 "../src/DataBase.vala"
	return NULL;
#line 316 "DataBase.c"
}

static void
__vala_GValue_free0_ (gpointer var)
{
#line 130 "../src/DataBase.vala"
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
#line 324 "DataBase.c"
}

static inline void
_g_slist_free___vala_GValue_free0_ (GSList* self)
{
#line 130 "../src/DataBase.vala"
	g_slist_free_full (self, (GDestroyNotify) __vala_GValue_free0_);
#line 332 "DataBase.c"
}

static void
_g_free0_ (gpointer var)
{
#line 130 "../src/DataBase.vala"
	var = (g_free (var), NULL);
#line 340 "DataBase.c"
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 130 "../src/DataBase.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 348 "DataBase.c"
}

void
music_database_set_field (gint64 rowid,
                          GdaConnection* connection,
                          const gchar* table,
                          const gchar* field,
                          GValue* val)
{
	GError* _inner_error0_ = NULL;
#line 116 "../src/DataBase.vala"
	g_return_if_fail (connection != NULL);
#line 116 "../src/DataBase.vala"
	g_return_if_fail (table != NULL);
#line 116 "../src/DataBase.vala"
	g_return_if_fail (field != NULL);
#line 116 "../src/DataBase.vala"
	g_return_if_fail (val != NULL);
#line 367 "DataBase.c"
	{
		GValue rowid_value = {0};
		GValue _tmp0_ = {0};
		GSList* col_names = NULL;
		gchar* _tmp1_;
		GSList* values = NULL;
		GValue _tmp9_;
		GSList* _tmp10_;
		GSList* _tmp11_;
#line 118 "../src/DataBase.vala"
		g_value_init (&_tmp0_, G_TYPE_INT64);
#line 118 "../src/DataBase.vala"
		rowid_value = _tmp0_;
#line 119 "../src/DataBase.vala"
		g_value_set_int64 (&rowid_value, rowid);
#line 120 "../src/DataBase.vala"
		col_names = NULL;
#line 121 "../src/DataBase.vala"
		_tmp1_ = g_strdup (field);
#line 121 "../src/DataBase.vala"
		col_names = g_slist_append (col_names, _tmp1_);
#line 122 "../src/DataBase.vala"
		values = NULL;
#line 123 "../src/DataBase.vala"
		if (G_TYPE_IS_ENUM (G_VALUE_TYPE (val))) {
#line 393 "DataBase.c"
			GValue int_val = {0};
			GValue _tmp2_ = {0};
			GValue _tmp3_;
			GValue _tmp4_;
			GValue* _tmp5_;
#line 124 "../src/DataBase.vala"
			g_value_init (&_tmp2_, G_TYPE_INT);
#line 124 "../src/DataBase.vala"
			int_val = _tmp2_;
#line 125 "../src/DataBase.vala"
			g_value_set_int (&int_val, g_value_get_enum (val));
#line 126 "../src/DataBase.vala"
			_tmp3_ = int_val;
#line 126 "../src/DataBase.vala"
			_tmp4_ = _tmp3_;
#line 126 "../src/DataBase.vala"
			_tmp5_ = __g_value_dup0 (&_tmp4_);
#line 126 "../src/DataBase.vala"
			values = g_slist_append (values, _tmp5_);
#line 123 "../src/DataBase.vala"
			G_IS_VALUE (&int_val) ? (g_value_unset (&int_val), NULL) : NULL;
#line 415 "DataBase.c"
		} else {
			GValue _tmp6_;
			GValue _tmp7_;
			GValue* _tmp8_;
#line 128 "../src/DataBase.vala"
			_tmp6_ = *val;
#line 128 "../src/DataBase.vala"
			_tmp7_ = _tmp6_;
#line 128 "../src/DataBase.vala"
			_tmp8_ = __g_value_dup0 (&_tmp7_);
#line 128 "../src/DataBase.vala"
			values = g_slist_append (values, _tmp8_);
#line 428 "DataBase.c"
		}
#line 130 "../src/DataBase.vala"
		_tmp9_ = rowid_value;
#line 130 "../src/DataBase.vala"
		_tmp10_ = col_names;
#line 130 "../src/DataBase.vala"
		_tmp11_ = values;
#line 130 "../src/DataBase.vala"
		gda_connection_update_row_in_table_v (connection, table, "rowid", &_tmp9_, _tmp10_, _tmp11_, &_inner_error0_);
#line 130 "../src/DataBase.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 130 "../src/DataBase.vala"
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 130 "../src/DataBase.vala"
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 130 "../src/DataBase.vala"
			G_IS_VALUE (&rowid_value) ? (g_value_unset (&rowid_value), NULL) : NULL;
#line 446 "DataBase.c"
			goto __catch0_g_error;
		}
#line 117 "../src/DataBase.vala"
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 117 "../src/DataBase.vala"
		(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 117 "../src/DataBase.vala"
		G_IS_VALUE (&rowid_value) ? (g_value_unset (&rowid_value), NULL) : NULL;
#line 455 "DataBase.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 117 "../src/DataBase.vala"
		e = _inner_error0_;
#line 117 "../src/DataBase.vala"
		_inner_error0_ = NULL;
#line 132 "../src/DataBase.vala"
		_tmp12_ = e;
#line 132 "../src/DataBase.vala"
		_tmp13_ = _tmp12_->message;
#line 132 "../src/DataBase.vala"
		g_critical ("DataBase.vala:132: Could not set field %s: %s", field, _tmp13_);
#line 117 "../src/DataBase.vala"
		_g_error_free0 (e);
#line 475 "DataBase.c"
	}
	__finally0:
#line 117 "../src/DataBase.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 117 "../src/DataBase.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 117 "../src/DataBase.vala"
		g_clear_error (&_inner_error0_);
#line 117 "../src/DataBase.vala"
		return;
#line 486 "DataBase.c"
	}
}

GdaSqlBuilderId
music_database_process_smart_query (GdaSqlBuilder* builder,
                                    MusicSmartQuery* sq)
{
	GValue value = {0};
	GValue _tmp0_ = {0};
	GValue _tmp1_;
	GValue _tmp2_ = {0};
	GValue _tmp3_ = {0};
	GValue _tmp4_;
	gchar* field = NULL;
	MusicSmartQueryFieldType _tmp5_;
	MusicSmartQueryFieldType _tmp6_;
	GdaSqlOperatorType sql_operator_type = 0;
	MusicSmartQueryComparatorType _tmp27_;
	MusicSmartQueryComparatorType _tmp28_;
	GdaSqlBuilderId id_field = 0U;
	const gchar* _tmp34_;
	GdaSqlBuilderId id_value = 0U;
	GValue _tmp35_;
	MusicSmartQueryComparatorType _tmp36_;
	MusicSmartQueryComparatorType _tmp37_;
	GdaSqlBuilderId result;
#line 136 "../src/DataBase.vala"
	g_return_val_if_fail (builder != NULL, 0U);
#line 136 "../src/DataBase.vala"
	g_return_val_if_fail (sq != NULL, 0U);
#line 137 "../src/DataBase.vala"
	music_smart_query_get_value (sq, &_tmp0_);
#line 137 "../src/DataBase.vala"
	_tmp1_ = _tmp0_;
#line 137 "../src/DataBase.vala"
	g_value_init (&_tmp2_, G_VALUE_TYPE (&_tmp1_));
#line 137 "../src/DataBase.vala"
	value = _tmp2_;
#line 138 "../src/DataBase.vala"
	music_smart_query_get_value (sq, &_tmp3_);
#line 138 "../src/DataBase.vala"
	_tmp4_ = _tmp3_;
#line 138 "../src/DataBase.vala"
	g_value_copy (&_tmp4_, &value);
#line 140 "../src/DataBase.vala"
	_tmp5_ = music_smart_query_get_field (sq);
#line 140 "../src/DataBase.vala"
	_tmp6_ = _tmp5_;
#line 140 "../src/DataBase.vala"
	switch (_tmp6_) {
#line 140 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_URI:
#line 539 "DataBase.c"
		{
			gchar* _tmp7_;
#line 142 "../src/DataBase.vala"
			_tmp7_ = g_strdup ("uri");
#line 142 "../src/DataBase.vala"
			_g_free0 (field);
#line 142 "../src/DataBase.vala"
			field = _tmp7_;
#line 143 "../src/DataBase.vala"
			break;
#line 550 "DataBase.c"
		}
#line 140 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_ALBUM:
#line 554 "DataBase.c"
		{
			gchar* _tmp8_;
#line 145 "../src/DataBase.vala"
			_tmp8_ = g_strdup ("album");
#line 145 "../src/DataBase.vala"
			_g_free0 (field);
#line 145 "../src/DataBase.vala"
			field = _tmp8_;
#line 146 "../src/DataBase.vala"
			break;
#line 565 "DataBase.c"
		}
#line 140 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_ARTIST:
#line 569 "DataBase.c"
		{
			gchar* _tmp9_;
#line 148 "../src/DataBase.vala"
			_tmp9_ = g_strdup ("artist");
#line 148 "../src/DataBase.vala"
			_g_free0 (field);
#line 148 "../src/DataBase.vala"
			field = _tmp9_;
#line 149 "../src/DataBase.vala"
			break;
#line 580 "DataBase.c"
		}
#line 140 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_BITRATE:
#line 584 "DataBase.c"
		{
			gchar* _tmp10_;
#line 151 "../src/DataBase.vala"
			_tmp10_ = g_strdup ("bitrate");
#line 151 "../src/DataBase.vala"
			_g_free0 (field);
#line 151 "../src/DataBase.vala"
			field = _tmp10_;
#line 152 "../src/DataBase.vala"
			break;
#line 595 "DataBase.c"
		}
#line 140 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_COMMENT:
#line 599 "DataBase.c"
		{
			gchar* _tmp11_;
#line 154 "../src/DataBase.vala"
			_tmp11_ = g_strdup ("comment");
#line 154 "../src/DataBase.vala"
			_g_free0 (field);
#line 154 "../src/DataBase.vala"
			field = _tmp11_;
#line 155 "../src/DataBase.vala"
			break;
#line 610 "DataBase.c"
		}
#line 140 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_COMPOSER:
#line 614 "DataBase.c"
		{
			gchar* _tmp12_;
#line 157 "../src/DataBase.vala"
			_tmp12_ = g_strdup ("composer");
#line 157 "../src/DataBase.vala"
			_g_free0 (field);
#line 157 "../src/DataBase.vala"
			field = _tmp12_;
#line 158 "../src/DataBase.vala"
			break;
#line 625 "DataBase.c"
		}
#line 140 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_DATE_ADDED:
#line 629 "DataBase.c"
		{
			GValue _tmp13_ = {0};
			time_t _tmp14_;
			gchar* _tmp15_;
#line 161 "../src/DataBase.vala"
			g_value_init (&_tmp13_, G_TYPE_INT);
#line 161 "../src/DataBase.vala"
			G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 161 "../src/DataBase.vala"
			value = _tmp13_;
#line 162 "../src/DataBase.vala"
			_tmp14_ = time (NULL);
#line 162 "../src/DataBase.vala"
			g_value_set_int (&value, (gint) _tmp14_);
#line 163 "../src/DataBase.vala"
			_tmp15_ = g_strdup ("dateadded");
#line 163 "../src/DataBase.vala"
			_g_free0 (field);
#line 163 "../src/DataBase.vala"
			field = _tmp15_;
#line 164 "../src/DataBase.vala"
			break;
#line 652 "DataBase.c"
		}
#line 140 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_GENRE:
#line 656 "DataBase.c"
		{
			gchar* _tmp16_;
#line 166 "../src/DataBase.vala"
			_tmp16_ = g_strdup ("genre");
#line 166 "../src/DataBase.vala"
			_g_free0 (field);
#line 166 "../src/DataBase.vala"
			field = _tmp16_;
#line 167 "../src/DataBase.vala"
			break;
#line 667 "DataBase.c"
		}
#line 140 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_GROUPING:
#line 671 "DataBase.c"
		{
			gchar* _tmp17_;
#line 169 "../src/DataBase.vala"
			_tmp17_ = g_strdup ("grouping");
#line 169 "../src/DataBase.vala"
			_g_free0 (field);
#line 169 "../src/DataBase.vala"
			field = _tmp17_;
#line 170 "../src/DataBase.vala"
			break;
#line 682 "DataBase.c"
		}
#line 140 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_LAST_PLAYED:
#line 686 "DataBase.c"
		{
			GValue _tmp18_ = {0};
			time_t _tmp19_;
			gchar* _tmp20_;
#line 173 "../src/DataBase.vala"
			g_value_init (&_tmp18_, G_TYPE_INT);
#line 173 "../src/DataBase.vala"
			G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 173 "../src/DataBase.vala"
			value = _tmp18_;
#line 174 "../src/DataBase.vala"
			_tmp19_ = time (NULL);
#line 174 "../src/DataBase.vala"
			g_value_set_int (&value, (gint) _tmp19_);
#line 175 "../src/DataBase.vala"
			_tmp20_ = g_strdup ("lastplayed");
#line 175 "../src/DataBase.vala"
			_g_free0 (field);
#line 175 "../src/DataBase.vala"
			field = _tmp20_;
#line 176 "../src/DataBase.vala"
			break;
#line 709 "DataBase.c"
		}
#line 140 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_LENGTH:
#line 713 "DataBase.c"
		{
			gchar* _tmp21_;
#line 178 "../src/DataBase.vala"
			_tmp21_ = g_strdup ("length");
#line 178 "../src/DataBase.vala"
			_g_free0 (field);
#line 178 "../src/DataBase.vala"
			field = _tmp21_;
#line 179 "../src/DataBase.vala"
			break;
#line 724 "DataBase.c"
		}
#line 140 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_PLAYCOUNT:
#line 728 "DataBase.c"
		{
			gchar* _tmp22_;
#line 181 "../src/DataBase.vala"
			_tmp22_ = g_strdup ("playcount");
#line 181 "../src/DataBase.vala"
			_g_free0 (field);
#line 181 "../src/DataBase.vala"
			field = _tmp22_;
#line 182 "../src/DataBase.vala"
			break;
#line 739 "DataBase.c"
		}
#line 140 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_RATING:
#line 743 "DataBase.c"
		{
			gchar* _tmp23_;
#line 184 "../src/DataBase.vala"
			_tmp23_ = g_strdup ("rating");
#line 184 "../src/DataBase.vala"
			_g_free0 (field);
#line 184 "../src/DataBase.vala"
			field = _tmp23_;
#line 185 "../src/DataBase.vala"
			break;
#line 754 "DataBase.c"
		}
#line 140 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_SKIPCOUNT:
#line 758 "DataBase.c"
		{
			gchar* _tmp24_;
#line 187 "../src/DataBase.vala"
			_tmp24_ = g_strdup ("skipcount");
#line 187 "../src/DataBase.vala"
			_g_free0 (field);
#line 187 "../src/DataBase.vala"
			field = _tmp24_;
#line 188 "../src/DataBase.vala"
			break;
#line 769 "DataBase.c"
		}
#line 140 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_YEAR:
#line 773 "DataBase.c"
		{
			gchar* _tmp25_;
#line 190 "../src/DataBase.vala"
			_tmp25_ = g_strdup ("year");
#line 190 "../src/DataBase.vala"
			_g_free0 (field);
#line 190 "../src/DataBase.vala"
			field = _tmp25_;
#line 191 "../src/DataBase.vala"
			break;
#line 784 "DataBase.c"
		}
		default:
#line 140 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_TITLE:
#line 789 "DataBase.c"
		{
			gchar* _tmp26_;
#line 194 "../src/DataBase.vala"
			_tmp26_ = g_strdup ("title");
#line 194 "../src/DataBase.vala"
			_g_free0 (field);
#line 194 "../src/DataBase.vala"
			field = _tmp26_;
#line 195 "../src/DataBase.vala"
			break;
#line 800 "DataBase.c"
		}
	}
#line 199 "../src/DataBase.vala"
	_tmp27_ = music_smart_query_get_comparator (sq);
#line 199 "../src/DataBase.vala"
	_tmp28_ = _tmp27_;
#line 199 "../src/DataBase.vala"
	switch (_tmp28_) {
#line 199 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_NOT:
#line 811 "DataBase.c"
		{
#line 201 "../src/DataBase.vala"
			sql_operator_type = GDA_SQL_OPERATOR_TYPE_NOT;
#line 202 "../src/DataBase.vala"
			break;
#line 817 "DataBase.c"
		}
#line 199 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_COMPARATOR_TYPE_CONTAINS:
#line 199 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS:
#line 823 "DataBase.c"
		{
			const gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			GValue _tmp33_ = {0};
#line 205 "../src/DataBase.vala"
			_tmp29_ = g_value_get_string (&value);
#line 205 "../src/DataBase.vala"
			_tmp30_ = g_strconcat ("%", _tmp29_, NULL);
#line 205 "../src/DataBase.vala"
			_tmp31_ = _tmp30_;
#line 205 "../src/DataBase.vala"
			_tmp32_ = g_strconcat (_tmp31_, "%", NULL);
#line 205 "../src/DataBase.vala"
			g_value_init (&_tmp33_, G_TYPE_STRING);
#line 205 "../src/DataBase.vala"
			g_value_take_string (&_tmp33_, _tmp32_);
#line 205 "../src/DataBase.vala"
			G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 205 "../src/DataBase.vala"
			value = _tmp33_;
#line 205 "../src/DataBase.vala"
			_g_free0 (_tmp31_);
#line 206 "../src/DataBase.vala"
			sql_operator_type = GDA_SQL_OPERATOR_TYPE_LIKE;
#line 207 "../src/DataBase.vala"
			break;
#line 852 "DataBase.c"
		}
#line 199 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY:
#line 856 "DataBase.c"
		{
#line 209 "../src/DataBase.vala"
			sql_operator_type = GDA_SQL_OPERATOR_TYPE_EQ;
#line 210 "../src/DataBase.vala"
			break;
#line 862 "DataBase.c"
		}
#line 199 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST:
#line 866 "DataBase.c"
		{
#line 212 "../src/DataBase.vala"
			sql_operator_type = GDA_SQL_OPERATOR_TYPE_LEQ;
#line 213 "../src/DataBase.vala"
			break;
#line 872 "DataBase.c"
		}
#line 199 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST:
#line 876 "DataBase.c"
		{
#line 215 "../src/DataBase.vala"
			sql_operator_type = GDA_SQL_OPERATOR_TYPE_GEQ;
#line 216 "../src/DataBase.vala"
			break;
#line 882 "DataBase.c"
		}
#line 199 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_WITHIN:
#line 886 "DataBase.c"
		{
#line 218 "../src/DataBase.vala"
			sql_operator_type = GDA_SQL_OPERATOR_TYPE_LEQ;
#line 219 "../src/DataBase.vala"
			break;
#line 892 "DataBase.c"
		}
#line 199 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_BEFORE:
#line 896 "DataBase.c"
		{
#line 221 "../src/DataBase.vala"
			sql_operator_type = GDA_SQL_OPERATOR_TYPE_GEQ;
#line 222 "../src/DataBase.vala"
			break;
#line 902 "DataBase.c"
		}
		default:
#line 199 "../src/DataBase.vala"
		case MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS:
#line 907 "DataBase.c"
		{
#line 225 "../src/DataBase.vala"
			sql_operator_type = GDA_SQL_OPERATOR_TYPE_LIKE;
#line 226 "../src/DataBase.vala"
			break;
#line 913 "DataBase.c"
		}
	}
#line 229 "../src/DataBase.vala"
	_tmp34_ = field;
#line 229 "../src/DataBase.vala"
	id_field = gda_sql_builder_add_id (builder, _tmp34_);
#line 230 "../src/DataBase.vala"
	_tmp35_ = value;
#line 230 "../src/DataBase.vala"
	id_value = gda_sql_builder_add_expr_value (builder, NULL, &_tmp35_);
#line 231 "../src/DataBase.vala"
	_tmp36_ = music_smart_query_get_comparator (sq);
#line 231 "../src/DataBase.vala"
	_tmp37_ = _tmp36_;
#line 231 "../src/DataBase.vala"
	if (_tmp37_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS) {
#line 930 "DataBase.c"
		GdaSqlBuilderId cond = 0U;
#line 232 "../src/DataBase.vala"
		cond = gda_sql_builder_add_cond (builder, sql_operator_type, id_field, id_value, (GdaSqlBuilderId) 0);
#line 233 "../src/DataBase.vala"
		result = gda_sql_builder_add_cond (builder, GDA_SQL_OPERATOR_TYPE_NOT, cond, (GdaSqlBuilderId) 0, (GdaSqlBuilderId) 0);
#line 233 "../src/DataBase.vala"
		_g_free0 (field);
#line 233 "../src/DataBase.vala"
		G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 233 "../src/DataBase.vala"
		return result;
#line 942 "DataBase.c"
	} else {
#line 235 "../src/DataBase.vala"
		result = gda_sql_builder_add_cond (builder, sql_operator_type, id_field, id_value, (GdaSqlBuilderId) 0);
#line 235 "../src/DataBase.vala"
		_g_free0 (field);
#line 235 "../src/DataBase.vala"
		G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 235 "../src/DataBase.vala"
		return result;
#line 952 "DataBase.c"
	}
}

void
music_database_create_tables (GdaConnection* connection)
{
	GError* e = NULL;
	GdaServerOperation* operation = NULL;
	GError* _tmp0_;
	GdaServerOperation* _tmp1_;
	GError* _tmp2_;
	GError* _tmp9_;
	GdaServerOperation* _tmp10_;
	GError* _tmp11_;
	GError* _tmp18_;
	GdaServerOperation* _tmp19_;
	GError* _tmp20_;
	GError* _tmp27_;
	GdaServerOperation* _tmp28_;
	GError* _tmp29_;
	GError* _tmp36_;
	GdaServerOperation* _tmp37_;
	GError* _tmp38_;
	GError* _inner_error0_ = NULL;
#line 239 "../src/DataBase.vala"
	g_return_if_fail (connection != NULL);
#line 240 "../src/DataBase.vala"
	e = NULL;
#line 245 "../src/DataBase.vala"
	_tmp0_ = e;
#line 245 "../src/DataBase.vala"
	_tmp1_ = gda_server_operation_prepare_create_table (connection, "playlists", _tmp0_, "name", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "media", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "rowid", G_TYPE_INT64, GDA_SERVER_OPERATION_CREATE_TABLE_PKEY_AUTOINC_FLAG, NULL);
#line 245 "../src/DataBase.vala"
	operation = _tmp1_;
#line 250 "../src/DataBase.vala"
	_tmp2_ = e;
#line 250 "../src/DataBase.vala"
	if (_tmp2_ != NULL) {
#line 991 "DataBase.c"
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 251 "../src/DataBase.vala"
		_tmp3_ = e;
#line 251 "../src/DataBase.vala"
		_tmp4_ = _tmp3_->message;
#line 251 "../src/DataBase.vala"
		g_critical ("DataBase.vala:251: %s", _tmp4_);
#line 1000 "DataBase.c"
	} else {
		{
			GdaServerOperation* _tmp5_;
#line 254 "../src/DataBase.vala"
			_tmp5_ = operation;
#line 254 "../src/DataBase.vala"
			gda_server_operation_perform_create_table (_tmp5_, &_inner_error0_);
#line 254 "../src/DataBase.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1010 "DataBase.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp6_;
#line 253 "../src/DataBase.vala"
			e = _inner_error0_;
#line 253 "../src/DataBase.vala"
			_inner_error0_ = NULL;
#line 257 "../src/DataBase.vala"
			_tmp6_ = e;
#line 257 "../src/DataBase.vala"
			if (_tmp6_->code != 1) {
#line 1027 "DataBase.c"
				GError* _tmp7_;
				const gchar* _tmp8_;
#line 258 "../src/DataBase.vala"
				_tmp7_ = e;
#line 258 "../src/DataBase.vala"
				_tmp8_ = _tmp7_->message;
#line 258 "../src/DataBase.vala"
				g_critical ("DataBase.vala:258: %s", _tmp8_);
#line 1036 "DataBase.c"
			}
#line 253 "../src/DataBase.vala"
			_g_error_free0 (e);
#line 1040 "DataBase.c"
		}
		__finally0:
#line 253 "../src/DataBase.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 253 "../src/DataBase.vala"
			_g_object_unref0 (operation);
#line 253 "../src/DataBase.vala"
			_g_error_free0 (e);
#line 253 "../src/DataBase.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 253 "../src/DataBase.vala"
			g_clear_error (&_inner_error0_);
#line 253 "../src/DataBase.vala"
			return;
#line 1055 "DataBase.c"
		}
	}
#line 266 "../src/DataBase.vala"
	_tmp9_ = e;
#line 266 "../src/DataBase.vala"
	_tmp10_ = gda_server_operation_prepare_create_table (connection, "smart_playlists", _tmp9_, "name", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "and_or", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "queries", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "limited", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "limit_amount", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "rowid", G_TYPE_INT64, GDA_SERVER_OPERATION_CREATE_TABLE_PKEY_AUTOINC_FLAG, NULL);
#line 266 "../src/DataBase.vala"
	_g_object_unref0 (operation);
#line 266 "../src/DataBase.vala"
	operation = _tmp10_;
#line 274 "../src/DataBase.vala"
	_tmp11_ = e;
#line 274 "../src/DataBase.vala"
	if (_tmp11_ != NULL) {
#line 1070 "DataBase.c"
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 275 "../src/DataBase.vala"
		_tmp12_ = e;
#line 275 "../src/DataBase.vala"
		_tmp13_ = _tmp12_->message;
#line 275 "../src/DataBase.vala"
		g_critical ("DataBase.vala:275: %s", _tmp13_);
#line 1079 "DataBase.c"
	} else {
		{
			GdaServerOperation* _tmp14_;
#line 278 "../src/DataBase.vala"
			_tmp14_ = operation;
#line 278 "../src/DataBase.vala"
			gda_server_operation_perform_create_table (_tmp14_, &_inner_error0_);
#line 278 "../src/DataBase.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1089 "DataBase.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp15_;
#line 277 "../src/DataBase.vala"
			e = _inner_error0_;
#line 277 "../src/DataBase.vala"
			_inner_error0_ = NULL;
#line 281 "../src/DataBase.vala"
			_tmp15_ = e;
#line 281 "../src/DataBase.vala"
			if (_tmp15_->code != 1) {
#line 1106 "DataBase.c"
				GError* _tmp16_;
				const gchar* _tmp17_;
#line 282 "../src/DataBase.vala"
				_tmp16_ = e;
#line 282 "../src/DataBase.vala"
				_tmp17_ = _tmp16_->message;
#line 282 "../src/DataBase.vala"
				g_critical ("DataBase.vala:282: %s", _tmp17_);
#line 1115 "DataBase.c"
			}
#line 277 "../src/DataBase.vala"
			_g_error_free0 (e);
#line 1119 "DataBase.c"
		}
		__finally1:
#line 277 "../src/DataBase.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 277 "../src/DataBase.vala"
			_g_object_unref0 (operation);
#line 277 "../src/DataBase.vala"
			_g_error_free0 (e);
#line 277 "../src/DataBase.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 277 "../src/DataBase.vala"
			g_clear_error (&_inner_error0_);
#line 277 "../src/DataBase.vala"
			return;
#line 1134 "DataBase.c"
		}
	}
#line 290 "../src/DataBase.vala"
	_tmp18_ = e;
#line 290 "../src/DataBase.vala"
	_tmp19_ = gda_server_operation_prepare_create_table (connection, "columns", _tmp18_, "unique_id", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_UNIQUE_FLAG, "sort_column_id", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "sort_direction", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "columns", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "rowid", G_TYPE_INT64, GDA_SERVER_OPERATION_CREATE_TABLE_PKEY_AUTOINC_FLAG, NULL);
#line 290 "../src/DataBase.vala"
	_g_object_unref0 (operation);
#line 290 "../src/DataBase.vala"
	operation = _tmp19_;
#line 297 "../src/DataBase.vala"
	_tmp20_ = e;
#line 297 "../src/DataBase.vala"
	if (_tmp20_ != NULL) {
#line 1149 "DataBase.c"
		GError* _tmp21_;
		const gchar* _tmp22_;
#line 298 "../src/DataBase.vala"
		_tmp21_ = e;
#line 298 "../src/DataBase.vala"
		_tmp22_ = _tmp21_->message;
#line 298 "../src/DataBase.vala"
		g_critical ("DataBase.vala:298: %s", _tmp22_);
#line 1158 "DataBase.c"
	} else {
		{
			GdaServerOperation* _tmp23_;
#line 301 "../src/DataBase.vala"
			_tmp23_ = operation;
#line 301 "../src/DataBase.vala"
			gda_server_operation_perform_create_table (_tmp23_, &_inner_error0_);
#line 301 "../src/DataBase.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1168 "DataBase.c"
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			GError* _tmp24_;
#line 300 "../src/DataBase.vala"
			e = _inner_error0_;
#line 300 "../src/DataBase.vala"
			_inner_error0_ = NULL;
#line 304 "../src/DataBase.vala"
			_tmp24_ = e;
#line 304 "../src/DataBase.vala"
			if (_tmp24_->code != 1) {
#line 1185 "DataBase.c"
				GError* _tmp25_;
				const gchar* _tmp26_;
#line 305 "../src/DataBase.vala"
				_tmp25_ = e;
#line 305 "../src/DataBase.vala"
				_tmp26_ = _tmp25_->message;
#line 305 "../src/DataBase.vala"
				g_critical ("DataBase.vala:305: %s", _tmp26_);
#line 1194 "DataBase.c"
			}
#line 300 "../src/DataBase.vala"
			_g_error_free0 (e);
#line 1198 "DataBase.c"
		}
		__finally2:
#line 300 "../src/DataBase.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 300 "../src/DataBase.vala"
			_g_object_unref0 (operation);
#line 300 "../src/DataBase.vala"
			_g_error_free0 (e);
#line 300 "../src/DataBase.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 300 "../src/DataBase.vala"
			g_clear_error (&_inner_error0_);
#line 300 "../src/DataBase.vala"
			return;
#line 1213 "DataBase.c"
		}
	}
#line 313 "../src/DataBase.vala"
	_tmp27_ = e;
#line 313 "../src/DataBase.vala"
	_tmp28_ = gda_server_operation_prepare_create_table (connection, "media", _tmp27_, "uri", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_UNIQUE_FLAG, "file_size", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "title", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "artist", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "composer", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "album_artist", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "album", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "grouping", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "genre", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "comment", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "lyrics", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "has_embedded", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "year", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "track", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "track_count", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "album_number", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "album_count", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "bitrate", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "length", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "samplerate", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "rating", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "playcount", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "skipcount", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "dateadded", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "lastplayed", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "lastmodified", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "rowid", G_TYPE_INT64, GDA_SERVER_OPERATION_CREATE_TABLE_PKEY_AUTOINC_FLAG, "show", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, NULL);
#line 313 "../src/DataBase.vala"
	_g_object_unref0 (operation);
#line 313 "../src/DataBase.vala"
	operation = _tmp28_;
#line 343 "../src/DataBase.vala"
	_tmp29_ = e;
#line 343 "../src/DataBase.vala"
	if (_tmp29_ != NULL) {
#line 1228 "DataBase.c"
		GError* _tmp30_;
		const gchar* _tmp31_;
#line 344 "../src/DataBase.vala"
		_tmp30_ = e;
#line 344 "../src/DataBase.vala"
		_tmp31_ = _tmp30_->message;
#line 344 "../src/DataBase.vala"
		g_critical ("DataBase.vala:344: %s", _tmp31_);
#line 1237 "DataBase.c"
	} else {
		{
			GdaServerOperation* _tmp32_;
#line 347 "../src/DataBase.vala"
			_tmp32_ = operation;
#line 347 "../src/DataBase.vala"
			gda_server_operation_perform_create_table (_tmp32_, &_inner_error0_);
#line 347 "../src/DataBase.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1247 "DataBase.c"
				goto __catch3_g_error;
			}
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError* e = NULL;
			GError* _tmp33_;
#line 346 "../src/DataBase.vala"
			e = _inner_error0_;
#line 346 "../src/DataBase.vala"
			_inner_error0_ = NULL;
#line 350 "../src/DataBase.vala"
			_tmp33_ = e;
#line 350 "../src/DataBase.vala"
			if (_tmp33_->code != 1) {
#line 1264 "DataBase.c"
				GError* _tmp34_;
				const gchar* _tmp35_;
#line 351 "../src/DataBase.vala"
				_tmp34_ = e;
#line 351 "../src/DataBase.vala"
				_tmp35_ = _tmp34_->message;
#line 351 "../src/DataBase.vala"
				g_critical ("DataBase.vala:351: %s", _tmp35_);
#line 1273 "DataBase.c"
			}
#line 346 "../src/DataBase.vala"
			_g_error_free0 (e);
#line 1277 "DataBase.c"
		}
		__finally3:
#line 346 "../src/DataBase.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 346 "../src/DataBase.vala"
			_g_object_unref0 (operation);
#line 346 "../src/DataBase.vala"
			_g_error_free0 (e);
#line 346 "../src/DataBase.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 346 "../src/DataBase.vala"
			g_clear_error (&_inner_error0_);
#line 346 "../src/DataBase.vala"
			return;
#line 1292 "DataBase.c"
		}
	}
#line 359 "../src/DataBase.vala"
	_tmp36_ = e;
#line 359 "../src/DataBase.vala"
	_tmp37_ = gda_server_operation_prepare_create_table (connection, "devices", _tmp36_, "unique_id", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_UNIQUE_FLAG, "sync_when_mounted", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "sync_music", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "sync_all_music", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "music_playlist", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "last_sync_time", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, NULL);
#line 359 "../src/DataBase.vala"
	_g_object_unref0 (operation);
#line 359 "../src/DataBase.vala"
	operation = _tmp37_;
#line 367 "../src/DataBase.vala"
	_tmp38_ = e;
#line 367 "../src/DataBase.vala"
	if (_tmp38_ != NULL) {
#line 1307 "DataBase.c"
		GError* _tmp39_;
		const gchar* _tmp40_;
#line 368 "../src/DataBase.vala"
		_tmp39_ = e;
#line 368 "../src/DataBase.vala"
		_tmp40_ = _tmp39_->message;
#line 368 "../src/DataBase.vala"
		g_critical ("DataBase.vala:368: %s", _tmp40_);
#line 1316 "DataBase.c"
	} else {
		{
			GdaServerOperation* _tmp41_;
#line 371 "../src/DataBase.vala"
			_tmp41_ = operation;
#line 371 "../src/DataBase.vala"
			gda_server_operation_perform_create_table (_tmp41_, &_inner_error0_);
#line 371 "../src/DataBase.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1326 "DataBase.c"
				goto __catch4_g_error;
			}
		}
		goto __finally4;
		__catch4_g_error:
		{
			GError* e = NULL;
			GError* _tmp42_;
#line 370 "../src/DataBase.vala"
			e = _inner_error0_;
#line 370 "../src/DataBase.vala"
			_inner_error0_ = NULL;
#line 374 "../src/DataBase.vala"
			_tmp42_ = e;
#line 374 "../src/DataBase.vala"
			if (_tmp42_->code != 1) {
#line 1343 "DataBase.c"
				GError* _tmp43_;
				const gchar* _tmp44_;
#line 375 "../src/DataBase.vala"
				_tmp43_ = e;
#line 375 "../src/DataBase.vala"
				_tmp44_ = _tmp43_->message;
#line 375 "../src/DataBase.vala"
				g_critical ("DataBase.vala:375: %s", _tmp44_);
#line 1352 "DataBase.c"
			}
#line 370 "../src/DataBase.vala"
			_g_error_free0 (e);
#line 1356 "DataBase.c"
		}
		__finally4:
#line 370 "../src/DataBase.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 370 "../src/DataBase.vala"
			_g_object_unref0 (operation);
#line 370 "../src/DataBase.vala"
			_g_error_free0 (e);
#line 370 "../src/DataBase.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 370 "../src/DataBase.vala"
			g_clear_error (&_inner_error0_);
#line 370 "../src/DataBase.vala"
			return;
#line 1371 "DataBase.c"
		}
	}
#line 239 "../src/DataBase.vala"
	_g_object_unref0 (operation);
#line 239 "../src/DataBase.vala"
	_g_error_free0 (e);
#line 1378 "DataBase.c"
}

