/* FileNotFoundDialog.c generated by valac 0.56.0, the Vala compiler
 * generated from FileNotFoundDialog.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <granite.h>
#include <glib-object.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <handy.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_FILE_NOT_FOUND_DIALOG (music_file_not_found_dialog_get_type ())
#define MUSIC_FILE_NOT_FOUND_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_FILE_NOT_FOUND_DIALOG, MusicFileNotFoundDialog))
#define MUSIC_FILE_NOT_FOUND_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_FILE_NOT_FOUND_DIALOG, MusicFileNotFoundDialogClass))
#define MUSIC_IS_FILE_NOT_FOUND_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_FILE_NOT_FOUND_DIALOG))
#define MUSIC_IS_FILE_NOT_FOUND_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_FILE_NOT_FOUND_DIALOG))
#define MUSIC_FILE_NOT_FOUND_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_FILE_NOT_FOUND_DIALOG, MusicFileNotFoundDialogClass))

typedef struct _MusicFileNotFoundDialog MusicFileNotFoundDialog;
typedef struct _MusicFileNotFoundDialogClass MusicFileNotFoundDialogClass;
typedef struct _MusicFileNotFoundDialogPrivate MusicFileNotFoundDialogPrivate;
enum  {
	MUSIC_FILE_NOT_FOUND_DIALOG_0_PROPERTY,
	MUSIC_FILE_NOT_FOUND_DIALOG_NUM_PROPERTIES
};
static GParamSpec* music_file_not_found_dialog_properties[MUSIC_FILE_NOT_FOUND_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block12Data Block12Data;

#define MUSIC_TYPE_LIBRARY_WINDOW (music_library_window_get_type ())
#define MUSIC_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow))
#define MUSIC_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))
#define MUSIC_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))

typedef struct _MusicLibraryWindow MusicLibraryWindow;
typedef struct _MusicLibraryWindowClass MusicLibraryWindowClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define MUSIC_TYPE_LOCAL_LIBRARY (music_local_library_get_type ())
#define MUSIC_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibrary))
#define MUSIC_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibraryClass))
#define MUSIC_IS_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LOCAL_LIBRARY))
#define MUSIC_IS_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LOCAL_LIBRARY))
#define MUSIC_LOCAL_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibraryClass))

typedef struct _MusicLocalLibrary MusicLocalLibrary;
typedef struct _MusicLocalLibraryClass MusicLocalLibraryClass;

struct _MusicFileNotFoundDialog {
	GraniteMessageDialog parent_instance;
	MusicFileNotFoundDialogPrivate * priv;
};

struct _MusicFileNotFoundDialogClass {
	GraniteMessageDialogClass parent_class;
};

struct _MusicFileNotFoundDialogPrivate {
	GeeLinkedList* media_list;
};

struct _Block12Data {
	int _ref_count_;
	MusicFileNotFoundDialog* self;
	GtkButton* rescan_library;
};

static gint MusicFileNotFoundDialog_private_offset;
static gpointer music_file_not_found_dialog_parent_class = NULL;

VALA_EXTERN GType music_file_not_found_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicFileNotFoundDialog, g_object_unref)
VALA_EXTERN MusicFileNotFoundDialog* music_file_not_found_dialog_new (GeeCollection* _media_list);
VALA_EXTERN MusicFileNotFoundDialog* music_file_not_found_dialog_construct (GType object_type,
                                                                GeeCollection* _media_list);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
VALA_EXTERN GType music_library_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLibraryWindow, g_object_unref)
VALA_EXTERN MusicLibraryWindow* music_app_get_main_window (void);
static void __lambda44_ (MusicFileNotFoundDialog* self,
                  gint response_id);
static void music_file_not_found_dialog_rescan_library_clicked (MusicFileNotFoundDialog* self);
static void music_file_not_found_dialog_remove_media_clicked (MusicFileNotFoundDialog* self);
static void music_file_not_found_dialog_locate_media_clicked (MusicFileNotFoundDialog* self);
static void ___lambda44__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void __lambda45_ (Block12Data* _data12_);
static void ___lambda45__music_library_file_operations_started (MusicLibrary* _sender,
                                                         gpointer self);
static void __lambda46_ (Block12Data* _data12_);
static void ___lambda46__music_library_file_operations_done (MusicLibrary* _sender,
                                                      gpointer self);
VALA_EXTERN GType music_local_library_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLocalLibrary, g_object_unref)
VALA_EXTERN void music_local_library_rescan_music_folder (MusicLocalLibrary* self);
static void music_file_not_found_dialog_finalize (GObject * obj);
static GType music_file_not_found_dialog_get_type_once (void);

static inline gpointer
music_file_not_found_dialog_get_instance_private (MusicFileNotFoundDialog* self)
{
	return G_STRUCT_MEMBER_P (self, MusicFileNotFoundDialog_private_offset);
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 33 "../src/Dialogs/FileNotFoundDialog.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 33 "../src/Dialogs/FileNotFoundDialog.vala"
	return _data12_;
#line 160 "FileNotFoundDialog.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 33 "../src/Dialogs/FileNotFoundDialog.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 170 "FileNotFoundDialog.c"
		MusicFileNotFoundDialog* self;
#line 33 "../src/Dialogs/FileNotFoundDialog.vala"
		self = _data12_->self;
#line 33 "../src/Dialogs/FileNotFoundDialog.vala"
		_g_object_unref0 (_data12_->rescan_library);
#line 33 "../src/Dialogs/FileNotFoundDialog.vala"
		_g_object_unref0 (self);
#line 33 "../src/Dialogs/FileNotFoundDialog.vala"
		g_slice_free (Block12Data, _data12_);
#line 180 "FileNotFoundDialog.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 53 "../src/Dialogs/FileNotFoundDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 189 "FileNotFoundDialog.c"
}

static void
__lambda44_ (MusicFileNotFoundDialog* self,
             gint response_id)
{
#line 61 "../src/Dialogs/FileNotFoundDialog.vala"
	switch (response_id) {
#line 61 "../src/Dialogs/FileNotFoundDialog.vala"
		case 1:
#line 200 "FileNotFoundDialog.c"
		{
#line 63 "../src/Dialogs/FileNotFoundDialog.vala"
			music_file_not_found_dialog_rescan_library_clicked (self);
#line 64 "../src/Dialogs/FileNotFoundDialog.vala"
			break;
#line 206 "FileNotFoundDialog.c"
		}
#line 61 "../src/Dialogs/FileNotFoundDialog.vala"
		case 2:
#line 210 "FileNotFoundDialog.c"
		{
#line 66 "../src/Dialogs/FileNotFoundDialog.vala"
			music_file_not_found_dialog_remove_media_clicked (self);
#line 67 "../src/Dialogs/FileNotFoundDialog.vala"
			break;
#line 216 "FileNotFoundDialog.c"
		}
#line 61 "../src/Dialogs/FileNotFoundDialog.vala"
		case 3:
#line 220 "FileNotFoundDialog.c"
		{
#line 69 "../src/Dialogs/FileNotFoundDialog.vala"
			music_file_not_found_dialog_locate_media_clicked (self);
#line 70 "../src/Dialogs/FileNotFoundDialog.vala"
			break;
#line 226 "FileNotFoundDialog.c"
		}
#line 61 "../src/Dialogs/FileNotFoundDialog.vala"
		case GTK_RESPONSE_CLOSE:
#line 230 "FileNotFoundDialog.c"
		{
#line 72 "../src/Dialogs/FileNotFoundDialog.vala"
			gtk_widget_destroy ((GtkWidget*) self);
#line 73 "../src/Dialogs/FileNotFoundDialog.vala"
			break;
#line 236 "FileNotFoundDialog.c"
		}
		default:
#line 61 "../src/Dialogs/FileNotFoundDialog.vala"
		break;
#line 241 "FileNotFoundDialog.c"
	}
}

static void
___lambda44__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 60 "../src/Dialogs/FileNotFoundDialog.vala"
	__lambda44_ ((MusicFileNotFoundDialog*) self, response_id);
#line 252 "FileNotFoundDialog.c"
}

static void
__lambda45_ (Block12Data* _data12_)
{
	MusicFileNotFoundDialog* self;
#line 77 "../src/Dialogs/FileNotFoundDialog.vala"
	self = _data12_->self;
#line 78 "../src/Dialogs/FileNotFoundDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _data12_->rescan_library, FALSE);
#line 263 "FileNotFoundDialog.c"
}

static void
___lambda45__music_library_file_operations_started (MusicLibrary* _sender,
                                                    gpointer self)
{
#line 77 "../src/Dialogs/FileNotFoundDialog.vala"
	__lambda45_ (self);
#line 272 "FileNotFoundDialog.c"
}

static void
__lambda46_ (Block12Data* _data12_)
{
	MusicFileNotFoundDialog* self;
#line 81 "../src/Dialogs/FileNotFoundDialog.vala"
	self = _data12_->self;
#line 82 "../src/Dialogs/FileNotFoundDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _data12_->rescan_library, TRUE);
#line 283 "FileNotFoundDialog.c"
}

static void
___lambda46__music_library_file_operations_done (MusicLibrary* _sender,
                                                 gpointer self)
{
#line 81 "../src/Dialogs/FileNotFoundDialog.vala"
	__lambda46_ (self);
#line 292 "FileNotFoundDialog.c"
}

MusicFileNotFoundDialog*
music_file_not_found_dialog_construct (GType object_type,
                                       GeeCollection* _media_list)
{
	MusicFileNotFoundDialog * self = NULL;
	Block12Data* _data12_;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	MusicLibraryWindow* _tmp3_;
	GeeLinkedList* _tmp4_;
	GeeLinkedList* _tmp5_;
	GeeLinkedList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GtkWidget* _tmp28_;
	GtkButton* _tmp29_;
	MusicLibrariesManager* _tmp30_;
	MusicLibrary* _tmp31_;
	MusicLibrariesManager* _tmp32_;
	MusicLibrary* _tmp33_;
	MusicLibrariesManager* _tmp34_;
	MusicLibrary* _tmp35_;
#line 33 "../src/Dialogs/FileNotFoundDialog.vala"
	g_return_val_if_fail (_media_list != NULL, NULL);
#line 33 "../src/Dialogs/FileNotFoundDialog.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 33 "../src/Dialogs/FileNotFoundDialog.vala"
	_data12_->_ref_count_ = 1;
#line 34 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("dialog-warning");
#line 34 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp1_ = _tmp0_;
#line 34 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp2_ = music_app_get_main_window ();
#line 34 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp3_ = _tmp2_;
#line 34 "../src/Dialogs/FileNotFoundDialog.vala"
	self = (MusicFileNotFoundDialog*) g_object_new (object_type, "destroy-with-parent", TRUE, "image-icon", _tmp1_, "primary-text", _ ("File not found"), "transient-for", _tmp3_, NULL);
#line 34 "../src/Dialogs/FileNotFoundDialog.vala"
	_data12_->self = g_object_ref (self);
#line 34 "../src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (_tmp1_);
#line 41 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp4_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 41 "../src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (self->priv->media_list);
#line 41 "../src/Dialogs/FileNotFoundDialog.vala"
	self->priv->media_list = _tmp4_;
#line 42 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp5_ = self->priv->media_list;
#line 42 "../src/Dialogs/FileNotFoundDialog.vala"
	gee_collection_add_all ((GeeCollection*) _tmp5_, _media_list);
#line 44 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp6_ = self->priv->media_list;
#line 44 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 44 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp8_ = _tmp7_;
#line 44 "../src/Dialogs/FileNotFoundDialog.vala"
	if (_tmp8_ == 1) {
#line 356 "FileNotFoundDialog.c"
		MusicMedia* s = NULL;
		GeeLinkedList* _tmp9_;
		gpointer _tmp10_;
		MusicMedia* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		MusicMedia* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 45 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp9_ = self->priv->media_list;
#line 45 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, 0);
#line 45 "../src/Dialogs/FileNotFoundDialog.vala"
		s = (MusicMedia*) _tmp10_;
#line 47 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp11_ = s;
#line 47 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp12_ = music_media_get_title (_tmp11_);
#line 47 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp13_ = _tmp12_;
#line 47 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp14_ = g_markup_escape_text (_tmp13_, (gssize) -1);
#line 47 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp15_ = _tmp14_;
#line 47 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp16_ = s;
#line 47 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp17_ = music_media_get_artist (_tmp16_);
#line 47 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp18_ = _tmp17_;
#line 47 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp19_ = g_markup_escape_text (_tmp18_, (gssize) -1);
#line 47 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp20_ = _tmp19_;
#line 47 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp21_ = g_strdup_printf (_ ("The music file for <b>%s</b> by <b>%s</b> could not be found."), _tmp15_, _tmp20_);
#line 47 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp22_ = _tmp21_;
#line 47 "../src/Dialogs/FileNotFoundDialog.vala"
		granite_message_dialog_set_secondary_text ((GraniteMessageDialog*) self, _tmp22_);
#line 47 "../src/Dialogs/FileNotFoundDialog.vala"
		_g_free0 (_tmp22_);
#line 47 "../src/Dialogs/FileNotFoundDialog.vala"
		_g_free0 (_tmp20_);
#line 47 "../src/Dialogs/FileNotFoundDialog.vala"
		_g_free0 (_tmp15_);
#line 44 "../src/Dialogs/FileNotFoundDialog.vala"
		_g_object_unref0 (s);
#line 412 "FileNotFoundDialog.c"
	} else {
		GeeLinkedList* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
#line 50 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp23_ = self->priv->media_list;
#line 50 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp24_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp23_);
#line 50 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp25_ = _tmp24_;
#line 50 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp26_ = g_strdup_printf (_ ("%i music files could not be found."), _tmp25_);
#line 50 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp27_ = _tmp26_;
#line 50 "../src/Dialogs/FileNotFoundDialog.vala"
		granite_message_dialog_set_secondary_text ((GraniteMessageDialog*) self, _tmp27_);
#line 50 "../src/Dialogs/FileNotFoundDialog.vala"
		_g_free0 (_tmp27_);
#line 433 "FileNotFoundDialog.c"
	}
#line 53 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp28_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Rescan Library"), 1);
#line 53 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp29_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, gtk_button_get_type (), GtkButton));
#line 53 "../src/Dialogs/FileNotFoundDialog.vala"
	_data12_->rescan_library = _tmp29_;
#line 54 "../src/Dialogs/FileNotFoundDialog.vala"
	gtk_dialog_add_button ((GtkDialog*) self, _ ("Remove Song"), 2);
#line 55 "../src/Dialogs/FileNotFoundDialog.vala"
	gtk_dialog_add_button ((GtkDialog*) self, _ ("Cancel"), (gint) GTK_RESPONSE_CLOSE);
#line 56 "../src/Dialogs/FileNotFoundDialog.vala"
	gtk_dialog_add_button ((GtkDialog*) self, _ ("Find Song"), 3);
#line 58 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp30_ = music_libraries_manager;
#line 58 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp31_ = _tmp30_->local_library;
#line 58 "../src/Dialogs/FileNotFoundDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _data12_->rescan_library, !music_library_doing_file_operations (_tmp31_));
#line 60 "../src/Dialogs/FileNotFoundDialog.vala"
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) ___lambda44__gtk_dialog_response, self, 0);
#line 77 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp32_ = music_libraries_manager;
#line 77 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp33_ = _tmp32_->local_library;
#line 77 "../src/Dialogs/FileNotFoundDialog.vala"
	g_signal_connect_data (_tmp33_, "file-operations-started", (GCallback) ___lambda45__music_library_file_operations_started, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 81 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp34_ = music_libraries_manager;
#line 81 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp35_ = _tmp34_->local_library;
#line 81 "../src/Dialogs/FileNotFoundDialog.vala"
	g_signal_connect_data (_tmp35_, "file-operations-done", (GCallback) ___lambda46__music_library_file_operations_done, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 85 "../src/Dialogs/FileNotFoundDialog.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 33 "../src/Dialogs/FileNotFoundDialog.vala"
	block12_data_unref (_data12_);
#line 33 "../src/Dialogs/FileNotFoundDialog.vala"
	_data12_ = NULL;
#line 33 "../src/Dialogs/FileNotFoundDialog.vala"
	return self;
#line 475 "FileNotFoundDialog.c"
}

MusicFileNotFoundDialog*
music_file_not_found_dialog_new (GeeCollection* _media_list)
{
#line 33 "../src/Dialogs/FileNotFoundDialog.vala"
	return music_file_not_found_dialog_construct (MUSIC_TYPE_FILE_NOT_FOUND_DIALOG, _media_list);
#line 483 "FileNotFoundDialog.c"
}

static void
music_file_not_found_dialog_remove_media_clicked (MusicFileNotFoundDialog* self)
{
	MusicLibrariesManager* _tmp0_;
	MusicLibrary* _tmp1_;
	GeeLinkedList* _tmp2_;
#line 88 "../src/Dialogs/FileNotFoundDialog.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp0_ = music_libraries_manager;
#line 89 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp1_ = _tmp0_->local_library;
#line 89 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp2_ = self->priv->media_list;
#line 89 "../src/Dialogs/FileNotFoundDialog.vala"
	music_library_remove_medias (_tmp1_, (GeeCollection*) _tmp2_, FALSE);
#line 91 "../src/Dialogs/FileNotFoundDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 504 "FileNotFoundDialog.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 523 "FileNotFoundDialog.c"
}

static void
music_file_not_found_dialog_locate_media_clicked (MusicFileNotFoundDialog* self)
{
	MusicMedia* m = NULL;
	GeeLinkedList* _tmp0_;
	gpointer _tmp1_;
	gint64 media_id = 0LL;
	MusicMedia* _tmp2_;
	gint64 _tmp3_;
	gint64 _tmp4_;
	GtkFileChooserNative* file_chooser = NULL;
	GtkFileChooserNative* _tmp5_;
	GFile* invalid_file = NULL;
	MusicLibrariesManager* _tmp6_;
	MusicLibrary* _tmp7_;
	MusicMedia* _tmp8_;
	MusicMedia* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	gchar* music_folder = NULL;
	MusicSettingsMain* _tmp15_;
	MusicSettingsMain* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GFile* _tmp21_;
	GFile* _tmp22_;
	GFile* _tmp23_;
	gboolean _tmp24_;
	gchar* file = NULL;
	gchar* _tmp62_;
	GtkFileChooserNative* _tmp63_;
	GtkFileChooserNative* _tmp66_;
	gboolean _tmp67_ = FALSE;
	const gchar* _tmp68_;
#line 94 "../src/Dialogs/FileNotFoundDialog.vala"
	g_return_if_fail (self != NULL);
#line 95 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp0_ = self->priv->media_list;
#line 95 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
#line 95 "../src/Dialogs/FileNotFoundDialog.vala"
	m = (MusicMedia*) _tmp1_;
#line 96 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp2_ = m;
#line 96 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp3_ = music_media_get_rowid (_tmp2_);
#line 96 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp4_ = _tmp3_;
#line 96 "../src/Dialogs/FileNotFoundDialog.vala"
	media_id = _tmp4_;
#line 98 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp5_ = gtk_file_chooser_native_new (_ ("Choose Music Folder"), (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_OPEN, _ ("Open"), _ ("Cancel"));
#line 98 "../src/Dialogs/FileNotFoundDialog.vala"
	file_chooser = _tmp5_;
#line 107 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp6_ = music_libraries_manager;
#line 107 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp7_ = _tmp6_->local_library;
#line 107 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp8_ = music_library_media_from_id (_tmp7_, media_id);
#line 107 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp9_ = _tmp8_;
#line 107 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp10_ = music_media_get_uri (_tmp9_);
#line 107 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp11_ = _tmp10_;
#line 107 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp12_ = _tmp11_;
#line 107 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp13_ = g_file_new_for_uri (_tmp12_);
#line 107 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp14_ = _tmp13_;
#line 107 "../src/Dialogs/FileNotFoundDialog.vala"
	_g_free0 (_tmp12_);
#line 107 "../src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (_tmp9_);
#line 107 "../src/Dialogs/FileNotFoundDialog.vala"
	invalid_file = _tmp14_;
#line 108 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp15_ = music_settings_main_get_default ();
#line 108 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp16_ = _tmp15_;
#line 108 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp17_ = music_settings_main_get_music_folder (_tmp16_);
#line 108 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp18_ = _tmp17_;
#line 108 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp19_ = g_strdup (_tmp18_);
#line 108 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp20_ = _tmp19_;
#line 108 "../src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (_tmp16_);
#line 108 "../src/Dialogs/FileNotFoundDialog.vala"
	music_folder = _tmp20_;
#line 110 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp21_ = invalid_file;
#line 110 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp22_ = g_file_get_parent (_tmp21_);
#line 110 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp23_ = _tmp22_;
#line 110 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp24_ = g_file_query_exists (_tmp23_, NULL);
#line 110 "../src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (_tmp23_);
#line 110 "../src/Dialogs/FileNotFoundDialog.vala"
	if (_tmp24_) {
#line 637 "FileNotFoundDialog.c"
		GtkFileChooserNative* _tmp25_;
		GFile* _tmp26_;
		GFile* _tmp27_;
		GFile* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
#line 111 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp25_ = file_chooser;
#line 111 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp26_ = invalid_file;
#line 111 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp27_ = g_file_get_parent (_tmp26_);
#line 111 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp28_ = _tmp27_;
#line 111 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp29_ = g_file_get_path (_tmp28_);
#line 111 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp30_ = _tmp29_;
#line 111 "../src/Dialogs/FileNotFoundDialog.vala"
		gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp25_, _tmp30_);
#line 111 "../src/Dialogs/FileNotFoundDialog.vala"
		_g_free0 (_tmp30_);
#line 111 "../src/Dialogs/FileNotFoundDialog.vala"
		_g_object_unref0 (_tmp28_);
#line 662 "FileNotFoundDialog.c"
	} else {
		gboolean _tmp31_ = FALSE;
		GFile* _tmp32_;
		GFile* _tmp33_;
		GFile* _tmp34_;
		GFile* _tmp35_;
		GFile* _tmp36_;
		gboolean _tmp37_;
#line 112 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp32_ = invalid_file;
#line 112 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp33_ = g_file_get_parent (_tmp32_);
#line 112 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp34_ = _tmp33_;
#line 112 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp35_ = g_file_get_parent (_tmp34_);
#line 112 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp36_ = _tmp35_;
#line 112 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp37_ = g_file_query_exists (_tmp36_, NULL);
#line 112 "../src/Dialogs/FileNotFoundDialog.vala"
		_g_object_unref0 (_tmp36_);
#line 112 "../src/Dialogs/FileNotFoundDialog.vala"
		_g_object_unref0 (_tmp34_);
#line 112 "../src/Dialogs/FileNotFoundDialog.vala"
		if (_tmp37_) {
#line 689 "FileNotFoundDialog.c"
			GFile* _tmp38_;
			GFile* _tmp39_;
			GFile* _tmp40_;
			GFile* _tmp41_;
			GFile* _tmp42_;
			gchar* _tmp43_;
			gchar* _tmp44_;
			const gchar* _tmp45_;
#line 113 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp38_ = invalid_file;
#line 113 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp39_ = g_file_get_parent (_tmp38_);
#line 113 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp40_ = _tmp39_;
#line 113 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp41_ = g_file_get_parent (_tmp40_);
#line 113 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp42_ = _tmp41_;
#line 113 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp43_ = g_file_get_path (_tmp42_);
#line 113 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp44_ = _tmp43_;
#line 113 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp45_ = music_folder;
#line 113 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp31_ = string_contains (_tmp44_, _tmp45_);
#line 113 "../src/Dialogs/FileNotFoundDialog.vala"
			_g_free0 (_tmp44_);
#line 113 "../src/Dialogs/FileNotFoundDialog.vala"
			_g_object_unref0 (_tmp42_);
#line 113 "../src/Dialogs/FileNotFoundDialog.vala"
			_g_object_unref0 (_tmp40_);
#line 722 "FileNotFoundDialog.c"
		} else {
#line 112 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp31_ = FALSE;
#line 726 "FileNotFoundDialog.c"
		}
#line 112 "../src/Dialogs/FileNotFoundDialog.vala"
		if (_tmp31_) {
#line 730 "FileNotFoundDialog.c"
			GtkFileChooserNative* _tmp46_;
			GFile* _tmp47_;
			GFile* _tmp48_;
			GFile* _tmp49_;
			GFile* _tmp50_;
			GFile* _tmp51_;
			gchar* _tmp52_;
			gchar* _tmp53_;
#line 115 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp46_ = file_chooser;
#line 115 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp47_ = invalid_file;
#line 115 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp48_ = g_file_get_parent (_tmp47_);
#line 115 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp49_ = _tmp48_;
#line 115 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp50_ = g_file_get_parent (_tmp49_);
#line 115 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp51_ = _tmp50_;
#line 115 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp52_ = g_file_get_path (_tmp51_);
#line 115 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp53_ = _tmp52_;
#line 115 "../src/Dialogs/FileNotFoundDialog.vala"
			gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp46_, _tmp53_);
#line 115 "../src/Dialogs/FileNotFoundDialog.vala"
			_g_free0 (_tmp53_);
#line 115 "../src/Dialogs/FileNotFoundDialog.vala"
			_g_object_unref0 (_tmp51_);
#line 115 "../src/Dialogs/FileNotFoundDialog.vala"
			_g_object_unref0 (_tmp49_);
#line 763 "FileNotFoundDialog.c"
		} else {
			const gchar* _tmp54_;
			GFile* _tmp55_;
			GFile* _tmp56_;
			gboolean _tmp57_;
#line 116 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp54_ = music_folder;
#line 116 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp55_ = g_file_new_for_path (_tmp54_);
#line 116 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp56_ = _tmp55_;
#line 116 "../src/Dialogs/FileNotFoundDialog.vala"
			_tmp57_ = g_file_query_exists (_tmp56_, NULL);
#line 116 "../src/Dialogs/FileNotFoundDialog.vala"
			_g_object_unref0 (_tmp56_);
#line 116 "../src/Dialogs/FileNotFoundDialog.vala"
			if (_tmp57_) {
#line 781 "FileNotFoundDialog.c"
				GtkFileChooserNative* _tmp58_;
				const gchar* _tmp59_;
#line 117 "../src/Dialogs/FileNotFoundDialog.vala"
				_tmp58_ = file_chooser;
#line 117 "../src/Dialogs/FileNotFoundDialog.vala"
				_tmp59_ = music_folder;
#line 117 "../src/Dialogs/FileNotFoundDialog.vala"
				gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp58_, _tmp59_);
#line 790 "FileNotFoundDialog.c"
			} else {
				GtkFileChooserNative* _tmp60_;
				const gchar* _tmp61_;
#line 119 "../src/Dialogs/FileNotFoundDialog.vala"
				_tmp60_ = file_chooser;
#line 119 "../src/Dialogs/FileNotFoundDialog.vala"
				_tmp61_ = g_get_home_dir ();
#line 119 "../src/Dialogs/FileNotFoundDialog.vala"
				gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp60_, _tmp61_);
#line 800 "FileNotFoundDialog.c"
			}
		}
	}
#line 122 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp62_ = g_strdup ("");
#line 122 "../src/Dialogs/FileNotFoundDialog.vala"
	file = _tmp62_;
#line 123 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp63_ = file_chooser;
#line 123 "../src/Dialogs/FileNotFoundDialog.vala"
	if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp63_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 812 "FileNotFoundDialog.c"
		GtkFileChooserNative* _tmp64_;
		gchar* _tmp65_;
#line 124 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp64_ = file_chooser;
#line 124 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp65_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp64_);
#line 124 "../src/Dialogs/FileNotFoundDialog.vala"
		_g_free0 (file);
#line 124 "../src/Dialogs/FileNotFoundDialog.vala"
		file = _tmp65_;
#line 823 "FileNotFoundDialog.c"
	}
#line 127 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp66_ = file_chooser;
#line 127 "../src/Dialogs/FileNotFoundDialog.vala"
	gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp66_);
#line 129 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp68_ = file;
#line 129 "../src/Dialogs/FileNotFoundDialog.vala"
	if (g_strcmp0 (_tmp68_, "") != 0) {
#line 833 "FileNotFoundDialog.c"
		const gchar* _tmp69_;
		GFile* _tmp70_;
		GFile* _tmp71_;
#line 129 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp69_ = file;
#line 129 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp70_ = g_file_new_for_path (_tmp69_);
#line 129 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp71_ = _tmp70_;
#line 129 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp67_ = g_file_query_exists (_tmp71_, NULL);
#line 129 "../src/Dialogs/FileNotFoundDialog.vala"
		_g_object_unref0 (_tmp71_);
#line 847 "FileNotFoundDialog.c"
	} else {
#line 129 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp67_ = FALSE;
#line 851 "FileNotFoundDialog.c"
	}
#line 129 "../src/Dialogs/FileNotFoundDialog.vala"
	if (_tmp67_) {
#line 855 "FileNotFoundDialog.c"
		MusicMedia* _tmp72_;
		const gchar* _tmp73_;
		GFile* _tmp74_;
		GFile* _tmp75_;
		gchar* _tmp76_;
		gchar* _tmp77_;
		MusicMedia* _tmp78_;
		MusicMedia* _tmp79_;
		MusicLibrariesManager* _tmp80_;
		MusicLibrary* _tmp81_;
		MusicMedia* _tmp82_;
#line 130 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp72_ = m;
#line 130 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp73_ = file;
#line 130 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp74_ = g_file_new_for_path (_tmp73_);
#line 130 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp75_ = _tmp74_;
#line 130 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp76_ = g_file_get_uri (_tmp75_);
#line 130 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp77_ = _tmp76_;
#line 130 "../src/Dialogs/FileNotFoundDialog.vala"
		music_media_set_uri (_tmp72_, _tmp77_);
#line 130 "../src/Dialogs/FileNotFoundDialog.vala"
		_g_free0 (_tmp77_);
#line 130 "../src/Dialogs/FileNotFoundDialog.vala"
		_g_object_unref0 (_tmp75_);
#line 131 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp78_ = m;
#line 131 "../src/Dialogs/FileNotFoundDialog.vala"
		music_media_set_location_unknown (_tmp78_, FALSE);
#line 132 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp79_ = m;
#line 132 "../src/Dialogs/FileNotFoundDialog.vala"
		music_media_set_unique_status_image (_tmp79_, NULL);
#line 135 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp80_ = music_libraries_manager;
#line 135 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp81_ = _tmp80_->local_library;
#line 135 "../src/Dialogs/FileNotFoundDialog.vala"
		_tmp82_ = m;
#line 135 "../src/Dialogs/FileNotFoundDialog.vala"
		music_library_update_media (_tmp81_, _tmp82_, FALSE, FALSE);
#line 137 "../src/Dialogs/FileNotFoundDialog.vala"
		gtk_widget_destroy ((GtkWidget*) self);
#line 903 "FileNotFoundDialog.c"
	}
#line 94 "../src/Dialogs/FileNotFoundDialog.vala"
	_g_free0 (file);
#line 94 "../src/Dialogs/FileNotFoundDialog.vala"
	_g_free0 (music_folder);
#line 94 "../src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (invalid_file);
#line 94 "../src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (file_chooser);
#line 94 "../src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (m);
#line 915 "FileNotFoundDialog.c"
}

static void
music_file_not_found_dialog_rescan_library_clicked (MusicFileNotFoundDialog* self)
{
	MusicLibrariesManager* _tmp0_;
	MusicLibrary* _tmp1_;
#line 141 "../src/Dialogs/FileNotFoundDialog.vala"
	g_return_if_fail (self != NULL);
#line 142 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp0_ = music_libraries_manager;
#line 142 "../src/Dialogs/FileNotFoundDialog.vala"
	_tmp1_ = _tmp0_->local_library;
#line 142 "../src/Dialogs/FileNotFoundDialog.vala"
	music_local_library_rescan_music_folder (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibrary));
#line 144 "../src/Dialogs/FileNotFoundDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 933 "FileNotFoundDialog.c"
}

static void
music_file_not_found_dialog_class_init (MusicFileNotFoundDialogClass * klass,
                                        gpointer klass_data)
{
#line 30 "../src/Dialogs/FileNotFoundDialog.vala"
	music_file_not_found_dialog_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/Dialogs/FileNotFoundDialog.vala"
	g_type_class_adjust_private_offset (klass, &MusicFileNotFoundDialog_private_offset);
#line 30 "../src/Dialogs/FileNotFoundDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = music_file_not_found_dialog_finalize;
#line 946 "FileNotFoundDialog.c"
}

static void
music_file_not_found_dialog_instance_init (MusicFileNotFoundDialog * self,
                                           gpointer klass)
{
#line 30 "../src/Dialogs/FileNotFoundDialog.vala"
	self->priv = music_file_not_found_dialog_get_instance_private (self);
#line 955 "FileNotFoundDialog.c"
}

static void
music_file_not_found_dialog_finalize (GObject * obj)
{
	MusicFileNotFoundDialog * self;
#line 30 "../src/Dialogs/FileNotFoundDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_FILE_NOT_FOUND_DIALOG, MusicFileNotFoundDialog);
#line 31 "../src/Dialogs/FileNotFoundDialog.vala"
	_g_object_unref0 (self->priv->media_list);
#line 30 "../src/Dialogs/FileNotFoundDialog.vala"
	G_OBJECT_CLASS (music_file_not_found_dialog_parent_class)->finalize (obj);
#line 968 "FileNotFoundDialog.c"
}

static GType
music_file_not_found_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicFileNotFoundDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_file_not_found_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicFileNotFoundDialog), 0, (GInstanceInitFunc) music_file_not_found_dialog_instance_init, NULL };
	GType music_file_not_found_dialog_type_id;
	music_file_not_found_dialog_type_id = g_type_register_static (GRANITE_TYPE_MESSAGE_DIALOG, "MusicFileNotFoundDialog", &g_define_type_info, 0);
	MusicFileNotFoundDialog_private_offset = g_type_add_instance_private (music_file_not_found_dialog_type_id, sizeof (MusicFileNotFoundDialogPrivate));
	return music_file_not_found_dialog_type_id;
}

GType
music_file_not_found_dialog_get_type (void)
{
	static volatile gsize music_file_not_found_dialog_type_id__once = 0;
	if (g_once_init_enter (&music_file_not_found_dialog_type_id__once)) {
		GType music_file_not_found_dialog_type_id;
		music_file_not_found_dialog_type_id = music_file_not_found_dialog_get_type_once ();
		g_once_init_leave (&music_file_not_found_dialog_type_id__once, music_file_not_found_dialog_type_id);
	}
	return music_file_not_found_dialog_type_id__once;
}

