/* FileOperator.c generated by valac 0.56.0, the Vala compiler
 * generated from FileOperator.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include "io.elementary.music-core.h"
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <tag_c.h>
#include <granite.h>
#include <gtk/gtk.h>
#include <handy.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_FILE_OPERATOR (music_file_operator_get_type ())
#define MUSIC_FILE_OPERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_FILE_OPERATOR, MusicFileOperator))
#define MUSIC_FILE_OPERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_FILE_OPERATOR, MusicFileOperatorClass))
#define MUSIC_IS_FILE_OPERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_FILE_OPERATOR))
#define MUSIC_IS_FILE_OPERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_FILE_OPERATOR))
#define MUSIC_FILE_OPERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_FILE_OPERATOR, MusicFileOperatorClass))

typedef struct _MusicFileOperator MusicFileOperator;
typedef struct _MusicFileOperatorClass MusicFileOperatorClass;
typedef struct _MusicFileOperatorPrivate MusicFileOperatorPrivate;

#define MUSIC_TYPE_GSTREAMER_TAGGER (music_gstreamer_tagger_get_type ())
#define MUSIC_GSTREAMER_TAGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_GSTREAMER_TAGGER, MusicGStreamerTagger))
#define MUSIC_GSTREAMER_TAGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_GSTREAMER_TAGGER, MusicGStreamerTaggerClass))
#define MUSIC_IS_GSTREAMER_TAGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_GSTREAMER_TAGGER))
#define MUSIC_IS_GSTREAMER_TAGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_GSTREAMER_TAGGER))
#define MUSIC_GSTREAMER_TAGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_GSTREAMER_TAGGER, MusicGStreamerTaggerClass))

typedef struct _MusicGStreamerTagger MusicGStreamerTagger;
typedef struct _MusicGStreamerTaggerClass MusicGStreamerTaggerClass;
typedef enum  {
	MUSIC_FILE_OPERATOR_IMPORT_TYPE_SET,
	MUSIC_FILE_OPERATOR_IMPORT_TYPE_RESCAN,
	MUSIC_FILE_OPERATOR_IMPORT_TYPE_PLAYLIST,
	MUSIC_FILE_OPERATOR_IMPORT_TYPE_IMPORT
} MusicFileOperatorImportType;

#define MUSIC_FILE_OPERATOR_TYPE_IMPORT_TYPE (music_file_operator_import_type_get_type ())
enum  {
	MUSIC_FILE_OPERATOR_0_PROPERTY,
	MUSIC_FILE_OPERATOR_NUM_PROPERTIES
};
static GParamSpec* music_file_operator_properties[MUSIC_FILE_OPERATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _taglib_file_free0(var) ((var == NULL) ? NULL : (var = (taglib_file_free (var), NULL)))
typedef struct _MusicFileOperatorSaveMediaData MusicFileOperatorSaveMediaData;
typedef struct _Block2Data Block2Data;

#define MUSIC_TYPE_NOT_IMPORTED_DIALOG (music_not_imported_dialog_get_type ())
#define MUSIC_NOT_IMPORTED_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_NOT_IMPORTED_DIALOG, MusicNotImportedDialog))
#define MUSIC_NOT_IMPORTED_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_NOT_IMPORTED_DIALOG, MusicNotImportedDialogClass))
#define MUSIC_IS_NOT_IMPORTED_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_NOT_IMPORTED_DIALOG))
#define MUSIC_IS_NOT_IMPORTED_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_NOT_IMPORTED_DIALOG))
#define MUSIC_NOT_IMPORTED_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_NOT_IMPORTED_DIALOG, MusicNotImportedDialogClass))

typedef struct _MusicNotImportedDialog MusicNotImportedDialog;
typedef struct _MusicNotImportedDialogClass MusicNotImportedDialogClass;

#define MUSIC_TYPE_LIBRARY_WINDOW (music_library_window_get_type ())
#define MUSIC_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow))
#define MUSIC_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))
#define MUSIC_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))

typedef struct _MusicLibraryWindow MusicLibraryWindow;
typedef struct _MusicLibraryWindowClass MusicLibraryWindowClass;
typedef struct _MusicFileOperatorCopyImportsAsyncData MusicFileOperatorCopyImportsAsyncData;
enum  {
	MUSIC_FILE_OPERATOR_IMPORT_CANCELLED_SIGNAL,
	MUSIC_FILE_OPERATOR_RESCAN_CANCELLED_SIGNAL,
	MUSIC_FILE_OPERATOR_NUM_SIGNALS
};
static guint music_file_operator_signals[MUSIC_FILE_OPERATOR_NUM_SIGNALS] = {0};

struct _MusicFileOperator {
	GObject parent_instance;
	MusicFileOperatorPrivate * priv;
	MusicGStreamerTagger* tagger;
	GCancellable* cancellable;
	gint index;
	gint item_count;
};

struct _MusicFileOperatorClass {
	GObjectClass parent_class;
};

struct _MusicFileOperatorPrivate {
	gint queue_size;
	MusicFileOperatorImportType import_type;
	MusicStaticPlaylist* new_playlist;
	GeeTreeSet* all_new_imports;
	GeeTreeSet* import_errors;
	GeeHashMap* monitors;
};

struct _MusicFileOperatorSaveMediaData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicFileOperator* self;
	GeeCollection* to_save;
	GeeTreeSet* copy;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	MusicSettingsMain* main_settings;
	MusicSettingsMain* _tmp2_;
	GeeIterator* _s_it;
	GeeTreeSet* _tmp3_;
	GeeIterator* _tmp4_;
	GeeIterator* _tmp5_;
	MusicMedia* s;
	GeeIterator* _tmp6_;
	gpointer _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	MusicMedia* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	MusicMedia* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	MusicMedia* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	GFile* _tmp20_;
	GFile* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	MusicSettingsMain* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	GSettings* _tmp27_;
	GSettings* _tmp28_;
	TagLib_File* tag_file;
	MusicMedia* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	GFile* _tmp33_;
	GFile* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	TagLib_File* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	TagLib_File* _tmp40_;
	TagLib_File* _tmp41_;
	TagLib_Tag* _tmp42_;
	TagLib_Tag* _tmp43_;
	TagLib_File* _tmp44_;
	const TagLib_AudioProperties* _tmp45_;
	const TagLib_AudioProperties* _tmp46_;
	TagLib_File* _tmp47_;
	TagLib_Tag* _tmp48_;
	TagLib_Tag* _tmp49_;
	MusicMedia* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	TagLib_File* _tmp53_;
	TagLib_Tag* _tmp54_;
	TagLib_Tag* _tmp55_;
	MusicMedia* _tmp56_;
	const gchar* _tmp57_;
	const gchar* _tmp58_;
	TagLib_File* _tmp59_;
	TagLib_Tag* _tmp60_;
	TagLib_Tag* _tmp61_;
	MusicMedia* _tmp62_;
	const gchar* _tmp63_;
	const gchar* _tmp64_;
	TagLib_File* _tmp65_;
	TagLib_Tag* _tmp66_;
	TagLib_Tag* _tmp67_;
	MusicMedia* _tmp68_;
	const gchar* _tmp69_;
	const gchar* _tmp70_;
	TagLib_File* _tmp71_;
	TagLib_Tag* _tmp72_;
	TagLib_Tag* _tmp73_;
	MusicMedia* _tmp74_;
	const gchar* _tmp75_;
	const gchar* _tmp76_;
	TagLib_File* _tmp77_;
	TagLib_Tag* _tmp78_;
	TagLib_Tag* _tmp79_;
	MusicMedia* _tmp80_;
	guint _tmp81_;
	guint _tmp82_;
	TagLib_File* _tmp83_;
	TagLib_Tag* _tmp84_;
	TagLib_Tag* _tmp85_;
	MusicMedia* _tmp86_;
	guint _tmp87_;
	guint _tmp88_;
	TagLib_File* _tmp89_;
	MusicMedia* _tmp90_;
	gchar* _tmp91_;
	gchar* _tmp92_;
	gchar* _tmp93_;
	GSettings* _tmp94_;
	GSettings* _tmp95_;
	MusicMedia* _tmp96_;
};

struct _Block2Data {
	int _ref_count_;
	MusicFileOperator* self;
	MusicMedia* s;
};

struct _MusicFileOperatorCopyImportsAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicFileOperator* self;
	GeeTreeSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeIterator* _s_it;
	GeeTreeSet* _tmp3_;
	GeeIterator* _tmp4_;
	GeeIterator* _tmp5_;
	MusicMedia* s;
	GeeIterator* _tmp6_;
	gpointer _tmp7_;
	GCancellable* _tmp8_;
	MusicMedia* _tmp9_;
	gint _tmp10_;
	MusicLibrariesManager* _tmp11_;
	MusicLibrary* _tmp12_;
};

static gint MusicFileOperator_private_offset;
static gpointer music_file_operator_parent_class = NULL;

VALA_EXTERN GType music_file_operator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicFileOperator, g_object_unref)
VALA_EXTERN GType music_gstreamer_tagger_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicGStreamerTagger, g_object_unref)
VALA_EXTERN GType music_file_operator_import_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MusicFileOperator* music_file_operator_new (void);
VALA_EXTERN MusicFileOperator* music_file_operator_construct (GType object_type);
VALA_EXTERN MusicGStreamerTagger* music_gstreamer_tagger_new (GCancellable* cancellable);
VALA_EXTERN MusicGStreamerTagger* music_gstreamer_tagger_construct (GType object_type,
                                                        GCancellable* cancellable);
static void music_file_operator_media_imported (MusicFileOperator* self,
                                         MusicMedia* m);
static void _music_file_operator_media_imported_music_gstreamer_tagger_media_imported (MusicGStreamerTagger* _sender,
                                                                                MusicMedia* m,
                                                                                gpointer self);
static void music_file_operator_import_error (MusicFileOperator* self,
                                       const gchar* file);
static void _music_file_operator_import_error_music_gstreamer_tagger_import_error (MusicGStreamerTagger* _sender,
                                                                            const gchar* file_uri,
                                                                            GError* _error_,
                                                                            gpointer self);
static void music_file_operator_queue_finished (MusicFileOperator* self);
static void _music_file_operator_queue_finished_music_gstreamer_tagger_queue_finished (MusicGStreamerTagger* _sender,
                                                                                gpointer self);
VALA_EXTERN gint music_file_operator_list_recursive_directory (MusicFileOperator* self,
                                                   GFile* music_folder,
                                                   GeeTreeSet** dirs);
static void music_file_operator_file_monitored_changed (MusicFileOperator* self,
                                                 GFile* file,
                                                 GFile* other_file,
                                                 GFileMonitorEvent event_type);
static void _music_file_operator_file_monitored_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                                         GFile* file,
                                                                         GFile* other_file,
                                                                         GFileMonitorEvent event_type,
                                                                         gpointer self);
VALA_EXTERN void music_file_operator_connect_to_manager (MusicFileOperator* self);
static void __lambda18_ (MusicFileOperator* self);
static void ___lambda18__music_notification_manager_progress_canceled (MusicNotificationManager* _sender,
                                                                gpointer self);
VALA_EXTERN void music_file_operator_reset_progress (MusicFileOperator* self,
                                         gint items);
static void music_file_operator_save_media_data_free (gpointer _data);
VALA_EXTERN void music_file_operator_save_media (MusicFileOperator* self,
                                     GeeCollection* to_save,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
VALA_EXTERN void music_file_operator_save_media_finish (MusicFileOperator* self,
                                            GAsyncResult* _res_);
static gboolean music_file_operator_save_media_co (MusicFileOperatorSaveMediaData* _data_);
VALA_EXTERN GSettings* music_app_get_settings (void);
VALA_EXTERN gboolean music_file_operator_update_file_hierarchy (MusicFileOperator* self,
                                                    MusicMedia* s,
                                                    gboolean delete_old,
                                                    gboolean emit_update);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean _____lambda17_ (Block2Data* _data2_);
static gboolean ______lambda17__gsource_func (gpointer self);
VALA_EXTERN void music_file_operator_remove_media (MusicFileOperator* self,
                                       GeeCollection* to_remove);
VALA_EXTERN void music_file_operator_import_files (MusicFileOperator* self,
                                       GeeCollection* files,
                                       MusicFileOperatorImportType type);
VALA_EXTERN gchar* music_file_operator_get_extension (MusicFileOperator* self,
                                          const gchar* name);
VALA_EXTERN void music_gstreamer_tagger_discoverer_import_media (MusicGStreamerTagger* self,
                                                     GeeCollection* uris);
VALA_EXTERN GType music_not_imported_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicNotImportedDialog, g_object_unref)
VALA_EXTERN MusicNotImportedDialog* music_not_imported_dialog_new (GeeCollection* files,
                                                       const gchar* music);
VALA_EXTERN MusicNotImportedDialog* music_not_imported_dialog_construct (GType object_type,
                                                             GeeCollection* files,
                                                             const gchar* music);
VALA_EXTERN GType music_library_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLibraryWindow, g_object_unref)
VALA_EXTERN MusicLibraryWindow* music_app_get_main_window (void);
VALA_EXTERN void music_library_window_show_notification (MusicLibraryWindow* self,
                                             const gchar* title,
                                             const gchar* body,
                                             GIcon* icon,
                                             GNotificationPriority priority,
                                             const gchar* context);
VALA_EXTERN void music_file_operator_copy_imports_async (MusicFileOperator* self,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
VALA_EXTERN void music_file_operator_copy_imports_finish (MusicFileOperator* self,
                                              GAsyncResult* _res_);
static void music_file_operator_copy_imports_async_data_free (gpointer _data);
static gboolean music_file_operator_copy_imports_async_co (MusicFileOperatorCopyImportsAsyncData* _data_);
static void music_file_operator_finalize (GObject * obj);
static GType music_file_operator_get_type_once (void);

static inline gpointer
music_file_operator_get_instance_private (MusicFileOperator* self)
{
	return G_STRUCT_MEMBER_P (self, MusicFileOperator_private_offset);
}

static GType
music_file_operator_import_type_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_FILE_OPERATOR_IMPORT_TYPE_SET, "MUSIC_FILE_OPERATOR_IMPORT_TYPE_SET", "set"}, {MUSIC_FILE_OPERATOR_IMPORT_TYPE_RESCAN, "MUSIC_FILE_OPERATOR_IMPORT_TYPE_RESCAN", "rescan"}, {MUSIC_FILE_OPERATOR_IMPORT_TYPE_PLAYLIST, "MUSIC_FILE_OPERATOR_IMPORT_TYPE_PLAYLIST", "playlist"}, {MUSIC_FILE_OPERATOR_IMPORT_TYPE_IMPORT, "MUSIC_FILE_OPERATOR_IMPORT_TYPE_IMPORT", "import"}, {0, NULL, NULL}};
	GType music_file_operator_import_type_type_id;
	music_file_operator_import_type_type_id = g_enum_register_static ("MusicFileOperatorImportType", values);
	return music_file_operator_import_type_type_id;
}

GType
music_file_operator_import_type_get_type (void)
{
	static volatile gsize music_file_operator_import_type_type_id__once = 0;
	if (g_once_init_enter (&music_file_operator_import_type_type_id__once)) {
		GType music_file_operator_import_type_type_id;
		music_file_operator_import_type_type_id = music_file_operator_import_type_get_type_once ();
		g_once_init_leave (&music_file_operator_import_type_type_id__once, music_file_operator_import_type_type_id);
	}
	return music_file_operator_import_type_type_id__once;
}

static void
_music_file_operator_media_imported_music_gstreamer_tagger_media_imported (MusicGStreamerTagger* _sender,
                                                                           MusicMedia* m,
                                                                           gpointer self)
{
#line 63 "../src/FileOperator.vala"
	music_file_operator_media_imported ((MusicFileOperator*) self, m);
#line 417 "FileOperator.c"
}

static void
_music_file_operator_import_error_music_gstreamer_tagger_import_error (MusicGStreamerTagger* _sender,
                                                                       const gchar* file_uri,
                                                                       GError* _error_,
                                                                       gpointer self)
{
#line 64 "../src/FileOperator.vala"
	music_file_operator_import_error ((MusicFileOperator*) self, file_uri);
#line 428 "FileOperator.c"
}

static void
_music_file_operator_queue_finished_music_gstreamer_tagger_queue_finished (MusicGStreamerTagger* _sender,
                                                                           gpointer self)
{
#line 65 "../src/FileOperator.vala"
	music_file_operator_queue_finished ((MusicFileOperator*) self);
#line 437 "FileOperator.c"
}

static void
_music_file_operator_file_monitored_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                                    GFile* file,
                                                                    GFile* other_file,
                                                                    GFileMonitorEvent event_type,
                                                                    gpointer self)
{
#line 78 "../src/FileOperator.vala"
	music_file_operator_file_monitored_changed ((MusicFileOperator*) self, file, other_file, event_type);
#line 449 "FileOperator.c"
}

MusicFileOperator*
music_file_operator_construct (GType object_type)
{
	MusicFileOperator * self = NULL;
	GCancellable* _tmp0_;
	GeeTreeSet* _tmp1_;
	GeeTreeSet* _tmp2_;
	GeeHashMap* _tmp3_;
	GCancellable* _tmp4_;
	MusicGStreamerTagger* _tmp5_;
	MusicGStreamerTagger* _tmp6_;
	MusicGStreamerTagger* _tmp7_;
	MusicGStreamerTagger* _tmp8_;
	gchar* music_folder = NULL;
	MusicSettingsMain* _tmp9_;
	MusicSettingsMain* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GFile* file = NULL;
	const gchar* _tmp15_;
	GFile* _tmp16_;
	GeeTreeSet* dirs = NULL;
	GeeTreeSet* _tmp17_;
	GeeTreeSet* _tmp18_;
	const gchar* _tmp19_;
	GFile* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 54 "../src/FileOperator.vala"
	self = (MusicFileOperator*) g_object_new (object_type, NULL);
#line 55 "../src/FileOperator.vala"
	taglib_id3v2_set_default_text_encoding (TagLib_ID3v2_UTF8);
#line 57 "../src/FileOperator.vala"
	_tmp0_ = g_cancellable_new ();
#line 57 "../src/FileOperator.vala"
	_g_object_unref0 (self->cancellable);
#line 57 "../src/FileOperator.vala"
	self->cancellable = _tmp0_;
#line 58 "../src/FileOperator.vala"
	_tmp1_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 58 "../src/FileOperator.vala"
	_g_object_unref0 (self->priv->all_new_imports);
#line 58 "../src/FileOperator.vala"
	self->priv->all_new_imports = _tmp1_;
#line 59 "../src/FileOperator.vala"
	_tmp2_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 59 "../src/FileOperator.vala"
	_g_object_unref0 (self->priv->import_errors);
#line 59 "../src/FileOperator.vala"
	self->priv->import_errors = _tmp2_;
#line 60 "../src/FileOperator.vala"
	_tmp3_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, g_file_monitor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 60 "../src/FileOperator.vala"
	_g_object_unref0 (self->priv->monitors);
#line 60 "../src/FileOperator.vala"
	self->priv->monitors = _tmp3_;
#line 61 "../src/FileOperator.vala"
	_tmp4_ = self->cancellable;
#line 61 "../src/FileOperator.vala"
	_tmp5_ = music_gstreamer_tagger_new (_tmp4_);
#line 61 "../src/FileOperator.vala"
	_g_object_unref0 (self->tagger);
#line 61 "../src/FileOperator.vala"
	self->tagger = _tmp5_;
#line 63 "../src/FileOperator.vala"
	_tmp6_ = self->tagger;
#line 63 "../src/FileOperator.vala"
	g_signal_connect_object (_tmp6_, "media-imported", (GCallback) _music_file_operator_media_imported_music_gstreamer_tagger_media_imported, self, 0);
#line 64 "../src/FileOperator.vala"
	_tmp7_ = self->tagger;
#line 64 "../src/FileOperator.vala"
	g_signal_connect_object (_tmp7_, "import-error", (GCallback) _music_file_operator_import_error_music_gstreamer_tagger_import_error, self, 0);
#line 65 "../src/FileOperator.vala"
	_tmp8_ = self->tagger;
#line 65 "../src/FileOperator.vala"
	g_signal_connect_object (_tmp8_, "queue-finished", (GCallback) _music_file_operator_queue_finished_music_gstreamer_tagger_queue_finished, self, 0);
#line 68 "../src/FileOperator.vala"
	_tmp9_ = music_settings_main_get_default ();
#line 68 "../src/FileOperator.vala"
	_tmp10_ = _tmp9_;
#line 68 "../src/FileOperator.vala"
	_tmp11_ = music_settings_main_get_music_folder (_tmp10_);
#line 68 "../src/FileOperator.vala"
	_tmp12_ = _tmp11_;
#line 68 "../src/FileOperator.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 68 "../src/FileOperator.vala"
	_tmp14_ = _tmp13_;
#line 68 "../src/FileOperator.vala"
	_g_object_unref0 (_tmp10_);
#line 68 "../src/FileOperator.vala"
	music_folder = _tmp14_;
#line 69 "../src/FileOperator.vala"
	_tmp15_ = music_folder;
#line 69 "../src/FileOperator.vala"
	_tmp16_ = g_file_new_for_path (_tmp15_);
#line 69 "../src/FileOperator.vala"
	file = _tmp16_;
#line 70 "../src/FileOperator.vala"
	_tmp17_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 70 "../src/FileOperator.vala"
	dirs = _tmp17_;
#line 71 "../src/FileOperator.vala"
	_tmp18_ = dirs;
#line 71 "../src/FileOperator.vala"
	_tmp19_ = music_folder;
#line 71 "../src/FileOperator.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
#line 72 "../src/FileOperator.vala"
	_tmp20_ = file;
#line 72 "../src/FileOperator.vala"
	music_file_operator_list_recursive_directory (self, _tmp20_, &dirs);
#line 565 "FileOperator.c"
	{
		GeeIterator* _dir_it = NULL;
		GeeTreeSet* _tmp21_;
		GeeIterator* _tmp22_;
#line 73 "../src/FileOperator.vala"
		_tmp21_ = dirs;
#line 73 "../src/FileOperator.vala"
		_tmp22_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp21_);
#line 73 "../src/FileOperator.vala"
		_dir_it = _tmp22_;
#line 73 "../src/FileOperator.vala"
		while (TRUE) {
#line 578 "FileOperator.c"
			GeeIterator* _tmp23_;
			gchar* dir = NULL;
			GeeIterator* _tmp24_;
			gpointer _tmp25_;
			GFile* dir_file = NULL;
			const gchar* _tmp26_;
			GFile* _tmp27_;
#line 73 "../src/FileOperator.vala"
			_tmp23_ = _dir_it;
#line 73 "../src/FileOperator.vala"
			if (!gee_iterator_next (_tmp23_)) {
#line 73 "../src/FileOperator.vala"
				break;
#line 592 "FileOperator.c"
			}
#line 73 "../src/FileOperator.vala"
			_tmp24_ = _dir_it;
#line 73 "../src/FileOperator.vala"
			_tmp25_ = gee_iterator_get (_tmp24_);
#line 73 "../src/FileOperator.vala"
			dir = (gchar*) _tmp25_;
#line 74 "../src/FileOperator.vala"
			_tmp26_ = dir;
#line 74 "../src/FileOperator.vala"
			_tmp27_ = g_file_new_for_path (_tmp26_);
#line 74 "../src/FileOperator.vala"
			dir_file = _tmp27_;
#line 606 "FileOperator.c"
			{
				GFileMonitor* file_monitor = NULL;
				GFile* _tmp28_;
				GFileMonitor* _tmp29_;
				GeeHashMap* _tmp30_;
				const gchar* _tmp31_;
				GFileMonitor* _tmp32_;
				GFileMonitor* _tmp33_;
#line 76 "../src/FileOperator.vala"
				_tmp28_ = dir_file;
#line 76 "../src/FileOperator.vala"
				_tmp29_ = g_file_monitor (_tmp28_, G_FILE_MONITOR_SEND_MOVED, NULL, &_inner_error0_);
#line 76 "../src/FileOperator.vala"
				file_monitor = _tmp29_;
#line 76 "../src/FileOperator.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 623 "FileOperator.c"
					goto __catch0_g_error;
				}
#line 77 "../src/FileOperator.vala"
				_tmp30_ = self->priv->monitors;
#line 77 "../src/FileOperator.vala"
				_tmp31_ = dir;
#line 77 "../src/FileOperator.vala"
				_tmp32_ = file_monitor;
#line 77 "../src/FileOperator.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp30_, _tmp31_, _tmp32_);
#line 78 "../src/FileOperator.vala"
				_tmp33_ = file_monitor;
#line 78 "../src/FileOperator.vala"
				g_signal_connect_object (_tmp33_, "changed", (GCallback) _music_file_operator_file_monitored_changed_g_file_monitor_changed, self, 0);
#line 75 "../src/FileOperator.vala"
				_g_object_unref0 (file_monitor);
#line 640 "FileOperator.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				const gchar* _tmp34_;
				GError* _tmp35_;
				const gchar* _tmp36_;
#line 75 "../src/FileOperator.vala"
				e = _inner_error0_;
#line 75 "../src/FileOperator.vala"
				_inner_error0_ = NULL;
#line 80 "../src/FileOperator.vala"
				_tmp34_ = dir;
#line 80 "../src/FileOperator.vala"
				_tmp35_ = e;
#line 80 "../src/FileOperator.vala"
				_tmp36_ = _tmp35_->message;
#line 80 "../src/FileOperator.vala"
				g_warning ("FileOperator.vala:80: file %s: %s", _tmp34_, _tmp36_);
#line 75 "../src/FileOperator.vala"
				_g_error_free0 (e);
#line 663 "FileOperator.c"
			}
			__finally0:
#line 75 "../src/FileOperator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 75 "../src/FileOperator.vala"
				_g_object_unref0 (dir_file);
#line 75 "../src/FileOperator.vala"
				_g_free0 (dir);
#line 75 "../src/FileOperator.vala"
				_g_object_unref0 (_dir_it);
#line 75 "../src/FileOperator.vala"
				_g_object_unref0 (dirs);
#line 75 "../src/FileOperator.vala"
				_g_object_unref0 (file);
#line 75 "../src/FileOperator.vala"
				_g_free0 (music_folder);
#line 75 "../src/FileOperator.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 75 "../src/FileOperator.vala"
				g_clear_error (&_inner_error0_);
#line 75 "../src/FileOperator.vala"
				return NULL;
#line 686 "FileOperator.c"
			}
#line 73 "../src/FileOperator.vala"
			_g_object_unref0 (dir_file);
#line 73 "../src/FileOperator.vala"
			_g_free0 (dir);
#line 692 "FileOperator.c"
		}
#line 73 "../src/FileOperator.vala"
		_g_object_unref0 (_dir_it);
#line 696 "FileOperator.c"
	}
#line 54 "../src/FileOperator.vala"
	_g_object_unref0 (dirs);
#line 54 "../src/FileOperator.vala"
	_g_object_unref0 (file);
#line 54 "../src/FileOperator.vala"
	_g_free0 (music_folder);
#line 54 "../src/FileOperator.vala"
	return self;
#line 706 "FileOperator.c"
}

MusicFileOperator*
music_file_operator_new (void)
{
#line 54 "../src/FileOperator.vala"
	return music_file_operator_construct (MUSIC_TYPE_FILE_OPERATOR);
#line 714 "FileOperator.c"
}

gint
music_file_operator_list_recursive_directory (MusicFileOperator* self,
                                              GFile* music_folder,
                                              GeeTreeSet** dirs)
{
	GFileInfo* file_info = NULL;
	gint index = 0;
	GError* _inner_error0_ = NULL;
	gint result;
#line 85 "../src/FileOperator.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 85 "../src/FileOperator.vala"
	g_return_val_if_fail (music_folder != NULL, 0);
#line 85 "../src/FileOperator.vala"
	g_return_val_if_fail (*dirs != NULL, 0);
#line 86 "../src/FileOperator.vala"
	file_info = NULL;
#line 87 "../src/FileOperator.vala"
	index = 0;
#line 736 "FileOperator.c"
	{
		GFileEnumerator* enumerator = NULL;
		GFileEnumerator* _tmp0_;
#line 89 "../src/FileOperator.vala"
		_tmp0_ = g_file_enumerate_children (music_folder, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, 0, NULL, &_inner_error0_);
#line 89 "../src/FileOperator.vala"
		enumerator = _tmp0_;
#line 89 "../src/FileOperator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 746 "FileOperator.c"
			goto __catch0_g_error;
		}
#line 90 "../src/FileOperator.vala"
		while (TRUE) {
#line 751 "FileOperator.c"
			GFileInfo* _tmp1_ = NULL;
			GFileEnumerator* _tmp2_;
			GFileInfo* _tmp3_;
			GFileInfo* _tmp4_;
			GFileInfo* _tmp5_;
			GFile* file = NULL;
			GFileInfo* _tmp6_;
			const gchar* _tmp7_;
			GFile* _tmp8_;
			GFileInfo* _tmp9_;
#line 90 "../src/FileOperator.vala"
			_tmp2_ = enumerator;
#line 90 "../src/FileOperator.vala"
			_tmp3_ = g_file_enumerator_next_file (_tmp2_, NULL, &_inner_error0_);
#line 90 "../src/FileOperator.vala"
			_tmp1_ = _tmp3_;
#line 90 "../src/FileOperator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 90 "../src/FileOperator.vala"
				_g_object_unref0 (enumerator);
#line 772 "FileOperator.c"
				goto __catch0_g_error;
			}
#line 90 "../src/FileOperator.vala"
			_tmp4_ = _tmp1_;
#line 90 "../src/FileOperator.vala"
			_tmp1_ = NULL;
#line 90 "../src/FileOperator.vala"
			_g_object_unref0 (file_info);
#line 90 "../src/FileOperator.vala"
			file_info = _tmp4_;
#line 90 "../src/FileOperator.vala"
			_tmp5_ = file_info;
#line 90 "../src/FileOperator.vala"
			if (!(_tmp5_ != NULL)) {
#line 90 "../src/FileOperator.vala"
				_g_object_unref0 (_tmp1_);
#line 90 "../src/FileOperator.vala"
				break;
#line 791 "FileOperator.c"
			}
#line 91 "../src/FileOperator.vala"
			_tmp6_ = file_info;
#line 91 "../src/FileOperator.vala"
			_tmp7_ = g_file_info_get_name (_tmp6_);
#line 91 "../src/FileOperator.vala"
			_tmp8_ = g_file_get_child (music_folder, _tmp7_);
#line 91 "../src/FileOperator.vala"
			file = _tmp8_;
#line 93 "../src/FileOperator.vala"
			_tmp9_ = file_info;
#line 93 "../src/FileOperator.vala"
			if (g_file_info_get_file_type (_tmp9_) == G_FILE_TYPE_DIRECTORY) {
#line 805 "FileOperator.c"
				GFile* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				GFile* _tmp13_;
#line 94 "../src/FileOperator.vala"
				_tmp10_ = file;
#line 94 "../src/FileOperator.vala"
				_tmp11_ = g_file_get_uri (_tmp10_);
#line 94 "../src/FileOperator.vala"
				_tmp12_ = _tmp11_;
#line 94 "../src/FileOperator.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) (*dirs), _tmp12_);
#line 94 "../src/FileOperator.vala"
				_g_free0 (_tmp12_);
#line 95 "../src/FileOperator.vala"
				_tmp13_ = file;
#line 95 "../src/FileOperator.vala"
				music_file_operator_list_recursive_directory (self, _tmp13_, dirs);
#line 824 "FileOperator.c"
			}
#line 90 "../src/FileOperator.vala"
			_g_object_unref0 (file);
#line 90 "../src/FileOperator.vala"
			_g_object_unref0 (_tmp1_);
#line 830 "FileOperator.c"
		}
#line 88 "../src/FileOperator.vala"
		_g_object_unref0 (enumerator);
#line 834 "FileOperator.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 88 "../src/FileOperator.vala"
		err = _inner_error0_;
#line 88 "../src/FileOperator.vala"
		_inner_error0_ = NULL;
#line 99 "../src/FileOperator.vala"
		_tmp14_ = err;
#line 99 "../src/FileOperator.vala"
		_tmp15_ = _tmp14_->message;
#line 99 "../src/FileOperator.vala"
		g_warning ("FileOperator.vala:99: Could not pre-scan music folder. Progress percen" \
"tage may be off: %s\n", _tmp15_);
#line 88 "../src/FileOperator.vala"
		_g_error_free0 (err);
#line 854 "FileOperator.c"
	}
	__finally0:
#line 88 "../src/FileOperator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 859 "FileOperator.c"
		gint _tmp16_ = -1;
#line 88 "../src/FileOperator.vala"
		_g_object_unref0 (file_info);
#line 88 "../src/FileOperator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 88 "../src/FileOperator.vala"
		g_clear_error (&_inner_error0_);
#line 88 "../src/FileOperator.vala"
		return _tmp16_;
#line 869 "FileOperator.c"
	}
#line 102 "../src/FileOperator.vala"
	result = index;
#line 102 "../src/FileOperator.vala"
	_g_object_unref0 (file_info);
#line 102 "../src/FileOperator.vala"
	return result;
#line 877 "FileOperator.c"
}

static void
__lambda18_ (MusicFileOperator* self)
{
	GCancellable* _tmp0_;
#line 107 "../src/FileOperator.vala"
	_tmp0_ = self->cancellable;
#line 107 "../src/FileOperator.vala"
	g_cancellable_cancel (_tmp0_);
#line 888 "FileOperator.c"
}

static void
___lambda18__music_notification_manager_progress_canceled (MusicNotificationManager* _sender,
                                                           gpointer self)
{
#line 106 "../src/FileOperator.vala"
	__lambda18_ ((MusicFileOperator*) self);
#line 897 "FileOperator.c"
}

void
music_file_operator_connect_to_manager (MusicFileOperator* self)
{
	MusicNotificationManager* _tmp0_;
	MusicNotificationManager* _tmp1_;
#line 105 "../src/FileOperator.vala"
	g_return_if_fail (self != NULL);
#line 106 "../src/FileOperator.vala"
	_tmp0_ = music_notification_manager_get_default ();
#line 106 "../src/FileOperator.vala"
	_tmp1_ = _tmp0_;
#line 106 "../src/FileOperator.vala"
	g_signal_connect_object (_tmp1_, "progress-canceled", (GCallback) ___lambda18__music_notification_manager_progress_canceled, self, 0);
#line 106 "../src/FileOperator.vala"
	_g_object_unref0 (_tmp1_);
#line 915 "FileOperator.c"
}

void
music_file_operator_reset_progress (MusicFileOperator* self,
                                    gint items)
{
#line 111 "../src/FileOperator.vala"
	g_return_if_fail (self != NULL);
#line 112 "../src/FileOperator.vala"
	self->index = 0;
#line 113 "../src/FileOperator.vala"
	self->item_count = items;
#line 928 "FileOperator.c"
}

static void
music_file_operator_save_media_data_free (gpointer _data)
{
	MusicFileOperatorSaveMediaData* _data_;
	_data_ = _data;
#line 30 "../src/FileOperator.vala"
	_g_object_unref0 (_data_->to_save);
#line 30 "../src/FileOperator.vala"
	_g_object_unref0 (_data_->self);
#line 30 "../src/FileOperator.vala"
	g_slice_free (MusicFileOperatorSaveMediaData, _data_);
#line 942 "FileOperator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/FileOperator.vala"
	return self ? g_object_ref (self) : NULL;
#line 950 "FileOperator.c"
}

void
music_file_operator_save_media (MusicFileOperator* self,
                                GeeCollection* to_save,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	MusicFileOperatorSaveMediaData* _data_;
	MusicFileOperator* _tmp0_;
	GeeCollection* _tmp1_;
#line 30 "../src/FileOperator.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/FileOperator.vala"
	g_return_if_fail (to_save != NULL);
#line 30 "../src/FileOperator.vala"
	_data_ = g_slice_new0 (MusicFileOperatorSaveMediaData);
#line 30 "../src/FileOperator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 30 "../src/FileOperator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_file_operator_save_media_data_free);
#line 30 "../src/FileOperator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 30 "../src/FileOperator.vala"
	_data_->self = _tmp0_;
#line 30 "../src/FileOperator.vala"
	_tmp1_ = _g_object_ref0 (to_save);
#line 30 "../src/FileOperator.vala"
	_g_object_unref0 (_data_->to_save);
#line 30 "../src/FileOperator.vala"
	_data_->to_save = _tmp1_;
#line 30 "../src/FileOperator.vala"
	music_file_operator_save_media_co (_data_);
#line 984 "FileOperator.c"
}

void
music_file_operator_save_media_finish (MusicFileOperator* self,
                                       GAsyncResult* _res_)
{
	MusicFileOperatorSaveMediaData* _data_;
#line 30 "../src/FileOperator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 994 "FileOperator.c"
}

static gboolean
music_file_operator_save_media_co (MusicFileOperatorSaveMediaData* _data_)
{
#line 117 "../src/FileOperator.vala"
	switch (_data_->_state_) {
#line 117 "../src/FileOperator.vala"
		case 0:
#line 1004 "FileOperator.c"
		goto _state_0;
		default:
#line 117 "../src/FileOperator.vala"
		g_assert_not_reached ();
#line 1009 "FileOperator.c"
	}
	_state_0:
#line 118 "../src/FileOperator.vala"
	_data_->_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 118 "../src/FileOperator.vala"
	_data_->copy = _data_->_tmp0_;
#line 119 "../src/FileOperator.vala"
	_data_->_tmp1_ = _data_->copy;
#line 119 "../src/FileOperator.vala"
	gee_collection_add_all ((GeeCollection*) _data_->_tmp1_, _data_->to_save);
#line 120 "../src/FileOperator.vala"
	_data_->_tmp2_ = music_settings_main_get_default ();
#line 120 "../src/FileOperator.vala"
	_data_->main_settings = _data_->_tmp2_;
#line 1024 "FileOperator.c"
	{
#line 121 "../src/FileOperator.vala"
		_data_->_tmp3_ = _data_->copy;
#line 121 "../src/FileOperator.vala"
		_data_->_tmp4_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _data_->_tmp3_);
#line 121 "../src/FileOperator.vala"
		_data_->_s_it = _data_->_tmp4_;
#line 121 "../src/FileOperator.vala"
		while (TRUE) {
#line 121 "../src/FileOperator.vala"
			_data_->_tmp5_ = _data_->_s_it;
#line 121 "../src/FileOperator.vala"
			if (!gee_iterator_next (_data_->_tmp5_)) {
#line 121 "../src/FileOperator.vala"
				break;
#line 1040 "FileOperator.c"
			}
#line 121 "../src/FileOperator.vala"
			_data_->_tmp6_ = _data_->_s_it;
#line 121 "../src/FileOperator.vala"
			_data_->_tmp7_ = gee_iterator_get (_data_->_tmp6_);
#line 121 "../src/FileOperator.vala"
			_data_->s = (MusicMedia*) _data_->_tmp7_;
#line 122 "../src/FileOperator.vala"
			_data_->_tmp10_ = _data_->s;
#line 122 "../src/FileOperator.vala"
			_data_->_tmp11_ = music_media_get_is_temporary (_data_->_tmp10_);
#line 122 "../src/FileOperator.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 122 "../src/FileOperator.vala"
			if (_data_->_tmp12_) {
#line 122 "../src/FileOperator.vala"
				_data_->_tmp9_ = TRUE;
#line 1058 "FileOperator.c"
			} else {
#line 122 "../src/FileOperator.vala"
				_data_->_tmp13_ = _data_->s;
#line 122 "../src/FileOperator.vala"
				_data_->_tmp14_ = music_media_get_is_preview (_data_->_tmp13_);
#line 122 "../src/FileOperator.vala"
				_data_->_tmp15_ = _data_->_tmp14_;
#line 122 "../src/FileOperator.vala"
				_data_->_tmp9_ = _data_->_tmp15_;
#line 1068 "FileOperator.c"
			}
#line 122 "../src/FileOperator.vala"
			if (_data_->_tmp9_) {
#line 122 "../src/FileOperator.vala"
				_data_->_tmp8_ = TRUE;
#line 1074 "FileOperator.c"
			} else {
#line 122 "../src/FileOperator.vala"
				_data_->_tmp16_ = _data_->s;
#line 122 "../src/FileOperator.vala"
				_data_->_tmp17_ = music_media_get_uri (_data_->_tmp16_);
#line 122 "../src/FileOperator.vala"
				_data_->_tmp18_ = _data_->_tmp17_;
#line 122 "../src/FileOperator.vala"
				_data_->_tmp19_ = _data_->_tmp18_;
#line 122 "../src/FileOperator.vala"
				_data_->_tmp20_ = g_file_new_for_uri (_data_->_tmp19_);
#line 122 "../src/FileOperator.vala"
				_data_->_tmp21_ = _data_->_tmp20_;
#line 122 "../src/FileOperator.vala"
				_data_->_tmp22_ = g_file_get_path (_data_->_tmp21_);
#line 122 "../src/FileOperator.vala"
				_data_->_tmp23_ = _data_->_tmp22_;
#line 122 "../src/FileOperator.vala"
				_data_->_tmp24_ = _data_->main_settings;
#line 122 "../src/FileOperator.vala"
				_data_->_tmp25_ = music_settings_main_get_music_folder (_data_->_tmp24_);
#line 122 "../src/FileOperator.vala"
				_data_->_tmp26_ = _data_->_tmp25_;
#line 122 "../src/FileOperator.vala"
				_data_->_tmp8_ = g_str_has_prefix (_data_->_tmp23_, _data_->_tmp26_) == FALSE;
#line 122 "../src/FileOperator.vala"
				_g_free0 (_data_->_tmp23_);
#line 122 "../src/FileOperator.vala"
				_g_object_unref0 (_data_->_tmp21_);
#line 122 "../src/FileOperator.vala"
				_g_free0 (_data_->_tmp19_);
#line 1106 "FileOperator.c"
			}
#line 122 "../src/FileOperator.vala"
			if (_data_->_tmp8_) {
#line 123 "../src/FileOperator.vala"
				_g_object_unref0 (_data_->s);
#line 123 "../src/FileOperator.vala"
				continue;
#line 1114 "FileOperator.c"
			}
#line 125 "../src/FileOperator.vala"
			_data_->_tmp27_ = music_app_get_settings ();
#line 125 "../src/FileOperator.vala"
			_data_->_tmp28_ = _data_->_tmp27_;
#line 125 "../src/FileOperator.vala"
			if (g_settings_get_boolean (_data_->_tmp28_, "write-metadata-to-file")) {
#line 127 "../src/FileOperator.vala"
				_data_->_tmp29_ = _data_->s;
#line 127 "../src/FileOperator.vala"
				_data_->_tmp30_ = music_media_get_uri (_data_->_tmp29_);
#line 127 "../src/FileOperator.vala"
				_data_->_tmp31_ = _data_->_tmp30_;
#line 127 "../src/FileOperator.vala"
				_data_->_tmp32_ = _data_->_tmp31_;
#line 127 "../src/FileOperator.vala"
				_data_->_tmp33_ = g_file_new_for_uri (_data_->_tmp32_);
#line 127 "../src/FileOperator.vala"
				_data_->_tmp34_ = _data_->_tmp33_;
#line 127 "../src/FileOperator.vala"
				_data_->_tmp35_ = g_file_get_path (_data_->_tmp34_);
#line 127 "../src/FileOperator.vala"
				_data_->_tmp36_ = _data_->_tmp35_;
#line 127 "../src/FileOperator.vala"
				_data_->_tmp37_ = taglib_file_new (_data_->_tmp36_);
#line 127 "../src/FileOperator.vala"
				_taglib_file_free0 (_data_->tag_file);
#line 127 "../src/FileOperator.vala"
				_data_->tag_file = _data_->_tmp37_;
#line 127 "../src/FileOperator.vala"
				_g_free0 (_data_->_tmp36_);
#line 127 "../src/FileOperator.vala"
				_g_object_unref0 (_data_->_tmp34_);
#line 127 "../src/FileOperator.vala"
				_g_free0 (_data_->_tmp32_);
#line 129 "../src/FileOperator.vala"
				_data_->_tmp40_ = _data_->tag_file;
#line 129 "../src/FileOperator.vala"
				if (_data_->_tmp40_ != NULL) {
#line 129 "../src/FileOperator.vala"
					_data_->_tmp41_ = _data_->tag_file;
#line 129 "../src/FileOperator.vala"
					_data_->_tmp42_ = taglib_file_tag (_data_->_tmp41_);
#line 129 "../src/FileOperator.vala"
					_data_->_tmp43_ = _data_->_tmp42_;
#line 129 "../src/FileOperator.vala"
					_data_->_tmp39_ = _data_->_tmp43_ != NULL;
#line 1162 "FileOperator.c"
				} else {
#line 129 "../src/FileOperator.vala"
					_data_->_tmp39_ = FALSE;
#line 1166 "FileOperator.c"
				}
#line 129 "../src/FileOperator.vala"
				if (_data_->_tmp39_) {
#line 129 "../src/FileOperator.vala"
					_data_->_tmp44_ = _data_->tag_file;
#line 129 "../src/FileOperator.vala"
					_data_->_tmp45_ = taglib_file_audioproperties (_data_->_tmp44_);
#line 129 "../src/FileOperator.vala"
					_data_->_tmp46_ = _data_->_tmp45_;
#line 129 "../src/FileOperator.vala"
					_data_->_tmp38_ = _data_->_tmp46_ != NULL;
#line 1178 "FileOperator.c"
				} else {
#line 129 "../src/FileOperator.vala"
					_data_->_tmp38_ = FALSE;
#line 1182 "FileOperator.c"
				}
#line 129 "../src/FileOperator.vala"
				if (_data_->_tmp38_) {
#line 130 "../src/FileOperator.vala"
					_data_->_tmp47_ = _data_->tag_file;
#line 130 "../src/FileOperator.vala"
					_data_->_tmp48_ = taglib_file_tag (_data_->_tmp47_);
#line 130 "../src/FileOperator.vala"
					_data_->_tmp49_ = _data_->_tmp48_;
#line 130 "../src/FileOperator.vala"
					_data_->_tmp50_ = _data_->s;
#line 130 "../src/FileOperator.vala"
					_data_->_tmp51_ = music_media_get_title (_data_->_tmp50_);
#line 130 "../src/FileOperator.vala"
					_data_->_tmp52_ = _data_->_tmp51_;
#line 130 "../src/FileOperator.vala"
					taglib_tag_set_title (_data_->_tmp49_, _data_->_tmp52_);
#line 131 "../src/FileOperator.vala"
					_data_->_tmp53_ = _data_->tag_file;
#line 131 "../src/FileOperator.vala"
					_data_->_tmp54_ = taglib_file_tag (_data_->_tmp53_);
#line 131 "../src/FileOperator.vala"
					_data_->_tmp55_ = _data_->_tmp54_;
#line 131 "../src/FileOperator.vala"
					_data_->_tmp56_ = _data_->s;
#line 131 "../src/FileOperator.vala"
					_data_->_tmp57_ = music_media_get_artist (_data_->_tmp56_);
#line 131 "../src/FileOperator.vala"
					_data_->_tmp58_ = _data_->_tmp57_;
#line 131 "../src/FileOperator.vala"
					taglib_tag_set_artist (_data_->_tmp55_, _data_->_tmp58_);
#line 132 "../src/FileOperator.vala"
					_data_->_tmp59_ = _data_->tag_file;
#line 132 "../src/FileOperator.vala"
					_data_->_tmp60_ = taglib_file_tag (_data_->_tmp59_);
#line 132 "../src/FileOperator.vala"
					_data_->_tmp61_ = _data_->_tmp60_;
#line 132 "../src/FileOperator.vala"
					_data_->_tmp62_ = _data_->s;
#line 132 "../src/FileOperator.vala"
					_data_->_tmp63_ = music_media_get_album (_data_->_tmp62_);
#line 132 "../src/FileOperator.vala"
					_data_->_tmp64_ = _data_->_tmp63_;
#line 132 "../src/FileOperator.vala"
					taglib_tag_set_album (_data_->_tmp61_, _data_->_tmp64_);
#line 133 "../src/FileOperator.vala"
					_data_->_tmp65_ = _data_->tag_file;
#line 133 "../src/FileOperator.vala"
					_data_->_tmp66_ = taglib_file_tag (_data_->_tmp65_);
#line 133 "../src/FileOperator.vala"
					_data_->_tmp67_ = _data_->_tmp66_;
#line 133 "../src/FileOperator.vala"
					_data_->_tmp68_ = _data_->s;
#line 133 "../src/FileOperator.vala"
					_data_->_tmp69_ = music_media_get_genre (_data_->_tmp68_);
#line 133 "../src/FileOperator.vala"
					_data_->_tmp70_ = _data_->_tmp69_;
#line 133 "../src/FileOperator.vala"
					taglib_tag_set_genre (_data_->_tmp67_, _data_->_tmp70_);
#line 134 "../src/FileOperator.vala"
					_data_->_tmp71_ = _data_->tag_file;
#line 134 "../src/FileOperator.vala"
					_data_->_tmp72_ = taglib_file_tag (_data_->_tmp71_);
#line 134 "../src/FileOperator.vala"
					_data_->_tmp73_ = _data_->_tmp72_;
#line 134 "../src/FileOperator.vala"
					_data_->_tmp74_ = _data_->s;
#line 134 "../src/FileOperator.vala"
					_data_->_tmp75_ = music_media_get_comment (_data_->_tmp74_);
#line 134 "../src/FileOperator.vala"
					_data_->_tmp76_ = _data_->_tmp75_;
#line 134 "../src/FileOperator.vala"
					taglib_tag_set_comment (_data_->_tmp73_, _data_->_tmp76_);
#line 135 "../src/FileOperator.vala"
					_data_->_tmp77_ = _data_->tag_file;
#line 135 "../src/FileOperator.vala"
					_data_->_tmp78_ = taglib_file_tag (_data_->_tmp77_);
#line 135 "../src/FileOperator.vala"
					_data_->_tmp79_ = _data_->_tmp78_;
#line 135 "../src/FileOperator.vala"
					_data_->_tmp80_ = _data_->s;
#line 135 "../src/FileOperator.vala"
					_data_->_tmp81_ = music_media_get_year (_data_->_tmp80_);
#line 135 "../src/FileOperator.vala"
					_data_->_tmp82_ = _data_->_tmp81_;
#line 135 "../src/FileOperator.vala"
					taglib_tag_set_year (_data_->_tmp79_, _data_->_tmp82_);
#line 136 "../src/FileOperator.vala"
					_data_->_tmp83_ = _data_->tag_file;
#line 136 "../src/FileOperator.vala"
					_data_->_tmp84_ = taglib_file_tag (_data_->_tmp83_);
#line 136 "../src/FileOperator.vala"
					_data_->_tmp85_ = _data_->_tmp84_;
#line 136 "../src/FileOperator.vala"
					_data_->_tmp86_ = _data_->s;
#line 136 "../src/FileOperator.vala"
					_data_->_tmp87_ = music_media_get_track (_data_->_tmp86_);
#line 136 "../src/FileOperator.vala"
					_data_->_tmp88_ = _data_->_tmp87_;
#line 136 "../src/FileOperator.vala"
					taglib_tag_set_track (_data_->_tmp85_, _data_->_tmp88_);
#line 137 "../src/FileOperator.vala"
					_data_->_tmp89_ = _data_->tag_file;
#line 137 "../src/FileOperator.vala"
					taglib_file_save (_data_->_tmp89_);
#line 1288 "FileOperator.c"
				} else {
#line 139 "../src/FileOperator.vala"
					_data_->_tmp90_ = _data_->s;
#line 139 "../src/FileOperator.vala"
					_data_->_tmp91_ = music_media_get_uri (_data_->_tmp90_);
#line 139 "../src/FileOperator.vala"
					_data_->_tmp92_ = _data_->_tmp91_;
#line 139 "../src/FileOperator.vala"
					_data_->_tmp93_ = _data_->_tmp92_;
#line 139 "../src/FileOperator.vala"
					g_debug ("FileOperator.vala:139: Could not save %s.\n", _data_->_tmp93_);
#line 139 "../src/FileOperator.vala"
					_g_free0 (_data_->_tmp93_);
#line 1302 "FileOperator.c"
				}
#line 125 "../src/FileOperator.vala"
				_taglib_file_free0 (_data_->tag_file);
#line 1306 "FileOperator.c"
			}
#line 143 "../src/FileOperator.vala"
			_data_->_tmp94_ = music_app_get_settings ();
#line 143 "../src/FileOperator.vala"
			_data_->_tmp95_ = _data_->_tmp94_;
#line 143 "../src/FileOperator.vala"
			if (g_settings_get_boolean (_data_->_tmp95_, "update-folder-hierarchy")) {
#line 144 "../src/FileOperator.vala"
				_data_->_tmp96_ = _data_->s;
#line 144 "../src/FileOperator.vala"
				music_file_operator_update_file_hierarchy (_data_->self, _data_->_tmp96_, TRUE, FALSE);
#line 1318 "FileOperator.c"
			}
#line 121 "../src/FileOperator.vala"
			_g_object_unref0 (_data_->s);
#line 1322 "FileOperator.c"
		}
#line 121 "../src/FileOperator.vala"
		_g_object_unref0 (_data_->_s_it);
#line 1326 "FileOperator.c"
	}
#line 117 "../src/FileOperator.vala"
	_g_object_unref0 (_data_->main_settings);
#line 117 "../src/FileOperator.vala"
	_g_object_unref0 (_data_->copy);
#line 117 "../src/FileOperator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 117 "../src/FileOperator.vala"
	if (_data_->_state_ != 0) {
#line 117 "../src/FileOperator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 117 "../src/FileOperator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1340 "FileOperator.c"
		}
	}
#line 117 "../src/FileOperator.vala"
	g_object_unref (_data_->_async_result);
#line 117 "../src/FileOperator.vala"
	return FALSE;
#line 1347 "FileOperator.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 149 "../src/FileOperator.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 149 "../src/FileOperator.vala"
	return _data2_;
#line 1357 "FileOperator.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 149 "../src/FileOperator.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1367 "FileOperator.c"
		MusicFileOperator* self;
#line 149 "../src/FileOperator.vala"
		self = _data2_->self;
#line 149 "../src/FileOperator.vala"
		_g_object_unref0 (_data2_->s);
#line 149 "../src/FileOperator.vala"
		_g_object_unref0 (self);
#line 149 "../src/FileOperator.vala"
		g_slice_free (Block2Data, _data2_);
#line 1377 "FileOperator.c"
	}
}

static gboolean
_____lambda17_ (Block2Data* _data2_)
{
	MusicFileOperator* self;
	MusicLibrariesManager* _tmp0_;
	MusicLibrary* _tmp1_;
	gboolean result;
#line 171 "../src/FileOperator.vala"
	self = _data2_->self;
#line 172 "../src/FileOperator.vala"
	_tmp0_ = music_libraries_manager;
#line 172 "../src/FileOperator.vala"
	_tmp1_ = _tmp0_->local_library;
#line 172 "../src/FileOperator.vala"
	music_library_update_media (_tmp1_, _data2_->s, FALSE, FALSE);
#line 172 "../src/FileOperator.vala"
	result = FALSE;
#line 172 "../src/FileOperator.vala"
	return result;
#line 1400 "FileOperator.c"
}

static gboolean
______lambda17__gsource_func (gpointer self)
{
	gboolean result;
	result = _____lambda17_ (self);
#line 171 "../src/FileOperator.vala"
	return result;
#line 1410 "FileOperator.c"
}

gboolean
music_file_operator_update_file_hierarchy (MusicFileOperator* self,
                                           MusicMedia* s,
                                           gboolean delete_old,
                                           gboolean emit_update)
{
	Block2Data* _data2_;
	MusicMedia* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 149 "../src/FileOperator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 149 "../src/FileOperator.vala"
	g_return_val_if_fail (s != NULL, FALSE);
#line 149 "../src/FileOperator.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 149 "../src/FileOperator.vala"
	_data2_->_ref_count_ = 1;
#line 149 "../src/FileOperator.vala"
	_data2_->self = g_object_ref (self);
#line 149 "../src/FileOperator.vala"
	_tmp0_ = _g_object_ref0 (s);
#line 149 "../src/FileOperator.vala"
	_g_object_unref0 (_data2_->s);
#line 149 "../src/FileOperator.vala"
	_data2_->s = _tmp0_;
#line 1439 "FileOperator.c"
	{
		GFile* dest = NULL;
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFile* original = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
		gboolean success = FALSE;
#line 151 "../src/FileOperator.vala"
		_tmp1_ = music_file_utils_get_new_destination (_data2_->s);
#line 151 "../src/FileOperator.vala"
		dest = _tmp1_;
#line 152 "../src/FileOperator.vala"
		_tmp2_ = dest;
#line 152 "../src/FileOperator.vala"
		if (_tmp2_ == NULL) {
#line 153 "../src/FileOperator.vala"
			result = TRUE;
#line 153 "../src/FileOperator.vala"
			_g_object_unref0 (dest);
#line 153 "../src/FileOperator.vala"
			block2_data_unref (_data2_);
#line 153 "../src/FileOperator.vala"
			_data2_ = NULL;
#line 153 "../src/FileOperator.vala"
			return result;
#line 1469 "FileOperator.c"
		}
#line 155 "../src/FileOperator.vala"
		_tmp3_ = music_media_get_uri (_data2_->s);
#line 155 "../src/FileOperator.vala"
		_tmp4_ = _tmp3_;
#line 155 "../src/FileOperator.vala"
		_tmp5_ = _tmp4_;
#line 155 "../src/FileOperator.vala"
		_tmp6_ = g_file_new_for_uri (_tmp5_);
#line 155 "../src/FileOperator.vala"
		_tmp7_ = _tmp6_;
#line 155 "../src/FileOperator.vala"
		_g_free0 (_tmp5_);
#line 155 "../src/FileOperator.vala"
		original = _tmp7_;
#line 157 "../src/FileOperator.vala"
		success = FALSE;
#line 158 "../src/FileOperator.vala"
		if (!delete_old) {
#line 1489 "FileOperator.c"
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			GFile* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gboolean _tmp14_ = FALSE;
			GFile* _tmp15_;
			GFile* _tmp16_;
#line 159 "../src/FileOperator.vala"
			_tmp8_ = music_media_get_uri (_data2_->s);
#line 159 "../src/FileOperator.vala"
			_tmp9_ = _tmp8_;
#line 159 "../src/FileOperator.vala"
			_tmp10_ = _tmp9_;
#line 159 "../src/FileOperator.vala"
			_tmp11_ = dest;
#line 159 "../src/FileOperator.vala"
			_tmp12_ = g_file_get_uri (_tmp11_);
#line 159 "../src/FileOperator.vala"
			_tmp13_ = _tmp12_;
#line 159 "../src/FileOperator.vala"
			g_debug ("FileOperator.vala:159: Copying %s to %s", _tmp10_, _tmp13_);
#line 159 "../src/FileOperator.vala"
			_g_free0 (_tmp13_);
#line 159 "../src/FileOperator.vala"
			_g_free0 (_tmp10_);
#line 160 "../src/FileOperator.vala"
			_tmp15_ = original;
#line 160 "../src/FileOperator.vala"
			_tmp16_ = dest;
#line 160 "../src/FileOperator.vala"
			_tmp14_ = g_file_copy (_tmp15_, _tmp16_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error0_);
#line 160 "../src/FileOperator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 160 "../src/FileOperator.vala"
				_g_object_unref0 (original);
#line 160 "../src/FileOperator.vala"
				_g_object_unref0 (dest);
#line 1529 "FileOperator.c"
				goto __catch0_g_error;
			}
#line 160 "../src/FileOperator.vala"
			success = _tmp14_;
#line 1534 "FileOperator.c"
		} else {
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			GFile* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gboolean _tmp23_ = FALSE;
			GFile* _tmp24_;
			GFile* _tmp25_;
#line 162 "../src/FileOperator.vala"
			_tmp17_ = music_media_get_uri (_data2_->s);
#line 162 "../src/FileOperator.vala"
			_tmp18_ = _tmp17_;
#line 162 "../src/FileOperator.vala"
			_tmp19_ = _tmp18_;
#line 162 "../src/FileOperator.vala"
			_tmp20_ = dest;
#line 162 "../src/FileOperator.vala"
			_tmp21_ = g_file_get_uri (_tmp20_);
#line 162 "../src/FileOperator.vala"
			_tmp22_ = _tmp21_;
#line 162 "../src/FileOperator.vala"
			g_debug ("FileOperator.vala:162: Moving %s to %s", _tmp19_, _tmp22_);
#line 162 "../src/FileOperator.vala"
			_g_free0 (_tmp22_);
#line 162 "../src/FileOperator.vala"
			_g_free0 (_tmp19_);
#line 163 "../src/FileOperator.vala"
			_tmp24_ = original;
#line 163 "../src/FileOperator.vala"
			_tmp25_ = dest;
#line 163 "../src/FileOperator.vala"
			_tmp23_ = g_file_move (_tmp24_, _tmp25_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error0_);
#line 163 "../src/FileOperator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 163 "../src/FileOperator.vala"
				_g_object_unref0 (original);
#line 163 "../src/FileOperator.vala"
				_g_object_unref0 (dest);
#line 1575 "FileOperator.c"
				goto __catch0_g_error;
			}
#line 163 "../src/FileOperator.vala"
			success = _tmp23_;
#line 1580 "FileOperator.c"
		}
#line 166 "../src/FileOperator.vala"
		if (success) {
#line 1584 "FileOperator.c"
			GFile* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
#line 167 "../src/FileOperator.vala"
			g_debug ("FileOperator.vala:167: success copying file");
#line 168 "../src/FileOperator.vala"
			_tmp26_ = dest;
#line 168 "../src/FileOperator.vala"
			_tmp27_ = g_file_get_uri (_tmp26_);
#line 168 "../src/FileOperator.vala"
			_tmp28_ = _tmp27_;
#line 168 "../src/FileOperator.vala"
			music_media_set_uri (_data2_->s, _tmp28_);
#line 168 "../src/FileOperator.vala"
			_g_free0 (_tmp28_);
#line 170 "../src/FileOperator.vala"
			if (emit_update) {
#line 171 "../src/FileOperator.vala"
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ______lambda17__gsource_func, block2_data_ref (_data2_), block2_data_unref);
#line 1604 "FileOperator.c"
			}
		} else {
			gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			GFile* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
#line 176 "../src/FileOperator.vala"
			_tmp29_ = music_media_get_uri (_data2_->s);
#line 176 "../src/FileOperator.vala"
			_tmp30_ = _tmp29_;
#line 176 "../src/FileOperator.vala"
			_tmp31_ = _tmp30_;
#line 176 "../src/FileOperator.vala"
			_tmp32_ = dest;
#line 176 "../src/FileOperator.vala"
			_tmp33_ = g_file_get_path (_tmp32_);
#line 176 "../src/FileOperator.vala"
			_tmp34_ = _tmp33_;
#line 176 "../src/FileOperator.vala"
			g_warning ("FileOperator.vala:176: Failure: Could not copy imported media %s to me" \
"dia folder %s", _tmp31_, _tmp34_);
#line 176 "../src/FileOperator.vala"
			_g_free0 (_tmp34_);
#line 176 "../src/FileOperator.vala"
			_g_free0 (_tmp31_);
#line 177 "../src/FileOperator.vala"
			result = FALSE;
#line 177 "../src/FileOperator.vala"
			_g_object_unref0 (original);
#line 177 "../src/FileOperator.vala"
			_g_object_unref0 (dest);
#line 177 "../src/FileOperator.vala"
			block2_data_unref (_data2_);
#line 177 "../src/FileOperator.vala"
			_data2_ = NULL;
#line 177 "../src/FileOperator.vala"
			return result;
#line 1643 "FileOperator.c"
		}
#line 181 "../src/FileOperator.vala"
		if (delete_old) {
#line 1647 "FileOperator.c"
			GeeTreeSet* dummy = NULL;
			GeeTreeSet* _tmp35_;
			gint old_folder_items = 0;
			GFile* _tmp36_;
			GFile* _tmp37_;
			GFile* _tmp38_;
			GeeTreeSet* _tmp39_;
			gint _tmp40_;
#line 182 "../src/FileOperator.vala"
			_tmp35_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 182 "../src/FileOperator.vala"
			dummy = _tmp35_;
#line 183 "../src/FileOperator.vala"
			_tmp36_ = original;
#line 183 "../src/FileOperator.vala"
			_tmp37_ = g_file_get_parent (_tmp36_);
#line 183 "../src/FileOperator.vala"
			_tmp38_ = _tmp37_;
#line 183 "../src/FileOperator.vala"
			_tmp39_ = dummy;
#line 183 "../src/FileOperator.vala"
			_tmp40_ = music_file_utils_count_music_files (_tmp38_, (GeeCollection*) _tmp39_);
#line 183 "../src/FileOperator.vala"
			_g_object_unref0 (_tmp38_);
#line 183 "../src/FileOperator.vala"
			old_folder_items = _tmp40_;
#line 186 "../src/FileOperator.vala"
			if (old_folder_items == 0) {
#line 1676 "FileOperator.c"
				GFile* _tmp41_;
				GFile* _tmp42_;
				GFile* _tmp43_;
				gchar* _tmp44_;
				gchar* _tmp45_;
				GFile* _tmp46_;
				GFile* _tmp47_;
				GFile* _tmp48_;
#line 187 "../src/FileOperator.vala"
				_tmp41_ = original;
#line 187 "../src/FileOperator.vala"
				_tmp42_ = g_file_get_parent (_tmp41_);
#line 187 "../src/FileOperator.vala"
				_tmp43_ = _tmp42_;
#line 187 "../src/FileOperator.vala"
				_tmp44_ = g_file_get_path (_tmp43_);
#line 187 "../src/FileOperator.vala"
				_tmp45_ = _tmp44_;
#line 187 "../src/FileOperator.vala"
				g_message ("FileOperator.vala:187: going to delete %s because no files are in it\n", _tmp45_);
#line 187 "../src/FileOperator.vala"
				_g_free0 (_tmp45_);
#line 187 "../src/FileOperator.vala"
				_g_object_unref0 (_tmp43_);
#line 188 "../src/FileOperator.vala"
				_tmp46_ = original;
#line 188 "../src/FileOperator.vala"
				_tmp47_ = g_file_get_parent (_tmp46_);
#line 188 "../src/FileOperator.vala"
				_tmp48_ = _tmp47_;
#line 188 "../src/FileOperator.vala"
				g_file_delete (_tmp48_, NULL, &_inner_error0_);
#line 188 "../src/FileOperator.vala"
				_g_object_unref0 (_tmp48_);
#line 188 "../src/FileOperator.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 188 "../src/FileOperator.vala"
					_g_object_unref0 (dummy);
#line 188 "../src/FileOperator.vala"
					_g_object_unref0 (original);
#line 188 "../src/FileOperator.vala"
					_g_object_unref0 (dest);
#line 1719 "FileOperator.c"
					goto __catch0_g_error;
				}
			}
#line 181 "../src/FileOperator.vala"
			_g_object_unref0 (dummy);
#line 1725 "FileOperator.c"
		}
#line 150 "../src/FileOperator.vala"
		_g_object_unref0 (original);
#line 150 "../src/FileOperator.vala"
		_g_object_unref0 (dest);
#line 1731 "FileOperator.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		GError* _tmp52_;
		const gchar* _tmp53_;
#line 150 "../src/FileOperator.vala"
		err = _inner_error0_;
#line 150 "../src/FileOperator.vala"
		_inner_error0_ = NULL;
#line 192 "../src/FileOperator.vala"
		_tmp49_ = music_media_get_uri (_data2_->s);
#line 192 "../src/FileOperator.vala"
		_tmp50_ = _tmp49_;
#line 192 "../src/FileOperator.vala"
		_tmp51_ = _tmp50_;
#line 192 "../src/FileOperator.vala"
		_tmp52_ = err;
#line 192 "../src/FileOperator.vala"
		_tmp53_ = _tmp52_->message;
#line 192 "../src/FileOperator.vala"
		g_warning ("FileOperator.vala:192: Could not copy imported media %s to media folde" \
"r: %s\n", _tmp51_, _tmp53_);
#line 192 "../src/FileOperator.vala"
		_g_free0 (_tmp51_);
#line 193 "../src/FileOperator.vala"
		result = FALSE;
#line 193 "../src/FileOperator.vala"
		_g_error_free0 (err);
#line 193 "../src/FileOperator.vala"
		block2_data_unref (_data2_);
#line 193 "../src/FileOperator.vala"
		_data2_ = NULL;
#line 193 "../src/FileOperator.vala"
		return result;
#line 1770 "FileOperator.c"
	}
	__finally0:
#line 150 "../src/FileOperator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1775 "FileOperator.c"
		gboolean _tmp54_ = FALSE;
#line 150 "../src/FileOperator.vala"
		block2_data_unref (_data2_);
#line 150 "../src/FileOperator.vala"
		_data2_ = NULL;
#line 150 "../src/FileOperator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 150 "../src/FileOperator.vala"
		g_clear_error (&_inner_error0_);
#line 150 "../src/FileOperator.vala"
		return _tmp54_;
#line 1787 "FileOperator.c"
	}
#line 196 "../src/FileOperator.vala"
	result = TRUE;
#line 196 "../src/FileOperator.vala"
	block2_data_unref (_data2_);
#line 196 "../src/FileOperator.vala"
	_data2_ = NULL;
#line 196 "../src/FileOperator.vala"
	return result;
#line 1797 "FileOperator.c"
}

void
music_file_operator_remove_media (MusicFileOperator* self,
                                  GeeCollection* to_remove)
{
	GeeTreeSet* dummy_list = NULL;
	GeeTreeSet* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 199 "../src/FileOperator.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/FileOperator.vala"
	g_return_if_fail (to_remove != NULL);
#line 200 "../src/FileOperator.vala"
	_tmp0_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 200 "../src/FileOperator.vala"
	dummy_list = _tmp0_;
#line 1815 "FileOperator.c"
	{
		GeeIterator* _s_it = NULL;
		GeeIterator* _tmp1_;
#line 201 "../src/FileOperator.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) to_remove);
#line 201 "../src/FileOperator.vala"
		_s_it = _tmp1_;
#line 201 "../src/FileOperator.vala"
		while (TRUE) {
#line 1825 "FileOperator.c"
			GeeIterator* _tmp2_;
			MusicMedia* s = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
#line 201 "../src/FileOperator.vala"
			_tmp2_ = _s_it;
#line 201 "../src/FileOperator.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 201 "../src/FileOperator.vala"
				break;
#line 1836 "FileOperator.c"
			}
#line 201 "../src/FileOperator.vala"
			_tmp3_ = _s_it;
#line 201 "../src/FileOperator.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 201 "../src/FileOperator.vala"
			s = (MusicMedia*) _tmp4_;
#line 1844 "FileOperator.c"
			{
				GFile* file = NULL;
				MusicMedia* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				GFile* _tmp9_;
				GFile* _tmp10_;
				GFile* _tmp11_;
				gint old_folder_items = 0;
				GFile* _tmp12_;
				GFile* _tmp13_;
				GFile* _tmp14_;
				GeeTreeSet* _tmp15_;
				gint _tmp16_;
#line 203 "../src/FileOperator.vala"
				_tmp5_ = s;
#line 203 "../src/FileOperator.vala"
				_tmp6_ = music_media_get_uri (_tmp5_);
#line 203 "../src/FileOperator.vala"
				_tmp7_ = _tmp6_;
#line 203 "../src/FileOperator.vala"
				_tmp8_ = _tmp7_;
#line 203 "../src/FileOperator.vala"
				_tmp9_ = g_file_new_for_uri (_tmp8_);
#line 203 "../src/FileOperator.vala"
				_tmp10_ = _tmp9_;
#line 203 "../src/FileOperator.vala"
				_g_free0 (_tmp8_);
#line 203 "../src/FileOperator.vala"
				file = _tmp10_;
#line 204 "../src/FileOperator.vala"
				_tmp11_ = file;
#line 204 "../src/FileOperator.vala"
				g_file_trash (_tmp11_, NULL, &_inner_error0_);
#line 204 "../src/FileOperator.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 204 "../src/FileOperator.vala"
					_g_object_unref0 (file);
#line 1884 "FileOperator.c"
					goto __catch0_g_error;
				}
#line 205 "../src/FileOperator.vala"
				_tmp12_ = file;
#line 205 "../src/FileOperator.vala"
				_tmp13_ = g_file_get_parent (_tmp12_);
#line 205 "../src/FileOperator.vala"
				_tmp14_ = _tmp13_;
#line 205 "../src/FileOperator.vala"
				_tmp15_ = dummy_list;
#line 205 "../src/FileOperator.vala"
				_tmp16_ = music_file_utils_count_music_files (_tmp14_, (GeeCollection*) _tmp15_);
#line 205 "../src/FileOperator.vala"
				_g_object_unref0 (_tmp14_);
#line 205 "../src/FileOperator.vala"
				old_folder_items = _tmp16_;
#line 207 "../src/FileOperator.vala"
				if (old_folder_items == 0) {
#line 1903 "FileOperator.c"
					GFile* _tmp17_;
					GFile* _tmp18_;
					GFile* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gint old_folder_parent_items = 0;
					GFile* _tmp22_;
					GFile* _tmp23_;
					GFile* _tmp24_;
					GFile* _tmp25_;
					GFile* _tmp26_;
					GeeTreeSet* _tmp27_;
					gint _tmp28_;
#line 208 "../src/FileOperator.vala"
					_tmp17_ = file;
#line 208 "../src/FileOperator.vala"
					_tmp18_ = g_file_get_parent (_tmp17_);
#line 208 "../src/FileOperator.vala"
					_tmp19_ = _tmp18_;
#line 208 "../src/FileOperator.vala"
					_tmp20_ = g_file_get_path (_tmp19_);
#line 208 "../src/FileOperator.vala"
					_tmp21_ = _tmp20_;
#line 208 "../src/FileOperator.vala"
					g_debug ("FileOperator.vala:208: going to delete %s because no files are in it\n", _tmp21_);
#line 208 "../src/FileOperator.vala"
					_g_free0 (_tmp21_);
#line 208 "../src/FileOperator.vala"
					_g_object_unref0 (_tmp19_);
#line 210 "../src/FileOperator.vala"
					_tmp22_ = file;
#line 210 "../src/FileOperator.vala"
					_tmp23_ = g_file_get_parent (_tmp22_);
#line 210 "../src/FileOperator.vala"
					_tmp24_ = _tmp23_;
#line 210 "../src/FileOperator.vala"
					_tmp25_ = g_file_get_parent (_tmp24_);
#line 210 "../src/FileOperator.vala"
					_tmp26_ = _tmp25_;
#line 210 "../src/FileOperator.vala"
					_tmp27_ = dummy_list;
#line 210 "../src/FileOperator.vala"
					_tmp28_ = music_file_utils_count_music_files (_tmp26_, (GeeCollection*) _tmp27_);
#line 210 "../src/FileOperator.vala"
					_g_object_unref0 (_tmp26_);
#line 210 "../src/FileOperator.vala"
					_g_object_unref0 (_tmp24_);
#line 210 "../src/FileOperator.vala"
					old_folder_parent_items = _tmp28_;
#line 211 "../src/FileOperator.vala"
					if (old_folder_parent_items == 0) {
#line 1955 "FileOperator.c"
						GFile* _tmp29_;
						GFile* _tmp30_;
						GFile* _tmp31_;
						GFile* _tmp32_;
						GFile* _tmp33_;
						gchar* _tmp34_;
						gchar* _tmp35_;
#line 212 "../src/FileOperator.vala"
						_tmp29_ = file;
#line 212 "../src/FileOperator.vala"
						_tmp30_ = g_file_get_parent (_tmp29_);
#line 212 "../src/FileOperator.vala"
						_tmp31_ = _tmp30_;
#line 212 "../src/FileOperator.vala"
						_tmp32_ = g_file_get_parent (_tmp31_);
#line 212 "../src/FileOperator.vala"
						_tmp33_ = _tmp32_;
#line 212 "../src/FileOperator.vala"
						_tmp34_ = g_file_get_path (_tmp33_);
#line 212 "../src/FileOperator.vala"
						_tmp35_ = _tmp34_;
#line 212 "../src/FileOperator.vala"
						g_debug ("FileOperator.vala:212: going to delete %s because no files are in it\n", _tmp35_);
#line 212 "../src/FileOperator.vala"
						_g_free0 (_tmp35_);
#line 212 "../src/FileOperator.vala"
						_g_object_unref0 (_tmp33_);
#line 212 "../src/FileOperator.vala"
						_g_object_unref0 (_tmp31_);
#line 1985 "FileOperator.c"
					}
				}
#line 202 "../src/FileOperator.vala"
				_g_object_unref0 (file);
#line 1990 "FileOperator.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				MusicMedia* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				gchar* _tmp39_;
				GError* _tmp40_;
				const gchar* _tmp41_;
#line 202 "../src/FileOperator.vala"
				err = _inner_error0_;
#line 202 "../src/FileOperator.vala"
				_inner_error0_ = NULL;
#line 216 "../src/FileOperator.vala"
				_tmp36_ = s;
#line 216 "../src/FileOperator.vala"
				_tmp37_ = music_media_get_uri (_tmp36_);
#line 216 "../src/FileOperator.vala"
				_tmp38_ = _tmp37_;
#line 216 "../src/FileOperator.vala"
				_tmp39_ = _tmp38_;
#line 216 "../src/FileOperator.vala"
				_tmp40_ = err;
#line 216 "../src/FileOperator.vala"
				_tmp41_ = _tmp40_->message;
#line 216 "../src/FileOperator.vala"
				g_warning ("FileOperator.vala:216: Could not move file %s to trash: %s (you could " \
"be using a file system which is not supported)\n", _tmp39_, _tmp41_);
#line 216 "../src/FileOperator.vala"
				_g_free0 (_tmp39_);
#line 202 "../src/FileOperator.vala"
				_g_error_free0 (err);
#line 2024 "FileOperator.c"
			}
			__finally0:
#line 202 "../src/FileOperator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 202 "../src/FileOperator.vala"
				_g_object_unref0 (s);
#line 202 "../src/FileOperator.vala"
				_g_object_unref0 (_s_it);
#line 202 "../src/FileOperator.vala"
				_g_object_unref0 (dummy_list);
#line 202 "../src/FileOperator.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 202 "../src/FileOperator.vala"
				g_clear_error (&_inner_error0_);
#line 202 "../src/FileOperator.vala"
				return;
#line 2041 "FileOperator.c"
			}
#line 201 "../src/FileOperator.vala"
			_g_object_unref0 (s);
#line 2045 "FileOperator.c"
		}
#line 201 "../src/FileOperator.vala"
		_g_object_unref0 (_s_it);
#line 2049 "FileOperator.c"
	}
#line 199 "../src/FileOperator.vala"
	_g_object_unref0 (dummy_list);
#line 2053 "FileOperator.c"
}

static void
music_file_operator_file_monitored_changed (MusicFileOperator* self,
                                            GFile* file,
                                            GFile* other_file,
                                            GFileMonitorEvent event_type)
{
	GError* _inner_error0_ = NULL;
#line 221 "../src/FileOperator.vala"
	g_return_if_fail (self != NULL);
#line 221 "../src/FileOperator.vala"
	g_return_if_fail (file != NULL);
#line 222 "../src/FileOperator.vala"
	switch (event_type) {
#line 222 "../src/FileOperator.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 2071 "FileOperator.c"
		{
			MusicMedia* media = NULL;
			MusicLibrariesManager* _tmp0_;
			MusicLibrary* _tmp1_;
			MusicMedia* _tmp2_;
			MusicMedia* _tmp3_;
			GFileMonitor* monitor = NULL;
			GeeHashMap* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gpointer _tmp10_;
			GFileMonitor* _tmp11_;
			GFileMonitor* _tmp12_;
#line 224 "../src/FileOperator.vala"
			_tmp0_ = music_libraries_manager;
#line 224 "../src/FileOperator.vala"
			_tmp1_ = _tmp0_->local_library;
#line 224 "../src/FileOperator.vala"
			_tmp2_ = music_library_media_from_file (_tmp1_, file);
#line 224 "../src/FileOperator.vala"
			media = _tmp2_;
#line 225 "../src/FileOperator.vala"
			_tmp3_ = media;
#line 225 "../src/FileOperator.vala"
			if (_tmp3_ != NULL) {
#line 2097 "FileOperator.c"
				MusicLibrariesManager* _tmp4_;
				MusicLibrary* _tmp5_;
				MusicMedia* _tmp6_;
#line 226 "../src/FileOperator.vala"
				_tmp4_ = music_libraries_manager;
#line 226 "../src/FileOperator.vala"
				_tmp5_ = _tmp4_->local_library;
#line 226 "../src/FileOperator.vala"
				_tmp6_ = media;
#line 226 "../src/FileOperator.vala"
				music_library_remove_media (_tmp5_, _tmp6_, FALSE);
#line 2109 "FileOperator.c"
			}
#line 227 "../src/FileOperator.vala"
			_tmp7_ = self->priv->monitors;
#line 227 "../src/FileOperator.vala"
			_tmp8_ = g_file_get_uri (file);
#line 227 "../src/FileOperator.vala"
			_tmp9_ = _tmp8_;
#line 227 "../src/FileOperator.vala"
			_tmp10_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, _tmp9_);
#line 227 "../src/FileOperator.vala"
			_tmp11_ = (GFileMonitor*) _tmp10_;
#line 227 "../src/FileOperator.vala"
			_g_free0 (_tmp9_);
#line 227 "../src/FileOperator.vala"
			monitor = _tmp11_;
#line 228 "../src/FileOperator.vala"
			_tmp12_ = monitor;
#line 228 "../src/FileOperator.vala"
			if (_tmp12_ != NULL) {
#line 2129 "FileOperator.c"
				GeeTreeSet* medias_to_remove = NULL;
				GeeTreeSet* _tmp13_;
				MusicLibrariesManager* _tmp32_;
				MusicLibrary* _tmp33_;
				GeeTreeSet* _tmp34_;
				GFileMonitor* _tmp35_;
				GeeHashMap* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
#line 229 "../src/FileOperator.vala"
				_tmp13_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 229 "../src/FileOperator.vala"
				medias_to_remove = _tmp13_;
#line 2143 "FileOperator.c"
				{
					GeeIterator* _m_it = NULL;
					MusicLibrariesManager* _tmp14_;
					MusicLibrary* _tmp15_;
					GeeCollection* _tmp16_;
					GeeCollection* _tmp17_;
					GeeIterator* _tmp18_;
					GeeIterator* _tmp19_;
#line 230 "../src/FileOperator.vala"
					_tmp14_ = music_libraries_manager;
#line 230 "../src/FileOperator.vala"
					_tmp15_ = _tmp14_->local_library;
#line 230 "../src/FileOperator.vala"
					_tmp16_ = music_library_get_medias (_tmp15_);
#line 230 "../src/FileOperator.vala"
					_tmp17_ = _tmp16_;
#line 230 "../src/FileOperator.vala"
					_tmp18_ = gee_iterable_iterator ((GeeIterable*) _tmp17_);
#line 230 "../src/FileOperator.vala"
					_tmp19_ = _tmp18_;
#line 230 "../src/FileOperator.vala"
					_g_object_unref0 (_tmp17_);
#line 230 "../src/FileOperator.vala"
					_m_it = _tmp19_;
#line 230 "../src/FileOperator.vala"
					while (TRUE) {
#line 2170 "FileOperator.c"
						GeeIterator* _tmp20_;
						MusicMedia* m = NULL;
						GeeIterator* _tmp21_;
						gpointer _tmp22_;
						MusicMedia* _tmp23_;
						gchar* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
						gchar* _tmp27_;
						gchar* _tmp28_;
						gboolean _tmp29_;
#line 230 "../src/FileOperator.vala"
						_tmp20_ = _m_it;
#line 230 "../src/FileOperator.vala"
						if (!gee_iterator_next (_tmp20_)) {
#line 230 "../src/FileOperator.vala"
							break;
#line 2188 "FileOperator.c"
						}
#line 230 "../src/FileOperator.vala"
						_tmp21_ = _m_it;
#line 230 "../src/FileOperator.vala"
						_tmp22_ = gee_iterator_get (_tmp21_);
#line 230 "../src/FileOperator.vala"
						m = (MusicMedia*) _tmp22_;
#line 231 "../src/FileOperator.vala"
						_tmp23_ = m;
#line 231 "../src/FileOperator.vala"
						_tmp24_ = music_media_get_uri (_tmp23_);
#line 231 "../src/FileOperator.vala"
						_tmp25_ = _tmp24_;
#line 231 "../src/FileOperator.vala"
						_tmp26_ = _tmp25_;
#line 231 "../src/FileOperator.vala"
						_tmp27_ = g_file_get_uri (file);
#line 231 "../src/FileOperator.vala"
						_tmp28_ = _tmp27_;
#line 231 "../src/FileOperator.vala"
						_tmp29_ = g_str_has_prefix (_tmp26_, _tmp28_);
#line 231 "../src/FileOperator.vala"
						_g_free0 (_tmp28_);
#line 231 "../src/FileOperator.vala"
						_g_free0 (_tmp26_);
#line 231 "../src/FileOperator.vala"
						if (_tmp29_) {
#line 2216 "FileOperator.c"
							GeeTreeSet* _tmp30_;
							MusicMedia* _tmp31_;
#line 232 "../src/FileOperator.vala"
							_tmp30_ = medias_to_remove;
#line 232 "../src/FileOperator.vala"
							_tmp31_ = m;
#line 232 "../src/FileOperator.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
#line 2225 "FileOperator.c"
						}
#line 230 "../src/FileOperator.vala"
						_g_object_unref0 (m);
#line 2229 "FileOperator.c"
					}
#line 230 "../src/FileOperator.vala"
					_g_object_unref0 (_m_it);
#line 2233 "FileOperator.c"
				}
#line 235 "../src/FileOperator.vala"
				_tmp32_ = music_libraries_manager;
#line 235 "../src/FileOperator.vala"
				_tmp33_ = _tmp32_->local_library;
#line 235 "../src/FileOperator.vala"
				_tmp34_ = medias_to_remove;
#line 235 "../src/FileOperator.vala"
				music_library_remove_medias (_tmp33_, (GeeCollection*) _tmp34_, FALSE);
#line 236 "../src/FileOperator.vala"
				_tmp35_ = monitor;
#line 236 "../src/FileOperator.vala"
				g_file_monitor_cancel (_tmp35_);
#line 237 "../src/FileOperator.vala"
				_tmp36_ = self->priv->monitors;
#line 237 "../src/FileOperator.vala"
				_tmp37_ = g_file_get_uri (file);
#line 237 "../src/FileOperator.vala"
				_tmp38_ = _tmp37_;
#line 237 "../src/FileOperator.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp36_, _tmp38_, NULL);
#line 237 "../src/FileOperator.vala"
				_g_free0 (_tmp38_);
#line 228 "../src/FileOperator.vala"
				_g_object_unref0 (medias_to_remove);
#line 2259 "FileOperator.c"
			}
#line 240 "../src/FileOperator.vala"
			_g_object_unref0 (monitor);
#line 240 "../src/FileOperator.vala"
			_g_object_unref0 (media);
#line 240 "../src/FileOperator.vala"
			break;
#line 2267 "FileOperator.c"
		}
#line 222 "../src/FileOperator.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 2271 "FileOperator.c"
		{
			{
				GFileInfo* info = NULL;
				GFileInfo* _tmp39_;
				gboolean _tmp40_ = FALSE;
				GFileInfo* _tmp41_;
#line 243 "../src/FileOperator.vala"
				_tmp39_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 243 "../src/FileOperator.vala"
				info = _tmp39_;
#line 243 "../src/FileOperator.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2284 "FileOperator.c"
					goto __catch0_g_error;
				}
#line 244 "../src/FileOperator.vala"
				_tmp41_ = info;
#line 244 "../src/FileOperator.vala"
				if (g_file_info_get_file_type (_tmp41_) == G_FILE_TYPE_REGULAR) {
#line 2291 "FileOperator.c"
					GFileInfo* _tmp42_;
					const gchar* _tmp43_;
#line 244 "../src/FileOperator.vala"
					_tmp42_ = info;
#line 244 "../src/FileOperator.vala"
					_tmp43_ = g_file_info_get_content_type (_tmp42_);
#line 244 "../src/FileOperator.vala"
					_tmp40_ = music_file_utils_is_valid_content_type (_tmp43_, NULL, (gint) 0);
#line 2300 "FileOperator.c"
				} else {
#line 244 "../src/FileOperator.vala"
					_tmp40_ = FALSE;
#line 2304 "FileOperator.c"
				}
#line 244 "../src/FileOperator.vala"
				if (_tmp40_) {
#line 2308 "FileOperator.c"
					GeeTreeSet* list = NULL;
					GeeTreeSet* _tmp44_;
					GeeTreeSet* _tmp45_;
					gchar* _tmp46_;
					gchar* _tmp47_;
					GeeTreeSet* _tmp48_;
#line 245 "../src/FileOperator.vala"
					_tmp44_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 245 "../src/FileOperator.vala"
					list = _tmp44_;
#line 246 "../src/FileOperator.vala"
					_tmp45_ = list;
#line 246 "../src/FileOperator.vala"
					_tmp46_ = g_file_get_uri (file);
#line 246 "../src/FileOperator.vala"
					_tmp47_ = _tmp46_;
#line 246 "../src/FileOperator.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp45_, _tmp47_);
#line 246 "../src/FileOperator.vala"
					_g_free0 (_tmp47_);
#line 247 "../src/FileOperator.vala"
					_tmp48_ = list;
#line 247 "../src/FileOperator.vala"
					music_file_operator_import_files (self, (GeeCollection*) _tmp48_, MUSIC_FILE_OPERATOR_IMPORT_TYPE_IMPORT);
#line 244 "../src/FileOperator.vala"
					_g_object_unref0 (list);
#line 2335 "FileOperator.c"
				} else {
					GFileInfo* _tmp49_;
#line 248 "../src/FileOperator.vala"
					_tmp49_ = info;
#line 248 "../src/FileOperator.vala"
					if (g_file_info_get_file_type (_tmp49_) == G_FILE_TYPE_DIRECTORY) {
#line 2342 "FileOperator.c"
						GeeTreeSet* list = NULL;
						GeeTreeSet* _tmp50_;
						GeeTreeSet* _tmp51_;
						GeeTreeSet* _tmp52_;
#line 249 "../src/FileOperator.vala"
						_tmp50_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 249 "../src/FileOperator.vala"
						list = _tmp50_;
#line 250 "../src/FileOperator.vala"
						_tmp51_ = list;
#line 250 "../src/FileOperator.vala"
						music_file_utils_count_music_files (file, (GeeCollection*) _tmp51_);
#line 251 "../src/FileOperator.vala"
						_tmp52_ = list;
#line 251 "../src/FileOperator.vala"
						music_file_operator_import_files (self, (GeeCollection*) _tmp52_, MUSIC_FILE_OPERATOR_IMPORT_TYPE_IMPORT);
#line 248 "../src/FileOperator.vala"
						_g_object_unref0 (list);
#line 2361 "FileOperator.c"
					}
				}
#line 242 "../src/FileOperator.vala"
				_g_object_unref0 (info);
#line 2366 "FileOperator.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GError* _tmp53_;
				const gchar* _tmp54_;
#line 242 "../src/FileOperator.vala"
				e = _inner_error0_;
#line 242 "../src/FileOperator.vala"
				_inner_error0_ = NULL;
#line 254 "../src/FileOperator.vala"
				_tmp53_ = e;
#line 254 "../src/FileOperator.vala"
				_tmp54_ = _tmp53_->message;
#line 254 "../src/FileOperator.vala"
				g_critical ("FileOperator.vala:254: %s", _tmp54_);
#line 242 "../src/FileOperator.vala"
				_g_error_free0 (e);
#line 2386 "FileOperator.c"
			}
			__finally0:
#line 242 "../src/FileOperator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 242 "../src/FileOperator.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 242 "../src/FileOperator.vala"
				g_clear_error (&_inner_error0_);
#line 242 "../src/FileOperator.vala"
				return;
#line 2397 "FileOperator.c"
			}
#line 257 "../src/FileOperator.vala"
			break;
#line 2401 "FileOperator.c"
		}
#line 222 "../src/FileOperator.vala"
		case G_FILE_MONITOR_EVENT_MOVED:
#line 2405 "FileOperator.c"
		{
			MusicMedia* media = NULL;
			MusicLibrariesManager* _tmp55_;
			MusicLibrary* _tmp56_;
			MusicMedia* _tmp57_;
			MusicMedia* _tmp58_;
			MusicLibrariesManager* _tmp59_;
			MusicLibrary* _tmp60_;
			MusicMedia* _tmp61_;
#line 259 "../src/FileOperator.vala"
			_tmp55_ = music_libraries_manager;
#line 259 "../src/FileOperator.vala"
			_tmp56_ = _tmp55_->local_library;
#line 259 "../src/FileOperator.vala"
			_tmp57_ = music_library_media_from_file (_tmp56_, file);
#line 259 "../src/FileOperator.vala"
			media = _tmp57_;
#line 260 "../src/FileOperator.vala"
			_tmp58_ = media;
#line 260 "../src/FileOperator.vala"
			music_media_set_file (_tmp58_, other_file);
#line 261 "../src/FileOperator.vala"
			_tmp59_ = music_libraries_manager;
#line 261 "../src/FileOperator.vala"
			_tmp60_ = _tmp59_->local_library;
#line 261 "../src/FileOperator.vala"
			_tmp61_ = media;
#line 261 "../src/FileOperator.vala"
			music_library_update_media (_tmp60_, _tmp61_, TRUE, FALSE);
#line 262 "../src/FileOperator.vala"
			_g_object_unref0 (media);
#line 262 "../src/FileOperator.vala"
			break;
#line 2439 "FileOperator.c"
		}
		default:
#line 222 "../src/FileOperator.vala"
		break;
#line 2444 "FileOperator.c"
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1481 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1481 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1481 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1482 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1483 "glib-2.0.vapi"
		start = string_length + start;
#line 2472 "FileOperator.c"
	}
#line 1485 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1486 "glib-2.0.vapi"
		end = string_length + end;
#line 2478 "FileOperator.c"
	}
#line 1488 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1488 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 2484 "FileOperator.c"
	} else {
#line 1488 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 2488 "FileOperator.c"
	}
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1489 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1489 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 2496 "FileOperator.c"
	} else {
#line 1489 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 2500 "FileOperator.c"
	}
#line 1489 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1490 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1491 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1491 "glib-2.0.vapi"
	result = _tmp4_;
#line 1491 "glib-2.0.vapi"
	return result;
#line 2512 "FileOperator.c"
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1143 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1143 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1144 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1144 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1146 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1146 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 2536 "FileOperator.c"
		gchar* _tmp2_;
#line 1147 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1147 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1147 "glib-2.0.vapi"
		return result;
#line 2544 "FileOperator.c"
	} else {
#line 1149 "glib-2.0.vapi"
		result = -1;
#line 1149 "glib-2.0.vapi"
		return result;
#line 2550 "FileOperator.c"
	}
}

gchar*
music_file_operator_get_extension (MusicFileOperator* self,
                                   const gchar* name)
{
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 266 "../src/FileOperator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 266 "../src/FileOperator.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 267 "../src/FileOperator.vala"
	_tmp0_ = strlen (name);
#line 267 "../src/FileOperator.vala"
	_tmp1_ = _tmp0_;
#line 267 "../src/FileOperator.vala"
	_tmp2_ = string_slice (name, (glong) string_last_index_of (name, ".", 0), (glong) _tmp1_);
#line 267 "../src/FileOperator.vala"
	result = _tmp2_;
#line 267 "../src/FileOperator.vala"
	return result;
#line 2576 "FileOperator.c"
}

void
music_file_operator_import_files (MusicFileOperator* self,
                                  GeeCollection* files,
                                  MusicFileOperatorImportType type)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 270 "../src/FileOperator.vala"
	g_return_if_fail (self != NULL);
#line 270 "../src/FileOperator.vala"
	g_return_if_fail (files != NULL);
#line 271 "../src/FileOperator.vala"
	self->priv->import_type = type;
#line 272 "../src/FileOperator.vala"
	_tmp0_ = gee_collection_get_size (files);
#line 272 "../src/FileOperator.vala"
	_tmp1_ = _tmp0_;
#line 272 "../src/FileOperator.vala"
	self->priv->queue_size = self->priv->queue_size + _tmp1_;
#line 273 "../src/FileOperator.vala"
	_tmp2_ = gee_collection_get_size (files);
#line 273 "../src/FileOperator.vala"
	_tmp3_ = _tmp2_;
#line 273 "../src/FileOperator.vala"
	if (_tmp3_ == 0) {
#line 274 "../src/FileOperator.vala"
		music_file_operator_queue_finished (self);
#line 2608 "FileOperator.c"
	} else {
		MusicGStreamerTagger* _tmp4_;
#line 276 "../src/FileOperator.vala"
		_tmp4_ = self->tagger;
#line 276 "../src/FileOperator.vala"
		music_gstreamer_tagger_discoverer_import_media (_tmp4_, files);
#line 2615 "FileOperator.c"
	}
}

static void
music_file_operator_media_imported (MusicFileOperator* self,
                                    MusicMedia* m)
{
	GeeTreeSet* _tmp0_;
	MusicLibrariesManager* _tmp1_;
	MusicLibrary* _tmp2_;
	gint _tmp3_;
#line 280 "../src/FileOperator.vala"
	g_return_if_fail (self != NULL);
#line 280 "../src/FileOperator.vala"
	g_return_if_fail (m != NULL);
#line 281 "../src/FileOperator.vala"
	_tmp0_ = self->priv->all_new_imports;
#line 281 "../src/FileOperator.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, m);
#line 282 "../src/FileOperator.vala"
	_tmp1_ = music_libraries_manager;
#line 282 "../src/FileOperator.vala"
	_tmp2_ = _tmp1_->local_library;
#line 282 "../src/FileOperator.vala"
	music_library_add_media (_tmp2_, m);
#line 284 "../src/FileOperator.vala"
	_tmp3_ = self->index;
#line 284 "../src/FileOperator.vala"
	self->index = _tmp3_ + 1;
#line 285 "../src/FileOperator.vala"
	if (self->index == self->priv->queue_size) {
#line 286 "../src/FileOperator.vala"
		music_file_operator_queue_finished (self);
#line 2649 "FileOperator.c"
	}
}

static void
music_file_operator_import_error (MusicFileOperator* self,
                                  const gchar* file)
{
	gint _tmp0_;
	GeeTreeSet* _tmp1_;
#line 290 "../src/FileOperator.vala"
	g_return_if_fail (self != NULL);
#line 290 "../src/FileOperator.vala"
	g_return_if_fail (file != NULL);
#line 291 "../src/FileOperator.vala"
	_tmp0_ = self->index;
#line 291 "../src/FileOperator.vala"
	self->index = _tmp0_ + 1;
#line 292 "../src/FileOperator.vala"
	_tmp1_ = self->priv->import_errors;
#line 292 "../src/FileOperator.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, file);
#line 293 "../src/FileOperator.vala"
	if (self->index == self->priv->queue_size) {
#line 294 "../src/FileOperator.vala"
		music_file_operator_queue_finished (self);
#line 2675 "FileOperator.c"
	}
}

static void
music_file_operator_queue_finished (MusicFileOperator* self)
{
	GeeTreeSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeTreeSet* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	GeeTreeSet* _tmp39_;
	GeeTreeSet* _tmp40_;
	GCancellable* _tmp41_;
#line 298 "../src/FileOperator.vala"
	g_return_if_fail (self != NULL);
#line 299 "../src/FileOperator.vala"
	self->priv->queue_size = 0;
#line 300 "../src/FileOperator.vala"
	_tmp0_ = self->priv->import_errors;
#line 300 "../src/FileOperator.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 300 "../src/FileOperator.vala"
	_tmp2_ = _tmp1_;
#line 300 "../src/FileOperator.vala"
	if (_tmp2_ > 0) {
#line 2705 "FileOperator.c"
		MusicNotImportedDialog* not_imported_dialog = NULL;
		GeeTreeSet* _tmp3_;
		MusicSettingsMain* _tmp4_;
		MusicSettingsMain* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		MusicNotImportedDialog* _tmp8_;
		MusicNotImportedDialog* _tmp9_;
		MusicNotImportedDialog* _tmp10_;
#line 301 "../src/FileOperator.vala"
		_tmp3_ = self->priv->import_errors;
#line 301 "../src/FileOperator.vala"
		_tmp4_ = music_settings_main_get_default ();
#line 301 "../src/FileOperator.vala"
		_tmp5_ = _tmp4_;
#line 301 "../src/FileOperator.vala"
		_tmp6_ = music_settings_main_get_music_folder (_tmp5_);
#line 301 "../src/FileOperator.vala"
		_tmp7_ = _tmp6_;
#line 301 "../src/FileOperator.vala"
		_tmp8_ = music_not_imported_dialog_new ((GeeCollection*) _tmp3_, _tmp7_);
#line 301 "../src/FileOperator.vala"
		g_object_ref_sink (_tmp8_);
#line 301 "../src/FileOperator.vala"
		_tmp9_ = _tmp8_;
#line 301 "../src/FileOperator.vala"
		_g_object_unref0 (_tmp5_);
#line 301 "../src/FileOperator.vala"
		not_imported_dialog = _tmp9_;
#line 302 "../src/FileOperator.vala"
		_tmp10_ = not_imported_dialog;
#line 302 "../src/FileOperator.vala"
		gtk_widget_show ((GtkWidget*) _tmp10_);
#line 300 "../src/FileOperator.vala"
		_g_object_unref0 (not_imported_dialog);
#line 2741 "FileOperator.c"
	}
#line 305 "../src/FileOperator.vala"
	_tmp11_ = self->priv->all_new_imports;
#line 305 "../src/FileOperator.vala"
	_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 305 "../src/FileOperator.vala"
	_tmp13_ = _tmp12_;
#line 305 "../src/FileOperator.vala"
	if (_tmp13_ > 0) {
#line 2751 "FileOperator.c"
		MusicLibraryWindow* _tmp14_;
		MusicLibraryWindow* _tmp15_;
#line 306 "../src/FileOperator.vala"
		_tmp14_ = music_app_get_main_window ();
#line 306 "../src/FileOperator.vala"
		_tmp15_ = _tmp14_;
#line 306 "../src/FileOperator.vala"
		music_library_window_show_notification (_tmp15_, _ ("Import Complete"), _ ("Your Library Has Been Imported."), NULL, G_NOTIFICATION_PRIORITY_LOW, "music");
#line 2760 "FileOperator.c"
	}
#line 308 "../src/FileOperator.vala"
	if (self->priv->import_type == MUSIC_FILE_OPERATOR_IMPORT_TYPE_PLAYLIST) {
#line 2764 "FileOperator.c"
		MusicStaticPlaylist* _tmp16_;
		GeeTreeSet* _tmp17_;
		MusicStaticPlaylist* _tmp18_;
		MusicLibrariesManager* _tmp19_;
		MusicLibrary* _tmp20_;
		GeeCollection* _tmp21_;
		GeeCollection* _tmp22_;
		MusicStaticPlaylist* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		MusicLibrariesManager* _tmp28_;
		MusicLibrary* _tmp29_;
		MusicStaticPlaylist* _tmp30_;
#line 309 "../src/FileOperator.vala"
		_tmp16_ = self->priv->new_playlist;
#line 309 "../src/FileOperator.vala"
		_tmp17_ = self->priv->all_new_imports;
#line 309 "../src/FileOperator.vala"
		music_playlist_add_medias ((MusicPlaylist*) _tmp16_, (GeeCollection*) _tmp17_);
#line 310 "../src/FileOperator.vala"
		_tmp18_ = self->priv->new_playlist;
#line 310 "../src/FileOperator.vala"
		_tmp19_ = music_libraries_manager;
#line 310 "../src/FileOperator.vala"
		_tmp20_ = _tmp19_->local_library;
#line 310 "../src/FileOperator.vala"
		_tmp21_ = music_library_get_playlists (_tmp20_);
#line 310 "../src/FileOperator.vala"
		_tmp22_ = _tmp21_;
#line 310 "../src/FileOperator.vala"
		_tmp23_ = self->priv->new_playlist;
#line 310 "../src/FileOperator.vala"
		_tmp24_ = music_playlist_get_name ((MusicPlaylist*) _tmp23_);
#line 310 "../src/FileOperator.vala"
		_tmp25_ = _tmp24_;
#line 310 "../src/FileOperator.vala"
		_tmp26_ = music_playlists_utils_get_new_playlist_name (_tmp22_, _tmp25_);
#line 310 "../src/FileOperator.vala"
		_tmp27_ = _tmp26_;
#line 310 "../src/FileOperator.vala"
		music_playlist_set_name ((MusicPlaylist*) _tmp18_, _tmp27_);
#line 310 "../src/FileOperator.vala"
		_g_free0 (_tmp27_);
#line 310 "../src/FileOperator.vala"
		_g_object_unref0 (_tmp22_);
#line 311 "../src/FileOperator.vala"
		_tmp28_ = music_libraries_manager;
#line 311 "../src/FileOperator.vala"
		_tmp29_ = _tmp28_->local_library;
#line 311 "../src/FileOperator.vala"
		_tmp30_ = self->priv->new_playlist;
#line 311 "../src/FileOperator.vala"
		music_library_add_playlist (_tmp29_, _tmp30_);
#line 2820 "FileOperator.c"
	}
#line 315 "../src/FileOperator.vala"
	if (self->priv->import_type == MUSIC_FILE_OPERATOR_IMPORT_TYPE_IMPORT) {
#line 315 "../src/FileOperator.vala"
		_tmp32_ = TRUE;
#line 2826 "FileOperator.c"
	} else {
#line 315 "../src/FileOperator.vala"
		_tmp32_ = self->priv->import_type == MUSIC_FILE_OPERATOR_IMPORT_TYPE_PLAYLIST;
#line 2830 "FileOperator.c"
	}
#line 315 "../src/FileOperator.vala"
	if (_tmp32_) {
#line 2834 "FileOperator.c"
		GSettings* _tmp33_;
		GSettings* _tmp34_;
#line 315 "../src/FileOperator.vala"
		_tmp33_ = music_app_get_settings ();
#line 315 "../src/FileOperator.vala"
		_tmp34_ = _tmp33_;
#line 315 "../src/FileOperator.vala"
		_tmp31_ = g_settings_get_boolean (_tmp34_, "copy-imported-music");
#line 2843 "FileOperator.c"
	} else {
#line 315 "../src/FileOperator.vala"
		_tmp31_ = FALSE;
#line 2847 "FileOperator.c"
	}
#line 315 "../src/FileOperator.vala"
	if (_tmp31_) {
#line 2851 "FileOperator.c"
		MusicNotificationManager* _tmp35_;
		MusicNotificationManager* _tmp36_;
#line 316 "../src/FileOperator.vala"
		_tmp35_ = music_notification_manager_get_default ();
#line 316 "../src/FileOperator.vala"
		_tmp36_ = _tmp35_;
#line 316 "../src/FileOperator.vala"
		g_signal_emit_by_name (_tmp36_, "update-progress", _ ("<b>Copying</b> files to <b>Music Folder</b>…"), 0.0);
#line 316 "../src/FileOperator.vala"
		_g_object_unref0 (_tmp36_);
#line 317 "../src/FileOperator.vala"
		music_file_operator_copy_imports_async (self, NULL, NULL);
#line 2864 "FileOperator.c"
	} else {
		MusicLibrariesManager* _tmp37_;
		MusicLibrary* _tmp38_;
#line 319 "../src/FileOperator.vala"
		_tmp37_ = music_libraries_manager;
#line 319 "../src/FileOperator.vala"
		_tmp38_ = _tmp37_->local_library;
#line 319 "../src/FileOperator.vala"
		music_library_finish_file_operations (_tmp38_);
#line 2874 "FileOperator.c"
	}
#line 322 "../src/FileOperator.vala"
	_tmp39_ = self->priv->all_new_imports;
#line 322 "../src/FileOperator.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp39_);
#line 323 "../src/FileOperator.vala"
	_tmp40_ = self->priv->import_errors;
#line 323 "../src/FileOperator.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp40_);
#line 324 "../src/FileOperator.vala"
	_tmp41_ = self->cancellable;
#line 324 "../src/FileOperator.vala"
	g_cancellable_reset (_tmp41_);
#line 2888 "FileOperator.c"
}

static void
music_file_operator_copy_imports_async_data_free (gpointer _data)
{
	MusicFileOperatorCopyImportsAsyncData* _data_;
	_data_ = _data;
#line 30 "../src/FileOperator.vala"
	_g_object_unref0 (_data_->self);
#line 30 "../src/FileOperator.vala"
	g_slice_free (MusicFileOperatorCopyImportsAsyncData, _data_);
#line 2900 "FileOperator.c"
}

void
music_file_operator_copy_imports_async (MusicFileOperator* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	MusicFileOperatorCopyImportsAsyncData* _data_;
	MusicFileOperator* _tmp0_;
#line 30 "../src/FileOperator.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/FileOperator.vala"
	_data_ = g_slice_new0 (MusicFileOperatorCopyImportsAsyncData);
#line 30 "../src/FileOperator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 30 "../src/FileOperator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_file_operator_copy_imports_async_data_free);
#line 30 "../src/FileOperator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 30 "../src/FileOperator.vala"
	_data_->self = _tmp0_;
#line 30 "../src/FileOperator.vala"
	music_file_operator_copy_imports_async_co (_data_);
#line 2924 "FileOperator.c"
}

void
music_file_operator_copy_imports_finish (MusicFileOperator* self,
                                         GAsyncResult* _res_)
{
	MusicFileOperatorCopyImportsAsyncData* _data_;
#line 30 "../src/FileOperator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2934 "FileOperator.c"
}

static gboolean
music_file_operator_copy_imports_async_co (MusicFileOperatorCopyImportsAsyncData* _data_)
{
#line 327 "../src/FileOperator.vala"
	switch (_data_->_state_) {
#line 327 "../src/FileOperator.vala"
		case 0:
#line 2944 "FileOperator.c"
		goto _state_0;
		default:
#line 327 "../src/FileOperator.vala"
		g_assert_not_reached ();
#line 2949 "FileOperator.c"
	}
	_state_0:
#line 328 "../src/FileOperator.vala"
	_data_->_tmp0_ = _data_->self->priv->all_new_imports;
#line 328 "../src/FileOperator.vala"
	_data_->_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp0_);
#line 328 "../src/FileOperator.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 328 "../src/FileOperator.vala"
	music_file_operator_reset_progress (_data_->self, _data_->_tmp2_);
#line 2960 "FileOperator.c"
	{
#line 329 "../src/FileOperator.vala"
		_data_->_tmp3_ = _data_->self->priv->all_new_imports;
#line 329 "../src/FileOperator.vala"
		_data_->_tmp4_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _data_->_tmp3_);
#line 329 "../src/FileOperator.vala"
		_data_->_s_it = _data_->_tmp4_;
#line 329 "../src/FileOperator.vala"
		while (TRUE) {
#line 329 "../src/FileOperator.vala"
			_data_->_tmp5_ = _data_->_s_it;
#line 329 "../src/FileOperator.vala"
			if (!gee_iterator_next (_data_->_tmp5_)) {
#line 329 "../src/FileOperator.vala"
				break;
#line 2976 "FileOperator.c"
			}
#line 329 "../src/FileOperator.vala"
			_data_->_tmp6_ = _data_->_s_it;
#line 329 "../src/FileOperator.vala"
			_data_->_tmp7_ = gee_iterator_get (_data_->_tmp6_);
#line 329 "../src/FileOperator.vala"
			_data_->s = (MusicMedia*) _data_->_tmp7_;
#line 330 "../src/FileOperator.vala"
			_data_->_tmp8_ = _data_->self->cancellable;
#line 330 "../src/FileOperator.vala"
			if (!g_cancellable_is_cancelled (_data_->_tmp8_)) {
#line 331 "../src/FileOperator.vala"
				_data_->_tmp9_ = _data_->s;
#line 331 "../src/FileOperator.vala"
				music_file_operator_update_file_hierarchy (_data_->self, _data_->_tmp9_, FALSE, TRUE);
#line 2992 "FileOperator.c"
			}
#line 334 "../src/FileOperator.vala"
			_data_->self->index = _data_->self->index + 1;
#line 334 "../src/FileOperator.vala"
			_data_->_tmp10_ = _data_->self->index;
#line 329 "../src/FileOperator.vala"
			_g_object_unref0 (_data_->s);
#line 3000 "FileOperator.c"
		}
#line 329 "../src/FileOperator.vala"
		_g_object_unref0 (_data_->_s_it);
#line 3004 "FileOperator.c"
	}
#line 337 "../src/FileOperator.vala"
	_data_->_tmp11_ = music_libraries_manager;
#line 337 "../src/FileOperator.vala"
	_data_->_tmp12_ = _data_->_tmp11_->local_library;
#line 337 "../src/FileOperator.vala"
	music_library_finish_file_operations (_data_->_tmp12_);
#line 327 "../src/FileOperator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 327 "../src/FileOperator.vala"
	if (_data_->_state_ != 0) {
#line 327 "../src/FileOperator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 327 "../src/FileOperator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3020 "FileOperator.c"
		}
	}
#line 327 "../src/FileOperator.vala"
	g_object_unref (_data_->_async_result);
#line 327 "../src/FileOperator.vala"
	return FALSE;
#line 3027 "FileOperator.c"
}

static void
music_file_operator_class_init (MusicFileOperatorClass * klass,
                                gpointer klass_data)
{
#line 30 "../src/FileOperator.vala"
	music_file_operator_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/FileOperator.vala"
	g_type_class_adjust_private_offset (klass, &MusicFileOperator_private_offset);
#line 30 "../src/FileOperator.vala"
	G_OBJECT_CLASS (klass)->finalize = music_file_operator_finalize;
#line 30 "../src/FileOperator.vala"
	music_file_operator_signals[MUSIC_FILE_OPERATOR_IMPORT_CANCELLED_SIGNAL] = g_signal_new ("import-cancelled", MUSIC_TYPE_FILE_OPERATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 30 "../src/FileOperator.vala"
	music_file_operator_signals[MUSIC_FILE_OPERATOR_RESCAN_CANCELLED_SIGNAL] = g_signal_new ("rescan-cancelled", MUSIC_TYPE_FILE_OPERATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3044 "FileOperator.c"
}

static void
music_file_operator_instance_init (MusicFileOperator * self,
                                   gpointer klass)
{
#line 30 "../src/FileOperator.vala"
	self->priv = music_file_operator_get_instance_private (self);
#line 39 "../src/FileOperator.vala"
	self->priv->queue_size = 0;
#line 3055 "FileOperator.c"
}

static void
music_file_operator_finalize (GObject * obj)
{
	MusicFileOperator * self;
#line 30 "../src/FileOperator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_FILE_OPERATOR, MusicFileOperator);
#line 34 "../src/FileOperator.vala"
	_g_object_unref0 (self->tagger);
#line 35 "../src/FileOperator.vala"
	_g_object_unref0 (self->cancellable);
#line 42 "../src/FileOperator.vala"
	_g_object_unref0 (self->priv->new_playlist);
#line 43 "../src/FileOperator.vala"
	_g_object_unref0 (self->priv->all_new_imports);
#line 44 "../src/FileOperator.vala"
	_g_object_unref0 (self->priv->import_errors);
#line 45 "../src/FileOperator.vala"
	_g_object_unref0 (self->priv->monitors);
#line 30 "../src/FileOperator.vala"
	G_OBJECT_CLASS (music_file_operator_parent_class)->finalize (obj);
#line 3078 "FileOperator.c"
}

static GType
music_file_operator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicFileOperatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_file_operator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicFileOperator), 0, (GInstanceInitFunc) music_file_operator_instance_init, NULL };
	GType music_file_operator_type_id;
	music_file_operator_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicFileOperator", &g_define_type_info, 0);
	MusicFileOperator_private_offset = g_type_add_instance_private (music_file_operator_type_id, sizeof (MusicFileOperatorPrivate));
	return music_file_operator_type_id;
}

GType
music_file_operator_get_type (void)
{
	static volatile gsize music_file_operator_type_id__once = 0;
	if (g_once_init_enter (&music_file_operator_type_id__once)) {
		GType music_file_operator_type_id;
		music_file_operator_type_id = music_file_operator_get_type_once ();
		g_once_init_leave (&music_file_operator_type_id__once, music_file_operator_type_id);
	}
	return music_file_operator_type_id__once;
}

