/* Streamer.c generated by valac 0.56.0, the Vala compiler
 * generated from Streamer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */

#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gst/gst.h>
#include <glib.h>
#include <granite.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gst/pbutils/pbutils.h>
#include <gtk/gtk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_STREAMER (music_streamer_get_type ())
#define MUSIC_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_STREAMER, MusicStreamer))
#define MUSIC_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_STREAMER, MusicStreamerClass))
#define MUSIC_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_STREAMER))
#define MUSIC_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_STREAMER))
#define MUSIC_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_STREAMER, MusicStreamerClass))

typedef struct _MusicStreamer MusicStreamer;
typedef struct _MusicStreamerClass MusicStreamerClass;
typedef struct _MusicStreamerPrivate MusicStreamerPrivate;

#define MUSIC_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG (music_install_gstreamer_plugins_dialog_get_type ())
#define MUSIC_INSTALL_GSTREAMER_PLUGINS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG, MusicInstallGstreamerPluginsDialog))
#define MUSIC_INSTALL_GSTREAMER_PLUGINS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG, MusicInstallGstreamerPluginsDialogClass))
#define MUSIC_IS_INSTALL_GSTREAMER_PLUGINS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG))
#define MUSIC_IS_INSTALL_GSTREAMER_PLUGINS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG))
#define MUSIC_INSTALL_GSTREAMER_PLUGINS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG, MusicInstallGstreamerPluginsDialogClass))

typedef struct _MusicInstallGstreamerPluginsDialog MusicInstallGstreamerPluginsDialog;
typedef struct _MusicInstallGstreamerPluginsDialogClass MusicInstallGstreamerPluginsDialogClass;
enum  {
	MUSIC_STREAMER_0_PROPERTY,
	MUSIC_STREAMER_NUM_PROPERTIES
};
static GParamSpec* music_streamer_properties[MUSIC_STREAMER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define MUSIC_TYPE_PLAYBACK_MANAGER (music_playback_manager_get_type ())
#define MUSIC_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager))
#define MUSIC_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))
#define MUSIC_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))

typedef struct _MusicPlaybackManager MusicPlaybackManager;
typedef struct _MusicPlaybackManagerClass MusicPlaybackManagerClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))

struct _MusicStreamer {
	GObject parent_instance;
	MusicStreamerPrivate * priv;
	GstElement* cdda;
	gboolean set_resume_pos;
};

struct _MusicStreamerClass {
	GObjectClass parent_class;
};

struct _MusicStreamerPrivate {
	MusicPipeline* pipe;
	MusicInstallGstreamerPluginsDialog* dialog;
};

static gint MusicStreamer_private_offset;
static gpointer music_streamer_parent_class = NULL;
static MusicPlaybackIface * music_streamer_music_playback_parent_iface = NULL;

VALA_EXTERN GType music_streamer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicStreamer, g_object_unref)
VALA_EXTERN GType music_install_gstreamer_plugins_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicInstallGstreamerPluginsDialog, g_object_unref)
VALA_EXTERN MusicStreamer* music_streamer_new (void);
VALA_EXTERN MusicStreamer* music_streamer_construct (GType object_type);
static gboolean music_streamer_bus_callback (MusicStreamer* self,
                                      GstBus* bus,
                                      GstMessage* message);
static gboolean _music_streamer_bus_callback_gst_bus_func (GstBus* bus,
                                                    GstMessage* message,
                                                    gpointer self);
static gboolean _music_playback_update_position_gsource_func (gpointer self);
static GeeCollection* music_streamer_real_get_supported_uri (MusicPlayback* base);
static gboolean music_streamer_real_update_position (MusicPlayback* base);
VALA_EXTERN GType music_playback_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPlaybackManager, g_object_unref)
VALA_EXTERN MusicPlaybackManager* music_app_get_player (void);
VALA_EXTERN MusicMedia* music_playback_manager_get_current_media (MusicPlaybackManager* self);
static void music_streamer_real_play (MusicPlayback* base);
static void music_streamer_real_pause (MusicPlayback* base);
static void music_streamer_real_set_state (MusicPlayback* base,
                                    GstState s);
static void music_streamer_real_set_media (MusicPlayback* base,
                                    MusicMedia* media);
static void music_streamer_real_set_position (MusicPlayback* base,
                                       gint64 pos);
static gint64 music_streamer_real_get_position (MusicPlayback* base);
static gint64 music_streamer_real_get_duration (MusicPlayback* base);
static void music_streamer_real_set_volume (MusicPlayback* base,
                                     gdouble val);
static gdouble music_streamer_real_get_volume (MusicPlayback* base);
static void music_streamer_real_enable_equalizer (MusicPlayback* base);
static void music_streamer_real_disable_equalizer (MusicPlayback* base);
static void music_streamer_real_set_equalizer_gain (MusicPlayback* base,
                                             gint index,
                                             gint val);
VALA_EXTERN MusicInstallGstreamerPluginsDialog* music_install_gstreamer_plugins_dialog_new (GstMessage* message);
VALA_EXTERN MusicInstallGstreamerPluginsDialog* music_install_gstreamer_plugins_dialog_construct (GType object_type,
                                                                                      GstMessage* message);
static void music_streamer_finalize (GObject * obj);
static GType music_streamer_get_type_once (void);

static inline gpointer
music_streamer_get_instance_private (MusicStreamer* self)
{
	return G_STRUCT_MEMBER_P (self, MusicStreamer_private_offset);
}

static gboolean
_music_streamer_bus_callback_gst_bus_func (GstBus* bus,
                                           GstMessage* message,
                                           gpointer self)
{
	gboolean result;
	result = music_streamer_bus_callback ((MusicStreamer*) self, bus, message);
#line 46 "../src/GStreamer/Streamer.vala"
	return result;
#line 175 "Streamer.c"
}

static gboolean
_music_playback_update_position_gsource_func (gpointer self)
{
	gboolean result;
	result = music_playback_update_position ((MusicPlayback*) self);
#line 50 "../src/GStreamer/Streamer.vala"
	return result;
#line 185 "Streamer.c"
}

MusicStreamer*
music_streamer_construct (GType object_type)
{
	MusicStreamer * self = NULL;
	MusicPipeline* _tmp0_;
	MusicPipeline* _tmp1_;
	GstBus* _tmp2_;
#line 43 "../src/GStreamer/Streamer.vala"
	self = (MusicStreamer*) g_object_new (object_type, NULL);
#line 44 "../src/GStreamer/Streamer.vala"
	_tmp0_ = music_pipeline_new ();
#line 44 "../src/GStreamer/Streamer.vala"
	_g_object_unref0 (self->priv->pipe);
#line 44 "../src/GStreamer/Streamer.vala"
	self->priv->pipe = _tmp0_;
#line 46 "../src/GStreamer/Streamer.vala"
	_tmp1_ = self->priv->pipe;
#line 46 "../src/GStreamer/Streamer.vala"
	_tmp2_ = _tmp1_->bus;
#line 46 "../src/GStreamer/Streamer.vala"
	gst_bus_add_watch_full (_tmp2_, G_PRIORITY_DEFAULT, _music_streamer_bus_callback_gst_bus_func, g_object_ref (self), g_object_unref);
#line 50 "../src/GStreamer/Streamer.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _music_playback_update_position_gsource_func, g_object_ref ((MusicPlayback*) self), g_object_unref);
#line 43 "../src/GStreamer/Streamer.vala"
	return self;
#line 213 "Streamer.c"
}

MusicStreamer*
music_streamer_new (void)
{
#line 43 "../src/GStreamer/Streamer.vala"
	return music_streamer_construct (MUSIC_TYPE_STREAMER);
#line 221 "Streamer.c"
}

static GeeCollection*
music_streamer_real_get_supported_uri (MusicPlayback* base)
{
	MusicStreamer * self;
	GeeLinkedList* uris = NULL;
	GeeLinkedList* _tmp0_;
	GeeCollection* result;
#line 53 "../src/GStreamer/Streamer.vala"
	self = (MusicStreamer*) base;
#line 54 "../src/GStreamer/Streamer.vala"
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 54 "../src/GStreamer/Streamer.vala"
	uris = _tmp0_;
#line 55 "../src/GStreamer/Streamer.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "file://");
#line 56 "../src/GStreamer/Streamer.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "http://");
#line 57 "../src/GStreamer/Streamer.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "smb://");
#line 58 "../src/GStreamer/Streamer.vala"
	result = (GeeCollection*) uris;
#line 58 "../src/GStreamer/Streamer.vala"
	return result;
#line 247 "Streamer.c"
}

static gboolean
music_streamer_real_update_position (MusicPlayback* base)
{
	MusicStreamer * self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 61 "../src/GStreamer/Streamer.vala"
	self = (MusicStreamer*) base;
#line 62 "../src/GStreamer/Streamer.vala"
	if (self->set_resume_pos) {
#line 62 "../src/GStreamer/Streamer.vala"
		_tmp0_ = TRUE;
#line 262 "Streamer.c"
	} else {
		gboolean _tmp1_ = FALSE;
		MusicPlaybackManager* _tmp2_;
		MusicPlaybackManager* _tmp3_;
		MusicMedia* _tmp4_;
		MusicMedia* _tmp5_;
#line 62 "../src/GStreamer/Streamer.vala"
		_tmp2_ = music_app_get_player ();
#line 62 "../src/GStreamer/Streamer.vala"
		_tmp3_ = _tmp2_;
#line 62 "../src/GStreamer/Streamer.vala"
		_tmp4_ = music_playback_manager_get_current_media (_tmp3_);
#line 62 "../src/GStreamer/Streamer.vala"
		_tmp5_ = _tmp4_;
#line 62 "../src/GStreamer/Streamer.vala"
		if (_tmp5_ != NULL) {
#line 279 "Streamer.c"
			MusicPlaybackManager* _tmp6_;
			MusicPlaybackManager* _tmp7_;
			MusicMedia* _tmp8_;
			MusicMedia* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
#line 62 "../src/GStreamer/Streamer.vala"
			_tmp6_ = music_app_get_player ();
#line 62 "../src/GStreamer/Streamer.vala"
			_tmp7_ = _tmp6_;
#line 62 "../src/GStreamer/Streamer.vala"
			_tmp8_ = music_playback_manager_get_current_media (_tmp7_);
#line 62 "../src/GStreamer/Streamer.vala"
			_tmp9_ = _tmp8_;
#line 62 "../src/GStreamer/Streamer.vala"
			_tmp10_ = music_media_get_resume_pos (_tmp9_);
#line 62 "../src/GStreamer/Streamer.vala"
			_tmp11_ = _tmp10_;
#line 62 "../src/GStreamer/Streamer.vala"
			_tmp1_ = music_playback_get_position ((MusicPlayback*) self) >= (((gint64) (_tmp11_ - 1)) * 1000000000);
#line 300 "Streamer.c"
		} else {
#line 62 "../src/GStreamer/Streamer.vala"
			_tmp1_ = FALSE;
#line 304 "Streamer.c"
		}
#line 62 "../src/GStreamer/Streamer.vala"
		_tmp0_ = _tmp1_;
#line 308 "Streamer.c"
	}
#line 62 "../src/GStreamer/Streamer.vala"
	if (_tmp0_) {
#line 63 "../src/GStreamer/Streamer.vala"
		self->set_resume_pos = TRUE;
#line 64 "../src/GStreamer/Streamer.vala"
		g_signal_emit_by_name ((MusicPlayback*) self, "current-position-update", music_playback_get_position ((MusicPlayback*) self));
#line 316 "Streamer.c"
	} else {
		MusicPlaybackManager* _tmp12_;
		MusicPlaybackManager* _tmp13_;
		MusicMedia* _tmp14_;
		MusicMedia* _tmp15_;
#line 65 "../src/GStreamer/Streamer.vala"
		_tmp12_ = music_app_get_player ();
#line 65 "../src/GStreamer/Streamer.vala"
		_tmp13_ = _tmp12_;
#line 65 "../src/GStreamer/Streamer.vala"
		_tmp14_ = music_playback_manager_get_current_media (_tmp13_);
#line 65 "../src/GStreamer/Streamer.vala"
		_tmp15_ = _tmp14_;
#line 65 "../src/GStreamer/Streamer.vala"
		if (_tmp15_ != NULL) {
#line 332 "Streamer.c"
			MusicPipeline* _tmp16_;
			GstElement* _tmp17_;
			MusicPlaybackManager* _tmp18_;
			MusicPlaybackManager* _tmp19_;
			MusicMedia* _tmp20_;
			MusicMedia* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
#line 66 "../src/GStreamer/Streamer.vala"
			_tmp16_ = self->priv->pipe;
#line 66 "../src/GStreamer/Streamer.vala"
			_tmp17_ = _tmp16_->playbin;
#line 66 "../src/GStreamer/Streamer.vala"
			_tmp18_ = music_app_get_player ();
#line 66 "../src/GStreamer/Streamer.vala"
			_tmp19_ = _tmp18_;
#line 66 "../src/GStreamer/Streamer.vala"
			_tmp20_ = music_playback_manager_get_current_media (_tmp19_);
#line 66 "../src/GStreamer/Streamer.vala"
			_tmp21_ = _tmp20_;
#line 66 "../src/GStreamer/Streamer.vala"
			_tmp22_ = music_media_get_resume_pos (_tmp21_);
#line 66 "../src/GStreamer/Streamer.vala"
			_tmp23_ = _tmp22_;
#line 66 "../src/GStreamer/Streamer.vala"
			gst_element_seek_simple (_tmp17_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp23_) * 1000000000);
#line 359 "Streamer.c"
		}
	}
#line 69 "../src/GStreamer/Streamer.vala"
	result = TRUE;
#line 69 "../src/GStreamer/Streamer.vala"
	return result;
#line 366 "Streamer.c"
}

static void
music_streamer_real_play (MusicPlayback* base)
{
	MusicStreamer * self;
#line 73 "../src/GStreamer/Streamer.vala"
	self = (MusicStreamer*) base;
#line 74 "../src/GStreamer/Streamer.vala"
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_PLAYING);
#line 377 "Streamer.c"
}

static void
music_streamer_real_pause (MusicPlayback* base)
{
	MusicStreamer * self;
#line 77 "../src/GStreamer/Streamer.vala"
	self = (MusicStreamer*) base;
#line 78 "../src/GStreamer/Streamer.vala"
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_PAUSED);
#line 388 "Streamer.c"
}

static void
music_streamer_real_set_state (MusicPlayback* base,
                               GstState s)
{
	MusicStreamer * self;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
#line 81 "../src/GStreamer/Streamer.vala"
	self = (MusicStreamer*) base;
#line 82 "../src/GStreamer/Streamer.vala"
	_tmp0_ = self->priv->pipe;
#line 82 "../src/GStreamer/Streamer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 82 "../src/GStreamer/Streamer.vala"
	gst_element_set_state (_tmp1_, s);
#line 406 "Streamer.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 428 "Streamer.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 432 "Streamer.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 438 "Streamer.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 442 "Streamer.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 446 "Streamer.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 454 "Streamer.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 482 "Streamer.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 491 "Streamer.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 505 "Streamer.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 514 "Streamer.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 528 "Streamer.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 537 "Streamer.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 546 "Streamer.c"
}

static void
music_streamer_real_set_media (MusicPlayback* base,
                               MusicMedia* media)
{
	MusicStreamer * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	MusicPipeline* _tmp3_;
	GstElement* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GValue _tmp9_ = {0};
	MusicPlaybackManager* _tmp10_;
	MusicPlaybackManager* _tmp11_;
	MusicMedia* _tmp12_;
	MusicMedia* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	MusicPipeline* _tmp16_;
	GstElement* _tmp17_;
	MusicPlaybackManager* _tmp18_;
	MusicPlaybackManager* _tmp19_;
	MusicMedia* _tmp20_;
	MusicMedia* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
#line 85 "../src/GStreamer/Streamer.vala"
	self = (MusicStreamer*) base;
#line 85 "../src/GStreamer/Streamer.vala"
	g_return_if_fail (media != NULL);
#line 86 "../src/GStreamer/Streamer.vala"
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_READY);
#line 87 "../src/GStreamer/Streamer.vala"
	_tmp0_ = music_media_get_uri (media);
#line 87 "../src/GStreamer/Streamer.vala"
	_tmp1_ = _tmp0_;
#line 87 "../src/GStreamer/Streamer.vala"
	_tmp2_ = _tmp1_;
#line 87 "../src/GStreamer/Streamer.vala"
	g_debug ("Streamer.vala:87: set uri to %s\n", _tmp2_);
#line 87 "../src/GStreamer/Streamer.vala"
	_g_free0 (_tmp2_);
#line 89 "../src/GStreamer/Streamer.vala"
	_tmp3_ = self->priv->pipe;
#line 89 "../src/GStreamer/Streamer.vala"
	_tmp4_ = _tmp3_->playbin;
#line 89 "../src/GStreamer/Streamer.vala"
	_tmp5_ = music_media_get_uri (media);
#line 89 "../src/GStreamer/Streamer.vala"
	_tmp6_ = _tmp5_;
#line 89 "../src/GStreamer/Streamer.vala"
	_tmp7_ = _tmp6_;
#line 89 "../src/GStreamer/Streamer.vala"
	_tmp8_ = string_replace (_tmp7_, "#", "%23");
#line 89 "../src/GStreamer/Streamer.vala"
	g_value_init (&_tmp9_, G_TYPE_STRING);
#line 89 "../src/GStreamer/Streamer.vala"
	g_value_take_string (&_tmp9_, _tmp8_);
#line 89 "../src/GStreamer/Streamer.vala"
	g_object_set_property ((GObject*) _tmp4_, "uri", &_tmp9_);
#line 89 "../src/GStreamer/Streamer.vala"
	G_IS_VALUE (&_tmp9_) ? (g_value_unset (&_tmp9_), NULL) : NULL;
#line 89 "../src/GStreamer/Streamer.vala"
	_g_free0 (_tmp7_);
#line 91 "../src/GStreamer/Streamer.vala"
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_PLAYING);
#line 93 "../src/GStreamer/Streamer.vala"
	_tmp10_ = music_app_get_player ();
#line 93 "../src/GStreamer/Streamer.vala"
	_tmp11_ = _tmp10_;
#line 93 "../src/GStreamer/Streamer.vala"
	_tmp12_ = music_playback_manager_get_current_media (_tmp11_);
#line 93 "../src/GStreamer/Streamer.vala"
	_tmp13_ = _tmp12_;
#line 93 "../src/GStreamer/Streamer.vala"
	_tmp14_ = music_media_get_resume_pos (_tmp13_);
#line 93 "../src/GStreamer/Streamer.vala"
	_tmp15_ = _tmp14_;
#line 93 "../src/GStreamer/Streamer.vala"
	g_debug ("Streamer.vala:93: setURI seeking to %d\n", _tmp15_);
#line 94 "../src/GStreamer/Streamer.vala"
	_tmp16_ = self->priv->pipe;
#line 94 "../src/GStreamer/Streamer.vala"
	_tmp17_ = _tmp16_->playbin;
#line 94 "../src/GStreamer/Streamer.vala"
	_tmp18_ = music_app_get_player ();
#line 94 "../src/GStreamer/Streamer.vala"
	_tmp19_ = _tmp18_;
#line 94 "../src/GStreamer/Streamer.vala"
	_tmp20_ = music_playback_manager_get_current_media (_tmp19_);
#line 94 "../src/GStreamer/Streamer.vala"
	_tmp21_ = _tmp20_;
#line 94 "../src/GStreamer/Streamer.vala"
	_tmp22_ = music_media_get_resume_pos (_tmp21_);
#line 94 "../src/GStreamer/Streamer.vala"
	_tmp23_ = _tmp22_;
#line 94 "../src/GStreamer/Streamer.vala"
	gst_element_seek_simple (_tmp17_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp23_) * 1000000000);
#line 96 "../src/GStreamer/Streamer.vala"
	music_playback_play ((MusicPlayback*) self);
#line 652 "Streamer.c"
}

static void
music_streamer_real_set_position (MusicPlayback* base,
                                  gint64 pos)
{
	MusicStreamer * self;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
#line 99 "../src/GStreamer/Streamer.vala"
	self = (MusicStreamer*) base;
#line 100 "../src/GStreamer/Streamer.vala"
	_tmp0_ = self->priv->pipe;
#line 100 "../src/GStreamer/Streamer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 100 "../src/GStreamer/Streamer.vala"
	gst_element_seek (_tmp1_, 1.0, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, GST_SEEK_TYPE_SET, pos, GST_SEEK_TYPE_NONE, music_playback_get_duration ((MusicPlayback*) self));
#line 670 "Streamer.c"
}

static gint64
music_streamer_real_get_position (MusicPlayback* base)
{
	MusicStreamer * self;
	gint64 rv = 0LL;
	GstFormat f = 0;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
	gint64 result;
#line 106 "../src/GStreamer/Streamer.vala"
	self = (MusicStreamer*) base;
#line 107 "../src/GStreamer/Streamer.vala"
	rv = (gint64) 0;
#line 108 "../src/GStreamer/Streamer.vala"
	f = GST_FORMAT_TIME;
#line 110 "../src/GStreamer/Streamer.vala"
	_tmp0_ = self->priv->pipe;
#line 110 "../src/GStreamer/Streamer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 110 "../src/GStreamer/Streamer.vala"
	gst_element_query_position (_tmp1_, f, &_tmp2_);
#line 110 "../src/GStreamer/Streamer.vala"
	rv = _tmp2_;
#line 112 "../src/GStreamer/Streamer.vala"
	result = rv;
#line 112 "../src/GStreamer/Streamer.vala"
	return result;
#line 701 "Streamer.c"
}

static gint64
music_streamer_real_get_duration (MusicPlayback* base)
{
	MusicStreamer * self;
	gint64 rv = 0LL;
	GstFormat f = 0;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
	gint64 result;
#line 115 "../src/GStreamer/Streamer.vala"
	self = (MusicStreamer*) base;
#line 116 "../src/GStreamer/Streamer.vala"
	rv = (gint64) 0;
#line 117 "../src/GStreamer/Streamer.vala"
	f = GST_FORMAT_TIME;
#line 119 "../src/GStreamer/Streamer.vala"
	_tmp0_ = self->priv->pipe;
#line 119 "../src/GStreamer/Streamer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 119 "../src/GStreamer/Streamer.vala"
	gst_element_query_duration (_tmp1_, f, &_tmp2_);
#line 119 "../src/GStreamer/Streamer.vala"
	rv = _tmp2_;
#line 121 "../src/GStreamer/Streamer.vala"
	result = rv;
#line 121 "../src/GStreamer/Streamer.vala"
	return result;
#line 732 "Streamer.c"
}

static void
music_streamer_real_set_volume (MusicPlayback* base,
                                gdouble val)
{
	MusicStreamer * self;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	GValue _tmp2_ = {0};
#line 124 "../src/GStreamer/Streamer.vala"
	self = (MusicStreamer*) base;
#line 125 "../src/GStreamer/Streamer.vala"
	_tmp0_ = self->priv->pipe;
#line 125 "../src/GStreamer/Streamer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 125 "../src/GStreamer/Streamer.vala"
	g_value_init (&_tmp2_, G_TYPE_DOUBLE);
#line 125 "../src/GStreamer/Streamer.vala"
	g_value_set_double (&_tmp2_, val);
#line 125 "../src/GStreamer/Streamer.vala"
	g_object_set_property ((GObject*) _tmp1_, "volume", &_tmp2_);
#line 125 "../src/GStreamer/Streamer.vala"
	G_IS_VALUE (&_tmp2_) ? (g_value_unset (&_tmp2_), NULL) : NULL;
#line 757 "Streamer.c"
}

static gdouble
music_streamer_real_get_volume (MusicPlayback* base)
{
	MusicStreamer * self;
	GValue val = {0};
	GValue _tmp0_ = {0};
	MusicPipeline* _tmp1_;
	GstElement* _tmp2_;
	GValue _tmp3_;
	gdouble result;
#line 128 "../src/GStreamer/Streamer.vala"
	self = (MusicStreamer*) base;
#line 129 "../src/GStreamer/Streamer.vala"
	g_value_init (&_tmp0_, G_TYPE_DOUBLE);
#line 129 "../src/GStreamer/Streamer.vala"
	val = _tmp0_;
#line 130 "../src/GStreamer/Streamer.vala"
	_tmp1_ = self->priv->pipe;
#line 130 "../src/GStreamer/Streamer.vala"
	_tmp2_ = _tmp1_->playbin;
#line 130 "../src/GStreamer/Streamer.vala"
	g_object_get_property ((GObject*) _tmp2_, "volume", &val);
#line 131 "../src/GStreamer/Streamer.vala"
	_tmp3_ = val;
#line 131 "../src/GStreamer/Streamer.vala"
	result = g_value_get_double (&_tmp3_);
#line 131 "../src/GStreamer/Streamer.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 131 "../src/GStreamer/Streamer.vala"
	return result;
#line 790 "Streamer.c"
}

static void
music_streamer_real_enable_equalizer (MusicPlayback* base)
{
	MusicStreamer * self;
	MusicPipeline* _tmp0_;
#line 135 "../src/GStreamer/Streamer.vala"
	self = (MusicStreamer*) base;
#line 136 "../src/GStreamer/Streamer.vala"
	_tmp0_ = self->priv->pipe;
#line 136 "../src/GStreamer/Streamer.vala"
	music_pipeline_enable_equalizer (_tmp0_);
#line 804 "Streamer.c"
}

static void
music_streamer_real_disable_equalizer (MusicPlayback* base)
{
	MusicStreamer * self;
	MusicPipeline* _tmp0_;
#line 139 "../src/GStreamer/Streamer.vala"
	self = (MusicStreamer*) base;
#line 140 "../src/GStreamer/Streamer.vala"
	_tmp0_ = self->priv->pipe;
#line 140 "../src/GStreamer/Streamer.vala"
	music_pipeline_disable_equalizer (_tmp0_);
#line 818 "Streamer.c"
}

static void
music_streamer_real_set_equalizer_gain (MusicPlayback* base,
                                        gint index,
                                        gint val)
{
	MusicStreamer * self;
	MusicPipeline* _tmp0_;
	MusicEqualizer* _tmp1_;
#line 143 "../src/GStreamer/Streamer.vala"
	self = (MusicStreamer*) base;
#line 144 "../src/GStreamer/Streamer.vala"
	_tmp0_ = self->priv->pipe;
#line 144 "../src/GStreamer/Streamer.vala"
	_tmp1_ = _tmp0_->eq;
#line 144 "../src/GStreamer/Streamer.vala"
	music_equalizer_set_gain (_tmp1_, index, (gdouble) val);
#line 837 "Streamer.c"
}

static gboolean
music_streamer_bus_callback (MusicStreamer* self,
                             GstBus* bus,
                             GstMessage* message)
{
	gboolean result;
#line 148 "../src/GStreamer/Streamer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 148 "../src/GStreamer/Streamer.vala"
	g_return_val_if_fail (bus != NULL, FALSE);
#line 148 "../src/GStreamer/Streamer.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 149 "../src/GStreamer/Streamer.vala"
	switch (message->type) {
#line 149 "../src/GStreamer/Streamer.vala"
		case GST_MESSAGE_ERROR:
#line 856 "Streamer.c"
		{
			GError* err = NULL;
			gchar* debug = NULL;
			GError* _tmp0_ = NULL;
			gchar* _tmp1_ = NULL;
			GError* _tmp2_;
			const gchar* _tmp3_;
#line 153 "../src/GStreamer/Streamer.vala"
			gst_message_parse_error (message, &_tmp0_, &_tmp1_);
#line 153 "../src/GStreamer/Streamer.vala"
			_g_error_free0 (err);
#line 153 "../src/GStreamer/Streamer.vala"
			err = _tmp0_;
#line 153 "../src/GStreamer/Streamer.vala"
			_g_free0 (debug);
#line 153 "../src/GStreamer/Streamer.vala"
			debug = _tmp1_;
#line 154 "../src/GStreamer/Streamer.vala"
			_tmp2_ = err;
#line 154 "../src/GStreamer/Streamer.vala"
			_tmp3_ = _tmp2_->message;
#line 154 "../src/GStreamer/Streamer.vala"
			g_warning ("Streamer.vala:154: Error: %s\n", _tmp3_);
#line 155 "../src/GStreamer/Streamer.vala"
			g_signal_emit_by_name ((MusicPlayback*) self, "error-occured");
#line 156 "../src/GStreamer/Streamer.vala"
			_g_free0 (debug);
#line 156 "../src/GStreamer/Streamer.vala"
			_g_error_free0 (err);
#line 156 "../src/GStreamer/Streamer.vala"
			break;
#line 888 "Streamer.c"
		}
#line 149 "../src/GStreamer/Streamer.vala"
		case GST_MESSAGE_ELEMENT:
#line 892 "Streamer.c"
		{
			gboolean _tmp4_ = FALSE;
			gboolean _tmp5_ = FALSE;
			GstStructure* _tmp6_;
#line 158 "../src/GStreamer/Streamer.vala"
			_tmp6_ = gst_message_get_structure (message);
#line 158 "../src/GStreamer/Streamer.vala"
			if (_tmp6_ != NULL) {
#line 158 "../src/GStreamer/Streamer.vala"
				_tmp5_ = gst_is_missing_plugin_message (message);
#line 903 "Streamer.c"
			} else {
#line 158 "../src/GStreamer/Streamer.vala"
				_tmp5_ = FALSE;
#line 907 "Streamer.c"
			}
#line 158 "../src/GStreamer/Streamer.vala"
			if (_tmp5_) {
#line 911 "Streamer.c"
				gboolean _tmp7_ = FALSE;
				MusicInstallGstreamerPluginsDialog* _tmp8_;
#line 158 "../src/GStreamer/Streamer.vala"
				_tmp8_ = self->priv->dialog;
#line 158 "../src/GStreamer/Streamer.vala"
				if (_tmp8_ == NULL) {
#line 158 "../src/GStreamer/Streamer.vala"
					_tmp7_ = TRUE;
#line 920 "Streamer.c"
				} else {
					MusicInstallGstreamerPluginsDialog* _tmp9_;
					gboolean _tmp10_;
					gboolean _tmp11_;
#line 158 "../src/GStreamer/Streamer.vala"
					_tmp9_ = self->priv->dialog;
#line 158 "../src/GStreamer/Streamer.vala"
					_tmp10_ = gtk_widget_get_visible ((GtkWidget*) _tmp9_);
#line 158 "../src/GStreamer/Streamer.vala"
					_tmp11_ = _tmp10_;
#line 158 "../src/GStreamer/Streamer.vala"
					_tmp7_ = !_tmp11_;
#line 933 "Streamer.c"
				}
#line 158 "../src/GStreamer/Streamer.vala"
				_tmp4_ = _tmp7_;
#line 937 "Streamer.c"
			} else {
#line 158 "../src/GStreamer/Streamer.vala"
				_tmp4_ = FALSE;
#line 941 "Streamer.c"
			}
#line 158 "../src/GStreamer/Streamer.vala"
			if (_tmp4_) {
#line 945 "Streamer.c"
				MusicInstallGstreamerPluginsDialog* _tmp12_;
#line 159 "../src/GStreamer/Streamer.vala"
				_tmp12_ = music_install_gstreamer_plugins_dialog_new (message);
#line 159 "../src/GStreamer/Streamer.vala"
				g_object_ref_sink (_tmp12_);
#line 159 "../src/GStreamer/Streamer.vala"
				_g_object_unref0 (self->priv->dialog);
#line 159 "../src/GStreamer/Streamer.vala"
				self->priv->dialog = _tmp12_;
#line 955 "Streamer.c"
			}
#line 161 "../src/GStreamer/Streamer.vala"
			break;
#line 959 "Streamer.c"
		}
#line 149 "../src/GStreamer/Streamer.vala"
		case GST_MESSAGE_EOS:
#line 963 "Streamer.c"
		{
#line 163 "../src/GStreamer/Streamer.vala"
			g_signal_emit_by_name ((MusicPlayback*) self, "end-of-stream");
#line 164 "../src/GStreamer/Streamer.vala"
			break;
#line 969 "Streamer.c"
		}
#line 149 "../src/GStreamer/Streamer.vala"
		case GST_MESSAGE_STATE_CHANGED:
#line 973 "Streamer.c"
		{
			GstState oldstate = 0;
			GstState newstate = 0;
			GstState pending = 0;
			GstState _tmp13_ = 0;
			GstState _tmp14_ = 0;
			GstState _tmp15_ = 0;
#line 169 "../src/GStreamer/Streamer.vala"
			gst_message_parse_state_changed (message, &_tmp13_, &_tmp14_, &_tmp15_);
#line 169 "../src/GStreamer/Streamer.vala"
			oldstate = _tmp13_;
#line 169 "../src/GStreamer/Streamer.vala"
			newstate = _tmp14_;
#line 169 "../src/GStreamer/Streamer.vala"
			pending = _tmp15_;
#line 171 "../src/GStreamer/Streamer.vala"
			if (newstate != GST_STATE_PLAYING) {
#line 172 "../src/GStreamer/Streamer.vala"
				break;
#line 993 "Streamer.c"
			}
#line 175 "../src/GStreamer/Streamer.vala"
			break;
#line 997 "Streamer.c"
		}
#line 149 "../src/GStreamer/Streamer.vala"
		case GST_MESSAGE_TAG:
#line 1001 "Streamer.c"
		{
			GstTagList* tag_list = NULL;
			GstTagList* _tmp16_ = NULL;
			GstTagList* _tmp17_;
#line 179 "../src/GStreamer/Streamer.vala"
			gst_message_parse_tag (message, &_tmp16_);
#line 179 "../src/GStreamer/Streamer.vala"
			_gst_tag_list_unref0 (tag_list);
#line 179 "../src/GStreamer/Streamer.vala"
			tag_list = _tmp16_;
#line 180 "../src/GStreamer/Streamer.vala"
			_tmp17_ = tag_list;
#line 180 "../src/GStreamer/Streamer.vala"
			if (_tmp17_ != NULL) {
#line 1016 "Streamer.c"
				GstTagList* _tmp18_;
#line 181 "../src/GStreamer/Streamer.vala"
				_tmp18_ = tag_list;
#line 181 "../src/GStreamer/Streamer.vala"
				if (gst_tag_list_get_tag_size (_tmp18_, GST_TAG_TITLE) > ((guint) 0)) {
#line 1022 "Streamer.c"
					gchar* title = NULL;
					gchar* _tmp19_;
					GstTagList* _tmp20_;
					gchar* _tmp21_ = NULL;
#line 182 "../src/GStreamer/Streamer.vala"
					_tmp19_ = g_strdup ("");
#line 182 "../src/GStreamer/Streamer.vala"
					title = _tmp19_;
#line 183 "../src/GStreamer/Streamer.vala"
					_tmp20_ = tag_list;
#line 183 "../src/GStreamer/Streamer.vala"
					gst_tag_list_get_string (_tmp20_, GST_TAG_TITLE, &_tmp21_);
#line 183 "../src/GStreamer/Streamer.vala"
					_g_free0 (title);
#line 183 "../src/GStreamer/Streamer.vala"
					title = _tmp21_;
#line 181 "../src/GStreamer/Streamer.vala"
					_g_free0 (title);
#line 1041 "Streamer.c"
				}
			}
#line 186 "../src/GStreamer/Streamer.vala"
			_gst_tag_list_unref0 (tag_list);
#line 186 "../src/GStreamer/Streamer.vala"
			break;
#line 1048 "Streamer.c"
		}
		default:
		{
#line 188 "../src/GStreamer/Streamer.vala"
			break;
#line 1054 "Streamer.c"
		}
	}
#line 191 "../src/GStreamer/Streamer.vala"
	result = TRUE;
#line 191 "../src/GStreamer/Streamer.vala"
	return result;
#line 1061 "Streamer.c"
}

static void
music_streamer_class_init (MusicStreamerClass * klass,
                           gpointer klass_data)
{
#line 29 "../src/GStreamer/Streamer.vala"
	music_streamer_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/GStreamer/Streamer.vala"
	g_type_class_adjust_private_offset (klass, &MusicStreamer_private_offset);
#line 29 "../src/GStreamer/Streamer.vala"
	G_OBJECT_CLASS (klass)->finalize = music_streamer_finalize;
#line 1074 "Streamer.c"
}

static void
music_streamer_music_playback_interface_init (MusicPlaybackIface * iface,
                                              gpointer iface_data)
{
#line 29 "../src/GStreamer/Streamer.vala"
	music_streamer_music_playback_parent_iface = g_type_interface_peek_parent (iface);
#line 29 "../src/GStreamer/Streamer.vala"
	iface->get_supported_uri = (GeeCollection* (*) (MusicPlayback*)) music_streamer_real_get_supported_uri;
#line 29 "../src/GStreamer/Streamer.vala"
	iface->update_position = (gboolean (*) (MusicPlayback*)) music_streamer_real_update_position;
#line 29 "../src/GStreamer/Streamer.vala"
	iface->play = (void (*) (MusicPlayback*)) music_streamer_real_play;
#line 29 "../src/GStreamer/Streamer.vala"
	iface->pause = (void (*) (MusicPlayback*)) music_streamer_real_pause;
#line 29 "../src/GStreamer/Streamer.vala"
	iface->set_state = (void (*) (MusicPlayback*, GstState)) music_streamer_real_set_state;
#line 29 "../src/GStreamer/Streamer.vala"
	iface->set_media = (void (*) (MusicPlayback*, MusicMedia*)) music_streamer_real_set_media;
#line 29 "../src/GStreamer/Streamer.vala"
	iface->set_position = (void (*) (MusicPlayback*, gint64)) music_streamer_real_set_position;
#line 29 "../src/GStreamer/Streamer.vala"
	iface->get_position = (gint64 (*) (MusicPlayback*)) music_streamer_real_get_position;
#line 29 "../src/GStreamer/Streamer.vala"
	iface->get_duration = (gint64 (*) (MusicPlayback*)) music_streamer_real_get_duration;
#line 29 "../src/GStreamer/Streamer.vala"
	iface->set_volume = (void (*) (MusicPlayback*, gdouble)) music_streamer_real_set_volume;
#line 29 "../src/GStreamer/Streamer.vala"
	iface->get_volume = (gdouble (*) (MusicPlayback*)) music_streamer_real_get_volume;
#line 29 "../src/GStreamer/Streamer.vala"
	iface->enable_equalizer = (void (*) (MusicPlayback*)) music_streamer_real_enable_equalizer;
#line 29 "../src/GStreamer/Streamer.vala"
	iface->disable_equalizer = (void (*) (MusicPlayback*)) music_streamer_real_disable_equalizer;
#line 29 "../src/GStreamer/Streamer.vala"
	iface->set_equalizer_gain = (void (*) (MusicPlayback*, gint, gint)) music_streamer_real_set_equalizer_gain;
#line 1111 "Streamer.c"
}

static void
music_streamer_instance_init (MusicStreamer * self,
                              gpointer klass)
{
#line 29 "../src/GStreamer/Streamer.vala"
	self->priv = music_streamer_get_instance_private (self);
#line 1120 "Streamer.c"
}

static void
music_streamer_finalize (GObject * obj)
{
	MusicStreamer * self;
#line 29 "../src/GStreamer/Streamer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_STREAMER, MusicStreamer);
#line 30 "../src/GStreamer/Streamer.vala"
	_g_object_unref0 (self->priv->pipe);
#line 32 "../src/GStreamer/Streamer.vala"
	_g_object_unref0 (self->priv->dialog);
#line 34 "../src/GStreamer/Streamer.vala"
	_g_object_unref0 (self->cdda);
#line 29 "../src/GStreamer/Streamer.vala"
	G_OBJECT_CLASS (music_streamer_parent_class)->finalize (obj);
#line 1137 "Streamer.c"
}

static GType
music_streamer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicStreamerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_streamer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicStreamer), 0, (GInstanceInitFunc) music_streamer_instance_init, NULL };
	static const GInterfaceInfo music_playback_info = { (GInterfaceInitFunc) music_streamer_music_playback_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_streamer_type_id;
	music_streamer_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicStreamer", &g_define_type_info, 0);
	g_type_add_interface_static (music_streamer_type_id, MUSIC_TYPE_PLAYBACK, &music_playback_info);
	MusicStreamer_private_offset = g_type_add_instance_private (music_streamer_type_id, sizeof (MusicStreamerPrivate));
	return music_streamer_type_id;
}

GType
music_streamer_get_type (void)
{
	static volatile gsize music_streamer_type_id__once = 0;
	if (g_once_init_enter (&music_streamer_type_id__once)) {
		GType music_streamer_type_id;
		music_streamer_type_id = music_streamer_get_type_once ();
		g_once_init_leave (&music_streamer_type_id__once, music_streamer_type_id);
	}
	return music_streamer_type_id__once;
}

