/* ViewInterface.c generated by valac 0.56.0, the Vala compiler
 * generated from ViewInterface.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <glib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_VIEW_INTERFACE (music_view_interface_get_type ())
#define MUSIC_VIEW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_VIEW_INTERFACE, MusicViewInterface))
#define MUSIC_IS_VIEW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_VIEW_INTERFACE))
#define MUSIC_VIEW_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), MUSIC_TYPE_VIEW_INTERFACE, MusicViewInterfaceIface))

typedef struct _MusicViewInterface MusicViewInterface;
typedef struct _MusicViewInterfaceIface MusicViewInterfaceIface;
enum  {
	MUSIC_VIEW_INTERFACE_IMPORT_REQUESTED_SIGNAL,
	MUSIC_VIEW_INTERFACE_NUM_SIGNALS
};
static guint music_view_interface_signals[MUSIC_VIEW_INTERFACE_NUM_SIGNALS] = {0};

struct _MusicViewInterfaceIface {
	GTypeInterface parent_iface;
	GeeCollection* (*get_media) (MusicViewInterface* self);
	GeeCollection* (*get_visible_media) (MusicViewInterface* self);
	void (*refilter) (MusicViewInterface* self);
	void (*set_media) (MusicViewInterface* self, GeeCollection* new_media);
	void (*add_media) (MusicViewInterface* self, GeeCollection* to_add);
	void (*remove_media) (MusicViewInterface* self, GeeCollection* to_remove);
	void (*update_media) (MusicViewInterface* self, GeeCollection* to_update);
};

VALA_EXTERN GType music_view_interface_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicViewInterface, g_object_unref)
VALA_EXTERN GeeCollection* music_view_interface_get_media (MusicViewInterface* self);
VALA_EXTERN GeeCollection* music_view_interface_get_visible_media (MusicViewInterface* self);
VALA_EXTERN void music_view_interface_refilter (MusicViewInterface* self);
VALA_EXTERN void music_view_interface_set_media (MusicViewInterface* self,
                                     GeeCollection* new_media);
VALA_EXTERN void music_view_interface_add_media (MusicViewInterface* self,
                                     GeeCollection* to_add);
VALA_EXTERN void music_view_interface_remove_media (MusicViewInterface* self,
                                        GeeCollection* to_remove);
VALA_EXTERN void music_view_interface_update_media (MusicViewInterface* self,
                                        GeeCollection* to_update);
static GType music_view_interface_get_type_once (void);

/**
     * For some views, get_media() and get_visible_media() return the same contents, since
     * the view doesn't have any kind of built-in filters. For other views, they don't return
     * the same since the view has some kind of internal browsing mechanism (e.g. Miller Columns).
     */
GeeCollection*
music_view_interface_get_media (MusicViewInterface* self)
{
	MusicViewInterfaceIface* _iface_;
#line 41 "../src/Interfaces/ViewInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/Interfaces/ViewInterface.vala"
	_iface_ = MUSIC_VIEW_INTERFACE_GET_INTERFACE (self);
#line 41 "../src/Interfaces/ViewInterface.vala"
	if (_iface_->get_media) {
#line 41 "../src/Interfaces/ViewInterface.vala"
		return _iface_->get_media (self);
#line 106 "ViewInterface.c"
	}
#line 41 "../src/Interfaces/ViewInterface.vala"
	return NULL;
#line 110 "ViewInterface.c"
}

GeeCollection*
music_view_interface_get_visible_media (MusicViewInterface* self)
{
	MusicViewInterfaceIface* _iface_;
#line 42 "../src/Interfaces/ViewInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/Interfaces/ViewInterface.vala"
	_iface_ = MUSIC_VIEW_INTERFACE_GET_INTERFACE (self);
#line 42 "../src/Interfaces/ViewInterface.vala"
	if (_iface_->get_visible_media) {
#line 42 "../src/Interfaces/ViewInterface.vala"
		return _iface_->get_visible_media (self);
#line 125 "ViewInterface.c"
	}
#line 42 "../src/Interfaces/ViewInterface.vala"
	return NULL;
#line 129 "ViewInterface.c"
}

/**
     * Requests the view to apply a filter to only show the media matching the
     * search string.
     *
     * @param search Search string; pass null to use the previous search string.
     */
void
music_view_interface_refilter (MusicViewInterface* self)
{
	MusicViewInterfaceIface* _iface_;
#line 50 "../src/Interfaces/ViewInterface.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/Interfaces/ViewInterface.vala"
	_iface_ = MUSIC_VIEW_INTERFACE_GET_INTERFACE (self);
#line 50 "../src/Interfaces/ViewInterface.vala"
	if (_iface_->refilter) {
#line 50 "../src/Interfaces/ViewInterface.vala"
		_iface_->refilter (self);
#line 150 "ViewInterface.c"
	}
}

void
music_view_interface_set_media (MusicViewInterface* self,
                                GeeCollection* new_media)
{
	MusicViewInterfaceIface* _iface_;
#line 52 "../src/Interfaces/ViewInterface.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/Interfaces/ViewInterface.vala"
	_iface_ = MUSIC_VIEW_INTERFACE_GET_INTERFACE (self);
#line 52 "../src/Interfaces/ViewInterface.vala"
	if (_iface_->set_media) {
#line 52 "../src/Interfaces/ViewInterface.vala"
		_iface_->set_media (self, new_media);
#line 167 "ViewInterface.c"
	}
}

void
music_view_interface_add_media (MusicViewInterface* self,
                                GeeCollection* to_add)
{
	MusicViewInterfaceIface* _iface_;
#line 53 "../src/Interfaces/ViewInterface.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/Interfaces/ViewInterface.vala"
	_iface_ = MUSIC_VIEW_INTERFACE_GET_INTERFACE (self);
#line 53 "../src/Interfaces/ViewInterface.vala"
	if (_iface_->add_media) {
#line 53 "../src/Interfaces/ViewInterface.vala"
		_iface_->add_media (self, to_add);
#line 184 "ViewInterface.c"
	}
}

void
music_view_interface_remove_media (MusicViewInterface* self,
                                   GeeCollection* to_remove)
{
	MusicViewInterfaceIface* _iface_;
#line 54 "../src/Interfaces/ViewInterface.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/Interfaces/ViewInterface.vala"
	_iface_ = MUSIC_VIEW_INTERFACE_GET_INTERFACE (self);
#line 54 "../src/Interfaces/ViewInterface.vala"
	if (_iface_->remove_media) {
#line 54 "../src/Interfaces/ViewInterface.vala"
		_iface_->remove_media (self, to_remove);
#line 201 "ViewInterface.c"
	}
}

void
music_view_interface_update_media (MusicViewInterface* self,
                                   GeeCollection* to_update)
{
	MusicViewInterfaceIface* _iface_;
#line 55 "../src/Interfaces/ViewInterface.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/Interfaces/ViewInterface.vala"
	_iface_ = MUSIC_VIEW_INTERFACE_GET_INTERFACE (self);
#line 55 "../src/Interfaces/ViewInterface.vala"
	if (_iface_->update_media) {
#line 55 "../src/Interfaces/ViewInterface.vala"
		_iface_->update_media (self, to_update);
#line 218 "ViewInterface.c"
	}
}

static void
music_view_interface_default_init (MusicViewInterfaceIface * iface,
                                   gpointer iface_data)
{
	/**
	     * Used for device syncing.
	     */
#line 30 "../src/Interfaces/ViewInterface.vala"
	music_view_interface_signals[MUSIC_VIEW_INTERFACE_IMPORT_REQUESTED_SIGNAL] = g_signal_new ("import-requested", MUSIC_TYPE_VIEW_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 231 "ViewInterface.c"
}

static GType
music_view_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicViewInterfaceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_view_interface_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType music_view_interface_type_id;
	music_view_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "MusicViewInterface", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (music_view_interface_type_id, gtk_widget_get_type ());
	return music_view_interface_type_id;
}

GType
music_view_interface_get_type (void)
{
	static volatile gsize music_view_interface_type_id__once = 0;
	if (g_once_init_enter (&music_view_interface_type_id__once)) {
		GType music_view_interface_type_id;
		music_view_interface_type_id = music_view_interface_get_type_once ();
		g_once_init_leave (&music_view_interface_type_id__once, music_view_interface_type_id);
	}
	return music_view_interface_type_id__once;
}

