/* LocalSmartPlaylist.c generated by valac 0.56.0, the Vala compiler
 * generated from LocalSmartPlaylist.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <glib-object.h>
#include <libgda/libgda.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib/gi18n-lib.h>

#define MUSIC_LOCAL_SMART_PLAYLIST_QUERY_SEPARATOR "<query_sep>"
#define MUSIC_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR "<val_sep>"
#define MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME "smart_playlists"
#define MUSIC_DATABASE_MEDIA_TABLE_NAME "media"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_LOCAL_SMART_PLAYLIST (music_local_smart_playlist_get_type ())
#define MUSIC_LOCAL_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylist))
#define MUSIC_LOCAL_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylistClass))
#define MUSIC_IS_LOCAL_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LOCAL_SMART_PLAYLIST))
#define MUSIC_IS_LOCAL_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LOCAL_SMART_PLAYLIST))
#define MUSIC_LOCAL_SMART_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylistClass))

typedef struct _MusicLocalSmartPlaylist MusicLocalSmartPlaylist;
typedef struct _MusicLocalSmartPlaylistClass MusicLocalSmartPlaylistClass;
typedef struct _MusicLocalSmartPlaylistPrivate MusicLocalSmartPlaylistPrivate;
enum  {
	MUSIC_LOCAL_SMART_PLAYLIST_0_PROPERTY,
	MUSIC_LOCAL_SMART_PLAYLIST_NAME_PROPERTY,
	MUSIC_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY,
	MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY,
	MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY,
	MUSIC_LOCAL_SMART_PLAYLIST_NUM_PROPERTIES
};
static GParamSpec* music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _MusicLocalSmartPlaylist {
	MusicSmartPlaylist parent_instance;
	MusicLocalSmartPlaylistPrivate * priv;
};

struct _MusicLocalSmartPlaylistClass {
	MusicSmartPlaylistClass parent_class;
};

struct _MusicLocalSmartPlaylistPrivate {
	GdaConnection* connection;
	gchar* _name;
};

static gint MusicLocalSmartPlaylist_private_offset;
static gpointer music_local_smart_playlist_parent_class = NULL;

VALA_EXTERN GType music_local_smart_playlist_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLocalSmartPlaylist, g_object_unref)
VALA_EXTERN MusicLocalSmartPlaylist* music_local_smart_playlist_new (gint64 rowid,
                                                         GdaConnection* connection);
VALA_EXTERN MusicLocalSmartPlaylist* music_local_smart_playlist_construct (GType object_type,
                                                               gint64 rowid,
                                                               GdaConnection* connection);
VALA_EXTERN GValue* music_database_query_field (gint64 rowid,
                                    GdaConnection* connection,
                                    const gchar* table,
                                    const gchar* field);
static void _vala_GValue_free (GValue* self);
VALA_EXTERN void music_local_smart_playlist_queries_from_string (MusicLocalSmartPlaylist* self,
                                                     const gchar* q);
static void music_local_smart_playlist_real_analyse_all (MusicSmartPlaylist* base);
static gint64* _int64_dup (gint64* self);
VALA_EXTERN GdaSqlBuilderId music_database_process_smart_query (GdaSqlBuilder* builder,
                                                    MusicSmartQuery* sq);
static void _vala_array_add2 (GdaSqlBuilderId* * array,
                       gint* length,
                       gint* size,
                       GdaSqlBuilderId value);
static void music_local_smart_playlist_real_clear_queries (MusicSmartPlaylist* base);
VALA_EXTERN void music_database_set_field (gint64 rowid,
                               GdaConnection* connection,
                               const gchar* table,
                               const gchar* field,
                               GValue* val);
static void music_local_smart_playlist_real_add_query (MusicSmartPlaylist* base,
                                                MusicSmartQuery* s);
static gchar* music_local_smart_playlist_queries_to_string (MusicLocalSmartPlaylist* self);
static void music_local_smart_playlist_real_add_queries (MusicSmartPlaylist* base,
                                                  GeeCollection* queries);
VALA_EXTERN void music_local_smart_playlist_add_defaults (GdaConnection* connection);
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_slist_free___vala_GValue_free0_ (GSList* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static void music_local_smart_playlist_finalize (GObject * obj);
static GType music_local_smart_playlist_get_type_once (void);
static void _vala_music_local_smart_playlist_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_music_local_smart_playlist_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
music_local_smart_playlist_get_instance_private (MusicLocalSmartPlaylist* self)
{
	return G_STRUCT_MEMBER_P (self, MusicLocalSmartPlaylist_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 84 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return self ? g_object_ref (self) : NULL;
#line 165 "LocalSmartPlaylist.c"
}

static void
_vala_GValue_free (GValue* self)
{
#line 86 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_boxed_free (G_TYPE_VALUE, self);
#line 173 "LocalSmartPlaylist.c"
}

MusicLocalSmartPlaylist*
music_local_smart_playlist_construct (GType object_type,
                                      gint64 rowid,
                                      GdaConnection* connection)
{
	MusicLocalSmartPlaylist * self = NULL;
	MusicLibrariesManager* _tmp0_;
	MusicLibrary* _tmp1_;
	GdaConnection* _tmp2_;
	gchar* queries_str = NULL;
	GValue* _tmp3_;
	GValue* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 82 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 83 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = music_libraries_manager;
#line 83 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_->local_library;
#line 83 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (MusicLocalSmartPlaylist*) music_smart_playlist_construct (object_type, _tmp1_);
#line 84 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = _g_object_ref0 (connection);
#line 84 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_object_unref0 (self->priv->connection);
#line 84 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self->priv->connection = _tmp2_;
#line 85 "../src/LocalBackend/LocalSmartPlaylist.vala"
	music_playlist_set_rowid ((MusicPlaylist*) self, rowid);
#line 86 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = music_database_query_field (rowid, connection, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries");
#line 86 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4_ = _tmp3_;
#line 86 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp5_ = g_value_get_string (_tmp4_);
#line 86 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 86 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp7_ = _tmp6_;
#line 86 "../src/LocalBackend/LocalSmartPlaylist.vala"
	__vala_GValue_free0 (_tmp4_);
#line 86 "../src/LocalBackend/LocalSmartPlaylist.vala"
	queries_str = _tmp7_;
#line 87 "../src/LocalBackend/LocalSmartPlaylist.vala"
	music_local_smart_playlist_queries_from_string (self, queries_str);
#line 82 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_free0 (queries_str);
#line 82 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return self;
#line 227 "LocalSmartPlaylist.c"
}

MusicLocalSmartPlaylist*
music_local_smart_playlist_new (gint64 rowid,
                                GdaConnection* connection)
{
#line 82 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return music_local_smart_playlist_construct (MUSIC_TYPE_LOCAL_SMART_PLAYLIST, rowid, connection);
#line 236 "LocalSmartPlaylist.c"
}

static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
#line 98 "../src/LocalBackend/LocalSmartPlaylist.vala"
	dup = g_new0 (gint64, 1);
#line 98 "../src/LocalBackend/LocalSmartPlaylist.vala"
	memcpy (dup, self, sizeof (gint64));
#line 98 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return dup;
#line 249 "LocalSmartPlaylist.c"
}

static void
_vala_array_add2 (GdaSqlBuilderId* * array,
                  gint* length,
                  gint* size,
                  GdaSqlBuilderId value)
{
#line 105 "../src/LocalBackend/LocalSmartPlaylist.vala"
	if ((*length) == (*size)) {
#line 105 "../src/LocalBackend/LocalSmartPlaylist.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 105 "../src/LocalBackend/LocalSmartPlaylist.vala"
		*array = g_renew (GdaSqlBuilderId, *array, *size);
#line 264 "LocalSmartPlaylist.c"
	}
#line 105 "../src/LocalBackend/LocalSmartPlaylist.vala"
	(*array)[(*length)++] = value;
#line 268 "LocalSmartPlaylist.c"
}

static void
music_local_smart_playlist_real_analyse_all (MusicSmartPlaylist* base)
{
	MusicLocalSmartPlaylist * self;
	GeeTreeSet* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GeeTreeSet* rowids = NULL;
	GeeTreeSet* _tmp10_;
	GError* _inner_error0_ = NULL;
#line 90 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (MusicLocalSmartPlaylist*) base;
#line 91 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = ((MusicSmartPlaylist*) self)->queries;
#line 91 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = gee_collection_get_is_empty ((GeeCollection*) _tmp0_);
#line 91 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = _tmp1_;
#line 91 "../src/LocalBackend/LocalSmartPlaylist.vala"
	if (_tmp2_) {
#line 291 "LocalSmartPlaylist.c"
		GeeCollection* meds = NULL;
		MusicLibrary* _tmp3_;
		MusicLibrary* _tmp4_;
		GeeCollection* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp7_;
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
#line 92 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp3_ = music_smart_playlist_get_library ((MusicSmartPlaylist*) self);
#line 92 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp4_ = _tmp3_;
#line 92 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp5_ = music_library_get_medias (_tmp4_);
#line 92 "../src/LocalBackend/LocalSmartPlaylist.vala"
		meds = _tmp5_;
#line 93 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp6_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 93 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp7_ = _tmp6_;
#line 93 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp8_ = meds;
#line 93 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gee_array_list_add_all (_tmp7_, _tmp8_);
#line 94 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp9_ = meds;
#line 94 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_signal_emit_by_name ((MusicPlaylist*) self, "media-added", _tmp9_);
#line 95 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (meds);
#line 95 "../src/LocalBackend/LocalSmartPlaylist.vala"
		return;
#line 324 "LocalSmartPlaylist.c"
	}
#line 98 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp10_ = gee_tree_set_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 98 "../src/LocalBackend/LocalSmartPlaylist.vala"
	rowids = _tmp10_;
#line 330 "LocalSmartPlaylist.c"
	{
		GdaSqlBuilder* sql = NULL;
		GdaSqlBuilder* _tmp11_;
		GdaSqlBuilder* _tmp12_;
		GdaSqlBuilder* _tmp13_;
		GdaSqlBuilderId* ids = NULL;
		gint ids_length1;
		gint _ids_size_;
		GdaSqlOperatorType sql_operator_type = 0;
		MusicSmartPlaylistConditionalType _tmp21_;
		MusicSmartPlaylistConditionalType _tmp22_;
		GdaSqlBuilderId id_cond = 0U;
		GdaSqlBuilder* _tmp23_;
		GdaSqlBuilderId* _tmp24_;
		gint _tmp24__length1;
		GdaSqlBuilder* _tmp25_;
		GdaStatement* statm = NULL;
		GdaSqlBuilder* _tmp26_;
		GdaStatement* _tmp27_;
		GdaDataModel* data_model = NULL;
		GdaConnection* _tmp28_;
		GdaStatement* _tmp29_;
		GdaDataModel* _tmp30_;
		GdaDataModelIter* data_model_iter = NULL;
		GdaDataModel* _tmp31_;
		GdaDataModelIter* _tmp32_;
		GdaDataModelIter* _tmp33_;
		GeeCollection* meds = NULL;
		MusicLibrary* _tmp39_;
		MusicLibrary* _tmp40_;
		GeeTreeSet* _tmp41_;
		GeeCollection* _tmp42_;
		GeeArrayList* _tmp43_;
		GeeArrayList* _tmp44_;
		GeeCollection* _tmp45_;
		GeeCollection* _tmp46_;
#line 100 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp11_ = gda_sql_builder_new (GDA_SQL_STATEMENT_SELECT);
#line 100 "../src/LocalBackend/LocalSmartPlaylist.vala"
		sql = _tmp11_;
#line 101 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp12_ = sql;
#line 101 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_sql_builder_select_add_target (_tmp12_, MUSIC_DATABASE_MEDIA_TABLE_NAME, NULL);
#line 102 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp13_ = sql;
#line 102 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_sql_builder_select_add_field (_tmp13_, "rowid", NULL, NULL);
#line 103 "../src/LocalBackend/LocalSmartPlaylist.vala"
		ids = NULL;
#line 103 "../src/LocalBackend/LocalSmartPlaylist.vala"
		ids_length1 = 0;
#line 103 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_ids_size_ = ids_length1;
#line 385 "LocalSmartPlaylist.c"
		{
			GeeIterator* _q_it = NULL;
			GeeTreeSet* _tmp14_;
			GeeIterator* _tmp15_;
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp14_ = ((MusicSmartPlaylist*) self)->queries;
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp14_);
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_q_it = _tmp15_;
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
			while (TRUE) {
#line 398 "LocalSmartPlaylist.c"
				GeeIterator* _tmp16_;
				MusicSmartQuery* q = NULL;
				GeeIterator* _tmp17_;
				gpointer _tmp18_;
				GdaSqlBuilder* _tmp19_;
				MusicSmartQuery* _tmp20_;
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp16_ = _q_it;
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
				if (!gee_iterator_next (_tmp16_)) {
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
					break;
#line 411 "LocalSmartPlaylist.c"
				}
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp17_ = _q_it;
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp18_ = gee_iterator_get (_tmp17_);
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
				q = (MusicSmartQuery*) _tmp18_;
#line 105 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp19_ = sql;
#line 105 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp20_ = q;
#line 105 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_vala_array_add2 (&ids, &ids_length1, &_ids_size_, music_database_process_smart_query (_tmp19_, _tmp20_));
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_g_object_unref0 (q);
#line 427 "LocalSmartPlaylist.c"
			}
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_g_object_unref0 (_q_it);
#line 431 "LocalSmartPlaylist.c"
		}
#line 108 "../src/LocalBackend/LocalSmartPlaylist.vala"
		sql_operator_type = GDA_SQL_OPERATOR_TYPE_AND;
#line 109 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp21_ = music_smart_playlist_get_conditional ((MusicSmartPlaylist*) self);
#line 109 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp22_ = _tmp21_;
#line 109 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (_tmp22_ == MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ANY) {
#line 110 "../src/LocalBackend/LocalSmartPlaylist.vala"
			sql_operator_type = GDA_SQL_OPERATOR_TYPE_OR;
#line 443 "LocalSmartPlaylist.c"
		}
#line 113 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp23_ = sql;
#line 113 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp24_ = ids;
#line 113 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp24__length1 = ids_length1;
#line 113 "../src/LocalBackend/LocalSmartPlaylist.vala"
		id_cond = gda_sql_builder_add_cond_v (_tmp23_, sql_operator_type, _tmp24_, (gint) _tmp24__length1);
#line 114 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp25_ = sql;
#line 114 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_sql_builder_set_where (_tmp25_, id_cond);
#line 116 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp26_ = sql;
#line 116 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp27_ = gda_sql_builder_get_statement (_tmp26_, &_inner_error0_);
#line 116 "../src/LocalBackend/LocalSmartPlaylist.vala"
		statm = _tmp27_;
#line 116 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 116 "../src/LocalBackend/LocalSmartPlaylist.vala"
			ids = (g_free (ids), NULL);
#line 116 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_g_object_unref0 (sql);
#line 469 "LocalSmartPlaylist.c"
			goto __catch0_g_error;
		}
#line 117 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp28_ = self->priv->connection;
#line 117 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp29_ = statm;
#line 117 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp30_ = gda_connection_statement_execute_select (_tmp28_, _tmp29_, NULL, &_inner_error0_);
#line 117 "../src/LocalBackend/LocalSmartPlaylist.vala"
		data_model = _tmp30_;
#line 117 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 117 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_g_object_unref0 (statm);
#line 117 "../src/LocalBackend/LocalSmartPlaylist.vala"
			ids = (g_free (ids), NULL);
#line 117 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_g_object_unref0 (sql);
#line 488 "LocalSmartPlaylist.c"
			goto __catch0_g_error;
		}
#line 118 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp31_ = data_model;
#line 118 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp32_ = gda_data_model_create_iter (_tmp31_);
#line 118 "../src/LocalBackend/LocalSmartPlaylist.vala"
		data_model_iter = _tmp32_;
#line 119 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp33_ = data_model_iter;
#line 119 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_data_model_iter_move_to_row (_tmp33_, -1);
#line 120 "../src/LocalBackend/LocalSmartPlaylist.vala"
		while (TRUE) {
#line 503 "LocalSmartPlaylist.c"
			GdaDataModelIter* _tmp34_;
			GValue* val = NULL;
			GdaDataModelIter* _tmp35_;
			GeeTreeSet* _tmp36_;
			GValue* _tmp37_;
			gint64 _tmp38_;
#line 120 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp34_ = data_model_iter;
#line 120 "../src/LocalBackend/LocalSmartPlaylist.vala"
			if (!gda_data_model_iter_move_next (_tmp34_)) {
#line 120 "../src/LocalBackend/LocalSmartPlaylist.vala"
				break;
#line 516 "LocalSmartPlaylist.c"
			}
#line 121 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp35_ = data_model_iter;
#line 121 "../src/LocalBackend/LocalSmartPlaylist.vala"
			val = gda_data_model_iter_get_value_at (_tmp35_, 0);
#line 122 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp36_ = rowids;
#line 122 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp37_ = val;
#line 122 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp38_ = g_value_get_int64 (_tmp37_);
#line 122 "../src/LocalBackend/LocalSmartPlaylist.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, &_tmp38_);
#line 530 "LocalSmartPlaylist.c"
		}
#line 125 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp39_ = music_smart_playlist_get_library ((MusicSmartPlaylist*) self);
#line 125 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp40_ = _tmp39_;
#line 125 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp41_ = rowids;
#line 125 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp42_ = music_library_medias_from_ids (_tmp40_, (GeeCollection*) _tmp41_);
#line 125 "../src/LocalBackend/LocalSmartPlaylist.vala"
		meds = _tmp42_;
#line 126 "../src/LocalBackend/LocalSmartPlaylist.vala"
		music_playlist_clear ((MusicPlaylist*) self);
#line 127 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp43_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 127 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp44_ = _tmp43_;
#line 127 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp45_ = meds;
#line 127 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gee_array_list_add_all (_tmp44_, _tmp45_);
#line 128 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp46_ = meds;
#line 128 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_signal_emit_by_name ((MusicPlaylist*) self, "media-added", _tmp46_);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (meds);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (data_model_iter);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (data_model);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (statm);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		ids = (g_free (ids), NULL);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (sql);
#line 568 "LocalSmartPlaylist.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp47_;
		const gchar* _tmp48_;
		GError* _tmp49_;
		const gchar* _tmp50_;
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		e = _inner_error0_;
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_inner_error0_ = NULL;
#line 130 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp47_ = music_playlist_get_name ((MusicPlaylist*) self);
#line 130 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp48_ = _tmp47_;
#line 130 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp49_ = e;
#line 130 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp50_ = _tmp49_->message;
#line 130 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_critical ("LocalSmartPlaylist.vala:130: Could not query media for smart playlist " \
"%s: %s", _tmp48_, _tmp50_);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_error_free0 (e);
#line 594 "LocalSmartPlaylist.c"
	}
	__finally0:
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (rowids);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_clear_error (&_inner_error0_);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		return;
#line 607 "LocalSmartPlaylist.c"
	}
#line 90 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_object_unref0 (rowids);
#line 611 "LocalSmartPlaylist.c"
}

static void
music_local_smart_playlist_real_clear_queries (MusicSmartPlaylist* base)
{
	MusicLocalSmartPlaylist * self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue _tmp3_ = {0};
#line 134 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (MusicLocalSmartPlaylist*) base;
#line 135 "../src/LocalBackend/LocalSmartPlaylist.vala"
	MUSIC_SMART_PLAYLIST_CLASS (music_local_smart_playlist_parent_class)->clear_queries (G_TYPE_CHECK_INSTANCE_CAST (self, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist));
#line 136 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
#line 136 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 136 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 136 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp3_, G_TYPE_STRING);
#line 136 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_set_string (&_tmp3_, "");
#line 136 "../src/LocalBackend/LocalSmartPlaylist.vala"
	music_database_set_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries", &_tmp3_);
#line 136 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
#line 640 "LocalSmartPlaylist.c"
}

static void
music_local_smart_playlist_real_add_query (MusicSmartPlaylist* base,
                                           MusicSmartQuery* s)
{
	MusicLocalSmartPlaylist * self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	gchar* _tmp3_;
	GValue _tmp4_ = {0};
#line 139 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (MusicLocalSmartPlaylist*) base;
#line 139 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_if_fail (s != NULL);
#line 140 "../src/LocalBackend/LocalSmartPlaylist.vala"
	MUSIC_SMART_PLAYLIST_CLASS (music_local_smart_playlist_parent_class)->add_query (G_TYPE_CHECK_INSTANCE_CAST (self, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist), s);
#line 141 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
#line 141 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 141 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 141 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = music_local_smart_playlist_queries_to_string (self);
#line 141 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp4_, G_TYPE_STRING);
#line 141 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_take_string (&_tmp4_, _tmp3_);
#line 141 "../src/LocalBackend/LocalSmartPlaylist.vala"
	music_database_set_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries", &_tmp4_);
#line 141 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
#line 675 "LocalSmartPlaylist.c"
}

static void
music_local_smart_playlist_real_add_queries (MusicSmartPlaylist* base,
                                             GeeCollection* queries)
{
	MusicLocalSmartPlaylist * self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	gchar* _tmp3_;
	GValue _tmp4_ = {0};
#line 144 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (MusicLocalSmartPlaylist*) base;
#line 144 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_if_fail (queries != NULL);
#line 145 "../src/LocalBackend/LocalSmartPlaylist.vala"
	MUSIC_SMART_PLAYLIST_CLASS (music_local_smart_playlist_parent_class)->add_queries (G_TYPE_CHECK_INSTANCE_CAST (self, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist), queries);
#line 146 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
#line 146 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 146 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 146 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = music_local_smart_playlist_queries_to_string (self);
#line 146 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp4_, G_TYPE_STRING);
#line 146 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_take_string (&_tmp4_, _tmp3_);
#line 146 "../src/LocalBackend/LocalSmartPlaylist.vala"
	music_database_set_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries", &_tmp4_);
#line 146 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
#line 710 "LocalSmartPlaylist.c"
}

static gchar*
music_local_smart_playlist_queries_to_string (MusicLocalSmartPlaylist* self)
{
	GString* sb = NULL;
	GString* _tmp0_;
	GString* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* result;
#line 149 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 150 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = g_string_new ("");
#line 150 "../src/LocalBackend/LocalSmartPlaylist.vala"
	sb = _tmp0_;
#line 728 "LocalSmartPlaylist.c"
	{
		GeeIterator* _q_it = NULL;
		GeeTreeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 151 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp1_ = ((MusicSmartPlaylist*) self)->queries;
#line 151 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
#line 151 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_q_it = _tmp2_;
#line 151 "../src/LocalBackend/LocalSmartPlaylist.vala"
		while (TRUE) {
#line 741 "LocalSmartPlaylist.c"
			GeeIterator* _tmp3_;
			MusicSmartQuery* q = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			GString* _tmp6_;
			GString* _tmp8_;
			MusicSmartQuery* _tmp9_;
			MusicSmartQueryFieldType _tmp10_;
			MusicSmartQueryFieldType _tmp11_;
			GString* _tmp12_;
			GString* _tmp13_;
			MusicSmartQuery* _tmp14_;
			MusicSmartQueryComparatorType _tmp15_;
			MusicSmartQueryComparatorType _tmp16_;
			GString* _tmp17_;
			MusicSmartQuery* _tmp18_;
			GValue _tmp19_ = {0};
			GValue _tmp20_;
#line 151 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp3_ = _q_it;
#line 151 "../src/LocalBackend/LocalSmartPlaylist.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 151 "../src/LocalBackend/LocalSmartPlaylist.vala"
				break;
#line 766 "LocalSmartPlaylist.c"
			}
#line 151 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp4_ = _q_it;
#line 151 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 151 "../src/LocalBackend/LocalSmartPlaylist.vala"
			q = (MusicSmartQuery*) _tmp5_;
#line 152 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp6_ = sb;
#line 152 "../src/LocalBackend/LocalSmartPlaylist.vala"
			if (_tmp6_->len != ((gssize) 0)) {
#line 778 "LocalSmartPlaylist.c"
				GString* _tmp7_;
#line 153 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp7_ = sb;
#line 153 "../src/LocalBackend/LocalSmartPlaylist.vala"
				g_string_append (_tmp7_, MUSIC_LOCAL_SMART_PLAYLIST_QUERY_SEPARATOR);
#line 784 "LocalSmartPlaylist.c"
			}
#line 156 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp8_ = sb;
#line 156 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp9_ = q;
#line 156 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp10_ = music_smart_query_get_field (_tmp9_);
#line 156 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp11_ = _tmp10_;
#line 156 "../src/LocalBackend/LocalSmartPlaylist.vala"
			g_string_append_printf (_tmp8_, "%d", (gint) _tmp11_);
#line 157 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp12_ = sb;
#line 157 "../src/LocalBackend/LocalSmartPlaylist.vala"
			g_string_append (_tmp12_, MUSIC_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR);
#line 158 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp13_ = sb;
#line 158 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp14_ = q;
#line 158 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp15_ = music_smart_query_get_comparator (_tmp14_);
#line 158 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp16_ = _tmp15_;
#line 158 "../src/LocalBackend/LocalSmartPlaylist.vala"
			g_string_append_printf (_tmp13_, "%d", (gint) _tmp16_);
#line 159 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp17_ = sb;
#line 159 "../src/LocalBackend/LocalSmartPlaylist.vala"
			g_string_append (_tmp17_, MUSIC_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR);
#line 160 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp18_ = q;
#line 160 "../src/LocalBackend/LocalSmartPlaylist.vala"
			music_smart_query_get_value (_tmp18_, &_tmp19_);
#line 160 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp20_ = _tmp19_;
#line 160 "../src/LocalBackend/LocalSmartPlaylist.vala"
			if (G_VALUE_TYPE (&_tmp20_) == G_TYPE_STRING) {
#line 822 "LocalSmartPlaylist.c"
				GString* _tmp21_;
				MusicSmartQuery* _tmp22_;
				GValue _tmp23_ = {0};
				GValue _tmp24_;
				const gchar* _tmp25_;
#line 161 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp21_ = sb;
#line 161 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp22_ = q;
#line 161 "../src/LocalBackend/LocalSmartPlaylist.vala"
				music_smart_query_get_value (_tmp22_, &_tmp23_);
#line 161 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp24_ = _tmp23_;
#line 161 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp25_ = g_value_get_string (&_tmp24_);
#line 161 "../src/LocalBackend/LocalSmartPlaylist.vala"
				g_string_append (_tmp21_, _tmp25_);
#line 840 "LocalSmartPlaylist.c"
			} else {
				GString* _tmp26_;
				MusicSmartQuery* _tmp27_;
				GValue _tmp28_ = {0};
				GValue _tmp29_;
#line 163 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp26_ = sb;
#line 163 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp27_ = q;
#line 163 "../src/LocalBackend/LocalSmartPlaylist.vala"
				music_smart_query_get_value (_tmp27_, &_tmp28_);
#line 163 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp29_ = _tmp28_;
#line 163 "../src/LocalBackend/LocalSmartPlaylist.vala"
				g_string_append_printf (_tmp26_, "%d", g_value_get_int (&_tmp29_));
#line 856 "LocalSmartPlaylist.c"
			}
#line 151 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_g_object_unref0 (q);
#line 860 "LocalSmartPlaylist.c"
		}
#line 151 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (_q_it);
#line 864 "LocalSmartPlaylist.c"
	}
#line 167 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp30_ = sb;
#line 167 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp31_ = _tmp30_->str;
#line 167 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp32_ = g_strdup (_tmp31_);
#line 167 "../src/LocalBackend/LocalSmartPlaylist.vala"
	result = _tmp32_;
#line 167 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_string_free0 (sb);
#line 167 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return result;
#line 878 "LocalSmartPlaylist.c"
}

void
music_local_smart_playlist_queries_from_string (MusicLocalSmartPlaylist* self,
                                                const gchar* q)
{
	gchar** queries_in_string = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint queries_in_string_length1;
	gint _queries_in_string_size_;
	GeeTreeSet* new_queries = NULL;
	GeeTreeSet* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GeeTreeSet* _tmp32_;
#line 170 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_if_fail (q != NULL);
#line 171 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_ = g_strsplit (q, MUSIC_LOCAL_SMART_PLAYLIST_QUERY_SEPARATOR, 0);
#line 171 "../src/LocalBackend/LocalSmartPlaylist.vala"
	queries_in_string = _tmp1_;
#line 171 "../src/LocalBackend/LocalSmartPlaylist.vala"
	queries_in_string_length1 = _vala_array_length (_tmp0_);
#line 171 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_queries_in_string_size_ = queries_in_string_length1;
#line 172 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = gee_tree_set_new (MUSIC_TYPE_SMART_QUERY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 172 "../src/LocalBackend/LocalSmartPlaylist.vala"
	new_queries = _tmp2_;
#line 173 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = queries_in_string;
#line 173 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3__length1 = queries_in_string_length1;
#line 915 "LocalSmartPlaylist.c"
	{
		gchar** query_string_collection = NULL;
		gint query_string_collection_length1 = 0;
		gint _query_string_collection_size_ = 0;
		gint query_string_it = 0;
#line 173 "../src/LocalBackend/LocalSmartPlaylist.vala"
		query_string_collection = _tmp3_;
#line 173 "../src/LocalBackend/LocalSmartPlaylist.vala"
		query_string_collection_length1 = _tmp3__length1;
#line 173 "../src/LocalBackend/LocalSmartPlaylist.vala"
		for (query_string_it = 0; query_string_it < query_string_collection_length1; query_string_it = query_string_it + 1) {
#line 927 "LocalSmartPlaylist.c"
			gchar* _tmp4_;
			gchar* query_string = NULL;
#line 173 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp4_ = g_strdup (query_string_collection[query_string_it]);
#line 173 "../src/LocalBackend/LocalSmartPlaylist.vala"
			query_string = _tmp4_;
#line 934 "LocalSmartPlaylist.c"
			{
				const gchar* _tmp5_;
				gchar** pieces_of_query = NULL;
				const gchar* _tmp6_;
				gchar** _tmp7_;
				gchar** _tmp8_;
				gint pieces_of_query_length1;
				gint _pieces_of_query_size_;
				gint _tmp9_;
				MusicSmartQuery* sq = NULL;
				MusicSmartQuery* _tmp10_;
				MusicSmartQuery* _tmp11_;
				gchar** _tmp12_;
				gint _tmp12__length1;
				const gchar* _tmp13_;
				MusicSmartQuery* _tmp14_;
				gchar** _tmp15_;
				gint _tmp15__length1;
				const gchar* _tmp16_;
				MusicSmartQuery* _tmp17_;
				MusicSmartQueryFieldType _tmp18_;
				MusicSmartQueryFieldType _tmp19_;
				GeeTreeSet* _tmp30_;
				MusicSmartQuery* _tmp31_;
#line 174 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp5_ = query_string;
#line 174 "../src/LocalBackend/LocalSmartPlaylist.vala"
				if (g_strcmp0 (_tmp5_, "") == 0) {
#line 175 "../src/LocalBackend/LocalSmartPlaylist.vala"
					_g_free0 (query_string);
#line 175 "../src/LocalBackend/LocalSmartPlaylist.vala"
					continue;
#line 967 "LocalSmartPlaylist.c"
				}
#line 177 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp6_ = query_string;
#line 177 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, MUSIC_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR, 3);
#line 177 "../src/LocalBackend/LocalSmartPlaylist.vala"
				pieces_of_query = _tmp8_;
#line 177 "../src/LocalBackend/LocalSmartPlaylist.vala"
				pieces_of_query_length1 = _vala_array_length (_tmp7_);
#line 177 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_pieces_of_query_size_ = pieces_of_query_length1;
#line 178 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp9_ = 3;
#line 178 "../src/LocalBackend/LocalSmartPlaylist.vala"
				pieces_of_query = g_renew (gchar*, pieces_of_query, 3);
#line 178 "../src/LocalBackend/LocalSmartPlaylist.vala"
				(_tmp9_ > pieces_of_query_length1) ? memset (pieces_of_query + pieces_of_query_length1, 0, sizeof (gchar*) * (_tmp9_ - pieces_of_query_length1)) : NULL;
#line 178 "../src/LocalBackend/LocalSmartPlaylist.vala"
				pieces_of_query_length1 = _tmp9_;
#line 178 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_pieces_of_query_size_ = _tmp9_;
#line 180 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp10_ = music_smart_query_new ();
#line 180 "../src/LocalBackend/LocalSmartPlaylist.vala"
				sq = _tmp10_;
#line 181 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp11_ = sq;
#line 181 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp12_ = pieces_of_query;
#line 181 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp12__length1 = pieces_of_query_length1;
#line 181 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp13_ = _tmp12_[0];
#line 181 "../src/LocalBackend/LocalSmartPlaylist.vala"
				music_smart_query_set_field (_tmp11_, (MusicSmartQueryFieldType) atoi (_tmp13_));
#line 182 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp14_ = sq;
#line 182 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp15_ = pieces_of_query;
#line 182 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp15__length1 = pieces_of_query_length1;
#line 182 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp16_ = _tmp15_[1];
#line 182 "../src/LocalBackend/LocalSmartPlaylist.vala"
				music_smart_query_set_comparator (_tmp14_, (MusicSmartQueryComparatorType) atoi (_tmp16_));
#line 183 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp17_ = sq;
#line 183 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp18_ = music_smart_query_get_field (_tmp17_);
#line 183 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp19_ = _tmp18_;
#line 183 "../src/LocalBackend/LocalSmartPlaylist.vala"
				switch (_tmp19_) {
#line 183 "../src/LocalBackend/LocalSmartPlaylist.vala"
					case MUSIC_SMART_QUERY_FIELD_TYPE_ALBUM:
#line 183 "../src/LocalBackend/LocalSmartPlaylist.vala"
					case MUSIC_SMART_QUERY_FIELD_TYPE_ARTIST:
#line 183 "../src/LocalBackend/LocalSmartPlaylist.vala"
					case MUSIC_SMART_QUERY_FIELD_TYPE_COMPOSER:
#line 183 "../src/LocalBackend/LocalSmartPlaylist.vala"
					case MUSIC_SMART_QUERY_FIELD_TYPE_COMMENT:
#line 183 "../src/LocalBackend/LocalSmartPlaylist.vala"
					case MUSIC_SMART_QUERY_FIELD_TYPE_GENRE:
#line 183 "../src/LocalBackend/LocalSmartPlaylist.vala"
					case MUSIC_SMART_QUERY_FIELD_TYPE_GROUPING:
#line 183 "../src/LocalBackend/LocalSmartPlaylist.vala"
					case MUSIC_SMART_QUERY_FIELD_TYPE_TITLE:
#line 183 "../src/LocalBackend/LocalSmartPlaylist.vala"
					case MUSIC_SMART_QUERY_FIELD_TYPE_URI:
#line 1037 "LocalSmartPlaylist.c"
					{
						GValue val = {0};
						GValue _tmp20_ = {0};
						gchar** _tmp21_;
						gint _tmp21__length1;
						const gchar* _tmp22_;
						MusicSmartQuery* _tmp23_;
						GValue _tmp24_;
#line 192 "../src/LocalBackend/LocalSmartPlaylist.vala"
						g_value_init (&_tmp20_, G_TYPE_STRING);
#line 192 "../src/LocalBackend/LocalSmartPlaylist.vala"
						val = _tmp20_;
#line 193 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp21_ = pieces_of_query;
#line 193 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp21__length1 = pieces_of_query_length1;
#line 193 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp22_ = _tmp21_[2];
#line 193 "../src/LocalBackend/LocalSmartPlaylist.vala"
						g_value_set_string (&val, _tmp22_);
#line 194 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp23_ = sq;
#line 194 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp24_ = val;
#line 194 "../src/LocalBackend/LocalSmartPlaylist.vala"
						music_smart_query_set_value (_tmp23_, &_tmp24_);
#line 195 "../src/LocalBackend/LocalSmartPlaylist.vala"
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 195 "../src/LocalBackend/LocalSmartPlaylist.vala"
						break;
#line 1068 "LocalSmartPlaylist.c"
					}
					default:
					{
						GValue val = {0};
						GValue _tmp25_ = {0};
						gchar** _tmp26_;
						gint _tmp26__length1;
						const gchar* _tmp27_;
						MusicSmartQuery* _tmp28_;
						GValue _tmp29_;
#line 197 "../src/LocalBackend/LocalSmartPlaylist.vala"
						g_value_init (&_tmp25_, G_TYPE_INT);
#line 197 "../src/LocalBackend/LocalSmartPlaylist.vala"
						val = _tmp25_;
#line 198 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp26_ = pieces_of_query;
#line 198 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp26__length1 = pieces_of_query_length1;
#line 198 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp27_ = _tmp26_[2];
#line 198 "../src/LocalBackend/LocalSmartPlaylist.vala"
						g_value_set_int (&val, atoi (_tmp27_));
#line 199 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp28_ = sq;
#line 199 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp29_ = val;
#line 199 "../src/LocalBackend/LocalSmartPlaylist.vala"
						music_smart_query_set_value (_tmp28_, &_tmp29_);
#line 200 "../src/LocalBackend/LocalSmartPlaylist.vala"
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 200 "../src/LocalBackend/LocalSmartPlaylist.vala"
						break;
#line 1101 "LocalSmartPlaylist.c"
					}
				}
#line 203 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp30_ = new_queries;
#line 203 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp31_ = sq;
#line 203 "../src/LocalBackend/LocalSmartPlaylist.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
#line 173 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_g_object_unref0 (sq);
#line 173 "../src/LocalBackend/LocalSmartPlaylist.vala"
				pieces_of_query = (_vala_array_free (pieces_of_query, pieces_of_query_length1, (GDestroyNotify) g_free), NULL);
#line 173 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_g_free0 (query_string);
#line 1116 "LocalSmartPlaylist.c"
			}
		}
	}
#line 205 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp32_ = new_queries;
#line 205 "../src/LocalBackend/LocalSmartPlaylist.vala"
	music_smart_playlist_add_queries ((MusicSmartPlaylist*) self, (GeeCollection*) _tmp32_);
#line 170 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_object_unref0 (new_queries);
#line 170 "../src/LocalBackend/LocalSmartPlaylist.vala"
	queries_in_string = (_vala_array_free (queries_in_string, queries_in_string_length1, (GDestroyNotify) g_free), NULL);
#line 1128 "LocalSmartPlaylist.c"
}

static void
__vala_GValue_free0_ (gpointer var)
{
#line 223 "../src/LocalBackend/LocalSmartPlaylist.vala"
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
#line 1136 "LocalSmartPlaylist.c"
}

static inline void
_g_slist_free___vala_GValue_free0_ (GSList* self)
{
#line 223 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_slist_free_full (self, (GDestroyNotify) __vala_GValue_free0_);
#line 1144 "LocalSmartPlaylist.c"
}

static void
_g_free0_ (gpointer var)
{
#line 223 "../src/LocalBackend/LocalSmartPlaylist.vala"
	var = (g_free (var), NULL);
#line 1152 "LocalSmartPlaylist.c"
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 223 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 1160 "LocalSmartPlaylist.c"
}

void
music_local_smart_playlist_add_defaults (GdaConnection* connection)
{
	GError* _inner_error0_ = NULL;
#line 208 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_if_fail (connection != NULL);
#line 1169 "LocalSmartPlaylist.c"
	{
		GSList* col_names = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GSList* values = NULL;
		GValue* _tmp5_ = NULL;
		GValue* _tmp6_ = NULL;
		GValue* _tmp7_ = NULL;
		GValue* _tmp8_ = NULL;
		GValue* _tmp9_ = NULL;
		GSList* _tmp10_;
		GSList* _tmp11_;
		GValue* _tmp12_ = NULL;
		GValue* _tmp13_ = NULL;
		GValue* _tmp14_ = NULL;
		GValue* _tmp15_ = NULL;
		GValue* _tmp16_ = NULL;
		GSList* _tmp17_;
		GSList* _tmp18_;
		GValue* _tmp19_ = NULL;
		GValue* _tmp20_ = NULL;
		GValue* _tmp21_ = NULL;
		GValue* _tmp22_ = NULL;
		GValue* _tmp23_ = NULL;
		GSList* _tmp24_;
		GSList* _tmp25_;
		GValue* _tmp26_ = NULL;
		GValue* _tmp27_ = NULL;
		GValue* _tmp28_ = NULL;
		GValue* _tmp29_ = NULL;
		GValue* _tmp30_ = NULL;
		GSList* _tmp31_;
		GSList* _tmp32_;
		GValue* _tmp33_ = NULL;
		GValue* _tmp34_ = NULL;
		GValue* _tmp35_ = NULL;
		GValue* _tmp36_ = NULL;
		GValue* _tmp37_ = NULL;
		GSList* _tmp38_;
		GSList* _tmp39_;
		GValue* _tmp40_ = NULL;
		GValue* _tmp41_ = NULL;
		GValue* _tmp42_ = NULL;
		GValue* _tmp43_ = NULL;
		GValue* _tmp44_ = NULL;
		GSList* _tmp45_;
		GSList* _tmp46_;
#line 210 "../src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = NULL;
#line 211 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp0_ = g_strdup ("name");
#line 211 "../src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = g_slist_append (col_names, _tmp0_);
#line 212 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp1_ = g_strdup ("queries");
#line 212 "../src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = g_slist_append (col_names, _tmp1_);
#line 213 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp2_ = g_strdup ("and_or");
#line 213 "../src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = g_slist_append (col_names, _tmp2_);
#line 214 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp3_ = g_strdup ("limited");
#line 214 "../src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = g_slist_append (col_names, _tmp3_);
#line 215 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp4_ = g_strdup ("limit_amount");
#line 215 "../src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = g_slist_append (col_names, _tmp4_);
#line 217 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 218 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp5_ = g_new0 (GValue, 1);
#line 218 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp5_, G_TYPE_STRING);
#line 218 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp5_, _ ("Favorite Songs"));
#line 218 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp5_);
#line 219 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp6_ = g_new0 (GValue, 1);
#line 219 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp6_, G_TYPE_STRING);
#line 219 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp6_, "10<val_sep>2<val_sep>4<query_sep>12<val_sep>0<val_sep>0<query_sep>11<v" \
"al_sep>6<val_sep>3");
#line 219 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp6_);
#line 220 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp7_ = g_new0 (GValue, 1);
#line 220 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp7_, G_TYPE_INT);
#line 220 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp7_, 1);
#line 220 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp7_);
#line 221 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp8_ = g_new0 (GValue, 1);
#line 221 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp8_, G_TYPE_INT);
#line 221 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp8_, 1);
#line 221 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp8_);
#line 222 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp9_ = g_new0 (GValue, 1);
#line 222 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp9_, G_TYPE_INT);
#line 222 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp9_, 50);
#line 222 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp9_);
#line 223 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp10_ = col_names;
#line 223 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp11_ = values;
#line 223 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (connection, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp10_, _tmp11_, &_inner_error0_);
#line 223 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 223 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 223 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 1296 "LocalSmartPlaylist.c"
			goto __catch0_g_error;
		}
#line 225 "../src/LocalBackend/LocalSmartPlaylist.vala"
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 225 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 226 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp12_ = g_new0 (GValue, 1);
#line 226 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp12_, G_TYPE_STRING);
#line 226 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp12_, _ ("Recently Added"));
#line 226 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp12_);
#line 227 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp13_ = g_new0 (GValue, 1);
#line 227 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp13_, G_TYPE_STRING);
#line 227 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp13_, "5<val_sep>7<val_sep>7");
#line 227 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp13_);
#line 228 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp14_ = g_new0 (GValue, 1);
#line 228 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp14_, G_TYPE_INT);
#line 228 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp14_, 1);
#line 228 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp14_);
#line 229 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp15_ = g_new0 (GValue, 1);
#line 229 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp15_, G_TYPE_INT);
#line 229 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp15_, 1);
#line 229 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp15_);
#line 230 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp16_ = g_new0 (GValue, 1);
#line 230 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp16_, G_TYPE_INT);
#line 230 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp16_, 50);
#line 230 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp16_);
#line 231 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp17_ = col_names;
#line 231 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp18_ = values;
#line 231 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (connection, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp17_, _tmp18_, &_inner_error0_);
#line 231 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 231 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 231 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 1355 "LocalSmartPlaylist.c"
			goto __catch0_g_error;
		}
#line 233 "../src/LocalBackend/LocalSmartPlaylist.vala"
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 233 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 234 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp19_ = g_new0 (GValue, 1);
#line 234 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp19_, G_TYPE_STRING);
#line 234 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp19_, _ ("Recent Favorites"));
#line 234 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp19_);
#line 235 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp20_ = g_new0 (GValue, 1);
#line 235 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp20_, G_TYPE_STRING);
#line 235 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp20_, "10<val_sep>2<val_sep>4<query_sep>12<val_sep>0<val_sep>0<query_sep>8<va" \
"l_sep>7<val_sep>7");
#line 235 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp20_);
#line 236 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp21_ = g_new0 (GValue, 1);
#line 236 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp21_, G_TYPE_INT);
#line 236 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp21_, 1);
#line 236 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp21_);
#line 237 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp22_ = g_new0 (GValue, 1);
#line 237 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp22_, G_TYPE_INT);
#line 237 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp22_, 1);
#line 237 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp22_);
#line 238 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp23_ = g_new0 (GValue, 1);
#line 238 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp23_, G_TYPE_INT);
#line 238 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp23_, 50);
#line 238 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp23_);
#line 239 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp24_ = col_names;
#line 239 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp25_ = values;
#line 239 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (connection, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp24_, _tmp25_, &_inner_error0_);
#line 239 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 239 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 239 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 1414 "LocalSmartPlaylist.c"
			goto __catch0_g_error;
		}
#line 241 "../src/LocalBackend/LocalSmartPlaylist.vala"
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 241 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 242 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp26_ = g_new0 (GValue, 1);
#line 242 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp26_, G_TYPE_STRING);
#line 242 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp26_, _ ("Never Played"));
#line 242 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp26_);
#line 243 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp27_ = g_new0 (GValue, 1);
#line 243 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp27_, G_TYPE_STRING);
#line 243 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp27_, "10<val_sep>0<val_sep>0");
#line 243 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp27_);
#line 244 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp28_ = g_new0 (GValue, 1);
#line 244 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp28_, G_TYPE_INT);
#line 244 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp28_, 0);
#line 244 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp28_);
#line 245 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp29_ = g_new0 (GValue, 1);
#line 245 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp29_, G_TYPE_INT);
#line 245 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp29_, 1);
#line 245 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp29_);
#line 246 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp30_ = g_new0 (GValue, 1);
#line 246 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp30_, G_TYPE_INT);
#line 246 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp30_, 50);
#line 246 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp30_);
#line 247 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp31_ = col_names;
#line 247 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp32_ = values;
#line 247 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (connection, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp31_, _tmp32_, &_inner_error0_);
#line 247 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 247 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 247 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 1473 "LocalSmartPlaylist.c"
			goto __catch0_g_error;
		}
#line 249 "../src/LocalBackend/LocalSmartPlaylist.vala"
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 249 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 250 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp33_ = g_new0 (GValue, 1);
#line 250 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp33_, G_TYPE_STRING);
#line 250 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp33_, _ ("Over Played"));
#line 250 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp33_);
#line 251 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp34_ = g_new0 (GValue, 1);
#line 251 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp34_, G_TYPE_STRING);
#line 251 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp34_, "10<val_sep>6<val_sep>10");
#line 251 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp34_);
#line 252 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp35_ = g_new0 (GValue, 1);
#line 252 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp35_, G_TYPE_INT);
#line 252 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp35_, 1);
#line 252 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp35_);
#line 253 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp36_ = g_new0 (GValue, 1);
#line 253 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp36_, G_TYPE_INT);
#line 253 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp36_, 1);
#line 253 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp36_);
#line 254 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp37_ = g_new0 (GValue, 1);
#line 254 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp37_, G_TYPE_INT);
#line 254 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp37_, 50);
#line 254 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp37_);
#line 255 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp38_ = col_names;
#line 255 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp39_ = values;
#line 255 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (connection, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp38_, _tmp39_, &_inner_error0_);
#line 255 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 255 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 255 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 1532 "LocalSmartPlaylist.c"
			goto __catch0_g_error;
		}
#line 257 "../src/LocalBackend/LocalSmartPlaylist.vala"
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 257 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 258 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp40_ = g_new0 (GValue, 1);
#line 258 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp40_, G_TYPE_STRING);
#line 258 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp40_, _ ("Not Recently Played"));
#line 258 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp40_);
#line 259 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp41_ = g_new0 (GValue, 1);
#line 259 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp41_, G_TYPE_STRING);
#line 259 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp41_, "8<val_sep>8<val_sep>7");
#line 259 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp41_);
#line 260 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp42_ = g_new0 (GValue, 1);
#line 260 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp42_, G_TYPE_INT);
#line 260 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp42_, 1);
#line 260 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp42_);
#line 261 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp43_ = g_new0 (GValue, 1);
#line 261 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp43_, G_TYPE_INT);
#line 261 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp43_, 1);
#line 261 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp43_);
#line 262 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp44_ = g_new0 (GValue, 1);
#line 262 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp44_, G_TYPE_INT);
#line 262 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp44_, 50);
#line 262 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp44_);
#line 263 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp45_ = col_names;
#line 263 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp46_ = values;
#line 263 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (connection, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp45_, _tmp46_, &_inner_error0_);
#line 263 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 263 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 263 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 1591 "LocalSmartPlaylist.c"
			goto __catch0_g_error;
		}
#line 209 "../src/LocalBackend/LocalSmartPlaylist.vala"
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 209 "../src/LocalBackend/LocalSmartPlaylist.vala"
		(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 1598 "LocalSmartPlaylist.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp47_;
		const gchar* _tmp48_;
#line 209 "../src/LocalBackend/LocalSmartPlaylist.vala"
		e = _inner_error0_;
#line 209 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_inner_error0_ = NULL;
#line 265 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp47_ = e;
#line 265 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp48_ = _tmp47_->message;
#line 265 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_critical ("LocalSmartPlaylist.vala:265: Could not initialize smart playlists: %s", _tmp48_);
#line 209 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_error_free0 (e);
#line 1618 "LocalSmartPlaylist.c"
	}
	__finally0:
#line 209 "../src/LocalBackend/LocalSmartPlaylist.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 209 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 209 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_clear_error (&_inner_error0_);
#line 209 "../src/LocalBackend/LocalSmartPlaylist.vala"
		return;
#line 1629 "LocalSmartPlaylist.c"
	}
}

static const gchar*
music_local_smart_playlist_real_get_name (MusicPlaylist* base)
{
	const gchar* result;
	MusicLocalSmartPlaylist* self;
	const gchar* _tmp0_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	GValue* _tmp5_;
	GValue* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
#line 39 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (MusicLocalSmartPlaylist*) base;
#line 40 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = self->priv->_name;
#line 40 "../src/LocalBackend/LocalSmartPlaylist.vala"
	if (_tmp0_ != NULL) {
#line 1652 "LocalSmartPlaylist.c"
		const gchar* _tmp1_;
#line 41 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp1_ = self->priv->_name;
#line 41 "../src/LocalBackend/LocalSmartPlaylist.vala"
		result = _tmp1_;
#line 41 "../src/LocalBackend/LocalSmartPlaylist.vala"
		return result;
#line 1660 "LocalSmartPlaylist.c"
	}
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = music_playlist_get_rowid ((MusicPlaylist*) self);
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = _tmp2_;
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4_ = self->priv->connection;
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp5_ = music_database_query_field (_tmp3_, _tmp4_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "name");
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp6_ = _tmp5_;
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp7_ = g_value_dup_string (_tmp6_);
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_free0 (self->priv->_name);
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self->priv->_name = _tmp7_;
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	__vala_GValue_free0 (_tmp6_);
#line 44 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp8_ = self->priv->_name;
#line 44 "../src/LocalBackend/LocalSmartPlaylist.vala"
	result = _tmp8_;
#line 44 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return result;
#line 1686 "LocalSmartPlaylist.c"
}

static void
music_local_smart_playlist_real_set_name (MusicPlaylist* base,
                                          const gchar* value)
{
	MusicLocalSmartPlaylist* self;
	gchar* _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	GdaConnection* _tmp3_;
	GValue _tmp4_ = {0};
#line 47 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (MusicLocalSmartPlaylist*) base;
#line 48 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = g_strdup (value);
#line 48 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_free0 (self->priv->_name);
#line 48 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self->priv->_name = _tmp0_;
#line 49 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = music_playlist_get_rowid ((MusicPlaylist*) self);
#line 49 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = _tmp1_;
#line 49 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = self->priv->connection;
#line 49 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp4_, G_TYPE_STRING);
#line 49 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_set_string (&_tmp4_, value);
#line 49 "../src/LocalBackend/LocalSmartPlaylist.vala"
	music_database_set_field (_tmp2_, _tmp3_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "name", &_tmp4_);
#line 49 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
#line 47 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_notify_by_pspec ((GObject *) self, music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_NAME_PROPERTY]);
#line 1723 "LocalSmartPlaylist.c"
}

static MusicSmartPlaylistConditionalType
music_local_smart_playlist_real_get_conditional (MusicSmartPlaylist* base)
{
	MusicSmartPlaylistConditionalType result;
	MusicLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	GValue* _tmp4_;
	MusicSmartPlaylistConditionalType _tmp5_;
#line 55 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (MusicLocalSmartPlaylist*) base;
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = music_database_query_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "and_or");
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4_ = _tmp3_;
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp5_ = (MusicSmartPlaylistConditionalType) g_value_get_int (_tmp4_);
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	__vala_GValue_free0 (_tmp4_);
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	result = _tmp5_;
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return result;
#line 1757 "LocalSmartPlaylist.c"
}

static void
music_local_smart_playlist_real_set_conditional (MusicSmartPlaylist* base,
                                                 MusicSmartPlaylistConditionalType value)
{
	MusicLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue _tmp3_ = {0};
#line 58 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (MusicLocalSmartPlaylist*) base;
#line 59 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
#line 59 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 59 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 59 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp3_, MUSIC_SMART_PLAYLIST_TYPE_CONDITIONAL_TYPE);
#line 59 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_set_enum (&_tmp3_, value);
#line 59 "../src/LocalBackend/LocalSmartPlaylist.vala"
	music_database_set_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "and_or", &_tmp3_);
#line 59 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
#line 58 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_notify_by_pspec ((GObject *) self, music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY]);
#line 1787 "LocalSmartPlaylist.c"
}

static guint
music_local_smart_playlist_real_get_limit_amount (MusicSmartPlaylist* base)
{
	guint result;
	MusicLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	GValue* _tmp4_;
	guint _tmp5_;
#line 64 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (MusicLocalSmartPlaylist*) base;
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = music_database_query_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limit_amount");
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4_ = _tmp3_;
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp5_ = (guint) g_value_get_int (_tmp4_);
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	__vala_GValue_free0 (_tmp4_);
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	result = _tmp5_;
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return result;
#line 1821 "LocalSmartPlaylist.c"
}

static void
music_local_smart_playlist_real_set_limit_amount (MusicSmartPlaylist* base,
                                                  guint value)
{
	MusicLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue _tmp3_ = {0};
#line 67 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (MusicLocalSmartPlaylist*) base;
#line 68 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
#line 68 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 68 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 68 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp3_, G_TYPE_UINT);
#line 68 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_set_uint (&_tmp3_, value);
#line 68 "../src/LocalBackend/LocalSmartPlaylist.vala"
	music_database_set_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limit_amount", &_tmp3_);
#line 68 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
#line 67 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_notify_by_pspec ((GObject *) self, music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY]);
#line 1851 "LocalSmartPlaylist.c"
}

static gboolean
music_local_smart_playlist_real_get_limit (MusicSmartPlaylist* base)
{
	gboolean result;
	MusicLocalSmartPlaylist* self;
	GValue* val = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
#line 73 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (MusicLocalSmartPlaylist*) base;
#line 74 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
#line 74 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 74 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 74 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = music_database_query_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limited");
#line 74 "../src/LocalBackend/LocalSmartPlaylist.vala"
	val = _tmp3_;
#line 75 "../src/LocalBackend/LocalSmartPlaylist.vala"
	result = (gboolean) g_value_get_int (val);
#line 75 "../src/LocalBackend/LocalSmartPlaylist.vala"
	__vala_GValue_free0 (val);
#line 75 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return result;
#line 1882 "LocalSmartPlaylist.c"
}

static void
music_local_smart_playlist_real_set_limit (MusicSmartPlaylist* base,
                                           gboolean value)
{
	MusicLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue _tmp3_ = {0};
#line 77 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (MusicLocalSmartPlaylist*) base;
#line 78 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
#line 78 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 78 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 78 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp3_, G_TYPE_BOOLEAN);
#line 78 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_set_boolean (&_tmp3_, value);
#line 78 "../src/LocalBackend/LocalSmartPlaylist.vala"
	music_database_set_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limited", &_tmp3_);
#line 78 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
#line 77 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_notify_by_pspec ((GObject *) self, music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY]);
#line 1912 "LocalSmartPlaylist.c"
}

static void
music_local_smart_playlist_class_init (MusicLocalSmartPlaylistClass * klass,
                                       gpointer klass_data)
{
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	music_local_smart_playlist_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_type_class_adjust_private_offset (klass, &MusicLocalSmartPlaylist_private_offset);
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	((MusicSmartPlaylistClass *) klass)->analyse_all = (void (*) (MusicSmartPlaylist*)) music_local_smart_playlist_real_analyse_all;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	((MusicSmartPlaylistClass *) klass)->clear_queries = (void (*) (MusicSmartPlaylist*)) music_local_smart_playlist_real_clear_queries;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	((MusicSmartPlaylistClass *) klass)->add_query = (void (*) (MusicSmartPlaylist*, MusicSmartQuery*)) music_local_smart_playlist_real_add_query;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	((MusicSmartPlaylistClass *) klass)->add_queries = (void (*) (MusicSmartPlaylist*, GeeCollection*)) music_local_smart_playlist_real_add_queries;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	MUSIC_PLAYLIST_CLASS (klass)->get_name = music_local_smart_playlist_real_get_name;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	MUSIC_PLAYLIST_CLASS (klass)->set_name = music_local_smart_playlist_real_set_name;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	MUSIC_SMART_PLAYLIST_CLASS (klass)->get_conditional = music_local_smart_playlist_real_get_conditional;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	MUSIC_SMART_PLAYLIST_CLASS (klass)->set_conditional = music_local_smart_playlist_real_set_conditional;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	MUSIC_SMART_PLAYLIST_CLASS (klass)->get_limit_amount = music_local_smart_playlist_real_get_limit_amount;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	MUSIC_SMART_PLAYLIST_CLASS (klass)->set_limit_amount = music_local_smart_playlist_real_set_limit_amount;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	MUSIC_SMART_PLAYLIST_CLASS (klass)->get_limit = music_local_smart_playlist_real_get_limit;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	MUSIC_SMART_PLAYLIST_CLASS (klass)->set_limit = music_local_smart_playlist_real_set_limit;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_local_smart_playlist_get_property;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_local_smart_playlist_set_property;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_OBJECT_CLASS (klass)->finalize = music_local_smart_playlist_finalize;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_SMART_PLAYLIST_NAME_PROPERTY, music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY, music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY] = g_param_spec_enum ("conditional", "conditional", "conditional", MUSIC_SMART_PLAYLIST_TYPE_CONDITIONAL_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY, music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY] = g_param_spec_uint ("limit-amount", "limit-amount", "limit-amount", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY, music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY] = g_param_spec_boolean ("limit", "limit", "limit", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1961 "LocalSmartPlaylist.c"
}

static void
music_local_smart_playlist_instance_init (MusicLocalSmartPlaylist * self,
                                          gpointer klass)
{
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self->priv = music_local_smart_playlist_get_instance_private (self);
#line 37 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self->priv->_name = NULL;
#line 1972 "LocalSmartPlaylist.c"
}

static void
music_local_smart_playlist_finalize (GObject * obj)
{
	MusicLocalSmartPlaylist * self;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylist);
#line 32 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_object_unref0 (self->priv->connection);
#line 37 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_free0 (self->priv->_name);
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_OBJECT_CLASS (music_local_smart_playlist_parent_class)->finalize (obj);
#line 1987 "LocalSmartPlaylist.c"
}

static GType
music_local_smart_playlist_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicLocalSmartPlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_local_smart_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicLocalSmartPlaylist), 0, (GInstanceInitFunc) music_local_smart_playlist_instance_init, NULL };
	GType music_local_smart_playlist_type_id;
	music_local_smart_playlist_type_id = g_type_register_static (MUSIC_TYPE_SMART_PLAYLIST, "MusicLocalSmartPlaylist", &g_define_type_info, 0);
	MusicLocalSmartPlaylist_private_offset = g_type_add_instance_private (music_local_smart_playlist_type_id, sizeof (MusicLocalSmartPlaylistPrivate));
	return music_local_smart_playlist_type_id;
}

GType
music_local_smart_playlist_get_type (void)
{
	static volatile gsize music_local_smart_playlist_type_id__once = 0;
	if (g_once_init_enter (&music_local_smart_playlist_type_id__once)) {
		GType music_local_smart_playlist_type_id;
		music_local_smart_playlist_type_id = music_local_smart_playlist_get_type_once ();
		g_once_init_leave (&music_local_smart_playlist_type_id__once, music_local_smart_playlist_type_id);
	}
	return music_local_smart_playlist_type_id__once;
}

static void
_vala_music_local_smart_playlist_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	MusicLocalSmartPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylist);
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	switch (property_id) {
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		case MUSIC_LOCAL_SMART_PLAYLIST_NAME_PROPERTY:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (value, music_playlist_get_name ((MusicPlaylist*) self));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		case MUSIC_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_enum (value, music_smart_playlist_get_conditional ((MusicSmartPlaylist*) self));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		case MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_uint (value, music_smart_playlist_get_limit_amount ((MusicSmartPlaylist*) self));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		case MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_boolean (value, music_smart_playlist_get_limit ((MusicSmartPlaylist*) self));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 2046 "LocalSmartPlaylist.c"
		default:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 2052 "LocalSmartPlaylist.c"
	}
}

static void
_vala_music_local_smart_playlist_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	MusicLocalSmartPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylist);
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	switch (property_id) {
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		case MUSIC_LOCAL_SMART_PLAYLIST_NAME_PROPERTY:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		music_playlist_set_name ((MusicPlaylist*) self, g_value_get_string (value));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		case MUSIC_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		music_smart_playlist_set_conditional ((MusicSmartPlaylist*) self, g_value_get_enum (value));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		case MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		music_smart_playlist_set_limit_amount ((MusicSmartPlaylist*) self, g_value_get_uint (value));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		case MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		music_smart_playlist_set_limit ((MusicSmartPlaylist*) self, g_value_get_boolean (value));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 2090 "LocalSmartPlaylist.c"
		default:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 2096 "LocalSmartPlaylist.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

