/* BrowserColumnModel.c generated by valac 0.56.0, the Vala compiler
 * generated from BrowserColumnModel.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <stdarg.h>
#include "io.elementary.music-core.h"

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_BROWSER_COLUMN_MODEL (music_browser_column_model_get_type ())
#define MUSIC_BROWSER_COLUMN_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_BROWSER_COLUMN_MODEL, MusicBrowserColumnModel))
#define MUSIC_BROWSER_COLUMN_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_BROWSER_COLUMN_MODEL, MusicBrowserColumnModelClass))
#define MUSIC_IS_BROWSER_COLUMN_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_BROWSER_COLUMN_MODEL))
#define MUSIC_IS_BROWSER_COLUMN_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_BROWSER_COLUMN_MODEL))
#define MUSIC_BROWSER_COLUMN_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_BROWSER_COLUMN_MODEL, MusicBrowserColumnModelClass))

typedef struct _MusicBrowserColumnModel MusicBrowserColumnModel;
typedef struct _MusicBrowserColumnModelClass MusicBrowserColumnModelClass;
typedef struct _MusicBrowserColumnModelPrivate MusicBrowserColumnModelPrivate;
typedef enum  {
	MUSIC_BROWSER_COLUMN_CATEGORY_RATING,
	MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING,
	MUSIC_BROWSER_COLUMN_CATEGORY_YEAR,
	MUSIC_BROWSER_COLUMN_CATEGORY_GENRE,
	MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER,
	MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST,
	MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM,
	MUSIC_BROWSER_COLUMN_CATEGORY_N_CATEGORIES
} MusicBrowserColumnCategory;

#define MUSIC_BROWSER_COLUMN_TYPE_CATEGORY (music_browser_column_category_get_type ())
enum  {
	MUSIC_BROWSER_COLUMN_MODEL_0_PROPERTY,
	MUSIC_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY,
	MUSIC_BROWSER_COLUMN_MODEL_NUM_PROPERTIES
};
static GParamSpec* music_browser_column_model_properties[MUSIC_BROWSER_COLUMN_MODEL_NUM_PROPERTIES];
#define _g_sequence_free0(var) ((var == NULL) ? NULL : (var = (g_sequence_free (var), NULL)))
#define __vala_GtkTreeIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeIter_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MusicBrowserColumnModel {
	GObject parent_instance;
	MusicBrowserColumnModelPrivate * priv;
};

struct _MusicBrowserColumnModelClass {
	GObjectClass parent_class;
};

struct _MusicBrowserColumnModelPrivate {
	gint stamp;
	GSequence* rows;
	GtkTreeIter* first_iter;
	gint sort_column_id;
	GtkSortType sort_direction;
	GtkTreeIterCompareFunc default_sort_func;
	gpointer default_sort_func_target;
	MusicBrowserColumnCategory category;
};

static gint MusicBrowserColumnModel_private_offset;
static gpointer music_browser_column_model_parent_class = NULL;
static GtkTreeModelIface * music_browser_column_model_gtk_tree_model_parent_iface = NULL;
static GtkTreeSortableIface * music_browser_column_model_gtk_tree_sortable_parent_iface = NULL;

VALA_EXTERN GType music_browser_column_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicBrowserColumnModel, g_object_unref)
VALA_EXTERN GType music_browser_column_category_get_type (void) G_GNUC_CONST ;
static void _vala_GtkTreeIter_free (GtkTreeIter* self);
VALA_EXTERN MusicBrowserColumnModel* music_browser_column_model_new (MusicBrowserColumnCategory category);
VALA_EXTERN MusicBrowserColumnModel* music_browser_column_model_construct (GType object_type,
                                                               MusicBrowserColumnCategory category);
static void _g_free0_ (gpointer var);
static GtkTreeModelFlags music_browser_column_model_real_get_flags (GtkTreeModel* base);
static gboolean music_browser_column_model_real_get_iter (GtkTreeModel* base,
                                                   GtkTreeIter* iter,
                                                   GtkTreePath* path);
static gint music_browser_column_model_real_get_n_columns (GtkTreeModel* base);
static GType music_browser_column_model_real_get_column_type (GtkTreeModel* base,
                                                       gint col);
static GtkTreePath* music_browser_column_model_real_get_path (GtkTreeModel* base,
                                                       GtkTreeIter* iter);
static void music_browser_column_model_real_get_value (GtkTreeModel* base,
                                                GtkTreeIter* iter,
                                                gint column,
                                                GValue* val);
static gboolean music_browser_column_model_real_iter_children (GtkTreeModel* base,
                                                        GtkTreeIter* iter,
                                                        GtkTreeIter* parent);
static gboolean music_browser_column_model_real_iter_has_child (GtkTreeModel* base,
                                                         GtkTreeIter* iter);
static gint music_browser_column_model_real_iter_n_children (GtkTreeModel* base,
                                                      GtkTreeIter* iter);
static gboolean music_browser_column_model_real_iter_next (GtkTreeModel* base,
                                                    GtkTreeIter* iter);
static gboolean music_browser_column_model_real_iter_nth_child (GtkTreeModel* base,
                                                         GtkTreeIter* iter,
                                                         GtkTreeIter* parent,
                                                         gint n);
static gboolean music_browser_column_model_real_iter_parent (GtkTreeModel* base,
                                                      GtkTreeIter* iter,
                                                      GtkTreeIter* child);
static void music_browser_column_model_real_ref_node (GtkTreeModel* base,
                                               GtkTreeIter* iter);
static void music_browser_column_model_real_unref_node (GtkTreeModel* base,
                                                 GtkTreeIter* iter);
VALA_EXTERN void music_browser_column_model_append (MusicBrowserColumnModel* self,
                                        GtkTreeIter* iter);
VALA_EXTERN void music_browser_column_model_append_items (MusicBrowserColumnModel* self,
                                              GeeCollection* strings,
                                              gboolean emit);
static void music_browser_column_model_add_first_element (MusicBrowserColumnModel* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void music_browser_column_model_update_first_item (MusicBrowserColumnModel* self);
static GtkTreeIter* _vala_GtkTreeIter_copy (GtkTreeIter* self);
static gchar* music_browser_column_model_get_first_item_text (MusicBrowserColumnModel* self,
                                                       gint n_items);
VALA_EXTERN gint music_browser_column_model_get_n_items (MusicBrowserColumnModel* self);
VALA_EXTERN void music_browser_column_model_set (MusicBrowserColumnModel* self,
                                     GtkTreeIter* iter,
                                     ...);
VALA_EXTERN void music_browser_column_model_remove (MusicBrowserColumnModel* self,
                                        GtkTreeIter* iter);
static gboolean music_browser_column_model_real_get_sort_column_id (GtkTreeSortable* base,
                                                             gint* sort_column_id,
                                                             GtkSortType* order);
static gboolean music_browser_column_model_real_has_default_sort_func (GtkTreeSortable* base);
static void music_browser_column_model_real_set_default_sort_func (GtkTreeSortable* base,
                                                            GtkTreeIterCompareFunc sort_func,
                                                            gpointer sort_func_target,
                                                            GDestroyNotify sort_func_target_destroy_notify);
static void music_browser_column_model_real_set_sort_column_id (GtkTreeSortable* base,
                                                         gint sort_column_id,
                                                         GtkSortType order);
VALA_EXTERN gint music_browser_column_model_sequence_iter_compare_func (MusicBrowserColumnModel* self,
                                                            GSequenceIter* a,
                                                            GSequenceIter* b);
static gint _music_browser_column_model_sequence_iter_compare_func_gsequence_iter_compare_func (GSequenceIter* a,
                                                                                         GSequenceIter* b,
                                                                                         gpointer self);
static void music_browser_column_model_real_set_sort_func (GtkTreeSortable* base,
                                                    gint sort_column_id,
                                                    GtkTreeIterCompareFunc sort_func,
                                                    gpointer sort_func_target,
                                                    GDestroyNotify sort_func_target_destroy_notify);
static void music_browser_column_model_finalize (GObject * obj);
static GType music_browser_column_model_get_type_once (void);
static void _vala_music_browser_column_model_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);

static inline gpointer
music_browser_column_model_get_instance_private (MusicBrowserColumnModel* self)
{
	return G_STRUCT_MEMBER_P (self, MusicBrowserColumnModel_private_offset);
}

static void
_vala_GtkTreeIter_free (GtkTreeIter* self)
{
#line 40 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_boxed_free (gtk_tree_iter_get_type (), self);
#line 211 "BrowserColumnModel.c"
}

/** Initialize data storage, columns, etc. **/
static void
_g_free0_ (gpointer var)
{
#line 51 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	var = (g_free (var), NULL);
#line 220 "BrowserColumnModel.c"
}

MusicBrowserColumnModel*
music_browser_column_model_construct (GType object_type,
                                      MusicBrowserColumnCategory category)
{
	MusicBrowserColumnModel * self = NULL;
	GSequence* _tmp0_;
#line 50 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) g_object_new (object_type, NULL);
#line 51 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = g_sequence_new (_g_free0_);
#line 51 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_g_sequence_free0 (self->priv->rows);
#line 51 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->rows = _tmp0_;
#line 53 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->category = category;
#line 55 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->sort_column_id = -2;
#line 56 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->sort_direction = GTK_SORT_ASCENDING;
#line 50 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return self;
#line 245 "BrowserColumnModel.c"
}

MusicBrowserColumnModel*
music_browser_column_model_new (MusicBrowserColumnCategory category)
{
#line 50 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return music_browser_column_model_construct (MUSIC_TYPE_BROWSER_COLUMN_MODEL, category);
#line 253 "BrowserColumnModel.c"
}

/** Returns a set of flags supported by this interface **/
static GtkTreeModelFlags
music_browser_column_model_real_get_flags (GtkTreeModel* base)
{
	MusicBrowserColumnModel * self;
	GtkTreeModelFlags result;
#line 60 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 61 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = GTK_TREE_MODEL_LIST_ONLY;
#line 61 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 268 "BrowserColumnModel.c"
}

/** Sets iter to a valid iterator pointing to path **/
static gboolean
music_browser_column_model_real_get_iter (GtkTreeModel* base,
                                          GtkTreeIter* iter,
                                          GtkTreePath* path)
{
	MusicBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gint path_index = 0;
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GSequence* _tmp5_;
	GSequenceIter* seq_iter = NULL;
	GSequence* _tmp7_;
	GSequenceIter* _tmp8_;
	GSequenceIter* _tmp9_;
	GSequenceIter* _tmp10_;
	gboolean result;
#line 65 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 65 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 66 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 67 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = gtk_tree_path_get_indices_with_depth (path, &_tmp0_);
#line 67 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = _tmp1_[0];
#line 67 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	path_index = _tmp2_;
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = self->priv->rows;
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (g_sequence_get_length (_tmp5_) == 0) {
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp4_ = TRUE;
#line 310 "BrowserColumnModel.c"
	} else {
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp4_ = path_index < 0;
#line 314 "BrowserColumnModel.c"
	}
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp4_) {
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp3_ = TRUE;
#line 320 "BrowserColumnModel.c"
	} else {
		GSequence* _tmp6_;
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp6_ = self->priv->rows;
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp3_ = path_index >= g_sequence_get_length (_tmp6_);
#line 327 "BrowserColumnModel.c"
	}
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp3_) {
#line 70 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = FALSE;
#line 70 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (iter) {
#line 70 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			*iter = _vala_iter;
#line 337 "BrowserColumnModel.c"
		}
#line 70 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 341 "BrowserColumnModel.c"
	}
#line 72 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp7_ = self->priv->rows;
#line 72 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp8_ = g_sequence_get_iter_at_pos (_tmp7_, path_index);
#line 72 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	seq_iter = _tmp8_;
#line 73 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp9_ = seq_iter;
#line 73 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp9_ == NULL) {
#line 74 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = FALSE;
#line 74 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (iter) {
#line 74 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			*iter = _vala_iter;
#line 359 "BrowserColumnModel.c"
		}
#line 74 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 363 "BrowserColumnModel.c"
	}
#line 76 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.stamp = self->priv->stamp;
#line 77 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp10_ = seq_iter;
#line 77 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.user_data = _tmp10_;
#line 79 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = TRUE;
#line 79 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (iter) {
#line 79 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*iter = _vala_iter;
#line 377 "BrowserColumnModel.c"
	}
#line 79 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 381 "BrowserColumnModel.c"
}

/** Returns the number of columns supported by tree_model. **/
static gint
music_browser_column_model_real_get_n_columns (GtkTreeModel* base)
{
	MusicBrowserColumnModel * self;
	gint result;
#line 83 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 84 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = 1;
#line 84 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 396 "BrowserColumnModel.c"
}

static GType
music_browser_column_model_real_get_column_type (GtkTreeModel* base,
                                                 gint col)
{
	MusicBrowserColumnModel * self;
	GType result;
#line 87 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 88 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = G_TYPE_STRING;
#line 88 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 411 "BrowserColumnModel.c"
}

/** Returns a newly-created Gtk.TreePath referenced by iter. **/
static GtkTreePath*
music_browser_column_model_real_get_path (GtkTreeModel* base,
                                          GtkTreeIter* iter)
{
	MusicBrowserColumnModel * self;
	GtkTreeIter _tmp0_;
	void* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkTreePath* _tmp4_;
	GtkTreePath* _tmp5_;
	GtkTreePath* result;
#line 92 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 92 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (iter != NULL, NULL);
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = *iter;
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = _tmp0_.user_data;
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = g_strdup_printf ("%i", g_sequence_iter_get_position ((GSequenceIter*) _tmp1_));
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = _tmp2_;
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = gtk_tree_path_new_from_string (_tmp3_);
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = _tmp4_;
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_g_free0 (_tmp3_);
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = _tmp5_;
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 449 "BrowserColumnModel.c"
}

/** Initializes and sets value to that at column. **/
static void
music_browser_column_model_real_get_value (GtkTreeModel* base,
                                           GtkTreeIter* iter,
                                           gint column,
                                           GValue* val)
{
	MusicBrowserColumnModel * self;
	GValue _vala_val = {0};
	GValue _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GtkTreeIter _tmp3_;
	GtkTreeIter _tmp4_;
	void* _tmp5_;
#line 97 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 97 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (iter != NULL);
#line 98 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_value_init (&_tmp0_, G_TYPE_STRING);
#line 98 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 98 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_val = _tmp0_;
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = *iter;
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp3_.stamp != self->priv->stamp) {
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp2_ = TRUE;
#line 483 "BrowserColumnModel.c"
	} else {
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp2_ = column < 0;
#line 487 "BrowserColumnModel.c"
	}
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp2_) {
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp1_ = TRUE;
#line 493 "BrowserColumnModel.c"
	} else {
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp1_ = column >= 1;
#line 497 "BrowserColumnModel.c"
	}
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp1_) {
#line 100 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (val) {
#line 100 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			*val = _vala_val;
#line 505 "BrowserColumnModel.c"
		} else {
#line 100 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 509 "BrowserColumnModel.c"
		}
#line 100 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return;
#line 513 "BrowserColumnModel.c"
	}
#line 102 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = *iter;
#line 102 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = _tmp4_.user_data;
#line 102 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (!g_sequence_iter_is_end ((GSequenceIter*) _tmp5_)) {
#line 521 "BrowserColumnModel.c"
		GtkTreeIter _tmp6_;
		void* _tmp7_;
		gconstpointer _tmp8_;
		GValue _tmp9_ = {0};
#line 103 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp6_ = *iter;
#line 103 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp7_ = _tmp6_.user_data;
#line 103 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp8_ = g_sequence_get ((GSequenceIter*) _tmp7_);
#line 103 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		g_value_init (&_tmp9_, G_TYPE_STRING);
#line 103 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		g_value_set_string (&_tmp9_, (const gchar*) _tmp8_);
#line 103 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 103 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_vala_val = _tmp9_;
#line 540 "BrowserColumnModel.c"
	}
#line 97 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (val) {
#line 97 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*val = _vala_val;
#line 546 "BrowserColumnModel.c"
	} else {
#line 97 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 550 "BrowserColumnModel.c"
	}
}

/** Sets iter to point to the first child of parent. **/
static gboolean
music_browser_column_model_real_iter_children (GtkTreeModel* base,
                                               GtkTreeIter* iter,
                                               GtkTreeIter* parent)
{
	MusicBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result;
#line 108 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 109 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 111 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = FALSE;
#line 111 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (iter) {
#line 111 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*iter = _vala_iter;
#line 573 "BrowserColumnModel.c"
	}
#line 111 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 577 "BrowserColumnModel.c"
}

/** Returns true if iter has children, false otherwise. **/
static gboolean
music_browser_column_model_real_iter_has_child (GtkTreeModel* base,
                                                GtkTreeIter* iter)
{
	MusicBrowserColumnModel * self;
	gboolean result;
#line 115 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 115 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 117 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = FALSE;
#line 117 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 595 "BrowserColumnModel.c"
}

/** Returns the number of children that iter has. **/
static gint
music_browser_column_model_real_iter_n_children (GtkTreeModel* base,
                                                 GtkTreeIter* iter)
{
	MusicBrowserColumnModel * self;
	gint result;
#line 121 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 122 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (iter == NULL) {
#line 609 "BrowserColumnModel.c"
		GSequence* _tmp0_;
#line 123 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp0_ = self->priv->rows;
#line 123 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = g_sequence_get_length (_tmp0_);
#line 123 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 617 "BrowserColumnModel.c"
	}
#line 125 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = 0;
#line 125 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 623 "BrowserColumnModel.c"
}

/** Sets iter to point to the node following it at the current level. **/
static gboolean
music_browser_column_model_real_iter_next (GtkTreeModel* base,
                                           GtkTreeIter* iter)
{
	MusicBrowserColumnModel * self;
	GtkTreeIter _tmp0_;
	GtkTreeIter _tmp1_;
	void* _tmp2_;
	GSequenceIter* _tmp3_;
	GtkTreeIter _tmp4_;
	void* _tmp5_;
	gboolean result;
#line 129 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 129 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 130 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = *iter;
#line 130 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp0_.stamp != self->priv->stamp) {
#line 131 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = FALSE;
#line 131 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 651 "BrowserColumnModel.c"
	}
#line 133 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = *iter;
#line 133 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = _tmp1_.user_data;
#line 133 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = g_sequence_iter_next ((GSequenceIter*) _tmp2_);
#line 133 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	(*iter).user_data = _tmp3_;
#line 135 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = *iter;
#line 135 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = _tmp4_.user_data;
#line 135 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (g_sequence_iter_is_end ((GSequenceIter*) _tmp5_)) {
#line 136 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = FALSE;
#line 136 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 671 "BrowserColumnModel.c"
	}
#line 138 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = TRUE;
#line 138 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 677 "BrowserColumnModel.c"
}

/** Sets iter to be the child of parent, using the given index. **/
static gboolean
music_browser_column_model_real_iter_nth_child (GtkTreeModel* base,
                                                GtkTreeIter* iter,
                                                GtkTreeIter* parent,
                                                gint n)
{
	MusicBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GSequence* _tmp3_;
	GSequenceIter* _tmp4_;
	gboolean result;
#line 142 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 143 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (n < 0) {
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp1_ = TRUE;
#line 702 "BrowserColumnModel.c"
	} else {
		GSequence* _tmp2_;
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp2_ = self->priv->rows;
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp1_ = n >= g_sequence_get_length (_tmp2_);
#line 709 "BrowserColumnModel.c"
	}
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp1_) {
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp0_ = TRUE;
#line 715 "BrowserColumnModel.c"
	} else {
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp0_ = parent != NULL;
#line 719 "BrowserColumnModel.c"
	}
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp0_) {
#line 145 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = FALSE;
#line 145 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (iter) {
#line 145 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			*iter = _vala_iter;
#line 729 "BrowserColumnModel.c"
		}
#line 145 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 733 "BrowserColumnModel.c"
	}
#line 147 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.stamp = self->priv->stamp;
#line 148 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = self->priv->rows;
#line 148 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = g_sequence_get_iter_at_pos (_tmp3_, n);
#line 148 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.user_data = _tmp4_;
#line 150 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = TRUE;
#line 150 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (iter) {
#line 150 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*iter = _vala_iter;
#line 749 "BrowserColumnModel.c"
	}
#line 150 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 753 "BrowserColumnModel.c"
}

/** Sets iter to be the parent of child. **/
static gboolean
music_browser_column_model_real_iter_parent (GtkTreeModel* base,
                                             GtkTreeIter* iter,
                                             GtkTreeIter* child)
{
	MusicBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result;
#line 154 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 154 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (child != NULL, FALSE);
#line 155 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 157 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = FALSE;
#line 157 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (iter) {
#line 157 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*iter = _vala_iter;
#line 777 "BrowserColumnModel.c"
	}
#line 157 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 781 "BrowserColumnModel.c"
}

/** Lets the tree ref the node. **/
static void
music_browser_column_model_real_ref_node (GtkTreeModel* base,
                                          GtkTreeIter* iter)
{
	MusicBrowserColumnModel * self;
#line 161 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 161 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (iter != NULL);
#line 794 "BrowserColumnModel.c"
}

/** Lets the tree unref the node. **/
static void
music_browser_column_model_real_unref_node (GtkTreeModel* base,
                                            GtkTreeIter* iter)
{
	MusicBrowserColumnModel * self;
#line 164 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 164 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (iter != NULL);
#line 807 "BrowserColumnModel.c"
}

/** simply adds iter to the model **/
void
music_browser_column_model_append (MusicBrowserColumnModel* self,
                                   GtkTreeIter* iter)
{
	GtkTreeIter _vala_iter = {0};
	GSequenceIter* added = NULL;
	GSequence* _tmp0_;
	gchar* _tmp1_;
	GSequenceIter* _tmp2_;
#line 167 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 169 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->rows;
#line 169 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = g_strdup ("");
#line 169 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = g_sequence_append (_tmp0_, _tmp1_);
#line 169 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	added = _tmp2_;
#line 170 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.stamp = self->priv->stamp;
#line 171 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.user_data = added;
#line 167 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (iter) {
#line 167 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*iter = _vala_iter;
#line 840 "BrowserColumnModel.c"
	}
}

/** convenience method to insert strings into the model. No iters returned. **/
static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 850 "BrowserColumnModel.c"
}

void
music_browser_column_model_append_items (MusicBrowserColumnModel* self,
                                         GeeCollection* strings,
                                         gboolean emit)
{
	GtkTreeIter* _tmp0_;
#line 175 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (strings != NULL);
#line 176 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->first_iter;
#line 176 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp0_ == NULL) {
#line 177 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		music_browser_column_model_add_first_element (self);
#line 869 "BrowserColumnModel.c"
	}
	{
		GeeIterator* _s_it = NULL;
		GeeIterator* _tmp1_;
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) strings);
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_s_it = _tmp1_;
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		while (TRUE) {
#line 880 "BrowserColumnModel.c"
			GeeIterator* _tmp2_;
			gchar* s = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GSequenceIter* added = NULL;
			GSequence* _tmp5_;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			GSequenceIter* _tmp8_;
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp2_ = _s_it;
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				break;
#line 896 "BrowserColumnModel.c"
			}
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp3_ = _s_it;
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			s = (gchar*) _tmp4_;
#line 180 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp5_ = self->priv->rows;
#line 180 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp6_ = s;
#line 180 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp7_ = g_strdup (_tmp6_);
#line 180 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp8_ = g_sequence_append (_tmp5_, _tmp7_);
#line 180 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			added = _tmp8_;
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (emit) {
#line 916 "BrowserColumnModel.c"
				GtkTreePath* path = NULL;
				GSequenceIter* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				GtkTreePath* _tmp12_;
				GtkTreePath* _tmp13_;
				GtkTreeIter iter = {0};
				GSequenceIter* _tmp14_;
				GtkTreePath* _tmp15_;
				GtkTreeIter _tmp16_;
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp9_ = added;
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp10_ = g_strdup_printf ("%i", g_sequence_iter_get_position (_tmp9_));
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp11_ = _tmp10_;
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp12_ = gtk_tree_path_new_from_string (_tmp11_);
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp13_ = _tmp12_;
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (_tmp11_);
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				path = _tmp13_;
#line 184 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				memset (&iter, 0, sizeof (GtkTreeIter));
#line 186 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				iter.stamp = self->priv->stamp;
#line 187 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp14_ = added;
#line 187 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				iter.user_data = _tmp14_;
#line 189 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp15_ = path;
#line 189 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp16_ = iter;
#line 189 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				gtk_tree_model_row_inserted ((GtkTreeModel*) self, _tmp15_, &_tmp16_);
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				__vala_GtkTreePath_free0 (path);
#line 957 "BrowserColumnModel.c"
			}
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_g_free0 (s);
#line 961 "BrowserColumnModel.c"
		}
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_g_object_unref0 (_s_it);
#line 965 "BrowserColumnModel.c"
	}
#line 193 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	music_browser_column_model_update_first_item (self);
#line 969 "BrowserColumnModel.c"
}

static GtkTreeIter*
_vala_GtkTreeIter_copy (GtkTreeIter* self)
{
#line 200 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return g_boxed_copy (gtk_tree_iter_get_type (), self);
#line 977 "BrowserColumnModel.c"
}

static gpointer
__vala_GtkTreeIter_copy0 (gpointer self)
{
#line 200 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return self ? _vala_GtkTreeIter_copy (self) : NULL;
#line 985 "BrowserColumnModel.c"
}

static void
music_browser_column_model_add_first_element (MusicBrowserColumnModel* self)
{
	GSequenceIter* added = NULL;
	GSequence* _tmp0_;
	gchar* _tmp1_;
	GSequenceIter* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	GtkTreeIter* _tmp4_;
	GtkTreeIter* _tmp5_;
	GtkTreeIter* _tmp6_;
#line 197 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 198 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->rows;
#line 198 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = g_strdup ("All");
#line 198 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = g_sequence_append (_tmp0_, _tmp1_);
#line 198 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	added = _tmp2_;
#line 200 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_tmp3_, 0, sizeof (GtkTreeIter));
#line 200 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = __vala_GtkTreeIter_copy0 (&_tmp3_);
#line 200 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	__vala_GtkTreeIter_free0 (self->priv->first_iter);
#line 200 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->first_iter = _tmp4_;
#line 202 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = self->priv->first_iter;
#line 202 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	(*_tmp5_).stamp = self->priv->stamp;
#line 203 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp6_ = self->priv->first_iter;
#line 203 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	(*_tmp6_).user_data = added;
#line 1025 "BrowserColumnModel.c"
}

static void
music_browser_column_model_update_first_item (MusicBrowserColumnModel* self)
{
	GtkTreeIter* _tmp0_;
	void* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_;
#line 207 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->first_iter;
#line 208 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = (*_tmp0_).user_data;
#line 208 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = music_browser_column_model_get_n_items (self);
#line 208 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = _tmp2_;
#line 208 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = music_browser_column_model_get_first_item_text (self, _tmp3_);
#line 208 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_sequence_set ((GSequenceIter*) _tmp1_, _tmp4_);
#line 1050 "BrowserColumnModel.c"
}

static gchar*
music_browser_column_model_get_first_item_text (MusicBrowserColumnModel* self,
                                                gint n_items)
{
	gchar* rv = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 213 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 214 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = g_strdup ("");
#line 214 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	rv = _tmp0_;
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	switch (self->priv->category) {
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_GENRE:
#line 1070 "BrowserColumnModel.c"
		{
#line 218 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (n_items == 1) {
#line 1074 "BrowserColumnModel.c"
				gchar* _tmp1_;
#line 219 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp1_ = g_strdup (_ ("All Genres"));
#line 219 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 219 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp1_;
#line 1082 "BrowserColumnModel.c"
			} else {
#line 220 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (n_items > 1) {
#line 1086 "BrowserColumnModel.c"
					gchar* _tmp2_;
#line 221 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp2_ = g_strdup_printf (_ ("All %i Genres"), n_items);
#line 221 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 221 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp2_;
#line 1094 "BrowserColumnModel.c"
				} else {
					gchar* _tmp3_;
#line 223 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp3_ = g_strdup (_ ("No Genres"));
#line 223 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 223 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp3_;
#line 1103 "BrowserColumnModel.c"
				}
			}
#line 224 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1108 "BrowserColumnModel.c"
		}
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST:
#line 1112 "BrowserColumnModel.c"
		{
#line 227 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (n_items == 1) {
#line 1116 "BrowserColumnModel.c"
				gchar* _tmp4_;
#line 228 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp4_ = g_strdup (_ ("All Artists"));
#line 228 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 228 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp4_;
#line 1124 "BrowserColumnModel.c"
			} else {
#line 229 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (n_items > 1) {
#line 1128 "BrowserColumnModel.c"
					gchar* _tmp5_;
#line 230 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp5_ = g_strdup_printf (_ ("All %i Artists"), n_items);
#line 230 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 230 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp5_;
#line 1136 "BrowserColumnModel.c"
				} else {
					gchar* _tmp6_;
#line 232 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp6_ = g_strdup (_ ("No Artists"));
#line 232 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 232 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp6_;
#line 1145 "BrowserColumnModel.c"
				}
			}
#line 233 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1150 "BrowserColumnModel.c"
		}
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM:
#line 1154 "BrowserColumnModel.c"
		{
#line 236 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (n_items == 1) {
#line 1158 "BrowserColumnModel.c"
				gchar* _tmp7_;
#line 237 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp7_ = g_strdup (_ ("All Albums"));
#line 237 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 237 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp7_;
#line 1166 "BrowserColumnModel.c"
			} else {
#line 238 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (n_items > 1) {
#line 1170 "BrowserColumnModel.c"
					gchar* _tmp8_;
#line 239 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp8_ = g_strdup_printf (_ ("All %i Albums"), n_items);
#line 239 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 239 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp8_;
#line 1178 "BrowserColumnModel.c"
				} else {
					gchar* _tmp9_;
#line 241 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp9_ = g_strdup (_ ("No Albums"));
#line 241 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 241 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp9_;
#line 1187 "BrowserColumnModel.c"
				}
			}
#line 242 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1192 "BrowserColumnModel.c"
		}
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_YEAR:
#line 1196 "BrowserColumnModel.c"
		{
#line 245 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (n_items == 1) {
#line 1200 "BrowserColumnModel.c"
				gchar* _tmp10_;
#line 246 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp10_ = g_strdup (_ ("All Years"));
#line 246 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 246 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp10_;
#line 1208 "BrowserColumnModel.c"
			} else {
#line 247 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (n_items > 1) {
#line 1212 "BrowserColumnModel.c"
					gchar* _tmp11_;
#line 248 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp11_ = g_strdup_printf (_ ("All %i Years"), n_items);
#line 248 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 248 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp11_;
#line 1220 "BrowserColumnModel.c"
				} else {
					gchar* _tmp12_;
#line 250 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp12_ = g_strdup (_ ("No Years"));
#line 250 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 250 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp12_;
#line 1229 "BrowserColumnModel.c"
				}
			}
#line 251 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1234 "BrowserColumnModel.c"
		}
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_RATING:
#line 1238 "BrowserColumnModel.c"
		{
#line 254 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (n_items >= 1) {
#line 1242 "BrowserColumnModel.c"
				gchar* _tmp13_;
#line 255 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp13_ = g_strdup (_ ("All Ratings"));
#line 255 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 255 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp13_;
#line 1250 "BrowserColumnModel.c"
			} else {
				gchar* _tmp14_;
#line 257 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp14_ = g_strdup (_ ("No Ratings"));
#line 257 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 257 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp14_;
#line 1259 "BrowserColumnModel.c"
			}
#line 258 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1263 "BrowserColumnModel.c"
		}
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING:
#line 1267 "BrowserColumnModel.c"
		{
#line 261 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (n_items == 1) {
#line 1271 "BrowserColumnModel.c"
				gchar* _tmp15_;
#line 262 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp15_ = g_strdup (_ ("All Groupings"));
#line 262 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 262 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp15_;
#line 1279 "BrowserColumnModel.c"
			} else {
#line 263 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (n_items > 1) {
#line 1283 "BrowserColumnModel.c"
					gchar* _tmp16_;
#line 264 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp16_ = g_strdup_printf (_ ("All %i Groupings"), n_items);
#line 264 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 264 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp16_;
#line 1291 "BrowserColumnModel.c"
				} else {
					gchar* _tmp17_;
#line 266 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp17_ = g_strdup (_ ("No Groupings"));
#line 266 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 266 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp17_;
#line 1300 "BrowserColumnModel.c"
				}
			}
#line 267 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1305 "BrowserColumnModel.c"
		}
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER:
#line 1309 "BrowserColumnModel.c"
		{
#line 270 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (n_items == 1) {
#line 1313 "BrowserColumnModel.c"
				gchar* _tmp18_;
#line 271 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp18_ = g_strdup (_ ("All Composers"));
#line 271 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 271 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp18_;
#line 1321 "BrowserColumnModel.c"
			} else {
#line 272 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (n_items > 1) {
#line 1325 "BrowserColumnModel.c"
					gchar* _tmp19_;
#line 273 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp19_ = g_strdup_printf (_ ("All %i Composers"), n_items);
#line 273 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 273 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp19_;
#line 1333 "BrowserColumnModel.c"
				} else {
					gchar* _tmp20_;
#line 275 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp20_ = g_strdup (_ ("No Composers"));
#line 275 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 275 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp20_;
#line 1342 "BrowserColumnModel.c"
				}
			}
#line 276 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1347 "BrowserColumnModel.c"
		}
		default:
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		break;
#line 1352 "BrowserColumnModel.c"
	}
#line 279 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = rv;
#line 279 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1358 "BrowserColumnModel.c"
}

void
music_browser_column_model_set (MusicBrowserColumnModel* self,
                                GtkTreeIter* iter,
                                ...)
{
	GtkTreeIter _tmp0_;
	va_list args = {0};
#line 283 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 283 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (iter != NULL);
#line 284 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = *iter;
#line 284 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp0_.stamp != self->priv->stamp) {
#line 285 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return;
#line 1378 "BrowserColumnModel.c"
	}
#line 287 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	va_start (args, iter);
#line 289 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	while (TRUE) {
#line 1384 "BrowserColumnModel.c"
		gint col = 0;
		gboolean _tmp1_ = FALSE;
#line 290 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		col = va_arg (args, gint);
#line 291 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (col < 0) {
#line 291 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp1_ = TRUE;
#line 1393 "BrowserColumnModel.c"
		} else {
#line 291 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp1_ = col >= 1;
#line 1397 "BrowserColumnModel.c"
		}
#line 291 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (_tmp1_) {
#line 292 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			va_end (args);
#line 292 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			return;
#line 1405 "BrowserColumnModel.c"
		} else {
#line 293 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (col == 0) {
#line 1409 "BrowserColumnModel.c"
				gchar* val = NULL;
				const gchar* _tmp2_;
				gchar* _tmp3_;
				GtkTreeIter _tmp4_;
				void* _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
#line 294 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp2_ = va_arg (args, gchar*);
#line 294 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp3_ = g_strdup (_tmp2_);
#line 294 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				val = _tmp3_;
#line 295 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp4_ = *iter;
#line 295 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp5_ = _tmp4_.user_data;
#line 295 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp6_ = val;
#line 295 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp7_ = g_strdup (_tmp6_);
#line 295 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				g_sequence_set ((GSequenceIter*) _tmp5_, _tmp7_);
#line 293 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (val);
#line 1435 "BrowserColumnModel.c"
			}
		}
	}
}

void
music_browser_column_model_remove (MusicBrowserColumnModel* self,
                                   GtkTreeIter* iter)
{
	GtkTreeIter _tmp0_;
	GSequenceIter* sequence_iter = NULL;
	GtkTreeIter _tmp1_;
	void* _tmp2_;
	GtkTreePath* path = NULL;
	GSequenceIter* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkTreePath* _tmp6_;
	GtkTreePath* _tmp7_;
	GSequenceIter* _tmp8_;
	GtkTreePath* _tmp9_;
#line 300 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 300 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (iter != NULL);
#line 301 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = *iter;
#line 301 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp0_.stamp != self->priv->stamp) {
#line 302 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return;
#line 1467 "BrowserColumnModel.c"
	}
#line 304 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = *iter;
#line 304 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = _tmp1_.user_data;
#line 304 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sequence_iter = (GSequenceIter*) _tmp2_;
#line 305 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = sequence_iter;
#line 305 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = g_strdup_printf ("%i", g_sequence_iter_get_position (_tmp3_));
#line 305 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = _tmp4_;
#line 305 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp6_ = gtk_tree_path_new_from_string (_tmp5_);
#line 305 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp7_ = _tmp6_;
#line 305 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_g_free0 (_tmp5_);
#line 305 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	path = _tmp7_;
#line 306 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp8_ = sequence_iter;
#line 306 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_sequence_remove (_tmp8_);
#line 307 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp9_ = path;
#line 307 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	gtk_tree_model_row_deleted ((GtkTreeModel*) self, _tmp9_);
#line 300 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	__vala_GtkTreePath_free0 (path);
#line 1499 "BrowserColumnModel.c"
}

/** Fills in sort_column_id and order with the current sort column and the order. **/
static gboolean
music_browser_column_model_real_get_sort_column_id (GtkTreeSortable* base,
                                                    gint* sort_column_id,
                                                    GtkSortType* order)
{
	MusicBrowserColumnModel * self;
	gint _vala_sort_column_id = 0;
	GtkSortType _vala_order = 0;
	gboolean result;
#line 311 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 312 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_sort_column_id = self->priv->sort_column_id;
#line 313 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_order = self->priv->sort_direction;
#line 315 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = TRUE;
#line 315 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (sort_column_id) {
#line 315 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*sort_column_id = _vala_sort_column_id;
#line 1524 "BrowserColumnModel.c"
	}
#line 315 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (order) {
#line 315 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*order = _vala_order;
#line 1530 "BrowserColumnModel.c"
	}
#line 315 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1534 "BrowserColumnModel.c"
}

/** Returns true if the model has a default sort function. **/
static gboolean
music_browser_column_model_real_has_default_sort_func (GtkTreeSortable* base)
{
	MusicBrowserColumnModel * self;
	GtkTreeIterCompareFunc _tmp0_;
	gpointer _tmp0__target;
	gboolean result;
#line 319 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 320 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->default_sort_func;
#line 320 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0__target = self->priv->default_sort_func_target;
#line 320 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = _tmp0_ != NULL;
#line 320 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1555 "BrowserColumnModel.c"
}

/** Sets the default comparison function used when sorting to be sort_func. **/
static void
music_browser_column_model_real_set_default_sort_func (GtkTreeSortable* base,
                                                       GtkTreeIterCompareFunc sort_func,
                                                       gpointer sort_func_target,
                                                       GDestroyNotify sort_func_target_destroy_notify)
{
	MusicBrowserColumnModel * self;
#line 324 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 325 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->default_sort_func = sort_func;
#line 325 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->default_sort_func_target = sort_func_target;
#line 324 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
#line 324 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func = NULL;
#line 324 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func_target = NULL;
#line 324 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func_target_destroy_notify = NULL;
#line 1580 "BrowserColumnModel.c"
}

/** Sets the current sort column to be sort_column_id. **/
static gint
_music_browser_column_model_sequence_iter_compare_func_gsequence_iter_compare_func (GSequenceIter* a,
                                                                                    GSequenceIter* b,
                                                                                    gpointer self)
{
	gint result;
	result = music_browser_column_model_sequence_iter_compare_func ((MusicBrowserColumnModel*) self, a, b);
#line 337 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1593 "BrowserColumnModel.c"
}

static void
music_browser_column_model_real_set_sort_column_id (GtkTreeSortable* base,
                                                    gint sort_column_id,
                                                    GtkSortType order)
{
	MusicBrowserColumnModel * self;
	gboolean _tmp0_ = FALSE;
	gboolean changed = FALSE;
	gboolean _tmp1_ = FALSE;
#line 329 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 330 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (self->priv->sort_column_id != sort_column_id) {
#line 330 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp0_ = TRUE;
#line 1611 "BrowserColumnModel.c"
	} else {
#line 330 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp0_ = order != self->priv->sort_direction;
#line 1615 "BrowserColumnModel.c"
	}
#line 330 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	changed = _tmp0_;
#line 332 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->sort_column_id = sort_column_id;
#line 333 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->sort_direction = order;
#line 335 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (changed) {
#line 335 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp1_ = sort_column_id >= 0;
#line 1627 "BrowserColumnModel.c"
	} else {
#line 335 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp1_ = FALSE;
#line 1631 "BrowserColumnModel.c"
	}
#line 335 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp1_) {
#line 1635 "BrowserColumnModel.c"
		GSequence* _tmp2_;
#line 337 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp2_ = self->priv->rows;
#line 337 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		g_sequence_sort_iter (_tmp2_, _music_browser_column_model_sequence_iter_compare_func_gsequence_iter_compare_func, self);
#line 339 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		gtk_tree_sortable_sort_column_changed ((GtkTreeSortable*) self);
#line 1643 "BrowserColumnModel.c"
	}
}

static void
music_browser_column_model_real_set_sort_func (GtkTreeSortable* base,
                                               gint sort_column_id,
                                               GtkTreeIterCompareFunc sort_func,
                                               gpointer sort_func_target,
                                               GDestroyNotify sort_func_target_destroy_notify)
{
	MusicBrowserColumnModel * self;
#line 343 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (MusicBrowserColumnModel*) base;
#line 343 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
#line 343 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func = NULL;
#line 343 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func_target = NULL;
#line 343 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func_target_destroy_notify = NULL;
#line 1665 "BrowserColumnModel.c"
}

/** Custom function to use built in sort in Sequence to our advantage **/
gint
music_browser_column_model_sequence_iter_compare_func (MusicBrowserColumnModel* self,
                                                       GSequenceIter* a,
                                                       GSequenceIter* b)
{
	gint rv = 0;
	gint result;
#line 349 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 349 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 349 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 350 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	rv = 1;
#line 352 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (self->priv->sort_column_id < 0) {
#line 353 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = 0;
#line 353 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 1690 "BrowserColumnModel.c"
	}
#line 355 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (self->priv->sort_column_id == 0) {
#line 1694 "BrowserColumnModel.c"
		GSequenceIter* first_sequence_iter = NULL;
		GtkTreeIter* _tmp0_;
		void* _tmp1_;
		GSequenceIter* _tmp2_;
#line 356 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp0_ = self->priv->first_iter;
#line 356 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp1_ = (*_tmp0_).user_data;
#line 356 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		first_sequence_iter = (GSequenceIter*) _tmp1_;
#line 359 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp2_ = first_sequence_iter;
#line 359 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (a == _tmp2_) {
#line 360 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			rv = -1;
#line 1711 "BrowserColumnModel.c"
		} else {
			GSequenceIter* _tmp3_;
#line 362 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp3_ = first_sequence_iter;
#line 362 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (b == _tmp3_) {
#line 363 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = 1;
#line 1720 "BrowserColumnModel.c"
			} else {
				gboolean _tmp4_ = FALSE;
#line 366 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (self->priv->category == MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST) {
#line 366 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp4_ = TRUE;
#line 1727 "BrowserColumnModel.c"
				} else {
#line 366 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp4_ = self->priv->category == MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM;
#line 1731 "BrowserColumnModel.c"
				}
#line 366 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (_tmp4_) {
#line 1735 "BrowserColumnModel.c"
					gconstpointer _tmp5_;
					gconstpointer _tmp6_;
#line 367 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp5_ = g_sequence_get (a);
#line 367 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp6_ = g_sequence_get (b);
#line 367 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = music_string_compare ((const gchar*) _tmp5_, (const gchar*) _tmp6_);
#line 1744 "BrowserColumnModel.c"
				} else {
					gconstpointer _tmp7_;
					gconstpointer _tmp8_;
#line 369 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp7_ = g_sequence_get (a);
#line 369 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp8_ = g_sequence_get (b);
#line 369 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = music_string_compare ((const gchar*) _tmp7_, (const gchar*) _tmp8_);
#line 1754 "BrowserColumnModel.c"
				}
			}
		}
	}
#line 373 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (self->priv->sort_direction == GTK_SORT_DESCENDING) {
#line 1761 "BrowserColumnModel.c"
		gint _tmp9_ = 0;
#line 374 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (rv > 0) {
#line 374 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp9_ = -1;
#line 1767 "BrowserColumnModel.c"
		} else {
#line 374 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp9_ = 1;
#line 1771 "BrowserColumnModel.c"
		}
#line 374 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		rv = _tmp9_;
#line 1775 "BrowserColumnModel.c"
	}
#line 376 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = rv;
#line 376 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1781 "BrowserColumnModel.c"
}

gint
music_browser_column_model_get_n_items (MusicBrowserColumnModel* self)
{
	gint result;
	GSequence* _tmp0_;
#line 34 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->rows;
#line 34 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = g_sequence_get_length (_tmp0_) - 1;
#line 34 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1797 "BrowserColumnModel.c"
}

static void
music_browser_column_model_class_init (MusicBrowserColumnModelClass * klass,
                                       gpointer klass_data)
{
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	music_browser_column_model_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_type_class_adjust_private_offset (klass, &MusicBrowserColumnModel_private_offset);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_browser_column_model_get_property;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	G_OBJECT_CLASS (klass)->finalize = music_browser_column_model_finalize;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY, music_browser_column_model_properties[MUSIC_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY] = g_param_spec_int ("n-items", "n-items", "n-items", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1814 "BrowserColumnModel.c"
}

static void
music_browser_column_model_gtk_tree_model_interface_init (GtkTreeModelIface * iface,
                                                          gpointer iface_data)
{
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	music_browser_column_model_gtk_tree_model_parent_iface = g_type_interface_peek_parent (iface);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_flags = (GtkTreeModelFlags (*) (GtkTreeModel*)) music_browser_column_model_real_get_flags;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_iter = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreePath*)) music_browser_column_model_real_get_iter;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_n_columns = (gint (*) (GtkTreeModel*)) music_browser_column_model_real_get_n_columns;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_column_type = (GType (*) (GtkTreeModel*, gint)) music_browser_column_model_real_get_column_type;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_path = (GtkTreePath* (*) (GtkTreeModel*, GtkTreeIter*)) music_browser_column_model_real_get_path;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_value = (void (*) (GtkTreeModel*, GtkTreeIter*, gint, GValue*)) music_browser_column_model_real_get_value;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_children = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*)) music_browser_column_model_real_iter_children;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_has_child = (gboolean (*) (GtkTreeModel*, GtkTreeIter*)) music_browser_column_model_real_iter_has_child;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_n_children = (gint (*) (GtkTreeModel*, GtkTreeIter*)) music_browser_column_model_real_iter_n_children;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_next = (gboolean (*) (GtkTreeModel*, GtkTreeIter*)) music_browser_column_model_real_iter_next;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_nth_child = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*, gint)) music_browser_column_model_real_iter_nth_child;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_parent = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*)) music_browser_column_model_real_iter_parent;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->ref_node = (void (*) (GtkTreeModel*, GtkTreeIter*)) music_browser_column_model_real_ref_node;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->unref_node = (void (*) (GtkTreeModel*, GtkTreeIter*)) music_browser_column_model_real_unref_node;
#line 1851 "BrowserColumnModel.c"
}

static void
music_browser_column_model_gtk_tree_sortable_interface_init (GtkTreeSortableIface * iface,
                                                             gpointer iface_data)
{
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	music_browser_column_model_gtk_tree_sortable_parent_iface = g_type_interface_peek_parent (iface);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_sort_column_id = (gboolean (*) (GtkTreeSortable*, gint*, GtkSortType*)) music_browser_column_model_real_get_sort_column_id;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->has_default_sort_func = (gboolean (*) (GtkTreeSortable*)) music_browser_column_model_real_has_default_sort_func;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->set_default_sort_func = (void (*) (GtkTreeSortable*, GtkTreeIterCompareFunc, gpointer, GDestroyNotify)) music_browser_column_model_real_set_default_sort_func;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->set_sort_column_id = (void (*) (GtkTreeSortable*, gint, GtkSortType)) music_browser_column_model_real_set_sort_column_id;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->set_sort_func = (void (*) (GtkTreeSortable*, gint, GtkTreeIterCompareFunc, gpointer, GDestroyNotify)) music_browser_column_model_real_set_sort_func;
#line 1870 "BrowserColumnModel.c"
}

static void
music_browser_column_model_instance_init (MusicBrowserColumnModel * self,
                                          gpointer klass)
{
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv = music_browser_column_model_get_instance_private (self);
#line 32 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->stamp = (gint) g_random_int ();
#line 1881 "BrowserColumnModel.c"
}

static void
music_browser_column_model_finalize (GObject * obj)
{
	MusicBrowserColumnModel * self;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_BROWSER_COLUMN_MODEL, MusicBrowserColumnModel);
#line 37 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_g_sequence_free0 (self->priv->rows);
#line 40 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	__vala_GtkTreeIter_free0 (self->priv->first_iter);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	G_OBJECT_CLASS (music_browser_column_model_parent_class)->finalize (obj);
#line 1896 "BrowserColumnModel.c"
}

static GType
music_browser_column_model_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicBrowserColumnModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_browser_column_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicBrowserColumnModel), 0, (GInstanceInitFunc) music_browser_column_model_instance_init, NULL };
	static const GInterfaceInfo gtk_tree_model_info = { (GInterfaceInitFunc) music_browser_column_model_gtk_tree_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gtk_tree_sortable_info = { (GInterfaceInitFunc) music_browser_column_model_gtk_tree_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_browser_column_model_type_id;
	music_browser_column_model_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicBrowserColumnModel", &g_define_type_info, 0);
	g_type_add_interface_static (music_browser_column_model_type_id, gtk_tree_model_get_type (), &gtk_tree_model_info);
	g_type_add_interface_static (music_browser_column_model_type_id, gtk_tree_sortable_get_type (), &gtk_tree_sortable_info);
	MusicBrowserColumnModel_private_offset = g_type_add_instance_private (music_browser_column_model_type_id, sizeof (MusicBrowserColumnModelPrivate));
	return music_browser_column_model_type_id;
}

GType
music_browser_column_model_get_type (void)
{
	static volatile gsize music_browser_column_model_type_id__once = 0;
	if (g_once_init_enter (&music_browser_column_model_type_id__once)) {
		GType music_browser_column_model_type_id;
		music_browser_column_model_type_id = music_browser_column_model_get_type_once ();
		g_once_init_leave (&music_browser_column_model_type_id__once, music_browser_column_model_type_id);
	}
	return music_browser_column_model_type_id__once;
}

static void
_vala_music_browser_column_model_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	MusicBrowserColumnModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_BROWSER_COLUMN_MODEL, MusicBrowserColumnModel);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	switch (property_id) {
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case MUSIC_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		g_value_set_int (value, music_browser_column_model_get_n_items (self));
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		break;
#line 1941 "BrowserColumnModel.c"
		default:
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		break;
#line 1947 "BrowserColumnModel.c"
	}
}

