/* ColumnBrowser.c generated by valac 0.56.0, the Vala compiler
 * generated from ColumnBrowser.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_COLUMN_BROWSER (music_column_browser_get_type ())
#define MUSIC_COLUMN_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowser))
#define MUSIC_COLUMN_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowserClass))
#define MUSIC_IS_COLUMN_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_COLUMN_BROWSER))
#define MUSIC_IS_COLUMN_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_COLUMN_BROWSER))
#define MUSIC_COLUMN_BROWSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowserClass))

typedef struct _MusicColumnBrowser MusicColumnBrowser;
typedef struct _MusicColumnBrowserClass MusicColumnBrowserClass;
typedef struct _MusicColumnBrowserPrivate MusicColumnBrowserPrivate;
typedef enum  {
	MUSIC_COLUMN_BROWSER_POSITION_AUTOMATIC,
	MUSIC_COLUMN_BROWSER_POSITION_LEFT,
	MUSIC_COLUMN_BROWSER_POSITION_TOP
} MusicColumnBrowserPosition;

#define MUSIC_COLUMN_BROWSER_TYPE_POSITION (music_column_browser_position_get_type ())

#define MUSIC_TYPE_VIEW_WRAPPER (music_view_wrapper_get_type ())
#define MUSIC_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper))
#define MUSIC_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapperClass))
#define MUSIC_IS_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_VIEW_WRAPPER))
#define MUSIC_IS_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_VIEW_WRAPPER))
#define MUSIC_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapperClass))

typedef struct _MusicViewWrapper MusicViewWrapper;
typedef struct _MusicViewWrapperClass MusicViewWrapperClass;

#define MUSIC_TYPE_BROWSER_COLUMN (music_browser_column_get_type ())
#define MUSIC_BROWSER_COLUMN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_BROWSER_COLUMN, MusicBrowserColumn))
#define MUSIC_BROWSER_COLUMN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_BROWSER_COLUMN, MusicBrowserColumnClass))
#define MUSIC_IS_BROWSER_COLUMN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_BROWSER_COLUMN))
#define MUSIC_IS_BROWSER_COLUMN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_BROWSER_COLUMN))
#define MUSIC_BROWSER_COLUMN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_BROWSER_COLUMN, MusicBrowserColumnClass))

typedef struct _MusicBrowserColumn MusicBrowserColumn;
typedef struct _MusicBrowserColumnClass MusicBrowserColumnClass;
enum  {
	MUSIC_COLUMN_BROWSER_0_PROPERTY,
	MUSIC_COLUMN_BROWSER_POSITION_PROPERTY,
	MUSIC_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY,
	MUSIC_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY,
	MUSIC_COLUMN_BROWSER_FILTERED_PROPERTY,
	MUSIC_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY,
	MUSIC_COLUMN_BROWSER_INITIALIZED_PROPERTY,
	MUSIC_COLUMN_BROWSER_COLUMNS_PROPERTY,
	MUSIC_COLUMN_BROWSER_NUM_PROPERTIES
};
static GParamSpec* music_column_browser_properties[MUSIC_COLUMN_BROWSER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	MUSIC_BROWSER_COLUMN_CATEGORY_RATING,
	MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING,
	MUSIC_BROWSER_COLUMN_CATEGORY_YEAR,
	MUSIC_BROWSER_COLUMN_CATEGORY_GENRE,
	MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER,
	MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST,
	MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM,
	MUSIC_BROWSER_COLUMN_CATEGORY_N_CATEGORIES
} MusicBrowserColumnCategory;

#define MUSIC_BROWSER_COLUMN_TYPE_CATEGORY (music_browser_column_category_get_type ())
typedef struct _Block23Data Block23Data;

#define MUSIC_TYPE_LIST_VIEW (music_list_view_get_type ())
#define MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIST_VIEW, MusicListView))
#define MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIST_VIEW, MusicListViewClass))
#define MUSIC_IS_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIST_VIEW))
#define MUSIC_IS_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIST_VIEW))
#define MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIST_VIEW, MusicListViewClass))

typedef struct _MusicListView MusicListView;
typedef struct _MusicListViewClass MusicListViewClass;

#define MUSIC_TYPE_GENERIC_LIST (music_generic_list_get_type ())
#define MUSIC_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_GENERIC_LIST, MusicGenericList))
#define MUSIC_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_GENERIC_LIST, MusicGenericListClass))
#define MUSIC_IS_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_GENERIC_LIST))
#define MUSIC_IS_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_GENERIC_LIST))
#define MUSIC_GENERIC_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_GENERIC_LIST, MusicGenericListClass))

typedef struct _MusicGenericList MusicGenericList;
typedef struct _MusicGenericListClass MusicGenericListClass;

#define MUSIC_TYPE_MUSIC_LIST_VIEW (music_music_list_view_get_type ())
#define MUSIC_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListView))
#define MUSIC_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListViewClass))
#define MUSIC_IS_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW))
#define MUSIC_IS_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_MUSIC_LIST_VIEW))
#define MUSIC_MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListViewClass))

typedef struct _MusicMusicListView MusicMusicListView;
typedef struct _MusicMusicListViewClass MusicMusicListViewClass;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	MUSIC_COLUMN_BROWSER_CHANGED_SIGNAL,
	MUSIC_COLUMN_BROWSER_POSITION_CHANGED_SIGNAL,
	MUSIC_COLUMN_BROWSER_NUM_SIGNALS
};
static guint music_column_browser_signals[MUSIC_COLUMN_BROWSER_NUM_SIGNALS] = {0};

struct _MusicColumnBrowser {
	GtkGrid parent_instance;
	MusicColumnBrowserPrivate * priv;
};

struct _MusicColumnBrowserClass {
	GtkGridClass parent_class;
};

struct _MusicColumnBrowserPrivate {
	MusicColumnBrowserPosition _position;
	MusicColumnBrowserPosition _actual_position;
	MusicViewWrapper* _view_wrapper;
	GeeTreeSet* _columns;
	GeeLinkedList* media;
	GeeCollection* search_results;
	GtkMenu* column_chooser_menu;
	GtkRadioMenuItem* top_menu_item;
	GtkRadioMenuItem* left_menu_item;
	GtkRadioMenuItem* automatic_menu_item;
};

struct _Block23Data {
	int _ref_count_;
	MusicColumnBrowser* self;
	MusicBrowserColumn* column;
};

static gint MusicColumnBrowser_private_offset;
static gpointer music_column_browser_parent_class = NULL;

VALA_EXTERN GType music_column_browser_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicColumnBrowser, g_object_unref)
VALA_EXTERN GType music_column_browser_position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType music_view_wrapper_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicViewWrapper, g_object_unref)
VALA_EXTERN GType music_browser_column_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicBrowserColumn, g_object_unref)
VALA_EXTERN MusicColumnBrowser* music_column_browser_new (MusicViewWrapper* view_wrapper);
VALA_EXTERN MusicColumnBrowser* music_column_browser_construct (GType object_type,
                                                    MusicViewWrapper* view_wrapper);
VALA_EXTERN void music_column_browser_reset_filters (MusicColumnBrowser* self);
VALA_EXTERN GeeTreeSet* music_column_browser_get_columns (MusicColumnBrowser* self);
VALA_EXTERN void music_browser_column_select_first_item (MusicBrowserColumn* self);
VALA_EXTERN GType music_browser_column_category_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MusicBrowserColumn* music_column_browser_add_column (MusicColumnBrowser* self,
                                                     MusicBrowserColumnCategory type);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
VALA_EXTERN MusicBrowserColumn* music_browser_column_new (MusicColumnBrowser* miller_parent,
                                              MusicBrowserColumnCategory category);
VALA_EXTERN MusicBrowserColumn* music_browser_column_construct (GType object_type,
                                                    MusicColumnBrowser* miller_parent,
                                                    MusicBrowserColumnCategory category);
static void music_column_browser_column_selection_changed (MusicColumnBrowser* self,
                                                    MusicBrowserColumnCategory category,
                                                    const gchar* val);
static void _music_column_browser_column_selection_changed_music_browser_column_selection_changed (MusicBrowserColumn* _sender,
                                                                                            MusicBrowserColumnCategory type,
                                                                                            const gchar* val,
                                                                                            gpointer self);
static void __lambda67_ (Block23Data* _data23_);
static void ___lambda67__music_browser_column_reset_requested (MusicBrowserColumn* _sender,
                                                        gpointer self);
VALA_EXTERN GtkCheckMenuItem* music_browser_column_get_menu_item (MusicBrowserColumn* self);
static void music_column_browser_column_row_activated (MusicColumnBrowser* self);
static void _music_column_browser_column_row_activated_music_browser_column_row_activated (MusicBrowserColumn* _sender,
                                                                                    const gchar* text,
                                                                                    gpointer self);
static void music_column_browser_column_header_clicked (MusicColumnBrowser* self,
                                                 GdkEventButton* e);
static void _music_column_browser_column_header_clicked_music_browser_column_header_clicked (MusicBrowserColumn* _sender,
                                                                                      GdkEventButton* e,
                                                                                      gpointer self);
static void music_column_browser_update_column_separators (MusicColumnBrowser* self);
static void _music_column_browser_update_column_separators_music_browser_column_visibility_changed (MusicBrowserColumn* _sender,
                                                                                             gboolean visible,
                                                                                             gpointer self);
VALA_EXTERN void music_column_browser_set_media (MusicColumnBrowser* self,
                                     GeeCollection* media);
VALA_EXTERN MusicBrowserColumnCategory music_browser_column_category_first (void);
static void music_column_browser_populate_columns (MusicColumnBrowser* self,
                                            MusicBrowserColumnCategory category,
                                            gboolean inclusive);
VALA_EXTERN MusicViewWrapper* music_column_browser_get_view_wrapper (MusicColumnBrowser* self);
VALA_EXTERN void music_view_wrapper_play_first_media (MusicViewWrapper* self,
                                          gboolean* force);
static void music_column_browser_update_search_results (MusicColumnBrowser* self,
                                                 MusicBrowserColumnCategory parent_category);
VALA_EXTERN GType music_list_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicListView, g_object_unref)
VALA_EXTERN MusicListView* music_view_wrapper_get_list_view (MusicViewWrapper* self);
VALA_EXTERN GType music_generic_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicGenericList, g_object_unref)
VALA_EXTERN GType music_music_list_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicMusicListView, g_object_unref)
VALA_EXTERN MusicMusicListView* music_list_view_get_list_view (MusicListView* self);
VALA_EXTERN void music_generic_list_set_research_needed (MusicGenericList* self,
                                             gboolean value);
static void music_column_browser_get_filters (MusicColumnBrowser* self,
                                       MusicBrowserColumnCategory parent_category,
                                       gint* rating,
                                       gint* year,
                                       gchar** genre,
                                       gchar** album_artist,
                                       gchar** album,
                                       gchar** grouping,
                                       gchar** composer);
VALA_EXTERN MusicBrowserColumnCategory music_browser_column_get_category (MusicBrowserColumn* self);
VALA_EXTERN gchar* music_browser_column_get_selected (MusicBrowserColumn* self);
VALA_EXTERN void music_column_browser_fill_column (MusicColumnBrowser* self,
                                       MusicBrowserColumn* column);
VALA_EXTERN void music_browser_column_populate (MusicBrowserColumn* self,
                                    GeeHashSet* items);
VALA_EXTERN gboolean music_column_browser_match_media (MusicColumnBrowser* self,
                                           MusicMedia* m);
VALA_EXTERN MusicBrowserColumnCategory music_browser_column_category_last (void);
VALA_EXTERN GeeTreeSet* music_column_browser_get_visible_columns (MusicColumnBrowser* self);
VALA_EXTERN void music_browser_column_set_show_separator (MusicBrowserColumn* self,
                                              gboolean value);
static void music_column_browser_save_current_state (MusicColumnBrowser* self);
static void _vala_array_add5 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN GSettings* music_app_get_saved_state (void);
VALA_EXTERN MusicColumnBrowserPosition music_column_browser_get_position (MusicColumnBrowser* self);
VALA_EXTERN void music_column_browser_set_position (MusicColumnBrowser* self,
                                        MusicColumnBrowserPosition value);
VALA_EXTERN MusicColumnBrowserPosition music_column_browser_get_actual_position (MusicColumnBrowser* self);
VALA_EXTERN void music_column_browser_set_actual_position (MusicColumnBrowser* self,
                                               MusicColumnBrowserPosition value);
static void music_column_browser_set_view_wrapper (MusicColumnBrowser* self,
                                            MusicViewWrapper* value);
VALA_EXTERN gboolean music_column_browser_get_filtered (MusicColumnBrowser* self);
VALA_EXTERN gboolean music_browser_column_get_first_item_selected (MusicBrowserColumn* self);
VALA_EXTERN gboolean music_browser_column_get_visible (MusicBrowserColumn* self);
VALA_EXTERN void music_column_browser_set_visible_columns (MusicColumnBrowser* self,
                                               GeeTreeSet* value);
VALA_EXTERN void music_browser_column_set_visible (MusicBrowserColumn* self,
                                       gboolean value);
VALA_EXTERN gboolean music_column_browser_get_initialized (MusicColumnBrowser* self);
static void music_column_browser_set_columns (MusicColumnBrowser* self,
                                       GeeTreeSet* value);
static GObject * music_column_browser_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static void _vala_array_add6 (MusicBrowserColumnCategory* * array,
                       gint* length,
                       gint* size,
                       MusicBrowserColumnCategory value);
static void _vala_array_add7 (MusicBrowserColumnCategory* * array,
                       gint* length,
                       gint* size,
                       MusicBrowserColumnCategory value);
static void _vala_array_add8 (MusicBrowserColumnCategory* * array,
                       gint* length,
                       gint* size,
                       MusicBrowserColumnCategory value);
static void _vala_array_add9 (MusicBrowserColumnCategory* * array,
                       gint* length,
                       gint* size,
                       MusicBrowserColumnCategory value);
static void _vala_array_add10 (MusicBrowserColumnCategory* * array,
                        gint* length,
                        gint* size,
                        MusicBrowserColumnCategory value);
static void _vala_array_add11 (MusicBrowserColumnCategory* * array,
                        gint* length,
                        gint* size,
                        MusicBrowserColumnCategory value);
static void _vala_array_add12 (MusicBrowserColumnCategory* * array,
                        gint* length,
                        gint* size,
                        MusicBrowserColumnCategory value);
static void _music_column_browser___lambda68_ (MusicColumnBrowser* self);
static void __music_column_browser___lambda68__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                     gpointer self);
static void _music_column_browser___lambda69_ (MusicColumnBrowser* self);
static void __music_column_browser___lambda69__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                     gpointer self);
static void _music_column_browser___lambda70_ (MusicColumnBrowser* self);
static void __music_column_browser___lambda70__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                     gpointer self);
static void _music_column_browser_save_current_state_gtk_widget_destroy (GtkWidget* _sender,
                                                                  gpointer self);
static void music_column_browser_finalize (GObject * obj);
static GType music_column_browser_get_type_once (void);
static void _vala_music_column_browser_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_music_column_browser_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
music_column_browser_get_instance_private (MusicColumnBrowser* self)
{
	return G_STRUCT_MEMBER_P (self, MusicColumnBrowser_private_offset);
}

static GType
music_column_browser_position_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_COLUMN_BROWSER_POSITION_AUTOMATIC, "MUSIC_COLUMN_BROWSER_POSITION_AUTOMATIC", "automatic"}, {MUSIC_COLUMN_BROWSER_POSITION_LEFT, "MUSIC_COLUMN_BROWSER_POSITION_LEFT", "left"}, {MUSIC_COLUMN_BROWSER_POSITION_TOP, "MUSIC_COLUMN_BROWSER_POSITION_TOP", "top"}, {0, NULL, NULL}};
	GType music_column_browser_position_type_id;
	music_column_browser_position_type_id = g_enum_register_static ("MusicColumnBrowserPosition", values);
	return music_column_browser_position_type_id;
}

GType
music_column_browser_position_get_type (void)
{
	static volatile gsize music_column_browser_position_type_id__once = 0;
	if (g_once_init_enter (&music_column_browser_position_type_id__once)) {
		GType music_column_browser_position_type_id;
		music_column_browser_position_type_id = music_column_browser_position_get_type_once ();
		g_once_init_leave (&music_column_browser_position_type_id__once, music_column_browser_position_type_id);
	}
	return music_column_browser_position_type_id__once;
}

MusicColumnBrowser*
music_column_browser_construct (GType object_type,
                                MusicViewWrapper* view_wrapper)
{
	MusicColumnBrowser * self = NULL;
#line 140 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (view_wrapper != NULL, NULL);
#line 141 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self = (MusicColumnBrowser*) g_object_new (object_type, "view-wrapper", view_wrapper, NULL);
#line 140 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return self;
#line 400 "ColumnBrowser.c"
}

MusicColumnBrowser*
music_column_browser_new (MusicViewWrapper* view_wrapper)
{
#line 140 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return music_column_browser_construct (MUSIC_TYPE_COLUMN_BROWSER, view_wrapper);
#line 408 "ColumnBrowser.c"
}

void
music_column_browser_reset_filters (MusicColumnBrowser* self)
{
#line 204 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 416 "ColumnBrowser.c"
	{
		GeeIterator* _col_it = NULL;
		GeeTreeSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp0_ = self->priv->_columns;
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_col_it = _tmp1_;
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 429 "ColumnBrowser.c"
			GeeIterator* _tmp2_;
			MusicBrowserColumn* col = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			MusicBrowserColumn* _tmp5_;
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp2_ = _col_it;
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 441 "ColumnBrowser.c"
			}
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp3_ = _col_it;
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			col = (MusicBrowserColumn*) _tmp4_;
#line 206 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp5_ = col;
#line 206 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			music_browser_column_select_first_item (_tmp5_);
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (col);
#line 455 "ColumnBrowser.c"
		}
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_col_it);
#line 459 "ColumnBrowser.c"
	}
}

static Block23Data*
block23_data_ref (Block23Data* _data23_)
{
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_atomic_int_inc (&_data23_->_ref_count_);
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return _data23_;
#line 470 "ColumnBrowser.c"
}

static void
block23_data_unref (void * _userdata_)
{
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
#line 480 "ColumnBrowser.c"
		MusicColumnBrowser* self;
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		self = _data23_->self;
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_data23_->column);
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (self);
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_slice_free (Block23Data, _data23_);
#line 490 "ColumnBrowser.c"
	}
}

static void
_music_column_browser_column_selection_changed_music_browser_column_selection_changed (MusicBrowserColumn* _sender,
                                                                                       MusicBrowserColumnCategory type,
                                                                                       const gchar* val,
                                                                                       gpointer self)
{
#line 213 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_column_browser_column_selection_changed ((MusicColumnBrowser*) self, type, val);
#line 502 "ColumnBrowser.c"
}

static void
__lambda67_ (Block23Data* _data23_)
{
	MusicColumnBrowser* self;
#line 218 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self = _data23_->self;
#line 219 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_browser_column_select_first_item (_data23_->column);
#line 513 "ColumnBrowser.c"
}

static void
___lambda67__music_browser_column_reset_requested (MusicBrowserColumn* _sender,
                                                   gpointer self)
{
#line 218 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	__lambda67_ (self);
#line 522 "ColumnBrowser.c"
}

static void
_music_column_browser_column_row_activated_music_browser_column_row_activated (MusicBrowserColumn* _sender,
                                                                               const gchar* text,
                                                                               gpointer self)
{
#line 229 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_column_browser_column_row_activated ((MusicColumnBrowser*) self);
#line 532 "ColumnBrowser.c"
}

static void
_music_column_browser_column_header_clicked_music_browser_column_header_clicked (MusicBrowserColumn* _sender,
                                                                                 GdkEventButton* e,
                                                                                 gpointer self)
{
#line 230 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_column_browser_column_header_clicked ((MusicColumnBrowser*) self, e);
#line 542 "ColumnBrowser.c"
}

static void
_music_column_browser_update_column_separators_music_browser_column_visibility_changed (MusicBrowserColumn* _sender,
                                                                                        gboolean visible,
                                                                                        gpointer self)
{
#line 231 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_column_browser_update_column_separators ((MusicColumnBrowser*) self);
#line 552 "ColumnBrowser.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 233 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return self ? g_object_ref (self) : NULL;
#line 560 "ColumnBrowser.c"
}

MusicBrowserColumn*
music_column_browser_add_column (MusicColumnBrowser* self,
                                 MusicBrowserColumnCategory type)
{
	Block23Data* _data23_;
	MusicBrowserColumn* _tmp0_;
	GeeTreeSet* _tmp1_;
	GtkMenu* _tmp2_;
	GtkCheckMenuItem* _tmp3_;
	GtkCheckMenuItem* _tmp4_;
	MusicBrowserColumn* _tmp5_;
	MusicBrowserColumn* result;
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_data23_ = g_slice_new0 (Block23Data);
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_data23_->_ref_count_ = 1;
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_data23_->self = g_object_ref (self);
#line 211 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = music_browser_column_new (self, type);
#line 211 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_ref_sink (_tmp0_);
#line 211 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_data23_->column = _tmp0_;
#line 213 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_object (_data23_->column, "selection-changed", (GCallback) _music_column_browser_column_selection_changed_music_browser_column_selection_changed, self, G_CONNECT_AFTER);
#line 216 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_widget_set_size_request ((GtkWidget*) _data23_->column, 60, 100);
#line 218 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_data (_data23_->column, "reset-requested", (GCallback) ___lambda67__music_browser_column_reset_requested, block23_data_ref (_data23_), (GClosureNotify) block23_data_unref, 0);
#line 222 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = self->priv->_columns;
#line 222 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _data23_->column);
#line 224 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _data23_->column, TRUE);
#line 224 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _data23_->column, TRUE);
#line 225 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _data23_->column, (gint) type, 0, 1, 1);
#line 227 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = self->priv->column_chooser_menu;
#line 227 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp3_ = music_browser_column_get_menu_item (_data23_->column);
#line 227 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp4_ = _tmp3_;
#line 227 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp2_, (GtkMenuItem*) _tmp4_);
#line 229 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_object (_data23_->column, "row-activated", (GCallback) _music_column_browser_column_row_activated_music_browser_column_row_activated, self, 0);
#line 230 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_object (_data23_->column, "header-clicked", (GCallback) _music_column_browser_column_header_clicked_music_browser_column_header_clicked, self, 0);
#line 231 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_object (_data23_->column, "visibility-changed", (GCallback) _music_column_browser_update_column_separators_music_browser_column_visibility_changed, self, 0);
#line 233 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp5_ = _g_object_ref0 (_data23_->column);
#line 233 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = _tmp5_;
#line 233 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	block23_data_unref (_data23_);
#line 233 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_data23_ = NULL;
#line 233 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 629 "ColumnBrowser.c"
}

void
music_column_browser_set_media (MusicColumnBrowser* self,
                                GeeCollection* media)
{
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	MusicBrowserColumnCategory highest_category = 0;
#line 236 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 236 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (media != NULL);
#line 237 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->media;
#line 237 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 238 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = self->priv->media;
#line 238 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gee_collection_add_all ((GeeCollection*) _tmp1_, media);
#line 240 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = self->priv->search_results;
#line 240 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gee_collection_clear (_tmp2_);
#line 241 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp3_ = self->priv->search_results;
#line 241 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gee_collection_add_all (_tmp3_, media);
#line 243 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	highest_category = music_browser_column_category_first ();
#line 245 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_column_browser_populate_columns (self, highest_category, TRUE);
#line 247 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_emit (self, music_column_browser_signals[MUSIC_COLUMN_BROWSER_CHANGED_SIGNAL], 0);
#line 667 "ColumnBrowser.c"
}

static void
music_column_browser_column_row_activated (MusicColumnBrowser* self)
{
	MusicViewWrapper* _tmp0_;
	gboolean _tmp1_;
#line 250 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 251 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->_view_wrapper;
#line 251 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = FALSE;
#line 251 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_view_wrapper_play_first_media (_tmp0_, &_tmp1_);
#line 683 "ColumnBrowser.c"
}

static void
music_column_browser_column_selection_changed (MusicColumnBrowser* self,
                                               MusicBrowserColumnCategory category,
                                               const gchar* val)
{
	MusicViewWrapper* _tmp0_;
	MusicListView* _tmp1_;
	MusicListView* _tmp2_;
	MusicMusicListView* _tmp3_;
	MusicMusicListView* _tmp4_;
#line 254 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (val != NULL);
#line 255 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_column_browser_update_search_results (self, category);
#line 256 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->_view_wrapper;
#line 256 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = music_view_wrapper_get_list_view (_tmp0_);
#line 256 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = _tmp1_;
#line 256 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp3_ = music_list_view_get_list_view (_tmp2_);
#line 256 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp4_ = _tmp3_;
#line 256 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_generic_list_set_research_needed ((MusicGenericList*) _tmp4_, TRUE);
#line 257 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_column_browser_populate_columns (self, category, FALSE);
#line 258 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_emit (self, music_column_browser_signals[MUSIC_COLUMN_BROWSER_CHANGED_SIGNAL], 0);
#line 718 "ColumnBrowser.c"
}

static void
music_column_browser_update_search_results (MusicColumnBrowser* self,
                                            MusicBrowserColumnCategory parent_category)
{
	gint rating = 0;
	gint year = 0;
	gchar* genre = NULL;
	gchar* album_artist = NULL;
	gchar* album = NULL;
	gchar* grouping = NULL;
	gchar* composer = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GeeLinkedList* _tmp7_;
	GeeCollection* _tmp8_ = NULL;
#line 261 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_column_browser_get_filters (self, parent_category, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	rating = _tmp0_;
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	year = _tmp1_;
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (genre);
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	genre = _tmp2_;
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (album_artist);
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	album_artist = _tmp3_;
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (album);
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	album = _tmp4_;
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (grouping);
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	grouping = _tmp5_;
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (composer);
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	composer = _tmp6_;
#line 268 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp7_ = self->priv->media;
#line 268 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_search_search_in_media_list ((GeeCollection*) _tmp7_, &_tmp8_, album_artist, album, genre, grouping, composer, year, rating, NULL);
#line 268 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->search_results);
#line 268 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->search_results = _tmp8_;
#line 261 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (composer);
#line 261 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (grouping);
#line 261 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (album);
#line 261 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (album_artist);
#line 261 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (genre);
#line 787 "ColumnBrowser.c"
}

static void
music_column_browser_get_filters (MusicColumnBrowser* self,
                                  MusicBrowserColumnCategory parent_category,
                                  gint* rating,
                                  gint* year,
                                  gchar** genre,
                                  gchar** album_artist,
                                  gchar** album,
                                  gchar** grouping,
                                  gchar** composer)
{
	gint _vala_rating = 0;
	gint _vala_year = 0;
	gchar* _vala_genre = NULL;
	gchar* _vala_album_artist = NULL;
	gchar* _vala_album = NULL;
	gchar* _vala_grouping = NULL;
	gchar* _vala_composer = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 282 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_rating = -1;
#line 283 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_year = -1;
#line 284 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = g_strdup ("");
#line 284 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (_vala_genre);
#line 284 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_genre = _tmp0_;
#line 285 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = g_strdup ("");
#line 285 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (_vala_album_artist);
#line 285 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_album_artist = _tmp1_;
#line 286 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = g_strdup ("");
#line 286 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (_vala_album);
#line 286 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_album = _tmp2_;
#line 287 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp3_ = g_strdup ("");
#line 287 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (_vala_grouping);
#line 287 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_grouping = _tmp3_;
#line 288 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp4_ = g_strdup ("");
#line 288 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (_vala_composer);
#line 288 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_composer = _tmp4_;
#line 849 "ColumnBrowser.c"
	{
		GeeIterator* _col_it = NULL;
		GeeTreeSet* _tmp5_;
		GeeIterator* _tmp6_;
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp5_ = self->priv->_columns;
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp6_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp5_);
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_col_it = _tmp6_;
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 862 "ColumnBrowser.c"
			GeeIterator* _tmp7_;
			MusicBrowserColumn* col = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			MusicBrowserColumn* _tmp10_;
			MusicBrowserColumnCategory _tmp11_;
			MusicBrowserColumnCategory _tmp12_;
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp7_ = _col_it;
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 876 "ColumnBrowser.c"
			}
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp8_ = _col_it;
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			col = (MusicBrowserColumn*) _tmp9_;
#line 292 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp10_ = col;
#line 292 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp11_ = music_browser_column_get_category (_tmp10_);
#line 292 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp12_ = _tmp11_;
#line 292 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (_tmp12_ <= parent_category) {
#line 892 "ColumnBrowser.c"
				gchar* selected = NULL;
				MusicBrowserColumn* _tmp13_;
				gchar* _tmp14_;
				MusicBrowserColumn* _tmp15_;
				MusicBrowserColumnCategory _tmp16_;
				MusicBrowserColumnCategory _tmp17_;
#line 293 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp13_ = col;
#line 293 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp14_ = music_browser_column_get_selected (_tmp13_);
#line 293 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				selected = _tmp14_;
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp15_ = col;
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp16_ = music_browser_column_get_category (_tmp15_);
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp17_ = _tmp16_;
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				switch (_tmp17_) {
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					case MUSIC_BROWSER_COLUMN_CATEGORY_GENRE:
#line 915 "ColumnBrowser.c"
					{
						const gchar* _tmp18_;
						gchar* _tmp19_;
#line 297 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp18_ = selected;
#line 297 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp19_ = g_strdup (_tmp18_);
#line 297 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_g_free0 (_vala_genre);
#line 297 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_vala_genre = _tmp19_;
#line 298 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 929 "ColumnBrowser.c"
					}
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					case MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST:
#line 933 "ColumnBrowser.c"
					{
						const gchar* _tmp20_;
						gchar* _tmp21_;
#line 301 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp20_ = selected;
#line 301 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp21_ = g_strdup (_tmp20_);
#line 301 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_g_free0 (_vala_album_artist);
#line 301 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_vala_album_artist = _tmp21_;
#line 302 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 947 "ColumnBrowser.c"
					}
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					case MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM:
#line 951 "ColumnBrowser.c"
					{
						const gchar* _tmp22_;
						gchar* _tmp23_;
#line 305 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp22_ = selected;
#line 305 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp23_ = g_strdup (_tmp22_);
#line 305 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_g_free0 (_vala_album);
#line 305 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_vala_album = _tmp23_;
#line 306 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 965 "ColumnBrowser.c"
					}
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					case MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING:
#line 969 "ColumnBrowser.c"
					{
						const gchar* _tmp24_;
						gchar* _tmp25_;
#line 309 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp24_ = selected;
#line 309 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp25_ = g_strdup (_tmp24_);
#line 309 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_g_free0 (_vala_grouping);
#line 309 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_vala_grouping = _tmp25_;
#line 310 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 983 "ColumnBrowser.c"
					}
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					case MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER:
#line 987 "ColumnBrowser.c"
					{
						const gchar* _tmp26_;
						gchar* _tmp27_;
#line 313 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp26_ = selected;
#line 313 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp27_ = g_strdup (_tmp26_);
#line 313 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_g_free0 (_vala_composer);
#line 313 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_vala_composer = _tmp27_;
#line 314 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1001 "ColumnBrowser.c"
					}
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					case MUSIC_BROWSER_COLUMN_CATEGORY_YEAR:
#line 1005 "ColumnBrowser.c"
					{
						gint _tmp28_ = 0;
						const gchar* _tmp29_;
#line 319 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp29_ = selected;
#line 319 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						if (music_string_is_empty (_tmp29_, FALSE)) {
#line 319 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp28_ = -1;
#line 1015 "ColumnBrowser.c"
						} else {
							const gchar* _tmp30_;
#line 319 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp30_ = selected;
#line 319 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp28_ = (gint) music_string_uint_from_string (_tmp30_);
#line 1022 "ColumnBrowser.c"
						}
#line 319 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_vala_year = _tmp28_;
#line 320 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1028 "ColumnBrowser.c"
					}
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					case MUSIC_BROWSER_COLUMN_CATEGORY_RATING:
#line 1032 "ColumnBrowser.c"
					{
						gint _tmp31_ = 0;
						const gchar* _tmp32_;
#line 336 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp32_ = selected;
#line 336 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						if (music_string_is_empty (_tmp32_, FALSE)) {
#line 336 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp31_ = -1;
#line 1042 "ColumnBrowser.c"
						} else {
							const gchar* _tmp33_;
#line 336 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp33_ = selected;
#line 336 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp31_ = (gint) music_string_uint_from_string (_tmp33_);
#line 1049 "ColumnBrowser.c"
						}
#line 336 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_vala_rating = _tmp31_;
#line 337 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1055 "ColumnBrowser.c"
					}
					default:
					{
#line 340 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						g_assert_not_reached ();
#line 1061 "ColumnBrowser.c"
					}
				}
#line 292 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_free0 (selected);
#line 1066 "ColumnBrowser.c"
			}
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (col);
#line 1070 "ColumnBrowser.c"
		}
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_col_it);
#line 1074 "ColumnBrowser.c"
	}
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (rating) {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*rating = _vala_rating;
#line 1080 "ColumnBrowser.c"
	}
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (year) {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*year = _vala_year;
#line 1086 "ColumnBrowser.c"
	}
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (genre) {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*genre = _vala_genre;
#line 1092 "ColumnBrowser.c"
	} else {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_free0 (_vala_genre);
#line 1096 "ColumnBrowser.c"
	}
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (album_artist) {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*album_artist = _vala_album_artist;
#line 1102 "ColumnBrowser.c"
	} else {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_free0 (_vala_album_artist);
#line 1106 "ColumnBrowser.c"
	}
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (album) {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*album = _vala_album;
#line 1112 "ColumnBrowser.c"
	} else {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_free0 (_vala_album);
#line 1116 "ColumnBrowser.c"
	}
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (grouping) {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*grouping = _vala_grouping;
#line 1122 "ColumnBrowser.c"
	} else {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_free0 (_vala_grouping);
#line 1126 "ColumnBrowser.c"
	}
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (composer) {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*composer = _vala_composer;
#line 1132 "ColumnBrowser.c"
	} else {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_free0 (_vala_composer);
#line 1136 "ColumnBrowser.c"
	}
}

static void
music_column_browser_populate_columns (MusicColumnBrowser* self,
                                       MusicBrowserColumnCategory category,
                                       gboolean inclusive)
{
#line 346 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 1147 "ColumnBrowser.c"
	{
		GeeIterator* _column_it = NULL;
		GeeTreeSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp0_ = self->priv->_columns;
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_column_it = _tmp1_;
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 1160 "ColumnBrowser.c"
			GeeIterator* _tmp2_;
			MusicBrowserColumn* column = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			MusicBrowserColumn* _tmp5_;
			MusicBrowserColumnCategory _tmp6_;
			MusicBrowserColumnCategory _tmp7_;
			gboolean _tmp8_ = FALSE;
			MusicBrowserColumn* _tmp9_;
			MusicBrowserColumnCategory _tmp10_;
			MusicBrowserColumnCategory _tmp11_;
			MusicBrowserColumn* _tmp12_;
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp2_ = _column_it;
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 1179 "ColumnBrowser.c"
			}
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp3_ = _column_it;
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			column = (MusicBrowserColumn*) _tmp4_;
#line 350 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp5_ = column;
#line 350 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp6_ = music_browser_column_get_category (_tmp5_);
#line 350 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp7_ = _tmp6_;
#line 350 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (_tmp7_ < category) {
#line 351 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (column);
#line 351 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				continue;
#line 1199 "ColumnBrowser.c"
			}
#line 353 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp9_ = column;
#line 353 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp10_ = music_browser_column_get_category (_tmp9_);
#line 353 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp11_ = _tmp10_;
#line 353 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (_tmp11_ == category) {
#line 353 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp8_ = !inclusive;
#line 1211 "ColumnBrowser.c"
			} else {
#line 353 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp8_ = FALSE;
#line 1215 "ColumnBrowser.c"
			}
#line 353 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (_tmp8_) {
#line 354 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (column);
#line 354 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				continue;
#line 1223 "ColumnBrowser.c"
			}
#line 356 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp12_ = column;
#line 356 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			music_column_browser_fill_column (self, _tmp12_);
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (column);
#line 1231 "ColumnBrowser.c"
		}
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_column_it);
#line 1235 "ColumnBrowser.c"
	}
}

void
music_column_browser_fill_column (MusicColumnBrowser* self,
                                  MusicBrowserColumn* column)
{
	GeeHashSet* column_set = NULL;
	GeeHashSet* _tmp0_;
	MusicBrowserColumnCategory _tmp1_;
	MusicBrowserColumnCategory _tmp2_;
	GeeHashSet* _tmp92_;
	MusicBrowserColumnCategory _tmp93_;
	MusicBrowserColumnCategory _tmp94_;
#line 360 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 360 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (column != NULL);
#line 361 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 361 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	column_set = _tmp0_;
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = music_browser_column_get_category (column);
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = _tmp1_;
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	switch (_tmp2_) {
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_GENRE:
#line 1266 "ColumnBrowser.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp3_;
				GeeIterator* _tmp4_;
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp3_ = self->priv->search_results;
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_m_it = _tmp4_;
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				while (TRUE) {
#line 1280 "ColumnBrowser.c"
					GeeIterator* _tmp5_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp6_;
					gpointer _tmp7_;
					gchar* genre = NULL;
					MusicMedia* _tmp8_;
					gchar* _tmp9_;
					GeeHashSet* _tmp10_;
					const gchar* _tmp11_;
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp5_ = _m_it;
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_iterator_next (_tmp5_)) {
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1296 "ColumnBrowser.c"
					}
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp6_ = _m_it;
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp7_ = gee_iterator_get (_tmp6_);
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					m = (MusicMedia*) _tmp7_;
#line 366 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp8_ = m;
#line 366 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp9_ = music_media_get_display_genre (_tmp8_);
#line 366 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					genre = _tmp9_;
#line 367 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp10_ = column_set;
#line 367 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp11_ = genre;
#line 367 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp10_, _tmp11_)) {
#line 1316 "ColumnBrowser.c"
						GeeHashSet* _tmp12_;
						const gchar* _tmp13_;
#line 368 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp12_ = column_set;
#line 368 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp13_ = genre;
#line 368 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
#line 1325 "ColumnBrowser.c"
					}
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_free0 (genre);
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_object_unref0 (m);
#line 1331 "ColumnBrowser.c"
				}
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_m_it);
#line 1335 "ColumnBrowser.c"
			}
#line 370 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 1339 "ColumnBrowser.c"
		}
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST:
#line 1343 "ColumnBrowser.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp14_;
				GeeIterator* _tmp15_;
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp14_ = self->priv->search_results;
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp15_ = gee_iterable_iterator ((GeeIterable*) _tmp14_);
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_m_it = _tmp15_;
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				while (TRUE) {
#line 1357 "ColumnBrowser.c"
					GeeIterator* _tmp16_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp17_;
					gpointer _tmp18_;
					gchar* artist = NULL;
					MusicMedia* _tmp19_;
					gchar* _tmp20_;
					GeeHashSet* _tmp21_;
					const gchar* _tmp22_;
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp16_ = _m_it;
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_iterator_next (_tmp16_)) {
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1373 "ColumnBrowser.c"
					}
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp17_ = _m_it;
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp18_ = gee_iterator_get (_tmp17_);
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					m = (MusicMedia*) _tmp18_;
#line 374 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp19_ = m;
#line 374 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp20_ = music_media_get_display_album_artist (_tmp19_, TRUE);
#line 374 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					artist = _tmp20_;
#line 375 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp21_ = column_set;
#line 375 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp22_ = artist;
#line 375 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp21_, _tmp22_)) {
#line 1393 "ColumnBrowser.c"
						GeeHashSet* _tmp23_;
						const gchar* _tmp24_;
#line 376 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp23_ = column_set;
#line 376 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp24_ = artist;
#line 376 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _tmp24_);
#line 1402 "ColumnBrowser.c"
					}
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_free0 (artist);
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_object_unref0 (m);
#line 1408 "ColumnBrowser.c"
				}
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_m_it);
#line 1412 "ColumnBrowser.c"
			}
#line 378 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 1416 "ColumnBrowser.c"
		}
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING:
#line 1420 "ColumnBrowser.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp25_;
				GeeIterator* _tmp26_;
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp25_ = self->priv->search_results;
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp26_ = gee_iterable_iterator ((GeeIterable*) _tmp25_);
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_m_it = _tmp26_;
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				while (TRUE) {
#line 1434 "ColumnBrowser.c"
					GeeIterator* _tmp27_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp28_;
					gpointer _tmp29_;
					gchar* grouping = NULL;
					MusicMedia* _tmp30_;
					const gchar* _tmp31_;
					const gchar* _tmp32_;
					gchar* _tmp33_;
					gboolean _tmp34_ = FALSE;
					const gchar* _tmp35_;
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp27_ = _m_it;
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_iterator_next (_tmp27_)) {
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1452 "ColumnBrowser.c"
					}
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp28_ = _m_it;
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp29_ = gee_iterator_get (_tmp28_);
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					m = (MusicMedia*) _tmp29_;
#line 382 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp30_ = m;
#line 382 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp31_ = music_media_get_grouping (_tmp30_);
#line 382 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp32_ = _tmp31_;
#line 382 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp33_ = g_strdup (_tmp32_);
#line 382 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					grouping = _tmp33_;
#line 385 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp35_ = grouping;
#line 385 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!music_string_is_empty (_tmp35_, FALSE)) {
#line 1474 "ColumnBrowser.c"
						GeeHashSet* _tmp36_;
						const gchar* _tmp37_;
#line 385 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp36_ = column_set;
#line 385 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp37_ = grouping;
#line 385 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp34_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp36_, _tmp37_);
#line 1483 "ColumnBrowser.c"
					} else {
#line 385 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp34_ = FALSE;
#line 1487 "ColumnBrowser.c"
					}
#line 385 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (_tmp34_) {
#line 1491 "ColumnBrowser.c"
						GeeHashSet* _tmp38_;
						const gchar* _tmp39_;
#line 386 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp38_ = column_set;
#line 386 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp39_ = grouping;
#line 386 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp38_, _tmp39_);
#line 1500 "ColumnBrowser.c"
					}
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_free0 (grouping);
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_object_unref0 (m);
#line 1506 "ColumnBrowser.c"
				}
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_m_it);
#line 1510 "ColumnBrowser.c"
			}
#line 388 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 1514 "ColumnBrowser.c"
		}
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER:
#line 1518 "ColumnBrowser.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp40_;
				GeeIterator* _tmp41_;
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp40_ = self->priv->search_results;
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp41_ = gee_iterable_iterator ((GeeIterable*) _tmp40_);
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_m_it = _tmp41_;
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				while (TRUE) {
#line 1532 "ColumnBrowser.c"
					GeeIterator* _tmp42_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp43_;
					gpointer _tmp44_;
					gchar* composer = NULL;
					MusicMedia* _tmp45_;
					gchar* _tmp46_;
					GeeHashSet* _tmp47_;
					const gchar* _tmp48_;
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp42_ = _m_it;
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_iterator_next (_tmp42_)) {
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1548 "ColumnBrowser.c"
					}
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp43_ = _m_it;
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp44_ = gee_iterator_get (_tmp43_);
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					m = (MusicMedia*) _tmp44_;
#line 392 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp45_ = m;
#line 392 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp46_ = music_media_get_display_composer (_tmp45_);
#line 392 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					composer = _tmp46_;
#line 393 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp47_ = column_set;
#line 393 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp48_ = composer;
#line 393 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp47_, _tmp48_)) {
#line 1568 "ColumnBrowser.c"
						GeeHashSet* _tmp49_;
						const gchar* _tmp50_;
#line 394 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp49_ = column_set;
#line 394 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp50_ = composer;
#line 394 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp49_, _tmp50_);
#line 1577 "ColumnBrowser.c"
					}
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_free0 (composer);
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_object_unref0 (m);
#line 1583 "ColumnBrowser.c"
				}
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_m_it);
#line 1587 "ColumnBrowser.c"
			}
#line 396 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 1591 "ColumnBrowser.c"
		}
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM:
#line 1595 "ColumnBrowser.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp51_;
				GeeIterator* _tmp52_;
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp51_ = self->priv->search_results;
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp52_ = gee_iterable_iterator ((GeeIterable*) _tmp51_);
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_m_it = _tmp52_;
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				while (TRUE) {
#line 1609 "ColumnBrowser.c"
					GeeIterator* _tmp53_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp54_;
					gpointer _tmp55_;
					gchar* album = NULL;
					MusicMedia* _tmp56_;
					gchar* _tmp57_;
					GeeHashSet* _tmp58_;
					const gchar* _tmp59_;
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp53_ = _m_it;
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_iterator_next (_tmp53_)) {
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1625 "ColumnBrowser.c"
					}
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp54_ = _m_it;
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp55_ = gee_iterator_get (_tmp54_);
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					m = (MusicMedia*) _tmp55_;
#line 400 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp56_ = m;
#line 400 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp57_ = music_media_get_display_album (_tmp56_);
#line 400 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					album = _tmp57_;
#line 401 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp58_ = column_set;
#line 401 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp59_ = album;
#line 401 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp58_, _tmp59_)) {
#line 1645 "ColumnBrowser.c"
						GeeHashSet* _tmp60_;
						const gchar* _tmp61_;
#line 402 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp60_ = column_set;
#line 402 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp61_ = album;
#line 402 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp60_, _tmp61_);
#line 1654 "ColumnBrowser.c"
					}
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_free0 (album);
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_object_unref0 (m);
#line 1660 "ColumnBrowser.c"
				}
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_m_it);
#line 1664 "ColumnBrowser.c"
			}
#line 404 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 1668 "ColumnBrowser.c"
		}
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_YEAR:
#line 1672 "ColumnBrowser.c"
		{
			GeeHashSet* numeric_set = NULL;
			GeeHashSet* _tmp62_;
#line 408 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp62_ = gee_hash_set_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 408 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			numeric_set = _tmp62_;
#line 1680 "ColumnBrowser.c"
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp63_;
				GeeIterator* _tmp64_;
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp63_ = self->priv->search_results;
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp64_ = gee_iterable_iterator ((GeeIterable*) _tmp63_);
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_m_it = _tmp64_;
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				while (TRUE) {
#line 1693 "ColumnBrowser.c"
					GeeIterator* _tmp65_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp66_;
					gpointer _tmp67_;
					guint year = 0U;
					MusicMedia* _tmp68_;
					guint _tmp69_;
					guint _tmp70_;
					gboolean _tmp71_ = FALSE;
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp65_ = _m_it;
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_iterator_next (_tmp65_)) {
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1709 "ColumnBrowser.c"
					}
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp66_ = _m_it;
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp67_ = gee_iterator_get (_tmp66_);
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					m = (MusicMedia*) _tmp67_;
#line 410 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp68_ = m;
#line 410 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp69_ = music_media_get_year (_tmp68_);
#line 410 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp70_ = _tmp69_;
#line 410 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					year = _tmp70_;
#line 411 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (year > ((guint) 0)) {
#line 1727 "ColumnBrowser.c"
						GeeHashSet* _tmp72_;
#line 411 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp72_ = numeric_set;
#line 411 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp71_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp72_, (gpointer) ((guintptr) year));
#line 1733 "ColumnBrowser.c"
					} else {
#line 411 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp71_ = FALSE;
#line 1737 "ColumnBrowser.c"
					}
#line 411 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (_tmp71_) {
#line 1741 "ColumnBrowser.c"
						GeeHashSet* _tmp73_;
						GeeHashSet* _tmp74_;
						gchar* _tmp75_;
						gchar* _tmp76_;
#line 412 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp73_ = numeric_set;
#line 412 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp73_, (gpointer) ((guintptr) year));
#line 413 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp74_ = column_set;
#line 413 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp75_ = g_strdup_printf ("%u", year);
#line 413 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp76_ = _tmp75_;
#line 413 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp74_, _tmp76_);
#line 413 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_g_free0 (_tmp76_);
#line 1760 "ColumnBrowser.c"
					}
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_object_unref0 (m);
#line 1764 "ColumnBrowser.c"
				}
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_m_it);
#line 1768 "ColumnBrowser.c"
			}
#line 416 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (numeric_set);
#line 416 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 1774 "ColumnBrowser.c"
		}
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_RATING:
#line 1778 "ColumnBrowser.c"
		{
			GeeHashSet* numeric_set = NULL;
			GeeHashSet* _tmp77_;
#line 420 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp77_ = gee_hash_set_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 420 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			numeric_set = _tmp77_;
#line 1786 "ColumnBrowser.c"
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp78_;
				GeeIterator* _tmp79_;
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp78_ = self->priv->search_results;
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp79_ = gee_iterable_iterator ((GeeIterable*) _tmp78_);
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_m_it = _tmp79_;
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				while (TRUE) {
#line 1799 "ColumnBrowser.c"
					GeeIterator* _tmp80_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp81_;
					gpointer _tmp82_;
					guint rating = 0U;
					MusicMedia* _tmp83_;
					guint _tmp84_;
					guint _tmp85_;
					GeeHashSet* _tmp86_;
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp80_ = _m_it;
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_iterator_next (_tmp80_)) {
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1815 "ColumnBrowser.c"
					}
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp81_ = _m_it;
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp82_ = gee_iterator_get (_tmp81_);
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					m = (MusicMedia*) _tmp82_;
#line 422 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp83_ = m;
#line 422 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp84_ = music_media_get_rating (_tmp83_);
#line 422 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp85_ = _tmp84_;
#line 422 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					rating = _tmp85_;
#line 423 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp86_ = numeric_set;
#line 423 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp86_, (gpointer) ((guintptr) rating))) {
#line 1835 "ColumnBrowser.c"
						GeeHashSet* _tmp87_;
						gchar* rating_str = NULL;
						GeeHashSet* _tmp90_;
						const gchar* _tmp91_;
#line 424 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp87_ = numeric_set;
#line 424 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp87_, (gpointer) ((guintptr) rating));
#line 427 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						if (rating < ((guint) 1)) {
#line 1846 "ColumnBrowser.c"
							gchar* _tmp88_;
#line 428 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp88_ = g_strdup (_ ("Unrated"));
#line 428 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_g_free0 (rating_str);
#line 428 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							rating_str = _tmp88_;
#line 1854 "ColumnBrowser.c"
						} else {
							gchar* _tmp89_;
#line 430 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp89_ = g_strdup_printf (ngettext ("%u Star", "%u Stars", (gulong) rating), rating);
#line 430 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_g_free0 (rating_str);
#line 430 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							rating_str = _tmp89_;
#line 1863 "ColumnBrowser.c"
						}
#line 432 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp90_ = column_set;
#line 432 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp91_ = rating_str;
#line 432 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp90_, _tmp91_);
#line 423 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_g_free0 (rating_str);
#line 1873 "ColumnBrowser.c"
					}
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_object_unref0 (m);
#line 1877 "ColumnBrowser.c"
				}
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_m_it);
#line 1881 "ColumnBrowser.c"
			}
#line 435 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (numeric_set);
#line 435 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 1887 "ColumnBrowser.c"
		}
		default:
		{
#line 438 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			g_assert_not_reached ();
#line 1893 "ColumnBrowser.c"
		}
	}
#line 441 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp92_ = column_set;
#line 441 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_browser_column_populate (column, _tmp92_);
#line 448 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp93_ = music_browser_column_get_category (column);
#line 448 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp94_ = _tmp93_;
#line 448 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_column_browser_update_search_results (self, _tmp94_);
#line 360 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (column_set);
#line 1908 "ColumnBrowser.c"
}

gboolean
music_column_browser_match_media (MusicColumnBrowser* self,
                                  MusicMedia* m)
{
	gint rating = 0;
	gint year = 0;
	gchar* genre = NULL;
	gchar* album_artist = NULL;
	gchar* album = NULL;
	gchar* grouping = NULL;
	gchar* composer = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gboolean result;
#line 451 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 451 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (m != NULL, FALSE);
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_column_browser_get_filters (self, music_browser_column_category_last (), &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	rating = _tmp0_;
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	year = _tmp1_;
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (genre);
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	genre = _tmp2_;
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (album_artist);
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	album_artist = _tmp3_;
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (album);
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	album = _tmp4_;
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (grouping);
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	grouping = _tmp5_;
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (composer);
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	composer = _tmp6_;
#line 463 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = music_search_match_fields_to_media (m, album_artist, album, genre, grouping, composer, year, rating);
#line 463 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (composer);
#line 463 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (grouping);
#line 463 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (album);
#line 463 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (album_artist);
#line 463 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (genre);
#line 463 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 1974 "ColumnBrowser.c"
}

static void
music_column_browser_update_column_separators (MusicColumnBrowser* self)
{
	guint n_visible_columns = 0U;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	GeeTreeSet* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	guint _tmp5_;
	MusicBrowserColumnCategory first_col = 0;
#line 467 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 468 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = music_column_browser_get_visible_columns (self);
#line 468 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = _tmp0_;
#line 468 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = _tmp1_;
#line 468 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 468 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp4_ = _tmp3_;
#line 468 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp5_ = (guint) _tmp4_;
#line 468 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (_tmp2_);
#line 468 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	n_visible_columns = _tmp5_;
#line 471 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	first_col = music_browser_column_category_first ();
#line 2008 "ColumnBrowser.c"
	{
		GeeIterator* _col_it = NULL;
		GeeTreeSet* _tmp6_;
		GeeTreeSet* _tmp7_;
		GeeTreeSet* _tmp8_;
		GeeIterator* _tmp9_;
		GeeIterator* _tmp10_;
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp6_ = music_column_browser_get_visible_columns (self);
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp7_ = _tmp6_;
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp8_ = _tmp7_;
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp9_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp8_);
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp10_ = _tmp9_;
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_tmp8_);
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_col_it = _tmp10_;
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 2032 "ColumnBrowser.c"
			GeeIterator* _tmp11_;
			MusicBrowserColumnCategory col = 0;
			GeeIterator* _tmp12_;
			gpointer _tmp13_;
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp11_ = _col_it;
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp11_)) {
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 2043 "ColumnBrowser.c"
			}
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp12_ = _col_it;
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp13_ = gee_iterator_get (_tmp12_);
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			col = (MusicBrowserColumnCategory) ((gintptr) _tmp13_);
#line 473 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (col > first_col) {
#line 474 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				first_col = col;
#line 2055 "ColumnBrowser.c"
			}
		}
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_col_it);
#line 2060 "ColumnBrowser.c"
	}
	{
		GeeIterator* _col_it = NULL;
		GeeTreeSet* _tmp14_;
		GeeIterator* _tmp15_;
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp14_ = self->priv->_columns;
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp14_);
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_col_it = _tmp15_;
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 2074 "ColumnBrowser.c"
			GeeIterator* _tmp16_;
			MusicBrowserColumn* col = NULL;
			GeeIterator* _tmp17_;
			gpointer _tmp18_;
			gboolean _tmp19_ = FALSE;
			MusicBrowserColumn* _tmp20_;
			MusicBrowserColumnCategory _tmp21_;
			MusicBrowserColumnCategory _tmp22_;
			MusicBrowserColumn* _tmp23_;
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp16_ = _col_it;
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp16_)) {
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 2090 "ColumnBrowser.c"
			}
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp17_ = _col_it;
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp18_ = gee_iterator_get (_tmp17_);
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			col = (MusicBrowserColumn*) _tmp18_;
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp20_ = col;
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp21_ = music_browser_column_get_category (_tmp20_);
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp22_ = _tmp21_;
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (_tmp22_ != first_col) {
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp19_ = n_visible_columns > ((guint) 1);
#line 2108 "ColumnBrowser.c"
			} else {
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp19_ = FALSE;
#line 2112 "ColumnBrowser.c"
			}
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp23_ = col;
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			music_browser_column_set_show_separator (_tmp23_, _tmp19_);
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (col);
#line 2120 "ColumnBrowser.c"
		}
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_col_it);
#line 2124 "ColumnBrowser.c"
	}
}

static void
music_column_browser_column_header_clicked (MusicColumnBrowser* self,
                                            GdkEventButton* e)
{
#line 481 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 481 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (e != NULL);
#line 482 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (e->button == ((guint) GDK_BUTTON_SECONDARY)) {
#line 2138 "ColumnBrowser.c"
		GtkMenu* _tmp0_;
#line 483 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp0_ = self->priv->column_chooser_menu;
#line 483 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		gtk_menu_popup_at_pointer (_tmp0_, (GdkEvent*) e);
#line 2144 "ColumnBrowser.c"
	}
}

static void
_vala_array_add5 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 491 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if ((*length) == (*size)) {
#line 491 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 491 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2160 "ColumnBrowser.c"
	}
#line 491 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[(*length)++] = value;
#line 491 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[*length] = NULL;
#line 2166 "ColumnBrowser.c"
}

static void
music_column_browser_save_current_state (MusicColumnBrowser* self)
{
	gchar** visible_categories = NULL;
	gchar** _tmp0_;
	gint visible_categories_length1;
	gint _visible_categories_size_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	GSettings* _tmp13_;
	GSettings* _tmp14_;
	MusicColumnBrowserPosition _tmp15_;
	MusicColumnBrowserPosition _tmp16_;
#line 487 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 488 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 488 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	visible_categories = _tmp0_;
#line 488 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	visible_categories_length1 = 0;
#line 488 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_visible_categories_size_ = visible_categories_length1;
#line 2194 "ColumnBrowser.c"
	{
		GeeIterator* _col_cat_it = NULL;
		GeeTreeSet* _tmp1_;
		GeeTreeSet* _tmp2_;
		GeeTreeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp1_ = music_column_browser_get_visible_columns (self);
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp2_ = _tmp1_;
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp3_ = _tmp2_;
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp4_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp3_);
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp5_ = _tmp4_;
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_tmp3_);
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_col_cat_it = _tmp5_;
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 2218 "ColumnBrowser.c"
			GeeIterator* _tmp6_;
			MusicBrowserColumnCategory col_cat = 0;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			gchar* _tmp9_;
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp6_ = _col_cat_it;
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 2230 "ColumnBrowser.c"
			}
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp7_ = _col_cat_it;
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			col_cat = (MusicBrowserColumnCategory) ((gintptr) _tmp8_);
#line 491 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp9_ = g_strdup_printf ("%i", (gint) col_cat);
#line 491 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_vala_array_add5 (&visible_categories, &visible_categories_length1, &_visible_categories_size_, _tmp9_);
#line 2242 "ColumnBrowser.c"
		}
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_col_cat_it);
#line 2246 "ColumnBrowser.c"
	}
#line 494 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp10_ = music_app_get_saved_state ();
#line 494 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp11_ = _tmp10_;
#line 494 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp12_ = visible_categories;
#line 494 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp12__length1 = visible_categories_length1;
#line 494 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_settings_set_strv (_tmp11_, "column-browser-visible-columns", _tmp12_);
#line 495 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp13_ = music_app_get_saved_state ();
#line 495 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp14_ = _tmp13_;
#line 495 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp15_ = music_column_browser_get_position (self);
#line 495 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp16_ = _tmp15_;
#line 495 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_settings_set_int (_tmp14_, "column-browser-position", (gint) _tmp16_);
#line 487 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	visible_categories = (_vala_array_free (visible_categories, visible_categories_length1, (GDestroyNotify) g_free), NULL);
#line 2270 "ColumnBrowser.c"
}

MusicColumnBrowserPosition
music_column_browser_get_position (MusicColumnBrowser* self)
{
	MusicColumnBrowserPosition result;
#line 42 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 43 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = self->priv->_position;
#line 43 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 2283 "ColumnBrowser.c"
}

void
music_column_browser_set_position (MusicColumnBrowser* self,
                                   MusicColumnBrowserPosition value)
{
#line 45 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->_position = value;
#line 48 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_emit (self, music_column_browser_signals[MUSIC_COLUMN_BROWSER_POSITION_CHANGED_SIGNAL], 0, self->priv->_position);
#line 50 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	switch (self->priv->_position) {
#line 50 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_COLUMN_BROWSER_POSITION_AUTOMATIC:
#line 2300 "ColumnBrowser.c"
		{
			GtkRadioMenuItem* _tmp0_;
#line 52 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp0_ = self->priv->automatic_menu_item;
#line 52 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			gtk_check_menu_item_set_active ((GtkCheckMenuItem*) _tmp0_, TRUE);
#line 53 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 2309 "ColumnBrowser.c"
		}
#line 50 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_COLUMN_BROWSER_POSITION_LEFT:
#line 2313 "ColumnBrowser.c"
		{
			GtkRadioMenuItem* _tmp1_;
#line 55 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp1_ = self->priv->left_menu_item;
#line 55 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			gtk_check_menu_item_set_active ((GtkCheckMenuItem*) _tmp1_, TRUE);
#line 56 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 2322 "ColumnBrowser.c"
		}
#line 50 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_COLUMN_BROWSER_POSITION_TOP:
#line 2326 "ColumnBrowser.c"
		{
			GtkRadioMenuItem* _tmp2_;
#line 58 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp2_ = self->priv->top_menu_item;
#line 58 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			gtk_check_menu_item_set_active ((GtkCheckMenuItem*) _tmp2_, TRUE);
#line 59 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 2335 "ColumnBrowser.c"
		}
		default:
		{
#line 61 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			g_assert_not_reached ();
#line 2341 "ColumnBrowser.c"
		}
	}
#line 45 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_notify_by_pspec ((GObject *) self, music_column_browser_properties[MUSIC_COLUMN_BROWSER_POSITION_PROPERTY]);
#line 2346 "ColumnBrowser.c"
}

MusicColumnBrowserPosition
music_column_browser_get_actual_position (MusicColumnBrowser* self)
{
	MusicColumnBrowserPosition result;
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = self->priv->_actual_position;
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 2359 "ColumnBrowser.c"
}

void
music_column_browser_set_actual_position (MusicColumnBrowser* self,
                                          MusicColumnBrowserPosition value)
{
	MusicColumnBrowserPosition old_value;
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	old_value = music_column_browser_get_actual_position (self);
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (old_value != value) {
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		self->priv->_actual_position = value;
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_object_notify_by_pspec ((GObject *) self, music_column_browser_properties[MUSIC_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY]);
#line 2377 "ColumnBrowser.c"
	}
}

MusicViewWrapper*
music_column_browser_get_view_wrapper (MusicColumnBrowser* self)
{
	MusicViewWrapper* result;
	MusicViewWrapper* _tmp0_;
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->_view_wrapper;
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = _tmp0_;
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 2394 "ColumnBrowser.c"
}

static void
music_column_browser_set_view_wrapper (MusicColumnBrowser* self,
                                       MusicViewWrapper* value)
{
	MusicViewWrapper* old_value;
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	old_value = music_column_browser_get_view_wrapper (self);
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (old_value != value) {
#line 2408 "ColumnBrowser.c"
		MusicViewWrapper* _tmp0_;
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (self->priv->_view_wrapper);
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		self->priv->_view_wrapper = _tmp0_;
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_object_notify_by_pspec ((GObject *) self, music_column_browser_properties[MUSIC_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY]);
#line 2418 "ColumnBrowser.c"
	}
}

gboolean
music_column_browser_get_filtered (MusicColumnBrowser* self)
{
	gboolean result;
#line 76 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2428 "ColumnBrowser.c"
	{
		GeeIterator* _col_it = NULL;
		GeeTreeSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp0_ = self->priv->_columns;
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_col_it = _tmp1_;
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 2441 "ColumnBrowser.c"
			GeeIterator* _tmp2_;
			MusicBrowserColumn* col = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			MusicBrowserColumn* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp2_ = _col_it;
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 2455 "ColumnBrowser.c"
			}
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp3_ = _col_it;
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			col = (MusicBrowserColumn*) _tmp4_;
#line 78 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp5_ = col;
#line 78 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp6_ = music_browser_column_get_first_item_selected (_tmp5_);
#line 78 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp7_ = _tmp6_;
#line 78 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!_tmp7_) {
#line 79 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				result = TRUE;
#line 79 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (col);
#line 79 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_col_it);
#line 79 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				return result;
#line 2479 "ColumnBrowser.c"
			}
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (col);
#line 2483 "ColumnBrowser.c"
		}
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_col_it);
#line 2487 "ColumnBrowser.c"
	}
#line 81 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = FALSE;
#line 81 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 2493 "ColumnBrowser.c"
}

GeeTreeSet*
music_column_browser_get_visible_columns (MusicColumnBrowser* self)
{
	GeeTreeSet* result;
	GeeTreeSet* visible_columns = NULL;
	GeeTreeSet* _tmp0_;
#line 86 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 87 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_BROWSER_COLUMN_TYPE_CATEGORY, NULL, NULL, NULL, NULL, NULL);
#line 87 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	visible_columns = _tmp0_;
#line 2508 "ColumnBrowser.c"
	{
		GeeIterator* _column_it = NULL;
		GeeTreeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp1_ = self->priv->_columns;
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_column_it = _tmp2_;
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 2521 "ColumnBrowser.c"
			GeeIterator* _tmp3_;
			MusicBrowserColumn* column = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			MusicBrowserColumn* _tmp6_;
			gboolean _tmp7_;
			gboolean _tmp8_;
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp3_ = _column_it;
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 2535 "ColumnBrowser.c"
			}
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp4_ = _column_it;
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			column = (MusicBrowserColumn*) _tmp5_;
#line 89 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp6_ = column;
#line 89 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp7_ = music_browser_column_get_visible (_tmp6_);
#line 89 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp8_ = _tmp7_;
#line 89 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (_tmp8_) {
#line 2551 "ColumnBrowser.c"
				GeeTreeSet* _tmp9_;
				MusicBrowserColumn* _tmp10_;
				MusicBrowserColumnCategory _tmp11_;
				MusicBrowserColumnCategory _tmp12_;
#line 90 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp9_ = visible_columns;
#line 90 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp10_ = column;
#line 90 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp11_ = music_browser_column_get_category (_tmp10_);
#line 90 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp12_ = _tmp11_;
#line 90 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, (gpointer) ((gintptr) _tmp12_));
#line 2566 "ColumnBrowser.c"
			}
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (column);
#line 2570 "ColumnBrowser.c"
		}
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_column_it);
#line 2574 "ColumnBrowser.c"
	}
#line 92 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = visible_columns;
#line 92 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 2580 "ColumnBrowser.c"
}

void
music_column_browser_set_visible_columns (MusicColumnBrowser* self,
                                          GeeTreeSet* value)
{
	gboolean no_column_enabled = FALSE;
#line 94 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	no_column_enabled = TRUE;
#line 2592 "ColumnBrowser.c"
	{
		GeeIterator* _column_it = NULL;
		GeeTreeSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp0_ = self->priv->_columns;
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_column_it = _tmp1_;
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 2605 "ColumnBrowser.c"
			GeeIterator* _tmp2_;
			MusicBrowserColumn* column = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			gboolean column_visible = FALSE;
			MusicBrowserColumn* _tmp12_;
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp2_ = _column_it;
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 2618 "ColumnBrowser.c"
			}
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp3_ = _column_it;
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			column = (MusicBrowserColumn*) _tmp4_;
#line 100 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			column_visible = FALSE;
#line 2628 "ColumnBrowser.c"
			{
				GeeIterator* _category_it = NULL;
				GeeIterator* _tmp5_;
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp5_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) value);
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_category_it = _tmp5_;
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				while (TRUE) {
#line 2638 "ColumnBrowser.c"
					GeeIterator* _tmp6_;
					MusicBrowserColumnCategory category = 0;
					GeeIterator* _tmp7_;
					gpointer _tmp8_;
					MusicBrowserColumn* _tmp9_;
					MusicBrowserColumnCategory _tmp10_;
					MusicBrowserColumnCategory _tmp11_;
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp6_ = _category_it;
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_iterator_next (_tmp6_)) {
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 2652 "ColumnBrowser.c"
					}
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp7_ = _category_it;
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp8_ = gee_iterator_get (_tmp7_);
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					category = (MusicBrowserColumnCategory) ((gintptr) _tmp8_);
#line 103 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp9_ = column;
#line 103 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp10_ = music_browser_column_get_category (_tmp9_);
#line 103 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp11_ = _tmp10_;
#line 103 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (_tmp11_ == category) {
#line 104 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						column_visible = TRUE;
#line 105 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 2672 "ColumnBrowser.c"
					}
				}
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_category_it);
#line 2677 "ColumnBrowser.c"
			}
#line 109 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp12_ = column;
#line 109 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			music_browser_column_set_visible (_tmp12_, column_visible);
#line 111 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (column_visible) {
#line 112 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				no_column_enabled = FALSE;
#line 2687 "ColumnBrowser.c"
			}
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (column);
#line 2691 "ColumnBrowser.c"
		}
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_column_it);
#line 2695 "ColumnBrowser.c"
	}
#line 116 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (no_column_enabled) {
#line 2699 "ColumnBrowser.c"
		MusicBrowserColumn* col = NULL;
		GeeTreeSet* _tmp13_;
		gpointer _tmp14_;
		MusicBrowserColumn* _tmp15_;
#line 117 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp13_ = self->priv->_columns;
#line 117 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp14_ = gee_abstract_sorted_set_first ((GeeAbstractSortedSet*) _tmp13_);
#line 117 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		col = (MusicBrowserColumn*) _tmp14_;
#line 118 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp15_ = col;
#line 118 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		if (_tmp15_ != NULL) {
#line 2714 "ColumnBrowser.c"
			MusicBrowserColumn* _tmp16_;
#line 119 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp16_ = col;
#line 119 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			music_browser_column_set_visible (_tmp16_, TRUE);
#line 2720 "ColumnBrowser.c"
		}
#line 116 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (col);
#line 2724 "ColumnBrowser.c"
	}
#line 94 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_notify_by_pspec ((GObject *) self, music_column_browser_properties[MUSIC_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY]);
#line 2728 "ColumnBrowser.c"
}

gboolean
music_column_browser_get_initialized (MusicColumnBrowser* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	GeeLinkedList* _tmp1_;
#line 124 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 124 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = self->priv->media;
#line 124 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (_tmp1_ == NULL) {
#line 124 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp0_ = TRUE;
#line 2745 "ColumnBrowser.c"
	} else {
		GeeCollection* _tmp2_;
#line 124 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp2_ = self->priv->search_results;
#line 124 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 2752 "ColumnBrowser.c"
	}
#line 124 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = _tmp0_;
#line 124 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 2758 "ColumnBrowser.c"
}

GeeTreeSet*
music_column_browser_get_columns (MusicColumnBrowser* self)
{
	GeeTreeSet* result;
	GeeTreeSet* _tmp0_;
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->_columns;
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = _tmp0_;
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 2774 "ColumnBrowser.c"
}

static void
music_column_browser_set_columns (MusicColumnBrowser* self,
                                  GeeTreeSet* value)
{
	GeeTreeSet* old_value;
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	old_value = music_column_browser_get_columns (self);
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (old_value != value) {
#line 2788 "ColumnBrowser.c"
		GeeTreeSet* _tmp0_;
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (self->priv->_columns);
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		self->priv->_columns = _tmp0_;
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_object_notify_by_pspec ((GObject *) self, music_column_browser_properties[MUSIC_COLUMN_BROWSER_COLUMNS_PROPERTY]);
#line 2798 "ColumnBrowser.c"
	}
}

static void
_g_object_unref0_ (gpointer var)
{
#line 145 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2807 "ColumnBrowser.c"
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 145 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 2815 "ColumnBrowser.c"
}

static void
_vala_array_add6 (MusicBrowserColumnCategory* * array,
                  gint* length,
                  gint* size,
                  MusicBrowserColumnCategory value)
{
#line 152 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if ((*length) == (*size)) {
#line 152 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 152 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*array = g_renew (MusicBrowserColumnCategory, *array, *size);
#line 2830 "ColumnBrowser.c"
	}
#line 152 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[(*length)++] = value;
#line 2834 "ColumnBrowser.c"
}

static void
_vala_array_add7 (MusicBrowserColumnCategory* * array,
                  gint* length,
                  gint* size,
                  MusicBrowserColumnCategory value)
{
#line 153 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if ((*length) == (*size)) {
#line 153 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 153 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*array = g_renew (MusicBrowserColumnCategory, *array, *size);
#line 2849 "ColumnBrowser.c"
	}
#line 153 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[(*length)++] = value;
#line 2853 "ColumnBrowser.c"
}

static void
_vala_array_add8 (MusicBrowserColumnCategory* * array,
                  gint* length,
                  gint* size,
                  MusicBrowserColumnCategory value)
{
#line 154 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if ((*length) == (*size)) {
#line 154 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 154 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*array = g_renew (MusicBrowserColumnCategory, *array, *size);
#line 2868 "ColumnBrowser.c"
	}
#line 154 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[(*length)++] = value;
#line 2872 "ColumnBrowser.c"
}

static void
_vala_array_add9 (MusicBrowserColumnCategory* * array,
                  gint* length,
                  gint* size,
                  MusicBrowserColumnCategory value)
{
#line 155 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if ((*length) == (*size)) {
#line 155 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 155 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*array = g_renew (MusicBrowserColumnCategory, *array, *size);
#line 2887 "ColumnBrowser.c"
	}
#line 155 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[(*length)++] = value;
#line 2891 "ColumnBrowser.c"
}

static void
_vala_array_add10 (MusicBrowserColumnCategory* * array,
                   gint* length,
                   gint* size,
                   MusicBrowserColumnCategory value)
{
#line 156 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if ((*length) == (*size)) {
#line 156 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 156 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*array = g_renew (MusicBrowserColumnCategory, *array, *size);
#line 2906 "ColumnBrowser.c"
	}
#line 156 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[(*length)++] = value;
#line 2910 "ColumnBrowser.c"
}

static void
_vala_array_add11 (MusicBrowserColumnCategory* * array,
                   gint* length,
                   gint* size,
                   MusicBrowserColumnCategory value)
{
#line 157 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if ((*length) == (*size)) {
#line 157 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 157 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*array = g_renew (MusicBrowserColumnCategory, *array, *size);
#line 2925 "ColumnBrowser.c"
	}
#line 157 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[(*length)++] = value;
#line 2929 "ColumnBrowser.c"
}

static void
_vala_array_add12 (MusicBrowserColumnCategory* * array,
                   gint* length,
                   gint* size,
                   MusicBrowserColumnCategory value)
{
#line 158 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if ((*length) == (*size)) {
#line 158 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 158 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*array = g_renew (MusicBrowserColumnCategory, *array, *size);
#line 2944 "ColumnBrowser.c"
	}
#line 158 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[(*length)++] = value;
#line 2948 "ColumnBrowser.c"
}

static void
_music_column_browser___lambda68_ (MusicColumnBrowser* self)
{
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 184 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->automatic_menu_item;
#line 184 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
#line 184 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = _tmp1_;
#line 184 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (_tmp2_) {
#line 185 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		music_column_browser_set_position (self, MUSIC_COLUMN_BROWSER_POSITION_AUTOMATIC);
#line 2967 "ColumnBrowser.c"
	}
}

static void
__music_column_browser___lambda68__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self)
{
#line 183 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_music_column_browser___lambda68_ ((MusicColumnBrowser*) self);
#line 2977 "ColumnBrowser.c"
}

static void
_music_column_browser___lambda69_ (MusicColumnBrowser* self)
{
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 190 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->left_menu_item;
#line 190 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
#line 190 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = _tmp1_;
#line 190 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (_tmp2_) {
#line 191 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		music_column_browser_set_position (self, MUSIC_COLUMN_BROWSER_POSITION_LEFT);
#line 2996 "ColumnBrowser.c"
	}
}

static void
__music_column_browser___lambda69__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self)
{
#line 189 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_music_column_browser___lambda69_ ((MusicColumnBrowser*) self);
#line 3006 "ColumnBrowser.c"
}

static void
_music_column_browser___lambda70_ (MusicColumnBrowser* self)
{
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 196 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->top_menu_item;
#line 196 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
#line 196 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = _tmp1_;
#line 196 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (_tmp2_) {
#line 197 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		music_column_browser_set_position (self, MUSIC_COLUMN_BROWSER_POSITION_TOP);
#line 3025 "ColumnBrowser.c"
	}
}

static void
__music_column_browser___lambda70__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self)
{
#line 195 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_music_column_browser___lambda70_ ((MusicColumnBrowser*) self);
#line 3035 "ColumnBrowser.c"
}

static void
_music_column_browser_save_current_state_gtk_widget_destroy (GtkWidget* _sender,
                                                             gpointer self)
{
#line 201 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_column_browser_save_current_state ((MusicColumnBrowser*) self);
#line 3044 "ColumnBrowser.c"
}

static GObject *
music_column_browser_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicColumnBrowser * self;
	GSList* _tmp0_;
	GtkRadioMenuItem* _tmp1_;
	GtkRadioMenuItem* _tmp2_;
	GSList* _tmp3_;
	GtkRadioMenuItem* _tmp4_;
	GtkRadioMenuItem* _tmp5_;
	GSList* _tmp6_;
	GtkRadioMenuItem* _tmp7_;
	GtkMenu* _tmp8_;
	MusicBrowserColumnCategory* categories = NULL;
	MusicBrowserColumnCategory* _tmp9_;
	gint categories_length1;
	gint _categories_size_;
	GeeTreeSet* _tmp10_;
	GeeTreeSet* _tmp11_;
	MusicBrowserColumnCategory* _tmp12_;
	gint _tmp12__length1;
	GeeTreeSet* visible_categories = NULL;
	GeeTreeSet* _tmp15_;
	GSettings* _tmp16_;
	GSettings* _tmp17_;
	gchar** _tmp18_;
	gchar** _tmp19_;
	GeeTreeSet* _tmp23_;
	GtkMenu* _tmp24_;
	GtkSeparatorMenuItem* _tmp25_;
	GtkSeparatorMenuItem* _tmp26_;
	GtkMenu* _tmp27_;
	GtkRadioMenuItem* _tmp28_;
	GtkMenu* _tmp29_;
	GtkRadioMenuItem* _tmp30_;
	GtkMenu* _tmp31_;
	GtkRadioMenuItem* _tmp32_;
	GtkMenu* _tmp33_;
	GSettings* _tmp34_;
	GSettings* _tmp35_;
	GtkRadioMenuItem* _tmp36_;
	GtkRadioMenuItem* _tmp37_;
	GtkRadioMenuItem* _tmp38_;
#line 144 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	parent_class = G_OBJECT_CLASS (music_column_browser_parent_class);
#line 144 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 144 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowser);
#line 145 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = NULL;
#line 145 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_label (_tmp0_, _ ("Automatic"));
#line 145 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_ref_sink (_tmp1_);
#line 145 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->automatic_menu_item);
#line 145 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->automatic_menu_item = _tmp1_;
#line 145 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__g_object_unref0_ (_tmp0_), NULL));
#line 146 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = self->priv->automatic_menu_item;
#line 146 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp3_ = gtk_radio_menu_item_get_group (_tmp2_);
#line 146 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp4_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_label (_tmp3_, _ ("On Left"));
#line 146 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_ref_sink (_tmp4_);
#line 146 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->left_menu_item);
#line 146 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->left_menu_item = _tmp4_;
#line 147 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp5_ = self->priv->left_menu_item;
#line 147 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp6_ = gtk_radio_menu_item_get_group (_tmp5_);
#line 147 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp7_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_label (_tmp6_, _ ("On Top"));
#line 147 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_ref_sink (_tmp7_);
#line 147 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->top_menu_item);
#line 147 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->top_menu_item = _tmp7_;
#line 149 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp8_ = (GtkMenu*) gtk_menu_new ();
#line 149 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_ref_sink (_tmp8_);
#line 149 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->column_chooser_menu);
#line 149 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->column_chooser_menu = _tmp8_;
#line 151 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp9_ = g_new0 (MusicBrowserColumnCategory, 0);
#line 151 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	categories = _tmp9_;
#line 151 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	categories_length1 = 0;
#line 151 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_categories_size_ = categories_length1;
#line 152 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_array_add6 (&categories, &categories_length1, &_categories_size_, MUSIC_BROWSER_COLUMN_CATEGORY_RATING);
#line 153 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_array_add7 (&categories, &categories_length1, &_categories_size_, MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING);
#line 154 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_array_add8 (&categories, &categories_length1, &_categories_size_, MUSIC_BROWSER_COLUMN_CATEGORY_YEAR);
#line 155 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_array_add9 (&categories, &categories_length1, &_categories_size_, MUSIC_BROWSER_COLUMN_CATEGORY_GENRE);
#line 156 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_array_add10 (&categories, &categories_length1, &_categories_size_, MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER);
#line 157 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_array_add11 (&categories, &categories_length1, &_categories_size_, MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST);
#line 158 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_array_add12 (&categories, &categories_length1, &_categories_size_, MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM);
#line 160 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp10_ = gee_tree_set_new (MUSIC_TYPE_BROWSER_COLUMN, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 160 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp11_ = _tmp10_;
#line 160 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_column_browser_set_columns (self, _tmp11_);
#line 160 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (_tmp11_);
#line 162 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp12_ = categories;
#line 162 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp12__length1 = categories_length1;
#line 3178 "ColumnBrowser.c"
	{
		MusicBrowserColumnCategory* category_collection = NULL;
		gint category_collection_length1 = 0;
		gint _category_collection_size_ = 0;
		gint category_it = 0;
#line 162 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		category_collection = _tmp12_;
#line 162 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		category_collection_length1 = _tmp12__length1;
#line 162 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		for (category_it = 0; category_it < category_collection_length1; category_it = category_it + 1) {
#line 3190 "ColumnBrowser.c"
			MusicBrowserColumnCategory category = 0;
#line 162 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			category = category_collection[category_it];
#line 3194 "ColumnBrowser.c"
			{
				MusicBrowserColumn* _tmp13_;
				MusicBrowserColumn* _tmp14_;
#line 163 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp13_ = music_column_browser_add_column (self, category);
#line 163 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp14_ = _tmp13_;
#line 163 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_tmp14_);
#line 3204 "ColumnBrowser.c"
			}
		}
	}
#line 166 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp15_ = gee_tree_set_new (MUSIC_BROWSER_COLUMN_TYPE_CATEGORY, NULL, NULL, NULL, NULL, NULL);
#line 166 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	visible_categories = _tmp15_;
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp16_ = music_app_get_saved_state ();
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp17_ = _tmp16_;
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp19_ = _tmp18_ = g_settings_get_strv (_tmp17_, "column-browser-visible-columns");
#line 3218 "ColumnBrowser.c"
	{
		gchar** col_n_collection = NULL;
		gint col_n_collection_length1 = 0;
		gint _col_n_collection_size_ = 0;
		gint col_n_it = 0;
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		col_n_collection = _tmp19_;
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		col_n_collection_length1 = _vala_array_length (_tmp18_);
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		for (col_n_it = 0; col_n_it < col_n_collection_length1; col_n_it = col_n_it + 1) {
#line 3230 "ColumnBrowser.c"
			gchar* _tmp20_;
			gchar* col_n = NULL;
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp20_ = g_strdup (col_n_collection[col_n_it]);
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			col_n = _tmp20_;
#line 3237 "ColumnBrowser.c"
			{
				GeeTreeSet* _tmp21_;
				const gchar* _tmp22_;
#line 169 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp21_ = visible_categories;
#line 169 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp22_ = col_n;
#line 169 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, (gpointer) ((gintptr) atoi (_tmp22_)));
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_free0 (col_n);
#line 3249 "ColumnBrowser.c"
			}
		}
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		col_n_collection = (_vala_array_free (col_n_collection, col_n_collection_length1, (GDestroyNotify) g_free), NULL);
#line 3254 "ColumnBrowser.c"
	}
#line 172 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp23_ = visible_categories;
#line 172 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_column_browser_set_visible_columns (self, _tmp23_);
#line 174 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp24_ = self->priv->column_chooser_menu;
#line 174 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp25_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 174 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_ref_sink (_tmp25_);
#line 174 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp26_ = _tmp25_;
#line 174 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp24_, (GtkMenuItem*) _tmp26_);
#line 174 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (_tmp26_);
#line 175 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp27_ = self->priv->column_chooser_menu;
#line 175 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp28_ = self->priv->automatic_menu_item;
#line 175 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp27_, (GtkMenuItem*) _tmp28_);
#line 176 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp29_ = self->priv->column_chooser_menu;
#line 176 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp30_ = self->priv->top_menu_item;
#line 176 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp29_, (GtkMenuItem*) _tmp30_);
#line 177 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp31_ = self->priv->column_chooser_menu;
#line 177 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp32_ = self->priv->left_menu_item;
#line 177 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp31_, (GtkMenuItem*) _tmp32_);
#line 178 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp33_ = self->priv->column_chooser_menu;
#line 178 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp33_);
#line 180 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_HORIZONTAL);
#line 181 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp34_ = music_app_get_saved_state ();
#line 181 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp35_ = _tmp34_;
#line 181 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_column_browser_set_position (self, (MusicColumnBrowserPosition) g_settings_get_int (_tmp35_, "column-browser-position"));
#line 183 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp36_ = self->priv->automatic_menu_item;
#line 183 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_object ((GtkCheckMenuItem*) _tmp36_, "toggled", (GCallback) __music_column_browser___lambda68__gtk_check_menu_item_toggled, self, 0);
#line 189 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp37_ = self->priv->left_menu_item;
#line 189 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_object ((GtkCheckMenuItem*) _tmp37_, "toggled", (GCallback) __music_column_browser___lambda69__gtk_check_menu_item_toggled, self, 0);
#line 195 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp38_ = self->priv->top_menu_item;
#line 195 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_object ((GtkCheckMenuItem*) _tmp38_, "toggled", (GCallback) __music_column_browser___lambda70__gtk_check_menu_item_toggled, self, 0);
#line 201 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_object ((GtkWidget*) self, "destroy", (GCallback) _music_column_browser_save_current_state_gtk_widget_destroy, self, 0);
#line 144 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (visible_categories);
#line 144 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	categories = (g_free (categories), NULL);
#line 144 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return obj;
#line 3322 "ColumnBrowser.c"
}

static void
music_column_browser_class_init (MusicColumnBrowserClass * klass,
                                 gpointer klass_data)
{
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_column_browser_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_type_class_adjust_private_offset (klass, &MusicColumnBrowser_private_offset);
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_column_browser_get_property;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_column_browser_set_property;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	G_OBJECT_CLASS (klass)->constructor = music_column_browser_constructor;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	G_OBJECT_CLASS (klass)->finalize = music_column_browser_finalize;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_COLUMN_BROWSER_POSITION_PROPERTY, music_column_browser_properties[MUSIC_COLUMN_BROWSER_POSITION_PROPERTY] = g_param_spec_enum ("position", "position", "position", MUSIC_COLUMN_BROWSER_TYPE_POSITION, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY, music_column_browser_properties[MUSIC_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY] = g_param_spec_enum ("actual-position", "actual-position", "actual-position", MUSIC_COLUMN_BROWSER_TYPE_POSITION, MUSIC_COLUMN_BROWSER_POSITION_LEFT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY, music_column_browser_properties[MUSIC_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY] = g_param_spec_object ("view-wrapper", "view-wrapper", "view-wrapper", MUSIC_TYPE_VIEW_WRAPPER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 3347 "ColumnBrowser.c"
	/**
	     * Whether the columns are filtered or not based on the current selection.
	     * Although 'media.size == search_results.size' would produce a similar result,
	     * here we want to know if the "All ..." filter is selected in every column.
	     */
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_COLUMN_BROWSER_FILTERED_PROPERTY, music_column_browser_properties[MUSIC_COLUMN_BROWSER_FILTERED_PROPERTY] = g_param_spec_boolean ("filtered", "filtered", "filtered", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY, music_column_browser_properties[MUSIC_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY] = g_param_spec_object ("visible-columns", "visible-columns", "visible-columns", GEE_TYPE_TREE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_COLUMN_BROWSER_INITIALIZED_PROPERTY, music_column_browser_properties[MUSIC_COLUMN_BROWSER_INITIALIZED_PROPERTY] = g_param_spec_boolean ("initialized", "initialized", "initialized", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_COLUMN_BROWSER_COLUMNS_PROPERTY, music_column_browser_properties[MUSIC_COLUMN_BROWSER_COLUMNS_PROPERTY] = g_param_spec_object ("columns", "columns", "columns", GEE_TYPE_TREE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_column_browser_signals[MUSIC_COLUMN_BROWSER_CHANGED_SIGNAL] = g_signal_new ("changed", MUSIC_TYPE_COLUMN_BROWSER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	music_column_browser_signals[MUSIC_COLUMN_BROWSER_POSITION_CHANGED_SIGNAL] = g_signal_new ("position-changed", MUSIC_TYPE_COLUMN_BROWSER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, MUSIC_COLUMN_BROWSER_TYPE_POSITION);
#line 3365 "ColumnBrowser.c"
}

static void
music_column_browser_instance_init (MusicColumnBrowser * self,
                                    gpointer klass)
{
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv = music_column_browser_get_instance_private (self);
#line 40 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->_position = MUSIC_COLUMN_BROWSER_POSITION_AUTOMATIC;
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->_actual_position = MUSIC_COLUMN_BROWSER_POSITION_LEFT;
#line 129 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 129 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->media = _tmp0_;
#line 133 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 133 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->search_results = (GeeCollection*) _tmp1_;
#line 3388 "ColumnBrowser.c"
}

static void
music_column_browser_finalize (GObject * obj)
{
	MusicColumnBrowser * self;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowser);
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->_view_wrapper);
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->_columns);
#line 129 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->media);
#line 133 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->search_results);
#line 135 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->column_chooser_menu);
#line 136 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->top_menu_item);
#line 137 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->left_menu_item);
#line 138 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->automatic_menu_item);
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	G_OBJECT_CLASS (music_column_browser_parent_class)->finalize (obj);
#line 3415 "ColumnBrowser.c"
}

static GType
music_column_browser_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicColumnBrowserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_column_browser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicColumnBrowser), 0, (GInstanceInitFunc) music_column_browser_instance_init, NULL };
	GType music_column_browser_type_id;
	music_column_browser_type_id = g_type_register_static (gtk_grid_get_type (), "MusicColumnBrowser", &g_define_type_info, 0);
	MusicColumnBrowser_private_offset = g_type_add_instance_private (music_column_browser_type_id, sizeof (MusicColumnBrowserPrivate));
	return music_column_browser_type_id;
}

GType
music_column_browser_get_type (void)
{
	static volatile gsize music_column_browser_type_id__once = 0;
	if (g_once_init_enter (&music_column_browser_type_id__once)) {
		GType music_column_browser_type_id;
		music_column_browser_type_id = music_column_browser_get_type_once ();
		g_once_init_leave (&music_column_browser_type_id__once, music_column_browser_type_id);
	}
	return music_column_browser_type_id__once;
}

static void
_vala_music_column_browser_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	MusicColumnBrowser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowser);
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	switch (property_id) {
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_COLUMN_BROWSER_POSITION_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_value_set_enum (value, music_column_browser_get_position (self));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_value_set_enum (value, music_column_browser_get_actual_position (self));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_value_set_object (value, music_column_browser_get_view_wrapper (self));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_COLUMN_BROWSER_FILTERED_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_value_set_boolean (value, music_column_browser_get_filtered (self));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_value_take_object (value, music_column_browser_get_visible_columns (self));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_COLUMN_BROWSER_INITIALIZED_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_value_set_boolean (value, music_column_browser_get_initialized (self));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_COLUMN_BROWSER_COLUMNS_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_value_set_object (value, music_column_browser_get_columns (self));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 3492 "ColumnBrowser.c"
		default:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 3498 "ColumnBrowser.c"
	}
}

static void
_vala_music_column_browser_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	MusicColumnBrowser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowser);
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	switch (property_id) {
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_COLUMN_BROWSER_POSITION_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		music_column_browser_set_position (self, g_value_get_enum (value));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		music_column_browser_set_actual_position (self, g_value_get_enum (value));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		music_column_browser_set_view_wrapper (self, g_value_get_object (value));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		music_column_browser_set_visible_columns (self, g_value_get_object (value));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case MUSIC_COLUMN_BROWSER_COLUMNS_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		music_column_browser_set_columns (self, g_value_get_object (value));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 3542 "ColumnBrowser.c"
		default:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 3548 "ColumnBrowser.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

