/* GenericList.c generated by valac 0.56.0, the Vala compiler
 * generated from GenericList.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <handy.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

#define MUSIC_GENERIC_LIST_OPTIMAL_COLUMN -2
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_GENERIC_LIST (music_generic_list_get_type ())
#define MUSIC_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_GENERIC_LIST, MusicGenericList))
#define MUSIC_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_GENERIC_LIST, MusicGenericListClass))
#define MUSIC_IS_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_GENERIC_LIST))
#define MUSIC_IS_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_GENERIC_LIST))
#define MUSIC_GENERIC_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_GENERIC_LIST, MusicGenericListClass))

typedef struct _MusicGenericList MusicGenericList;
typedef struct _MusicGenericListClass MusicGenericListClass;
typedef struct _MusicGenericListPrivate MusicGenericListPrivate;
typedef enum  {
	MUSIC_LIST_COLUMN_ICON = 0,
	MUSIC_LIST_COLUMN_NUMBER,
	MUSIC_LIST_COLUMN_TRACK,
	MUSIC_LIST_COLUMN_TITLE,
	MUSIC_LIST_COLUMN_LENGTH,
	MUSIC_LIST_COLUMN_ARTIST,
	MUSIC_LIST_COLUMN_ALBUM,
	MUSIC_LIST_COLUMN_ALBUM_ARTIST,
	MUSIC_LIST_COLUMN_COMPOSER,
	MUSIC_LIST_COLUMN_GENRE,
	MUSIC_LIST_COLUMN_YEAR,
	MUSIC_LIST_COLUMN_GROUPING,
	MUSIC_LIST_COLUMN_BITRATE,
	MUSIC_LIST_COLUMN_RATING,
	MUSIC_LIST_COLUMN_PLAY_COUNT,
	MUSIC_LIST_COLUMN_SKIP_COUNT,
	MUSIC_LIST_COLUMN_DATE_ADDED,
	MUSIC_LIST_COLUMN_LAST_PLAYED,
	MUSIC_LIST_COLUMN_BPM,
	MUSIC_LIST_COLUMN_FILE_LOCATION,
	MUSIC_LIST_COLUMN_FILE_SIZE,
	MUSIC_LIST_COLUMN_N_COLUMNS
} MusicListColumn;

#define MUSIC_TYPE_LIST_COLUMN (music_list_column_get_type ())

#define MUSIC_TYPE_FAST_MODEL (music_fast_model_get_type ())
#define MUSIC_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_FAST_MODEL, MusicFastModel))
#define MUSIC_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_FAST_MODEL, MusicFastModelClass))
#define MUSIC_IS_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_FAST_MODEL))
#define MUSIC_IS_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_FAST_MODEL))
#define MUSIC_FAST_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_FAST_MODEL, MusicFastModelClass))

typedef struct _MusicFastModel MusicFastModel;
typedef struct _MusicFastModelClass MusicFastModelClass;

#define MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER (music_cell_data_function_helper_get_type ())
#define MUSIC_CELL_DATA_FUNCTION_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER, MusicCellDataFunctionHelper))
#define MUSIC_CELL_DATA_FUNCTION_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER, MusicCellDataFunctionHelperClass))
#define MUSIC_IS_CELL_DATA_FUNCTION_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER))
#define MUSIC_IS_CELL_DATA_FUNCTION_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER))
#define MUSIC_CELL_DATA_FUNCTION_HELPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER, MusicCellDataFunctionHelperClass))

typedef struct _MusicCellDataFunctionHelper MusicCellDataFunctionHelper;
typedef struct _MusicCellDataFunctionHelperClass MusicCellDataFunctionHelperClass;

#define MUSIC_TYPE_TREE_VIEW_SETUP (music_tree_view_setup_get_type ())
#define MUSIC_TREE_VIEW_SETUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_TREE_VIEW_SETUP, MusicTreeViewSetup))
#define MUSIC_TREE_VIEW_SETUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_TREE_VIEW_SETUP, MusicTreeViewSetupClass))
#define MUSIC_IS_TREE_VIEW_SETUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_TREE_VIEW_SETUP))
#define MUSIC_IS_TREE_VIEW_SETUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_TREE_VIEW_SETUP))
#define MUSIC_TREE_VIEW_SETUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_TREE_VIEW_SETUP, MusicTreeViewSetupClass))

typedef struct _MusicTreeViewSetup MusicTreeViewSetup;
typedef struct _MusicTreeViewSetupClass MusicTreeViewSetupClass;

#define MUSIC_TYPE_VIEW_WRAPPER (music_view_wrapper_get_type ())
#define MUSIC_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper))
#define MUSIC_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapperClass))
#define MUSIC_IS_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_VIEW_WRAPPER))
#define MUSIC_IS_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_VIEW_WRAPPER))
#define MUSIC_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapperClass))

typedef struct _MusicViewWrapper MusicViewWrapper;
typedef struct _MusicViewWrapperClass MusicViewWrapperClass;
typedef gint (*MusicGenericListSortCompareFunc) (gint sort_column_id, GtkSortType sort_direction, MusicMedia* a, MusicMedia* b, gint index_a, gint index_b, gpointer user_data);
typedef void (*MusicGenericListViewSearchFunc) (const gchar* search, GeeArrayList* table, GeeArrayList* showing, gpointer user_data);
enum  {
	MUSIC_GENERIC_LIST_0_PROPERTY,
	MUSIC_GENERIC_LIST_COLUMNS_PROPERTY,
	MUSIC_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY,
	MUSIC_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY,
	MUSIC_GENERIC_LIST_PLAYLIST_PROPERTY,
	MUSIC_GENERIC_LIST_TVS_PROPERTY,
	MUSIC_GENERIC_LIST_HINT_PROPERTY,
	MUSIC_GENERIC_LIST_PARENT_WRAPPER_PROPERTY,
	MUSIC_GENERIC_LIST_NUM_PROPERTIES
};
static GParamSpec* music_generic_list_properties[MUSIC_GENERIC_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _music_cell_data_function_helper_unref0(var) ((var == NULL) ? NULL : (var = (music_cell_data_function_helper_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	MUSIC_VIEW_WRAPPER_HINT_NONE,
	MUSIC_VIEW_WRAPPER_HINT_MUSIC,
	MUSIC_VIEW_WRAPPER_HINT_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_CDROM,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	MUSIC_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	MUSIC_VIEW_WRAPPER_HINT_ALBUM_LIST,
	MUSIC_VIEW_WRAPPER_HINT_QUEUE
} MusicViewWrapperHint;

#define MUSIC_VIEW_WRAPPER_TYPE_HINT (music_view_wrapper_hint_get_type ())

#define MUSIC_TYPE_PLAYBACK_MANAGER (music_playback_manager_get_type ())
#define MUSIC_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager))
#define MUSIC_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))
#define MUSIC_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))

typedef struct _MusicPlaybackManager MusicPlaybackManager;
typedef struct _MusicPlaybackManagerClass MusicPlaybackManagerClass;

#define MUSIC_TYPE_LIBRARY_WINDOW (music_library_window_get_type ())
#define MUSIC_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow))
#define MUSIC_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))
#define MUSIC_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))

typedef struct _MusicLibraryWindow MusicLibraryWindow;
typedef struct _MusicLibraryWindowClass MusicLibraryWindowClass;
typedef struct _MusicGenericListMediaPlayedData MusicGenericListMediaPlayedData;

#define MUSIC_TYPE_LOCAL_LIBRARY (music_local_library_get_type ())
#define MUSIC_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibrary))
#define MUSIC_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibraryClass))
#define MUSIC_IS_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LOCAL_LIBRARY))
#define MUSIC_IS_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LOCAL_LIBRARY))
#define MUSIC_LOCAL_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibraryClass))

typedef struct _MusicLocalLibrary MusicLocalLibrary;
typedef struct _MusicLocalLibraryClass MusicLocalLibraryClass;
typedef struct _MusicLocalLibraryPrivate MusicLocalLibraryPrivate;
typedef struct _MusicLibraryWindowPrivate MusicLibraryWindowPrivate;
typedef struct _MusicPlaybackManagerPrivate MusicPlaybackManagerPrivate;

#define MUSIC_TYPE_HISTORY_PLAYLIST (music_history_playlist_get_type ())
#define MUSIC_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_HISTORY_PLAYLIST, MusicHistoryPlaylist))
#define MUSIC_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_HISTORY_PLAYLIST, MusicHistoryPlaylistClass))
#define MUSIC_IS_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_HISTORY_PLAYLIST))
#define MUSIC_IS_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_HISTORY_PLAYLIST))
#define MUSIC_HISTORY_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_HISTORY_PLAYLIST, MusicHistoryPlaylistClass))

typedef struct _MusicHistoryPlaylist MusicHistoryPlaylist;
typedef struct _MusicHistoryPlaylistClass MusicHistoryPlaylistClass;

#define MUSIC_TYPE_STREAMER (music_streamer_get_type ())
#define MUSIC_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_STREAMER, MusicStreamer))
#define MUSIC_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_STREAMER, MusicStreamerClass))
#define MUSIC_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_STREAMER))
#define MUSIC_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_STREAMER))
#define MUSIC_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_STREAMER, MusicStreamerClass))

typedef struct _MusicStreamer MusicStreamer;
typedef struct _MusicStreamerClass MusicStreamerClass;

#define MUSIC_TYPE_LIST_VIEW (music_list_view_get_type ())
#define MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIST_VIEW, MusicListView))
#define MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIST_VIEW, MusicListViewClass))
#define MUSIC_IS_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIST_VIEW))
#define MUSIC_IS_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIST_VIEW))
#define MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIST_VIEW, MusicListViewClass))

typedef struct _MusicListView MusicListView;
typedef struct _MusicListViewClass MusicListViewClass;

#define MUSIC_TYPE_MUSIC_LIST_VIEW (music_music_list_view_get_type ())
#define MUSIC_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListView))
#define MUSIC_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListViewClass))
#define MUSIC_IS_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW))
#define MUSIC_IS_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_MUSIC_LIST_VIEW))
#define MUSIC_MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListViewClass))

typedef struct _MusicMusicListView MusicMusicListView;
typedef struct _MusicMusicListViewClass MusicMusicListViewClass;
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
typedef GValue* (*MusicFastModelValueReturnFunc) (gint row, gint column, GObject* o, gpointer user_data);
enum  {
	MUSIC_GENERIC_LIST_IMPORT_REQUESTED_SIGNAL,
	MUSIC_GENERIC_LIST_ROWS_REORDERED_SIGNAL,
	MUSIC_GENERIC_LIST_NUM_SIGNALS
};
static guint music_generic_list_signals[MUSIC_GENERIC_LIST_NUM_SIGNALS] = {0};

struct _MusicGenericList {
	GtkTreeView parent_instance;
	MusicGenericListPrivate * priv;
	MusicFastModel* fm;
	GeeArrayList* table;
	GeeArrayList* showing;
	gint sort_column_id;
	GtkSortType sort_direction;
	gboolean dragging;
	MusicCellDataFunctionHelper* cell_data_helper;
};

struct _MusicGenericListClass {
	GtkTreeViewClass parent_class;
	void (*add_column) (MusicGenericList* self, GtkTreeViewColumn* column, MusicListColumn type);
	void (*media_remove_clicked) (MusicGenericList* self);
};

struct _MusicGenericListPrivate {
	GeeList* _columns;
	gboolean _research_needed;
	gboolean _is_current_list;
	MusicPlaylist* _playlist;
	MusicTreeViewSetup* _tvs;
	MusicViewWrapper* _parent_wrapper;
	MusicGenericListSortCompareFunc compare_func;
	gpointer compare_func_target;
	MusicGenericListViewSearchFunc search_func;
	gpointer search_func_target;
};

struct _MusicGenericListMediaPlayedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicGenericList* self;
	MusicMedia* m;
};

struct _MusicLocalLibrary {
	MusicLibrary parent_instance;
	MusicLocalLibraryPrivate * priv;
	MusicStaticPlaylist* p_music;
};

struct _MusicLocalLibraryClass {
	MusicLibraryClass parent_class;
};

struct _MusicLibraryWindow {
	HdyApplicationWindow parent_instance;
	MusicLibraryWindowPrivate * priv;
	GeeHashMap* match_playlists;
};

struct _MusicLibraryWindowClass {
	HdyApplicationWindowClass parent_class;
	void (*playback_stopped) (MusicLibraryWindow* self, gint64 was_playing);
	void (*play_media) (MusicLibraryWindow* self, gboolean inhibit_notifications);
	void (*play_next_media) (MusicLibraryWindow* self, gboolean inhibit_notifications);
	void (*play_previous_media) (MusicLibraryWindow* self, gboolean inhibit_notifications);
	void (*action_import) (MusicLibraryWindow* self);
	void (*end_of_stream) (MusicLibraryWindow* self);
	void (*error_occured) (MusicLibraryWindow* self);
	void (*current_position_update) (MusicLibraryWindow* self, gint64 position);
	void (*drag_received) (MusicLibraryWindow* self, GdkDragContext* context, gint x, gint y, GtkSelectionData* data, guint info, guint timestamp);
};

struct _MusicPlaybackManager {
	GObject parent_instance;
	MusicPlaybackManagerPrivate * priv;
	MusicStaticPlaylist* queue_playlist;
	MusicHistoryPlaylist* history_playlist;
	MusicStreamer* file_player;
	MusicPlayback* player;
};

struct _MusicPlaybackManagerClass {
	GObjectClass parent_class;
};

static gint MusicGenericList_private_offset;
static gpointer music_generic_list_parent_class = NULL;

VALA_EXTERN GType music_generic_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicGenericList, g_object_unref)
VALA_EXTERN GType music_list_column_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType music_fast_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicFastModel, g_object_unref)
VALA_EXTERN gpointer music_cell_data_function_helper_ref (gpointer instance);
VALA_EXTERN void music_cell_data_function_helper_unref (gpointer instance);
VALA_EXTERN GParamSpec* music_param_spec_cell_data_function_helper (const gchar* name,
                                                        const gchar* nick,
                                                        const gchar* blurb,
                                                        GType object_type,
                                                        GParamFlags flags);
VALA_EXTERN void music_value_set_cell_data_function_helper (GValue* value,
                                                gpointer v_object);
VALA_EXTERN void music_value_take_cell_data_function_helper (GValue* value,
                                                 gpointer v_object);
VALA_EXTERN gpointer music_value_get_cell_data_function_helper (const GValue* value);
VALA_EXTERN GType music_cell_data_function_helper_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicCellDataFunctionHelper, music_cell_data_function_helper_unref)
VALA_EXTERN GType music_tree_view_setup_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicTreeViewSetup, g_object_unref)
VALA_EXTERN GType music_view_wrapper_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicViewWrapper, g_object_unref)
VALA_EXTERN void music_generic_list_add_column (MusicGenericList* self,
                                    GtkTreeViewColumn* column,
                                    MusicListColumn type);
VALA_EXTERN void music_generic_list_media_remove_clicked (MusicGenericList* self);
VALA_EXTERN MusicGenericList* music_generic_list_construct (GType object_type,
                                                MusicViewWrapper* view_wrapper,
                                                MusicTreeViewSetup* tvs);
static void music_generic_list_real_add_column (MusicGenericList* self,
                                         GtkTreeViewColumn* column,
                                         MusicListColumn type);
static void music_generic_list_real_media_remove_clicked (MusicGenericList* self);
VALA_EXTERN void music_generic_list_set_media (MusicGenericList* self,
                                   GeeCollection* to_add);
VALA_EXTERN void music_generic_list_set_table (MusicGenericList* self,
                                   GeeArrayList* table,
                                   gboolean do_resort);
VALA_EXTERN void music_generic_list_scroll_to_current_media (MusicGenericList* self,
                                                 gboolean unfilter_if_not_found);
VALA_EXTERN void music_generic_list_set_fixed_column_width (MusicGenericList* self,
                                                GtkWidget* treeview,
                                                GtkTreeViewColumn* column,
                                                GtkCellRendererText* renderer,
                                                gchar** strings,
                                                gint strings_length1,
                                                gint padding);
static MusicMedia* music_generic_list_get_media_from_index (MusicGenericList* self,
                                                     gint index);
VALA_EXTERN MusicMedia* music_generic_list_get_object_from_index (MusicGenericList* self,
                                                      gint index);
VALA_EXTERN void music_generic_list_on_rating_cell_changed (MusicGenericList* self,
                                                gint new_rating,
                                                GtkWidget* widget,
                                                const gchar* path);
VALA_EXTERN MusicViewWrapper* music_generic_list_get_parent_wrapper (MusicGenericList* self);
VALA_EXTERN MusicLibrary* music_view_wrapper_get_library (MusicViewWrapper* self);
static void music_generic_list_on_rows_reordered (MusicGenericList* self);
VALA_EXTERN gboolean music_generic_list_get_is_current_list (MusicGenericList* self);
VALA_EXTERN void music_generic_list_set_as_current_list (MusicGenericList* self,
                                             MusicMedia* m);
static void music_generic_list_real_row_activated (GtkTreeView* base,
                                            GtkTreePath* path,
                                            GtkTreeViewColumn* column);
VALA_EXTERN GType music_view_wrapper_hint_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MusicViewWrapperHint music_generic_list_get_hint (MusicGenericList* self);
VALA_EXTERN GType music_playback_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPlaybackManager, g_object_unref)
VALA_EXTERN MusicPlaybackManager* music_app_get_player (void);
VALA_EXTERN void music_playback_manager_set_current_index (MusicPlaybackManager* self,
                                               gint value);
VALA_EXTERN void music_playback_manager_play_media (MusicPlaybackManager* self,
                                        MusicMedia* m);
VALA_EXTERN gboolean music_playback_manager_get_playing (MusicPlaybackManager* self);
VALA_EXTERN GType music_library_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLibraryWindow, g_object_unref)
VALA_EXTERN MusicLibraryWindow* music_app_get_main_window (void);
VALA_EXTERN void music_library_window_play_media (MusicLibraryWindow* self,
                                      gboolean inhibit_notifications);
static void music_generic_list_media_played_data_free (gpointer _data);
static void music_generic_list_media_played (MusicGenericList* self,
                                      MusicMedia* m,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static void music_generic_list_media_played_finish (MusicGenericList* self,
                                             GAsyncResult* _res_);
static gboolean music_generic_list_media_played_co (MusicGenericListMediaPlayedData* _data_);
static gboolean _music_generic_list_media_played_co_gsource_func (gpointer self);
VALA_EXTERN MusicMedia* music_playback_manager_get_current_media (MusicPlaybackManager* self);
static void music_generic_list_set_is_current_list (MusicGenericList* self,
                                             gboolean value);
VALA_EXTERN MusicPlaylist* music_generic_list_get_playlist (MusicGenericList* self);
VALA_EXTERN GType music_local_library_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLocalLibrary, g_object_unref)
VALA_EXTERN GSettings* music_app_get_saved_state (void);
static GeeList* music_generic_list_start_at (MusicGenericList* self,
                                      MusicMedia* start,
                                      GeeList* media);
VALA_EXTERN GeeBidirList* music_generic_list_get_visible_table (MusicGenericList* self);
VALA_EXTERN void music_playback_manager_clear_queue (MusicPlaybackManager* self);
VALA_EXTERN void music_playback_manager_queue_media (MusicPlaybackManager* self,
                                         GeeCollection* to_queue);
VALA_EXTERN GType music_history_playlist_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicHistoryPlaylist, g_object_unref)
VALA_EXTERN GType music_streamer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicStreamer, g_object_unref)
VALA_EXTERN GType music_list_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicListView, g_object_unref)
VALA_EXTERN MusicListView* music_view_wrapper_get_list_view (MusicViewWrapper* self);
VALA_EXTERN GType music_music_list_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicMusicListView, g_object_unref)
VALA_EXTERN MusicMusicListView* music_list_view_get_list_view (MusicListView* self);
VALA_EXTERN void music_generic_list_set_sort_column_id (MusicGenericList* self,
                                            gint sort_column_id,
                                            GtkSortType order);
VALA_EXTERN MusicTreeViewSetup* music_generic_list_get_tvs (MusicGenericList* self);
VALA_EXTERN MusicListColumn music_tree_view_setup_get_sort_column_id (MusicTreeViewSetup* self);
VALA_EXTERN GtkSortType music_tree_view_setup_get_sort_direction (MusicTreeViewSetup* self);
VALA_EXTERN GeeCollection* music_generic_list_get_selected_medias (MusicGenericList* self);
static GtkTreePath* _vala_GtkTreePath_copy (GtkTreePath* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void __vala_GtkTreePath_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreePath_free0_ (GList* self);
VALA_EXTERN GeeBidirList* music_generic_list_get_table (MusicGenericList* self);
VALA_EXTERN gint music_generic_list_get_index_from_iter (GtkTreeIter* iter);
VALA_EXTERN void music_generic_list_set_value_func (MusicGenericList* self,
                                        MusicFastModelValueReturnFunc func,
                                        gpointer func_target);
VALA_EXTERN void music_fast_model_set_value_func (MusicFastModel* self,
                                      MusicFastModelValueReturnFunc func,
                                      gpointer func_target);
VALA_EXTERN void music_generic_list_resort (MusicGenericList* self);
VALA_EXTERN void music_generic_list_do_search (MusicGenericList* self,
                                   const gchar* search);
VALA_EXTERN void music_generic_list_set_search_func (MusicGenericList* self,
                                         MusicGenericListViewSearchFunc func,
                                         gpointer func_target);
VALA_EXTERN gboolean music_generic_list_get_research_needed (MusicGenericList* self);
VALA_EXTERN void music_generic_list_set_research_needed (MusicGenericList* self,
                                             gboolean value);
VALA_EXTERN void music_fast_model_set_table (MusicFastModel* self,
                                 GeeArrayList* table);
VALA_EXTERN void music_fast_model_remove (MusicFastModel* self,
                              GtkTreeIter* iter);
VALA_EXTERN void music_fast_model_append (MusicFastModel* self,
                              GtkTreeIter* iter);
static void music_generic_list_reorder_requested (MusicGenericList* self,
                                           gint column,
                                           GtkSortType direction);
static void music_generic_list_quicksort (MusicGenericList* self,
                                   gint start,
                                   gint end);
VALA_EXTERN void music_generic_list_set_compare_func (MusicGenericList* self,
                                          MusicGenericListSortCompareFunc func,
                                          gpointer func_target);
static void music_generic_list_swap (MusicGenericList* self,
                              gint a,
                              gint b);
static void music_generic_list_on_drag_begin (MusicGenericList* self,
                                       GtkWidget* sender,
                                       GdkDragContext* context);
static void music_generic_list_on_drag_data_get (MusicGenericList* self,
                                          GdkDragContext* context,
                                          GtkSelectionData* selection_data,
                                          guint info,
                                          guint time_);
static void _vala_array_add13 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void music_generic_list_on_drag_end (MusicGenericList* self,
                                     GtkWidget* sender,
                                     GdkDragContext* context);
VALA_EXTERN GeeList* music_generic_list_get_columns (MusicGenericList* self);
VALA_EXTERN void music_generic_list_set_columns (MusicGenericList* self,
                                     GeeList* value);
VALA_EXTERN void music_generic_list_set_playlist (MusicGenericList* self,
                                      MusicPlaylist* value);
VALA_EXTERN void music_generic_list_set_tvs (MusicGenericList* self,
                                 MusicTreeViewSetup* value);
VALA_EXTERN MusicViewWrapperHint music_tree_view_setup_get_hint (MusicTreeViewSetup* self);
VALA_EXTERN void music_generic_list_set_hint (MusicGenericList* self,
                                  MusicViewWrapperHint value);
VALA_EXTERN void music_tree_view_setup_set_hint (MusicTreeViewSetup* self,
                                     MusicViewWrapperHint value);
VALA_EXTERN void music_generic_list_set_parent_wrapper (MusicGenericList* self,
                                            MusicViewWrapper* value);
VALA_EXTERN MusicPlaylist* music_view_wrapper_get_playlist (MusicViewWrapper* self);
static GObject * music_generic_list_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
VALA_EXTERN GeeCollection* music_list_column_get_all (void);
VALA_EXTERN GType music_list_column_get_data_type (MusicListColumn self);
VALA_EXTERN MusicFastModel* music_fast_model_new (GeeList* column_types);
VALA_EXTERN MusicFastModel* music_fast_model_construct (GType object_type,
                                            GeeList* column_types);
static void _music_generic_list_reorder_requested_music_fast_model_reorder_requested (MusicFastModel* _sender,
                                                                               gint column,
                                                                               GtkSortType direction,
                                                                               gpointer self);
VALA_EXTERN MusicCellDataFunctionHelper* music_cell_data_function_helper_new (MusicGenericList* view);
VALA_EXTERN MusicCellDataFunctionHelper* music_cell_data_function_helper_construct (GType object_type,
                                                                        MusicGenericList* view);
VALA_EXTERN GeeCollection* music_tree_view_setup_get_columns (MusicTreeViewSetup* self);
VALA_EXTERN MusicListColumn* music_tree_view_setup_get_column_type (GtkTreeViewColumn* column);
static void _music_generic_list_on_rows_reordered_music_generic_list_rows_reordered (MusicGenericList* _sender,
                                                                              gpointer self);
static gboolean _music_generic_list___lambda40_ (MusicGenericList* self,
                                          GdkEventKey* event);
static gboolean __music_generic_list___lambda40__gtk_widget_key_press_event (GtkWidget* _sender,
                                                                      GdkEventKey* event,
                                                                      gpointer self);
static void _music_generic_list_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                              GdkDragContext* context,
                                                              gpointer self);
static void _music_generic_list_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                    GdkDragContext* context,
                                                                    GtkSelectionData* selection_data,
                                                                    guint info,
                                                                    guint time_,
                                                                    gpointer self);
static void _music_generic_list_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                          GdkDragContext* context,
                                                          gpointer self);
static void _gtk_widget_queue_draw_music_library_media_updated (MusicLibrary* _sender,
                                                         GeeCollection* medias,
                                                         gpointer self);
static void _music_generic_list___lambda41_ (MusicGenericList* self);
static void __music_generic_list___lambda41__music_playback_manager_queue_cleared (MusicPlaybackManager* _sender,
                                                                            gpointer self);
static void _music_generic_list_media_played_music_playback_manager_media_played (MusicPlaybackManager* _sender,
                                                                           MusicMedia* played_media,
                                                                           gpointer self);
static void music_generic_list_finalize (GObject * obj);
static GType music_generic_list_get_type_once (void);
static void _vala_music_generic_list_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_music_generic_list_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
music_generic_list_get_instance_private (MusicGenericList* self)
{
	return G_STRUCT_MEMBER_P (self, MusicGenericList_private_offset);
}

MusicGenericList*
music_generic_list_construct (GType object_type,
                              MusicViewWrapper* view_wrapper,
                              MusicTreeViewSetup* tvs)
{
	MusicGenericList * self = NULL;
#line 94 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (view_wrapper != NULL, NULL);
#line 94 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (tvs != NULL, NULL);
#line 95 "../src/Views/ListView/Lists/GenericList.vala"
	self = (MusicGenericList*) g_object_new (object_type, "parent-wrapper", view_wrapper, "tvs", tvs, NULL);
#line 94 "../src/Views/ListView/Lists/GenericList.vala"
	return self;
#line 607 "GenericList.c"
}

static void
music_generic_list_real_add_column (MusicGenericList* self,
                                    GtkTreeViewColumn* column,
                                    MusicListColumn type)
{
#line 157 "../src/Views/ListView/Lists/GenericList.vala"
	g_critical ("Type `%s' does not implement abstract method `music_generic_list_add_column'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 157 "../src/Views/ListView/Lists/GenericList.vala"
	return;
#line 619 "GenericList.c"
}

void
music_generic_list_add_column (MusicGenericList* self,
                               GtkTreeViewColumn* column,
                               MusicListColumn type)
{
	MusicGenericListClass* _klass_;
#line 157 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/Views/ListView/Lists/GenericList.vala"
	_klass_ = MUSIC_GENERIC_LIST_GET_CLASS (self);
#line 157 "../src/Views/ListView/Lists/GenericList.vala"
	if (_klass_->add_column) {
#line 157 "../src/Views/ListView/Lists/GenericList.vala"
		_klass_->add_column (self, column, type);
#line 636 "GenericList.c"
	}
}

static void
music_generic_list_real_media_remove_clicked (MusicGenericList* self)
{
#line 158 "../src/Views/ListView/Lists/GenericList.vala"
	g_critical ("Type `%s' does not implement abstract method `music_generic_list_media_remove_clicked'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 158 "../src/Views/ListView/Lists/GenericList.vala"
	return;
#line 647 "GenericList.c"
}

void
music_generic_list_media_remove_clicked (MusicGenericList* self)
{
	MusicGenericListClass* _klass_;
#line 158 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/Views/ListView/Lists/GenericList.vala"
	_klass_ = MUSIC_GENERIC_LIST_GET_CLASS (self);
#line 158 "../src/Views/ListView/Lists/GenericList.vala"
	if (_klass_->media_remove_clicked) {
#line 158 "../src/Views/ListView/Lists/GenericList.vala"
		_klass_->media_remove_clicked (self);
#line 662 "GenericList.c"
	}
}

void
music_generic_list_set_media (MusicGenericList* self,
                              GeeCollection* to_add)
{
	GeeArrayList* new_table = NULL;
	GeeArrayList* _tmp0_;
#line 160 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (to_add != NULL);
#line 161 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 161 "../src/Views/ListView/Lists/GenericList.vala"
	new_table = _tmp0_;
#line 162 "../src/Views/ListView/Lists/GenericList.vala"
	gee_array_list_add_all (new_table, to_add);
#line 165 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_set_table (self, new_table, TRUE);
#line 167 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_scroll_to_current_media (self, FALSE);
#line 160 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (new_table);
#line 688 "GenericList.c"
}

void
music_generic_list_set_fixed_column_width (MusicGenericList* self,
                                           GtkWidget* treeview,
                                           GtkTreeViewColumn* column,
                                           GtkCellRendererText* renderer,
                                           gchar** strings,
                                           gint strings_length1,
                                           gint padding)
{
	gint max_width = 0;
#line 170 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (treeview != NULL);
#line 170 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (column != NULL);
#line 170 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (renderer != NULL);
#line 171 "../src/Views/ListView/Lists/GenericList.vala"
	max_width = 0;
#line 711 "GenericList.c"
	{
		gchar** str_collection = NULL;
		gint str_collection_length1 = 0;
		gint _str_collection_size_ = 0;
		gint str_it = 0;
#line 173 "../src/Views/ListView/Lists/GenericList.vala"
		str_collection = strings;
#line 173 "../src/Views/ListView/Lists/GenericList.vala"
		str_collection_length1 = strings_length1;
#line 173 "../src/Views/ListView/Lists/GenericList.vala"
		for (str_it = 0; str_it < str_collection_length1; str_it = str_it + 1) {
#line 723 "GenericList.c"
			const gchar* str = NULL;
#line 173 "../src/Views/ListView/Lists/GenericList.vala"
			str = str_collection[str_it];
#line 727 "GenericList.c"
			{
				const gchar* _tmp0_;
				GtkRequisition natural_size = {0};
				GtkRequisition _tmp1_ = {0};
				GtkRequisition _tmp2_;
#line 174 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp0_ = str;
#line 174 "../src/Views/ListView/Lists/GenericList.vala"
				g_object_set (renderer, "text", _tmp0_, NULL);
#line 177 "../src/Views/ListView/Lists/GenericList.vala"
				gtk_cell_renderer_get_preferred_size ((GtkCellRenderer*) renderer, treeview, NULL, &_tmp1_);
#line 177 "../src/Views/ListView/Lists/GenericList.vala"
				natural_size = _tmp1_;
#line 179 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp2_ = natural_size;
#line 179 "../src/Views/ListView/Lists/GenericList.vala"
				if (_tmp2_.width > max_width) {
#line 745 "GenericList.c"
					GtkRequisition _tmp3_;
#line 180 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp3_ = natural_size;
#line 180 "../src/Views/ListView/Lists/GenericList.vala"
					max_width = _tmp3_.width;
#line 751 "GenericList.c"
				}
			}
		}
	}
#line 183 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_tree_view_column_set_fixed_width (column, max_width + padding);
#line 758 "GenericList.c"
}

static MusicMedia*
music_generic_list_get_media_from_index (MusicGenericList* self,
                                         gint index)
{
	MusicMedia* _tmp0_;
	MusicMedia* result;
#line 186 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 187 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = music_generic_list_get_object_from_index (self, index);
#line 187 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp0_;
#line 187 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 775 "GenericList.c"
}

void
music_generic_list_on_rating_cell_changed (MusicGenericList* self,
                                           gint new_rating,
                                           GtkWidget* widget,
                                           const gchar* path)
{
	MusicMedia* m = NULL;
	MusicMedia* _tmp0_;
	GeeTreeSet* to_update = NULL;
	GeeTreeSet* _tmp1_;
	MusicViewWrapper* _tmp2_;
	MusicViewWrapper* _tmp3_;
	MusicLibrary* _tmp4_;
	MusicLibrary* _tmp5_;
#line 192 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 192 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (widget != NULL);
#line 192 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (path != NULL);
#line 193 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = music_generic_list_get_media_from_index (self, atoi (path));
#line 193 "../src/Views/ListView/Lists/GenericList.vala"
	m = _tmp0_;
#line 195 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (m != NULL);
#line 197 "../src/Views/ListView/Lists/GenericList.vala"
	music_media_set_rating (m, (guint) new_rating);
#line 199 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 199 "../src/Views/ListView/Lists/GenericList.vala"
	to_update = _tmp1_;
#line 200 "../src/Views/ListView/Lists/GenericList.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) to_update, m);
#line 201 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = music_generic_list_get_parent_wrapper (self);
#line 201 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = _tmp2_;
#line 201 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp4_ = music_view_wrapper_get_library (_tmp3_);
#line 201 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp5_ = _tmp4_;
#line 201 "../src/Views/ListView/Lists/GenericList.vala"
	music_library_update_medias (_tmp5_, (GeeCollection*) to_update, TRUE, TRUE);
#line 192 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (to_update);
#line 192 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (m);
#line 826 "GenericList.c"
}

static void
music_generic_list_on_rows_reordered (MusicGenericList* self)
{
	gboolean _tmp0_;
#line 204 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_scroll_to_current_media (self, FALSE);
#line 206 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->priv->_is_current_list;
#line 206 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp0_) {
#line 207 "../src/Views/ListView/Lists/GenericList.vala"
		music_generic_list_set_as_current_list (self, NULL);
#line 843 "GenericList.c"
	}
}

static void
music_generic_list_real_row_activated (GtkTreeView* base,
                                       GtkTreePath* path,
                                       GtkTreeViewColumn* column)
{
	MusicGenericList * self;
	MusicMedia* m = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	MusicViewWrapperHint _tmp4_;
	MusicViewWrapperHint _tmp5_;
	MusicPlaybackManager* _tmp11_;
	MusicPlaybackManager* _tmp12_;
	MusicMedia* _tmp13_;
	MusicPlaybackManager* _tmp14_;
	MusicPlaybackManager* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
#line 210 "../src/Views/ListView/Lists/GenericList.vala"
	self = (MusicGenericList*) base;
#line 210 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (path != NULL);
#line 210 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (column != NULL);
#line 211 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = gtk_tree_path_to_string (path);
#line 211 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = _tmp0_;
#line 211 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = music_generic_list_get_media_from_index (self, atoi (_tmp1_));
#line 211 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = _tmp2_;
#line 211 "../src/Views/ListView/Lists/GenericList.vala"
	_g_free0 (_tmp1_);
#line 211 "../src/Views/ListView/Lists/GenericList.vala"
	m = _tmp3_;
#line 214 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp4_ = music_generic_list_get_hint (self);
#line 214 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp5_ = _tmp4_;
#line 214 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp5_ == MUSIC_VIEW_WRAPPER_HINT_QUEUE) {
#line 891 "GenericList.c"
		MusicPlaybackManager* _tmp6_;
		MusicPlaybackManager* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 215 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp6_ = music_app_get_player ();
#line 215 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp7_ = _tmp6_;
#line 215 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp8_ = gtk_tree_path_to_string (path);
#line 215 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp9_ = _tmp8_;
#line 215 "../src/Views/ListView/Lists/GenericList.vala"
		music_playback_manager_set_current_index (_tmp7_, atoi (_tmp9_));
#line 215 "../src/Views/ListView/Lists/GenericList.vala"
		_g_free0 (_tmp9_);
#line 908 "GenericList.c"
	} else {
		MusicMedia* _tmp10_;
#line 217 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp10_ = m;
#line 217 "../src/Views/ListView/Lists/GenericList.vala"
		music_generic_list_set_as_current_list (self, _tmp10_);
#line 915 "GenericList.c"
	}
#line 221 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp11_ = music_app_get_player ();
#line 221 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp12_ = _tmp11_;
#line 221 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp13_ = m;
#line 221 "../src/Views/ListView/Lists/GenericList.vala"
	music_playback_manager_play_media (_tmp12_, _tmp13_);
#line 223 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp14_ = music_app_get_player ();
#line 223 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp15_ = _tmp14_;
#line 223 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp16_ = music_playback_manager_get_playing (_tmp15_);
#line 223 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp17_ = _tmp16_;
#line 223 "../src/Views/ListView/Lists/GenericList.vala"
	if (!_tmp17_) {
#line 935 "GenericList.c"
		MusicLibraryWindow* _tmp18_;
		MusicLibraryWindow* _tmp19_;
#line 224 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp18_ = music_app_get_main_window ();
#line 224 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp19_ = _tmp18_;
#line 224 "../src/Views/ListView/Lists/GenericList.vala"
		music_library_window_play_media (_tmp19_, FALSE);
#line 944 "GenericList.c"
	}
#line 210 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (m);
#line 948 "GenericList.c"
}

static void
music_generic_list_media_played_data_free (gpointer _data)
{
	MusicGenericListMediaPlayedData* _data_;
	_data_ = _data;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (_data_->m);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (_data_->self);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_slice_free (MusicGenericListMediaPlayedData, _data_);
#line 962 "GenericList.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	return self ? g_object_ref (self) : NULL;
#line 970 "GenericList.c"
}

static void
music_generic_list_media_played (MusicGenericList* self,
                                 MusicMedia* m,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	MusicGenericListMediaPlayedData* _data_;
	MusicGenericList* _tmp0_;
	MusicMedia* _tmp1_;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (m != NULL);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_data_ = g_slice_new0 (MusicGenericListMediaPlayedData);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_generic_list_media_played_data_free);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_data_->self = _tmp0_;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = _g_object_ref0 (m);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (_data_->m);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_data_->m = _tmp1_;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_media_played_co (_data_);
#line 1004 "GenericList.c"
}

static void
music_generic_list_media_played_finish (MusicGenericList* self,
                                        GAsyncResult* _res_)
{
	MusicGenericListMediaPlayedData* _data_;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1014 "GenericList.c"
}

static gboolean
_music_generic_list_media_played_co_gsource_func (gpointer self)
{
	gboolean result;
	result = music_generic_list_media_played_co (self);
#line 231 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 1024 "GenericList.c"
}

static gboolean
music_generic_list_media_played_co (MusicGenericListMediaPlayedData* _data_)
{
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
	switch (_data_->_state_) {
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
		case 0:
#line 1034 "GenericList.c"
		goto _state_0;
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
		case 1:
#line 1038 "GenericList.c"
		goto _state_1;
		default:
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
		g_assert_not_reached ();
#line 1043 "GenericList.c"
	}
	_state_0:
#line 229 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_widget_queue_draw ((GtkWidget*) _data_->self);
#line 231 "../src/Views/ListView/Lists/GenericList.vala"
	g_idle_add_full (G_PRIORITY_HIGH_IDLE + 10, _music_generic_list_media_played_co_gsource_func, _data_, NULL);
#line 232 "../src/Views/ListView/Lists/GenericList.vala"
	_data_->_state_ = 1;
#line 232 "../src/Views/ListView/Lists/GenericList.vala"
	return FALSE;
#line 1054 "GenericList.c"
	_state_1:
	;
#line 234 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_scroll_to_current_media (_data_->self, FALSE);
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
	if (_data_->_state_ != 0) {
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1067 "GenericList.c"
		}
	}
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_unref (_data_->_async_result);
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
	return FALSE;
#line 1074 "GenericList.c"
}

void
music_generic_list_set_as_current_list (MusicGenericList* self,
                                        MusicMedia* m)
{
	MusicMedia* _tmp0_ = NULL;
	MusicMedia* to_set = NULL;
	MusicMedia* _tmp5_;
	MusicSettingsMain* main_settings = NULL;
	MusicSettingsMain* _tmp6_;
	MusicSettingsMain* _tmp7_;
	GeeList* queue = NULL;
	MusicMedia* _tmp43_;
	GeeBidirList* _tmp44_;
	GeeBidirList* _tmp45_;
	GeeList* _tmp46_;
	GeeList* _tmp47_;
	MusicPlaybackManager* _tmp59_;
	MusicPlaybackManager* _tmp60_;
	MusicPlaybackManager* _tmp61_;
	MusicPlaybackManager* _tmp62_;
	GeeList* _tmp63_;
	MusicPlaybackManager* _tmp64_;
	MusicPlaybackManager* _tmp65_;
	MusicViewWrapper* view = NULL;
	MusicLibraryWindow* _tmp66_;
	MusicLibraryWindow* _tmp67_;
	GeeHashMap* _tmp68_;
	MusicPlaybackManager* _tmp69_;
	MusicPlaybackManager* _tmp70_;
	MusicStaticPlaylist* _tmp71_;
	gpointer _tmp72_;
	MusicListView* _tmp73_;
	MusicListView* _tmp74_;
	MusicMusicListView* _tmp75_;
	MusicMusicListView* _tmp76_;
	MusicTreeViewSetup* _tmp77_;
	MusicListColumn _tmp78_;
	MusicListColumn _tmp79_;
	MusicTreeViewSetup* _tmp80_;
	GtkSortType _tmp81_;
	GtkSortType _tmp82_;
	MusicPlaybackManager* _tmp83_;
	MusicPlaybackManager* _tmp84_;
	MusicMedia* _tmp85_;
	MusicMedia* _tmp86_;
#line 237 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
	if (m == NULL) {
#line 1126 "GenericList.c"
		MusicPlaybackManager* _tmp1_;
		MusicPlaybackManager* _tmp2_;
		MusicMedia* _tmp3_;
		MusicMedia* _tmp4_;
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp1_ = music_app_get_player ();
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp2_ = _tmp1_;
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp3_ = music_playback_manager_get_current_media (_tmp2_);
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp4_ = _tmp3_;
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = _tmp4_;
#line 1141 "GenericList.c"
	} else {
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = m;
#line 1145 "GenericList.c"
	}
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp5_ = _g_object_ref0 (_tmp0_);
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
	to_set = _tmp5_;
#line 240 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_set_is_current_list (self, TRUE);
#line 241 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp6_ = music_settings_main_get_default ();
#line 241 "../src/Views/ListView/Lists/GenericList.vala"
	main_settings = _tmp6_;
#line 243 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp7_ = main_settings;
#line 243 "../src/Views/ListView/Lists/GenericList.vala"
	if (!music_settings_main_privacy_mode_enabled (_tmp7_)) {
#line 1161 "GenericList.c"
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		MusicPlaylist* _tmp10_;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp10_ = self->priv->_playlist;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
		if (_tmp10_ == NULL) {
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp9_ = TRUE;
#line 1171 "GenericList.c"
		} else {
			MusicPlaylist* _tmp11_;
			MusicLibrariesManager* _tmp12_;
			MusicLibrary* _tmp13_;
			MusicStaticPlaylist* _tmp14_;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp11_ = self->priv->_playlist;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp12_ = music_libraries_manager;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp13_ = _tmp12_->local_library;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp14_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibrary)->p_music;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp9_ = _tmp11_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, MUSIC_TYPE_PLAYLIST, MusicPlaylist);
#line 1187 "GenericList.c"
		}
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
		if (_tmp9_) {
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp8_ = TRUE;
#line 1193 "GenericList.c"
		} else {
			MusicViewWrapper* _tmp15_;
			MusicViewWrapper* _tmp16_;
			MusicLibrary* _tmp17_;
			MusicLibrary* _tmp18_;
			MusicLibrariesManager* _tmp19_;
			MusicLibrary* _tmp20_;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp15_ = music_generic_list_get_parent_wrapper (self);
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp16_ = _tmp15_;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp17_ = music_view_wrapper_get_library (_tmp16_);
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp18_ = _tmp17_;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp19_ = music_libraries_manager;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp20_ = _tmp19_->local_library;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp8_ = _tmp18_ != _tmp20_;
#line 1215 "GenericList.c"
		}
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
		if (_tmp8_) {
#line 1219 "GenericList.c"
			GSettings* _tmp21_;
			GSettings* _tmp22_;
#line 245 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp21_ = music_app_get_saved_state ();
#line 245 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp22_ = _tmp21_;
#line 245 "../src/Views/ListView/Lists/GenericList.vala"
			g_settings_set_string (_tmp22_, "last-playlist-playing", "");
#line 1228 "GenericList.c"
		} else {
			MusicPlaylist* _tmp23_;
#line 246 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp23_ = self->priv->_playlist;
#line 246 "../src/Views/ListView/Lists/GenericList.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp23_, MUSIC_TYPE_SMART_PLAYLIST)) {
#line 1235 "GenericList.c"
				GSettings* _tmp24_;
				GSettings* _tmp25_;
				MusicPlaylist* _tmp26_;
				gint64 _tmp27_;
				gint64 _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp24_ = music_app_get_saved_state ();
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp25_ = _tmp24_;
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp26_ = self->priv->_playlist;
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp27_ = music_playlist_get_rowid (_tmp26_);
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp28_ = _tmp27_;
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp29_ = g_strdup_printf ("s%lld", _tmp28_);
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp30_ = _tmp29_;
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				g_settings_set_string (_tmp25_, "last-playlist-playing", _tmp30_);
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				_g_free0 (_tmp30_);
#line 1261 "GenericList.c"
			} else {
				MusicPlaylist* _tmp31_;
				gboolean _tmp32_;
				gboolean _tmp33_;
#line 249 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp31_ = self->priv->_playlist;
#line 249 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp32_ = music_static_playlist_get_read_only (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist));
#line 249 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp33_ = _tmp32_;
#line 249 "../src/Views/ListView/Lists/GenericList.vala"
				if (_tmp33_ == FALSE) {
#line 1274 "GenericList.c"
					GSettings* _tmp34_;
					GSettings* _tmp35_;
					MusicPlaylist* _tmp36_;
					gint64 _tmp37_;
					gint64 _tmp38_;
					gchar* _tmp39_;
					gchar* _tmp40_;
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp34_ = music_app_get_saved_state ();
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp35_ = _tmp34_;
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp36_ = self->priv->_playlist;
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp37_ = music_playlist_get_rowid (_tmp36_);
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp38_ = _tmp37_;
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp39_ = g_strdup_printf ("p%lld", _tmp38_);
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp40_ = _tmp39_;
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					g_settings_set_string (_tmp35_, "last-playlist-playing", _tmp40_);
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					_g_free0 (_tmp40_);
#line 1300 "GenericList.c"
				} else {
					GSettings* _tmp41_;
					GSettings* _tmp42_;
#line 252 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp41_ = music_app_get_saved_state ();
#line 252 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp42_ = _tmp41_;
#line 252 "../src/Views/ListView/Lists/GenericList.vala"
					g_settings_set_string (_tmp42_, "last-playlist-playing", "");
#line 1310 "GenericList.c"
				}
			}
		}
	}
#line 257 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp43_ = to_set;
#line 257 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp44_ = music_generic_list_get_visible_table (self);
#line 257 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp45_ = _tmp44_;
#line 257 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp46_ = music_generic_list_start_at (self, _tmp43_, (GeeList*) _tmp45_);
#line 257 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp47_ = _tmp46_;
#line 257 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (_tmp45_);
#line 257 "../src/Views/ListView/Lists/GenericList.vala"
	queue = _tmp47_;
#line 1329 "GenericList.c"
	{
		GeeList* _q_list = NULL;
		GeeList* _tmp48_;
		gint _q_size = 0;
		GeeList* _tmp49_;
		gint _tmp50_;
		gint _tmp51_;
		gint _q_index = 0;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp48_ = queue;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		_q_list = _tmp48_;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp49_ = _q_list;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp50_ = gee_collection_get_size ((GeeCollection*) _tmp49_);
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp51_ = _tmp50_;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		_q_size = _tmp51_;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		_q_index = -1;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		while (TRUE) {
#line 1354 "GenericList.c"
			gint _tmp52_;
			gint _tmp53_;
			MusicMedia* q = NULL;
			GeeList* _tmp54_;
			gpointer _tmp55_;
			MusicMedia* _tmp56_;
			const gchar* _tmp57_;
			const gchar* _tmp58_;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			_q_index = _q_index + 1;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp52_ = _q_index;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp53_ = _q_size;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			if (!(_tmp52_ < _tmp53_)) {
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
				break;
#line 1373 "GenericList.c"
			}
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp54_ = _q_list;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp55_ = gee_list_get (_tmp54_, _q_index);
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			q = (MusicMedia*) _tmp55_;
#line 259 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp56_ = q;
#line 259 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp57_ = music_media_get_title (_tmp56_);
#line 259 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp58_ = _tmp57_;
#line 259 "../src/Views/ListView/Lists/GenericList.vala"
			g_debug ("GenericList.vala:259: QUEING: %s", _tmp58_);
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			_g_object_unref0 (q);
#line 1391 "GenericList.c"
		}
	}
#line 261 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp59_ = music_app_get_player ();
#line 261 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp60_ = _tmp59_;
#line 261 "../src/Views/ListView/Lists/GenericList.vala"
	music_playback_manager_clear_queue (_tmp60_);
#line 262 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp61_ = music_app_get_player ();
#line 262 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp62_ = _tmp61_;
#line 262 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp63_ = queue;
#line 262 "../src/Views/ListView/Lists/GenericList.vala"
	music_playback_manager_queue_media (_tmp62_, (GeeCollection*) _tmp63_);
#line 263 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp64_ = music_app_get_player ();
#line 263 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp65_ = _tmp64_;
#line 263 "../src/Views/ListView/Lists/GenericList.vala"
	music_playback_manager_set_current_index (_tmp65_, 0);
#line 266 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp66_ = music_app_get_main_window ();
#line 266 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp67_ = _tmp66_;
#line 266 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp68_ = _tmp67_->match_playlists;
#line 266 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp69_ = music_app_get_player ();
#line 266 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp70_ = _tmp69_;
#line 266 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp71_ = _tmp70_->queue_playlist;
#line 266 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp72_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp68_, (MusicPlaylist*) _tmp71_);
#line 266 "../src/Views/ListView/Lists/GenericList.vala"
	view = (MusicViewWrapper*) _tmp72_;
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp73_ = music_view_wrapper_get_list_view (view);
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp74_ = _tmp73_;
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp75_ = music_list_view_get_list_view (_tmp74_);
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp76_ = _tmp75_;
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp77_ = self->priv->_tvs;
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp78_ = music_tree_view_setup_get_sort_column_id (_tmp77_);
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp79_ = _tmp78_;
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp80_ = self->priv->_tvs;
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp81_ = music_tree_view_setup_get_sort_direction (_tmp80_);
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp82_ = _tmp81_;
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_set_sort_column_id ((MusicGenericList*) _tmp76_, (gint) _tmp79_, _tmp82_);
#line 269 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp83_ = music_app_get_player ();
#line 269 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp84_ = _tmp83_;
#line 269 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp85_ = music_playback_manager_get_current_media (_tmp84_);
#line 269 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp86_ = _tmp85_;
#line 269 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_media_played (self, _tmp86_, NULL, NULL);
#line 237 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (view);
#line 237 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (queue);
#line 237 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (main_settings);
#line 237 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (to_set);
#line 1470 "GenericList.c"
}

/**
    * Shift a list (of media) to make it start at a given element
    */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1570 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1571 "glib-2.0.vapi"
	result = self;
#line 1571 "glib-2.0.vapi"
	return result;
#line 1486 "GenericList.c"
}

static GeeList*
music_generic_list_start_at (MusicGenericList* self,
                             MusicMedia* start,
                             GeeList* media)
{
	gint index = 0;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	GeeArrayList* res = NULL;
	GeeArrayList* _tmp27_;
	GeeArrayList* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	GeeList* _tmp31_;
	GeeList* _tmp32_;
	GeeArrayList* _tmp33_;
	GeeList* _tmp34_;
	GeeList* _tmp35_;
	GeeList* result;
#line 275 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 275 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (start != NULL, NULL);
#line 275 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (media != NULL, NULL);
#line 276 "../src/Views/ListView/Lists/GenericList.vala"
	index = 0;
#line 1527 "GenericList.c"
	{
		gboolean _tmp0_ = FALSE;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = TRUE;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
		while (TRUE) {
#line 1534 "GenericList.c"
			gboolean _tmp2_ = FALSE;
			gint _tmp3_;
			gint _tmp4_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
			if (!_tmp0_) {
#line 1540 "GenericList.c"
				gint _tmp1_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				index = index + 1;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp1_ = index;
#line 1546 "GenericList.c"
			}
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp0_ = FALSE;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp3_ = gee_collection_get_size ((GeeCollection*) media);
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp4_ = _tmp3_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
			if (index < _tmp4_) {
#line 1556 "GenericList.c"
				gpointer _tmp5_;
				MusicMedia* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp5_ = gee_list_get (media, index);
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp6_ = (MusicMedia*) _tmp5_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp7_ = music_media_get_uri (_tmp6_);
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp8_ = _tmp7_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp9_ = _tmp8_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp10_ = music_media_get_uri (start);
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp11_ = _tmp10_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp12_ = _tmp11_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp2_ = g_strcmp0 (_tmp9_, _tmp12_) != 0;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_g_free0 (_tmp12_);
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_g_free0 (_tmp9_);
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_g_object_unref0 (_tmp6_);
#line 1589 "GenericList.c"
			} else {
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp2_ = FALSE;
#line 1593 "GenericList.c"
			}
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
			if (!_tmp2_) {
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				break;
#line 1599 "GenericList.c"
			}
		}
	}
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp13_ = music_media_get_title (start);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp14_ = _tmp13_;
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp15_ = string_to_string (_tmp14_);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp16_ = gee_collection_get_size ((GeeCollection*) media);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp17_ = _tmp16_;
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp18_ = g_strdup_printf ("%i", _tmp17_);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp19_ = _tmp18_;
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp20_ = g_strdup_printf ("%i", index);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp21_ = _tmp20_;
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp22_ = g_strconcat ("TO START: '", _tmp15_, "', size = ", _tmp19_, ", index: ", _tmp21_, NULL);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp23_ = _tmp22_;
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	g_debug ("GenericList.vala:278: %s", _tmp23_);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_g_free0 (_tmp23_);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_g_free0 (_tmp21_);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_g_free0 (_tmp19_);
#line 280 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp24_ = gee_collection_get_size ((GeeCollection*) media);
#line 280 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp25_ = _tmp24_;
#line 280 "../src/Views/ListView/Lists/GenericList.vala"
	if (index == _tmp25_) {
#line 1639 "GenericList.c"
		GeeList* _tmp26_;
#line 281 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp26_ = _g_object_ref0 (media);
#line 281 "../src/Views/ListView/Lists/GenericList.vala"
		result = _tmp26_;
#line 281 "../src/Views/ListView/Lists/GenericList.vala"
		return result;
#line 1647 "GenericList.c"
	}
#line 284 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp27_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 284 "../src/Views/ListView/Lists/GenericList.vala"
	res = _tmp27_;
#line 285 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp28_ = res;
#line 285 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp29_ = gee_collection_get_size ((GeeCollection*) media);
#line 285 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp30_ = _tmp29_;
#line 285 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp31_ = gee_list_slice (media, index, _tmp30_);
#line 285 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp32_ = _tmp31_;
#line 285 "../src/Views/ListView/Lists/GenericList.vala"
	gee_array_list_add_all (_tmp28_, (GeeCollection*) _tmp32_);
#line 285 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (_tmp32_);
#line 286 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp33_ = res;
#line 286 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp34_ = gee_list_slice (media, 0, index);
#line 286 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp35_ = _tmp34_;
#line 286 "../src/Views/ListView/Lists/GenericList.vala"
	gee_array_list_add_all (_tmp33_, (GeeCollection*) _tmp35_);
#line 286 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (_tmp35_);
#line 287 "../src/Views/ListView/Lists/GenericList.vala"
	result = (GeeList*) res;
#line 287 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 1681 "GenericList.c"
}

static GtkTreePath*
_vala_GtkTreePath_copy (GtkTreePath* self)
{
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	return g_boxed_copy (gtk_tree_path_get_type (), self);
#line 1689 "GenericList.c"
}

static gpointer
__vala_GtkTreePath_copy0 (gpointer self)
{
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	return self ? _vala_GtkTreePath_copy (self) : NULL;
#line 1697 "GenericList.c"
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 1705 "GenericList.c"
}

static void
__vala_GtkTreePath_free0_ (gpointer var)
{
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	(var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL));
#line 1713 "GenericList.c"
}

static inline void
_g_list_free___vala_GtkTreePath_free0_ (GList* self)
{
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreePath_free0_);
#line 1721 "GenericList.c"
}

GeeCollection*
music_generic_list_get_selected_medias (MusicGenericList* self)
{
	GeeArrayQueue* rv = NULL;
	GeeArrayQueue* _tmp0_;
	GtkTreeModel* temp = NULL;
	GtkTreeSelection* _tmp1_;
	GtkTreeModel* _tmp2_ = NULL;
	GList* _tmp3_;
	GtkTreeModel* _tmp4_;
	GeeCollection* result;
#line 290 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 291 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = gee_array_queue_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 291 "../src/Views/ListView/Lists/GenericList.vala"
	rv = _tmp0_;
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = gtk_tree_selection_get_selected_rows (_tmp1_, &_tmp2_);
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (temp);
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp4_ = _g_object_ref0 (_tmp2_);
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	temp = _tmp4_;
#line 1751 "GenericList.c"
	{
		GList* path_collection = NULL;
		GList* path_it = NULL;
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
		path_collection = _tmp3_;
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
		for (path_it = path_collection; path_it != NULL; path_it = path_it->next) {
#line 1759 "GenericList.c"
			GtkTreePath* _tmp5_;
			GtkTreePath* path = NULL;
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp5_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) path_it->data);
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
			path = _tmp5_;
#line 1766 "GenericList.c"
			{
				MusicMedia* m = NULL;
				GtkTreePath* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				MusicMedia* _tmp9_;
				MusicMedia* _tmp10_;
				GeeArrayQueue* _tmp11_;
				MusicMedia* _tmp12_;
#line 295 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp6_ = path;
#line 295 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp7_ = gtk_tree_path_to_string (_tmp6_);
#line 295 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp8_ = _tmp7_;
#line 295 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp9_ = music_generic_list_get_media_from_index (self, atoi (_tmp8_));
#line 295 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp10_ = _tmp9_;
#line 295 "../src/Views/ListView/Lists/GenericList.vala"
				_g_free0 (_tmp8_);
#line 295 "../src/Views/ListView/Lists/GenericList.vala"
				m = _tmp10_;
#line 296 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp11_ = rv;
#line 296 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp12_ = m;
#line 296 "../src/Views/ListView/Lists/GenericList.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
				_g_object_unref0 (m);
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
				__vala_GtkTreePath_free0 (path);
#line 1800 "GenericList.c"
			}
		}
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
		(path_collection == NULL) ? NULL : (path_collection = (_g_list_free___vala_GtkTreePath_free0_ (path_collection), NULL));
#line 1805 "GenericList.c"
	}
#line 299 "../src/Views/ListView/Lists/GenericList.vala"
	result = (GeeCollection*) rv;
#line 299 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (temp);
#line 299 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 1813 "GenericList.c"
}

void
music_generic_list_scroll_to_current_media (MusicGenericList* self,
                                            gboolean unfilter_if_not_found)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
#line 302 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 303 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = music_app_get_player ();
#line 303 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = _tmp0_;
#line 303 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = music_playback_manager_get_current_media (_tmp1_);
#line 303 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = _tmp2_;
#line 303 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp3_ == NULL) {
#line 304 "../src/Views/ListView/Lists/GenericList.vala"
		return;
#line 1838 "GenericList.c"
	}
	{
		gint i = 0;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
		i = 0;
#line 1844 "GenericList.c"
		{
			gboolean _tmp4_ = FALSE;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp4_ = TRUE;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
			while (TRUE) {
#line 1851 "GenericList.c"
				GeeBidirList* _tmp6_;
				GeeBidirList* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
				gboolean _tmp10_;
				MusicMedia* m = NULL;
				MusicMedia* _tmp11_;
				MusicMedia* _tmp12_;
				MusicPlaybackManager* _tmp13_;
				MusicPlaybackManager* _tmp14_;
				MusicMedia* _tmp15_;
				MusicMedia* _tmp16_;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				if (!_tmp4_) {
#line 1866 "GenericList.c"
					gint _tmp5_;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
					i = i + 1;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp5_ = i;
#line 1872 "GenericList.c"
				}
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp4_ = FALSE;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp6_ = music_generic_list_get_visible_table (self);
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp7_ = _tmp6_;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp8_ = gee_collection_get_size ((GeeCollection*) _tmp7_);
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp9_ = _tmp8_;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp10_ = !(i < _tmp9_);
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				_g_object_unref0 (_tmp7_);
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				if (_tmp10_) {
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
					break;
#line 1892 "GenericList.c"
				}
#line 307 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp11_ = music_generic_list_get_media_from_index (self, i);
#line 307 "../src/Views/ListView/Lists/GenericList.vala"
				m = _tmp11_;
#line 309 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp12_ = m;
#line 309 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp13_ = music_app_get_player ();
#line 309 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp14_ = _tmp13_;
#line 309 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp15_ = music_playback_manager_get_current_media (_tmp14_);
#line 309 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp16_ = _tmp15_;
#line 309 "../src/Views/ListView/Lists/GenericList.vala"
				if (_tmp12_ == _tmp16_) {
#line 1910 "GenericList.c"
					GtkTreePath* path = NULL;
					GtkTreePath* _tmp17_;
					gboolean center_cell = FALSE;
					GtkTreePath* start_path = NULL;
					GtkTreePath* end_path = NULL;
					GtkTreePath* _tmp18_ = NULL;
					GtkTreePath* _tmp19_ = NULL;
					gboolean _tmp20_;
					GtkTreePath* _tmp30_;
					GtkTreeViewColumn* column = NULL;
					GtkTreeViewColumn* _tmp31_;
					GtkTreeViewColumn* _tmp32_;
					GtkTreePath* _tmp33_;
					GtkTreeViewColumn* _tmp34_;
					GtkTreeViewColumn* _tmp35_;
					GList* _tmp36_;
					GList* _tmp37_;
					gconstpointer _tmp38_;
#line 310 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp17_ = gtk_tree_path_new_from_indices (i, -1, -1);
#line 310 "../src/Views/ListView/Lists/GenericList.vala"
					path = _tmp17_;
#line 315 "../src/Views/ListView/Lists/GenericList.vala"
					center_cell = FALSE;
#line 319 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp20_ = gtk_tree_view_get_visible_range ((GtkTreeView*) self, &_tmp18_, &_tmp19_);
#line 319 "../src/Views/ListView/Lists/GenericList.vala"
					__vala_GtkTreePath_free0 (start_path);
#line 319 "../src/Views/ListView/Lists/GenericList.vala"
					start_path = _tmp18_;
#line 319 "../src/Views/ListView/Lists/GenericList.vala"
					__vala_GtkTreePath_free0 (end_path);
#line 319 "../src/Views/ListView/Lists/GenericList.vala"
					end_path = _tmp19_;
#line 319 "../src/Views/ListView/Lists/GenericList.vala"
					if (_tmp20_) {
#line 1947 "GenericList.c"
						gint start_index = 0;
						GtkTreePath* _tmp21_;
						gint _tmp22_ = 0;
						gint* _tmp23_;
						gint _tmp24_;
						gint end_index = 0;
						GtkTreePath* _tmp25_;
						gint _tmp26_ = 0;
						gint* _tmp27_;
						gint _tmp28_;
						gboolean _tmp29_ = FALSE;
#line 320 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp21_ = start_path;
#line 320 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp23_ = gtk_tree_path_get_indices_with_depth (_tmp21_, &_tmp22_);
#line 320 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp24_ = _tmp23_[0];
#line 320 "../src/Views/ListView/Lists/GenericList.vala"
						start_index = _tmp24_;
#line 321 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp25_ = end_path;
#line 321 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp27_ = gtk_tree_path_get_indices_with_depth (_tmp25_, &_tmp26_);
#line 321 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp28_ = _tmp27_[0];
#line 321 "../src/Views/ListView/Lists/GenericList.vala"
						end_index = _tmp28_;
#line 328 "../src/Views/ListView/Lists/GenericList.vala"
						if (i < (start_index - 1)) {
#line 328 "../src/Views/ListView/Lists/GenericList.vala"
							_tmp29_ = TRUE;
#line 1979 "GenericList.c"
						} else {
#line 328 "../src/Views/ListView/Lists/GenericList.vala"
							_tmp29_ = i > (end_index + 1);
#line 1983 "GenericList.c"
						}
#line 328 "../src/Views/ListView/Lists/GenericList.vala"
						if (_tmp29_) {
#line 329 "../src/Views/ListView/Lists/GenericList.vala"
							center_cell = TRUE;
#line 1989 "GenericList.c"
						}
					}
#line 332 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp30_ = path;
#line 332 "../src/Views/ListView/Lists/GenericList.vala"
					gtk_tree_view_scroll_to_cell ((GtkTreeView*) self, _tmp30_, NULL, center_cell, 0.5f, (gfloat) 0);
#line 334 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp31_ = gtk_tree_view_get_column ((GtkTreeView*) self, 0);
#line 334 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp32_ = _g_object_ref0 (_tmp31_);
#line 334 "../src/Views/ListView/Lists/GenericList.vala"
					column = _tmp32_;
#line 335 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp33_ = path;
#line 335 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp34_ = column;
#line 335 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp35_ = column;
#line 335 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp36_ = gtk_cell_layout_get_cells ((GtkCellLayout*) _tmp35_);
#line 335 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp37_ = _tmp36_;
#line 335 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp38_ = g_list_nth_data (_tmp37_, (guint) 0);
#line 335 "../src/Views/ListView/Lists/GenericList.vala"
					gtk_tree_view_set_cursor_on_cell ((GtkTreeView*) self, _tmp33_, _tmp34_, (GtkCellRenderer*) _tmp38_, FALSE);
#line 335 "../src/Views/ListView/Lists/GenericList.vala"
					(_tmp37_ == NULL) ? NULL : (_tmp37_ = (g_list_free (_tmp37_), NULL));
#line 337 "../src/Views/ListView/Lists/GenericList.vala"
					_g_object_unref0 (column);
#line 337 "../src/Views/ListView/Lists/GenericList.vala"
					__vala_GtkTreePath_free0 (end_path);
#line 337 "../src/Views/ListView/Lists/GenericList.vala"
					__vala_GtkTreePath_free0 (start_path);
#line 337 "../src/Views/ListView/Lists/GenericList.vala"
					__vala_GtkTreePath_free0 (path);
#line 337 "../src/Views/ListView/Lists/GenericList.vala"
					_g_object_unref0 (m);
#line 337 "../src/Views/ListView/Lists/GenericList.vala"
					break;
#line 2030 "GenericList.c"
				}
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				_g_object_unref0 (m);
#line 2034 "GenericList.c"
			}
		}
	}
}

/** Should not be manipulated by client */
GeeBidirList*
music_generic_list_get_table (MusicGenericList* self)
{
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	GeeBidirList* result;
#line 343 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 344 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->table;
#line 344 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
#line 344 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = _tmp1_;
#line 344 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp2_;
#line 344 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 2060 "GenericList.c"
}

/** Should not be manipulated by client */
GeeBidirList*
music_generic_list_get_visible_table (MusicGenericList* self)
{
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	GeeBidirList* result;
#line 348 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 349 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->showing;
#line 349 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
#line 349 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = _tmp1_;
#line 349 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp2_;
#line 349 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 2083 "GenericList.c"
}

gint
music_generic_list_get_index_from_iter (GtkTreeIter* iter)
{
	GtkTreeIter _tmp0_;
	void* _tmp1_;
	gint result;
#line 352 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (iter != NULL, 0);
#line 353 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = *iter;
#line 353 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = _tmp0_.user_data;
#line 353 "../src/Views/ListView/Lists/GenericList.vala"
	result = (gint) _tmp1_;
#line 353 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 2102 "GenericList.c"
}

MusicMedia*
music_generic_list_get_object_from_index (MusicGenericList* self,
                                          gint index)
{
	MusicMedia* _tmp0_ = NULL;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	MusicMedia* result;
#line 356 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = self->showing;
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = _tmp2_;
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
	if (index < _tmp3_) {
#line 2124 "GenericList.c"
		GeeArrayList* _tmp4_;
		gpointer _tmp5_;
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp4_ = self->showing;
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp4_, index);
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (_tmp0_);
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = (MusicMedia*) _tmp5_;
#line 2135 "GenericList.c"
	} else {
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (_tmp0_);
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = NULL;
#line 2141 "GenericList.c"
	}
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp0_;
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 2147 "GenericList.c"
}

void
music_generic_list_set_value_func (MusicGenericList* self,
                                   MusicFastModelValueReturnFunc func,
                                   gpointer func_target)
{
	MusicFastModel* _tmp0_;
#line 360 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 361 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->fm;
#line 361 "../src/Views/ListView/Lists/GenericList.vala"
	music_fast_model_set_value_func (_tmp0_, func, func_target);
#line 2162 "GenericList.c"
}

void
music_generic_list_set_table (MusicGenericList* self,
                              GeeArrayList* table,
                              gboolean do_resort)
{
	GeeArrayList* _tmp0_;
#line 364 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 364 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (table != NULL);
#line 365 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = _g_object_ref0 (table);
#line 365 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->table);
#line 365 "../src/Views/ListView/Lists/GenericList.vala"
	self->table = _tmp0_;
#line 367 "../src/Views/ListView/Lists/GenericList.vala"
	if (do_resort) {
#line 368 "../src/Views/ListView/Lists/GenericList.vala"
		music_generic_list_resort (self);
#line 2185 "GenericList.c"
	} else {
#line 370 "../src/Views/ListView/Lists/GenericList.vala"
		music_generic_list_do_search (self, NULL);
#line 2189 "GenericList.c"
	}
}

void
music_generic_list_set_search_func (MusicGenericList* self,
                                    MusicGenericListViewSearchFunc func,
                                    gpointer func_target)
{
#line 374 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 375 "../src/Views/ListView/Lists/GenericList.vala"
	self->priv->search_func = func;
#line 375 "../src/Views/ListView/Lists/GenericList.vala"
	self->priv->search_func_target = func_target;
#line 2204 "GenericList.c"
}

void
music_generic_list_do_search (MusicGenericList* self,
                              const gchar* search)
{
	gboolean _tmp0_ = FALSE;
	MusicGenericListViewSearchFunc _tmp1_;
	gpointer _tmp1__target;
	gint old_size = 0;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeArrayList* _tmp6_;
	const gchar* _tmp7_ = NULL;
	MusicGenericListViewSearchFunc _tmp8_;
	gpointer _tmp8__target;
	GeeArrayList* _tmp9_;
	GeeArrayList* _tmp10_;
	GeeArrayList* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
#line 378 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 379 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = self->priv->search_func;
#line 379 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1__target = self->priv->search_func_target;
#line 379 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp1_ == NULL) {
#line 379 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = TRUE;
#line 2237 "GenericList.c"
	} else {
		gboolean _tmp2_;
#line 379 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp2_ = self->priv->_research_needed;
#line 379 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = _tmp2_ == FALSE;
#line 2244 "GenericList.c"
	}
#line 379 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp0_) {
#line 380 "../src/Views/ListView/Lists/GenericList.vala"
		return;
#line 2250 "GenericList.c"
	}
#line 383 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_set_research_needed (self, FALSE);
#line 384 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = self->showing;
#line 384 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 384 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp5_ = _tmp4_;
#line 384 "../src/Views/ListView/Lists/GenericList.vala"
	old_size = _tmp5_;
#line 386 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp6_ = self->showing;
#line 386 "../src/Views/ListView/Lists/GenericList.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp6_);
#line 387 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp7_ = search;
#line 387 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp7_ == NULL) {
#line 387 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp7_ = "";
#line 2272 "GenericList.c"
	}
#line 387 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp8_ = self->priv->search_func;
#line 387 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp8__target = self->priv->search_func_target;
#line 387 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp9_ = self->table;
#line 387 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp10_ = self->showing;
#line 387 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp8_ (_tmp7_, _tmp9_, _tmp10_, _tmp8__target);
#line 389 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp11_ = self->showing;
#line 389 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 389 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp13_ = _tmp12_;
#line 389 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp13_ == old_size) {
#line 2292 "GenericList.c"
		MusicFastModel* _tmp14_;
		GeeArrayList* _tmp15_;
#line 390 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp14_ = self->fm;
#line 390 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp15_ = self->showing;
#line 390 "../src/Views/ListView/Lists/GenericList.vala"
		music_fast_model_set_table (_tmp14_, _tmp15_);
#line 391 "../src/Views/ListView/Lists/GenericList.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 2303 "GenericList.c"
	} else {
#line 392 "../src/Views/ListView/Lists/GenericList.vala"
		if (old_size == 0) {
#line 2307 "GenericList.c"
			MusicFastModel* _tmp16_;
			GeeArrayList* _tmp17_;
			MusicFastModel* _tmp18_;
#line 393 "../src/Views/ListView/Lists/GenericList.vala"
			gtk_tree_view_set_model ((GtkTreeView*) self, NULL);
#line 394 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp16_ = self->fm;
#line 394 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp17_ = self->showing;
#line 394 "../src/Views/ListView/Lists/GenericList.vala"
			music_fast_model_set_table (_tmp16_, _tmp17_);
#line 395 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp18_ = self->fm;
#line 395 "../src/Views/ListView/Lists/GenericList.vala"
			gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp18_);
#line 2323 "GenericList.c"
		} else {
			GeeArrayList* _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
#line 396 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp19_ = self->showing;
#line 396 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp20_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp19_);
#line 396 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp21_ = _tmp20_;
#line 396 "../src/Views/ListView/Lists/GenericList.vala"
			if (old_size > _tmp21_) {
#line 2336 "GenericList.c"
				MusicFastModel* _tmp31_;
				GeeArrayList* _tmp32_;
#line 397 "../src/Views/ListView/Lists/GenericList.vala"
				while (TRUE) {
#line 2341 "GenericList.c"
					MusicFastModel* _tmp22_;
					GeeArrayList* _tmp23_;
					gint _tmp24_;
					gint _tmp25_;
					GtkTreeIter iter = {0};
					MusicFastModel* _tmp26_;
					MusicFastModel* _tmp27_;
					GtkTreeIter _tmp28_ = {0};
					MusicFastModel* _tmp29_;
					GtkTreeIter _tmp30_;
#line 397 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp22_ = self->fm;
#line 397 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp23_ = self->showing;
#line 397 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp24_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp23_);
#line 397 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp25_ = _tmp24_;
#line 397 "../src/Views/ListView/Lists/GenericList.vala"
					if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp22_, NULL) > _tmp25_)) {
#line 397 "../src/Views/ListView/Lists/GenericList.vala"
						break;
#line 2364 "GenericList.c"
					}
#line 399 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp26_ = self->fm;
#line 399 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp27_ = self->fm;
#line 399 "../src/Views/ListView/Lists/GenericList.vala"
					gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp26_, &_tmp28_, NULL, gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp27_, NULL) - 1);
#line 399 "../src/Views/ListView/Lists/GenericList.vala"
					iter = _tmp28_;
#line 400 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp29_ = self->fm;
#line 400 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp30_ = iter;
#line 400 "../src/Views/ListView/Lists/GenericList.vala"
					music_fast_model_remove (_tmp29_, &_tmp30_);
#line 2380 "GenericList.c"
				}
#line 403 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp31_ = self->fm;
#line 403 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp32_ = self->showing;
#line 403 "../src/Views/ListView/Lists/GenericList.vala"
				music_fast_model_set_table (_tmp31_, _tmp32_);
#line 404 "../src/Views/ListView/Lists/GenericList.vala"
				gtk_widget_queue_draw ((GtkWidget*) self);
#line 2390 "GenericList.c"
			} else {
				GeeArrayList* _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
#line 405 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp33_ = self->showing;
#line 405 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp34_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp33_);
#line 405 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp35_ = _tmp34_;
#line 405 "../src/Views/ListView/Lists/GenericList.vala"
				if (_tmp35_ > old_size) {
#line 2403 "GenericList.c"
					GtkTreeIter iter = {0};
					MusicFastModel* _tmp42_;
					GeeArrayList* _tmp43_;
#line 408 "../src/Views/ListView/Lists/GenericList.vala"
					while (TRUE) {
#line 2409 "GenericList.c"
						MusicFastModel* _tmp36_;
						GeeArrayList* _tmp37_;
						gint _tmp38_;
						gint _tmp39_;
						MusicFastModel* _tmp40_;
						GtkTreeIter _tmp41_ = {0};
#line 408 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp36_ = self->fm;
#line 408 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp37_ = self->showing;
#line 408 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp38_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp37_);
#line 408 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp39_ = _tmp38_;
#line 408 "../src/Views/ListView/Lists/GenericList.vala"
						if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp36_, NULL) < _tmp39_)) {
#line 408 "../src/Views/ListView/Lists/GenericList.vala"
							break;
#line 2428 "GenericList.c"
						}
#line 409 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp40_ = self->fm;
#line 409 "../src/Views/ListView/Lists/GenericList.vala"
						music_fast_model_append (_tmp40_, &_tmp41_);
#line 409 "../src/Views/ListView/Lists/GenericList.vala"
						iter = _tmp41_;
#line 2436 "GenericList.c"
					}
#line 412 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp42_ = self->fm;
#line 412 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp43_ = self->showing;
#line 412 "../src/Views/ListView/Lists/GenericList.vala"
					music_fast_model_set_table (_tmp42_, _tmp43_);
#line 413 "../src/Views/ListView/Lists/GenericList.vala"
					gtk_widget_queue_draw ((GtkWidget*) self);
#line 2446 "GenericList.c"
				}
			}
		}
	}
}

void
music_generic_list_set_sort_column_id (MusicGenericList* self,
                                       gint sort_column_id,
                                       GtkSortType order)
{
	MusicFastModel* _tmp0_;
#line 421 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 422 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->fm;
#line 422 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp0_, sort_column_id, order);
#line 2465 "GenericList.c"
}

static void
music_generic_list_reorder_requested (MusicGenericList* self,
                                      gint column,
                                      GtkSortType direction)
{
	gboolean _tmp0_ = FALSE;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 425 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 426 "../src/Views/ListView/Lists/GenericList.vala"
	if (column == self->sort_column_id) {
#line 426 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = direction == self->sort_direction;
#line 2483 "GenericList.c"
	} else {
#line 426 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = FALSE;
#line 2487 "GenericList.c"
	}
#line 426 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp0_) {
#line 427 "../src/Views/ListView/Lists/GenericList.vala"
		return;
#line 2493 "GenericList.c"
	}
#line 430 "../src/Views/ListView/Lists/GenericList.vala"
	self->sort_column_id = column;
#line 431 "../src/Views/ListView/Lists/GenericList.vala"
	self->sort_direction = direction;
#line 433 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = self->table;
#line 433 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 433 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = _tmp2_;
#line 433 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_quicksort (self, 0, _tmp3_ - 1);
#line 434 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_set_research_needed (self, TRUE);
#line 435 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_do_search (self, NULL);
#line 438 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_emit (self, music_generic_list_signals[MUSIC_GENERIC_LIST_ROWS_REORDERED_SIGNAL], 0);
#line 2513 "GenericList.c"
}

void
music_generic_list_resort (MusicGenericList* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 441 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 442 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->table;
#line 442 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 442 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = _tmp1_;
#line 442 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_quicksort (self, 0, _tmp2_ - 1);
#line 444 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_set_research_needed (self, TRUE);
#line 445 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_do_search (self, NULL);
#line 2536 "GenericList.c"
}

void
music_generic_list_set_compare_func (MusicGenericList* self,
                                     MusicGenericListSortCompareFunc func,
                                     gpointer func_target)
{
#line 448 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 449 "../src/Views/ListView/Lists/GenericList.vala"
	self->priv->compare_func = func;
#line 449 "../src/Views/ListView/Lists/GenericList.vala"
	self->priv->compare_func_target = func_target;
#line 2550 "GenericList.c"
}

static void
music_generic_list_swap (MusicGenericList* self,
                         gint a,
                         gint b)
{
	MusicMedia* temp = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gpointer _tmp4_;
	MusicMedia* _tmp5_;
	GeeArrayList* _tmp6_;
#line 452 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 453 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->table;
#line 453 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, a);
#line 453 "../src/Views/ListView/Lists/GenericList.vala"
	temp = (MusicMedia*) _tmp1_;
#line 454 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = self->table;
#line 454 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = self->table;
#line 454 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, b);
#line 454 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp5_ = (MusicMedia*) _tmp4_;
#line 454 "../src/Views/ListView/Lists/GenericList.vala"
	gee_abstract_list_set ((GeeAbstractList*) _tmp2_, a, _tmp5_);
#line 454 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (_tmp5_);
#line 455 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp6_ = self->table;
#line 455 "../src/Views/ListView/Lists/GenericList.vala"
	gee_abstract_list_set ((GeeAbstractList*) _tmp6_, b, temp);
#line 452 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (temp);
#line 2592 "GenericList.c"
}

static void
music_generic_list_quicksort (MusicGenericList* self,
                              gint start,
                              gint end)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint pivot_index = 0;
	MusicMedia* pivot = NULL;
	GeeArrayList* _tmp3_;
	gpointer _tmp4_;
	gint i = 0;
	gint j = 0;
#line 458 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 459 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->table;
#line 459 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 459 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = _tmp1_;
#line 459 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp2_ == 0) {
#line 460 "../src/Views/ListView/Lists/GenericList.vala"
		return;
#line 2621 "GenericList.c"
	}
#line 463 "../src/Views/ListView/Lists/GenericList.vala"
	pivot_index = (start + end) / 2;
#line 464 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = self->table;
#line 464 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, pivot_index);
#line 464 "../src/Views/ListView/Lists/GenericList.vala"
	pivot = (MusicMedia*) _tmp4_;
#line 465 "../src/Views/ListView/Lists/GenericList.vala"
	i = start;
#line 466 "../src/Views/ListView/Lists/GenericList.vala"
	j = end;
#line 468 "../src/Views/ListView/Lists/GenericList.vala"
	while (TRUE) {
#line 468 "../src/Views/ListView/Lists/GenericList.vala"
		if (!(i <= j)) {
#line 468 "../src/Views/ListView/Lists/GenericList.vala"
			break;
#line 2641 "GenericList.c"
		}
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
		while (TRUE) {
#line 2645 "GenericList.c"
			gboolean _tmp5_ = FALSE;
			gint _tmp11_;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
			if (i < end) {
#line 2650 "GenericList.c"
				MusicGenericListSortCompareFunc _tmp6_;
				gpointer _tmp6__target;
				GeeArrayList* _tmp7_;
				gpointer _tmp8_;
				MusicMedia* _tmp9_;
				MusicMedia* _tmp10_;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp6_ = self->priv->compare_func;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp6__target = self->priv->compare_func_target;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp7_ = self->table;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, i);
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp9_ = (MusicMedia*) _tmp8_;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp10_ = pivot;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp5_ = _tmp6_ (self->sort_column_id, self->sort_direction, _tmp9_, _tmp10_, i, pivot_index, _tmp6__target) < 0;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_g_object_unref0 (_tmp9_);
#line 2673 "GenericList.c"
			} else {
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp5_ = FALSE;
#line 2677 "GenericList.c"
			}
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
			if (!_tmp5_) {
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				break;
#line 2683 "GenericList.c"
			}
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
			i = i + 1;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp11_ = i;
#line 2689 "GenericList.c"
		}
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
		while (TRUE) {
#line 2693 "GenericList.c"
			gboolean _tmp12_ = FALSE;
			gint _tmp18_;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
			if (j > start) {
#line 2698 "GenericList.c"
				MusicGenericListSortCompareFunc _tmp13_;
				gpointer _tmp13__target;
				GeeArrayList* _tmp14_;
				gpointer _tmp15_;
				MusicMedia* _tmp16_;
				MusicMedia* _tmp17_;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp13_ = self->priv->compare_func;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp13__target = self->priv->compare_func_target;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp14_ = self->table;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, j);
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp16_ = (MusicMedia*) _tmp15_;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp17_ = pivot;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp12_ = _tmp13_ (self->sort_column_id, self->sort_direction, _tmp16_, _tmp17_, j, pivot_index, _tmp13__target) > 0;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_g_object_unref0 (_tmp16_);
#line 2721 "GenericList.c"
			} else {
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp12_ = FALSE;
#line 2725 "GenericList.c"
			}
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
			if (!_tmp12_) {
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				break;
#line 2731 "GenericList.c"
			}
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
			j = j - 1;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp18_ = j;
#line 2737 "GenericList.c"
		}
#line 471 "../src/Views/ListView/Lists/GenericList.vala"
		if (i <= j) {
#line 2741 "GenericList.c"
			gint _tmp19_;
			gint _tmp20_;
#line 472 "../src/Views/ListView/Lists/GenericList.vala"
			music_generic_list_swap (self, i, j);
#line 473 "../src/Views/ListView/Lists/GenericList.vala"
			i = i + 1;
#line 473 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp19_ = i;
#line 473 "../src/Views/ListView/Lists/GenericList.vala"
			j = j - 1;
#line 473 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp20_ = j;
#line 2754 "GenericList.c"
		}
	}
#line 477 "../src/Views/ListView/Lists/GenericList.vala"
	if (start < j) {
#line 478 "../src/Views/ListView/Lists/GenericList.vala"
		music_generic_list_quicksort (self, start, j);
#line 2761 "GenericList.c"
	}
#line 480 "../src/Views/ListView/Lists/GenericList.vala"
	if (i < end) {
#line 481 "../src/Views/ListView/Lists/GenericList.vala"
		music_generic_list_quicksort (self, i, end);
#line 2767 "GenericList.c"
	}
#line 458 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (pivot);
#line 2771 "GenericList.c"
}

/** **********************************************************
     * Drag and drop support. GenericList is a source for media and can
     * be dragged to a playlist in the sidebar. No support for reordering
     * is implemented yet.
    ***************************************************************/
static void
music_generic_list_on_drag_begin (MusicGenericList* self,
                                  GtkWidget* sender,
                                  GdkDragContext* context)
{
	gint selected_rows = 0;
	GtkTreeSelection* _tmp0_;
#line 490 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 490 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (sender != NULL);
#line 490 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (context != NULL);
#line 491 "../src/Views/ListView/Lists/GenericList.vala"
	self->dragging = TRUE;
#line 492 "../src/Views/ListView/Lists/GenericList.vala"
	g_debug ("GenericList.vala:492: drag begin");
#line 494 "../src/Views/ListView/Lists/GenericList.vala"
	gdk_drag_abort (context, gtk_get_current_event_time ());
#line 496 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 496 "../src/Views/ListView/Lists/GenericList.vala"
	selected_rows = gtk_tree_selection_count_selected_rows (_tmp0_);
#line 498 "../src/Views/ListView/Lists/GenericList.vala"
	if (selected_rows > 0) {
#line 499 "../src/Views/ListView/Lists/GenericList.vala"
		gtk_drag_source_set_icon_name ((GtkWidget*) self, "audio-x-generic");
#line 2806 "GenericList.c"
	}
}

static void
_vala_array_add13 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
	if ((*length) == (*size)) {
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2822 "GenericList.c"
	}
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
	(*array)[(*length)++] = value;
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
	(*array)[*length] = NULL;
#line 2828 "GenericList.c"
}

static void
music_generic_list_on_drag_data_get (MusicGenericList* self,
                                     GdkDragContext* context,
                                     GtkSelectionData* selection_data,
                                     guint info,
                                     guint time_)
{
	gchar** uris = NULL;
	gint uris_length1;
	gint _uris_size_;
	gchar** _tmp10_;
	gint _tmp10__length1;
#line 502 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 502 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (context != NULL);
#line 502 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (selection_data != NULL);
#line 503 "../src/Views/ListView/Lists/GenericList.vala"
	uris = NULL;
#line 503 "../src/Views/ListView/Lists/GenericList.vala"
	uris_length1 = 0;
#line 503 "../src/Views/ListView/Lists/GenericList.vala"
	_uris_size_ = uris_length1;
#line 2855 "GenericList.c"
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = music_generic_list_get_selected_medias (self);
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp1_ = _tmp0_;
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp3_ = _tmp2_;
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (_tmp1_);
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
		_m_it = _tmp3_;
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
		while (TRUE) {
#line 2876 "GenericList.c"
			GeeIterator* _tmp4_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			MusicMedia* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp4_ = _m_it;
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
				break;
#line 2890 "GenericList.c"
			}
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp5_ = _m_it;
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
			m = (MusicMedia*) _tmp6_;
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp7_ = m;
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp8_ = music_media_get_uri (_tmp7_);
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp9_ = _tmp8_;
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
			_vala_array_add13 (&uris, &uris_length1, &_uris_size_, _tmp9_);
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
			_g_object_unref0 (m);
#line 2908 "GenericList.c"
		}
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (_m_it);
#line 2912 "GenericList.c"
	}
#line 508 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp10_ = uris;
#line 508 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp10__length1 = uris_length1;
#line 508 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp10_ != NULL) {
#line 2920 "GenericList.c"
		gchar** _tmp11_;
		gint _tmp11__length1;
#line 509 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp11_ = uris;
#line 509 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp11__length1 = uris_length1;
#line 509 "../src/Views/ListView/Lists/GenericList.vala"
		gtk_selection_data_set_uris (selection_data, _tmp11_);
#line 2929 "GenericList.c"
	}
#line 502 "../src/Views/ListView/Lists/GenericList.vala"
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 2933 "GenericList.c"
}

static void
music_generic_list_on_drag_end (MusicGenericList* self,
                                GtkWidget* sender,
                                GdkDragContext* context)
{
	GtkTargetEntry* _tmp0_;
	GtkTargetEntry* _tmp1_;
	gint _tmp1__length1;
#line 512 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 512 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (sender != NULL);
#line 512 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (context != NULL);
#line 513 "../src/Views/ListView/Lists/GenericList.vala"
	self->dragging = FALSE;
#line 515 "../src/Views/ListView/Lists/GenericList.vala"
	g_debug ("GenericList.vala:515: drag end\n");
#line 518 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = g_new0 (GtkTargetEntry, 0);
#line 518 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = _tmp0_;
#line 518 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1__length1 = 0;
#line 518 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_drag_dest_set ((GtkWidget*) self, GTK_DEST_DEFAULT_ALL, _tmp1_, (gint) 0, GDK_ACTION_COPY | GDK_ACTION_MOVE);
#line 518 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 2964 "GenericList.c"
}

GeeList*
music_generic_list_get_columns (MusicGenericList* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->priv->_columns;
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp0_;
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 2980 "GenericList.c"
}

void
music_generic_list_set_columns (MusicGenericList* self,
                                GeeList* value)
{
	GeeList* old_value;
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
	old_value = music_generic_list_get_columns (self);
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
	if (old_value != value) {
#line 2994 "GenericList.c"
		GeeList* _tmp0_;
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (self->priv->_columns);
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
		self->priv->_columns = _tmp0_;
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
		g_object_notify_by_pspec ((GObject *) self, music_generic_list_properties[MUSIC_GENERIC_LIST_COLUMNS_PROPERTY]);
#line 3004 "GenericList.c"
	}
}

gboolean
music_generic_list_get_research_needed (MusicGenericList* self)
{
	gboolean result;
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
	result = self->priv->_research_needed;
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 3018 "GenericList.c"
}

void
music_generic_list_set_research_needed (MusicGenericList* self,
                                        gboolean value)
{
	gboolean old_value;
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
	old_value = music_generic_list_get_research_needed (self);
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
	if (old_value != value) {
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
		self->priv->_research_needed = value;
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
		g_object_notify_by_pspec ((GObject *) self, music_generic_list_properties[MUSIC_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY]);
#line 3036 "GenericList.c"
	}
}

gboolean
music_generic_list_get_is_current_list (MusicGenericList* self)
{
	gboolean result;
#line 36 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/Views/ListView/Lists/GenericList.vala"
	result = self->priv->_is_current_list;
#line 36 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 3050 "GenericList.c"
}

static void
music_generic_list_set_is_current_list (MusicGenericList* self,
                                        gboolean value)
{
	gboolean old_value;
#line 36 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Views/ListView/Lists/GenericList.vala"
	old_value = music_generic_list_get_is_current_list (self);
#line 36 "../src/Views/ListView/Lists/GenericList.vala"
	if (old_value != value) {
#line 36 "../src/Views/ListView/Lists/GenericList.vala"
		self->priv->_is_current_list = value;
#line 36 "../src/Views/ListView/Lists/GenericList.vala"
		g_object_notify_by_pspec ((GObject *) self, music_generic_list_properties[MUSIC_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY]);
#line 3068 "GenericList.c"
	}
}

MusicPlaylist*
music_generic_list_get_playlist (MusicGenericList* self)
{
	MusicPlaylist* result;
	MusicPlaylist* _tmp0_;
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->priv->_playlist;
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp0_;
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 3085 "GenericList.c"
}

void
music_generic_list_set_playlist (MusicGenericList* self,
                                 MusicPlaylist* value)
{
	MusicPlaylist* old_value;
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
	old_value = music_generic_list_get_playlist (self);
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
	if (old_value != value) {
#line 3099 "GenericList.c"
		MusicPlaylist* _tmp0_;
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (self->priv->_playlist);
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
		self->priv->_playlist = _tmp0_;
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
		g_object_notify_by_pspec ((GObject *) self, music_generic_list_properties[MUSIC_GENERIC_LIST_PLAYLIST_PROPERTY]);
#line 3109 "GenericList.c"
	}
}

MusicTreeViewSetup*
music_generic_list_get_tvs (MusicGenericList* self)
{
	MusicTreeViewSetup* result;
	MusicTreeViewSetup* _tmp0_;
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->priv->_tvs;
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp0_;
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 3126 "GenericList.c"
}

void
music_generic_list_set_tvs (MusicGenericList* self,
                            MusicTreeViewSetup* value)
{
	MusicTreeViewSetup* old_value;
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
	old_value = music_generic_list_get_tvs (self);
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
	if (old_value != value) {
#line 3140 "GenericList.c"
		MusicTreeViewSetup* _tmp0_;
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (self->priv->_tvs);
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
		self->priv->_tvs = _tmp0_;
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
		g_object_notify_by_pspec ((GObject *) self, music_generic_list_properties[MUSIC_GENERIC_LIST_TVS_PROPERTY]);
#line 3150 "GenericList.c"
	}
}

MusicViewWrapperHint
music_generic_list_get_hint (MusicGenericList* self)
{
	MusicViewWrapperHint result;
	MusicTreeViewSetup* _tmp0_;
	MusicViewWrapperHint _tmp1_;
	MusicViewWrapperHint _tmp2_;
#line 41 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 42 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->priv->_tvs;
#line 42 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = music_tree_view_setup_get_hint (_tmp0_);
#line 42 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = _tmp1_;
#line 42 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp2_;
#line 42 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 3173 "GenericList.c"
}

void
music_generic_list_set_hint (MusicGenericList* self,
                             MusicViewWrapperHint value)
{
	MusicTreeViewSetup* _tmp0_;
#line 44 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->priv->_tvs;
#line 45 "../src/Views/ListView/Lists/GenericList.vala"
	music_tree_view_setup_set_hint (_tmp0_, value);
#line 44 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_notify_by_pspec ((GObject *) self, music_generic_list_properties[MUSIC_GENERIC_LIST_HINT_PROPERTY]);
#line 3189 "GenericList.c"
}

MusicViewWrapper*
music_generic_list_get_parent_wrapper (MusicGenericList* self)
{
	MusicViewWrapper* result;
	MusicViewWrapper* _tmp0_;
#line 51 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->priv->_parent_wrapper;
#line 52 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp0_;
#line 52 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 3205 "GenericList.c"
}

void
music_generic_list_set_parent_wrapper (MusicGenericList* self,
                                       MusicViewWrapper* value)
{
	MusicViewWrapper* _tmp0_;
	MusicPlaylist* _tmp1_;
	MusicPlaylist* _tmp2_;
#line 54 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 55 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->priv->_parent_wrapper);
#line 55 "../src/Views/ListView/Lists/GenericList.vala"
	self->priv->_parent_wrapper = _tmp0_;
#line 56 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = music_view_wrapper_get_playlist (value);
#line 56 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = _tmp1_;
#line 56 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_set_playlist (self, _tmp2_);
#line 54 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_notify_by_pspec ((GObject *) self, music_generic_list_properties[MUSIC_GENERIC_LIST_PARENT_WRAPPER_PROPERTY]);
#line 3231 "GenericList.c"
}

static void
_music_generic_list_reorder_requested_music_fast_model_reorder_requested (MusicFastModel* _sender,
                                                                          gint column,
                                                                          GtkSortType direction,
                                                                          gpointer self)
{
#line 108 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_reorder_requested ((MusicGenericList*) self, column, direction);
#line 3242 "GenericList.c"
}

static void
_music_generic_list_on_rows_reordered_music_generic_list_rows_reordered (MusicGenericList* _sender,
                                                                         gpointer self)
{
#line 130 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_on_rows_reordered ((MusicGenericList*) self);
#line 3251 "GenericList.c"
}

static gboolean
_music_generic_list___lambda40_ (MusicGenericList* self,
                                 GdkEventKey* event)
{
	gboolean result;
#line 132 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 133 "../src/Views/ListView/Lists/GenericList.vala"
	if (event->keyval == GDK_KEY_Delete) {
#line 134 "../src/Views/ListView/Lists/GenericList.vala"
		music_generic_list_media_remove_clicked (self);
#line 3265 "GenericList.c"
	}
#line 137 "../src/Views/ListView/Lists/GenericList.vala"
	result = FALSE;
#line 137 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 3271 "GenericList.c"
}

static gboolean
__music_generic_list___lambda40__gtk_widget_key_press_event (GtkWidget* _sender,
                                                             GdkEventKey* event,
                                                             gpointer self)
{
	gboolean result;
	result = _music_generic_list___lambda40_ ((MusicGenericList*) self, event);
#line 132 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 3283 "GenericList.c"
}

static void
_music_generic_list_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                         GdkDragContext* context,
                                                         gpointer self)
{
#line 144 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_on_drag_begin ((MusicGenericList*) self, _sender, context);
#line 3293 "GenericList.c"
}

static void
_music_generic_list_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                               GdkDragContext* context,
                                                               GtkSelectionData* selection_data,
                                                               guint info,
                                                               guint time_,
                                                               gpointer self)
{
#line 145 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_on_drag_data_get ((MusicGenericList*) self, context, selection_data, info, time_);
#line 3306 "GenericList.c"
}

static void
_music_generic_list_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                     GdkDragContext* context,
                                                     gpointer self)
{
#line 146 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_on_drag_end ((MusicGenericList*) self, _sender, context);
#line 3316 "GenericList.c"
}

static void
_gtk_widget_queue_draw_music_library_media_updated (MusicLibrary* _sender,
                                                    GeeCollection* medias,
                                                    gpointer self)
{
#line 148 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 3326 "GenericList.c"
}

static void
_music_generic_list___lambda41_ (MusicGenericList* self)
{
#line 151 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_set_is_current_list (self, FALSE);
#line 3334 "GenericList.c"
}

static void
__music_generic_list___lambda41__music_playback_manager_queue_cleared (MusicPlaybackManager* _sender,
                                                                       gpointer self)
{
#line 150 "../src/Views/ListView/Lists/GenericList.vala"
	_music_generic_list___lambda41_ ((MusicGenericList*) self);
#line 3343 "GenericList.c"
}

static void
_music_generic_list_media_played_music_playback_manager_media_played (MusicPlaybackManager* _sender,
                                                                      MusicMedia* played_media,
                                                                      gpointer self)
{
#line 154 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_media_played ((MusicGenericList*) self, played_media, NULL, NULL);
#line 3353 "GenericList.c"
}

static GObject *
music_generic_list_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicGenericList * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeList* _tmp10_;
	MusicFastModel* _tmp11_;
	MusicFastModel* _tmp12_;
	GeeArrayList* _tmp13_;
	MusicFastModel* _tmp14_;
	MusicCellDataFunctionHelper* _tmp15_;
	MusicTreeViewSetup* _tmp16_;
	MusicListColumn _tmp17_;
	MusicListColumn _tmp18_;
	MusicTreeViewSetup* _tmp19_;
	GtkSortType _tmp20_;
	GtkSortType _tmp21_;
	GtkTreeSelection* _tmp34_;
	GtkTargetEntry te = {0};
	GtkTargetEntry _tmp35_ = {0};
	GtkTargetEntry _tmp36_;
	GtkTargetEntry* _tmp37_;
	GtkTargetEntry* _tmp38_;
	gint _tmp38__length1;
	MusicViewWrapper* _tmp39_;
	MusicViewWrapper* _tmp40_;
	MusicLibrary* _tmp41_;
	MusicLibrary* _tmp42_;
	MusicPlaybackManager* _tmp43_;
	MusicPlaybackManager* _tmp44_;
	MusicPlaybackManager* _tmp45_;
	MusicPlaybackManager* _tmp46_;
#line 98 "../src/Views/ListView/Lists/GenericList.vala"
	parent_class = G_OBJECT_CLASS (music_generic_list_parent_class);
#line 98 "../src/Views/ListView/Lists/GenericList.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 98 "../src/Views/ListView/Lists/GenericList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_GENERIC_LIST, MusicGenericList);
#line 99 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_GTYPE, NULL, NULL, NULL, NULL, NULL);
#line 99 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = _tmp0_;
#line 99 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_set_columns (self, (GeeList*) _tmp1_);
#line 99 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (_tmp1_);
#line 3407 "GenericList.c"
	{
		GeeIterator* _type_it = NULL;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp2_ = music_list_column_get_all ();
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp3_ = _tmp2_;
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp5_ = _tmp4_;
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (_tmp3_);
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
		_type_it = _tmp5_;
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
		while (TRUE) {
#line 3428 "GenericList.c"
			GeeIterator* _tmp6_;
			MusicListColumn type = 0;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeList* _tmp9_;
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp6_ = _type_it;
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
				break;
#line 3440 "GenericList.c"
			}
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp7_ = _type_it;
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
			type = (MusicListColumn) ((gintptr) _tmp8_);
#line 101 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp9_ = self->priv->_columns;
#line 101 "../src/Views/ListView/Lists/GenericList.vala"
			gee_collection_add ((GeeCollection*) _tmp9_, (gpointer) ((gintptr) music_list_column_get_data_type (type)));
#line 3452 "GenericList.c"
		}
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (_type_it);
#line 3456 "GenericList.c"
	}
#line 104 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp10_ = self->priv->_columns;
#line 104 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp11_ = music_fast_model_new (_tmp10_);
#line 104 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->fm);
#line 104 "../src/Views/ListView/Lists/GenericList.vala"
	self->fm = _tmp11_;
#line 105 "../src/Views/ListView/Lists/GenericList.vala"
	self->sort_column_id = MUSIC_GENERIC_LIST_OPTIMAL_COLUMN;
#line 106 "../src/Views/ListView/Lists/GenericList.vala"
	self->sort_direction = GTK_SORT_ASCENDING;
#line 108 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp12_ = self->fm;
#line 108 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object (_tmp12_, "reorder-requested", (GCallback) _music_generic_list_reorder_requested_music_fast_model_reorder_requested, self, 0);
#line 110 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp13_ = self->table;
#line 110 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_set_table (self, _tmp13_, TRUE);
#line 111 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp14_ = self->fm;
#line 111 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp14_);
#line 113 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp15_ = music_cell_data_function_helper_new (self);
#line 113 "../src/Views/ListView/Lists/GenericList.vala"
	_music_cell_data_function_helper_unref0 (self->cell_data_helper);
#line 113 "../src/Views/ListView/Lists/GenericList.vala"
	self->cell_data_helper = _tmp15_;
#line 116 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp16_ = self->priv->_tvs;
#line 116 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp17_ = music_tree_view_setup_get_sort_column_id (_tmp16_);
#line 116 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp18_ = _tmp17_;
#line 116 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp19_ = self->priv->_tvs;
#line 116 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp20_ = music_tree_view_setup_get_sort_direction (_tmp19_);
#line 116 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp21_ = _tmp20_;
#line 116 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_set_sort_column_id (self, (gint) _tmp18_, _tmp21_);
#line 118 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_tree_view_set_enable_search ((GtkTreeView*) self, FALSE);
#line 120 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_tree_view_set_fixed_height_mode ((GtkTreeView*) self, TRUE);
#line 121 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_tree_view_set_reorderable ((GtkTreeView*) self, FALSE);
#line 3508 "GenericList.c"
	{
		GeeIterator* _tvc_it = NULL;
		MusicTreeViewSetup* _tmp22_;
		GeeCollection* _tmp23_;
		GeeCollection* _tmp24_;
		GeeIterator* _tmp25_;
		GeeIterator* _tmp26_;
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp22_ = self->priv->_tvs;
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp23_ = music_tree_view_setup_get_columns (_tmp22_);
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp24_ = _tmp23_;
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp25_ = gee_iterable_iterator ((GeeIterable*) _tmp24_);
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp26_ = _tmp25_;
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (_tmp24_);
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		_tvc_it = _tmp26_;
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		while (TRUE) {
#line 3532 "GenericList.c"
			GeeIterator* _tmp27_;
			GtkTreeViewColumn* tvc = NULL;
			GeeIterator* _tmp28_;
			gpointer _tmp29_;
			GtkTreeViewColumn* _tmp30_;
			GtkTreeViewColumn* _tmp31_;
			MusicListColumn* _tmp32_;
			MusicListColumn* _tmp33_;
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp27_ = _tvc_it;
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
			if (!gee_iterator_next (_tmp27_)) {
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
				break;
#line 3547 "GenericList.c"
			}
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp28_ = _tvc_it;
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp29_ = gee_iterator_get (_tmp28_);
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
			tvc = (GtkTreeViewColumn*) _tmp29_;
#line 124 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp30_ = tvc;
#line 124 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp31_ = tvc;
#line 124 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp32_ = music_tree_view_setup_get_column_type (_tmp31_);
#line 124 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp33_ = _tmp32_;
#line 124 "../src/Views/ListView/Lists/GenericList.vala"
			music_generic_list_add_column (self, _tmp30_, *_tmp33_);
#line 124 "../src/Views/ListView/Lists/GenericList.vala"
			_g_free0 (_tmp33_);
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
			_g_object_unref0 (tvc);
#line 3569 "GenericList.c"
		}
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (_tvc_it);
#line 3573 "GenericList.c"
	}
#line 128 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp34_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 128 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_tree_selection_set_mode (_tmp34_, GTK_SELECTION_MULTIPLE);
#line 130 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object (self, "rows-reordered", (GCallback) _music_generic_list_on_rows_reordered_music_generic_list_rows_reordered, self, 0);
#line 132 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object ((GtkWidget*) self, "key-press-event", (GCallback) __music_generic_list___lambda40__gtk_widget_key_press_event, self, 0);
#line 141 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp35_.target = "text/uri-list";
#line 141 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp35_.flags = (guint) GTK_TARGET_SAME_APP;
#line 141 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp35_.info = (guint) 0;
#line 141 "../src/Views/ListView/Lists/GenericList.vala"
	te = _tmp35_;
#line 142 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp36_ = te;
#line 142 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp37_ = g_new0 (GtkTargetEntry, 1);
#line 142 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp37_[0] = _tmp36_;
#line 142 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp38_ = _tmp37_;
#line 142 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp38__length1 = 1;
#line 142 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_drag_source_set ((GtkWidget*) self, GDK_BUTTON1_MASK, _tmp38_, (gint) 1, GDK_ACTION_COPY);
#line 142 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp38_ = (g_free (_tmp38_), NULL);
#line 144 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-begin", (GCallback) _music_generic_list_on_drag_begin_gtk_widget_drag_begin, self, 0);
#line 145 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-data-get", (GCallback) _music_generic_list_on_drag_data_get_gtk_widget_drag_data_get, self, 0);
#line 146 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-end", (GCallback) _music_generic_list_on_drag_end_gtk_widget_drag_end, self, 0);
#line 148 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp39_ = music_generic_list_get_parent_wrapper (self);
#line 148 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp40_ = _tmp39_;
#line 148 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp41_ = music_view_wrapper_get_library (_tmp40_);
#line 148 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp42_ = _tmp41_;
#line 148 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object (_tmp42_, "media-updated", (GCallback) _gtk_widget_queue_draw_music_library_media_updated, (GtkWidget*) self, 0);
#line 150 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp43_ = music_app_get_player ();
#line 150 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp44_ = _tmp43_;
#line 150 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object (_tmp44_, "queue-cleared", (GCallback) __music_generic_list___lambda41__music_playback_manager_queue_cleared, self, 0);
#line 154 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp45_ = music_app_get_player ();
#line 154 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp46_ = _tmp45_;
#line 154 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object (_tmp46_, "media-played", (GCallback) _music_generic_list_media_played_music_playback_manager_media_played, self, 0);
#line 98 "../src/Views/ListView/Lists/GenericList.vala"
	return obj;
#line 3635 "GenericList.c"
}

static void
music_generic_list_class_init (MusicGenericListClass * klass,
                               gpointer klass_data)
{
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_type_class_adjust_private_offset (klass, &MusicGenericList_private_offset);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	((MusicGenericListClass *) klass)->add_column = (void (*) (MusicGenericList*, GtkTreeViewColumn*, MusicListColumn)) music_generic_list_real_add_column;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	((MusicGenericListClass *) klass)->media_remove_clicked = (void (*) (MusicGenericList*)) music_generic_list_real_media_remove_clicked;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	((GtkTreeViewClass *) klass)->row_activated = (void (*) (GtkTreeView*, GtkTreePath*, GtkTreeViewColumn*)) music_generic_list_real_row_activated;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_generic_list_get_property;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_generic_list_set_property;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	G_OBJECT_CLASS (klass)->constructor = music_generic_list_constructor;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	G_OBJECT_CLASS (klass)->finalize = music_generic_list_finalize;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_GENERIC_LIST_COLUMNS_PROPERTY, music_generic_list_properties[MUSIC_GENERIC_LIST_COLUMNS_PROPERTY] = g_param_spec_object ("columns", "columns", "columns", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY, music_generic_list_properties[MUSIC_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY] = g_param_spec_boolean ("research-needed", "research-needed", "research-needed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY, music_generic_list_properties[MUSIC_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY] = g_param_spec_boolean ("is-current-list", "is-current-list", "is-current-list", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_GENERIC_LIST_PLAYLIST_PROPERTY, music_generic_list_properties[MUSIC_GENERIC_LIST_PLAYLIST_PROPERTY] = g_param_spec_object ("playlist", "playlist", "playlist", MUSIC_TYPE_PLAYLIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_GENERIC_LIST_TVS_PROPERTY, music_generic_list_properties[MUSIC_GENERIC_LIST_TVS_PROPERTY] = g_param_spec_object ("tvs", "tvs", "tvs", MUSIC_TYPE_TREE_VIEW_SETUP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_GENERIC_LIST_HINT_PROPERTY, music_generic_list_properties[MUSIC_GENERIC_LIST_HINT_PROPERTY] = g_param_spec_enum ("hint", "hint", "hint", MUSIC_VIEW_WRAPPER_TYPE_HINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_GENERIC_LIST_PARENT_WRAPPER_PROPERTY, music_generic_list_properties[MUSIC_GENERIC_LIST_PARENT_WRAPPER_PROPERTY] = g_param_spec_object ("parent-wrapper", "parent-wrapper", "parent-wrapper", MUSIC_TYPE_VIEW_WRAPPER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_signals[MUSIC_GENERIC_LIST_IMPORT_REQUESTED_SIGNAL] = g_signal_new ("import-requested", MUSIC_TYPE_GENERIC_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	music_generic_list_signals[MUSIC_GENERIC_LIST_ROWS_REORDERED_SIGNAL] = g_signal_new ("rows-reordered", MUSIC_TYPE_GENERIC_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3678 "GenericList.c"
}

static void
music_generic_list_instance_init (MusicGenericList * self,
                                  gpointer klass)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	self->priv = music_generic_list_get_instance_private (self);
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
	self->priv->_research_needed = FALSE;
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
	self->priv->_playlist = NULL;
#line 66 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 66 "../src/Views/ListView/Lists/GenericList.vala"
	self->table = _tmp0_;
#line 71 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 71 "../src/Views/ListView/Lists/GenericList.vala"
	self->showing = _tmp1_;
#line 3701 "GenericList.c"
}

static void
music_generic_list_finalize (GObject * obj)
{
	MusicGenericList * self;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_GENERIC_LIST, MusicGenericList);
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->priv->_columns);
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->priv->_playlist);
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->priv->_tvs);
#line 49 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->priv->_parent_wrapper);
#line 61 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->fm);
#line 66 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->table);
#line 71 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->showing);
#line 92 "../src/Views/ListView/Lists/GenericList.vala"
	_music_cell_data_function_helper_unref0 (self->cell_data_helper);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	G_OBJECT_CLASS (music_generic_list_parent_class)->finalize (obj);
#line 3728 "GenericList.c"
}

static GType
music_generic_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicGenericListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_generic_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicGenericList), 0, (GInstanceInitFunc) music_generic_list_instance_init, NULL };
	GType music_generic_list_type_id;
	music_generic_list_type_id = g_type_register_static (gtk_tree_view_get_type (), "MusicGenericList", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	MusicGenericList_private_offset = g_type_add_instance_private (music_generic_list_type_id, sizeof (MusicGenericListPrivate));
	return music_generic_list_type_id;
}

GType
music_generic_list_get_type (void)
{
	static volatile gsize music_generic_list_type_id__once = 0;
	if (g_once_init_enter (&music_generic_list_type_id__once)) {
		GType music_generic_list_type_id;
		music_generic_list_type_id = music_generic_list_get_type_once ();
		g_once_init_leave (&music_generic_list_type_id__once, music_generic_list_type_id);
	}
	return music_generic_list_type_id__once;
}

static void
_vala_music_generic_list_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	MusicGenericList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_GENERIC_LIST, MusicGenericList);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	switch (property_id) {
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case MUSIC_GENERIC_LIST_COLUMNS_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		g_value_set_object (value, music_generic_list_get_columns (self));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case MUSIC_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		g_value_set_boolean (value, music_generic_list_get_research_needed (self));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case MUSIC_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		g_value_set_boolean (value, music_generic_list_get_is_current_list (self));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case MUSIC_GENERIC_LIST_PLAYLIST_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		g_value_set_object (value, music_generic_list_get_playlist (self));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case MUSIC_GENERIC_LIST_TVS_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		g_value_set_object (value, music_generic_list_get_tvs (self));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case MUSIC_GENERIC_LIST_HINT_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		g_value_set_enum (value, music_generic_list_get_hint (self));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case MUSIC_GENERIC_LIST_PARENT_WRAPPER_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		g_value_set_object (value, music_generic_list_get_parent_wrapper (self));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 3805 "GenericList.c"
		default:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 3811 "GenericList.c"
	}
}

static void
_vala_music_generic_list_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	MusicGenericList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_GENERIC_LIST, MusicGenericList);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	switch (property_id) {
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case MUSIC_GENERIC_LIST_COLUMNS_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		music_generic_list_set_columns (self, g_value_get_object (value));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case MUSIC_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		music_generic_list_set_research_needed (self, g_value_get_boolean (value));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case MUSIC_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		music_generic_list_set_is_current_list (self, g_value_get_boolean (value));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case MUSIC_GENERIC_LIST_PLAYLIST_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		music_generic_list_set_playlist (self, g_value_get_object (value));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case MUSIC_GENERIC_LIST_TVS_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		music_generic_list_set_tvs (self, g_value_get_object (value));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case MUSIC_GENERIC_LIST_HINT_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		music_generic_list_set_hint (self, g_value_get_enum (value));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case MUSIC_GENERIC_LIST_PARENT_WRAPPER_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		music_generic_list_set_parent_wrapper (self, g_value_get_object (value));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 3867 "GenericList.c"
		default:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 3873 "GenericList.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

