/* ListColumn.c generated by valac 0.56.0, the Vala compiler
 * generated from ListColumn.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include "io.elementary.music-core.h"
#include <gee.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	MUSIC_LIST_COLUMN_ICON = 0,
	MUSIC_LIST_COLUMN_NUMBER,
	MUSIC_LIST_COLUMN_TRACK,
	MUSIC_LIST_COLUMN_TITLE,
	MUSIC_LIST_COLUMN_LENGTH,
	MUSIC_LIST_COLUMN_ARTIST,
	MUSIC_LIST_COLUMN_ALBUM,
	MUSIC_LIST_COLUMN_ALBUM_ARTIST,
	MUSIC_LIST_COLUMN_COMPOSER,
	MUSIC_LIST_COLUMN_GENRE,
	MUSIC_LIST_COLUMN_YEAR,
	MUSIC_LIST_COLUMN_GROUPING,
	MUSIC_LIST_COLUMN_BITRATE,
	MUSIC_LIST_COLUMN_RATING,
	MUSIC_LIST_COLUMN_PLAY_COUNT,
	MUSIC_LIST_COLUMN_SKIP_COUNT,
	MUSIC_LIST_COLUMN_DATE_ADDED,
	MUSIC_LIST_COLUMN_LAST_PLAYED,
	MUSIC_LIST_COLUMN_BPM,
	MUSIC_LIST_COLUMN_FILE_LOCATION,
	MUSIC_LIST_COLUMN_FILE_SIZE,
	MUSIC_LIST_COLUMN_N_COLUMNS
} MusicListColumn;

#define MUSIC_TYPE_LIST_COLUMN (music_list_column_get_type ())

#define MUSIC_TYPE_PLAYBACK_MANAGER (music_playback_manager_get_type ())
#define MUSIC_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager))
#define MUSIC_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))
#define MUSIC_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))

typedef struct _MusicPlaybackManager MusicPlaybackManager;
typedef struct _MusicPlaybackManagerClass MusicPlaybackManagerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

VALA_EXTERN GType music_list_column_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* music_list_column_to_string (MusicListColumn self);
VALA_EXTERN GType music_list_column_get_data_type (MusicListColumn self);
VALA_EXTERN GValue* music_list_column_get_value_for_media (MusicListColumn self,
                                               MusicMedia* m,
                                               gint media_row_index);
VALA_EXTERN GType music_playback_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPlaybackManager, g_object_unref)
VALA_EXTERN MusicPlaybackManager* music_app_get_player (void);
VALA_EXTERN MusicMedia* music_playback_manager_get_current_media (MusicPlaybackManager* self);
VALA_EXTERN GeeCollection* music_list_column_get_all (void);

/**
 * Represents every possible column that can go in a media list.
 *
 * New column types must be appended at the end in order to ensure backwards
 * compatibility with older TreeViewSetup representations.
 */
/**
     * Returns a string representation of the column.
     */
gchar*
music_list_column_to_string (MusicListColumn self)
{
	gchar* result;
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
	switch (self) {
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_ICON:
#line 123 "ListColumn.c"
		{
			gchar* _tmp0_;
#line 66 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp0_ = g_strdup (" ");
#line 66 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp0_;
#line 66 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 132 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_NUMBER:
#line 136 "ListColumn.c"
		{
			gchar* _tmp1_;
#line 69 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp1_ = g_strdup (C_ ("List column title", "#"));
#line 69 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp1_;
#line 69 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 145 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_TRACK:
#line 149 "ListColumn.c"
		{
			gchar* _tmp2_;
#line 72 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp2_ = g_strdup (C_ ("List column title", "Track"));
#line 72 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp2_;
#line 72 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 158 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_TITLE:
#line 162 "ListColumn.c"
		{
			gchar* _tmp3_;
#line 75 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp3_ = g_strdup (C_ ("List column title", "Title"));
#line 75 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp3_;
#line 75 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 171 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_LENGTH:
#line 175 "ListColumn.c"
		{
			gchar* _tmp4_;
#line 78 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp4_ = g_strdup (C_ ("List column title", "Length"));
#line 78 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp4_;
#line 78 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 184 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_ARTIST:
#line 188 "ListColumn.c"
		{
			gchar* _tmp5_;
#line 81 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp5_ = g_strdup (C_ ("List column title", "Artist"));
#line 81 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp5_;
#line 81 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 197 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_ALBUM:
#line 201 "ListColumn.c"
		{
			gchar* _tmp6_;
#line 84 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp6_ = g_strdup (C_ ("List column title", "Album"));
#line 84 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp6_;
#line 84 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 210 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_ALBUM_ARTIST:
#line 214 "ListColumn.c"
		{
			gchar* _tmp7_;
#line 87 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp7_ = g_strdup (C_ ("List column title", "Album Artist"));
#line 87 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp7_;
#line 87 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 223 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_COMPOSER:
#line 227 "ListColumn.c"
		{
			gchar* _tmp8_;
#line 90 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp8_ = g_strdup (C_ ("List column title", "Composer"));
#line 90 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp8_;
#line 90 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 236 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_GENRE:
#line 240 "ListColumn.c"
		{
			gchar* _tmp9_;
#line 93 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp9_ = g_strdup (C_ ("List column title", "Genre"));
#line 93 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp9_;
#line 93 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 249 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_YEAR:
#line 253 "ListColumn.c"
		{
			gchar* _tmp10_;
#line 96 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp10_ = g_strdup (C_ ("List column title", "Year"));
#line 96 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp10_;
#line 96 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 262 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_GROUPING:
#line 266 "ListColumn.c"
		{
			gchar* _tmp11_;
#line 99 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp11_ = g_strdup (C_ ("List column title", "Grouping"));
#line 99 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp11_;
#line 99 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 275 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_BITRATE:
#line 279 "ListColumn.c"
		{
			gchar* _tmp12_;
#line 102 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp12_ = g_strdup (C_ ("List column title", "Bitrate"));
#line 102 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp12_;
#line 102 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 288 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_RATING:
#line 292 "ListColumn.c"
		{
			gchar* _tmp13_;
#line 105 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp13_ = g_strdup (C_ ("List column title", "Rating"));
#line 105 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp13_;
#line 105 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 301 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_PLAY_COUNT:
#line 305 "ListColumn.c"
		{
			gchar* _tmp14_;
#line 108 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp14_ = g_strdup (C_ ("List column title", "Plays"));
#line 108 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp14_;
#line 108 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 314 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_SKIP_COUNT:
#line 318 "ListColumn.c"
		{
			gchar* _tmp15_;
#line 111 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp15_ = g_strdup (C_ ("List column title", "Skips"));
#line 111 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp15_;
#line 111 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 327 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_DATE_ADDED:
#line 331 "ListColumn.c"
		{
			gchar* _tmp16_;
#line 114 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp16_ = g_strdup (C_ ("List column title", "Date Added"));
#line 114 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp16_;
#line 114 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 340 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_LAST_PLAYED:
#line 344 "ListColumn.c"
		{
			gchar* _tmp17_;
#line 117 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp17_ = g_strdup (C_ ("List column title", "Last Played"));
#line 117 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp17_;
#line 117 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 353 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_BPM:
#line 357 "ListColumn.c"
		{
			gchar* _tmp18_;
#line 120 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp18_ = g_strdup (C_ ("List column title (beats per minute)", "BPM"));
#line 120 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp18_;
#line 120 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 366 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_FILE_LOCATION:
#line 370 "ListColumn.c"
		{
			gchar* _tmp19_;
#line 123 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp19_ = g_strdup (C_ ("List column title (file location)", "Location"));
#line 123 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp19_;
#line 123 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 379 "ListColumn.c"
		}
#line 64 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_FILE_SIZE:
#line 383 "ListColumn.c"
		{
			gchar* _tmp20_;
#line 126 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp20_ = g_strdup (C_ ("List column title", "File Size"));
#line 126 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp20_;
#line 126 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 392 "ListColumn.c"
		}
		default:
		{
#line 129 "../src/Views/ListView/Lists/ListColumn.vala"
			g_assert_not_reached ();
#line 398 "ListColumn.c"
		}
	}
}

GType
music_list_column_get_data_type (MusicListColumn self)
{
	GType result;
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
	switch (self) {
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_ICON:
#line 411 "ListColumn.c"
		{
#line 139 "../src/Views/ListView/Lists/ListColumn.vala"
			result = g_icon_get_type ();
#line 139 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 417 "ListColumn.c"
		}
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_TITLE:
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_ARTIST:
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_ALBUM:
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_ALBUM_ARTIST:
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_COMPOSER:
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_GENRE:
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_GROUPING:
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_FILE_LOCATION:
#line 435 "ListColumn.c"
		{
#line 149 "../src/Views/ListView/Lists/ListColumn.vala"
			result = G_TYPE_STRING;
#line 149 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 441 "ListColumn.c"
		}
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_NUMBER:
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_TRACK:
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_LENGTH:
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_YEAR:
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_BITRATE:
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_RATING:
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_PLAY_COUNT:
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_SKIP_COUNT:
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_DATE_ADDED:
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_LAST_PLAYED:
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_BPM:
#line 465 "ListColumn.c"
		{
#line 162 "../src/Views/ListView/Lists/ListColumn.vala"
			result = G_TYPE_UINT;
#line 162 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 471 "ListColumn.c"
		}
#line 137 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_FILE_SIZE:
#line 475 "ListColumn.c"
		{
#line 165 "../src/Views/ListView/Lists/ListColumn.vala"
			result = G_TYPE_UINT64;
#line 165 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 481 "ListColumn.c"
		}
		default:
		{
#line 168 "../src/Views/ListView/Lists/ListColumn.vala"
			g_assert_not_reached ();
#line 487 "ListColumn.c"
		}
	}
}

/**
     * Returns the value of the data that should be displayed by the column in the view.
     *
     * media_row_index is only necessary for {@link ListColumn.NUMBER}.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 181 "../src/Views/ListView/Lists/ListColumn.vala"
	return self ? g_object_ref (self) : NULL;
#line 502 "ListColumn.c"
}

GValue*
music_list_column_get_value_for_media (MusicListColumn self,
                                       MusicMedia* m,
                                       gint media_row_index)
{
	GValue* result;
#line 177 "../src/Views/ListView/Lists/ListColumn.vala"
	g_return_val_if_fail (m != NULL, NULL);
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
	switch (self) {
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_ICON:
#line 517 "ListColumn.c"
		{
			GIcon* icon = NULL;
			MusicMedia* currently_playing = NULL;
			MusicPlaybackManager* _tmp0_;
			MusicPlaybackManager* _tmp1_;
			MusicMedia* _tmp2_;
			MusicMedia* _tmp3_;
			MusicMedia* _tmp4_;
			gboolean _tmp5_ = FALSE;
			MusicMedia* _tmp6_;
			GValue* _tmp12_ = NULL;
#line 181 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp0_ = music_app_get_player ();
#line 181 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp1_ = _tmp0_;
#line 181 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp2_ = music_playback_manager_get_current_media (_tmp1_);
#line 181 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp3_ = _tmp2_;
#line 181 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp4_ = _g_object_ref0 (_tmp3_);
#line 181 "../src/Views/ListView/Lists/ListColumn.vala"
			currently_playing = _tmp4_;
#line 183 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp6_ = currently_playing;
#line 183 "../src/Views/ListView/Lists/ListColumn.vala"
			if (m == _tmp6_) {
#line 545 "ListColumn.c"
				MusicMedia* _tmp7_;
#line 183 "../src/Views/ListView/Lists/ListColumn.vala"
				_tmp7_ = currently_playing;
#line 183 "../src/Views/ListView/Lists/ListColumn.vala"
				_tmp5_ = _tmp7_ != NULL;
#line 551 "ListColumn.c"
			} else {
#line 183 "../src/Views/ListView/Lists/ListColumn.vala"
				_tmp5_ = FALSE;
#line 555 "ListColumn.c"
			}
#line 183 "../src/Views/ListView/Lists/ListColumn.vala"
			if (_tmp5_) {
#line 559 "ListColumn.c"
				GThemedIcon* _tmp8_;
#line 184 "../src/Views/ListView/Lists/ListColumn.vala"
				_tmp8_ = (GThemedIcon*) g_themed_icon_new ("audio-volume-high-symbolic");
#line 184 "../src/Views/ListView/Lists/ListColumn.vala"
				_g_object_unref0 (icon);
#line 184 "../src/Views/ListView/Lists/ListColumn.vala"
				icon = (GIcon*) _tmp8_;
#line 567 "ListColumn.c"
			} else {
				GIcon* _tmp9_;
				GIcon* _tmp10_;
				GIcon* _tmp11_;
#line 186 "../src/Views/ListView/Lists/ListColumn.vala"
				_tmp9_ = music_media_get_unique_status_image (m);
#line 186 "../src/Views/ListView/Lists/ListColumn.vala"
				_tmp10_ = _tmp9_;
#line 186 "../src/Views/ListView/Lists/ListColumn.vala"
				_tmp11_ = _g_object_ref0 (_tmp10_);
#line 186 "../src/Views/ListView/Lists/ListColumn.vala"
				_g_object_unref0 (icon);
#line 186 "../src/Views/ListView/Lists/ListColumn.vala"
				icon = _tmp11_;
#line 582 "ListColumn.c"
			}
#line 188 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp12_ = g_new0 (GValue, 1);
#line 188 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp12_, g_icon_get_type ());
#line 188 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_take_object (_tmp12_, icon);
#line 188 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp12_;
#line 188 "../src/Views/ListView/Lists/ListColumn.vala"
			_g_object_unref0 (currently_playing);
#line 188 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 596 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_NUMBER:
#line 600 "ListColumn.c"
		{
			GValue* _tmp13_ = NULL;
#line 191 "../src/Views/ListView/Lists/ListColumn.vala"
			_vala_assert (media_row_index >= 0, "media_row_index >= 0");
#line 192 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp13_ = g_new0 (GValue, 1);
#line 192 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp13_, G_TYPE_UINT);
#line 192 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_set_uint (_tmp13_, ((guint) media_row_index) + 1);
#line 192 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp13_;
#line 192 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 615 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_TRACK:
#line 619 "ListColumn.c"
		{
			guint _tmp14_;
			guint _tmp15_;
			GValue* _tmp16_ = NULL;
#line 195 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp14_ = music_media_get_track (m);
#line 195 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp15_ = _tmp14_;
#line 195 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp16_ = g_new0 (GValue, 1);
#line 195 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp16_, G_TYPE_UINT);
#line 195 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_set_uint (_tmp16_, _tmp15_);
#line 195 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp16_;
#line 195 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 638 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_TITLE:
#line 642 "ListColumn.c"
		{
			gchar* _tmp17_;
			GValue* _tmp18_ = NULL;
#line 198 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp17_ = music_media_get_display_title (m);
#line 198 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp18_ = g_new0 (GValue, 1);
#line 198 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp18_, G_TYPE_STRING);
#line 198 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_take_string (_tmp18_, _tmp17_);
#line 198 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp18_;
#line 198 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 658 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_LENGTH:
#line 662 "ListColumn.c"
		{
			guint _tmp19_;
			guint _tmp20_;
			GValue* _tmp21_ = NULL;
#line 201 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp19_ = music_media_get_length (m);
#line 201 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp20_ = _tmp19_;
#line 201 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp21_ = g_new0 (GValue, 1);
#line 201 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp21_, G_TYPE_UINT);
#line 201 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_set_uint (_tmp21_, _tmp20_);
#line 201 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp21_;
#line 201 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 681 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_ARTIST:
#line 685 "ListColumn.c"
		{
			gchar* _tmp22_;
			GValue* _tmp23_ = NULL;
#line 204 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp22_ = music_media_get_display_artist (m);
#line 204 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp23_ = g_new0 (GValue, 1);
#line 204 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp23_, G_TYPE_STRING);
#line 204 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_take_string (_tmp23_, _tmp22_);
#line 204 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp23_;
#line 204 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 701 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_ALBUM:
#line 705 "ListColumn.c"
		{
			gchar* _tmp24_;
			GValue* _tmp25_ = NULL;
#line 207 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp24_ = music_media_get_display_album (m);
#line 207 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp25_ = g_new0 (GValue, 1);
#line 207 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp25_, G_TYPE_STRING);
#line 207 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_take_string (_tmp25_, _tmp24_);
#line 207 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp25_;
#line 207 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 721 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_ALBUM_ARTIST:
#line 725 "ListColumn.c"
		{
			gchar* _tmp26_;
			GValue* _tmp27_ = NULL;
#line 210 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp26_ = music_media_get_display_album_artist (m, FALSE);
#line 210 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp27_ = g_new0 (GValue, 1);
#line 210 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp27_, G_TYPE_STRING);
#line 210 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_take_string (_tmp27_, _tmp26_);
#line 210 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp27_;
#line 210 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 741 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_COMPOSER:
#line 745 "ListColumn.c"
		{
			gchar* _tmp28_;
			GValue* _tmp29_ = NULL;
#line 213 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp28_ = music_media_get_display_composer (m);
#line 213 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp29_ = g_new0 (GValue, 1);
#line 213 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp29_, G_TYPE_STRING);
#line 213 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_take_string (_tmp29_, _tmp28_);
#line 213 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp29_;
#line 213 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 761 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_GENRE:
#line 765 "ListColumn.c"
		{
			gchar* _tmp30_;
			GValue* _tmp31_ = NULL;
#line 216 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp30_ = music_media_get_display_genre (m);
#line 216 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp31_ = g_new0 (GValue, 1);
#line 216 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp31_, G_TYPE_STRING);
#line 216 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_take_string (_tmp31_, _tmp30_);
#line 216 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp31_;
#line 216 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 781 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_YEAR:
#line 785 "ListColumn.c"
		{
			guint _tmp32_;
			guint _tmp33_;
			GValue* _tmp34_ = NULL;
#line 219 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp32_ = music_media_get_year (m);
#line 219 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp33_ = _tmp32_;
#line 219 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp34_ = g_new0 (GValue, 1);
#line 219 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp34_, G_TYPE_UINT);
#line 219 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_set_uint (_tmp34_, _tmp33_);
#line 219 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp34_;
#line 219 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 804 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_GROUPING:
#line 808 "ListColumn.c"
		{
			const gchar* _tmp35_;
			const gchar* _tmp36_;
			GValue* _tmp37_ = NULL;
#line 222 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp35_ = music_media_get_grouping (m);
#line 222 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp36_ = _tmp35_;
#line 222 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp37_ = g_new0 (GValue, 1);
#line 222 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp37_, G_TYPE_STRING);
#line 222 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_set_string (_tmp37_, _tmp36_);
#line 222 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp37_;
#line 222 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 827 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_BITRATE:
#line 831 "ListColumn.c"
		{
			guint _tmp38_;
			guint _tmp39_;
			GValue* _tmp40_ = NULL;
#line 225 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp38_ = music_media_get_bitrate (m);
#line 225 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp39_ = _tmp38_;
#line 225 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp40_ = g_new0 (GValue, 1);
#line 225 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp40_, G_TYPE_UINT);
#line 225 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_set_uint (_tmp40_, _tmp39_);
#line 225 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp40_;
#line 225 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 850 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_RATING:
#line 854 "ListColumn.c"
		{
			guint _tmp41_;
			guint _tmp42_;
			GValue* _tmp43_ = NULL;
#line 228 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp41_ = music_media_get_rating (m);
#line 228 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp42_ = _tmp41_;
#line 228 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp43_ = g_new0 (GValue, 1);
#line 228 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp43_, G_TYPE_UINT);
#line 228 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_set_uint (_tmp43_, _tmp42_);
#line 228 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp43_;
#line 228 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 873 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_PLAY_COUNT:
#line 877 "ListColumn.c"
		{
			guint _tmp44_;
			guint _tmp45_;
			GValue* _tmp46_ = NULL;
#line 231 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp44_ = music_media_get_play_count (m);
#line 231 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp45_ = _tmp44_;
#line 231 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp46_ = g_new0 (GValue, 1);
#line 231 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp46_, G_TYPE_UINT);
#line 231 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_set_uint (_tmp46_, _tmp45_);
#line 231 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp46_;
#line 231 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 896 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_SKIP_COUNT:
#line 900 "ListColumn.c"
		{
			guint _tmp47_;
			guint _tmp48_;
			GValue* _tmp49_ = NULL;
#line 234 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp47_ = music_media_get_skip_count (m);
#line 234 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp48_ = _tmp47_;
#line 234 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp49_ = g_new0 (GValue, 1);
#line 234 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp49_, G_TYPE_UINT);
#line 234 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_set_uint (_tmp49_, _tmp48_);
#line 234 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp49_;
#line 234 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 919 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_DATE_ADDED:
#line 923 "ListColumn.c"
		{
			guint _tmp50_;
			guint _tmp51_;
			GValue* _tmp52_ = NULL;
#line 237 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp50_ = music_media_get_date_added (m);
#line 237 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp51_ = _tmp50_;
#line 237 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp52_ = g_new0 (GValue, 1);
#line 237 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp52_, G_TYPE_UINT);
#line 237 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_set_uint (_tmp52_, _tmp51_);
#line 237 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp52_;
#line 237 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 942 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_LAST_PLAYED:
#line 946 "ListColumn.c"
		{
			guint _tmp53_;
			guint _tmp54_;
			GValue* _tmp55_ = NULL;
#line 240 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp53_ = music_media_get_last_played (m);
#line 240 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp54_ = _tmp53_;
#line 240 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp55_ = g_new0 (GValue, 1);
#line 240 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp55_, G_TYPE_UINT);
#line 240 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_set_uint (_tmp55_, _tmp54_);
#line 240 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp55_;
#line 240 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 965 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_BPM:
#line 969 "ListColumn.c"
		{
			guint _tmp56_;
			guint _tmp57_;
			GValue* _tmp58_ = NULL;
#line 243 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp56_ = music_media_get_bpm (m);
#line 243 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp57_ = _tmp56_;
#line 243 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp58_ = g_new0 (GValue, 1);
#line 243 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp58_, G_TYPE_UINT);
#line 243 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_set_uint (_tmp58_, _tmp57_);
#line 243 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp58_;
#line 243 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 988 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_FILE_LOCATION:
#line 992 "ListColumn.c"
		{
			gchar* _tmp59_;
			GValue* _tmp60_ = NULL;
#line 246 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp59_ = music_media_get_display_location (m);
#line 246 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp60_ = g_new0 (GValue, 1);
#line 246 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp60_, G_TYPE_STRING);
#line 246 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_take_string (_tmp60_, _tmp59_);
#line 246 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp60_;
#line 246 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 1008 "ListColumn.c"
		}
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		case MUSIC_LIST_COLUMN_FILE_SIZE:
#line 1012 "ListColumn.c"
		{
			guint64 _tmp61_;
			guint64 _tmp62_;
			GValue* _tmp63_ = NULL;
#line 249 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp61_ = music_media_get_file_size (m);
#line 249 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp62_ = _tmp61_;
#line 249 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp63_ = g_new0 (GValue, 1);
#line 249 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_init (_tmp63_, G_TYPE_UINT64);
#line 249 "../src/Views/ListView/Lists/ListColumn.vala"
			g_value_set_uint64 (_tmp63_, _tmp62_);
#line 249 "../src/Views/ListView/Lists/ListColumn.vala"
			result = _tmp63_;
#line 249 "../src/Views/ListView/Lists/ListColumn.vala"
			return result;
#line 1031 "ListColumn.c"
		}
		default:
#line 178 "../src/Views/ListView/Lists/ListColumn.vala"
		break;
#line 1036 "ListColumn.c"
	}
#line 252 "../src/Views/ListView/Lists/ListColumn.vala"
	g_assert_not_reached ();
#line 1040 "ListColumn.c"
}

GeeCollection*
music_list_column_get_all (void)
{
	GeeLinkedList* list = NULL;
	GeeLinkedList* _tmp0_;
	GeeCollection* result;
#line 256 "../src/Views/ListView/Lists/ListColumn.vala"
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_LIST_COLUMN, NULL, NULL, NULL, NULL, NULL);
#line 256 "../src/Views/ListView/Lists/ListColumn.vala"
	list = _tmp0_;
#line 1053 "ListColumn.c"
	{
		gint i = 0;
#line 257 "../src/Views/ListView/Lists/ListColumn.vala"
		i = 0;
#line 1058 "ListColumn.c"
		{
			gboolean _tmp1_ = FALSE;
#line 257 "../src/Views/ListView/Lists/ListColumn.vala"
			_tmp1_ = TRUE;
#line 257 "../src/Views/ListView/Lists/ListColumn.vala"
			while (TRUE) {
#line 1065 "ListColumn.c"
				GeeLinkedList* _tmp3_;
#line 257 "../src/Views/ListView/Lists/ListColumn.vala"
				if (!_tmp1_) {
#line 1069 "ListColumn.c"
					gint _tmp2_;
#line 257 "../src/Views/ListView/Lists/ListColumn.vala"
					_tmp2_ = i;
#line 257 "../src/Views/ListView/Lists/ListColumn.vala"
					i = _tmp2_ + 1;
#line 1075 "ListColumn.c"
				}
#line 257 "../src/Views/ListView/Lists/ListColumn.vala"
				_tmp1_ = FALSE;
#line 257 "../src/Views/ListView/Lists/ListColumn.vala"
				if (!(i < ((gint) MUSIC_LIST_COLUMN_N_COLUMNS))) {
#line 257 "../src/Views/ListView/Lists/ListColumn.vala"
					break;
#line 1083 "ListColumn.c"
				}
#line 258 "../src/Views/ListView/Lists/ListColumn.vala"
				_tmp3_ = list;
#line 258 "../src/Views/ListView/Lists/ListColumn.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, (gpointer) ((gintptr) i));
#line 1089 "ListColumn.c"
			}
		}
	}
#line 259 "../src/Views/ListView/Lists/ListColumn.vala"
	result = (GeeCollection*) list;
#line 259 "../src/Views/ListView/Lists/ListColumn.vala"
	return result;
#line 1097 "ListColumn.c"
}

static GType
music_list_column_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_LIST_COLUMN_ICON, "MUSIC_LIST_COLUMN_ICON", "icon"}, {MUSIC_LIST_COLUMN_NUMBER, "MUSIC_LIST_COLUMN_NUMBER", "number"}, {MUSIC_LIST_COLUMN_TRACK, "MUSIC_LIST_COLUMN_TRACK", "track"}, {MUSIC_LIST_COLUMN_TITLE, "MUSIC_LIST_COLUMN_TITLE", "title"}, {MUSIC_LIST_COLUMN_LENGTH, "MUSIC_LIST_COLUMN_LENGTH", "length"}, {MUSIC_LIST_COLUMN_ARTIST, "MUSIC_LIST_COLUMN_ARTIST", "artist"}, {MUSIC_LIST_COLUMN_ALBUM, "MUSIC_LIST_COLUMN_ALBUM", "album"}, {MUSIC_LIST_COLUMN_ALBUM_ARTIST, "MUSIC_LIST_COLUMN_ALBUM_ARTIST", "album-artist"}, {MUSIC_LIST_COLUMN_COMPOSER, "MUSIC_LIST_COLUMN_COMPOSER", "composer"}, {MUSIC_LIST_COLUMN_GENRE, "MUSIC_LIST_COLUMN_GENRE", "genre"}, {MUSIC_LIST_COLUMN_YEAR, "MUSIC_LIST_COLUMN_YEAR", "year"}, {MUSIC_LIST_COLUMN_GROUPING, "MUSIC_LIST_COLUMN_GROUPING", "grouping"}, {MUSIC_LIST_COLUMN_BITRATE, "MUSIC_LIST_COLUMN_BITRATE", "bitrate"}, {MUSIC_LIST_COLUMN_RATING, "MUSIC_LIST_COLUMN_RATING", "rating"}, {MUSIC_LIST_COLUMN_PLAY_COUNT, "MUSIC_LIST_COLUMN_PLAY_COUNT", "play-count"}, {MUSIC_LIST_COLUMN_SKIP_COUNT, "MUSIC_LIST_COLUMN_SKIP_COUNT", "skip-count"}, {MUSIC_LIST_COLUMN_DATE_ADDED, "MUSIC_LIST_COLUMN_DATE_ADDED", "date-added"}, {MUSIC_LIST_COLUMN_LAST_PLAYED, "MUSIC_LIST_COLUMN_LAST_PLAYED", "last-played"}, {MUSIC_LIST_COLUMN_BPM, "MUSIC_LIST_COLUMN_BPM", "bpm"}, {MUSIC_LIST_COLUMN_FILE_LOCATION, "MUSIC_LIST_COLUMN_FILE_LOCATION", "file-location"}, {MUSIC_LIST_COLUMN_FILE_SIZE, "MUSIC_LIST_COLUMN_FILE_SIZE", "file-size"}, {MUSIC_LIST_COLUMN_N_COLUMNS, "MUSIC_LIST_COLUMN_N_COLUMNS", "n-columns"}, {0, NULL, NULL}};
	GType music_list_column_type_id;
	music_list_column_type_id = g_enum_register_static ("MusicListColumn", values);
	return music_list_column_type_id;
}

GType
music_list_column_get_type (void)
{
	static volatile gsize music_list_column_type_id__once = 0;
	if (g_once_init_enter (&music_list_column_type_id__once)) {
		GType music_list_column_type_id;
		music_list_column_type_id = music_list_column_get_type_once ();
		g_once_init_leave (&music_list_column_type_id__once, music_list_column_type_id);
	}
	return music_list_column_type_id__once;
}

