/* ViewWrapper.c generated by valac 0.56.0, the Vala compiler
 * generated from ViewWrapper.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>,
 *              Scott Ringwelski <sgringwe@mtu.edu>
 */
/*
 * Container and controller of the list and grid views, and info widgets
 * (welcome screen and embedded alert).
 *
 * A ViewWrapper triggers searches, status info updates, and also handles
 * view switching. It also works as a proxy for setting the media contained
 * by all the views. Please see set_media(), update_media(), remove_media()
 * and add_media().
 *
 * The views it contains implement the {@link Music.ContentView} interface.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <granite.h>
#include "io.elementary.music-core.h"
#include <handy.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#define MUSIC_VIEW_WRAPPER_VIEW_CONSTRUCT_PRIORITY (G_PRIORITY_DEFAULT_IDLE - 10)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_VIEW_WRAPPER (music_view_wrapper_get_type ())
#define MUSIC_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper))
#define MUSIC_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapperClass))
#define MUSIC_IS_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_VIEW_WRAPPER))
#define MUSIC_IS_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_VIEW_WRAPPER))
#define MUSIC_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapperClass))

typedef struct _MusicViewWrapper MusicViewWrapper;
typedef struct _MusicViewWrapperClass MusicViewWrapperClass;
typedef struct _MusicViewWrapperPrivate MusicViewWrapperPrivate;

#define MUSIC_TYPE_LIST_VIEW (music_list_view_get_type ())
#define MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIST_VIEW, MusicListView))
#define MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIST_VIEW, MusicListViewClass))
#define MUSIC_IS_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIST_VIEW))
#define MUSIC_IS_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIST_VIEW))
#define MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIST_VIEW, MusicListViewClass))

typedef struct _MusicListView MusicListView;
typedef struct _MusicListViewClass MusicListViewClass;

#define MUSIC_TYPE_ALBUMS_VIEW (music_albums_view_get_type ())
#define MUSIC_ALBUMS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_ALBUMS_VIEW, MusicAlbumsView))
#define MUSIC_ALBUMS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_ALBUMS_VIEW, MusicAlbumsViewClass))
#define MUSIC_IS_ALBUMS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_ALBUMS_VIEW))
#define MUSIC_IS_ALBUMS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_ALBUMS_VIEW))
#define MUSIC_ALBUMS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_ALBUMS_VIEW, MusicAlbumsViewClass))

typedef struct _MusicAlbumsView MusicAlbumsView;
typedef struct _MusicAlbumsViewClass MusicAlbumsViewClass;
typedef enum  {
	MUSIC_VIEW_WRAPPER_HINT_NONE,
	MUSIC_VIEW_WRAPPER_HINT_MUSIC,
	MUSIC_VIEW_WRAPPER_HINT_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_CDROM,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	MUSIC_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	MUSIC_VIEW_WRAPPER_HINT_ALBUM_LIST,
	MUSIC_VIEW_WRAPPER_HINT_QUEUE
} MusicViewWrapperHint;

#define MUSIC_VIEW_WRAPPER_TYPE_HINT (music_view_wrapper_hint_get_type ())

#define MUSIC_TYPE_VIEW_STACK (music_view_stack_get_type ())
#define MUSIC_VIEW_STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_VIEW_STACK, MusicViewStack))
#define MUSIC_VIEW_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_VIEW_STACK, MusicViewStackClass))
#define MUSIC_IS_VIEW_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_VIEW_STACK))
#define MUSIC_IS_VIEW_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_VIEW_STACK))
#define MUSIC_VIEW_STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_VIEW_STACK, MusicViewStackClass))

typedef struct _MusicViewStack MusicViewStack;
typedef struct _MusicViewStackClass MusicViewStackClass;
typedef enum  {
	MUSIC_VIEW_WRAPPER_VIEW_TYPE_GRID = 0,
	MUSIC_VIEW_WRAPPER_VIEW_TYPE_LIST = 1,
	MUSIC_VIEW_WRAPPER_VIEW_TYPE_ALERT = 2,
	MUSIC_VIEW_WRAPPER_VIEW_TYPE_WELCOME = 3,
	MUSIC_VIEW_WRAPPER_VIEW_TYPE_NONE = 4
} MusicViewWrapperViewType;

#define MUSIC_VIEW_WRAPPER_TYPE_VIEW_TYPE (music_view_wrapper_view_type_get_type ())
enum  {
	MUSIC_VIEW_WRAPPER_0_PROPERTY,
	MUSIC_VIEW_WRAPPER_LIST_VIEW_PROPERTY,
	MUSIC_VIEW_WRAPPER_GRID_VIEW_PROPERTY,
	MUSIC_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY,
	MUSIC_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY,
	MUSIC_VIEW_WRAPPER_HAS_GRID_VIEW_PROPERTY,
	MUSIC_VIEW_WRAPPER_HAS_LIST_VIEW_PROPERTY,
	MUSIC_VIEW_WRAPPER_HAS_EMBEDDED_ALERT_PROPERTY,
	MUSIC_VIEW_WRAPPER_HAS_WELCOME_SCREEN_PROPERTY,
	MUSIC_VIEW_WRAPPER_CURRENT_VIEW_PROPERTY,
	MUSIC_VIEW_WRAPPER_HINT_PROPERTY,
	MUSIC_VIEW_WRAPPER_LIBRARY_PROPERTY,
	MUSIC_VIEW_WRAPPER_IS_CURRENT_WRAPPER_PROPERTY,
	MUSIC_VIEW_WRAPPER_PLAYLIST_PROPERTY,
	MUSIC_VIEW_WRAPPER_MEDIA_COUNT_PROPERTY,
	MUSIC_VIEW_WRAPPER_NUM_PROPERTIES
};
static GParamSpec* music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define MUSIC_TYPE_GENERIC_LIST (music_generic_list_get_type ())
#define MUSIC_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_GENERIC_LIST, MusicGenericList))
#define MUSIC_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_GENERIC_LIST, MusicGenericListClass))
#define MUSIC_IS_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_GENERIC_LIST))
#define MUSIC_IS_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_GENERIC_LIST))
#define MUSIC_GENERIC_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_GENERIC_LIST, MusicGenericListClass))

typedef struct _MusicGenericList MusicGenericList;
typedef struct _MusicGenericListClass MusicGenericListClass;

#define MUSIC_TYPE_MUSIC_LIST_VIEW (music_music_list_view_get_type ())
#define MUSIC_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListView))
#define MUSIC_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListViewClass))
#define MUSIC_IS_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW))
#define MUSIC_IS_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_MUSIC_LIST_VIEW))
#define MUSIC_MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListViewClass))

typedef struct _MusicMusicListView MusicMusicListView;
typedef struct _MusicMusicListViewClass MusicMusicListViewClass;

#define MUSIC_TYPE_LIBRARY_WINDOW (music_library_window_get_type ())
#define MUSIC_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow))
#define MUSIC_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))
#define MUSIC_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))

typedef struct _MusicLibraryWindow MusicLibraryWindow;
typedef struct _MusicLibraryWindowClass MusicLibraryWindowClass;

#define MUSIC_WIDGETS_TYPE_VIEW_SELECTOR (music_widgets_view_selector_get_type ())
#define MUSIC_WIDGETS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelector))
#define MUSIC_WIDGETS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelectorClass))
#define MUSIC_WIDGETS_IS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR))
#define MUSIC_WIDGETS_IS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR))
#define MUSIC_WIDGETS_VIEW_SELECTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelectorClass))

typedef struct _MusicWidgetsViewSelector MusicWidgetsViewSelector;
typedef struct _MusicWidgetsViewSelectorClass MusicWidgetsViewSelectorClass;

#define MUSIC_TYPE_COLUMN_BROWSER (music_column_browser_get_type ())
#define MUSIC_COLUMN_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowser))
#define MUSIC_COLUMN_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowserClass))
#define MUSIC_IS_COLUMN_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_COLUMN_BROWSER))
#define MUSIC_IS_COLUMN_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_COLUMN_BROWSER))
#define MUSIC_COLUMN_BROWSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowserClass))

typedef struct _MusicColumnBrowser MusicColumnBrowser;
typedef struct _MusicColumnBrowserClass MusicColumnBrowserClass;
typedef enum  {
	MUSIC_WIDGETS_VIEW_SELECTOR_MODE_GRID = 0,
	MUSIC_WIDGETS_VIEW_SELECTOR_MODE_LIST = 1,
	MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN = 2
} MusicWidgetsViewSelectorMode;

#define MUSIC_WIDGETS_VIEW_SELECTOR_TYPE_MODE (music_widgets_view_selector_mode_get_type ())

#define MUSIC_TYPE_PLAYBACK_MANAGER (music_playback_manager_get_type ())
#define MUSIC_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager))
#define MUSIC_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))
#define MUSIC_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))

typedef struct _MusicPlaybackManager MusicPlaybackManager;
typedef struct _MusicPlaybackManagerClass MusicPlaybackManagerClass;

#define MUSIC_TYPE_VIEW_INTERFACE (music_view_interface_get_type ())
#define MUSIC_VIEW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_VIEW_INTERFACE, MusicViewInterface))
#define MUSIC_IS_VIEW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_VIEW_INTERFACE))
#define MUSIC_VIEW_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), MUSIC_TYPE_VIEW_INTERFACE, MusicViewInterfaceIface))

typedef struct _MusicViewInterface MusicViewInterface;
typedef struct _MusicViewInterfaceIface MusicViewInterfaceIface;
typedef struct _MusicViewWrapperSetMediaAsyncData MusicViewWrapperSetMediaAsyncData;
typedef struct _MusicViewWrapperAddMediaAsyncData MusicViewWrapperAddMediaAsyncData;
typedef struct _MusicViewWrapperRemoveMediaAsyncData MusicViewWrapperRemoveMediaAsyncData;
typedef struct _MusicViewWrapperUpdateMediaAsyncData MusicViewWrapperUpdateMediaAsyncData;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MusicViewWrapper {
	GtkGrid parent_instance;
	MusicViewWrapperPrivate * priv;
};

struct _MusicViewWrapperClass {
	GtkGridClass parent_class;
	gboolean (*check_have_media) (MusicViewWrapper* self);
	void (*select_proper_content_view) (MusicViewWrapper* self);
	void (*set_no_media_alert) (MusicViewWrapper* self);
};

struct _MusicViewWrapperPrivate {
	MusicListView* _list_view;
	MusicAlbumsView* _grid_view;
	GraniteWidgetsAlertView* _embedded_alert;
	GraniteWidgetsWelcome* _welcome_screen;
	MusicViewWrapperHint _hint;
	MusicLibrary* _library;
	MusicPlaylist* _playlist;
	gboolean widgets_ready;
	MusicViewStack* view_stack;
	MusicViewWrapperViewType last_used_view;
	gboolean data_initialized;
	GRecMutex __lock_list_view;
	GRecMutex __lock_grid_view;
};

struct _MusicViewInterfaceIface {
	GTypeInterface parent_iface;
	GeeCollection* (*get_media) (MusicViewInterface* self);
	GeeCollection* (*get_visible_media) (MusicViewInterface* self);
	void (*refilter) (MusicViewInterface* self);
	void (*set_media) (MusicViewInterface* self, GeeCollection* new_media);
	void (*add_media) (MusicViewInterface* self, GeeCollection* to_add);
	void (*remove_media) (MusicViewInterface* self, GeeCollection* to_remove);
	void (*update_media) (MusicViewInterface* self, GeeCollection* to_update);
};

struct _MusicViewWrapperSetMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicViewWrapper* self;
	GeeCollection* new_media;
};

struct _MusicViewWrapperAddMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicViewWrapper* self;
	GeeCollection* to_add;
};

struct _MusicViewWrapperRemoveMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicViewWrapper* self;
	GeeCollection* to_remove;
};

struct _MusicViewWrapperUpdateMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicViewWrapper* self;
	GeeCollection* to_update;
};

static gint MusicViewWrapper_private_offset;
static gpointer music_view_wrapper_parent_class = NULL;

VALA_EXTERN GType music_view_wrapper_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicViewWrapper, g_object_unref)
VALA_EXTERN GType music_list_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicListView, g_object_unref)
VALA_EXTERN GType music_albums_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicAlbumsView, g_object_unref)
VALA_EXTERN GType music_view_wrapper_hint_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType music_view_stack_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicViewStack, g_object_unref)
VALA_EXTERN GType music_view_wrapper_view_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean music_view_wrapper_check_have_media (MusicViewWrapper* self);
VALA_EXTERN void music_view_wrapper_select_proper_content_view (MusicViewWrapper* self);
VALA_EXTERN void music_view_wrapper_set_no_media_alert (MusicViewWrapper* self);
VALA_EXTERN MusicViewWrapper* music_view_wrapper_construct (GType object_type,
                                                MusicViewWrapperHint hint,
                                                MusicLibrary* library);
VALA_EXTERN void music_view_wrapper_pack_views (MusicViewWrapper* self);
VALA_EXTERN gboolean music_view_wrapper_get_has_grid_view (MusicViewWrapper* self);
VALA_EXTERN MusicAlbumsView* music_view_wrapper_get_grid_view (MusicViewWrapper* self);
VALA_EXTERN void music_view_stack_add_view (MusicViewStack* self,
                                GtkWidget* view);
VALA_EXTERN gboolean music_view_wrapper_get_has_list_view (MusicViewWrapper* self);
VALA_EXTERN MusicListView* music_view_wrapper_get_list_view (MusicViewWrapper* self);
VALA_EXTERN gboolean music_view_wrapper_get_has_welcome_screen (MusicViewWrapper* self);
VALA_EXTERN GraniteWidgetsWelcome* music_view_wrapper_get_welcome_screen (MusicViewWrapper* self);
VALA_EXTERN gboolean music_view_wrapper_get_has_embedded_alert (MusicViewWrapper* self);
VALA_EXTERN GraniteWidgetsAlertView* music_view_wrapper_get_embedded_alert (MusicViewWrapper* self);
VALA_EXTERN void music_view_wrapper_set_active_view (MusicViewWrapper* self,
                                         MusicViewWrapperViewType type,
                                         gboolean* successful);
VALA_EXTERN MusicViewWrapperViewType music_view_wrapper_get_current_view (MusicViewWrapper* self);
VALA_EXTERN gboolean music_view_wrapper_get_is_current_wrapper (MusicViewWrapper* self);
VALA_EXTERN GType music_generic_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicGenericList, g_object_unref)
VALA_EXTERN GType music_music_list_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicMusicListView, g_object_unref)
VALA_EXTERN MusicMusicListView* music_list_view_get_list_view (MusicListView* self);
VALA_EXTERN void music_generic_list_scroll_to_current_media (MusicGenericList* self,
                                                 gboolean unfilter_if_not_found);
VALA_EXTERN MusicViewWrapperHint music_view_wrapper_get_hint (MusicViewWrapper* self);
VALA_EXTERN void music_view_wrapper_update_library_window_widgets (MusicViewWrapper* self);
VALA_EXTERN GType music_library_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLibraryWindow, g_object_unref)
VALA_EXTERN MusicLibraryWindow* music_app_get_main_window (void);
VALA_EXTERN gboolean music_library_window_get_initialization_finished (MusicLibraryWindow* self);
VALA_EXTERN GtkSearchEntry* music_library_window_get_search_entry (MusicLibraryWindow* self);
VALA_EXTERN gint music_view_wrapper_get_media_count (MusicViewWrapper* self);
VALA_EXTERN GType music_widgets_view_selector_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicWidgetsViewSelector, g_object_unref)
VALA_EXTERN MusicWidgetsViewSelector* music_library_window_get_view_selector (MusicLibraryWindow* self);
VALA_EXTERN void music_widgets_view_selector_set_sensitive (MusicWidgetsViewSelector* self,
                                                gboolean value);
VALA_EXTERN GType music_column_browser_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicColumnBrowser, g_object_unref)
VALA_EXTERN MusicColumnBrowser* music_list_view_get_column_browser (MusicListView* self);
VALA_EXTERN void music_widgets_view_selector_set_column_browser_toggle_active (MusicWidgetsViewSelector* self,
                                                                   gboolean active);
VALA_EXTERN gboolean music_widgets_view_selector_get_column_browser_toggle_active (MusicWidgetsViewSelector* self);
VALA_EXTERN GType music_widgets_view_selector_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MusicWidgetsViewSelectorMode music_widgets_view_selector_get_selected (MusicWidgetsViewSelector* self);
VALA_EXTERN void music_widgets_view_selector_set_selected (MusicWidgetsViewSelector* self,
                                               MusicWidgetsViewSelectorMode value);
VALA_EXTERN void music_view_wrapper_view_selector_changed (MusicViewWrapper* self);
VALA_EXTERN gboolean music_widgets_view_selector_get_sensitive (MusicWidgetsViewSelector* self);
VALA_EXTERN void music_view_wrapper_play_first_media (MusicViewWrapper* self,
                                          gboolean* force);
VALA_EXTERN void music_list_view_set_as_current_list (MusicListView* self,
                                          gint media_id);
VALA_EXTERN GType music_playback_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPlaybackManager, g_object_unref)
VALA_EXTERN MusicPlaybackManager* music_app_get_player (void);
VALA_EXTERN MusicMedia* music_playback_manager_media_from_current_index (MusicPlaybackManager* self,
                                                             gint index_in_current);
VALA_EXTERN void music_playback_manager_play_media (MusicPlaybackManager* self,
                                        MusicMedia* m);
VALA_EXTERN void music_playback_manager_start_playback (MusicPlaybackManager* self);
VALA_EXTERN void music_view_wrapper_set_as_current_view (MusicViewWrapper* self);
VALA_EXTERN void music_view_wrapper_update_visible_media (MusicViewWrapper* self);
static void music_view_wrapper_search_field_changed (MusicViewWrapper* self);
static gboolean music_view_wrapper_real_check_have_media (MusicViewWrapper* self);
static void music_view_wrapper_real_select_proper_content_view (MusicViewWrapper* self);
VALA_EXTERN GeeCollection* music_view_wrapper_get_media_list (MusicViewWrapper* self);
VALA_EXTERN GType music_view_interface_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicViewInterface, g_object_unref)
VALA_EXTERN GeeCollection* music_view_interface_get_media (MusicViewInterface* self);
VALA_EXTERN void music_view_wrapper_clear_filters (MusicViewWrapper* self);
VALA_EXTERN void music_view_interface_refilter (MusicViewInterface* self);
static void music_view_wrapper_real_set_no_media_alert (MusicViewWrapper* self);
static void music_view_wrapper_set_media_async_data_free (gpointer _data);
VALA_EXTERN void music_view_wrapper_set_media_async (MusicViewWrapper* self,
                                         GeeCollection* new_media,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
VALA_EXTERN void music_view_wrapper_set_media_finish (MusicViewWrapper* self,
                                          GAsyncResult* _res_);
static gboolean music_view_wrapper_set_media_async_co (MusicViewWrapperSetMediaAsyncData* _data_);
static void music_view_wrapper_set_media (MusicViewWrapper* self,
                                   GeeCollection* new_media);
static void music_view_wrapper_add_media_async_data_free (gpointer _data);
VALA_EXTERN void music_view_wrapper_add_media_async (MusicViewWrapper* self,
                                         GeeCollection* to_add,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
VALA_EXTERN void music_view_wrapper_add_media_finish (MusicViewWrapper* self,
                                          GAsyncResult* _res_);
static gboolean music_view_wrapper_add_media_async_co (MusicViewWrapperAddMediaAsyncData* _data_);
static void music_view_wrapper_add_media (MusicViewWrapper* self,
                                   GeeCollection* new_media);
static void music_view_wrapper_remove_media_async_data_free (gpointer _data);
VALA_EXTERN void music_view_wrapper_remove_media_async (MusicViewWrapper* self,
                                            GeeCollection* to_remove,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
VALA_EXTERN void music_view_wrapper_remove_media_finish (MusicViewWrapper* self,
                                             GAsyncResult* _res_);
static gboolean music_view_wrapper_remove_media_async_co (MusicViewWrapperRemoveMediaAsyncData* _data_);
static void music_view_wrapper_remove_media (MusicViewWrapper* self,
                                      GeeCollection* media);
static void music_view_wrapper_update_media_async_data_free (gpointer _data);
VALA_EXTERN void music_view_wrapper_update_media_async (MusicViewWrapper* self,
                                            GeeCollection* to_update,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
VALA_EXTERN void music_view_wrapper_update_media_finish (MusicViewWrapper* self,
                                             GAsyncResult* _res_);
static gboolean music_view_wrapper_update_media_async_co (MusicViewWrapperUpdateMediaAsyncData* _data_);
static void music_view_wrapper_update_media (MusicViewWrapper* self,
                                      GeeCollection* media);
VALA_EXTERN void music_view_interface_set_media (MusicViewInterface* self,
                                     GeeCollection* new_media);
static void music_view_wrapper_update_widget_state (MusicViewWrapper* self);
VALA_EXTERN void music_view_interface_update_media (MusicViewInterface* self,
                                        GeeCollection* to_update);
VALA_EXTERN void music_view_interface_add_media (MusicViewInterface* self,
                                     GeeCollection* to_add);
VALA_EXTERN void music_view_interface_remove_media (MusicViewInterface* self,
                                        GeeCollection* to_remove);
VALA_EXTERN void music_view_wrapper_set_list_view (MusicViewWrapper* self,
                                       MusicListView* value);
VALA_EXTERN void music_view_wrapper_set_grid_view (MusicViewWrapper* self,
                                       MusicAlbumsView* value);
VALA_EXTERN void music_view_wrapper_set_embedded_alert (MusicViewWrapper* self,
                                            GraniteWidgetsAlertView* value);
VALA_EXTERN void music_view_wrapper_set_welcome_screen (MusicViewWrapper* self,
                                            GraniteWidgetsWelcome* value);
VALA_EXTERN void music_view_wrapper_set_hint (MusicViewWrapper* self,
                                  MusicViewWrapperHint value);
VALA_EXTERN MusicLibrary* music_view_wrapper_get_library (MusicViewWrapper* self);
VALA_EXTERN void music_view_wrapper_set_library (MusicViewWrapper* self,
                                     MusicLibrary* value);
VALA_EXTERN MusicViewStack* music_library_window_get_view_stack (MusicLibraryWindow* self);
VALA_EXTERN MusicPlaylist* music_view_wrapper_get_playlist (MusicViewWrapper* self);
VALA_EXTERN void music_view_wrapper_set_playlist (MusicViewWrapper* self,
                                      MusicPlaylist* value);
VALA_EXTERN guint music_list_view_get_n_media (MusicListView* self);
static GObject * music_view_wrapper_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
VALA_EXTERN MusicViewStack* music_view_stack_new (void);
VALA_EXTERN MusicViewStack* music_view_stack_construct (GType object_type);
static void _music_view_wrapper_view_selector_changed_music_widgets_view_selector_mode_changed (MusicWidgetsViewSelector* _sender,
                                                                                         MusicWidgetsViewSelectorMode new_mode,
                                                                                         gpointer self);
static void _music_view_wrapper_search_field_changed_music_library_search_finished (MusicLibrary* _sender,
                                                                             gpointer self);
static void music_view_wrapper_finalize (GObject * obj);
static GType music_view_wrapper_get_type_once (void);
static void _vala_music_view_wrapper_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_music_view_wrapper_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
music_view_wrapper_get_instance_private (MusicViewWrapper* self)
{
	return G_STRUCT_MEMBER_P (self, MusicViewWrapper_private_offset);
}

static GType
music_view_wrapper_hint_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_VIEW_WRAPPER_HINT_NONE, "MUSIC_VIEW_WRAPPER_HINT_NONE", "none"}, {MUSIC_VIEW_WRAPPER_HINT_MUSIC, "MUSIC_VIEW_WRAPPER_HINT_MUSIC", "music"}, {MUSIC_VIEW_WRAPPER_HINT_PLAYLIST, "MUSIC_VIEW_WRAPPER_HINT_PLAYLIST", "playlist"}, {MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST, "MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST", "read-only-playlist"}, {MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST, "MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST", "smart-playlist"}, {MUSIC_VIEW_WRAPPER_HINT_CDROM, "MUSIC_VIEW_WRAPPER_HINT_CDROM", "cdrom"}, {MUSIC_VIEW_WRAPPER_HINT_DEVICE, "MUSIC_VIEW_WRAPPER_HINT_DEVICE", "device"}, {MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO, "MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO", "device-audio"}, {MUSIC_VIEW_WRAPPER_HINT_DEVICE_PODCAST, "MUSIC_VIEW_WRAPPER_HINT_DEVICE_PODCAST", "device-podcast"}, {MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK, "MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK", "device-audiobook"}, {MUSIC_VIEW_WRAPPER_HINT_NETWORK_DEVICE, "MUSIC_VIEW_WRAPPER_HINT_NETWORK_DEVICE", "network-device"}, {MUSIC_VIEW_WRAPPER_HINT_ALBUM_LIST, "MUSIC_VIEW_WRAPPER_HINT_ALBUM_LIST", "album-list"}, {MUSIC_VIEW_WRAPPER_HINT_QUEUE, "MUSIC_VIEW_WRAPPER_HINT_QUEUE", "queue"}, {0, NULL, NULL}};
	GType music_view_wrapper_hint_type_id;
	music_view_wrapper_hint_type_id = g_enum_register_static ("MusicViewWrapperHint", values);
	return music_view_wrapper_hint_type_id;
}

GType
music_view_wrapper_hint_get_type (void)
{
	static volatile gsize music_view_wrapper_hint_type_id__once = 0;
	if (g_once_init_enter (&music_view_wrapper_hint_type_id__once)) {
		GType music_view_wrapper_hint_type_id;
		music_view_wrapper_hint_type_id = music_view_wrapper_hint_get_type_once ();
		g_once_init_leave (&music_view_wrapper_hint_type_id__once, music_view_wrapper_hint_type_id);
	}
	return music_view_wrapper_hint_type_id__once;
}

/**
     * Type of visual representation of the media.
     *
     * Values *must* match the index of the respective view in the view selector.
     */
static GType
music_view_wrapper_view_type_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_VIEW_WRAPPER_VIEW_TYPE_GRID, "MUSIC_VIEW_WRAPPER_VIEW_TYPE_GRID", "grid"}, {MUSIC_VIEW_WRAPPER_VIEW_TYPE_LIST, "MUSIC_VIEW_WRAPPER_VIEW_TYPE_LIST", "list"}, {MUSIC_VIEW_WRAPPER_VIEW_TYPE_ALERT, "MUSIC_VIEW_WRAPPER_VIEW_TYPE_ALERT", "alert"}, {MUSIC_VIEW_WRAPPER_VIEW_TYPE_WELCOME, "MUSIC_VIEW_WRAPPER_VIEW_TYPE_WELCOME", "welcome"}, {MUSIC_VIEW_WRAPPER_VIEW_TYPE_NONE, "MUSIC_VIEW_WRAPPER_VIEW_TYPE_NONE", "none"}, {0, NULL, NULL}};
	GType music_view_wrapper_view_type_type_id;
	music_view_wrapper_view_type_type_id = g_enum_register_static ("MusicViewWrapperViewType", values);
	return music_view_wrapper_view_type_type_id;
}

GType
music_view_wrapper_view_type_get_type (void)
{
	static volatile gsize music_view_wrapper_view_type_type_id__once = 0;
	if (g_once_init_enter (&music_view_wrapper_view_type_type_id__once)) {
		GType music_view_wrapper_view_type_type_id;
		music_view_wrapper_view_type_type_id = music_view_wrapper_view_type_get_type_once ();
		g_once_init_leave (&music_view_wrapper_view_type_type_id__once, music_view_wrapper_view_type_type_id);
	}
	return music_view_wrapper_view_type_type_id__once;
}

MusicViewWrapper*
music_view_wrapper_construct (GType object_type,
                              MusicViewWrapperHint hint,
                              MusicLibrary* library)
{
	MusicViewWrapper * self = NULL;
#line 133 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (library != NULL, NULL);
#line 134 "../src/Views/Wrappers/ViewWrapper.vala"
	self = (MusicViewWrapper*) g_object_new (object_type, "hint", hint, "library", library, NULL);
#line 133 "../src/Views/Wrappers/ViewWrapper.vala"
	return self;
#line 555 "ViewWrapper.c"
}

/**
     * Checks which views are available and packs them in (if they are not packed yet)
     */
void
music_view_wrapper_pack_views (MusicViewWrapper* self)
{
	MusicViewStack* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_;
	gboolean _tmp30_;
#line 150 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->view_stack;
#line 151 "../src/Views/Wrappers/ViewWrapper.vala"
	_vala_assert (_tmp0_ != NULL, "view_stack != null");
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = music_view_wrapper_get_has_grid_view (self);
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = _tmp2_;
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp3_) {
#line 589 "ViewWrapper.c"
		MusicAlbumsView* _tmp4_;
		GtkContainer* _tmp5_;
		GtkContainer* _tmp6_;
		MusicViewStack* _tmp7_;
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp4_ = self->priv->_grid_view;
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp5_ = gtk_widget_get_parent ((GtkWidget*) _tmp4_);
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp6_ = _tmp5_;
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp7_ = self->priv->view_stack;
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp1_ = _tmp6_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_container_get_type (), GtkContainer);
#line 604 "ViewWrapper.c"
	} else {
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp1_ = FALSE;
#line 608 "ViewWrapper.c"
	}
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp1_) {
#line 612 "ViewWrapper.c"
		MusicViewStack* _tmp8_;
		MusicAlbumsView* _tmp9_;
#line 154 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp8_ = self->priv->view_stack;
#line 154 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp9_ = self->priv->_grid_view;
#line 154 "../src/Views/Wrappers/ViewWrapper.vala"
		music_view_stack_add_view (_tmp8_, (GtkWidget*) _tmp9_);
#line 621 "ViewWrapper.c"
	}
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp11_ = music_view_wrapper_get_has_list_view (self);
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp12_ = _tmp11_;
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp12_) {
#line 629 "ViewWrapper.c"
		MusicListView* _tmp13_;
		GtkContainer* _tmp14_;
		GtkContainer* _tmp15_;
		MusicViewStack* _tmp16_;
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp13_ = self->priv->_list_view;
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp14_ = gtk_widget_get_parent ((GtkWidget*) _tmp13_);
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp15_ = _tmp14_;
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp16_ = self->priv->view_stack;
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp10_ = _tmp15_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_container_get_type (), GtkContainer);
#line 644 "ViewWrapper.c"
	} else {
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp10_ = FALSE;
#line 648 "ViewWrapper.c"
	}
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp10_) {
#line 652 "ViewWrapper.c"
		MusicViewStack* _tmp17_;
		MusicListView* _tmp18_;
#line 157 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp17_ = self->priv->view_stack;
#line 157 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp18_ = self->priv->_list_view;
#line 157 "../src/Views/Wrappers/ViewWrapper.vala"
		music_view_stack_add_view (_tmp17_, (GtkWidget*) _tmp18_);
#line 661 "ViewWrapper.c"
	}
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp20_ = music_view_wrapper_get_has_welcome_screen (self);
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp21_ = _tmp20_;
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp21_) {
#line 669 "ViewWrapper.c"
		GraniteWidgetsWelcome* _tmp22_;
		GtkContainer* _tmp23_;
		GtkContainer* _tmp24_;
		MusicViewStack* _tmp25_;
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp22_ = self->priv->_welcome_screen;
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp23_ = gtk_widget_get_parent ((GtkWidget*) _tmp22_);
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp24_ = _tmp23_;
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp25_ = self->priv->view_stack;
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp19_ = _tmp24_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_container_get_type (), GtkContainer);
#line 684 "ViewWrapper.c"
	} else {
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp19_ = FALSE;
#line 688 "ViewWrapper.c"
	}
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp19_) {
#line 692 "ViewWrapper.c"
		MusicViewStack* _tmp26_;
		GraniteWidgetsWelcome* _tmp27_;
#line 160 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp26_ = self->priv->view_stack;
#line 160 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp27_ = self->priv->_welcome_screen;
#line 160 "../src/Views/Wrappers/ViewWrapper.vala"
		music_view_stack_add_view (_tmp26_, (GtkWidget*) _tmp27_);
#line 701 "ViewWrapper.c"
	}
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp29_ = music_view_wrapper_get_has_embedded_alert (self);
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp30_ = _tmp29_;
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp30_) {
#line 709 "ViewWrapper.c"
		GraniteWidgetsAlertView* _tmp31_;
		GtkContainer* _tmp32_;
		GtkContainer* _tmp33_;
		MusicViewStack* _tmp34_;
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp31_ = self->priv->_embedded_alert;
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp32_ = gtk_widget_get_parent ((GtkWidget*) _tmp31_);
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp33_ = _tmp32_;
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp34_ = self->priv->view_stack;
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp28_ = _tmp33_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, gtk_container_get_type (), GtkContainer);
#line 724 "ViewWrapper.c"
	} else {
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp28_ = FALSE;
#line 728 "ViewWrapper.c"
	}
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp28_) {
#line 732 "ViewWrapper.c"
		MusicViewStack* _tmp35_;
		GraniteWidgetsAlertView* _tmp36_;
#line 163 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp35_ = self->priv->view_stack;
#line 163 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp36_ = self->priv->_embedded_alert;
#line 163 "../src/Views/Wrappers/ViewWrapper.vala"
		music_view_stack_add_view (_tmp35_, (GtkWidget*) _tmp36_);
#line 741 "ViewWrapper.c"
	}
#line 165 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv->widgets_ready = TRUE;
#line 166 "../src/Views/Wrappers/ViewWrapper.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 747 "ViewWrapper.c"
}

/**
     * Convenient visibility method
     */
void
music_view_wrapper_set_active_view (MusicViewWrapper* self,
                                    MusicViewWrapperViewType type,
                                    gboolean* successful)
{
	gboolean _vala_successful = FALSE;
	gboolean _tmp0_ = FALSE;
	MusicViewWrapperViewType _tmp1_;
	MusicViewWrapperViewType _tmp2_;
#line 172 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/Views/Wrappers/ViewWrapper.vala"
	_vala_successful = TRUE;
#line 175 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = music_view_wrapper_get_current_view (self);
#line 175 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = _tmp1_;
#line 175 "../src/Views/Wrappers/ViewWrapper.vala"
	if (type == _tmp2_) {
#line 175 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = TRUE;
#line 774 "ViewWrapper.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 175 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp3_ = music_view_wrapper_get_is_current_wrapper (self);
#line 175 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp4_ = _tmp3_;
#line 175 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = !_tmp4_;
#line 784 "ViewWrapper.c"
	}
#line 175 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp0_) {
#line 176 "../src/Views/Wrappers/ViewWrapper.vala"
		if (successful) {
#line 176 "../src/Views/Wrappers/ViewWrapper.vala"
			*successful = _vala_successful;
#line 792 "ViewWrapper.c"
		}
#line 176 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 796 "ViewWrapper.c"
	}
#line 178 "../src/Views/Wrappers/ViewWrapper.vala"
	switch (type) {
#line 178 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_VIEW_TYPE_LIST:
#line 802 "ViewWrapper.c"
		{
			gboolean _tmp5_;
			gboolean _tmp6_;
#line 180 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp5_ = music_view_wrapper_get_has_list_view (self);
#line 180 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp6_ = _tmp5_;
#line 180 "../src/Views/Wrappers/ViewWrapper.vala"
			if (_tmp6_) {
#line 812 "ViewWrapper.c"
				MusicViewStack* _tmp7_;
				MusicListView* _tmp8_;
				MusicListView* _tmp9_;
				MusicMusicListView* _tmp10_;
				MusicMusicListView* _tmp11_;
#line 181 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp7_ = self->priv->view_stack;
#line 181 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp8_ = self->priv->_list_view;
#line 181 "../src/Views/Wrappers/ViewWrapper.vala"
				gtk_stack_set_visible_child ((GtkStack*) _tmp7_, (GtkWidget*) _tmp8_);
#line 182 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp9_ = self->priv->_list_view;
#line 182 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp10_ = music_list_view_get_list_view (_tmp9_);
#line 182 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp11_ = _tmp10_;
#line 182 "../src/Views/Wrappers/ViewWrapper.vala"
				music_generic_list_scroll_to_current_media ((MusicGenericList*) _tmp11_, TRUE);
#line 832 "ViewWrapper.c"
			} else {
#line 184 "../src/Views/Wrappers/ViewWrapper.vala"
				_vala_successful = FALSE;
#line 836 "ViewWrapper.c"
			}
#line 186 "../src/Views/Wrappers/ViewWrapper.vala"
			break;
#line 840 "ViewWrapper.c"
		}
#line 178 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_VIEW_TYPE_GRID:
#line 844 "ViewWrapper.c"
		{
			gboolean _tmp12_;
			gboolean _tmp13_;
#line 188 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp12_ = music_view_wrapper_get_has_grid_view (self);
#line 188 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp13_ = _tmp12_;
#line 188 "../src/Views/Wrappers/ViewWrapper.vala"
			if (_tmp13_) {
#line 854 "ViewWrapper.c"
				MusicViewStack* _tmp14_;
				MusicAlbumsView* _tmp15_;
#line 189 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp14_ = self->priv->view_stack;
#line 189 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp15_ = self->priv->_grid_view;
#line 189 "../src/Views/Wrappers/ViewWrapper.vala"
				gtk_stack_set_visible_child ((GtkStack*) _tmp14_, (GtkWidget*) _tmp15_);
#line 863 "ViewWrapper.c"
			} else {
				gboolean _tmp16_;
				gboolean _tmp17_;
#line 191 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp16_ = music_view_wrapper_get_has_list_view (self);
#line 191 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp17_ = _tmp16_;
#line 191 "../src/Views/Wrappers/ViewWrapper.vala"
				if (_tmp17_) {
#line 873 "ViewWrapper.c"
					MusicViewStack* _tmp18_;
					MusicListView* _tmp19_;
					MusicListView* _tmp20_;
					MusicMusicListView* _tmp21_;
					MusicMusicListView* _tmp22_;
#line 192 "../src/Views/Wrappers/ViewWrapper.vala"
					_tmp18_ = self->priv->view_stack;
#line 192 "../src/Views/Wrappers/ViewWrapper.vala"
					_tmp19_ = self->priv->_list_view;
#line 192 "../src/Views/Wrappers/ViewWrapper.vala"
					gtk_stack_set_visible_child ((GtkStack*) _tmp18_, (GtkWidget*) _tmp19_);
#line 193 "../src/Views/Wrappers/ViewWrapper.vala"
					_tmp20_ = self->priv->_list_view;
#line 193 "../src/Views/Wrappers/ViewWrapper.vala"
					_tmp21_ = music_list_view_get_list_view (_tmp20_);
#line 193 "../src/Views/Wrappers/ViewWrapper.vala"
					_tmp22_ = _tmp21_;
#line 193 "../src/Views/Wrappers/ViewWrapper.vala"
					music_generic_list_scroll_to_current_media ((MusicGenericList*) _tmp22_, TRUE);
#line 893 "ViewWrapper.c"
				}
#line 195 "../src/Views/Wrappers/ViewWrapper.vala"
				_vala_successful = FALSE;
#line 897 "ViewWrapper.c"
			}
#line 197 "../src/Views/Wrappers/ViewWrapper.vala"
			break;
#line 901 "ViewWrapper.c"
		}
#line 178 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_VIEW_TYPE_ALERT:
#line 905 "ViewWrapper.c"
		{
			MusicViewStack* _tmp23_;
			GraniteWidgetsAlertView* _tmp24_;
#line 199 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp23_ = self->priv->view_stack;
#line 199 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp24_ = self->priv->_embedded_alert;
#line 199 "../src/Views/Wrappers/ViewWrapper.vala"
			gtk_stack_set_visible_child ((GtkStack*) _tmp23_, (GtkWidget*) _tmp24_);
#line 200 "../src/Views/Wrappers/ViewWrapper.vala"
			break;
#line 917 "ViewWrapper.c"
		}
#line 178 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_VIEW_TYPE_WELCOME:
#line 921 "ViewWrapper.c"
		{
			MusicViewStack* _tmp25_;
			GraniteWidgetsWelcome* _tmp26_;
#line 202 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp25_ = self->priv->view_stack;
#line 202 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp26_ = self->priv->_welcome_screen;
#line 202 "../src/Views/Wrappers/ViewWrapper.vala"
			gtk_stack_set_visible_child ((GtkStack*) _tmp25_, (GtkWidget*) _tmp26_);
#line 203 "../src/Views/Wrappers/ViewWrapper.vala"
			break;
#line 933 "ViewWrapper.c"
		}
		default:
#line 178 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 938 "ViewWrapper.c"
	}
#line 207 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_vala_successful) {
#line 942 "ViewWrapper.c"
		MusicViewWrapperHint _tmp27_;
		GEnumValue* _tmp28_;
		GEnumValue* _tmp29_;
#line 208 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp27_ = self->priv->_hint;
#line 208 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp28_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp27_);
#line 208 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp29_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_VIEW_TYPE), type);
#line 208 "../src/Views/Wrappers/ViewWrapper.vala"
		g_debug ("ViewWrapper.vala:208: %s : VIEW %s was not available", (_tmp28_ != NULL) ? _tmp28_->value_name : NULL, (_tmp29_ != NULL) ? _tmp29_->value_name : NULL);
#line 209 "../src/Views/Wrappers/ViewWrapper.vala"
		if (successful) {
#line 209 "../src/Views/Wrappers/ViewWrapper.vala"
			*successful = _vala_successful;
#line 958 "ViewWrapper.c"
		}
#line 209 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 962 "ViewWrapper.c"
	}
#line 212 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv->last_used_view = type;
#line 215 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_update_library_window_widgets (self);
#line 172 "../src/Views/Wrappers/ViewWrapper.vala"
	if (successful) {
#line 172 "../src/Views/Wrappers/ViewWrapper.vala"
		*successful = _vala_successful;
#line 972 "ViewWrapper.c"
	}
}

/**
     * This method ensures that the view switcher and search box are sensitive/insensitive
     * when they have to. It also selects the proper view switcher item based on the
     * current view.
     */
void
music_view_wrapper_update_library_window_widgets (MusicViewWrapper* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	MusicViewWrapperHint _tmp10_;
	GEnumValue* _tmp11_;
	MusicLibraryWindow* _tmp12_;
	MusicLibraryWindow* _tmp13_;
	GtkSearchEntry* _tmp14_;
	GtkSearchEntry* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_;
	gboolean _tmp22_;
	MusicLibraryWindow* _tmp29_;
	MusicLibraryWindow* _tmp30_;
	MusicWidgetsViewSelector* _tmp31_;
	MusicWidgetsViewSelector* _tmp32_;
	gboolean _tmp33_ = FALSE;
	MusicListView* _tmp34_;
	MusicColumnBrowser* _tmp35_;
	MusicColumnBrowser* _tmp36_;
	MusicLibraryWindow* _tmp42_;
	MusicLibraryWindow* _tmp43_;
	MusicWidgetsViewSelector* _tmp44_;
	MusicWidgetsViewSelector* _tmp45_;
	MusicLibraryWindow* _tmp46_;
	MusicLibraryWindow* _tmp47_;
	MusicWidgetsViewSelector* _tmp48_;
	MusicWidgetsViewSelector* _tmp49_;
#line 223 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = music_view_wrapper_get_is_current_wrapper (self);
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = _tmp2_;
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_tmp3_) {
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp1_ = TRUE;
#line 1027 "ViewWrapper.c"
	} else {
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp4_ = music_view_wrapper_get_has_list_view (self);
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp5_ = _tmp4_;
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp1_ = !_tmp5_;
#line 1037 "ViewWrapper.c"
	}
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp1_) {
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = TRUE;
#line 1043 "ViewWrapper.c"
	} else {
		MusicLibraryWindow* _tmp6_;
		MusicLibraryWindow* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp6_ = music_app_get_main_window ();
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp7_ = _tmp6_;
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp8_ = music_library_window_get_initialization_finished (_tmp7_);
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp9_ = _tmp8_;
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = !_tmp9_;
#line 1059 "ViewWrapper.c"
	}
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp0_) {
#line 225 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 1065 "ViewWrapper.c"
	}
#line 227 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp10_ = self->priv->_hint;
#line 227 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp11_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp10_);
#line 227 "../src/Views/Wrappers/ViewWrapper.vala"
	g_debug ("ViewWrapper.vala:227: update_library_window_widgets [%s]", (_tmp11_ != NULL) ? _tmp11_->value_name : NULL);
#line 231 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp12_ = music_app_get_main_window ();
#line 231 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp13_ = _tmp12_;
#line 231 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp14_ = music_library_window_get_search_entry (_tmp13_);
#line 231 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp15_ = _tmp14_;
#line 231 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp16_ = music_view_wrapper_get_media_count (self);
#line 231 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp17_ = _tmp16_;
#line 231 "../src/Views/Wrappers/ViewWrapper.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, _tmp17_ > 0);
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp21_ = music_view_wrapper_get_has_grid_view (self);
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp22_ = _tmp21_;
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp22_) {
#line 1093 "ViewWrapper.c"
		gboolean _tmp23_;
		gboolean _tmp24_;
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp23_ = music_view_wrapper_get_has_list_view (self);
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp24_ = _tmp23_;
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp20_ = _tmp24_;
#line 1102 "ViewWrapper.c"
	} else {
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp20_ = FALSE;
#line 1106 "ViewWrapper.c"
	}
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp20_) {
#line 1110 "ViewWrapper.c"
		MusicViewWrapperViewType _tmp25_;
		MusicViewWrapperViewType _tmp26_;
#line 237 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp25_ = music_view_wrapper_get_current_view (self);
#line 237 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp26_ = _tmp25_;
#line 237 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp19_ = _tmp26_ != MUSIC_VIEW_WRAPPER_VIEW_TYPE_WELCOME;
#line 1119 "ViewWrapper.c"
	} else {
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp19_ = FALSE;
#line 1123 "ViewWrapper.c"
	}
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp19_) {
#line 1127 "ViewWrapper.c"
		MusicViewWrapperViewType _tmp27_;
		MusicViewWrapperViewType _tmp28_;
#line 238 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp27_ = music_view_wrapper_get_current_view (self);
#line 238 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp28_ = _tmp27_;
#line 238 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp18_ = _tmp28_ != MUSIC_VIEW_WRAPPER_VIEW_TYPE_ALERT;
#line 1136 "ViewWrapper.c"
	} else {
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp18_ = FALSE;
#line 1140 "ViewWrapper.c"
	}
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp29_ = music_app_get_main_window ();
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp30_ = _tmp29_;
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp31_ = music_library_window_get_view_selector (_tmp30_);
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp32_ = _tmp31_;
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	music_widgets_view_selector_set_sensitive (_tmp32_, _tmp18_);
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp34_ = self->priv->_list_view;
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp35_ = music_list_view_get_column_browser (_tmp34_);
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp36_ = _tmp35_;
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp36_ != NULL) {
#line 1160 "ViewWrapper.c"
		MusicListView* _tmp37_;
		MusicColumnBrowser* _tmp38_;
		MusicColumnBrowser* _tmp39_;
		gboolean _tmp40_;
		gboolean _tmp41_;
#line 245 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp37_ = self->priv->_list_view;
#line 245 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp38_ = music_list_view_get_column_browser (_tmp37_);
#line 245 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp39_ = _tmp38_;
#line 245 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp40_ = gtk_widget_get_visible ((GtkWidget*) _tmp39_);
#line 245 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp41_ = _tmp40_;
#line 245 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp33_ = _tmp41_;
#line 1178 "ViewWrapper.c"
	} else {
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp33_ = FALSE;
#line 1182 "ViewWrapper.c"
	}
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp42_ = music_app_get_main_window ();
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp43_ = _tmp42_;
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp44_ = music_library_window_get_view_selector (_tmp43_);
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp45_ = _tmp44_;
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	music_widgets_view_selector_set_column_browser_toggle_active (_tmp45_, _tmp33_);
#line 250 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp46_ = music_app_get_main_window ();
#line 250 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp47_ = _tmp46_;
#line 250 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp48_ = music_library_window_get_view_selector (_tmp47_);
#line 250 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp49_ = _tmp48_;
#line 250 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!music_widgets_view_selector_get_column_browser_toggle_active (_tmp49_)) {
#line 1204 "ViewWrapper.c"
		gboolean _tmp50_ = FALSE;
		MusicLibraryWindow* _tmp51_;
		MusicLibraryWindow* _tmp52_;
		MusicWidgetsViewSelector* _tmp53_;
		MusicWidgetsViewSelector* _tmp54_;
		MusicWidgetsViewSelectorMode _tmp55_;
		MusicWidgetsViewSelectorMode _tmp56_;
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp51_ = music_app_get_main_window ();
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp52_ = _tmp51_;
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp53_ = music_library_window_get_view_selector (_tmp52_);
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp54_ = _tmp53_;
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp55_ = music_widgets_view_selector_get_selected (_tmp54_);
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp56_ = _tmp55_;
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
		if (_tmp56_ != ((gint) self->priv->last_used_view)) {
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp50_ = ((gint) self->priv->last_used_view) <= 1;
#line 1228 "ViewWrapper.c"
		} else {
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp50_ = FALSE;
#line 1232 "ViewWrapper.c"
		}
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
		if (_tmp50_) {
#line 1236 "ViewWrapper.c"
			MusicLibraryWindow* _tmp57_;
			MusicLibraryWindow* _tmp58_;
			MusicWidgetsViewSelector* _tmp59_;
			MusicWidgetsViewSelector* _tmp60_;
#line 252 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp57_ = music_app_get_main_window ();
#line 252 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp58_ = _tmp57_;
#line 252 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp59_ = music_library_window_get_view_selector (_tmp58_);
#line 252 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp60_ = _tmp59_;
#line 252 "../src/Views/Wrappers/ViewWrapper.vala"
			music_widgets_view_selector_set_selected (_tmp60_, (MusicWidgetsViewSelectorMode) self->priv->last_used_view);
#line 1251 "ViewWrapper.c"
		}
	}
}

void
music_view_wrapper_view_selector_changed (MusicViewWrapper* self)
{
	gboolean _tmp0_ = FALSE;
	MusicLibraryWindow* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	MusicViewWrapperViewType _tmp13_;
	MusicViewWrapperViewType _tmp14_;
	MusicViewWrapperHint _tmp19_;
	GEnumValue* _tmp20_;
	MusicViewWrapperViewType selected_view = 0;
	MusicLibraryWindow* _tmp21_;
	MusicLibraryWindow* _tmp22_;
	MusicWidgetsViewSelector* _tmp23_;
	MusicWidgetsViewSelector* _tmp24_;
	MusicWidgetsViewSelectorMode _tmp25_;
	MusicWidgetsViewSelectorMode _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
#line 256 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = music_app_get_main_window ();
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = _tmp1_;
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = music_library_window_get_initialization_finished (_tmp2_);
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = _tmp3_;
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_tmp4_) {
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = TRUE;
#line 1293 "ViewWrapper.c"
	} else {
		MusicLibraryWindow* _tmp5_;
		MusicLibraryWindow* _tmp6_;
		MusicWidgetsViewSelector* _tmp7_;
		MusicWidgetsViewSelector* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp5_ = music_app_get_main_window ();
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp6_ = _tmp5_;
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp7_ = music_library_window_get_view_selector (_tmp6_);
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp8_ = _tmp7_;
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp9_ = music_widgets_view_selector_get_sensitive (_tmp8_);
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp10_ = _tmp9_;
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = !_tmp10_;
#line 1315 "ViewWrapper.c"
	}
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp0_) {
#line 258 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 1321 "ViewWrapper.c"
	}
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp13_ = music_view_wrapper_get_current_view (self);
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp14_ = _tmp13_;
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp14_ == MUSIC_VIEW_WRAPPER_VIEW_TYPE_ALERT) {
#line 1329 "ViewWrapper.c"
		gint _tmp15_;
		gint _tmp16_;
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp15_ = music_view_wrapper_get_media_count (self);
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp16_ = _tmp15_;
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp12_ = _tmp16_ < 1;
#line 1338 "ViewWrapper.c"
	} else {
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp12_ = FALSE;
#line 1342 "ViewWrapper.c"
	}
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp12_) {
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp11_ = TRUE;
#line 1348 "ViewWrapper.c"
	} else {
		MusicViewWrapperViewType _tmp17_;
		MusicViewWrapperViewType _tmp18_;
#line 261 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp17_ = music_view_wrapper_get_current_view (self);
#line 261 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp18_ = _tmp17_;
#line 261 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp11_ = _tmp18_ == MUSIC_VIEW_WRAPPER_VIEW_TYPE_WELCOME;
#line 1358 "ViewWrapper.c"
	}
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp11_) {
#line 262 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 1364 "ViewWrapper.c"
	}
#line 264 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp19_ = self->priv->_hint;
#line 264 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp20_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp19_);
#line 264 "../src/Views/Wrappers/ViewWrapper.vala"
	g_debug ("ViewWrapper.vala:264: view_selector_changed [%s]", (_tmp20_ != NULL) ? _tmp20_->value_name : NULL);
#line 266 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp21_ = music_app_get_main_window ();
#line 266 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp22_ = _tmp21_;
#line 266 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp23_ = music_library_window_get_view_selector (_tmp22_);
#line 266 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp24_ = _tmp23_;
#line 266 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp25_ = music_widgets_view_selector_get_selected (_tmp24_);
#line 266 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp26_ = _tmp25_;
#line 266 "../src/Views/Wrappers/ViewWrapper.vala"
	selected_view = (MusicViewWrapperViewType) _tmp26_;
#line 268 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp27_ = music_view_wrapper_get_is_current_wrapper (self);
#line 268 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp28_ = _tmp27_;
#line 268 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp28_) {
#line 269 "../src/Views/Wrappers/ViewWrapper.vala"
		music_view_wrapper_set_active_view (self, selected_view, NULL);
#line 1394 "ViewWrapper.c"
	} else {
#line 271 "../src/Views/Wrappers/ViewWrapper.vala"
		self->priv->last_used_view = selected_view;
#line 1398 "ViewWrapper.c"
	}
}

void
music_view_wrapper_play_first_media (MusicViewWrapper* self,
                                     gboolean* force)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	MusicViewWrapperHint _tmp2_;
	GEnumValue* _tmp3_;
	MusicListView* _tmp4_;
	MusicMedia* m = NULL;
	MusicPlaybackManager* _tmp5_;
	MusicPlaybackManager* _tmp6_;
	MusicMedia* _tmp7_;
	MusicMedia* _tmp8_;
	MusicPlaybackManager* _tmp9_;
	MusicPlaybackManager* _tmp10_;
	MusicMedia* _tmp11_;
	MusicPlaybackManager* _tmp12_;
	MusicPlaybackManager* _tmp13_;
#line 274 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 275 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = music_view_wrapper_get_has_list_view (self);
#line 275 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 275 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_tmp1_) {
#line 276 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 1431 "ViewWrapper.c"
	}
#line 278 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = self->priv->_hint;
#line 278 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp2_);
#line 278 "../src/Views/Wrappers/ViewWrapper.vala"
	g_debug ("ViewWrapper.vala:278: play_first_media [%s]", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL);
#line 280 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = self->priv->_list_view;
#line 280 "../src/Views/Wrappers/ViewWrapper.vala"
	music_list_view_set_as_current_list (_tmp4_, 1);
#line 281 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp5_ = music_app_get_player ();
#line 281 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp6_ = _tmp5_;
#line 281 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp7_ = music_playback_manager_media_from_current_index (_tmp6_, 0);
#line 281 "../src/Views/Wrappers/ViewWrapper.vala"
	m = _tmp7_;
#line 283 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp8_ = m;
#line 283 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp8_ == NULL) {
#line 284 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (m);
#line 284 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 1459 "ViewWrapper.c"
	}
#line 285 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp9_ = music_app_get_player ();
#line 285 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp10_ = _tmp9_;
#line 285 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp11_ = m;
#line 285 "../src/Views/Wrappers/ViewWrapper.vala"
	music_playback_manager_play_media (_tmp10_, _tmp11_);
#line 286 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp12_ = music_app_get_player ();
#line 286 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp13_ = _tmp12_;
#line 286 "../src/Views/Wrappers/ViewWrapper.vala"
	music_playback_manager_start_playback (_tmp13_);
#line 274 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (m);
#line 1477 "ViewWrapper.c"
}

/**
     * This handles updating all the shared stuff outside the view area.
     *
     * You should only call this method on the respective ViewWrapper whenever the sidebar's
     * selected view changes.
     *
     * Note: The sidebar-item selection and other stuff is handled automatically by the LibraryWindow
     *       by request of SideTreeView. See LibraryWindow :: set_active_view() for more details.
     */
void
music_view_wrapper_set_as_current_view (MusicViewWrapper* self)
{
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	MusicViewWrapperHint _tmp4_;
	GEnumValue* _tmp5_;
#line 298 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 299 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = music_app_get_main_window ();
#line 299 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 299 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = music_library_window_get_initialization_finished (_tmp1_);
#line 299 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = _tmp2_;
#line 299 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_tmp3_) {
#line 300 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 1512 "ViewWrapper.c"
	}
#line 301 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = self->priv->_hint;
#line 301 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp5_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp4_);
#line 301 "../src/Views/Wrappers/ViewWrapper.vala"
	g_debug ("ViewWrapper.vala:301: SETTING AS CURRENT VIEW [%s]", (_tmp5_ != NULL) ? _tmp5_->value_name : NULL);
#line 303 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_update_visible_media (self);
#line 304 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_check_have_media (self);
#line 305 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_update_library_window_widgets (self);
#line 1526 "ViewWrapper.c"
}

static void
music_view_wrapper_search_field_changed (MusicViewWrapper* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 308 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 309 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = music_view_wrapper_get_is_current_wrapper (self);
#line 309 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 309 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_tmp1_) {
#line 310 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 1544 "ViewWrapper.c"
	}
#line 313 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_update_visible_media (self);
#line 1548 "ViewWrapper.c"
}

static gboolean
music_view_wrapper_real_check_have_media (MusicViewWrapper* self)
{
	gboolean have_media = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	gboolean result;
#line 344 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!self->priv->data_initialized) {
#line 345 "../src/Views/Wrappers/ViewWrapper.vala"
		result = FALSE;
#line 345 "../src/Views/Wrappers/ViewWrapper.vala"
		return result;
#line 1564 "ViewWrapper.c"
	}
#line 347 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = music_view_wrapper_get_media_count (self);
#line 347 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 347 "../src/Views/Wrappers/ViewWrapper.vala"
	have_media = _tmp1_ > 0;
#line 349 "../src/Views/Wrappers/ViewWrapper.vala"
	if (have_media) {
#line 350 "../src/Views/Wrappers/ViewWrapper.vala"
		music_view_wrapper_select_proper_content_view (self);
#line 1576 "ViewWrapper.c"
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 351 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp2_ = music_view_wrapper_get_has_welcome_screen (self);
#line 351 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp3_ = _tmp2_;
#line 351 "../src/Views/Wrappers/ViewWrapper.vala"
		if (_tmp3_) {
#line 352 "../src/Views/Wrappers/ViewWrapper.vala"
			music_view_wrapper_set_active_view (self, MUSIC_VIEW_WRAPPER_VIEW_TYPE_WELCOME, NULL);
#line 1588 "ViewWrapper.c"
		} else {
			gboolean _tmp4_;
			gboolean _tmp5_;
#line 353 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp4_ = music_view_wrapper_get_has_embedded_alert (self);
#line 353 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp5_ = _tmp4_;
#line 353 "../src/Views/Wrappers/ViewWrapper.vala"
			if (_tmp5_) {
#line 354 "../src/Views/Wrappers/ViewWrapper.vala"
				music_view_wrapper_set_no_media_alert (self);
#line 355 "../src/Views/Wrappers/ViewWrapper.vala"
				music_view_wrapper_set_active_view (self, MUSIC_VIEW_WRAPPER_VIEW_TYPE_ALERT, NULL);
#line 1602 "ViewWrapper.c"
			}
		}
	}
#line 358 "../src/Views/Wrappers/ViewWrapper.vala"
	result = have_media;
#line 358 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 1610 "ViewWrapper.c"
}

gboolean
music_view_wrapper_check_have_media (MusicViewWrapper* self)
{
	MusicViewWrapperClass* _klass_;
#line 342 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 342 "../src/Views/Wrappers/ViewWrapper.vala"
	_klass_ = MUSIC_VIEW_WRAPPER_GET_CLASS (self);
#line 342 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_klass_->check_have_media) {
#line 342 "../src/Views/Wrappers/ViewWrapper.vala"
		return _klass_->check_have_media (self);
#line 1625 "ViewWrapper.c"
	}
#line 342 "../src/Views/Wrappers/ViewWrapper.vala"
	return FALSE;
#line 1629 "ViewWrapper.c"
}

static void
music_view_wrapper_real_select_proper_content_view (MusicViewWrapper* self)
{
	MusicViewWrapperViewType new_view = 0;
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	MusicWidgetsViewSelector* _tmp2_;
	MusicWidgetsViewSelector* _tmp3_;
	MusicWidgetsViewSelectorMode _tmp4_;
	MusicWidgetsViewSelectorMode _tmp5_;
#line 364 "../src/Views/Wrappers/ViewWrapper.vala"
	static const gint N_VIEWS = 2;
#line 1644 "ViewWrapper.c"
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
#line 362 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = music_app_get_main_window ();
#line 362 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 362 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = music_library_window_get_view_selector (_tmp1_);
#line 362 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = _tmp2_;
#line 362 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = music_widgets_view_selector_get_selected (_tmp3_);
#line 362 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp5_ = _tmp4_;
#line 362 "../src/Views/Wrappers/ViewWrapper.vala"
	new_view = (MusicViewWrapperViewType) _tmp5_;
#line 365 "../src/Views/Wrappers/ViewWrapper.vala"
	if (new_view < 0) {
#line 365 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp6_ = TRUE;
#line 1665 "ViewWrapper.c"
	} else {
#line 365 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp6_ = new_view > (N_VIEWS - 1);
#line 1669 "ViewWrapper.c"
	}
#line 365 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp6_) {
#line 366 "../src/Views/Wrappers/ViewWrapper.vala"
		new_view = MUSIC_VIEW_WRAPPER_VIEW_TYPE_LIST;
#line 1675 "ViewWrapper.c"
	}
#line 368 "../src/Views/Wrappers/ViewWrapper.vala"
	if (new_view == MUSIC_VIEW_WRAPPER_VIEW_TYPE_LIST) {
#line 1679 "ViewWrapper.c"
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 368 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp8_ = music_view_wrapper_get_has_list_view (self);
#line 368 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp9_ = _tmp8_;
#line 368 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp7_ = _tmp9_;
#line 1688 "ViewWrapper.c"
	} else {
#line 368 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp7_ = FALSE;
#line 1692 "ViewWrapper.c"
	}
#line 368 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp7_) {
#line 369 "../src/Views/Wrappers/ViewWrapper.vala"
		music_view_wrapper_set_active_view (self, MUSIC_VIEW_WRAPPER_VIEW_TYPE_LIST, NULL);
#line 1698 "ViewWrapper.c"
	} else {
		gboolean _tmp10_ = FALSE;
#line 370 "../src/Views/Wrappers/ViewWrapper.vala"
		if (new_view == MUSIC_VIEW_WRAPPER_VIEW_TYPE_GRID) {
#line 1703 "ViewWrapper.c"
			gboolean _tmp11_;
			gboolean _tmp12_;
#line 370 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp11_ = music_view_wrapper_get_has_grid_view (self);
#line 370 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp12_ = _tmp11_;
#line 370 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp10_ = _tmp12_;
#line 1712 "ViewWrapper.c"
		} else {
#line 370 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp10_ = FALSE;
#line 1716 "ViewWrapper.c"
		}
#line 370 "../src/Views/Wrappers/ViewWrapper.vala"
		if (_tmp10_) {
#line 371 "../src/Views/Wrappers/ViewWrapper.vala"
			music_view_wrapper_set_active_view (self, MUSIC_VIEW_WRAPPER_VIEW_TYPE_GRID, NULL);
#line 1722 "ViewWrapper.c"
		} else {
			gboolean _tmp13_;
			gboolean _tmp14_;
#line 372 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp13_ = music_view_wrapper_get_has_list_view (self);
#line 372 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp14_ = _tmp13_;
#line 372 "../src/Views/Wrappers/ViewWrapper.vala"
			if (_tmp14_) {
#line 1732 "ViewWrapper.c"
				MusicViewStack* _tmp15_;
				MusicListView* _tmp16_;
#line 373 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp15_ = self->priv->view_stack;
#line 373 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp16_ = self->priv->_list_view;
#line 373 "../src/Views/Wrappers/ViewWrapper.vala"
				gtk_stack_set_visible_child ((GtkStack*) _tmp15_, (GtkWidget*) _tmp16_);
#line 1741 "ViewWrapper.c"
			} else {
				gboolean _tmp17_;
				gboolean _tmp18_;
#line 374 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp17_ = music_view_wrapper_get_has_grid_view (self);
#line 374 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp18_ = _tmp17_;
#line 374 "../src/Views/Wrappers/ViewWrapper.vala"
				if (_tmp18_) {
#line 1751 "ViewWrapper.c"
					MusicViewStack* _tmp19_;
					MusicAlbumsView* _tmp20_;
#line 375 "../src/Views/Wrappers/ViewWrapper.vala"
					_tmp19_ = self->priv->view_stack;
#line 375 "../src/Views/Wrappers/ViewWrapper.vala"
					_tmp20_ = self->priv->_grid_view;
#line 375 "../src/Views/Wrappers/ViewWrapper.vala"
					gtk_stack_set_visible_child ((GtkStack*) _tmp19_, (GtkWidget*) _tmp20_);
#line 1760 "ViewWrapper.c"
				}
			}
		}
	}
}

void
music_view_wrapper_select_proper_content_view (MusicViewWrapper* self)
{
	MusicViewWrapperClass* _klass_;
#line 361 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 361 "../src/Views/Wrappers/ViewWrapper.vala"
	_klass_ = MUSIC_VIEW_WRAPPER_GET_CLASS (self);
#line 361 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_klass_->select_proper_content_view) {
#line 361 "../src/Views/Wrappers/ViewWrapper.vala"
		_klass_->select_proper_content_view (self);
#line 1779 "ViewWrapper.c"
	}
}

/**
     * @return A collection containing ALL the media associated to this view.
     */
GeeCollection*
music_view_wrapper_get_media_list (MusicViewWrapper* self)
{
	MusicListView* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result;
#line 381 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 382 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_list_view;
#line 382 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = music_view_interface_get_media ((MusicViewInterface*) _tmp0_);
#line 382 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp1_;
#line 382 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 1802 "ViewWrapper.c"
}

/**
     * Resets all the filters (external and internal) applied to a view inside
     * the view wrapper. It should only be called if the view is the current active
     * wrapper.
     */
void
music_view_wrapper_clear_filters (MusicViewWrapper* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 390 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 390 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = music_view_wrapper_get_is_current_wrapper (self);
#line 390 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 390 "../src/Views/Wrappers/ViewWrapper.vala"
	_vala_return_if_fail (_tmp1_, "is_current_wrapper");
#line 391 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_update_visible_media (self);
#line 1825 "ViewWrapper.c"
}

/**
     * Updates the data in visible_media and re-populates all the views.
     * Primarily used for searches
     */
void
music_view_wrapper_update_visible_media (MusicViewWrapper* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	MusicViewWrapperHint _tmp2_;
	GEnumValue* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GError* _inner_error0_ = NULL;
#line 398 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 399 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = music_view_wrapper_get_is_current_wrapper (self);
#line 399 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 399 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_tmp1_) {
#line 400 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 1854 "ViewWrapper.c"
	}
#line 401 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = self->priv->_hint;
#line 401 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp2_);
#line 401 "../src/Views/Wrappers/ViewWrapper.vala"
	g_debug ("ViewWrapper.vala:401: UPDATING VISIBLE MEDIA [%s]", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL);
#line 403 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = music_view_wrapper_get_has_list_view (self);
#line 403 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp5_ = _tmp4_;
#line 403 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp5_) {
#line 1868 "ViewWrapper.c"
		{
			MusicListView* _tmp6_;
#line 404 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp6_ = self->priv->_list_view;
#line 404 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_list_view);
#line 1875 "ViewWrapper.c"
			{
				MusicListView* _tmp7_;
#line 405 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp7_ = self->priv->_list_view;
#line 405 "../src/Views/Wrappers/ViewWrapper.vala"
				music_view_interface_refilter ((MusicViewInterface*) _tmp7_);
#line 1882 "ViewWrapper.c"
			}
			__finally0:
			{
				MusicListView* _tmp8_;
#line 404 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp8_ = self->priv->_list_view;
#line 404 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_list_view);
#line 1891 "ViewWrapper.c"
			}
#line 404 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 404 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 404 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 404 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 1901 "ViewWrapper.c"
			}
		}
	}
#line 409 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp9_ = music_view_wrapper_get_has_grid_view (self);
#line 409 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp10_ = _tmp9_;
#line 409 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp10_) {
#line 1911 "ViewWrapper.c"
		{
			MusicAlbumsView* _tmp11_;
#line 410 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp11_ = self->priv->_grid_view;
#line 410 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_grid_view);
#line 1918 "ViewWrapper.c"
			{
				MusicAlbumsView* _tmp12_;
#line 411 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp12_ = self->priv->_grid_view;
#line 411 "../src/Views/Wrappers/ViewWrapper.vala"
				music_view_interface_refilter ((MusicViewInterface*) _tmp12_);
#line 1925 "ViewWrapper.c"
			}
			__finally1:
			{
				MusicAlbumsView* _tmp13_;
#line 410 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp13_ = self->priv->_grid_view;
#line 410 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_grid_view);
#line 1934 "ViewWrapper.c"
			}
#line 410 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 410 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 410 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 410 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 1944 "ViewWrapper.c"
			}
		}
	}
}

static void
music_view_wrapper_real_set_no_media_alert (MusicViewWrapper* self)
{
	GraniteWidgetsAlertView* _tmp0_;
	GraniteWidgetsAlertView* _tmp1_;
#line 417 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_embedded_alert;
#line 417 "../src/Views/Wrappers/ViewWrapper.vala"
	granite_widgets_alert_view_set_icon_name (_tmp0_, "dialog-information");
#line 418 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = self->priv->_embedded_alert;
#line 418 "../src/Views/Wrappers/ViewWrapper.vala"
	granite_widgets_alert_view_set_title (_tmp1_, _ ("No media"));
#line 1963 "ViewWrapper.c"
}

void
music_view_wrapper_set_no_media_alert (MusicViewWrapper* self)
{
	MusicViewWrapperClass* _klass_;
#line 416 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 416 "../src/Views/Wrappers/ViewWrapper.vala"
	_klass_ = MUSIC_VIEW_WRAPPER_GET_CLASS (self);
#line 416 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_klass_->set_no_media_alert) {
#line 416 "../src/Views/Wrappers/ViewWrapper.vala"
		_klass_->set_no_media_alert (self);
#line 1978 "ViewWrapper.c"
	}
}

static void
music_view_wrapper_set_media_async_data_free (gpointer _data)
{
	MusicViewWrapperSetMediaAsyncData* _data_;
	_data_ = _data;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->new_media);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->self);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_slice_free (MusicViewWrapperSetMediaAsyncData, _data_);
#line 1993 "ViewWrapper.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	return self ? g_object_ref (self) : NULL;
#line 2001 "ViewWrapper.c"
}

void
music_view_wrapper_set_media_async (MusicViewWrapper* self,
                                    GeeCollection* new_media,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	MusicViewWrapperSetMediaAsyncData* _data_;
	MusicViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (new_media != NULL);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_ = g_slice_new0 (MusicViewWrapperSetMediaAsyncData);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_view_wrapper_set_media_async_data_free);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->self = _tmp0_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _g_object_ref0 (new_media);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->new_media);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->new_media = _tmp1_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_set_media_async_co (_data_);
#line 2035 "ViewWrapper.c"
}

void
music_view_wrapper_set_media_finish (MusicViewWrapper* self,
                                     GAsyncResult* _res_)
{
	MusicViewWrapperSetMediaAsyncData* _data_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2045 "ViewWrapper.c"
}

static gboolean
music_view_wrapper_set_media_async_co (MusicViewWrapperSetMediaAsyncData* _data_)
{
#line 421 "../src/Views/Wrappers/ViewWrapper.vala"
	switch (_data_->_state_) {
#line 421 "../src/Views/Wrappers/ViewWrapper.vala"
		case 0:
#line 2055 "ViewWrapper.c"
		goto _state_0;
		default:
#line 421 "../src/Views/Wrappers/ViewWrapper.vala"
		g_assert_not_reached ();
#line 2060 "ViewWrapper.c"
	}
	_state_0:
#line 422 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_data_->self->priv->widgets_ready) {
#line 423 "../src/Views/Wrappers/ViewWrapper.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 423 "../src/Views/Wrappers/ViewWrapper.vala"
		if (_data_->_state_ != 0) {
#line 423 "../src/Views/Wrappers/ViewWrapper.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 423 "../src/Views/Wrappers/ViewWrapper.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2073 "ViewWrapper.c"
			}
		}
#line 423 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_unref (_data_->_async_result);
#line 423 "../src/Views/Wrappers/ViewWrapper.vala"
		return FALSE;
#line 2080 "ViewWrapper.c"
	}
#line 424 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_set_media (_data_->self, _data_->new_media);
#line 421 "../src/Views/Wrappers/ViewWrapper.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 421 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_data_->_state_ != 0) {
#line 421 "../src/Views/Wrappers/ViewWrapper.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 421 "../src/Views/Wrappers/ViewWrapper.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2092 "ViewWrapper.c"
		}
	}
#line 421 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_unref (_data_->_async_result);
#line 421 "../src/Views/Wrappers/ViewWrapper.vala"
	return FALSE;
#line 2099 "ViewWrapper.c"
}

static void
music_view_wrapper_add_media_async_data_free (gpointer _data)
{
	MusicViewWrapperAddMediaAsyncData* _data_;
	_data_ = _data;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->to_add);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->self);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_slice_free (MusicViewWrapperAddMediaAsyncData, _data_);
#line 2113 "ViewWrapper.c"
}

void
music_view_wrapper_add_media_async (MusicViewWrapper* self,
                                    GeeCollection* to_add,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	MusicViewWrapperAddMediaAsyncData* _data_;
	MusicViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (to_add != NULL);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_ = g_slice_new0 (MusicViewWrapperAddMediaAsyncData);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_view_wrapper_add_media_async_data_free);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->self = _tmp0_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _g_object_ref0 (to_add);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->to_add);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->to_add = _tmp1_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_add_media_async_co (_data_);
#line 2147 "ViewWrapper.c"
}

void
music_view_wrapper_add_media_finish (MusicViewWrapper* self,
                                     GAsyncResult* _res_)
{
	MusicViewWrapperAddMediaAsyncData* _data_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2157 "ViewWrapper.c"
}

static gboolean
music_view_wrapper_add_media_async_co (MusicViewWrapperAddMediaAsyncData* _data_)
{
#line 427 "../src/Views/Wrappers/ViewWrapper.vala"
	switch (_data_->_state_) {
#line 427 "../src/Views/Wrappers/ViewWrapper.vala"
		case 0:
#line 2167 "ViewWrapper.c"
		goto _state_0;
		default:
#line 427 "../src/Views/Wrappers/ViewWrapper.vala"
		g_assert_not_reached ();
#line 2172 "ViewWrapper.c"
	}
	_state_0:
#line 428 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_data_->self->priv->widgets_ready) {
#line 429 "../src/Views/Wrappers/ViewWrapper.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 429 "../src/Views/Wrappers/ViewWrapper.vala"
		if (_data_->_state_ != 0) {
#line 429 "../src/Views/Wrappers/ViewWrapper.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 429 "../src/Views/Wrappers/ViewWrapper.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2185 "ViewWrapper.c"
			}
		}
#line 429 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_unref (_data_->_async_result);
#line 429 "../src/Views/Wrappers/ViewWrapper.vala"
		return FALSE;
#line 2192 "ViewWrapper.c"
	}
#line 430 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_add_media (_data_->self, _data_->to_add);
#line 431 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_update_visible_media (_data_->self);
#line 427 "../src/Views/Wrappers/ViewWrapper.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 427 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_data_->_state_ != 0) {
#line 427 "../src/Views/Wrappers/ViewWrapper.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 427 "../src/Views/Wrappers/ViewWrapper.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2206 "ViewWrapper.c"
		}
	}
#line 427 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_unref (_data_->_async_result);
#line 427 "../src/Views/Wrappers/ViewWrapper.vala"
	return FALSE;
#line 2213 "ViewWrapper.c"
}

static void
music_view_wrapper_remove_media_async_data_free (gpointer _data)
{
	MusicViewWrapperRemoveMediaAsyncData* _data_;
	_data_ = _data;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->to_remove);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->self);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_slice_free (MusicViewWrapperRemoveMediaAsyncData, _data_);
#line 2227 "ViewWrapper.c"
}

void
music_view_wrapper_remove_media_async (MusicViewWrapper* self,
                                       GeeCollection* to_remove,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	MusicViewWrapperRemoveMediaAsyncData* _data_;
	MusicViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (to_remove != NULL);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_ = g_slice_new0 (MusicViewWrapperRemoveMediaAsyncData);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_view_wrapper_remove_media_async_data_free);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->self = _tmp0_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _g_object_ref0 (to_remove);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->to_remove);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->to_remove = _tmp1_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_remove_media_async_co (_data_);
#line 2261 "ViewWrapper.c"
}

void
music_view_wrapper_remove_media_finish (MusicViewWrapper* self,
                                        GAsyncResult* _res_)
{
	MusicViewWrapperRemoveMediaAsyncData* _data_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2271 "ViewWrapper.c"
}

static gboolean
music_view_wrapper_remove_media_async_co (MusicViewWrapperRemoveMediaAsyncData* _data_)
{
#line 434 "../src/Views/Wrappers/ViewWrapper.vala"
	switch (_data_->_state_) {
#line 434 "../src/Views/Wrappers/ViewWrapper.vala"
		case 0:
#line 2281 "ViewWrapper.c"
		goto _state_0;
		default:
#line 434 "../src/Views/Wrappers/ViewWrapper.vala"
		g_assert_not_reached ();
#line 2286 "ViewWrapper.c"
	}
	_state_0:
#line 435 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_data_->self->priv->widgets_ready) {
#line 436 "../src/Views/Wrappers/ViewWrapper.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 436 "../src/Views/Wrappers/ViewWrapper.vala"
		if (_data_->_state_ != 0) {
#line 436 "../src/Views/Wrappers/ViewWrapper.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 436 "../src/Views/Wrappers/ViewWrapper.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2299 "ViewWrapper.c"
			}
		}
#line 436 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_unref (_data_->_async_result);
#line 436 "../src/Views/Wrappers/ViewWrapper.vala"
		return FALSE;
#line 2306 "ViewWrapper.c"
	}
#line 437 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_remove_media (_data_->self, _data_->to_remove);
#line 434 "../src/Views/Wrappers/ViewWrapper.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 434 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_data_->_state_ != 0) {
#line 434 "../src/Views/Wrappers/ViewWrapper.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 434 "../src/Views/Wrappers/ViewWrapper.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2318 "ViewWrapper.c"
		}
	}
#line 434 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_unref (_data_->_async_result);
#line 434 "../src/Views/Wrappers/ViewWrapper.vala"
	return FALSE;
#line 2325 "ViewWrapper.c"
}

static void
music_view_wrapper_update_media_async_data_free (gpointer _data)
{
	MusicViewWrapperUpdateMediaAsyncData* _data_;
	_data_ = _data;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->to_update);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->self);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_slice_free (MusicViewWrapperUpdateMediaAsyncData, _data_);
#line 2339 "ViewWrapper.c"
}

void
music_view_wrapper_update_media_async (MusicViewWrapper* self,
                                       GeeCollection* to_update,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	MusicViewWrapperUpdateMediaAsyncData* _data_;
	MusicViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (to_update != NULL);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_ = g_slice_new0 (MusicViewWrapperUpdateMediaAsyncData);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_view_wrapper_update_media_async_data_free);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->self = _tmp0_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _g_object_ref0 (to_update);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->to_update);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->to_update = _tmp1_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_update_media_async_co (_data_);
#line 2373 "ViewWrapper.c"
}

void
music_view_wrapper_update_media_finish (MusicViewWrapper* self,
                                        GAsyncResult* _res_)
{
	MusicViewWrapperUpdateMediaAsyncData* _data_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2383 "ViewWrapper.c"
}

static gboolean
music_view_wrapper_update_media_async_co (MusicViewWrapperUpdateMediaAsyncData* _data_)
{
#line 440 "../src/Views/Wrappers/ViewWrapper.vala"
	switch (_data_->_state_) {
#line 440 "../src/Views/Wrappers/ViewWrapper.vala"
		case 0:
#line 2393 "ViewWrapper.c"
		goto _state_0;
		default:
#line 440 "../src/Views/Wrappers/ViewWrapper.vala"
		g_assert_not_reached ();
#line 2398 "ViewWrapper.c"
	}
	_state_0:
#line 441 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_data_->self->priv->widgets_ready) {
#line 442 "../src/Views/Wrappers/ViewWrapper.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 442 "../src/Views/Wrappers/ViewWrapper.vala"
		if (_data_->_state_ != 0) {
#line 442 "../src/Views/Wrappers/ViewWrapper.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 442 "../src/Views/Wrappers/ViewWrapper.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2411 "ViewWrapper.c"
			}
		}
#line 442 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_unref (_data_->_async_result);
#line 442 "../src/Views/Wrappers/ViewWrapper.vala"
		return FALSE;
#line 2418 "ViewWrapper.c"
	}
#line 443 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_update_media (_data_->self, _data_->to_update);
#line 440 "../src/Views/Wrappers/ViewWrapper.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 440 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_data_->_state_ != 0) {
#line 440 "../src/Views/Wrappers/ViewWrapper.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 440 "../src/Views/Wrappers/ViewWrapper.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2430 "ViewWrapper.c"
		}
	}
#line 440 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_unref (_data_->_async_result);
#line 440 "../src/Views/Wrappers/ViewWrapper.vala"
	return FALSE;
#line 2437 "ViewWrapper.c"
}

static void
music_view_wrapper_set_media (MusicViewWrapper* self,
                              GeeCollection* new_media)
{
	MusicViewWrapperHint _tmp0_;
	GEnumValue* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	GError* _inner_error0_ = NULL;
#line 446 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 446 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (new_media != NULL);
#line 447 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_hint;
#line 447 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp0_);
#line 447 "../src/Views/Wrappers/ViewWrapper.vala"
	g_debug ("ViewWrapper.vala:447: SETTING MEDIA [%s]", (_tmp1_ != NULL) ? _tmp1_->value_name : NULL);
#line 449 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = music_view_wrapper_get_has_list_view (self);
#line 449 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = _tmp2_;
#line 449 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp3_) {
#line 2467 "ViewWrapper.c"
		{
			MusicListView* _tmp4_;
#line 450 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp4_ = self->priv->_list_view;
#line 450 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_list_view);
#line 2474 "ViewWrapper.c"
			{
				MusicListView* _tmp5_;
#line 451 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp5_ = self->priv->_list_view;
#line 451 "../src/Views/Wrappers/ViewWrapper.vala"
				music_view_interface_set_media ((MusicViewInterface*) _tmp5_, new_media);
#line 2481 "ViewWrapper.c"
			}
			__finally0:
			{
				MusicListView* _tmp6_;
#line 450 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp6_ = self->priv->_list_view;
#line 450 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_list_view);
#line 2490 "ViewWrapper.c"
			}
#line 450 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 450 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 450 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 450 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 2500 "ViewWrapper.c"
			}
		}
	}
#line 455 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp7_ = music_view_wrapper_get_has_grid_view (self);
#line 455 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp8_ = _tmp7_;
#line 455 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp8_) {
#line 2510 "ViewWrapper.c"
		{
			MusicAlbumsView* _tmp9_;
#line 456 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp9_ = self->priv->_grid_view;
#line 456 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_grid_view);
#line 2517 "ViewWrapper.c"
			{
				MusicAlbumsView* _tmp10_;
#line 457 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp10_ = self->priv->_grid_view;
#line 457 "../src/Views/Wrappers/ViewWrapper.vala"
				music_view_interface_set_media ((MusicViewInterface*) _tmp10_, new_media);
#line 2524 "ViewWrapper.c"
			}
			__finally1:
			{
				MusicAlbumsView* _tmp11_;
#line 456 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp11_ = self->priv->_grid_view;
#line 456 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_grid_view);
#line 2533 "ViewWrapper.c"
			}
#line 456 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 456 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 456 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 456 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 2543 "ViewWrapper.c"
			}
		}
	}
#line 461 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv->data_initialized = TRUE;
#line 463 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_update_visible_media (self);
#line 464 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_update_widget_state (self);
#line 2553 "ViewWrapper.c"
}

static void
music_view_wrapper_update_media (MusicViewWrapper* self,
                                 GeeCollection* media)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	MusicViewWrapperHint _tmp2_;
	GEnumValue* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GError* _inner_error0_ = NULL;
#line 467 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 467 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (media != NULL);
#line 467 "../src/Views/Wrappers/ViewWrapper.vala"
	_vala_return_if_fail (self->priv->data_initialized, "data_initialized");
#line 468 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = gee_collection_get_is_empty (media);
#line 468 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 468 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp1_) {
#line 469 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 2583 "ViewWrapper.c"
	}
#line 471 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = self->priv->_hint;
#line 471 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp2_);
#line 471 "../src/Views/Wrappers/ViewWrapper.vala"
	g_debug ("ViewWrapper.vala:471: UPDATING MEDIA [%s]", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL);
#line 473 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = music_view_wrapper_get_has_list_view (self);
#line 473 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp5_ = _tmp4_;
#line 473 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp5_) {
#line 2597 "ViewWrapper.c"
		{
			MusicListView* _tmp6_;
#line 474 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp6_ = self->priv->_list_view;
#line 474 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_list_view);
#line 2604 "ViewWrapper.c"
			{
				MusicListView* _tmp7_;
#line 475 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp7_ = self->priv->_list_view;
#line 475 "../src/Views/Wrappers/ViewWrapper.vala"
				music_view_interface_update_media ((MusicViewInterface*) _tmp7_, media);
#line 2611 "ViewWrapper.c"
			}
			__finally0:
			{
				MusicListView* _tmp8_;
#line 474 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp8_ = self->priv->_list_view;
#line 474 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_list_view);
#line 2620 "ViewWrapper.c"
			}
#line 474 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 474 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 474 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 474 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 2630 "ViewWrapper.c"
			}
		}
	}
#line 479 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp9_ = music_view_wrapper_get_has_grid_view (self);
#line 479 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp10_ = _tmp9_;
#line 479 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp10_) {
#line 2640 "ViewWrapper.c"
		{
			MusicAlbumsView* _tmp11_;
#line 480 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp11_ = self->priv->_grid_view;
#line 480 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_grid_view);
#line 2647 "ViewWrapper.c"
			{
				MusicAlbumsView* _tmp12_;
#line 481 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp12_ = self->priv->_grid_view;
#line 481 "../src/Views/Wrappers/ViewWrapper.vala"
				music_view_interface_update_media ((MusicViewInterface*) _tmp12_, media);
#line 2654 "ViewWrapper.c"
			}
			__finally1:
			{
				MusicAlbumsView* _tmp13_;
#line 480 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp13_ = self->priv->_grid_view;
#line 480 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_grid_view);
#line 2663 "ViewWrapper.c"
			}
#line 480 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 480 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 480 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 480 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 2673 "ViewWrapper.c"
			}
		}
	}
#line 485 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_update_widget_state (self);
#line 2679 "ViewWrapper.c"
}

static void
music_view_wrapper_add_media (MusicViewWrapper* self,
                              GeeCollection* new_media)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	GError* _inner_error0_ = NULL;
#line 488 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 488 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (new_media != NULL);
#line 488 "../src/Views/Wrappers/ViewWrapper.vala"
	_vala_return_if_fail (self->priv->data_initialized, "data_initialized");
#line 489 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = gee_collection_get_is_empty (new_media);
#line 489 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 489 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp1_) {
#line 490 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 2707 "ViewWrapper.c"
	}
#line 492 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = music_view_wrapper_get_has_list_view (self);
#line 492 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = _tmp2_;
#line 492 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp3_) {
#line 2715 "ViewWrapper.c"
		{
			MusicListView* _tmp4_;
#line 493 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp4_ = self->priv->_list_view;
#line 493 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_list_view);
#line 2722 "ViewWrapper.c"
			{
				MusicListView* _tmp5_;
#line 494 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp5_ = self->priv->_list_view;
#line 494 "../src/Views/Wrappers/ViewWrapper.vala"
				music_view_interface_add_media ((MusicViewInterface*) _tmp5_, new_media);
#line 2729 "ViewWrapper.c"
			}
			__finally0:
			{
				MusicListView* _tmp6_;
#line 493 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp6_ = self->priv->_list_view;
#line 493 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_list_view);
#line 2738 "ViewWrapper.c"
			}
#line 493 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 493 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 493 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 493 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 2748 "ViewWrapper.c"
			}
		}
	}
#line 498 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp7_ = music_view_wrapper_get_has_grid_view (self);
#line 498 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp8_ = _tmp7_;
#line 498 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp8_) {
#line 2758 "ViewWrapper.c"
		{
			MusicAlbumsView* _tmp9_;
#line 499 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp9_ = self->priv->_grid_view;
#line 499 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_grid_view);
#line 2765 "ViewWrapper.c"
			{
				MusicAlbumsView* _tmp10_;
#line 500 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp10_ = self->priv->_grid_view;
#line 500 "../src/Views/Wrappers/ViewWrapper.vala"
				music_view_interface_add_media ((MusicViewInterface*) _tmp10_, new_media);
#line 2772 "ViewWrapper.c"
			}
			__finally1:
			{
				MusicAlbumsView* _tmp11_;
#line 499 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp11_ = self->priv->_grid_view;
#line 499 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_grid_view);
#line 2781 "ViewWrapper.c"
			}
#line 499 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 499 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 499 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 499 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 2791 "ViewWrapper.c"
			}
		}
	}
#line 504 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_update_widget_state (self);
#line 2797 "ViewWrapper.c"
}

static void
music_view_wrapper_remove_media (MusicViewWrapper* self,
                                 GeeCollection* media)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	MusicViewWrapperHint _tmp2_;
	GEnumValue* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GError* _inner_error0_ = NULL;
#line 507 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 507 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (media != NULL);
#line 507 "../src/Views/Wrappers/ViewWrapper.vala"
	_vala_return_if_fail (self->priv->data_initialized, "data_initialized");
#line 508 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = gee_collection_get_is_empty (media);
#line 508 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 508 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp1_) {
#line 509 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 2827 "ViewWrapper.c"
	}
#line 511 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = self->priv->_hint;
#line 511 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp2_);
#line 511 "../src/Views/Wrappers/ViewWrapper.vala"
	g_debug ("ViewWrapper.vala:511: REMOVING MEDIA [%s]", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL);
#line 513 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = music_view_wrapper_get_has_list_view (self);
#line 513 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp5_ = _tmp4_;
#line 513 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp5_) {
#line 2841 "ViewWrapper.c"
		{
			MusicListView* _tmp6_;
#line 514 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp6_ = self->priv->_list_view;
#line 514 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_list_view);
#line 2848 "ViewWrapper.c"
			{
				MusicListView* _tmp7_;
#line 515 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp7_ = self->priv->_list_view;
#line 515 "../src/Views/Wrappers/ViewWrapper.vala"
				music_view_interface_remove_media ((MusicViewInterface*) _tmp7_, media);
#line 2855 "ViewWrapper.c"
			}
			__finally0:
			{
				MusicListView* _tmp8_;
#line 514 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp8_ = self->priv->_list_view;
#line 514 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_list_view);
#line 2864 "ViewWrapper.c"
			}
#line 514 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 514 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 514 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 514 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 2874 "ViewWrapper.c"
			}
		}
	}
#line 519 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp9_ = music_view_wrapper_get_has_grid_view (self);
#line 519 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp10_ = _tmp9_;
#line 519 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp10_) {
#line 2884 "ViewWrapper.c"
		{
			MusicAlbumsView* _tmp11_;
#line 520 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp11_ = self->priv->_grid_view;
#line 520 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_grid_view);
#line 2891 "ViewWrapper.c"
			{
				MusicAlbumsView* _tmp12_;
#line 521 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp12_ = self->priv->_grid_view;
#line 521 "../src/Views/Wrappers/ViewWrapper.vala"
				music_view_interface_remove_media ((MusicViewInterface*) _tmp12_, media);
#line 2898 "ViewWrapper.c"
			}
			__finally1:
			{
				MusicAlbumsView* _tmp13_;
#line 520 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp13_ = self->priv->_grid_view;
#line 520 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_grid_view);
#line 2907 "ViewWrapper.c"
			}
#line 520 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 520 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 520 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 520 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 2917 "ViewWrapper.c"
			}
		}
	}
#line 525 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_update_widget_state (self);
#line 2923 "ViewWrapper.c"
}

static void
music_view_wrapper_update_widget_state (MusicViewWrapper* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 528 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 529 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_check_have_media (self);
#line 532 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = music_view_wrapper_get_is_current_wrapper (self);
#line 532 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 532 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp1_) {
#line 533 "../src/Views/Wrappers/ViewWrapper.vala"
		music_view_wrapper_update_library_window_widgets (self);
#line 2943 "ViewWrapper.c"
	}
}

MusicListView*
music_view_wrapper_get_list_view (MusicViewWrapper* self)
{
	MusicListView* result;
	MusicListView* _tmp0_;
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_list_view;
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_;
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 2960 "ViewWrapper.c"
}

void
music_view_wrapper_set_list_view (MusicViewWrapper* self,
                                  MusicListView* value)
{
	MusicListView* old_value;
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
	old_value = music_view_wrapper_get_list_view (self);
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
	if (old_value != value) {
#line 2974 "ViewWrapper.c"
		MusicListView* _tmp0_;
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (self->priv->_list_view);
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
		self->priv->_list_view = _tmp0_;
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_LIST_VIEW_PROPERTY]);
#line 2984 "ViewWrapper.c"
	}
}

MusicAlbumsView*
music_view_wrapper_get_grid_view (MusicViewWrapper* self)
{
	MusicAlbumsView* result;
	MusicAlbumsView* _tmp0_;
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_grid_view;
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_;
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3001 "ViewWrapper.c"
}

void
music_view_wrapper_set_grid_view (MusicViewWrapper* self,
                                  MusicAlbumsView* value)
{
	MusicAlbumsView* old_value;
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
	old_value = music_view_wrapper_get_grid_view (self);
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
	if (old_value != value) {
#line 3015 "ViewWrapper.c"
		MusicAlbumsView* _tmp0_;
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (self->priv->_grid_view);
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
		self->priv->_grid_view = _tmp0_;
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_GRID_VIEW_PROPERTY]);
#line 3025 "ViewWrapper.c"
	}
}

GraniteWidgetsAlertView*
music_view_wrapper_get_embedded_alert (MusicViewWrapper* self)
{
	GraniteWidgetsAlertView* result;
	GraniteWidgetsAlertView* _tmp0_;
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_embedded_alert;
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_;
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3042 "ViewWrapper.c"
}

void
music_view_wrapper_set_embedded_alert (MusicViewWrapper* self,
                                       GraniteWidgetsAlertView* value)
{
	GraniteWidgetsAlertView* old_value;
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
	old_value = music_view_wrapper_get_embedded_alert (self);
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
	if (old_value != value) {
#line 3056 "ViewWrapper.c"
		GraniteWidgetsAlertView* _tmp0_;
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (self->priv->_embedded_alert);
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
		self->priv->_embedded_alert = _tmp0_;
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY]);
#line 3066 "ViewWrapper.c"
	}
}

GraniteWidgetsWelcome*
music_view_wrapper_get_welcome_screen (MusicViewWrapper* self)
{
	GraniteWidgetsWelcome* result;
	GraniteWidgetsWelcome* _tmp0_;
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_welcome_screen;
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_;
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3083 "ViewWrapper.c"
}

void
music_view_wrapper_set_welcome_screen (MusicViewWrapper* self,
                                       GraniteWidgetsWelcome* value)
{
	GraniteWidgetsWelcome* old_value;
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
	old_value = music_view_wrapper_get_welcome_screen (self);
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
	if (old_value != value) {
#line 3097 "ViewWrapper.c"
		GraniteWidgetsWelcome* _tmp0_;
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (self->priv->_welcome_screen);
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
		self->priv->_welcome_screen = _tmp0_;
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY]);
#line 3107 "ViewWrapper.c"
	}
}

gboolean
music_view_wrapper_get_has_grid_view (MusicViewWrapper* self)
{
	gboolean result;
	MusicAlbumsView* _tmp0_;
#line 76 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 76 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_grid_view;
#line 76 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_ != NULL;
#line 76 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3124 "ViewWrapper.c"
}

gboolean
music_view_wrapper_get_has_list_view (MusicViewWrapper* self)
{
	gboolean result;
	MusicListView* _tmp0_;
#line 77 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 77 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_list_view;
#line 77 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_ != NULL;
#line 77 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3140 "ViewWrapper.c"
}

gboolean
music_view_wrapper_get_has_embedded_alert (MusicViewWrapper* self)
{
	gboolean result;
	GraniteWidgetsAlertView* _tmp0_;
#line 78 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 78 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_embedded_alert;
#line 78 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_ != NULL;
#line 78 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3156 "ViewWrapper.c"
}

gboolean
music_view_wrapper_get_has_welcome_screen (MusicViewWrapper* self)
{
	gboolean result;
	GraniteWidgetsWelcome* _tmp0_;
#line 79 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 79 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_welcome_screen;
#line 79 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_ != NULL;
#line 79 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3172 "ViewWrapper.c"
}

MusicViewWrapperViewType
music_view_wrapper_get_current_view (MusicViewWrapper* self)
{
	MusicViewWrapperViewType result;
	GtkWidget* view = NULL;
	MusicViewStack* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	MusicAlbumsView* _tmp5_;
	GtkWidget* _tmp6_;
	MusicListView* _tmp7_;
	GtkWidget* _tmp8_;
	GraniteWidgetsAlertView* _tmp9_;
	GtkWidget* _tmp10_;
	GraniteWidgetsWelcome* _tmp11_;
#line 82 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 83 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->view_stack;
#line 83 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = gtk_stack_get_visible_child ((GtkStack*) _tmp0_);
#line 83 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = _tmp1_;
#line 83 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 83 "../src/Views/Wrappers/ViewWrapper.vala"
	view = _tmp3_;
#line 85 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = view;
#line 85 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp5_ = self->priv->_grid_view;
#line 85 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp4_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget)) {
#line 86 "../src/Views/Wrappers/ViewWrapper.vala"
		result = MUSIC_VIEW_WRAPPER_VIEW_TYPE_GRID;
#line 86 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (view);
#line 86 "../src/Views/Wrappers/ViewWrapper.vala"
		return result;
#line 3216 "ViewWrapper.c"
	}
#line 88 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp6_ = view;
#line 88 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp7_ = self->priv->_list_view;
#line 88 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp6_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget)) {
#line 89 "../src/Views/Wrappers/ViewWrapper.vala"
		result = MUSIC_VIEW_WRAPPER_VIEW_TYPE_LIST;
#line 89 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (view);
#line 89 "../src/Views/Wrappers/ViewWrapper.vala"
		return result;
#line 3230 "ViewWrapper.c"
	}
#line 91 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp8_ = view;
#line 91 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp9_ = self->priv->_embedded_alert;
#line 91 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp8_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget)) {
#line 92 "../src/Views/Wrappers/ViewWrapper.vala"
		result = MUSIC_VIEW_WRAPPER_VIEW_TYPE_ALERT;
#line 92 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (view);
#line 92 "../src/Views/Wrappers/ViewWrapper.vala"
		return result;
#line 3244 "ViewWrapper.c"
	}
#line 95 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp10_ = view;
#line 95 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp11_ = self->priv->_welcome_screen;
#line 95 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp10_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget)) {
#line 96 "../src/Views/Wrappers/ViewWrapper.vala"
		result = MUSIC_VIEW_WRAPPER_VIEW_TYPE_WELCOME;
#line 96 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (view);
#line 96 "../src/Views/Wrappers/ViewWrapper.vala"
		return result;
#line 3258 "ViewWrapper.c"
	}
#line 98 "../src/Views/Wrappers/ViewWrapper.vala"
	result = MUSIC_VIEW_WRAPPER_VIEW_TYPE_NONE;
#line 98 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (view);
#line 98 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3266 "ViewWrapper.c"
}

MusicViewWrapperHint
music_view_wrapper_get_hint (MusicViewWrapper* self)
{
	MusicViewWrapperHint result;
#line 107 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 107 "../src/Views/Wrappers/ViewWrapper.vala"
	result = self->priv->_hint;
#line 107 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3279 "ViewWrapper.c"
}

void
music_view_wrapper_set_hint (MusicViewWrapper* self,
                             MusicViewWrapperHint value)
{
	MusicViewWrapperHint old_value;
#line 107 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/Views/Wrappers/ViewWrapper.vala"
	old_value = music_view_wrapper_get_hint (self);
#line 107 "../src/Views/Wrappers/ViewWrapper.vala"
	if (old_value != value) {
#line 107 "../src/Views/Wrappers/ViewWrapper.vala"
		self->priv->_hint = value;
#line 107 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_HINT_PROPERTY]);
#line 3297 "ViewWrapper.c"
	}
}

MusicLibrary*
music_view_wrapper_get_library (MusicViewWrapper* self)
{
	MusicLibrary* result;
	MusicLibrary* _tmp0_;
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_library;
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_;
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3314 "ViewWrapper.c"
}

void
music_view_wrapper_set_library (MusicViewWrapper* self,
                                MusicLibrary* value)
{
	MusicLibrary* old_value;
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
	old_value = music_view_wrapper_get_library (self);
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
	if (old_value != value) {
#line 3328 "ViewWrapper.c"
		MusicLibrary* _tmp0_;
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (self->priv->_library);
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
		self->priv->_library = _tmp0_;
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_LIBRARY_PROPERTY]);
#line 3338 "ViewWrapper.c"
	}
}

gboolean
music_view_wrapper_get_is_current_wrapper (MusicViewWrapper* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	MusicLibraryWindow* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 111 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = music_app_get_main_window ();
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = _tmp1_;
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = music_library_window_get_initialization_finished (_tmp2_);
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = _tmp3_;
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp4_) {
#line 3363 "ViewWrapper.c"
		MusicLibraryWindow* _tmp5_;
		MusicLibraryWindow* _tmp6_;
		MusicViewStack* _tmp7_;
		MusicViewStack* _tmp8_;
		GtkWidget* _tmp9_;
		GtkWidget* _tmp10_;
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp5_ = music_app_get_main_window ();
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp6_ = _tmp5_;
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp7_ = music_library_window_get_view_stack (_tmp6_);
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp8_ = _tmp7_;
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp9_ = gtk_stack_get_visible_child ((GtkStack*) _tmp8_);
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp10_ = _tmp9_;
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = _tmp10_ == G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget);
#line 3384 "ViewWrapper.c"
	} else {
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = FALSE;
#line 3388 "ViewWrapper.c"
	}
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_;
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3394 "ViewWrapper.c"
}

MusicPlaylist*
music_view_wrapper_get_playlist (MusicViewWrapper* self)
{
	MusicPlaylist* result;
	MusicPlaylist* _tmp0_;
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_playlist;
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_;
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3410 "ViewWrapper.c"
}

void
music_view_wrapper_set_playlist (MusicViewWrapper* self,
                                 MusicPlaylist* value)
{
	MusicPlaylist* old_value;
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
	old_value = music_view_wrapper_get_playlist (self);
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
	if (old_value != value) {
#line 3424 "ViewWrapper.c"
		MusicPlaylist* _tmp0_;
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (self->priv->_playlist);
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
		self->priv->_playlist = _tmp0_;
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_PLAYLIST_PROPERTY]);
#line 3434 "ViewWrapper.c"
	}
}

gint
music_view_wrapper_get_media_count (MusicViewWrapper* self)
{
	gint result;
	MusicListView* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
#line 119 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 119 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_list_view;
#line 119 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = music_list_view_get_n_media (_tmp0_);
#line 119 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = _tmp1_;
#line 119 "../src/Views/Wrappers/ViewWrapper.vala"
	result = (gint) _tmp2_;
#line 119 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3457 "ViewWrapper.c"
}

static void
_music_view_wrapper_view_selector_changed_music_widgets_view_selector_mode_changed (MusicWidgetsViewSelector* _sender,
                                                                                    MusicWidgetsViewSelectorMode new_mode,
                                                                                    gpointer self)
{
#line 143 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_view_selector_changed ((MusicViewWrapper*) self);
#line 3467 "ViewWrapper.c"
}

static void
_music_view_wrapper_search_field_changed_music_library_search_finished (MusicLibrary* _sender,
                                                                        gpointer self)
{
#line 144 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_search_field_changed ((MusicViewWrapper*) self);
#line 3476 "ViewWrapper.c"
}

static GObject *
music_view_wrapper_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicViewWrapper * self;
	MusicViewStack* _tmp0_;
	MusicViewStack* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	MusicLibraryWindow* _tmp3_;
	MusicWidgetsViewSelector* _tmp4_;
	MusicWidgetsViewSelector* _tmp5_;
	MusicLibrary* _tmp6_;
#line 137 "../src/Views/Wrappers/ViewWrapper.vala"
	parent_class = G_OBJECT_CLASS (music_view_wrapper_parent_class);
#line 137 "../src/Views/Wrappers/ViewWrapper.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 137 "../src/Views/Wrappers/ViewWrapper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper);
#line 138 "../src/Views/Wrappers/ViewWrapper.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 140 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = music_view_stack_new ();
#line 140 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_ref_sink (_tmp0_);
#line 140 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (self->priv->view_stack);
#line 140 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv->view_stack = _tmp0_;
#line 141 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = self->priv->view_stack;
#line 141 "../src/Views/Wrappers/ViewWrapper.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
#line 143 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = music_app_get_main_window ();
#line 143 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = _tmp2_;
#line 143 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = music_library_window_get_view_selector (_tmp3_);
#line 143 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp5_ = _tmp4_;
#line 143 "../src/Views/Wrappers/ViewWrapper.vala"
	g_signal_connect_object (_tmp5_, "mode-changed", (GCallback) _music_view_wrapper_view_selector_changed_music_widgets_view_selector_mode_changed, self, 0);
#line 144 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp6_ = self->priv->_library;
#line 144 "../src/Views/Wrappers/ViewWrapper.vala"
	g_signal_connect_object (_tmp6_, "search-finished", (GCallback) _music_view_wrapper_search_field_changed_music_library_search_finished, self, 0);
#line 137 "../src/Views/Wrappers/ViewWrapper.vala"
	return obj;
#line 3530 "ViewWrapper.c"
}

static void
music_view_wrapper_class_init (MusicViewWrapperClass * klass,
                               gpointer klass_data)
{
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	music_view_wrapper_parent_class = g_type_class_peek_parent (klass);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_type_class_adjust_private_offset (klass, &MusicViewWrapper_private_offset);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	((MusicViewWrapperClass *) klass)->check_have_media = (gboolean (*) (MusicViewWrapper*)) music_view_wrapper_real_check_have_media;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	((MusicViewWrapperClass *) klass)->select_proper_content_view = (void (*) (MusicViewWrapper*)) music_view_wrapper_real_select_proper_content_view;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	((MusicViewWrapperClass *) klass)->set_no_media_alert = (void (*) (MusicViewWrapper*)) music_view_wrapper_real_set_no_media_alert;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_view_wrapper_get_property;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_view_wrapper_set_property;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	G_OBJECT_CLASS (klass)->constructor = music_view_wrapper_constructor;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	G_OBJECT_CLASS (klass)->finalize = music_view_wrapper_finalize;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_LIST_VIEW_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_LIST_VIEW_PROPERTY] = g_param_spec_object ("list-view", "list-view", "list-view", MUSIC_TYPE_LIST_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_GRID_VIEW_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_GRID_VIEW_PROPERTY] = g_param_spec_object ("grid-view", "grid-view", "grid-view", MUSIC_TYPE_ALBUMS_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY] = g_param_spec_object ("embedded-alert", "embedded-alert", "embedded-alert", GRANITE_WIDGETS_TYPE_ALERT_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY] = g_param_spec_object ("welcome-screen", "welcome-screen", "welcome-screen", GRANITE_WIDGETS_TYPE_WELCOME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_HAS_GRID_VIEW_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_HAS_GRID_VIEW_PROPERTY] = g_param_spec_boolean ("has-grid-view", "has-grid-view", "has-grid-view", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_HAS_LIST_VIEW_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_HAS_LIST_VIEW_PROPERTY] = g_param_spec_boolean ("has-list-view", "has-list-view", "has-list-view", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_HAS_EMBEDDED_ALERT_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_HAS_EMBEDDED_ALERT_PROPERTY] = g_param_spec_boolean ("has-embedded-alert", "has-embedded-alert", "has-embedded-alert", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_HAS_WELCOME_SCREEN_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_HAS_WELCOME_SCREEN_PROPERTY] = g_param_spec_boolean ("has-welcome-screen", "has-welcome-screen", "has-welcome-screen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_CURRENT_VIEW_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_CURRENT_VIEW_PROPERTY] = g_param_spec_enum ("current-view", "current-view", "current-view", MUSIC_VIEW_WRAPPER_TYPE_VIEW_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3573 "ViewWrapper.c"
	/**
	     * This is by far the most important property of this object.
	     * It defines how child widgets behave and some other properties.
	     */
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_HINT_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_HINT_PROPERTY] = g_param_spec_enum ("hint", "hint", "hint", MUSIC_VIEW_WRAPPER_TYPE_HINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_LIBRARY_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_LIBRARY_PROPERTY] = g_param_spec_object ("library", "library", "library", MUSIC_TYPE_LIBRARY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_IS_CURRENT_WRAPPER_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_IS_CURRENT_WRAPPER_PROPERTY] = g_param_spec_boolean ("is-current-wrapper", "is-current-wrapper", "is-current-wrapper", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_PLAYLIST_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_PLAYLIST_PROPERTY] = g_param_spec_object ("playlist", "playlist", "playlist", MUSIC_TYPE_PLAYLIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_MEDIA_COUNT_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_MEDIA_COUNT_PROPERTY] = g_param_spec_int ("media-count", "media-count", "media-count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3588 "ViewWrapper.c"
}

static void
music_view_wrapper_instance_init (MusicViewWrapper * self,
                                  gpointer klass)
{
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv = music_view_wrapper_get_instance_private (self);
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv->_playlist = NULL;
#line 125 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv->widgets_ready = FALSE;
#line 127 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv->last_used_view = MUSIC_VIEW_WRAPPER_VIEW_TYPE_NONE;
#line 131 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv->data_initialized = FALSE;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_rec_mutex_init (&self->priv->__lock_list_view);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_rec_mutex_init (&self->priv->__lock_grid_view);
#line 3609 "ViewWrapper.c"
}

static void
music_view_wrapper_finalize (GObject * obj)
{
	MusicViewWrapper * self;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper);
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (self->priv->_list_view);
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (self->priv->_grid_view);
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (self->priv->_embedded_alert);
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (self->priv->_welcome_screen);
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (self->priv->_library);
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (self->priv->_playlist);
#line 126 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (self->priv->view_stack);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_rec_mutex_clear (&self->priv->__lock_list_view);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_rec_mutex_clear (&self->priv->__lock_grid_view);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	G_OBJECT_CLASS (music_view_wrapper_parent_class)->finalize (obj);
#line 3638 "ViewWrapper.c"
}

static GType
music_view_wrapper_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicViewWrapperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_view_wrapper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicViewWrapper), 0, (GInstanceInitFunc) music_view_wrapper_instance_init, NULL };
	GType music_view_wrapper_type_id;
	music_view_wrapper_type_id = g_type_register_static (gtk_grid_get_type (), "MusicViewWrapper", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	MusicViewWrapper_private_offset = g_type_add_instance_private (music_view_wrapper_type_id, sizeof (MusicViewWrapperPrivate));
	return music_view_wrapper_type_id;
}

GType
music_view_wrapper_get_type (void)
{
	static volatile gsize music_view_wrapper_type_id__once = 0;
	if (g_once_init_enter (&music_view_wrapper_type_id__once)) {
		GType music_view_wrapper_type_id;
		music_view_wrapper_type_id = music_view_wrapper_get_type_once ();
		g_once_init_leave (&music_view_wrapper_type_id__once, music_view_wrapper_type_id);
	}
	return music_view_wrapper_type_id__once;
}

static void
_vala_music_view_wrapper_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	MusicViewWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	switch (property_id) {
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_LIST_VIEW_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_object (value, music_view_wrapper_get_list_view (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_GRID_VIEW_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_object (value, music_view_wrapper_get_grid_view (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_object (value, music_view_wrapper_get_embedded_alert (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_object (value, music_view_wrapper_get_welcome_screen (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_HAS_GRID_VIEW_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_boolean (value, music_view_wrapper_get_has_grid_view (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_HAS_LIST_VIEW_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_boolean (value, music_view_wrapper_get_has_list_view (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_HAS_EMBEDDED_ALERT_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_boolean (value, music_view_wrapper_get_has_embedded_alert (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_HAS_WELCOME_SCREEN_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_boolean (value, music_view_wrapper_get_has_welcome_screen (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_CURRENT_VIEW_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_enum (value, music_view_wrapper_get_current_view (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_HINT_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_enum (value, music_view_wrapper_get_hint (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_LIBRARY_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_object (value, music_view_wrapper_get_library (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_IS_CURRENT_WRAPPER_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_boolean (value, music_view_wrapper_get_is_current_wrapper (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_PLAYLIST_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_object (value, music_view_wrapper_get_playlist (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_MEDIA_COUNT_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_int (value, music_view_wrapper_get_media_count (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 3757 "ViewWrapper.c"
		default:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 3763 "ViewWrapper.c"
	}
}

static void
_vala_music_view_wrapper_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	MusicViewWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	switch (property_id) {
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_LIST_VIEW_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		music_view_wrapper_set_list_view (self, g_value_get_object (value));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_GRID_VIEW_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		music_view_wrapper_set_grid_view (self, g_value_get_object (value));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		music_view_wrapper_set_embedded_alert (self, g_value_get_object (value));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		music_view_wrapper_set_welcome_screen (self, g_value_get_object (value));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_HINT_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		music_view_wrapper_set_hint (self, g_value_get_enum (value));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_LIBRARY_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		music_view_wrapper_set_library (self, g_value_get_object (value));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_PLAYLIST_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		music_view_wrapper_set_playlist (self, g_value_get_object (value));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 3819 "ViewWrapper.c"
		default:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 3825 "ViewWrapper.c"
	}
}

