/* MediaMenu.c generated by valac 0.56.0, the Vala compiler
 * generated from MediaMenu.vala, do not modify */

/*
 * Copyright (c) 2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <granite.h>
#include <gdk/gdk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_MEDIA_MENU (music_media_menu_get_type ())
#define MUSIC_MEDIA_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_MEDIA_MENU, MusicMediaMenu))
#define MUSIC_MEDIA_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_MEDIA_MENU, MusicMediaMenuClass))
#define MUSIC_IS_MEDIA_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_MEDIA_MENU))
#define MUSIC_IS_MEDIA_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_MEDIA_MENU))
#define MUSIC_MEDIA_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_MEDIA_MENU, MusicMediaMenuClass))

typedef struct _MusicMediaMenu MusicMediaMenu;
typedef struct _MusicMediaMenuClass MusicMediaMenuClass;
typedef struct _MusicMediaMenuPrivate MusicMediaMenuPrivate;
typedef enum  {
	MUSIC_VIEW_WRAPPER_HINT_NONE,
	MUSIC_VIEW_WRAPPER_HINT_MUSIC,
	MUSIC_VIEW_WRAPPER_HINT_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_CDROM,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	MUSIC_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	MUSIC_VIEW_WRAPPER_HINT_ALBUM_LIST,
	MUSIC_VIEW_WRAPPER_HINT_QUEUE
} MusicViewWrapperHint;

#define MUSIC_VIEW_WRAPPER_TYPE_HINT (music_view_wrapper_hint_get_type ())

#define MUSIC_TYPE_GENERIC_LIST (music_generic_list_get_type ())
#define MUSIC_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_GENERIC_LIST, MusicGenericList))
#define MUSIC_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_GENERIC_LIST, MusicGenericListClass))
#define MUSIC_IS_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_GENERIC_LIST))
#define MUSIC_IS_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_GENERIC_LIST))
#define MUSIC_GENERIC_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_GENERIC_LIST, MusicGenericListClass))

typedef struct _MusicGenericList MusicGenericList;
typedef struct _MusicGenericListClass MusicGenericListClass;

#define MUSIC_TYPE_RATING_MENU_ITEM (music_rating_menu_item_get_type ())
#define MUSIC_RATING_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_RATING_MENU_ITEM, MusicRatingMenuItem))
#define MUSIC_RATING_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_RATING_MENU_ITEM, MusicRatingMenuItemClass))
#define MUSIC_IS_RATING_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_RATING_MENU_ITEM))
#define MUSIC_IS_RATING_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_RATING_MENU_ITEM))
#define MUSIC_RATING_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_RATING_MENU_ITEM, MusicRatingMenuItemClass))

typedef struct _MusicRatingMenuItem MusicRatingMenuItem;
typedef struct _MusicRatingMenuItemClass MusicRatingMenuItemClass;
enum  {
	MUSIC_MEDIA_MENU_0_PROPERTY,
	MUSIC_MEDIA_MENU_HINT_PROPERTY,
	MUSIC_MEDIA_MENU_GENERIC_LIST_PROPERTY,
	MUSIC_MEDIA_MENU_NUM_PROPERTIES
};
static GParamSpec* music_media_menu_properties[MUSIC_MEDIA_MENU_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block28Data Block28Data;

#define MUSIC_TYPE_VIEW_WRAPPER (music_view_wrapper_get_type ())
#define MUSIC_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper))
#define MUSIC_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapperClass))
#define MUSIC_IS_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_VIEW_WRAPPER))
#define MUSIC_IS_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_VIEW_WRAPPER))
#define MUSIC_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapperClass))

typedef struct _MusicViewWrapper MusicViewWrapper;
typedef struct _MusicViewWrapperClass MusicViewWrapperClass;
typedef struct _Block29Data Block29Data;
#define _g_free0(var) (var = (g_free (var), NULL))

#define MUSIC_TYPE_CONTRACT_MENU_ITEM (music_contract_menu_item_get_type ())
#define MUSIC_CONTRACT_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_CONTRACT_MENU_ITEM, MusicContractMenuItem))
#define MUSIC_CONTRACT_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_CONTRACT_MENU_ITEM, MusicContractMenuItemClass))
#define MUSIC_IS_CONTRACT_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_CONTRACT_MENU_ITEM))
#define MUSIC_IS_CONTRACT_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_CONTRACT_MENU_ITEM))
#define MUSIC_CONTRACT_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_CONTRACT_MENU_ITEM, MusicContractMenuItemClass))

typedef struct _MusicContractMenuItem MusicContractMenuItem;
typedef struct _MusicContractMenuItemClass MusicContractMenuItemClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define MUSIC_TYPE_FILE_NOT_FOUND_DIALOG (music_file_not_found_dialog_get_type ())
#define MUSIC_FILE_NOT_FOUND_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_FILE_NOT_FOUND_DIALOG, MusicFileNotFoundDialog))
#define MUSIC_FILE_NOT_FOUND_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_FILE_NOT_FOUND_DIALOG, MusicFileNotFoundDialogClass))
#define MUSIC_IS_FILE_NOT_FOUND_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_FILE_NOT_FOUND_DIALOG))
#define MUSIC_IS_FILE_NOT_FOUND_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_FILE_NOT_FOUND_DIALOG))
#define MUSIC_FILE_NOT_FOUND_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_FILE_NOT_FOUND_DIALOG, MusicFileNotFoundDialogClass))

typedef struct _MusicFileNotFoundDialog MusicFileNotFoundDialog;
typedef struct _MusicFileNotFoundDialogClass MusicFileNotFoundDialogClass;

#define MUSIC_TYPE_MEDIA_EDITOR (music_media_editor_get_type ())
#define MUSIC_MEDIA_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_MEDIA_EDITOR, MusicMediaEditor))
#define MUSIC_MEDIA_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_MEDIA_EDITOR, MusicMediaEditorClass))
#define MUSIC_IS_MEDIA_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_MEDIA_EDITOR))
#define MUSIC_IS_MEDIA_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_MEDIA_EDITOR))
#define MUSIC_MEDIA_EDITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_MEDIA_EDITOR, MusicMediaEditorClass))

typedef struct _MusicMediaEditor MusicMediaEditor;
typedef struct _MusicMediaEditorClass MusicMediaEditorClass;

#define MUSIC_TYPE_PLAYBACK_MANAGER (music_playback_manager_get_type ())
#define MUSIC_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager))
#define MUSIC_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))
#define MUSIC_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))

typedef struct _MusicPlaybackManager MusicPlaybackManager;
typedef struct _MusicPlaybackManagerClass MusicPlaybackManagerClass;
typedef struct _Block30Data Block30Data;

#define MUSIC_TYPE_REMOVE_FILES_DIALOG (music_remove_files_dialog_get_type ())
#define MUSIC_REMOVE_FILES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_REMOVE_FILES_DIALOG, MusicRemoveFilesDialog))
#define MUSIC_REMOVE_FILES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_REMOVE_FILES_DIALOG, MusicRemoveFilesDialogClass))
#define MUSIC_IS_REMOVE_FILES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_REMOVE_FILES_DIALOG))
#define MUSIC_IS_REMOVE_FILES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_REMOVE_FILES_DIALOG))
#define MUSIC_REMOVE_FILES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_REMOVE_FILES_DIALOG, MusicRemoveFilesDialogClass))

typedef struct _MusicRemoveFilesDialog MusicRemoveFilesDialog;
typedef struct _MusicRemoveFilesDialogClass MusicRemoveFilesDialogClass;

#define MUSIC_TYPE_DEVICE_VIEW_WRAPPER (music_device_view_wrapper_get_type ())
#define MUSIC_DEVICE_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper))
#define MUSIC_DEVICE_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapperClass))
#define MUSIC_IS_DEVICE_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_DEVICE_VIEW_WRAPPER))
#define MUSIC_IS_DEVICE_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_DEVICE_VIEW_WRAPPER))
#define MUSIC_DEVICE_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapperClass))

typedef struct _MusicDeviceViewWrapper MusicDeviceViewWrapper;
typedef struct _MusicDeviceViewWrapperClass MusicDeviceViewWrapperClass;
typedef struct _Block31Data Block31Data;

struct _MusicMediaMenu {
	GtkMenu parent_instance;
	MusicMediaMenuPrivate * priv;
};

struct _MusicMediaMenuClass {
	GtkMenuClass parent_class;
};

struct _MusicMediaMenuPrivate {
	MusicViewWrapperHint _hint;
	MusicGenericList* _generic_list;
	GtkMenuItem* add_to_playlist;
	GtkMenuItem* contractor_entry;
	GtkMenuItem* edit_media;
	GtkMenuItem* import_to_library;
	GtkMenuItem* queue_media;
	MusicRatingMenuItem* rate_media;
	GtkMenuItem* remove_media;
};

struct _Block28Data {
	int _ref_count_;
	MusicMediaMenu* self;
	GeeCollection* selection;
};

struct _Block29Data {
	int _ref_count_;
	Block28Data * _data28_;
	MusicStaticPlaylist* playlist;
};

struct _Block30Data {
	int _ref_count_;
	MusicMediaMenu* self;
	GeeCollection* selected_media;
};

struct _Block31Data {
	int _ref_count_;
	MusicMediaMenu* self;
	GtkMenuItem* scroll_to_current;
};

static gint MusicMediaMenu_private_offset;
static gpointer music_media_menu_parent_class = NULL;

VALA_EXTERN GType music_media_menu_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicMediaMenu, g_object_unref)
VALA_EXTERN GType music_view_wrapper_hint_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType music_generic_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicGenericList, g_object_unref)
VALA_EXTERN GType music_rating_menu_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicRatingMenuItem, g_object_unref)
VALA_EXTERN MusicMediaMenu* music_media_menu_new (MusicGenericList* generic_list);
VALA_EXTERN MusicMediaMenu* music_media_menu_construct (GType object_type,
                                            MusicGenericList* generic_list);
VALA_EXTERN MusicViewWrapperHint music_generic_list_get_hint (MusicGenericList* self);
VALA_EXTERN void music_media_menu_popup_media_menu (MusicMediaMenu* self,
                                        GeeCollection* selection);
static Block28Data* block28_data_ref (Block28Data* _data28_);
static void block28_data_unref (void * _userdata_);
static void music_media_menu_media_menu_new_playlist_clicked (MusicMediaMenu* self);
static void _music_media_menu_media_menu_new_playlist_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                               gpointer self);
VALA_EXTERN MusicGenericList* music_media_menu_get_generic_list (MusicMediaMenu* self);
VALA_EXTERN GType music_view_wrapper_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicViewWrapper, g_object_unref)
VALA_EXTERN MusicViewWrapper* music_generic_list_get_parent_wrapper (MusicGenericList* self);
VALA_EXTERN MusicLibrary* music_view_wrapper_get_library (MusicViewWrapper* self);
static Block29Data* block29_data_ref (Block29Data* _data29_);
static void block29_data_unref (void * _userdata_);
VALA_EXTERN MusicPlaylist* music_generic_list_get_playlist (MusicGenericList* self);
static void ____lambda43_ (Block29Data* _data29_);
static void _____lambda43__gtk_menu_item_activate (GtkMenuItem* _sender,
                                            gpointer self);
VALA_EXTERN void music_rating_menu_item_set_rating_value (MusicRatingMenuItem* self,
                                              gint value);
VALA_EXTERN GType music_contract_menu_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicContractMenuItem, g_object_unref)
VALA_EXTERN MusicContractMenuItem* music_contract_menu_item_new (GraniteServicesContract* contract,
                                                     GeeCollection* medias);
VALA_EXTERN MusicContractMenuItem* music_contract_menu_item_construct (GType object_type,
                                                           GraniteServicesContract* contract,
                                                           GeeCollection* medias);
static void music_media_menu_edit_media_clicked (MusicMediaMenu* self);
VALA_EXTERN GeeCollection* music_generic_list_get_selected_medias (MusicGenericList* self);
VALA_EXTERN GType music_file_not_found_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicFileNotFoundDialog, g_object_unref)
VALA_EXTERN MusicFileNotFoundDialog* music_file_not_found_dialog_new (GeeCollection* _media_list);
VALA_EXTERN MusicFileNotFoundDialog* music_file_not_found_dialog_construct (GType object_type,
                                                                GeeCollection* _media_list);
VALA_EXTERN GType music_media_editor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicMediaEditor, g_object_unref)
VALA_EXTERN MusicMediaEditor* music_media_editor_new (GeeTreeSet* given_media);
VALA_EXTERN MusicMediaEditor* music_media_editor_construct (GType object_type,
                                                GeeTreeSet* given_media);
static void music_media_menu_file_browse_clicked (MusicMediaMenu* self);
static void music_media_menu_import_to_library_clicked (MusicMediaMenu* self);
static void music_media_menu_queue_clicked (MusicMediaMenu* self);
VALA_EXTERN GType music_playback_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPlaybackManager, g_object_unref)
VALA_EXTERN MusicPlaybackManager* music_app_get_player (void);
VALA_EXTERN void music_playback_manager_queue_media (MusicPlaybackManager* self,
                                         GeeCollection* to_queue);
static void music_media_menu_rate_media_clicked (MusicMediaMenu* self);
VALA_EXTERN gint music_rating_menu_item_get_rating_value (MusicRatingMenuItem* self);
static void music_media_menu_remove_media_clicked (MusicMediaMenu* self);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
VALA_EXTERN MusicViewWrapperHint music_media_menu_get_hint (MusicMediaMenu* self);
VALA_EXTERN GType music_remove_files_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicRemoveFilesDialog, g_object_unref)
VALA_EXTERN MusicRemoveFilesDialog* music_remove_files_dialog_new (GeeCollection* to_remove);
VALA_EXTERN MusicRemoveFilesDialog* music_remove_files_dialog_construct (GType object_type,
                                                             GeeCollection* to_remove);
static void ___lambda53_ (Block30Data* _data30_,
                   gboolean delete_files);
static void ____lambda53__music_remove_files_dialog_remove_media (MusicRemoveFilesDialog* _sender,
                                                           gboolean response,
                                                           gpointer self);
VALA_EXTERN GType music_device_view_wrapper_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicDeviceViewWrapper, g_object_unref)
VALA_EXTERN void music_playback_manager_unqueue_media (MusicPlaybackManager* self,
                                           GeeCollection* to_unqueue);
static void music_media_menu_set_hint (MusicMediaMenu* self,
                                MusicViewWrapperHint value);
static void music_media_menu_set_generic_list (MusicMediaMenu* self,
                                        MusicGenericList* value);
static GObject * music_media_menu_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static Block31Data* block31_data_ref (Block31Data* _data31_);
static void block31_data_unref (void * _userdata_);
VALA_EXTERN MusicRatingMenuItem* music_rating_menu_item_new (void);
VALA_EXTERN MusicRatingMenuItem* music_rating_menu_item_construct (GType object_type);
static void _music_media_menu___lambda60_ (MusicMediaMenu* self);
VALA_EXTERN void music_generic_list_scroll_to_current_media (MusicGenericList* self,
                                                 gboolean unfilter_if_not_found);
static void __music_media_menu___lambda60__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                            gpointer self);
static void _music_media_menu___lambda61_ (Block31Data* _data31_);
static void __music_media_menu___lambda61__music_playback_manager_playback_stopped (MusicPlaybackManager* _sender,
                                                                             gint64 was_playing,
                                                                             gpointer self);
static void _music_media_menu___lambda62_ (Block31Data* _data31_);
static void __music_media_menu___lambda62__music_playback_manager_playback_started (MusicPlaybackManager* _sender,
                                                                             gpointer self);
static void _music_media_menu_edit_media_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                  gpointer self);
static void _music_media_menu_file_browse_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _music_media_menu_import_to_library_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                         gpointer self);
static void _music_media_menu_queue_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                             gpointer self);
static void _music_media_menu_rate_media_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                  gpointer self);
static void _music_media_menu_remove_media_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                    gpointer self);
static void music_media_menu_finalize (GObject * obj);
static GType music_media_menu_get_type_once (void);
static void _vala_music_media_menu_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_music_media_menu_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
music_media_menu_get_instance_private (MusicMediaMenu* self)
{
	return G_STRUCT_MEMBER_P (self, MusicMediaMenu_private_offset);
}

MusicMediaMenu*
music_media_menu_construct (GType object_type,
                            MusicGenericList* generic_list)
{
	MusicMediaMenu * self = NULL;
	MusicViewWrapperHint _tmp0_;
	MusicViewWrapperHint _tmp1_;
#line 38 "../src/Widgets/MediaMenu.vala"
	g_return_val_if_fail (generic_list != NULL, NULL);
#line 39 "../src/Widgets/MediaMenu.vala"
	_tmp0_ = music_generic_list_get_hint (generic_list);
#line 39 "../src/Widgets/MediaMenu.vala"
	_tmp1_ = _tmp0_;
#line 39 "../src/Widgets/MediaMenu.vala"
	self = (MusicMediaMenu*) g_object_new (object_type, "generic-list", generic_list, "hint", _tmp1_, NULL);
#line 38 "../src/Widgets/MediaMenu.vala"
	return self;
#line 385 "MediaMenu.c"
}

MusicMediaMenu*
music_media_menu_new (MusicGenericList* generic_list)
{
#line 38 "../src/Widgets/MediaMenu.vala"
	return music_media_menu_construct (MUSIC_TYPE_MEDIA_MENU, generic_list);
#line 393 "MediaMenu.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 152 "../src/Widgets/MediaMenu.vala"
	return self ? g_object_ref (self) : NULL;
#line 401 "MediaMenu.c"
}

static Block28Data*
block28_data_ref (Block28Data* _data28_)
{
#line 152 "../src/Widgets/MediaMenu.vala"
	g_atomic_int_inc (&_data28_->_ref_count_);
#line 152 "../src/Widgets/MediaMenu.vala"
	return _data28_;
#line 411 "MediaMenu.c"
}

static void
block28_data_unref (void * _userdata_)
{
	Block28Data* _data28_;
	_data28_ = (Block28Data*) _userdata_;
#line 152 "../src/Widgets/MediaMenu.vala"
	if (g_atomic_int_dec_and_test (&_data28_->_ref_count_)) {
#line 421 "MediaMenu.c"
		MusicMediaMenu* self;
#line 152 "../src/Widgets/MediaMenu.vala"
		self = _data28_->self;
#line 152 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (_data28_->selection);
#line 152 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (self);
#line 152 "../src/Widgets/MediaMenu.vala"
		g_slice_free (Block28Data, _data28_);
#line 431 "MediaMenu.c"
	}
}

static void
_music_media_menu_media_menu_new_playlist_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                          gpointer self)
{
#line 154 "../src/Widgets/MediaMenu.vala"
	music_media_menu_media_menu_new_playlist_clicked ((MusicMediaMenu*) self);
#line 441 "MediaMenu.c"
}

static Block29Data*
block29_data_ref (Block29Data* _data29_)
{
#line 161 "../src/Widgets/MediaMenu.vala"
	g_atomic_int_inc (&_data29_->_ref_count_);
#line 161 "../src/Widgets/MediaMenu.vala"
	return _data29_;
#line 451 "MediaMenu.c"
}

static void
block29_data_unref (void * _userdata_)
{
	Block29Data* _data29_;
	_data29_ = (Block29Data*) _userdata_;
#line 161 "../src/Widgets/MediaMenu.vala"
	if (g_atomic_int_dec_and_test (&_data29_->_ref_count_)) {
#line 461 "MediaMenu.c"
		MusicMediaMenu* self;
#line 161 "../src/Widgets/MediaMenu.vala"
		self = _data29_->_data28_->self;
#line 161 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (_data29_->playlist);
#line 161 "../src/Widgets/MediaMenu.vala"
		block28_data_unref (_data29_->_data28_);
#line 161 "../src/Widgets/MediaMenu.vala"
		_data29_->_data28_ = NULL;
#line 161 "../src/Widgets/MediaMenu.vala"
		g_slice_free (Block29Data, _data29_);
#line 473 "MediaMenu.c"
	}
}

static void
____lambda43_ (Block29Data* _data29_)
{
	Block28Data* _data28_;
	MusicMediaMenu* self;
	MusicStaticPlaylist* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
#line 170 "../src/Widgets/MediaMenu.vala"
	_data28_ = _data29_->_data28_;
#line 170 "../src/Widgets/MediaMenu.vala"
	self = _data28_->self;
#line 171 "../src/Widgets/MediaMenu.vala"
	_tmp0_ = _data29_->playlist;
#line 171 "../src/Widgets/MediaMenu.vala"
	_tmp1_ = gee_collection_get_read_only_view (_data28_->selection);
#line 171 "../src/Widgets/MediaMenu.vala"
	_tmp2_ = _tmp1_;
#line 171 "../src/Widgets/MediaMenu.vala"
	_tmp3_ = _tmp2_;
#line 171 "../src/Widgets/MediaMenu.vala"
	music_playlist_add_medias ((MusicPlaylist*) _tmp0_, _tmp3_);
#line 171 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (_tmp3_);
#line 502 "MediaMenu.c"
}

static void
_____lambda43__gtk_menu_item_activate (GtkMenuItem* _sender,
                                       gpointer self)
{
#line 170 "../src/Widgets/MediaMenu.vala"
	____lambda43_ (self);
#line 511 "MediaMenu.c"
}

void
music_media_menu_popup_media_menu (MusicMediaMenu* self,
                                   GeeCollection* selection)
{
	Block28Data* _data28_;
	GeeCollection* _tmp0_;
	GtkMenuItem* media_menu_new_playlist = NULL;
	GtkMenuItem* _tmp1_;
	GtkMenuItem* _tmp2_;
	GtkMenu* add_to_playlist_menu = NULL;
	GtkMenu* _tmp3_;
	GtkMenu* _tmp4_;
	GtkMenuItem* _tmp5_;
	GtkMenuItem* _tmp6_;
	MusicGenericList* _tmp7_;
	MusicViewWrapper* _tmp8_;
	MusicViewWrapper* _tmp9_;
	MusicLibrary* _tmp10_;
	MusicLibrary* _tmp11_;
	GtkMenu* _tmp39_;
	GtkMenuItem* _tmp40_;
	GtkMenu* _tmp41_;
	gint temporary_count = 0;
	gint total_count = 0;
	gint set_rating = 0;
	MusicRatingMenuItem* _tmp69_;
	GtkMenu* contractor_sub_menu = NULL;
	GtkMenu* _tmp70_;
	GtkMenuItem* _tmp71_;
	GtkMenu* _tmp72_;
	GError* _inner_error0_ = NULL;
#line 152 "../src/Widgets/MediaMenu.vala"
	g_return_if_fail (self != NULL);
#line 152 "../src/Widgets/MediaMenu.vala"
	g_return_if_fail (selection != NULL);
#line 152 "../src/Widgets/MediaMenu.vala"
	_data28_ = g_slice_new0 (Block28Data);
#line 152 "../src/Widgets/MediaMenu.vala"
	_data28_->_ref_count_ = 1;
#line 152 "../src/Widgets/MediaMenu.vala"
	_data28_->self = g_object_ref (self);
#line 152 "../src/Widgets/MediaMenu.vala"
	_tmp0_ = _g_object_ref0 (selection);
#line 152 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (_data28_->selection);
#line 152 "../src/Widgets/MediaMenu.vala"
	_data28_->selection = _tmp0_;
#line 153 "../src/Widgets/MediaMenu.vala"
	_tmp1_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Playlist…"));
#line 153 "../src/Widgets/MediaMenu.vala"
	g_object_ref_sink (_tmp1_);
#line 153 "../src/Widgets/MediaMenu.vala"
	media_menu_new_playlist = _tmp1_;
#line 154 "../src/Widgets/MediaMenu.vala"
	_tmp2_ = media_menu_new_playlist;
#line 154 "../src/Widgets/MediaMenu.vala"
	g_signal_connect_object (_tmp2_, "activate", (GCallback) _music_media_menu_media_menu_new_playlist_clicked_gtk_menu_item_activate, self, 0);
#line 156 "../src/Widgets/MediaMenu.vala"
	_tmp3_ = (GtkMenu*) gtk_menu_new ();
#line 156 "../src/Widgets/MediaMenu.vala"
	g_object_ref_sink (_tmp3_);
#line 156 "../src/Widgets/MediaMenu.vala"
	add_to_playlist_menu = _tmp3_;
#line 157 "../src/Widgets/MediaMenu.vala"
	_tmp4_ = add_to_playlist_menu;
#line 157 "../src/Widgets/MediaMenu.vala"
	_tmp5_ = media_menu_new_playlist;
#line 157 "../src/Widgets/MediaMenu.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp4_, _tmp5_);
#line 159 "../src/Widgets/MediaMenu.vala"
	_tmp6_ = media_menu_new_playlist;
#line 159 "../src/Widgets/MediaMenu.vala"
	_tmp7_ = self->priv->_generic_list;
#line 159 "../src/Widgets/MediaMenu.vala"
	_tmp8_ = music_generic_list_get_parent_wrapper (_tmp7_);
#line 159 "../src/Widgets/MediaMenu.vala"
	_tmp9_ = _tmp8_;
#line 159 "../src/Widgets/MediaMenu.vala"
	_tmp10_ = music_view_wrapper_get_library (_tmp9_);
#line 159 "../src/Widgets/MediaMenu.vala"
	_tmp11_ = _tmp10_;
#line 159 "../src/Widgets/MediaMenu.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, music_library_support_playlists (_tmp11_));
#line 597 "MediaMenu.c"
	{
		GeeIterator* _playlist_it = NULL;
		MusicGenericList* _tmp12_;
		MusicViewWrapper* _tmp13_;
		MusicViewWrapper* _tmp14_;
		MusicLibrary* _tmp15_;
		MusicLibrary* _tmp16_;
		GeeCollection* _tmp17_;
		GeeCollection* _tmp18_;
		GeeIterator* _tmp19_;
		GeeIterator* _tmp20_;
#line 161 "../src/Widgets/MediaMenu.vala"
		_tmp12_ = self->priv->_generic_list;
#line 161 "../src/Widgets/MediaMenu.vala"
		_tmp13_ = music_generic_list_get_parent_wrapper (_tmp12_);
#line 161 "../src/Widgets/MediaMenu.vala"
		_tmp14_ = _tmp13_;
#line 161 "../src/Widgets/MediaMenu.vala"
		_tmp15_ = music_view_wrapper_get_library (_tmp14_);
#line 161 "../src/Widgets/MediaMenu.vala"
		_tmp16_ = _tmp15_;
#line 161 "../src/Widgets/MediaMenu.vala"
		_tmp17_ = music_library_get_playlists (_tmp16_);
#line 161 "../src/Widgets/MediaMenu.vala"
		_tmp18_ = _tmp17_;
#line 161 "../src/Widgets/MediaMenu.vala"
		_tmp19_ = gee_iterable_iterator ((GeeIterable*) _tmp18_);
#line 161 "../src/Widgets/MediaMenu.vala"
		_tmp20_ = _tmp19_;
#line 161 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (_tmp18_);
#line 161 "../src/Widgets/MediaMenu.vala"
		_playlist_it = _tmp20_;
#line 161 "../src/Widgets/MediaMenu.vala"
		while (TRUE) {
#line 633 "MediaMenu.c"
			Block29Data* _data29_;
			GeeIterator* _tmp21_;
			GeeIterator* _tmp22_;
			gpointer _tmp23_;
			gboolean _tmp24_ = FALSE;
			MusicStaticPlaylist* _tmp25_;
			MusicGenericList* _tmp26_;
			MusicPlaylist* _tmp27_;
			MusicPlaylist* _tmp28_;
			GtkMenuItem* playlist_item = NULL;
			MusicStaticPlaylist* _tmp32_;
			const gchar* _tmp33_;
			const gchar* _tmp34_;
			GtkMenuItem* _tmp35_;
			GtkMenu* _tmp36_;
			GtkMenuItem* _tmp37_;
			GtkMenuItem* _tmp38_;
#line 161 "../src/Widgets/MediaMenu.vala"
			_data29_ = g_slice_new0 (Block29Data);
#line 161 "../src/Widgets/MediaMenu.vala"
			_data29_->_ref_count_ = 1;
#line 161 "../src/Widgets/MediaMenu.vala"
			_data29_->_data28_ = block28_data_ref (_data28_);
#line 161 "../src/Widgets/MediaMenu.vala"
			_tmp21_ = _playlist_it;
#line 161 "../src/Widgets/MediaMenu.vala"
			if (!gee_iterator_next (_tmp21_)) {
#line 161 "../src/Widgets/MediaMenu.vala"
				block29_data_unref (_data29_);
#line 161 "../src/Widgets/MediaMenu.vala"
				_data29_ = NULL;
#line 161 "../src/Widgets/MediaMenu.vala"
				break;
#line 667 "MediaMenu.c"
			}
#line 161 "../src/Widgets/MediaMenu.vala"
			_tmp22_ = _playlist_it;
#line 161 "../src/Widgets/MediaMenu.vala"
			_tmp23_ = gee_iterator_get (_tmp22_);
#line 161 "../src/Widgets/MediaMenu.vala"
			_data29_->playlist = (MusicStaticPlaylist*) _tmp23_;
#line 163 "../src/Widgets/MediaMenu.vala"
			_tmp25_ = _data29_->playlist;
#line 163 "../src/Widgets/MediaMenu.vala"
			_tmp26_ = self->priv->_generic_list;
#line 163 "../src/Widgets/MediaMenu.vala"
			_tmp27_ = music_generic_list_get_playlist (_tmp26_);
#line 163 "../src/Widgets/MediaMenu.vala"
			_tmp28_ = _tmp27_;
#line 163 "../src/Widgets/MediaMenu.vala"
			if (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, MUSIC_TYPE_PLAYLIST, MusicPlaylist) == _tmp28_) {
#line 163 "../src/Widgets/MediaMenu.vala"
				_tmp24_ = TRUE;
#line 687 "MediaMenu.c"
			} else {
				MusicStaticPlaylist* _tmp29_;
				gboolean _tmp30_;
				gboolean _tmp31_;
#line 163 "../src/Widgets/MediaMenu.vala"
				_tmp29_ = _data29_->playlist;
#line 163 "../src/Widgets/MediaMenu.vala"
				_tmp30_ = music_static_playlist_get_read_only (_tmp29_);
#line 163 "../src/Widgets/MediaMenu.vala"
				_tmp31_ = _tmp30_;
#line 163 "../src/Widgets/MediaMenu.vala"
				_tmp24_ = _tmp31_ == TRUE;
#line 700 "MediaMenu.c"
			}
#line 163 "../src/Widgets/MediaMenu.vala"
			if (_tmp24_) {
#line 164 "../src/Widgets/MediaMenu.vala"
				block29_data_unref (_data29_);
#line 164 "../src/Widgets/MediaMenu.vala"
				_data29_ = NULL;
#line 164 "../src/Widgets/MediaMenu.vala"
				continue;
#line 710 "MediaMenu.c"
			}
#line 167 "../src/Widgets/MediaMenu.vala"
			_tmp32_ = _data29_->playlist;
#line 167 "../src/Widgets/MediaMenu.vala"
			_tmp33_ = music_playlist_get_name ((MusicPlaylist*) _tmp32_);
#line 167 "../src/Widgets/MediaMenu.vala"
			_tmp34_ = _tmp33_;
#line 167 "../src/Widgets/MediaMenu.vala"
			_tmp35_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp34_);
#line 167 "../src/Widgets/MediaMenu.vala"
			g_object_ref_sink (_tmp35_);
#line 167 "../src/Widgets/MediaMenu.vala"
			playlist_item = _tmp35_;
#line 168 "../src/Widgets/MediaMenu.vala"
			_tmp36_ = add_to_playlist_menu;
#line 168 "../src/Widgets/MediaMenu.vala"
			_tmp37_ = playlist_item;
#line 168 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) _tmp36_, _tmp37_);
#line 170 "../src/Widgets/MediaMenu.vala"
			_tmp38_ = playlist_item;
#line 170 "../src/Widgets/MediaMenu.vala"
			g_signal_connect_data (_tmp38_, "activate", (GCallback) _____lambda43__gtk_menu_item_activate, block29_data_ref (_data29_), (GClosureNotify) block29_data_unref, 0);
#line 161 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (playlist_item);
#line 161 "../src/Widgets/MediaMenu.vala"
			block29_data_unref (_data29_);
#line 161 "../src/Widgets/MediaMenu.vala"
			_data29_ = NULL;
#line 740 "MediaMenu.c"
		}
#line 161 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (_playlist_it);
#line 744 "MediaMenu.c"
	}
#line 174 "../src/Widgets/MediaMenu.vala"
	_tmp39_ = add_to_playlist_menu;
#line 174 "../src/Widgets/MediaMenu.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp39_);
#line 175 "../src/Widgets/MediaMenu.vala"
	_tmp40_ = self->priv->add_to_playlist;
#line 175 "../src/Widgets/MediaMenu.vala"
	_tmp41_ = add_to_playlist_menu;
#line 175 "../src/Widgets/MediaMenu.vala"
	gtk_menu_item_set_submenu (_tmp40_, _tmp41_);
#line 179 "../src/Widgets/MediaMenu.vala"
	temporary_count = 0;
#line 180 "../src/Widgets/MediaMenu.vala"
	total_count = 0;
#line 760 "MediaMenu.c"
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp42_;
#line 181 "../src/Widgets/MediaMenu.vala"
		_tmp42_ = gee_iterable_iterator ((GeeIterable*) _data28_->selection);
#line 181 "../src/Widgets/MediaMenu.vala"
		_m_it = _tmp42_;
#line 181 "../src/Widgets/MediaMenu.vala"
		while (TRUE) {
#line 770 "MediaMenu.c"
			GeeIterator* _tmp43_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp44_;
			gpointer _tmp45_;
			MusicMedia* _tmp46_;
			gboolean _tmp47_;
			gboolean _tmp48_;
			gint _tmp50_;
#line 181 "../src/Widgets/MediaMenu.vala"
			_tmp43_ = _m_it;
#line 181 "../src/Widgets/MediaMenu.vala"
			if (!gee_iterator_next (_tmp43_)) {
#line 181 "../src/Widgets/MediaMenu.vala"
				break;
#line 785 "MediaMenu.c"
			}
#line 181 "../src/Widgets/MediaMenu.vala"
			_tmp44_ = _m_it;
#line 181 "../src/Widgets/MediaMenu.vala"
			_tmp45_ = gee_iterator_get (_tmp44_);
#line 181 "../src/Widgets/MediaMenu.vala"
			m = (MusicMedia*) _tmp45_;
#line 182 "../src/Widgets/MediaMenu.vala"
			_tmp46_ = m;
#line 182 "../src/Widgets/MediaMenu.vala"
			_tmp47_ = music_media_get_is_temporary (_tmp46_);
#line 182 "../src/Widgets/MediaMenu.vala"
			_tmp48_ = _tmp47_;
#line 182 "../src/Widgets/MediaMenu.vala"
			if (_tmp48_) {
#line 801 "MediaMenu.c"
				gint _tmp49_;
#line 183 "../src/Widgets/MediaMenu.vala"
				_tmp49_ = temporary_count;
#line 183 "../src/Widgets/MediaMenu.vala"
				temporary_count = _tmp49_ + 1;
#line 807 "MediaMenu.c"
			}
#line 185 "../src/Widgets/MediaMenu.vala"
			_tmp50_ = total_count;
#line 185 "../src/Widgets/MediaMenu.vala"
			total_count = _tmp50_ + 1;
#line 181 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (m);
#line 815 "MediaMenu.c"
		}
#line 181 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (_m_it);
#line 819 "MediaMenu.c"
	}
#line 188 "../src/Widgets/MediaMenu.vala"
	if (temporary_count < 1) {
#line 823 "MediaMenu.c"
		GtkMenuItem* _tmp51_;
#line 189 "../src/Widgets/MediaMenu.vala"
		_tmp51_ = self->priv->import_to_library;
#line 189 "../src/Widgets/MediaMenu.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp51_, FALSE);
#line 829 "MediaMenu.c"
	} else {
		GtkMenuItem* _tmp52_;
#line 191 "../src/Widgets/MediaMenu.vala"
		_tmp52_ = self->priv->import_to_library;
#line 191 "../src/Widgets/MediaMenu.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp52_, TRUE);
#line 192 "../src/Widgets/MediaMenu.vala"
		if (temporary_count != total_count) {
#line 838 "MediaMenu.c"
			GtkMenuItem* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
#line 193 "../src/Widgets/MediaMenu.vala"
			_tmp53_ = self->priv->import_to_library;
#line 193 "../src/Widgets/MediaMenu.vala"
			_tmp54_ = g_strdup_printf (_ ("Import %i of %i selected songs"), (gint) temporary_count, (gint) total_count);
#line 193 "../src/Widgets/MediaMenu.vala"
			_tmp55_ = _tmp54_;
#line 193 "../src/Widgets/MediaMenu.vala"
			gtk_menu_item_set_label (_tmp53_, _tmp55_);
#line 193 "../src/Widgets/MediaMenu.vala"
			_g_free0 (_tmp55_);
#line 852 "MediaMenu.c"
		} else {
			GtkMenuItem* _tmp56_;
			gchar* _tmp57_;
			gchar* _tmp58_;
#line 195 "../src/Widgets/MediaMenu.vala"
			_tmp56_ = self->priv->import_to_library;
#line 195 "../src/Widgets/MediaMenu.vala"
			_tmp57_ = g_strdup_printf (ngettext ("Import %i song", "Import %i songs", (gulong) temporary_count), (gint) temporary_count);
#line 195 "../src/Widgets/MediaMenu.vala"
			_tmp58_ = _tmp57_;
#line 195 "../src/Widgets/MediaMenu.vala"
			gtk_menu_item_set_label (_tmp56_, _tmp58_);
#line 195 "../src/Widgets/MediaMenu.vala"
			_g_free0 (_tmp58_);
#line 867 "MediaMenu.c"
		}
	}
#line 199 "../src/Widgets/MediaMenu.vala"
	set_rating = -1;
#line 872 "MediaMenu.c"
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp59_;
#line 200 "../src/Widgets/MediaMenu.vala"
		_tmp59_ = gee_iterable_iterator ((GeeIterable*) _data28_->selection);
#line 200 "../src/Widgets/MediaMenu.vala"
		_m_it = _tmp59_;
#line 200 "../src/Widgets/MediaMenu.vala"
		while (TRUE) {
#line 882 "MediaMenu.c"
			GeeIterator* _tmp60_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp61_;
			gpointer _tmp62_;
#line 200 "../src/Widgets/MediaMenu.vala"
			_tmp60_ = _m_it;
#line 200 "../src/Widgets/MediaMenu.vala"
			if (!gee_iterator_next (_tmp60_)) {
#line 200 "../src/Widgets/MediaMenu.vala"
				break;
#line 893 "MediaMenu.c"
			}
#line 200 "../src/Widgets/MediaMenu.vala"
			_tmp61_ = _m_it;
#line 200 "../src/Widgets/MediaMenu.vala"
			_tmp62_ = gee_iterator_get (_tmp61_);
#line 200 "../src/Widgets/MediaMenu.vala"
			m = (MusicMedia*) _tmp62_;
#line 201 "../src/Widgets/MediaMenu.vala"
			if (set_rating == -1) {
#line 903 "MediaMenu.c"
				MusicMedia* _tmp63_;
				guint _tmp64_;
				guint _tmp65_;
#line 202 "../src/Widgets/MediaMenu.vala"
				_tmp63_ = m;
#line 202 "../src/Widgets/MediaMenu.vala"
				_tmp64_ = music_media_get_rating (_tmp63_);
#line 202 "../src/Widgets/MediaMenu.vala"
				_tmp65_ = _tmp64_;
#line 202 "../src/Widgets/MediaMenu.vala"
				set_rating = (gint) _tmp65_;
#line 915 "MediaMenu.c"
			} else {
				MusicMedia* _tmp66_;
				guint _tmp67_;
				guint _tmp68_;
#line 203 "../src/Widgets/MediaMenu.vala"
				_tmp66_ = m;
#line 203 "../src/Widgets/MediaMenu.vala"
				_tmp67_ = music_media_get_rating (_tmp66_);
#line 203 "../src/Widgets/MediaMenu.vala"
				_tmp68_ = _tmp67_;
#line 203 "../src/Widgets/MediaMenu.vala"
				if (((guint) set_rating) != _tmp68_) {
#line 204 "../src/Widgets/MediaMenu.vala"
					set_rating = 0;
#line 205 "../src/Widgets/MediaMenu.vala"
					_g_object_unref0 (m);
#line 205 "../src/Widgets/MediaMenu.vala"
					break;
#line 934 "MediaMenu.c"
				}
			}
#line 200 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (m);
#line 939 "MediaMenu.c"
		}
#line 200 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (_m_it);
#line 943 "MediaMenu.c"
	}
#line 209 "../src/Widgets/MediaMenu.vala"
	_tmp69_ = self->priv->rate_media;
#line 209 "../src/Widgets/MediaMenu.vala"
	music_rating_menu_item_set_rating_value (_tmp69_, set_rating);
#line 212 "../src/Widgets/MediaMenu.vala"
	_tmp70_ = (GtkMenu*) gtk_menu_new ();
#line 212 "../src/Widgets/MediaMenu.vala"
	g_object_ref_sink (_tmp70_);
#line 212 "../src/Widgets/MediaMenu.vala"
	contractor_sub_menu = _tmp70_;
#line 213 "../src/Widgets/MediaMenu.vala"
	_tmp71_ = self->priv->contractor_entry;
#line 213 "../src/Widgets/MediaMenu.vala"
	_tmp72_ = contractor_sub_menu;
#line 213 "../src/Widgets/MediaMenu.vala"
	gtk_menu_item_set_submenu (_tmp71_, _tmp72_);
#line 961 "MediaMenu.c"
	{
		GeeHashSet* files = NULL;
		GeeHashSet* _tmp73_;
		gint _tmp74_;
		gint _tmp75_;
		GeeList* contracts = NULL;
		GeeHashSet* _tmp104_;
		gint _tmp105_ = 0;
		gpointer* _tmp106_;
		GFile** _tmp107_;
		gint _tmp107__length1;
		GeeList* _tmp108_;
		GeeList* _tmp109_;
		GtkMenuItem* _tmp122_;
		GtkMenu* _tmp123_;
		GList* _tmp124_;
		GList* _tmp125_;
		GtkMenu* _tmp126_;
#line 216 "../src/Widgets/MediaMenu.vala"
		_tmp73_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 216 "../src/Widgets/MediaMenu.vala"
		files = _tmp73_;
#line 217 "../src/Widgets/MediaMenu.vala"
		_tmp74_ = gee_collection_get_size (_data28_->selection);
#line 217 "../src/Widgets/MediaMenu.vala"
		_tmp75_ = _tmp74_;
#line 217 "../src/Widgets/MediaMenu.vala"
		g_debug ("MediaMenu.vala:217: Number of selected medias obtained by MusicListVie" \
"w class: %u\n", (guint) _tmp75_);
#line 990 "MediaMenu.c"
		{
			GeeIterator* _media_it = NULL;
			GeeIterator* _tmp76_;
#line 218 "../src/Widgets/MediaMenu.vala"
			_tmp76_ = gee_iterable_iterator ((GeeIterable*) _data28_->selection);
#line 218 "../src/Widgets/MediaMenu.vala"
			_media_it = _tmp76_;
#line 218 "../src/Widgets/MediaMenu.vala"
			while (TRUE) {
#line 1000 "MediaMenu.c"
				GeeIterator* _tmp77_;
				MusicMedia* media = NULL;
				GeeIterator* _tmp78_;
				gpointer _tmp79_;
				MusicMedia* _tmp80_;
				GFile* _tmp81_;
				GFile* _tmp82_;
#line 218 "../src/Widgets/MediaMenu.vala"
				_tmp77_ = _media_it;
#line 218 "../src/Widgets/MediaMenu.vala"
				if (!gee_iterator_next (_tmp77_)) {
#line 218 "../src/Widgets/MediaMenu.vala"
					break;
#line 1014 "MediaMenu.c"
				}
#line 218 "../src/Widgets/MediaMenu.vala"
				_tmp78_ = _media_it;
#line 218 "../src/Widgets/MediaMenu.vala"
				_tmp79_ = gee_iterator_get (_tmp78_);
#line 218 "../src/Widgets/MediaMenu.vala"
				media = (MusicMedia*) _tmp79_;
#line 219 "../src/Widgets/MediaMenu.vala"
				_tmp80_ = media;
#line 219 "../src/Widgets/MediaMenu.vala"
				_tmp81_ = music_media_get_file (_tmp80_);
#line 219 "../src/Widgets/MediaMenu.vala"
				_tmp82_ = _tmp81_;
#line 219 "../src/Widgets/MediaMenu.vala"
				if (g_file_query_exists (_tmp82_, NULL)) {
#line 1030 "MediaMenu.c"
					GeeHashSet* _tmp83_;
					MusicMedia* _tmp84_;
					GFile* _tmp85_;
					GFile* _tmp86_;
					gboolean _tmp87_ = FALSE;
					MusicMedia* _tmp88_;
					gboolean _tmp89_;
					gboolean _tmp90_;
#line 220 "../src/Widgets/MediaMenu.vala"
					_tmp83_ = files;
#line 220 "../src/Widgets/MediaMenu.vala"
					_tmp84_ = media;
#line 220 "../src/Widgets/MediaMenu.vala"
					_tmp85_ = music_media_get_file (_tmp84_);
#line 220 "../src/Widgets/MediaMenu.vala"
					_tmp86_ = _tmp85_;
#line 220 "../src/Widgets/MediaMenu.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp83_, _tmp86_);
#line 222 "../src/Widgets/MediaMenu.vala"
					_tmp88_ = media;
#line 222 "../src/Widgets/MediaMenu.vala"
					_tmp89_ = music_media_get_location_unknown (_tmp88_);
#line 222 "../src/Widgets/MediaMenu.vala"
					_tmp90_ = _tmp89_;
#line 222 "../src/Widgets/MediaMenu.vala"
					if (_tmp90_) {
#line 1057 "MediaMenu.c"
						MusicMedia* _tmp91_;
						GIcon* _tmp92_;
						GIcon* _tmp93_;
#line 222 "../src/Widgets/MediaMenu.vala"
						_tmp91_ = media;
#line 222 "../src/Widgets/MediaMenu.vala"
						_tmp92_ = music_media_get_unique_status_image (_tmp91_);
#line 222 "../src/Widgets/MediaMenu.vala"
						_tmp93_ = _tmp92_;
#line 222 "../src/Widgets/MediaMenu.vala"
						_tmp87_ = _tmp93_ != NULL;
#line 1069 "MediaMenu.c"
					} else {
#line 222 "../src/Widgets/MediaMenu.vala"
						_tmp87_ = FALSE;
#line 1073 "MediaMenu.c"
					}
#line 222 "../src/Widgets/MediaMenu.vala"
					if (_tmp87_) {
#line 1077 "MediaMenu.c"
						MusicMedia* _tmp94_;
						MusicMedia* _tmp95_;
#line 223 "../src/Widgets/MediaMenu.vala"
						_tmp94_ = media;
#line 223 "../src/Widgets/MediaMenu.vala"
						music_media_set_unique_status_image (_tmp94_, NULL);
#line 224 "../src/Widgets/MediaMenu.vala"
						_tmp95_ = media;
#line 224 "../src/Widgets/MediaMenu.vala"
						music_media_set_location_unknown (_tmp95_, FALSE);
#line 1088 "MediaMenu.c"
					}
				} else {
					MusicMedia* _tmp96_;
					gchar* _tmp97_;
					gchar* _tmp98_;
					gchar* _tmp99_;
					MusicMedia* _tmp100_;
					GThemedIcon* _tmp101_;
					GThemedIcon* _tmp102_;
					MusicMedia* _tmp103_;
#line 227 "../src/Widgets/MediaMenu.vala"
					_tmp96_ = media;
#line 227 "../src/Widgets/MediaMenu.vala"
					_tmp97_ = music_media_get_uri (_tmp96_);
#line 227 "../src/Widgets/MediaMenu.vala"
					_tmp98_ = _tmp97_;
#line 227 "../src/Widgets/MediaMenu.vala"
					_tmp99_ = _tmp98_;
#line 227 "../src/Widgets/MediaMenu.vala"
					g_warning ("MediaMenu.vala:227: File %s does not exist, ignoring it", _tmp99_);
#line 227 "../src/Widgets/MediaMenu.vala"
					_g_free0 (_tmp99_);
#line 229 "../src/Widgets/MediaMenu.vala"
					_tmp100_ = media;
#line 229 "../src/Widgets/MediaMenu.vala"
					_tmp101_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
#line 229 "../src/Widgets/MediaMenu.vala"
					_tmp102_ = _tmp101_;
#line 229 "../src/Widgets/MediaMenu.vala"
					music_media_set_unique_status_image (_tmp100_, (GIcon*) _tmp102_);
#line 229 "../src/Widgets/MediaMenu.vala"
					_g_object_unref0 (_tmp102_);
#line 230 "../src/Widgets/MediaMenu.vala"
					_tmp103_ = media;
#line 230 "../src/Widgets/MediaMenu.vala"
					music_media_set_location_unknown (_tmp103_, TRUE);
#line 1125 "MediaMenu.c"
				}
#line 218 "../src/Widgets/MediaMenu.vala"
				_g_object_unref0 (media);
#line 1129 "MediaMenu.c"
			}
#line 218 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (_media_it);
#line 1133 "MediaMenu.c"
		}
#line 234 "../src/Widgets/MediaMenu.vala"
		_tmp104_ = files;
#line 234 "../src/Widgets/MediaMenu.vala"
		_tmp106_ = gee_collection_to_array ((GeeCollection*) _tmp104_, &_tmp105_);
#line 234 "../src/Widgets/MediaMenu.vala"
		_tmp107_ = _tmp106_;
#line 234 "../src/Widgets/MediaMenu.vala"
		_tmp107__length1 = _tmp105_;
#line 234 "../src/Widgets/MediaMenu.vala"
		_tmp108_ = granite_services_contractor_proxy_get_contracts_for_files (_tmp107_, (gint) _tmp105_, &_inner_error0_);
#line 234 "../src/Widgets/MediaMenu.vala"
		_tmp109_ = _tmp108_;
#line 234 "../src/Widgets/MediaMenu.vala"
		_tmp107_ = (_vala_array_free (_tmp107_, _tmp107__length1, (GDestroyNotify) g_object_unref), NULL);
#line 234 "../src/Widgets/MediaMenu.vala"
		contracts = _tmp109_;
#line 234 "../src/Widgets/MediaMenu.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 234 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (files);
#line 1155 "MediaMenu.c"
			goto __catch0_g_error;
		}
		{
			GeeList* _contract_list = NULL;
			GeeList* _tmp110_;
			gint _contract_size = 0;
			GeeList* _tmp111_;
			gint _tmp112_;
			gint _tmp113_;
			gint _contract_index = 0;
#line 235 "../src/Widgets/MediaMenu.vala"
			_tmp110_ = contracts;
#line 235 "../src/Widgets/MediaMenu.vala"
			_contract_list = _tmp110_;
#line 235 "../src/Widgets/MediaMenu.vala"
			_tmp111_ = _contract_list;
#line 235 "../src/Widgets/MediaMenu.vala"
			_tmp112_ = gee_collection_get_size ((GeeCollection*) _tmp111_);
#line 235 "../src/Widgets/MediaMenu.vala"
			_tmp113_ = _tmp112_;
#line 235 "../src/Widgets/MediaMenu.vala"
			_contract_size = _tmp113_;
#line 235 "../src/Widgets/MediaMenu.vala"
			_contract_index = -1;
#line 235 "../src/Widgets/MediaMenu.vala"
			while (TRUE) {
#line 1182 "MediaMenu.c"
				gint _tmp114_;
				gint _tmp115_;
				GraniteServicesContract* contract = NULL;
				GeeList* _tmp116_;
				gpointer _tmp117_;
				MusicContractMenuItem* menu_item = NULL;
				GraniteServicesContract* _tmp118_;
				MusicContractMenuItem* _tmp119_;
				GtkMenu* _tmp120_;
				MusicContractMenuItem* _tmp121_;
#line 235 "../src/Widgets/MediaMenu.vala"
				_contract_index = _contract_index + 1;
#line 235 "../src/Widgets/MediaMenu.vala"
				_tmp114_ = _contract_index;
#line 235 "../src/Widgets/MediaMenu.vala"
				_tmp115_ = _contract_size;
#line 235 "../src/Widgets/MediaMenu.vala"
				if (!(_tmp114_ < _tmp115_)) {
#line 235 "../src/Widgets/MediaMenu.vala"
					break;
#line 1203 "MediaMenu.c"
				}
#line 235 "../src/Widgets/MediaMenu.vala"
				_tmp116_ = _contract_list;
#line 235 "../src/Widgets/MediaMenu.vala"
				_tmp117_ = gee_list_get (_tmp116_, _contract_index);
#line 235 "../src/Widgets/MediaMenu.vala"
				contract = (GraniteServicesContract*) _tmp117_;
#line 236 "../src/Widgets/MediaMenu.vala"
				_tmp118_ = contract;
#line 236 "../src/Widgets/MediaMenu.vala"
				_tmp119_ = music_contract_menu_item_new (_tmp118_, _data28_->selection);
#line 236 "../src/Widgets/MediaMenu.vala"
				g_object_ref_sink (_tmp119_);
#line 236 "../src/Widgets/MediaMenu.vala"
				menu_item = _tmp119_;
#line 237 "../src/Widgets/MediaMenu.vala"
				_tmp120_ = contractor_sub_menu;
#line 237 "../src/Widgets/MediaMenu.vala"
				_tmp121_ = menu_item;
#line 237 "../src/Widgets/MediaMenu.vala"
				gtk_menu_shell_append ((GtkMenuShell*) _tmp120_, (GtkMenuItem*) _tmp121_);
#line 235 "../src/Widgets/MediaMenu.vala"
				_g_object_unref0 (menu_item);
#line 235 "../src/Widgets/MediaMenu.vala"
				_g_object_unref0 (contract);
#line 1229 "MediaMenu.c"
			}
		}
#line 240 "../src/Widgets/MediaMenu.vala"
		_tmp122_ = self->priv->contractor_entry;
#line 240 "../src/Widgets/MediaMenu.vala"
		_tmp123_ = contractor_sub_menu;
#line 240 "../src/Widgets/MediaMenu.vala"
		_tmp124_ = gtk_container_get_children ((GtkContainer*) _tmp123_);
#line 240 "../src/Widgets/MediaMenu.vala"
		_tmp125_ = _tmp124_;
#line 240 "../src/Widgets/MediaMenu.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp122_, g_list_length (_tmp125_) > ((guint) 0));
#line 240 "../src/Widgets/MediaMenu.vala"
		(_tmp125_ == NULL) ? NULL : (_tmp125_ = (g_list_free (_tmp125_), NULL));
#line 241 "../src/Widgets/MediaMenu.vala"
		_tmp126_ = contractor_sub_menu;
#line 241 "../src/Widgets/MediaMenu.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp126_);
#line 215 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (contracts);
#line 215 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (files);
#line 1252 "MediaMenu.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp127_;
		const gchar* _tmp128_;
		GtkMenuItem* _tmp129_;
#line 215 "../src/Widgets/MediaMenu.vala"
		err = _inner_error0_;
#line 215 "../src/Widgets/MediaMenu.vala"
		_inner_error0_ = NULL;
#line 243 "../src/Widgets/MediaMenu.vala"
		_tmp127_ = err;
#line 243 "../src/Widgets/MediaMenu.vala"
		_tmp128_ = _tmp127_->message;
#line 243 "../src/Widgets/MediaMenu.vala"
		g_warning ("MediaMenu.vala:243: Failed to obtain Contractor actions: %s", _tmp128_);
#line 244 "../src/Widgets/MediaMenu.vala"
		_tmp129_ = self->priv->contractor_entry;
#line 244 "../src/Widgets/MediaMenu.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp129_, FALSE);
#line 215 "../src/Widgets/MediaMenu.vala"
		_g_error_free0 (err);
#line 1277 "MediaMenu.c"
	}
	__finally0:
#line 215 "../src/Widgets/MediaMenu.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 215 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (contractor_sub_menu);
#line 215 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (add_to_playlist_menu);
#line 215 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (media_menu_new_playlist);
#line 215 "../src/Widgets/MediaMenu.vala"
		block28_data_unref (_data28_);
#line 215 "../src/Widgets/MediaMenu.vala"
		_data28_ = NULL;
#line 215 "../src/Widgets/MediaMenu.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 215 "../src/Widgets/MediaMenu.vala"
		g_clear_error (&_inner_error0_);
#line 215 "../src/Widgets/MediaMenu.vala"
		return;
#line 1298 "MediaMenu.c"
	}
#line 247 "../src/Widgets/MediaMenu.vala"
	gtk_menu_popup_at_pointer ((GtkMenu*) self, NULL);
#line 152 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (contractor_sub_menu);
#line 152 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (add_to_playlist_menu);
#line 152 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (media_menu_new_playlist);
#line 152 "../src/Widgets/MediaMenu.vala"
	block28_data_unref (_data28_);
#line 152 "../src/Widgets/MediaMenu.vala"
	_data28_ = NULL;
#line 1312 "MediaMenu.c"
}

static void
music_media_menu_edit_media_clicked (MusicMediaMenu* self)
{
	GeeTreeSet* to_edit_med = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	MusicGenericList* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeTreeSet* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	MusicMedia* first_media = NULL;
	GeeTreeSet* _tmp8_;
	gpointer _tmp9_;
	gchar* music_folder_uri = NULL;
	MusicSettingsMain* _tmp10_;
	MusicSettingsMain* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GFile* _tmp14_;
	GFile* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	GeeTreeSet* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
#line 250 "../src/Widgets/MediaMenu.vala"
	g_return_if_fail (self != NULL);
#line 251 "../src/Widgets/MediaMenu.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 251 "../src/Widgets/MediaMenu.vala"
	to_edit_med = _tmp0_;
#line 252 "../src/Widgets/MediaMenu.vala"
	_tmp1_ = to_edit_med;
#line 252 "../src/Widgets/MediaMenu.vala"
	_tmp2_ = self->priv->_generic_list;
#line 252 "../src/Widgets/MediaMenu.vala"
	_tmp3_ = music_generic_list_get_selected_medias (_tmp2_);
#line 252 "../src/Widgets/MediaMenu.vala"
	_tmp4_ = _tmp3_;
#line 252 "../src/Widgets/MediaMenu.vala"
	gee_collection_add_all ((GeeCollection*) _tmp1_, _tmp4_);
#line 252 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (_tmp4_);
#line 254 "../src/Widgets/MediaMenu.vala"
	_tmp5_ = to_edit_med;
#line 254 "../src/Widgets/MediaMenu.vala"
	_tmp6_ = gee_collection_get_is_empty ((GeeCollection*) _tmp5_);
#line 254 "../src/Widgets/MediaMenu.vala"
	_tmp7_ = _tmp6_;
#line 254 "../src/Widgets/MediaMenu.vala"
	if (_tmp7_) {
#line 255 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (to_edit_med);
#line 255 "../src/Widgets/MediaMenu.vala"
		return;
#line 1374 "MediaMenu.c"
	}
#line 258 "../src/Widgets/MediaMenu.vala"
	_tmp8_ = to_edit_med;
#line 258 "../src/Widgets/MediaMenu.vala"
	_tmp9_ = gee_abstract_sorted_set_first ((GeeAbstractSortedSet*) _tmp8_);
#line 258 "../src/Widgets/MediaMenu.vala"
	first_media = (MusicMedia*) _tmp9_;
#line 259 "../src/Widgets/MediaMenu.vala"
	_tmp10_ = music_settings_main_get_default ();
#line 259 "../src/Widgets/MediaMenu.vala"
	_tmp11_ = _tmp10_;
#line 259 "../src/Widgets/MediaMenu.vala"
	_tmp12_ = music_settings_main_get_music_folder (_tmp11_);
#line 259 "../src/Widgets/MediaMenu.vala"
	_tmp13_ = _tmp12_;
#line 259 "../src/Widgets/MediaMenu.vala"
	_tmp14_ = g_file_new_for_path (_tmp13_);
#line 259 "../src/Widgets/MediaMenu.vala"
	_tmp15_ = _tmp14_;
#line 259 "../src/Widgets/MediaMenu.vala"
	_tmp16_ = g_file_get_uri (_tmp15_);
#line 259 "../src/Widgets/MediaMenu.vala"
	_tmp17_ = _tmp16_;
#line 259 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (_tmp15_);
#line 259 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (_tmp11_);
#line 259 "../src/Widgets/MediaMenu.vala"
	music_folder_uri = _tmp17_;
#line 260 "../src/Widgets/MediaMenu.vala"
	_tmp20_ = to_edit_med;
#line 260 "../src/Widgets/MediaMenu.vala"
	_tmp21_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp20_);
#line 260 "../src/Widgets/MediaMenu.vala"
	_tmp22_ = _tmp21_;
#line 260 "../src/Widgets/MediaMenu.vala"
	if (_tmp22_ == 1) {
#line 1412 "MediaMenu.c"
		MusicMedia* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
#line 260 "../src/Widgets/MediaMenu.vala"
		_tmp23_ = first_media;
#line 260 "../src/Widgets/MediaMenu.vala"
		_tmp24_ = music_media_get_file (_tmp23_);
#line 260 "../src/Widgets/MediaMenu.vala"
		_tmp25_ = _tmp24_;
#line 260 "../src/Widgets/MediaMenu.vala"
		_tmp19_ = !g_file_query_exists (_tmp25_, NULL);
#line 1424 "MediaMenu.c"
	} else {
#line 260 "../src/Widgets/MediaMenu.vala"
		_tmp19_ = FALSE;
#line 1428 "MediaMenu.c"
	}
#line 260 "../src/Widgets/MediaMenu.vala"
	if (_tmp19_) {
#line 1432 "MediaMenu.c"
		MusicMedia* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
#line 260 "../src/Widgets/MediaMenu.vala"
		_tmp26_ = first_media;
#line 260 "../src/Widgets/MediaMenu.vala"
		_tmp27_ = music_media_get_uri (_tmp26_);
#line 260 "../src/Widgets/MediaMenu.vala"
		_tmp28_ = _tmp27_;
#line 260 "../src/Widgets/MediaMenu.vala"
		_tmp29_ = _tmp28_;
#line 260 "../src/Widgets/MediaMenu.vala"
		_tmp30_ = music_folder_uri;
#line 260 "../src/Widgets/MediaMenu.vala"
		_tmp18_ = g_str_has_prefix (_tmp29_, _tmp30_);
#line 260 "../src/Widgets/MediaMenu.vala"
		_g_free0 (_tmp29_);
#line 1452 "MediaMenu.c"
	} else {
#line 260 "../src/Widgets/MediaMenu.vala"
		_tmp18_ = FALSE;
#line 1456 "MediaMenu.c"
	}
#line 260 "../src/Widgets/MediaMenu.vala"
	if (_tmp18_) {
#line 1460 "MediaMenu.c"
		MusicMedia* _tmp31_;
		GThemedIcon* _tmp32_;
		GThemedIcon* _tmp33_;
		MusicFileNotFoundDialog* fnfd = NULL;
		GeeTreeSet* _tmp34_;
		MusicFileNotFoundDialog* _tmp35_;
		MusicFileNotFoundDialog* _tmp36_;
#line 261 "../src/Widgets/MediaMenu.vala"
		_tmp31_ = first_media;
#line 261 "../src/Widgets/MediaMenu.vala"
		_tmp32_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
#line 261 "../src/Widgets/MediaMenu.vala"
		_tmp33_ = _tmp32_;
#line 261 "../src/Widgets/MediaMenu.vala"
		music_media_set_unique_status_image (_tmp31_, (GIcon*) _tmp33_);
#line 261 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (_tmp33_);
#line 262 "../src/Widgets/MediaMenu.vala"
		_tmp34_ = to_edit_med;
#line 262 "../src/Widgets/MediaMenu.vala"
		_tmp35_ = music_file_not_found_dialog_new ((GeeCollection*) _tmp34_);
#line 262 "../src/Widgets/MediaMenu.vala"
		g_object_ref_sink (_tmp35_);
#line 262 "../src/Widgets/MediaMenu.vala"
		fnfd = _tmp35_;
#line 263 "../src/Widgets/MediaMenu.vala"
		_tmp36_ = fnfd;
#line 263 "../src/Widgets/MediaMenu.vala"
		gtk_window_present ((GtkWindow*) _tmp36_);
#line 260 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (fnfd);
#line 1492 "MediaMenu.c"
	} else {
		MusicMediaEditor* media_editor = NULL;
		GeeTreeSet* _tmp37_;
		MusicMediaEditor* _tmp38_;
		MusicMediaEditor* _tmp39_;
#line 265 "../src/Widgets/MediaMenu.vala"
		_tmp37_ = to_edit_med;
#line 265 "../src/Widgets/MediaMenu.vala"
		_tmp38_ = music_media_editor_new (_tmp37_);
#line 265 "../src/Widgets/MediaMenu.vala"
		g_object_ref_sink (_tmp38_);
#line 265 "../src/Widgets/MediaMenu.vala"
		media_editor = _tmp38_;
#line 266 "../src/Widgets/MediaMenu.vala"
		_tmp39_ = media_editor;
#line 266 "../src/Widgets/MediaMenu.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp39_);
#line 260 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (media_editor);
#line 1512 "MediaMenu.c"
	}
#line 250 "../src/Widgets/MediaMenu.vala"
	_g_free0 (music_folder_uri);
#line 250 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (first_media);
#line 250 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (to_edit_med);
#line 1520 "MediaMenu.c"
}

static void
music_media_menu_file_browse_clicked (MusicMediaMenu* self)
{
	GError* _inner_error0_ = NULL;
#line 270 "../src/Widgets/MediaMenu.vala"
	g_return_if_fail (self != NULL);
#line 1529 "MediaMenu.c"
	{
		GeeIterator* _media_it = NULL;
		MusicGenericList* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 271 "../src/Widgets/MediaMenu.vala"
		_tmp0_ = self->priv->_generic_list;
#line 271 "../src/Widgets/MediaMenu.vala"
		_tmp1_ = music_generic_list_get_selected_medias (_tmp0_);
#line 271 "../src/Widgets/MediaMenu.vala"
		_tmp2_ = _tmp1_;
#line 271 "../src/Widgets/MediaMenu.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 271 "../src/Widgets/MediaMenu.vala"
		_tmp4_ = _tmp3_;
#line 271 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (_tmp2_);
#line 271 "../src/Widgets/MediaMenu.vala"
		_media_it = _tmp4_;
#line 271 "../src/Widgets/MediaMenu.vala"
		while (TRUE) {
#line 1553 "MediaMenu.c"
			GeeIterator* _tmp5_;
			MusicMedia* media = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
#line 271 "../src/Widgets/MediaMenu.vala"
			_tmp5_ = _media_it;
#line 271 "../src/Widgets/MediaMenu.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 271 "../src/Widgets/MediaMenu.vala"
				break;
#line 1564 "MediaMenu.c"
			}
#line 271 "../src/Widgets/MediaMenu.vala"
			_tmp6_ = _media_it;
#line 271 "../src/Widgets/MediaMenu.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 271 "../src/Widgets/MediaMenu.vala"
			media = (MusicMedia*) _tmp7_;
#line 1572 "MediaMenu.c"
			{
				GtkWindow* main_window = NULL;
				GApplication* _tmp8_;
				GtkWindow* _tmp9_;
				GtkWindow* _tmp10_;
				GFile* _tmp11_;
				GFile* _tmp12_;
				GFile* _tmp13_;
				GFile* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
#line 273 "../src/Widgets/MediaMenu.vala"
				_tmp8_ = g_application_get_default ();
#line 273 "../src/Widgets/MediaMenu.vala"
				_tmp9_ = gtk_application_get_active_window (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_application_get_type (), GtkApplication));
#line 273 "../src/Widgets/MediaMenu.vala"
				_tmp10_ = _g_object_ref0 (_tmp9_);
#line 273 "../src/Widgets/MediaMenu.vala"
				main_window = _tmp10_;
#line 274 "../src/Widgets/MediaMenu.vala"
				_tmp11_ = music_media_get_file (media);
#line 274 "../src/Widgets/MediaMenu.vala"
				_tmp12_ = _tmp11_;
#line 274 "../src/Widgets/MediaMenu.vala"
				_tmp13_ = g_file_get_parent (_tmp12_);
#line 274 "../src/Widgets/MediaMenu.vala"
				_tmp14_ = _tmp13_;
#line 274 "../src/Widgets/MediaMenu.vala"
				_tmp15_ = g_file_get_uri (_tmp14_);
#line 274 "../src/Widgets/MediaMenu.vala"
				_tmp16_ = _tmp15_;
#line 274 "../src/Widgets/MediaMenu.vala"
				gtk_show_uri_on_window (main_window, _tmp16_, (guint32) GDK_CURRENT_TIME, &_inner_error0_);
#line 274 "../src/Widgets/MediaMenu.vala"
				_g_free0 (_tmp16_);
#line 274 "../src/Widgets/MediaMenu.vala"
				_g_object_unref0 (_tmp14_);
#line 274 "../src/Widgets/MediaMenu.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 274 "../src/Widgets/MediaMenu.vala"
					_g_object_unref0 (main_window);
#line 1614 "MediaMenu.c"
					goto __catch0_g_error;
				}
#line 272 "../src/Widgets/MediaMenu.vala"
				_g_object_unref0 (main_window);
#line 1619 "MediaMenu.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				GError* _tmp20_;
				const gchar* _tmp21_;
#line 272 "../src/Widgets/MediaMenu.vala"
				err = _inner_error0_;
#line 272 "../src/Widgets/MediaMenu.vala"
				_inner_error0_ = NULL;
#line 276 "../src/Widgets/MediaMenu.vala"
				_tmp17_ = music_media_get_uri (media);
#line 276 "../src/Widgets/MediaMenu.vala"
				_tmp18_ = _tmp17_;
#line 276 "../src/Widgets/MediaMenu.vala"
				_tmp19_ = _tmp18_;
#line 276 "../src/Widgets/MediaMenu.vala"
				_tmp20_ = err;
#line 276 "../src/Widgets/MediaMenu.vala"
				_tmp21_ = _tmp20_->message;
#line 276 "../src/Widgets/MediaMenu.vala"
				g_debug ("MediaMenu.vala:276: Could not browse media %s: %s\n", _tmp19_, _tmp21_);
#line 276 "../src/Widgets/MediaMenu.vala"
				_g_free0 (_tmp19_);
#line 272 "../src/Widgets/MediaMenu.vala"
				_g_error_free0 (err);
#line 1650 "MediaMenu.c"
			}
			__finally0:
#line 272 "../src/Widgets/MediaMenu.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 272 "../src/Widgets/MediaMenu.vala"
				_g_object_unref0 (media);
#line 272 "../src/Widgets/MediaMenu.vala"
				_g_object_unref0 (_media_it);
#line 272 "../src/Widgets/MediaMenu.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 272 "../src/Widgets/MediaMenu.vala"
				g_clear_error (&_inner_error0_);
#line 272 "../src/Widgets/MediaMenu.vala"
				return;
#line 1665 "MediaMenu.c"
			}
#line 279 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (media);
#line 279 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (_media_it);
#line 279 "../src/Widgets/MediaMenu.vala"
			return;
#line 1673 "MediaMenu.c"
		}
#line 271 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (_media_it);
#line 1677 "MediaMenu.c"
	}
}

static void
music_media_menu_import_to_library_clicked (MusicMediaMenu* self)
{
	MusicGenericList* _tmp0_;
	MusicGenericList* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	GeeCollection* _tmp6_;
#line 283 "../src/Widgets/MediaMenu.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/Widgets/MediaMenu.vala"
	_tmp0_ = self->priv->_generic_list;
#line 284 "../src/Widgets/MediaMenu.vala"
	_tmp1_ = self->priv->_generic_list;
#line 284 "../src/Widgets/MediaMenu.vala"
	_tmp2_ = music_generic_list_get_selected_medias (_tmp1_);
#line 284 "../src/Widgets/MediaMenu.vala"
	_tmp3_ = _tmp2_;
#line 284 "../src/Widgets/MediaMenu.vala"
	_tmp4_ = gee_collection_get_read_only_view (_tmp3_);
#line 284 "../src/Widgets/MediaMenu.vala"
	_tmp5_ = _tmp4_;
#line 284 "../src/Widgets/MediaMenu.vala"
	_tmp6_ = _tmp5_;
#line 284 "../src/Widgets/MediaMenu.vala"
	g_signal_emit_by_name (_tmp0_, "import-requested", _tmp6_);
#line 284 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (_tmp6_);
#line 284 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (_tmp3_);
#line 1713 "MediaMenu.c"
}

static void
music_media_menu_media_menu_new_playlist_clicked (MusicMediaMenu* self)
{
	MusicStaticPlaylist* p = NULL;
	MusicStaticPlaylist* _tmp0_;
	MusicGenericList* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	GeeCollection* _tmp6_;
	MusicGenericList* _tmp7_;
	MusicViewWrapper* _tmp8_;
	MusicViewWrapper* _tmp9_;
	MusicLibrary* _tmp10_;
	MusicLibrary* _tmp11_;
	GeeCollection* _tmp12_;
	GeeCollection* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	MusicGenericList* _tmp16_;
	MusicViewWrapper* _tmp17_;
	MusicViewWrapper* _tmp18_;
	MusicLibrary* _tmp19_;
	MusicLibrary* _tmp20_;
#line 287 "../src/Widgets/MediaMenu.vala"
	g_return_if_fail (self != NULL);
#line 288 "../src/Widgets/MediaMenu.vala"
	_tmp0_ = music_static_playlist_new ();
#line 288 "../src/Widgets/MediaMenu.vala"
	p = _tmp0_;
#line 289 "../src/Widgets/MediaMenu.vala"
	_tmp1_ = self->priv->_generic_list;
#line 289 "../src/Widgets/MediaMenu.vala"
	_tmp2_ = music_generic_list_get_selected_medias (_tmp1_);
#line 289 "../src/Widgets/MediaMenu.vala"
	_tmp3_ = _tmp2_;
#line 289 "../src/Widgets/MediaMenu.vala"
	_tmp4_ = gee_collection_get_read_only_view (_tmp3_);
#line 289 "../src/Widgets/MediaMenu.vala"
	_tmp5_ = _tmp4_;
#line 289 "../src/Widgets/MediaMenu.vala"
	_tmp6_ = _tmp5_;
#line 289 "../src/Widgets/MediaMenu.vala"
	music_playlist_add_medias ((MusicPlaylist*) p, _tmp6_);
#line 289 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (_tmp6_);
#line 289 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (_tmp3_);
#line 290 "../src/Widgets/MediaMenu.vala"
	_tmp7_ = self->priv->_generic_list;
#line 290 "../src/Widgets/MediaMenu.vala"
	_tmp8_ = music_generic_list_get_parent_wrapper (_tmp7_);
#line 290 "../src/Widgets/MediaMenu.vala"
	_tmp9_ = _tmp8_;
#line 290 "../src/Widgets/MediaMenu.vala"
	_tmp10_ = music_view_wrapper_get_library (_tmp9_);
#line 290 "../src/Widgets/MediaMenu.vala"
	_tmp11_ = _tmp10_;
#line 290 "../src/Widgets/MediaMenu.vala"
	_tmp12_ = music_library_get_playlists (_tmp11_);
#line 290 "../src/Widgets/MediaMenu.vala"
	_tmp13_ = _tmp12_;
#line 290 "../src/Widgets/MediaMenu.vala"
	_tmp14_ = music_playlists_utils_get_new_playlist_name (_tmp13_, NULL);
#line 290 "../src/Widgets/MediaMenu.vala"
	_tmp15_ = _tmp14_;
#line 290 "../src/Widgets/MediaMenu.vala"
	music_playlist_set_name ((MusicPlaylist*) p, _tmp15_);
#line 290 "../src/Widgets/MediaMenu.vala"
	_g_free0 (_tmp15_);
#line 290 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (_tmp13_);
#line 291 "../src/Widgets/MediaMenu.vala"
	_tmp16_ = self->priv->_generic_list;
#line 291 "../src/Widgets/MediaMenu.vala"
	_tmp17_ = music_generic_list_get_parent_wrapper (_tmp16_);
#line 291 "../src/Widgets/MediaMenu.vala"
	_tmp18_ = _tmp17_;
#line 291 "../src/Widgets/MediaMenu.vala"
	_tmp19_ = music_view_wrapper_get_library (_tmp18_);
#line 291 "../src/Widgets/MediaMenu.vala"
	_tmp20_ = _tmp19_;
#line 291 "../src/Widgets/MediaMenu.vala"
	music_library_add_playlist (_tmp20_, p);
#line 287 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (p);
#line 1803 "MediaMenu.c"
}

static void
music_media_menu_queue_clicked (MusicMediaMenu* self)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicGenericList* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	GeeCollection* _tmp6_;
	GeeCollection* _tmp7_;
#line 294 "../src/Widgets/MediaMenu.vala"
	g_return_if_fail (self != NULL);
#line 295 "../src/Widgets/MediaMenu.vala"
	_tmp0_ = music_app_get_player ();
#line 295 "../src/Widgets/MediaMenu.vala"
	_tmp1_ = _tmp0_;
#line 295 "../src/Widgets/MediaMenu.vala"
	_tmp2_ = self->priv->_generic_list;
#line 295 "../src/Widgets/MediaMenu.vala"
	_tmp3_ = music_generic_list_get_selected_medias (_tmp2_);
#line 295 "../src/Widgets/MediaMenu.vala"
	_tmp4_ = _tmp3_;
#line 295 "../src/Widgets/MediaMenu.vala"
	_tmp5_ = gee_collection_get_read_only_view (_tmp4_);
#line 295 "../src/Widgets/MediaMenu.vala"
	_tmp6_ = _tmp5_;
#line 295 "../src/Widgets/MediaMenu.vala"
	_tmp7_ = _tmp6_;
#line 295 "../src/Widgets/MediaMenu.vala"
	music_playback_manager_queue_media (_tmp1_, _tmp7_);
#line 295 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (_tmp7_);
#line 295 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (_tmp4_);
#line 1841 "MediaMenu.c"
}

static void
music_media_menu_rate_media_clicked (MusicMediaMenu* self)
{
	gint new_rating = 0;
	MusicRatingMenuItem* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeCollection* selected = NULL;
	MusicGenericList* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	GeeCollection* _tmp6_;
	GeeCollection* _tmp7_;
	GeeCollection* _tmp8_;
	MusicGenericList* _tmp15_;
	MusicViewWrapper* _tmp16_;
	MusicViewWrapper* _tmp17_;
	MusicLibrary* _tmp18_;
	MusicLibrary* _tmp19_;
	GeeCollection* _tmp20_;
#line 298 "../src/Widgets/MediaMenu.vala"
	g_return_if_fail (self != NULL);
#line 299 "../src/Widgets/MediaMenu.vala"
	_tmp0_ = self->priv->rate_media;
#line 299 "../src/Widgets/MediaMenu.vala"
	_tmp1_ = music_rating_menu_item_get_rating_value (_tmp0_);
#line 299 "../src/Widgets/MediaMenu.vala"
	_tmp2_ = _tmp1_;
#line 299 "../src/Widgets/MediaMenu.vala"
	new_rating = _tmp2_;
#line 300 "../src/Widgets/MediaMenu.vala"
	_tmp3_ = self->priv->_generic_list;
#line 300 "../src/Widgets/MediaMenu.vala"
	_tmp4_ = music_generic_list_get_selected_medias (_tmp3_);
#line 300 "../src/Widgets/MediaMenu.vala"
	_tmp5_ = _tmp4_;
#line 300 "../src/Widgets/MediaMenu.vala"
	_tmp6_ = gee_collection_get_read_only_view (_tmp5_);
#line 300 "../src/Widgets/MediaMenu.vala"
	_tmp7_ = _tmp6_;
#line 300 "../src/Widgets/MediaMenu.vala"
	_tmp8_ = _tmp7_;
#line 300 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (_tmp5_);
#line 300 "../src/Widgets/MediaMenu.vala"
	selected = _tmp8_;
#line 1890 "MediaMenu.c"
	{
		GeeIterator* _media_it = NULL;
		GeeCollection* _tmp9_;
		GeeIterator* _tmp10_;
#line 301 "../src/Widgets/MediaMenu.vala"
		_tmp9_ = selected;
#line 301 "../src/Widgets/MediaMenu.vala"
		_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 301 "../src/Widgets/MediaMenu.vala"
		_media_it = _tmp10_;
#line 301 "../src/Widgets/MediaMenu.vala"
		while (TRUE) {
#line 1903 "MediaMenu.c"
			GeeIterator* _tmp11_;
			MusicMedia* media = NULL;
			GeeIterator* _tmp12_;
			gpointer _tmp13_;
			MusicMedia* _tmp14_;
#line 301 "../src/Widgets/MediaMenu.vala"
			_tmp11_ = _media_it;
#line 301 "../src/Widgets/MediaMenu.vala"
			if (!gee_iterator_next (_tmp11_)) {
#line 301 "../src/Widgets/MediaMenu.vala"
				break;
#line 1915 "MediaMenu.c"
			}
#line 301 "../src/Widgets/MediaMenu.vala"
			_tmp12_ = _media_it;
#line 301 "../src/Widgets/MediaMenu.vala"
			_tmp13_ = gee_iterator_get (_tmp12_);
#line 301 "../src/Widgets/MediaMenu.vala"
			media = (MusicMedia*) _tmp13_;
#line 302 "../src/Widgets/MediaMenu.vala"
			_tmp14_ = media;
#line 302 "../src/Widgets/MediaMenu.vala"
			music_media_set_rating (_tmp14_, (guint) new_rating);
#line 301 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (media);
#line 1929 "MediaMenu.c"
		}
#line 301 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (_media_it);
#line 1933 "MediaMenu.c"
	}
#line 304 "../src/Widgets/MediaMenu.vala"
	_tmp15_ = self->priv->_generic_list;
#line 304 "../src/Widgets/MediaMenu.vala"
	_tmp16_ = music_generic_list_get_parent_wrapper (_tmp15_);
#line 304 "../src/Widgets/MediaMenu.vala"
	_tmp17_ = _tmp16_;
#line 304 "../src/Widgets/MediaMenu.vala"
	_tmp18_ = music_view_wrapper_get_library (_tmp17_);
#line 304 "../src/Widgets/MediaMenu.vala"
	_tmp19_ = _tmp18_;
#line 304 "../src/Widgets/MediaMenu.vala"
	_tmp20_ = selected;
#line 304 "../src/Widgets/MediaMenu.vala"
	music_library_update_medias (_tmp19_, _tmp20_, FALSE, TRUE);
#line 298 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (selected);
#line 1951 "MediaMenu.c"
}

static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
#line 307 "../src/Widgets/MediaMenu.vala"
	g_atomic_int_inc (&_data30_->_ref_count_);
#line 307 "../src/Widgets/MediaMenu.vala"
	return _data30_;
#line 1961 "MediaMenu.c"
}

static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
#line 307 "../src/Widgets/MediaMenu.vala"
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
#line 1971 "MediaMenu.c"
		MusicMediaMenu* self;
#line 307 "../src/Widgets/MediaMenu.vala"
		self = _data30_->self;
#line 307 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (_data30_->selected_media);
#line 307 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (self);
#line 307 "../src/Widgets/MediaMenu.vala"
		g_slice_free (Block30Data, _data30_);
#line 1981 "MediaMenu.c"
	}
}

static void
___lambda53_ (Block30Data* _data30_,
              gboolean delete_files)
{
	MusicMediaMenu* self;
	MusicGenericList* _tmp0_;
	MusicViewWrapper* _tmp1_;
	MusicViewWrapper* _tmp2_;
	MusicLibrary* _tmp3_;
	MusicLibrary* _tmp4_;
	GeeCollection* _tmp5_;
#line 314 "../src/Widgets/MediaMenu.vala"
	self = _data30_->self;
#line 315 "../src/Widgets/MediaMenu.vala"
	_tmp0_ = self->priv->_generic_list;
#line 315 "../src/Widgets/MediaMenu.vala"
	_tmp1_ = music_generic_list_get_parent_wrapper (_tmp0_);
#line 315 "../src/Widgets/MediaMenu.vala"
	_tmp2_ = _tmp1_;
#line 315 "../src/Widgets/MediaMenu.vala"
	_tmp3_ = music_view_wrapper_get_library (_tmp2_);
#line 315 "../src/Widgets/MediaMenu.vala"
	_tmp4_ = _tmp3_;
#line 315 "../src/Widgets/MediaMenu.vala"
	_tmp5_ = _data30_->selected_media;
#line 315 "../src/Widgets/MediaMenu.vala"
	music_library_remove_medias (_tmp4_, _tmp5_, delete_files);
#line 2012 "MediaMenu.c"
}

static void
____lambda53__music_remove_files_dialog_remove_media (MusicRemoveFilesDialog* _sender,
                                                      gboolean response,
                                                      gpointer self)
{
#line 314 "../src/Widgets/MediaMenu.vala"
	___lambda53_ (self, response);
#line 2022 "MediaMenu.c"
}

static void
music_media_menu_remove_media_clicked (MusicMediaMenu* self)
{
	Block30Data* _data30_;
	MusicGenericList* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	MusicViewWrapperHint _tmp6_;
#line 307 "../src/Widgets/MediaMenu.vala"
	g_return_if_fail (self != NULL);
#line 307 "../src/Widgets/MediaMenu.vala"
	_data30_ = g_slice_new0 (Block30Data);
#line 307 "../src/Widgets/MediaMenu.vala"
	_data30_->_ref_count_ = 1;
#line 307 "../src/Widgets/MediaMenu.vala"
	_data30_->self = g_object_ref (self);
#line 308 "../src/Widgets/MediaMenu.vala"
	_tmp0_ = self->priv->_generic_list;
#line 308 "../src/Widgets/MediaMenu.vala"
	_tmp1_ = music_generic_list_get_selected_medias (_tmp0_);
#line 308 "../src/Widgets/MediaMenu.vala"
	_tmp2_ = _tmp1_;
#line 308 "../src/Widgets/MediaMenu.vala"
	_tmp3_ = gee_collection_get_read_only_view (_tmp2_);
#line 308 "../src/Widgets/MediaMenu.vala"
	_tmp4_ = _tmp3_;
#line 308 "../src/Widgets/MediaMenu.vala"
	_tmp5_ = _tmp4_;
#line 308 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (_tmp2_);
#line 308 "../src/Widgets/MediaMenu.vala"
	_data30_->selected_media = _tmp5_;
#line 310 "../src/Widgets/MediaMenu.vala"
	_tmp6_ = self->priv->_hint;
#line 310 "../src/Widgets/MediaMenu.vala"
	switch (_tmp6_) {
#line 310 "../src/Widgets/MediaMenu.vala"
		case MUSIC_VIEW_WRAPPER_HINT_ALBUM_LIST:
#line 310 "../src/Widgets/MediaMenu.vala"
		case MUSIC_VIEW_WRAPPER_HINT_MUSIC:
#line 2068 "MediaMenu.c"
		{
			MusicRemoveFilesDialog* dialog = NULL;
			GeeCollection* _tmp7_;
			MusicRemoveFilesDialog* _tmp8_;
			MusicRemoveFilesDialog* _tmp9_;
#line 313 "../src/Widgets/MediaMenu.vala"
			_tmp7_ = _data30_->selected_media;
#line 313 "../src/Widgets/MediaMenu.vala"
			_tmp8_ = music_remove_files_dialog_new (_tmp7_);
#line 313 "../src/Widgets/MediaMenu.vala"
			g_object_ref_sink (_tmp8_);
#line 313 "../src/Widgets/MediaMenu.vala"
			dialog = _tmp8_;
#line 314 "../src/Widgets/MediaMenu.vala"
			_tmp9_ = dialog;
#line 314 "../src/Widgets/MediaMenu.vala"
			g_signal_connect_data (_tmp9_, "remove-media", (GCallback) ____lambda53__music_remove_files_dialog_remove_media, block30_data_ref (_data30_), (GClosureNotify) block30_data_unref, 0);
#line 317 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (dialog);
#line 317 "../src/Widgets/MediaMenu.vala"
			break;
#line 2090 "MediaMenu.c"
		}
#line 310 "../src/Widgets/MediaMenu.vala"
		case MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO:
#line 2094 "MediaMenu.c"
		{
			MusicDeviceViewWrapper* dvw = NULL;
			MusicGenericList* _tmp10_;
			MusicViewWrapper* _tmp11_;
			MusicViewWrapper* _tmp12_;
			MusicDeviceViewWrapper* _tmp13_;
			MusicDeviceViewWrapper* _tmp14_;
			MusicLibrary* _tmp15_;
			MusicLibrary* _tmp16_;
			GeeCollection* _tmp17_;
#line 319 "../src/Widgets/MediaMenu.vala"
			_tmp10_ = self->priv->_generic_list;
#line 319 "../src/Widgets/MediaMenu.vala"
			_tmp11_ = music_generic_list_get_parent_wrapper (_tmp10_);
#line 319 "../src/Widgets/MediaMenu.vala"
			_tmp12_ = _tmp11_;
#line 319 "../src/Widgets/MediaMenu.vala"
			_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper));
#line 319 "../src/Widgets/MediaMenu.vala"
			dvw = _tmp13_;
#line 320 "../src/Widgets/MediaMenu.vala"
			_tmp14_ = dvw;
#line 320 "../src/Widgets/MediaMenu.vala"
			_tmp15_ = music_view_wrapper_get_library ((MusicViewWrapper*) _tmp14_);
#line 320 "../src/Widgets/MediaMenu.vala"
			_tmp16_ = _tmp15_;
#line 320 "../src/Widgets/MediaMenu.vala"
			_tmp17_ = _data30_->selected_media;
#line 320 "../src/Widgets/MediaMenu.vala"
			music_library_remove_medias (_tmp16_, _tmp17_, TRUE);
#line 321 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (dvw);
#line 321 "../src/Widgets/MediaMenu.vala"
			break;
#line 2129 "MediaMenu.c"
		}
#line 310 "../src/Widgets/MediaMenu.vala"
		case MUSIC_VIEW_WRAPPER_HINT_PLAYLIST:
#line 2133 "MediaMenu.c"
		{
			MusicGenericList* _tmp18_;
			MusicPlaylist* _tmp19_;
			MusicPlaylist* _tmp20_;
			GeeCollection* _tmp21_;
#line 323 "../src/Widgets/MediaMenu.vala"
			_tmp18_ = self->priv->_generic_list;
#line 323 "../src/Widgets/MediaMenu.vala"
			_tmp19_ = music_generic_list_get_playlist (_tmp18_);
#line 323 "../src/Widgets/MediaMenu.vala"
			_tmp20_ = _tmp19_;
#line 323 "../src/Widgets/MediaMenu.vala"
			_tmp21_ = _data30_->selected_media;
#line 323 "../src/Widgets/MediaMenu.vala"
			music_playlist_remove_medias (_tmp20_, _tmp21_);
#line 324 "../src/Widgets/MediaMenu.vala"
			break;
#line 2151 "MediaMenu.c"
		}
#line 310 "../src/Widgets/MediaMenu.vala"
		case MUSIC_VIEW_WRAPPER_HINT_QUEUE:
#line 2155 "MediaMenu.c"
		{
			MusicPlaybackManager* _tmp22_;
			MusicPlaybackManager* _tmp23_;
			GeeCollection* _tmp24_;
#line 326 "../src/Widgets/MediaMenu.vala"
			_tmp22_ = music_app_get_player ();
#line 326 "../src/Widgets/MediaMenu.vala"
			_tmp23_ = _tmp22_;
#line 326 "../src/Widgets/MediaMenu.vala"
			_tmp24_ = _data30_->selected_media;
#line 326 "../src/Widgets/MediaMenu.vala"
			music_playback_manager_unqueue_media (_tmp23_, _tmp24_);
#line 327 "../src/Widgets/MediaMenu.vala"
			break;
#line 2170 "MediaMenu.c"
		}
		default:
#line 310 "../src/Widgets/MediaMenu.vala"
		break;
#line 2175 "MediaMenu.c"
	}
#line 307 "../src/Widgets/MediaMenu.vala"
	block30_data_unref (_data30_);
#line 307 "../src/Widgets/MediaMenu.vala"
	_data30_ = NULL;
#line 2181 "MediaMenu.c"
}

MusicViewWrapperHint
music_media_menu_get_hint (MusicMediaMenu* self)
{
	MusicViewWrapperHint result;
#line 27 "../src/Widgets/MediaMenu.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "../src/Widgets/MediaMenu.vala"
	result = self->priv->_hint;
#line 27 "../src/Widgets/MediaMenu.vala"
	return result;
#line 2194 "MediaMenu.c"
}

static void
music_media_menu_set_hint (MusicMediaMenu* self,
                           MusicViewWrapperHint value)
{
	MusicViewWrapperHint old_value;
#line 27 "../src/Widgets/MediaMenu.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Widgets/MediaMenu.vala"
	old_value = music_media_menu_get_hint (self);
#line 27 "../src/Widgets/MediaMenu.vala"
	if (old_value != value) {
#line 27 "../src/Widgets/MediaMenu.vala"
		self->priv->_hint = value;
#line 27 "../src/Widgets/MediaMenu.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_menu_properties[MUSIC_MEDIA_MENU_HINT_PROPERTY]);
#line 2212 "MediaMenu.c"
	}
}

MusicGenericList*
music_media_menu_get_generic_list (MusicMediaMenu* self)
{
	MusicGenericList* result;
	MusicGenericList* _tmp0_;
#line 28 "../src/Widgets/MediaMenu.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Widgets/MediaMenu.vala"
	_tmp0_ = self->priv->_generic_list;
#line 28 "../src/Widgets/MediaMenu.vala"
	result = _tmp0_;
#line 28 "../src/Widgets/MediaMenu.vala"
	return result;
#line 2229 "MediaMenu.c"
}

static void
music_media_menu_set_generic_list (MusicMediaMenu* self,
                                   MusicGenericList* value)
{
	MusicGenericList* old_value;
#line 28 "../src/Widgets/MediaMenu.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Widgets/MediaMenu.vala"
	old_value = music_media_menu_get_generic_list (self);
#line 28 "../src/Widgets/MediaMenu.vala"
	if (old_value != value) {
#line 2243 "MediaMenu.c"
		MusicGenericList* _tmp0_;
#line 28 "../src/Widgets/MediaMenu.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 28 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (self->priv->_generic_list);
#line 28 "../src/Widgets/MediaMenu.vala"
		self->priv->_generic_list = _tmp0_;
#line 28 "../src/Widgets/MediaMenu.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_menu_properties[MUSIC_MEDIA_MENU_GENERIC_LIST_PROPERTY]);
#line 2253 "MediaMenu.c"
	}
}

static Block31Data*
block31_data_ref (Block31Data* _data31_)
{
#line 45 "../src/Widgets/MediaMenu.vala"
	g_atomic_int_inc (&_data31_->_ref_count_);
#line 45 "../src/Widgets/MediaMenu.vala"
	return _data31_;
#line 2264 "MediaMenu.c"
}

static void
block31_data_unref (void * _userdata_)
{
	Block31Data* _data31_;
	_data31_ = (Block31Data*) _userdata_;
#line 45 "../src/Widgets/MediaMenu.vala"
	if (g_atomic_int_dec_and_test (&_data31_->_ref_count_)) {
#line 2274 "MediaMenu.c"
		MusicMediaMenu* self;
#line 45 "../src/Widgets/MediaMenu.vala"
		self = _data31_->self;
#line 45 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (_data31_->scroll_to_current);
#line 45 "../src/Widgets/MediaMenu.vala"
		_g_object_unref0 (self);
#line 45 "../src/Widgets/MediaMenu.vala"
		g_slice_free (Block31Data, _data31_);
#line 2284 "MediaMenu.c"
	}
}

static void
_music_media_menu___lambda60_ (MusicMediaMenu* self)
{
	MusicGenericList* _tmp0_;
#line 133 "../src/Widgets/MediaMenu.vala"
	_tmp0_ = self->priv->_generic_list;
#line 133 "../src/Widgets/MediaMenu.vala"
	music_generic_list_scroll_to_current_media (_tmp0_, TRUE);
#line 2296 "MediaMenu.c"
}

static void
__music_media_menu___lambda60__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                       gpointer self)
{
#line 132 "../src/Widgets/MediaMenu.vala"
	_music_media_menu___lambda60_ ((MusicMediaMenu*) self);
#line 2305 "MediaMenu.c"
}

static void
_music_media_menu___lambda61_ (Block31Data* _data31_)
{
	MusicMediaMenu* self;
	GtkMenuItem* _tmp0_;
#line 136 "../src/Widgets/MediaMenu.vala"
	self = _data31_->self;
#line 137 "../src/Widgets/MediaMenu.vala"
	_tmp0_ = _data31_->scroll_to_current;
#line 137 "../src/Widgets/MediaMenu.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
#line 2319 "MediaMenu.c"
}

static void
__music_media_menu___lambda61__music_playback_manager_playback_stopped (MusicPlaybackManager* _sender,
                                                                        gint64 was_playing,
                                                                        gpointer self)
{
#line 136 "../src/Widgets/MediaMenu.vala"
	_music_media_menu___lambda61_ (self);
#line 2329 "MediaMenu.c"
}

static void
_music_media_menu___lambda62_ (Block31Data* _data31_)
{
	MusicMediaMenu* self;
	GtkMenuItem* _tmp0_;
#line 140 "../src/Widgets/MediaMenu.vala"
	self = _data31_->self;
#line 141 "../src/Widgets/MediaMenu.vala"
	_tmp0_ = _data31_->scroll_to_current;
#line 141 "../src/Widgets/MediaMenu.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
#line 2343 "MediaMenu.c"
}

static void
__music_media_menu___lambda62__music_playback_manager_playback_started (MusicPlaybackManager* _sender,
                                                                        gpointer self)
{
#line 140 "../src/Widgets/MediaMenu.vala"
	_music_media_menu___lambda62_ (self);
#line 2352 "MediaMenu.c"
}

static void
_music_media_menu_edit_media_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                             gpointer self)
{
#line 144 "../src/Widgets/MediaMenu.vala"
	music_media_menu_edit_media_clicked ((MusicMediaMenu*) self);
#line 2361 "MediaMenu.c"
}

static void
_music_media_menu_file_browse_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
#line 145 "../src/Widgets/MediaMenu.vala"
	music_media_menu_file_browse_clicked ((MusicMediaMenu*) self);
#line 2370 "MediaMenu.c"
}

static void
_music_media_menu_import_to_library_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                    gpointer self)
{
#line 146 "../src/Widgets/MediaMenu.vala"
	music_media_menu_import_to_library_clicked ((MusicMediaMenu*) self);
#line 2379 "MediaMenu.c"
}

static void
_music_media_menu_queue_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                        gpointer self)
{
#line 147 "../src/Widgets/MediaMenu.vala"
	music_media_menu_queue_clicked ((MusicMediaMenu*) self);
#line 2388 "MediaMenu.c"
}

static void
_music_media_menu_rate_media_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                             gpointer self)
{
#line 148 "../src/Widgets/MediaMenu.vala"
	music_media_menu_rate_media_clicked ((MusicMediaMenu*) self);
#line 2397 "MediaMenu.c"
}

static void
_music_media_menu_remove_media_clicked_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self)
{
#line 149 "../src/Widgets/MediaMenu.vala"
	music_media_menu_remove_media_clicked ((MusicMediaMenu*) self);
#line 2406 "MediaMenu.c"
}

static GObject *
music_media_menu_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicMediaMenu * self;
	Block31Data* _data31_;
	GtkMenuItem* _tmp0_;
	GtkMenuItem* _tmp1_;
	GtkMenuItem* file_browse = NULL;
	GtkMenuItem* _tmp2_;
	GtkMenuItem* _tmp3_;
	GtkMenuItem* _tmp4_;
	MusicRatingMenuItem* _tmp5_;
	GtkMenuItem* _tmp6_;
	GtkMenuItem* _tmp7_;
	GtkMenuItem* _tmp8_;
	GtkMenuItem* _tmp9_;
	MusicViewWrapperHint _tmp10_;
	GtkMenuItem* _tmp78_;
	MusicPlaybackManager* _tmp79_;
	MusicPlaybackManager* _tmp80_;
	MusicPlaybackManager* _tmp81_;
	MusicPlaybackManager* _tmp82_;
	GtkMenuItem* _tmp83_;
	GtkMenuItem* _tmp84_;
	GtkMenuItem* _tmp85_;
	GtkMenuItem* _tmp86_;
	MusicRatingMenuItem* _tmp87_;
	GtkMenuItem* _tmp88_;
#line 45 "../src/Widgets/MediaMenu.vala"
	parent_class = G_OBJECT_CLASS (music_media_menu_parent_class);
#line 45 "../src/Widgets/MediaMenu.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 45 "../src/Widgets/MediaMenu.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MEDIA_MENU, MusicMediaMenu);
#line 45 "../src/Widgets/MediaMenu.vala"
	_data31_ = g_slice_new0 (Block31Data);
#line 45 "../src/Widgets/MediaMenu.vala"
	_data31_->_ref_count_ = 1;
#line 45 "../src/Widgets/MediaMenu.vala"
	_data31_->self = g_object_ref (self);
#line 46 "../src/Widgets/MediaMenu.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Scroll to Current Song"));
#line 46 "../src/Widgets/MediaMenu.vala"
	g_object_ref_sink (_tmp0_);
#line 46 "../src/Widgets/MediaMenu.vala"
	_data31_->scroll_to_current = _tmp0_;
#line 47 "../src/Widgets/MediaMenu.vala"
	_tmp1_ = _data31_->scroll_to_current;
#line 47 "../src/Widgets/MediaMenu.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 49 "../src/Widgets/MediaMenu.vala"
	_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Show in File Browser…"));
#line 49 "../src/Widgets/MediaMenu.vala"
	g_object_ref_sink (_tmp2_);
#line 49 "../src/Widgets/MediaMenu.vala"
	file_browse = _tmp2_;
#line 50 "../src/Widgets/MediaMenu.vala"
	_tmp3_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Edit Song Info…"));
#line 50 "../src/Widgets/MediaMenu.vala"
	g_object_ref_sink (_tmp3_);
#line 50 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (self->priv->edit_media);
#line 50 "../src/Widgets/MediaMenu.vala"
	self->priv->edit_media = _tmp3_;
#line 51 "../src/Widgets/MediaMenu.vala"
	_tmp4_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Other Actions"));
#line 51 "../src/Widgets/MediaMenu.vala"
	g_object_ref_sink (_tmp4_);
#line 51 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (self->priv->contractor_entry);
#line 51 "../src/Widgets/MediaMenu.vala"
	self->priv->contractor_entry = _tmp4_;
#line 52 "../src/Widgets/MediaMenu.vala"
	_tmp5_ = music_rating_menu_item_new ();
#line 52 "../src/Widgets/MediaMenu.vala"
	g_object_ref_sink (_tmp5_);
#line 52 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (self->priv->rate_media);
#line 52 "../src/Widgets/MediaMenu.vala"
	self->priv->rate_media = _tmp5_;
#line 53 "../src/Widgets/MediaMenu.vala"
	_tmp6_ = (GtkMenuItem*) gtk_menu_item_new_with_label (C_ ("Action item (verb)", "Queue"));
#line 53 "../src/Widgets/MediaMenu.vala"
	g_object_ref_sink (_tmp6_);
#line 53 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (self->priv->queue_media);
#line 53 "../src/Widgets/MediaMenu.vala"
	self->priv->queue_media = _tmp6_;
#line 54 "../src/Widgets/MediaMenu.vala"
	_tmp7_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Add to Playlist"));
#line 54 "../src/Widgets/MediaMenu.vala"
	g_object_ref_sink (_tmp7_);
#line 54 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (self->priv->add_to_playlist);
#line 54 "../src/Widgets/MediaMenu.vala"
	self->priv->add_to_playlist = _tmp7_;
#line 55 "../src/Widgets/MediaMenu.vala"
	_tmp8_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Remove Song…"));
#line 55 "../src/Widgets/MediaMenu.vala"
	g_object_ref_sink (_tmp8_);
#line 55 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (self->priv->remove_media);
#line 55 "../src/Widgets/MediaMenu.vala"
	self->priv->remove_media = _tmp8_;
#line 56 "../src/Widgets/MediaMenu.vala"
	_tmp9_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Import to Library"));
#line 56 "../src/Widgets/MediaMenu.vala"
	g_object_ref_sink (_tmp9_);
#line 56 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (self->priv->import_to_library);
#line 56 "../src/Widgets/MediaMenu.vala"
	self->priv->import_to_library = _tmp9_;
#line 58 "../src/Widgets/MediaMenu.vala"
	_tmp10_ = self->priv->_hint;
#line 58 "../src/Widgets/MediaMenu.vala"
	switch (_tmp10_) {
#line 58 "../src/Widgets/MediaMenu.vala"
		case MUSIC_VIEW_WRAPPER_HINT_ALBUM_LIST:
#line 2531 "MediaMenu.c"
		{
			GtkMenuItem* _tmp11_;
			GtkMenuItem* _tmp12_;
			GtkMenuItem* _tmp13_;
			MusicRatingMenuItem* _tmp14_;
			GtkSeparatorMenuItem* _tmp15_;
			GtkSeparatorMenuItem* _tmp16_;
			GtkMenuItem* _tmp17_;
			GtkMenuItem* _tmp18_;
			GtkSeparatorMenuItem* _tmp19_;
			GtkSeparatorMenuItem* _tmp20_;
			GtkMenuItem* _tmp21_;
			GtkMenuItem* _tmp22_;
#line 60 "../src/Widgets/MediaMenu.vala"
			_tmp11_ = self->priv->edit_media;
#line 60 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp11_);
#line 61 "../src/Widgets/MediaMenu.vala"
			_tmp12_ = file_browse;
#line 61 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp12_);
#line 62 "../src/Widgets/MediaMenu.vala"
			_tmp13_ = self->priv->contractor_entry;
#line 62 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp13_);
#line 63 "../src/Widgets/MediaMenu.vala"
			_tmp14_ = self->priv->rate_media;
#line 63 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp14_);
#line 64 "../src/Widgets/MediaMenu.vala"
			_tmp15_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 64 "../src/Widgets/MediaMenu.vala"
			g_object_ref_sink (_tmp15_);
#line 64 "../src/Widgets/MediaMenu.vala"
			_tmp16_ = _tmp15_;
#line 64 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp16_);
#line 64 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (_tmp16_);
#line 65 "../src/Widgets/MediaMenu.vala"
			_tmp17_ = self->priv->queue_media;
#line 65 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp17_);
#line 66 "../src/Widgets/MediaMenu.vala"
			_tmp18_ = self->priv->add_to_playlist;
#line 66 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp18_);
#line 67 "../src/Widgets/MediaMenu.vala"
			_tmp19_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 67 "../src/Widgets/MediaMenu.vala"
			g_object_ref_sink (_tmp19_);
#line 67 "../src/Widgets/MediaMenu.vala"
			_tmp20_ = _tmp19_;
#line 67 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp20_);
#line 67 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (_tmp20_);
#line 68 "../src/Widgets/MediaMenu.vala"
			_tmp21_ = self->priv->remove_media;
#line 68 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp21_);
#line 69 "../src/Widgets/MediaMenu.vala"
			_tmp22_ = self->priv->remove_media;
#line 69 "../src/Widgets/MediaMenu.vala"
			gtk_menu_item_set_label (_tmp22_, _ ("Remove from Library…"));
#line 70 "../src/Widgets/MediaMenu.vala"
			break;
#line 2599 "MediaMenu.c"
		}
#line 58 "../src/Widgets/MediaMenu.vala"
		case MUSIC_VIEW_WRAPPER_HINT_MUSIC:
#line 58 "../src/Widgets/MediaMenu.vala"
		case MUSIC_VIEW_WRAPPER_HINT_PLAYLIST:
#line 2605 "MediaMenu.c"
		{
			GtkMenuItem* _tmp23_;
			GtkSeparatorMenuItem* _tmp24_;
			GtkSeparatorMenuItem* _tmp25_;
			GtkMenuItem* _tmp26_;
			GtkMenuItem* _tmp27_;
			GtkMenuItem* _tmp28_;
			MusicRatingMenuItem* _tmp29_;
			GtkSeparatorMenuItem* _tmp30_;
			GtkSeparatorMenuItem* _tmp31_;
			GtkMenuItem* _tmp32_;
			GtkMenuItem* _tmp33_;
			GtkSeparatorMenuItem* _tmp34_;
			GtkSeparatorMenuItem* _tmp35_;
			GtkMenuItem* _tmp36_;
			MusicViewWrapperHint _tmp37_;
#line 73 "../src/Widgets/MediaMenu.vala"
			_tmp23_ = _data31_->scroll_to_current;
#line 73 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp23_);
#line 74 "../src/Widgets/MediaMenu.vala"
			_tmp24_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 74 "../src/Widgets/MediaMenu.vala"
			g_object_ref_sink (_tmp24_);
#line 74 "../src/Widgets/MediaMenu.vala"
			_tmp25_ = _tmp24_;
#line 74 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp25_);
#line 74 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (_tmp25_);
#line 75 "../src/Widgets/MediaMenu.vala"
			_tmp26_ = self->priv->edit_media;
#line 75 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp26_);
#line 76 "../src/Widgets/MediaMenu.vala"
			_tmp27_ = file_browse;
#line 76 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp27_);
#line 77 "../src/Widgets/MediaMenu.vala"
			_tmp28_ = self->priv->contractor_entry;
#line 77 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp28_);
#line 78 "../src/Widgets/MediaMenu.vala"
			_tmp29_ = self->priv->rate_media;
#line 78 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp29_);
#line 79 "../src/Widgets/MediaMenu.vala"
			_tmp30_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 79 "../src/Widgets/MediaMenu.vala"
			g_object_ref_sink (_tmp30_);
#line 79 "../src/Widgets/MediaMenu.vala"
			_tmp31_ = _tmp30_;
#line 79 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp31_);
#line 79 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (_tmp31_);
#line 80 "../src/Widgets/MediaMenu.vala"
			_tmp32_ = self->priv->queue_media;
#line 80 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp32_);
#line 81 "../src/Widgets/MediaMenu.vala"
			_tmp33_ = self->priv->add_to_playlist;
#line 81 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp33_);
#line 82 "../src/Widgets/MediaMenu.vala"
			_tmp34_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 82 "../src/Widgets/MediaMenu.vala"
			g_object_ref_sink (_tmp34_);
#line 82 "../src/Widgets/MediaMenu.vala"
			_tmp35_ = _tmp34_;
#line 82 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp35_);
#line 82 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (_tmp35_);
#line 83 "../src/Widgets/MediaMenu.vala"
			_tmp36_ = self->priv->remove_media;
#line 83 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp36_);
#line 84 "../src/Widgets/MediaMenu.vala"
			_tmp37_ = self->priv->_hint;
#line 84 "../src/Widgets/MediaMenu.vala"
			if (_tmp37_ == MUSIC_VIEW_WRAPPER_HINT_MUSIC) {
#line 2688 "MediaMenu.c"
				GtkMenuItem* _tmp38_;
#line 85 "../src/Widgets/MediaMenu.vala"
				_tmp38_ = self->priv->remove_media;
#line 85 "../src/Widgets/MediaMenu.vala"
				gtk_menu_item_set_label (_tmp38_, _ ("Remove from Library…"));
#line 2694 "MediaMenu.c"
			}
#line 87 "../src/Widgets/MediaMenu.vala"
			break;
#line 2698 "MediaMenu.c"
		}
#line 58 "../src/Widgets/MediaMenu.vala"
		case MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO:
#line 2702 "MediaMenu.c"
		{
			GtkMenuItem* _tmp39_;
			GtkSeparatorMenuItem* _tmp40_;
			GtkSeparatorMenuItem* _tmp41_;
			GtkMenuItem* _tmp42_;
			GtkMenuItem* _tmp43_;
			MusicRatingMenuItem* _tmp44_;
			GtkSeparatorMenuItem* _tmp45_;
			GtkSeparatorMenuItem* _tmp46_;
			GtkMenuItem* _tmp47_;
			GtkSeparatorMenuItem* _tmp48_;
			GtkSeparatorMenuItem* _tmp49_;
			GtkMenuItem* _tmp50_;
			GtkMenuItem* _tmp51_;
			GtkMenuItem* _tmp52_;
#line 89 "../src/Widgets/MediaMenu.vala"
			_tmp39_ = _data31_->scroll_to_current;
#line 89 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp39_);
#line 90 "../src/Widgets/MediaMenu.vala"
			_tmp40_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 90 "../src/Widgets/MediaMenu.vala"
			g_object_ref_sink (_tmp40_);
#line 90 "../src/Widgets/MediaMenu.vala"
			_tmp41_ = _tmp40_;
#line 90 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp41_);
#line 90 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (_tmp41_);
#line 91 "../src/Widgets/MediaMenu.vala"
			_tmp42_ = file_browse;
#line 91 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp42_);
#line 92 "../src/Widgets/MediaMenu.vala"
			_tmp43_ = self->priv->contractor_entry;
#line 92 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp43_);
#line 93 "../src/Widgets/MediaMenu.vala"
			_tmp44_ = self->priv->rate_media;
#line 93 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp44_);
#line 94 "../src/Widgets/MediaMenu.vala"
			_tmp45_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 94 "../src/Widgets/MediaMenu.vala"
			g_object_ref_sink (_tmp45_);
#line 94 "../src/Widgets/MediaMenu.vala"
			_tmp46_ = _tmp45_;
#line 94 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp46_);
#line 94 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (_tmp46_);
#line 95 "../src/Widgets/MediaMenu.vala"
			_tmp47_ = self->priv->queue_media;
#line 95 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp47_);
#line 96 "../src/Widgets/MediaMenu.vala"
			_tmp48_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 96 "../src/Widgets/MediaMenu.vala"
			g_object_ref_sink (_tmp48_);
#line 96 "../src/Widgets/MediaMenu.vala"
			_tmp49_ = _tmp48_;
#line 96 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp49_);
#line 96 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (_tmp49_);
#line 97 "../src/Widgets/MediaMenu.vala"
			_tmp50_ = self->priv->remove_media;
#line 97 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp50_);
#line 98 "../src/Widgets/MediaMenu.vala"
			_tmp51_ = self->priv->import_to_library;
#line 98 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp51_);
#line 99 "../src/Widgets/MediaMenu.vala"
			_tmp52_ = self->priv->remove_media;
#line 99 "../src/Widgets/MediaMenu.vala"
			gtk_menu_item_set_label (_tmp52_, _ ("Remove from Device"));
#line 100 "../src/Widgets/MediaMenu.vala"
			break;
#line 2782 "MediaMenu.c"
		}
#line 58 "../src/Widgets/MediaMenu.vala"
		case MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST:
#line 2786 "MediaMenu.c"
		{
			GtkMenuItem* _tmp53_;
			GtkSeparatorMenuItem* _tmp54_;
			GtkSeparatorMenuItem* _tmp55_;
			GtkMenuItem* _tmp56_;
			GtkMenuItem* _tmp57_;
			GtkMenuItem* _tmp58_;
			MusicRatingMenuItem* _tmp59_;
			GtkSeparatorMenuItem* _tmp60_;
			GtkSeparatorMenuItem* _tmp61_;
			GtkMenuItem* _tmp62_;
			GtkMenuItem* _tmp63_;
#line 102 "../src/Widgets/MediaMenu.vala"
			_tmp53_ = _data31_->scroll_to_current;
#line 102 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp53_);
#line 103 "../src/Widgets/MediaMenu.vala"
			_tmp54_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 103 "../src/Widgets/MediaMenu.vala"
			g_object_ref_sink (_tmp54_);
#line 103 "../src/Widgets/MediaMenu.vala"
			_tmp55_ = _tmp54_;
#line 103 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp55_);
#line 103 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (_tmp55_);
#line 104 "../src/Widgets/MediaMenu.vala"
			_tmp56_ = self->priv->edit_media;
#line 104 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp56_);
#line 105 "../src/Widgets/MediaMenu.vala"
			_tmp57_ = file_browse;
#line 105 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp57_);
#line 106 "../src/Widgets/MediaMenu.vala"
			_tmp58_ = self->priv->contractor_entry;
#line 106 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp58_);
#line 107 "../src/Widgets/MediaMenu.vala"
			_tmp59_ = self->priv->rate_media;
#line 107 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp59_);
#line 108 "../src/Widgets/MediaMenu.vala"
			_tmp60_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 108 "../src/Widgets/MediaMenu.vala"
			g_object_ref_sink (_tmp60_);
#line 108 "../src/Widgets/MediaMenu.vala"
			_tmp61_ = _tmp60_;
#line 108 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp61_);
#line 108 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (_tmp61_);
#line 109 "../src/Widgets/MediaMenu.vala"
			_tmp62_ = self->priv->queue_media;
#line 109 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp62_);
#line 110 "../src/Widgets/MediaMenu.vala"
			_tmp63_ = self->priv->add_to_playlist;
#line 110 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp63_);
#line 111 "../src/Widgets/MediaMenu.vala"
			break;
#line 2849 "MediaMenu.c"
		}
#line 58 "../src/Widgets/MediaMenu.vala"
		case MUSIC_VIEW_WRAPPER_HINT_QUEUE:
#line 2853 "MediaMenu.c"
		{
			GtkMenuItem* _tmp64_;
			GtkSeparatorMenuItem* _tmp65_;
			GtkSeparatorMenuItem* _tmp66_;
			GtkMenuItem* _tmp67_;
			GtkMenuItem* _tmp68_;
			GtkSeparatorMenuItem* _tmp69_;
			GtkSeparatorMenuItem* _tmp70_;
			GtkMenuItem* _tmp71_;
			GtkMenuItem* _tmp72_;
#line 113 "../src/Widgets/MediaMenu.vala"
			_tmp64_ = _data31_->scroll_to_current;
#line 113 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp64_);
#line 114 "../src/Widgets/MediaMenu.vala"
			_tmp65_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 114 "../src/Widgets/MediaMenu.vala"
			g_object_ref_sink (_tmp65_);
#line 114 "../src/Widgets/MediaMenu.vala"
			_tmp66_ = _tmp65_;
#line 114 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp66_);
#line 114 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (_tmp66_);
#line 115 "../src/Widgets/MediaMenu.vala"
			_tmp67_ = file_browse;
#line 115 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp67_);
#line 116 "../src/Widgets/MediaMenu.vala"
			_tmp68_ = self->priv->contractor_entry;
#line 116 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp68_);
#line 117 "../src/Widgets/MediaMenu.vala"
			_tmp69_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 117 "../src/Widgets/MediaMenu.vala"
			g_object_ref_sink (_tmp69_);
#line 117 "../src/Widgets/MediaMenu.vala"
			_tmp70_ = _tmp69_;
#line 117 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp70_);
#line 117 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (_tmp70_);
#line 118 "../src/Widgets/MediaMenu.vala"
			_tmp71_ = self->priv->remove_media;
#line 118 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp71_);
#line 119 "../src/Widgets/MediaMenu.vala"
			_tmp72_ = self->priv->remove_media;
#line 119 "../src/Widgets/MediaMenu.vala"
			gtk_menu_item_set_label (_tmp72_, _ ("Remove from Queue"));
#line 120 "../src/Widgets/MediaMenu.vala"
			break;
#line 2906 "MediaMenu.c"
		}
		default:
#line 58 "../src/Widgets/MediaMenu.vala"
		case MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST:
#line 2911 "MediaMenu.c"
		{
			GtkMenuItem* _tmp73_;
			GtkSeparatorMenuItem* _tmp74_;
			GtkSeparatorMenuItem* _tmp75_;
			GtkMenuItem* _tmp76_;
			GtkMenuItem* _tmp77_;
#line 123 "../src/Widgets/MediaMenu.vala"
			_tmp73_ = _data31_->scroll_to_current;
#line 123 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp73_);
#line 124 "../src/Widgets/MediaMenu.vala"
			_tmp74_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 124 "../src/Widgets/MediaMenu.vala"
			g_object_ref_sink (_tmp74_);
#line 124 "../src/Widgets/MediaMenu.vala"
			_tmp75_ = _tmp74_;
#line 124 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp75_);
#line 124 "../src/Widgets/MediaMenu.vala"
			_g_object_unref0 (_tmp75_);
#line 125 "../src/Widgets/MediaMenu.vala"
			_tmp76_ = file_browse;
#line 125 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp76_);
#line 126 "../src/Widgets/MediaMenu.vala"
			_tmp77_ = self->priv->contractor_entry;
#line 126 "../src/Widgets/MediaMenu.vala"
			gtk_menu_shell_append ((GtkMenuShell*) self, _tmp77_);
#line 127 "../src/Widgets/MediaMenu.vala"
			break;
#line 2942 "MediaMenu.c"
		}
	}
#line 130 "../src/Widgets/MediaMenu.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 132 "../src/Widgets/MediaMenu.vala"
	_tmp78_ = _data31_->scroll_to_current;
#line 132 "../src/Widgets/MediaMenu.vala"
	g_signal_connect_object (_tmp78_, "activate", (GCallback) __music_media_menu___lambda60__gtk_menu_item_activate, self, 0);
#line 136 "../src/Widgets/MediaMenu.vala"
	_tmp79_ = music_app_get_player ();
#line 136 "../src/Widgets/MediaMenu.vala"
	_tmp80_ = _tmp79_;
#line 136 "../src/Widgets/MediaMenu.vala"
	g_signal_connect_data (_tmp80_, "playback-stopped", (GCallback) __music_media_menu___lambda61__music_playback_manager_playback_stopped, block31_data_ref (_data31_), (GClosureNotify) block31_data_unref, 0);
#line 140 "../src/Widgets/MediaMenu.vala"
	_tmp81_ = music_app_get_player ();
#line 140 "../src/Widgets/MediaMenu.vala"
	_tmp82_ = _tmp81_;
#line 140 "../src/Widgets/MediaMenu.vala"
	g_signal_connect_data (_tmp82_, "playback-started", (GCallback) __music_media_menu___lambda62__music_playback_manager_playback_started, block31_data_ref (_data31_), (GClosureNotify) block31_data_unref, 0);
#line 144 "../src/Widgets/MediaMenu.vala"
	_tmp83_ = self->priv->edit_media;
#line 144 "../src/Widgets/MediaMenu.vala"
	g_signal_connect_object (_tmp83_, "activate", (GCallback) _music_media_menu_edit_media_clicked_gtk_menu_item_activate, self, 0);
#line 145 "../src/Widgets/MediaMenu.vala"
	_tmp84_ = file_browse;
#line 145 "../src/Widgets/MediaMenu.vala"
	g_signal_connect_object (_tmp84_, "activate", (GCallback) _music_media_menu_file_browse_clicked_gtk_menu_item_activate, self, 0);
#line 146 "../src/Widgets/MediaMenu.vala"
	_tmp85_ = self->priv->import_to_library;
#line 146 "../src/Widgets/MediaMenu.vala"
	g_signal_connect_object (_tmp85_, "activate", (GCallback) _music_media_menu_import_to_library_clicked_gtk_menu_item_activate, self, 0);
#line 147 "../src/Widgets/MediaMenu.vala"
	_tmp86_ = self->priv->queue_media;
#line 147 "../src/Widgets/MediaMenu.vala"
	g_signal_connect_object (_tmp86_, "activate", (GCallback) _music_media_menu_queue_clicked_gtk_menu_item_activate, self, 0);
#line 148 "../src/Widgets/MediaMenu.vala"
	_tmp87_ = self->priv->rate_media;
#line 148 "../src/Widgets/MediaMenu.vala"
	g_signal_connect_object ((GtkMenuItem*) _tmp87_, "activate", (GCallback) _music_media_menu_rate_media_clicked_gtk_menu_item_activate, self, 0);
#line 149 "../src/Widgets/MediaMenu.vala"
	_tmp88_ = self->priv->remove_media;
#line 149 "../src/Widgets/MediaMenu.vala"
	g_signal_connect_object (_tmp88_, "activate", (GCallback) _music_media_menu_remove_media_clicked_gtk_menu_item_activate, self, 0);
#line 45 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (file_browse);
#line 45 "../src/Widgets/MediaMenu.vala"
	block31_data_unref (_data31_);
#line 45 "../src/Widgets/MediaMenu.vala"
	_data31_ = NULL;
#line 45 "../src/Widgets/MediaMenu.vala"
	return obj;
#line 2995 "MediaMenu.c"
}

static void
music_media_menu_class_init (MusicMediaMenuClass * klass,
                             gpointer klass_data)
{
#line 26 "../src/Widgets/MediaMenu.vala"
	music_media_menu_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/Widgets/MediaMenu.vala"
	g_type_class_adjust_private_offset (klass, &MusicMediaMenu_private_offset);
#line 26 "../src/Widgets/MediaMenu.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_media_menu_get_property;
#line 26 "../src/Widgets/MediaMenu.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_media_menu_set_property;
#line 26 "../src/Widgets/MediaMenu.vala"
	G_OBJECT_CLASS (klass)->constructor = music_media_menu_constructor;
#line 26 "../src/Widgets/MediaMenu.vala"
	G_OBJECT_CLASS (klass)->finalize = music_media_menu_finalize;
#line 26 "../src/Widgets/MediaMenu.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_MENU_HINT_PROPERTY, music_media_menu_properties[MUSIC_MEDIA_MENU_HINT_PROPERTY] = g_param_spec_enum ("hint", "hint", "hint", MUSIC_VIEW_WRAPPER_TYPE_HINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 26 "../src/Widgets/MediaMenu.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_MENU_GENERIC_LIST_PROPERTY, music_media_menu_properties[MUSIC_MEDIA_MENU_GENERIC_LIST_PROPERTY] = g_param_spec_object ("generic-list", "generic-list", "generic-list", MUSIC_TYPE_GENERIC_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 3018 "MediaMenu.c"
}

static void
music_media_menu_instance_init (MusicMediaMenu * self,
                                gpointer klass)
{
#line 26 "../src/Widgets/MediaMenu.vala"
	self->priv = music_media_menu_get_instance_private (self);
#line 3027 "MediaMenu.c"
}

static void
music_media_menu_finalize (GObject * obj)
{
	MusicMediaMenu * self;
#line 26 "../src/Widgets/MediaMenu.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MEDIA_MENU, MusicMediaMenu);
#line 28 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (self->priv->_generic_list);
#line 30 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (self->priv->add_to_playlist);
#line 31 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (self->priv->contractor_entry);
#line 32 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (self->priv->edit_media);
#line 33 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (self->priv->import_to_library);
#line 34 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (self->priv->queue_media);
#line 35 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (self->priv->rate_media);
#line 36 "../src/Widgets/MediaMenu.vala"
	_g_object_unref0 (self->priv->remove_media);
#line 26 "../src/Widgets/MediaMenu.vala"
	G_OBJECT_CLASS (music_media_menu_parent_class)->finalize (obj);
#line 3054 "MediaMenu.c"
}

static GType
music_media_menu_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicMediaMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_media_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicMediaMenu), 0, (GInstanceInitFunc) music_media_menu_instance_init, NULL };
	GType music_media_menu_type_id;
	music_media_menu_type_id = g_type_register_static (gtk_menu_get_type (), "MusicMediaMenu", &g_define_type_info, 0);
	MusicMediaMenu_private_offset = g_type_add_instance_private (music_media_menu_type_id, sizeof (MusicMediaMenuPrivate));
	return music_media_menu_type_id;
}

GType
music_media_menu_get_type (void)
{
	static volatile gsize music_media_menu_type_id__once = 0;
	if (g_once_init_enter (&music_media_menu_type_id__once)) {
		GType music_media_menu_type_id;
		music_media_menu_type_id = music_media_menu_get_type_once ();
		g_once_init_leave (&music_media_menu_type_id__once, music_media_menu_type_id);
	}
	return music_media_menu_type_id__once;
}

static void
_vala_music_media_menu_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	MusicMediaMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_MEDIA_MENU, MusicMediaMenu);
#line 26 "../src/Widgets/MediaMenu.vala"
	switch (property_id) {
#line 26 "../src/Widgets/MediaMenu.vala"
		case MUSIC_MEDIA_MENU_HINT_PROPERTY:
#line 26 "../src/Widgets/MediaMenu.vala"
		g_value_set_enum (value, music_media_menu_get_hint (self));
#line 26 "../src/Widgets/MediaMenu.vala"
		break;
#line 26 "../src/Widgets/MediaMenu.vala"
		case MUSIC_MEDIA_MENU_GENERIC_LIST_PROPERTY:
#line 26 "../src/Widgets/MediaMenu.vala"
		g_value_set_object (value, music_media_menu_get_generic_list (self));
#line 26 "../src/Widgets/MediaMenu.vala"
		break;
#line 3101 "MediaMenu.c"
		default:
#line 26 "../src/Widgets/MediaMenu.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/Widgets/MediaMenu.vala"
		break;
#line 3107 "MediaMenu.c"
	}
}

static void
_vala_music_media_menu_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	MusicMediaMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_MEDIA_MENU, MusicMediaMenu);
#line 26 "../src/Widgets/MediaMenu.vala"
	switch (property_id) {
#line 26 "../src/Widgets/MediaMenu.vala"
		case MUSIC_MEDIA_MENU_HINT_PROPERTY:
#line 26 "../src/Widgets/MediaMenu.vala"
		music_media_menu_set_hint (self, g_value_get_enum (value));
#line 26 "../src/Widgets/MediaMenu.vala"
		break;
#line 26 "../src/Widgets/MediaMenu.vala"
		case MUSIC_MEDIA_MENU_GENERIC_LIST_PROPERTY:
#line 26 "../src/Widgets/MediaMenu.vala"
		music_media_menu_set_generic_list (self, g_value_get_object (value));
#line 26 "../src/Widgets/MediaMenu.vala"
		break;
#line 3133 "MediaMenu.c"
		default:
#line 26 "../src/Widgets/MediaMenu.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/Widgets/MediaMenu.vala"
		break;
#line 3139 "MediaMenu.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

