/* ViewSelector.c generated by valac 0.56.0, the Vala compiler
 * generated from ViewSelector.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <granite.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <handy.h>

#define MUSIC_LIBRARY_WINDOW_ACTION_PREFIX "win."
#define MUSIC_LIBRARY_WINDOW_ACTION_VIEW_ALBUMS "action_view_albums"
#define MUSIC_LIBRARY_WINDOW_ACTION_VIEW_LIST "action_view_list"
#define MUSIC_LIBRARY_WINDOW_ACTION_VIEW_COLUMNS "action_view_columns"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_WIDGETS_TYPE_VIEW_SELECTOR (music_widgets_view_selector_get_type ())
#define MUSIC_WIDGETS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelector))
#define MUSIC_WIDGETS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelectorClass))
#define MUSIC_WIDGETS_IS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR))
#define MUSIC_WIDGETS_IS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR))
#define MUSIC_WIDGETS_VIEW_SELECTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelectorClass))

typedef struct _MusicWidgetsViewSelector MusicWidgetsViewSelector;
typedef struct _MusicWidgetsViewSelectorClass MusicWidgetsViewSelectorClass;
typedef struct _MusicWidgetsViewSelectorPrivate MusicWidgetsViewSelectorPrivate;
typedef enum  {
	MUSIC_WIDGETS_VIEW_SELECTOR_MODE_GRID = 0,
	MUSIC_WIDGETS_VIEW_SELECTOR_MODE_LIST = 1,
	MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN = 2
} MusicWidgetsViewSelectorMode;

#define MUSIC_WIDGETS_VIEW_SELECTOR_TYPE_MODE (music_widgets_view_selector_mode_get_type ())
enum  {
	MUSIC_WIDGETS_VIEW_SELECTOR_0_PROPERTY,
	MUSIC_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY,
	MUSIC_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY,
	MUSIC_WIDGETS_VIEW_SELECTOR_NUM_PROPERTIES
};
static GParamSpec* music_widgets_view_selector_properties[MUSIC_WIDGETS_VIEW_SELECTOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define MUSIC_TYPE_LIBRARY_WINDOW (music_library_window_get_type ())
#define MUSIC_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow))
#define MUSIC_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))
#define MUSIC_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))

typedef struct _MusicLibraryWindow MusicLibraryWindow;
typedef struct _MusicLibraryWindowClass MusicLibraryWindowClass;
enum  {
	MUSIC_WIDGETS_VIEW_SELECTOR_MODE_CHANGED_SIGNAL,
	MUSIC_WIDGETS_VIEW_SELECTOR_COLUMN_BROWSER_TOGGLED_SIGNAL,
	MUSIC_WIDGETS_VIEW_SELECTOR_NUM_SIGNALS
};
static guint music_widgets_view_selector_signals[MUSIC_WIDGETS_VIEW_SELECTOR_NUM_SIGNALS] = {0};

struct _MusicWidgetsViewSelector {
	GtkToolItem parent_instance;
	MusicWidgetsViewSelectorPrivate * priv;
};

struct _MusicWidgetsViewSelectorClass {
	GtkToolItemClass parent_class;
};

struct _MusicWidgetsViewSelectorPrivate {
	GraniteWidgetsModeButton* mode_button;
	MusicWidgetsViewSelectorMode mode;
};

static gint MusicWidgetsViewSelector_private_offset;
static gpointer music_widgets_view_selector_parent_class = NULL;

VALA_EXTERN GType music_widgets_view_selector_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicWidgetsViewSelector, g_object_unref)
VALA_EXTERN GType music_widgets_view_selector_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MusicWidgetsViewSelector* music_widgets_view_selector_new (void);
VALA_EXTERN MusicWidgetsViewSelector* music_widgets_view_selector_construct (GType object_type);
static void __lambda58_ (MusicWidgetsViewSelector* self);
VALA_EXTERN void music_widgets_view_selector_set_selected (MusicWidgetsViewSelector* self,
                                               MusicWidgetsViewSelectorMode value);
static void ___lambda58__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                            GtkWidget* widget,
                                                            gpointer self);
VALA_EXTERN gboolean music_widgets_view_selector_get_column_browser_toggle_active (MusicWidgetsViewSelector* self);
VALA_EXTERN void music_widgets_view_selector_set_column_browser_toggle_active (MusicWidgetsViewSelector* self,
                                                                   gboolean active);
VALA_EXTERN MusicWidgetsViewSelectorMode music_widgets_view_selector_get_selected (MusicWidgetsViewSelector* self);
VALA_EXTERN gboolean music_widgets_view_selector_get_sensitive (MusicWidgetsViewSelector* self);
VALA_EXTERN void music_widgets_view_selector_set_sensitive (MusicWidgetsViewSelector* self,
                                                gboolean value);
VALA_EXTERN GType music_library_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLibraryWindow, g_object_unref)
VALA_EXTERN MusicLibraryWindow* music_app_get_main_window (void);
static void music_widgets_view_selector_finalize (GObject * obj);
static GType music_widgets_view_selector_get_type_once (void);
static void _vala_music_widgets_view_selector_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_music_widgets_view_selector_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
music_widgets_view_selector_get_instance_private (MusicWidgetsViewSelector* self)
{
	return G_STRUCT_MEMBER_P (self, MusicWidgetsViewSelector_private_offset);
}

static GType
music_widgets_view_selector_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_WIDGETS_VIEW_SELECTOR_MODE_GRID, "MUSIC_WIDGETS_VIEW_SELECTOR_MODE_GRID", "grid"}, {MUSIC_WIDGETS_VIEW_SELECTOR_MODE_LIST, "MUSIC_WIDGETS_VIEW_SELECTOR_MODE_LIST", "list"}, {MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN, "MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN", "column"}, {0, NULL, NULL}};
	GType music_widgets_view_selector_mode_type_id;
	music_widgets_view_selector_mode_type_id = g_enum_register_static ("MusicWidgetsViewSelectorMode", values);
	return music_widgets_view_selector_mode_type_id;
}

GType
music_widgets_view_selector_mode_get_type (void)
{
	static volatile gsize music_widgets_view_selector_mode_type_id__once = 0;
	if (g_once_init_enter (&music_widgets_view_selector_mode_type_id__once)) {
		GType music_widgets_view_selector_mode_type_id;
		music_widgets_view_selector_mode_type_id = music_widgets_view_selector_mode_get_type_once ();
		g_once_init_leave (&music_widgets_view_selector_mode_type_id__once, music_widgets_view_selector_mode_type_id);
	}
	return music_widgets_view_selector_mode_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 76 "../src/Widgets/ViewSelector.vala"
	return self ? g_object_ref (self) : NULL;
#line 186 "ViewSelector.c"
}

static void
__lambda58_ (MusicWidgetsViewSelector* self)
{
	gint new_mode = 0;
	GraniteWidgetsModeButton* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 104 "../src/Widgets/ViewSelector.vala"
	_tmp0_ = self->priv->mode_button;
#line 104 "../src/Widgets/ViewSelector.vala"
	_tmp1_ = granite_widgets_mode_button_get_selected (_tmp0_);
#line 104 "../src/Widgets/ViewSelector.vala"
	_tmp2_ = _tmp1_;
#line 104 "../src/Widgets/ViewSelector.vala"
	new_mode = _tmp2_;
#line 105 "../src/Widgets/ViewSelector.vala"
	if (new_mode <= 2) {
#line 106 "../src/Widgets/ViewSelector.vala"
		music_widgets_view_selector_set_selected (self, (MusicWidgetsViewSelectorMode) new_mode);
#line 208 "ViewSelector.c"
	} else {
		GraniteWidgetsModeButton* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 107 "../src/Widgets/ViewSelector.vala"
		_tmp3_ = self->priv->mode_button;
#line 107 "../src/Widgets/ViewSelector.vala"
		_tmp4_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp3_);
#line 107 "../src/Widgets/ViewSelector.vala"
		_tmp5_ = _tmp4_;
#line 107 "../src/Widgets/ViewSelector.vala"
		if (_tmp5_) {
#line 108 "../src/Widgets/ViewSelector.vala"
			music_widgets_view_selector_set_selected (self, self->priv->mode);
#line 223 "ViewSelector.c"
		}
	}
}

static void
___lambda58__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                       GtkWidget* widget,
                                                       gpointer self)
{
#line 103 "../src/Widgets/ViewSelector.vala"
	__lambda58_ ((MusicWidgetsViewSelector*) self);
#line 235 "ViewSelector.c"
}

MusicWidgetsViewSelector*
music_widgets_view_selector_construct (GType object_type)
{
	MusicWidgetsViewSelector * self = NULL;
	GtkApplication* application_instance = NULL;
	GApplication* _tmp0_;
	GtkApplication* _tmp1_;
	GtkImage* image = NULL;
	GtkImage* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GtkImage* list = NULL;
	GtkImage* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GtkImage* column = NULL;
	GtkImage* _tmp14_;
	gchar** _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gchar* _tmp18_;
	gchar* _tmp19_;
	GraniteWidgetsModeButton* _tmp20_;
	GraniteWidgetsModeButton* _tmp21_;
	GraniteWidgetsModeButton* _tmp22_;
	GraniteWidgetsModeButton* _tmp23_;
	GraniteWidgetsModeButton* _tmp24_;
	GraniteWidgetsModeButton* _tmp25_;
#line 75 "../src/Widgets/ViewSelector.vala"
	self = (MusicWidgetsViewSelector*) g_object_new (object_type, NULL);
#line 76 "../src/Widgets/ViewSelector.vala"
	_tmp0_ = g_application_get_default ();
#line 76 "../src/Widgets/ViewSelector.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication));
#line 76 "../src/Widgets/ViewSelector.vala"
	application_instance = _tmp1_;
#line 78 "../src/Widgets/ViewSelector.vala"
	_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("view-grid-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 78 "../src/Widgets/ViewSelector.vala"
	g_object_ref_sink (_tmp2_);
#line 78 "../src/Widgets/ViewSelector.vala"
	image = _tmp2_;
#line 79 "../src/Widgets/ViewSelector.vala"
	_tmp4_ = _tmp3_ = gtk_application_get_accels_for_action (application_instance, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_VIEW_ALBUMS);
#line 79 "../src/Widgets/ViewSelector.vala"
	_tmp5_ = _tmp4_;
#line 79 "../src/Widgets/ViewSelector.vala"
	_tmp5__length1 = _vala_array_length (_tmp3_);
#line 79 "../src/Widgets/ViewSelector.vala"
	_tmp6_ = granite_markup_accel_tooltip (_tmp5_, (gint) _vala_array_length (_tmp3_), _ ("View as albums"));
#line 79 "../src/Widgets/ViewSelector.vala"
	_tmp7_ = _tmp6_;
#line 79 "../src/Widgets/ViewSelector.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) image, _tmp7_);
#line 79 "../src/Widgets/ViewSelector.vala"
	_g_free0 (_tmp7_);
#line 79 "../src/Widgets/ViewSelector.vala"
	_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 84 "../src/Widgets/ViewSelector.vala"
	_tmp8_ = (GtkImage*) gtk_image_new_from_icon_name ("view-list-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 84 "../src/Widgets/ViewSelector.vala"
	g_object_ref_sink (_tmp8_);
#line 84 "../src/Widgets/ViewSelector.vala"
	list = _tmp8_;
#line 85 "../src/Widgets/ViewSelector.vala"
	_tmp10_ = _tmp9_ = gtk_application_get_accels_for_action (application_instance, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_VIEW_LIST);
#line 85 "../src/Widgets/ViewSelector.vala"
	_tmp11_ = _tmp10_;
#line 85 "../src/Widgets/ViewSelector.vala"
	_tmp11__length1 = _vala_array_length (_tmp9_);
#line 85 "../src/Widgets/ViewSelector.vala"
	_tmp12_ = granite_markup_accel_tooltip (_tmp11_, (gint) _vala_array_length (_tmp9_), _ ("View as list"));
#line 85 "../src/Widgets/ViewSelector.vala"
	_tmp13_ = _tmp12_;
#line 85 "../src/Widgets/ViewSelector.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) list, _tmp13_);
#line 85 "../src/Widgets/ViewSelector.vala"
	_g_free0 (_tmp13_);
#line 85 "../src/Widgets/ViewSelector.vala"
	_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 90 "../src/Widgets/ViewSelector.vala"
	_tmp14_ = (GtkImage*) gtk_image_new_from_icon_name ("view-column-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 90 "../src/Widgets/ViewSelector.vala"
	g_object_ref_sink (_tmp14_);
#line 90 "../src/Widgets/ViewSelector.vala"
	column = _tmp14_;
#line 91 "../src/Widgets/ViewSelector.vala"
	_tmp16_ = _tmp15_ = gtk_application_get_accels_for_action (application_instance, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_VIEW_COLUMNS);
#line 91 "../src/Widgets/ViewSelector.vala"
	_tmp17_ = _tmp16_;
#line 91 "../src/Widgets/ViewSelector.vala"
	_tmp17__length1 = _vala_array_length (_tmp15_);
#line 91 "../src/Widgets/ViewSelector.vala"
	_tmp18_ = granite_markup_accel_tooltip (_tmp17_, (gint) _vala_array_length (_tmp15_), _ ("View in columns"));
#line 91 "../src/Widgets/ViewSelector.vala"
	_tmp19_ = _tmp18_;
#line 91 "../src/Widgets/ViewSelector.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) column, _tmp19_);
#line 91 "../src/Widgets/ViewSelector.vala"
	_g_free0 (_tmp19_);
#line 91 "../src/Widgets/ViewSelector.vala"
	_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
#line 96 "../src/Widgets/ViewSelector.vala"
	_tmp20_ = granite_widgets_mode_button_new ();
#line 96 "../src/Widgets/ViewSelector.vala"
	g_object_ref_sink (_tmp20_);
#line 96 "../src/Widgets/ViewSelector.vala"
	_g_object_unref0 (self->priv->mode_button);
#line 96 "../src/Widgets/ViewSelector.vala"
	self->priv->mode_button = _tmp20_;
#line 97 "../src/Widgets/ViewSelector.vala"
	_tmp21_ = self->priv->mode_button;
#line 97 "../src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_append (_tmp21_, (GtkWidget*) image);
#line 98 "../src/Widgets/ViewSelector.vala"
	_tmp22_ = self->priv->mode_button;
#line 98 "../src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_append (_tmp22_, (GtkWidget*) list);
#line 99 "../src/Widgets/ViewSelector.vala"
	_tmp23_ = self->priv->mode_button;
#line 99 "../src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_append (_tmp23_, (GtkWidget*) column);
#line 101 "../src/Widgets/ViewSelector.vala"
	_tmp24_ = self->priv->mode_button;
#line 101 "../src/Widgets/ViewSelector.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp24_);
#line 103 "../src/Widgets/ViewSelector.vala"
	_tmp25_ = self->priv->mode_button;
#line 103 "../src/Widgets/ViewSelector.vala"
	g_signal_connect_object (_tmp25_, "mode-changed", (GCallback) ___lambda58__granite_widgets_mode_button_mode_changed, self, 0);
#line 75 "../src/Widgets/ViewSelector.vala"
	_g_object_unref0 (column);
#line 75 "../src/Widgets/ViewSelector.vala"
	_g_object_unref0 (list);
#line 75 "../src/Widgets/ViewSelector.vala"
	_g_object_unref0 (image);
#line 75 "../src/Widgets/ViewSelector.vala"
	_g_object_unref0 (application_instance);
#line 75 "../src/Widgets/ViewSelector.vala"
	return self;
#line 387 "ViewSelector.c"
}

MusicWidgetsViewSelector*
music_widgets_view_selector_new (void)
{
#line 75 "../src/Widgets/ViewSelector.vala"
	return music_widgets_view_selector_construct (MUSIC_WIDGETS_TYPE_VIEW_SELECTOR);
#line 395 "ViewSelector.c"
}

gboolean
music_widgets_view_selector_get_column_browser_toggle_active (MusicWidgetsViewSelector* self)
{
	gboolean result;
#line 117 "../src/Widgets/ViewSelector.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 118 "../src/Widgets/ViewSelector.vala"
	result = self->priv->mode == MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN;
#line 118 "../src/Widgets/ViewSelector.vala"
	return result;
#line 408 "ViewSelector.c"
}

void
music_widgets_view_selector_set_column_browser_toggle_active (MusicWidgetsViewSelector* self,
                                                              gboolean active)
{
#line 121 "../src/Widgets/ViewSelector.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/Widgets/ViewSelector.vala"
	if (active) {
#line 123 "../src/Widgets/ViewSelector.vala"
		music_widgets_view_selector_set_selected (self, MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN);
#line 421 "ViewSelector.c"
	} else {
#line 124 "../src/Widgets/ViewSelector.vala"
		if (music_widgets_view_selector_get_column_browser_toggle_active (self)) {
#line 125 "../src/Widgets/ViewSelector.vala"
			music_widgets_view_selector_set_selected (self, MUSIC_WIDGETS_VIEW_SELECTOR_MODE_LIST);
#line 427 "ViewSelector.c"
		}
	}
}

MusicWidgetsViewSelectorMode
music_widgets_view_selector_get_selected (MusicWidgetsViewSelector* self)
{
	MusicWidgetsViewSelectorMode result;
	MusicWidgetsViewSelectorMode _tmp0_ = 0;
#line 40 "../src/Widgets/ViewSelector.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 41 "../src/Widgets/ViewSelector.vala"
	if (self->priv->mode != MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN) {
#line 41 "../src/Widgets/ViewSelector.vala"
		_tmp0_ = self->priv->mode;
#line 443 "ViewSelector.c"
	} else {
#line 41 "../src/Widgets/ViewSelector.vala"
		_tmp0_ = MUSIC_WIDGETS_VIEW_SELECTOR_MODE_LIST;
#line 447 "ViewSelector.c"
	}
#line 41 "../src/Widgets/ViewSelector.vala"
	result = _tmp0_;
#line 41 "../src/Widgets/ViewSelector.vala"
	return result;
#line 453 "ViewSelector.c"
}

void
music_widgets_view_selector_set_selected (MusicWidgetsViewSelector* self,
                                          MusicWidgetsViewSelectorMode value)
{
	GraniteWidgetsModeButton* _tmp0_;
	gboolean is_column_mode = FALSE;
	MusicWidgetsViewSelectorMode _tmp1_ = 0;
#line 43 "../src/Widgets/ViewSelector.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/Widgets/ViewSelector.vala"
	if (self->priv->mode == value) {
#line 45 "../src/Widgets/ViewSelector.vala"
		return;
#line 469 "ViewSelector.c"
	}
#line 48 "../src/Widgets/ViewSelector.vala"
	self->priv->mode = value;
#line 49 "../src/Widgets/ViewSelector.vala"
	_tmp0_ = self->priv->mode_button;
#line 49 "../src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_set_selected (_tmp0_, (gint) value);
#line 51 "../src/Widgets/ViewSelector.vala"
	is_column_mode = value == MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN;
#line 52 "../src/Widgets/ViewSelector.vala"
	g_signal_emit (self, music_widgets_view_selector_signals[MUSIC_WIDGETS_VIEW_SELECTOR_COLUMN_BROWSER_TOGGLED_SIGNAL], 0, is_column_mode);
#line 53 "../src/Widgets/ViewSelector.vala"
	if (is_column_mode) {
#line 53 "../src/Widgets/ViewSelector.vala"
		_tmp1_ = MUSIC_WIDGETS_VIEW_SELECTOR_MODE_LIST;
#line 485 "ViewSelector.c"
	} else {
#line 53 "../src/Widgets/ViewSelector.vala"
		_tmp1_ = value;
#line 489 "ViewSelector.c"
	}
#line 53 "../src/Widgets/ViewSelector.vala"
	g_signal_emit (self, music_widgets_view_selector_signals[MUSIC_WIDGETS_VIEW_SELECTOR_MODE_CHANGED_SIGNAL], 0, _tmp1_);
#line 43 "../src/Widgets/ViewSelector.vala"
	g_object_notify_by_pspec ((GObject *) self, music_widgets_view_selector_properties[MUSIC_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY]);
#line 495 "ViewSelector.c"
}

gboolean
music_widgets_view_selector_get_sensitive (MusicWidgetsViewSelector* self)
{
	gboolean result;
	GraniteWidgetsModeButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 59 "../src/Widgets/ViewSelector.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 60 "../src/Widgets/ViewSelector.vala"
	_tmp0_ = self->priv->mode_button;
#line 60 "../src/Widgets/ViewSelector.vala"
	_tmp1_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp0_);
#line 60 "../src/Widgets/ViewSelector.vala"
	_tmp2_ = _tmp1_;
#line 60 "../src/Widgets/ViewSelector.vala"
	result = _tmp2_;
#line 60 "../src/Widgets/ViewSelector.vala"
	return result;
#line 517 "ViewSelector.c"
}

void
music_widgets_view_selector_set_sensitive (MusicWidgetsViewSelector* self,
                                           gboolean value)
{
	GraniteWidgetsModeButton* _tmp0_;
	gint _tmp1_ = 0;
	GraniteWidgetsModeButton* _tmp2_;
	MusicLibraryWindow* _tmp3_;
	MusicLibraryWindow* _tmp4_;
	GAction* _tmp5_;
	MusicLibraryWindow* _tmp6_;
	MusicLibraryWindow* _tmp7_;
	GAction* _tmp8_;
	MusicLibraryWindow* _tmp9_;
	MusicLibraryWindow* _tmp10_;
	GAction* _tmp11_;
#line 62 "../src/Widgets/ViewSelector.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/Widgets/ViewSelector.vala"
	_tmp0_ = self->priv->mode_button;
#line 64 "../src/Widgets/ViewSelector.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, value);
#line 65 "../src/Widgets/ViewSelector.vala"
	if (value) {
#line 65 "../src/Widgets/ViewSelector.vala"
		_tmp1_ = (gint) self->priv->mode;
#line 546 "ViewSelector.c"
	} else {
#line 65 "../src/Widgets/ViewSelector.vala"
		_tmp1_ = -1;
#line 550 "ViewSelector.c"
	}
#line 65 "../src/Widgets/ViewSelector.vala"
	_tmp2_ = self->priv->mode_button;
#line 65 "../src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_set_active (_tmp2_, _tmp1_);
#line 66 "../src/Widgets/ViewSelector.vala"
	_tmp3_ = music_app_get_main_window ();
#line 66 "../src/Widgets/ViewSelector.vala"
	_tmp4_ = _tmp3_;
#line 66 "../src/Widgets/ViewSelector.vala"
	_tmp5_ = g_action_map_lookup_action ((GActionMap*) _tmp4_, MUSIC_LIBRARY_WINDOW_ACTION_VIEW_ALBUMS);
#line 66 "../src/Widgets/ViewSelector.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_simple_action_get_type (), GSimpleAction), value);
#line 67 "../src/Widgets/ViewSelector.vala"
	_tmp6_ = music_app_get_main_window ();
#line 67 "../src/Widgets/ViewSelector.vala"
	_tmp7_ = _tmp6_;
#line 67 "../src/Widgets/ViewSelector.vala"
	_tmp8_ = g_action_map_lookup_action ((GActionMap*) _tmp7_, MUSIC_LIBRARY_WINDOW_ACTION_VIEW_LIST);
#line 67 "../src/Widgets/ViewSelector.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_simple_action_get_type (), GSimpleAction), value);
#line 68 "../src/Widgets/ViewSelector.vala"
	_tmp9_ = music_app_get_main_window ();
#line 68 "../src/Widgets/ViewSelector.vala"
	_tmp10_ = _tmp9_;
#line 68 "../src/Widgets/ViewSelector.vala"
	_tmp11_ = g_action_map_lookup_action ((GActionMap*) _tmp10_, MUSIC_LIBRARY_WINDOW_ACTION_VIEW_COLUMNS);
#line 68 "../src/Widgets/ViewSelector.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, g_simple_action_get_type (), GSimpleAction), value);
#line 62 "../src/Widgets/ViewSelector.vala"
	g_object_notify_by_pspec ((GObject *) self, music_widgets_view_selector_properties[MUSIC_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY]);
#line 582 "ViewSelector.c"
}

static void
music_widgets_view_selector_class_init (MusicWidgetsViewSelectorClass * klass,
                                        gpointer klass_data)
{
#line 27 "../src/Widgets/ViewSelector.vala"
	music_widgets_view_selector_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/Widgets/ViewSelector.vala"
	g_type_class_adjust_private_offset (klass, &MusicWidgetsViewSelector_private_offset);
#line 27 "../src/Widgets/ViewSelector.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_widgets_view_selector_get_property;
#line 27 "../src/Widgets/ViewSelector.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_widgets_view_selector_set_property;
#line 27 "../src/Widgets/ViewSelector.vala"
	G_OBJECT_CLASS (klass)->finalize = music_widgets_view_selector_finalize;
#line 27 "../src/Widgets/ViewSelector.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY, music_widgets_view_selector_properties[MUSIC_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY] = g_param_spec_enum ("selected", "selected", "selected", MUSIC_WIDGETS_VIEW_SELECTOR_TYPE_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/Widgets/ViewSelector.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY, music_widgets_view_selector_properties[MUSIC_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY] = g_param_spec_boolean ("sensitive", "sensitive", "sensitive", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/Widgets/ViewSelector.vala"
	music_widgets_view_selector_signals[MUSIC_WIDGETS_VIEW_SELECTOR_MODE_CHANGED_SIGNAL] = g_signal_new ("mode-changed", MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, MUSIC_WIDGETS_VIEW_SELECTOR_TYPE_MODE);
#line 27 "../src/Widgets/ViewSelector.vala"
	music_widgets_view_selector_signals[MUSIC_WIDGETS_VIEW_SELECTOR_COLUMN_BROWSER_TOGGLED_SIGNAL] = g_signal_new ("column-browser-toggled", MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 607 "ViewSelector.c"
}

static void
music_widgets_view_selector_instance_init (MusicWidgetsViewSelector * self,
                                           gpointer klass)
{
#line 27 "../src/Widgets/ViewSelector.vala"
	self->priv = music_widgets_view_selector_get_instance_private (self);
#line 616 "ViewSelector.c"
}

static void
music_widgets_view_selector_finalize (GObject * obj)
{
	MusicWidgetsViewSelector * self;
#line 27 "../src/Widgets/ViewSelector.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelector);
#line 72 "../src/Widgets/ViewSelector.vala"
	_g_object_unref0 (self->priv->mode_button);
#line 27 "../src/Widgets/ViewSelector.vala"
	G_OBJECT_CLASS (music_widgets_view_selector_parent_class)->finalize (obj);
#line 629 "ViewSelector.c"
}

static GType
music_widgets_view_selector_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicWidgetsViewSelectorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_widgets_view_selector_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicWidgetsViewSelector), 0, (GInstanceInitFunc) music_widgets_view_selector_instance_init, NULL };
	GType music_widgets_view_selector_type_id;
	music_widgets_view_selector_type_id = g_type_register_static (gtk_tool_item_get_type (), "MusicWidgetsViewSelector", &g_define_type_info, 0);
	MusicWidgetsViewSelector_private_offset = g_type_add_instance_private (music_widgets_view_selector_type_id, sizeof (MusicWidgetsViewSelectorPrivate));
	return music_widgets_view_selector_type_id;
}

GType
music_widgets_view_selector_get_type (void)
{
	static volatile gsize music_widgets_view_selector_type_id__once = 0;
	if (g_once_init_enter (&music_widgets_view_selector_type_id__once)) {
		GType music_widgets_view_selector_type_id;
		music_widgets_view_selector_type_id = music_widgets_view_selector_get_type_once ();
		g_once_init_leave (&music_widgets_view_selector_type_id__once, music_widgets_view_selector_type_id);
	}
	return music_widgets_view_selector_type_id__once;
}

static void
_vala_music_widgets_view_selector_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	MusicWidgetsViewSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelector);
#line 27 "../src/Widgets/ViewSelector.vala"
	switch (property_id) {
#line 27 "../src/Widgets/ViewSelector.vala"
		case MUSIC_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY:
#line 27 "../src/Widgets/ViewSelector.vala"
		g_value_set_enum (value, music_widgets_view_selector_get_selected (self));
#line 27 "../src/Widgets/ViewSelector.vala"
		break;
#line 27 "../src/Widgets/ViewSelector.vala"
		case MUSIC_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY:
#line 27 "../src/Widgets/ViewSelector.vala"
		g_value_set_boolean (value, music_widgets_view_selector_get_sensitive (self));
#line 27 "../src/Widgets/ViewSelector.vala"
		break;
#line 676 "ViewSelector.c"
		default:
#line 27 "../src/Widgets/ViewSelector.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/Widgets/ViewSelector.vala"
		break;
#line 682 "ViewSelector.c"
	}
}

static void
_vala_music_widgets_view_selector_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	MusicWidgetsViewSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelector);
#line 27 "../src/Widgets/ViewSelector.vala"
	switch (property_id) {
#line 27 "../src/Widgets/ViewSelector.vala"
		case MUSIC_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY:
#line 27 "../src/Widgets/ViewSelector.vala"
		music_widgets_view_selector_set_selected (self, g_value_get_enum (value));
#line 27 "../src/Widgets/ViewSelector.vala"
		break;
#line 27 "../src/Widgets/ViewSelector.vala"
		case MUSIC_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY:
#line 27 "../src/Widgets/ViewSelector.vala"
		music_widgets_view_selector_set_sensitive (self, g_value_get_boolean (value));
#line 27 "../src/Widgets/ViewSelector.vala"
		break;
#line 708 "ViewSelector.c"
		default:
#line 27 "../src/Widgets/ViewSelector.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/Widgets/ViewSelector.vala"
		break;
#line 714 "ViewSelector.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

