/* MediaEditor.c generated by valac 0.56.0, the Vala compiler
 * generated from MediaEditor.vala, do not modify */

/*-
 * Copyright (c) 2012-2018 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "music-lib.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <granite.h>

#define MUSIC_MEDIA_EDITOR_TYPE_ACTIVATES_DEFAULT_ENTRY (music_media_editor_activates_default_entry_get_type ())
#define MUSIC_MEDIA_EDITOR_ACTIVATES_DEFAULT_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_MEDIA_EDITOR_TYPE_ACTIVATES_DEFAULT_ENTRY, MusicMediaEditorActivatesDefaultEntry))
#define MUSIC_MEDIA_EDITOR_ACTIVATES_DEFAULT_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_MEDIA_EDITOR_TYPE_ACTIVATES_DEFAULT_ENTRY, MusicMediaEditorActivatesDefaultEntryClass))
#define MUSIC_MEDIA_EDITOR_IS_ACTIVATES_DEFAULT_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_MEDIA_EDITOR_TYPE_ACTIVATES_DEFAULT_ENTRY))
#define MUSIC_MEDIA_EDITOR_IS_ACTIVATES_DEFAULT_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_MEDIA_EDITOR_TYPE_ACTIVATES_DEFAULT_ENTRY))
#define MUSIC_MEDIA_EDITOR_ACTIVATES_DEFAULT_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_MEDIA_EDITOR_TYPE_ACTIVATES_DEFAULT_ENTRY, MusicMediaEditorActivatesDefaultEntryClass))

typedef struct _MusicMediaEditorActivatesDefaultEntry MusicMediaEditorActivatesDefaultEntry;
typedef struct _MusicMediaEditorActivatesDefaultEntryClass MusicMediaEditorActivatesDefaultEntryClass;
enum  {
	MUSIC_MEDIA_EDITOR_0_PROPERTY,
	MUSIC_MEDIA_EDITOR_NUM_PROPERTIES
};
static GParamSpec* music_media_editor_properties[MUSIC_MEDIA_EDITOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MusicMediaEditorActivatesDefaultEntryPrivate MusicMediaEditorActivatesDefaultEntryPrivate;
enum  {
	MUSIC_MEDIA_EDITOR_ACTIVATES_DEFAULT_ENTRY_0_PROPERTY,
	MUSIC_MEDIA_EDITOR_ACTIVATES_DEFAULT_ENTRY_NUM_PROPERTIES
};
static GParamSpec* music_media_editor_activates_default_entry_properties[MUSIC_MEDIA_EDITOR_ACTIVATES_DEFAULT_ENTRY_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _MusicMediaEditorPrivate {
	MusicMediaEditorActivatesDefaultEntry* title_entry;
	MusicMediaEditorActivatesDefaultEntry* artist_entry;
	MusicMediaEditorActivatesDefaultEntry* album_artist_entry;
	MusicMediaEditorActivatesDefaultEntry* album_entry;
	MusicMediaEditorActivatesDefaultEntry* genre_entry;
	MusicMediaEditorActivatesDefaultEntry* composer_entry;
	MusicMediaEditorActivatesDefaultEntry* grouping_entry;
	GtkTextView* comment_textview;
	GtkScrolledWindow* comment_scrolledwindow;
	GtkSpinButton* track_spinbutton;
	GtkSpinButton* disk_spinbutton;
	GtkSpinButton* year_spinbutton;
	MusicRatingWidget* rating_widget;
	GtkButton* previous_button;
	GtkButton* next_button;
	GeeTreeSet* media_list;
	GeeHashMap* temp_list;
	MusicMedia* current_media;
};

struct _MusicMediaEditorActivatesDefaultEntry {
	GtkEntry parent_instance;
	MusicMediaEditorActivatesDefaultEntryPrivate * priv;
};

struct _MusicMediaEditorActivatesDefaultEntryClass {
	GtkEntryClass parent_class;
};

static gint MusicMediaEditor_private_offset;
static gpointer music_media_editor_parent_class = NULL;
static gpointer music_media_editor_activates_default_entry_parent_class = NULL;

static GType music_media_editor_activates_default_entry_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void music_media_editor_set_media (MusicMediaEditor* self,
                                   MusicMedia* m);
static void music_media_editor_previous_track (MusicMediaEditor* self);
static void music_media_editor_save_track (MusicMediaEditor* self);
static void music_media_editor_next_track (MusicMediaEditor* self);
static void music_media_editor_save_and_exit (MusicMediaEditor* self);
static MusicMediaEditorActivatesDefaultEntry* music_media_editor_activates_default_entry_new (void);
static MusicMediaEditorActivatesDefaultEntry* music_media_editor_activates_default_entry_construct (GType object_type);
static GObject * music_media_editor_activates_default_entry_constructor (GType type,
                                                                  guint n_construct_properties,
                                                                  GObjectConstructParam * construct_properties);
static GType music_media_editor_activates_default_entry_get_type_once (void);
static GObject * music_media_editor_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static guint _music_media_editor___lambda47_ (MusicMediaEditor* self,
                                       gint64* x);
static guint __music_media_editor___lambda47__gee_hash_data_func (gconstpointer v,
                                                           gpointer self);
static gboolean _music_media_editor___lambda48_ (MusicMediaEditor* self,
                                          gint64* a,
                                          gint64* b);
static gboolean __music_media_editor___lambda48__gee_equal_data_func (gconstpointer a,
                                                               gconstpointer b,
                                                               gpointer self);
static gint64* _int64_dup (gint64* self);
static void _music_media_editor_previous_track_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void _music_media_editor_next_track_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _music_media_editor___lambda49_ (MusicMediaEditor* self,
                                      gint response_id);
static void __music_media_editor___lambda49__gtk_dialog_response (GtkDialog* _sender,
                                                           gint response_id,
                                                           gpointer self);
static void music_media_editor_finalize (GObject * obj);
static GType music_media_editor_get_type_once (void);

static inline gpointer
music_media_editor_get_instance_private (MusicMediaEditor* self)
{
	return G_STRUCT_MEMBER_P (self, MusicMediaEditor_private_offset);
}

MusicMediaEditor*
music_media_editor_construct (GType object_type,
                              GeeTreeSet* given_media)
{
	MusicMediaEditor * self = NULL;
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	GeeTreeSet* _tmp2_;
	GeeTreeSet* _tmp3_;
	gpointer _tmp4_;
	MusicMedia* _tmp5_;
#line 50 "../src/Dialogs/MediaEditor.vala"
	g_return_val_if_fail (given_media != NULL, NULL);
#line 51 "../src/Dialogs/MediaEditor.vala"
	_tmp0_ = music_app_get_main_window ();
#line 51 "../src/Dialogs/MediaEditor.vala"
	_tmp1_ = _tmp0_;
#line 51 "../src/Dialogs/MediaEditor.vala"
	self = (MusicMediaEditor*) g_object_new (object_type, "deletable", FALSE, "destroy-with-parent", TRUE, "height-request", 400, "resizable", TRUE, "transient-for", _tmp1_, "width-request", 600, "window-position", GTK_WIN_POS_CENTER_ON_PARENT, NULL);
#line 60 "../src/Dialogs/MediaEditor.vala"
	_tmp2_ = self->priv->media_list;
#line 60 "../src/Dialogs/MediaEditor.vala"
	gee_collection_add_all ((GeeCollection*) _tmp2_, (GeeCollection*) given_media);
#line 61 "../src/Dialogs/MediaEditor.vala"
	_tmp3_ = self->priv->media_list;
#line 61 "../src/Dialogs/MediaEditor.vala"
	_tmp4_ = gee_abstract_sorted_set_first ((GeeAbstractSortedSet*) _tmp3_);
#line 61 "../src/Dialogs/MediaEditor.vala"
	_tmp5_ = (MusicMedia*) _tmp4_;
#line 61 "../src/Dialogs/MediaEditor.vala"
	music_media_editor_set_media (self, _tmp5_);
#line 61 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (_tmp5_);
#line 50 "../src/Dialogs/MediaEditor.vala"
	return self;
#line 183 "MediaEditor.c"
}

MusicMediaEditor*
music_media_editor_new (GeeTreeSet* given_media)
{
#line 50 "../src/Dialogs/MediaEditor.vala"
	return music_media_editor_construct (MUSIC_TYPE_MEDIA_EDITOR, given_media);
#line 191 "MediaEditor.c"
}

static void
music_media_editor_previous_track (MusicMediaEditor* self)
{
	GeeBidirIterator* iterator = NULL;
	GeeTreeSet* _tmp0_;
	MusicMedia* _tmp1_;
	GeeIterator* _tmp2_;
	GeeBidirIterator* _tmp3_;
#line 156 "../src/Dialogs/MediaEditor.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/Dialogs/MediaEditor.vala"
	_tmp0_ = self->priv->media_list;
#line 157 "../src/Dialogs/MediaEditor.vala"
	_tmp1_ = self->priv->current_media;
#line 157 "../src/Dialogs/MediaEditor.vala"
	_tmp2_ = gee_abstract_sorted_set_iterator_at ((GeeAbstractSortedSet*) _tmp0_, _tmp1_);
#line 157 "../src/Dialogs/MediaEditor.vala"
	iterator = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_BIDIR_ITERATOR, GeeBidirIterator);
#line 158 "../src/Dialogs/MediaEditor.vala"
	_tmp3_ = iterator;
#line 158 "../src/Dialogs/MediaEditor.vala"
	if (gee_bidir_iterator_has_previous (_tmp3_)) {
#line 216 "MediaEditor.c"
		GeeBidirIterator* _tmp4_;
		GeeBidirIterator* _tmp5_;
		gpointer _tmp6_;
		MusicMedia* _tmp7_;
#line 159 "../src/Dialogs/MediaEditor.vala"
		music_media_editor_save_track (self);
#line 160 "../src/Dialogs/MediaEditor.vala"
		_tmp4_ = iterator;
#line 160 "../src/Dialogs/MediaEditor.vala"
		gee_bidir_iterator_previous (_tmp4_);
#line 161 "../src/Dialogs/MediaEditor.vala"
		_tmp5_ = iterator;
#line 161 "../src/Dialogs/MediaEditor.vala"
		_tmp6_ = gee_iterator_get ((GeeIterator*) _tmp5_);
#line 161 "../src/Dialogs/MediaEditor.vala"
		_tmp7_ = (MusicMedia*) _tmp6_;
#line 161 "../src/Dialogs/MediaEditor.vala"
		music_media_editor_set_media (self, _tmp7_);
#line 161 "../src/Dialogs/MediaEditor.vala"
		_g_object_unref0 (_tmp7_);
#line 237 "MediaEditor.c"
	} else {
		GtkButton* _tmp8_;
#line 163 "../src/Dialogs/MediaEditor.vala"
		_tmp8_ = self->priv->previous_button;
#line 163 "../src/Dialogs/MediaEditor.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
#line 244 "MediaEditor.c"
	}
#line 156 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (iterator);
#line 248 "MediaEditor.c"
}

static void
music_media_editor_next_track (MusicMediaEditor* self)
{
	GeeIterator* iterator = NULL;
	GeeTreeSet* _tmp0_;
	MusicMedia* _tmp1_;
	GeeIterator* _tmp2_;
	GeeIterator* _tmp3_;
#line 167 "../src/Dialogs/MediaEditor.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/Dialogs/MediaEditor.vala"
	_tmp0_ = self->priv->media_list;
#line 168 "../src/Dialogs/MediaEditor.vala"
	_tmp1_ = self->priv->current_media;
#line 168 "../src/Dialogs/MediaEditor.vala"
	_tmp2_ = gee_abstract_sorted_set_iterator_at ((GeeAbstractSortedSet*) _tmp0_, _tmp1_);
#line 168 "../src/Dialogs/MediaEditor.vala"
	iterator = _tmp2_;
#line 169 "../src/Dialogs/MediaEditor.vala"
	_tmp3_ = iterator;
#line 169 "../src/Dialogs/MediaEditor.vala"
	if (gee_iterator_has_next (_tmp3_)) {
#line 273 "MediaEditor.c"
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		gpointer _tmp6_;
		MusicMedia* _tmp7_;
#line 170 "../src/Dialogs/MediaEditor.vala"
		music_media_editor_save_track (self);
#line 171 "../src/Dialogs/MediaEditor.vala"
		_tmp4_ = iterator;
#line 171 "../src/Dialogs/MediaEditor.vala"
		gee_iterator_next (_tmp4_);
#line 172 "../src/Dialogs/MediaEditor.vala"
		_tmp5_ = iterator;
#line 172 "../src/Dialogs/MediaEditor.vala"
		_tmp6_ = gee_iterator_get (_tmp5_);
#line 172 "../src/Dialogs/MediaEditor.vala"
		_tmp7_ = (MusicMedia*) _tmp6_;
#line 172 "../src/Dialogs/MediaEditor.vala"
		music_media_editor_set_media (self, _tmp7_);
#line 172 "../src/Dialogs/MediaEditor.vala"
		_g_object_unref0 (_tmp7_);
#line 294 "MediaEditor.c"
	} else {
		GtkButton* _tmp8_;
#line 174 "../src/Dialogs/MediaEditor.vala"
		_tmp8_ = self->priv->next_button;
#line 174 "../src/Dialogs/MediaEditor.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
#line 301 "MediaEditor.c"
	}
#line 167 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (iterator);
#line 305 "MediaEditor.c"
}

static void
music_media_editor_save_track (MusicMediaEditor* self)
{
	MusicMedia* m = NULL;
	MusicMedia* _tmp0_;
	MusicMedia* _tmp1_;
	MusicMediaEditorActivatesDefaultEntry* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	MusicMediaEditorActivatesDefaultEntry* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	MusicMediaEditorActivatesDefaultEntry* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	MusicMediaEditorActivatesDefaultEntry* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	MusicMediaEditorActivatesDefaultEntry* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	MusicMediaEditorActivatesDefaultEntry* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	MusicMediaEditorActivatesDefaultEntry* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	GtkTextView* _tmp23_;
	GtkTextBuffer* _tmp24_;
	GtkTextBuffer* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GtkSpinButton* _tmp29_;
	gdouble _tmp30_;
	gdouble _tmp31_;
	GtkSpinButton* _tmp32_;
	gdouble _tmp33_;
	gdouble _tmp34_;
	GtkSpinButton* _tmp35_;
	gdouble _tmp36_;
	gdouble _tmp37_;
	MusicRatingWidget* _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	GeeHashMap* _tmp41_;
	MusicMedia* _tmp42_;
	gint64 _tmp43_;
	gint64 _tmp44_;
#line 178 "../src/Dialogs/MediaEditor.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/Dialogs/MediaEditor.vala"
	_tmp0_ = self->priv->current_media;
#line 179 "../src/Dialogs/MediaEditor.vala"
	_tmp1_ = music_media_copy (_tmp0_);
#line 179 "../src/Dialogs/MediaEditor.vala"
	m = _tmp1_;
#line 180 "../src/Dialogs/MediaEditor.vala"
	_tmp2_ = self->priv->title_entry;
#line 180 "../src/Dialogs/MediaEditor.vala"
	_tmp3_ = gtk_entry_get_text ((GtkEntry*) _tmp2_);
#line 180 "../src/Dialogs/MediaEditor.vala"
	_tmp4_ = _tmp3_;
#line 180 "../src/Dialogs/MediaEditor.vala"
	music_media_set_title (m, _tmp4_);
#line 181 "../src/Dialogs/MediaEditor.vala"
	_tmp5_ = self->priv->artist_entry;
#line 181 "../src/Dialogs/MediaEditor.vala"
	_tmp6_ = gtk_entry_get_text ((GtkEntry*) _tmp5_);
#line 181 "../src/Dialogs/MediaEditor.vala"
	_tmp7_ = _tmp6_;
#line 181 "../src/Dialogs/MediaEditor.vala"
	music_media_set_artist (m, _tmp7_);
#line 182 "../src/Dialogs/MediaEditor.vala"
	_tmp8_ = self->priv->album_artist_entry;
#line 182 "../src/Dialogs/MediaEditor.vala"
	_tmp9_ = gtk_entry_get_text ((GtkEntry*) _tmp8_);
#line 182 "../src/Dialogs/MediaEditor.vala"
	_tmp10_ = _tmp9_;
#line 182 "../src/Dialogs/MediaEditor.vala"
	music_media_set_album_artist (m, _tmp10_);
#line 183 "../src/Dialogs/MediaEditor.vala"
	_tmp11_ = self->priv->album_entry;
#line 183 "../src/Dialogs/MediaEditor.vala"
	_tmp12_ = gtk_entry_get_text ((GtkEntry*) _tmp11_);
#line 183 "../src/Dialogs/MediaEditor.vala"
	_tmp13_ = _tmp12_;
#line 183 "../src/Dialogs/MediaEditor.vala"
	music_media_set_album (m, _tmp13_);
#line 184 "../src/Dialogs/MediaEditor.vala"
	_tmp14_ = self->priv->genre_entry;
#line 184 "../src/Dialogs/MediaEditor.vala"
	_tmp15_ = gtk_entry_get_text ((GtkEntry*) _tmp14_);
#line 184 "../src/Dialogs/MediaEditor.vala"
	_tmp16_ = _tmp15_;
#line 184 "../src/Dialogs/MediaEditor.vala"
	music_media_set_genre (m, _tmp16_);
#line 185 "../src/Dialogs/MediaEditor.vala"
	_tmp17_ = self->priv->composer_entry;
#line 185 "../src/Dialogs/MediaEditor.vala"
	_tmp18_ = gtk_entry_get_text ((GtkEntry*) _tmp17_);
#line 185 "../src/Dialogs/MediaEditor.vala"
	_tmp19_ = _tmp18_;
#line 185 "../src/Dialogs/MediaEditor.vala"
	music_media_set_composer (m, _tmp19_);
#line 186 "../src/Dialogs/MediaEditor.vala"
	_tmp20_ = self->priv->grouping_entry;
#line 186 "../src/Dialogs/MediaEditor.vala"
	_tmp21_ = gtk_entry_get_text ((GtkEntry*) _tmp20_);
#line 186 "../src/Dialogs/MediaEditor.vala"
	_tmp22_ = _tmp21_;
#line 186 "../src/Dialogs/MediaEditor.vala"
	music_media_set_grouping (m, _tmp22_);
#line 187 "../src/Dialogs/MediaEditor.vala"
	_tmp23_ = self->priv->comment_textview;
#line 187 "../src/Dialogs/MediaEditor.vala"
	_tmp24_ = gtk_text_view_get_buffer (_tmp23_);
#line 187 "../src/Dialogs/MediaEditor.vala"
	_tmp25_ = _tmp24_;
#line 187 "../src/Dialogs/MediaEditor.vala"
	g_object_get (_tmp25_, "text", &_tmp26_, NULL);
#line 187 "../src/Dialogs/MediaEditor.vala"
	_tmp27_ = _tmp26_;
#line 187 "../src/Dialogs/MediaEditor.vala"
	_tmp28_ = _tmp27_;
#line 187 "../src/Dialogs/MediaEditor.vala"
	music_media_set_comment (m, _tmp28_);
#line 187 "../src/Dialogs/MediaEditor.vala"
	_g_free0 (_tmp28_);
#line 188 "../src/Dialogs/MediaEditor.vala"
	_tmp29_ = self->priv->track_spinbutton;
#line 188 "../src/Dialogs/MediaEditor.vala"
	_tmp30_ = gtk_spin_button_get_value (_tmp29_);
#line 188 "../src/Dialogs/MediaEditor.vala"
	_tmp31_ = _tmp30_;
#line 188 "../src/Dialogs/MediaEditor.vala"
	music_media_set_track (m, (guint) ((gint) _tmp31_));
#line 189 "../src/Dialogs/MediaEditor.vala"
	_tmp32_ = self->priv->disk_spinbutton;
#line 189 "../src/Dialogs/MediaEditor.vala"
	_tmp33_ = gtk_spin_button_get_value (_tmp32_);
#line 189 "../src/Dialogs/MediaEditor.vala"
	_tmp34_ = _tmp33_;
#line 189 "../src/Dialogs/MediaEditor.vala"
	music_media_set_album_number (m, (guint) ((gint) _tmp34_));
#line 190 "../src/Dialogs/MediaEditor.vala"
	_tmp35_ = self->priv->year_spinbutton;
#line 190 "../src/Dialogs/MediaEditor.vala"
	_tmp36_ = gtk_spin_button_get_value (_tmp35_);
#line 190 "../src/Dialogs/MediaEditor.vala"
	_tmp37_ = _tmp36_;
#line 190 "../src/Dialogs/MediaEditor.vala"
	music_media_set_year (m, (guint) ((gint) _tmp37_));
#line 191 "../src/Dialogs/MediaEditor.vala"
	_tmp38_ = self->priv->rating_widget;
#line 191 "../src/Dialogs/MediaEditor.vala"
	_tmp39_ = music_rating_widget_get_rating (_tmp38_);
#line 191 "../src/Dialogs/MediaEditor.vala"
	_tmp40_ = _tmp39_;
#line 191 "../src/Dialogs/MediaEditor.vala"
	music_media_set_rating (m, (guint) _tmp40_);
#line 192 "../src/Dialogs/MediaEditor.vala"
	_tmp41_ = self->priv->temp_list;
#line 192 "../src/Dialogs/MediaEditor.vala"
	_tmp42_ = self->priv->current_media;
#line 192 "../src/Dialogs/MediaEditor.vala"
	_tmp43_ = music_media_get_rowid (_tmp42_);
#line 192 "../src/Dialogs/MediaEditor.vala"
	_tmp44_ = _tmp43_;
#line 192 "../src/Dialogs/MediaEditor.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp41_, &_tmp44_, m);
#line 178 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (m);
#line 481 "MediaEditor.c"
}

static void
music_media_editor_save_and_exit (MusicMediaEditor* self)
{
	GeeTreeSet* _tmp62_;
	GeeHashMap* _tmp63_;
#line 196 "../src/Dialogs/MediaEditor.vala"
	g_return_if_fail (self != NULL);
#line 197 "../src/Dialogs/MediaEditor.vala"
	music_media_editor_save_track (self);
#line 493 "MediaEditor.c"
	{
		GeeIterator* _m_it = NULL;
		GeeTreeSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 198 "../src/Dialogs/MediaEditor.vala"
		_tmp0_ = self->priv->media_list;
#line 198 "../src/Dialogs/MediaEditor.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 198 "../src/Dialogs/MediaEditor.vala"
		_m_it = _tmp1_;
#line 198 "../src/Dialogs/MediaEditor.vala"
		while (TRUE) {
#line 506 "MediaEditor.c"
			GeeIterator* _tmp2_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeHashMap* _tmp5_;
			MusicMedia* _tmp6_;
			gint64 _tmp7_;
			gint64 _tmp8_;
#line 198 "../src/Dialogs/MediaEditor.vala"
			_tmp2_ = _m_it;
#line 198 "../src/Dialogs/MediaEditor.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 198 "../src/Dialogs/MediaEditor.vala"
				break;
#line 521 "MediaEditor.c"
			}
#line 198 "../src/Dialogs/MediaEditor.vala"
			_tmp3_ = _m_it;
#line 198 "../src/Dialogs/MediaEditor.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 198 "../src/Dialogs/MediaEditor.vala"
			m = (MusicMedia*) _tmp4_;
#line 199 "../src/Dialogs/MediaEditor.vala"
			_tmp5_ = self->priv->temp_list;
#line 199 "../src/Dialogs/MediaEditor.vala"
			_tmp6_ = m;
#line 199 "../src/Dialogs/MediaEditor.vala"
			_tmp7_ = music_media_get_rowid (_tmp6_);
#line 199 "../src/Dialogs/MediaEditor.vala"
			_tmp8_ = _tmp7_;
#line 199 "../src/Dialogs/MediaEditor.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp5_, &_tmp8_)) {
#line 539 "MediaEditor.c"
				MusicMedia* copy = NULL;
				GeeHashMap* _tmp9_;
				MusicMedia* _tmp10_;
				gint64 _tmp11_;
				gint64 _tmp12_;
				gpointer _tmp13_;
				MusicMedia* _tmp14_;
				MusicMedia* _tmp15_;
				const gchar* _tmp16_;
				const gchar* _tmp17_;
				MusicMedia* _tmp18_;
				MusicMedia* _tmp19_;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
				MusicMedia* _tmp22_;
				MusicMedia* _tmp23_;
				const gchar* _tmp24_;
				const gchar* _tmp25_;
				MusicMedia* _tmp26_;
				MusicMedia* _tmp27_;
				const gchar* _tmp28_;
				const gchar* _tmp29_;
				MusicMedia* _tmp30_;
				MusicMedia* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				MusicMedia* _tmp34_;
				MusicMedia* _tmp35_;
				const gchar* _tmp36_;
				const gchar* _tmp37_;
				MusicMedia* _tmp38_;
				MusicMedia* _tmp39_;
				const gchar* _tmp40_;
				const gchar* _tmp41_;
				MusicMedia* _tmp42_;
				MusicMedia* _tmp43_;
				const gchar* _tmp44_;
				const gchar* _tmp45_;
				MusicMedia* _tmp46_;
				MusicMedia* _tmp47_;
				guint _tmp48_;
				guint _tmp49_;
				MusicMedia* _tmp50_;
				MusicMedia* _tmp51_;
				guint _tmp52_;
				guint _tmp53_;
				MusicMedia* _tmp54_;
				MusicMedia* _tmp55_;
				guint _tmp56_;
				guint _tmp57_;
				MusicMedia* _tmp58_;
				MusicMedia* _tmp59_;
				guint _tmp60_;
				guint _tmp61_;
#line 200 "../src/Dialogs/MediaEditor.vala"
				_tmp9_ = self->priv->temp_list;
#line 200 "../src/Dialogs/MediaEditor.vala"
				_tmp10_ = m;
#line 200 "../src/Dialogs/MediaEditor.vala"
				_tmp11_ = music_media_get_rowid (_tmp10_);
#line 200 "../src/Dialogs/MediaEditor.vala"
				_tmp12_ = _tmp11_;
#line 200 "../src/Dialogs/MediaEditor.vala"
				_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp9_, &_tmp12_);
#line 200 "../src/Dialogs/MediaEditor.vala"
				copy = (MusicMedia*) _tmp13_;
#line 201 "../src/Dialogs/MediaEditor.vala"
				_tmp14_ = m;
#line 201 "../src/Dialogs/MediaEditor.vala"
				_tmp15_ = copy;
#line 201 "../src/Dialogs/MediaEditor.vala"
				_tmp16_ = music_media_get_title (_tmp15_);
#line 201 "../src/Dialogs/MediaEditor.vala"
				_tmp17_ = _tmp16_;
#line 201 "../src/Dialogs/MediaEditor.vala"
				music_media_set_title (_tmp14_, _tmp17_);
#line 202 "../src/Dialogs/MediaEditor.vala"
				_tmp18_ = m;
#line 202 "../src/Dialogs/MediaEditor.vala"
				_tmp19_ = copy;
#line 202 "../src/Dialogs/MediaEditor.vala"
				_tmp20_ = music_media_get_artist (_tmp19_);
#line 202 "../src/Dialogs/MediaEditor.vala"
				_tmp21_ = _tmp20_;
#line 202 "../src/Dialogs/MediaEditor.vala"
				music_media_set_artist (_tmp18_, _tmp21_);
#line 203 "../src/Dialogs/MediaEditor.vala"
				_tmp22_ = m;
#line 203 "../src/Dialogs/MediaEditor.vala"
				_tmp23_ = copy;
#line 203 "../src/Dialogs/MediaEditor.vala"
				_tmp24_ = music_media_get_album_artist (_tmp23_);
#line 203 "../src/Dialogs/MediaEditor.vala"
				_tmp25_ = _tmp24_;
#line 203 "../src/Dialogs/MediaEditor.vala"
				music_media_set_album_artist (_tmp22_, _tmp25_);
#line 204 "../src/Dialogs/MediaEditor.vala"
				_tmp26_ = m;
#line 204 "../src/Dialogs/MediaEditor.vala"
				_tmp27_ = copy;
#line 204 "../src/Dialogs/MediaEditor.vala"
				_tmp28_ = music_media_get_album (_tmp27_);
#line 204 "../src/Dialogs/MediaEditor.vala"
				_tmp29_ = _tmp28_;
#line 204 "../src/Dialogs/MediaEditor.vala"
				music_media_set_album (_tmp26_, _tmp29_);
#line 205 "../src/Dialogs/MediaEditor.vala"
				_tmp30_ = m;
#line 205 "../src/Dialogs/MediaEditor.vala"
				_tmp31_ = copy;
#line 205 "../src/Dialogs/MediaEditor.vala"
				_tmp32_ = music_media_get_genre (_tmp31_);
#line 205 "../src/Dialogs/MediaEditor.vala"
				_tmp33_ = _tmp32_;
#line 205 "../src/Dialogs/MediaEditor.vala"
				music_media_set_genre (_tmp30_, _tmp33_);
#line 206 "../src/Dialogs/MediaEditor.vala"
				_tmp34_ = m;
#line 206 "../src/Dialogs/MediaEditor.vala"
				_tmp35_ = copy;
#line 206 "../src/Dialogs/MediaEditor.vala"
				_tmp36_ = music_media_get_composer (_tmp35_);
#line 206 "../src/Dialogs/MediaEditor.vala"
				_tmp37_ = _tmp36_;
#line 206 "../src/Dialogs/MediaEditor.vala"
				music_media_set_composer (_tmp34_, _tmp37_);
#line 207 "../src/Dialogs/MediaEditor.vala"
				_tmp38_ = m;
#line 207 "../src/Dialogs/MediaEditor.vala"
				_tmp39_ = copy;
#line 207 "../src/Dialogs/MediaEditor.vala"
				_tmp40_ = music_media_get_grouping (_tmp39_);
#line 207 "../src/Dialogs/MediaEditor.vala"
				_tmp41_ = _tmp40_;
#line 207 "../src/Dialogs/MediaEditor.vala"
				music_media_set_grouping (_tmp38_, _tmp41_);
#line 208 "../src/Dialogs/MediaEditor.vala"
				_tmp42_ = m;
#line 208 "../src/Dialogs/MediaEditor.vala"
				_tmp43_ = copy;
#line 208 "../src/Dialogs/MediaEditor.vala"
				_tmp44_ = music_media_get_comment (_tmp43_);
#line 208 "../src/Dialogs/MediaEditor.vala"
				_tmp45_ = _tmp44_;
#line 208 "../src/Dialogs/MediaEditor.vala"
				music_media_set_comment (_tmp42_, _tmp45_);
#line 209 "../src/Dialogs/MediaEditor.vala"
				_tmp46_ = m;
#line 209 "../src/Dialogs/MediaEditor.vala"
				_tmp47_ = copy;
#line 209 "../src/Dialogs/MediaEditor.vala"
				_tmp48_ = music_media_get_track (_tmp47_);
#line 209 "../src/Dialogs/MediaEditor.vala"
				_tmp49_ = _tmp48_;
#line 209 "../src/Dialogs/MediaEditor.vala"
				music_media_set_track (_tmp46_, _tmp49_);
#line 210 "../src/Dialogs/MediaEditor.vala"
				_tmp50_ = m;
#line 210 "../src/Dialogs/MediaEditor.vala"
				_tmp51_ = copy;
#line 210 "../src/Dialogs/MediaEditor.vala"
				_tmp52_ = music_media_get_album_number (_tmp51_);
#line 210 "../src/Dialogs/MediaEditor.vala"
				_tmp53_ = _tmp52_;
#line 210 "../src/Dialogs/MediaEditor.vala"
				music_media_set_album_number (_tmp50_, _tmp53_);
#line 211 "../src/Dialogs/MediaEditor.vala"
				_tmp54_ = m;
#line 211 "../src/Dialogs/MediaEditor.vala"
				_tmp55_ = copy;
#line 211 "../src/Dialogs/MediaEditor.vala"
				_tmp56_ = music_media_get_year (_tmp55_);
#line 211 "../src/Dialogs/MediaEditor.vala"
				_tmp57_ = _tmp56_;
#line 211 "../src/Dialogs/MediaEditor.vala"
				music_media_set_year (_tmp54_, _tmp57_);
#line 212 "../src/Dialogs/MediaEditor.vala"
				_tmp58_ = m;
#line 212 "../src/Dialogs/MediaEditor.vala"
				_tmp59_ = copy;
#line 212 "../src/Dialogs/MediaEditor.vala"
				_tmp60_ = music_media_get_rating (_tmp59_);
#line 212 "../src/Dialogs/MediaEditor.vala"
				_tmp61_ = _tmp60_;
#line 212 "../src/Dialogs/MediaEditor.vala"
				music_media_set_rating (_tmp58_, _tmp61_);
#line 199 "../src/Dialogs/MediaEditor.vala"
				_g_object_unref0 (copy);
#line 728 "MediaEditor.c"
			}
#line 198 "../src/Dialogs/MediaEditor.vala"
			_g_object_unref0 (m);
#line 732 "MediaEditor.c"
		}
#line 198 "../src/Dialogs/MediaEditor.vala"
		_g_object_unref0 (_m_it);
#line 736 "MediaEditor.c"
	}
#line 216 "../src/Dialogs/MediaEditor.vala"
	_tmp62_ = self->priv->media_list;
#line 216 "../src/Dialogs/MediaEditor.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp62_);
#line 217 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->current_media);
#line 217 "../src/Dialogs/MediaEditor.vala"
	self->priv->current_media = NULL;
#line 218 "../src/Dialogs/MediaEditor.vala"
	_tmp63_ = self->priv->temp_list;
#line 218 "../src/Dialogs/MediaEditor.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp63_);
#line 750 "MediaEditor.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 222 "../src/Dialogs/MediaEditor.vala"
	return self ? g_object_ref (self) : NULL;
#line 758 "MediaEditor.c"
}

static void
music_media_editor_set_media (MusicMediaEditor* self,
                              MusicMedia* m)
{
	MusicMedia* _tmp0_;
	MusicMedia* considered_media = NULL;
	MusicMedia* _tmp1_;
	MusicMedia* _tmp2_;
	GeeHashMap* _tmp3_;
	MusicMedia* _tmp4_;
	gint64 _tmp5_;
	gint64 _tmp6_;
	MusicMediaEditorActivatesDefaultEntry* _tmp12_;
	MusicMedia* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	MusicMediaEditorActivatesDefaultEntry* _tmp16_;
	MusicMedia* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	MusicMediaEditorActivatesDefaultEntry* _tmp20_;
	MusicMedia* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	MusicMediaEditorActivatesDefaultEntry* _tmp24_;
	MusicMedia* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	MusicMediaEditorActivatesDefaultEntry* _tmp28_;
	MusicMedia* _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	MusicMediaEditorActivatesDefaultEntry* _tmp32_;
	MusicMedia* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	MusicMediaEditorActivatesDefaultEntry* _tmp36_;
	MusicMedia* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	GtkTextView* _tmp40_;
	GtkTextBuffer* _tmp41_;
	GtkTextBuffer* _tmp42_;
	MusicMedia* _tmp43_;
	const gchar* _tmp44_;
	const gchar* _tmp45_;
	GtkSpinButton* _tmp46_;
	MusicMedia* _tmp47_;
	guint _tmp48_;
	guint _tmp49_;
	GtkSpinButton* _tmp50_;
	MusicMedia* _tmp51_;
	guint _tmp52_;
	guint _tmp53_;
	GtkSpinButton* _tmp54_;
	MusicMedia* _tmp55_;
	guint _tmp56_;
	guint _tmp57_;
	MusicRatingWidget* _tmp58_;
	MusicMedia* _tmp59_;
	guint _tmp60_;
	guint _tmp61_;
	GeeBidirIterator* iterator = NULL;
	GeeTreeSet* _tmp62_;
	MusicMedia* _tmp63_;
	GeeIterator* _tmp64_;
	GtkButton* _tmp65_;
	GtkButton* _tmp66_;
#line 221 "../src/Dialogs/MediaEditor.vala"
	g_return_if_fail (self != NULL);
#line 221 "../src/Dialogs/MediaEditor.vala"
	g_return_if_fail (m != NULL);
#line 222 "../src/Dialogs/MediaEditor.vala"
	_tmp0_ = _g_object_ref0 (m);
#line 222 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->current_media);
#line 222 "../src/Dialogs/MediaEditor.vala"
	self->priv->current_media = _tmp0_;
#line 223 "../src/Dialogs/MediaEditor.vala"
	_tmp1_ = self->priv->current_media;
#line 223 "../src/Dialogs/MediaEditor.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 223 "../src/Dialogs/MediaEditor.vala"
	considered_media = _tmp2_;
#line 224 "../src/Dialogs/MediaEditor.vala"
	_tmp3_ = self->priv->temp_list;
#line 224 "../src/Dialogs/MediaEditor.vala"
	_tmp4_ = self->priv->current_media;
#line 224 "../src/Dialogs/MediaEditor.vala"
	_tmp5_ = music_media_get_rowid (_tmp4_);
#line 224 "../src/Dialogs/MediaEditor.vala"
	_tmp6_ = _tmp5_;
#line 224 "../src/Dialogs/MediaEditor.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, &_tmp6_)) {
#line 855 "MediaEditor.c"
		GeeHashMap* _tmp7_;
		MusicMedia* _tmp8_;
		gint64 _tmp9_;
		gint64 _tmp10_;
		gpointer _tmp11_;
#line 225 "../src/Dialogs/MediaEditor.vala"
		_tmp7_ = self->priv->temp_list;
#line 225 "../src/Dialogs/MediaEditor.vala"
		_tmp8_ = self->priv->current_media;
#line 225 "../src/Dialogs/MediaEditor.vala"
		_tmp9_ = music_media_get_rowid (_tmp8_);
#line 225 "../src/Dialogs/MediaEditor.vala"
		_tmp10_ = _tmp9_;
#line 225 "../src/Dialogs/MediaEditor.vala"
		_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, &_tmp10_);
#line 225 "../src/Dialogs/MediaEditor.vala"
		_g_object_unref0 (considered_media);
#line 225 "../src/Dialogs/MediaEditor.vala"
		considered_media = (MusicMedia*) _tmp11_;
#line 875 "MediaEditor.c"
	}
#line 228 "../src/Dialogs/MediaEditor.vala"
	_tmp12_ = self->priv->title_entry;
#line 228 "../src/Dialogs/MediaEditor.vala"
	_tmp13_ = considered_media;
#line 228 "../src/Dialogs/MediaEditor.vala"
	_tmp14_ = music_media_get_title (_tmp13_);
#line 228 "../src/Dialogs/MediaEditor.vala"
	_tmp15_ = _tmp14_;
#line 228 "../src/Dialogs/MediaEditor.vala"
	gtk_entry_set_text ((GtkEntry*) _tmp12_, _tmp15_);
#line 229 "../src/Dialogs/MediaEditor.vala"
	_tmp16_ = self->priv->artist_entry;
#line 229 "../src/Dialogs/MediaEditor.vala"
	_tmp17_ = considered_media;
#line 229 "../src/Dialogs/MediaEditor.vala"
	_tmp18_ = music_media_get_artist (_tmp17_);
#line 229 "../src/Dialogs/MediaEditor.vala"
	_tmp19_ = _tmp18_;
#line 229 "../src/Dialogs/MediaEditor.vala"
	gtk_entry_set_text ((GtkEntry*) _tmp16_, _tmp19_);
#line 230 "../src/Dialogs/MediaEditor.vala"
	_tmp20_ = self->priv->album_artist_entry;
#line 230 "../src/Dialogs/MediaEditor.vala"
	_tmp21_ = considered_media;
#line 230 "../src/Dialogs/MediaEditor.vala"
	_tmp22_ = music_media_get_album_artist (_tmp21_);
#line 230 "../src/Dialogs/MediaEditor.vala"
	_tmp23_ = _tmp22_;
#line 230 "../src/Dialogs/MediaEditor.vala"
	gtk_entry_set_text ((GtkEntry*) _tmp20_, _tmp23_);
#line 231 "../src/Dialogs/MediaEditor.vala"
	_tmp24_ = self->priv->album_entry;
#line 231 "../src/Dialogs/MediaEditor.vala"
	_tmp25_ = considered_media;
#line 231 "../src/Dialogs/MediaEditor.vala"
	_tmp26_ = music_media_get_album (_tmp25_);
#line 231 "../src/Dialogs/MediaEditor.vala"
	_tmp27_ = _tmp26_;
#line 231 "../src/Dialogs/MediaEditor.vala"
	gtk_entry_set_text ((GtkEntry*) _tmp24_, _tmp27_);
#line 232 "../src/Dialogs/MediaEditor.vala"
	_tmp28_ = self->priv->genre_entry;
#line 232 "../src/Dialogs/MediaEditor.vala"
	_tmp29_ = considered_media;
#line 232 "../src/Dialogs/MediaEditor.vala"
	_tmp30_ = music_media_get_genre (_tmp29_);
#line 232 "../src/Dialogs/MediaEditor.vala"
	_tmp31_ = _tmp30_;
#line 232 "../src/Dialogs/MediaEditor.vala"
	gtk_entry_set_text ((GtkEntry*) _tmp28_, _tmp31_);
#line 233 "../src/Dialogs/MediaEditor.vala"
	_tmp32_ = self->priv->composer_entry;
#line 233 "../src/Dialogs/MediaEditor.vala"
	_tmp33_ = considered_media;
#line 233 "../src/Dialogs/MediaEditor.vala"
	_tmp34_ = music_media_get_composer (_tmp33_);
#line 233 "../src/Dialogs/MediaEditor.vala"
	_tmp35_ = _tmp34_;
#line 233 "../src/Dialogs/MediaEditor.vala"
	gtk_entry_set_text ((GtkEntry*) _tmp32_, _tmp35_);
#line 234 "../src/Dialogs/MediaEditor.vala"
	_tmp36_ = self->priv->grouping_entry;
#line 234 "../src/Dialogs/MediaEditor.vala"
	_tmp37_ = considered_media;
#line 234 "../src/Dialogs/MediaEditor.vala"
	_tmp38_ = music_media_get_grouping (_tmp37_);
#line 234 "../src/Dialogs/MediaEditor.vala"
	_tmp39_ = _tmp38_;
#line 234 "../src/Dialogs/MediaEditor.vala"
	gtk_entry_set_text ((GtkEntry*) _tmp36_, _tmp39_);
#line 235 "../src/Dialogs/MediaEditor.vala"
	_tmp40_ = self->priv->comment_textview;
#line 235 "../src/Dialogs/MediaEditor.vala"
	_tmp41_ = gtk_text_view_get_buffer (_tmp40_);
#line 235 "../src/Dialogs/MediaEditor.vala"
	_tmp42_ = _tmp41_;
#line 235 "../src/Dialogs/MediaEditor.vala"
	_tmp43_ = considered_media;
#line 235 "../src/Dialogs/MediaEditor.vala"
	_tmp44_ = music_media_get_comment (_tmp43_);
#line 235 "../src/Dialogs/MediaEditor.vala"
	_tmp45_ = _tmp44_;
#line 235 "../src/Dialogs/MediaEditor.vala"
	g_object_set (_tmp42_, "text", _tmp45_, NULL);
#line 236 "../src/Dialogs/MediaEditor.vala"
	_tmp46_ = self->priv->track_spinbutton;
#line 236 "../src/Dialogs/MediaEditor.vala"
	_tmp47_ = considered_media;
#line 236 "../src/Dialogs/MediaEditor.vala"
	_tmp48_ = music_media_get_track (_tmp47_);
#line 236 "../src/Dialogs/MediaEditor.vala"
	_tmp49_ = _tmp48_;
#line 236 "../src/Dialogs/MediaEditor.vala"
	gtk_spin_button_set_value (_tmp46_, (gdouble) _tmp49_);
#line 237 "../src/Dialogs/MediaEditor.vala"
	_tmp50_ = self->priv->disk_spinbutton;
#line 237 "../src/Dialogs/MediaEditor.vala"
	_tmp51_ = considered_media;
#line 237 "../src/Dialogs/MediaEditor.vala"
	_tmp52_ = music_media_get_album_number (_tmp51_);
#line 237 "../src/Dialogs/MediaEditor.vala"
	_tmp53_ = _tmp52_;
#line 237 "../src/Dialogs/MediaEditor.vala"
	gtk_spin_button_set_value (_tmp50_, (gdouble) _tmp53_);
#line 238 "../src/Dialogs/MediaEditor.vala"
	_tmp54_ = self->priv->year_spinbutton;
#line 238 "../src/Dialogs/MediaEditor.vala"
	_tmp55_ = considered_media;
#line 238 "../src/Dialogs/MediaEditor.vala"
	_tmp56_ = music_media_get_year (_tmp55_);
#line 238 "../src/Dialogs/MediaEditor.vala"
	_tmp57_ = _tmp56_;
#line 238 "../src/Dialogs/MediaEditor.vala"
	gtk_spin_button_set_value (_tmp54_, (gdouble) _tmp57_);
#line 239 "../src/Dialogs/MediaEditor.vala"
	_tmp58_ = self->priv->rating_widget;
#line 239 "../src/Dialogs/MediaEditor.vala"
	_tmp59_ = considered_media;
#line 239 "../src/Dialogs/MediaEditor.vala"
	_tmp60_ = music_media_get_rating (_tmp59_);
#line 239 "../src/Dialogs/MediaEditor.vala"
	_tmp61_ = _tmp60_;
#line 239 "../src/Dialogs/MediaEditor.vala"
	music_rating_widget_set_rating (_tmp58_, (gint) _tmp61_);
#line 240 "../src/Dialogs/MediaEditor.vala"
	_tmp62_ = self->priv->media_list;
#line 240 "../src/Dialogs/MediaEditor.vala"
	_tmp63_ = self->priv->current_media;
#line 240 "../src/Dialogs/MediaEditor.vala"
	_tmp64_ = gee_abstract_sorted_set_iterator_at ((GeeAbstractSortedSet*) _tmp62_, _tmp63_);
#line 240 "../src/Dialogs/MediaEditor.vala"
	iterator = G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, GEE_TYPE_BIDIR_ITERATOR, GeeBidirIterator);
#line 241 "../src/Dialogs/MediaEditor.vala"
	_tmp65_ = self->priv->previous_button;
#line 241 "../src/Dialogs/MediaEditor.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp65_, gee_bidir_iterator_has_previous (iterator));
#line 242 "../src/Dialogs/MediaEditor.vala"
	_tmp66_ = self->priv->next_button;
#line 242 "../src/Dialogs/MediaEditor.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp66_, gee_iterator_has_next ((GeeIterator*) iterator));
#line 221 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (iterator);
#line 221 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (considered_media);
#line 1021 "MediaEditor.c"
}

static MusicMediaEditorActivatesDefaultEntry*
music_media_editor_activates_default_entry_construct (GType object_type)
{
	MusicMediaEditorActivatesDefaultEntry * self = NULL;
#line 245 "../src/Dialogs/MediaEditor.vala"
	self = (MusicMediaEditorActivatesDefaultEntry*) g_object_new (object_type, NULL);
#line 245 "../src/Dialogs/MediaEditor.vala"
	return self;
#line 1032 "MediaEditor.c"
}

static MusicMediaEditorActivatesDefaultEntry*
music_media_editor_activates_default_entry_new (void)
{
#line 245 "../src/Dialogs/MediaEditor.vala"
	return music_media_editor_activates_default_entry_construct (MUSIC_MEDIA_EDITOR_TYPE_ACTIVATES_DEFAULT_ENTRY);
#line 1040 "MediaEditor.c"
}

static GObject *
music_media_editor_activates_default_entry_constructor (GType type,
                                                        guint n_construct_properties,
                                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicMediaEditorActivatesDefaultEntry * self;
#line 246 "../src/Dialogs/MediaEditor.vala"
	parent_class = G_OBJECT_CLASS (music_media_editor_activates_default_entry_parent_class);
#line 246 "../src/Dialogs/MediaEditor.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 246 "../src/Dialogs/MediaEditor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_MEDIA_EDITOR_TYPE_ACTIVATES_DEFAULT_ENTRY, MusicMediaEditorActivatesDefaultEntry);
#line 247 "../src/Dialogs/MediaEditor.vala"
	gtk_entry_set_activates_default ((GtkEntry*) self, TRUE);
#line 246 "../src/Dialogs/MediaEditor.vala"
	return obj;
#line 1061 "MediaEditor.c"
}

static void
music_media_editor_activates_default_entry_class_init (MusicMediaEditorActivatesDefaultEntryClass * klass,
                                                       gpointer klass_data)
{
#line 245 "../src/Dialogs/MediaEditor.vala"
	music_media_editor_activates_default_entry_parent_class = g_type_class_peek_parent (klass);
#line 245 "../src/Dialogs/MediaEditor.vala"
	G_OBJECT_CLASS (klass)->constructor = music_media_editor_activates_default_entry_constructor;
#line 1072 "MediaEditor.c"
}

static void
music_media_editor_activates_default_entry_instance_init (MusicMediaEditorActivatesDefaultEntry * self,
                                                          gpointer klass)
{
}

static GType
music_media_editor_activates_default_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicMediaEditorActivatesDefaultEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_media_editor_activates_default_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicMediaEditorActivatesDefaultEntry), 0, (GInstanceInitFunc) music_media_editor_activates_default_entry_instance_init, NULL };
	GType music_media_editor_activates_default_entry_type_id;
	music_media_editor_activates_default_entry_type_id = g_type_register_static (gtk_entry_get_type (), "MusicMediaEditorActivatesDefaultEntry", &g_define_type_info, 0);
	return music_media_editor_activates_default_entry_type_id;
}

static GType
music_media_editor_activates_default_entry_get_type (void)
{
	static volatile gsize music_media_editor_activates_default_entry_type_id__once = 0;
	if (g_once_init_enter (&music_media_editor_activates_default_entry_type_id__once)) {
		GType music_media_editor_activates_default_entry_type_id;
		music_media_editor_activates_default_entry_type_id = music_media_editor_activates_default_entry_get_type_once ();
		g_once_init_leave (&music_media_editor_activates_default_entry_type_id__once, music_media_editor_activates_default_entry_type_id);
	}
	return music_media_editor_activates_default_entry_type_id__once;
}

static guint
_music_media_editor___lambda47_ (MusicMediaEditor* self,
                                 gint64* x)
{
	GHashFunc _tmp0_;
	guint result;
#line 66 "../src/Dialogs/MediaEditor.vala"
	_tmp0_ = g_int64_hash;
#line 66 "../src/Dialogs/MediaEditor.vala"
	result = _tmp0_ (x);
#line 66 "../src/Dialogs/MediaEditor.vala"
	return result;
#line 1114 "MediaEditor.c"
}

static guint
__music_media_editor___lambda47__gee_hash_data_func (gconstpointer v,
                                                     gpointer self)
{
	guint result;
	result = _music_media_editor___lambda47_ ((MusicMediaEditor*) self, (gint64*) v);
#line 66 "../src/Dialogs/MediaEditor.vala"
	return result;
#line 1125 "MediaEditor.c"
}

static gboolean
_music_media_editor___lambda48_ (MusicMediaEditor* self,
                                 gint64* a,
                                 gint64* b)
{
	GEqualFunc _tmp0_;
#line 66 "../src/Dialogs/MediaEditor.vala"
	_tmp0_ = g_int64_equal;
#line 66 "../src/Dialogs/MediaEditor.vala"
	_tmp0_ (a, b);
#line 1138 "MediaEditor.c"
}

static gboolean
__music_media_editor___lambda48__gee_equal_data_func (gconstpointer a,
                                                      gconstpointer b,
                                                      gpointer self)
{
	gboolean result;
	result = _music_media_editor___lambda48_ ((MusicMediaEditor*) self, (gint64*) a, (gint64*) b);
#line 66 "../src/Dialogs/MediaEditor.vala"
	return result;
#line 1150 "MediaEditor.c"
}

static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
#line 66 "../src/Dialogs/MediaEditor.vala"
	dup = g_new0 (gint64, 1);
#line 66 "../src/Dialogs/MediaEditor.vala"
	memcpy (dup, self, sizeof (gint64));
#line 66 "../src/Dialogs/MediaEditor.vala"
	return dup;
#line 1163 "MediaEditor.c"
}

static void
_music_media_editor_previous_track_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
#line 144 "../src/Dialogs/MediaEditor.vala"
	music_media_editor_previous_track ((MusicMediaEditor*) self);
#line 1172 "MediaEditor.c"
}

static void
_music_media_editor_next_track_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 145 "../src/Dialogs/MediaEditor.vala"
	music_media_editor_next_track ((MusicMediaEditor*) self);
#line 1181 "MediaEditor.c"
}

static void
_music_media_editor___lambda49_ (MusicMediaEditor* self,
                                 gint response_id)
{
#line 148 "../src/Dialogs/MediaEditor.vala"
	if (response_id == ((gint) GTK_RESPONSE_APPLY)) {
#line 149 "../src/Dialogs/MediaEditor.vala"
		music_media_editor_save_and_exit (self);
#line 1192 "MediaEditor.c"
	}
#line 152 "../src/Dialogs/MediaEditor.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 1196 "MediaEditor.c"
}

static void
__music_media_editor___lambda49__gtk_dialog_response (GtkDialog* _sender,
                                                      gint response_id,
                                                      gpointer self)
{
#line 147 "../src/Dialogs/MediaEditor.vala"
	_music_media_editor___lambda49_ ((MusicMediaEditor*) self, response_id);
#line 1206 "MediaEditor.c"
}

static GObject *
music_media_editor_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicMediaEditor * self;
	GeeTreeSet* _tmp0_;
	GeeHashMap* _tmp1_;
	MusicMediaEditorActivatesDefaultEntry* _tmp2_;
	MusicMediaEditorActivatesDefaultEntry* _tmp3_;
	MusicMediaEditorActivatesDefaultEntry* _tmp4_;
	MusicMediaEditorActivatesDefaultEntry* _tmp5_;
	MusicMediaEditorActivatesDefaultEntry* _tmp6_;
	MusicMediaEditorActivatesDefaultEntry* _tmp7_;
	MusicMediaEditorActivatesDefaultEntry* _tmp8_;
	GtkTextView* _tmp9_;
	GtkTextView* _tmp10_;
	GtkScrolledWindow* _tmp11_;
	GtkScrolledWindow* _tmp12_;
	GtkScrolledWindow* _tmp13_;
	GtkTextView* _tmp14_;
	GtkSpinButton* _tmp15_;
	GtkSpinButton* _tmp16_;
	GDateTime* local_time = NULL;
	GDateTime* _tmp17_;
	GDateTime* _tmp18_;
	GtkSpinButton* _tmp19_;
	MusicRatingWidget* _tmp20_;
	MusicRatingWidget* _tmp21_;
	GtkFrame* comment_frame = NULL;
	GtkFrame* _tmp22_;
	GtkFrame* _tmp23_;
	GtkFrame* _tmp24_;
	GtkScrolledWindow* _tmp25_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp26_;
	GtkGrid* _tmp27_;
	GtkGrid* _tmp28_;
	GtkGrid* _tmp29_;
	GtkGrid* _tmp30_;
	GtkGrid* _tmp31_;
	GraniteHeaderLabel* _tmp32_;
	GraniteHeaderLabel* _tmp33_;
	GtkGrid* _tmp34_;
	MusicMediaEditorActivatesDefaultEntry* _tmp35_;
	GtkGrid* _tmp36_;
	GraniteHeaderLabel* _tmp37_;
	GraniteHeaderLabel* _tmp38_;
	GtkGrid* _tmp39_;
	MusicMediaEditorActivatesDefaultEntry* _tmp40_;
	GtkGrid* _tmp41_;
	GraniteHeaderLabel* _tmp42_;
	GraniteHeaderLabel* _tmp43_;
	GtkGrid* _tmp44_;
	MusicMediaEditorActivatesDefaultEntry* _tmp45_;
	GtkGrid* _tmp46_;
	GraniteHeaderLabel* _tmp47_;
	GraniteHeaderLabel* _tmp48_;
	GtkGrid* _tmp49_;
	MusicMediaEditorActivatesDefaultEntry* _tmp50_;
	GtkGrid* _tmp51_;
	GraniteHeaderLabel* _tmp52_;
	GraniteHeaderLabel* _tmp53_;
	GtkGrid* _tmp54_;
	MusicMediaEditorActivatesDefaultEntry* _tmp55_;
	GtkGrid* _tmp56_;
	GraniteHeaderLabel* _tmp57_;
	GraniteHeaderLabel* _tmp58_;
	GtkGrid* _tmp59_;
	MusicMediaEditorActivatesDefaultEntry* _tmp60_;
	GtkGrid* _tmp61_;
	GraniteHeaderLabel* _tmp62_;
	GraniteHeaderLabel* _tmp63_;
	GtkGrid* _tmp64_;
	MusicMediaEditorActivatesDefaultEntry* _tmp65_;
	GtkGrid* _tmp66_;
	GraniteHeaderLabel* _tmp67_;
	GraniteHeaderLabel* _tmp68_;
	GtkGrid* _tmp69_;
	GtkSpinButton* _tmp70_;
	GtkGrid* _tmp71_;
	GraniteHeaderLabel* _tmp72_;
	GraniteHeaderLabel* _tmp73_;
	GtkGrid* _tmp74_;
	GtkSpinButton* _tmp75_;
	GtkGrid* _tmp76_;
	GraniteHeaderLabel* _tmp77_;
	GraniteHeaderLabel* _tmp78_;
	GtkGrid* _tmp79_;
	GtkSpinButton* _tmp80_;
	GtkGrid* _tmp81_;
	GraniteHeaderLabel* _tmp82_;
	GraniteHeaderLabel* _tmp83_;
	GtkGrid* _tmp84_;
	MusicRatingWidget* _tmp85_;
	GtkGrid* _tmp86_;
	GraniteHeaderLabel* _tmp87_;
	GraniteHeaderLabel* _tmp88_;
	GtkGrid* _tmp89_;
	GtkFrame* _tmp90_;
	GtkBox* _tmp91_;
	GtkGrid* _tmp92_;
	GtkButton* _tmp93_;
	GtkButton* _tmp94_;
	GtkGrid* arrows_grid = NULL;
	GtkGrid* _tmp95_;
	GtkGrid* _tmp96_;
	GtkStyleContext* _tmp97_;
	GtkGrid* _tmp98_;
	GtkButton* _tmp99_;
	GtkGrid* _tmp100_;
	GtkButton* _tmp101_;
	GtkButton* save_button = NULL;
	GtkWidget* _tmp102_;
	GtkButton* _tmp103_;
	GtkButton* _tmp104_;
	GtkButton* _tmp105_;
	GtkStyleContext* _tmp106_;
	GtkButtonBox* action_area = NULL;
	GtkBox* _tmp107_;
	GtkButtonBox* _tmp108_;
	GtkButtonBox* _tmp109_;
	GtkButtonBox* _tmp110_;
	GtkButtonBox* _tmp111_;
	GtkGrid* _tmp112_;
	GtkButtonBox* _tmp113_;
	GtkGrid* _tmp114_;
	GtkButtonBox* _tmp115_;
	GtkGrid* _tmp116_;
	GtkButton* _tmp117_;
	GtkButton* _tmp118_;
#line 64 "../src/Dialogs/MediaEditor.vala"
	parent_class = G_OBJECT_CLASS (music_media_editor_parent_class);
#line 64 "../src/Dialogs/MediaEditor.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 64 "../src/Dialogs/MediaEditor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MEDIA_EDITOR, MusicMediaEditor);
#line 65 "../src/Dialogs/MediaEditor.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 65 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->media_list);
#line 65 "../src/Dialogs/MediaEditor.vala"
	self->priv->media_list = _tmp0_;
#line 66 "../src/Dialogs/MediaEditor.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, __music_media_editor___lambda47__gee_hash_data_func, g_object_ref (self), g_object_unref, __music_media_editor___lambda48__gee_equal_data_func, g_object_ref (self), g_object_unref, NULL, NULL, NULL);
#line 66 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->temp_list);
#line 66 "../src/Dialogs/MediaEditor.vala"
	self->priv->temp_list = _tmp1_;
#line 68 "../src/Dialogs/MediaEditor.vala"
	_tmp2_ = music_media_editor_activates_default_entry_new ();
#line 68 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp2_);
#line 68 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->title_entry);
#line 68 "../src/Dialogs/MediaEditor.vala"
	self->priv->title_entry = _tmp2_;
#line 69 "../src/Dialogs/MediaEditor.vala"
	_tmp3_ = music_media_editor_activates_default_entry_new ();
#line 69 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp3_);
#line 69 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->artist_entry);
#line 69 "../src/Dialogs/MediaEditor.vala"
	self->priv->artist_entry = _tmp3_;
#line 70 "../src/Dialogs/MediaEditor.vala"
	_tmp4_ = music_media_editor_activates_default_entry_new ();
#line 70 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp4_);
#line 70 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->album_artist_entry);
#line 70 "../src/Dialogs/MediaEditor.vala"
	self->priv->album_artist_entry = _tmp4_;
#line 71 "../src/Dialogs/MediaEditor.vala"
	_tmp5_ = music_media_editor_activates_default_entry_new ();
#line 71 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp5_);
#line 71 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->album_entry);
#line 71 "../src/Dialogs/MediaEditor.vala"
	self->priv->album_entry = _tmp5_;
#line 72 "../src/Dialogs/MediaEditor.vala"
	_tmp6_ = music_media_editor_activates_default_entry_new ();
#line 72 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp6_);
#line 72 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->genre_entry);
#line 72 "../src/Dialogs/MediaEditor.vala"
	self->priv->genre_entry = _tmp6_;
#line 73 "../src/Dialogs/MediaEditor.vala"
	_tmp7_ = music_media_editor_activates_default_entry_new ();
#line 73 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp7_);
#line 73 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->composer_entry);
#line 73 "../src/Dialogs/MediaEditor.vala"
	self->priv->composer_entry = _tmp7_;
#line 74 "../src/Dialogs/MediaEditor.vala"
	_tmp8_ = music_media_editor_activates_default_entry_new ();
#line 74 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp8_);
#line 74 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->grouping_entry);
#line 74 "../src/Dialogs/MediaEditor.vala"
	self->priv->grouping_entry = _tmp8_;
#line 75 "../src/Dialogs/MediaEditor.vala"
	_tmp9_ = (GtkTextView*) gtk_text_view_new ();
#line 75 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp9_);
#line 75 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->comment_textview);
#line 75 "../src/Dialogs/MediaEditor.vala"
	self->priv->comment_textview = _tmp9_;
#line 76 "../src/Dialogs/MediaEditor.vala"
	_tmp10_ = self->priv->comment_textview;
#line 76 "../src/Dialogs/MediaEditor.vala"
	gtk_text_view_set_wrap_mode (_tmp10_, GTK_WRAP_WORD_CHAR);
#line 77 "../src/Dialogs/MediaEditor.vala"
	_tmp11_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 77 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp11_);
#line 77 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->comment_scrolledwindow);
#line 77 "../src/Dialogs/MediaEditor.vala"
	self->priv->comment_scrolledwindow = _tmp11_;
#line 78 "../src/Dialogs/MediaEditor.vala"
	_tmp12_ = self->priv->comment_scrolledwindow;
#line 78 "../src/Dialogs/MediaEditor.vala"
	gtk_scrolled_window_set_policy (_tmp12_, GTK_POLICY_EXTERNAL, GTK_POLICY_AUTOMATIC);
#line 79 "../src/Dialogs/MediaEditor.vala"
	_tmp13_ = self->priv->comment_scrolledwindow;
#line 79 "../src/Dialogs/MediaEditor.vala"
	_tmp14_ = self->priv->comment_textview;
#line 79 "../src/Dialogs/MediaEditor.vala"
	gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
#line 80 "../src/Dialogs/MediaEditor.vala"
	_tmp15_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 500, (gdouble) 1);
#line 80 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp15_);
#line 80 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->track_spinbutton);
#line 80 "../src/Dialogs/MediaEditor.vala"
	self->priv->track_spinbutton = _tmp15_;
#line 81 "../src/Dialogs/MediaEditor.vala"
	_tmp16_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 500, (gdouble) 1);
#line 81 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp16_);
#line 81 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->disk_spinbutton);
#line 81 "../src/Dialogs/MediaEditor.vala"
	self->priv->disk_spinbutton = _tmp16_;
#line 82 "../src/Dialogs/MediaEditor.vala"
	_tmp17_ = g_date_time_new_now_local ();
#line 82 "../src/Dialogs/MediaEditor.vala"
	local_time = _tmp17_;
#line 83 "../src/Dialogs/MediaEditor.vala"
	_tmp18_ = local_time;
#line 83 "../src/Dialogs/MediaEditor.vala"
	_tmp19_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) g_date_time_get_year (_tmp18_), (gdouble) 1);
#line 83 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp19_);
#line 83 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->year_spinbutton);
#line 83 "../src/Dialogs/MediaEditor.vala"
	self->priv->year_spinbutton = _tmp19_;
#line 84 "../src/Dialogs/MediaEditor.vala"
	_tmp20_ = music_rating_widget_new (FALSE, GTK_ICON_SIZE_MENU, FALSE);
#line 84 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp20_);
#line 84 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->rating_widget);
#line 84 "../src/Dialogs/MediaEditor.vala"
	self->priv->rating_widget = _tmp20_;
#line 85 "../src/Dialogs/MediaEditor.vala"
	_tmp21_ = self->priv->rating_widget;
#line 85 "../src/Dialogs/MediaEditor.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp21_, TRUE);
#line 87 "../src/Dialogs/MediaEditor.vala"
	_tmp22_ = (GtkFrame*) gtk_frame_new (NULL);
#line 87 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp22_);
#line 87 "../src/Dialogs/MediaEditor.vala"
	comment_frame = _tmp22_;
#line 88 "../src/Dialogs/MediaEditor.vala"
	_tmp23_ = comment_frame;
#line 88 "../src/Dialogs/MediaEditor.vala"
	g_object_set ((GtkWidget*) _tmp23_, "expand", TRUE, NULL);
#line 89 "../src/Dialogs/MediaEditor.vala"
	_tmp24_ = comment_frame;
#line 89 "../src/Dialogs/MediaEditor.vala"
	_tmp25_ = self->priv->comment_scrolledwindow;
#line 89 "../src/Dialogs/MediaEditor.vala"
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
#line 91 "../src/Dialogs/MediaEditor.vala"
	_tmp26_ = (GtkGrid*) gtk_grid_new ();
#line 91 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp26_);
#line 91 "../src/Dialogs/MediaEditor.vala"
	grid = _tmp26_;
#line 92 "../src/Dialogs/MediaEditor.vala"
	_tmp27_ = grid;
#line 92 "../src/Dialogs/MediaEditor.vala"
	g_object_set ((GtkWidget*) _tmp27_, "expand", TRUE, NULL);
#line 93 "../src/Dialogs/MediaEditor.vala"
	_tmp28_ = grid;
#line 93 "../src/Dialogs/MediaEditor.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp28_, 12);
#line 94 "../src/Dialogs/MediaEditor.vala"
	_tmp29_ = grid;
#line 94 "../src/Dialogs/MediaEditor.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp29_, 12);
#line 95 "../src/Dialogs/MediaEditor.vala"
	_tmp30_ = grid;
#line 95 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_set_column_spacing (_tmp30_, 12);
#line 96 "../src/Dialogs/MediaEditor.vala"
	_tmp31_ = grid;
#line 96 "../src/Dialogs/MediaEditor.vala"
	_tmp32_ = granite_header_label_new (_ ("Title:"));
#line 96 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp32_);
#line 96 "../src/Dialogs/MediaEditor.vala"
	_tmp33_ = _tmp32_;
#line 96 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp31_, (GtkWidget*) _tmp33_, 0, 0, 1, 1);
#line 96 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (_tmp33_);
#line 97 "../src/Dialogs/MediaEditor.vala"
	_tmp34_ = grid;
#line 97 "../src/Dialogs/MediaEditor.vala"
	_tmp35_ = self->priv->title_entry;
#line 97 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp34_, (GtkWidget*) _tmp35_, 0, 1, 1, 1);
#line 98 "../src/Dialogs/MediaEditor.vala"
	_tmp36_ = grid;
#line 98 "../src/Dialogs/MediaEditor.vala"
	_tmp37_ = granite_header_label_new (_ ("Artist:"));
#line 98 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp37_);
#line 98 "../src/Dialogs/MediaEditor.vala"
	_tmp38_ = _tmp37_;
#line 98 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp36_, (GtkWidget*) _tmp38_, 1, 0, 1, 1);
#line 98 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (_tmp38_);
#line 99 "../src/Dialogs/MediaEditor.vala"
	_tmp39_ = grid;
#line 99 "../src/Dialogs/MediaEditor.vala"
	_tmp40_ = self->priv->artist_entry;
#line 99 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp39_, (GtkWidget*) _tmp40_, 1, 1, 1, 1);
#line 100 "../src/Dialogs/MediaEditor.vala"
	_tmp41_ = grid;
#line 100 "../src/Dialogs/MediaEditor.vala"
	_tmp42_ = granite_header_label_new (_ ("Album:"));
#line 100 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp42_);
#line 100 "../src/Dialogs/MediaEditor.vala"
	_tmp43_ = _tmp42_;
#line 100 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp41_, (GtkWidget*) _tmp43_, 0, 2, 1, 1);
#line 100 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (_tmp43_);
#line 101 "../src/Dialogs/MediaEditor.vala"
	_tmp44_ = grid;
#line 101 "../src/Dialogs/MediaEditor.vala"
	_tmp45_ = self->priv->album_entry;
#line 101 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp44_, (GtkWidget*) _tmp45_, 0, 3, 1, 1);
#line 102 "../src/Dialogs/MediaEditor.vala"
	_tmp46_ = grid;
#line 102 "../src/Dialogs/MediaEditor.vala"
	_tmp47_ = granite_header_label_new (_ ("Album Artist:"));
#line 102 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp47_);
#line 102 "../src/Dialogs/MediaEditor.vala"
	_tmp48_ = _tmp47_;
#line 102 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp46_, (GtkWidget*) _tmp48_, 1, 2, 1, 1);
#line 102 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (_tmp48_);
#line 103 "../src/Dialogs/MediaEditor.vala"
	_tmp49_ = grid;
#line 103 "../src/Dialogs/MediaEditor.vala"
	_tmp50_ = self->priv->album_artist_entry;
#line 103 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp49_, (GtkWidget*) _tmp50_, 1, 3, 1, 1);
#line 104 "../src/Dialogs/MediaEditor.vala"
	_tmp51_ = grid;
#line 104 "../src/Dialogs/MediaEditor.vala"
	_tmp52_ = granite_header_label_new (_ ("Composer:"));
#line 104 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp52_);
#line 104 "../src/Dialogs/MediaEditor.vala"
	_tmp53_ = _tmp52_;
#line 104 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp51_, (GtkWidget*) _tmp53_, 0, 4, 1, 1);
#line 104 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (_tmp53_);
#line 105 "../src/Dialogs/MediaEditor.vala"
	_tmp54_ = grid;
#line 105 "../src/Dialogs/MediaEditor.vala"
	_tmp55_ = self->priv->composer_entry;
#line 105 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp54_, (GtkWidget*) _tmp55_, 0, 5, 1, 1);
#line 106 "../src/Dialogs/MediaEditor.vala"
	_tmp56_ = grid;
#line 106 "../src/Dialogs/MediaEditor.vala"
	_tmp57_ = granite_header_label_new (_ ("Grouping:"));
#line 106 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp57_);
#line 106 "../src/Dialogs/MediaEditor.vala"
	_tmp58_ = _tmp57_;
#line 106 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp56_, (GtkWidget*) _tmp58_, 1, 4, 1, 1);
#line 106 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (_tmp58_);
#line 107 "../src/Dialogs/MediaEditor.vala"
	_tmp59_ = grid;
#line 107 "../src/Dialogs/MediaEditor.vala"
	_tmp60_ = self->priv->grouping_entry;
#line 107 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp59_, (GtkWidget*) _tmp60_, 1, 5, 1, 1);
#line 108 "../src/Dialogs/MediaEditor.vala"
	_tmp61_ = grid;
#line 108 "../src/Dialogs/MediaEditor.vala"
	_tmp62_ = granite_header_label_new (_ ("Genre:"));
#line 108 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp62_);
#line 108 "../src/Dialogs/MediaEditor.vala"
	_tmp63_ = _tmp62_;
#line 108 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp61_, (GtkWidget*) _tmp63_, 0, 6, 1, 1);
#line 108 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (_tmp63_);
#line 109 "../src/Dialogs/MediaEditor.vala"
	_tmp64_ = grid;
#line 109 "../src/Dialogs/MediaEditor.vala"
	_tmp65_ = self->priv->genre_entry;
#line 109 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp64_, (GtkWidget*) _tmp65_, 0, 7, 1, 1);
#line 110 "../src/Dialogs/MediaEditor.vala"
	_tmp66_ = grid;
#line 110 "../src/Dialogs/MediaEditor.vala"
	_tmp67_ = granite_header_label_new (_ ("Year:"));
#line 110 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp67_);
#line 110 "../src/Dialogs/MediaEditor.vala"
	_tmp68_ = _tmp67_;
#line 110 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp66_, (GtkWidget*) _tmp68_, 1, 6, 1, 1);
#line 110 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (_tmp68_);
#line 111 "../src/Dialogs/MediaEditor.vala"
	_tmp69_ = grid;
#line 111 "../src/Dialogs/MediaEditor.vala"
	_tmp70_ = self->priv->year_spinbutton;
#line 111 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp69_, (GtkWidget*) _tmp70_, 1, 7, 1, 1);
#line 112 "../src/Dialogs/MediaEditor.vala"
	_tmp71_ = grid;
#line 112 "../src/Dialogs/MediaEditor.vala"
	_tmp72_ = granite_header_label_new (_ ("Track:"));
#line 112 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp72_);
#line 112 "../src/Dialogs/MediaEditor.vala"
	_tmp73_ = _tmp72_;
#line 112 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp71_, (GtkWidget*) _tmp73_, 1, 8, 1, 1);
#line 112 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (_tmp73_);
#line 113 "../src/Dialogs/MediaEditor.vala"
	_tmp74_ = grid;
#line 113 "../src/Dialogs/MediaEditor.vala"
	_tmp75_ = self->priv->track_spinbutton;
#line 113 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp74_, (GtkWidget*) _tmp75_, 1, 9, 1, 1);
#line 114 "../src/Dialogs/MediaEditor.vala"
	_tmp76_ = grid;
#line 114 "../src/Dialogs/MediaEditor.vala"
	_tmp77_ = granite_header_label_new (_ ("Disc:"));
#line 114 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp77_);
#line 114 "../src/Dialogs/MediaEditor.vala"
	_tmp78_ = _tmp77_;
#line 114 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp76_, (GtkWidget*) _tmp78_, 1, 10, 1, 1);
#line 114 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (_tmp78_);
#line 115 "../src/Dialogs/MediaEditor.vala"
	_tmp79_ = grid;
#line 115 "../src/Dialogs/MediaEditor.vala"
	_tmp80_ = self->priv->disk_spinbutton;
#line 115 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp79_, (GtkWidget*) _tmp80_, 1, 11, 1, 1);
#line 116 "../src/Dialogs/MediaEditor.vala"
	_tmp81_ = grid;
#line 116 "../src/Dialogs/MediaEditor.vala"
	_tmp82_ = granite_header_label_new (_ ("Rating:"));
#line 116 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp82_);
#line 116 "../src/Dialogs/MediaEditor.vala"
	_tmp83_ = _tmp82_;
#line 116 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp81_, (GtkWidget*) _tmp83_, 1, 12, 1, 1);
#line 116 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (_tmp83_);
#line 117 "../src/Dialogs/MediaEditor.vala"
	_tmp84_ = grid;
#line 117 "../src/Dialogs/MediaEditor.vala"
	_tmp85_ = self->priv->rating_widget;
#line 117 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp84_, (GtkWidget*) _tmp85_, 1, 13, 1, 1);
#line 118 "../src/Dialogs/MediaEditor.vala"
	_tmp86_ = grid;
#line 118 "../src/Dialogs/MediaEditor.vala"
	_tmp87_ = granite_header_label_new (_ ("Comment:"));
#line 118 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp87_);
#line 118 "../src/Dialogs/MediaEditor.vala"
	_tmp88_ = _tmp87_;
#line 118 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp86_, (GtkWidget*) _tmp88_, 0, 8, 1, 1);
#line 118 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (_tmp88_);
#line 119 "../src/Dialogs/MediaEditor.vala"
	_tmp89_ = grid;
#line 119 "../src/Dialogs/MediaEditor.vala"
	_tmp90_ = comment_frame;
#line 119 "../src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp89_, (GtkWidget*) _tmp90_, 0, 9, 1, 5);
#line 121 "../src/Dialogs/MediaEditor.vala"
	_tmp91_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 121 "../src/Dialogs/MediaEditor.vala"
	_tmp92_ = grid;
#line 121 "../src/Dialogs/MediaEditor.vala"
	gtk_container_add ((GtkContainer*) _tmp91_, (GtkWidget*) _tmp92_);
#line 123 "../src/Dialogs/MediaEditor.vala"
	_tmp93_ = (GtkButton*) gtk_button_new_from_icon_name ("go-previous-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 123 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp93_);
#line 123 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->previous_button);
#line 123 "../src/Dialogs/MediaEditor.vala"
	self->priv->previous_button = _tmp93_;
#line 124 "../src/Dialogs/MediaEditor.vala"
	_tmp94_ = (GtkButton*) gtk_button_new_from_icon_name ("go-next-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 124 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp94_);
#line 124 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->next_button);
#line 124 "../src/Dialogs/MediaEditor.vala"
	self->priv->next_button = _tmp94_;
#line 126 "../src/Dialogs/MediaEditor.vala"
	_tmp95_ = (GtkGrid*) gtk_grid_new ();
#line 126 "../src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp95_);
#line 126 "../src/Dialogs/MediaEditor.vala"
	arrows_grid = _tmp95_;
#line 127 "../src/Dialogs/MediaEditor.vala"
	_tmp96_ = arrows_grid;
#line 127 "../src/Dialogs/MediaEditor.vala"
	_tmp97_ = gtk_widget_get_style_context ((GtkWidget*) _tmp96_);
#line 127 "../src/Dialogs/MediaEditor.vala"
	gtk_style_context_add_class (_tmp97_, GTK_STYLE_CLASS_LINKED);
#line 128 "../src/Dialogs/MediaEditor.vala"
	_tmp98_ = arrows_grid;
#line 128 "../src/Dialogs/MediaEditor.vala"
	_tmp99_ = self->priv->previous_button;
#line 128 "../src/Dialogs/MediaEditor.vala"
	gtk_container_add ((GtkContainer*) _tmp98_, (GtkWidget*) _tmp99_);
#line 129 "../src/Dialogs/MediaEditor.vala"
	_tmp100_ = arrows_grid;
#line 129 "../src/Dialogs/MediaEditor.vala"
	_tmp101_ = self->priv->next_button;
#line 129 "../src/Dialogs/MediaEditor.vala"
	gtk_container_add ((GtkContainer*) _tmp100_, (GtkWidget*) _tmp101_);
#line 131 "../src/Dialogs/MediaEditor.vala"
	gtk_dialog_add_button ((GtkDialog*) self, _ ("Close"), (gint) GTK_RESPONSE_CLOSE);
#line 133 "../src/Dialogs/MediaEditor.vala"
	_tmp102_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Save"), (gint) GTK_RESPONSE_APPLY);
#line 133 "../src/Dialogs/MediaEditor.vala"
	_tmp103_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp102_, gtk_button_get_type (), GtkButton));
#line 133 "../src/Dialogs/MediaEditor.vala"
	save_button = _tmp103_;
#line 134 "../src/Dialogs/MediaEditor.vala"
	_tmp104_ = save_button;
#line 134 "../src/Dialogs/MediaEditor.vala"
	g_object_set ((GtkWidget*) _tmp104_, "has-default", TRUE, NULL);
#line 135 "../src/Dialogs/MediaEditor.vala"
	_tmp105_ = save_button;
#line 135 "../src/Dialogs/MediaEditor.vala"
	_tmp106_ = gtk_widget_get_style_context ((GtkWidget*) _tmp105_);
#line 135 "../src/Dialogs/MediaEditor.vala"
	gtk_style_context_add_class (_tmp106_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 137 "../src/Dialogs/MediaEditor.vala"
	_tmp107_ = gtk_dialog_get_action_area ((GtkDialog*) self);
#line 137 "../src/Dialogs/MediaEditor.vala"
	_tmp108_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp107_, gtk_button_box_get_type (), GtkButtonBox));
#line 137 "../src/Dialogs/MediaEditor.vala"
	action_area = _tmp108_;
#line 138 "../src/Dialogs/MediaEditor.vala"
	_tmp109_ = action_area;
#line 138 "../src/Dialogs/MediaEditor.vala"
	g_object_set ((GtkWidget*) _tmp109_, "margin", 5, NULL);
#line 139 "../src/Dialogs/MediaEditor.vala"
	_tmp110_ = action_area;
#line 139 "../src/Dialogs/MediaEditor.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp110_, 14);
#line 140 "../src/Dialogs/MediaEditor.vala"
	_tmp111_ = action_area;
#line 140 "../src/Dialogs/MediaEditor.vala"
	_tmp112_ = arrows_grid;
#line 140 "../src/Dialogs/MediaEditor.vala"
	gtk_box_pack_start ((GtkBox*) _tmp111_, (GtkWidget*) _tmp112_, FALSE, FALSE, (guint) 0);
#line 141 "../src/Dialogs/MediaEditor.vala"
	_tmp113_ = action_area;
#line 141 "../src/Dialogs/MediaEditor.vala"
	_tmp114_ = arrows_grid;
#line 141 "../src/Dialogs/MediaEditor.vala"
	gtk_button_box_set_child_secondary (_tmp113_, (GtkWidget*) _tmp114_, TRUE);
#line 142 "../src/Dialogs/MediaEditor.vala"
	_tmp115_ = action_area;
#line 142 "../src/Dialogs/MediaEditor.vala"
	_tmp116_ = arrows_grid;
#line 142 "../src/Dialogs/MediaEditor.vala"
	gtk_button_box_set_child_non_homogeneous (_tmp115_, (GtkWidget*) _tmp116_, TRUE);
#line 144 "../src/Dialogs/MediaEditor.vala"
	_tmp117_ = self->priv->previous_button;
#line 144 "../src/Dialogs/MediaEditor.vala"
	g_signal_connect_object (_tmp117_, "clicked", (GCallback) _music_media_editor_previous_track_gtk_button_clicked, self, 0);
#line 145 "../src/Dialogs/MediaEditor.vala"
	_tmp118_ = self->priv->next_button;
#line 145 "../src/Dialogs/MediaEditor.vala"
	g_signal_connect_object (_tmp118_, "clicked", (GCallback) _music_media_editor_next_track_gtk_button_clicked, self, 0);
#line 147 "../src/Dialogs/MediaEditor.vala"
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) __music_media_editor___lambda49__gtk_dialog_response, self, 0);
#line 64 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (action_area);
#line 64 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (save_button);
#line 64 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (arrows_grid);
#line 64 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (grid);
#line 64 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (comment_frame);
#line 64 "../src/Dialogs/MediaEditor.vala"
	_g_date_time_unref0 (local_time);
#line 64 "../src/Dialogs/MediaEditor.vala"
	return obj;
#line 1862 "MediaEditor.c"
}

static void
music_media_editor_class_init (MusicMediaEditorClass * klass,
                               gpointer klass_data)
{
#line 28 "../src/Dialogs/MediaEditor.vala"
	music_media_editor_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/Dialogs/MediaEditor.vala"
	g_type_class_adjust_private_offset (klass, &MusicMediaEditor_private_offset);
#line 28 "../src/Dialogs/MediaEditor.vala"
	G_OBJECT_CLASS (klass)->constructor = music_media_editor_constructor;
#line 28 "../src/Dialogs/MediaEditor.vala"
	G_OBJECT_CLASS (klass)->finalize = music_media_editor_finalize;
#line 1877 "MediaEditor.c"
}

static void
music_media_editor_instance_init (MusicMediaEditor * self,
                                  gpointer klass)
{
#line 28 "../src/Dialogs/MediaEditor.vala"
	self->priv = music_media_editor_get_instance_private (self);
#line 1886 "MediaEditor.c"
}

static void
music_media_editor_finalize (GObject * obj)
{
	MusicMediaEditor * self;
#line 28 "../src/Dialogs/MediaEditor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MEDIA_EDITOR, MusicMediaEditor);
#line 29 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->title_entry);
#line 30 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->artist_entry);
#line 31 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->album_artist_entry);
#line 32 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->album_entry);
#line 33 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->genre_entry);
#line 34 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->composer_entry);
#line 35 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->grouping_entry);
#line 36 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->comment_textview);
#line 37 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->comment_scrolledwindow);
#line 38 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->track_spinbutton);
#line 39 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->disk_spinbutton);
#line 40 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->year_spinbutton);
#line 41 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->rating_widget);
#line 43 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->previous_button);
#line 44 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->next_button);
#line 46 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->media_list);
#line 47 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->temp_list);
#line 48 "../src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->current_media);
#line 28 "../src/Dialogs/MediaEditor.vala"
	G_OBJECT_CLASS (music_media_editor_parent_class)->finalize (obj);
#line 1933 "MediaEditor.c"
}

static GType
music_media_editor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicMediaEditorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_media_editor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicMediaEditor), 0, (GInstanceInitFunc) music_media_editor_instance_init, NULL };
	GType music_media_editor_type_id;
	music_media_editor_type_id = g_type_register_static (GRANITE_TYPE_DIALOG, "MusicMediaEditor", &g_define_type_info, 0);
	MusicMediaEditor_private_offset = g_type_add_instance_private (music_media_editor_type_id, sizeof (MusicMediaEditorPrivate));
	return music_media_editor_type_id;
}

GType
music_media_editor_get_type (void)
{
	static volatile gsize music_media_editor_type_id__once = 0;
	if (g_once_init_enter (&music_media_editor_type_id__once)) {
		GType music_media_editor_type_id;
		music_media_editor_type_id = music_media_editor_get_type_once ();
		g_once_init_leave (&music_media_editor_type_id__once, music_media_editor_type_id);
	}
	return music_media_editor_type_id__once;
}

