/* NotImportedDialog.c generated by valac 0.56.0, the Vala compiler
 * generated from NotImportedDialog.vala, do not modify */

/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */
/* Merely a place holder for multiple pieces of information regarding
 * the current media playing. Mostly here because of dependence. */

#include "music-lib.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

enum  {
	MUSIC_NOT_IMPORTED_DIALOG_0_PROPERTY,
	MUSIC_NOT_IMPORTED_DIALOG_NUM_PROPERTIES
};
static GParamSpec* music_not_imported_dialog_properties[MUSIC_NOT_IMPORTED_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block14Data Block14Data;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MusicNotImportedDialogPrivate {
	GeeLinkedList* _files;
	gchar* music_folder;
	GtkListStore* files_model;
	GtkButton* move_to_trash;
};

struct _Block14Data {
	int _ref_count_;
	MusicNotImportedDialog* self;
	GtkCheckButton* trash_all;
	GtkTreeView* files_view;
	GtkExpander* expander;
};

static gint MusicNotImportedDialog_private_offset;
static gpointer music_not_imported_dialog_parent_class = NULL;

static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static void music_not_imported_dialog_move_to_trash_click (MusicNotImportedDialog* self);
static void _music_not_imported_dialog_move_to_trash_click_gtk_button_clicked (GtkButton* _sender,
                                                                        gpointer self);
static void __lambda13_ (MusicNotImportedDialog* self,
                  GtkCellRendererToggle* toggle,
                  const gchar* path);
static gboolean music_not_imported_dialog_update_move_to_trash_sensitivity (MusicNotImportedDialog* self,
                                                                     GtkTreeModel* model,
                                                                     GtkTreePath* path,
                                                                     GtkTreeIter* iter);
static gboolean _music_not_imported_dialog_update_move_to_trash_sensitivity_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                                                  GtkTreePath* path,
                                                                                                  GtkTreeIter* iter,
                                                                                                  gpointer self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void ___lambda13__gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender,
                                                    const gchar* path,
                                                    gpointer self);
static void __lambda14_ (Block14Data* _data14_);
static gboolean music_not_imported_dialog_select_all (MusicNotImportedDialog* self,
                                               GtkTreeModel* model,
                                               GtkTreePath* path,
                                               GtkTreeIter* iter);
static gboolean _music_not_imported_dialog_select_all_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                            GtkTreePath* path,
                                                                            GtkTreeIter* iter,
                                                                            gpointer self);
static gboolean music_not_imported_dialog_unselect_all (MusicNotImportedDialog* self,
                                                 GtkTreeModel* model,
                                                 GtkTreePath* path,
                                                 GtkTreeIter* iter);
static gboolean _music_not_imported_dialog_unselect_all_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                              GtkTreePath* path,
                                                                              GtkTreeIter* iter,
                                                                              gpointer self);
static void ___lambda14__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda15_ (MusicNotImportedDialog* self);
static void ___lambda15__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda16_ (Block14Data* _data14_);
static void ___lambda16__gtk_expander_activate (GtkExpander* _sender,
                                         gpointer self);
static gboolean music_not_imported_dialog_delete_selected_items (MusicNotImportedDialog* self,
                                                          GtkTreeModel* model,
                                                          GtkTreePath* path,
                                                          GtkTreeIter* iter);
static gboolean _music_not_imported_dialog_delete_selected_items_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                                       GtkTreePath* path,
                                                                                       GtkTreeIter* iter,
                                                                                       gpointer self);
static void music_not_imported_dialog_finalize (GObject * obj);
static GType music_not_imported_dialog_get_type_once (void);

static inline gpointer
music_not_imported_dialog_get_instance_private (MusicNotImportedDialog* self)
{
	return G_STRUCT_MEMBER_P (self, MusicNotImportedDialog_private_offset);
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	g_atomic_int_inc (&_data14_->_ref_count_);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	return _data14_;
#line 144 "NotImportedDialog.c"
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
#line 154 "NotImportedDialog.c"
		MusicNotImportedDialog* self;
#line 38 "../src/Dialogs/NotImportedDialog.vala"
		self = _data14_->self;
#line 38 "../src/Dialogs/NotImportedDialog.vala"
		_g_object_unref0 (_data14_->expander);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
		_g_object_unref0 (_data14_->files_view);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
		_g_object_unref0 (_data14_->trash_all);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
		_g_object_unref0 (self);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
		g_slice_free (Block14Data, _data14_);
#line 168 "NotImportedDialog.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 191 "NotImportedDialog.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 195 "NotImportedDialog.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 201 "NotImportedDialog.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 205 "NotImportedDialog.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 209 "NotImportedDialog.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 217 "NotImportedDialog.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 245 "NotImportedDialog.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 254 "NotImportedDialog.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 268 "NotImportedDialog.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 277 "NotImportedDialog.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 291 "NotImportedDialog.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 300 "NotImportedDialog.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 309 "NotImportedDialog.c"
}

static void
_music_not_imported_dialog_move_to_trash_click_gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self)
{
#line 125 "../src/Dialogs/NotImportedDialog.vala"
	music_not_imported_dialog_move_to_trash_click ((MusicNotImportedDialog*) self);
#line 318 "NotImportedDialog.c"
}

static gboolean
_music_not_imported_dialog_update_move_to_trash_sensitivity_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                                         GtkTreePath* path,
                                                                                         GtkTreeIter* iter,
                                                                                         gpointer self)
{
	gboolean result;
	result = music_not_imported_dialog_update_move_to_trash_sensitivity ((MusicNotImportedDialog*) self, model, path, iter);
#line 134 "../src/Dialogs/NotImportedDialog.vala"
	return result;
#line 331 "NotImportedDialog.c"
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 127 "../src/Dialogs/NotImportedDialog.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 339 "NotImportedDialog.c"
}

static void
__lambda13_ (MusicNotImportedDialog* self,
             GtkCellRendererToggle* toggle,
             const gchar* path)
{
	GtkTreePath* tree_path = NULL;
	GtkTreePath* _tmp0_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	GtkListStore* _tmp3_;
	GtkTreeIter _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GtkButton* _tmp7_;
	GtkListStore* _tmp8_;
#line 127 "../src/Dialogs/NotImportedDialog.vala"
	g_return_if_fail (toggle != NULL);
#line 127 "../src/Dialogs/NotImportedDialog.vala"
	g_return_if_fail (path != NULL);
#line 128 "../src/Dialogs/NotImportedDialog.vala"
	_tmp0_ = gtk_tree_path_new_from_string (path);
#line 128 "../src/Dialogs/NotImportedDialog.vala"
	tree_path = _tmp0_;
#line 130 "../src/Dialogs/NotImportedDialog.vala"
	_tmp1_ = self->priv->files_model;
#line 130 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp1_, &_tmp2_, tree_path);
#line 130 "../src/Dialogs/NotImportedDialog.vala"
	iter = _tmp2_;
#line 131 "../src/Dialogs/NotImportedDialog.vala"
	_tmp3_ = self->priv->files_model;
#line 131 "../src/Dialogs/NotImportedDialog.vala"
	_tmp4_ = iter;
#line 131 "../src/Dialogs/NotImportedDialog.vala"
	_tmp5_ = gtk_cell_renderer_toggle_get_active (toggle);
#line 131 "../src/Dialogs/NotImportedDialog.vala"
	_tmp6_ = _tmp5_;
#line 131 "../src/Dialogs/NotImportedDialog.vala"
	gtk_list_store_set (_tmp3_, &_tmp4_, 0, !_tmp6_, -1);
#line 133 "../src/Dialogs/NotImportedDialog.vala"
	_tmp7_ = self->priv->move_to_trash;
#line 133 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
#line 134 "../src/Dialogs/NotImportedDialog.vala"
	_tmp8_ = self->priv->files_model;
#line 134 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_model_foreach ((GtkTreeModel*) _tmp8_, _music_not_imported_dialog_update_move_to_trash_sensitivity_gtk_tree_model_foreach_func, self);
#line 127 "../src/Dialogs/NotImportedDialog.vala"
	__vala_GtkTreePath_free0 (tree_path);
#line 392 "NotImportedDialog.c"
}

static void
___lambda13__gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender,
                                               const gchar* path,
                                               gpointer self)
{
#line 127 "../src/Dialogs/NotImportedDialog.vala"
	__lambda13_ ((MusicNotImportedDialog*) self, _sender, path);
#line 402 "NotImportedDialog.c"
}

static gboolean
_music_not_imported_dialog_select_all_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                   GtkTreePath* path,
                                                                   GtkTreeIter* iter,
                                                                   gpointer self)
{
	gboolean result;
	result = music_not_imported_dialog_select_all ((MusicNotImportedDialog*) self, model, path, iter);
#line 139 "../src/Dialogs/NotImportedDialog.vala"
	return result;
#line 415 "NotImportedDialog.c"
}

static gboolean
_music_not_imported_dialog_unselect_all_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                     GtkTreePath* path,
                                                                     GtkTreeIter* iter,
                                                                     gpointer self)
{
	gboolean result;
	result = music_not_imported_dialog_unselect_all ((MusicNotImportedDialog*) self, model, path, iter);
#line 143 "../src/Dialogs/NotImportedDialog.vala"
	return result;
#line 428 "NotImportedDialog.c"
}

static void
__lambda14_ (Block14Data* _data14_)
{
	MusicNotImportedDialog* self;
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 137 "../src/Dialogs/NotImportedDialog.vala"
	self = _data14_->self;
#line 138 "../src/Dialogs/NotImportedDialog.vala"
	_tmp0_ = _data14_->trash_all;
#line 138 "../src/Dialogs/NotImportedDialog.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 138 "../src/Dialogs/NotImportedDialog.vala"
	_tmp2_ = _tmp1_;
#line 138 "../src/Dialogs/NotImportedDialog.vala"
	if (_tmp2_) {
#line 448 "NotImportedDialog.c"
		GtkListStore* _tmp3_;
		GtkTreeView* _tmp4_;
		GtkButton* _tmp5_;
#line 139 "../src/Dialogs/NotImportedDialog.vala"
		_tmp3_ = self->priv->files_model;
#line 139 "../src/Dialogs/NotImportedDialog.vala"
		gtk_tree_model_foreach ((GtkTreeModel*) _tmp3_, _music_not_imported_dialog_select_all_gtk_tree_model_foreach_func, self);
#line 140 "../src/Dialogs/NotImportedDialog.vala"
		_tmp4_ = _data14_->files_view;
#line 140 "../src/Dialogs/NotImportedDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, FALSE);
#line 141 "../src/Dialogs/NotImportedDialog.vala"
		_tmp5_ = self->priv->move_to_trash;
#line 141 "../src/Dialogs/NotImportedDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, TRUE);
#line 464 "NotImportedDialog.c"
	} else {
		GtkListStore* _tmp6_;
		GtkTreeView* _tmp7_;
		GtkButton* _tmp8_;
#line 143 "../src/Dialogs/NotImportedDialog.vala"
		_tmp6_ = self->priv->files_model;
#line 143 "../src/Dialogs/NotImportedDialog.vala"
		gtk_tree_model_foreach ((GtkTreeModel*) _tmp6_, _music_not_imported_dialog_unselect_all_gtk_tree_model_foreach_func, self);
#line 144 "../src/Dialogs/NotImportedDialog.vala"
		_tmp7_ = _data14_->files_view;
#line 144 "../src/Dialogs/NotImportedDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, TRUE);
#line 145 "../src/Dialogs/NotImportedDialog.vala"
		_tmp8_ = self->priv->move_to_trash;
#line 145 "../src/Dialogs/NotImportedDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
#line 481 "NotImportedDialog.c"
	}
}

static void
___lambda14__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
#line 137 "../src/Dialogs/NotImportedDialog.vala"
	__lambda14_ (self);
#line 491 "NotImportedDialog.c"
}

static void
__lambda15_ (MusicNotImportedDialog* self)
{
#line 150 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 499 "NotImportedDialog.c"
}

static void
___lambda15__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 149 "../src/Dialogs/NotImportedDialog.vala"
	__lambda15_ ((MusicNotImportedDialog*) self);
#line 508 "NotImportedDialog.c"
}

static void
__lambda16_ (Block14Data* _data14_)
{
	MusicNotImportedDialog* self;
#line 153 "../src/Dialogs/NotImportedDialog.vala"
	self = _data14_->self;
#line 154 "../src/Dialogs/NotImportedDialog.vala"
	if (gtk_expander_get_expanded (_data14_->expander)) {
#line 155 "../src/Dialogs/NotImportedDialog.vala"
		gtk_widget_set_size_request ((GtkWidget*) _data14_->expander, -1, -1);
#line 521 "NotImportedDialog.c"
	} else {
#line 157 "../src/Dialogs/NotImportedDialog.vala"
		gtk_widget_set_size_request ((GtkWidget*) _data14_->expander, -1, 120);
#line 525 "NotImportedDialog.c"
	}
}

static void
___lambda16__gtk_expander_activate (GtkExpander* _sender,
                                    gpointer self)
{
#line 153 "../src/Dialogs/NotImportedDialog.vala"
	__lambda16_ (self);
#line 535 "NotImportedDialog.c"
}

MusicNotImportedDialog*
music_not_imported_dialog_construct (GType object_type,
                                     GeeCollection* files,
                                     const gchar* music)
{
	MusicNotImportedDialog * self = NULL;
	Block14Data* _data14_;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	gchar* _tmp2_;
	MusicLibraryWindow* _tmp3_;
	MusicLibraryWindow* _tmp4_;
	GtkImage* warning = NULL;
	GtkImage* _tmp5_;
	GtkLabel* title = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkStyleContext* _tmp14_;
	gchar* secondary_text = NULL;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gchar* _tmp19_;
	GtkLabel* info = NULL;
	const gchar* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	GtkCheckButton* _tmp23_;
	GtkCheckButton* _tmp24_;
	GtkCellRendererToggle* toggle = NULL;
	GtkCellRendererToggle* _tmp25_;
	GtkTreeViewColumn* column = NULL;
	GtkTreeViewColumn* _tmp26_;
	GtkTreeViewColumn* _tmp27_;
	GtkTreeViewColumn* _tmp28_;
	GtkCellRendererToggle* _tmp29_;
	GtkTreeViewColumn* _tmp30_;
	GtkCellRendererToggle* _tmp31_;
	GtkListStore* _tmp32_;
	GtkTreeView* _tmp33_;
	GtkTreeView* _tmp34_;
	GtkListStore* _tmp35_;
	GtkTreeView* _tmp36_;
	GtkTreeViewColumn* _tmp37_;
	GtkTreeView* _tmp38_;
	GtkCellRendererText* _tmp39_;
	GtkCellRendererText* _tmp40_;
	GtkTreeView* _tmp41_;
	GtkScrolledWindow* files_scrolled = NULL;
	GtkScrolledWindow* _tmp58_;
	GtkTreeView* _tmp59_;
	GtkExpander* _tmp60_;
	GtkButton* _tmp61_;
	GtkButton* _tmp62_;
	GtkButton* ignore_button = NULL;
	GtkButton* _tmp63_;
	GtkButtonBox* button_box = NULL;
	GtkButtonBox* _tmp64_;
	GtkButton* _tmp65_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp66_;
	GtkImage* _tmp67_;
	GtkLabel* _tmp68_;
	GtkLabel* _tmp69_;
	GtkCheckButton* _tmp70_;
	GtkBox* _tmp71_;
	GtkButton* _tmp72_;
	GtkCellRendererToggle* _tmp73_;
	GtkCheckButton* _tmp74_;
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (files != NULL, NULL);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (music != NULL, NULL);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	_data14_ = g_slice_new0 (Block14Data);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	_data14_->_ref_count_ = 1;
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	self = (MusicNotImportedDialog*) granite_dialog_construct (object_type);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	_data14_->self = g_object_ref (self);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (self->priv->_files);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	self->priv->_files = _tmp0_;
#line 40 "../src/Dialogs/NotImportedDialog.vala"
	_tmp1_ = self->priv->_files;
#line 40 "../src/Dialogs/NotImportedDialog.vala"
	gee_collection_add_all ((GeeCollection*) _tmp1_, files);
#line 41 "../src/Dialogs/NotImportedDialog.vala"
	_tmp2_ = g_strdup (music);
#line 41 "../src/Dialogs/NotImportedDialog.vala"
	_g_free0 (self->priv->music_folder);
#line 41 "../src/Dialogs/NotImportedDialog.vala"
	self->priv->music_folder = _tmp2_;
#line 43 "../src/Dialogs/NotImportedDialog.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 44 "../src/Dialogs/NotImportedDialog.vala"
	_tmp3_ = music_app_get_main_window ();
#line 44 "../src/Dialogs/NotImportedDialog.vala"
	_tmp4_ = _tmp3_;
#line 44 "../src/Dialogs/NotImportedDialog.vala"
	gtk_window_set_transient_for ((GtkWindow*) self, (GtkWindow*) _tmp4_);
#line 45 "../src/Dialogs/NotImportedDialog.vala"
	gtk_window_set_destroy_with_parent ((GtkWindow*) self, TRUE);
#line 46 "../src/Dialogs/NotImportedDialog.vala"
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
#line 48 "../src/Dialogs/NotImportedDialog.vala"
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("dialog-error", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 48 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp5_);
#line 48 "../src/Dialogs/NotImportedDialog.vala"
	warning = _tmp5_;
#line 50 "../src/Dialogs/NotImportedDialog.vala"
	_tmp6_ = self->priv->music_folder;
#line 50 "../src/Dialogs/NotImportedDialog.vala"
	_tmp7_ = g_strdup_printf (_ ("Issues while importing from %s"), _tmp6_);
#line 50 "../src/Dialogs/NotImportedDialog.vala"
	_tmp8_ = _tmp7_;
#line 50 "../src/Dialogs/NotImportedDialog.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (_tmp8_);
#line 50 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp9_);
#line 50 "../src/Dialogs/NotImportedDialog.vala"
	_tmp10_ = _tmp9_;
#line 50 "../src/Dialogs/NotImportedDialog.vala"
	_g_free0 (_tmp8_);
#line 50 "../src/Dialogs/NotImportedDialog.vala"
	title = _tmp10_;
#line 51 "../src/Dialogs/NotImportedDialog.vala"
	_tmp11_ = title;
#line 51 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp11_, GTK_ALIGN_START);
#line 52 "../src/Dialogs/NotImportedDialog.vala"
	_tmp12_ = title;
#line 52 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp12_, TRUE);
#line 53 "../src/Dialogs/NotImportedDialog.vala"
	_tmp13_ = title;
#line 53 "../src/Dialogs/NotImportedDialog.vala"
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
#line 53 "../src/Dialogs/NotImportedDialog.vala"
	gtk_style_context_add_class (_tmp14_, GRANITE_STYLE_CLASS_PRIMARY_LABEL);
#line 55 "../src/Dialogs/NotImportedDialog.vala"
	_tmp15_ = gee_collection_get_size (files);
#line 55 "../src/Dialogs/NotImportedDialog.vala"
	_tmp16_ = _tmp15_;
#line 55 "../src/Dialogs/NotImportedDialog.vala"
	_tmp17_ = gee_collection_get_size (files);
#line 55 "../src/Dialogs/NotImportedDialog.vala"
	_tmp18_ = _tmp17_;
#line 55 "../src/Dialogs/NotImportedDialog.vala"
	_tmp19_ = g_strdup_printf (ngettext ("Unable to import %d item. The file may be damaged.", "Unable to import %d items. The files may be damaged.", (gulong) _tmp16_), _tmp18_);
#line 55 "../src/Dialogs/NotImportedDialog.vala"
	secondary_text = _tmp19_;
#line 61 "../src/Dialogs/NotImportedDialog.vala"
	_tmp20_ = secondary_text;
#line 61 "../src/Dialogs/NotImportedDialog.vala"
	_tmp21_ = (GtkLabel*) gtk_label_new (_tmp20_);
#line 61 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp21_);
#line 61 "../src/Dialogs/NotImportedDialog.vala"
	info = _tmp21_;
#line 62 "../src/Dialogs/NotImportedDialog.vala"
	_tmp22_ = info;
#line 62 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp22_, GTK_ALIGN_START);
#line 64 "../src/Dialogs/NotImportedDialog.vala"
	_tmp23_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Move all corrupted files to trash"));
#line 64 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp23_);
#line 64 "../src/Dialogs/NotImportedDialog.vala"
	_data14_->trash_all = _tmp23_;
#line 65 "../src/Dialogs/NotImportedDialog.vala"
	_tmp24_ = _data14_->trash_all;
#line 65 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp24_, GTK_ALIGN_CENTER);
#line 68 "../src/Dialogs/NotImportedDialog.vala"
	_tmp25_ = (GtkCellRendererToggle*) gtk_cell_renderer_toggle_new ();
#line 68 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp25_);
#line 68 "../src/Dialogs/NotImportedDialog.vala"
	toggle = _tmp25_;
#line 70 "../src/Dialogs/NotImportedDialog.vala"
	_tmp26_ = gtk_tree_view_column_new ();
#line 70 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp26_);
#line 70 "../src/Dialogs/NotImportedDialog.vala"
	column = _tmp26_;
#line 71 "../src/Dialogs/NotImportedDialog.vala"
	_tmp27_ = column;
#line 71 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_view_column_set_title (_tmp27_, _ ("del"));
#line 72 "../src/Dialogs/NotImportedDialog.vala"
	_tmp28_ = column;
#line 72 "../src/Dialogs/NotImportedDialog.vala"
	_tmp29_ = toggle;
#line 72 "../src/Dialogs/NotImportedDialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp28_, (GtkCellRenderer*) _tmp29_, FALSE);
#line 73 "../src/Dialogs/NotImportedDialog.vala"
	_tmp30_ = column;
#line 73 "../src/Dialogs/NotImportedDialog.vala"
	_tmp31_ = toggle;
#line 73 "../src/Dialogs/NotImportedDialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp30_, (GtkCellRenderer*) _tmp31_, "active", 0);
#line 75 "../src/Dialogs/NotImportedDialog.vala"
	_tmp32_ = gtk_list_store_new (2, G_TYPE_BOOLEAN, G_TYPE_STRING, -1);
#line 75 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (self->priv->files_model);
#line 75 "../src/Dialogs/NotImportedDialog.vala"
	self->priv->files_model = _tmp32_;
#line 77 "../src/Dialogs/NotImportedDialog.vala"
	_tmp33_ = (GtkTreeView*) gtk_tree_view_new ();
#line 77 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp33_);
#line 77 "../src/Dialogs/NotImportedDialog.vala"
	_data14_->files_view = _tmp33_;
#line 78 "../src/Dialogs/NotImportedDialog.vala"
	_tmp34_ = _data14_->files_view;
#line 78 "../src/Dialogs/NotImportedDialog.vala"
	_tmp35_ = self->priv->files_model;
#line 78 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_view_set_model (_tmp34_, (GtkTreeModel*) _tmp35_);
#line 79 "../src/Dialogs/NotImportedDialog.vala"
	_tmp36_ = _data14_->files_view;
#line 79 "../src/Dialogs/NotImportedDialog.vala"
	_tmp37_ = column;
#line 79 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_view_append_column (_tmp36_, _tmp37_);
#line 80 "../src/Dialogs/NotImportedDialog.vala"
	_tmp38_ = _data14_->files_view;
#line 80 "../src/Dialogs/NotImportedDialog.vala"
	_tmp39_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 80 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp39_);
#line 80 "../src/Dialogs/NotImportedDialog.vala"
	_tmp40_ = _tmp39_;
#line 80 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp38_, -1, _ ("File Location"), (GtkCellRenderer*) _tmp40_, "text", 1, NULL, NULL);
#line 80 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (_tmp40_);
#line 81 "../src/Dialogs/NotImportedDialog.vala"
	_tmp41_ = _data14_->files_view;
#line 81 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_view_set_headers_visible (_tmp41_, FALSE);
#line 792 "NotImportedDialog.c"
	{
		GeeIterator* _file_it = NULL;
		GeeIterator* _tmp42_;
#line 84 "../src/Dialogs/NotImportedDialog.vala"
		_tmp42_ = gee_iterable_iterator ((GeeIterable*) files);
#line 84 "../src/Dialogs/NotImportedDialog.vala"
		_file_it = _tmp42_;
#line 84 "../src/Dialogs/NotImportedDialog.vala"
		while (TRUE) {
#line 802 "NotImportedDialog.c"
			GeeIterator* _tmp43_;
			gchar* file = NULL;
			GeeIterator* _tmp44_;
			gpointer _tmp45_;
			GtkTreeIter item = {0};
			GtkListStore* _tmp46_;
			GtkTreeIter _tmp47_ = {0};
			GtkListStore* _tmp48_;
			GtkTreeIter _tmp49_;
			const gchar* _tmp50_;
			const gchar* _tmp51_;
			gchar* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
#line 84 "../src/Dialogs/NotImportedDialog.vala"
			_tmp43_ = _file_it;
#line 84 "../src/Dialogs/NotImportedDialog.vala"
			if (!gee_iterator_next (_tmp43_)) {
#line 84 "../src/Dialogs/NotImportedDialog.vala"
				break;
#line 826 "NotImportedDialog.c"
			}
#line 84 "../src/Dialogs/NotImportedDialog.vala"
			_tmp44_ = _file_it;
#line 84 "../src/Dialogs/NotImportedDialog.vala"
			_tmp45_ = gee_iterator_get (_tmp44_);
#line 84 "../src/Dialogs/NotImportedDialog.vala"
			file = (gchar*) _tmp45_;
#line 86 "../src/Dialogs/NotImportedDialog.vala"
			_tmp46_ = self->priv->files_model;
#line 86 "../src/Dialogs/NotImportedDialog.vala"
			gtk_list_store_append (_tmp46_, &_tmp47_);
#line 86 "../src/Dialogs/NotImportedDialog.vala"
			item = _tmp47_;
#line 87 "../src/Dialogs/NotImportedDialog.vala"
			_tmp48_ = self->priv->files_model;
#line 87 "../src/Dialogs/NotImportedDialog.vala"
			_tmp49_ = item;
#line 87 "../src/Dialogs/NotImportedDialog.vala"
			_tmp50_ = file;
#line 87 "../src/Dialogs/NotImportedDialog.vala"
			_tmp51_ = self->priv->music_folder;
#line 87 "../src/Dialogs/NotImportedDialog.vala"
			_tmp52_ = g_strconcat ("file://", _tmp51_, NULL);
#line 87 "../src/Dialogs/NotImportedDialog.vala"
			_tmp53_ = _tmp52_;
#line 87 "../src/Dialogs/NotImportedDialog.vala"
			_tmp54_ = string_replace (_tmp50_, _tmp53_, "");
#line 87 "../src/Dialogs/NotImportedDialog.vala"
			_tmp55_ = _tmp54_;
#line 87 "../src/Dialogs/NotImportedDialog.vala"
			_tmp56_ = g_uri_unescape_string (_tmp55_, NULL);
#line 87 "../src/Dialogs/NotImportedDialog.vala"
			_tmp57_ = _tmp56_;
#line 87 "../src/Dialogs/NotImportedDialog.vala"
			gtk_list_store_set (_tmp48_, &_tmp49_, 0, FALSE, 1, _tmp57_, -1);
#line 87 "../src/Dialogs/NotImportedDialog.vala"
			_g_free0 (_tmp57_);
#line 87 "../src/Dialogs/NotImportedDialog.vala"
			_g_free0 (_tmp55_);
#line 87 "../src/Dialogs/NotImportedDialog.vala"
			_g_free0 (_tmp53_);
#line 84 "../src/Dialogs/NotImportedDialog.vala"
			_g_free0 (file);
#line 870 "NotImportedDialog.c"
		}
#line 84 "../src/Dialogs/NotImportedDialog.vala"
		_g_object_unref0 (_file_it);
#line 874 "NotImportedDialog.c"
	}
#line 90 "../src/Dialogs/NotImportedDialog.vala"
	_tmp58_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 90 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp58_);
#line 90 "../src/Dialogs/NotImportedDialog.vala"
	files_scrolled = _tmp58_;
#line 91 "../src/Dialogs/NotImportedDialog.vala"
	_tmp59_ = _data14_->files_view;
#line 91 "../src/Dialogs/NotImportedDialog.vala"
	gtk_container_add ((GtkContainer*) files_scrolled, (GtkWidget*) _tmp59_);
#line 92 "../src/Dialogs/NotImportedDialog.vala"
	gtk_scrolled_window_set_policy (files_scrolled, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 93 "../src/Dialogs/NotImportedDialog.vala"
	g_object_set ((GtkWidget*) files_scrolled, "expand", TRUE, NULL);
#line 94 "../src/Dialogs/NotImportedDialog.vala"
	g_object_set ((GtkWidget*) files_scrolled, "margin", 6, NULL);
#line 96 "../src/Dialogs/NotImportedDialog.vala"
	_tmp60_ = (GtkExpander*) gtk_expander_new (_ ("Select individual files to move to trash:"));
#line 96 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp60_);
#line 96 "../src/Dialogs/NotImportedDialog.vala"
	_data14_->expander = _tmp60_;
#line 97 "../src/Dialogs/NotImportedDialog.vala"
	gtk_container_add ((GtkContainer*) _data14_->expander, (GtkWidget*) files_scrolled);
#line 98 "../src/Dialogs/NotImportedDialog.vala"
	gtk_expander_set_expanded (_data14_->expander, FALSE);
#line 100 "../src/Dialogs/NotImportedDialog.vala"
	_tmp61_ = (GtkButton*) gtk_button_new_with_label (_ ("Move to Trash"));
#line 100 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp61_);
#line 100 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (self->priv->move_to_trash);
#line 100 "../src/Dialogs/NotImportedDialog.vala"
	self->priv->move_to_trash = _tmp61_;
#line 101 "../src/Dialogs/NotImportedDialog.vala"
	_tmp62_ = self->priv->move_to_trash;
#line 101 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp62_, FALSE);
#line 103 "../src/Dialogs/NotImportedDialog.vala"
	_tmp63_ = (GtkButton*) gtk_button_new_with_label (_ ("Ignore"));
#line 103 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp63_);
#line 103 "../src/Dialogs/NotImportedDialog.vala"
	ignore_button = _tmp63_;
#line 105 "../src/Dialogs/NotImportedDialog.vala"
	_tmp64_ = (GtkButtonBox*) gtk_button_box_new (GTK_ORIENTATION_HORIZONTAL);
#line 105 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp64_);
#line 105 "../src/Dialogs/NotImportedDialog.vala"
	button_box = _tmp64_;
#line 106 "../src/Dialogs/NotImportedDialog.vala"
	gtk_button_box_set_layout (button_box, GTK_BUTTONBOX_END);
#line 107 "../src/Dialogs/NotImportedDialog.vala"
	_tmp65_ = self->priv->move_to_trash;
#line 107 "../src/Dialogs/NotImportedDialog.vala"
	gtk_box_pack_end ((GtkBox*) button_box, (GtkWidget*) _tmp65_, FALSE, FALSE, (guint) 0);
#line 108 "../src/Dialogs/NotImportedDialog.vala"
	gtk_box_pack_end ((GtkBox*) button_box, (GtkWidget*) ignore_button, FALSE, FALSE, (guint) 0);
#line 109 "../src/Dialogs/NotImportedDialog.vala"
	gtk_box_set_spacing ((GtkBox*) button_box, 12);
#line 111 "../src/Dialogs/NotImportedDialog.vala"
	_tmp66_ = (GtkGrid*) gtk_grid_new ();
#line 111 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp66_);
#line 111 "../src/Dialogs/NotImportedDialog.vala"
	grid = _tmp66_;
#line 112 "../src/Dialogs/NotImportedDialog.vala"
	gtk_grid_set_column_spacing (grid, 12);
#line 113 "../src/Dialogs/NotImportedDialog.vala"
	gtk_grid_set_row_spacing (grid, 6);
#line 114 "../src/Dialogs/NotImportedDialog.vala"
	g_object_set ((GtkWidget*) grid, "margin", 12, NULL);
#line 115 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) grid, 0);
#line 116 "../src/Dialogs/NotImportedDialog.vala"
	g_object_set ((GtkWidget*) grid, "expand", TRUE, NULL);
#line 117 "../src/Dialogs/NotImportedDialog.vala"
	_tmp67_ = warning;
#line 117 "../src/Dialogs/NotImportedDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp67_, 0, 0, 1, 2);
#line 118 "../src/Dialogs/NotImportedDialog.vala"
	_tmp68_ = title;
#line 118 "../src/Dialogs/NotImportedDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp68_, 1, 0, 1, 1);
#line 119 "../src/Dialogs/NotImportedDialog.vala"
	_tmp69_ = info;
#line 119 "../src/Dialogs/NotImportedDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp69_, 1, 1, 1, 1);
#line 120 "../src/Dialogs/NotImportedDialog.vala"
	_tmp70_ = _data14_->trash_all;
#line 120 "../src/Dialogs/NotImportedDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp70_, 0, 2, 2, 1);
#line 121 "../src/Dialogs/NotImportedDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _data14_->expander, 0, 3, 2, 1);
#line 122 "../src/Dialogs/NotImportedDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) button_box, 0, 4, 2, 1);
#line 123 "../src/Dialogs/NotImportedDialog.vala"
	_tmp71_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 123 "../src/Dialogs/NotImportedDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp71_, (GtkWidget*) grid);
#line 125 "../src/Dialogs/NotImportedDialog.vala"
	_tmp72_ = self->priv->move_to_trash;
#line 125 "../src/Dialogs/NotImportedDialog.vala"
	g_signal_connect_object (_tmp72_, "clicked", (GCallback) _music_not_imported_dialog_move_to_trash_click_gtk_button_clicked, self, 0);
#line 127 "../src/Dialogs/NotImportedDialog.vala"
	_tmp73_ = toggle;
#line 127 "../src/Dialogs/NotImportedDialog.vala"
	g_signal_connect_object (_tmp73_, "toggled", (GCallback) ___lambda13__gtk_cell_renderer_toggle_toggled, self, 0);
#line 137 "../src/Dialogs/NotImportedDialog.vala"
	_tmp74_ = _data14_->trash_all;
#line 137 "../src/Dialogs/NotImportedDialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp74_, "toggled", (GCallback) ___lambda14__gtk_toggle_button_toggled, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
#line 149 "../src/Dialogs/NotImportedDialog.vala"
	g_signal_connect_object (ignore_button, "clicked", (GCallback) ___lambda15__gtk_button_clicked, self, 0);
#line 153 "../src/Dialogs/NotImportedDialog.vala"
	g_signal_connect_data (_data14_->expander, "activate", (GCallback) ___lambda16__gtk_expander_activate, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
#line 161 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (grid);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (button_box);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (ignore_button);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (files_scrolled);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (column);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (toggle);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (info);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	_g_free0 (secondary_text);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (title);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (warning);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	block14_data_unref (_data14_);
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	_data14_ = NULL;
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	return self;
#line 1020 "NotImportedDialog.c"
}

MusicNotImportedDialog*
music_not_imported_dialog_new (GeeCollection* files,
                               const gchar* music)
{
#line 38 "../src/Dialogs/NotImportedDialog.vala"
	return music_not_imported_dialog_construct (MUSIC_TYPE_NOT_IMPORTED_DIALOG, files, music);
#line 1029 "NotImportedDialog.c"
}

static gboolean
music_not_imported_dialog_update_move_to_trash_sensitivity (MusicNotImportedDialog* self,
                                                            GtkTreeModel* model,
                                                            GtkTreePath* path,
                                                            GtkTreeIter* iter)
{
	gboolean sel = FALSE;
	GtkTreeIter _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 164 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 164 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 164 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 164 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 165 "../src/Dialogs/NotImportedDialog.vala"
	sel = FALSE;
#line 166 "../src/Dialogs/NotImportedDialog.vala"
	_tmp0_ = *iter;
#line 166 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_model_get (model, &_tmp0_, 0, &_tmp1_, -1);
#line 166 "../src/Dialogs/NotImportedDialog.vala"
	sel = _tmp1_;
#line 168 "../src/Dialogs/NotImportedDialog.vala"
	if (sel) {
#line 1060 "NotImportedDialog.c"
		GtkButton* _tmp2_;
#line 169 "../src/Dialogs/NotImportedDialog.vala"
		_tmp2_ = self->priv->move_to_trash;
#line 169 "../src/Dialogs/NotImportedDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, TRUE);
#line 170 "../src/Dialogs/NotImportedDialog.vala"
		result = TRUE;
#line 170 "../src/Dialogs/NotImportedDialog.vala"
		return result;
#line 1070 "NotImportedDialog.c"
	}
#line 173 "../src/Dialogs/NotImportedDialog.vala"
	result = FALSE;
#line 173 "../src/Dialogs/NotImportedDialog.vala"
	return result;
#line 1076 "NotImportedDialog.c"
}

static gboolean
music_not_imported_dialog_select_all (MusicNotImportedDialog* self,
                                      GtkTreeModel* model,
                                      GtkTreePath* path,
                                      GtkTreeIter* iter)
{
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
	gboolean result;
#line 176 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 176 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 176 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 176 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 177 "../src/Dialogs/NotImportedDialog.vala"
	_tmp0_ = self->priv->files_model;
#line 177 "../src/Dialogs/NotImportedDialog.vala"
	_tmp1_ = *iter;
#line 177 "../src/Dialogs/NotImportedDialog.vala"
	gtk_list_store_set (_tmp0_, &_tmp1_, 0, TRUE, -1);
#line 178 "../src/Dialogs/NotImportedDialog.vala"
	result = FALSE;
#line 178 "../src/Dialogs/NotImportedDialog.vala"
	return result;
#line 1106 "NotImportedDialog.c"
}

static gboolean
music_not_imported_dialog_unselect_all (MusicNotImportedDialog* self,
                                        GtkTreeModel* model,
                                        GtkTreePath* path,
                                        GtkTreeIter* iter)
{
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
	gboolean result;
#line 181 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 181 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 181 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 181 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 182 "../src/Dialogs/NotImportedDialog.vala"
	_tmp0_ = self->priv->files_model;
#line 182 "../src/Dialogs/NotImportedDialog.vala"
	_tmp1_ = *iter;
#line 182 "../src/Dialogs/NotImportedDialog.vala"
	gtk_list_store_set (_tmp0_, &_tmp1_, 0, FALSE, -1);
#line 183 "../src/Dialogs/NotImportedDialog.vala"
	result = FALSE;
#line 183 "../src/Dialogs/NotImportedDialog.vala"
	return result;
#line 1136 "NotImportedDialog.c"
}

static gboolean
music_not_imported_dialog_delete_selected_items (MusicNotImportedDialog* self,
                                                 GtkTreeModel* model,
                                                 GtkTreePath* path,
                                                 GtkTreeIter* iter)
{
	gboolean selected = FALSE;
	gchar* location = NULL;
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkListStore* _tmp3_;
	GtkTreeIter _tmp4_;
	gchar* _tmp5_ = NULL;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 186 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 186 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 186 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 186 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 189 "../src/Dialogs/NotImportedDialog.vala"
	_tmp0_ = self->priv->files_model;
#line 189 "../src/Dialogs/NotImportedDialog.vala"
	_tmp1_ = *iter;
#line 189 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp0_, &_tmp1_, 0, &_tmp2_, -1);
#line 189 "../src/Dialogs/NotImportedDialog.vala"
	selected = _tmp2_;
#line 190 "../src/Dialogs/NotImportedDialog.vala"
	_tmp3_ = self->priv->files_model;
#line 190 "../src/Dialogs/NotImportedDialog.vala"
	_tmp4_ = *iter;
#line 190 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 1, &_tmp5_, -1);
#line 190 "../src/Dialogs/NotImportedDialog.vala"
	_g_free0 (location);
#line 190 "../src/Dialogs/NotImportedDialog.vala"
	location = _tmp5_;
#line 192 "../src/Dialogs/NotImportedDialog.vala"
	if (selected) {
#line 1183 "NotImportedDialog.c"
		{
			GFile* file = NULL;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
			GFile* _tmp12_;
#line 194 "../src/Dialogs/NotImportedDialog.vala"
			_tmp6_ = self->priv->music_folder;
#line 194 "../src/Dialogs/NotImportedDialog.vala"
			_tmp7_ = location;
#line 194 "../src/Dialogs/NotImportedDialog.vala"
			_tmp8_ = g_strconcat (_tmp6_, _tmp7_, NULL);
#line 194 "../src/Dialogs/NotImportedDialog.vala"
			_tmp9_ = _tmp8_;
#line 194 "../src/Dialogs/NotImportedDialog.vala"
			_tmp10_ = g_file_new_for_path (_tmp9_);
#line 194 "../src/Dialogs/NotImportedDialog.vala"
			_tmp11_ = _tmp10_;
#line 194 "../src/Dialogs/NotImportedDialog.vala"
			_g_free0 (_tmp9_);
#line 194 "../src/Dialogs/NotImportedDialog.vala"
			file = _tmp11_;
#line 195 "../src/Dialogs/NotImportedDialog.vala"
			_tmp12_ = file;
#line 195 "../src/Dialogs/NotImportedDialog.vala"
			g_file_trash (_tmp12_, NULL, &_inner_error0_);
#line 195 "../src/Dialogs/NotImportedDialog.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 195 "../src/Dialogs/NotImportedDialog.vala"
				_g_object_unref0 (file);
#line 1217 "NotImportedDialog.c"
				goto __catch0_g_error;
			}
#line 193 "../src/Dialogs/NotImportedDialog.vala"
			_g_object_unref0 (file);
#line 1222 "NotImportedDialog.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			const gchar* _tmp13_;
			GError* _tmp14_;
			const gchar* _tmp15_;
#line 193 "../src/Dialogs/NotImportedDialog.vala"
			err = _inner_error0_;
#line 193 "../src/Dialogs/NotImportedDialog.vala"
			_inner_error0_ = NULL;
#line 197 "../src/Dialogs/NotImportedDialog.vala"
			_tmp13_ = location;
#line 197 "../src/Dialogs/NotImportedDialog.vala"
			_tmp14_ = err;
#line 197 "../src/Dialogs/NotImportedDialog.vala"
			_tmp15_ = _tmp14_->message;
#line 197 "../src/Dialogs/NotImportedDialog.vala"
			g_warning ("NotImportedDialog.vala:197: Could not move file %s to recycle: %s\n", _tmp13_, _tmp15_);
#line 193 "../src/Dialogs/NotImportedDialog.vala"
			_g_error_free0 (err);
#line 1245 "NotImportedDialog.c"
		}
		__finally0:
#line 193 "../src/Dialogs/NotImportedDialog.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1250 "NotImportedDialog.c"
			gboolean _tmp16_ = FALSE;
#line 193 "../src/Dialogs/NotImportedDialog.vala"
			_g_free0 (location);
#line 193 "../src/Dialogs/NotImportedDialog.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 193 "../src/Dialogs/NotImportedDialog.vala"
			g_clear_error (&_inner_error0_);
#line 193 "../src/Dialogs/NotImportedDialog.vala"
			return _tmp16_;
#line 1260 "NotImportedDialog.c"
		}
	}
#line 201 "../src/Dialogs/NotImportedDialog.vala"
	result = FALSE;
#line 201 "../src/Dialogs/NotImportedDialog.vala"
	_g_free0 (location);
#line 201 "../src/Dialogs/NotImportedDialog.vala"
	return result;
#line 1269 "NotImportedDialog.c"
}

static gboolean
_music_not_imported_dialog_delete_selected_items_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                              GtkTreePath* path,
                                                                              GtkTreeIter* iter,
                                                                              gpointer self)
{
	gboolean result;
	result = music_not_imported_dialog_delete_selected_items ((MusicNotImportedDialog*) self, model, path, iter);
#line 205 "../src/Dialogs/NotImportedDialog.vala"
	return result;
#line 1282 "NotImportedDialog.c"
}

static void
music_not_imported_dialog_move_to_trash_click (MusicNotImportedDialog* self)
{
	GtkListStore* _tmp0_;
#line 204 "../src/Dialogs/NotImportedDialog.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/Dialogs/NotImportedDialog.vala"
	_tmp0_ = self->priv->files_model;
#line 205 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_model_foreach ((GtkTreeModel*) _tmp0_, _music_not_imported_dialog_delete_selected_items_gtk_tree_model_foreach_func, self);
#line 206 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 1297 "NotImportedDialog.c"
}

static void
music_not_imported_dialog_class_init (MusicNotImportedDialogClass * klass,
                                      gpointer klass_data)
{
#line 31 "../src/Dialogs/NotImportedDialog.vala"
	music_not_imported_dialog_parent_class = g_type_class_peek_parent (klass);
#line 31 "../src/Dialogs/NotImportedDialog.vala"
	g_type_class_adjust_private_offset (klass, &MusicNotImportedDialog_private_offset);
#line 31 "../src/Dialogs/NotImportedDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = music_not_imported_dialog_finalize;
#line 1310 "NotImportedDialog.c"
}

static void
music_not_imported_dialog_instance_init (MusicNotImportedDialog * self,
                                         gpointer klass)
{
#line 31 "../src/Dialogs/NotImportedDialog.vala"
	self->priv = music_not_imported_dialog_get_instance_private (self);
#line 1319 "NotImportedDialog.c"
}

static void
music_not_imported_dialog_finalize (GObject * obj)
{
	MusicNotImportedDialog * self;
#line 31 "../src/Dialogs/NotImportedDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_NOT_IMPORTED_DIALOG, MusicNotImportedDialog);
#line 32 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (self->priv->_files);
#line 33 "../src/Dialogs/NotImportedDialog.vala"
	_g_free0 (self->priv->music_folder);
#line 35 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (self->priv->files_model);
#line 36 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (self->priv->move_to_trash);
#line 31 "../src/Dialogs/NotImportedDialog.vala"
	G_OBJECT_CLASS (music_not_imported_dialog_parent_class)->finalize (obj);
#line 1338 "NotImportedDialog.c"
}

static GType
music_not_imported_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicNotImportedDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_not_imported_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicNotImportedDialog), 0, (GInstanceInitFunc) music_not_imported_dialog_instance_init, NULL };
	GType music_not_imported_dialog_type_id;
	music_not_imported_dialog_type_id = g_type_register_static (GRANITE_TYPE_DIALOG, "MusicNotImportedDialog", &g_define_type_info, 0);
	MusicNotImportedDialog_private_offset = g_type_add_instance_private (music_not_imported_dialog_type_id, sizeof (MusicNotImportedDialogPrivate));
	return music_not_imported_dialog_type_id;
}

GType
music_not_imported_dialog_get_type (void)
{
	static volatile gsize music_not_imported_dialog_type_id__once = 0;
	if (g_once_init_enter (&music_not_imported_dialog_type_id__once)) {
		GType music_not_imported_dialog_type_id;
		music_not_imported_dialog_type_id = music_not_imported_dialog_get_type_once ();
		g_once_init_leave (&music_not_imported_dialog_type_id__once, music_not_imported_dialog_type_id);
	}
	return music_not_imported_dialog_type_id__once;
}

