/* PreferencesWindow.c generated by valac 0.56.0, the Vala compiler
 * generated from PreferencesWindow.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 */

#include "music-lib.h"
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include "io.elementary.music-core.h"
#include <granite.h>
#include <gio/gio.h>

enum  {
	MUSIC_PREFERENCES_WINDOW_0_PROPERTY,
	MUSIC_PREFERENCES_WINDOW_NUM_PROPERTIES
};
static GParamSpec* music_preferences_window_properties[MUSIC_PREFERENCES_WINDOW_NUM_PROPERTIES];

#define MUSIC_PREFERENCES_WINDOW_TYPE_SETTINGS_LABEL (music_preferences_window_settings_label_get_type ())
#define MUSIC_PREFERENCES_WINDOW_SETTINGS_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_PREFERENCES_WINDOW_TYPE_SETTINGS_LABEL, MusicPreferencesWindowSettingsLabel))
#define MUSIC_PREFERENCES_WINDOW_SETTINGS_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_PREFERENCES_WINDOW_TYPE_SETTINGS_LABEL, MusicPreferencesWindowSettingsLabelClass))
#define MUSIC_PREFERENCES_WINDOW_IS_SETTINGS_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_PREFERENCES_WINDOW_TYPE_SETTINGS_LABEL))
#define MUSIC_PREFERENCES_WINDOW_IS_SETTINGS_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_PREFERENCES_WINDOW_TYPE_SETTINGS_LABEL))
#define MUSIC_PREFERENCES_WINDOW_SETTINGS_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_PREFERENCES_WINDOW_TYPE_SETTINGS_LABEL, MusicPreferencesWindowSettingsLabelClass))

typedef struct _MusicPreferencesWindowSettingsLabel MusicPreferencesWindowSettingsLabel;
typedef struct _MusicPreferencesWindowSettingsLabelClass MusicPreferencesWindowSettingsLabelClass;
typedef struct _MusicPreferencesWindowSettingsLabelPrivate MusicPreferencesWindowSettingsLabelPrivate;
enum  {
	MUSIC_PREFERENCES_WINDOW_SETTINGS_LABEL_0_PROPERTY,
	MUSIC_PREFERENCES_WINDOW_SETTINGS_LABEL_NUM_PROPERTIES
};
static GParamSpec* music_preferences_window_settings_label_properties[MUSIC_PREFERENCES_WINDOW_SETTINGS_LABEL_NUM_PROPERTIES];
typedef struct _Block15Data Block15Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MusicPreferencesWindowSettingsLabel {
	GtkLabel parent_instance;
	MusicPreferencesWindowSettingsLabelPrivate * priv;
};

struct _MusicPreferencesWindowSettingsLabelClass {
	GtkLabelClass parent_class;
};

struct _Block15Data {
	int _ref_count_;
	MusicPreferencesWindow* self;
	GtkFileChooserButton* library_filechooser;
};

static gpointer music_preferences_window_parent_class = NULL;
static gpointer music_preferences_window_settings_label_parent_class = NULL;

static GType music_preferences_window_settings_label_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static MusicPreferencesWindowSettingsLabel* music_preferences_window_settings_label_new (const gchar* text);
static MusicPreferencesWindowSettingsLabel* music_preferences_window_settings_label_construct (GType object_type,
                                                                                        const gchar* text);
static GType music_preferences_window_settings_label_get_type_once (void);
static GObject * music_preferences_window_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static Block15Data* block15_data_ref (Block15Data* _data15_);
static void block15_data_unref (void * _userdata_);
static void _music_preferences_window___lambda120_ (Block15Data* _data15_);
static void __music_preferences_window___lambda120__gtk_file_chooser_button_file_set (GtkFileChooserButton* _sender,
                                                                               gpointer self);
static void _music_preferences_window___lambda123_ (MusicPreferencesWindow* self);
static void __music_preferences_window___lambda123__gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self);
static GType music_preferences_window_get_type_once (void);

MusicPreferencesWindow*
music_preferences_window_construct (GType object_type)
{
	MusicPreferencesWindow * self = NULL;
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
#line 29 "../src/Dialogs/PreferencesWindow.vala"
	_tmp0_ = music_app_get_main_window ();
#line 29 "../src/Dialogs/PreferencesWindow.vala"
	_tmp1_ = _tmp0_;
#line 29 "../src/Dialogs/PreferencesWindow.vala"
	self = (MusicPreferencesWindow*) g_object_new (object_type, "destroy-with-parent", TRUE, "resizable", FALSE, "title", _ ("Preferences"), "transient-for", _tmp1_, NULL);
#line 28 "../src/Dialogs/PreferencesWindow.vala"
	return self;
#line 117 "PreferencesWindow.c"
}

MusicPreferencesWindow*
music_preferences_window_new (void)
{
#line 28 "../src/Dialogs/PreferencesWindow.vala"
	return music_preferences_window_construct (MUSIC_TYPE_PREFERENCES_WINDOW);
#line 125 "PreferencesWindow.c"
}

static MusicPreferencesWindowSettingsLabel*
music_preferences_window_settings_label_construct (GType object_type,
                                                   const gchar* text)
{
	MusicPreferencesWindowSettingsLabel * self = NULL;
#line 93 "../src/Dialogs/PreferencesWindow.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 93 "../src/Dialogs/PreferencesWindow.vala"
	self = (MusicPreferencesWindowSettingsLabel*) g_object_new (object_type, NULL);
#line 94 "../src/Dialogs/PreferencesWindow.vala"
	gtk_label_set_label ((GtkLabel*) self, text);
#line 95 "../src/Dialogs/PreferencesWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_END);
#line 96 "../src/Dialogs/PreferencesWindow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
#line 97 "../src/Dialogs/PreferencesWindow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) self, 12);
#line 93 "../src/Dialogs/PreferencesWindow.vala"
	return self;
#line 147 "PreferencesWindow.c"
}

static MusicPreferencesWindowSettingsLabel*
music_preferences_window_settings_label_new (const gchar* text)
{
#line 93 "../src/Dialogs/PreferencesWindow.vala"
	return music_preferences_window_settings_label_construct (MUSIC_PREFERENCES_WINDOW_TYPE_SETTINGS_LABEL, text);
#line 155 "PreferencesWindow.c"
}

static void
music_preferences_window_settings_label_class_init (MusicPreferencesWindowSettingsLabelClass * klass,
                                                    gpointer klass_data)
{
#line 92 "../src/Dialogs/PreferencesWindow.vala"
	music_preferences_window_settings_label_parent_class = g_type_class_peek_parent (klass);
#line 164 "PreferencesWindow.c"
}

static void
music_preferences_window_settings_label_instance_init (MusicPreferencesWindowSettingsLabel * self,
                                                       gpointer klass)
{
}

static GType
music_preferences_window_settings_label_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPreferencesWindowSettingsLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_preferences_window_settings_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPreferencesWindowSettingsLabel), 0, (GInstanceInitFunc) music_preferences_window_settings_label_instance_init, NULL };
	GType music_preferences_window_settings_label_type_id;
	music_preferences_window_settings_label_type_id = g_type_register_static (gtk_label_get_type (), "MusicPreferencesWindowSettingsLabel", &g_define_type_info, 0);
	return music_preferences_window_settings_label_type_id;
}

static GType
music_preferences_window_settings_label_get_type (void)
{
	static volatile gsize music_preferences_window_settings_label_type_id__once = 0;
	if (g_once_init_enter (&music_preferences_window_settings_label_type_id__once)) {
		GType music_preferences_window_settings_label_type_id;
		music_preferences_window_settings_label_type_id = music_preferences_window_settings_label_get_type_once ();
		g_once_init_leave (&music_preferences_window_settings_label_type_id__once, music_preferences_window_settings_label_type_id);
	}
	return music_preferences_window_settings_label_type_id__once;
}

static Block15Data*
block15_data_ref (Block15Data* _data15_)
{
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	g_atomic_int_inc (&_data15_->_ref_count_);
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	return _data15_;
#line 201 "PreferencesWindow.c"
}

static void
block15_data_unref (void * _userdata_)
{
	Block15Data* _data15_;
	_data15_ = (Block15Data*) _userdata_;
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	if (g_atomic_int_dec_and_test (&_data15_->_ref_count_)) {
#line 211 "PreferencesWindow.c"
		MusicPreferencesWindow* self;
#line 37 "../src/Dialogs/PreferencesWindow.vala"
		self = _data15_->self;
#line 37 "../src/Dialogs/PreferencesWindow.vala"
		_g_object_unref0 (_data15_->library_filechooser);
#line 37 "../src/Dialogs/PreferencesWindow.vala"
		_g_object_unref0 (self);
#line 37 "../src/Dialogs/PreferencesWindow.vala"
		g_slice_free (Block15Data, _data15_);
#line 221 "PreferencesWindow.c"
	}
}

static void
_music_preferences_window___lambda120_ (Block15Data* _data15_)
{
	MusicPreferencesWindow* self;
	gchar* filename = NULL;
	GtkFileChooserButton* _tmp0_;
	gchar* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	MusicLibraryWindow* _tmp3_;
	const gchar* _tmp4_;
#line 41 "../src/Dialogs/PreferencesWindow.vala"
	self = _data15_->self;
#line 42 "../src/Dialogs/PreferencesWindow.vala"
	_tmp0_ = _data15_->library_filechooser;
#line 42 "../src/Dialogs/PreferencesWindow.vala"
	_tmp1_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp0_);
#line 42 "../src/Dialogs/PreferencesWindow.vala"
	filename = _tmp1_;
#line 43 "../src/Dialogs/PreferencesWindow.vala"
	_tmp2_ = music_app_get_main_window ();
#line 43 "../src/Dialogs/PreferencesWindow.vala"
	_tmp3_ = _tmp2_;
#line 43 "../src/Dialogs/PreferencesWindow.vala"
	_tmp4_ = filename;
#line 43 "../src/Dialogs/PreferencesWindow.vala"
	music_library_window_set_music_folder (_tmp3_, _tmp4_);
#line 41 "../src/Dialogs/PreferencesWindow.vala"
	_g_free0 (filename);
#line 253 "PreferencesWindow.c"
}

static void
__music_preferences_window___lambda120__gtk_file_chooser_button_file_set (GtkFileChooserButton* _sender,
                                                                          gpointer self)
{
#line 41 "../src/Dialogs/PreferencesWindow.vala"
	_music_preferences_window___lambda120_ (self);
#line 262 "PreferencesWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 88 "../src/Dialogs/PreferencesWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 270 "PreferencesWindow.c"
}

static void
_music_preferences_window___lambda123_ (MusicPreferencesWindow* self)
{
#line 89 "../src/Dialogs/PreferencesWindow.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 278 "PreferencesWindow.c"
}

static void
__music_preferences_window___lambda123__gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self)
{
#line 89 "../src/Dialogs/PreferencesWindow.vala"
	_music_preferences_window___lambda123_ ((MusicPreferencesWindow*) self);
#line 287 "PreferencesWindow.c"
}

static GObject *
music_preferences_window_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicPreferencesWindow * self;
	Block15Data* _data15_;
	GtkFileChooserButton* _tmp0_;
	GtkFileChooserButton* _tmp1_;
	GtkFileChooserButton* _tmp2_;
	MusicSettingsMain* _tmp3_;
	MusicSettingsMain* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GtkFileChooserButton* _tmp7_;
	MusicSettingsMain* main_settings = NULL;
	MusicSettingsMain* _tmp8_;
	GtkSwitch* organize_folders_switch = NULL;
	GtkSwitch* _tmp9_;
	GtkSwitch* _tmp10_;
	MusicSettingsMain* _tmp11_;
	GSettings* _tmp12_;
	GSettings* _tmp13_;
	GtkSwitch* _tmp14_;
	GtkSwitch* write_file_metadata_switch = NULL;
	GtkSwitch* _tmp15_;
	GtkSwitch* _tmp16_;
	MusicSettingsMain* _tmp17_;
	GSettings* _tmp18_;
	GSettings* _tmp19_;
	GtkSwitch* _tmp20_;
	GtkSwitch* copy_imported_music_switch = NULL;
	GtkSwitch* _tmp21_;
	GtkSwitch* _tmp22_;
	MusicSettingsMain* _tmp23_;
	GSettings* _tmp24_;
	GSettings* _tmp25_;
	GtkSwitch* _tmp26_;
	GtkSwitch* hide_on_close_switch = NULL;
	GtkSwitch* _tmp27_;
	GtkSwitch* _tmp28_;
	MusicSettingsMain* _tmp29_;
	GSettings* _tmp30_;
	GSettings* _tmp31_;
	GtkSwitch* _tmp32_;
	GtkGrid* layout = NULL;
	GtkGrid* _tmp33_ = NULL;
	GtkGrid* _tmp34_;
	GraniteHeaderLabel* _tmp35_;
	GraniteHeaderLabel* _tmp36_;
	GtkGrid* _tmp37_;
	GtkFileChooserButton* _tmp38_;
	GtkGrid* _tmp39_;
	GraniteHeaderLabel* _tmp40_;
	GraniteHeaderLabel* _tmp41_;
	GtkGrid* _tmp42_;
	MusicPreferencesWindowSettingsLabel* _tmp43_;
	MusicPreferencesWindowSettingsLabel* _tmp44_;
	GtkGrid* _tmp45_;
	GtkSwitch* _tmp46_;
	GtkGrid* _tmp47_;
	MusicPreferencesWindowSettingsLabel* _tmp48_;
	MusicPreferencesWindowSettingsLabel* _tmp49_;
	GtkGrid* _tmp50_;
	GtkSwitch* _tmp51_;
	GtkGrid* _tmp52_;
	MusicPreferencesWindowSettingsLabel* _tmp53_;
	MusicPreferencesWindowSettingsLabel* _tmp54_;
	GtkGrid* _tmp55_;
	GtkSwitch* _tmp56_;
	GtkGrid* _tmp57_;
	GraniteHeaderLabel* _tmp58_;
	GraniteHeaderLabel* _tmp59_;
	GtkGrid* _tmp60_;
	MusicPreferencesWindowSettingsLabel* _tmp61_;
	MusicPreferencesWindowSettingsLabel* _tmp62_;
	GtkGrid* _tmp63_;
	GtkSwitch* _tmp64_;
	GtkBox* _tmp65_;
	GtkGrid* _tmp66_;
	MusicPluginsManager* _tmp67_;
	MusicPluginsManager* _tmp68_;
	GtkWidget* close_button = NULL;
	GtkWidget* _tmp69_;
	GtkWidget* _tmp70_;
	GtkWidget* _tmp71_;
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	parent_class = G_OBJECT_CLASS (music_preferences_window_parent_class);
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PREFERENCES_WINDOW, MusicPreferencesWindow);
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	_data15_ = g_slice_new0 (Block15Data);
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	_data15_->_ref_count_ = 1;
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	_data15_->self = g_object_ref (self);
#line 38 "../src/Dialogs/PreferencesWindow.vala"
	_tmp0_ = (GtkFileChooserButton*) gtk_file_chooser_button_new (_ ("Select Music Folder…"), GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER);
#line 38 "../src/Dialogs/PreferencesWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 38 "../src/Dialogs/PreferencesWindow.vala"
	_data15_->library_filechooser = _tmp0_;
#line 39 "../src/Dialogs/PreferencesWindow.vala"
	_tmp1_ = _data15_->library_filechooser;
#line 39 "../src/Dialogs/PreferencesWindow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
#line 40 "../src/Dialogs/PreferencesWindow.vala"
	_tmp2_ = _data15_->library_filechooser;
#line 40 "../src/Dialogs/PreferencesWindow.vala"
	_tmp3_ = music_settings_main_get_default ();
#line 40 "../src/Dialogs/PreferencesWindow.vala"
	_tmp4_ = _tmp3_;
#line 40 "../src/Dialogs/PreferencesWindow.vala"
	_tmp5_ = music_settings_main_get_music_folder (_tmp4_);
#line 40 "../src/Dialogs/PreferencesWindow.vala"
	_tmp6_ = _tmp5_;
#line 40 "../src/Dialogs/PreferencesWindow.vala"
	gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp2_, _tmp6_);
#line 40 "../src/Dialogs/PreferencesWindow.vala"
	_g_object_unref0 (_tmp4_);
#line 41 "../src/Dialogs/PreferencesWindow.vala"
	_tmp7_ = _data15_->library_filechooser;
#line 41 "../src/Dialogs/PreferencesWindow.vala"
	g_signal_connect_data (_tmp7_, "file-set", (GCallback) __music_preferences_window___lambda120__gtk_file_chooser_button_file_set, block15_data_ref (_data15_), (GClosureNotify) block15_data_unref, 0);
#line 46 "../src/Dialogs/PreferencesWindow.vala"
	_tmp8_ = music_settings_main_get_default ();
#line 46 "../src/Dialogs/PreferencesWindow.vala"
	main_settings = _tmp8_;
#line 48 "../src/Dialogs/PreferencesWindow.vala"
	_tmp9_ = (GtkSwitch*) gtk_switch_new ();
#line 48 "../src/Dialogs/PreferencesWindow.vala"
	g_object_ref_sink (_tmp9_);
#line 48 "../src/Dialogs/PreferencesWindow.vala"
	organize_folders_switch = _tmp9_;
#line 49 "../src/Dialogs/PreferencesWindow.vala"
	_tmp10_ = organize_folders_switch;
#line 49 "../src/Dialogs/PreferencesWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp10_, GTK_ALIGN_START);
#line 50 "../src/Dialogs/PreferencesWindow.vala"
	_tmp11_ = main_settings;
#line 50 "../src/Dialogs/PreferencesWindow.vala"
	_tmp12_ = granite_services_settings_get_schema ((GraniteServicesSettings*) _tmp11_);
#line 50 "../src/Dialogs/PreferencesWindow.vala"
	_tmp13_ = _tmp12_;
#line 50 "../src/Dialogs/PreferencesWindow.vala"
	_tmp14_ = organize_folders_switch;
#line 50 "../src/Dialogs/PreferencesWindow.vala"
	g_settings_bind (_tmp13_, "update-folder-hierarchy", (GObject*) _tmp14_, "active", G_SETTINGS_BIND_DEFAULT);
#line 52 "../src/Dialogs/PreferencesWindow.vala"
	_tmp15_ = (GtkSwitch*) gtk_switch_new ();
#line 52 "../src/Dialogs/PreferencesWindow.vala"
	g_object_ref_sink (_tmp15_);
#line 52 "../src/Dialogs/PreferencesWindow.vala"
	write_file_metadata_switch = _tmp15_;
#line 53 "../src/Dialogs/PreferencesWindow.vala"
	_tmp16_ = write_file_metadata_switch;
#line 53 "../src/Dialogs/PreferencesWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp16_, GTK_ALIGN_START);
#line 54 "../src/Dialogs/PreferencesWindow.vala"
	_tmp17_ = main_settings;
#line 54 "../src/Dialogs/PreferencesWindow.vala"
	_tmp18_ = granite_services_settings_get_schema ((GraniteServicesSettings*) _tmp17_);
#line 54 "../src/Dialogs/PreferencesWindow.vala"
	_tmp19_ = _tmp18_;
#line 54 "../src/Dialogs/PreferencesWindow.vala"
	_tmp20_ = write_file_metadata_switch;
#line 54 "../src/Dialogs/PreferencesWindow.vala"
	g_settings_bind (_tmp19_, "write-metadata-to-file", (GObject*) _tmp20_, "active", G_SETTINGS_BIND_DEFAULT);
#line 56 "../src/Dialogs/PreferencesWindow.vala"
	_tmp21_ = (GtkSwitch*) gtk_switch_new ();
#line 56 "../src/Dialogs/PreferencesWindow.vala"
	g_object_ref_sink (_tmp21_);
#line 56 "../src/Dialogs/PreferencesWindow.vala"
	copy_imported_music_switch = _tmp21_;
#line 57 "../src/Dialogs/PreferencesWindow.vala"
	_tmp22_ = copy_imported_music_switch;
#line 57 "../src/Dialogs/PreferencesWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp22_, GTK_ALIGN_START);
#line 58 "../src/Dialogs/PreferencesWindow.vala"
	_tmp23_ = main_settings;
#line 58 "../src/Dialogs/PreferencesWindow.vala"
	_tmp24_ = granite_services_settings_get_schema ((GraniteServicesSettings*) _tmp23_);
#line 58 "../src/Dialogs/PreferencesWindow.vala"
	_tmp25_ = _tmp24_;
#line 58 "../src/Dialogs/PreferencesWindow.vala"
	_tmp26_ = copy_imported_music_switch;
#line 58 "../src/Dialogs/PreferencesWindow.vala"
	g_settings_bind (_tmp25_, "copy-imported-music", (GObject*) _tmp26_, "active", G_SETTINGS_BIND_DEFAULT);
#line 60 "../src/Dialogs/PreferencesWindow.vala"
	_tmp27_ = (GtkSwitch*) gtk_switch_new ();
#line 60 "../src/Dialogs/PreferencesWindow.vala"
	g_object_ref_sink (_tmp27_);
#line 60 "../src/Dialogs/PreferencesWindow.vala"
	hide_on_close_switch = _tmp27_;
#line 61 "../src/Dialogs/PreferencesWindow.vala"
	_tmp28_ = hide_on_close_switch;
#line 61 "../src/Dialogs/PreferencesWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp28_, GTK_ALIGN_START);
#line 62 "../src/Dialogs/PreferencesWindow.vala"
	_tmp29_ = main_settings;
#line 62 "../src/Dialogs/PreferencesWindow.vala"
	_tmp30_ = granite_services_settings_get_schema ((GraniteServicesSettings*) _tmp29_);
#line 62 "../src/Dialogs/PreferencesWindow.vala"
	_tmp31_ = _tmp30_;
#line 62 "../src/Dialogs/PreferencesWindow.vala"
	_tmp32_ = hide_on_close_switch;
#line 62 "../src/Dialogs/PreferencesWindow.vala"
	g_settings_bind (_tmp31_, "close-while-playing", (GObject*) _tmp32_, "active", G_SETTINGS_BIND_INVERT_BOOLEAN);
#line 64 "../src/Dialogs/PreferencesWindow.vala"
	_tmp33_ = (GtkGrid*) gtk_grid_new ();
#line 64 "../src/Dialogs/PreferencesWindow.vala"
	gtk_grid_set_column_spacing (_tmp33_, 12);
#line 64 "../src/Dialogs/PreferencesWindow.vala"
	gtk_grid_set_row_spacing (_tmp33_, 6);
#line 64 "../src/Dialogs/PreferencesWindow.vala"
	g_object_set ((GtkWidget*) _tmp33_, "margin", 12, NULL);
#line 64 "../src/Dialogs/PreferencesWindow.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp33_, 0);
#line 64 "../src/Dialogs/PreferencesWindow.vala"
	g_object_ref_sink (_tmp33_);
#line 64 "../src/Dialogs/PreferencesWindow.vala"
	layout = _tmp33_;
#line 70 "../src/Dialogs/PreferencesWindow.vala"
	_tmp34_ = layout;
#line 70 "../src/Dialogs/PreferencesWindow.vala"
	_tmp35_ = granite_header_label_new (_ ("Music Folder Location"));
#line 70 "../src/Dialogs/PreferencesWindow.vala"
	g_object_ref_sink (_tmp35_);
#line 70 "../src/Dialogs/PreferencesWindow.vala"
	_tmp36_ = _tmp35_;
#line 70 "../src/Dialogs/PreferencesWindow.vala"
	gtk_grid_attach (_tmp34_, (GtkWidget*) _tmp36_, 0, 0, 1, 1);
#line 70 "../src/Dialogs/PreferencesWindow.vala"
	_g_object_unref0 (_tmp36_);
#line 71 "../src/Dialogs/PreferencesWindow.vala"
	_tmp37_ = layout;
#line 71 "../src/Dialogs/PreferencesWindow.vala"
	_tmp38_ = _data15_->library_filechooser;
#line 71 "../src/Dialogs/PreferencesWindow.vala"
	gtk_grid_attach (_tmp37_, (GtkWidget*) _tmp38_, 0, 1, 2, 1);
#line 72 "../src/Dialogs/PreferencesWindow.vala"
	_tmp39_ = layout;
#line 72 "../src/Dialogs/PreferencesWindow.vala"
	_tmp40_ = granite_header_label_new (_ ("Library Management"));
#line 72 "../src/Dialogs/PreferencesWindow.vala"
	g_object_ref_sink (_tmp40_);
#line 72 "../src/Dialogs/PreferencesWindow.vala"
	_tmp41_ = _tmp40_;
#line 72 "../src/Dialogs/PreferencesWindow.vala"
	gtk_grid_attach (_tmp39_, (GtkWidget*) _tmp41_, 0, 2, 1, 1);
#line 72 "../src/Dialogs/PreferencesWindow.vala"
	_g_object_unref0 (_tmp41_);
#line 73 "../src/Dialogs/PreferencesWindow.vala"
	_tmp42_ = layout;
#line 73 "../src/Dialogs/PreferencesWindow.vala"
	_tmp43_ = music_preferences_window_settings_label_new (_ ("Keep Music folder organized:"));
#line 73 "../src/Dialogs/PreferencesWindow.vala"
	g_object_ref_sink (_tmp43_);
#line 73 "../src/Dialogs/PreferencesWindow.vala"
	_tmp44_ = _tmp43_;
#line 73 "../src/Dialogs/PreferencesWindow.vala"
	gtk_grid_attach (_tmp42_, (GtkWidget*) _tmp44_, 0, 3, 1, 1);
#line 73 "../src/Dialogs/PreferencesWindow.vala"
	_g_object_unref0 (_tmp44_);
#line 74 "../src/Dialogs/PreferencesWindow.vala"
	_tmp45_ = layout;
#line 74 "../src/Dialogs/PreferencesWindow.vala"
	_tmp46_ = organize_folders_switch;
#line 74 "../src/Dialogs/PreferencesWindow.vala"
	gtk_grid_attach (_tmp45_, (GtkWidget*) _tmp46_, 1, 3, 1, 1);
#line 75 "../src/Dialogs/PreferencesWindow.vala"
	_tmp47_ = layout;
#line 75 "../src/Dialogs/PreferencesWindow.vala"
	_tmp48_ = music_preferences_window_settings_label_new (_ ("Write metadata to file:"));
#line 75 "../src/Dialogs/PreferencesWindow.vala"
	g_object_ref_sink (_tmp48_);
#line 75 "../src/Dialogs/PreferencesWindow.vala"
	_tmp49_ = _tmp48_;
#line 75 "../src/Dialogs/PreferencesWindow.vala"
	gtk_grid_attach (_tmp47_, (GtkWidget*) _tmp49_, 0, 4, 1, 1);
#line 75 "../src/Dialogs/PreferencesWindow.vala"
	_g_object_unref0 (_tmp49_);
#line 76 "../src/Dialogs/PreferencesWindow.vala"
	_tmp50_ = layout;
#line 76 "../src/Dialogs/PreferencesWindow.vala"
	_tmp51_ = write_file_metadata_switch;
#line 76 "../src/Dialogs/PreferencesWindow.vala"
	gtk_grid_attach (_tmp50_, (GtkWidget*) _tmp51_, 1, 4, 1, 1);
#line 77 "../src/Dialogs/PreferencesWindow.vala"
	_tmp52_ = layout;
#line 77 "../src/Dialogs/PreferencesWindow.vala"
	_tmp53_ = music_preferences_window_settings_label_new (_ ("Copy imported files to Library:"));
#line 77 "../src/Dialogs/PreferencesWindow.vala"
	g_object_ref_sink (_tmp53_);
#line 77 "../src/Dialogs/PreferencesWindow.vala"
	_tmp54_ = _tmp53_;
#line 77 "../src/Dialogs/PreferencesWindow.vala"
	gtk_grid_attach (_tmp52_, (GtkWidget*) _tmp54_, 0, 5, 1, 1);
#line 77 "../src/Dialogs/PreferencesWindow.vala"
	_g_object_unref0 (_tmp54_);
#line 78 "../src/Dialogs/PreferencesWindow.vala"
	_tmp55_ = layout;
#line 78 "../src/Dialogs/PreferencesWindow.vala"
	_tmp56_ = copy_imported_music_switch;
#line 78 "../src/Dialogs/PreferencesWindow.vala"
	gtk_grid_attach (_tmp55_, (GtkWidget*) _tmp56_, 1, 5, 1, 1);
#line 79 "../src/Dialogs/PreferencesWindow.vala"
	_tmp57_ = layout;
#line 79 "../src/Dialogs/PreferencesWindow.vala"
	_tmp58_ = granite_header_label_new (_ ("Desktop Integration"));
#line 79 "../src/Dialogs/PreferencesWindow.vala"
	g_object_ref_sink (_tmp58_);
#line 79 "../src/Dialogs/PreferencesWindow.vala"
	_tmp59_ = _tmp58_;
#line 79 "../src/Dialogs/PreferencesWindow.vala"
	gtk_grid_attach (_tmp57_, (GtkWidget*) _tmp59_, 0, 6, 1, 1);
#line 79 "../src/Dialogs/PreferencesWindow.vala"
	_g_object_unref0 (_tmp59_);
#line 80 "../src/Dialogs/PreferencesWindow.vala"
	_tmp60_ = layout;
#line 80 "../src/Dialogs/PreferencesWindow.vala"
	_tmp61_ = music_preferences_window_settings_label_new (_ ("Continue playback when closed:"));
#line 80 "../src/Dialogs/PreferencesWindow.vala"
	g_object_ref_sink (_tmp61_);
#line 80 "../src/Dialogs/PreferencesWindow.vala"
	_tmp62_ = _tmp61_;
#line 80 "../src/Dialogs/PreferencesWindow.vala"
	gtk_grid_attach (_tmp60_, (GtkWidget*) _tmp62_, 0, 7, 1, 1);
#line 80 "../src/Dialogs/PreferencesWindow.vala"
	_g_object_unref0 (_tmp62_);
#line 81 "../src/Dialogs/PreferencesWindow.vala"
	_tmp63_ = layout;
#line 81 "../src/Dialogs/PreferencesWindow.vala"
	_tmp64_ = hide_on_close_switch;
#line 81 "../src/Dialogs/PreferencesWindow.vala"
	gtk_grid_attach (_tmp63_, (GtkWidget*) _tmp64_, 1, 7, 1, 1);
#line 83 "../src/Dialogs/PreferencesWindow.vala"
	_tmp65_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 83 "../src/Dialogs/PreferencesWindow.vala"
	_tmp66_ = layout;
#line 83 "../src/Dialogs/PreferencesWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp65_, (GtkWidget*) _tmp66_);
#line 86 "../src/Dialogs/PreferencesWindow.vala"
	_tmp67_ = music_plugins_manager_get_default ();
#line 86 "../src/Dialogs/PreferencesWindow.vala"
	_tmp68_ = _tmp67_;
#line 86 "../src/Dialogs/PreferencesWindow.vala"
	g_signal_emit_by_name (_tmp68_, "hook-preferences-window", (GtkWindow*) self);
#line 86 "../src/Dialogs/PreferencesWindow.vala"
	_g_object_unref0 (_tmp68_);
#line 88 "../src/Dialogs/PreferencesWindow.vala"
	_tmp69_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Close"), (gint) GTK_RESPONSE_CLOSE);
#line 88 "../src/Dialogs/PreferencesWindow.vala"
	_tmp70_ = _g_object_ref0 (_tmp69_);
#line 88 "../src/Dialogs/PreferencesWindow.vala"
	close_button = _tmp70_;
#line 89 "../src/Dialogs/PreferencesWindow.vala"
	_tmp71_ = close_button;
#line 89 "../src/Dialogs/PreferencesWindow.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, gtk_button_get_type (), GtkButton), "clicked", (GCallback) __music_preferences_window___lambda123__gtk_button_clicked, self, 0);
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	_g_object_unref0 (close_button);
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	_g_object_unref0 (layout);
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	_g_object_unref0 (hide_on_close_switch);
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	_g_object_unref0 (copy_imported_music_switch);
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	_g_object_unref0 (write_file_metadata_switch);
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	_g_object_unref0 (organize_folders_switch);
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	_g_object_unref0 (main_settings);
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	block15_data_unref (_data15_);
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	_data15_ = NULL;
#line 37 "../src/Dialogs/PreferencesWindow.vala"
	return obj;
#line 674 "PreferencesWindow.c"
}

static void
music_preferences_window_class_init (MusicPreferencesWindowClass * klass,
                                     gpointer klass_data)
{
#line 27 "../src/Dialogs/PreferencesWindow.vala"
	music_preferences_window_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/Dialogs/PreferencesWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = music_preferences_window_constructor;
#line 685 "PreferencesWindow.c"
}

static void
music_preferences_window_instance_init (MusicPreferencesWindow * self,
                                        gpointer klass)
{
}

static GType
music_preferences_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPreferencesWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_preferences_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPreferencesWindow), 0, (GInstanceInitFunc) music_preferences_window_instance_init, NULL };
	GType music_preferences_window_type_id;
	music_preferences_window_type_id = g_type_register_static (GRANITE_TYPE_DIALOG, "MusicPreferencesWindow", &g_define_type_info, 0);
	return music_preferences_window_type_id;
}

GType
music_preferences_window_get_type (void)
{
	static volatile gsize music_preferences_window_type_id__once = 0;
	if (g_once_init_enter (&music_preferences_window_type_id__once)) {
		GType music_preferences_window_type_id;
		music_preferences_window_type_id = music_preferences_window_get_type_once ();
		g_once_init_leave (&music_preferences_window_type_id__once, music_preferences_window_type_id);
	}
	return music_preferences_window_type_id__once;
}

