/* LocalStaticPlaylist.c generated by valac 0.56.0, the Vala compiler
 * generated from LocalStaticPlaylist.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "music-lib.h"
#include <libgda/libgda.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "io.elementary.music-core.h"
#include <glib-object.h>
#include <gee.h>

enum  {
	MUSIC_LOCAL_STATIC_PLAYLIST_0_PROPERTY,
	MUSIC_LOCAL_STATIC_PLAYLIST_NAME_PROPERTY,
	MUSIC_LOCAL_STATIC_PLAYLIST_NUM_PROPERTIES
};
static GParamSpec* music_local_static_playlist_properties[MUSIC_LOCAL_STATIC_PLAYLIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _MusicLocalStaticPlaylistPrivate {
	GdaConnection* connection;
	gchar* _name;
};

static gint MusicLocalStaticPlaylist_private_offset;
static gpointer music_local_static_playlist_parent_class = NULL;

static void _vala_GValue_free (GValue* self);
static void music_local_static_playlist_update_database (MusicLocalStaticPlaylist* self);
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_slist_free___vala_GValue_free0_ (GSList* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static GObject * music_local_static_playlist_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void _music_local_static_playlist___lambda19_ (MusicLocalStaticPlaylist* self,
                                               const gchar* old_name);
static void __music_local_static_playlist___lambda19__music_playlist_updated (MusicPlaylist* _sender,
                                                                       const gchar* old_name,
                                                                       gpointer self);
static void music_local_static_playlist_finalize (GObject * obj);
static GType music_local_static_playlist_get_type_once (void);
static void _vala_music_local_static_playlist_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_music_local_static_playlist_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
music_local_static_playlist_get_instance_private (MusicLocalStaticPlaylist* self)
{
	return G_STRUCT_MEMBER_P (self, MusicLocalStaticPlaylist_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 52 "../src/LocalBackend/LocalStaticPlaylist.vala"
	return self ? g_object_ref (self) : NULL;
#line 105 "LocalStaticPlaylist.c"
}

static void
_vala_GValue_free (GValue* self)
{
#line 53 "../src/LocalBackend/LocalStaticPlaylist.vala"
	g_boxed_free (G_TYPE_VALUE, self);
#line 113 "LocalStaticPlaylist.c"
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result;
#line 770 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 771 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, _base);
#line 771 "glib-2.0.vapi"
	return result;
#line 127 "LocalStaticPlaylist.c"
}

MusicLocalStaticPlaylist*
music_local_static_playlist_construct (GType object_type,
                                       gint64 rowid,
                                       GdaConnection* connection)
{
	MusicLocalStaticPlaylist * self = NULL;
	GdaConnection* _tmp0_;
	gchar* all = NULL;
	GValue* _tmp1_;
	GValue* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
#line 50 "../src/LocalBackend/LocalStaticPlaylist.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 50 "../src/LocalBackend/LocalStaticPlaylist.vala"
	self = (MusicLocalStaticPlaylist*) music_static_playlist_construct (object_type);
#line 51 "../src/LocalBackend/LocalStaticPlaylist.vala"
	music_playlist_set_rowid ((MusicPlaylist*) self, rowid);
#line 52 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp0_ = _g_object_ref0 (connection);
#line 52 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_g_object_unref0 (self->priv->connection);
#line 52 "../src/LocalBackend/LocalStaticPlaylist.vala"
	self->priv->connection = _tmp0_;
#line 53 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp1_ = music_database_query_field (rowid, connection, MUSIC_DATABASE_PLAYLISTS_TABLE_NAME, "media");
#line 53 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp2_ = _tmp1_;
#line 53 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp3_ = g_value_dup_string (_tmp2_);
#line 53 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp4_ = _tmp3_;
#line 53 "../src/LocalBackend/LocalStaticPlaylist.vala"
	__vala_GValue_free0 (_tmp2_);
#line 53 "../src/LocalBackend/LocalStaticPlaylist.vala"
	all = _tmp4_;
#line 54 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp5_ = all;
#line 54 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, ";", 0);
#line 173 "LocalStaticPlaylist.c"
	{
		gchar** id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
#line 54 "../src/LocalBackend/LocalStaticPlaylist.vala"
		id_collection = _tmp7_;
#line 54 "../src/LocalBackend/LocalStaticPlaylist.vala"
		id_collection_length1 = _vala_array_length (_tmp6_);
#line 54 "../src/LocalBackend/LocalStaticPlaylist.vala"
		for (id_it = 0; id_it < id_collection_length1; id_it = id_it + 1) {
#line 185 "LocalStaticPlaylist.c"
			gchar* _tmp8_;
			gchar* id = NULL;
#line 54 "../src/LocalBackend/LocalStaticPlaylist.vala"
			_tmp8_ = g_strdup (id_collection[id_it]);
#line 54 "../src/LocalBackend/LocalStaticPlaylist.vala"
			id = _tmp8_;
#line 192 "LocalStaticPlaylist.c"
			{
				GeeArrayList* _tmp9_;
				GeeArrayList* _tmp10_;
				MusicLibrariesManager* _tmp11_;
				MusicLibrary* _tmp12_;
				const gchar* _tmp13_;
				MusicMedia* _tmp14_;
				MusicMedia* _tmp15_;
#line 55 "../src/LocalBackend/LocalStaticPlaylist.vala"
				_tmp9_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 55 "../src/LocalBackend/LocalStaticPlaylist.vala"
				_tmp10_ = _tmp9_;
#line 55 "../src/LocalBackend/LocalStaticPlaylist.vala"
				_tmp11_ = music_libraries_manager;
#line 55 "../src/LocalBackend/LocalStaticPlaylist.vala"
				_tmp12_ = _tmp11_->local_library;
#line 55 "../src/LocalBackend/LocalStaticPlaylist.vala"
				_tmp13_ = id;
#line 55 "../src/LocalBackend/LocalStaticPlaylist.vala"
				_tmp14_ = music_library_media_from_id (_tmp12_, int64_parse (_tmp13_, (guint) 0));
#line 55 "../src/LocalBackend/LocalStaticPlaylist.vala"
				_tmp15_ = _tmp14_;
#line 55 "../src/LocalBackend/LocalStaticPlaylist.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp15_);
#line 55 "../src/LocalBackend/LocalStaticPlaylist.vala"
				_g_object_unref0 (_tmp15_);
#line 54 "../src/LocalBackend/LocalStaticPlaylist.vala"
				_g_free0 (id);
#line 221 "LocalStaticPlaylist.c"
			}
		}
#line 54 "../src/LocalBackend/LocalStaticPlaylist.vala"
		id_collection = (_vala_array_free (id_collection, id_collection_length1, (GDestroyNotify) g_free), NULL);
#line 226 "LocalStaticPlaylist.c"
	}
#line 50 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_g_free0 (all);
#line 50 "../src/LocalBackend/LocalStaticPlaylist.vala"
	return self;
#line 232 "LocalStaticPlaylist.c"
}

MusicLocalStaticPlaylist*
music_local_static_playlist_new (gint64 rowid,
                                 GdaConnection* connection)
{
#line 50 "../src/LocalBackend/LocalStaticPlaylist.vala"
	return music_local_static_playlist_construct (MUSIC_TYPE_LOCAL_STATIC_PLAYLIST, rowid, connection);
#line 241 "LocalStaticPlaylist.c"
}

static void
__vala_GValue_free0_ (gpointer var)
{
#line 82 "../src/LocalBackend/LocalStaticPlaylist.vala"
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
#line 249 "LocalStaticPlaylist.c"
}

static inline void
_g_slist_free___vala_GValue_free0_ (GSList* self)
{
#line 82 "../src/LocalBackend/LocalStaticPlaylist.vala"
	g_slist_free_full (self, (GDestroyNotify) __vala_GValue_free0_);
#line 257 "LocalStaticPlaylist.c"
}

static void
_g_free0_ (gpointer var)
{
#line 82 "../src/LocalBackend/LocalStaticPlaylist.vala"
	var = (g_free (var), NULL);
#line 265 "LocalStaticPlaylist.c"
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 82 "../src/LocalBackend/LocalStaticPlaylist.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 273 "LocalStaticPlaylist.c"
}

static void
music_local_static_playlist_update_database (MusicLocalStaticPlaylist* self)
{
	GValue rowid_value = {0};
	GValue _tmp0_ = {0};
	gint64 _tmp1_;
	gint64 _tmp2_;
	GSList* col_names = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GSList* values = NULL;
	GString* sb = NULL;
	GString* _tmp5_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	GValue* _tmp23_ = NULL;
	GString* _tmp24_;
	const gchar* _tmp25_;
	GValue* _tmp26_ = NULL;
	GError* _inner_error0_ = NULL;
#line 65 "../src/LocalBackend/LocalStaticPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/LocalBackend/LocalStaticPlaylist.vala"
	g_value_init (&_tmp0_, G_TYPE_INT64);
#line 66 "../src/LocalBackend/LocalStaticPlaylist.vala"
	rowid_value = _tmp0_;
#line 67 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp1_ = music_playlist_get_rowid ((MusicPlaylist*) self);
#line 67 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp2_ = _tmp1_;
#line 67 "../src/LocalBackend/LocalStaticPlaylist.vala"
	g_value_set_int64 (&rowid_value, _tmp2_);
#line 68 "../src/LocalBackend/LocalStaticPlaylist.vala"
	col_names = NULL;
#line 69 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp3_ = g_strdup ("name");
#line 69 "../src/LocalBackend/LocalStaticPlaylist.vala"
	col_names = g_slist_append (col_names, _tmp3_);
#line 70 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp4_ = g_strdup ("media");
#line 70 "../src/LocalBackend/LocalStaticPlaylist.vala"
	col_names = g_slist_append (col_names, _tmp4_);
#line 71 "../src/LocalBackend/LocalStaticPlaylist.vala"
	values = NULL;
#line 72 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp5_ = g_string_new ("");
#line 72 "../src/LocalBackend/LocalStaticPlaylist.vala"
	sb = _tmp5_;
#line 324 "LocalStaticPlaylist.c"
	{
		GeeArrayList* _m_list = NULL;
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp7_;
		gint _m_size = 0;
		GeeArrayList* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _m_index = 0;
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_tmp6_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_tmp7_ = _tmp6_;
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_m_list = _tmp7_;
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_tmp8_ = _m_list;
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_tmp10_ = _tmp9_;
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_m_size = _tmp10_;
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_m_index = -1;
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
		while (TRUE) {
#line 352 "LocalStaticPlaylist.c"
			gint _tmp11_;
			gint _tmp12_;
			MusicMedia* m = NULL;
			GeeArrayList* _tmp13_;
			gpointer _tmp14_;
			GString* _tmp15_;
			GString* _tmp17_;
			MusicMedia* _tmp18_;
			gint64 _tmp19_;
			gint64 _tmp20_;
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
			_m_index = _m_index + 1;
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
			_tmp11_ = _m_index;
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
			_tmp12_ = _m_size;
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
			if (!(_tmp11_ < _tmp12_)) {
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
				break;
#line 373 "LocalStaticPlaylist.c"
			}
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
			_tmp13_ = _m_list;
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
			_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, _m_index);
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
			m = (MusicMedia*) _tmp14_;
#line 74 "../src/LocalBackend/LocalStaticPlaylist.vala"
			_tmp15_ = sb;
#line 74 "../src/LocalBackend/LocalStaticPlaylist.vala"
			if (_tmp15_->len != ((gssize) 0)) {
#line 385 "LocalStaticPlaylist.c"
				GString* _tmp16_;
#line 75 "../src/LocalBackend/LocalStaticPlaylist.vala"
				_tmp16_ = sb;
#line 75 "../src/LocalBackend/LocalStaticPlaylist.vala"
				g_string_append_c (_tmp16_, ';');
#line 391 "LocalStaticPlaylist.c"
			}
#line 77 "../src/LocalBackend/LocalStaticPlaylist.vala"
			_tmp17_ = sb;
#line 77 "../src/LocalBackend/LocalStaticPlaylist.vala"
			_tmp18_ = m;
#line 77 "../src/LocalBackend/LocalStaticPlaylist.vala"
			_tmp19_ = music_media_get_rowid (_tmp18_);
#line 77 "../src/LocalBackend/LocalStaticPlaylist.vala"
			_tmp20_ = _tmp19_;
#line 77 "../src/LocalBackend/LocalStaticPlaylist.vala"
			g_string_append_printf (_tmp17_, "%lld", _tmp20_);
#line 73 "../src/LocalBackend/LocalStaticPlaylist.vala"
			_g_object_unref0 (m);
#line 405 "LocalStaticPlaylist.c"
		}
	}
#line 80 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp21_ = music_playlist_get_name ((MusicPlaylist*) self);
#line 80 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp22_ = _tmp21_;
#line 80 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp23_ = g_new0 (GValue, 1);
#line 80 "../src/LocalBackend/LocalStaticPlaylist.vala"
	g_value_init (_tmp23_, G_TYPE_STRING);
#line 80 "../src/LocalBackend/LocalStaticPlaylist.vala"
	g_value_set_string (_tmp23_, _tmp22_);
#line 80 "../src/LocalBackend/LocalStaticPlaylist.vala"
	values = g_slist_append (values, _tmp23_);
#line 81 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp24_ = sb;
#line 81 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp25_ = _tmp24_->str;
#line 81 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp26_ = g_new0 (GValue, 1);
#line 81 "../src/LocalBackend/LocalStaticPlaylist.vala"
	g_value_init (_tmp26_, G_TYPE_STRING);
#line 81 "../src/LocalBackend/LocalStaticPlaylist.vala"
	g_value_set_string (_tmp26_, _tmp25_);
#line 81 "../src/LocalBackend/LocalStaticPlaylist.vala"
	values = g_slist_append (values, _tmp26_);
#line 432 "LocalStaticPlaylist.c"
	{
		GdaConnection* _tmp27_;
		GValue _tmp28_;
		GSList* _tmp29_;
		GSList* _tmp30_;
#line 83 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_tmp27_ = self->priv->connection;
#line 83 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_tmp28_ = rowid_value;
#line 83 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_tmp29_ = col_names;
#line 83 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_tmp30_ = values;
#line 83 "../src/LocalBackend/LocalStaticPlaylist.vala"
		gda_connection_update_row_in_table_v (_tmp27_, MUSIC_DATABASE_PLAYLISTS_TABLE_NAME, "rowid", &_tmp28_, _tmp29_, _tmp30_, &_inner_error0_);
#line 83 "../src/LocalBackend/LocalStaticPlaylist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 450 "LocalStaticPlaylist.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp31_;
		const gchar* _tmp32_;
#line 82 "../src/LocalBackend/LocalStaticPlaylist.vala"
		e = _inner_error0_;
#line 82 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_inner_error0_ = NULL;
#line 85 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_tmp31_ = e;
#line 85 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_tmp32_ = _tmp31_->message;
#line 85 "../src/LocalBackend/LocalStaticPlaylist.vala"
		g_critical ("LocalStaticPlaylist.vala:85: %s", _tmp32_);
#line 82 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_g_error_free0 (e);
#line 472 "LocalStaticPlaylist.c"
	}
	__finally0:
#line 82 "../src/LocalBackend/LocalStaticPlaylist.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 82 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_g_string_free0 (sb);
#line 82 "../src/LocalBackend/LocalStaticPlaylist.vala"
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 82 "../src/LocalBackend/LocalStaticPlaylist.vala"
		(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 82 "../src/LocalBackend/LocalStaticPlaylist.vala"
		G_IS_VALUE (&rowid_value) ? (g_value_unset (&rowid_value), NULL) : NULL;
#line 82 "../src/LocalBackend/LocalStaticPlaylist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 82 "../src/LocalBackend/LocalStaticPlaylist.vala"
		g_clear_error (&_inner_error0_);
#line 82 "../src/LocalBackend/LocalStaticPlaylist.vala"
		return;
#line 491 "LocalStaticPlaylist.c"
	}
#line 65 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_g_string_free0 (sb);
#line 65 "../src/LocalBackend/LocalStaticPlaylist.vala"
	(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 65 "../src/LocalBackend/LocalStaticPlaylist.vala"
	(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 65 "../src/LocalBackend/LocalStaticPlaylist.vala"
	G_IS_VALUE (&rowid_value) ? (g_value_unset (&rowid_value), NULL) : NULL;
#line 501 "LocalStaticPlaylist.c"
}

static const gchar*
music_local_static_playlist_real_get_name (MusicPlaylist* base)
{
	const gchar* result;
	MusicLocalStaticPlaylist* self;
	const gchar* _tmp0_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	GValue* _tmp5_;
	GValue* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
#line 37 "../src/LocalBackend/LocalStaticPlaylist.vala"
	self = (MusicLocalStaticPlaylist*) base;
#line 38 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp0_ = self->priv->_name;
#line 38 "../src/LocalBackend/LocalStaticPlaylist.vala"
	if (_tmp0_ != NULL) {
#line 523 "LocalStaticPlaylist.c"
		const gchar* _tmp1_;
#line 39 "../src/LocalBackend/LocalStaticPlaylist.vala"
		_tmp1_ = self->priv->_name;
#line 39 "../src/LocalBackend/LocalStaticPlaylist.vala"
		result = _tmp1_;
#line 39 "../src/LocalBackend/LocalStaticPlaylist.vala"
		return result;
#line 531 "LocalStaticPlaylist.c"
	}
#line 41 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp2_ = music_playlist_get_rowid ((MusicPlaylist*) self);
#line 41 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp3_ = _tmp2_;
#line 41 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp4_ = self->priv->connection;
#line 41 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp5_ = music_database_query_field (_tmp3_, _tmp4_, MUSIC_DATABASE_PLAYLISTS_TABLE_NAME, "name");
#line 41 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp6_ = _tmp5_;
#line 41 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp7_ = g_value_dup_string (_tmp6_);
#line 41 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_g_free0 (self->priv->_name);
#line 41 "../src/LocalBackend/LocalStaticPlaylist.vala"
	self->priv->_name = _tmp7_;
#line 41 "../src/LocalBackend/LocalStaticPlaylist.vala"
	__vala_GValue_free0 (_tmp6_);
#line 42 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp8_ = self->priv->_name;
#line 42 "../src/LocalBackend/LocalStaticPlaylist.vala"
	result = _tmp8_;
#line 42 "../src/LocalBackend/LocalStaticPlaylist.vala"
	return result;
#line 557 "LocalStaticPlaylist.c"
}

static void
music_local_static_playlist_real_set_name (MusicPlaylist* base,
                                           const gchar* value)
{
	MusicLocalStaticPlaylist* self;
	gchar* _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	GdaConnection* _tmp3_;
	GValue _tmp4_ = {0};
#line 44 "../src/LocalBackend/LocalStaticPlaylist.vala"
	self = (MusicLocalStaticPlaylist*) base;
#line 45 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp0_ = g_strdup (value);
#line 45 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_g_free0 (self->priv->_name);
#line 45 "../src/LocalBackend/LocalStaticPlaylist.vala"
	self->priv->_name = _tmp0_;
#line 46 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp1_ = music_playlist_get_rowid ((MusicPlaylist*) self);
#line 46 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp2_ = _tmp1_;
#line 46 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_tmp3_ = self->priv->connection;
#line 46 "../src/LocalBackend/LocalStaticPlaylist.vala"
	g_value_init (&_tmp4_, G_TYPE_STRING);
#line 46 "../src/LocalBackend/LocalStaticPlaylist.vala"
	g_value_set_string (&_tmp4_, value);
#line 46 "../src/LocalBackend/LocalStaticPlaylist.vala"
	music_database_set_field (_tmp2_, _tmp3_, MUSIC_DATABASE_PLAYLISTS_TABLE_NAME, "name", &_tmp4_);
#line 46 "../src/LocalBackend/LocalStaticPlaylist.vala"
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
#line 44 "../src/LocalBackend/LocalStaticPlaylist.vala"
	g_object_notify_by_pspec ((GObject *) self, music_local_static_playlist_properties[MUSIC_LOCAL_STATIC_PLAYLIST_NAME_PROPERTY]);
#line 594 "LocalStaticPlaylist.c"
}

static void
_music_local_static_playlist___lambda19_ (MusicLocalStaticPlaylist* self,
                                          const gchar* old_name)
{
#line 61 "../src/LocalBackend/LocalStaticPlaylist.vala"
	music_local_static_playlist_update_database (self);
#line 603 "LocalStaticPlaylist.c"
}

static void
__music_local_static_playlist___lambda19__music_playlist_updated (MusicPlaylist* _sender,
                                                                  const gchar* old_name,
                                                                  gpointer self)
{
#line 60 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_music_local_static_playlist___lambda19_ ((MusicLocalStaticPlaylist*) self, old_name);
#line 613 "LocalStaticPlaylist.c"
}

static GObject *
music_local_static_playlist_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicLocalStaticPlaylist * self;
#line 59 "../src/LocalBackend/LocalStaticPlaylist.vala"
	parent_class = G_OBJECT_CLASS (music_local_static_playlist_parent_class);
#line 59 "../src/LocalBackend/LocalStaticPlaylist.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 59 "../src/LocalBackend/LocalStaticPlaylist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_LOCAL_STATIC_PLAYLIST, MusicLocalStaticPlaylist);
#line 60 "../src/LocalBackend/LocalStaticPlaylist.vala"
	g_signal_connect_object ((MusicPlaylist*) self, "updated", (GCallback) __music_local_static_playlist___lambda19__music_playlist_updated, self, 0);
#line 59 "../src/LocalBackend/LocalStaticPlaylist.vala"
	return obj;
#line 634 "LocalStaticPlaylist.c"
}

static void
music_local_static_playlist_class_init (MusicLocalStaticPlaylistClass * klass,
                                        gpointer klass_data)
{
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
	music_local_static_playlist_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
	g_type_class_adjust_private_offset (klass, &MusicLocalStaticPlaylist_private_offset);
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
	MUSIC_PLAYLIST_CLASS (klass)->get_name = music_local_static_playlist_real_get_name;
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
	MUSIC_PLAYLIST_CLASS (klass)->set_name = music_local_static_playlist_real_set_name;
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_local_static_playlist_get_property;
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_local_static_playlist_set_property;
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
	G_OBJECT_CLASS (klass)->constructor = music_local_static_playlist_constructor;
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
	G_OBJECT_CLASS (klass)->finalize = music_local_static_playlist_finalize;
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_STATIC_PLAYLIST_NAME_PROPERTY, music_local_static_playlist_properties[MUSIC_LOCAL_STATIC_PLAYLIST_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 659 "LocalStaticPlaylist.c"
}

static void
music_local_static_playlist_instance_init (MusicLocalStaticPlaylist * self,
                                           gpointer klass)
{
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
	self->priv = music_local_static_playlist_get_instance_private (self);
#line 35 "../src/LocalBackend/LocalStaticPlaylist.vala"
	self->priv->_name = NULL;
#line 670 "LocalStaticPlaylist.c"
}

static void
music_local_static_playlist_finalize (GObject * obj)
{
	MusicLocalStaticPlaylist * self;
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_LOCAL_STATIC_PLAYLIST, MusicLocalStaticPlaylist);
#line 30 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_g_object_unref0 (self->priv->connection);
#line 35 "../src/LocalBackend/LocalStaticPlaylist.vala"
	_g_free0 (self->priv->_name);
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
	G_OBJECT_CLASS (music_local_static_playlist_parent_class)->finalize (obj);
#line 685 "LocalStaticPlaylist.c"
}

static GType
music_local_static_playlist_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicLocalStaticPlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_local_static_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicLocalStaticPlaylist), 0, (GInstanceInitFunc) music_local_static_playlist_instance_init, NULL };
	GType music_local_static_playlist_type_id;
	music_local_static_playlist_type_id = g_type_register_static (MUSIC_TYPE_STATIC_PLAYLIST, "MusicLocalStaticPlaylist", &g_define_type_info, 0);
	MusicLocalStaticPlaylist_private_offset = g_type_add_instance_private (music_local_static_playlist_type_id, sizeof (MusicLocalStaticPlaylistPrivate));
	return music_local_static_playlist_type_id;
}

GType
music_local_static_playlist_get_type (void)
{
	static volatile gsize music_local_static_playlist_type_id__once = 0;
	if (g_once_init_enter (&music_local_static_playlist_type_id__once)) {
		GType music_local_static_playlist_type_id;
		music_local_static_playlist_type_id = music_local_static_playlist_get_type_once ();
		g_once_init_leave (&music_local_static_playlist_type_id__once, music_local_static_playlist_type_id);
	}
	return music_local_static_playlist_type_id__once;
}

static void
_vala_music_local_static_playlist_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	MusicLocalStaticPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LOCAL_STATIC_PLAYLIST, MusicLocalStaticPlaylist);
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
	switch (property_id) {
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
		case MUSIC_LOCAL_STATIC_PLAYLIST_NAME_PROPERTY:
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
		g_value_set_string (value, music_playlist_get_name ((MusicPlaylist*) self));
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
		break;
#line 726 "LocalStaticPlaylist.c"
		default:
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
		break;
#line 732 "LocalStaticPlaylist.c"
	}
}

static void
_vala_music_local_static_playlist_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	MusicLocalStaticPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LOCAL_STATIC_PLAYLIST, MusicLocalStaticPlaylist);
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
	switch (property_id) {
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
		case MUSIC_LOCAL_STATIC_PLAYLIST_NAME_PROPERTY:
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
		music_playlist_set_name ((MusicPlaylist*) self, g_value_get_string (value));
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
		break;
#line 752 "LocalStaticPlaylist.c"
		default:
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/LocalBackend/LocalStaticPlaylist.vala"
		break;
#line 758 "LocalStaticPlaylist.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

