/* AlbumsView.c generated by valac 0.56.0, the Vala compiler
 * generated from AlbumsView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include "music-lib.h"
#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>

enum  {
	MUSIC_ALBUMS_VIEW_0_PROPERTY,
	MUSIC_ALBUMS_VIEW_PARENT_VIEW_WRAPPER_PROPERTY,
	MUSIC_ALBUMS_VIEW_NUM_PROPERTIES
};
static GParamSpec* music_albums_view_properties[MUSIC_ALBUMS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MusicAlbumsViewPrivate {
	MusicFastGrid* icon_view;
	MusicViewWrapper* _parent_view_wrapper;
};

static gint MusicAlbumsView_private_offset;
static gpointer music_albums_view_parent_class = NULL;
static MusicAlbumListGrid* music_albums_view__popup;
static MusicAlbumListGrid* music_albums_view__popup = NULL;
static MusicViewInterfaceIface * music_albums_view_music_view_interface_parent_iface = NULL;

static void music_albums_view_on_item_selected (MusicAlbumsView* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void __vala_GtkTreePath_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreePath_free0_ (GList* self);
static void music_albums_view_on_item_activated (MusicAlbumsView* self,
                                          GtkTreePath* path);
static MusicAlbumListGrid* music_albums_view_get_popup_list_view (MusicAlbumsView* self);
static void music_albums_view_on_drag_begin (MusicAlbumsView* self,
                                      GtkWidget* sender,
                                      GdkDragContext* context);
static GtkTreePath* _vala_GtkTreePath_copy (GtkTreePath* self);
static void music_albums_view_on_drag_data_get (MusicAlbumsView* self,
                                         GdkDragContext* context,
                                         GtkSelectionData* selection_data,
                                         guint info,
                                         guint time_);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static GeeCollection* music_albums_view_real_get_visible_media (MusicViewInterface* base);
static GeeCollection* music_albums_view_get_visible_albums (MusicAlbumsView* self);
static GeeCollection* music_albums_view_real_get_media (MusicViewInterface* base);
static GeeCollection* music_albums_view_get_albums (MusicAlbumsView* self);
static void music_albums_view_real_refilter (MusicViewInterface* base);
static void music_albums_view_real_update_media (MusicViewInterface* base,
                                          GeeCollection* media);
static void _gtk_widget_queue_draw_music_album_cover_rendered (MusicAlbum* _sender,
                                                        gpointer self);
static void _gtk_widget_queue_draw_g_object_notify (GObject* _sender,
                                             GParamSpec* pspec,
                                             gpointer self);
static void music_albums_view_real_set_media (MusicViewInterface* base,
                                       GeeCollection* to_add);
static void music_albums_view_real_add_media (MusicViewInterface* base,
                                       GeeCollection* media);
static void music_albums_view_real_remove_media (MusicViewInterface* base,
                                          GeeCollection* to_remove);
static gint __lambda55_ (MusicAlbumsView* self,
                  MusicAlbum* a,
                  MusicAlbum* b);
static gint ___lambda55__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
static GObject * music_albums_view_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static gint _music_albums_view_compare_func_music_fast_grid_sort_compare_func (GObject* a,
                                                                        GObject* b,
                                                                        gpointer self);
static void _music_albums_view_search_func_music_fast_grid_view_search_func (GeeHashMap* showing,
                                                                      gpointer self);
static void _music_albums_view_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                             GdkDragContext* context,
                                                             gpointer self);
static void _music_albums_view_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                   GdkDragContext* context,
                                                                   GtkSelectionData* selection_data,
                                                                   guint info,
                                                                   guint time_,
                                                                   gpointer self);
static void _music_albums_view_on_item_activated_gtk_icon_view_item_activated (GtkIconView* _sender,
                                                                        GtkTreePath* path,
                                                                        gpointer self);
static void _music_albums_view_on_item_selected_gtk_icon_view_selection_changed (GtkIconView* _sender,
                                                                          gpointer self);
static void _music_albums_view___lambda56_ (MusicAlbumsView* self);
static void __music_albums_view___lambda56__g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void _music_albums_view___lambda57_ (MusicAlbumsView* self);
static void __music_albums_view___lambda57__music_library_search_finished (MusicLibrary* _sender,
                                                                    gpointer self);
static void music_albums_view_finalize (GObject * obj);
static GType music_albums_view_get_type_once (void);
static void _vala_music_albums_view_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_music_albums_view_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
music_albums_view_get_instance_private (MusicAlbumsView* self)
{
	return G_STRUCT_MEMBER_P (self, MusicAlbumsView_private_offset);
}

MusicAlbumsView*
music_albums_view_construct (GType object_type,
                             MusicViewWrapper* view_wrapper)
{
	MusicAlbumsView * self = NULL;
#line 47 "../src/Views/AlbumsView.vala"
	g_return_val_if_fail (view_wrapper != NULL, NULL);
#line 48 "../src/Views/AlbumsView.vala"
	self = (MusicAlbumsView*) g_object_new (object_type, "parent-view-wrapper", view_wrapper, NULL);
#line 47 "../src/Views/AlbumsView.vala"
	return self;
#line 173 "AlbumsView.c"
}

MusicAlbumsView*
music_albums_view_new (MusicViewWrapper* view_wrapper)
{
#line 47 "../src/Views/AlbumsView.vala"
	return music_albums_view_construct (MUSIC_TYPE_ALBUMS_VIEW, view_wrapper);
#line 181 "AlbumsView.c"
}

void
music_albums_view_clear_objects (MusicAlbumsView* self)
{
	MusicFastGrid* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
#line 86 "../src/Views/AlbumsView.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/Views/AlbumsView.vala"
	_tmp0_ = self->priv->icon_view;
#line 87 "../src/Views/AlbumsView.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, MUSIC_TYPE_ALBUM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 87 "../src/Views/AlbumsView.vala"
	_tmp2_ = _tmp1_;
#line 87 "../src/Views/AlbumsView.vala"
	music_fast_grid_set_table (_tmp0_, _tmp2_, TRUE);
#line 87 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (_tmp2_);
#line 202 "AlbumsView.c"
}

GeeCollection*
music_albums_view_get_objects (MusicAlbumsView* self)
{
	MusicFastGrid* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	GeeCollection* result;
#line 90 "../src/Views/AlbumsView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 91 "../src/Views/AlbumsView.vala"
	_tmp0_ = self->priv->icon_view;
#line 91 "../src/Views/AlbumsView.vala"
	_tmp1_ = music_fast_grid_get_table (_tmp0_);
#line 91 "../src/Views/AlbumsView.vala"
	_tmp2_ = _tmp1_;
#line 91 "../src/Views/AlbumsView.vala"
	_tmp3_ = gee_map_get_values (_tmp2_);
#line 91 "../src/Views/AlbumsView.vala"
	_tmp4_ = _tmp3_;
#line 91 "../src/Views/AlbumsView.vala"
	_tmp5_ = _tmp4_;
#line 91 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (_tmp2_);
#line 91 "../src/Views/AlbumsView.vala"
	result = _tmp5_;
#line 91 "../src/Views/AlbumsView.vala"
	return result;
#line 235 "AlbumsView.c"
}

GeeCollection*
music_albums_view_get_visible_objects (MusicAlbumsView* self)
{
	MusicFastGrid* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	GeeCollection* result;
#line 94 "../src/Views/AlbumsView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 95 "../src/Views/AlbumsView.vala"
	_tmp0_ = self->priv->icon_view;
#line 95 "../src/Views/AlbumsView.vala"
	_tmp1_ = music_fast_grid_get_visible_table (_tmp0_);
#line 95 "../src/Views/AlbumsView.vala"
	_tmp2_ = _tmp1_;
#line 95 "../src/Views/AlbumsView.vala"
	_tmp3_ = gee_map_get_values (_tmp2_);
#line 95 "../src/Views/AlbumsView.vala"
	_tmp4_ = _tmp3_;
#line 95 "../src/Views/AlbumsView.vala"
	_tmp5_ = _tmp4_;
#line 95 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (_tmp2_);
#line 95 "../src/Views/AlbumsView.vala"
	result = _tmp5_;
#line 95 "../src/Views/AlbumsView.vala"
	return result;
#line 268 "AlbumsView.c"
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 102 "../src/Views/AlbumsView.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 276 "AlbumsView.c"
}

static void
__vala_GtkTreePath_free0_ (gpointer var)
{
#line 102 "../src/Views/AlbumsView.vala"
	(var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL));
#line 284 "AlbumsView.c"
}

static inline void
_g_list_free___vala_GtkTreePath_free0_ (GList* self)
{
#line 102 "../src/Views/AlbumsView.vala"
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreePath_free0_);
#line 292 "AlbumsView.c"
}

static void
music_albums_view_on_item_selected (MusicAlbumsView* self)
{
	GList* path = NULL;
	MusicFastGrid* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GObject* obj = NULL;
	MusicFastGrid* _tmp3_;
	GList* _tmp4_;
	gconstpointer _tmp5_;
	gint _tmp6_ = 0;
	gint* _tmp7_;
	gint _tmp8_;
	GObject* _tmp9_;
	GObject* _tmp10_;
#line 98 "../src/Views/AlbumsView.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/Views/AlbumsView.vala"
	_tmp0_ = self->priv->icon_view;
#line 99 "../src/Views/AlbumsView.vala"
	_tmp1_ = gtk_icon_view_get_selected_items ((GtkIconView*) _tmp0_);
#line 99 "../src/Views/AlbumsView.vala"
	path = _tmp1_;
#line 100 "../src/Views/AlbumsView.vala"
	_tmp2_ = path;
#line 100 "../src/Views/AlbumsView.vala"
	if (_tmp2_ == NULL) {
#line 101 "../src/Views/AlbumsView.vala"
		music_albums_view_item_activated (self, NULL);
#line 102 "../src/Views/AlbumsView.vala"
		(path == NULL) ? NULL : (path = (_g_list_free___vala_GtkTreePath_free0_ (path), NULL));
#line 102 "../src/Views/AlbumsView.vala"
		return;
#line 329 "AlbumsView.c"
	}
#line 105 "../src/Views/AlbumsView.vala"
	_tmp3_ = self->priv->icon_view;
#line 105 "../src/Views/AlbumsView.vala"
	_tmp4_ = path;
#line 105 "../src/Views/AlbumsView.vala"
	_tmp5_ = _tmp4_->data;
#line 105 "../src/Views/AlbumsView.vala"
	_tmp7_ = gtk_tree_path_get_indices_with_depth ((GtkTreePath*) _tmp5_, &_tmp6_);
#line 105 "../src/Views/AlbumsView.vala"
	_tmp8_ = _tmp7_[0];
#line 105 "../src/Views/AlbumsView.vala"
	_tmp9_ = music_fast_grid_get_object_from_index (_tmp3_, _tmp8_);
#line 105 "../src/Views/AlbumsView.vala"
	obj = _tmp9_;
#line 106 "../src/Views/AlbumsView.vala"
	_tmp10_ = obj;
#line 106 "../src/Views/AlbumsView.vala"
	music_albums_view_item_activated (self, _tmp10_);
#line 98 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (obj);
#line 98 "../src/Views/AlbumsView.vala"
	(path == NULL) ? NULL : (path = (_g_list_free___vala_GtkTreePath_free0_ (path), NULL));
#line 353 "AlbumsView.c"
}

static void
music_albums_view_on_item_activated (MusicAlbumsView* self,
                                     GtkTreePath* path)
{
	MusicAlbumListGrid* _tmp0_;
	MusicAlbumListGrid* _tmp1_;
#line 109 "../src/Views/AlbumsView.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/Views/AlbumsView.vala"
	_tmp0_ = music_albums_view_get_popup_list_view (self);
#line 110 "../src/Views/AlbumsView.vala"
	_tmp1_ = _tmp0_;
#line 110 "../src/Views/AlbumsView.vala"
	music_album_list_grid_play_active_list (_tmp1_);
#line 370 "AlbumsView.c"
}

static GtkTreePath*
_vala_GtkTreePath_copy (GtkTreePath* self)
{
#line 119 "../src/Views/AlbumsView.vala"
	return g_boxed_copy (gtk_tree_path_get_type (), self);
#line 378 "AlbumsView.c"
}

static gpointer
__vala_GtkTreePath_copy0 (gpointer self)
{
#line 119 "../src/Views/AlbumsView.vala"
	return self ? _vala_GtkTreePath_copy (self) : NULL;
#line 386 "AlbumsView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 121 "../src/Views/AlbumsView.vala"
	return self ? g_object_ref (self) : NULL;
#line 394 "AlbumsView.c"
}

static void
music_albums_view_on_drag_begin (MusicAlbumsView* self,
                                 GtkWidget* sender,
                                 GdkDragContext* context)
{
	GList* selected_items = NULL;
	MusicFastGrid* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 113 "../src/Views/AlbumsView.vala"
	g_return_if_fail (self != NULL);
#line 113 "../src/Views/AlbumsView.vala"
	g_return_if_fail (sender != NULL);
#line 113 "../src/Views/AlbumsView.vala"
	g_return_if_fail (context != NULL);
#line 114 "../src/Views/AlbumsView.vala"
	g_debug ("AlbumsView.vala:114: drag begin");
#line 116 "../src/Views/AlbumsView.vala"
	_tmp0_ = self->priv->icon_view;
#line 116 "../src/Views/AlbumsView.vala"
	_tmp1_ = gtk_icon_view_get_selected_items ((GtkIconView*) _tmp0_);
#line 116 "../src/Views/AlbumsView.vala"
	selected_items = _tmp1_;
#line 118 "../src/Views/AlbumsView.vala"
	_tmp2_ = selected_items;
#line 118 "../src/Views/AlbumsView.vala"
	if (g_list_length (_tmp2_) > ((guint) 0)) {
#line 424 "AlbumsView.c"
		GtkTreePath* path = NULL;
		GList* _tmp3_;
		gconstpointer _tmp4_;
		GtkTreePath* _tmp5_;
		GObject* obj = NULL;
		MusicFastGrid* _tmp6_;
		GtkTreePath* _tmp7_;
		gint _tmp8_ = 0;
		gint* _tmp9_;
		gint _tmp10_;
		GObject* _tmp11_;
		GIcon* drag_icon = NULL;
		GObject* _tmp12_;
		GIcon* _tmp13_;
		GIcon* _tmp14_;
		GIcon* _tmp15_;
		GIcon* _tmp16_;
#line 119 "../src/Views/AlbumsView.vala"
		_tmp3_ = selected_items;
#line 119 "../src/Views/AlbumsView.vala"
		_tmp4_ = g_list_nth_data (_tmp3_, (guint) 0);
#line 119 "../src/Views/AlbumsView.vala"
		_tmp5_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) _tmp4_);
#line 119 "../src/Views/AlbumsView.vala"
		path = _tmp5_;
#line 120 "../src/Views/AlbumsView.vala"
		_tmp6_ = self->priv->icon_view;
#line 120 "../src/Views/AlbumsView.vala"
		_tmp7_ = path;
#line 120 "../src/Views/AlbumsView.vala"
		_tmp9_ = gtk_tree_path_get_indices_with_depth (_tmp7_, &_tmp8_);
#line 120 "../src/Views/AlbumsView.vala"
		_tmp10_ = _tmp9_[0];
#line 120 "../src/Views/AlbumsView.vala"
		_tmp11_ = music_fast_grid_get_object_from_index (_tmp6_, _tmp10_);
#line 120 "../src/Views/AlbumsView.vala"
		obj = _tmp11_;
#line 121 "../src/Views/AlbumsView.vala"
		_tmp12_ = obj;
#line 121 "../src/Views/AlbumsView.vala"
		_tmp13_ = music_album_get_cover_icon (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, MUSIC_TYPE_ALBUM, MusicAlbum));
#line 121 "../src/Views/AlbumsView.vala"
		_tmp14_ = _tmp13_;
#line 121 "../src/Views/AlbumsView.vala"
		_tmp15_ = _g_object_ref0 (_tmp14_);
#line 121 "../src/Views/AlbumsView.vala"
		drag_icon = _tmp15_;
#line 123 "../src/Views/AlbumsView.vala"
		_tmp16_ = drag_icon;
#line 123 "../src/Views/AlbumsView.vala"
		gtk_drag_set_icon_gicon (context, _tmp16_, 0, 0);
#line 118 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (drag_icon);
#line 118 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (obj);
#line 118 "../src/Views/AlbumsView.vala"
		__vala_GtkTreePath_free0 (path);
#line 482 "AlbumsView.c"
	}
#line 113 "../src/Views/AlbumsView.vala"
	(selected_items == NULL) ? NULL : (selected_items = (_g_list_free___vala_GtkTreePath_free0_ (selected_items), NULL));
#line 486 "AlbumsView.c"
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 143 "../src/Views/AlbumsView.vala"
	if ((*length) == (*size)) {
#line 143 "../src/Views/AlbumsView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 143 "../src/Views/AlbumsView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 501 "AlbumsView.c"
	}
#line 143 "../src/Views/AlbumsView.vala"
	(*array)[(*length)++] = value;
#line 143 "../src/Views/AlbumsView.vala"
	(*array)[*length] = NULL;
#line 507 "AlbumsView.c"
}

static void
music_albums_view_on_drag_data_get (MusicAlbumsView* self,
                                    GdkDragContext* context,
                                    GtkSelectionData* selection_data,
                                    guint info,
                                    guint time_)
{
	gchar** uris = NULL;
	gint uris_length1;
	gint _uris_size_;
	GList* selected_items = NULL;
	MusicFastGrid* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GtkTreePath* path = NULL;
	GList* _tmp3_;
	gconstpointer _tmp4_;
	GtkTreePath* _tmp5_;
	GObject* obj = NULL;
	MusicFastGrid* _tmp6_;
	GtkTreePath* _tmp7_;
	gint _tmp8_ = 0;
	gint* _tmp9_;
	gint _tmp10_;
	GObject* _tmp11_;
	GObject* _tmp12_;
	gchar** _tmp24_;
	gint _tmp24__length1;
#line 127 "../src/Views/AlbumsView.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/Views/AlbumsView.vala"
	g_return_if_fail (context != NULL);
#line 127 "../src/Views/AlbumsView.vala"
	g_return_if_fail (selection_data != NULL);
#line 128 "../src/Views/AlbumsView.vala"
	uris = NULL;
#line 128 "../src/Views/AlbumsView.vala"
	uris_length1 = 0;
#line 128 "../src/Views/AlbumsView.vala"
	_uris_size_ = uris_length1;
#line 130 "../src/Views/AlbumsView.vala"
	_tmp0_ = self->priv->icon_view;
#line 130 "../src/Views/AlbumsView.vala"
	_tmp1_ = gtk_icon_view_get_selected_items ((GtkIconView*) _tmp0_);
#line 130 "../src/Views/AlbumsView.vala"
	selected_items = _tmp1_;
#line 132 "../src/Views/AlbumsView.vala"
	_tmp2_ = selected_items;
#line 132 "../src/Views/AlbumsView.vala"
	if (g_list_length (_tmp2_) <= ((guint) 0)) {
#line 133 "../src/Views/AlbumsView.vala"
		(selected_items == NULL) ? NULL : (selected_items = (_g_list_free___vala_GtkTreePath_free0_ (selected_items), NULL));
#line 133 "../src/Views/AlbumsView.vala"
		uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 133 "../src/Views/AlbumsView.vala"
		return;
#line 566 "AlbumsView.c"
	}
#line 136 "../src/Views/AlbumsView.vala"
	_tmp3_ = selected_items;
#line 136 "../src/Views/AlbumsView.vala"
	_tmp4_ = g_list_nth_data (_tmp3_, (guint) 0);
#line 136 "../src/Views/AlbumsView.vala"
	_tmp5_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) _tmp4_);
#line 136 "../src/Views/AlbumsView.vala"
	path = _tmp5_;
#line 137 "../src/Views/AlbumsView.vala"
	_tmp6_ = self->priv->icon_view;
#line 137 "../src/Views/AlbumsView.vala"
	_tmp7_ = path;
#line 137 "../src/Views/AlbumsView.vala"
	_tmp9_ = gtk_tree_path_get_indices_with_depth (_tmp7_, &_tmp8_);
#line 137 "../src/Views/AlbumsView.vala"
	_tmp10_ = _tmp9_[0];
#line 137 "../src/Views/AlbumsView.vala"
	_tmp11_ = music_fast_grid_get_object_from_index (_tmp6_, _tmp10_);
#line 137 "../src/Views/AlbumsView.vala"
	obj = _tmp11_;
#line 139 "../src/Views/AlbumsView.vala"
	_tmp12_ = obj;
#line 139 "../src/Views/AlbumsView.vala"
	if (_tmp12_ == NULL) {
#line 140 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (obj);
#line 140 "../src/Views/AlbumsView.vala"
		__vala_GtkTreePath_free0 (path);
#line 140 "../src/Views/AlbumsView.vala"
		(selected_items == NULL) ? NULL : (selected_items = (_g_list_free___vala_GtkTreePath_free0_ (selected_items), NULL));
#line 140 "../src/Views/AlbumsView.vala"
		uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 140 "../src/Views/AlbumsView.vala"
		return;
#line 602 "AlbumsView.c"
	}
	{
		GeeIterator* _m_it = NULL;
		GObject* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeIterator* _tmp16_;
		GeeIterator* _tmp17_;
#line 142 "../src/Views/AlbumsView.vala"
		_tmp13_ = obj;
#line 142 "../src/Views/AlbumsView.vala"
		_tmp14_ = music_albums_view_get_selected_media (self, _tmp13_);
#line 142 "../src/Views/AlbumsView.vala"
		_tmp15_ = _tmp14_;
#line 142 "../src/Views/AlbumsView.vala"
		_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
#line 142 "../src/Views/AlbumsView.vala"
		_tmp17_ = _tmp16_;
#line 142 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (_tmp15_);
#line 142 "../src/Views/AlbumsView.vala"
		_m_it = _tmp17_;
#line 142 "../src/Views/AlbumsView.vala"
		while (TRUE) {
#line 627 "AlbumsView.c"
			GeeIterator* _tmp18_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp19_;
			gpointer _tmp20_;
			MusicMedia* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 142 "../src/Views/AlbumsView.vala"
			_tmp18_ = _m_it;
#line 142 "../src/Views/AlbumsView.vala"
			if (!gee_iterator_next (_tmp18_)) {
#line 142 "../src/Views/AlbumsView.vala"
				break;
#line 641 "AlbumsView.c"
			}
#line 142 "../src/Views/AlbumsView.vala"
			_tmp19_ = _m_it;
#line 142 "../src/Views/AlbumsView.vala"
			_tmp20_ = gee_iterator_get (_tmp19_);
#line 142 "../src/Views/AlbumsView.vala"
			m = (MusicMedia*) _tmp20_;
#line 143 "../src/Views/AlbumsView.vala"
			_tmp21_ = m;
#line 143 "../src/Views/AlbumsView.vala"
			_tmp22_ = music_media_get_uri (_tmp21_);
#line 143 "../src/Views/AlbumsView.vala"
			_tmp23_ = _tmp22_;
#line 143 "../src/Views/AlbumsView.vala"
			_vala_array_add4 (&uris, &uris_length1, &_uris_size_, _tmp23_);
#line 142 "../src/Views/AlbumsView.vala"
			_g_object_unref0 (m);
#line 659 "AlbumsView.c"
		}
#line 142 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (_m_it);
#line 663 "AlbumsView.c"
	}
#line 145 "../src/Views/AlbumsView.vala"
	_tmp24_ = uris;
#line 145 "../src/Views/AlbumsView.vala"
	_tmp24__length1 = uris_length1;
#line 145 "../src/Views/AlbumsView.vala"
	if (_tmp24_ != NULL) {
#line 671 "AlbumsView.c"
		gchar** _tmp25_;
		gint _tmp25__length1;
#line 146 "../src/Views/AlbumsView.vala"
		_tmp25_ = uris;
#line 146 "../src/Views/AlbumsView.vala"
		_tmp25__length1 = uris_length1;
#line 146 "../src/Views/AlbumsView.vala"
		gtk_selection_data_set_uris (selection_data, _tmp25_);
#line 680 "AlbumsView.c"
	}
#line 127 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (obj);
#line 127 "../src/Views/AlbumsView.vala"
	__vala_GtkTreePath_free0 (path);
#line 127 "../src/Views/AlbumsView.vala"
	(selected_items == NULL) ? NULL : (selected_items = (_g_list_free___vala_GtkTreePath_free0_ (selected_items), NULL));
#line 127 "../src/Views/AlbumsView.vala"
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 690 "AlbumsView.c"
}

static GeeCollection*
music_albums_view_real_get_visible_media (MusicViewInterface* base)
{
	MusicAlbumsView * self;
	GeeTreeSet* all_visible_media = NULL;
	GeeTreeSet* _tmp0_;
	GeeCollection* result;
#line 149 "../src/Views/AlbumsView.vala"
	self = (MusicAlbumsView*) base;
#line 150 "../src/Views/AlbumsView.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 150 "../src/Views/AlbumsView.vala"
	all_visible_media = _tmp0_;
#line 706 "AlbumsView.c"
	{
		GeeIterator* _album_it = NULL;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 152 "../src/Views/AlbumsView.vala"
		_tmp1_ = music_albums_view_get_visible_albums (self);
#line 152 "../src/Views/AlbumsView.vala"
		_tmp2_ = _tmp1_;
#line 152 "../src/Views/AlbumsView.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 152 "../src/Views/AlbumsView.vala"
		_tmp4_ = _tmp3_;
#line 152 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (_tmp2_);
#line 152 "../src/Views/AlbumsView.vala"
		_album_it = _tmp4_;
#line 152 "../src/Views/AlbumsView.vala"
		while (TRUE) {
#line 727 "AlbumsView.c"
			GeeIterator* _tmp5_;
			MusicAlbum* album = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GeeCollection* album_media = NULL;
			MusicAlbum* _tmp8_;
			GeeCollection* _tmp9_;
			GeeTreeSet* _tmp10_;
			GeeCollection* _tmp11_;
#line 152 "../src/Views/AlbumsView.vala"
			_tmp5_ = _album_it;
#line 152 "../src/Views/AlbumsView.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 152 "../src/Views/AlbumsView.vala"
				break;
#line 743 "AlbumsView.c"
			}
#line 152 "../src/Views/AlbumsView.vala"
			_tmp6_ = _album_it;
#line 152 "../src/Views/AlbumsView.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 152 "../src/Views/AlbumsView.vala"
			album = (MusicAlbum*) _tmp7_;
#line 153 "../src/Views/AlbumsView.vala"
			_tmp8_ = album;
#line 153 "../src/Views/AlbumsView.vala"
			_tmp9_ = music_album_get_media (_tmp8_, (guint) 1);
#line 153 "../src/Views/AlbumsView.vala"
			album_media = _tmp9_;
#line 154 "../src/Views/AlbumsView.vala"
			_tmp10_ = all_visible_media;
#line 154 "../src/Views/AlbumsView.vala"
			_tmp11_ = album_media;
#line 154 "../src/Views/AlbumsView.vala"
			gee_collection_add_all ((GeeCollection*) _tmp10_, _tmp11_);
#line 152 "../src/Views/AlbumsView.vala"
			_g_object_unref0 (album_media);
#line 152 "../src/Views/AlbumsView.vala"
			_g_object_unref0 (album);
#line 767 "AlbumsView.c"
		}
#line 152 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (_album_it);
#line 771 "AlbumsView.c"
	}
#line 157 "../src/Views/AlbumsView.vala"
	result = (GeeCollection*) all_visible_media;
#line 157 "../src/Views/AlbumsView.vala"
	return result;
#line 777 "AlbumsView.c"
}

static GeeCollection*
music_albums_view_real_get_media (MusicViewInterface* base)
{
	MusicAlbumsView * self;
	GeeTreeSet* all_media = NULL;
	GeeTreeSet* _tmp0_;
	GeeCollection* result;
#line 160 "../src/Views/AlbumsView.vala"
	self = (MusicAlbumsView*) base;
#line 161 "../src/Views/AlbumsView.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 161 "../src/Views/AlbumsView.vala"
	all_media = _tmp0_;
#line 793 "AlbumsView.c"
	{
		GeeIterator* _album_it = NULL;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 163 "../src/Views/AlbumsView.vala"
		_tmp1_ = music_albums_view_get_albums (self);
#line 163 "../src/Views/AlbumsView.vala"
		_tmp2_ = _tmp1_;
#line 163 "../src/Views/AlbumsView.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 163 "../src/Views/AlbumsView.vala"
		_tmp4_ = _tmp3_;
#line 163 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (_tmp2_);
#line 163 "../src/Views/AlbumsView.vala"
		_album_it = _tmp4_;
#line 163 "../src/Views/AlbumsView.vala"
		while (TRUE) {
#line 814 "AlbumsView.c"
			GeeIterator* _tmp5_;
			MusicAlbum* album = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GeeCollection* album_media = NULL;
			MusicAlbum* _tmp8_;
			GeeCollection* _tmp9_;
			GeeTreeSet* _tmp10_;
			GeeCollection* _tmp11_;
#line 163 "../src/Views/AlbumsView.vala"
			_tmp5_ = _album_it;
#line 163 "../src/Views/AlbumsView.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 163 "../src/Views/AlbumsView.vala"
				break;
#line 830 "AlbumsView.c"
			}
#line 163 "../src/Views/AlbumsView.vala"
			_tmp6_ = _album_it;
#line 163 "../src/Views/AlbumsView.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 163 "../src/Views/AlbumsView.vala"
			album = (MusicAlbum*) _tmp7_;
#line 164 "../src/Views/AlbumsView.vala"
			_tmp8_ = album;
#line 164 "../src/Views/AlbumsView.vala"
			_tmp9_ = music_album_get_media (_tmp8_, (guint) 1);
#line 164 "../src/Views/AlbumsView.vala"
			album_media = _tmp9_;
#line 165 "../src/Views/AlbumsView.vala"
			_tmp10_ = all_media;
#line 165 "../src/Views/AlbumsView.vala"
			_tmp11_ = album_media;
#line 165 "../src/Views/AlbumsView.vala"
			gee_collection_add_all ((GeeCollection*) _tmp10_, _tmp11_);
#line 163 "../src/Views/AlbumsView.vala"
			_g_object_unref0 (album_media);
#line 163 "../src/Views/AlbumsView.vala"
			_g_object_unref0 (album);
#line 854 "AlbumsView.c"
		}
#line 163 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (_album_it);
#line 858 "AlbumsView.c"
	}
#line 168 "../src/Views/AlbumsView.vala"
	result = (GeeCollection*) all_media;
#line 168 "../src/Views/AlbumsView.vala"
	return result;
#line 864 "AlbumsView.c"
}

static GeeCollection*
music_albums_view_get_visible_albums (MusicAlbumsView* self)
{
	GeeCollection* _tmp0_;
	GeeCollection* result;
#line 171 "../src/Views/AlbumsView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 172 "../src/Views/AlbumsView.vala"
	_tmp0_ = music_albums_view_get_visible_objects (self);
#line 172 "../src/Views/AlbumsView.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 172 "../src/Views/AlbumsView.vala"
	return result;
#line 880 "AlbumsView.c"
}

static GeeCollection*
music_albums_view_get_albums (MusicAlbumsView* self)
{
	GeeCollection* _tmp0_;
	GeeCollection* result;
#line 175 "../src/Views/AlbumsView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 176 "../src/Views/AlbumsView.vala"
	_tmp0_ = music_albums_view_get_objects (self);
#line 176 "../src/Views/AlbumsView.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 176 "../src/Views/AlbumsView.vala"
	return result;
#line 896 "AlbumsView.c"
}

static void
music_albums_view_real_refilter (MusicViewInterface* base)
{
	MusicAlbumsView * self;
	MusicFastGrid* _tmp0_;
#line 179 "../src/Views/AlbumsView.vala"
	self = (MusicAlbumsView*) base;
#line 180 "../src/Views/AlbumsView.vala"
	_tmp0_ = self->priv->icon_view;
#line 180 "../src/Views/AlbumsView.vala"
	music_fast_grid_do_search (_tmp0_);
#line 910 "AlbumsView.c"
}

static void
_gtk_widget_queue_draw_music_album_cover_rendered (MusicAlbum* _sender,
                                                   gpointer self)
{
#line 200 "../src/Views/AlbumsView.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 919 "AlbumsView.c"
}

static void
_gtk_widget_queue_draw_g_object_notify (GObject* _sender,
                                        GParamSpec* pspec,
                                        gpointer self)
{
#line 201 "../src/Views/AlbumsView.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 929 "AlbumsView.c"
}

static void
music_albums_view_real_update_media (MusicViewInterface* base,
                                     GeeCollection* media)
{
	MusicAlbumsView * self;
	GeeTreeSet* medias_to_update = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	GeeTreeSet* medias_to_add = NULL;
	GeeTreeSet* _tmp2_;
	GeeTreeSet* albums_to_remove = NULL;
	GeeTreeSet* _tmp3_;
	MusicFastGrid* _tmp31_;
	GeeTreeSet* _tmp32_;
	GeeTreeSet* _tmp33_;
	MusicFastGrid* _tmp34_;
#line 183 "../src/Views/AlbumsView.vala"
	self = (MusicAlbumsView*) base;
#line 183 "../src/Views/AlbumsView.vala"
	g_return_if_fail (media != NULL);
#line 184 "../src/Views/AlbumsView.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 184 "../src/Views/AlbumsView.vala"
	medias_to_update = _tmp0_;
#line 185 "../src/Views/AlbumsView.vala"
	_tmp1_ = medias_to_update;
#line 185 "../src/Views/AlbumsView.vala"
	gee_collection_add_all ((GeeCollection*) _tmp1_, media);
#line 186 "../src/Views/AlbumsView.vala"
	_tmp2_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 186 "../src/Views/AlbumsView.vala"
	medias_to_add = _tmp2_;
#line 187 "../src/Views/AlbumsView.vala"
	_tmp3_ = gee_tree_set_new (MUSIC_TYPE_ALBUM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 187 "../src/Views/AlbumsView.vala"
	albums_to_remove = _tmp3_;
#line 968 "AlbumsView.c"
	{
		GeeIterator* _m_it = NULL;
		GeeTreeSet* _tmp4_;
		GeeIterator* _tmp5_;
#line 188 "../src/Views/AlbumsView.vala"
		_tmp4_ = medias_to_update;
#line 188 "../src/Views/AlbumsView.vala"
		_tmp5_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp4_);
#line 188 "../src/Views/AlbumsView.vala"
		_m_it = _tmp5_;
#line 188 "../src/Views/AlbumsView.vala"
		while (TRUE) {
#line 981 "AlbumsView.c"
			GeeIterator* _tmp6_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			MusicMedia* _tmp9_;
			MusicAlbum* album = NULL;
			MusicMedia* _tmp10_;
			MusicAlbum* _tmp11_;
			MusicAlbum* _tmp12_;
			MusicAlbum* _tmp13_;
			MusicAlbum* _tmp14_;
			MusicAlbum* _tmp15_;
			MusicMedia* _tmp16_;
#line 188 "../src/Views/AlbumsView.vala"
			_tmp6_ = _m_it;
#line 188 "../src/Views/AlbumsView.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 188 "../src/Views/AlbumsView.vala"
				break;
#line 1001 "AlbumsView.c"
			}
#line 188 "../src/Views/AlbumsView.vala"
			_tmp7_ = _m_it;
#line 188 "../src/Views/AlbumsView.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 188 "../src/Views/AlbumsView.vala"
			m = (MusicMedia*) _tmp8_;
#line 189 "../src/Views/AlbumsView.vala"
			_tmp9_ = m;
#line 189 "../src/Views/AlbumsView.vala"
			if (_tmp9_ == NULL) {
#line 190 "../src/Views/AlbumsView.vala"
				_g_object_unref0 (m);
#line 190 "../src/Views/AlbumsView.vala"
				continue;
#line 1017 "AlbumsView.c"
			}
#line 192 "../src/Views/AlbumsView.vala"
			_tmp10_ = m;
#line 192 "../src/Views/AlbumsView.vala"
			_tmp11_ = music_media_get_album_info (_tmp10_);
#line 192 "../src/Views/AlbumsView.vala"
			_tmp12_ = _tmp11_;
#line 192 "../src/Views/AlbumsView.vala"
			_tmp13_ = _g_object_ref0 (_tmp12_);
#line 192 "../src/Views/AlbumsView.vala"
			album = _tmp13_;
#line 193 "../src/Views/AlbumsView.vala"
			_tmp14_ = album;
#line 193 "../src/Views/AlbumsView.vala"
			if (_tmp14_ == NULL) {
#line 194 "../src/Views/AlbumsView.vala"
				_g_object_unref0 (album);
#line 194 "../src/Views/AlbumsView.vala"
				_g_object_unref0 (m);
#line 194 "../src/Views/AlbumsView.vala"
				continue;
#line 1039 "AlbumsView.c"
			}
#line 196 "../src/Views/AlbumsView.vala"
			_tmp15_ = album;
#line 196 "../src/Views/AlbumsView.vala"
			_tmp16_ = m;
#line 196 "../src/Views/AlbumsView.vala"
			if (!music_album_is_compatible (_tmp15_, _tmp16_)) {
#line 1047 "AlbumsView.c"
				GeeTreeSet* _tmp17_;
				MusicMedia* _tmp18_;
				MusicAlbum* _tmp19_;
				MusicMedia* _tmp20_;
				MusicAlbum* _tmp21_;
				gboolean _tmp22_;
				gboolean _tmp23_;
#line 197 "../src/Views/AlbumsView.vala"
				_tmp17_ = medias_to_add;
#line 197 "../src/Views/AlbumsView.vala"
				_tmp18_ = m;
#line 197 "../src/Views/AlbumsView.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp18_);
#line 198 "../src/Views/AlbumsView.vala"
				_tmp19_ = album;
#line 198 "../src/Views/AlbumsView.vala"
				_tmp20_ = m;
#line 198 "../src/Views/AlbumsView.vala"
				music_album_remove_media (_tmp19_, _tmp20_);
#line 199 "../src/Views/AlbumsView.vala"
				_tmp21_ = album;
#line 199 "../src/Views/AlbumsView.vala"
				_tmp22_ = music_album_get_is_empty (_tmp21_);
#line 199 "../src/Views/AlbumsView.vala"
				_tmp23_ = _tmp22_;
#line 199 "../src/Views/AlbumsView.vala"
				if (_tmp23_ == TRUE) {
#line 1075 "AlbumsView.c"
					MusicAlbum* _tmp24_;
					guint _tmp25_;
					MusicAlbum* _tmp26_;
					guint _tmp27_;
					GQuark _tmp28_;
					GeeTreeSet* _tmp29_;
					MusicAlbum* _tmp30_;
#line 200 "../src/Views/AlbumsView.vala"
					_tmp24_ = album;
#line 200 "../src/Views/AlbumsView.vala"
					g_signal_parse_name ("cover-rendered", MUSIC_TYPE_ALBUM, &_tmp25_, NULL, FALSE);
#line 200 "../src/Views/AlbumsView.vala"
					g_signal_handlers_disconnect_matched (_tmp24_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp25_, 0, NULL, (GCallback) _gtk_widget_queue_draw_music_album_cover_rendered, (GtkWidget*) self);
#line 201 "../src/Views/AlbumsView.vala"
					_tmp26_ = album;
#line 201 "../src/Views/AlbumsView.vala"
					g_signal_parse_name ("notify::cover-icon", G_TYPE_OBJECT, &_tmp27_, &_tmp28_, TRUE);
#line 201 "../src/Views/AlbumsView.vala"
					g_signal_handlers_disconnect_matched ((GObject*) _tmp26_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp27_, _tmp28_, NULL, (GCallback) _gtk_widget_queue_draw_g_object_notify, (GtkWidget*) self);
#line 202 "../src/Views/AlbumsView.vala"
					_tmp29_ = albums_to_remove;
#line 202 "../src/Views/AlbumsView.vala"
					_tmp30_ = album;
#line 202 "../src/Views/AlbumsView.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, _tmp30_);
#line 1101 "AlbumsView.c"
				}
			}
#line 188 "../src/Views/AlbumsView.vala"
			_g_object_unref0 (album);
#line 188 "../src/Views/AlbumsView.vala"
			_g_object_unref0 (m);
#line 1108 "AlbumsView.c"
		}
#line 188 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (_m_it);
#line 1112 "AlbumsView.c"
	}
#line 208 "../src/Views/AlbumsView.vala"
	_tmp31_ = self->priv->icon_view;
#line 208 "../src/Views/AlbumsView.vala"
	_tmp32_ = albums_to_remove;
#line 208 "../src/Views/AlbumsView.vala"
	music_fast_grid_remove_objects (_tmp31_, (GeeCollection*) _tmp32_);
#line 209 "../src/Views/AlbumsView.vala"
	_tmp33_ = medias_to_add;
#line 209 "../src/Views/AlbumsView.vala"
	music_view_interface_add_media ((MusicViewInterface*) self, (GeeCollection*) _tmp33_);
#line 210 "../src/Views/AlbumsView.vala"
	_tmp34_ = self->priv->icon_view;
#line 210 "../src/Views/AlbumsView.vala"
	_tmp34_->research_needed = TRUE;
#line 183 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (albums_to_remove);
#line 183 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (medias_to_add);
#line 183 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (medias_to_update);
#line 1134 "AlbumsView.c"
}

static void
music_albums_view_real_set_media (MusicViewInterface* base,
                                  GeeCollection* to_add)
{
	MusicAlbumsView * self;
#line 213 "../src/Views/AlbumsView.vala"
	self = (MusicAlbumsView*) base;
#line 213 "../src/Views/AlbumsView.vala"
	g_return_if_fail (to_add != NULL);
#line 214 "../src/Views/AlbumsView.vala"
	music_albums_view_clear_objects (self);
#line 215 "../src/Views/AlbumsView.vala"
	music_view_interface_add_media ((MusicViewInterface*) self, to_add);
#line 1150 "AlbumsView.c"
}

static void
music_albums_view_real_add_media (MusicViewInterface* base,
                                  GeeCollection* media)
{
	MusicAlbumsView * self;
	GeeTreeSet* medias_to_add = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	GeeTreeSet* albums_to_append = NULL;
	GeeTreeSet* _tmp2_;
	GeeCollection* albums = NULL;
	GeeCollection* _tmp3_;
	GeeTreeSet* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	MusicFastGrid* _tmp22_;
	GeeTreeSet* _tmp23_;
	MusicFastGrid* _tmp24_;
#line 219 "../src/Views/AlbumsView.vala"
	self = (MusicAlbumsView*) base;
#line 219 "../src/Views/AlbumsView.vala"
	g_return_if_fail (media != NULL);
#line 220 "../src/Views/AlbumsView.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 220 "../src/Views/AlbumsView.vala"
	medias_to_add = _tmp0_;
#line 221 "../src/Views/AlbumsView.vala"
	_tmp1_ = medias_to_add;
#line 221 "../src/Views/AlbumsView.vala"
	gee_collection_add_all ((GeeCollection*) _tmp1_, media);
#line 222 "../src/Views/AlbumsView.vala"
	_tmp2_ = gee_tree_set_new (MUSIC_TYPE_ALBUM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 222 "../src/Views/AlbumsView.vala"
	albums_to_append = _tmp2_;
#line 223 "../src/Views/AlbumsView.vala"
	_tmp3_ = music_albums_view_get_albums (self);
#line 223 "../src/Views/AlbumsView.vala"
	albums = _tmp3_;
#line 1191 "AlbumsView.c"
	{
		GeeIterator* _m_it = NULL;
		GeeTreeSet* _tmp4_;
		GeeIterator* _tmp5_;
#line 224 "../src/Views/AlbumsView.vala"
		_tmp4_ = medias_to_add;
#line 224 "../src/Views/AlbumsView.vala"
		_tmp5_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp4_);
#line 224 "../src/Views/AlbumsView.vala"
		_m_it = _tmp5_;
#line 224 "../src/Views/AlbumsView.vala"
		while (TRUE) {
#line 1204 "AlbumsView.c"
			GeeIterator* _tmp6_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			MusicAlbum* album = NULL;
			MusicMedia* _tmp9_;
			MusicAlbum* _tmp10_;
			MusicAlbum* _tmp11_;
			MusicAlbum* _tmp12_;
			GeeCollection* _tmp13_;
			MusicAlbum* _tmp14_;
#line 224 "../src/Views/AlbumsView.vala"
			_tmp6_ = _m_it;
#line 224 "../src/Views/AlbumsView.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 224 "../src/Views/AlbumsView.vala"
				break;
#line 1222 "AlbumsView.c"
			}
#line 224 "../src/Views/AlbumsView.vala"
			_tmp7_ = _m_it;
#line 224 "../src/Views/AlbumsView.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 224 "../src/Views/AlbumsView.vala"
			m = (MusicMedia*) _tmp8_;
#line 225 "../src/Views/AlbumsView.vala"
			_tmp9_ = m;
#line 225 "../src/Views/AlbumsView.vala"
			_tmp10_ = music_media_get_album_info (_tmp9_);
#line 225 "../src/Views/AlbumsView.vala"
			_tmp11_ = _tmp10_;
#line 225 "../src/Views/AlbumsView.vala"
			_tmp12_ = _g_object_ref0 (_tmp11_);
#line 225 "../src/Views/AlbumsView.vala"
			album = _tmp12_;
#line 226 "../src/Views/AlbumsView.vala"
			_tmp13_ = albums;
#line 226 "../src/Views/AlbumsView.vala"
			_tmp14_ = album;
#line 226 "../src/Views/AlbumsView.vala"
			if (!gee_collection_contains (_tmp13_, _tmp14_)) {
#line 1246 "AlbumsView.c"
				GeeTreeSet* _tmp15_;
				MusicAlbum* _tmp16_;
				MusicAlbum* _tmp17_;
				MusicAlbum* _tmp18_;
#line 227 "../src/Views/AlbumsView.vala"
				_tmp15_ = albums_to_append;
#line 227 "../src/Views/AlbumsView.vala"
				_tmp16_ = album;
#line 227 "../src/Views/AlbumsView.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 228 "../src/Views/AlbumsView.vala"
				_tmp17_ = album;
#line 228 "../src/Views/AlbumsView.vala"
				g_signal_connect_object (_tmp17_, "cover-rendered", (GCallback) _gtk_widget_queue_draw_music_album_cover_rendered, (GtkWidget*) self, 0);
#line 229 "../src/Views/AlbumsView.vala"
				_tmp18_ = album;
#line 229 "../src/Views/AlbumsView.vala"
				g_signal_connect_object ((GObject*) _tmp18_, "notify::cover-icon", (GCallback) _gtk_widget_queue_draw_g_object_notify, (GtkWidget*) self, 0);
#line 1265 "AlbumsView.c"
			}
#line 224 "../src/Views/AlbumsView.vala"
			_g_object_unref0 (album);
#line 224 "../src/Views/AlbumsView.vala"
			_g_object_unref0 (m);
#line 1271 "AlbumsView.c"
		}
#line 224 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (_m_it);
#line 1275 "AlbumsView.c"
	}
#line 233 "../src/Views/AlbumsView.vala"
	_tmp19_ = albums_to_append;
#line 233 "../src/Views/AlbumsView.vala"
	_tmp20_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp19_);
#line 233 "../src/Views/AlbumsView.vala"
	_tmp21_ = _tmp20_;
#line 233 "../src/Views/AlbumsView.vala"
	if (_tmp21_ <= 0) {
#line 234 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (albums);
#line 234 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (albums_to_append);
#line 234 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (medias_to_add);
#line 234 "../src/Views/AlbumsView.vala"
		return;
#line 1293 "AlbumsView.c"
	}
#line 237 "../src/Views/AlbumsView.vala"
	_tmp22_ = self->priv->icon_view;
#line 237 "../src/Views/AlbumsView.vala"
	_tmp23_ = albums_to_append;
#line 237 "../src/Views/AlbumsView.vala"
	music_fast_grid_add_objects (_tmp22_, (GeeCollection*) _tmp23_);
#line 238 "../src/Views/AlbumsView.vala"
	_tmp24_ = self->priv->icon_view;
#line 238 "../src/Views/AlbumsView.vala"
	_tmp24_->research_needed = TRUE;
#line 219 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (albums);
#line 219 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (albums_to_append);
#line 219 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (medias_to_add);
#line 1311 "AlbumsView.c"
}

static void
music_albums_view_real_remove_media (MusicViewInterface* base,
                                     GeeCollection* to_remove)
{
	MusicAlbumsView * self;
	GeeTreeSet* albums_to_remove = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	MusicFastGrid* _tmp26_;
	GeeTreeSet* _tmp27_;
	MusicFastGrid* _tmp28_;
#line 246 "../src/Views/AlbumsView.vala"
	self = (MusicAlbumsView*) base;
#line 246 "../src/Views/AlbumsView.vala"
	g_return_if_fail (to_remove != NULL);
#line 247 "../src/Views/AlbumsView.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_ALBUM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 247 "../src/Views/AlbumsView.vala"
	albums_to_remove = _tmp0_;
#line 1335 "AlbumsView.c"
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp1_;
#line 248 "../src/Views/AlbumsView.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) to_remove);
#line 248 "../src/Views/AlbumsView.vala"
		_m_it = _tmp1_;
#line 248 "../src/Views/AlbumsView.vala"
		while (TRUE) {
#line 1345 "AlbumsView.c"
			GeeIterator* _tmp2_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			MusicMedia* _tmp5_;
			MusicAlbum* album = NULL;
			MusicMedia* _tmp6_;
			MusicAlbum* _tmp7_;
			MusicAlbum* _tmp8_;
			MusicAlbum* _tmp9_;
			MusicAlbum* _tmp10_;
			MusicAlbum* _tmp11_;
			MusicMedia* _tmp12_;
			MusicAlbum* _tmp13_;
			gboolean _tmp14_;
			gboolean _tmp15_;
#line 248 "../src/Views/AlbumsView.vala"
			_tmp2_ = _m_it;
#line 248 "../src/Views/AlbumsView.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 248 "../src/Views/AlbumsView.vala"
				break;
#line 1368 "AlbumsView.c"
			}
#line 248 "../src/Views/AlbumsView.vala"
			_tmp3_ = _m_it;
#line 248 "../src/Views/AlbumsView.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 248 "../src/Views/AlbumsView.vala"
			m = (MusicMedia*) _tmp4_;
#line 249 "../src/Views/AlbumsView.vala"
			_tmp5_ = m;
#line 249 "../src/Views/AlbumsView.vala"
			if (_tmp5_ == NULL) {
#line 250 "../src/Views/AlbumsView.vala"
				_g_object_unref0 (m);
#line 250 "../src/Views/AlbumsView.vala"
				continue;
#line 1384 "AlbumsView.c"
			}
#line 252 "../src/Views/AlbumsView.vala"
			_tmp6_ = m;
#line 252 "../src/Views/AlbumsView.vala"
			_tmp7_ = music_media_get_album_info (_tmp6_);
#line 252 "../src/Views/AlbumsView.vala"
			_tmp8_ = _tmp7_;
#line 252 "../src/Views/AlbumsView.vala"
			_tmp9_ = _g_object_ref0 (_tmp8_);
#line 252 "../src/Views/AlbumsView.vala"
			album = _tmp9_;
#line 253 "../src/Views/AlbumsView.vala"
			_tmp10_ = album;
#line 253 "../src/Views/AlbumsView.vala"
			if (_tmp10_ == NULL) {
#line 254 "../src/Views/AlbumsView.vala"
				_g_object_unref0 (album);
#line 254 "../src/Views/AlbumsView.vala"
				_g_object_unref0 (m);
#line 254 "../src/Views/AlbumsView.vala"
				continue;
#line 1406 "AlbumsView.c"
			}
#line 256 "../src/Views/AlbumsView.vala"
			_tmp11_ = album;
#line 256 "../src/Views/AlbumsView.vala"
			_tmp12_ = m;
#line 256 "../src/Views/AlbumsView.vala"
			music_album_remove_media (_tmp11_, _tmp12_);
#line 257 "../src/Views/AlbumsView.vala"
			_tmp13_ = album;
#line 257 "../src/Views/AlbumsView.vala"
			_tmp14_ = music_album_get_is_empty (_tmp13_);
#line 257 "../src/Views/AlbumsView.vala"
			_tmp15_ = _tmp14_;
#line 257 "../src/Views/AlbumsView.vala"
			if (_tmp15_ == TRUE) {
#line 1422 "AlbumsView.c"
				MusicAlbum* _tmp16_;
				guint _tmp17_;
				MusicAlbum* _tmp18_;
				guint _tmp19_;
				GQuark _tmp20_;
				GeeTreeSet* _tmp21_;
				MusicAlbum* _tmp22_;
#line 258 "../src/Views/AlbumsView.vala"
				_tmp16_ = album;
#line 258 "../src/Views/AlbumsView.vala"
				g_signal_parse_name ("cover-rendered", MUSIC_TYPE_ALBUM, &_tmp17_, NULL, FALSE);
#line 258 "../src/Views/AlbumsView.vala"
				g_signal_handlers_disconnect_matched (_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _gtk_widget_queue_draw_music_album_cover_rendered, (GtkWidget*) self);
#line 259 "../src/Views/AlbumsView.vala"
				_tmp18_ = album;
#line 259 "../src/Views/AlbumsView.vala"
				g_signal_parse_name ("notify::cover-icon", G_TYPE_OBJECT, &_tmp19_, &_tmp20_, TRUE);
#line 259 "../src/Views/AlbumsView.vala"
				g_signal_handlers_disconnect_matched ((GObject*) _tmp18_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, _tmp20_, NULL, (GCallback) _gtk_widget_queue_draw_g_object_notify, (GtkWidget*) self);
#line 260 "../src/Views/AlbumsView.vala"
				_tmp21_ = albums_to_remove;
#line 260 "../src/Views/AlbumsView.vala"
				_tmp22_ = album;
#line 260 "../src/Views/AlbumsView.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, _tmp22_);
#line 1448 "AlbumsView.c"
			}
#line 248 "../src/Views/AlbumsView.vala"
			_g_object_unref0 (album);
#line 248 "../src/Views/AlbumsView.vala"
			_g_object_unref0 (m);
#line 1454 "AlbumsView.c"
		}
#line 248 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (_m_it);
#line 1458 "AlbumsView.c"
	}
#line 264 "../src/Views/AlbumsView.vala"
	_tmp23_ = albums_to_remove;
#line 264 "../src/Views/AlbumsView.vala"
	_tmp24_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp23_);
#line 264 "../src/Views/AlbumsView.vala"
	_tmp25_ = _tmp24_;
#line 264 "../src/Views/AlbumsView.vala"
	if (_tmp25_ <= 0) {
#line 265 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (albums_to_remove);
#line 265 "../src/Views/AlbumsView.vala"
		return;
#line 1472 "AlbumsView.c"
	}
#line 267 "../src/Views/AlbumsView.vala"
	_tmp26_ = self->priv->icon_view;
#line 267 "../src/Views/AlbumsView.vala"
	_tmp27_ = albums_to_remove;
#line 267 "../src/Views/AlbumsView.vala"
	music_fast_grid_remove_objects (_tmp26_, (GeeCollection*) _tmp27_);
#line 268 "../src/Views/AlbumsView.vala"
	_tmp28_ = self->priv->icon_view;
#line 268 "../src/Views/AlbumsView.vala"
	_tmp28_->research_needed = TRUE;
#line 246 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (albums_to_remove);
#line 1486 "AlbumsView.c"
}

void
music_albums_view_item_activated (MusicAlbumsView* self,
                                  GObject* object)
{
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	MusicAlbum* album = NULL;
	MusicAlbum* _tmp6_;
	MusicAlbum* _tmp7_;
	MusicAlbumListGrid* _tmp8_;
	MusicAlbumListGrid* _tmp9_;
	MusicViewWrapper* _tmp10_;
	MusicAlbumListGrid* _tmp11_;
	MusicAlbumListGrid* _tmp12_;
	MusicAlbum* _tmp13_;
	MusicAlbumListGrid* _tmp14_;
	MusicAlbumListGrid* _tmp15_;
#line 271 "../src/Views/AlbumsView.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/Views/AlbumsView.vala"
	_tmp0_ = music_app_get_main_window ();
#line 272 "../src/Views/AlbumsView.vala"
	_tmp1_ = _tmp0_;
#line 272 "../src/Views/AlbumsView.vala"
	_tmp2_ = music_library_window_get_initialization_finished (_tmp1_);
#line 272 "../src/Views/AlbumsView.vala"
	_tmp3_ = _tmp2_;
#line 272 "../src/Views/AlbumsView.vala"
	if (!_tmp3_) {
#line 273 "../src/Views/AlbumsView.vala"
		return;
#line 1522 "AlbumsView.c"
	}
#line 275 "../src/Views/AlbumsView.vala"
	if (object == NULL) {
#line 1526 "AlbumsView.c"
		MusicAlbumListGrid* _tmp4_;
		MusicAlbumListGrid* _tmp5_;
#line 276 "../src/Views/AlbumsView.vala"
		_tmp4_ = music_albums_view_get_popup_list_view (self);
#line 276 "../src/Views/AlbumsView.vala"
		_tmp5_ = _tmp4_;
#line 276 "../src/Views/AlbumsView.vala"
		gtk_widget_hide ((GtkWidget*) _tmp5_);
#line 277 "../src/Views/AlbumsView.vala"
		return;
#line 1537 "AlbumsView.c"
	}
#line 280 "../src/Views/AlbumsView.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, MUSIC_TYPE_ALBUM) ? ((MusicAlbum*) object) : NULL);
#line 280 "../src/Views/AlbumsView.vala"
	album = _tmp6_;
#line 281 "../src/Views/AlbumsView.vala"
	_tmp7_ = album;
#line 281 "../src/Views/AlbumsView.vala"
	g_return_if_fail (_tmp7_ != NULL);
#line 283 "../src/Views/AlbumsView.vala"
	_tmp8_ = music_albums_view_get_popup_list_view (self);
#line 283 "../src/Views/AlbumsView.vala"
	_tmp9_ = _tmp8_;
#line 283 "../src/Views/AlbumsView.vala"
	_tmp10_ = self->priv->_parent_view_wrapper;
#line 283 "../src/Views/AlbumsView.vala"
	music_album_list_grid_set_view_wrapper (_tmp9_, _tmp10_);
#line 284 "../src/Views/AlbumsView.vala"
	_tmp11_ = music_albums_view_get_popup_list_view (self);
#line 284 "../src/Views/AlbumsView.vala"
	_tmp12_ = _tmp11_;
#line 284 "../src/Views/AlbumsView.vala"
	_tmp13_ = album;
#line 284 "../src/Views/AlbumsView.vala"
	music_album_list_grid_set_album (_tmp12_, _tmp13_);
#line 285 "../src/Views/AlbumsView.vala"
	_tmp14_ = music_albums_view_get_popup_list_view (self);
#line 285 "../src/Views/AlbumsView.vala"
	_tmp15_ = _tmp14_;
#line 285 "../src/Views/AlbumsView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp15_);
#line 271 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (album);
#line 1571 "AlbumsView.c"
}

gint
music_albums_view_compare_func (MusicAlbumsView* self,
                                GObject* o_a,
                                GObject* o_b)
{
	MusicAlbum* album_a = NULL;
	MusicAlbum* _tmp0_;
	MusicAlbum* album_b = NULL;
	MusicAlbum* _tmp1_;
	MusicAlbum* _tmp2_;
	MusicAlbum* _tmp5_;
	gint order = 0;
	MusicAlbum* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	MusicAlbum* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gint _tmp12_;
	gint result;
#line 288 "../src/Views/AlbumsView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 288 "../src/Views/AlbumsView.vala"
	g_return_val_if_fail (o_a != NULL, 0);
#line 288 "../src/Views/AlbumsView.vala"
	g_return_val_if_fail (o_b != NULL, 0);
#line 289 "../src/Views/AlbumsView.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (o_a, MUSIC_TYPE_ALBUM) ? ((MusicAlbum*) o_a) : NULL);
#line 289 "../src/Views/AlbumsView.vala"
	album_a = _tmp0_;
#line 290 "../src/Views/AlbumsView.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (o_b, MUSIC_TYPE_ALBUM) ? ((MusicAlbum*) o_b) : NULL);
#line 290 "../src/Views/AlbumsView.vala"
	album_b = _tmp1_;
#line 293 "../src/Views/AlbumsView.vala"
	_tmp2_ = album_a;
#line 293 "../src/Views/AlbumsView.vala"
	if (_tmp2_ == NULL) {
#line 1612 "AlbumsView.c"
		gint _tmp3_ = 0;
		MusicAlbum* _tmp4_;
#line 294 "../src/Views/AlbumsView.vala"
		_tmp4_ = album_b;
#line 294 "../src/Views/AlbumsView.vala"
		if (_tmp4_ != NULL) {
#line 294 "../src/Views/AlbumsView.vala"
			_tmp3_ = -1;
#line 1621 "AlbumsView.c"
		} else {
#line 294 "../src/Views/AlbumsView.vala"
			_tmp3_ = 0;
#line 1625 "AlbumsView.c"
		}
#line 294 "../src/Views/AlbumsView.vala"
		result = _tmp3_;
#line 294 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (album_b);
#line 294 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (album_a);
#line 294 "../src/Views/AlbumsView.vala"
		return result;
#line 1635 "AlbumsView.c"
	}
#line 296 "../src/Views/AlbumsView.vala"
	_tmp5_ = album_b;
#line 296 "../src/Views/AlbumsView.vala"
	if (_tmp5_ == NULL) {
#line 297 "../src/Views/AlbumsView.vala"
		result = 1;
#line 297 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (album_b);
#line 297 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (album_a);
#line 297 "../src/Views/AlbumsView.vala"
		return result;
#line 1649 "AlbumsView.c"
	}
#line 299 "../src/Views/AlbumsView.vala"
	_tmp6_ = album_a;
#line 299 "../src/Views/AlbumsView.vala"
	_tmp7_ = music_album_get_display_artist (_tmp6_);
#line 299 "../src/Views/AlbumsView.vala"
	_tmp8_ = _tmp7_;
#line 299 "../src/Views/AlbumsView.vala"
	_tmp9_ = album_b;
#line 299 "../src/Views/AlbumsView.vala"
	_tmp10_ = music_album_get_display_artist (_tmp9_);
#line 299 "../src/Views/AlbumsView.vala"
	_tmp11_ = _tmp10_;
#line 299 "../src/Views/AlbumsView.vala"
	_tmp12_ = music_string_compare (_tmp8_, _tmp11_);
#line 299 "../src/Views/AlbumsView.vala"
	_g_free0 (_tmp11_);
#line 299 "../src/Views/AlbumsView.vala"
	_g_free0 (_tmp8_);
#line 299 "../src/Views/AlbumsView.vala"
	order = _tmp12_;
#line 301 "../src/Views/AlbumsView.vala"
	if (order == 0) {
#line 1673 "AlbumsView.c"
		MusicAlbum* _tmp13_;
		guint _tmp14_;
		guint _tmp15_;
		MusicAlbum* _tmp16_;
		guint _tmp17_;
		guint _tmp18_;
#line 302 "../src/Views/AlbumsView.vala"
		_tmp13_ = album_a;
#line 302 "../src/Views/AlbumsView.vala"
		_tmp14_ = music_album_get_year (_tmp13_);
#line 302 "../src/Views/AlbumsView.vala"
		_tmp15_ = _tmp14_;
#line 302 "../src/Views/AlbumsView.vala"
		_tmp16_ = album_b;
#line 302 "../src/Views/AlbumsView.vala"
		_tmp17_ = music_album_get_year (_tmp16_);
#line 302 "../src/Views/AlbumsView.vala"
		_tmp18_ = _tmp17_;
#line 302 "../src/Views/AlbumsView.vala"
		order = music_compare_standard_unsigned (_tmp15_, _tmp18_);
#line 1694 "AlbumsView.c"
	}
#line 304 "../src/Views/AlbumsView.vala"
	if (order == 0) {
#line 1698 "AlbumsView.c"
		MusicAlbum* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		MusicAlbum* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
#line 305 "../src/Views/AlbumsView.vala"
		_tmp19_ = album_a;
#line 305 "../src/Views/AlbumsView.vala"
		_tmp20_ = music_album_get_display_name (_tmp19_);
#line 305 "../src/Views/AlbumsView.vala"
		_tmp21_ = _tmp20_;
#line 305 "../src/Views/AlbumsView.vala"
		_tmp22_ = album_b;
#line 305 "../src/Views/AlbumsView.vala"
		_tmp23_ = music_album_get_display_name (_tmp22_);
#line 305 "../src/Views/AlbumsView.vala"
		_tmp24_ = _tmp23_;
#line 305 "../src/Views/AlbumsView.vala"
		order = music_string_compare (_tmp21_, _tmp24_);
#line 305 "../src/Views/AlbumsView.vala"
		_g_free0 (_tmp24_);
#line 305 "../src/Views/AlbumsView.vala"
		_g_free0 (_tmp21_);
#line 1723 "AlbumsView.c"
	}
#line 307 "../src/Views/AlbumsView.vala"
	result = order;
#line 307 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (album_b);
#line 307 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (album_a);
#line 307 "../src/Views/AlbumsView.vala"
	return result;
#line 1733 "AlbumsView.c"
}

static gint
__lambda55_ (MusicAlbumsView* self,
             MusicAlbum* a,
             MusicAlbum* b)
{
	gint order = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	guint _tmp9_;
	guint _tmp10_;
	guint _tmp11_;
	guint _tmp12_;
	gint result;
#line 312 "../src/Views/AlbumsView.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 312 "../src/Views/AlbumsView.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 313 "../src/Views/AlbumsView.vala"
	_tmp0_ = music_album_get_display_name (a);
#line 313 "../src/Views/AlbumsView.vala"
	_tmp1_ = _tmp0_;
#line 313 "../src/Views/AlbumsView.vala"
	_tmp2_ = music_album_get_display_name (b);
#line 313 "../src/Views/AlbumsView.vala"
	_tmp3_ = _tmp2_;
#line 313 "../src/Views/AlbumsView.vala"
	_tmp4_ = music_string_compare (_tmp1_, _tmp3_);
#line 313 "../src/Views/AlbumsView.vala"
	_g_free0 (_tmp3_);
#line 313 "../src/Views/AlbumsView.vala"
	_g_free0 (_tmp1_);
#line 313 "../src/Views/AlbumsView.vala"
	order = _tmp4_;
#line 314 "../src/Views/AlbumsView.vala"
	if (order != 0) {
#line 315 "../src/Views/AlbumsView.vala"
		result = order;
#line 315 "../src/Views/AlbumsView.vala"
		return result;
#line 1782 "AlbumsView.c"
	}
#line 318 "../src/Views/AlbumsView.vala"
	_tmp5_ = music_album_get_display_artist (a);
#line 318 "../src/Views/AlbumsView.vala"
	_tmp6_ = _tmp5_;
#line 318 "../src/Views/AlbumsView.vala"
	_tmp7_ = music_album_get_display_artist (b);
#line 318 "../src/Views/AlbumsView.vala"
	_tmp8_ = _tmp7_;
#line 318 "../src/Views/AlbumsView.vala"
	order = music_string_compare (_tmp6_, _tmp8_);
#line 318 "../src/Views/AlbumsView.vala"
	_g_free0 (_tmp8_);
#line 318 "../src/Views/AlbumsView.vala"
	_g_free0 (_tmp6_);
#line 319 "../src/Views/AlbumsView.vala"
	if (order != 0) {
#line 320 "../src/Views/AlbumsView.vala"
		result = order;
#line 320 "../src/Views/AlbumsView.vala"
		return result;
#line 1804 "AlbumsView.c"
	}
#line 323 "../src/Views/AlbumsView.vala"
	_tmp9_ = music_album_get_year (a);
#line 323 "../src/Views/AlbumsView.vala"
	_tmp10_ = _tmp9_;
#line 323 "../src/Views/AlbumsView.vala"
	_tmp11_ = music_album_get_year (b);
#line 323 "../src/Views/AlbumsView.vala"
	_tmp12_ = _tmp11_;
#line 323 "../src/Views/AlbumsView.vala"
	result = ((gint) _tmp10_) - ((gint) _tmp12_);
#line 323 "../src/Views/AlbumsView.vala"
	return result;
#line 1818 "AlbumsView.c"
}

static gint
___lambda55__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda55_ ((MusicAlbumsView*) self, (MusicAlbum*) a, (MusicAlbum*) b);
#line 312 "../src/Views/AlbumsView.vala"
	return result;
#line 1830 "AlbumsView.c"
}

void
music_albums_view_search_func (MusicAlbumsView* self,
                               GeeHashMap* showing)
{
	GeeCollection* _result_ = NULL;
	MusicViewWrapper* _tmp0_;
	MusicLibrary* _tmp1_;
	MusicLibrary* _tmp2_;
	GeeCollection* _tmp3_;
	GeeTreeSet* albums = NULL;
	GeeTreeSet* _tmp4_;
	gint _tmp22_;
	gint _tmp23_;
#line 310 "../src/Views/AlbumsView.vala"
	g_return_if_fail (self != NULL);
#line 310 "../src/Views/AlbumsView.vala"
	g_return_if_fail (showing != NULL);
#line 311 "../src/Views/AlbumsView.vala"
	_tmp0_ = self->priv->_parent_view_wrapper;
#line 311 "../src/Views/AlbumsView.vala"
	_tmp1_ = music_view_wrapper_get_library (_tmp0_);
#line 311 "../src/Views/AlbumsView.vala"
	_tmp2_ = _tmp1_;
#line 311 "../src/Views/AlbumsView.vala"
	_tmp3_ = music_library_get_search_result (_tmp2_);
#line 311 "../src/Views/AlbumsView.vala"
	_result_ = _tmp3_;
#line 312 "../src/Views/AlbumsView.vala"
	_tmp4_ = gee_tree_set_new (MUSIC_TYPE_ALBUM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, ___lambda55__gcompare_data_func, g_object_ref (self), g_object_unref);
#line 312 "../src/Views/AlbumsView.vala"
	albums = _tmp4_;
#line 1864 "AlbumsView.c"
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp5_;
		GeeIterator* _tmp6_;
#line 325 "../src/Views/AlbumsView.vala"
		_tmp5_ = _result_;
#line 325 "../src/Views/AlbumsView.vala"
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 325 "../src/Views/AlbumsView.vala"
		_m_it = _tmp6_;
#line 325 "../src/Views/AlbumsView.vala"
		while (TRUE) {
#line 1877 "AlbumsView.c"
			GeeIterator* _tmp7_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GeeTreeSet* _tmp10_;
			MusicMedia* _tmp11_;
			MusicAlbum* _tmp12_;
			MusicAlbum* _tmp13_;
#line 325 "../src/Views/AlbumsView.vala"
			_tmp7_ = _m_it;
#line 325 "../src/Views/AlbumsView.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 325 "../src/Views/AlbumsView.vala"
				break;
#line 1892 "AlbumsView.c"
			}
#line 325 "../src/Views/AlbumsView.vala"
			_tmp8_ = _m_it;
#line 325 "../src/Views/AlbumsView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 325 "../src/Views/AlbumsView.vala"
			m = (MusicMedia*) _tmp9_;
#line 326 "../src/Views/AlbumsView.vala"
			_tmp10_ = albums;
#line 326 "../src/Views/AlbumsView.vala"
			_tmp11_ = m;
#line 326 "../src/Views/AlbumsView.vala"
			_tmp12_ = music_media_get_album_info (_tmp11_);
#line 326 "../src/Views/AlbumsView.vala"
			_tmp13_ = _tmp12_;
#line 326 "../src/Views/AlbumsView.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp13_);
#line 325 "../src/Views/AlbumsView.vala"
			_g_object_unref0 (m);
#line 1912 "AlbumsView.c"
		}
#line 325 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (_m_it);
#line 1916 "AlbumsView.c"
	}
	{
		GeeIterator* _album_it = NULL;
		GeeTreeSet* _tmp14_;
		GeeIterator* _tmp15_;
#line 329 "../src/Views/AlbumsView.vala"
		_tmp14_ = albums;
#line 329 "../src/Views/AlbumsView.vala"
		_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp14_);
#line 329 "../src/Views/AlbumsView.vala"
		_album_it = _tmp15_;
#line 329 "../src/Views/AlbumsView.vala"
		while (TRUE) {
#line 1930 "AlbumsView.c"
			GeeIterator* _tmp16_;
			MusicAlbum* album = NULL;
			GeeIterator* _tmp17_;
			gpointer _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			MusicAlbum* _tmp21_;
#line 329 "../src/Views/AlbumsView.vala"
			_tmp16_ = _album_it;
#line 329 "../src/Views/AlbumsView.vala"
			if (!gee_iterator_next (_tmp16_)) {
#line 329 "../src/Views/AlbumsView.vala"
				break;
#line 1944 "AlbumsView.c"
			}
#line 329 "../src/Views/AlbumsView.vala"
			_tmp17_ = _album_it;
#line 329 "../src/Views/AlbumsView.vala"
			_tmp18_ = gee_iterator_get (_tmp17_);
#line 329 "../src/Views/AlbumsView.vala"
			album = (MusicAlbum*) _tmp18_;
#line 330 "../src/Views/AlbumsView.vala"
			_tmp19_ = gee_abstract_map_get_size ((GeeAbstractMap*) showing);
#line 330 "../src/Views/AlbumsView.vala"
			_tmp20_ = _tmp19_;
#line 330 "../src/Views/AlbumsView.vala"
			_tmp21_ = album;
#line 330 "../src/Views/AlbumsView.vala"
			gee_abstract_map_set ((GeeAbstractMap*) showing, (gpointer) ((gintptr) _tmp20_), (GObject*) _tmp21_);
#line 329 "../src/Views/AlbumsView.vala"
			_g_object_unref0 (album);
#line 1962 "AlbumsView.c"
		}
#line 329 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (_album_it);
#line 1966 "AlbumsView.c"
	}
#line 334 "../src/Views/AlbumsView.vala"
	_tmp22_ = gee_abstract_map_get_size ((GeeAbstractMap*) showing);
#line 334 "../src/Views/AlbumsView.vala"
	_tmp23_ = _tmp22_;
#line 334 "../src/Views/AlbumsView.vala"
	if (_tmp23_ < 1) {
#line 1974 "AlbumsView.c"
		MusicLibraryWindow* _tmp24_;
		MusicLibraryWindow* _tmp25_;
		MusicViewStack* _tmp26_;
		MusicViewStack* _tmp27_;
#line 335 "../src/Views/AlbumsView.vala"
		_tmp24_ = music_app_get_main_window ();
#line 335 "../src/Views/AlbumsView.vala"
		_tmp25_ = _tmp24_;
#line 335 "../src/Views/AlbumsView.vala"
		_tmp26_ = music_library_window_get_view_stack (_tmp25_);
#line 335 "../src/Views/AlbumsView.vala"
		_tmp27_ = _tmp26_;
#line 335 "../src/Views/AlbumsView.vala"
		music_view_stack_show_alert (_tmp27_);
#line 1989 "AlbumsView.c"
	}
#line 310 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (albums);
#line 310 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (_result_);
#line 1995 "AlbumsView.c"
}

GeeCollection*
music_albums_view_get_selected_media (MusicAlbumsView* self,
                                      GObject* obj)
{
	MusicAlbum* album = NULL;
	MusicAlbum* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result;
#line 339 "../src/Views/AlbumsView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 339 "../src/Views/AlbumsView.vala"
	g_return_val_if_fail (obj != NULL, NULL);
#line 340 "../src/Views/AlbumsView.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (obj, MUSIC_TYPE_ALBUM) ? ((MusicAlbum*) obj) : NULL);
#line 340 "../src/Views/AlbumsView.vala"
	album = _tmp0_;
#line 341 "../src/Views/AlbumsView.vala"
	g_return_val_if_fail (album != NULL, NULL);
#line 343 "../src/Views/AlbumsView.vala"
	_tmp1_ = music_album_get_media (album, (guint) 1);
#line 343 "../src/Views/AlbumsView.vala"
	result = _tmp1_;
#line 343 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (album);
#line 343 "../src/Views/AlbumsView.vala"
	return result;
#line 2024 "AlbumsView.c"
}

static MusicAlbumListGrid*
music_albums_view_get_popup_list_view (MusicAlbumsView* self)
{
	MusicAlbumListGrid* result;
	MusicAlbumListGrid* _tmp0_;
	MusicAlbumListGrid* _tmp4_;
#line 35 "../src/Views/AlbumsView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../src/Views/AlbumsView.vala"
	_tmp0_ = music_albums_view__popup;
#line 36 "../src/Views/AlbumsView.vala"
	if (_tmp0_ == NULL) {
#line 2039 "AlbumsView.c"
		MusicViewWrapper* _tmp1_;
		MusicAlbumListGrid* _tmp2_;
		MusicAlbumListGrid* _tmp3_;
#line 37 "../src/Views/AlbumsView.vala"
		_tmp1_ = self->priv->_parent_view_wrapper;
#line 37 "../src/Views/AlbumsView.vala"
		_tmp2_ = music_album_list_grid_new (_tmp1_);
#line 37 "../src/Views/AlbumsView.vala"
		g_object_ref_sink (_tmp2_);
#line 37 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (music_albums_view__popup);
#line 37 "../src/Views/AlbumsView.vala"
		music_albums_view__popup = _tmp2_;
#line 38 "../src/Views/AlbumsView.vala"
		_tmp3_ = music_albums_view__popup;
#line 38 "../src/Views/AlbumsView.vala"
		gtk_paned_pack2 ((GtkPaned*) self, (GtkWidget*) _tmp3_, FALSE, FALSE);
#line 2057 "AlbumsView.c"
	}
#line 41 "../src/Views/AlbumsView.vala"
	_tmp4_ = music_albums_view__popup;
#line 41 "../src/Views/AlbumsView.vala"
	result = _tmp4_;
#line 41 "../src/Views/AlbumsView.vala"
	return result;
#line 2065 "AlbumsView.c"
}

MusicViewWrapper*
music_albums_view_get_parent_view_wrapper (MusicAlbumsView* self)
{
	MusicViewWrapper* result;
	MusicViewWrapper* _tmp0_;
#line 45 "../src/Views/AlbumsView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/Views/AlbumsView.vala"
	_tmp0_ = self->priv->_parent_view_wrapper;
#line 45 "../src/Views/AlbumsView.vala"
	result = _tmp0_;
#line 45 "../src/Views/AlbumsView.vala"
	return result;
#line 2081 "AlbumsView.c"
}

static void
music_albums_view_set_parent_view_wrapper (MusicAlbumsView* self,
                                           MusicViewWrapper* value)
{
	MusicViewWrapper* old_value;
#line 45 "../src/Views/AlbumsView.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/Views/AlbumsView.vala"
	old_value = music_albums_view_get_parent_view_wrapper (self);
#line 45 "../src/Views/AlbumsView.vala"
	if (old_value != value) {
#line 2095 "AlbumsView.c"
		MusicViewWrapper* _tmp0_;
#line 45 "../src/Views/AlbumsView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 45 "../src/Views/AlbumsView.vala"
		_g_object_unref0 (self->priv->_parent_view_wrapper);
#line 45 "../src/Views/AlbumsView.vala"
		self->priv->_parent_view_wrapper = _tmp0_;
#line 45 "../src/Views/AlbumsView.vala"
		g_object_notify_by_pspec ((GObject *) self, music_albums_view_properties[MUSIC_ALBUMS_VIEW_PARENT_VIEW_WRAPPER_PROPERTY]);
#line 2105 "AlbumsView.c"
	}
}

static gint
_music_albums_view_compare_func_music_fast_grid_sort_compare_func (GObject* a,
                                                                   GObject* b,
                                                                   gpointer self)
{
	gint result;
	result = music_albums_view_compare_func ((MusicAlbumsView*) self, a, b);
#line 53 "../src/Views/AlbumsView.vala"
	return result;
#line 2118 "AlbumsView.c"
}

static void
_music_albums_view_search_func_music_fast_grid_view_search_func (GeeHashMap* showing,
                                                                 gpointer self)
{
#line 54 "../src/Views/AlbumsView.vala"
	music_albums_view_search_func ((MusicAlbumsView*) self, showing);
#line 2127 "AlbumsView.c"
}

static void
_music_albums_view_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                        GdkDragContext* context,
                                                        gpointer self)
{
#line 56 "../src/Views/AlbumsView.vala"
	music_albums_view_on_drag_begin ((MusicAlbumsView*) self, _sender, context);
#line 2137 "AlbumsView.c"
}

static void
_music_albums_view_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                              GdkDragContext* context,
                                                              GtkSelectionData* selection_data,
                                                              guint info,
                                                              guint time_,
                                                              gpointer self)
{
#line 57 "../src/Views/AlbumsView.vala"
	music_albums_view_on_drag_data_get ((MusicAlbumsView*) self, context, selection_data, info, time_);
#line 2150 "AlbumsView.c"
}

static void
_music_albums_view_on_item_activated_gtk_icon_view_item_activated (GtkIconView* _sender,
                                                                   GtkTreePath* path,
                                                                   gpointer self)
{
#line 58 "../src/Views/AlbumsView.vala"
	music_albums_view_on_item_activated ((MusicAlbumsView*) self, path);
#line 2160 "AlbumsView.c"
}

static void
_music_albums_view_on_item_selected_gtk_icon_view_selection_changed (GtkIconView* _sender,
                                                                     gpointer self)
{
#line 59 "../src/Views/AlbumsView.vala"
	music_albums_view_on_item_selected ((MusicAlbumsView*) self);
#line 2169 "AlbumsView.c"
}

static void
_music_albums_view___lambda56_ (MusicAlbumsView* self)
{
#line 74 "../src/Views/AlbumsView.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 75 "../src/Views/AlbumsView.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 2179 "AlbumsView.c"
}

static void
__music_albums_view___lambda56__g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
#line 73 "../src/Views/AlbumsView.vala"
	_music_albums_view___lambda56_ ((MusicAlbumsView*) self);
#line 2189 "AlbumsView.c"
}

static void
_music_albums_view___lambda57_ (MusicAlbumsView* self)
{
	MusicFastGrid* _tmp0_;
#line 79 "../src/Views/AlbumsView.vala"
	_tmp0_ = self->priv->icon_view;
#line 79 "../src/Views/AlbumsView.vala"
	_tmp0_->research_needed = TRUE;
#line 2200 "AlbumsView.c"
}

static void
__music_albums_view___lambda57__music_library_search_finished (MusicLibrary* _sender,
                                                               gpointer self)
{
#line 78 "../src/Views/AlbumsView.vala"
	_music_albums_view___lambda57_ ((MusicAlbumsView*) self);
#line 2209 "AlbumsView.c"
}

static GObject *
music_albums_view_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicAlbumsView * self;
	MusicFastGrid* _tmp0_;
	MusicFastGrid* _tmp1_;
	MusicFastGrid* _tmp2_;
	MusicFastGrid* _tmp3_;
	MusicFastGrid* _tmp4_;
	MusicFastGrid* _tmp5_;
	MusicFastGrid* _tmp6_;
	MusicFastGrid* _tmp7_;
	GtkScrolledWindow* scroll = NULL;
	GtkScrolledWindow* _tmp8_;
	GtkScrolledWindow* _tmp9_;
	GtkScrolledWindow* _tmp10_;
	MusicFastGrid* _tmp11_;
	GtkScrolledWindow* _tmp12_;
	MusicViewWrapper* _tmp13_;
	MusicLibrary* _tmp14_;
	MusicLibrary* _tmp15_;
	GtkTargetEntry te = {0};
	GtkTargetEntry _tmp16_ = {0};
	MusicFastGrid* _tmp17_;
	GtkTargetEntry _tmp18_;
	GtkTargetEntry* _tmp19_;
	GtkTargetEntry* _tmp20_;
	gint _tmp20__length1;
#line 51 "../src/Views/AlbumsView.vala"
	parent_class = G_OBJECT_CLASS (music_albums_view_parent_class);
#line 51 "../src/Views/AlbumsView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 51 "../src/Views/AlbumsView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_ALBUMS_VIEW, MusicAlbumsView);
#line 52 "../src/Views/AlbumsView.vala"
	_tmp0_ = music_fast_grid_new ();
#line 52 "../src/Views/AlbumsView.vala"
	g_object_ref_sink (_tmp0_);
#line 52 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (self->priv->icon_view);
#line 52 "../src/Views/AlbumsView.vala"
	self->priv->icon_view = _tmp0_;
#line 53 "../src/Views/AlbumsView.vala"
	_tmp1_ = self->priv->icon_view;
#line 53 "../src/Views/AlbumsView.vala"
	_tmp1_->compare_func = _music_albums_view_compare_func_music_fast_grid_sort_compare_func;
#line 53 "../src/Views/AlbumsView.vala"
	_tmp1_->compare_func_target = self;
#line 54 "../src/Views/AlbumsView.vala"
	_tmp2_ = self->priv->icon_view;
#line 54 "../src/Views/AlbumsView.vala"
	_tmp2_->search_func = _music_albums_view_search_func_music_fast_grid_view_search_func;
#line 54 "../src/Views/AlbumsView.vala"
	_tmp2_->search_func_target = self;
#line 55 "../src/Views/AlbumsView.vala"
	_tmp3_ = self->priv->icon_view;
#line 55 "../src/Views/AlbumsView.vala"
	gtk_icon_view_set_columns ((GtkIconView*) _tmp3_, -1);
#line 56 "../src/Views/AlbumsView.vala"
	_tmp4_ = self->priv->icon_view;
#line 56 "../src/Views/AlbumsView.vala"
	g_signal_connect_object ((GtkWidget*) _tmp4_, "drag-begin", (GCallback) _music_albums_view_on_drag_begin_gtk_widget_drag_begin, self, G_CONNECT_AFTER);
#line 57 "../src/Views/AlbumsView.vala"
	_tmp5_ = self->priv->icon_view;
#line 57 "../src/Views/AlbumsView.vala"
	g_signal_connect_object ((GtkWidget*) _tmp5_, "drag-data-get", (GCallback) _music_albums_view_on_drag_data_get_gtk_widget_drag_data_get, self, 0);
#line 58 "../src/Views/AlbumsView.vala"
	_tmp6_ = self->priv->icon_view;
#line 58 "../src/Views/AlbumsView.vala"
	g_signal_connect_object ((GtkIconView*) _tmp6_, "item-activated", (GCallback) _music_albums_view_on_item_activated_gtk_icon_view_item_activated, self, 0);
#line 59 "../src/Views/AlbumsView.vala"
	_tmp7_ = self->priv->icon_view;
#line 59 "../src/Views/AlbumsView.vala"
	g_signal_connect_object ((GtkIconView*) _tmp7_, "selection-changed", (GCallback) _music_albums_view_on_item_selected_gtk_icon_view_selection_changed, self, 0);
#line 61 "../src/Views/AlbumsView.vala"
	_tmp8_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 61 "../src/Views/AlbumsView.vala"
	g_object_ref_sink (_tmp8_);
#line 61 "../src/Views/AlbumsView.vala"
	scroll = _tmp8_;
#line 62 "../src/Views/AlbumsView.vala"
	_tmp9_ = scroll;
#line 62 "../src/Views/AlbumsView.vala"
	gtk_scrolled_window_set_policy (_tmp9_, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 63 "../src/Views/AlbumsView.vala"
	_tmp10_ = scroll;
#line 63 "../src/Views/AlbumsView.vala"
	_tmp11_ = self->priv->icon_view;
#line 63 "../src/Views/AlbumsView.vala"
	gtk_container_add ((GtkContainer*) _tmp10_, (GtkWidget*) _tmp11_);
#line 65 "../src/Views/AlbumsView.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_HORIZONTAL);
#line 66 "../src/Views/AlbumsView.vala"
	_tmp12_ = scroll;
#line 66 "../src/Views/AlbumsView.vala"
	gtk_paned_pack1 ((GtkPaned*) self, (GtkWidget*) _tmp12_, TRUE, FALSE);
#line 68 "../src/Views/AlbumsView.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 70 "../src/Views/AlbumsView.vala"
	music_albums_view_clear_objects (self);
#line 71 "../src/Views/AlbumsView.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 73 "../src/Views/AlbumsView.vala"
	g_signal_connect_object ((GObject*) self, "notify::scale-factor", (GCallback) __music_albums_view___lambda56__g_object_notify, self, 0);
#line 78 "../src/Views/AlbumsView.vala"
	_tmp13_ = self->priv->_parent_view_wrapper;
#line 78 "../src/Views/AlbumsView.vala"
	_tmp14_ = music_view_wrapper_get_library (_tmp13_);
#line 78 "../src/Views/AlbumsView.vala"
	_tmp15_ = _tmp14_;
#line 78 "../src/Views/AlbumsView.vala"
	g_signal_connect_object (_tmp15_, "search-finished", (GCallback) __music_albums_view___lambda57__music_library_search_finished, self, 0);
#line 82 "../src/Views/AlbumsView.vala"
	_tmp16_.target = "text/uri-list";
#line 82 "../src/Views/AlbumsView.vala"
	_tmp16_.flags = (guint) GTK_TARGET_SAME_APP;
#line 82 "../src/Views/AlbumsView.vala"
	_tmp16_.info = (guint) 0;
#line 82 "../src/Views/AlbumsView.vala"
	te = _tmp16_;
#line 83 "../src/Views/AlbumsView.vala"
	_tmp17_ = self->priv->icon_view;
#line 83 "../src/Views/AlbumsView.vala"
	_tmp18_ = te;
#line 83 "../src/Views/AlbumsView.vala"
	_tmp19_ = g_new0 (GtkTargetEntry, 1);
#line 83 "../src/Views/AlbumsView.vala"
	_tmp19_[0] = _tmp18_;
#line 83 "../src/Views/AlbumsView.vala"
	_tmp20_ = _tmp19_;
#line 83 "../src/Views/AlbumsView.vala"
	_tmp20__length1 = 1;
#line 83 "../src/Views/AlbumsView.vala"
	gtk_drag_source_set ((GtkWidget*) _tmp17_, GDK_BUTTON1_MASK, _tmp20_, (gint) 1, GDK_ACTION_COPY);
#line 83 "../src/Views/AlbumsView.vala"
	_tmp20_ = (g_free (_tmp20_), NULL);
#line 51 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (scroll);
#line 51 "../src/Views/AlbumsView.vala"
	return obj;
#line 2356 "AlbumsView.c"
}

static void
music_albums_view_class_init (MusicAlbumsViewClass * klass,
                              gpointer klass_data)
{
#line 30 "../src/Views/AlbumsView.vala"
	music_albums_view_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/Views/AlbumsView.vala"
	g_type_class_adjust_private_offset (klass, &MusicAlbumsView_private_offset);
#line 30 "../src/Views/AlbumsView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_albums_view_get_property;
#line 30 "../src/Views/AlbumsView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_albums_view_set_property;
#line 30 "../src/Views/AlbumsView.vala"
	G_OBJECT_CLASS (klass)->constructor = music_albums_view_constructor;
#line 30 "../src/Views/AlbumsView.vala"
	G_OBJECT_CLASS (klass)->finalize = music_albums_view_finalize;
#line 30 "../src/Views/AlbumsView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_ALBUMS_VIEW_PARENT_VIEW_WRAPPER_PROPERTY, music_albums_view_properties[MUSIC_ALBUMS_VIEW_PARENT_VIEW_WRAPPER_PROPERTY] = g_param_spec_object ("parent-view-wrapper", "parent-view-wrapper", "parent-view-wrapper", MUSIC_TYPE_VIEW_WRAPPER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2377 "AlbumsView.c"
}

static void
music_albums_view_music_view_interface_interface_init (MusicViewInterfaceIface * iface,
                                                       gpointer iface_data)
{
#line 30 "../src/Views/AlbumsView.vala"
	music_albums_view_music_view_interface_parent_iface = g_type_interface_peek_parent (iface);
#line 30 "../src/Views/AlbumsView.vala"
	iface->get_visible_media = (GeeCollection* (*) (MusicViewInterface*)) music_albums_view_real_get_visible_media;
#line 30 "../src/Views/AlbumsView.vala"
	iface->get_media = (GeeCollection* (*) (MusicViewInterface*)) music_albums_view_real_get_media;
#line 30 "../src/Views/AlbumsView.vala"
	iface->refilter = (void (*) (MusicViewInterface*)) music_albums_view_real_refilter;
#line 30 "../src/Views/AlbumsView.vala"
	iface->update_media = (void (*) (MusicViewInterface*, GeeCollection*)) music_albums_view_real_update_media;
#line 30 "../src/Views/AlbumsView.vala"
	iface->set_media = (void (*) (MusicViewInterface*, GeeCollection*)) music_albums_view_real_set_media;
#line 30 "../src/Views/AlbumsView.vala"
	iface->add_media = (void (*) (MusicViewInterface*, GeeCollection*)) music_albums_view_real_add_media;
#line 30 "../src/Views/AlbumsView.vala"
	iface->remove_media = (void (*) (MusicViewInterface*, GeeCollection*)) music_albums_view_real_remove_media;
#line 2400 "AlbumsView.c"
}

static void
music_albums_view_instance_init (MusicAlbumsView * self,
                                 gpointer klass)
{
#line 30 "../src/Views/AlbumsView.vala"
	self->priv = music_albums_view_get_instance_private (self);
#line 2409 "AlbumsView.c"
}

static void
music_albums_view_finalize (GObject * obj)
{
	MusicAlbumsView * self;
#line 30 "../src/Views/AlbumsView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_ALBUMS_VIEW, MusicAlbumsView);
#line 31 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (self->priv->icon_view);
#line 45 "../src/Views/AlbumsView.vala"
	_g_object_unref0 (self->priv->_parent_view_wrapper);
#line 30 "../src/Views/AlbumsView.vala"
	G_OBJECT_CLASS (music_albums_view_parent_class)->finalize (obj);
#line 2424 "AlbumsView.c"
}

static GType
music_albums_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicAlbumsViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_albums_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicAlbumsView), 0, (GInstanceInitFunc) music_albums_view_instance_init, NULL };
	static const GInterfaceInfo music_view_interface_info = { (GInterfaceInitFunc) music_albums_view_music_view_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_albums_view_type_id;
	music_albums_view_type_id = g_type_register_static (gtk_paned_get_type (), "MusicAlbumsView", &g_define_type_info, 0);
	g_type_add_interface_static (music_albums_view_type_id, MUSIC_TYPE_VIEW_INTERFACE, &music_view_interface_info);
	MusicAlbumsView_private_offset = g_type_add_instance_private (music_albums_view_type_id, sizeof (MusicAlbumsViewPrivate));
	return music_albums_view_type_id;
}

GType
music_albums_view_get_type (void)
{
	static volatile gsize music_albums_view_type_id__once = 0;
	if (g_once_init_enter (&music_albums_view_type_id__once)) {
		GType music_albums_view_type_id;
		music_albums_view_type_id = music_albums_view_get_type_once ();
		g_once_init_leave (&music_albums_view_type_id__once, music_albums_view_type_id);
	}
	return music_albums_view_type_id__once;
}

static void
_vala_music_albums_view_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	MusicAlbumsView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_ALBUMS_VIEW, MusicAlbumsView);
#line 30 "../src/Views/AlbumsView.vala"
	switch (property_id) {
#line 30 "../src/Views/AlbumsView.vala"
		case MUSIC_ALBUMS_VIEW_PARENT_VIEW_WRAPPER_PROPERTY:
#line 30 "../src/Views/AlbumsView.vala"
		g_value_set_object (value, music_albums_view_get_parent_view_wrapper (self));
#line 30 "../src/Views/AlbumsView.vala"
		break;
#line 2467 "AlbumsView.c"
		default:
#line 30 "../src/Views/AlbumsView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/Views/AlbumsView.vala"
		break;
#line 2473 "AlbumsView.c"
	}
}

static void
_vala_music_albums_view_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	MusicAlbumsView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_ALBUMS_VIEW, MusicAlbumsView);
#line 30 "../src/Views/AlbumsView.vala"
	switch (property_id) {
#line 30 "../src/Views/AlbumsView.vala"
		case MUSIC_ALBUMS_VIEW_PARENT_VIEW_WRAPPER_PROPERTY:
#line 30 "../src/Views/AlbumsView.vala"
		music_albums_view_set_parent_view_wrapper (self, g_value_get_object (value));
#line 30 "../src/Views/AlbumsView.vala"
		break;
#line 2493 "AlbumsView.c"
		default:
#line 30 "../src/Views/AlbumsView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/Views/AlbumsView.vala"
		break;
#line 2499 "AlbumsView.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

