/* DeviceView.c generated by valac 0.56.0, the Vala compiler
 * generated from DeviceView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */

#include "music-lib.h"
#include "io.elementary.music-core.h"
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

enum  {
	MUSIC_DEVICE_VIEW_0_PROPERTY,
	MUSIC_DEVICE_VIEW_DEVICE_PROPERTY,
	MUSIC_DEVICE_VIEW_PREFERENCES_PROPERTY,
	MUSIC_DEVICE_VIEW_NUM_PROPERTIES
};
static GParamSpec* music_device_view_properties[MUSIC_DEVICE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block22Data Block22Data;

struct _MusicDeviceViewPrivate {
	MusicDevice* _device;
	MusicDevicePreferences* _preferences;
};

struct _Block22Data {
	int _ref_count_;
	MusicDeviceView* self;
	GtkLabel* infobar_label;
	GtkInfoBar* infobar;
	gulong connector;
};

static gint MusicDeviceView_private_offset;
static gpointer music_device_view_parent_class = NULL;

static GObject * music_device_view_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static Block22Data* block22_data_ref (Block22Data* _data22_);
static void block22_data_unref (void * _userdata_);
static void _music_device_view___lambda116_ (MusicDeviceView* self);
static void __music_device_view___lambda116__music_notification_manager_progress_canceled (MusicNotificationManager* _sender,
                                                                                    gpointer self);
static void _music_device_view___lambda117_ (Block22Data* _data22_);
static void __music_device_view___lambda117__music_device_device_unmounted (MusicDevice* _sender,
                                                                     gpointer self);
static void _music_device_view___lambda118_ (Block22Data* _data22_,
                                      const gchar* label,
                                      GtkMessageType message_type);
static void __music_device_view___lambda118__music_device_infobar_message (MusicDevice* _sender,
                                                                    const gchar* label,
                                                                    GtkMessageType message_type,
                                                                    gpointer self);
static void _music_device_view___lambda119_ (Block22Data* _data22_,
                                      GtkInfoBar* _self_,
                                      gint response);
static void __music_device_view___lambda119__gtk_info_bar_response (GtkInfoBar* _sender,
                                                             gint response_id,
                                                             gpointer self);
static void music_device_view_finalize (GObject * obj);
static GType music_device_view_get_type_once (void);
static void _vala_music_device_view_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_music_device_view_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
music_device_view_get_instance_private (MusicDeviceView* self)
{
	return G_STRUCT_MEMBER_P (self, MusicDeviceView_private_offset);
}

MusicDeviceView*
music_device_view_construct (GType object_type,
                             MusicDevice* device,
                             MusicDevicePreferences* preferences)
{
	MusicDeviceView * self = NULL;
#line 33 "../src/Views/DeviceView.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 33 "../src/Views/DeviceView.vala"
	g_return_val_if_fail (preferences != NULL, NULL);
#line 34 "../src/Views/DeviceView.vala"
	self = (MusicDeviceView*) g_object_new (object_type, "device", device, "preferences", preferences, NULL);
#line 33 "../src/Views/DeviceView.vala"
	return self;
#line 123 "DeviceView.c"
}

MusicDeviceView*
music_device_view_new (MusicDevice* device,
                       MusicDevicePreferences* preferences)
{
#line 33 "../src/Views/DeviceView.vala"
	return music_device_view_construct (MUSIC_TYPE_DEVICE_VIEW, device, preferences);
#line 132 "DeviceView.c"
}

MusicDevice*
music_device_view_get_device (MusicDeviceView* self)
{
	MusicDevice* result;
	MusicDevice* _tmp0_;
#line 30 "../src/Views/DeviceView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Views/DeviceView.vala"
	_tmp0_ = self->priv->_device;
#line 30 "../src/Views/DeviceView.vala"
	result = _tmp0_;
#line 30 "../src/Views/DeviceView.vala"
	return result;
#line 148 "DeviceView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/Views/DeviceView.vala"
	return self ? g_object_ref (self) : NULL;
#line 156 "DeviceView.c"
}

static void
music_device_view_set_device (MusicDeviceView* self,
                              MusicDevice* value)
{
	MusicDevice* old_value;
#line 30 "../src/Views/DeviceView.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Views/DeviceView.vala"
	old_value = music_device_view_get_device (self);
#line 30 "../src/Views/DeviceView.vala"
	if (old_value != value) {
#line 170 "DeviceView.c"
		MusicDevice* _tmp0_;
#line 30 "../src/Views/DeviceView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/Views/DeviceView.vala"
		_g_object_unref0 (self->priv->_device);
#line 30 "../src/Views/DeviceView.vala"
		self->priv->_device = _tmp0_;
#line 30 "../src/Views/DeviceView.vala"
		g_object_notify_by_pspec ((GObject *) self, music_device_view_properties[MUSIC_DEVICE_VIEW_DEVICE_PROPERTY]);
#line 180 "DeviceView.c"
	}
}

MusicDevicePreferences*
music_device_view_get_preferences (MusicDeviceView* self)
{
	MusicDevicePreferences* result;
	MusicDevicePreferences* _tmp0_;
#line 31 "../src/Views/DeviceView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/Views/DeviceView.vala"
	_tmp0_ = self->priv->_preferences;
#line 31 "../src/Views/DeviceView.vala"
	result = _tmp0_;
#line 31 "../src/Views/DeviceView.vala"
	return result;
#line 197 "DeviceView.c"
}

static void
music_device_view_set_preferences (MusicDeviceView* self,
                                   MusicDevicePreferences* value)
{
	MusicDevicePreferences* old_value;
#line 31 "../src/Views/DeviceView.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Views/DeviceView.vala"
	old_value = music_device_view_get_preferences (self);
#line 31 "../src/Views/DeviceView.vala"
	if (old_value != value) {
#line 211 "DeviceView.c"
		MusicDevicePreferences* _tmp0_;
#line 31 "../src/Views/DeviceView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 31 "../src/Views/DeviceView.vala"
		_g_object_unref0 (self->priv->_preferences);
#line 31 "../src/Views/DeviceView.vala"
		self->priv->_preferences = _tmp0_;
#line 31 "../src/Views/DeviceView.vala"
		g_object_notify_by_pspec ((GObject *) self, music_device_view_properties[MUSIC_DEVICE_VIEW_PREFERENCES_PROPERTY]);
#line 221 "DeviceView.c"
	}
}

static Block22Data*
block22_data_ref (Block22Data* _data22_)
{
#line 40 "../src/Views/DeviceView.vala"
	g_atomic_int_inc (&_data22_->_ref_count_);
#line 40 "../src/Views/DeviceView.vala"
	return _data22_;
#line 232 "DeviceView.c"
}

static void
block22_data_unref (void * _userdata_)
{
	Block22Data* _data22_;
	_data22_ = (Block22Data*) _userdata_;
#line 40 "../src/Views/DeviceView.vala"
	if (g_atomic_int_dec_and_test (&_data22_->_ref_count_)) {
#line 242 "DeviceView.c"
		MusicDeviceView* self;
#line 40 "../src/Views/DeviceView.vala"
		self = _data22_->self;
#line 40 "../src/Views/DeviceView.vala"
		_g_object_unref0 (_data22_->infobar);
#line 40 "../src/Views/DeviceView.vala"
		_g_object_unref0 (_data22_->infobar_label);
#line 40 "../src/Views/DeviceView.vala"
		_g_object_unref0 (self);
#line 40 "../src/Views/DeviceView.vala"
		g_slice_free (Block22Data, _data22_);
#line 254 "DeviceView.c"
	}
}

static void
_music_device_view___lambda116_ (MusicDeviceView* self)
{
	MusicDevice* _tmp0_;
	MusicLibrary* _tmp1_;
	MusicLibrary* _tmp2_;
	gboolean _tmp3_;
#line 65 "../src/Views/DeviceView.vala"
	_tmp0_ = self->priv->_device;
#line 65 "../src/Views/DeviceView.vala"
	_tmp1_ = music_device_get_library (_tmp0_);
#line 65 "../src/Views/DeviceView.vala"
	_tmp2_ = _tmp1_;
#line 65 "../src/Views/DeviceView.vala"
	_tmp3_ = music_library_doing_file_operations (_tmp2_);
#line 65 "../src/Views/DeviceView.vala"
	_g_object_unref0 (_tmp2_);
#line 65 "../src/Views/DeviceView.vala"
	if (_tmp3_) {
#line 277 "DeviceView.c"
		MusicNotificationManager* _tmp4_;
		MusicNotificationManager* _tmp5_;
#line 66 "../src/Views/DeviceView.vala"
		_tmp4_ = music_notification_manager_get_default ();
#line 66 "../src/Views/DeviceView.vala"
		_tmp5_ = _tmp4_;
#line 66 "../src/Views/DeviceView.vala"
		g_signal_emit_by_name (_tmp5_, "show-alert", _ ("Cancelling…"), _ ("Device operation has been cancelled and will stop after this media."));
#line 66 "../src/Views/DeviceView.vala"
		_g_object_unref0 (_tmp5_);
#line 288 "DeviceView.c"
	}
}

static void
__music_device_view___lambda116__music_notification_manager_progress_canceled (MusicNotificationManager* _sender,
                                                                               gpointer self)
{
#line 64 "../src/Views/DeviceView.vala"
	_music_device_view___lambda116_ ((MusicDeviceView*) self);
#line 298 "DeviceView.c"
}

static void
_music_device_view___lambda117_ (Block22Data* _data22_)
{
	MusicDeviceView* self;
	MusicDevice* _tmp0_;
#line 70 "../src/Views/DeviceView.vala"
	self = _data22_->self;
#line 71 "../src/Views/DeviceView.vala"
	g_message ("DeviceView.vala:71: device unmounted\n");
#line 72 "../src/Views/DeviceView.vala"
	_tmp0_ = self->priv->_device;
#line 72 "../src/Views/DeviceView.vala"
	g_signal_handler_disconnect ((GObject*) _tmp0_, _data22_->connector);
#line 314 "DeviceView.c"
}

static void
__music_device_view___lambda117__music_device_device_unmounted (MusicDevice* _sender,
                                                                gpointer self)
{
#line 70 "../src/Views/DeviceView.vala"
	_music_device_view___lambda117_ (self);
#line 323 "DeviceView.c"
}

static void
_music_device_view___lambda118_ (Block22Data* _data22_,
                                 const gchar* label,
                                 GtkMessageType message_type)
{
	MusicDeviceView* self;
	GtkLabel* _tmp0_;
	GtkInfoBar* _tmp1_;
	GtkInfoBar* _tmp2_;
#line 75 "../src/Views/DeviceView.vala"
	self = _data22_->self;
#line 75 "../src/Views/DeviceView.vala"
	g_return_if_fail (label != NULL);
#line 76 "../src/Views/DeviceView.vala"
	_tmp0_ = _data22_->infobar_label;
#line 76 "../src/Views/DeviceView.vala"
	gtk_label_set_label (_tmp0_, label);
#line 77 "../src/Views/DeviceView.vala"
	_tmp1_ = _data22_->infobar;
#line 77 "../src/Views/DeviceView.vala"
	gtk_info_bar_set_message_type (_tmp1_, message_type);
#line 78 "../src/Views/DeviceView.vala"
	_tmp2_ = _data22_->infobar;
#line 78 "../src/Views/DeviceView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp2_);
#line 351 "DeviceView.c"
}

static void
__music_device_view___lambda118__music_device_infobar_message (MusicDevice* _sender,
                                                               const gchar* label,
                                                               GtkMessageType message_type,
                                                               gpointer self)
{
#line 75 "../src/Views/DeviceView.vala"
	_music_device_view___lambda118_ (self, label, message_type);
#line 362 "DeviceView.c"
}

static void
_music_device_view___lambda119_ (Block22Data* _data22_,
                                 GtkInfoBar* _self_,
                                 gint response)
{
	MusicDeviceView* self;
	GtkInfoBar* _tmp0_;
#line 81 "../src/Views/DeviceView.vala"
	self = _data22_->self;
#line 81 "../src/Views/DeviceView.vala"
	g_return_if_fail (_self_ != NULL);
#line 82 "../src/Views/DeviceView.vala"
	_tmp0_ = _data22_->infobar;
#line 82 "../src/Views/DeviceView.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 380 "DeviceView.c"
}

static void
__music_device_view___lambda119__gtk_info_bar_response (GtkInfoBar* _sender,
                                                        gint response_id,
                                                        gpointer self)
{
#line 81 "../src/Views/DeviceView.vala"
	_music_device_view___lambda119_ (self, _sender, response_id);
#line 390 "DeviceView.c"
}

static GObject *
music_device_view_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicDeviceView * self;
	Block22Data* _data22_;
	GtkLabel* _tmp0_;
	GtkInfoBar* _tmp1_;
	GtkInfoBar* _tmp2_;
	GtkInfoBar* _tmp3_;
	GtkInfoBar* _tmp4_;
	GtkContainer* _tmp5_;
	GtkLabel* _tmp6_;
	MusicDeviceSummaryWidget* summary = NULL;
	MusicDevice* _tmp7_;
	MusicDevicePreferences* _tmp8_;
	MusicDeviceSummaryWidget* _tmp9_;
	GtkInfoBar* _tmp10_;
	GtkWidget* custom_view = NULL;
	MusicDevice* _tmp11_;
	GtkWidget* _tmp12_;
	GtkWidget* _tmp13_;
	GtkInfoBar* _tmp16_;
	MusicNotificationManager* _tmp17_;
	MusicNotificationManager* _tmp18_;
	gulong _tmp19_;
	gulong _tmp20_;
	MusicDevice* _tmp21_;
	MusicDevice* _tmp22_;
	GtkInfoBar* _tmp23_;
	MusicDevicePreferences* _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
#line 40 "../src/Views/DeviceView.vala"
	parent_class = G_OBJECT_CLASS (music_device_view_parent_class);
#line 40 "../src/Views/DeviceView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 40 "../src/Views/DeviceView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_DEVICE_VIEW, MusicDeviceView);
#line 40 "../src/Views/DeviceView.vala"
	_data22_ = g_slice_new0 (Block22Data);
#line 40 "../src/Views/DeviceView.vala"
	_data22_->_ref_count_ = 1;
#line 40 "../src/Views/DeviceView.vala"
	_data22_->self = g_object_ref (self);
#line 41 "../src/Views/DeviceView.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new ("");
#line 41 "../src/Views/DeviceView.vala"
	g_object_ref_sink (_tmp0_);
#line 41 "../src/Views/DeviceView.vala"
	_data22_->infobar_label = _tmp0_;
#line 43 "../src/Views/DeviceView.vala"
	_tmp1_ = (GtkInfoBar*) gtk_info_bar_new ();
#line 43 "../src/Views/DeviceView.vala"
	g_object_ref_sink (_tmp1_);
#line 43 "../src/Views/DeviceView.vala"
	_data22_->infobar = _tmp1_;
#line 44 "../src/Views/DeviceView.vala"
	_tmp2_ = _data22_->infobar;
#line 44 "../src/Views/DeviceView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp2_, TRUE);
#line 45 "../src/Views/DeviceView.vala"
	_tmp3_ = _data22_->infobar;
#line 45 "../src/Views/DeviceView.vala"
	gtk_info_bar_add_button (_tmp3_, _ ("Close"), 0);
#line 46 "../src/Views/DeviceView.vala"
	_tmp4_ = _data22_->infobar;
#line 46 "../src/Views/DeviceView.vala"
	_tmp5_ = gtk_info_bar_get_content_area (_tmp4_);
#line 46 "../src/Views/DeviceView.vala"
	_tmp6_ = _data22_->infobar_label;
#line 46 "../src/Views/DeviceView.vala"
	gtk_container_add (_tmp5_, (GtkWidget*) _tmp6_);
#line 48 "../src/Views/DeviceView.vala"
	_tmp7_ = self->priv->_device;
#line 48 "../src/Views/DeviceView.vala"
	_tmp8_ = self->priv->_preferences;
#line 48 "../src/Views/DeviceView.vala"
	_tmp9_ = music_device_summary_widget_new (_tmp7_, _tmp8_);
#line 48 "../src/Views/DeviceView.vala"
	g_object_ref_sink (_tmp9_);
#line 48 "../src/Views/DeviceView.vala"
	summary = _tmp9_;
#line 50 "../src/Views/DeviceView.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 51 "../src/Views/DeviceView.vala"
	_tmp10_ = _data22_->infobar;
#line 51 "../src/Views/DeviceView.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp10_, 0, 0, 1, 1);
#line 53 "../src/Views/DeviceView.vala"
	_tmp11_ = self->priv->_device;
#line 53 "../src/Views/DeviceView.vala"
	_tmp12_ = music_device_get_custom_view (_tmp11_);
#line 53 "../src/Views/DeviceView.vala"
	custom_view = _tmp12_;
#line 54 "../src/Views/DeviceView.vala"
	_tmp13_ = custom_view;
#line 54 "../src/Views/DeviceView.vala"
	if (_tmp13_ != NULL) {
#line 495 "DeviceView.c"
		GtkWidget* _tmp14_;
#line 55 "../src/Views/DeviceView.vala"
		_tmp14_ = custom_view;
#line 55 "../src/Views/DeviceView.vala"
		gtk_grid_attach ((GtkGrid*) self, _tmp14_, 0, 1, 1, 1);
#line 501 "DeviceView.c"
	} else {
		MusicDeviceSummaryWidget* _tmp15_;
#line 57 "../src/Views/DeviceView.vala"
		_tmp15_ = summary;
#line 57 "../src/Views/DeviceView.vala"
		gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp15_, 0, 1, 1, 1);
#line 508 "DeviceView.c"
	}
#line 60 "../src/Views/DeviceView.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 62 "../src/Views/DeviceView.vala"
	_tmp16_ = _data22_->infobar;
#line 62 "../src/Views/DeviceView.vala"
	gtk_widget_hide ((GtkWidget*) _tmp16_);
#line 64 "../src/Views/DeviceView.vala"
	_tmp17_ = music_notification_manager_get_default ();
#line 64 "../src/Views/DeviceView.vala"
	_tmp18_ = _tmp17_;
#line 64 "../src/Views/DeviceView.vala"
	_tmp19_ = g_signal_connect_object (_tmp18_, "progress-canceled", (GCallback) __music_device_view___lambda116__music_notification_manager_progress_canceled, self, 0);
#line 64 "../src/Views/DeviceView.vala"
	_tmp20_ = _tmp19_;
#line 64 "../src/Views/DeviceView.vala"
	_g_object_unref0 (_tmp18_);
#line 64 "../src/Views/DeviceView.vala"
	_data22_->connector = _tmp20_;
#line 70 "../src/Views/DeviceView.vala"
	_tmp21_ = self->priv->_device;
#line 70 "../src/Views/DeviceView.vala"
	g_signal_connect_data (_tmp21_, "device-unmounted", (GCallback) __music_device_view___lambda117__music_device_device_unmounted, block22_data_ref (_data22_), (GClosureNotify) block22_data_unref, 0);
#line 75 "../src/Views/DeviceView.vala"
	_tmp22_ = self->priv->_device;
#line 75 "../src/Views/DeviceView.vala"
	g_signal_connect_data (_tmp22_, "infobar-message", (GCallback) __music_device_view___lambda118__music_device_infobar_message, block22_data_ref (_data22_), (GClosureNotify) block22_data_unref, 0);
#line 81 "../src/Views/DeviceView.vala"
	_tmp23_ = _data22_->infobar;
#line 81 "../src/Views/DeviceView.vala"
	g_signal_connect_data (_tmp23_, "response", (GCallback) __music_device_view___lambda119__gtk_info_bar_response, block22_data_ref (_data22_), (GClosureNotify) block22_data_unref, 0);
#line 85 "../src/Views/DeviceView.vala"
	_tmp24_ = self->priv->_preferences;
#line 85 "../src/Views/DeviceView.vala"
	_tmp25_ = music_device_preferences_get_sync_when_mounted (_tmp24_);
#line 85 "../src/Views/DeviceView.vala"
	_tmp26_ = _tmp25_;
#line 85 "../src/Views/DeviceView.vala"
	if (_tmp26_) {
#line 548 "DeviceView.c"
		MusicDeviceSummaryWidget* _tmp27_;
#line 86 "../src/Views/DeviceView.vala"
		_tmp27_ = summary;
#line 86 "../src/Views/DeviceView.vala"
		music_device_summary_widget_sync_clicked (_tmp27_);
#line 554 "DeviceView.c"
	}
#line 40 "../src/Views/DeviceView.vala"
	_g_object_unref0 (custom_view);
#line 40 "../src/Views/DeviceView.vala"
	_g_object_unref0 (summary);
#line 40 "../src/Views/DeviceView.vala"
	block22_data_unref (_data22_);
#line 40 "../src/Views/DeviceView.vala"
	_data22_ = NULL;
#line 40 "../src/Views/DeviceView.vala"
	return obj;
#line 566 "DeviceView.c"
}

static void
music_device_view_class_init (MusicDeviceViewClass * klass,
                              gpointer klass_data)
{
#line 29 "../src/Views/DeviceView.vala"
	music_device_view_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Views/DeviceView.vala"
	g_type_class_adjust_private_offset (klass, &MusicDeviceView_private_offset);
#line 29 "../src/Views/DeviceView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_device_view_get_property;
#line 29 "../src/Views/DeviceView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_device_view_set_property;
#line 29 "../src/Views/DeviceView.vala"
	G_OBJECT_CLASS (klass)->constructor = music_device_view_constructor;
#line 29 "../src/Views/DeviceView.vala"
	G_OBJECT_CLASS (klass)->finalize = music_device_view_finalize;
#line 29 "../src/Views/DeviceView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_DEVICE_VIEW_DEVICE_PROPERTY, music_device_view_properties[MUSIC_DEVICE_VIEW_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", MUSIC_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 29 "../src/Views/DeviceView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_DEVICE_VIEW_PREFERENCES_PROPERTY, music_device_view_properties[MUSIC_DEVICE_VIEW_PREFERENCES_PROPERTY] = g_param_spec_object ("preferences", "preferences", "preferences", MUSIC_TYPE_DEVICE_PREFERENCES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 589 "DeviceView.c"
}

static void
music_device_view_instance_init (MusicDeviceView * self,
                                 gpointer klass)
{
#line 29 "../src/Views/DeviceView.vala"
	self->priv = music_device_view_get_instance_private (self);
#line 598 "DeviceView.c"
}

static void
music_device_view_finalize (GObject * obj)
{
	MusicDeviceView * self;
#line 29 "../src/Views/DeviceView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_DEVICE_VIEW, MusicDeviceView);
#line 30 "../src/Views/DeviceView.vala"
	_g_object_unref0 (self->priv->_device);
#line 31 "../src/Views/DeviceView.vala"
	_g_object_unref0 (self->priv->_preferences);
#line 29 "../src/Views/DeviceView.vala"
	G_OBJECT_CLASS (music_device_view_parent_class)->finalize (obj);
#line 613 "DeviceView.c"
}

static GType
music_device_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicDeviceViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_device_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicDeviceView), 0, (GInstanceInitFunc) music_device_view_instance_init, NULL };
	GType music_device_view_type_id;
	music_device_view_type_id = g_type_register_static (gtk_grid_get_type (), "MusicDeviceView", &g_define_type_info, 0);
	MusicDeviceView_private_offset = g_type_add_instance_private (music_device_view_type_id, sizeof (MusicDeviceViewPrivate));
	return music_device_view_type_id;
}

GType
music_device_view_get_type (void)
{
	static volatile gsize music_device_view_type_id__once = 0;
	if (g_once_init_enter (&music_device_view_type_id__once)) {
		GType music_device_view_type_id;
		music_device_view_type_id = music_device_view_get_type_once ();
		g_once_init_leave (&music_device_view_type_id__once, music_device_view_type_id);
	}
	return music_device_view_type_id__once;
}

static void
_vala_music_device_view_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	MusicDeviceView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_DEVICE_VIEW, MusicDeviceView);
#line 29 "../src/Views/DeviceView.vala"
	switch (property_id) {
#line 29 "../src/Views/DeviceView.vala"
		case MUSIC_DEVICE_VIEW_DEVICE_PROPERTY:
#line 29 "../src/Views/DeviceView.vala"
		g_value_set_object (value, music_device_view_get_device (self));
#line 29 "../src/Views/DeviceView.vala"
		break;
#line 29 "../src/Views/DeviceView.vala"
		case MUSIC_DEVICE_VIEW_PREFERENCES_PROPERTY:
#line 29 "../src/Views/DeviceView.vala"
		g_value_set_object (value, music_device_view_get_preferences (self));
#line 29 "../src/Views/DeviceView.vala"
		break;
#line 660 "DeviceView.c"
		default:
#line 29 "../src/Views/DeviceView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Views/DeviceView.vala"
		break;
#line 666 "DeviceView.c"
	}
}

static void
_vala_music_device_view_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	MusicDeviceView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_DEVICE_VIEW, MusicDeviceView);
#line 29 "../src/Views/DeviceView.vala"
	switch (property_id) {
#line 29 "../src/Views/DeviceView.vala"
		case MUSIC_DEVICE_VIEW_DEVICE_PROPERTY:
#line 29 "../src/Views/DeviceView.vala"
		music_device_view_set_device (self, g_value_get_object (value));
#line 29 "../src/Views/DeviceView.vala"
		break;
#line 29 "../src/Views/DeviceView.vala"
		case MUSIC_DEVICE_VIEW_PREFERENCES_PROPERTY:
#line 29 "../src/Views/DeviceView.vala"
		music_device_view_set_preferences (self, g_value_get_object (value));
#line 29 "../src/Views/DeviceView.vala"
		break;
#line 692 "DeviceView.c"
		default:
#line 29 "../src/Views/DeviceView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Views/DeviceView.vala"
		break;
#line 698 "DeviceView.c"
	}
}

