/* BrowserColumn.c generated by valac 0.56.0, the Vala compiler
 * generated from BrowserColumn.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include "music-lib.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <pango/pango.h>
#include <gdk/gdk.h>
#include <gee.h>

enum  {
	MUSIC_BROWSER_COLUMN_0_PROPERTY,
	MUSIC_BROWSER_COLUMN_VISIBLE_PROPERTY,
	MUSIC_BROWSER_COLUMN_SHOW_SEPARATOR_PROPERTY,
	MUSIC_BROWSER_COLUMN_FIRST_ITEM_SELECTED_PROPERTY,
	MUSIC_BROWSER_COLUMN_CATEGORY_PROPERTY,
	MUSIC_BROWSER_COLUMN_MENU_ITEM_PROPERTY,
	MUSIC_BROWSER_COLUMN_NUM_PROPERTIES
};
static GParamSpec* music_browser_column_properties[MUSIC_BROWSER_COLUMN_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
enum  {
	MUSIC_BROWSER_COLUMN_SELECTION_CHANGED_SIGNAL,
	MUSIC_BROWSER_COLUMN_ROW_ACTIVATED_SIGNAL,
	MUSIC_BROWSER_COLUMN_RESET_REQUESTED_SIGNAL,
	MUSIC_BROWSER_COLUMN_HEADER_CLICKED_SIGNAL,
	MUSIC_BROWSER_COLUMN_VISIBILITY_CHANGED_SIGNAL,
	MUSIC_BROWSER_COLUMN_NUM_SIGNALS
};
static guint music_browser_column_signals[MUSIC_BROWSER_COLUMN_NUM_SIGNALS] = {0};

struct _MusicBrowserColumnPrivate {
	GtkSeparator* separator;
	MusicBrowserColumnCategory _category;
	GtkCheckMenuItem* _menu_item;
	MusicColumnBrowser* miller_parent;
	GtkTreeView* view;
	MusicBrowserColumnModel* model;
	gchar* _selected;
};

static gint MusicBrowserColumn_private_offset;
static gpointer music_browser_column_parent_class = NULL;

static void music_browser_column_on_menu_item_toggled (MusicBrowserColumn* self);
static void _music_browser_column_on_menu_item_toggled_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                             gpointer self);
static void music_browser_column_view_double_click (MusicBrowserColumn* self,
                                             GtkTreePath* path,
                                             GtkTreeViewColumn* column);
static void _music_browser_column_view_double_click_gtk_tree_view_row_activated (GtkTreeView* _sender,
                                                                          GtkTreePath* path,
                                                                          GtkTreeViewColumn* column,
                                                                          gpointer self);
static gboolean music_browser_column_on_header_clicked (MusicBrowserColumn* self,
                                                 GtkWidget* w,
                                                 GdkEventButton* e);
static gboolean _music_browser_column_on_header_clicked_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                GdkEventButton* event,
                                                                                gpointer self);
static void music_browser_column_selected_item_changed (MusicBrowserColumn* self);
static void _music_browser_column_selected_item_changed_gtk_tree_selection_changed (GtkTreeSelection* _sender,
                                                                             gpointer self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static gboolean music_browser_column_select_proper_string (MusicBrowserColumn* self,
                                                    GtkTreeModel* tmodel,
                                                    GtkTreePath* path,
                                                    GtkTreeIter* item);
static gboolean _music_browser_column_select_proper_string_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                                 GtkTreePath* path,
                                                                                 GtkTreeIter* iter,
                                                                                 gpointer self);
static gboolean ___lambda5_ (MusicBrowserColumn* self);
static gboolean ____lambda5__gsource_func (gpointer self);
static void g_cclosure_user_marshal_VOID__ENUM_STRING (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void music_browser_column_finalize (GObject * obj);
static GType music_browser_column_get_type_once (void);
static void _vala_music_browser_column_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_music_browser_column_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
music_browser_column_get_instance_private (MusicBrowserColumn* self)
{
	return G_STRUCT_MEMBER_P (self, MusicBrowserColumn_private_offset);
}

MusicBrowserColumnCategory
music_browser_column_category_first (void)
{
	MusicBrowserColumnCategory result;
#line 48 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	result = (MusicBrowserColumnCategory) 0;
#line 48 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	return result;
#line 142 "BrowserColumn.c"
}

MusicBrowserColumnCategory
music_browser_column_category_last (void)
{
	MusicBrowserColumnCategory result;
#line 52 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	result = (MusicBrowserColumnCategory) (MUSIC_BROWSER_COLUMN_CATEGORY_N_CATEGORIES - 1);
#line 52 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	return result;
#line 153 "BrowserColumn.c"
}

gchar*
music_browser_column_category_to_string (MusicBrowserColumnCategory self)
{
	gchar* result;
#line 56 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	switch (self) {
#line 56 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_GENRE:
#line 164 "BrowserColumn.c"
		{
			gchar* _tmp0_;
#line 58 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp0_ = g_strdup (_ ("Genres"));
#line 58 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			result = _tmp0_;
#line 58 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			return result;
#line 173 "BrowserColumn.c"
		}
#line 56 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST:
#line 177 "BrowserColumn.c"
		{
			gchar* _tmp1_;
#line 60 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp1_ = g_strdup (_ ("Artists"));
#line 60 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			result = _tmp1_;
#line 60 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			return result;
#line 186 "BrowserColumn.c"
		}
#line 56 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM:
#line 190 "BrowserColumn.c"
		{
			gchar* _tmp2_;
#line 62 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp2_ = g_strdup (_ ("Albums"));
#line 62 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			result = _tmp2_;
#line 62 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			return result;
#line 199 "BrowserColumn.c"
		}
#line 56 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_YEAR:
#line 203 "BrowserColumn.c"
		{
			gchar* _tmp3_;
#line 64 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp3_ = g_strdup (_ ("Years"));
#line 64 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			result = _tmp3_;
#line 64 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			return result;
#line 212 "BrowserColumn.c"
		}
#line 56 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_RATING:
#line 216 "BrowserColumn.c"
		{
			gchar* _tmp4_;
#line 66 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp4_ = g_strdup (_ ("Ratings"));
#line 66 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			result = _tmp4_;
#line 66 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			return result;
#line 225 "BrowserColumn.c"
		}
#line 56 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER:
#line 229 "BrowserColumn.c"
		{
			gchar* _tmp5_;
#line 68 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp5_ = g_strdup (_ ("Composers"));
#line 68 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			result = _tmp5_;
#line 68 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			return result;
#line 238 "BrowserColumn.c"
		}
#line 56 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING:
#line 242 "BrowserColumn.c"
		{
			gchar* _tmp6_;
#line 70 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp6_ = g_strdup (_ ("Groupings"));
#line 70 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			result = _tmp6_;
#line 70 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			return result;
#line 251 "BrowserColumn.c"
		}
		default:
		{
#line 72 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			g_assert_not_reached ();
#line 257 "BrowserColumn.c"
		}
	}
}

static GType
music_browser_column_category_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_BROWSER_COLUMN_CATEGORY_RATING, "MUSIC_BROWSER_COLUMN_CATEGORY_RATING", "rating"}, {MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING, "MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING", "grouping"}, {MUSIC_BROWSER_COLUMN_CATEGORY_YEAR, "MUSIC_BROWSER_COLUMN_CATEGORY_YEAR", "year"}, {MUSIC_BROWSER_COLUMN_CATEGORY_GENRE, "MUSIC_BROWSER_COLUMN_CATEGORY_GENRE", "genre"}, {MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER, "MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER", "composer"}, {MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST, "MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST", "artist"}, {MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM, "MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM", "album"}, {MUSIC_BROWSER_COLUMN_CATEGORY_N_CATEGORIES, "MUSIC_BROWSER_COLUMN_CATEGORY_N_CATEGORIES", "n-categories"}, {0, NULL, NULL}};
	GType music_browser_column_category_type_id;
	music_browser_column_category_type_id = g_enum_register_static ("MusicBrowserColumnCategory", values);
	return music_browser_column_category_type_id;
}

GType
music_browser_column_category_get_type (void)
{
	static volatile gsize music_browser_column_category_type_id__once = 0;
	if (g_once_init_enter (&music_browser_column_category_type_id__once)) {
		GType music_browser_column_category_type_id;
		music_browser_column_category_type_id = music_browser_column_category_get_type_once ();
		g_once_init_leave (&music_browser_column_category_type_id__once, music_browser_column_category_type_id);
	}
	return music_browser_column_category_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 131 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	return self ? g_object_ref (self) : NULL;
#line 288 "BrowserColumn.c"
}

static void
_music_browser_column_on_menu_item_toggled_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                        gpointer self)
{
#line 153 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	music_browser_column_on_menu_item_toggled ((MusicBrowserColumn*) self);
#line 297 "BrowserColumn.c"
}

static void
_music_browser_column_view_double_click_gtk_tree_view_row_activated (GtkTreeView* _sender,
                                                                     GtkTreePath* path,
                                                                     GtkTreeViewColumn* column,
                                                                     gpointer self)
{
#line 154 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	music_browser_column_view_double_click ((MusicBrowserColumn*) self, path, column);
#line 308 "BrowserColumn.c"
}

static gboolean
_music_browser_column_on_header_clicked_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                       GdkEventButton* event,
                                                                       gpointer self)
{
	gboolean result;
	result = music_browser_column_on_header_clicked ((MusicBrowserColumn*) self, _sender, event);
#line 158 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	return result;
#line 320 "BrowserColumn.c"
}

MusicBrowserColumn*
music_browser_column_construct (GType object_type,
                                MusicColumnBrowser* miller_parent,
                                MusicBrowserColumnCategory category)
{
	MusicBrowserColumn * self = NULL;
	MusicColumnBrowser* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkCheckMenuItem* _tmp3_;
	GtkCheckMenuItem* _tmp4_;
	GtkTreeView* _tmp5_;
	MusicBrowserColumnModel* _tmp6_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp7_;
	GtkTreeView* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GtkScrolledWindow* scrolled = NULL;
	GtkScrolledWindow* _tmp11_;
	GtkTreeView* _tmp12_;
	GtkTreeView* _tmp13_;
	GtkCheckMenuItem* _tmp14_;
	GtkTreeView* _tmp15_;
	GtkTreeViewColumn* column = NULL;
	GtkTreeView* _tmp16_;
	GtkTreeViewColumn* _tmp17_;
	GtkTreeViewColumn* _tmp18_;
	GtkWidget* _tmp19_;
	GtkTreeView* _tmp20_;
	GtkTreeSelection* _tmp21_;
#line 130 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_val_if_fail (miller_parent != NULL, NULL);
#line 130 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	self = (MusicBrowserColumn*) g_object_new (object_type, NULL);
#line 131 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp0_ = _g_object_ref0 (miller_parent);
#line 131 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_object_unref0 (self->priv->miller_parent);
#line 131 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	self->priv->miller_parent = _tmp0_;
#line 132 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	music_browser_column_set_category (self, category);
#line 133 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_HORIZONTAL);
#line 135 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp1_ = music_browser_column_category_to_string (category);
#line 135 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp2_ = _tmp1_;
#line 135 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp3_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_tmp2_);
#line 135 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_object_ref_sink (_tmp3_);
#line 135 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp4_ = _tmp3_;
#line 135 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	music_browser_column_set_menu_item (self, _tmp4_);
#line 135 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_object_unref0 (_tmp4_);
#line 135 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_free0 (_tmp2_);
#line 136 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	music_browser_column_set_visible (self, FALSE);
#line 138 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp5_ = (GtkTreeView*) gtk_tree_view_new ();
#line 138 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_object_ref_sink (_tmp5_);
#line 138 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_object_unref0 (self->priv->view);
#line 138 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	self->priv->view = _tmp5_;
#line 139 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp6_ = music_browser_column_model_new (category);
#line 139 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_object_unref0 (self->priv->model);
#line 139 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	self->priv->model = _tmp6_;
#line 141 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp7_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 141 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_object_ref_sink (_tmp7_);
#line 141 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	cell = _tmp7_;
#line 142 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_object_set (cell, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp8_ = self->priv->view;
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp9_ = music_browser_column_category_to_string (category);
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp10_ = _tmp9_;
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp8_, -1, _tmp10_, (GtkCellRenderer*) cell, "text", 0, NULL, NULL);
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_free0 (_tmp10_);
#line 146 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp11_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 146 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_object_ref_sink (_tmp11_);
#line 146 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	scrolled = _tmp11_;
#line 147 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_object_set ((GtkWidget*) scrolled, "expand", TRUE, NULL);
#line 148 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp12_ = self->priv->view;
#line 148 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gtk_container_add ((GtkContainer*) scrolled, (GtkWidget*) _tmp12_);
#line 149 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) scrolled);
#line 151 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp13_ = self->priv->view;
#line 151 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gtk_tree_view_set_headers_clickable (_tmp13_, TRUE);
#line 153 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp14_ = self->priv->_menu_item;
#line 153 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_signal_connect_object (_tmp14_, "toggled", (GCallback) _music_browser_column_on_menu_item_toggled_gtk_check_menu_item_toggled, self, 0);
#line 154 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp15_ = self->priv->view;
#line 154 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_signal_connect_object (_tmp15_, "row-activated", (GCallback) _music_browser_column_view_double_click_gtk_tree_view_row_activated, self, 0);
#line 156 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp16_ = self->priv->view;
#line 156 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp17_ = gtk_tree_view_get_column (_tmp16_, 0);
#line 156 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp18_ = _g_object_ref0 (_tmp17_);
#line 156 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	column = _tmp18_;
#line 157 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gtk_tree_view_column_set_alignment (column, 0.5f);
#line 158 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp19_ = gtk_tree_view_column_get_button (column);
#line 158 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_signal_connect_object (_tmp19_, "button-press-event", (GCallback) _music_browser_column_on_header_clicked_gtk_widget_button_press_event, self, 0);
#line 159 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp20_ = self->priv->view;
#line 159 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp21_ = gtk_tree_view_get_selection (_tmp20_);
#line 159 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gtk_tree_selection_set_mode (_tmp21_, GTK_SELECTION_BROWSE);
#line 130 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_object_unref0 (column);
#line 130 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_object_unref0 (scrolled);
#line 130 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_object_unref0 (cell);
#line 130 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	return self;
#line 472 "BrowserColumn.c"
}

MusicBrowserColumn*
music_browser_column_new (MusicColumnBrowser* miller_parent,
                          MusicBrowserColumnCategory category)
{
#line 130 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	return music_browser_column_construct (MUSIC_TYPE_BROWSER_COLUMN, miller_parent, category);
#line 481 "BrowserColumn.c"
}

static void
_music_browser_column_selected_item_changed_gtk_tree_selection_changed (GtkTreeSelection* _sender,
                                                                        gpointer self)
{
#line 191 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	music_browser_column_selected_item_changed ((MusicBrowserColumn*) self);
#line 490 "BrowserColumn.c"
}

static void
music_browser_column_on_menu_item_toggled (MusicBrowserColumn* self)
{
	gboolean _tmp0_ = FALSE;
	GtkCheckMenuItem* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkCheckMenuItem* _tmp9_;
	guint _tmp10_;
	gint visible_columns = 0;
	GtkCheckMenuItem* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	GtkCheckMenuItem* _tmp27_;
	gboolean _tmp28_;
	gboolean _tmp29_;
	GtkCheckMenuItem* _tmp42_;
	GtkTreeView* _tmp43_;
	GtkTreeSelection* _tmp44_;
#line 162 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_if_fail (self != NULL);
#line 163 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp1_ = self->priv->_menu_item;
#line 163 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp2_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp1_);
#line 163 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp3_ = _tmp2_;
#line 163 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (!_tmp3_) {
#line 163 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp0_ = TRUE;
#line 524 "BrowserColumn.c"
	} else {
		GtkCheckMenuItem* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 163 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp4_ = self->priv->_menu_item;
#line 163 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp5_ = gtk_check_menu_item_get_active (_tmp4_);
#line 163 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp6_ = _tmp5_;
#line 163 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp7_ = music_browser_column_get_visible (self);
#line 163 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp8_ = _tmp7_;
#line 163 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp0_ = _tmp6_ == _tmp8_;
#line 543 "BrowserColumn.c"
	}
#line 163 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (_tmp0_) {
#line 164 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		return;
#line 549 "BrowserColumn.c"
	}
#line 166 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp9_ = self->priv->_menu_item;
#line 166 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_signal_parse_name ("toggled", gtk_check_menu_item_get_type (), &_tmp10_, NULL, FALSE);
#line 166 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_signal_handlers_disconnect_matched (_tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _music_browser_column_on_menu_item_toggled_gtk_check_menu_item_toggled, self);
#line 168 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	visible_columns = 0;
#line 559 "BrowserColumn.c"
	{
		GeeIterator* _col_it = NULL;
		MusicColumnBrowser* _tmp11_;
		GeeTreeSet* _tmp12_;
		GeeTreeSet* _tmp13_;
		GeeIterator* _tmp14_;
#line 170 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp11_ = self->priv->miller_parent;
#line 170 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp12_ = music_column_browser_get_columns (_tmp11_);
#line 170 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp13_ = _tmp12_;
#line 170 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp14_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp13_);
#line 170 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_col_it = _tmp14_;
#line 170 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		while (TRUE) {
#line 578 "BrowserColumn.c"
			GeeIterator* _tmp15_;
			MusicBrowserColumn* col = NULL;
			GeeIterator* _tmp16_;
			gpointer _tmp17_;
			MusicBrowserColumn* _tmp18_;
			gboolean _tmp19_;
			gboolean _tmp20_;
#line 170 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp15_ = _col_it;
#line 170 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			if (!gee_iterator_next (_tmp15_)) {
#line 170 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
				break;
#line 592 "BrowserColumn.c"
			}
#line 170 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp16_ = _col_it;
#line 170 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp17_ = gee_iterator_get (_tmp16_);
#line 170 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			col = (MusicBrowserColumn*) _tmp17_;
#line 171 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp18_ = col;
#line 171 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp19_ = music_browser_column_get_visible (_tmp18_);
#line 171 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp20_ = _tmp19_;
#line 171 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			if (_tmp20_) {
#line 608 "BrowserColumn.c"
				gint _tmp21_;
#line 172 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
				_tmp21_ = visible_columns;
#line 172 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
				visible_columns = _tmp21_ + 1;
#line 614 "BrowserColumn.c"
			}
#line 170 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_g_object_unref0 (col);
#line 618 "BrowserColumn.c"
		}
#line 170 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_g_object_unref0 (_col_it);
#line 622 "BrowserColumn.c"
	}
#line 175 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp22_ = self->priv->_menu_item;
#line 175 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp23_ = gtk_check_menu_item_get_active (_tmp22_);
#line 175 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp24_ = _tmp23_;
#line 175 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (_tmp24_) {
#line 632 "BrowserColumn.c"
		gint _tmp25_;
#line 176 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp25_ = visible_columns;
#line 176 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		visible_columns = _tmp25_ + 1;
#line 638 "BrowserColumn.c"
	} else {
		gint _tmp26_;
#line 178 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp26_ = visible_columns;
#line 178 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		visible_columns = _tmp26_ - 1;
#line 645 "BrowserColumn.c"
	}
#line 180 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp27_ = self->priv->_menu_item;
#line 180 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp28_ = gtk_check_menu_item_get_active (_tmp27_);
#line 180 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp29_ = _tmp28_;
#line 180 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	music_browser_column_set_visible (self, _tmp29_);
#line 655 "BrowserColumn.c"
	{
		GeeIterator* _col_it = NULL;
		MusicColumnBrowser* _tmp30_;
		GeeTreeSet* _tmp31_;
		GeeTreeSet* _tmp32_;
		GeeIterator* _tmp33_;
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp30_ = self->priv->miller_parent;
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp31_ = music_column_browser_get_columns (_tmp30_);
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp32_ = _tmp31_;
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp33_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp32_);
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_col_it = _tmp33_;
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		while (TRUE) {
#line 674 "BrowserColumn.c"
			GeeIterator* _tmp34_;
			MusicBrowserColumn* col = NULL;
			GeeIterator* _tmp35_;
			gpointer _tmp36_;
			MusicBrowserColumn* _tmp37_;
			gboolean _tmp38_;
			gboolean _tmp39_;
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp34_ = _col_it;
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			if (!gee_iterator_next (_tmp34_)) {
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
				break;
#line 688 "BrowserColumn.c"
			}
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp35_ = _col_it;
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp36_ = gee_iterator_get (_tmp35_);
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			col = (MusicBrowserColumn*) _tmp36_;
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp37_ = col;
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp38_ = music_browser_column_get_visible (_tmp37_);
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp39_ = _tmp38_;
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			if (_tmp39_) {
#line 704 "BrowserColumn.c"
				MusicBrowserColumn* _tmp40_;
				GtkCheckMenuItem* _tmp41_;
#line 185 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
				_tmp40_ = col;
#line 185 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
				_tmp41_ = _tmp40_->priv->_menu_item;
#line 185 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp41_, visible_columns > 1);
#line 713 "BrowserColumn.c"
			}
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_g_object_unref0 (col);
#line 717 "BrowserColumn.c"
		}
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_g_object_unref0 (_col_it);
#line 721 "BrowserColumn.c"
	}
#line 189 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp42_ = self->priv->_menu_item;
#line 189 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_signal_connect_object (_tmp42_, "toggled", (GCallback) _music_browser_column_on_menu_item_toggled_gtk_check_menu_item_toggled, self, 0);
#line 191 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp43_ = self->priv->view;
#line 191 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp44_ = gtk_tree_view_get_selection (_tmp43_);
#line 191 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_signal_connect_object (_tmp44_, "changed", (GCallback) _music_browser_column_selected_item_changed_gtk_tree_selection_changed, self, G_CONNECT_AFTER);
#line 733 "BrowserColumn.c"
}

void
music_browser_column_add_item (MusicBrowserColumn* self,
                               const gchar* text)
{
	GtkTreeIter iter = {0};
	MusicBrowserColumnModel* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	MusicBrowserColumnModel* _tmp2_;
	GtkTreeIter _tmp3_;
#line 195 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_if_fail (self != NULL);
#line 195 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_if_fail (text != NULL);
#line 198 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp0_ = self->priv->model;
#line 198 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	music_browser_column_model_append (_tmp0_, &_tmp1_);
#line 198 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	iter = _tmp1_;
#line 199 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp2_ = self->priv->model;
#line 199 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp3_ = iter;
#line 199 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	music_browser_column_model_set (_tmp2_, &_tmp3_, 0, text, NULL);
#line 761 "BrowserColumn.c"
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 212 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 769 "BrowserColumn.c"
}

void
music_browser_column_select_first_item (MusicBrowserColumn* self)
{
	MusicBrowserColumnModel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 204 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp0_ = self->priv->model;
#line 205 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (_tmp0_ == NULL) {
#line 206 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		return;
#line 786 "BrowserColumn.c"
	}
#line 208 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp1_ = music_browser_column_get_first_item_selected (self);
#line 208 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp2_ = _tmp1_;
#line 208 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (!_tmp2_) {
#line 209 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		music_browser_column_set_selected (self, NULL, TRUE);
#line 796 "BrowserColumn.c"
	} else {
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		MusicBrowserColumnModel* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 210 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp5_ = self->priv->model;
#line 210 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp6_ = music_browser_column_model_get_n_items (_tmp5_);
#line 210 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp7_ = _tmp6_;
#line 210 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		if ((_tmp7_ + 1) >= 1) {
#line 811 "BrowserColumn.c"
			gboolean _tmp8_;
			gboolean _tmp9_;
#line 210 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp8_ = music_browser_column_get_visible (self);
#line 210 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp9_ = _tmp8_;
#line 210 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp4_ = _tmp9_;
#line 820 "BrowserColumn.c"
		} else {
#line 210 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp4_ = FALSE;
#line 824 "BrowserColumn.c"
		}
#line 210 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		if (_tmp4_) {
#line 828 "BrowserColumn.c"
			MusicLibraryWindow* _tmp10_;
			MusicLibraryWindow* _tmp11_;
			gboolean _tmp12_;
			gboolean _tmp13_;
#line 210 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp10_ = music_app_get_main_window ();
#line 210 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp11_ = _tmp10_;
#line 210 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp12_ = music_library_window_get_initialization_finished (_tmp11_);
#line 210 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp13_ = _tmp12_;
#line 210 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp3_ = _tmp13_;
#line 843 "BrowserColumn.c"
		} else {
#line 210 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp3_ = FALSE;
#line 847 "BrowserColumn.c"
		}
#line 210 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		if (_tmp3_) {
#line 851 "BrowserColumn.c"
			GtkTreeView* _tmp14_;
			GtkTreePath* _tmp15_;
			GtkTreePath* _tmp16_;
#line 212 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp14_ = self->priv->view;
#line 212 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp15_ = gtk_tree_path_new_first ();
#line 212 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp16_ = _tmp15_;
#line 212 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			gtk_tree_view_scroll_to_cell (_tmp14_, _tmp16_, NULL, FALSE, 0.0f, 0.0f);
#line 212 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			__vala_GtkTreePath_free0 (_tmp16_);
#line 865 "BrowserColumn.c"
		}
	}
}

/**
     * Since this is used to get the selected column item, when _selected is NULL it returns ""
     * to represent "All" in LibraryManager.do_search()
     */
gchar*
music_browser_column_get_selected (MusicBrowserColumn* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 220 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 221 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp1_ = self->priv->_selected;
#line 221 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (_tmp1_ == NULL) {
#line 221 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp0_ = TRUE;
#line 890 "BrowserColumn.c"
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 221 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp2_ = music_browser_column_get_visible (self);
#line 221 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp3_ = _tmp2_;
#line 221 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp0_ = !_tmp3_;
#line 900 "BrowserColumn.c"
	}
#line 221 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (_tmp0_) {
#line 904 "BrowserColumn.c"
		gchar* _tmp4_;
#line 222 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp4_ = g_strdup ("");
#line 222 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		result = _tmp4_;
#line 222 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		return result;
#line 912 "BrowserColumn.c"
	}
#line 224 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp5_ = self->priv->_selected;
#line 224 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 224 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	result = _tmp6_;
#line 224 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	return result;
#line 922 "BrowserColumn.c"
}

static gboolean
_music_browser_column_select_proper_string_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                        GtkTreePath* path,
                                                                        GtkTreeIter* iter,
                                                                        gpointer self)
{
	gboolean result;
	result = music_browser_column_select_proper_string ((MusicBrowserColumn*) self, model, path, iter);
#line 248 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	return result;
#line 935 "BrowserColumn.c"
}

void
music_browser_column_populate (MusicBrowserColumn* self,
                               GeeHashSet* items)
{
	GtkTreeView* _tmp0_;
	GtkTreeSelection* _tmp1_;
	MusicBrowserColumnCategory _tmp2_;
	MusicBrowserColumnModel* _tmp3_;
	GtkTreeView* _tmp4_;
	MusicBrowserColumnModel* _tmp5_;
	MusicBrowserColumnModel* _tmp6_;
	GtkTreeView* _tmp7_;
	MusicBrowserColumnModel* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gboolean _tmp11_;
	MusicBrowserColumnModel* _tmp12_;
	GtkTreeView* _tmp13_;
	GtkTreeSelection* _tmp14_;
#line 227 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_if_fail (self != NULL);
#line 227 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_if_fail (items != NULL);
#line 228 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) items, "");
#line 230 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp0_ = self->priv->view;
#line 230 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp1_ = gtk_tree_view_get_selection (_tmp0_);
#line 230 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_object_freeze_notify ((GObject*) _tmp1_);
#line 231 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp2_ = self->priv->_category;
#line 231 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp3_ = music_browser_column_model_new (_tmp2_);
#line 231 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_object_unref0 (self->priv->model);
#line 231 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	self->priv->model = _tmp3_;
#line 232 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp4_ = self->priv->view;
#line 232 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gtk_tree_view_set_model (_tmp4_, NULL);
#line 234 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp5_ = self->priv->model;
#line 234 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	music_browser_column_model_append_items (_tmp5_, (GeeCollection*) items, FALSE);
#line 235 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp6_ = self->priv->model;
#line 235 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp6_, 0, GTK_SORT_ASCENDING);
#line 237 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp7_ = self->priv->view;
#line 237 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp8_ = self->priv->model;
#line 237 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gtk_tree_view_set_model (_tmp7_, (GtkTreeModel*) _tmp8_);
#line 245 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp9_ = music_browser_column_get_selected (self);
#line 245 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp10_ = _tmp9_;
#line 245 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp11_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) items, _tmp10_);
#line 245 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_free0 (_tmp10_);
#line 245 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (_tmp11_) {
#line 246 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_g_free0 (self->priv->_selected);
#line 246 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		self->priv->_selected = NULL;
#line 1009 "BrowserColumn.c"
	}
#line 248 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp12_ = self->priv->model;
#line 248 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gtk_tree_model_foreach ((GtkTreeModel*) _tmp12_, _music_browser_column_select_proper_string_gtk_tree_model_foreach_func, self);
#line 250 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp13_ = self->priv->view;
#line 250 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp14_ = gtk_tree_view_get_selection (_tmp13_);
#line 250 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_object_thaw_notify ((GObject*) _tmp14_);
#line 1021 "BrowserColumn.c"
}

static gboolean
___lambda5_ (MusicBrowserColumn* self)
{
	MusicBrowserColumnCategory _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean result;
#line 263 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp0_ = self->priv->_category;
#line 263 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp1_ = music_browser_column_get_selected (self);
#line 263 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp2_ = _tmp1_;
#line 263 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_signal_emit (self, music_browser_column_signals[MUSIC_BROWSER_COLUMN_SELECTION_CHANGED_SIGNAL], 0, _tmp0_, _tmp2_);
#line 263 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_free0 (_tmp2_);
#line 264 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	result = FALSE;
#line 264 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	return result;
#line 1045 "BrowserColumn.c"
}

static gboolean
____lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda5_ ((MusicBrowserColumn*) self);
#line 262 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	return result;
#line 1055 "BrowserColumn.c"
}

void
music_browser_column_set_selected (MusicBrowserColumn* self,
                                   const gchar* val,
                                   gboolean notify)
{
	gboolean _tmp0_ = FALSE;
	MusicBrowserColumnModel* _tmp1_;
	gchar* _tmp8_;
	MusicBrowserColumnModel* _tmp9_;
#line 253 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp1_ = self->priv->model;
#line 254 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (_tmp1_ != NULL) {
#line 1073 "BrowserColumn.c"
		gboolean _tmp2_ = FALSE;
		MusicLibraryWindow* _tmp3_;
		MusicLibraryWindow* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 254 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp3_ = music_app_get_main_window ();
#line 254 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp4_ = _tmp3_;
#line 254 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp5_ = music_library_window_get_initialization_finished (_tmp4_);
#line 254 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp6_ = _tmp5_;
#line 254 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		if (!_tmp6_) {
#line 254 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp2_ = TRUE;
#line 1091 "BrowserColumn.c"
		} else {
			const gchar* _tmp7_;
#line 254 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp7_ = self->priv->_selected;
#line 254 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp2_ = g_strcmp0 (val, _tmp7_) == 0;
#line 1098 "BrowserColumn.c"
		}
#line 254 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp0_ = _tmp2_;
#line 1102 "BrowserColumn.c"
	} else {
#line 254 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp0_ = FALSE;
#line 1106 "BrowserColumn.c"
	}
#line 254 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (_tmp0_) {
#line 255 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		return;
#line 1112 "BrowserColumn.c"
	}
#line 257 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp8_ = g_strdup (val);
#line 257 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_free0 (self->priv->_selected);
#line 257 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	self->priv->_selected = _tmp8_;
#line 259 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp9_ = self->priv->model;
#line 259 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gtk_tree_model_foreach ((GtkTreeModel*) _tmp9_, _music_browser_column_select_proper_string_gtk_tree_model_foreach_func, self);
#line 261 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (notify) {
#line 262 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE - 10, ____lambda5__gsource_func, g_object_ref (self), g_object_unref);
#line 1128 "BrowserColumn.c"
	}
}

static gboolean
music_browser_column_on_header_clicked (MusicBrowserColumn* self,
                                        GtkWidget* w,
                                        GdkEventButton* e)
{
	gboolean result;
#line 269 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 269 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_val_if_fail (w != NULL, FALSE);
#line 269 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 271 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (e->button == ((guint) GDK_BUTTON_PRIMARY)) {
#line 272 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		music_browser_column_select_first_item (self);
#line 1148 "BrowserColumn.c"
	}
#line 276 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_signal_emit (self, music_browser_column_signals[MUSIC_BROWSER_COLUMN_HEADER_CLICKED_SIGNAL], 0, e);
#line 278 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	result = TRUE;
#line 278 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	return result;
#line 1156 "BrowserColumn.c"
}

static void
music_browser_column_selected_item_changed (MusicBrowserColumn* self)
{
	GtkTreeModel* temp_model = NULL;
	GtkTreeIter iter = {0};
	gchar* text = NULL;
	GtkTreeView* _tmp0_;
	GtkTreeSelection* _tmp1_;
	GtkTreeModel* _tmp2_ = NULL;
	GtkTreeIter _tmp3_ = {0};
	gboolean _tmp4_;
	GtkTreeModel* _tmp5_;
#line 281 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_if_fail (self != NULL);
#line 286 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp0_ = self->priv->view;
#line 286 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp1_ = gtk_tree_view_get_selection (_tmp0_);
#line 286 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp4_ = gtk_tree_selection_get_selected (_tmp1_, &_tmp2_, &_tmp3_);
#line 286 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_object_unref0 (temp_model);
#line 286 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp5_ = _g_object_ref0 (_tmp2_);
#line 286 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	temp_model = _tmp5_;
#line 286 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	iter = _tmp3_;
#line 286 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (_tmp4_) {
#line 1189 "BrowserColumn.c"
		GtkTreeIter _tmp6_;
		void* _tmp7_;
#line 287 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp6_ = iter;
#line 287 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp7_ = _tmp6_.user_data;
#line 287 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		if (g_sequence_iter_get_position ((GSequenceIter*) _tmp7_) == 0) {
#line 289 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			music_browser_column_select_first_item (self);
#line 1200 "BrowserColumn.c"
		} else {
			GtkTreeModel* _tmp8_;
			GtkTreeIter _tmp9_;
			gchar* _tmp10_ = NULL;
			const gchar* _tmp11_;
#line 291 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp8_ = temp_model;
#line 291 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp9_ = iter;
#line 291 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			gtk_tree_model_get (_tmp8_, &_tmp9_, 0, &_tmp10_, -1);
#line 291 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_g_free0 (text);
#line 291 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			text = _tmp10_;
#line 292 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp11_ = text;
#line 292 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			music_browser_column_set_selected (self, _tmp11_, TRUE);
#line 1220 "BrowserColumn.c"
		}
	}
#line 281 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_free0 (text);
#line 281 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_object_unref0 (temp_model);
#line 1227 "BrowserColumn.c"
}

static void
music_browser_column_view_double_click (MusicBrowserColumn* self,
                                        GtkTreePath* path,
                                        GtkTreeViewColumn* column)
{
	GtkTreeIter iter = {0};
	MusicBrowserColumnModel* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkTreeIter _tmp2_;
	void* _tmp3_;
#line 297 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_if_fail (self != NULL);
#line 297 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_if_fail (path != NULL);
#line 297 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_if_fail (column != NULL);
#line 299 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp0_ = self->priv->model;
#line 299 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp0_, &_tmp1_, path);
#line 299 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	iter = _tmp1_;
#line 301 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp2_ = iter;
#line 301 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp3_ = _tmp2_.user_data;
#line 301 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (g_sequence_iter_get_position ((GSequenceIter*) _tmp3_) == 0) {
#line 303 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		g_signal_emit (self, music_browser_column_signals[MUSIC_BROWSER_COLUMN_RESET_REQUESTED_SIGNAL], 0);
#line 1260 "BrowserColumn.c"
	} else {
		GValue text = {0};
		MusicBrowserColumnModel* _tmp4_;
		GtkTreeIter _tmp5_;
		GValue _tmp6_ = {0};
		GValue _tmp7_;
#line 307 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp4_ = self->priv->model;
#line 307 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp5_ = iter;
#line 307 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		gtk_tree_model_get_value ((GtkTreeModel*) _tmp4_, &_tmp5_, 0, &_tmp6_);
#line 307 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		G_IS_VALUE (&text) ? (g_value_unset (&text), NULL) : NULL;
#line 307 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		text = _tmp6_;
#line 308 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp7_ = text;
#line 308 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		g_signal_emit (self, music_browser_column_signals[MUSIC_BROWSER_COLUMN_ROW_ACTIVATED_SIGNAL], 0, g_value_get_string (&_tmp7_));
#line 301 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		G_IS_VALUE (&text) ? (g_value_unset (&text), NULL) : NULL;
#line 1283 "BrowserColumn.c"
	}
}

static gboolean
music_browser_column_select_proper_string (MusicBrowserColumn* self,
                                           GtkTreeModel* tmodel,
                                           GtkTreePath* path,
                                           GtkTreeIter* item)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gchar* s = NULL;
	GtkTreeIter _tmp8_;
	gchar* _tmp9_ = NULL;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gboolean _tmp13_;
	GtkTreeView* _tmp34_;
	GtkTreeSelection* _tmp35_;
	GtkTreeIter _tmp36_;
	gboolean result;
#line 312 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 312 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_val_if_fail (tmodel != NULL, FALSE);
#line 312 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 312 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 313 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp0_ = music_browser_column_get_first_item_selected (self);
#line 313 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp1_ = _tmp0_;
#line 313 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (_tmp1_) {
#line 1320 "BrowserColumn.c"
		GtkTreePath* first_path = NULL;
		GtkTreePath* _tmp2_;
		GtkTreeView* _tmp3_;
		GtkTreeSelection* _tmp4_;
		GtkTreePath* _tmp5_;
		GtkTreeView* _tmp6_;
		GtkTreePath* _tmp7_;
#line 314 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp2_ = gtk_tree_path_new_first ();
#line 314 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		first_path = _tmp2_;
#line 315 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp3_ = self->priv->view;
#line 315 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp4_ = gtk_tree_view_get_selection (_tmp3_);
#line 315 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp5_ = first_path;
#line 315 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		gtk_tree_selection_select_path (_tmp4_, _tmp5_);
#line 316 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp6_ = self->priv->view;
#line 316 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp7_ = first_path;
#line 316 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		gtk_tree_view_scroll_to_cell (_tmp6_, _tmp7_, NULL, TRUE, 0.0f, 0.0f);
#line 317 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		result = TRUE;
#line 317 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		__vala_GtkTreePath_free0 (first_path);
#line 317 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		return result;
#line 1352 "BrowserColumn.c"
	}
#line 321 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp8_ = *item;
#line 321 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gtk_tree_model_get (tmodel, &_tmp8_, 0, &_tmp9_, -1);
#line 321 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_free0 (s);
#line 321 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	s = _tmp9_;
#line 323 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp10_ = s;
#line 323 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp11_ = music_browser_column_get_selected (self);
#line 323 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp12_ = _tmp11_;
#line 323 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp13_ = g_strcmp0 (_tmp10_, _tmp12_) == 0;
#line 323 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_free0 (_tmp12_);
#line 323 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (_tmp13_) {
#line 1374 "BrowserColumn.c"
		GtkTreeView* _tmp14_;
		GtkTreeSelection* _tmp15_;
		GtkTreeIter _tmp16_;
		gboolean scroll_to_center = FALSE;
		GtkTreePath* start = NULL;
		GtkTreePath* end = NULL;
		GtkTreeView* _tmp17_;
		GtkTreePath* _tmp18_ = NULL;
		GtkTreePath* _tmp19_ = NULL;
		gboolean _tmp20_;
		GtkTreeView* _tmp33_;
#line 324 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp14_ = self->priv->view;
#line 324 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp15_ = gtk_tree_view_get_selection (_tmp14_);
#line 324 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp16_ = *item;
#line 324 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		gtk_tree_selection_select_iter (_tmp15_, &_tmp16_);
#line 328 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		scroll_to_center = FALSE;
#line 331 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp17_ = self->priv->view;
#line 331 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp20_ = gtk_tree_view_get_visible_range (_tmp17_, &_tmp18_, &_tmp19_);
#line 331 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		__vala_GtkTreePath_free0 (start);
#line 331 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		start = _tmp18_;
#line 331 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		__vala_GtkTreePath_free0 (end);
#line 331 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		end = _tmp19_;
#line 331 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		if (_tmp20_) {
#line 1410 "BrowserColumn.c"
			gint start_index = 0;
			GtkTreePath* _tmp21_;
			gint _tmp22_ = 0;
			gint* _tmp23_;
			gint _tmp24_;
			gint end_index = 0;
			GtkTreePath* _tmp25_;
			gint _tmp26_ = 0;
			gint* _tmp27_;
			gint _tmp28_;
			gint current_index = 0;
			gint _tmp29_ = 0;
			gint* _tmp30_;
			gint _tmp31_;
			gboolean _tmp32_ = FALSE;
#line 332 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp21_ = start;
#line 332 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp23_ = gtk_tree_path_get_indices_with_depth (_tmp21_, &_tmp22_);
#line 332 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp24_ = _tmp23_[0];
#line 332 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			start_index = _tmp24_;
#line 333 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp25_ = end;
#line 333 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp27_ = gtk_tree_path_get_indices_with_depth (_tmp25_, &_tmp26_);
#line 333 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp28_ = _tmp27_[0];
#line 333 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			end_index = _tmp28_;
#line 334 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp30_ = gtk_tree_path_get_indices_with_depth (path, &_tmp29_);
#line 334 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			_tmp31_ = _tmp30_[0];
#line 334 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			current_index = _tmp31_;
#line 336 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			if (current_index < start_index) {
#line 336 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
				_tmp32_ = TRUE;
#line 1452 "BrowserColumn.c"
			} else {
#line 336 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
				_tmp32_ = current_index > end_index;
#line 1456 "BrowserColumn.c"
			}
#line 336 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
			if (_tmp32_) {
#line 337 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
				scroll_to_center = TRUE;
#line 1462 "BrowserColumn.c"
			}
		}
#line 340 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp33_ = self->priv->view;
#line 340 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		gtk_tree_view_scroll_to_cell (_tmp33_, path, NULL, scroll_to_center, 0.5f, 0.0f);
#line 342 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		result = TRUE;
#line 342 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		__vala_GtkTreePath_free0 (end);
#line 342 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		__vala_GtkTreePath_free0 (start);
#line 342 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_g_free0 (s);
#line 342 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		return result;
#line 1479 "BrowserColumn.c"
	}
#line 345 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp34_ = self->priv->view;
#line 345 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp35_ = gtk_tree_view_get_selection (_tmp34_);
#line 345 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp36_ = *item;
#line 345 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gtk_tree_selection_unselect_iter (_tmp35_, &_tmp36_);
#line 347 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	result = FALSE;
#line 347 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_free0 (s);
#line 347 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	return result;
#line 1495 "BrowserColumn.c"
}

gboolean
music_browser_column_get_visible (MusicBrowserColumn* self)
{
	gboolean result;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 78 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 79 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp0_ = gtk_widget_get_no_show_all ((GtkWidget*) self);
#line 79 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp1_ = _tmp0_;
#line 79 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	result = !_tmp1_;
#line 79 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	return result;
#line 1514 "BrowserColumn.c"
}

void
music_browser_column_set_visible (MusicBrowserColumn* self,
                                  gboolean value)
{
	gboolean show_column = FALSE;
	GtkCheckMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 81 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	show_column = value;
#line 84 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp0_ = self->priv->_menu_item;
#line 84 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gtk_check_menu_item_set_active (_tmp0_, show_column);
#line 85 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) self, !show_column);
#line 87 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (show_column) {
#line 88 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		gtk_widget_show_all ((GtkWidget*) self);
#line 1539 "BrowserColumn.c"
	} else {
#line 91 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		music_browser_column_select_first_item (self);
#line 92 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		gtk_widget_hide ((GtkWidget*) self);
#line 1545 "BrowserColumn.c"
	}
#line 95 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp1_ = gtk_widget_get_no_show_all ((GtkWidget*) self);
#line 95 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp2_ = _tmp1_;
#line 95 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_signal_emit (self, music_browser_column_signals[MUSIC_BROWSER_COLUMN_VISIBILITY_CHANGED_SIGNAL], 0, !_tmp2_);
#line 81 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_object_notify_by_pspec ((GObject *) self, music_browser_column_properties[MUSIC_BROWSER_COLUMN_VISIBLE_PROPERTY]);
#line 1555 "BrowserColumn.c"
}

void
music_browser_column_set_show_separator (MusicBrowserColumn* self,
                                         gboolean value)
{
	gboolean _tmp0_ = FALSE;
	GtkSeparator* _tmp1_;
#line 101 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp1_ = self->priv->separator;
#line 102 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (_tmp1_ != NULL) {
#line 1570 "BrowserColumn.c"
		GtkSeparator* _tmp2_;
		GtkContainer* _tmp3_;
		GtkContainer* _tmp4_;
#line 102 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp2_ = self->priv->separator;
#line 102 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp3_ = gtk_widget_get_parent ((GtkWidget*) _tmp2_);
#line 102 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp4_ = _tmp3_;
#line 102 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp0_ = _tmp4_ == G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer);
#line 1582 "BrowserColumn.c"
	} else {
#line 102 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp0_ = FALSE;
#line 1586 "BrowserColumn.c"
	}
#line 102 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (_tmp0_) {
#line 1590 "BrowserColumn.c"
		GtkSeparator* _tmp5_;
#line 103 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp5_ = self->priv->separator;
#line 103 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		gtk_container_remove ((GtkContainer*) self, (GtkWidget*) _tmp5_);
#line 104 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_g_object_unref0 (self->priv->separator);
#line 104 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		self->priv->separator = NULL;
#line 1600 "BrowserColumn.c"
	}
#line 107 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (value) {
#line 1604 "BrowserColumn.c"
		GtkSeparator* _tmp6_;
		GtkSeparator* _tmp7_;
		GtkSeparator* _tmp8_;
		GtkSeparator* _tmp9_;
		GtkSeparator* _tmp10_;
#line 108 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp6_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_VERTICAL);
#line 108 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		g_object_ref_sink (_tmp6_);
#line 108 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_g_object_unref0 (self->priv->separator);
#line 108 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		self->priv->separator = _tmp6_;
#line 109 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp7_ = self->priv->separator;
#line 109 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		gtk_widget_set_hexpand ((GtkWidget*) _tmp7_, FALSE);
#line 110 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp8_ = self->priv->separator;
#line 110 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		gtk_widget_set_vexpand ((GtkWidget*) _tmp8_, TRUE);
#line 111 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp9_ = self->priv->separator;
#line 111 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		gtk_widget_show ((GtkWidget*) _tmp9_);
#line 112 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp10_ = self->priv->separator;
#line 112 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp10_);
#line 1634 "BrowserColumn.c"
	}
#line 101 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_object_notify_by_pspec ((GObject *) self, music_browser_column_properties[MUSIC_BROWSER_COLUMN_SHOW_SEPARATOR_PROPERTY]);
#line 1638 "BrowserColumn.c"
}

gboolean
music_browser_column_get_first_item_selected (MusicBrowserColumn* self)
{
	gboolean result;
	const gchar* _tmp0_;
#line 117 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 117 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp0_ = self->priv->_selected;
#line 117 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	result = _tmp0_ == NULL;
#line 117 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	return result;
#line 1654 "BrowserColumn.c"
}

MusicBrowserColumnCategory
music_browser_column_get_category (MusicBrowserColumn* self)
{
	MusicBrowserColumnCategory result;
#line 119 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 119 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	result = self->priv->_category;
#line 119 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	return result;
#line 1667 "BrowserColumn.c"
}

void
music_browser_column_set_category (MusicBrowserColumn* self,
                                   MusicBrowserColumnCategory value)
{
	MusicBrowserColumnCategory old_value;
#line 119 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	old_value = music_browser_column_get_category (self);
#line 119 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (old_value != value) {
#line 119 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		self->priv->_category = value;
#line 119 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		g_object_notify_by_pspec ((GObject *) self, music_browser_column_properties[MUSIC_BROWSER_COLUMN_CATEGORY_PROPERTY]);
#line 1685 "BrowserColumn.c"
	}
}

GtkCheckMenuItem*
music_browser_column_get_menu_item (MusicBrowserColumn* self)
{
	GtkCheckMenuItem* result;
	GtkCheckMenuItem* _tmp0_;
#line 120 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 120 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_tmp0_ = self->priv->_menu_item;
#line 120 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	result = _tmp0_;
#line 120 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	return result;
#line 1702 "BrowserColumn.c"
}

void
music_browser_column_set_menu_item (MusicBrowserColumn* self,
                                    GtkCheckMenuItem* value)
{
	GtkCheckMenuItem* old_value;
#line 120 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	old_value = music_browser_column_get_menu_item (self);
#line 120 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (old_value != value) {
#line 1716 "BrowserColumn.c"
		GtkCheckMenuItem* _tmp0_;
#line 120 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 120 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		_g_object_unref0 (self->priv->_menu_item);
#line 120 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		self->priv->_menu_item = _tmp0_;
#line 120 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		g_object_notify_by_pspec ((GObject *) self, music_browser_column_properties[MUSIC_BROWSER_COLUMN_MENU_ITEM_PROPERTY]);
#line 1726 "BrowserColumn.c"
	}
}

static void
g_cclosure_user_marshal_VOID__ENUM_STRING (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__ENUM_STRING) (gpointer data1, gint arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__ENUM_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_return_if_fail (n_param_values == 3);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		data1 = closure->data;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		data2 = param_values->data[0].v_pointer;
#line 1752 "BrowserColumn.c"
	} else {
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		data1 = param_values->data[0].v_pointer;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		data2 = closure->data;
#line 1758 "BrowserColumn.c"
	}
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	callback = (GMarshalFunc_VOID__ENUM_STRING) (marshal_data ? marshal_data : cc->callback);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	callback (data1, g_value_get_enum (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 1764 "BrowserColumn.c"
}

static void
music_browser_column_class_init (MusicBrowserColumnClass * klass,
                                 gpointer klass_data)
{
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	music_browser_column_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_type_class_adjust_private_offset (klass, &MusicBrowserColumn_private_offset);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_browser_column_get_property;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_browser_column_set_property;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	G_OBJECT_CLASS (klass)->finalize = music_browser_column_finalize;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_BROWSER_COLUMN_VISIBLE_PROPERTY, music_browser_column_properties[MUSIC_BROWSER_COLUMN_VISIBLE_PROPERTY] = g_param_spec_boolean ("visible", "visible", "visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_BROWSER_COLUMN_SHOW_SEPARATOR_PROPERTY, music_browser_column_properties[MUSIC_BROWSER_COLUMN_SHOW_SEPARATOR_PROPERTY] = g_param_spec_boolean ("show-separator", "show-separator", "show-separator", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_BROWSER_COLUMN_FIRST_ITEM_SELECTED_PROPERTY, music_browser_column_properties[MUSIC_BROWSER_COLUMN_FIRST_ITEM_SELECTED_PROPERTY] = g_param_spec_boolean ("first-item-selected", "first-item-selected", "first-item-selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_BROWSER_COLUMN_CATEGORY_PROPERTY, music_browser_column_properties[MUSIC_BROWSER_COLUMN_CATEGORY_PROPERTY] = g_param_spec_enum ("category", "category", "category", MUSIC_BROWSER_COLUMN_TYPE_CATEGORY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_BROWSER_COLUMN_MENU_ITEM_PROPERTY, music_browser_column_properties[MUSIC_BROWSER_COLUMN_MENU_ITEM_PROPERTY] = g_param_spec_object ("menu-item", "menu-item", "menu-item", gtk_check_menu_item_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	music_browser_column_signals[MUSIC_BROWSER_COLUMN_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", MUSIC_TYPE_BROWSER_COLUMN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_STRING, G_TYPE_NONE, 2, MUSIC_BROWSER_COLUMN_TYPE_CATEGORY, G_TYPE_STRING);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	music_browser_column_signals[MUSIC_BROWSER_COLUMN_ROW_ACTIVATED_SIGNAL] = g_signal_new ("row-activated", MUSIC_TYPE_BROWSER_COLUMN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	music_browser_column_signals[MUSIC_BROWSER_COLUMN_RESET_REQUESTED_SIGNAL] = g_signal_new ("reset-requested", MUSIC_TYPE_BROWSER_COLUMN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	music_browser_column_signals[MUSIC_BROWSER_COLUMN_HEADER_CLICKED_SIGNAL] = g_signal_new ("header-clicked", MUSIC_TYPE_BROWSER_COLUMN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, gdk_event_get_type ());
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	music_browser_column_signals[MUSIC_BROWSER_COLUMN_VISIBILITY_CHANGED_SIGNAL] = g_signal_new ("visibility-changed", MUSIC_TYPE_BROWSER_COLUMN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 1801 "BrowserColumn.c"
}

static void
music_browser_column_instance_init (MusicBrowserColumn * self,
                                    gpointer klass)
{
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	self->priv = music_browser_column_get_instance_private (self);
#line 1810 "BrowserColumn.c"
}

static void
music_browser_column_finalize (GObject * obj)
{
	MusicBrowserColumn * self;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_BROWSER_COLUMN, MusicBrowserColumn);
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_object_unref0 (self->priv->separator);
#line 120 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_object_unref0 (self->priv->_menu_item);
#line 122 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_object_unref0 (self->priv->miller_parent);
#line 124 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_object_unref0 (self->priv->view);
#line 125 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_object_unref0 (self->priv->model);
#line 128 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	_g_free0 (self->priv->_selected);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	G_OBJECT_CLASS (music_browser_column_parent_class)->finalize (obj);
#line 1833 "BrowserColumn.c"
}

static GType
music_browser_column_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicBrowserColumnClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_browser_column_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicBrowserColumn), 0, (GInstanceInitFunc) music_browser_column_instance_init, NULL };
	GType music_browser_column_type_id;
	music_browser_column_type_id = g_type_register_static (gtk_grid_get_type (), "MusicBrowserColumn", &g_define_type_info, 0);
	MusicBrowserColumn_private_offset = g_type_add_instance_private (music_browser_column_type_id, sizeof (MusicBrowserColumnPrivate));
	return music_browser_column_type_id;
}

GType
music_browser_column_get_type (void)
{
	static volatile gsize music_browser_column_type_id__once = 0;
	if (g_once_init_enter (&music_browser_column_type_id__once)) {
		GType music_browser_column_type_id;
		music_browser_column_type_id = music_browser_column_get_type_once ();
		g_once_init_leave (&music_browser_column_type_id__once, music_browser_column_type_id);
	}
	return music_browser_column_type_id__once;
}

static void
_vala_music_browser_column_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	MusicBrowserColumn * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_BROWSER_COLUMN, MusicBrowserColumn);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	switch (property_id) {
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		case MUSIC_BROWSER_COLUMN_VISIBLE_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		g_value_set_boolean (value, music_browser_column_get_visible (self));
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		case MUSIC_BROWSER_COLUMN_FIRST_ITEM_SELECTED_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		g_value_set_boolean (value, music_browser_column_get_first_item_selected (self));
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		g_value_set_enum (value, music_browser_column_get_category (self));
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		case MUSIC_BROWSER_COLUMN_MENU_ITEM_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		g_value_set_object (value, music_browser_column_get_menu_item (self));
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		break;
#line 1892 "BrowserColumn.c"
		default:
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		break;
#line 1898 "BrowserColumn.c"
	}
}

static void
_vala_music_browser_column_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	MusicBrowserColumn * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_BROWSER_COLUMN, MusicBrowserColumn);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
	switch (property_id) {
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		case MUSIC_BROWSER_COLUMN_VISIBLE_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		music_browser_column_set_visible (self, g_value_get_boolean (value));
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		case MUSIC_BROWSER_COLUMN_SHOW_SEPARATOR_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		music_browser_column_set_show_separator (self, g_value_get_boolean (value));
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		case MUSIC_BROWSER_COLUMN_CATEGORY_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		music_browser_column_set_category (self, g_value_get_enum (value));
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		case MUSIC_BROWSER_COLUMN_MENU_ITEM_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		music_browser_column_set_menu_item (self, g_value_get_object (value));
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		break;
#line 1936 "BrowserColumn.c"
		default:
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumn.vala"
		break;
#line 1942 "BrowserColumn.c"
	}
}

