/* ListView.c generated by valac 0.56.0, the Vala compiler
 * generated from ListView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include "music-lib.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>

enum  {
	MUSIC_LIST_VIEW_0_PROPERTY,
	MUSIC_LIST_VIEW_COLUMN_BROWSER_PROPERTY,
	MUSIC_LIST_VIEW_LIST_VIEW_PROPERTY,
	MUSIC_LIST_VIEW_VIEW_WRAPPER_PROPERTY,
	MUSIC_LIST_VIEW_N_MEDIA_PROPERTY,
	MUSIC_LIST_VIEW_HAS_COLUMN_BROWSER_PROPERTY,
	MUSIC_LIST_VIEW_COLUMN_BROWSER_ENABLED_PROPERTY,
	MUSIC_LIST_VIEW_NUM_PROPERTIES
};
static GParamSpec* music_list_view_properties[MUSIC_LIST_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	MUSIC_LIST_VIEW_REORDERED_SIGNAL,
	MUSIC_LIST_VIEW_NUM_SIGNALS
};
static guint music_list_view_signals[MUSIC_LIST_VIEW_NUM_SIGNALS] = {0};

struct _MusicListViewPrivate {
	GtkPaned* browser_pane;
	MusicColumnBrowser* _column_browser;
	MusicMusicListView* _list_view;
	MusicViewWrapper* _view_wrapper;
	gboolean obey_column_browser;
};

static gint MusicListView_private_offset;
static gpointer music_list_view_parent_class = NULL;
static MusicViewInterfaceIface * music_list_view_music_view_interface_parent_iface = NULL;

static void music_list_view_set_column_browser_position (MusicListView* self,
                                                  MusicColumnBrowserPosition position);
static void music_list_view_connect_column_browser_ui_signals (MusicListView* self);
static void __lambda71_ (MusicListView* self);
static void ___lambda71__gtk_widget_size_allocate (GtkWidget* _sender,
                                            GtkAllocation* allocation,
                                            gpointer self);
static void __lambda72_ (MusicListView* self);
static void ___lambda72__gtk_widget_size_allocate (GtkWidget* _sender,
                                            GtkAllocation* allocation,
                                            gpointer self);
static void __lambda73_ (MusicListView* self,
                  gboolean enabled);
static void music_list_view_set_column_browser_enabled (MusicListView* self,
                                                 gboolean value);
static void ___lambda73__music_widgets_view_selector_column_browser_toggled (MusicWidgetsViewSelector* _sender,
                                                                      gboolean new_value,
                                                                      gpointer self);
static void _music_list_view_set_column_browser_position_music_column_browser_position_changed (MusicColumnBrowser* _sender,
                                                                                         MusicColumnBrowserPosition p,
                                                                                         gpointer self);
static void music_list_view_save_column_browser_settings (MusicListView* self);
static void _music_list_view_save_column_browser_settings_gtk_widget_destroy (GtkWidget* _sender,
                                                                       gpointer self);
static GeeCollection* music_list_view_real_get_media (MusicViewInterface* base);
static GeeCollection* music_list_view_real_get_visible_media (MusicViewInterface* base);
static void music_list_view_column_browser_changed (MusicListView* self);
static void music_list_view_real_add_media (MusicViewInterface* base,
                                     GeeCollection* to_add);
static void music_list_view_real_remove_media (MusicViewInterface* base,
                                        GeeCollection* to_remove);
static void music_list_view_real_set_media (MusicViewInterface* base,
                                     GeeCollection* media);
static void music_list_view_real_update_media (MusicViewInterface* base,
                                        GeeCollection* media);
static void music_list_view_real_refilter (MusicViewInterface* base);
static void music_list_view_view_search_func (MusicListView* self,
                                       const gchar* search,
                                       GeeArrayList* table,
                                       GeeArrayList* showing);
static GObject * music_list_view_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _music_list_view___lambda74_ (MusicListView* self);
static void __music_list_view___lambda74__music_generic_list_rows_reordered (MusicGenericList* _sender,
                                                                      gpointer self);
static void _music_list_view___lambda75_ (MusicListView* self,
                                   GeeCollection* to_import);
static void __music_list_view___lambda75__music_generic_list_import_requested (MusicGenericList* _sender,
                                                                        GeeCollection* to_import,
                                                                        gpointer self);
static void _music_list_view_view_search_func_music_generic_list_view_search_func (const gchar* search,
                                                                            GeeArrayList* table,
                                                                            GeeArrayList* showing,
                                                                            gpointer self);
static void _music_list_view___lambda76_ (MusicListView* self);
static void __music_list_view___lambda76__music_library_search_finished (MusicLibrary* _sender,
                                                                  gpointer self);
static void _music_list_view_connect_column_browser_ui_signals_gtk_widget_realize (GtkWidget* _sender,
                                                                            gpointer self);
static void _music_list_view_column_browser_changed_music_column_browser_changed (MusicColumnBrowser* _sender,
                                                                           gpointer self);
static void music_list_view_finalize (GObject * obj);
static GType music_list_view_get_type_once (void);
static void _vala_music_list_view_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_music_list_view_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
music_list_view_get_instance_private (MusicListView* self)
{
	return G_STRUCT_MEMBER_P (self, MusicListView_private_offset);
}

MusicListView*
music_list_view_construct (GType object_type,
                           MusicViewWrapper* view_wrapper,
                           MusicTreeViewSetup* tvs,
                           gboolean add_browser)
{
	MusicListView * self = NULL;
	MusicColumnBrowser* _tmp0_ = NULL;
	MusicMusicListView* _tmp2_;
	MusicMusicListView* _tmp3_;
#line 78 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (view_wrapper != NULL, NULL);
#line 78 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (tvs != NULL, NULL);
#line 81 "../src/Views/ListView/ListView.vala"
	if (add_browser) {
#line 168 "ListView.c"
		MusicColumnBrowser* _tmp1_;
#line 81 "../src/Views/ListView/ListView.vala"
		_tmp1_ = music_column_browser_new (view_wrapper);
#line 81 "../src/Views/ListView/ListView.vala"
		g_object_ref_sink (_tmp1_);
#line 81 "../src/Views/ListView/ListView.vala"
		_g_object_unref0 (_tmp0_);
#line 81 "../src/Views/ListView/ListView.vala"
		_tmp0_ = _tmp1_;
#line 178 "ListView.c"
	} else {
#line 81 "../src/Views/ListView/ListView.vala"
		_g_object_unref0 (_tmp0_);
#line 81 "../src/Views/ListView/ListView.vala"
		_tmp0_ = NULL;
#line 184 "ListView.c"
	}
#line 79 "../src/Views/ListView/ListView.vala"
	_tmp2_ = music_music_list_view_new (view_wrapper, tvs);
#line 79 "../src/Views/ListView/ListView.vala"
	g_object_ref_sink (_tmp2_);
#line 79 "../src/Views/ListView/ListView.vala"
	_tmp3_ = _tmp2_;
#line 79 "../src/Views/ListView/ListView.vala"
	self = (MusicListView*) g_object_new (object_type, "view-wrapper", view_wrapper, "list-view", _tmp3_, "column-browser", _tmp0_, NULL);
#line 79 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (_tmp3_);
#line 78 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (_tmp0_);
#line 78 "../src/Views/ListView/ListView.vala"
	return self;
#line 200 "ListView.c"
}

MusicListView*
music_list_view_new (MusicViewWrapper* view_wrapper,
                     MusicTreeViewSetup* tvs,
                     gboolean add_browser)
{
#line 78 "../src/Views/ListView/ListView.vala"
	return music_list_view_construct (MUSIC_TYPE_LIST_VIEW, view_wrapper, tvs, add_browser);
#line 210 "ListView.c"
}

static void
music_list_view_set_column_browser_position (MusicListView* self,
                                             MusicColumnBrowserPosition position)
{
	MusicColumnBrowserPosition actual_position = 0;
	MusicColumnBrowser* _tmp20_;
#line 123 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 124 "../src/Views/ListView/ListView.vala"
	actual_position = position;
#line 126 "../src/Views/ListView/ListView.vala"
	if (actual_position == MUSIC_COLUMN_BROWSER_POSITION_AUTOMATIC) {
#line 225 "ListView.c"
		gint view_width = 0;
#line 130 "../src/Views/ListView/ListView.vala"
		static const gint MIN_RECOMMENDED_COLUMN_WIDTH = 160;
#line 229 "ListView.c"
		gint visible_columns = 0;
		gint required_width = 0;
		gint n_cols = 0;
		MusicMusicListView* _tmp11_;
		GList* _tmp12_;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		MusicMusicListView* _tmp19_;
#line 129 "../src/Views/ListView/ListView.vala"
		view_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 132 "../src/Views/ListView/ListView.vala"
		visible_columns = 0;
#line 242 "ListView.c"
		{
			GeeIterator* _column_it = NULL;
			MusicColumnBrowser* _tmp0_;
			GeeTreeSet* _tmp1_;
			GeeTreeSet* _tmp2_;
			GeeIterator* _tmp3_;
#line 133 "../src/Views/ListView/ListView.vala"
			_tmp0_ = self->priv->_column_browser;
#line 133 "../src/Views/ListView/ListView.vala"
			_tmp1_ = music_column_browser_get_columns (_tmp0_);
#line 133 "../src/Views/ListView/ListView.vala"
			_tmp2_ = _tmp1_;
#line 133 "../src/Views/ListView/ListView.vala"
			_tmp3_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp2_);
#line 133 "../src/Views/ListView/ListView.vala"
			_column_it = _tmp3_;
#line 133 "../src/Views/ListView/ListView.vala"
			while (TRUE) {
#line 261 "ListView.c"
				GeeIterator* _tmp4_;
				MusicBrowserColumn* column = NULL;
				GeeIterator* _tmp5_;
				gpointer _tmp6_;
				MusicBrowserColumn* _tmp7_;
				gboolean _tmp8_;
				gboolean _tmp9_;
#line 133 "../src/Views/ListView/ListView.vala"
				_tmp4_ = _column_it;
#line 133 "../src/Views/ListView/ListView.vala"
				if (!gee_iterator_next (_tmp4_)) {
#line 133 "../src/Views/ListView/ListView.vala"
					break;
#line 275 "ListView.c"
				}
#line 133 "../src/Views/ListView/ListView.vala"
				_tmp5_ = _column_it;
#line 133 "../src/Views/ListView/ListView.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 133 "../src/Views/ListView/ListView.vala"
				column = (MusicBrowserColumn*) _tmp6_;
#line 134 "../src/Views/ListView/ListView.vala"
				_tmp7_ = column;
#line 134 "../src/Views/ListView/ListView.vala"
				_tmp8_ = music_browser_column_get_visible (_tmp7_);
#line 134 "../src/Views/ListView/ListView.vala"
				_tmp9_ = _tmp8_;
#line 134 "../src/Views/ListView/ListView.vala"
				if (_tmp9_) {
#line 291 "ListView.c"
					gint _tmp10_;
#line 135 "../src/Views/ListView/ListView.vala"
					visible_columns = visible_columns + 1;
#line 135 "../src/Views/ListView/ListView.vala"
					_tmp10_ = visible_columns;
#line 297 "ListView.c"
				}
#line 133 "../src/Views/ListView/ListView.vala"
				_g_object_unref0 (column);
#line 301 "ListView.c"
			}
#line 133 "../src/Views/ListView/ListView.vala"
			_g_object_unref0 (_column_it);
#line 305 "ListView.c"
		}
#line 141 "../src/Views/ListView/ListView.vala"
		required_width = MIN_RECOMMENDED_COLUMN_WIDTH * visible_columns;
#line 142 "../src/Views/ListView/ListView.vala"
		n_cols = 0;
#line 143 "../src/Views/ListView/ListView.vala"
		_tmp11_ = self->priv->_list_view;
#line 143 "../src/Views/ListView/ListView.vala"
		_tmp12_ = gtk_tree_view_get_columns ((GtkTreeView*) _tmp11_);
#line 315 "ListView.c"
		{
			GList* column_collection = NULL;
			GList* column_it = NULL;
#line 143 "../src/Views/ListView/ListView.vala"
			column_collection = _tmp12_;
#line 143 "../src/Views/ListView/ListView.vala"
			for (column_it = column_collection; column_it != NULL; column_it = column_it->next) {
#line 323 "ListView.c"
				GtkTreeViewColumn* column = NULL;
#line 143 "../src/Views/ListView/ListView.vala"
				column = (GtkTreeViewColumn*) column_it->data;
#line 327 "ListView.c"
				{
					GtkTreeViewColumn* _tmp13_;
					gboolean _tmp14_;
					gboolean _tmp15_;
#line 144 "../src/Views/ListView/ListView.vala"
					_tmp13_ = column;
#line 144 "../src/Views/ListView/ListView.vala"
					_tmp14_ = gtk_tree_view_column_get_visible (_tmp13_);
#line 144 "../src/Views/ListView/ListView.vala"
					_tmp15_ = _tmp14_;
#line 144 "../src/Views/ListView/ListView.vala"
					if (_tmp15_) {
#line 340 "ListView.c"
						gint _tmp16_;
#line 145 "../src/Views/ListView/ListView.vala"
						_tmp16_ = n_cols;
#line 145 "../src/Views/ListView/ListView.vala"
						n_cols = _tmp16_ + 1;
#line 346 "ListView.c"
					}
				}
			}
#line 143 "../src/Views/ListView/ListView.vala"
			(column_collection == NULL) ? NULL : (column_collection = (g_list_free (column_collection), NULL));
#line 352 "ListView.c"
		}
#line 149 "../src/Views/ListView/ListView.vala"
		_tmp19_ = self->priv->_list_view;
#line 149 "../src/Views/ListView/ListView.vala"
		if ((view_width - required_width) < gtk_widget_get_allocated_width ((GtkWidget*) _tmp19_)) {
#line 149 "../src/Views/ListView/ListView.vala"
			_tmp18_ = n_cols > 2;
#line 360 "ListView.c"
		} else {
#line 149 "../src/Views/ListView/ListView.vala"
			_tmp18_ = FALSE;
#line 364 "ListView.c"
		}
#line 149 "../src/Views/ListView/ListView.vala"
		if (_tmp18_) {
#line 149 "../src/Views/ListView/ListView.vala"
			_tmp17_ = visible_columns > 2;
#line 370 "ListView.c"
		} else {
#line 149 "../src/Views/ListView/ListView.vala"
			_tmp17_ = FALSE;
#line 374 "ListView.c"
		}
#line 149 "../src/Views/ListView/ListView.vala"
		if (_tmp17_) {
#line 150 "../src/Views/ListView/ListView.vala"
			actual_position = MUSIC_COLUMN_BROWSER_POSITION_TOP;
#line 380 "ListView.c"
		} else {
#line 152 "../src/Views/ListView/ListView.vala"
			actual_position = MUSIC_COLUMN_BROWSER_POSITION_LEFT;
#line 384 "ListView.c"
		}
	}
#line 156 "../src/Views/ListView/ListView.vala"
	_tmp20_ = self->priv->_column_browser;
#line 156 "../src/Views/ListView/ListView.vala"
	music_column_browser_set_actual_position (_tmp20_, actual_position);
#line 158 "../src/Views/ListView/ListView.vala"
	if (actual_position == MUSIC_COLUMN_BROWSER_POSITION_LEFT) {
#line 393 "ListView.c"
		GtkPaned* _tmp21_;
		GtkPaned* _tmp22_;
		GSettings* _tmp23_;
		GSettings* _tmp24_;
		GtkPaned* _tmp25_;
#line 159 "../src/Views/ListView/ListView.vala"
		_tmp21_ = self->priv->browser_pane;
#line 159 "../src/Views/ListView/ListView.vala"
		g_settings_unbind ((GObject*) _tmp21_, "position");
#line 160 "../src/Views/ListView/ListView.vala"
		_tmp22_ = self->priv->browser_pane;
#line 160 "../src/Views/ListView/ListView.vala"
		gtk_orientable_set_orientation ((GtkOrientable*) _tmp22_, GTK_ORIENTATION_HORIZONTAL);
#line 161 "../src/Views/ListView/ListView.vala"
		_tmp23_ = music_app_get_saved_state ();
#line 161 "../src/Views/ListView/ListView.vala"
		_tmp24_ = _tmp23_;
#line 161 "../src/Views/ListView/ListView.vala"
		_tmp25_ = self->priv->browser_pane;
#line 161 "../src/Views/ListView/ListView.vala"
		g_settings_bind (_tmp24_, "column-browser-width", (GObject*) _tmp25_, "position", G_SETTINGS_BIND_DEFAULT);
#line 415 "ListView.c"
	} else {
#line 162 "../src/Views/ListView/ListView.vala"
		if (actual_position == MUSIC_COLUMN_BROWSER_POSITION_TOP) {
#line 419 "ListView.c"
			GtkPaned* _tmp26_;
			GtkPaned* _tmp27_;
			GSettings* _tmp28_;
			GSettings* _tmp29_;
			GtkPaned* _tmp30_;
#line 163 "../src/Views/ListView/ListView.vala"
			_tmp26_ = self->priv->browser_pane;
#line 163 "../src/Views/ListView/ListView.vala"
			g_settings_unbind ((GObject*) _tmp26_, "position");
#line 164 "../src/Views/ListView/ListView.vala"
			_tmp27_ = self->priv->browser_pane;
#line 164 "../src/Views/ListView/ListView.vala"
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp27_, GTK_ORIENTATION_VERTICAL);
#line 165 "../src/Views/ListView/ListView.vala"
			_tmp28_ = music_app_get_saved_state ();
#line 165 "../src/Views/ListView/ListView.vala"
			_tmp29_ = _tmp28_;
#line 165 "../src/Views/ListView/ListView.vala"
			_tmp30_ = self->priv->browser_pane;
#line 165 "../src/Views/ListView/ListView.vala"
			g_settings_bind (_tmp29_, "column-browser-height", (GObject*) _tmp30_, "position", G_SETTINGS_BIND_DEFAULT);
#line 441 "ListView.c"
		}
	}
}

static void
__lambda71_ (MusicListView* self)
{
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	MusicColumnBrowser* _tmp4_;
	MusicColumnBrowserPosition _tmp5_;
	MusicColumnBrowserPosition _tmp6_;
#line 176 "../src/Views/ListView/ListView.vala"
	_tmp0_ = music_app_get_main_window ();
#line 176 "../src/Views/ListView/ListView.vala"
	_tmp1_ = _tmp0_;
#line 176 "../src/Views/ListView/ListView.vala"
	_tmp2_ = music_library_window_get_initialization_finished (_tmp1_);
#line 176 "../src/Views/ListView/ListView.vala"
	_tmp3_ = _tmp2_;
#line 176 "../src/Views/ListView/ListView.vala"
	if (!_tmp3_) {
#line 177 "../src/Views/ListView/ListView.vala"
		return;
#line 468 "ListView.c"
	}
#line 180 "../src/Views/ListView/ListView.vala"
	_tmp4_ = self->priv->_column_browser;
#line 180 "../src/Views/ListView/ListView.vala"
	_tmp5_ = music_column_browser_get_position (_tmp4_);
#line 180 "../src/Views/ListView/ListView.vala"
	_tmp6_ = _tmp5_;
#line 180 "../src/Views/ListView/ListView.vala"
	if (_tmp6_ == MUSIC_COLUMN_BROWSER_POSITION_AUTOMATIC) {
#line 181 "../src/Views/ListView/ListView.vala"
		music_list_view_set_column_browser_position (self, MUSIC_COLUMN_BROWSER_POSITION_AUTOMATIC);
#line 480 "ListView.c"
	}
}

static void
___lambda71__gtk_widget_size_allocate (GtkWidget* _sender,
                                       GtkAllocation* allocation,
                                       gpointer self)
{
#line 175 "../src/Views/ListView/ListView.vala"
	__lambda71_ ((MusicListView*) self);
#line 491 "ListView.c"
}

static void
__lambda72_ (MusicListView* self)
{
	gboolean _tmp0_ = FALSE;
	MusicLibraryWindow* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 186 "../src/Views/ListView/ListView.vala"
	_tmp1_ = music_app_get_main_window ();
#line 186 "../src/Views/ListView/ListView.vala"
	_tmp2_ = _tmp1_;
#line 186 "../src/Views/ListView/ListView.vala"
	_tmp3_ = music_library_window_get_initialization_finished (_tmp2_);
#line 186 "../src/Views/ListView/ListView.vala"
	_tmp4_ = _tmp3_;
#line 186 "../src/Views/ListView/ListView.vala"
	if (!_tmp4_) {
#line 186 "../src/Views/ListView/ListView.vala"
		_tmp0_ = TRUE;
#line 514 "ListView.c"
	} else {
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 186 "../src/Views/ListView/ListView.vala"
		_tmp5_ = music_list_view_get_column_browser_enabled (self);
#line 186 "../src/Views/ListView/ListView.vala"
		_tmp6_ = _tmp5_;
#line 186 "../src/Views/ListView/ListView.vala"
		_tmp0_ = !_tmp6_;
#line 524 "ListView.c"
	}
#line 186 "../src/Views/ListView/ListView.vala"
	if (_tmp0_) {
#line 187 "../src/Views/ListView/ListView.vala"
		return;
#line 530 "ListView.c"
	}
}

static void
___lambda72__gtk_widget_size_allocate (GtkWidget* _sender,
                                       GtkAllocation* allocation,
                                       gpointer self)
{
#line 185 "../src/Views/ListView/ListView.vala"
	__lambda72_ ((MusicListView*) self);
#line 541 "ListView.c"
}

static void
__lambda73_ (MusicListView* self,
             gboolean enabled)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 192 "../src/Views/ListView/ListView.vala"
	_tmp0_ = music_list_view_get_column_browser_enabled (self);
#line 192 "../src/Views/ListView/ListView.vala"
	_tmp1_ = _tmp0_;
#line 192 "../src/Views/ListView/ListView.vala"
	if (enabled != _tmp1_) {
#line 193 "../src/Views/ListView/ListView.vala"
		music_list_view_set_column_browser_enabled (self, enabled);
#line 558 "ListView.c"
	}
}

static void
___lambda73__music_widgets_view_selector_column_browser_toggled (MusicWidgetsViewSelector* _sender,
                                                                 gboolean new_value,
                                                                 gpointer self)
{
#line 191 "../src/Views/ListView/ListView.vala"
	__lambda73_ ((MusicListView*) self, new_value);
#line 569 "ListView.c"
}

static void
_music_list_view_set_column_browser_position_music_column_browser_position_changed (MusicColumnBrowser* _sender,
                                                                                    MusicColumnBrowserPosition p,
                                                                                    gpointer self)
{
#line 197 "../src/Views/ListView/ListView.vala"
	music_list_view_set_column_browser_position ((MusicListView*) self, p);
#line 579 "ListView.c"
}

static void
_music_list_view_save_column_browser_settings_gtk_widget_destroy (GtkWidget* _sender,
                                                                  gpointer self)
{
#line 201 "../src/Views/ListView/ListView.vala"
	music_list_view_save_column_browser_settings ((MusicListView*) self);
#line 588 "ListView.c"
}

static void
music_list_view_connect_column_browser_ui_signals (MusicListView* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	MusicColumnBrowser* _tmp2_;
	MusicLibraryWindow* _tmp3_;
	MusicLibraryWindow* _tmp4_;
	MusicWidgetsViewSelector* _tmp5_;
	MusicWidgetsViewSelector* _tmp6_;
	MusicColumnBrowser* _tmp7_;
#line 169 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/Views/ListView/ListView.vala"
	_tmp0_ = music_list_view_get_has_column_browser (self);
#line 170 "../src/Views/ListView/ListView.vala"
	_tmp1_ = _tmp0_;
#line 170 "../src/Views/ListView/ListView.vala"
	if (!_tmp1_) {
#line 171 "../src/Views/ListView/ListView.vala"
		return;
#line 612 "ListView.c"
	}
#line 175 "../src/Views/ListView/ListView.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) ___lambda71__gtk_widget_size_allocate, self, 0);
#line 185 "../src/Views/ListView/ListView.vala"
	_tmp2_ = self->priv->_column_browser;
#line 185 "../src/Views/ListView/ListView.vala"
	g_signal_connect_object ((GtkWidget*) _tmp2_, "size-allocate", (GCallback) ___lambda72__gtk_widget_size_allocate, self, 0);
#line 191 "../src/Views/ListView/ListView.vala"
	_tmp3_ = music_app_get_main_window ();
#line 191 "../src/Views/ListView/ListView.vala"
	_tmp4_ = _tmp3_;
#line 191 "../src/Views/ListView/ListView.vala"
	_tmp5_ = music_library_window_get_view_selector (_tmp4_);
#line 191 "../src/Views/ListView/ListView.vala"
	_tmp6_ = _tmp5_;
#line 191 "../src/Views/ListView/ListView.vala"
	g_signal_connect_object (_tmp6_, "column-browser-toggled", (GCallback) ___lambda73__music_widgets_view_selector_column_browser_toggled, self, 0);
#line 197 "../src/Views/ListView/ListView.vala"
	_tmp7_ = self->priv->_column_browser;
#line 197 "../src/Views/ListView/ListView.vala"
	g_signal_connect_object (_tmp7_, "position-changed", (GCallback) _music_list_view_set_column_browser_position_music_column_browser_position_changed, self, 0);
#line 201 "../src/Views/ListView/ListView.vala"
	g_signal_connect_object ((GtkWidget*) self, "destroy", (GCallback) _music_list_view_save_column_browser_settings_gtk_widget_destroy, self, 0);
#line 636 "ListView.c"
}

static void
music_list_view_save_column_browser_settings (MusicListView* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 204 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/Views/ListView/ListView.vala"
	_tmp0_ = music_list_view_get_has_column_browser (self);
#line 206 "../src/Views/ListView/ListView.vala"
	_tmp1_ = _tmp0_;
#line 206 "../src/Views/ListView/ListView.vala"
	if (_tmp1_) {
#line 652 "ListView.c"
		GSettings* _tmp2_;
		GSettings* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 207 "../src/Views/ListView/ListView.vala"
		_tmp2_ = music_app_get_saved_state ();
#line 207 "../src/Views/ListView/ListView.vala"
		_tmp3_ = _tmp2_;
#line 207 "../src/Views/ListView/ListView.vala"
		_tmp4_ = music_list_view_get_column_browser_enabled (self);
#line 207 "../src/Views/ListView/ListView.vala"
		_tmp5_ = _tmp4_;
#line 207 "../src/Views/ListView/ListView.vala"
		g_settings_set_boolean (_tmp3_, "column-browser-enabled", _tmp5_);
#line 667 "ListView.c"
	}
}

/**
     * ContentView interface methods
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 216 "../src/Views/ListView/ListView.vala"
	return self ? g_object_ref (self) : NULL;
#line 679 "ListView.c"
}

MusicPlaylist*
music_list_view_get_playlist (MusicListView* self)
{
	MusicMusicListView* _tmp0_;
	MusicPlaylist* _tmp1_;
	MusicPlaylist* _tmp2_;
	MusicPlaylist* _tmp3_;
	MusicPlaylist* result;
#line 215 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 216 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 216 "../src/Views/ListView/ListView.vala"
	_tmp1_ = music_generic_list_get_playlist ((MusicGenericList*) _tmp0_);
#line 216 "../src/Views/ListView/ListView.vala"
	_tmp2_ = _tmp1_;
#line 216 "../src/Views/ListView/ListView.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 216 "../src/Views/ListView/ListView.vala"
	result = _tmp3_;
#line 216 "../src/Views/ListView/ListView.vala"
	return result;
#line 704 "ListView.c"
}

static GeeCollection*
music_list_view_real_get_media (MusicViewInterface* base)
{
	MusicListView * self;
	GeeArrayList* media = NULL;
	GeeArrayList* _tmp0_;
	MusicMusicListView* _tmp1_;
	GeeBidirList* _tmp2_;
	GeeBidirList* _tmp3_;
	GeeCollection* result;
#line 219 "../src/Views/ListView/ListView.vala"
	self = (MusicListView*) base;
#line 220 "../src/Views/ListView/ListView.vala"
	_tmp0_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 220 "../src/Views/ListView/ListView.vala"
	media = _tmp0_;
#line 221 "../src/Views/ListView/ListView.vala"
	_tmp1_ = self->priv->_list_view;
#line 221 "../src/Views/ListView/ListView.vala"
	_tmp2_ = music_generic_list_get_table ((MusicGenericList*) _tmp1_);
#line 221 "../src/Views/ListView/ListView.vala"
	_tmp3_ = _tmp2_;
#line 221 "../src/Views/ListView/ListView.vala"
	gee_array_list_add_all (media, (GeeCollection*) _tmp3_);
#line 221 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (_tmp3_);
#line 222 "../src/Views/ListView/ListView.vala"
	result = (GeeCollection*) media;
#line 222 "../src/Views/ListView/ListView.vala"
	return result;
#line 737 "ListView.c"
}

static GeeCollection*
music_list_view_real_get_visible_media (MusicViewInterface* base)
{
	MusicListView * self;
	GeeArrayList* media = NULL;
	GeeArrayList* _tmp0_;
	MusicMusicListView* _tmp1_;
	GeeBidirList* _tmp2_;
	GeeBidirList* _tmp3_;
	GeeCollection* result;
#line 225 "../src/Views/ListView/ListView.vala"
	self = (MusicListView*) base;
#line 226 "../src/Views/ListView/ListView.vala"
	_tmp0_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 226 "../src/Views/ListView/ListView.vala"
	media = _tmp0_;
#line 227 "../src/Views/ListView/ListView.vala"
	_tmp1_ = self->priv->_list_view;
#line 227 "../src/Views/ListView/ListView.vala"
	_tmp2_ = music_generic_list_get_visible_table ((MusicGenericList*) _tmp1_);
#line 227 "../src/Views/ListView/ListView.vala"
	_tmp3_ = _tmp2_;
#line 227 "../src/Views/ListView/ListView.vala"
	gee_array_list_add_all (media, (GeeCollection*) _tmp3_);
#line 227 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (_tmp3_);
#line 228 "../src/Views/ListView/ListView.vala"
	result = (GeeCollection*) media;
#line 228 "../src/Views/ListView/ListView.vala"
	return result;
#line 770 "ListView.c"
}

static void
music_list_view_column_browser_changed (MusicListView* self)
{
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 231 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 232 "../src/Views/ListView/ListView.vala"
	_tmp0_ = music_app_get_main_window ();
#line 232 "../src/Views/ListView/ListView.vala"
	_tmp1_ = _tmp0_;
#line 232 "../src/Views/ListView/ListView.vala"
	_tmp2_ = music_library_window_get_initialization_finished (_tmp1_);
#line 232 "../src/Views/ListView/ListView.vala"
	_tmp3_ = _tmp2_;
#line 232 "../src/Views/ListView/ListView.vala"
	if (_tmp3_) {
#line 792 "ListView.c"
		MusicMusicListView* _tmp4_;
#line 234 "../src/Views/ListView/ListView.vala"
		_tmp4_ = self->priv->_list_view;
#line 234 "../src/Views/ListView/ListView.vala"
		music_generic_list_do_search ((MusicGenericList*) _tmp4_, NULL);
#line 798 "ListView.c"
	}
}

void
music_list_view_set_as_current_list (MusicListView* self,
                                     gint media_id)
{
	MusicMusicListView* _tmp0_;
	MusicViewWrapper* _tmp1_;
	MusicLibrary* _tmp2_;
	MusicLibrary* _tmp3_;
	MusicMedia* _tmp4_;
	MusicMedia* _tmp5_;
#line 238 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 239 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 239 "../src/Views/ListView/ListView.vala"
	_tmp1_ = self->priv->_view_wrapper;
#line 239 "../src/Views/ListView/ListView.vala"
	_tmp2_ = music_view_wrapper_get_library (_tmp1_);
#line 239 "../src/Views/ListView/ListView.vala"
	_tmp3_ = _tmp2_;
#line 239 "../src/Views/ListView/ListView.vala"
	_tmp4_ = music_library_media_from_id (_tmp3_, (gint64) media_id);
#line 239 "../src/Views/ListView/ListView.vala"
	_tmp5_ = _tmp4_;
#line 239 "../src/Views/ListView/ListView.vala"
	music_generic_list_set_as_current_list ((MusicGenericList*) _tmp0_, _tmp5_);
#line 239 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (_tmp5_);
#line 830 "ListView.c"
}

gboolean
music_list_view_get_is_current_list (MusicListView* self)
{
	MusicMusicListView* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 242 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 243 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 243 "../src/Views/ListView/ListView.vala"
	_tmp1_ = music_generic_list_get_is_current_list ((MusicGenericList*) _tmp0_);
#line 243 "../src/Views/ListView/ListView.vala"
	_tmp2_ = _tmp1_;
#line 243 "../src/Views/ListView/ListView.vala"
	result = _tmp2_;
#line 243 "../src/Views/ListView/ListView.vala"
	return result;
#line 852 "ListView.c"
}

static void
music_list_view_real_add_media (MusicViewInterface* base,
                                GeeCollection* to_add)
{
	MusicListView * self;
	MusicMusicListView* _tmp0_;
	MusicMusicListView* _tmp1_;
#line 246 "../src/Views/ListView/ListView.vala"
	self = (MusicListView*) base;
#line 246 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (to_add != NULL);
#line 247 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 247 "../src/Views/ListView/ListView.vala"
	music_music_list_view_add_media (_tmp0_, to_add);
#line 248 "../src/Views/ListView/ListView.vala"
	_tmp1_ = self->priv->_list_view;
#line 248 "../src/Views/ListView/ListView.vala"
	music_generic_list_set_research_needed ((MusicGenericList*) _tmp1_, TRUE);
#line 249 "../src/Views/ListView/ListView.vala"
	music_view_interface_refilter ((MusicViewInterface*) self);
#line 876 "ListView.c"
}

static void
music_list_view_real_remove_media (MusicViewInterface* base,
                                   GeeCollection* to_remove)
{
	MusicListView * self;
	MusicMusicListView* _tmp0_;
	MusicMusicListView* _tmp1_;
#line 252 "../src/Views/ListView/ListView.vala"
	self = (MusicListView*) base;
#line 252 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (to_remove != NULL);
#line 253 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 253 "../src/Views/ListView/ListView.vala"
	music_music_list_view_remove_media (_tmp0_, to_remove);
#line 254 "../src/Views/ListView/ListView.vala"
	_tmp1_ = self->priv->_list_view;
#line 254 "../src/Views/ListView/ListView.vala"
	music_generic_list_set_research_needed ((MusicGenericList*) _tmp1_, TRUE);
#line 255 "../src/Views/ListView/ListView.vala"
	music_view_interface_refilter ((MusicViewInterface*) self);
#line 900 "ListView.c"
}

static void
music_list_view_real_set_media (MusicViewInterface* base,
                                GeeCollection* media)
{
	MusicListView * self;
	MusicMusicListView* _tmp0_;
	MusicMusicListView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 258 "../src/Views/ListView/ListView.vala"
	self = (MusicListView*) base;
#line 258 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (media != NULL);
#line 259 "../src/Views/ListView/ListView.vala"
	self->priv->obey_column_browser = FALSE;
#line 261 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 261 "../src/Views/ListView/ListView.vala"
	music_generic_list_set_media ((MusicGenericList*) _tmp0_, media);
#line 262 "../src/Views/ListView/ListView.vala"
	_tmp1_ = self->priv->_list_view;
#line 262 "../src/Views/ListView/ListView.vala"
	music_generic_list_set_research_needed ((MusicGenericList*) _tmp1_, TRUE);
#line 264 "../src/Views/ListView/ListView.vala"
	_tmp2_ = music_list_view_get_has_column_browser (self);
#line 264 "../src/Views/ListView/ListView.vala"
	_tmp3_ = _tmp2_;
#line 264 "../src/Views/ListView/ListView.vala"
	if (_tmp3_) {
#line 932 "ListView.c"
		MusicColumnBrowser* _tmp4_;
#line 265 "../src/Views/ListView/ListView.vala"
		_tmp4_ = self->priv->_column_browser;
#line 265 "../src/Views/ListView/ListView.vala"
		music_column_browser_set_media (_tmp4_, media);
#line 938 "ListView.c"
	}
#line 268 "../src/Views/ListView/ListView.vala"
	self->priv->obey_column_browser = TRUE;
#line 942 "ListView.c"
}

static void
music_list_view_real_update_media (MusicViewInterface* base,
                                   GeeCollection* media)
{
	MusicListView * self;
#line 271 "../src/Views/ListView/ListView.vala"
	self = (MusicListView*) base;
#line 271 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (media != NULL);
#line 272 "../src/Views/ListView/ListView.vala"
	music_view_interface_refilter ((MusicViewInterface*) self);
#line 956 "ListView.c"
}

static void
music_list_view_real_refilter (MusicViewInterface* base)
{
	MusicListView * self;
	MusicMusicListView* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 275 "../src/Views/ListView/ListView.vala"
	self = (MusicListView*) base;
#line 286 "../src/Views/ListView/ListView.vala"
	self->priv->obey_column_browser = FALSE;
#line 287 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 287 "../src/Views/ListView/ListView.vala"
	music_generic_list_do_search ((MusicGenericList*) _tmp0_, NULL);
#line 288 "../src/Views/ListView/ListView.vala"
	self->priv->obey_column_browser = TRUE;
#line 290 "../src/Views/ListView/ListView.vala"
	_tmp1_ = music_list_view_get_has_column_browser (self);
#line 290 "../src/Views/ListView/ListView.vala"
	_tmp2_ = _tmp1_;
#line 290 "../src/Views/ListView/ListView.vala"
	if (_tmp2_) {
#line 982 "ListView.c"
		MusicColumnBrowser* _tmp3_;
		MusicViewWrapper* _tmp4_;
		MusicLibrary* _tmp5_;
		MusicLibrary* _tmp6_;
		GeeCollection* _tmp7_;
		GeeCollection* _tmp8_;
#line 291 "../src/Views/ListView/ListView.vala"
		_tmp3_ = self->priv->_column_browser;
#line 291 "../src/Views/ListView/ListView.vala"
		_tmp4_ = self->priv->_view_wrapper;
#line 291 "../src/Views/ListView/ListView.vala"
		_tmp5_ = music_view_wrapper_get_library (_tmp4_);
#line 291 "../src/Views/ListView/ListView.vala"
		_tmp6_ = _tmp5_;
#line 291 "../src/Views/ListView/ListView.vala"
		_tmp7_ = music_library_get_search_result (_tmp6_);
#line 291 "../src/Views/ListView/ListView.vala"
		_tmp8_ = _tmp7_;
#line 291 "../src/Views/ListView/ListView.vala"
		music_column_browser_set_media (_tmp3_, _tmp8_);
#line 291 "../src/Views/ListView/ListView.vala"
		_g_object_unref0 (_tmp8_);
#line 1005 "ListView.c"
	}
}

static void
music_list_view_view_search_func (MusicListView* self,
                                  const gchar* search,
                                  GeeArrayList* table,
                                  GeeArrayList* showing)
{
	GeeCollection* _result_ = NULL;
	MusicViewWrapper* _tmp0_;
	MusicLibrary* _tmp1_;
	MusicLibrary* _tmp2_;
	GeeCollection* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean obey_column_browser = FALSE;
	GeeCollection* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	MusicViewWrapper* _tmp10_;
	MusicLibrary* _tmp11_;
	MusicLibrary* _tmp12_;
	GeeCollection* _tmp13_;
	GeeCollection* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp42_ = FALSE;
	gint _tmp43_;
	gint _tmp44_;
#line 294 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 294 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (search != NULL);
#line 294 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (table != NULL);
#line 294 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (showing != NULL);
#line 295 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_view_wrapper;
#line 295 "../src/Views/ListView/ListView.vala"
	_tmp1_ = music_view_wrapper_get_library (_tmp0_);
#line 295 "../src/Views/ListView/ListView.vala"
	_tmp2_ = _tmp1_;
#line 295 "../src/Views/ListView/ListView.vala"
	_tmp3_ = music_library_get_search_result (_tmp2_);
#line 295 "../src/Views/ListView/ListView.vala"
	_result_ = _tmp3_;
#line 300 "../src/Views/ListView/ListView.vala"
	_tmp5_ = music_list_view_get_column_browser_enabled (self);
#line 300 "../src/Views/ListView/ListView.vala"
	_tmp6_ = _tmp5_;
#line 300 "../src/Views/ListView/ListView.vala"
	if (_tmp6_) {
#line 300 "../src/Views/ListView/ListView.vala"
		_tmp4_ = self->priv->obey_column_browser;
#line 1064 "ListView.c"
	} else {
#line 300 "../src/Views/ListView/ListView.vala"
		_tmp4_ = FALSE;
#line 1068 "ListView.c"
	}
#line 300 "../src/Views/ListView/ListView.vala"
	obey_column_browser = _tmp4_;
#line 302 "../src/Views/ListView/ListView.vala"
	_tmp7_ = _result_;
#line 302 "../src/Views/ListView/ListView.vala"
	_tmp8_ = gee_collection_get_size (_tmp7_);
#line 302 "../src/Views/ListView/ListView.vala"
	_tmp9_ = _tmp8_;
#line 302 "../src/Views/ListView/ListView.vala"
	_tmp10_ = self->priv->_view_wrapper;
#line 302 "../src/Views/ListView/ListView.vala"
	_tmp11_ = music_view_wrapper_get_library (_tmp10_);
#line 302 "../src/Views/ListView/ListView.vala"
	_tmp12_ = _tmp11_;
#line 302 "../src/Views/ListView/ListView.vala"
	_tmp13_ = music_library_get_medias (_tmp12_);
#line 302 "../src/Views/ListView/ListView.vala"
	_tmp14_ = _tmp13_;
#line 302 "../src/Views/ListView/ListView.vala"
	_tmp15_ = gee_collection_get_size (_tmp14_);
#line 302 "../src/Views/ListView/ListView.vala"
	_tmp16_ = _tmp15_;
#line 302 "../src/Views/ListView/ListView.vala"
	_tmp17_ = _tmp9_ != _tmp16_;
#line 302 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (_tmp14_);
#line 302 "../src/Views/ListView/ListView.vala"
	if (_tmp17_) {
#line 1098 "ListView.c"
		{
			GeeArrayList* _m_list = NULL;
			gint _m_size = 0;
			GeeArrayList* _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			gint _m_index = 0;
#line 303 "../src/Views/ListView/ListView.vala"
			_m_list = table;
#line 303 "../src/Views/ListView/ListView.vala"
			_tmp18_ = _m_list;
#line 303 "../src/Views/ListView/ListView.vala"
			_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 303 "../src/Views/ListView/ListView.vala"
			_tmp20_ = _tmp19_;
#line 303 "../src/Views/ListView/ListView.vala"
			_m_size = _tmp20_;
#line 303 "../src/Views/ListView/ListView.vala"
			_m_index = -1;
#line 303 "../src/Views/ListView/ListView.vala"
			while (TRUE) {
#line 1120 "ListView.c"
				gint _tmp21_;
				gint _tmp22_;
				MusicMedia* m = NULL;
				GeeArrayList* _tmp23_;
				gpointer _tmp24_;
				gboolean _tmp25_ = FALSE;
				GeeCollection* _tmp28_;
				MusicMedia* _tmp29_;
#line 303 "../src/Views/ListView/ListView.vala"
				_m_index = _m_index + 1;
#line 303 "../src/Views/ListView/ListView.vala"
				_tmp21_ = _m_index;
#line 303 "../src/Views/ListView/ListView.vala"
				_tmp22_ = _m_size;
#line 303 "../src/Views/ListView/ListView.vala"
				if (!(_tmp21_ < _tmp22_)) {
#line 303 "../src/Views/ListView/ListView.vala"
					break;
#line 1139 "ListView.c"
				}
#line 303 "../src/Views/ListView/ListView.vala"
				_tmp23_ = _m_list;
#line 303 "../src/Views/ListView/ListView.vala"
				_tmp24_ = gee_abstract_list_get ((GeeAbstractList*) _tmp23_, _m_index);
#line 303 "../src/Views/ListView/ListView.vala"
				m = (MusicMedia*) _tmp24_;
#line 304 "../src/Views/ListView/ListView.vala"
				if (obey_column_browser) {
#line 1149 "ListView.c"
					MusicColumnBrowser* _tmp26_;
					MusicMedia* _tmp27_;
#line 304 "../src/Views/ListView/ListView.vala"
					_tmp26_ = self->priv->_column_browser;
#line 304 "../src/Views/ListView/ListView.vala"
					_tmp27_ = m;
#line 304 "../src/Views/ListView/ListView.vala"
					_tmp25_ = !music_column_browser_match_media (_tmp26_, _tmp27_);
#line 1158 "ListView.c"
				} else {
#line 304 "../src/Views/ListView/ListView.vala"
					_tmp25_ = FALSE;
#line 1162 "ListView.c"
				}
#line 304 "../src/Views/ListView/ListView.vala"
				if (_tmp25_) {
#line 305 "../src/Views/ListView/ListView.vala"
					_g_object_unref0 (m);
#line 305 "../src/Views/ListView/ListView.vala"
					continue;
#line 1170 "ListView.c"
				}
#line 308 "../src/Views/ListView/ListView.vala"
				_tmp28_ = _result_;
#line 308 "../src/Views/ListView/ListView.vala"
				_tmp29_ = m;
#line 308 "../src/Views/ListView/ListView.vala"
				if (gee_collection_contains (_tmp28_, _tmp29_)) {
#line 1178 "ListView.c"
					MusicMedia* _tmp30_;
#line 309 "../src/Views/ListView/ListView.vala"
					_tmp30_ = m;
#line 309 "../src/Views/ListView/ListView.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) showing, _tmp30_);
#line 1184 "ListView.c"
				}
#line 303 "../src/Views/ListView/ListView.vala"
				_g_object_unref0 (m);
#line 1188 "ListView.c"
			}
		}
	} else {
		{
			GeeArrayList* _m_list = NULL;
			gint _m_size = 0;
			GeeArrayList* _tmp31_;
			gint _tmp32_;
			gint _tmp33_;
			gint _m_index = 0;
#line 313 "../src/Views/ListView/ListView.vala"
			_m_list = table;
#line 313 "../src/Views/ListView/ListView.vala"
			_tmp31_ = _m_list;
#line 313 "../src/Views/ListView/ListView.vala"
			_tmp32_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp31_);
#line 313 "../src/Views/ListView/ListView.vala"
			_tmp33_ = _tmp32_;
#line 313 "../src/Views/ListView/ListView.vala"
			_m_size = _tmp33_;
#line 313 "../src/Views/ListView/ListView.vala"
			_m_index = -1;
#line 313 "../src/Views/ListView/ListView.vala"
			while (TRUE) {
#line 1213 "ListView.c"
				gint _tmp34_;
				gint _tmp35_;
				MusicMedia* m = NULL;
				GeeArrayList* _tmp36_;
				gpointer _tmp37_;
				gboolean _tmp38_ = FALSE;
				MusicMedia* _tmp41_;
#line 313 "../src/Views/ListView/ListView.vala"
				_m_index = _m_index + 1;
#line 313 "../src/Views/ListView/ListView.vala"
				_tmp34_ = _m_index;
#line 313 "../src/Views/ListView/ListView.vala"
				_tmp35_ = _m_size;
#line 313 "../src/Views/ListView/ListView.vala"
				if (!(_tmp34_ < _tmp35_)) {
#line 313 "../src/Views/ListView/ListView.vala"
					break;
#line 1231 "ListView.c"
				}
#line 313 "../src/Views/ListView/ListView.vala"
				_tmp36_ = _m_list;
#line 313 "../src/Views/ListView/ListView.vala"
				_tmp37_ = gee_abstract_list_get ((GeeAbstractList*) _tmp36_, _m_index);
#line 313 "../src/Views/ListView/ListView.vala"
				m = (MusicMedia*) _tmp37_;
#line 314 "../src/Views/ListView/ListView.vala"
				if (obey_column_browser) {
#line 1241 "ListView.c"
					MusicColumnBrowser* _tmp39_;
					MusicMedia* _tmp40_;
#line 314 "../src/Views/ListView/ListView.vala"
					_tmp39_ = self->priv->_column_browser;
#line 314 "../src/Views/ListView/ListView.vala"
					_tmp40_ = m;
#line 314 "../src/Views/ListView/ListView.vala"
					_tmp38_ = !music_column_browser_match_media (_tmp39_, _tmp40_);
#line 1250 "ListView.c"
				} else {
#line 314 "../src/Views/ListView/ListView.vala"
					_tmp38_ = FALSE;
#line 1254 "ListView.c"
				}
#line 314 "../src/Views/ListView/ListView.vala"
				if (_tmp38_) {
#line 315 "../src/Views/ListView/ListView.vala"
					_g_object_unref0 (m);
#line 315 "../src/Views/ListView/ListView.vala"
					continue;
#line 1262 "ListView.c"
				}
#line 318 "../src/Views/ListView/ListView.vala"
				_tmp41_ = m;
#line 318 "../src/Views/ListView/ListView.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) showing, _tmp41_);
#line 313 "../src/Views/ListView/ListView.vala"
				_g_object_unref0 (m);
#line 1270 "ListView.c"
			}
		}
	}
#line 323 "../src/Views/ListView/ListView.vala"
	_tmp43_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) showing);
#line 323 "../src/Views/ListView/ListView.vala"
	_tmp44_ = _tmp43_;
#line 323 "../src/Views/ListView/ListView.vala"
	if (_tmp44_ < 1) {
#line 323 "../src/Views/ListView/ListView.vala"
		_tmp42_ = g_strcmp0 (search, "") != 0;
#line 1282 "ListView.c"
	} else {
#line 323 "../src/Views/ListView/ListView.vala"
		_tmp42_ = FALSE;
#line 1286 "ListView.c"
	}
#line 323 "../src/Views/ListView/ListView.vala"
	if (_tmp42_) {
#line 1290 "ListView.c"
		MusicLibraryWindow* _tmp45_;
		MusicLibraryWindow* _tmp46_;
		MusicViewStack* _tmp47_;
		MusicViewStack* _tmp48_;
#line 324 "../src/Views/ListView/ListView.vala"
		_tmp45_ = music_app_get_main_window ();
#line 324 "../src/Views/ListView/ListView.vala"
		_tmp46_ = _tmp45_;
#line 324 "../src/Views/ListView/ListView.vala"
		_tmp47_ = music_library_window_get_view_stack (_tmp46_);
#line 324 "../src/Views/ListView/ListView.vala"
		_tmp48_ = _tmp47_;
#line 324 "../src/Views/ListView/ListView.vala"
		music_view_stack_show_alert (_tmp48_);
#line 1305 "ListView.c"
	}
#line 294 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (_result_);
#line 1309 "ListView.c"
}

MusicColumnBrowser*
music_list_view_get_column_browser (MusicListView* self)
{
	MusicColumnBrowser* result;
	MusicColumnBrowser* _tmp0_;
#line 38 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_column_browser;
#line 38 "../src/Views/ListView/ListView.vala"
	result = _tmp0_;
#line 38 "../src/Views/ListView/ListView.vala"
	return result;
#line 1325 "ListView.c"
}

void
music_list_view_set_column_browser (MusicListView* self,
                                    MusicColumnBrowser* value)
{
	MusicColumnBrowser* old_value;
#line 38 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Views/ListView/ListView.vala"
	old_value = music_list_view_get_column_browser (self);
#line 38 "../src/Views/ListView/ListView.vala"
	if (old_value != value) {
#line 1339 "ListView.c"
		MusicColumnBrowser* _tmp0_;
#line 38 "../src/Views/ListView/ListView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 38 "../src/Views/ListView/ListView.vala"
		_g_object_unref0 (self->priv->_column_browser);
#line 38 "../src/Views/ListView/ListView.vala"
		self->priv->_column_browser = _tmp0_;
#line 38 "../src/Views/ListView/ListView.vala"
		g_object_notify_by_pspec ((GObject *) self, music_list_view_properties[MUSIC_LIST_VIEW_COLUMN_BROWSER_PROPERTY]);
#line 1349 "ListView.c"
	}
}

MusicMusicListView*
music_list_view_get_list_view (MusicListView* self)
{
	MusicMusicListView* result;
	MusicMusicListView* _tmp0_;
#line 39 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 39 "../src/Views/ListView/ListView.vala"
	result = _tmp0_;
#line 39 "../src/Views/ListView/ListView.vala"
	return result;
#line 1366 "ListView.c"
}

void
music_list_view_set_list_view (MusicListView* self,
                               MusicMusicListView* value)
{
	MusicMusicListView* old_value;
#line 39 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Views/ListView/ListView.vala"
	old_value = music_list_view_get_list_view (self);
#line 39 "../src/Views/ListView/ListView.vala"
	if (old_value != value) {
#line 1380 "ListView.c"
		MusicMusicListView* _tmp0_;
#line 39 "../src/Views/ListView/ListView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 39 "../src/Views/ListView/ListView.vala"
		_g_object_unref0 (self->priv->_list_view);
#line 39 "../src/Views/ListView/ListView.vala"
		self->priv->_list_view = _tmp0_;
#line 39 "../src/Views/ListView/ListView.vala"
		g_object_notify_by_pspec ((GObject *) self, music_list_view_properties[MUSIC_LIST_VIEW_LIST_VIEW_PROPERTY]);
#line 1390 "ListView.c"
	}
}

MusicViewWrapper*
music_list_view_get_view_wrapper (MusicListView* self)
{
	MusicViewWrapper* result;
	MusicViewWrapper* _tmp0_;
#line 41 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_view_wrapper;
#line 41 "../src/Views/ListView/ListView.vala"
	result = _tmp0_;
#line 41 "../src/Views/ListView/ListView.vala"
	return result;
#line 1407 "ListView.c"
}

void
music_list_view_set_view_wrapper (MusicListView* self,
                                  MusicViewWrapper* value)
{
	MusicViewWrapper* old_value;
#line 41 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Views/ListView/ListView.vala"
	old_value = music_list_view_get_view_wrapper (self);
#line 41 "../src/Views/ListView/ListView.vala"
	if (old_value != value) {
#line 1421 "ListView.c"
		MusicViewWrapper* _tmp0_;
#line 41 "../src/Views/ListView/ListView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 41 "../src/Views/ListView/ListView.vala"
		_g_object_unref0 (self->priv->_view_wrapper);
#line 41 "../src/Views/ListView/ListView.vala"
		self->priv->_view_wrapper = _tmp0_;
#line 41 "../src/Views/ListView/ListView.vala"
		g_object_notify_by_pspec ((GObject *) self, music_list_view_properties[MUSIC_LIST_VIEW_VIEW_WRAPPER_PROPERTY]);
#line 1431 "ListView.c"
	}
}

guint
music_list_view_get_n_media (MusicListView* self)
{
	guint result;
	MusicMusicListView* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	guint _tmp5_;
#line 46 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 46 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 46 "../src/Views/ListView/ListView.vala"
	_tmp1_ = music_generic_list_get_table ((MusicGenericList*) _tmp0_);
#line 46 "../src/Views/ListView/ListView.vala"
	_tmp2_ = _tmp1_;
#line 46 "../src/Views/ListView/ListView.vala"
	_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 46 "../src/Views/ListView/ListView.vala"
	_tmp4_ = _tmp3_;
#line 46 "../src/Views/ListView/ListView.vala"
	_tmp5_ = (guint) _tmp4_;
#line 46 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (_tmp2_);
#line 46 "../src/Views/ListView/ListView.vala"
	result = _tmp5_;
#line 46 "../src/Views/ListView/ListView.vala"
	return result;
#line 1465 "ListView.c"
}

gboolean
music_list_view_get_has_column_browser (MusicListView* self)
{
	gboolean result;
	MusicColumnBrowser* _tmp0_;
#line 51 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_column_browser;
#line 51 "../src/Views/ListView/ListView.vala"
	result = _tmp0_ != NULL;
#line 51 "../src/Views/ListView/ListView.vala"
	return result;
#line 1481 "ListView.c"
}

gboolean
music_list_view_get_column_browser_enabled (MusicListView* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 54 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 55 "../src/Views/ListView/ListView.vala"
	_tmp1_ = music_list_view_get_has_column_browser (self);
#line 55 "../src/Views/ListView/ListView.vala"
	_tmp2_ = _tmp1_;
#line 55 "../src/Views/ListView/ListView.vala"
	if (_tmp2_) {
#line 1499 "ListView.c"
		MusicColumnBrowser* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 55 "../src/Views/ListView/ListView.vala"
		_tmp3_ = self->priv->_column_browser;
#line 55 "../src/Views/ListView/ListView.vala"
		_tmp4_ = gtk_widget_get_no_show_all ((GtkWidget*) _tmp3_);
#line 55 "../src/Views/ListView/ListView.vala"
		_tmp5_ = _tmp4_;
#line 55 "../src/Views/ListView/ListView.vala"
		_tmp0_ = !_tmp5_;
#line 1511 "ListView.c"
	} else {
#line 55 "../src/Views/ListView/ListView.vala"
		_tmp0_ = FALSE;
#line 1515 "ListView.c"
	}
#line 55 "../src/Views/ListView/ListView.vala"
	result = _tmp0_;
#line 55 "../src/Views/ListView/ListView.vala"
	return result;
#line 1521 "ListView.c"
}

static void
music_list_view_set_column_browser_enabled (MusicListView* self,
                                            gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 57 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/Views/ListView/ListView.vala"
	_tmp0_ = music_list_view_get_has_column_browser (self);
#line 58 "../src/Views/ListView/ListView.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/Views/ListView/ListView.vala"
	if (_tmp1_) {
#line 1538 "ListView.c"
		MusicColumnBrowser* _tmp2_;
#line 59 "../src/Views/ListView/ListView.vala"
		_tmp2_ = self->priv->_column_browser;
#line 59 "../src/Views/ListView/ListView.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp2_, !value);
#line 60 "../src/Views/ListView/ListView.vala"
		if (value) {
#line 1546 "ListView.c"
			MusicColumnBrowser* _tmp3_;
			MusicColumnBrowser* _tmp4_;
			gboolean _tmp5_;
			gboolean _tmp6_;
#line 62 "../src/Views/ListView/ListView.vala"
			_tmp3_ = self->priv->_column_browser;
#line 62 "../src/Views/ListView/ListView.vala"
			gtk_widget_show_all ((GtkWidget*) _tmp3_);
#line 64 "../src/Views/ListView/ListView.vala"
			_tmp4_ = self->priv->_column_browser;
#line 64 "../src/Views/ListView/ListView.vala"
			_tmp5_ = music_column_browser_get_initialized (_tmp4_);
#line 64 "../src/Views/ListView/ListView.vala"
			_tmp6_ = _tmp5_;
#line 64 "../src/Views/ListView/ListView.vala"
			if (!_tmp6_) {
#line 1563 "ListView.c"
				MusicColumnBrowser* _tmp7_;
				GeeCollection* _tmp8_;
				GeeCollection* _tmp9_;
#line 65 "../src/Views/ListView/ListView.vala"
				_tmp7_ = self->priv->_column_browser;
#line 65 "../src/Views/ListView/ListView.vala"
				_tmp8_ = music_view_interface_get_visible_media ((MusicViewInterface*) self);
#line 65 "../src/Views/ListView/ListView.vala"
				_tmp9_ = _tmp8_;
#line 65 "../src/Views/ListView/ListView.vala"
				music_column_browser_set_media (_tmp7_, _tmp9_);
#line 65 "../src/Views/ListView/ListView.vala"
				_g_object_unref0 (_tmp9_);
#line 1577 "ListView.c"
			}
		} else {
			MusicColumnBrowser* _tmp10_;
			MusicColumnBrowser* _tmp11_;
#line 71 "../src/Views/ListView/ListView.vala"
			_tmp10_ = self->priv->_column_browser;
#line 71 "../src/Views/ListView/ListView.vala"
			gtk_widget_hide ((GtkWidget*) _tmp10_);
#line 72 "../src/Views/ListView/ListView.vala"
			_tmp11_ = self->priv->_column_browser;
#line 72 "../src/Views/ListView/ListView.vala"
			music_column_browser_reset_filters (_tmp11_);
#line 1590 "ListView.c"
		}
	}
#line 57 "../src/Views/ListView/ListView.vala"
	g_object_notify_by_pspec ((GObject *) self, music_list_view_properties[MUSIC_LIST_VIEW_COLUMN_BROWSER_ENABLED_PROPERTY]);
#line 1595 "ListView.c"
}

static void
_music_list_view___lambda74_ (MusicListView* self)
{
#line 90 "../src/Views/ListView/ListView.vala"
	g_signal_emit (self, music_list_view_signals[MUSIC_LIST_VIEW_REORDERED_SIGNAL], 0);
#line 1603 "ListView.c"
}

static void
__music_list_view___lambda74__music_generic_list_rows_reordered (MusicGenericList* _sender,
                                                                 gpointer self)
{
#line 89 "../src/Views/ListView/ListView.vala"
	_music_list_view___lambda74_ ((MusicListView*) self);
#line 1612 "ListView.c"
}

static void
_music_list_view___lambda75_ (MusicListView* self,
                              GeeCollection* to_import)
{
#line 93 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (to_import != NULL);
#line 94 "../src/Views/ListView/ListView.vala"
	g_signal_emit_by_name ((MusicViewInterface*) self, "import-requested", to_import);
#line 1623 "ListView.c"
}

static void
__music_list_view___lambda75__music_generic_list_import_requested (MusicGenericList* _sender,
                                                                   GeeCollection* to_import,
                                                                   gpointer self)
{
#line 93 "../src/Views/ListView/ListView.vala"
	_music_list_view___lambda75_ ((MusicListView*) self, to_import);
#line 1633 "ListView.c"
}

static void
_music_list_view_view_search_func_music_generic_list_view_search_func (const gchar* search,
                                                                       GeeArrayList* table,
                                                                       GeeArrayList* showing,
                                                                       gpointer self)
{
#line 97 "../src/Views/ListView/ListView.vala"
	music_list_view_view_search_func ((MusicListView*) self, search, table, showing);
#line 1644 "ListView.c"
}

static void
_music_list_view___lambda76_ (MusicListView* self)
{
	MusicMusicListView* _tmp0_;
#line 98 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 98 "../src/Views/ListView/ListView.vala"
	music_generic_list_set_research_needed ((MusicGenericList*) _tmp0_, TRUE);
#line 1655 "ListView.c"
}

static void
__music_list_view___lambda76__music_library_search_finished (MusicLibrary* _sender,
                                                             gpointer self)
{
#line 98 "../src/Views/ListView/ListView.vala"
	_music_list_view___lambda76_ ((MusicListView*) self);
#line 1664 "ListView.c"
}

static void
_music_list_view_connect_column_browser_ui_signals_gtk_widget_realize (GtkWidget* _sender,
                                                                       gpointer self)
{
#line 112 "../src/Views/ListView/ListView.vala"
	music_list_view_connect_column_browser_ui_signals ((MusicListView*) self);
#line 1673 "ListView.c"
}

static void
_music_list_view_column_browser_changed_music_column_browser_changed (MusicColumnBrowser* _sender,
                                                                      gpointer self)
{
#line 117 "../src/Views/ListView/ListView.vala"
	music_list_view_column_browser_changed ((MusicListView*) self);
#line 1682 "ListView.c"
}

static GObject *
music_list_view_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicListView * self;
	GtkScrolledWindow* list_scrolled = NULL;
	GtkScrolledWindow* _tmp0_;
	GtkScrolledWindow* _tmp1_;
	MusicMusicListView* _tmp2_;
	GtkScrolledWindow* _tmp3_;
	MusicMusicListView* _tmp4_;
	MusicMusicListView* _tmp5_;
	MusicMusicListView* _tmp6_;
	MusicViewWrapper* _tmp7_;
	MusicLibrary* _tmp8_;
	MusicLibrary* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
#line 84 "../src/Views/ListView/ListView.vala"
	parent_class = G_OBJECT_CLASS (music_list_view_parent_class);
#line 84 "../src/Views/ListView/ListView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 84 "../src/Views/ListView/ListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_LIST_VIEW, MusicListView);
#line 85 "../src/Views/ListView/ListView.vala"
	_tmp0_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 85 "../src/Views/ListView/ListView.vala"
	g_object_ref_sink (_tmp0_);
#line 85 "../src/Views/ListView/ListView.vala"
	list_scrolled = _tmp0_;
#line 86 "../src/Views/ListView/ListView.vala"
	_tmp1_ = list_scrolled;
#line 86 "../src/Views/ListView/ListView.vala"
	_tmp2_ = self->priv->_list_view;
#line 86 "../src/Views/ListView/ListView.vala"
	gtk_container_add ((GtkContainer*) _tmp1_, (GtkWidget*) _tmp2_);
#line 87 "../src/Views/ListView/ListView.vala"
	_tmp3_ = list_scrolled;
#line 87 "../src/Views/ListView/ListView.vala"
	g_object_set ((GtkWidget*) _tmp3_, "expand", TRUE, NULL);
#line 89 "../src/Views/ListView/ListView.vala"
	_tmp4_ = self->priv->_list_view;
#line 89 "../src/Views/ListView/ListView.vala"
	g_signal_connect_object ((MusicGenericList*) _tmp4_, "rows-reordered", (GCallback) __music_list_view___lambda74__music_generic_list_rows_reordered, self, 0);
#line 93 "../src/Views/ListView/ListView.vala"
	_tmp5_ = self->priv->_list_view;
#line 93 "../src/Views/ListView/ListView.vala"
	g_signal_connect_object ((MusicGenericList*) _tmp5_, "import-requested", (GCallback) __music_list_view___lambda75__music_generic_list_import_requested, self, 0);
#line 97 "../src/Views/ListView/ListView.vala"
	_tmp6_ = self->priv->_list_view;
#line 97 "../src/Views/ListView/ListView.vala"
	music_generic_list_set_search_func ((MusicGenericList*) _tmp6_, _music_list_view_view_search_func_music_generic_list_view_search_func, self);
#line 98 "../src/Views/ListView/ListView.vala"
	_tmp7_ = self->priv->_view_wrapper;
#line 98 "../src/Views/ListView/ListView.vala"
	_tmp8_ = music_view_wrapper_get_library (_tmp7_);
#line 98 "../src/Views/ListView/ListView.vala"
	_tmp9_ = _tmp8_;
#line 98 "../src/Views/ListView/ListView.vala"
	g_signal_connect_object (_tmp9_, "search-finished", (GCallback) __music_list_view___lambda76__music_library_search_finished, self, 0);
#line 100 "../src/Views/ListView/ListView.vala"
	_tmp10_ = music_list_view_get_has_column_browser (self);
#line 100 "../src/Views/ListView/ListView.vala"
	_tmp11_ = _tmp10_;
#line 100 "../src/Views/ListView/ListView.vala"
	if (_tmp11_) {
#line 1754 "ListView.c"
		GtkPaned* _tmp12_;
		GtkPaned* _tmp13_;
		GtkPaned* _tmp14_;
		MusicColumnBrowser* _tmp15_;
		GtkPaned* _tmp16_;
		GtkScrolledWindow* _tmp17_;
		GtkPaned* _tmp18_;
		MusicColumnBrowser* _tmp19_;
		MusicColumnBrowserPosition _tmp20_;
		MusicColumnBrowserPosition _tmp21_;
		GSettings* _tmp22_;
		GSettings* _tmp23_;
		MusicColumnBrowser* _tmp24_;
#line 101 "../src/Views/ListView/ListView.vala"
		_tmp12_ = (GtkPaned*) gtk_paned_new (GTK_ORIENTATION_HORIZONTAL);
#line 101 "../src/Views/ListView/ListView.vala"
		g_object_ref_sink (_tmp12_);
#line 101 "../src/Views/ListView/ListView.vala"
		_g_object_unref0 (self->priv->browser_pane);
#line 101 "../src/Views/ListView/ListView.vala"
		self->priv->browser_pane = _tmp12_;
#line 102 "../src/Views/ListView/ListView.vala"
		_tmp13_ = self->priv->browser_pane;
#line 102 "../src/Views/ListView/ListView.vala"
		g_object_set ((GtkWidget*) _tmp13_, "expand", TRUE, NULL);
#line 103 "../src/Views/ListView/ListView.vala"
		_tmp14_ = self->priv->browser_pane;
#line 103 "../src/Views/ListView/ListView.vala"
		_tmp15_ = self->priv->_column_browser;
#line 103 "../src/Views/ListView/ListView.vala"
		gtk_paned_pack1 (_tmp14_, (GtkWidget*) _tmp15_, FALSE, FALSE);
#line 104 "../src/Views/ListView/ListView.vala"
		_tmp16_ = self->priv->browser_pane;
#line 104 "../src/Views/ListView/ListView.vala"
		_tmp17_ = list_scrolled;
#line 104 "../src/Views/ListView/ListView.vala"
		gtk_paned_pack2 (_tmp16_, (GtkWidget*) _tmp17_, TRUE, FALSE);
#line 106 "../src/Views/ListView/ListView.vala"
		_tmp18_ = self->priv->browser_pane;
#line 106 "../src/Views/ListView/ListView.vala"
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp18_);
#line 108 "../src/Views/ListView/ListView.vala"
		_tmp19_ = self->priv->_column_browser;
#line 108 "../src/Views/ListView/ListView.vala"
		_tmp20_ = music_column_browser_get_position (_tmp19_);
#line 108 "../src/Views/ListView/ListView.vala"
		_tmp21_ = _tmp20_;
#line 108 "../src/Views/ListView/ListView.vala"
		music_list_view_set_column_browser_position (self, _tmp21_);
#line 112 "../src/Views/ListView/ListView.vala"
		g_signal_connect_object ((GtkWidget*) self, "realize", (GCallback) _music_list_view_connect_column_browser_ui_signals_gtk_widget_realize, self, 0);
#line 114 "../src/Views/ListView/ListView.vala"
		_tmp22_ = music_app_get_saved_state ();
#line 114 "../src/Views/ListView/ListView.vala"
		_tmp23_ = _tmp22_;
#line 114 "../src/Views/ListView/ListView.vala"
		music_list_view_set_column_browser_enabled (self, g_settings_get_boolean (_tmp23_, "column-browser-enabled"));
#line 117 "../src/Views/ListView/ListView.vala"
		_tmp24_ = self->priv->_column_browser;
#line 117 "../src/Views/ListView/ListView.vala"
		g_signal_connect_object (_tmp24_, "changed", (GCallback) _music_list_view_column_browser_changed_music_column_browser_changed, self, 0);
#line 1816 "ListView.c"
	} else {
		GtkScrolledWindow* _tmp25_;
#line 119 "../src/Views/ListView/ListView.vala"
		_tmp25_ = list_scrolled;
#line 119 "../src/Views/ListView/ListView.vala"
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp25_);
#line 1823 "ListView.c"
	}
#line 84 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (list_scrolled);
#line 84 "../src/Views/ListView/ListView.vala"
	return obj;
#line 1829 "ListView.c"
}

static void
music_list_view_class_init (MusicListViewClass * klass,
                            gpointer klass_data)
{
#line 32 "../src/Views/ListView/ListView.vala"
	music_list_view_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/Views/ListView/ListView.vala"
	g_type_class_adjust_private_offset (klass, &MusicListView_private_offset);
#line 32 "../src/Views/ListView/ListView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_list_view_get_property;
#line 32 "../src/Views/ListView/ListView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_list_view_set_property;
#line 32 "../src/Views/ListView/ListView.vala"
	G_OBJECT_CLASS (klass)->constructor = music_list_view_constructor;
#line 32 "../src/Views/ListView/ListView.vala"
	G_OBJECT_CLASS (klass)->finalize = music_list_view_finalize;
#line 32 "../src/Views/ListView/ListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIST_VIEW_COLUMN_BROWSER_PROPERTY, music_list_view_properties[MUSIC_LIST_VIEW_COLUMN_BROWSER_PROPERTY] = g_param_spec_object ("column-browser", "column-browser", "column-browser", MUSIC_TYPE_COLUMN_BROWSER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 32 "../src/Views/ListView/ListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIST_VIEW_LIST_VIEW_PROPERTY, music_list_view_properties[MUSIC_LIST_VIEW_LIST_VIEW_PROPERTY] = g_param_spec_object ("list-view", "list-view", "list-view", MUSIC_TYPE_MUSIC_LIST_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 32 "../src/Views/ListView/ListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIST_VIEW_VIEW_WRAPPER_PROPERTY, music_list_view_properties[MUSIC_LIST_VIEW_VIEW_WRAPPER_PROPERTY] = g_param_spec_object ("view-wrapper", "view-wrapper", "view-wrapper", MUSIC_TYPE_VIEW_WRAPPER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 32 "../src/Views/ListView/ListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIST_VIEW_N_MEDIA_PROPERTY, music_list_view_properties[MUSIC_LIST_VIEW_N_MEDIA_PROPERTY] = g_param_spec_uint ("n-media", "n-media", "n-media", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/Views/ListView/ListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIST_VIEW_HAS_COLUMN_BROWSER_PROPERTY, music_list_view_properties[MUSIC_LIST_VIEW_HAS_COLUMN_BROWSER_PROPERTY] = g_param_spec_boolean ("has-column-browser", "has-column-browser", "has-column-browser", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/Views/ListView/ListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIST_VIEW_COLUMN_BROWSER_ENABLED_PROPERTY, music_list_view_properties[MUSIC_LIST_VIEW_COLUMN_BROWSER_ENABLED_PROPERTY] = g_param_spec_boolean ("column-browser-enabled", "column-browser-enabled", "column-browser-enabled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/Views/ListView/ListView.vala"
	music_list_view_signals[MUSIC_LIST_VIEW_REORDERED_SIGNAL] = g_signal_new ("reordered", MUSIC_TYPE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1862 "ListView.c"
}

static void
music_list_view_music_view_interface_interface_init (MusicViewInterfaceIface * iface,
                                                     gpointer iface_data)
{
#line 32 "../src/Views/ListView/ListView.vala"
	music_list_view_music_view_interface_parent_iface = g_type_interface_peek_parent (iface);
#line 32 "../src/Views/ListView/ListView.vala"
	iface->get_media = (GeeCollection* (*) (MusicViewInterface*)) music_list_view_real_get_media;
#line 32 "../src/Views/ListView/ListView.vala"
	iface->get_visible_media = (GeeCollection* (*) (MusicViewInterface*)) music_list_view_real_get_visible_media;
#line 32 "../src/Views/ListView/ListView.vala"
	iface->add_media = (void (*) (MusicViewInterface*, GeeCollection*)) music_list_view_real_add_media;
#line 32 "../src/Views/ListView/ListView.vala"
	iface->remove_media = (void (*) (MusicViewInterface*, GeeCollection*)) music_list_view_real_remove_media;
#line 32 "../src/Views/ListView/ListView.vala"
	iface->set_media = (void (*) (MusicViewInterface*, GeeCollection*)) music_list_view_real_set_media;
#line 32 "../src/Views/ListView/ListView.vala"
	iface->update_media = (void (*) (MusicViewInterface*, GeeCollection*)) music_list_view_real_update_media;
#line 32 "../src/Views/ListView/ListView.vala"
	iface->refilter = (void (*) (MusicViewInterface*)) music_list_view_real_refilter;
#line 1885 "ListView.c"
}

static void
music_list_view_instance_init (MusicListView * self,
                               gpointer klass)
{
#line 32 "../src/Views/ListView/ListView.vala"
	self->priv = music_list_view_get_instance_private (self);
#line 43 "../src/Views/ListView/ListView.vala"
	self->priv->obey_column_browser = FALSE;
#line 1896 "ListView.c"
}

static void
music_list_view_finalize (GObject * obj)
{
	MusicListView * self;
#line 32 "../src/Views/ListView/ListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_LIST_VIEW, MusicListView);
#line 36 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (self->priv->browser_pane);
#line 38 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (self->priv->_column_browser);
#line 39 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (self->priv->_list_view);
#line 41 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (self->priv->_view_wrapper);
#line 32 "../src/Views/ListView/ListView.vala"
	G_OBJECT_CLASS (music_list_view_parent_class)->finalize (obj);
#line 1915 "ListView.c"
}

/**
 * Contains the column browser and list view.
 */
static GType
music_list_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicListViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_list_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicListView), 0, (GInstanceInitFunc) music_list_view_instance_init, NULL };
	static const GInterfaceInfo music_view_interface_info = { (GInterfaceInitFunc) music_list_view_music_view_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_list_view_type_id;
	music_list_view_type_id = g_type_register_static (gtk_box_get_type (), "MusicListView", &g_define_type_info, 0);
	g_type_add_interface_static (music_list_view_type_id, MUSIC_TYPE_VIEW_INTERFACE, &music_view_interface_info);
	MusicListView_private_offset = g_type_add_instance_private (music_list_view_type_id, sizeof (MusicListViewPrivate));
	return music_list_view_type_id;
}

GType
music_list_view_get_type (void)
{
	static volatile gsize music_list_view_type_id__once = 0;
	if (g_once_init_enter (&music_list_view_type_id__once)) {
		GType music_list_view_type_id;
		music_list_view_type_id = music_list_view_get_type_once ();
		g_once_init_leave (&music_list_view_type_id__once, music_list_view_type_id);
	}
	return music_list_view_type_id__once;
}

static void
_vala_music_list_view_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	MusicListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LIST_VIEW, MusicListView);
#line 32 "../src/Views/ListView/ListView.vala"
	switch (property_id) {
#line 32 "../src/Views/ListView/ListView.vala"
		case MUSIC_LIST_VIEW_COLUMN_BROWSER_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		g_value_set_object (value, music_list_view_get_column_browser (self));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 32 "../src/Views/ListView/ListView.vala"
		case MUSIC_LIST_VIEW_LIST_VIEW_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		g_value_set_object (value, music_list_view_get_list_view (self));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 32 "../src/Views/ListView/ListView.vala"
		case MUSIC_LIST_VIEW_VIEW_WRAPPER_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		g_value_set_object (value, music_list_view_get_view_wrapper (self));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 32 "../src/Views/ListView/ListView.vala"
		case MUSIC_LIST_VIEW_N_MEDIA_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		g_value_set_uint (value, music_list_view_get_n_media (self));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 32 "../src/Views/ListView/ListView.vala"
		case MUSIC_LIST_VIEW_HAS_COLUMN_BROWSER_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		g_value_set_boolean (value, music_list_view_get_has_column_browser (self));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 32 "../src/Views/ListView/ListView.vala"
		case MUSIC_LIST_VIEW_COLUMN_BROWSER_ENABLED_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		g_value_set_boolean (value, music_list_view_get_column_browser_enabled (self));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 1991 "ListView.c"
		default:
#line 32 "../src/Views/ListView/ListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 1997 "ListView.c"
	}
}

static void
_vala_music_list_view_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	MusicListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LIST_VIEW, MusicListView);
#line 32 "../src/Views/ListView/ListView.vala"
	switch (property_id) {
#line 32 "../src/Views/ListView/ListView.vala"
		case MUSIC_LIST_VIEW_COLUMN_BROWSER_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		music_list_view_set_column_browser (self, g_value_get_object (value));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 32 "../src/Views/ListView/ListView.vala"
		case MUSIC_LIST_VIEW_LIST_VIEW_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		music_list_view_set_list_view (self, g_value_get_object (value));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 32 "../src/Views/ListView/ListView.vala"
		case MUSIC_LIST_VIEW_VIEW_WRAPPER_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		music_list_view_set_view_wrapper (self, g_value_get_object (value));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 32 "../src/Views/ListView/ListView.vala"
		case MUSIC_LIST_VIEW_COLUMN_BROWSER_ENABLED_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		music_list_view_set_column_browser_enabled (self, g_value_get_boolean (value));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 2035 "ListView.c"
		default:
#line 32 "../src/Views/ListView/ListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 2041 "ListView.c"
	}
}

