/* CellDataFunctionHelper.c generated by valac 0.56.0, the Vala compiler
 * generated from CellDataFunctionHelper.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#define _XOPEN_SOURCE

#include "music-lib.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include "io.elementary.music-core.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <time.h>
#include <gobject/gvaluecollector.h>

#define MUSIC_CELL_DATA_FUNCTION_HELPER_NOT_AVAILABLE ""

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MusicParamSpecCellDataFunctionHelper MusicParamSpecCellDataFunctionHelper;

struct _MusicCellDataFunctionHelperPrivate {
	MusicGenericList* view;
};

struct _MusicParamSpecCellDataFunctionHelper {
	GParamSpec parent_instance;
};

static gint MusicCellDataFunctionHelper_private_offset;
static gpointer music_cell_data_function_helper_parent_class = NULL;

static inline void music_cell_data_function_helper_set_renderer_number (GtkCellRendererText* renderer,
                                                          GtkTreeIter* iter,
                                                          GtkTreeModel* model,
                                                          gint column);
static void music_cell_data_function_helper_finalize (MusicCellDataFunctionHelper * obj);
static GType music_cell_data_function_helper_get_type_once (void);

static inline gpointer
music_cell_data_function_helper_get_instance_private (MusicCellDataFunctionHelper* self)
{
	return G_STRUCT_MEMBER_P (self, MusicCellDataFunctionHelper_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 36 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	return self ? g_object_ref (self) : NULL;
#line 84 "CellDataFunctionHelper.c"
}

MusicCellDataFunctionHelper*
music_cell_data_function_helper_construct (GType object_type,
                                           MusicGenericList* view)
{
	MusicCellDataFunctionHelper* self = NULL;
	MusicGenericList* _tmp0_;
#line 35 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 35 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	self = (MusicCellDataFunctionHelper*) g_type_create_instance (object_type);
#line 36 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp0_ = _g_object_ref0 (view);
#line 36 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_g_object_unref0 (self->priv->view);
#line 36 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	self->priv->view = _tmp0_;
#line 35 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	return self;
#line 105 "CellDataFunctionHelper.c"
}

MusicCellDataFunctionHelper*
music_cell_data_function_helper_new (MusicGenericList* view)
{
#line 35 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	return music_cell_data_function_helper_construct (MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER, view);
#line 113 "CellDataFunctionHelper.c"
}

/**
     * For unique icon on each row
     */
void
music_cell_data_function_helper_icon_func (MusicCellDataFunctionHelper* self,
                                           GtkCellLayout* layout,
                                           GtkCellRenderer* renderer,
                                           GtkTreeModel* model,
                                           GtkTreeIter* iter)
{
	MusicMedia* m = NULL;
	MusicGenericList* _tmp0_;
	GtkTreeIter _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	MusicMedia* _tmp4_;
	MusicMedia* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	GtkCellRendererPixbuf* image_renderer = NULL;
	GtkCellRendererPixbuf* _tmp8_;
	GtkCellRendererPixbuf* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
#line 42 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (layout != NULL);
#line 42 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (renderer != NULL);
#line 42 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (model != NULL);
#line 42 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (iter != NULL);
#line 43 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp0_ = self->priv->view;
#line 43 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp1_ = *iter;
#line 43 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp2_ = music_generic_list_get_object_from_index (_tmp0_, music_generic_list_get_index_from_iter (&_tmp1_));
#line 43 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, MUSIC_TYPE_MEDIA) ? ((MusicMedia*) _tmp2_) : NULL;
#line 43 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (_tmp3_ == NULL) {
#line 43 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_g_object_unref0 (_tmp2_);
#line 162 "CellDataFunctionHelper.c"
	}
#line 43 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	m = _tmp3_;
#line 44 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp4_ = m;
#line 44 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (_tmp4_ == NULL) {
#line 45 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_g_object_unref0 (m);
#line 45 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		return;
#line 174 "CellDataFunctionHelper.c"
	}
#line 47 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp5_ = m;
#line 47 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp6_ = music_media_get_show_indicator (_tmp5_);
#line 47 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp7_ = _tmp6_;
#line 47 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	gtk_cell_renderer_set_visible (renderer, !_tmp7_);
#line 49 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (renderer, gtk_cell_renderer_pixbuf_get_type ()) ? ((GtkCellRendererPixbuf*) renderer) : NULL);
#line 49 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	image_renderer = _tmp8_;
#line 50 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp9_ = image_renderer;
#line 50 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (_tmp9_ != NULL);
#line 52 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp10_ = gtk_cell_renderer_get_visible (renderer);
#line 52 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp11_ = _tmp10_;
#line 52 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (_tmp11_) {
#line 198 "CellDataFunctionHelper.c"
		GValue icon = {0};
		GtkTreeIter _tmp12_;
		GValue _tmp13_ = {0};
		GtkCellRendererPixbuf* _tmp14_;
		GObject* _tmp15_;
#line 54 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp12_ = *iter;
#line 54 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		gtk_tree_model_get_value (model, &_tmp12_, (gint) MUSIC_LIST_COLUMN_ICON, &_tmp13_);
#line 54 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		G_IS_VALUE (&icon) ? (g_value_unset (&icon), NULL) : NULL;
#line 54 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		icon = _tmp13_;
#line 55 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp14_ = image_renderer;
#line 55 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp15_ = g_value_get_object (&icon);
#line 55 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		g_object_set (_tmp14_, "gicon", G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, g_icon_get_type ()) ? ((GIcon*) _tmp15_) : NULL, NULL);
#line 52 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		G_IS_VALUE (&icon) ? (g_value_unset (&icon), NULL) : NULL;
#line 220 "CellDataFunctionHelper.c"
	}
#line 42 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_g_object_unref0 (image_renderer);
#line 42 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_g_object_unref0 (m);
#line 226 "CellDataFunctionHelper.c"
}

void
music_cell_data_function_helper_spinner_func (MusicCellDataFunctionHelper* self,
                                              GtkCellLayout* layout,
                                              GtkCellRenderer* renderer,
                                              GtkTreeModel* model,
                                              GtkTreeIter* iter)
{
	MusicMedia* m = NULL;
	MusicGenericList* _tmp0_;
	GtkTreeIter _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	MusicMedia* _tmp4_;
	MusicMedia* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	GtkCellRendererSpinner* spinner_renderer = NULL;
	GtkCellRendererSpinner* _tmp8_;
	GtkCellRendererSpinner* _tmp9_;
	GtkCellRendererSpinner* _tmp10_;
	GtkCellRendererSpinner* _tmp11_;
	guint _tmp12_;
	guint _tmp13_;
#line 59 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (layout != NULL);
#line 59 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (renderer != NULL);
#line 59 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (model != NULL);
#line 59 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (iter != NULL);
#line 60 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp0_ = self->priv->view;
#line 60 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp1_ = *iter;
#line 60 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp2_ = music_generic_list_get_object_from_index (_tmp0_, music_generic_list_get_index_from_iter (&_tmp1_));
#line 60 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, MUSIC_TYPE_MEDIA) ? ((MusicMedia*) _tmp2_) : NULL;
#line 60 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (_tmp3_ == NULL) {
#line 60 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_g_object_unref0 (_tmp2_);
#line 274 "CellDataFunctionHelper.c"
	}
#line 60 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	m = _tmp3_;
#line 61 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp4_ = m;
#line 61 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (_tmp4_ == NULL) {
#line 62 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_g_object_unref0 (m);
#line 62 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		return;
#line 286 "CellDataFunctionHelper.c"
	}
#line 64 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp5_ = m;
#line 64 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp6_ = music_media_get_show_indicator (_tmp5_);
#line 64 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp7_ = _tmp6_;
#line 64 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	gtk_cell_renderer_set_visible (renderer, _tmp7_);
#line 66 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (renderer, gtk_cell_renderer_spinner_get_type ()) ? ((GtkCellRendererSpinner*) renderer) : NULL);
#line 66 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	spinner_renderer = _tmp8_;
#line 67 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp9_ = spinner_renderer;
#line 67 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (_tmp9_ != NULL);
#line 69 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp10_ = spinner_renderer;
#line 69 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_object_set (_tmp10_, "active", TRUE, NULL);
#line 70 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp11_ = spinner_renderer;
#line 70 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_object_get (_tmp11_, "pulse", &_tmp12_, NULL);
#line 70 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp13_ = _tmp12_;
#line 70 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_object_set (_tmp11_, "pulse", _tmp13_ + 1, NULL);
#line 59 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_g_object_unref0 (spinner_renderer);
#line 59 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_g_object_unref0 (m);
#line 320 "CellDataFunctionHelper.c"
}

inline void
music_cell_data_function_helper_file_size_func (GtkCellLayout* layout,
                                                GtkCellRenderer* cell,
                                                GtkTreeModel* tree_model,
                                                GtkTreeIter* iter)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	guint64 n = 0ULL;
	gchar* _tmp2_ = NULL;
#line 73 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (layout != NULL);
#line 73 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (cell != NULL);
#line 73 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (tree_model != NULL);
#line 73 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (iter != NULL);
#line 75 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp0_ = *iter;
#line 75 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	gtk_tree_model_get_value (tree_model, &_tmp0_, (gint) MUSIC_LIST_COLUMN_FILE_SIZE, &_tmp1_);
#line 75 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 75 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	val = _tmp1_;
#line 76 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	n = g_value_get_uint64 (&val);
#line 77 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (n > ((guint64) 0)) {
#line 354 "CellDataFunctionHelper.c"
		gchar* _tmp3_;
#line 77 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp3_ = g_format_size_full (n, G_FORMAT_SIZE_DEFAULT);
#line 77 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_g_free0 (_tmp2_);
#line 77 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp2_ = _tmp3_;
#line 362 "CellDataFunctionHelper.c"
	} else {
		gchar* _tmp4_;
#line 77 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp4_ = g_strdup (MUSIC_CELL_DATA_FUNCTION_HELPER_NOT_AVAILABLE);
#line 77 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_g_free0 (_tmp2_);
#line 77 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp2_ = _tmp4_;
#line 371 "CellDataFunctionHelper.c"
	}
#line 77 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (cell, gtk_cell_renderer_text_get_type (), GtkCellRendererText), "text", _tmp2_, NULL);
#line 73 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_g_free0 (_tmp2_);
#line 73 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 379 "CellDataFunctionHelper.c"
}

inline void
music_cell_data_function_helper_number_func (GtkCellLayout* layout,
                                             GtkCellRenderer* cell,
                                             GtkTreeModel* tree_model,
                                             GtkTreeIter* iter)
{
	GtkTreeIter _tmp0_;
#line 82 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (layout != NULL);
#line 82 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (cell != NULL);
#line 82 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (tree_model != NULL);
#line 82 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (iter != NULL);
#line 83 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp0_ = *iter;
#line 83 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	music_cell_data_function_helper_set_renderer_number (G_TYPE_CHECK_INSTANCE_TYPE (cell, gtk_cell_renderer_text_get_type ()) ? ((GtkCellRendererText*) cell) : NULL, &_tmp0_, tree_model, (gint) MUSIC_LIST_COLUMN_NUMBER);
#line 401 "CellDataFunctionHelper.c"
}

inline void
music_cell_data_function_helper_intelligent_func (GtkCellLayout* layout,
                                                  GtkCellRenderer* cell,
                                                  GtkTreeModel* tree_model,
                                                  GtkTreeIter* iter)
{
	GtkTreeViewColumn* tvc = NULL;
	GtkTreeViewColumn* _tmp0_;
	GtkTreeViewColumn* _tmp1_;
	gint column = 0;
	GtkTreeViewColumn* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GtkTreeIter _tmp5_;
#line 87 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (layout != NULL);
#line 87 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (cell != NULL);
#line 87 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (tree_model != NULL);
#line 87 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (iter != NULL);
#line 88 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (layout, gtk_tree_view_column_get_type ()) ? ((GtkTreeViewColumn*) layout) : NULL);
#line 88 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	tvc = _tmp0_;
#line 89 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp1_ = tvc;
#line 89 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (_tmp1_ != NULL);
#line 93 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp2_ = tvc;
#line 93 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp3_ = gtk_tree_view_column_get_sort_column_id (_tmp2_);
#line 93 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp4_ = _tmp3_;
#line 93 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	column = _tmp4_;
#line 94 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (column < 0) {
#line 95 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_g_object_unref0 (tvc);
#line 95 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		return;
#line 448 "CellDataFunctionHelper.c"
	}
#line 97 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp5_ = *iter;
#line 97 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	music_cell_data_function_helper_set_renderer_number (G_TYPE_CHECK_INSTANCE_TYPE (cell, gtk_cell_renderer_text_get_type ()) ? ((GtkCellRendererText*) cell) : NULL, &_tmp5_, tree_model, column);
#line 87 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_g_object_unref0 (tvc);
#line 456 "CellDataFunctionHelper.c"
}

static inline void
music_cell_data_function_helper_set_renderer_number (GtkCellRendererText* renderer,
                                                     GtkTreeIter* iter,
                                                     GtkTreeModel* model,
                                                     gint column)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	guint n = 0U;
	gchar* _tmp2_ = NULL;
#line 100 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (renderer != NULL);
#line 100 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (iter != NULL);
#line 100 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (model != NULL);
#line 102 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp0_ = *iter;
#line 102 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	gtk_tree_model_get_value (model, &_tmp0_, column, &_tmp1_);
#line 102 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 102 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	val = _tmp1_;
#line 103 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	n = g_value_get_uint (&val);
#line 104 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (n > ((guint) 0)) {
#line 488 "CellDataFunctionHelper.c"
		gchar* _tmp3_;
#line 104 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp3_ = g_strdup_printf ("%u", n);
#line 104 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_g_free0 (_tmp2_);
#line 104 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp2_ = _tmp3_;
#line 496 "CellDataFunctionHelper.c"
	} else {
		gchar* _tmp4_;
#line 104 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp4_ = g_strdup ("");
#line 104 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_g_free0 (_tmp2_);
#line 104 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp2_ = _tmp4_;
#line 505 "CellDataFunctionHelper.c"
	}
#line 104 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_object_set (renderer, "text", _tmp2_, NULL);
#line 100 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_g_free0 (_tmp2_);
#line 100 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 513 "CellDataFunctionHelper.c"
}

inline void
music_cell_data_function_helper_string_func (GtkCellLayout* layout,
                                             GtkCellRenderer* cell,
                                             GtkTreeModel* tree_model,
                                             GtkTreeIter* iter)
{
	GtkTreeViewColumn* tvc = NULL;
	GtkTreeViewColumn* _tmp0_;
	GtkTreeViewColumn* _tmp1_;
	gint column = 0;
	GtkTreeViewColumn* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GValue val = {0};
	GtkTreeIter _tmp5_;
	GValue _tmp6_ = {0};
	const gchar* _tmp7_;
#line 107 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (layout != NULL);
#line 107 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (cell != NULL);
#line 107 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (tree_model != NULL);
#line 107 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (iter != NULL);
#line 108 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (layout, gtk_tree_view_column_get_type ()) ? ((GtkTreeViewColumn*) layout) : NULL);
#line 108 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	tvc = _tmp0_;
#line 109 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp1_ = tvc;
#line 109 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (_tmp1_ != NULL);
#line 113 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp2_ = tvc;
#line 113 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp3_ = gtk_tree_view_column_get_sort_column_id (_tmp2_);
#line 113 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp4_ = _tmp3_;
#line 113 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	column = _tmp4_;
#line 114 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (column < 0) {
#line 115 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_g_object_unref0 (tvc);
#line 115 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		return;
#line 563 "CellDataFunctionHelper.c"
	}
#line 118 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp5_ = *iter;
#line 118 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	gtk_tree_model_get_value (tree_model, &_tmp5_, column, &_tmp6_);
#line 118 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 118 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	val = _tmp6_;
#line 119 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp7_ = g_value_get_string (&val);
#line 119 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (cell, gtk_cell_renderer_text_get_type (), GtkCellRendererText), "text", _tmp7_, NULL);
#line 107 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 107 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_g_object_unref0 (tvc);
#line 581 "CellDataFunctionHelper.c"
}

inline void
music_cell_data_function_helper_bitrate_func (GtkCellLayout* layout,
                                              GtkCellRenderer* cell,
                                              GtkTreeModel* tree_model,
                                              GtkTreeIter* iter)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	GtkCellRendererText* text_cell = NULL;
	GtkCellRendererText* _tmp2_;
	guint n = 0U;
	gchar* _tmp3_ = NULL;
	GtkCellRendererText* _tmp6_;
#line 123 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (layout != NULL);
#line 123 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (cell != NULL);
#line 123 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (tree_model != NULL);
#line 123 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (iter != NULL);
#line 125 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp0_ = *iter;
#line 125 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	gtk_tree_model_get_value (tree_model, &_tmp0_, (gint) MUSIC_LIST_COLUMN_BITRATE, &_tmp1_);
#line 125 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 125 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	val = _tmp1_;
#line 126 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (cell, gtk_cell_renderer_text_get_type ()) ? ((GtkCellRendererText*) cell) : NULL);
#line 126 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	text_cell = _tmp2_;
#line 127 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	n = g_value_get_uint (&val);
#line 128 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (n <= ((guint) 0)) {
#line 622 "CellDataFunctionHelper.c"
		gchar* _tmp4_;
#line 128 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp4_ = g_strdup (MUSIC_CELL_DATA_FUNCTION_HELPER_NOT_AVAILABLE);
#line 128 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_g_free0 (_tmp3_);
#line 128 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp3_ = _tmp4_;
#line 630 "CellDataFunctionHelper.c"
	} else {
		gchar* _tmp5_;
#line 128 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp5_ = g_strdup_printf (_ ("%u kbps"), n);
#line 128 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_g_free0 (_tmp3_);
#line 128 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp3_ = _tmp5_;
#line 639 "CellDataFunctionHelper.c"
	}
#line 128 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp6_ = text_cell;
#line 128 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_object_set (_tmp6_, "text", _tmp3_, NULL);
#line 123 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_g_free0 (_tmp3_);
#line 123 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_g_object_unref0 (text_cell);
#line 123 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 651 "CellDataFunctionHelper.c"
}

inline void
music_cell_data_function_helper_length_func (GtkCellLayout* layout,
                                             GtkCellRenderer* cell,
                                             GtkTreeModel* tree_model,
                                             GtkTreeIter* iter)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	guint ms = 0U;
	GtkCellRendererText* text_cell = NULL;
	GtkCellRendererText* _tmp2_;
	gchar* _tmp3_ = NULL;
	GtkCellRendererText* _tmp6_;
#line 132 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (layout != NULL);
#line 132 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (cell != NULL);
#line 132 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (tree_model != NULL);
#line 132 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (iter != NULL);
#line 134 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp0_ = *iter;
#line 134 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	gtk_tree_model_get_value (tree_model, &_tmp0_, (gint) MUSIC_LIST_COLUMN_LENGTH, &_tmp1_);
#line 134 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 134 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	val = _tmp1_;
#line 135 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	ms = g_value_get_uint (&val);
#line 136 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (cell, gtk_cell_renderer_text_get_type ()) ? ((GtkCellRendererText*) cell) : NULL);
#line 136 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	text_cell = _tmp2_;
#line 137 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (ms <= ((guint) 0)) {
#line 692 "CellDataFunctionHelper.c"
		gchar* _tmp4_;
#line 137 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp4_ = g_strdup (MUSIC_CELL_DATA_FUNCTION_HELPER_NOT_AVAILABLE);
#line 137 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_g_free0 (_tmp3_);
#line 137 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp3_ = _tmp4_;
#line 700 "CellDataFunctionHelper.c"
	} else {
		gchar* _tmp5_;
#line 137 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp5_ = granite_date_time_seconds_to_time ((gint) (ms / MUSIC_TIME_UTILS_MILI_INV));
#line 137 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_g_free0 (_tmp3_);
#line 137 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp3_ = _tmp5_;
#line 709 "CellDataFunctionHelper.c"
	}
#line 137 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp6_ = text_cell;
#line 137 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_object_set (_tmp6_, "text", _tmp3_, NULL);
#line 132 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_g_free0 (_tmp3_);
#line 132 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_g_object_unref0 (text_cell);
#line 132 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 721 "CellDataFunctionHelper.c"
}

inline void
music_cell_data_function_helper_date_func (GtkCellLayout* layout,
                                           GtkCellRenderer* cell,
                                           GtkTreeModel* tree_model,
                                           GtkTreeIter* iter)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	GtkCellRendererText* text_cell = NULL;
	GtkCellRendererText* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 141 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (layout != NULL);
#line 141 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (cell != NULL);
#line 141 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (tree_model != NULL);
#line 141 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (iter != NULL);
#line 143 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp0_ = *iter;
#line 143 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	gtk_tree_model_get_value (tree_model, &_tmp0_, (gint) MUSIC_LIST_COLUMN_DATE_ADDED, &_tmp1_);
#line 143 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 143 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	val = _tmp1_;
#line 144 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (cell, gtk_cell_renderer_text_get_type ()) ? ((GtkCellRendererText*) cell) : NULL);
#line 144 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	text_cell = _tmp2_;
#line 145 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp3_ = music_cell_data_function_helper_get_date_string (g_value_get_uint (&val));
#line 145 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp4_ = _tmp3_;
#line 145 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_object_set (text_cell, "text", _tmp4_, NULL);
#line 145 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_g_free0 (_tmp4_);
#line 141 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_g_object_unref0 (text_cell);
#line 141 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 769 "CellDataFunctionHelper.c"
}

static void
g_time_local (time_t time,
              struct tm* result)
{
	struct tm _result_ = {0};
	struct tm _tmp0_ = {0};
#line 3219 "glib-2.0.vapi"
	localtime_r (&time, &_tmp0_);
#line 3219 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 3220 "glib-2.0.vapi"
	*result = _result_;
#line 3220 "glib-2.0.vapi"
	return;
#line 786 "CellDataFunctionHelper.c"
}

inline gchar*
music_cell_data_function_helper_get_date_string (guint n)
{
	gchar* _tmp0_ = NULL;
	gchar* result;
#line 149 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (n == ((guint) 0)) {
#line 796 "CellDataFunctionHelper.c"
		gchar* _tmp1_;
#line 149 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp1_ = g_strdup (_ ("Never"));
#line 149 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_g_free0 (_tmp0_);
#line 149 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp0_ = _tmp1_;
#line 804 "CellDataFunctionHelper.c"
	} else {
		struct tm _tmp2_ = {0};
		gchar* _tmp3_;
#line 149 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		g_time_local ((time_t) n, &_tmp2_);
#line 149 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp3_ = music_time_utils_pretty_timestamp_from_time (&_tmp2_);
#line 149 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_g_free0 (_tmp0_);
#line 149 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		_tmp0_ = _tmp3_;
#line 816 "CellDataFunctionHelper.c"
	}
#line 149 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	result = _tmp0_;
#line 149 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	return result;
#line 822 "CellDataFunctionHelper.c"
}

inline void
music_cell_data_function_helper_rating_func (GtkCellLayout* layout,
                                             GtkCellRenderer* cell,
                                             GtkTreeModel* tree_model,
                                             GtkTreeIter* iter)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	MusicRatingCellRenderer* rating_cell = NULL;
	MusicRatingCellRenderer* _tmp2_;
#line 152 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (layout != NULL);
#line 152 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (cell != NULL);
#line 152 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (tree_model != NULL);
#line 152 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (iter != NULL);
#line 154 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp0_ = *iter;
#line 154 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	gtk_tree_model_get_value (tree_model, &_tmp0_, (gint) MUSIC_LIST_COLUMN_RATING, &_tmp1_);
#line 154 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 154 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	val = _tmp1_;
#line 155 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_tmp2_ = _g_object_ref0 (MUSIC_IS_RATING_CELL_RENDERER (cell) ? ((MusicRatingCellRenderer*) cell) : NULL);
#line 155 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	rating_cell = _tmp2_;
#line 156 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	music_rating_cell_renderer_set_rating (rating_cell, g_value_get_uint (&val));
#line 152 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_g_object_unref0 (rating_cell);
#line 152 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 862 "CellDataFunctionHelper.c"
}

static void
music_value_cell_data_function_helper_init (GValue* value)
{
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	value->data[0].v_pointer = NULL;
#line 870 "CellDataFunctionHelper.c"
}

static void
music_value_cell_data_function_helper_free_value (GValue* value)
{
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (value->data[0].v_pointer) {
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		music_cell_data_function_helper_unref (value->data[0].v_pointer);
#line 880 "CellDataFunctionHelper.c"
	}
}

static void
music_value_cell_data_function_helper_copy_value (const GValue* src_value,
                                                  GValue* dest_value)
{
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (src_value->data[0].v_pointer) {
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		dest_value->data[0].v_pointer = music_cell_data_function_helper_ref (src_value->data[0].v_pointer);
#line 892 "CellDataFunctionHelper.c"
	} else {
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		dest_value->data[0].v_pointer = NULL;
#line 896 "CellDataFunctionHelper.c"
	}
}

static gpointer
music_value_cell_data_function_helper_peek_pointer (const GValue* value)
{
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	return value->data[0].v_pointer;
#line 905 "CellDataFunctionHelper.c"
}

static gchar*
music_value_cell_data_function_helper_collect_value (GValue* value,
                                                     guint n_collect_values,
                                                     GTypeCValue* collect_values,
                                                     guint collect_flags)
{
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (collect_values[0].v_pointer) {
#line 916 "CellDataFunctionHelper.c"
		MusicCellDataFunctionHelper * object;
		object = collect_values[0].v_pointer;
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		if (object->parent_instance.g_class == NULL) {
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 923 "CellDataFunctionHelper.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 927 "CellDataFunctionHelper.c"
		}
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		value->data[0].v_pointer = music_cell_data_function_helper_ref (object);
#line 931 "CellDataFunctionHelper.c"
	} else {
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		value->data[0].v_pointer = NULL;
#line 935 "CellDataFunctionHelper.c"
	}
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	return NULL;
#line 939 "CellDataFunctionHelper.c"
}

static gchar*
music_value_cell_data_function_helper_lcopy_value (const GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
	MusicCellDataFunctionHelper ** object_p;
	object_p = collect_values[0].v_pointer;
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (!object_p) {
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 954 "CellDataFunctionHelper.c"
	}
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (!value->data[0].v_pointer) {
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		*object_p = NULL;
#line 960 "CellDataFunctionHelper.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		*object_p = value->data[0].v_pointer;
#line 964 "CellDataFunctionHelper.c"
	} else {
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		*object_p = music_cell_data_function_helper_ref (value->data[0].v_pointer);
#line 968 "CellDataFunctionHelper.c"
	}
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	return NULL;
#line 972 "CellDataFunctionHelper.c"
}

GParamSpec*
music_param_spec_cell_data_function_helper (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags)
{
	MusicParamSpecCellDataFunctionHelper* spec;
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_val_if_fail (g_type_is_a (object_type, MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER), NULL);
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	return G_PARAM_SPEC (spec);
#line 991 "CellDataFunctionHelper.c"
}

gpointer
music_value_get_cell_data_function_helper (const GValue* value)
{
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER), NULL);
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	return value->data[0].v_pointer;
#line 1001 "CellDataFunctionHelper.c"
}

void
music_value_set_cell_data_function_helper (GValue* value,
                                           gpointer v_object)
{
	MusicCellDataFunctionHelper * old;
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER));
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	old = value->data[0].v_pointer;
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (v_object) {
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER));
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		value->data[0].v_pointer = v_object;
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		music_cell_data_function_helper_ref (value->data[0].v_pointer);
#line 1023 "CellDataFunctionHelper.c"
	} else {
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		value->data[0].v_pointer = NULL;
#line 1027 "CellDataFunctionHelper.c"
	}
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (old) {
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		music_cell_data_function_helper_unref (old);
#line 1033 "CellDataFunctionHelper.c"
	}
}

void
music_value_take_cell_data_function_helper (GValue* value,
                                            gpointer v_object)
{
	MusicCellDataFunctionHelper * old;
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER));
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	old = value->data[0].v_pointer;
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (v_object) {
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER));
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		value->data[0].v_pointer = v_object;
#line 1054 "CellDataFunctionHelper.c"
	} else {
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		value->data[0].v_pointer = NULL;
#line 1058 "CellDataFunctionHelper.c"
	}
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (old) {
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		music_cell_data_function_helper_unref (old);
#line 1064 "CellDataFunctionHelper.c"
	}
}

static void
music_cell_data_function_helper_class_init (MusicCellDataFunctionHelperClass * klass,
                                            gpointer klass_data)
{
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	music_cell_data_function_helper_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	((MusicCellDataFunctionHelperClass *) klass)->finalize = music_cell_data_function_helper_finalize;
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_type_class_adjust_private_offset (klass, &MusicCellDataFunctionHelper_private_offset);
#line 1078 "CellDataFunctionHelper.c"
}

static void
music_cell_data_function_helper_instance_init (MusicCellDataFunctionHelper * self,
                                               gpointer klass)
{
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	self->priv = music_cell_data_function_helper_get_instance_private (self);
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	self->ref_count = 1;
#line 1089 "CellDataFunctionHelper.c"
}

static void
music_cell_data_function_helper_finalize (MusicCellDataFunctionHelper * obj)
{
	MusicCellDataFunctionHelper * self;
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER, MusicCellDataFunctionHelper);
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_signal_handlers_destroy (self);
#line 33 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	_g_object_unref0 (self->priv->view);
#line 1102 "CellDataFunctionHelper.c"
}

static GType
music_cell_data_function_helper_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { music_value_cell_data_function_helper_init, music_value_cell_data_function_helper_free_value, music_value_cell_data_function_helper_copy_value, music_value_cell_data_function_helper_peek_pointer, "p", music_value_cell_data_function_helper_collect_value, "p", music_value_cell_data_function_helper_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (MusicCellDataFunctionHelperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_cell_data_function_helper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicCellDataFunctionHelper), 0, (GInstanceInitFunc) music_cell_data_function_helper_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType music_cell_data_function_helper_type_id;
	music_cell_data_function_helper_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MusicCellDataFunctionHelper", &g_define_type_info, &g_define_type_fundamental_info, 0);
	MusicCellDataFunctionHelper_private_offset = g_type_add_instance_private (music_cell_data_function_helper_type_id, sizeof (MusicCellDataFunctionHelperPrivate));
	return music_cell_data_function_helper_type_id;
}

GType
music_cell_data_function_helper_get_type (void)
{
	static volatile gsize music_cell_data_function_helper_type_id__once = 0;
	if (g_once_init_enter (&music_cell_data_function_helper_type_id__once)) {
		GType music_cell_data_function_helper_type_id;
		music_cell_data_function_helper_type_id = music_cell_data_function_helper_get_type_once ();
		g_once_init_leave (&music_cell_data_function_helper_type_id__once, music_cell_data_function_helper_type_id);
	}
	return music_cell_data_function_helper_type_id__once;
}

gpointer
music_cell_data_function_helper_ref (gpointer instance)
{
	MusicCellDataFunctionHelper * self;
	self = instance;
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	g_atomic_int_inc (&self->ref_count);
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	return instance;
#line 1138 "CellDataFunctionHelper.c"
}

void
music_cell_data_function_helper_unref (gpointer instance)
{
	MusicCellDataFunctionHelper * self;
	self = instance;
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		MUSIC_CELL_DATA_FUNCTION_HELPER_GET_CLASS (self)->finalize (self);
#line 30 "../src/Views/ListView/Lists/CellDataFunctionHelper.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1152 "CellDataFunctionHelper.c"
	}
}

