/* MusicListView.c generated by valac 0.56.0, the Vala compiler
 * generated from MusicListView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Corentin Noël <corentin@elementary.io>,
 *              Lucas Baudin <xapantu@gmail.com>,
 *              ammonkey <am.monkeyd@gmail.com>,
 *              Victor Martinez <victoreduardm@gmail.com>,
 *              Sergey Davidoff <shnatsel@gmail.com>
 */

#include "music-lib.h"
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <pango/pango.h>

enum  {
	MUSIC_MUSIC_LIST_VIEW_0_PROPERTY,
	MUSIC_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY,
	MUSIC_MUSIC_LIST_VIEW_NUM_PROPERTIES
};
static GParamSpec* music_music_list_view_properties[MUSIC_MUSIC_LIST_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block24Data Block24Data;
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
typedef struct _Block25Data Block25Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MusicMusicListViewPrivate {
	MusicMediaMenu* _media_action_menu;
	GtkMenuItem* autosize_menu_item;
};

struct _Block24Data {
	int _ref_count_;
	MusicMusicListView* self;
	GtkCheckMenuItem* menu_item;
	GtkTreeViewColumn* tvc;
};

struct _Block25Data {
	int _ref_count_;
	MusicMusicListView* self;
	GeeCollection* selected_media;
};

static gint MusicMusicListView_private_offset;
static gpointer music_music_list_view_parent_class = NULL;

static void music_music_list_view_add_column_chooser_menu_item (MusicMusicListView* self,
                                                         GtkTreeViewColumn* tvc,
                                                         MusicListColumn type);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
static void music_music_list_view_columns_autosize (MusicMusicListView* self);
static void _music_music_list_view_columns_autosize_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                     gpointer self);
static void __lambda63_ (Block24Data* _data24_);
static void ___lambda63__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                               gpointer self);
static gboolean music_music_list_view_real_button_press_event (GtkWidget* base,
                                                        GdkEventButton* event);
static gboolean music_music_list_view_check_selection_event (MusicMusicListView* self,
                                                      GdkEventButton* event);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void music_music_list_view_reset_column_widths (MusicMusicListView* self);
static gboolean music_music_list_view_view_click_release (MusicMusicListView* self,
                                                   GtkWidget* sender,
                                                   GdkEventButton* event);
static gboolean music_music_list_view_view_header_click (MusicMusicListView* self,
                                                  GdkEventButton* e,
                                                  gboolean is_selector_col);
static void music_music_list_view_real_media_remove_clicked (MusicGenericList* base);
static Block25Data* block25_data_ref (Block25Data* _data25_);
static void block25_data_unref (void * _userdata_);
static void ___lambda64_ (Block25Data* _data25_,
                   gboolean delete_files);
static void ____lambda64__music_remove_files_dialog_remove_media (MusicRemoveFilesDialog* _sender,
                                                           gboolean response,
                                                           gpointer self);
static void music_music_list_view_real_on_drag_data_get (MusicMusicListView* self,
                                                  GdkDragContext* context,
                                                  GtkSelectionData* selection_data,
                                                  guint info,
                                                  guint time_);
static void _vala_array_add14 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void music_music_list_view_real_add_column (MusicGenericList* base,
                                            GtkTreeViewColumn* tvc,
                                            MusicListColumn type);
static void _music_cell_data_function_helper_icon_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                           GtkCellRenderer* cell,
                                                                           GtkTreeModel* tree_model,
                                                                           GtkTreeIter* iter,
                                                                           gpointer self);
static void _music_cell_data_function_helper_spinner_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                              GtkCellRenderer* cell,
                                                                              GtkTreeModel* tree_model,
                                                                              GtkTreeIter* iter,
                                                                              gpointer self);
static void _music_cell_data_function_helper_bitrate_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                              GtkCellRenderer* cell,
                                                                              GtkTreeModel* tree_model,
                                                                              GtkTreeIter* iter,
                                                                              gpointer self);
static void _vala_array_add15 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _music_cell_data_function_helper_length_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                             GtkCellRenderer* cell,
                                                                             GtkTreeModel* tree_model,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self);
static void _vala_array_add16 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _music_cell_data_function_helper_date_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                           GtkCellRenderer* cell,
                                                                           GtkTreeModel* tree_model,
                                                                           GtkTreeIter* iter,
                                                                           gpointer self);
static void _vala_array_add17 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add18 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _music_generic_list_on_rating_cell_changed_music_rating_cell_renderer_rating_changed (MusicRatingCellRenderer* _sender,
                                                                                           gint new_rating,
                                                                                           GtkWidget* widget,
                                                                                           const gchar* path,
                                                                                           gpointer self);
static void _music_cell_data_function_helper_rating_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                             GtkCellRenderer* cell,
                                                                             GtkTreeModel* tree_model,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self);
static void _music_cell_data_function_helper_number_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                             GtkCellRenderer* cell,
                                                                             GtkTreeModel* tree_model,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self);
static void _vala_array_add19 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _music_cell_data_function_helper_intelligent_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                  GtkCellRenderer* cell,
                                                                                  GtkTreeModel* tree_model,
                                                                                  GtkTreeIter* iter,
                                                                                  gpointer self);
static void _vala_array_add20 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add21 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _music_cell_data_function_helper_string_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                             GtkCellRenderer* cell,
                                                                             GtkTreeModel* tree_model,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self);
static void _vala_array_add22 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add23 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _music_cell_data_function_helper_file_size_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                GtkCellRenderer* cell,
                                                                                GtkTreeModel* tree_model,
                                                                                GtkTreeIter* iter,
                                                                                gpointer self);
static void _vala_array_add24 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static gboolean ___lambda65_ (MusicMusicListView* self,
                       GdkEventButton* e);
static gboolean ____lambda65__gtk_widget_button_press_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
static gboolean ___lambda66_ (MusicMusicListView* self,
                       GdkEventButton* e);
static gboolean ____lambda66__gtk_widget_button_press_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
static void music_music_list_view_set_media_action_menu (MusicMusicListView* self,
                                                  MusicMediaMenu* value);
static GObject * music_music_list_view_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static GValue* _music_music_list_view_view_value_func_music_fast_model_value_return_func (gint row,
                                                                                   gint column,
                                                                                   GObject* o,
                                                                                   gpointer self);
static gint _music_music_list_view_view_compare_func_music_generic_list_sort_compare_func (gint sort_column_id,
                                                                                    GtkSortType sort_direction,
                                                                                    MusicMedia* a,
                                                                                    MusicMedia* b,
                                                                                    gint index_a,
                                                                                    gint index_b,
                                                                                    gpointer self);
static gboolean _music_music_list_view_view_click_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                    GdkEventButton* event,
                                                                                    gpointer self);
static void music_music_list_view_finalize (GObject * obj);
static GType music_music_list_view_get_type_once (void);
static void _vala_music_music_list_view_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_music_music_list_view_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
music_music_list_view_get_instance_private (MusicMusicListView* self)
{
	return G_STRUCT_MEMBER_P (self, MusicMusicListView_private_offset);
}

MusicMusicListView*
music_music_list_view_construct (GType object_type,
                                 MusicViewWrapper* view_wrapper,
                                 MusicTreeViewSetup* tvs)
{
	MusicMusicListView * self = NULL;
#line 41 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (view_wrapper != NULL, NULL);
#line 41 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (tvs != NULL, NULL);
#line 42 "../src/Views/ListView/Lists/MusicListView.vala"
	self = (MusicMusicListView*) g_object_new (object_type, "parent-wrapper", view_wrapper, "tvs", tvs, NULL);
#line 41 "../src/Views/ListView/Lists/MusicListView.vala"
	return self;
#line 291 "MusicListView.c"
}

MusicMusicListView*
music_music_list_view_new (MusicViewWrapper* view_wrapper,
                           MusicTreeViewSetup* tvs)
{
#line 41 "../src/Views/ListView/Lists/MusicListView.vala"
	return music_music_list_view_construct (MUSIC_TYPE_MUSIC_LIST_VIEW, view_wrapper, tvs);
#line 300 "MusicListView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	return self ? g_object_ref (self) : NULL;
#line 308 "MusicListView.c"
}

static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	g_atomic_int_inc (&_data24_->_ref_count_);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	return _data24_;
#line 318 "MusicListView.c"
}

static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
#line 328 "MusicListView.c"
		MusicMusicListView* self;
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
		self = _data24_->self;
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (_data24_->menu_item);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (_data24_->tvc);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (self);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
		g_slice_free (Block24Data, _data24_);
#line 340 "MusicListView.c"
	}
}

static void
_music_music_list_view_columns_autosize_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                gpointer self)
{
#line 75 "../src/Views/ListView/Lists/MusicListView.vala"
	music_music_list_view_columns_autosize ((MusicMusicListView*) self);
#line 350 "MusicListView.c"
}

static void
__lambda63_ (Block24Data* _data24_)
{
	MusicMusicListView* self;
	GtkCheckMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 90 "../src/Views/ListView/Lists/MusicListView.vala"
	self = _data24_->self;
#line 91 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = _data24_->menu_item;
#line 91 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = gtk_check_menu_item_get_active (_tmp0_);
#line 91 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp2_ = _tmp1_;
#line 91 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_visible (_data24_->tvc, _tmp2_);
#line 93 "../src/Views/ListView/Lists/MusicListView.vala"
	music_music_list_view_columns_autosize (self);
#line 372 "MusicListView.c"
}

static void
___lambda63__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                          gpointer self)
{
#line 90 "../src/Views/ListView/Lists/MusicListView.vala"
	__lambda63_ (self);
#line 381 "MusicListView.c"
}

static void
music_music_list_view_add_column_chooser_menu_item (MusicMusicListView* self,
                                                    GtkTreeViewColumn* tvc,
                                                    MusicListColumn type)
{
	Block24Data* _data24_;
	GtkTreeViewColumn* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	MusicViewWrapperHint _tmp3_;
	MusicViewWrapperHint _tmp4_;
	GtkMenu* _tmp5_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GtkCheckMenuItem* _tmp17_;
	GtkCheckMenuItem* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	GtkMenu* _tmp21_;
	GtkCheckMenuItem* _tmp22_;
	GtkMenu* _tmp23_;
	GtkCheckMenuItem* _tmp24_;
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (tvc != NULL);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	_data24_ = g_slice_new0 (Block24Data);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	_data24_->_ref_count_ = 1;
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	_data24_->self = g_object_ref (self);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = _g_object_ref0 (tvc);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (_data24_->tvc);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	_data24_->tvc = _tmp0_;
#line 65 "../src/Views/ListView/Lists/MusicListView.vala"
	if (type == MUSIC_LIST_COLUMN_TITLE) {
#line 65 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp1_ = TRUE;
#line 426 "MusicListView.c"
	} else {
#line 65 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp1_ = type == MUSIC_LIST_COLUMN_ICON;
#line 430 "MusicListView.c"
	}
#line 65 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp1_) {
#line 66 "../src/Views/ListView/Lists/MusicListView.vala"
		block24_data_unref (_data24_);
#line 66 "../src/Views/ListView/Lists/MusicListView.vala"
		_data24_ = NULL;
#line 66 "../src/Views/ListView/Lists/MusicListView.vala"
		return;
#line 440 "MusicListView.c"
	}
#line 69 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp3_ = music_generic_list_get_hint ((MusicGenericList*) self);
#line 69 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp4_ = _tmp3_;
#line 69 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp4_ == MUSIC_VIEW_WRAPPER_HINT_MUSIC) {
#line 69 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp2_ = type == MUSIC_LIST_COLUMN_NUMBER;
#line 450 "MusicListView.c"
	} else {
#line 69 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp2_ = FALSE;
#line 454 "MusicListView.c"
	}
#line 69 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp2_) {
#line 70 "../src/Views/ListView/Lists/MusicListView.vala"
		block24_data_unref (_data24_);
#line 70 "../src/Views/ListView/Lists/MusicListView.vala"
		_data24_ = NULL;
#line 70 "../src/Views/ListView/Lists/MusicListView.vala"
		return;
#line 464 "MusicListView.c"
	}
#line 73 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp5_ = self->column_chooser_menu;
#line 73 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp5_ == NULL) {
#line 470 "MusicListView.c"
		GtkMenuItem* _tmp6_;
		GtkMenuItem* _tmp7_;
		GtkMenu* _tmp8_;
		GtkMenu* _tmp9_;
		GtkMenuItem* _tmp10_;
		GtkMenu* _tmp11_;
		GtkSeparatorMenuItem* _tmp12_;
		GtkSeparatorMenuItem* _tmp13_;
		GtkMenu* _tmp14_;
#line 74 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp6_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Autosize Columns"));
#line 74 "../src/Views/ListView/Lists/MusicListView.vala"
		g_object_ref_sink (_tmp6_);
#line 74 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (self->priv->autosize_menu_item);
#line 74 "../src/Views/ListView/Lists/MusicListView.vala"
		self->priv->autosize_menu_item = _tmp6_;
#line 75 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp7_ = self->priv->autosize_menu_item;
#line 75 "../src/Views/ListView/Lists/MusicListView.vala"
		g_signal_connect_object (_tmp7_, "activate", (GCallback) _music_music_list_view_columns_autosize_gtk_menu_item_activate, self, 0);
#line 77 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp8_ = (GtkMenu*) gtk_menu_new ();
#line 77 "../src/Views/ListView/Lists/MusicListView.vala"
		g_object_ref_sink (_tmp8_);
#line 77 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (self->column_chooser_menu);
#line 77 "../src/Views/ListView/Lists/MusicListView.vala"
		self->column_chooser_menu = _tmp8_;
#line 78 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp9_ = self->column_chooser_menu;
#line 78 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp10_ = self->priv->autosize_menu_item;
#line 78 "../src/Views/ListView/Lists/MusicListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp9_, _tmp10_);
#line 79 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp11_ = self->column_chooser_menu;
#line 79 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp12_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 79 "../src/Views/ListView/Lists/MusicListView.vala"
		g_object_ref_sink (_tmp12_);
#line 79 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp13_ = _tmp12_;
#line 79 "../src/Views/ListView/Lists/MusicListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp11_, (GtkMenuItem*) _tmp13_);
#line 79 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (_tmp13_);
#line 80 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp14_ = self->column_chooser_menu;
#line 80 "../src/Views/ListView/Lists/MusicListView.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp14_);
#line 522 "MusicListView.c"
	}
#line 83 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp15_ = gtk_tree_view_column_get_title (_data24_->tvc);
#line 83 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp16_ = _tmp15_;
#line 83 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp17_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_tmp16_);
#line 83 "../src/Views/ListView/Lists/MusicListView.vala"
	g_object_ref_sink (_tmp17_);
#line 83 "../src/Views/ListView/Lists/MusicListView.vala"
	_data24_->menu_item = _tmp17_;
#line 84 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp18_ = _data24_->menu_item;
#line 84 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp19_ = gtk_tree_view_column_get_visible (_data24_->tvc);
#line 84 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp20_ = _tmp19_;
#line 84 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_check_menu_item_set_active (_tmp18_, _tmp20_);
#line 86 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp21_ = self->column_chooser_menu;
#line 86 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp22_ = _data24_->menu_item;
#line 86 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp21_, (GtkMenuItem*) _tmp22_);
#line 87 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp23_ = self->column_chooser_menu;
#line 87 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp23_);
#line 90 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp24_ = _data24_->menu_item;
#line 90 "../src/Views/ListView/Lists/MusicListView.vala"
	g_signal_connect_data (_tmp24_, "toggled", (GCallback) ___lambda63__gtk_check_menu_item_toggled, block24_data_ref (_data24_), (GClosureNotify) block24_data_unref, 0);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	block24_data_unref (_data24_);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	_data24_ = NULL;
#line 560 "MusicListView.c"
}

void
music_music_list_view_add_media (MusicMusicListView* self,
                                 GeeCollection* to_add)
{
	GeeArrayList* _tmp0_;
#line 97 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (to_add != NULL);
#line 99 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = ((MusicGenericList*) self)->table;
#line 99 "../src/Views/ListView/Lists/MusicListView.vala"
	gee_array_list_add_all (_tmp0_, to_add);
#line 102 "../src/Views/ListView/Lists/MusicListView.vala"
	music_generic_list_resort ((MusicGenericList*) self);
#line 578 "MusicListView.c"
}

void
music_music_list_view_remove_media (MusicMusicListView* self,
                                    GeeCollection* to_remove)
{
	GeeArrayList* new_table = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp12_;
#line 106 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (self != NULL);
#line 106 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (to_remove != NULL);
#line 107 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 107 "../src/Views/ListView/Lists/MusicListView.vala"
	new_table = _tmp0_;
#line 596 "MusicListView.c"
	{
		GeeArrayList* _m_list = NULL;
		GeeArrayList* _tmp1_;
		gint _m_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _m_index = 0;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp1_ = ((MusicGenericList*) self)->table;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		_m_list = _tmp1_;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp2_ = _m_list;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp4_ = _tmp3_;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		_m_size = _tmp4_;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		_m_index = -1;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		while (TRUE) {
#line 621 "MusicListView.c"
			gint _tmp5_;
			gint _tmp6_;
			MusicMedia* m = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			MusicMedia* _tmp9_;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			_m_index = _m_index + 1;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp5_ = _m_index;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp6_ = _m_size;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
				break;
#line 638 "MusicListView.c"
			}
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp7_ = _m_list;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _m_index);
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			m = (MusicMedia*) _tmp8_;
#line 110 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp9_ = m;
#line 110 "../src/Views/ListView/Lists/MusicListView.vala"
			if (!gee_collection_contains (to_remove, _tmp9_)) {
#line 650 "MusicListView.c"
				GeeArrayList* _tmp10_;
				MusicMedia* _tmp11_;
#line 111 "../src/Views/ListView/Lists/MusicListView.vala"
				_tmp10_ = new_table;
#line 111 "../src/Views/ListView/Lists/MusicListView.vala"
				_tmp11_ = m;
#line 111 "../src/Views/ListView/Lists/MusicListView.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 659 "MusicListView.c"
			}
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (m);
#line 663 "MusicListView.c"
		}
	}
#line 116 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp12_ = new_table;
#line 116 "../src/Views/ListView/Lists/MusicListView.vala"
	music_generic_list_set_table ((MusicGenericList*) self, _tmp12_, FALSE);
#line 106 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (new_table);
#line 672 "MusicListView.c"
}

static gboolean
music_music_list_view_real_button_press_event (GtkWidget* base,
                                               GdkEventButton* event)
{
	MusicMusicListView * self;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	gboolean result;
#line 119 "../src/Views/ListView/Lists/MusicListView.vala"
	self = (MusicMusicListView*) base;
#line 119 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 120 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = event->window;
#line 120 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = gtk_tree_view_get_bin_window ((GtkTreeView*) self);
#line 120 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp0_ != _tmp1_) {
#line 121 "../src/Views/ListView/Lists/MusicListView.vala"
		result = GTK_WIDGET_CLASS (music_music_list_view_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, MUSIC_TYPE_GENERIC_LIST, MusicGenericList), event);
#line 121 "../src/Views/ListView/Lists/MusicListView.vala"
		return result;
#line 697 "MusicListView.c"
	}
#line 124 "../src/Views/ListView/Lists/MusicListView.vala"
	if (music_music_list_view_check_selection_event (self, event)) {
#line 125 "../src/Views/ListView/Lists/MusicListView.vala"
		GTK_WIDGET_CLASS (music_music_list_view_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, MUSIC_TYPE_GENERIC_LIST, MusicGenericList), event);
#line 703 "MusicListView.c"
	}
#line 127 "../src/Views/ListView/Lists/MusicListView.vala"
	if (event->button == ((guint) GDK_BUTTON_SECONDARY)) {
#line 707 "MusicListView.c"
		MusicMediaMenu* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
#line 128 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp2_ = self->priv->_media_action_menu;
#line 128 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp3_ = music_generic_list_get_selected_medias ((MusicGenericList*) self);
#line 128 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp4_ = _tmp3_;
#line 128 "../src/Views/ListView/Lists/MusicListView.vala"
		music_media_menu_popup_media_menu (_tmp2_, _tmp4_);
#line 128 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (_tmp4_);
#line 129 "../src/Views/ListView/Lists/MusicListView.vala"
		result = TRUE;
#line 129 "../src/Views/ListView/Lists/MusicListView.vala"
		return result;
#line 725 "MusicListView.c"
	}
#line 132 "../src/Views/ListView/Lists/MusicListView.vala"
	result = FALSE;
#line 132 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 731 "MusicListView.c"
}

/**
     * Checks whether a Gdk.EventButton resulting in a selection change should be sent
     * to the default handler or not. This is useful to prevent the default handler from
     * destroying the user's previous selection in case there was a multiple selection.
     *
     * @param event the Gdk.EventButton to check
     * @return //true// if the event should be passed to the default handler; false otherwise.
     */
static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 747 "MusicListView.c"
}

static gboolean
music_music_list_view_check_selection_event (MusicMusicListView* self,
                                             GdkEventButton* event)
{
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkTreePath* path = NULL;
	GtkTreeViewColumn* column = NULL;
	gint cell_x = 0;
	gint cell_y = 0;
	GtkTreePath* _tmp3_ = NULL;
	GtkTreeViewColumn* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gboolean _tmp7_;
	GtkTreeViewColumn* _tmp8_;
	gboolean result;
#line 143 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 143 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 143 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = event->window;
#line 143 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = gtk_tree_view_get_bin_window ((GtkTreeView*) self);
#line 143 "../src/Views/ListView/Lists/MusicListView.vala"
	_vala_return_val_if_fail (_tmp0_ == _tmp1_, "event.window == get_bin_window ()", FALSE);
#line 144 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((event->state & GDK_CONTROL_MASK) == event->state) {
#line 144 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp2_ = TRUE;
#line 782 "MusicListView.c"
	} else {
#line 144 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp2_ = (event->state & GDK_SHIFT_MASK) == event->state;
#line 786 "MusicListView.c"
	}
#line 144 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp2_) {
#line 145 "../src/Views/ListView/Lists/MusicListView.vala"
		result = TRUE;
#line 145 "../src/Views/ListView/Lists/MusicListView.vala"
		return result;
#line 794 "MusicListView.c"
	}
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp7_ = gtk_tree_view_get_path_at_pos ((GtkTreeView*) self, (gint) event->x, (gint) event->y, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	__vala_GtkTreePath_free0 (path);
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	path = _tmp3_;
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (column);
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp8_ = _g_object_ref0 (_tmp4_);
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	column = _tmp8_;
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	cell_x = _tmp5_;
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	cell_y = _tmp6_;
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp7_) {
#line 814 "MusicListView.c"
		GtkTreeSelection* selection = NULL;
		GtkTreeSelection* _tmp9_;
		GtkTreeSelection* _tmp10_;
		gboolean _tmp11_ = FALSE;
		GtkTreeSelection* _tmp12_;
#line 153 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp9_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 153 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 153 "../src/Views/ListView/Lists/MusicListView.vala"
		selection = _tmp10_;
#line 158 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp12_ = selection;
#line 158 "../src/Views/ListView/Lists/MusicListView.vala"
		if (gtk_tree_selection_count_selected_rows (_tmp12_) > 1) {
#line 830 "MusicListView.c"
			GtkTreeSelection* _tmp13_;
			GtkTreePath* _tmp14_;
#line 158 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp13_ = selection;
#line 158 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp14_ = path;
#line 158 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp11_ = gtk_tree_selection_path_is_selected (_tmp13_, _tmp14_);
#line 839 "MusicListView.c"
		} else {
#line 158 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp11_ = FALSE;
#line 843 "MusicListView.c"
		}
#line 158 "../src/Views/ListView/Lists/MusicListView.vala"
		if (_tmp11_) {
#line 159 "../src/Views/ListView/Lists/MusicListView.vala"
			result = FALSE;
#line 159 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (selection);
#line 159 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (column);
#line 159 "../src/Views/ListView/Lists/MusicListView.vala"
			__vala_GtkTreePath_free0 (path);
#line 159 "../src/Views/ListView/Lists/MusicListView.vala"
			return result;
#line 857 "MusicListView.c"
		}
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (selection);
#line 861 "MusicListView.c"
	}
#line 162 "../src/Views/ListView/Lists/MusicListView.vala"
	result = TRUE;
#line 162 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (column);
#line 162 "../src/Views/ListView/Lists/MusicListView.vala"
	__vala_GtkTreePath_free0 (path);
#line 162 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 871 "MusicListView.c"
}

static void
music_music_list_view_columns_autosize (MusicMusicListView* self)
{
#line 165 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (self != NULL);
#line 166 "../src/Views/ListView/Lists/MusicListView.vala"
	music_music_list_view_reset_column_widths (self);
#line 167 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_columns_autosize ((GtkTreeView*) G_TYPE_CHECK_INSTANCE_CAST (self, MUSIC_TYPE_GENERIC_LIST, MusicGenericList));
#line 883 "MusicListView.c"
}

static gboolean
music_music_list_view_view_click_release (MusicMusicListView* self,
                                          GtkWidget* sender,
                                          GdkEventButton* event)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 171 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 171 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 171 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 173 "../src/Views/ListView/Lists/MusicListView.vala"
	if (((MusicGenericList*) self)->dragging) {
#line 173 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp0_ = event->button == ((guint) 1);
#line 903 "MusicListView.c"
	} else {
#line 173 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp0_ = FALSE;
#line 907 "MusicListView.c"
	}
#line 173 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp0_) {
#line 174 "../src/Views/ListView/Lists/MusicListView.vala"
		((MusicGenericList*) self)->dragging = FALSE;
#line 175 "../src/Views/ListView/Lists/MusicListView.vala"
		result = TRUE;
#line 175 "../src/Views/ListView/Lists/MusicListView.vala"
		return result;
#line 917 "MusicListView.c"
	} else {
#line 176 "../src/Views/ListView/Lists/MusicListView.vala"
		if (((event->state & GDK_SHIFT_MASK) == GDK_SHIFT_MASK) | ((event->state & GDK_CONTROL_MASK) == GDK_CONTROL_MASK)) {
#line 177 "../src/Views/ListView/Lists/MusicListView.vala"
			result = TRUE;
#line 177 "../src/Views/ListView/Lists/MusicListView.vala"
			return result;
#line 925 "MusicListView.c"
		} else {
			GtkTreePath* path = NULL;
			GtkTreeViewColumn* tvc = NULL;
			gint cell_x = 0;
			gint cell_y = 0;
			gint x = 0;
			gint y = 0;
			GtkTreePath* _tmp1_ = NULL;
			GtkTreeViewColumn* _tmp2_ = NULL;
			gint _tmp3_ = 0;
			gint _tmp4_ = 0;
			gboolean _tmp5_;
			GtkTreeViewColumn* _tmp6_;
			GtkTreeSelection* _tmp7_;
			GtkTreeSelection* _tmp8_;
			GtkTreePath* _tmp9_;
#line 183 "../src/Views/ListView/Lists/MusicListView.vala"
			x = (gint) event->x;
#line 184 "../src/Views/ListView/Lists/MusicListView.vala"
			y = (gint) event->y;
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp5_ = gtk_tree_view_get_path_at_pos ((GtkTreeView*) self, x, y, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			__vala_GtkTreePath_free0 (path);
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			path = _tmp1_;
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (tvc);
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp6_ = _g_object_ref0 (_tmp2_);
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			tvc = _tmp6_;
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			cell_x = _tmp3_;
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			cell_y = _tmp4_;
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			if (!_tmp5_) {
#line 187 "../src/Views/ListView/Lists/MusicListView.vala"
				result = FALSE;
#line 187 "../src/Views/ListView/Lists/MusicListView.vala"
				_g_object_unref0 (tvc);
#line 187 "../src/Views/ListView/Lists/MusicListView.vala"
				__vala_GtkTreePath_free0 (path);
#line 187 "../src/Views/ListView/Lists/MusicListView.vala"
				return result;
#line 972 "MusicListView.c"
			}
#line 188 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp7_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 188 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_tree_selection_unselect_all (_tmp7_);
#line 189 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp8_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 189 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp9_ = path;
#line 189 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_tree_selection_select_path (_tmp8_, _tmp9_);
#line 190 "../src/Views/ListView/Lists/MusicListView.vala"
			result = FALSE;
#line 190 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (tvc);
#line 190 "../src/Views/ListView/Lists/MusicListView.vala"
			__vala_GtkTreePath_free0 (path);
#line 190 "../src/Views/ListView/Lists/MusicListView.vala"
			return result;
#line 992 "MusicListView.c"
		}
	}
}

static gboolean
music_music_list_view_view_header_click (MusicMusicListView* self,
                                         GdkEventButton* e,
                                         gboolean is_selector_col)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 194 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 194 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 195 "../src/Views/ListView/Lists/MusicListView.vala"
	if (e->button == ((guint) GDK_BUTTON_SECONDARY)) {
#line 195 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp0_ = TRUE;
#line 1012 "MusicListView.c"
	} else {
#line 195 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp0_ = is_selector_col;
#line 1016 "MusicListView.c"
	}
#line 195 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp0_) {
#line 1020 "MusicListView.c"
		GtkMenu* _tmp1_;
#line 196 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp1_ = self->column_chooser_menu;
#line 196 "../src/Views/ListView/Lists/MusicListView.vala"
		gtk_menu_popup_at_pointer (_tmp1_, (GdkEvent*) e);
#line 197 "../src/Views/ListView/Lists/MusicListView.vala"
		result = TRUE;
#line 197 "../src/Views/ListView/Lists/MusicListView.vala"
		return result;
#line 1030 "MusicListView.c"
	}
#line 200 "../src/Views/ListView/Lists/MusicListView.vala"
	result = FALSE;
#line 200 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 1036 "MusicListView.c"
}

static Block25Data*
block25_data_ref (Block25Data* _data25_)
{
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	g_atomic_int_inc (&_data25_->_ref_count_);
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	return _data25_;
#line 1046 "MusicListView.c"
}

static void
block25_data_unref (void * _userdata_)
{
	Block25Data* _data25_;
	_data25_ = (Block25Data*) _userdata_;
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	if (g_atomic_int_dec_and_test (&_data25_->_ref_count_)) {
#line 1056 "MusicListView.c"
		MusicMusicListView* self;
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
		self = _data25_->self;
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (_data25_->selected_media);
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (self);
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
		g_slice_free (Block25Data, _data25_);
#line 1066 "MusicListView.c"
	}
}

static void
___lambda64_ (Block25Data* _data25_,
              gboolean delete_files)
{
	MusicMusicListView* self;
	MusicViewWrapper* _tmp0_;
	MusicViewWrapper* _tmp1_;
	MusicLibrary* _tmp2_;
	MusicLibrary* _tmp3_;
	GeeCollection* _tmp4_;
#line 210 "../src/Views/ListView/Lists/MusicListView.vala"
	self = _data25_->self;
#line 211 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = music_generic_list_get_parent_wrapper ((MusicGenericList*) self);
#line 211 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = _tmp0_;
#line 211 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp2_ = music_view_wrapper_get_library (_tmp1_);
#line 211 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp3_ = _tmp2_;
#line 211 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp4_ = _data25_->selected_media;
#line 211 "../src/Views/ListView/Lists/MusicListView.vala"
	music_library_remove_medias (_tmp3_, _tmp4_, delete_files);
#line 1094 "MusicListView.c"
}

static void
____lambda64__music_remove_files_dialog_remove_media (MusicRemoveFilesDialog* _sender,
                                                      gboolean response,
                                                      gpointer self)
{
#line 210 "../src/Views/ListView/Lists/MusicListView.vala"
	___lambda64_ (self, response);
#line 1104 "MusicListView.c"
}

static void
music_music_list_view_real_media_remove_clicked (MusicGenericList* base)
{
	MusicMusicListView * self;
	Block25Data* _data25_;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	MusicViewWrapperHint _tmp5_;
	MusicViewWrapperHint _tmp6_;
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	self = (MusicMusicListView*) base;
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	_data25_ = g_slice_new0 (Block25Data);
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	_data25_->_ref_count_ = 1;
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	_data25_->self = g_object_ref (self);
#line 204 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = music_generic_list_get_selected_medias ((MusicGenericList*) self);
#line 204 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = _tmp0_;
#line 204 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp2_ = gee_collection_get_read_only_view (_tmp1_);
#line 204 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp3_ = _tmp2_;
#line 204 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp4_ = _tmp3_;
#line 204 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (_tmp1_);
#line 204 "../src/Views/ListView/Lists/MusicListView.vala"
	_data25_->selected_media = _tmp4_;
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp5_ = music_generic_list_get_hint ((MusicGenericList*) self);
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp6_ = _tmp5_;
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
	switch (_tmp6_) {
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_VIEW_WRAPPER_HINT_ALBUM_LIST:
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_VIEW_WRAPPER_HINT_MUSIC:
#line 1151 "MusicListView.c"
		{
			MusicRemoveFilesDialog* dialog = NULL;
			GeeCollection* _tmp7_;
			MusicRemoveFilesDialog* _tmp8_;
			MusicRemoveFilesDialog* _tmp9_;
#line 209 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp7_ = _data25_->selected_media;
#line 209 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp8_ = music_remove_files_dialog_new (_tmp7_);
#line 209 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp8_);
#line 209 "../src/Views/ListView/Lists/MusicListView.vala"
			dialog = _tmp8_;
#line 210 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp9_ = dialog;
#line 210 "../src/Views/ListView/Lists/MusicListView.vala"
			g_signal_connect_data (_tmp9_, "remove-media", (GCallback) ____lambda64__music_remove_files_dialog_remove_media, block25_data_ref (_data25_), (GClosureNotify) block25_data_unref, 0);
#line 213 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (dialog);
#line 213 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1173 "MusicListView.c"
		}
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO:
#line 1177 "MusicListView.c"
		{
			MusicDeviceViewWrapper* dvw = NULL;
			MusicViewWrapper* _tmp10_;
			MusicViewWrapper* _tmp11_;
			MusicDeviceViewWrapper* _tmp12_;
			MusicDeviceViewWrapper* _tmp13_;
			MusicLibrary* _tmp14_;
			MusicLibrary* _tmp15_;
			GeeCollection* _tmp16_;
#line 215 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp10_ = music_generic_list_get_parent_wrapper ((MusicGenericList*) self);
#line 215 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp11_ = _tmp10_;
#line 215 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper));
#line 215 "../src/Views/ListView/Lists/MusicListView.vala"
			dvw = _tmp12_;
#line 216 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp13_ = dvw;
#line 216 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp14_ = music_view_wrapper_get_library ((MusicViewWrapper*) _tmp13_);
#line 216 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp15_ = _tmp14_;
#line 216 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp16_ = _data25_->selected_media;
#line 216 "../src/Views/ListView/Lists/MusicListView.vala"
			music_library_remove_medias (_tmp15_, _tmp16_, TRUE);
#line 217 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (dvw);
#line 217 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1209 "MusicListView.c"
		}
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_VIEW_WRAPPER_HINT_PLAYLIST:
#line 1213 "MusicListView.c"
		{
			MusicPlaylist* _tmp17_;
			MusicPlaylist* _tmp18_;
			GeeCollection* _tmp19_;
#line 219 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp17_ = music_generic_list_get_playlist ((MusicGenericList*) self);
#line 219 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp18_ = _tmp17_;
#line 219 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp19_ = _data25_->selected_media;
#line 219 "../src/Views/ListView/Lists/MusicListView.vala"
			music_playlist_remove_medias (_tmp18_, _tmp19_);
#line 220 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1228 "MusicListView.c"
		}
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_VIEW_WRAPPER_HINT_QUEUE:
#line 1232 "MusicListView.c"
		{
			MusicPlaybackManager* _tmp20_;
			MusicPlaybackManager* _tmp21_;
			GeeCollection* _tmp22_;
#line 222 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp20_ = music_app_get_player ();
#line 222 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp21_ = _tmp20_;
#line 222 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp22_ = _data25_->selected_media;
#line 222 "../src/Views/ListView/Lists/MusicListView.vala"
			music_playback_manager_unqueue_media (_tmp21_, _tmp22_);
#line 223 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1247 "MusicListView.c"
		}
		default:
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
		break;
#line 1252 "MusicListView.c"
	}
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	block25_data_unref (_data25_);
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	_data25_ = NULL;
#line 1258 "MusicListView.c"
}

static void
_vala_array_add14 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1273 "MusicListView.c"
	}
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 1279 "MusicListView.c"
}

static void
music_music_list_view_real_on_drag_data_get (MusicMusicListView* self,
                                             GdkDragContext* context,
                                             GtkSelectionData* selection_data,
                                             guint info,
                                             guint time_)
{
	gchar** uris = NULL;
	gint uris_length1;
	gint _uris_size_;
	gchar** _tmp14_;
	gint _tmp14__length1;
#line 227 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (context != NULL);
#line 227 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (selection_data != NULL);
#line 228 "../src/Views/ListView/Lists/MusicListView.vala"
	uris = NULL;
#line 228 "../src/Views/ListView/Lists/MusicListView.vala"
	uris_length1 = 0;
#line 228 "../src/Views/ListView/Lists/MusicListView.vala"
	_uris_size_ = uris_length1;
#line 1304 "MusicListView.c"
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp0_ = music_generic_list_get_selected_medias ((MusicGenericList*) self);
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp1_ = _tmp0_;
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp3_ = _tmp2_;
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (_tmp1_);
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
		_m_it = _tmp3_;
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
		while (TRUE) {
#line 1325 "MusicListView.c"
			GeeIterator* _tmp4_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			MusicMedia* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			MusicMedia* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp4_ = _m_it;
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
				break;
#line 1343 "MusicListView.c"
			}
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp5_ = _m_it;
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
			m = (MusicMedia*) _tmp6_;
#line 231 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp7_ = m;
#line 231 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp8_ = music_media_get_uri (_tmp7_);
#line 231 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp9_ = _tmp8_;
#line 231 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp10_ = _tmp9_;
#line 231 "../src/Views/ListView/Lists/MusicListView.vala"
			g_debug ("MusicListView.vala:231: adding %s", _tmp10_);
#line 231 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_free0 (_tmp10_);
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp11_ = m;
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp12_ = music_media_get_uri (_tmp11_);
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp13_ = _tmp12_;
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add14 (&uris, &uris_length1, &_uris_size_, _tmp13_);
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (m);
#line 1373 "MusicListView.c"
		}
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (_m_it);
#line 1377 "MusicListView.c"
	}
#line 235 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp14_ = uris;
#line 235 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp14__length1 = uris_length1;
#line 235 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp14_ != NULL) {
#line 1385 "MusicListView.c"
		gchar** _tmp15_;
		gint _tmp15__length1;
#line 236 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp15_ = uris;
#line 236 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp15__length1 = uris_length1;
#line 236 "../src/Views/ListView/Lists/MusicListView.vala"
		gtk_selection_data_set_uris (selection_data, _tmp15_);
#line 1394 "MusicListView.c"
	}
#line 227 "../src/Views/ListView/Lists/MusicListView.vala"
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 1398 "MusicListView.c"
}

void
music_music_list_view_on_drag_data_get (MusicMusicListView* self,
                                        GdkDragContext* context,
                                        GtkSelectionData* selection_data,
                                        guint info,
                                        guint time_)
{
	MusicMusicListViewClass* _klass_;
#line 227 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (self != NULL);
#line 227 "../src/Views/ListView/Lists/MusicListView.vala"
	_klass_ = MUSIC_MUSIC_LIST_VIEW_GET_CLASS (self);
#line 227 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_klass_->on_drag_data_get) {
#line 227 "../src/Views/ListView/Lists/MusicListView.vala"
		_klass_->on_drag_data_get (self, context, selection_data, info, time_);
#line 1417 "MusicListView.c"
	}
}

static void
music_music_list_view_reset_column_widths (MusicMusicListView* self)
{
	GList* _tmp0_;
#line 239 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (self != NULL);
#line 240 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = gtk_tree_view_get_columns ((GtkTreeView*) self);
#line 1429 "MusicListView.c"
	{
		GList* column_collection = NULL;
		GList* column_it = NULL;
#line 240 "../src/Views/ListView/Lists/MusicListView.vala"
		column_collection = _tmp0_;
#line 240 "../src/Views/ListView/Lists/MusicListView.vala"
		for (column_it = column_collection; column_it != NULL; column_it = column_it->next) {
#line 1437 "MusicListView.c"
			GtkTreeViewColumn* column = NULL;
#line 240 "../src/Views/ListView/Lists/MusicListView.vala"
			column = (GtkTreeViewColumn*) column_it->data;
#line 1441 "MusicListView.c"
			{
				GtkTreeViewColumn* _tmp1_;
				gint _tmp2_;
				gint _tmp3_;
#line 241 "../src/Views/ListView/Lists/MusicListView.vala"
				_tmp1_ = column;
#line 241 "../src/Views/ListView/Lists/MusicListView.vala"
				_tmp2_ = gtk_tree_view_column_get_min_width (_tmp1_);
#line 241 "../src/Views/ListView/Lists/MusicListView.vala"
				_tmp3_ = _tmp2_;
#line 241 "../src/Views/ListView/Lists/MusicListView.vala"
				if (_tmp3_ > 0) {
#line 1454 "MusicListView.c"
					GtkTreeViewColumn* _tmp4_;
					GtkTreeViewColumn* _tmp5_;
					gint _tmp6_;
					gint _tmp7_;
#line 242 "../src/Views/ListView/Lists/MusicListView.vala"
					_tmp4_ = column;
#line 242 "../src/Views/ListView/Lists/MusicListView.vala"
					_tmp5_ = column;
#line 242 "../src/Views/ListView/Lists/MusicListView.vala"
					_tmp6_ = gtk_tree_view_column_get_min_width (_tmp5_);
#line 242 "../src/Views/ListView/Lists/MusicListView.vala"
					_tmp7_ = _tmp6_;
#line 242 "../src/Views/ListView/Lists/MusicListView.vala"
					gtk_tree_view_column_set_fixed_width (_tmp4_, _tmp7_);
#line 1469 "MusicListView.c"
				}
			}
		}
#line 240 "../src/Views/ListView/Lists/MusicListView.vala"
		(column_collection == NULL) ? NULL : (column_collection = (g_list_free (column_collection), NULL));
#line 1475 "MusicListView.c"
	}
}

/**
     * Compares the two given objects based on the sort column.
     */
gint
music_music_list_view_view_compare_func (MusicMusicListView* self,
                                         gint column,
                                         GtkSortType dir,
                                         MusicMedia* media_a,
                                         MusicMedia* media_b,
                                         gint a_pos,
                                         gint b_pos)
{
	MusicPlaylist* _tmp0_;
	MusicPlaylist* _tmp1_;
	MusicPlaybackManager* _tmp2_;
	MusicPlaybackManager* _tmp3_;
	MusicStaticPlaylist* _tmp4_;
	gint order = 0;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp58_ = FALSE;
	gboolean _tmp59_ = FALSE;
	gboolean _tmp66_ = FALSE;
	gint result;
#line 250 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 250 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (media_a != NULL, 0);
#line 250 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (media_b != NULL, 0);
#line 251 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = music_generic_list_get_playlist ((MusicGenericList*) self);
#line 251 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = _tmp0_;
#line 251 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp2_ = music_app_get_player ();
#line 251 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp3_ = _tmp2_;
#line 251 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp4_ = _tmp3_->queue_playlist;
#line 251 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp1_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, MUSIC_TYPE_PLAYLIST, MusicPlaylist)) {
#line 252 "../src/Views/ListView/Lists/MusicListView.vala"
		result = a_pos - b_pos;
#line 252 "../src/Views/ListView/Lists/MusicListView.vala"
		return result;
#line 1524 "MusicListView.c"
	}
#line 255 "../src/Views/ListView/Lists/MusicListView.vala"
	order = 0;
#line 256 "../src/Views/ListView/Lists/MusicListView.vala"
	if (column >= 0) {
#line 256 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp5_ = column < ((gint) MUSIC_LIST_COLUMN_N_COLUMNS);
#line 1532 "MusicListView.c"
	} else {
#line 256 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp5_ = FALSE;
#line 1536 "MusicListView.c"
	}
#line 256 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (_tmp5_, order);
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
	switch (column) {
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_NUMBER:
#line 1544 "MusicListView.c"
		{
#line 260 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_compare_standard (a_pos, b_pos);
#line 261 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1550 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_TITLE:
#line 1554 "MusicListView.c"
		{
#line 264 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_compare_titles (media_a, media_b);
#line 265 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1560 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_LENGTH:
#line 1564 "MusicListView.c"
		{
			guint _tmp6_;
			guint _tmp7_;
			guint _tmp8_;
			guint _tmp9_;
#line 268 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp6_ = music_media_get_length (media_a);
#line 268 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp7_ = _tmp6_;
#line 268 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp8_ = music_media_get_length (media_b);
#line 268 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp9_ = _tmp8_;
#line 268 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_compare_standard_unsigned (_tmp7_, _tmp9_);
#line 269 "../src/Views/ListView/Lists/MusicListView.vala"
			if (order == 0) {
#line 270 "../src/Views/ListView/Lists/MusicListView.vala"
				music_compare_titles (media_a, media_b);
#line 1584 "MusicListView.c"
			}
#line 272 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1588 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_ARTIST:
#line 1592 "MusicListView.c"
		{
#line 275 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_compare_artists (media_a, media_b);
#line 276 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1598 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_ALBUM:
#line 1602 "MusicListView.c"
		{
#line 279 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_compare_albums (media_a, media_b);
#line 280 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1608 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_TRACK:
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_ALBUM_ARTIST:
#line 1614 "MusicListView.c"
		{
#line 288 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_compare_album_artists (media_a, media_b);
#line 289 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1620 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_COMPOSER:
#line 1624 "MusicListView.c"
		{
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 292 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp10_ = music_media_get_display_composer (media_a);
#line 292 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp11_ = _tmp10_;
#line 292 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp12_ = music_media_get_display_composer (media_b);
#line 292 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp13_ = _tmp12_;
#line 292 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_string_compare (_tmp11_, _tmp13_);
#line 292 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_free0 (_tmp13_);
#line 292 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_free0 (_tmp11_);
#line 293 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1646 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_GROUPING:
#line 1650 "MusicListView.c"
		{
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
#line 296 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp14_ = music_media_get_grouping (media_a);
#line 296 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp15_ = _tmp14_;
#line 296 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp16_ = music_media_get_grouping (media_b);
#line 296 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp17_ = _tmp16_;
#line 296 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_string_compare (_tmp15_, _tmp17_);
#line 297 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1668 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_GENRE:
#line 1672 "MusicListView.c"
		{
#line 299 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_compare_genres (media_a, media_b);
#line 300 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1678 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_YEAR:
#line 1682 "MusicListView.c"
		{
			guint _tmp18_;
			guint _tmp19_;
			guint _tmp20_;
			guint _tmp21_;
#line 303 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp18_ = music_media_get_year (media_a);
#line 303 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp19_ = _tmp18_;
#line 303 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp20_ = music_media_get_year (media_b);
#line 303 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp21_ = _tmp20_;
#line 303 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_compare_standard_unsigned (_tmp19_, _tmp21_);
#line 304 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1700 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_BITRATE:
#line 1704 "MusicListView.c"
		{
			guint _tmp22_;
			guint _tmp23_;
			guint _tmp24_;
			guint _tmp25_;
#line 307 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp22_ = music_media_get_bitrate (media_a);
#line 307 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp23_ = _tmp22_;
#line 307 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp24_ = music_media_get_bitrate (media_b);
#line 307 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp25_ = _tmp24_;
#line 307 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_compare_standard_unsigned (_tmp23_, _tmp25_);
#line 308 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1722 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_RATING:
#line 1726 "MusicListView.c"
		{
			guint _tmp26_;
			guint _tmp27_;
			guint _tmp28_;
			guint _tmp29_;
#line 311 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp26_ = music_media_get_rating (media_a);
#line 311 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp27_ = _tmp26_;
#line 311 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp28_ = music_media_get_rating (media_b);
#line 311 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp29_ = _tmp28_;
#line 311 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_compare_standard_unsigned (_tmp27_, _tmp29_);
#line 312 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1744 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_PLAY_COUNT:
#line 1748 "MusicListView.c"
		{
			guint _tmp30_;
			guint _tmp31_;
			guint _tmp32_;
			guint _tmp33_;
#line 315 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp30_ = music_media_get_play_count (media_a);
#line 315 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp31_ = _tmp30_;
#line 315 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp32_ = music_media_get_play_count (media_b);
#line 315 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp33_ = _tmp32_;
#line 315 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_compare_standard_unsigned (_tmp31_, _tmp33_);
#line 316 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1766 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_SKIP_COUNT:
#line 1770 "MusicListView.c"
		{
			guint _tmp34_;
			guint _tmp35_;
			guint _tmp36_;
			guint _tmp37_;
#line 319 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp34_ = music_media_get_skip_count (media_a);
#line 319 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp35_ = _tmp34_;
#line 319 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp36_ = music_media_get_skip_count (media_b);
#line 319 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp37_ = _tmp36_;
#line 319 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_compare_standard_unsigned (_tmp35_, _tmp37_);
#line 320 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1788 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_DATE_ADDED:
#line 1792 "MusicListView.c"
		{
			guint _tmp38_;
			guint _tmp39_;
			guint _tmp40_;
			guint _tmp41_;
#line 323 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp38_ = music_media_get_date_added (media_a);
#line 323 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp39_ = _tmp38_;
#line 323 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp40_ = music_media_get_date_added (media_b);
#line 323 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp41_ = _tmp40_;
#line 323 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_compare_standard_unsigned (_tmp39_, _tmp41_);
#line 324 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1810 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_LAST_PLAYED:
#line 1814 "MusicListView.c"
		{
			guint _tmp42_;
			guint _tmp43_;
			guint _tmp44_;
			guint _tmp45_;
#line 327 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp42_ = music_media_get_last_played (media_a);
#line 327 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp43_ = _tmp42_;
#line 327 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp44_ = music_media_get_last_played (media_b);
#line 327 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp45_ = _tmp44_;
#line 327 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_compare_standard_unsigned (_tmp43_, _tmp45_);
#line 328 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1832 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_BPM:
#line 1836 "MusicListView.c"
		{
			guint _tmp46_;
			guint _tmp47_;
			guint _tmp48_;
			guint _tmp49_;
#line 331 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp46_ = music_media_get_bpm (media_a);
#line 331 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp47_ = _tmp46_;
#line 331 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp48_ = music_media_get_bpm (media_b);
#line 331 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp49_ = _tmp48_;
#line 331 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_compare_standard_unsigned (_tmp47_, _tmp49_);
#line 332 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1854 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_FILE_SIZE:
#line 1858 "MusicListView.c"
		{
			guint64 _tmp50_;
			guint64 _tmp51_;
			guint64 _tmp52_;
			guint64 _tmp53_;
#line 335 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp50_ = music_media_get_file_size (media_a);
#line 335 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp51_ = _tmp50_;
#line 335 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp52_ = music_media_get_file_size (media_b);
#line 335 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp53_ = _tmp52_;
#line 335 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_compare_standard_64 ((gint64) _tmp51_, (gint64) _tmp53_);
#line 336 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1876 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_FILE_LOCATION:
#line 1880 "MusicListView.c"
		{
			gchar* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
#line 339 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp54_ = music_media_get_display_location (media_a);
#line 339 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp55_ = _tmp54_;
#line 339 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp56_ = music_media_get_display_location (media_b);
#line 339 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp57_ = _tmp56_;
#line 339 "../src/Views/ListView/Lists/MusicListView.vala"
			order = music_string_compare (_tmp55_, _tmp57_);
#line 339 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_free0 (_tmp57_);
#line 339 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_free0 (_tmp55_);
#line 340 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1902 "MusicListView.c"
		}
		default:
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		break;
#line 1907 "MusicListView.c"
	}
#line 345 "../src/Views/ListView/Lists/MusicListView.vala"
	if (order == 0) {
#line 345 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp59_ = column != ((gint) MUSIC_LIST_COLUMN_GENRE);
#line 1913 "MusicListView.c"
	} else {
#line 345 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp59_ = FALSE;
#line 1917 "MusicListView.c"
	}
#line 345 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp59_) {
#line 345 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp58_ = column != ((gint) MUSIC_LIST_COLUMN_ARTIST);
#line 1923 "MusicListView.c"
	} else {
#line 345 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp58_ = FALSE;
#line 1927 "MusicListView.c"
	}
#line 345 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp58_) {
#line 346 "../src/Views/ListView/Lists/MusicListView.vala"
		order = music_compare_titles (media_a, media_b);
#line 1933 "MusicListView.c"
	}
#line 349 "../src/Views/ListView/Lists/MusicListView.vala"
	if (order == 0) {
#line 1937 "MusicListView.c"
		gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		gchar* _tmp63_;
		gchar* _tmp64_;
		gchar* _tmp65_;
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp60_ = music_media_get_uri (media_a);
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp61_ = _tmp60_;
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp62_ = _tmp61_;
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp63_ = music_media_get_uri (media_b);
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp64_ = _tmp63_;
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp65_ = _tmp64_;
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		order = music_string_compare (_tmp62_, _tmp65_);
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_free0 (_tmp65_);
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_free0 (_tmp62_);
#line 1962 "MusicListView.c"
	}
#line 353 "../src/Views/ListView/Lists/MusicListView.vala"
	if (dir == GTK_SORT_DESCENDING) {
#line 353 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp66_ = order != 0;
#line 1968 "MusicListView.c"
	} else {
#line 353 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp66_ = FALSE;
#line 1972 "MusicListView.c"
	}
#line 353 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp66_) {
#line 1976 "MusicListView.c"
		gint _tmp67_ = 0;
#line 354 "../src/Views/ListView/Lists/MusicListView.vala"
		if (order > 0) {
#line 354 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp67_ = -1;
#line 1982 "MusicListView.c"
		} else {
#line 354 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp67_ = 1;
#line 1986 "MusicListView.c"
		}
#line 354 "../src/Views/ListView/Lists/MusicListView.vala"
		order = _tmp67_;
#line 1990 "MusicListView.c"
	}
#line 356 "../src/Views/ListView/Lists/MusicListView.vala"
	result = order;
#line 356 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 1996 "MusicListView.c"
}

GValue*
music_music_list_view_view_value_func (MusicMusicListView* self,
                                       gint row,
                                       gint column,
                                       GObject* o)
{
	MusicMedia* m = NULL;
	MusicMedia* _tmp0_;
	MusicListColumn list_column = 0;
	GValue* _tmp1_;
	GValue* result;
#line 359 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 359 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (o != NULL, NULL);
#line 360 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (o, MUSIC_TYPE_MEDIA) ? ((MusicMedia*) o) : NULL);
#line 360 "../src/Views/ListView/Lists/MusicListView.vala"
	m = _tmp0_;
#line 361 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (m != NULL, NULL);
#line 363 "../src/Views/ListView/Lists/MusicListView.vala"
	list_column = (MusicListColumn) column;
#line 364 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = music_list_column_get_value_for_media (list_column, m, row);
#line 364 "../src/Views/ListView/Lists/MusicListView.vala"
	result = _tmp1_;
#line 364 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (m);
#line 364 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 2030 "MusicListView.c"
}

static void
_music_cell_data_function_helper_icon_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                      GtkCellRenderer* cell,
                                                                      GtkTreeModel* tree_model,
                                                                      GtkTreeIter* iter,
                                                                      gpointer self)
{
#line 396 "../src/Views/ListView/Lists/MusicListView.vala"
	music_cell_data_function_helper_icon_func ((MusicCellDataFunctionHelper*) self, cell_layout, cell, tree_model, iter);
#line 2042 "MusicListView.c"
}

static void
_music_cell_data_function_helper_spinner_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                         GtkCellRenderer* cell,
                                                                         GtkTreeModel* tree_model,
                                                                         GtkTreeIter* iter,
                                                                         gpointer self)
{
#line 397 "../src/Views/ListView/Lists/MusicListView.vala"
	music_cell_data_function_helper_spinner_func ((MusicCellDataFunctionHelper*) self, cell_layout, cell, tree_model, iter);
#line 2054 "MusicListView.c"
}

static void
_music_cell_data_function_helper_bitrate_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                         GtkCellRenderer* cell,
                                                                         GtkTreeModel* tree_model,
                                                                         GtkTreeIter* iter,
                                                                         gpointer self)
{
#line 408 "../src/Views/ListView/Lists/MusicListView.vala"
	music_cell_data_function_helper_bitrate_func (cell_layout, cell, tree_model, iter);
#line 2066 "MusicListView.c"
}

static void
_vala_array_add15 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 410 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 410 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 410 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2081 "MusicListView.c"
	}
#line 410 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 410 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2087 "MusicListView.c"
}

static void
_music_cell_data_function_helper_length_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                        GtkCellRenderer* cell,
                                                                        GtkTreeModel* tree_model,
                                                                        GtkTreeIter* iter,
                                                                        gpointer self)
{
#line 415 "../src/Views/ListView/Lists/MusicListView.vala"
	music_cell_data_function_helper_length_func (cell_layout, cell, tree_model, iter);
#line 2099 "MusicListView.c"
}

static void
_vala_array_add16 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 417 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 417 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 417 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2114 "MusicListView.c"
	}
#line 417 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 417 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2120 "MusicListView.c"
}

static void
_music_cell_data_function_helper_date_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                      GtkCellRenderer* cell,
                                                                      GtkTreeModel* tree_model,
                                                                      GtkTreeIter* iter,
                                                                      gpointer self)
{
#line 423 "../src/Views/ListView/Lists/MusicListView.vala"
	music_cell_data_function_helper_date_func (cell_layout, cell, tree_model, iter);
#line 2132 "MusicListView.c"
}

static void
_vala_array_add17 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 424 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 424 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 424 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2147 "MusicListView.c"
	}
#line 424 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 424 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2153 "MusicListView.c"
}

static void
_vala_array_add18 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 425 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 425 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 425 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2168 "MusicListView.c"
	}
#line 425 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 425 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2174 "MusicListView.c"
}

static void
_music_generic_list_on_rating_cell_changed_music_rating_cell_renderer_rating_changed (MusicRatingCellRenderer* _sender,
                                                                                      gint new_rating,
                                                                                      GtkWidget* widget,
                                                                                      const gchar* path,
                                                                                      gpointer self)
{
#line 430 "../src/Views/ListView/Lists/MusicListView.vala"
	music_generic_list_on_rating_cell_changed ((MusicGenericList*) self, new_rating, widget, path);
#line 2186 "MusicListView.c"
}

static void
_music_cell_data_function_helper_rating_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                        GtkCellRenderer* cell,
                                                                        GtkTreeModel* tree_model,
                                                                        GtkTreeIter* iter,
                                                                        gpointer self)
{
#line 433 "../src/Views/ListView/Lists/MusicListView.vala"
	music_cell_data_function_helper_rating_func (cell_layout, cell, tree_model, iter);
#line 2198 "MusicListView.c"
}

static void
_music_cell_data_function_helper_number_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                        GtkCellRenderer* cell,
                                                                        GtkTreeModel* tree_model,
                                                                        GtkTreeIter* iter,
                                                                        gpointer self)
{
#line 443 "../src/Views/ListView/Lists/MusicListView.vala"
	music_cell_data_function_helper_number_func (cell_layout, cell, tree_model, iter);
#line 2210 "MusicListView.c"
}

static void
_vala_array_add19 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 445 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 445 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 445 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2225 "MusicListView.c"
	}
#line 445 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 445 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2231 "MusicListView.c"
}

static void
_music_cell_data_function_helper_intelligent_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                             GtkCellRenderer* cell,
                                                                             GtkTreeModel* tree_model,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self)
{
#line 450 "../src/Views/ListView/Lists/MusicListView.vala"
	music_cell_data_function_helper_intelligent_func (cell_layout, cell, tree_model, iter);
#line 2243 "MusicListView.c"
}

static void
_vala_array_add20 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 452 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 452 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 452 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2258 "MusicListView.c"
	}
#line 452 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 452 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2264 "MusicListView.c"
}

static void
_vala_array_add21 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 461 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 461 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 461 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2279 "MusicListView.c"
	}
#line 461 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 461 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2285 "MusicListView.c"
}

static void
_music_cell_data_function_helper_string_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                        GtkCellRenderer* cell,
                                                                        GtkTreeModel* tree_model,
                                                                        GtkTreeIter* iter,
                                                                        gpointer self)
{
#line 473 "../src/Views/ListView/Lists/MusicListView.vala"
	music_cell_data_function_helper_string_func (cell_layout, cell, tree_model, iter);
#line 2297 "MusicListView.c"
}

static void
_vala_array_add22 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 481 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 481 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 481 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2312 "MusicListView.c"
	}
#line 481 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 481 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2318 "MusicListView.c"
}

static void
_vala_array_add23 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 488 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 488 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 488 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2333 "MusicListView.c"
	}
#line 488 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 488 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2339 "MusicListView.c"
}

static void
_music_cell_data_function_helper_file_size_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                           GtkCellRenderer* cell,
                                                                           GtkTreeModel* tree_model,
                                                                           GtkTreeIter* iter,
                                                                           gpointer self)
{
#line 493 "../src/Views/ListView/Lists/MusicListView.vala"
	music_cell_data_function_helper_file_size_func (cell_layout, cell, tree_model, iter);
#line 2351 "MusicListView.c"
}

static void
_vala_array_add24 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 494 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 494 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 494 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2366 "MusicListView.c"
	}
#line 494 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 494 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2372 "MusicListView.c"
}

static gboolean
___lambda65_ (MusicMusicListView* self,
              GdkEventButton* e)
{
	gboolean result;
#line 551 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 552 "../src/Views/ListView/Lists/MusicListView.vala"
	result = music_music_list_view_view_header_click (self, e, TRUE);
#line 552 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 2386 "MusicListView.c"
}

static gboolean
____lambda65__gtk_widget_button_press_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = ___lambda65_ ((MusicMusicListView*) self, event);
#line 551 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 2398 "MusicListView.c"
}

static gboolean
___lambda66_ (MusicMusicListView* self,
              GdkEventButton* e)
{
	gboolean result;
#line 555 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 556 "../src/Views/ListView/Lists/MusicListView.vala"
	result = music_music_list_view_view_header_click (self, e, FALSE);
#line 556 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 2412 "MusicListView.c"
}

static gboolean
____lambda66__gtk_widget_button_press_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = ___lambda66_ ((MusicMusicListView*) self, event);
#line 555 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 2424 "MusicListView.c"
}

static void
music_music_list_view_real_add_column (MusicGenericList* base,
                                       GtkTreeViewColumn* tvc,
                                       MusicListColumn type)
{
	MusicMusicListView * self;
	gboolean column_resizable = FALSE;
	gboolean column_reorderable = FALSE;
	gint column_width = 0;
	gint insert_index = 0;
	gchar** test_strings = NULL;
	gchar** _tmp0_;
	gint test_strings_length1;
	gint _test_strings_size_;
	GtkCellRenderer* renderer = NULL;
	GtkCellRenderer* _tmp56_;
	gboolean _tmp63_ = FALSE;
	gboolean sortable = FALSE;
	gint _tmp64_ = 0;
	GtkWidget* header_button = NULL;
	GtkWidget* _tmp65_;
	GtkWidget* _tmp66_;
	gboolean _tmp67_;
	gboolean _tmp68_;
	gint _tmp79_;
	gint _tmp80_;
#line 367 "../src/Views/ListView/Lists/MusicListView.vala"
	self = (MusicMusicListView*) base;
#line 367 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (tvc != NULL);
#line 368 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_sizing (tvc, GTK_TREE_VIEW_COLUMN_FIXED);
#line 370 "../src/Views/ListView/Lists/MusicListView.vala"
	column_resizable = TRUE;
#line 371 "../src/Views/ListView/Lists/MusicListView.vala"
	column_reorderable = TRUE;
#line 372 "../src/Views/ListView/Lists/MusicListView.vala"
	column_width = -1;
#line 373 "../src/Views/ListView/Lists/MusicListView.vala"
	insert_index = -1;
#line 374 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 374 "../src/Views/ListView/Lists/MusicListView.vala"
	test_strings = _tmp0_;
#line 374 "../src/Views/ListView/Lists/MusicListView.vala"
	test_strings_length1 = 0;
#line 374 "../src/Views/ListView/Lists/MusicListView.vala"
	_test_strings_size_ = test_strings_length1;
#line 376 "../src/Views/ListView/Lists/MusicListView.vala"
	renderer = NULL;
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
	switch (type) {
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_ICON:
#line 2481 "MusicListView.c"
		{
			GtkCellRendererPixbuf* icon_renderer = NULL;
			GtkCellRendererPixbuf* _tmp1_;
			GtkCellRendererSpinner* spinner_renderer = NULL;
			GtkCellRendererSpinner* _tmp2_;
			GtkCellRendererPixbuf* _tmp3_;
			GtkCellRendererSpinner* _tmp4_;
			gint width = 0;
			gint height = 0;
			GtkCellRendererPixbuf* _tmp5_;
			guint _tmp6_;
			guint _tmp7_;
			gint _tmp8_ = 0;
			gint _tmp9_ = 0;
			GtkCellRendererPixbuf* _tmp10_;
			MusicCellDataFunctionHelper* _tmp11_;
			GtkCellRendererSpinner* _tmp12_;
			MusicCellDataFunctionHelper* _tmp13_;
			GtkCellRendererSpinner* _tmp14_;
			GtkCellRendererPixbuf* _tmp15_;
			GtkCellRenderer* _tmp16_;
#line 381 "../src/Views/ListView/Lists/MusicListView.vala"
			insert_index = (gint) type;
#line 383 "../src/Views/ListView/Lists/MusicListView.vala"
			column_reorderable = FALSE;
#line 384 "../src/Views/ListView/Lists/MusicListView.vala"
			column_resizable = FALSE;
#line 386 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp1_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
#line 386 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp1_);
#line 386 "../src/Views/ListView/Lists/MusicListView.vala"
			icon_renderer = _tmp1_;
#line 388 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp2_ = (GtkCellRendererSpinner*) gtk_cell_renderer_spinner_new ();
#line 388 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp2_);
#line 388 "../src/Views/ListView/Lists/MusicListView.vala"
			spinner_renderer = _tmp2_;
#line 390 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp3_ = icon_renderer;
#line 390 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp4_ = spinner_renderer;
#line 390 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_set (_tmp4_, "size", GTK_ICON_SIZE_MENU, NULL);
#line 390 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_set (_tmp3_, "stock-size", (guint) GTK_ICON_SIZE_MENU, NULL);
#line 393 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp5_ = icon_renderer;
#line 393 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_get (_tmp5_, "stock-size", &_tmp6_, NULL);
#line 393 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp7_ = _tmp6_;
#line 393 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_icon_size_lookup ((GtkIconSize) _tmp7_, &_tmp8_, &_tmp9_);
#line 393 "../src/Views/ListView/Lists/MusicListView.vala"
			width = _tmp8_;
#line 393 "../src/Views/ListView/Lists/MusicListView.vala"
			height = _tmp9_;
#line 394 "../src/Views/ListView/Lists/MusicListView.vala"
			column_width = MAX (width, height) + 7;
#line 396 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp10_ = icon_renderer;
#line 396 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp11_ = ((MusicGenericList*) self)->cell_data_helper;
#line 396 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, (GtkCellRenderer*) _tmp10_, _music_cell_data_function_helper_icon_func_gtk_cell_layout_data_func, music_cell_data_function_helper_ref (_tmp11_), music_cell_data_function_helper_unref);
#line 397 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp12_ = spinner_renderer;
#line 397 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp13_ = ((MusicGenericList*) self)->cell_data_helper;
#line 397 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, (GtkCellRenderer*) _tmp12_, _music_cell_data_function_helper_spinner_func_gtk_cell_layout_data_func, music_cell_data_function_helper_ref (_tmp13_), music_cell_data_function_helper_unref);
#line 400 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp14_ = spinner_renderer;
#line 400 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_pack_start ((GtkCellLayout*) tvc, (GtkCellRenderer*) _tmp14_, TRUE);
#line 403 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp15_ = icon_renderer;
#line 403 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp16_ = _g_object_ref0 ((GtkCellRenderer*) _tmp15_);
#line 403 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 403 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = _tmp16_;
#line 404 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (spinner_renderer);
#line 404 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (icon_renderer);
#line 404 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2573 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_BITRATE:
#line 2577 "MusicListView.c"
		{
			GtkCellRendererText* _tmp17_;
			GtkCellRenderer* _tmp18_;
			gchar* _tmp19_;
#line 407 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp17_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 407 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp17_);
#line 407 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 407 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = (GtkCellRenderer*) _tmp17_;
#line 408 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp18_ = renderer;
#line 408 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp18_, _music_cell_data_function_helper_bitrate_func_gtk_cell_layout_data_func, NULL, NULL);
#line 409 "../src/Views/ListView/Lists/MusicListView.vala"
			column_resizable = FALSE;
#line 410 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp19_ = g_strdup (_ ("1234 kbps"));
#line 410 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add15 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp19_);
#line 411 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2602 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_LENGTH:
#line 2606 "MusicListView.c"
		{
			GtkCellRendererText* _tmp20_;
			GtkCellRenderer* _tmp21_;
			gchar* _tmp22_;
#line 414 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp20_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 414 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp20_);
#line 414 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 414 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = (GtkCellRenderer*) _tmp20_;
#line 415 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp21_ = renderer;
#line 415 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp21_, _music_cell_data_function_helper_length_func_gtk_cell_layout_data_func, NULL, NULL);
#line 416 "../src/Views/ListView/Lists/MusicListView.vala"
			column_resizable = FALSE;
#line 417 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp22_ = g_strdup ("0000:00");
#line 417 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add16 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp22_);
#line 418 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2631 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_DATE_ADDED:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_LAST_PLAYED:
#line 2637 "MusicListView.c"
		{
			GtkCellRendererText* _tmp23_;
			GtkCellRenderer* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
#line 422 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp23_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 422 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp23_);
#line 422 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 422 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = (GtkCellRenderer*) _tmp23_;
#line 423 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp24_ = renderer;
#line 423 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp24_, _music_cell_data_function_helper_date_func_gtk_cell_layout_data_func, NULL, NULL);
#line 424 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp25_ = music_cell_data_function_helper_get_date_string ((guint) 1324512000);
#line 424 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add17 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp25_);
#line 425 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp26_ = g_strdup (_ ("Never"));
#line 425 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add18 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp26_);
#line 426 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2665 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_RATING:
#line 2669 "MusicListView.c"
		{
			MusicRatingCellRenderer* rating_renderer = NULL;
			MusicRatingCellRenderer* _tmp27_;
			MusicRatingCellRenderer* _tmp28_;
			MusicRatingCellRenderer* _tmp29_;
			GtkCellRenderer* _tmp30_;
			MusicRatingCellRenderer* _tmp31_;
			MusicRatingCellRenderer* _tmp32_;
			gint _tmp33_;
			gint _tmp34_;
#line 429 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp27_ = music_rating_cell_renderer_new (GTK_ICON_SIZE_MENU);
#line 429 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp27_);
#line 429 "../src/Views/ListView/Lists/MusicListView.vala"
			rating_renderer = _tmp27_;
#line 430 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp28_ = rating_renderer;
#line 430 "../src/Views/ListView/Lists/MusicListView.vala"
			g_signal_connect_object (_tmp28_, "rating-changed", (GCallback) _music_generic_list_on_rating_cell_changed_music_rating_cell_renderer_rating_changed, (MusicGenericList*) self, 0);
#line 432 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp29_ = rating_renderer;
#line 432 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp30_ = _g_object_ref0 ((GtkCellRenderer*) _tmp29_);
#line 432 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 432 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = _tmp30_;
#line 433 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp31_ = rating_renderer;
#line 433 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, (GtkCellRenderer*) _tmp31_, _music_cell_data_function_helper_rating_func_gtk_cell_layout_data_func, NULL, NULL);
#line 435 "../src/Views/ListView/Lists/MusicListView.vala"
			column_resizable = FALSE;
#line 436 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp32_ = rating_renderer;
#line 436 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_get ((GtkCellRenderer*) _tmp32_, "width", &_tmp33_, NULL);
#line 436 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp34_ = _tmp33_;
#line 436 "../src/Views/ListView/Lists/MusicListView.vala"
			column_width = _tmp34_ + 5;
#line 437 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (rating_renderer);
#line 437 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2716 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_NUMBER:
#line 2720 "MusicListView.c"
		{
			GtkCellRendererText* text_renderer = NULL;
			GtkCellRendererText* _tmp35_;
			GtkCellRendererText* _tmp36_;
			GtkCellRendererText* _tmp37_;
			GtkCellRenderer* _tmp38_;
			GtkCellRenderer* _tmp39_;
			gchar* _tmp40_;
#line 440 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp35_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 440 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp35_);
#line 440 "../src/Views/ListView/Lists/MusicListView.vala"
			text_renderer = _tmp35_;
#line 441 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp36_ = text_renderer;
#line 441 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_set (_tmp36_, "style", PANGO_STYLE_ITALIC, NULL);
#line 442 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp37_ = text_renderer;
#line 442 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp38_ = _g_object_ref0 ((GtkCellRenderer*) _tmp37_);
#line 442 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 442 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = _tmp38_;
#line 443 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp39_ = renderer;
#line 443 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp39_, _music_cell_data_function_helper_number_func_gtk_cell_layout_data_func, NULL, NULL);
#line 444 "../src/Views/ListView/Lists/MusicListView.vala"
			column_resizable = FALSE;
#line 445 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp40_ = g_strdup ("00000");
#line 445 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add19 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp40_);
#line 446 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (text_renderer);
#line 446 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2761 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_YEAR:
#line 2765 "MusicListView.c"
		{
			GtkCellRendererText* _tmp41_;
			GtkCellRenderer* _tmp42_;
			gchar* _tmp43_;
#line 449 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp41_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 449 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp41_);
#line 449 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 449 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = (GtkCellRenderer*) _tmp41_;
#line 450 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp42_ = renderer;
#line 450 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp42_, _music_cell_data_function_helper_intelligent_func_gtk_cell_layout_data_func, NULL, NULL);
#line 451 "../src/Views/ListView/Lists/MusicListView.vala"
			column_resizable = FALSE;
#line 452 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp43_ = g_strdup ("0000");
#line 452 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add20 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp43_);
#line 453 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2790 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_TRACK:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_PLAY_COUNT:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_SKIP_COUNT:
#line 2798 "MusicListView.c"
		{
			GtkCellRendererText* _tmp44_;
			GtkCellRenderer* _tmp45_;
			gchar* _tmp46_;
#line 458 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp44_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 458 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp44_);
#line 458 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 458 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = (GtkCellRenderer*) _tmp44_;
#line 459 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp45_ = renderer;
#line 459 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp45_, _music_cell_data_function_helper_intelligent_func_gtk_cell_layout_data_func, NULL, NULL);
#line 460 "../src/Views/ListView/Lists/MusicListView.vala"
			column_resizable = FALSE;
#line 461 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp46_ = g_strdup ("9999");
#line 461 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add21 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp46_);
#line 462 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2823 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_ALBUM:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_TITLE:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_ARTIST:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_ALBUM_ARTIST:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_COMPOSER:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_GENRE:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_GROUPING:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_FILE_LOCATION:
#line 2841 "MusicListView.c"
		{
			GtkCellRendererText* _tmp47_;
			GtkCellRenderer* _tmp48_;
			gchar* _tmp49_;
#line 472 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp47_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 472 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp47_);
#line 472 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 472 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = (GtkCellRenderer*) _tmp47_;
#line 473 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp48_ = renderer;
#line 473 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp48_, _music_cell_data_function_helper_string_func_gtk_cell_layout_data_func, NULL, NULL);
#line 481 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp49_ = g_strdup (_ ("Sample List String"));
#line 481 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add22 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp49_);
#line 482 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2864 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_BPM:
#line 2868 "MusicListView.c"
		{
			GtkCellRendererText* _tmp50_;
			GtkCellRenderer* _tmp51_;
			gchar* _tmp52_;
#line 485 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp50_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 485 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp50_);
#line 485 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 485 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = (GtkCellRenderer*) _tmp50_;
#line 486 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp51_ = renderer;
#line 486 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp51_, _music_cell_data_function_helper_intelligent_func_gtk_cell_layout_data_func, NULL, NULL);
#line 487 "../src/Views/ListView/Lists/MusicListView.vala"
			column_resizable = FALSE;
#line 488 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp52_ = g_strdup ("9999");
#line 488 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add23 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp52_);
#line 489 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2893 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_LIST_COLUMN_FILE_SIZE:
#line 2897 "MusicListView.c"
		{
			GtkCellRendererText* _tmp53_;
			GtkCellRenderer* _tmp54_;
			gchar* _tmp55_;
#line 492 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp53_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 492 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp53_);
#line 492 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 492 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = (GtkCellRenderer*) _tmp53_;
#line 493 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp54_ = renderer;
#line 493 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp54_, _music_cell_data_function_helper_file_size_func_gtk_cell_layout_data_func, NULL, NULL);
#line 494 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp55_ = g_format_size_full ((guint64) ((1024 * 1024) * 932), G_FORMAT_SIZE_DEFAULT);
#line 494 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add24 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp55_);
#line 495 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2920 "MusicListView.c"
		}
		default:
		{
#line 499 "../src/Views/ListView/Lists/MusicListView.vala"
			g_return_if_reached ();
#line 2926 "MusicListView.c"
		}
	}
#line 502 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp56_ = renderer;
#line 502 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) tvc, _tmp56_, TRUE);
#line 505 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_insert_column ((GtkTreeView*) self, tvc, insert_index);
#line 507 "../src/Views/ListView/Lists/MusicListView.vala"
	if (column_width > 0) {
#line 508 "../src/Views/ListView/Lists/MusicListView.vala"
		gtk_tree_view_column_set_fixed_width (tvc, column_width);
#line 2939 "MusicListView.c"
	} else {
		GtkCellRenderer* _tmp57_;
#line 509 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp57_ = renderer;
#line 509 "../src/Views/ListView/Lists/MusicListView.vala"
		if (_tmp57_ != NULL) {
#line 2946 "MusicListView.c"
			GtkCellRendererText* text_renderer = NULL;
			GtkCellRenderer* _tmp58_;
			GtkCellRendererText* _tmp59_;
			GtkCellRendererText* _tmp60_;
#line 510 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp58_ = renderer;
#line 510 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp59_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp58_, gtk_cell_renderer_text_get_type ()) ? ((GtkCellRendererText*) _tmp58_) : NULL);
#line 510 "../src/Views/ListView/Lists/MusicListView.vala"
			text_renderer = _tmp59_;
#line 511 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp60_ = text_renderer;
#line 511 "../src/Views/ListView/Lists/MusicListView.vala"
			if (_tmp60_ != NULL) {
#line 2961 "MusicListView.c"
				GtkCellRendererText* _tmp61_;
				gchar** _tmp62_;
				gint _tmp62__length1;
#line 512 "../src/Views/ListView/Lists/MusicListView.vala"
				_tmp61_ = text_renderer;
#line 512 "../src/Views/ListView/Lists/MusicListView.vala"
				_tmp62_ = test_strings;
#line 512 "../src/Views/ListView/Lists/MusicListView.vala"
				_tmp62__length1 = test_strings_length1;
#line 512 "../src/Views/ListView/Lists/MusicListView.vala"
				music_generic_list_set_fixed_column_width ((MusicGenericList*) self, (GtkWidget*) self, tvc, _tmp61_, _tmp62_, (gint) _tmp62__length1, 5);
#line 2973 "MusicListView.c"
			}
#line 509 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (text_renderer);
#line 2977 "MusicListView.c"
		}
	}
#line 515 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_reorderable (tvc, FALSE);
#line 516 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_clickable (tvc, TRUE);
#line 518 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_resizable (tvc, column_resizable);
#line 519 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_expand (tvc, column_resizable);
#line 521 "../src/Views/ListView/Lists/MusicListView.vala"
	if (type != MUSIC_LIST_COLUMN_NUMBER) {
#line 521 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp63_ = type != MUSIC_LIST_COLUMN_ICON;
#line 2992 "MusicListView.c"
	} else {
#line 521 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp63_ = FALSE;
#line 2996 "MusicListView.c"
	}
#line 521 "../src/Views/ListView/Lists/MusicListView.vala"
	sortable = _tmp63_;
#line 527 "../src/Views/ListView/Lists/MusicListView.vala"
	if (sortable) {
#line 527 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp64_ = (gint) type;
#line 3004 "MusicListView.c"
	} else {
#line 527 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp64_ = -1;
#line 3008 "MusicListView.c"
	}
#line 527 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_sort_column_id (tvc, _tmp64_);
#line 528 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_sort_indicator (tvc, sortable);
#line 530 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp65_ = gtk_tree_view_column_get_button (tvc);
#line 530 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp66_ = _g_object_ref0 (_tmp65_);
#line 530 "../src/Views/ListView/Lists/MusicListView.vala"
	header_button = _tmp66_;
#line 533 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp67_ = gtk_tree_view_get_headers_visible ((GtkTreeView*) self);
#line 533 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp68_ = _tmp67_;
#line 533 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp68_) {
#line 3026 "MusicListView.c"
		GtkRequisition natural_size = {0};
		GtkWidget* _tmp69_;
		GtkRequisition _tmp70_ = {0};
		GtkRequisition _tmp71_;
		gint _tmp72_;
		gint _tmp73_;
		gboolean _tmp75_;
		gboolean _tmp76_;
#line 535 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp69_ = header_button;
#line 535 "../src/Views/ListView/Lists/MusicListView.vala"
		gtk_widget_get_preferred_size (_tmp69_, NULL, &_tmp70_);
#line 535 "../src/Views/ListView/Lists/MusicListView.vala"
		natural_size = _tmp70_;
#line 537 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp71_ = natural_size;
#line 537 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp72_ = gtk_tree_view_column_get_fixed_width (tvc);
#line 537 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp73_ = _tmp72_;
#line 537 "../src/Views/ListView/Lists/MusicListView.vala"
		if (_tmp71_.width > _tmp73_) {
#line 3049 "MusicListView.c"
			GtkRequisition _tmp74_;
#line 538 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp74_ = natural_size;
#line 538 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_tree_view_column_set_fixed_width (tvc, _tmp74_.width);
#line 3055 "MusicListView.c"
		}
#line 541 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp75_ = gtk_tree_view_column_get_sort_indicator (tvc);
#line 541 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp76_ = _tmp75_;
#line 541 "../src/Views/ListView/Lists/MusicListView.vala"
		if (_tmp76_) {
#line 3063 "MusicListView.c"
			gint _tmp77_;
			gint _tmp78_;
#line 542 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp77_ = gtk_tree_view_column_get_fixed_width (tvc);
#line 542 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp78_ = _tmp77_;
#line 542 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_tree_view_column_set_fixed_width (tvc, _tmp78_ + 5);
#line 3072 "MusicListView.c"
		}
	}
#line 545 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp79_ = gtk_tree_view_column_get_fixed_width (tvc);
#line 545 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp80_ = _tmp79_;
#line 545 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_min_width (tvc, _tmp80_);
#line 548 "../src/Views/ListView/Lists/MusicListView.vala"
	music_music_list_view_add_column_chooser_menu_item (self, tvc, type);
#line 550 "../src/Views/ListView/Lists/MusicListView.vala"
	if (type == MUSIC_LIST_COLUMN_ICON) {
#line 3085 "MusicListView.c"
		GtkWidget* _tmp81_;
#line 551 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp81_ = header_button;
#line 551 "../src/Views/ListView/Lists/MusicListView.vala"
		g_signal_connect_object (_tmp81_, "button-press-event", (GCallback) ____lambda65__gtk_widget_button_press_event, self, 0);
#line 3091 "MusicListView.c"
	} else {
		GtkWidget* _tmp82_;
#line 555 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp82_ = header_button;
#line 555 "../src/Views/ListView/Lists/MusicListView.vala"
		g_signal_connect_object (_tmp82_, "button-press-event", (GCallback) ____lambda66__gtk_widget_button_press_event, self, 0);
#line 3098 "MusicListView.c"
	}
#line 367 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (header_button);
#line 367 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (renderer);
#line 367 "../src/Views/ListView/Lists/MusicListView.vala"
	test_strings = (_vala_array_free (test_strings, test_strings_length1, (GDestroyNotify) g_free), NULL);
#line 3106 "MusicListView.c"
}

MusicMediaMenu*
music_music_list_view_get_media_action_menu (MusicMusicListView* self)
{
	MusicMediaMenu* result;
	MusicMediaMenu* _tmp0_;
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = self->priv->_media_action_menu;
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
	result = _tmp0_;
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 3122 "MusicListView.c"
}

static void
music_music_list_view_set_media_action_menu (MusicMusicListView* self,
                                             MusicMediaMenu* value)
{
	MusicMediaMenu* old_value;
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
	old_value = music_music_list_view_get_media_action_menu (self);
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
	if (old_value != value) {
#line 3136 "MusicListView.c"
		MusicMediaMenu* _tmp0_;
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (self->priv->_media_action_menu);
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
		self->priv->_media_action_menu = _tmp0_;
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
		g_object_notify_by_pspec ((GObject *) self, music_music_list_view_properties[MUSIC_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY]);
#line 3146 "MusicListView.c"
	}
}

static GValue*
_music_music_list_view_view_value_func_music_fast_model_value_return_func (gint row,
                                                                           gint column,
                                                                           GObject* o,
                                                                           gpointer self)
{
	GValue* result;
	result = music_music_list_view_view_value_func ((MusicMusicListView*) self, row, column, o);
#line 53 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 3160 "MusicListView.c"
}

static gint
_music_music_list_view_view_compare_func_music_generic_list_sort_compare_func (gint sort_column_id,
                                                                               GtkSortType sort_direction,
                                                                               MusicMedia* a,
                                                                               MusicMedia* b,
                                                                               gint index_a,
                                                                               gint index_b,
                                                                               gpointer self)
{
	gint result;
	result = music_music_list_view_view_compare_func ((MusicMusicListView*) self, sort_column_id, sort_direction, a, b, index_a, index_b);
#line 54 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 3176 "MusicListView.c"
}

static gboolean
_music_music_list_view_view_click_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                           GdkEventButton* event,
                                                                           gpointer self)
{
	gboolean result;
	result = music_music_list_view_view_click_release ((MusicMusicListView*) self, _sender, event);
#line 56 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 3188 "MusicListView.c"
}

static GObject *
music_music_list_view_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicMusicListView * self;
	MusicMediaMenu* _tmp0_;
	MusicMediaMenu* _tmp1_;
	MusicMediaMenu* _tmp2_;
	MusicPlaylist* _tmp3_;
	MusicPlaylist* _tmp4_;
	MusicPlaybackManager* _tmp5_;
	MusicPlaybackManager* _tmp6_;
	MusicStaticPlaylist* _tmp7_;
#line 48 "../src/Views/ListView/Lists/MusicListView.vala"
	parent_class = G_OBJECT_CLASS (music_music_list_view_parent_class);
#line 48 "../src/Views/ListView/Lists/MusicListView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 48 "../src/Views/ListView/Lists/MusicListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListView);
#line 49 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_set_headers_clickable ((GtkTreeView*) self, TRUE);
#line 50 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_set_headers_visible ((GtkTreeView*) self, TRUE);
#line 53 "../src/Views/ListView/Lists/MusicListView.vala"
	music_generic_list_set_value_func ((MusicGenericList*) self, _music_music_list_view_view_value_func_music_fast_model_value_return_func, self);
#line 54 "../src/Views/ListView/Lists/MusicListView.vala"
	music_generic_list_set_compare_func ((MusicGenericList*) self, _music_music_list_view_view_compare_func_music_generic_list_sort_compare_func, self);
#line 56 "../src/Views/ListView/Lists/MusicListView.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-release-event", (GCallback) _music_music_list_view_view_click_release_gtk_widget_button_release_event, self, 0);
#line 58 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = music_media_menu_new ((MusicGenericList*) self);
#line 58 "../src/Views/ListView/Lists/MusicListView.vala"
	g_object_ref_sink (_tmp0_);
#line 58 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/Views/ListView/Lists/MusicListView.vala"
	music_music_list_view_set_media_action_menu (self, _tmp1_);
#line 58 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (_tmp1_);
#line 59 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp2_ = self->priv->_media_action_menu;
#line 59 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_menu_attach_to_widget ((GtkMenu*) _tmp2_, (GtkWidget*) self, NULL);
#line 61 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp3_ = music_generic_list_get_playlist ((MusicGenericList*) self);
#line 61 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp4_ = _tmp3_;
#line 61 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp5_ = music_app_get_player ();
#line 61 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp6_ = _tmp5_;
#line 61 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp7_ = _tmp6_->queue_playlist;
#line 61 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_set_headers_clickable ((GtkTreeView*) self, _tmp4_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, MUSIC_TYPE_PLAYLIST, MusicPlaylist));
#line 48 "../src/Views/ListView/Lists/MusicListView.vala"
	return obj;
#line 3251 "MusicListView.c"
}

static void
music_music_list_view_class_init (MusicMusicListViewClass * klass,
                                  gpointer klass_data)
{
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	music_music_list_view_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	g_type_class_adjust_private_offset (klass, &MusicMusicListView_private_offset);
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) music_music_list_view_real_button_press_event;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	((MusicGenericListClass *) klass)->media_remove_clicked = (void (*) (MusicGenericList*)) music_music_list_view_real_media_remove_clicked;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	((MusicMusicListViewClass *) klass)->on_drag_data_get = (void (*) (MusicMusicListView*, GdkDragContext*, GtkSelectionData*, guint, guint)) music_music_list_view_real_on_drag_data_get;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	((MusicGenericListClass *) klass)->add_column = (void (*) (MusicGenericList*, GtkTreeViewColumn*, MusicListColumn)) music_music_list_view_real_add_column;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_music_list_view_get_property;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_music_list_view_set_property;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	G_OBJECT_CLASS (klass)->constructor = music_music_list_view_constructor;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	G_OBJECT_CLASS (klass)->finalize = music_music_list_view_finalize;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY, music_music_list_view_properties[MUSIC_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY] = g_param_spec_object ("media-action-menu", "media-action-menu", "media-action-menu", MUSIC_TYPE_MEDIA_MENU, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3280 "MusicListView.c"
}

static void
music_music_list_view_instance_init (MusicMusicListView * self,
                                     gpointer klass)
{
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	self->priv = music_music_list_view_get_instance_private (self);
#line 3289 "MusicListView.c"
}

static void
music_music_list_view_finalize (GObject * obj)
{
	MusicMusicListView * self;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListView);
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (self->priv->_media_action_menu);
#line 38 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (self->column_chooser_menu);
#line 39 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (self->priv->autosize_menu_item);
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	G_OBJECT_CLASS (music_music_list_view_parent_class)->finalize (obj);
#line 3306 "MusicListView.c"
}

static GType
music_music_list_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicMusicListViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_music_list_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicMusicListView), 0, (GInstanceInitFunc) music_music_list_view_instance_init, NULL };
	GType music_music_list_view_type_id;
	music_music_list_view_type_id = g_type_register_static (MUSIC_TYPE_GENERIC_LIST, "MusicMusicListView", &g_define_type_info, 0);
	MusicMusicListView_private_offset = g_type_add_instance_private (music_music_list_view_type_id, sizeof (MusicMusicListViewPrivate));
	return music_music_list_view_type_id;
}

GType
music_music_list_view_get_type (void)
{
	static volatile gsize music_music_list_view_type_id__once = 0;
	if (g_once_init_enter (&music_music_list_view_type_id__once)) {
		GType music_music_list_view_type_id;
		music_music_list_view_type_id = music_music_list_view_get_type_once ();
		g_once_init_leave (&music_music_list_view_type_id__once, music_music_list_view_type_id);
	}
	return music_music_list_view_type_id__once;
}

static void
_vala_music_music_list_view_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	MusicMusicListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListView);
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	switch (property_id) {
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY:
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		g_value_set_object (value, music_music_list_view_get_media_action_menu (self));
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		break;
#line 3347 "MusicListView.c"
		default:
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		break;
#line 3353 "MusicListView.c"
	}
}

static void
_vala_music_music_list_view_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	MusicMusicListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListView);
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	switch (property_id) {
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		case MUSIC_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY:
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		music_music_list_view_set_media_action_menu (self, g_value_get_object (value));
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		break;
#line 3373 "MusicListView.c"
		default:
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		break;
#line 3379 "MusicListView.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

