/* ViewStack.c generated by valac 0.56.0, the Vala compiler
 * generated from ViewStack.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include "music-lib.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <granite.h>
#include <glib/gi18n-lib.h>

enum  {
	MUSIC_VIEW_STACK_0_PROPERTY,
	MUSIC_VIEW_STACK_NUM_PROPERTIES
};
static GParamSpec* music_view_stack_properties[MUSIC_VIEW_STACK_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MusicViewStackPrivate {
	gint _nextview_number;
	gchar* _current_view;
};

static gint MusicViewStack_private_offset;
static gpointer music_view_stack_parent_class = NULL;

static gint music_view_stack_get_nextview_number (MusicViewStack* self);
static void music_view_stack_set_nextview_number (MusicViewStack* self,
                                           gint value);
static void music_view_stack_update_visible (MusicViewStack* self);
static void music_view_stack_set_current_view (MusicViewStack* self,
                                        const gchar* value);
static const gchar* music_view_stack_get_current_view (MusicViewStack* self);
static GObject * music_view_stack_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static void _music_view_stack___lambda59_ (MusicViewStack* self);
static void __music_view_stack___lambda59__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void music_view_stack_finalize (GObject * obj);
static GType music_view_stack_get_type_once (void);
static void _vala_music_view_stack_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_music_view_stack_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
music_view_stack_get_instance_private (MusicViewStack* self)
{
	return G_STRUCT_MEMBER_P (self, MusicViewStack_private_offset);
}

/**
     * Appends a widget to the main views.
     * @return the index of the view in the view container
     */
void
music_view_stack_add_view (MusicViewStack* self,
                           GtkWidget* view)
{
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
#line 53 "../src/Views/ViewStack.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/Views/ViewStack.vala"
	g_return_if_fail (view != NULL);
#line 54 "../src/Views/ViewStack.vala"
	g_object_set (view, "expand", TRUE, NULL);
#line 55 "../src/Views/ViewStack.vala"
	gtk_widget_set_visible (view, TRUE);
#line 56 "../src/Views/ViewStack.vala"
	_tmp0_ = self->priv->_nextview_number;
#line 56 "../src/Views/ViewStack.vala"
	_tmp1_ = g_strdup_printf ("%i", _tmp0_);
#line 56 "../src/Views/ViewStack.vala"
	_tmp2_ = _tmp1_;
#line 56 "../src/Views/ViewStack.vala"
	gtk_stack_add_named ((GtkStack*) self, view, _tmp2_);
#line 56 "../src/Views/ViewStack.vala"
	_g_free0 (_tmp2_);
#line 58 "../src/Views/ViewStack.vala"
	_tmp3_ = self->priv->_nextview_number;
#line 58 "../src/Views/ViewStack.vala"
	music_view_stack_set_nextview_number (self, _tmp3_ + 1);
#line 123 "ViewStack.c"
}

/**
     * Removes a widget from the main views.
     * @return the index of the view in the view container
     */
void
music_view_stack_remove_view (MusicViewStack* self,
                              GtkWidget* view)
{
#line 65 "../src/Views/ViewStack.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/Views/ViewStack.vala"
	g_return_if_fail (view != NULL);
#line 66 "../src/Views/ViewStack.vala"
	gtk_container_remove ((GtkContainer*) self, view);
#line 67 "../src/Views/ViewStack.vala"
	gtk_widget_destroy (view);
#line 142 "ViewStack.c"
}

static void
music_view_stack_update_visible (MusicViewStack* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
#line 70 "../src/Views/ViewStack.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/Views/ViewStack.vala"
	_tmp0_ = gtk_stack_get_visible_child_name ((GtkStack*) self);
#line 71 "../src/Views/ViewStack.vala"
	_tmp1_ = _tmp0_;
#line 71 "../src/Views/ViewStack.vala"
	if (g_strcmp0 (_tmp1_, "alert") != 0) {
#line 160 "ViewStack.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 72 "../src/Views/ViewStack.vala"
		_tmp2_ = gtk_stack_get_visible_child_name ((GtkStack*) self);
#line 72 "../src/Views/ViewStack.vala"
		_tmp3_ = _tmp2_;
#line 72 "../src/Views/ViewStack.vala"
		music_view_stack_set_current_view (self, _tmp3_);
#line 169 "ViewStack.c"
	}
#line 75 "../src/Views/ViewStack.vala"
	_tmp4_ = gtk_stack_get_visible_child ((GtkStack*) self);
#line 75 "../src/Views/ViewStack.vala"
	_tmp5_ = _tmp4_;
#line 75 "../src/Views/ViewStack.vala"
	if (MUSIC_IS_VIEW_WRAPPER (_tmp5_)) {
#line 177 "ViewStack.c"
		GtkWidget* _tmp6_;
		GtkWidget* _tmp7_;
#line 76 "../src/Views/ViewStack.vala"
		_tmp6_ = gtk_stack_get_visible_child ((GtkStack*) self);
#line 76 "../src/Views/ViewStack.vala"
		_tmp7_ = _tmp6_;
#line 76 "../src/Views/ViewStack.vala"
		music_view_wrapper_set_as_current_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper));
#line 186 "ViewStack.c"
	} else {
		gboolean _tmp8_ = FALSE;
		GtkWidget* _tmp9_;
		GtkWidget* _tmp10_;
#line 77 "../src/Views/ViewStack.vala"
		_tmp9_ = gtk_stack_get_visible_child ((GtkStack*) self);
#line 77 "../src/Views/ViewStack.vala"
		_tmp10_ = _tmp9_;
#line 77 "../src/Views/ViewStack.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, gtk_grid_get_type ())) {
#line 197 "ViewStack.c"
			const gchar* _tmp11_;
			const gchar* _tmp12_;
#line 77 "../src/Views/ViewStack.vala"
			_tmp11_ = gtk_stack_get_visible_child_name ((GtkStack*) self);
#line 77 "../src/Views/ViewStack.vala"
			_tmp12_ = _tmp11_;
#line 77 "../src/Views/ViewStack.vala"
			_tmp8_ = g_strcmp0 (_tmp12_, "alert") != 0;
#line 206 "ViewStack.c"
		} else {
#line 77 "../src/Views/ViewStack.vala"
			_tmp8_ = FALSE;
#line 210 "ViewStack.c"
		}
#line 77 "../src/Views/ViewStack.vala"
		if (_tmp8_) {
#line 214 "ViewStack.c"
			MusicLibraryWindow* _tmp13_;
			MusicLibraryWindow* _tmp14_;
			MusicWidgetsViewSelector* _tmp15_;
			MusicWidgetsViewSelector* _tmp16_;
			MusicLibraryWindow* _tmp17_;
			MusicLibraryWindow* _tmp18_;
			MusicWidgetsViewSelector* _tmp19_;
			MusicWidgetsViewSelector* _tmp20_;
			MusicLibraryWindow* _tmp21_;
			MusicLibraryWindow* _tmp22_;
			GtkSearchEntry* _tmp23_;
			GtkSearchEntry* _tmp24_;
#line 78 "../src/Views/ViewStack.vala"
			_tmp13_ = music_app_get_main_window ();
#line 78 "../src/Views/ViewStack.vala"
			_tmp14_ = _tmp13_;
#line 78 "../src/Views/ViewStack.vala"
			_tmp15_ = music_library_window_get_view_selector (_tmp14_);
#line 78 "../src/Views/ViewStack.vala"
			_tmp16_ = _tmp15_;
#line 78 "../src/Views/ViewStack.vala"
			music_widgets_view_selector_set_selected (_tmp16_, MUSIC_WIDGETS_VIEW_SELECTOR_MODE_LIST);
#line 79 "../src/Views/ViewStack.vala"
			_tmp17_ = music_app_get_main_window ();
#line 79 "../src/Views/ViewStack.vala"
			_tmp18_ = _tmp17_;
#line 79 "../src/Views/ViewStack.vala"
			_tmp19_ = music_library_window_get_view_selector (_tmp18_);
#line 79 "../src/Views/ViewStack.vala"
			_tmp20_ = _tmp19_;
#line 79 "../src/Views/ViewStack.vala"
			music_widgets_view_selector_set_sensitive (_tmp20_, FALSE);
#line 80 "../src/Views/ViewStack.vala"
			_tmp21_ = music_app_get_main_window ();
#line 80 "../src/Views/ViewStack.vala"
			_tmp22_ = _tmp21_;
#line 80 "../src/Views/ViewStack.vala"
			_tmp23_ = music_library_window_get_search_entry (_tmp22_);
#line 80 "../src/Views/ViewStack.vala"
			_tmp24_ = _tmp23_;
#line 80 "../src/Views/ViewStack.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp24_, FALSE);
#line 257 "ViewStack.c"
		}
	}
}

void
music_view_stack_show_alert (MusicViewStack* self)
{
#line 84 "../src/Views/ViewStack.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/Views/ViewStack.vala"
	gtk_stack_set_visible_child_name ((GtkStack*) self, "alert");
#line 269 "ViewStack.c"
}

void
music_view_stack_hide_alert (MusicViewStack* self)
{
	const gchar* _tmp0_;
#line 88 "../src/Views/ViewStack.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/Views/ViewStack.vala"
	_tmp0_ = self->priv->_current_view;
#line 89 "../src/Views/ViewStack.vala"
	gtk_stack_set_visible_child_name ((GtkStack*) self, _tmp0_);
#line 282 "ViewStack.c"
}

MusicViewStack*
music_view_stack_construct (GType object_type)
{
	MusicViewStack * self = NULL;
#line 29 "../src/Views/ViewStack.vala"
	self = (MusicViewStack*) g_object_new (object_type, NULL);
#line 29 "../src/Views/ViewStack.vala"
	return self;
#line 293 "ViewStack.c"
}

MusicViewStack*
music_view_stack_new (void)
{
#line 29 "../src/Views/ViewStack.vala"
	return music_view_stack_construct (MUSIC_TYPE_VIEW_STACK);
#line 301 "ViewStack.c"
}

static gint
music_view_stack_get_nextview_number (MusicViewStack* self)
{
	gint result;
#line 30 "../src/Views/ViewStack.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 30 "../src/Views/ViewStack.vala"
	result = self->priv->_nextview_number;
#line 30 "../src/Views/ViewStack.vala"
	return result;
#line 314 "ViewStack.c"
}

static void
music_view_stack_set_nextview_number (MusicViewStack* self,
                                      gint value)
{
#line 30 "../src/Views/ViewStack.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Views/ViewStack.vala"
	self->priv->_nextview_number = value;
#line 325 "ViewStack.c"
}

static const gchar*
music_view_stack_get_current_view (MusicViewStack* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../src/Views/ViewStack.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/Views/ViewStack.vala"
	_tmp0_ = self->priv->_current_view;
#line 32 "../src/Views/ViewStack.vala"
	result = _tmp0_;
#line 32 "../src/Views/ViewStack.vala"
	return result;
#line 341 "ViewStack.c"
}

static void
music_view_stack_set_current_view (MusicViewStack* self,
                                   const gchar* value)
{
	gchar* _tmp0_;
#line 32 "../src/Views/ViewStack.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Views/ViewStack.vala"
	_tmp0_ = g_strdup (value);
#line 32 "../src/Views/ViewStack.vala"
	_g_free0 (self->priv->_current_view);
#line 32 "../src/Views/ViewStack.vala"
	self->priv->_current_view = _tmp0_;
#line 357 "ViewStack.c"
}

static void
_music_view_stack___lambda59_ (MusicViewStack* self)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
#line 38 "../src/Views/ViewStack.vala"
	_tmp0_ = gtk_stack_get_visible_child ((GtkStack*) self);
#line 38 "../src/Views/ViewStack.vala"
	_tmp1_ = _tmp0_;
#line 38 "../src/Views/ViewStack.vala"
	if (_tmp1_ == NULL) {
#line 39 "../src/Views/ViewStack.vala"
		g_critical ("ViewStack.vala:39: Cannot set view as current view");
#line 373 "ViewStack.c"
	} else {
#line 41 "../src/Views/ViewStack.vala"
		music_view_stack_update_visible (self);
#line 377 "ViewStack.c"
	}
}

static void
__music_view_stack___lambda59__g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 37 "../src/Views/ViewStack.vala"
	_music_view_stack___lambda59_ ((MusicViewStack*) self);
#line 388 "ViewStack.c"
}

static GObject *
music_view_stack_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicViewStack * self;
	GraniteWidgetsAlertView* alert_view = NULL;
	GraniteWidgetsAlertView* _tmp0_;
	GraniteWidgetsAlertView* _tmp1_;
#line 34 "../src/Views/ViewStack.vala"
	parent_class = G_OBJECT_CLASS (music_view_stack_parent_class);
#line 34 "../src/Views/ViewStack.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 34 "../src/Views/ViewStack.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_VIEW_STACK, MusicViewStack);
#line 35 "../src/Views/ViewStack.vala"
	g_object_set ((GtkWidget*) self, "expand", TRUE, NULL);
#line 37 "../src/Views/ViewStack.vala"
	g_signal_connect_object ((GObject*) self, "notify::visible-child", (GCallback) __music_view_stack___lambda59__g_object_notify, self, 0);
#line 45 "../src/Views/ViewStack.vala"
	_tmp0_ = granite_widgets_alert_view_new (_ ("No Results"), _ ("Try another search"), "edit-find-symbolic");
#line 45 "../src/Views/ViewStack.vala"
	g_object_ref_sink (_tmp0_);
#line 45 "../src/Views/ViewStack.vala"
	alert_view = _tmp0_;
#line 46 "../src/Views/ViewStack.vala"
	_tmp1_ = alert_view;
#line 46 "../src/Views/ViewStack.vala"
	gtk_stack_add_named ((GtkStack*) self, (GtkWidget*) _tmp1_, "alert");
#line 34 "../src/Views/ViewStack.vala"
	_g_object_unref0 (alert_view);
#line 34 "../src/Views/ViewStack.vala"
	return obj;
#line 426 "ViewStack.c"
}

static void
music_view_stack_class_init (MusicViewStackClass * klass,
                             gpointer klass_data)
{
#line 29 "../src/Views/ViewStack.vala"
	music_view_stack_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Views/ViewStack.vala"
	g_type_class_adjust_private_offset (klass, &MusicViewStack_private_offset);
#line 29 "../src/Views/ViewStack.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_view_stack_get_property;
#line 29 "../src/Views/ViewStack.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_view_stack_set_property;
#line 29 "../src/Views/ViewStack.vala"
	G_OBJECT_CLASS (klass)->constructor = music_view_stack_constructor;
#line 29 "../src/Views/ViewStack.vala"
	G_OBJECT_CLASS (klass)->finalize = music_view_stack_finalize;
#line 445 "ViewStack.c"
}

static void
music_view_stack_instance_init (MusicViewStack * self,
                                gpointer klass)
{
#line 29 "../src/Views/ViewStack.vala"
	self->priv = music_view_stack_get_instance_private (self);
#line 30 "../src/Views/ViewStack.vala"
	self->priv->_nextview_number = 0;
#line 456 "ViewStack.c"
}

static void
music_view_stack_finalize (GObject * obj)
{
	MusicViewStack * self;
#line 29 "../src/Views/ViewStack.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_VIEW_STACK, MusicViewStack);
#line 32 "../src/Views/ViewStack.vala"
	_g_free0 (self->priv->_current_view);
#line 29 "../src/Views/ViewStack.vala"
	G_OBJECT_CLASS (music_view_stack_parent_class)->finalize (obj);
#line 469 "ViewStack.c"
}

static GType
music_view_stack_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicViewStackClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_view_stack_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicViewStack), 0, (GInstanceInitFunc) music_view_stack_instance_init, NULL };
	GType music_view_stack_type_id;
	music_view_stack_type_id = g_type_register_static (gtk_stack_get_type (), "MusicViewStack", &g_define_type_info, 0);
	MusicViewStack_private_offset = g_type_add_instance_private (music_view_stack_type_id, sizeof (MusicViewStackPrivate));
	return music_view_stack_type_id;
}

GType
music_view_stack_get_type (void)
{
	static volatile gsize music_view_stack_type_id__once = 0;
	if (g_once_init_enter (&music_view_stack_type_id__once)) {
		GType music_view_stack_type_id;
		music_view_stack_type_id = music_view_stack_get_type_once ();
		g_once_init_leave (&music_view_stack_type_id__once, music_view_stack_type_id);
	}
	return music_view_stack_type_id__once;
}

static void
_vala_music_view_stack_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	MusicViewStack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_VIEW_STACK, MusicViewStack);
#line 29 "../src/Views/ViewStack.vala"
	switch (property_id) {
#line 504 "ViewStack.c"
		default:
#line 29 "../src/Views/ViewStack.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Views/ViewStack.vala"
		break;
#line 510 "ViewStack.c"
	}
}

static void
_vala_music_view_stack_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	MusicViewStack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_VIEW_STACK, MusicViewStack);
#line 29 "../src/Views/ViewStack.vala"
	switch (property_id) {
#line 524 "ViewStack.c"
		default:
#line 29 "../src/Views/ViewStack.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Views/ViewStack.vala"
		break;
#line 530 "ViewStack.c"
	}
}

