/* PlaylistViewWrapper.c generated by valac 0.56.0, the Vala compiler
 * generated from PlaylistViewWrapper.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include "music-lib.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "io.elementary.music-core.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include <granite.h>
#include <glib/gi18n-lib.h>

enum  {
	MUSIC_PLAYLIST_VIEW_WRAPPER_0_PROPERTY,
	MUSIC_PLAYLIST_VIEW_WRAPPER_TVS_PROPERTY,
	MUSIC_PLAYLIST_VIEW_WRAPPER_NUM_PROPERTIES
};
static GParamSpec* music_playlist_view_wrapper_properties[MUSIC_PLAYLIST_VIEW_WRAPPER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MusicPlaylistViewWrapperOnPlaylistMediaAddedData MusicPlaylistViewWrapperOnPlaylistMediaAddedData;
typedef struct _MusicPlaylistViewWrapperOnPlaylistMediaRemovedData MusicPlaylistViewWrapperOnPlaylistMediaRemovedData;
typedef struct _MusicPlaylistViewWrapperOnPlaylistClearedData MusicPlaylistViewWrapperOnPlaylistClearedData;
enum  {
	MUSIC_PLAYLIST_VIEW_WRAPPER_BUTTON_CLICKED_SIGNAL,
	MUSIC_PLAYLIST_VIEW_WRAPPER_NUM_SIGNALS
};
static guint music_playlist_view_wrapper_signals[MUSIC_PLAYLIST_VIEW_WRAPPER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MusicPlaylistViewWrapperPrivate {
	MusicTreeViewSetup* _tvs;
	gchar* message_head;
	gchar* message_body;
};

struct _MusicPlaylistViewWrapperOnPlaylistMediaAddedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicPlaylistViewWrapper* self;
	GeeCollection* to_add;
};

struct _MusicPlaylistViewWrapperOnPlaylistMediaRemovedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicPlaylistViewWrapper* self;
	GeeCollection* to_remove;
};

struct _MusicPlaylistViewWrapperOnPlaylistClearedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicPlaylistViewWrapper* self;
	GeeArrayQueue* _tmp0_;
	GeeArrayQueue* _tmp1_;
};

static gint MusicPlaylistViewWrapper_private_offset;
static gpointer music_playlist_view_wrapper_parent_class = NULL;

static void music_playlist_view_wrapper_connect_data_signals (MusicPlaylistViewWrapper* self);
static void music_playlist_view_wrapper_on_playlist_media_added (MusicPlaylistViewWrapper* self,
                                                          GeeCollection* to_add,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
static void music_playlist_view_wrapper_on_playlist_media_added_finish (MusicPlaylistViewWrapper* self,
                                                                 GAsyncResult* _res_);
static void _music_playlist_view_wrapper_on_playlist_media_added_music_playlist_media_added (MusicPlaylist* _sender,
                                                                                      GeeCollection* media,
                                                                                      gpointer self);
static void music_playlist_view_wrapper_on_playlist_media_removed (MusicPlaylistViewWrapper* self,
                                                            GeeCollection* to_remove,
                                                            GAsyncReadyCallback _callback_,
                                                            gpointer _user_data_);
static void music_playlist_view_wrapper_on_playlist_media_removed_finish (MusicPlaylistViewWrapper* self,
                                                                   GAsyncResult* _res_);
static void _music_playlist_view_wrapper_on_playlist_media_removed_music_playlist_media_removed (MusicPlaylist* _sender,
                                                                                          GeeCollection* media,
                                                                                          gpointer self);
static void music_playlist_view_wrapper_on_playlist_cleared (MusicPlaylistViewWrapper* self,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
static void music_playlist_view_wrapper_on_playlist_cleared_finish (MusicPlaylistViewWrapper* self,
                                                             GAsyncResult* _res_);
static void _music_playlist_view_wrapper_on_playlist_cleared_music_playlist_cleared (MusicPlaylist* _sender,
                                                                              gpointer self);
static void ____lambda141_ (MusicPlaylistViewWrapper* self);
static void _____lambda141__music_playlist_request_play (MusicPlaylist* _sender,
                                                  gpointer self);
static void music_playlist_view_wrapper_real_set_no_media_alert (MusicViewWrapper* base);
static void music_playlist_view_wrapper_on_playlist_media_added_data_free (gpointer _data);
static gboolean music_playlist_view_wrapper_on_playlist_media_added_co (MusicPlaylistViewWrapperOnPlaylistMediaAddedData* _data_);
static void music_playlist_view_wrapper_on_playlist_media_added_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_);
static void music_playlist_view_wrapper_on_playlist_media_removed_data_free (gpointer _data);
static gboolean music_playlist_view_wrapper_on_playlist_media_removed_co (MusicPlaylistViewWrapperOnPlaylistMediaRemovedData* _data_);
static void music_playlist_view_wrapper_on_playlist_media_removed_ready (GObject* source_object,
                                                                  GAsyncResult* _res_,
                                                                  gpointer _user_data_);
static void music_playlist_view_wrapper_on_playlist_cleared_data_free (gpointer _data);
static gboolean music_playlist_view_wrapper_on_playlist_cleared_co (MusicPlaylistViewWrapperOnPlaylistClearedData* _data_);
static void music_playlist_view_wrapper_on_playlist_cleared_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_);
static GObject * music_playlist_view_wrapper_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void _music_playlist_view_wrapper____lambda142_ (MusicPlaylistViewWrapper* self);
static void __music_playlist_view_wrapper____lambda142__granite_widgets_alert_view_action_activated (GraniteWidgetsAlertView* _sender,
                                                                                              gpointer self);
static void music_playlist_view_wrapper_finalize (GObject * obj);
static GType music_playlist_view_wrapper_get_type_once (void);
static void _vala_music_playlist_view_wrapper_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_music_playlist_view_wrapper_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);

static inline gpointer
music_playlist_view_wrapper_get_instance_private (MusicPlaylistViewWrapper* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPlaylistViewWrapper_private_offset);
}

MusicPlaylistViewWrapper*
music_playlist_view_wrapper_construct (GType object_type,
                                       MusicPlaylist* playlist,
                                       MusicViewWrapperHint hint,
                                       MusicTreeViewSetup* tvs,
                                       MusicLibrary* library)
{
	MusicPlaylistViewWrapper * self = NULL;
#line 35 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_return_val_if_fail (playlist != NULL, NULL);
#line 35 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_return_val_if_fail (tvs != NULL, NULL);
#line 35 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_return_val_if_fail (library != NULL, NULL);
#line 36 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	self = (MusicPlaylistViewWrapper*) g_object_new (object_type, "tvs", tvs, "playlist", playlist, "hint", hint, "library", library, NULL);
#line 35 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	return self;
#line 188 "PlaylistViewWrapper.c"
}

MusicPlaylistViewWrapper*
music_playlist_view_wrapper_new (MusicPlaylist* playlist,
                                 MusicViewWrapperHint hint,
                                 MusicTreeViewSetup* tvs,
                                 MusicLibrary* library)
{
#line 35 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	return music_playlist_view_wrapper_construct (MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, playlist, hint, tvs, library);
#line 199 "PlaylistViewWrapper.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 83 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	return self ? g_object_ref (self) : NULL;
#line 207 "PlaylistViewWrapper.c"
}

static void
_music_playlist_view_wrapper_on_playlist_media_added_music_playlist_media_added (MusicPlaylist* _sender,
                                                                                 GeeCollection* media,
                                                                                 gpointer self)
{
#line 87 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_playlist_view_wrapper_on_playlist_media_added ((MusicPlaylistViewWrapper*) self, media, NULL, NULL);
#line 217 "PlaylistViewWrapper.c"
}

static void
_music_playlist_view_wrapper_on_playlist_media_removed_music_playlist_media_removed (MusicPlaylist* _sender,
                                                                                     GeeCollection* media,
                                                                                     gpointer self)
{
#line 88 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_playlist_view_wrapper_on_playlist_media_removed ((MusicPlaylistViewWrapper*) self, media, NULL, NULL);
#line 227 "PlaylistViewWrapper.c"
}

static void
_music_playlist_view_wrapper_on_playlist_cleared_music_playlist_cleared (MusicPlaylist* _sender,
                                                                         gpointer self)
{
#line 89 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_playlist_view_wrapper_on_playlist_cleared ((MusicPlaylistViewWrapper*) self, NULL, NULL);
#line 236 "PlaylistViewWrapper.c"
}

static void
____lambda141_ (MusicPlaylistViewWrapper* self)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	gboolean _tmp2_;
	MusicPlaybackManager* _tmp3_;
	MusicPlaybackManager* _tmp4_;
	MusicMedia* _tmp5_;
	MusicMedia* _tmp6_;
#line 91 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp0_ = music_app_get_player ();
#line 91 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 91 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_playback_manager_clear_queue (_tmp1_);
#line 92 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp2_ = TRUE;
#line 92 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_view_wrapper_play_first_media ((MusicViewWrapper*) self, &_tmp2_);
#line 93 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp3_ = music_app_get_player ();
#line 93 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp4_ = _tmp3_;
#line 93 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp5_ = music_playback_manager_get_next (_tmp4_, TRUE);
#line 93 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp6_ = _tmp5_;
#line 93 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_g_object_unref0 (_tmp6_);
#line 269 "PlaylistViewWrapper.c"
}

static void
_____lambda141__music_playlist_request_play (MusicPlaylist* _sender,
                                             gpointer self)
{
#line 90 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	____lambda141_ ((MusicPlaylistViewWrapper*) self);
#line 278 "PlaylistViewWrapper.c"
}

static void
music_playlist_view_wrapper_connect_data_signals (MusicPlaylistViewWrapper* self)
{
	MusicViewWrapperHint _tmp0_;
	MusicViewWrapperHint _tmp1_;
#line 78 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 79 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp0_ = music_view_wrapper_get_hint ((MusicViewWrapper*) self);
#line 79 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 79 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	switch (_tmp1_) {
#line 79 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST:
#line 79 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_HINT_PLAYLIST:
#line 79 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST:
#line 300 "PlaylistViewWrapper.c"
		{
			MusicPlaylist* p = NULL;
			MusicPlaylist* _tmp2_;
			MusicPlaylist* _tmp3_;
			MusicPlaylist* _tmp4_;
			MusicPlaylist* _tmp5_;
#line 83 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_tmp2_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) self);
#line 83 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_tmp3_ = _tmp2_;
#line 83 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, MUSIC_TYPE_PLAYLIST, MusicPlaylist));
#line 83 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			p = _tmp4_;
#line 86 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_tmp5_ = p;
#line 86 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			if (_tmp5_ != NULL) {
#line 319 "PlaylistViewWrapper.c"
				MusicPlaylist* _tmp6_;
				MusicPlaylist* _tmp7_;
				MusicPlaylist* _tmp8_;
				MusicPlaylist* _tmp9_;
#line 87 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
				_tmp6_ = p;
#line 87 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
				g_signal_connect_object (_tmp6_, "media-added", (GCallback) _music_playlist_view_wrapper_on_playlist_media_added_music_playlist_media_added, self, 0);
#line 88 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
				_tmp7_ = p;
#line 88 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
				g_signal_connect_object (_tmp7_, "media-removed", (GCallback) _music_playlist_view_wrapper_on_playlist_media_removed_music_playlist_media_removed, self, 0);
#line 89 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
				_tmp8_ = p;
#line 89 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
				g_signal_connect_object (_tmp8_, "cleared", (GCallback) _music_playlist_view_wrapper_on_playlist_cleared_music_playlist_cleared, self, 0);
#line 90 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
				_tmp9_ = p;
#line 90 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
				g_signal_connect_object (_tmp9_, "request-play", (GCallback) _____lambda141__music_playlist_request_play, self, 0);
#line 340 "PlaylistViewWrapper.c"
			}
#line 96 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_g_object_unref0 (p);
#line 96 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			break;
#line 346 "PlaylistViewWrapper.c"
		}
		default:
		{
#line 98 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			g_assert_not_reached ();
#line 352 "PlaylistViewWrapper.c"
		}
	}
}

void
music_playlist_view_wrapper_set_no_media_alert_message (MusicPlaylistViewWrapper* self,
                                                        const gchar* head,
                                                        const gchar* body)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 102 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_return_if_fail (head != NULL);
#line 102 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_return_if_fail (body != NULL);
#line 103 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp0_ = g_strdup (head);
#line 103 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_g_free0 (self->priv->message_head);
#line 103 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	self->priv->message_head = _tmp0_;
#line 104 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp1_ = g_strdup (body);
#line 104 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_g_free0 (self->priv->message_body);
#line 104 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	self->priv->message_body = _tmp1_;
#line 382 "PlaylistViewWrapper.c"
}

static void
music_playlist_view_wrapper_real_set_no_media_alert (MusicViewWrapper* base)
{
	MusicPlaylistViewWrapper * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GraniteWidgetsAlertView* _tmp2_;
	GraniteWidgetsAlertView* _tmp3_;
	GraniteWidgetsAlertView* _tmp4_;
	GraniteWidgetsAlertView* _tmp5_;
	const gchar* _tmp6_;
	GraniteWidgetsAlertView* _tmp7_;
	GraniteWidgetsAlertView* _tmp8_;
	const gchar* _tmp9_;
#line 107 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	self = (MusicPlaylistViewWrapper*) base;
#line 109 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp0_ = music_view_wrapper_get_has_embedded_alert ((MusicViewWrapper*) self);
#line 109 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 109 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_vala_assert (_tmp1_, "has_embedded_alert");
#line 111 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp2_ = music_view_wrapper_get_embedded_alert ((MusicViewWrapper*) self);
#line 111 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp3_ = _tmp2_;
#line 111 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	granite_widgets_alert_view_set_icon_name (_tmp3_, "dialog-information");
#line 112 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp4_ = music_view_wrapper_get_embedded_alert ((MusicViewWrapper*) self);
#line 112 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp5_ = _tmp4_;
#line 112 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp6_ = self->priv->message_head;
#line 112 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	granite_widgets_alert_view_set_title (_tmp5_, _tmp6_);
#line 113 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp7_ = music_view_wrapper_get_embedded_alert ((MusicViewWrapper*) self);
#line 113 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp8_ = _tmp7_;
#line 113 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp9_ = self->priv->message_body;
#line 113 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	granite_widgets_alert_view_set_description (_tmp8_, _tmp9_);
#line 429 "PlaylistViewWrapper.c"
}

static void
music_playlist_view_wrapper_on_playlist_media_added_data_free (gpointer _data)
{
	MusicPlaylistViewWrapperOnPlaylistMediaAddedData* _data_;
	_data_ = _data;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_g_object_unref0 (_data_->to_add);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_slice_free (MusicPlaylistViewWrapperOnPlaylistMediaAddedData, _data_);
#line 443 "PlaylistViewWrapper.c"
}

static void
music_playlist_view_wrapper_on_playlist_media_added (MusicPlaylistViewWrapper* self,
                                                     GeeCollection* to_add,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	MusicPlaylistViewWrapperOnPlaylistMediaAddedData* _data_;
	MusicPlaylistViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_return_if_fail (to_add != NULL);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_ = g_slice_new0 (MusicPlaylistViewWrapperOnPlaylistMediaAddedData);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_playlist_view_wrapper_on_playlist_media_added_data_free);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->self = _tmp0_;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp1_ = _g_object_ref0 (to_add);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_g_object_unref0 (_data_->to_add);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->to_add = _tmp1_;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_playlist_view_wrapper_on_playlist_media_added_co (_data_);
#line 477 "PlaylistViewWrapper.c"
}

static void
music_playlist_view_wrapper_on_playlist_media_added_finish (MusicPlaylistViewWrapper* self,
                                                            GAsyncResult* _res_)
{
	MusicPlaylistViewWrapperOnPlaylistMediaAddedData* _data_;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 487 "PlaylistViewWrapper.c"
}

static void
music_playlist_view_wrapper_on_playlist_media_added_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_)
{
	MusicPlaylistViewWrapperOnPlaylistMediaAddedData* _data_;
#line 117 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_ = _user_data_;
#line 117 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->_source_object_ = source_object;
#line 117 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->_res_ = _res_;
#line 117 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_playlist_view_wrapper_on_playlist_media_added_co (_data_);
#line 504 "PlaylistViewWrapper.c"
}

static gboolean
music_playlist_view_wrapper_on_playlist_media_added_co (MusicPlaylistViewWrapperOnPlaylistMediaAddedData* _data_)
{
#line 116 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	switch (_data_->_state_) {
#line 116 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		case 0:
#line 514 "PlaylistViewWrapper.c"
		goto _state_0;
#line 116 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		case 1:
#line 518 "PlaylistViewWrapper.c"
		goto _state_1;
		default:
#line 116 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		g_assert_not_reached ();
#line 523 "PlaylistViewWrapper.c"
	}
	_state_0:
#line 117 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->_state_ = 1;
#line 117 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_view_wrapper_add_media_async ((MusicViewWrapper*) _data_->self, _data_->to_add, music_playlist_view_wrapper_on_playlist_media_added_ready, _data_);
#line 117 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	return FALSE;
#line 532 "PlaylistViewWrapper.c"
	_state_1:
#line 117 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_view_wrapper_add_media_finish ((MusicViewWrapper*) _data_->self, _data_->_res_);
#line 116 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 116 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	if (_data_->_state_ != 0) {
#line 116 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 116 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 544 "PlaylistViewWrapper.c"
		}
	}
#line 116 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_object_unref (_data_->_async_result);
#line 116 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	return FALSE;
#line 551 "PlaylistViewWrapper.c"
}

static void
music_playlist_view_wrapper_on_playlist_media_removed_data_free (gpointer _data)
{
	MusicPlaylistViewWrapperOnPlaylistMediaRemovedData* _data_;
	_data_ = _data;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_g_object_unref0 (_data_->to_remove);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_slice_free (MusicPlaylistViewWrapperOnPlaylistMediaRemovedData, _data_);
#line 565 "PlaylistViewWrapper.c"
}

static void
music_playlist_view_wrapper_on_playlist_media_removed (MusicPlaylistViewWrapper* self,
                                                       GeeCollection* to_remove,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_)
{
	MusicPlaylistViewWrapperOnPlaylistMediaRemovedData* _data_;
	MusicPlaylistViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_return_if_fail (to_remove != NULL);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_ = g_slice_new0 (MusicPlaylistViewWrapperOnPlaylistMediaRemovedData);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_playlist_view_wrapper_on_playlist_media_removed_data_free);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->self = _tmp0_;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp1_ = _g_object_ref0 (to_remove);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_g_object_unref0 (_data_->to_remove);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->to_remove = _tmp1_;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_playlist_view_wrapper_on_playlist_media_removed_co (_data_);
#line 599 "PlaylistViewWrapper.c"
}

static void
music_playlist_view_wrapper_on_playlist_media_removed_finish (MusicPlaylistViewWrapper* self,
                                                              GAsyncResult* _res_)
{
	MusicPlaylistViewWrapperOnPlaylistMediaRemovedData* _data_;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 609 "PlaylistViewWrapper.c"
}

static void
music_playlist_view_wrapper_on_playlist_media_removed_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_)
{
	MusicPlaylistViewWrapperOnPlaylistMediaRemovedData* _data_;
#line 121 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_ = _user_data_;
#line 121 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->_source_object_ = source_object;
#line 121 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->_res_ = _res_;
#line 121 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_playlist_view_wrapper_on_playlist_media_removed_co (_data_);
#line 626 "PlaylistViewWrapper.c"
}

static gboolean
music_playlist_view_wrapper_on_playlist_media_removed_co (MusicPlaylistViewWrapperOnPlaylistMediaRemovedData* _data_)
{
#line 120 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	switch (_data_->_state_) {
#line 120 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		case 0:
#line 636 "PlaylistViewWrapper.c"
		goto _state_0;
#line 120 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		case 1:
#line 640 "PlaylistViewWrapper.c"
		goto _state_1;
		default:
#line 120 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		g_assert_not_reached ();
#line 645 "PlaylistViewWrapper.c"
	}
	_state_0:
#line 121 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->_state_ = 1;
#line 121 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_view_wrapper_remove_media_async ((MusicViewWrapper*) _data_->self, _data_->to_remove, music_playlist_view_wrapper_on_playlist_media_removed_ready, _data_);
#line 121 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	return FALSE;
#line 654 "PlaylistViewWrapper.c"
	_state_1:
#line 121 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_view_wrapper_remove_media_finish ((MusicViewWrapper*) _data_->self, _data_->_res_);
#line 120 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 120 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	if (_data_->_state_ != 0) {
#line 120 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 120 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 666 "PlaylistViewWrapper.c"
		}
	}
#line 120 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_object_unref (_data_->_async_result);
#line 120 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	return FALSE;
#line 673 "PlaylistViewWrapper.c"
}

static void
music_playlist_view_wrapper_on_playlist_cleared_data_free (gpointer _data)
{
	MusicPlaylistViewWrapperOnPlaylistClearedData* _data_;
	_data_ = _data;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_slice_free (MusicPlaylistViewWrapperOnPlaylistClearedData, _data_);
#line 685 "PlaylistViewWrapper.c"
}

static void
music_playlist_view_wrapper_on_playlist_cleared (MusicPlaylistViewWrapper* self,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	MusicPlaylistViewWrapperOnPlaylistClearedData* _data_;
	MusicPlaylistViewWrapper* _tmp0_;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_ = g_slice_new0 (MusicPlaylistViewWrapperOnPlaylistClearedData);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_playlist_view_wrapper_on_playlist_cleared_data_free);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->self = _tmp0_;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_playlist_view_wrapper_on_playlist_cleared_co (_data_);
#line 709 "PlaylistViewWrapper.c"
}

static void
music_playlist_view_wrapper_on_playlist_cleared_finish (MusicPlaylistViewWrapper* self,
                                                        GAsyncResult* _res_)
{
	MusicPlaylistViewWrapperOnPlaylistClearedData* _data_;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 719 "PlaylistViewWrapper.c"
}

static void
music_playlist_view_wrapper_on_playlist_cleared_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_)
{
	MusicPlaylistViewWrapperOnPlaylistClearedData* _data_;
#line 125 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_ = _user_data_;
#line 125 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->_source_object_ = source_object;
#line 125 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->_res_ = _res_;
#line 125 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_playlist_view_wrapper_on_playlist_cleared_co (_data_);
#line 736 "PlaylistViewWrapper.c"
}

static gboolean
music_playlist_view_wrapper_on_playlist_cleared_co (MusicPlaylistViewWrapperOnPlaylistClearedData* _data_)
{
#line 124 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	switch (_data_->_state_) {
#line 124 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		case 0:
#line 746 "PlaylistViewWrapper.c"
		goto _state_0;
#line 124 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		case 1:
#line 750 "PlaylistViewWrapper.c"
		goto _state_1;
		default:
#line 124 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		g_assert_not_reached ();
#line 755 "PlaylistViewWrapper.c"
	}
	_state_0:
#line 125 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->_tmp0_ = gee_array_queue_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 125 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 125 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_data_->_state_ = 1;
#line 125 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_view_wrapper_set_media_async ((MusicViewWrapper*) _data_->self, (GeeCollection*) _data_->_tmp1_, music_playlist_view_wrapper_on_playlist_cleared_ready, _data_);
#line 125 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	return FALSE;
#line 768 "PlaylistViewWrapper.c"
	_state_1:
#line 125 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_view_wrapper_set_media_finish ((MusicViewWrapper*) _data_->self, _data_->_res_);
#line 125 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 124 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 124 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	if (_data_->_state_ != 0) {
#line 124 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 124 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 782 "PlaylistViewWrapper.c"
		}
	}
#line 124 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_object_unref (_data_->_async_result);
#line 124 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	return FALSE;
#line 789 "PlaylistViewWrapper.c"
}

MusicTreeViewSetup*
music_playlist_view_wrapper_get_tvs (MusicPlaylistViewWrapper* self)
{
	MusicTreeViewSetup* result;
	MusicTreeViewSetup* _tmp0_;
#line 30 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp0_ = self->priv->_tvs;
#line 30 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	result = _tmp0_;
#line 30 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	return result;
#line 805 "PlaylistViewWrapper.c"
}

void
music_playlist_view_wrapper_set_tvs (MusicPlaylistViewWrapper* self,
                                     MusicTreeViewSetup* value)
{
	MusicTreeViewSetup* old_value;
#line 30 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	old_value = music_playlist_view_wrapper_get_tvs (self);
#line 30 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	if (old_value != value) {
#line 819 "PlaylistViewWrapper.c"
		MusicTreeViewSetup* _tmp0_;
#line 30 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		_g_object_unref0 (self->priv->_tvs);
#line 30 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		self->priv->_tvs = _tmp0_;
#line 30 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, music_playlist_view_wrapper_properties[MUSIC_PLAYLIST_VIEW_WRAPPER_TVS_PROPERTY]);
#line 829 "PlaylistViewWrapper.c"
	}
}

static void
_music_playlist_view_wrapper____lambda142_ (MusicPlaylistViewWrapper* self)
{
	MusicPlaylist* _tmp0_;
	MusicPlaylist* _tmp1_;
#line 61 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp0_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) self);
#line 61 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 61 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_signal_emit (self, music_playlist_view_wrapper_signals[MUSIC_PLAYLIST_VIEW_WRAPPER_BUTTON_CLICKED_SIGNAL], 0, _tmp1_);
#line 844 "PlaylistViewWrapper.c"
}

static void
__music_playlist_view_wrapper____lambda142__granite_widgets_alert_view_action_activated (GraniteWidgetsAlertView* _sender,
                                                                                         gpointer self)
{
#line 60 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_music_playlist_view_wrapper____lambda142_ ((MusicPlaylistViewWrapper*) self);
#line 853 "PlaylistViewWrapper.c"
}

static GObject *
music_playlist_view_wrapper_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicPlaylistViewWrapper * self;
	MusicTreeViewSetup* _tmp0_;
	MusicListView* _tmp1_;
	MusicListView* _tmp2_;
	GraniteWidgetsAlertView* _tmp3_;
	GraniteWidgetsAlertView* _tmp4_;
	MusicViewWrapperHint _tmp5_;
	MusicViewWrapperHint _tmp6_;
	MusicPlaylist* _tmp17_;
	MusicPlaylist* _tmp18_;
	GeeArrayList* _tmp19_;
	GeeArrayList* _tmp20_;
#line 39 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	parent_class = G_OBJECT_CLASS (music_playlist_view_wrapper_parent_class);
#line 39 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 39 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapper);
#line 40 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp0_ = self->priv->_tvs;
#line 40 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp1_ = music_list_view_new ((MusicViewWrapper*) self, _tmp0_, FALSE);
#line 40 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_object_ref_sink (_tmp1_);
#line 40 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp2_ = _tmp1_;
#line 40 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_view_wrapper_set_list_view ((MusicViewWrapper*) self, _tmp2_);
#line 40 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_g_object_unref0 (_tmp2_);
#line 41 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp3_ = granite_widgets_alert_view_new ("", "", "");
#line 41 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_object_ref_sink (_tmp3_);
#line 41 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp4_ = _tmp3_;
#line 41 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_view_wrapper_set_embedded_alert ((MusicViewWrapper*) self, _tmp4_);
#line 41 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_g_object_unref0 (_tmp4_);
#line 44 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_view_wrapper_pack_views ((MusicViewWrapper*) self);
#line 48 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp5_ = music_view_wrapper_get_hint ((MusicViewWrapper*) self);
#line 48 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp6_ = _tmp5_;
#line 48 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	switch (_tmp6_) {
#line 48 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST:
#line 913 "PlaylistViewWrapper.c"
		{
			gchar* _tmp7_;
			gchar* _tmp8_;
#line 50 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_tmp7_ = g_strdup (_ ("No Songs"));
#line 50 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_g_free0 (self->priv->message_head);
#line 50 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			self->priv->message_head = _tmp7_;
#line 51 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_tmp8_ = g_strdup (_ ("Updating playlist. Please wait."));
#line 51 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_g_free0 (self->priv->message_body);
#line 51 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			self->priv->message_body = _tmp8_;
#line 52 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			break;
#line 931 "PlaylistViewWrapper.c"
		}
#line 48 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_HINT_PLAYLIST:
#line 935 "PlaylistViewWrapper.c"
		{
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 54 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_tmp9_ = g_strdup (_ ("No Songs"));
#line 54 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_g_free0 (self->priv->message_head);
#line 54 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			self->priv->message_head = _tmp9_;
#line 55 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_tmp10_ = g_strdup (_ ("To add songs to this playlist, use the <b>secondary click</b> on an it" \
"em and choose <b>Add to Playlist</b>."));
#line 55 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_g_free0 (self->priv->message_body);
#line 55 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			self->priv->message_body = _tmp10_;
#line 56 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			break;
#line 953 "PlaylistViewWrapper.c"
		}
#line 48 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST:
#line 957 "PlaylistViewWrapper.c"
		{
			GraniteWidgetsAlertView* _tmp11_;
			GraniteWidgetsAlertView* _tmp12_;
			GraniteWidgetsAlertView* _tmp13_;
			GraniteWidgetsAlertView* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 58 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_tmp11_ = music_view_wrapper_get_embedded_alert ((MusicViewWrapper*) self);
#line 58 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_tmp12_ = _tmp11_;
#line 58 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			granite_widgets_alert_view_show_action (_tmp12_, _ ("Edit Smart Playlist"));
#line 60 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_tmp13_ = music_view_wrapper_get_embedded_alert ((MusicViewWrapper*) self);
#line 60 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_tmp14_ = _tmp13_;
#line 60 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			g_signal_connect_object (_tmp14_, "action-activated", (GCallback) __music_playlist_view_wrapper____lambda142__granite_widgets_alert_view_action_activated, self, 0);
#line 64 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_tmp15_ = g_strdup (_ ("No Songs"));
#line 64 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_g_free0 (self->priv->message_head);
#line 64 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			self->priv->message_head = _tmp15_;
#line 65 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_tmp16_ = g_strdup (_ ("This playlist will be automatically populated with songs that match it" \
"s rules. To modify these rules, use the <b>secondary click</b> on it i" \
"n the sidebar and click on <b>Edit</b>. Optionally, you can click on t" \
"he button below."));
#line 65 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			_g_free0 (self->priv->message_body);
#line 65 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			self->priv->message_body = _tmp16_;
#line 66 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			break;
#line 991 "PlaylistViewWrapper.c"
		}
#line 48 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		case MUSIC_VIEW_WRAPPER_HINT_NONE:
#line 995 "PlaylistViewWrapper.c"
		{
#line 68 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			g_debug ("PlaylistViewWrapper.vala:68: Hint = NONE");
#line 69 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			break;
#line 1001 "PlaylistViewWrapper.c"
		}
		default:
		{
#line 71 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
			g_assert_not_reached ();
#line 1007 "PlaylistViewWrapper.c"
		}
	}
#line 74 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp17_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) self);
#line 74 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp18_ = _tmp17_;
#line 74 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp19_ = music_playlist_get_medias (_tmp18_);
#line 74 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_tmp20_ = _tmp19_;
#line 74 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_view_wrapper_set_media_async ((MusicViewWrapper*) self, (GeeCollection*) _tmp20_, NULL, NULL);
#line 75 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_playlist_view_wrapper_connect_data_signals (self);
#line 39 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	return obj;
#line 1024 "PlaylistViewWrapper.c"
}

static void
music_playlist_view_wrapper_class_init (MusicPlaylistViewWrapperClass * klass,
                                        gpointer klass_data)
{
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_playlist_view_wrapper_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_type_class_adjust_private_offset (klass, &MusicPlaylistViewWrapper_private_offset);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	((MusicViewWrapperClass *) klass)->set_no_media_alert = (void (*) (MusicViewWrapper*)) music_playlist_view_wrapper_real_set_no_media_alert;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_playlist_view_wrapper_get_property;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_playlist_view_wrapper_set_property;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	G_OBJECT_CLASS (klass)->constructor = music_playlist_view_wrapper_constructor;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	G_OBJECT_CLASS (klass)->finalize = music_playlist_view_wrapper_finalize;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYLIST_VIEW_WRAPPER_TVS_PROPERTY, music_playlist_view_wrapper_properties[MUSIC_PLAYLIST_VIEW_WRAPPER_TVS_PROPERTY] = g_param_spec_object ("tvs", "tvs", "tvs", MUSIC_TYPE_TREE_VIEW_SETUP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	music_playlist_view_wrapper_signals[MUSIC_PLAYLIST_VIEW_WRAPPER_BUTTON_CLICKED_SIGNAL] = g_signal_new ("button-clicked", MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_PLAYLIST);
#line 1049 "PlaylistViewWrapper.c"
}

static void
music_playlist_view_wrapper_instance_init (MusicPlaylistViewWrapper * self,
                                           gpointer klass)
{
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	self->priv = music_playlist_view_wrapper_get_instance_private (self);
#line 1058 "PlaylistViewWrapper.c"
}

static void
music_playlist_view_wrapper_finalize (GObject * obj)
{
	MusicPlaylistViewWrapper * self;
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapper);
#line 30 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_g_object_unref0 (self->priv->_tvs);
#line 32 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_g_free0 (self->priv->message_head);
#line 33 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	_g_free0 (self->priv->message_body);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	G_OBJECT_CLASS (music_playlist_view_wrapper_parent_class)->finalize (obj);
#line 1075 "PlaylistViewWrapper.c"
}

static GType
music_playlist_view_wrapper_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPlaylistViewWrapperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_playlist_view_wrapper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPlaylistViewWrapper), 0, (GInstanceInitFunc) music_playlist_view_wrapper_instance_init, NULL };
	GType music_playlist_view_wrapper_type_id;
	music_playlist_view_wrapper_type_id = g_type_register_static (MUSIC_TYPE_VIEW_WRAPPER, "MusicPlaylistViewWrapper", &g_define_type_info, 0);
	MusicPlaylistViewWrapper_private_offset = g_type_add_instance_private (music_playlist_view_wrapper_type_id, sizeof (MusicPlaylistViewWrapperPrivate));
	return music_playlist_view_wrapper_type_id;
}

GType
music_playlist_view_wrapper_get_type (void)
{
	static volatile gsize music_playlist_view_wrapper_type_id__once = 0;
	if (g_once_init_enter (&music_playlist_view_wrapper_type_id__once)) {
		GType music_playlist_view_wrapper_type_id;
		music_playlist_view_wrapper_type_id = music_playlist_view_wrapper_get_type_once ();
		g_once_init_leave (&music_playlist_view_wrapper_type_id__once, music_playlist_view_wrapper_type_id);
	}
	return music_playlist_view_wrapper_type_id__once;
}

static void
_vala_music_playlist_view_wrapper_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	MusicPlaylistViewWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapper);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	switch (property_id) {
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		case MUSIC_PLAYLIST_VIEW_WRAPPER_TVS_PROPERTY:
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		g_value_set_object (value, music_playlist_view_wrapper_get_tvs (self));
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		break;
#line 1116 "PlaylistViewWrapper.c"
		default:
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		break;
#line 1122 "PlaylistViewWrapper.c"
	}
}

static void
_vala_music_playlist_view_wrapper_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	MusicPlaylistViewWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapper);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
	switch (property_id) {
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		case MUSIC_PLAYLIST_VIEW_WRAPPER_TVS_PROPERTY:
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		music_playlist_view_wrapper_set_tvs (self, g_value_get_object (value));
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		break;
#line 1142 "PlaylistViewWrapper.c"
		default:
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Views/Wrappers/PlaylistViewWrapper.vala"
		break;
#line 1148 "PlaylistViewWrapper.c"
	}
}

