/* ContractMenuItem.c generated by valac 0.56.0, the Vala compiler
 * generated from ContractMenuItem.vala, do not modify */

/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Corentin Noël <corentin@elementary.io>,
 *              Lucas Baudin <xapantu@gmail.com>,
 *              ammonkey <am.monkeyd@gmail.com>,
 *              Victor Martinez <victoreduardm@gmail.com>,
 *              Sergey Davidoff <shnatsel@gmail.com>
 */

#include "music-lib.h"
#include <granite.h>
#include <gee.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

enum  {
	MUSIC_CONTRACT_MENU_ITEM_0_PROPERTY,
	MUSIC_CONTRACT_MENU_ITEM_CONTRACT_PROPERTY,
	MUSIC_CONTRACT_MENU_ITEM_MEDIAS_PROPERTY,
	MUSIC_CONTRACT_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* music_contract_menu_item_properties[MUSIC_CONTRACT_MENU_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MusicContractMenuItemPrivate {
	GraniteServicesContract* _contract;
	GeeCollection* _medias;
};

static gint MusicContractMenuItem_private_offset;
static gpointer music_contract_menu_item_parent_class = NULL;

static void music_contract_menu_item_real_activate (GtkMenuItem* base);
static void _vala_array_add25 (GFile** * array,
                        gint* length,
                        gint* size,
                        GFile* value);
static void music_contract_menu_item_finalize (GObject * obj);
static GType music_contract_menu_item_get_type_once (void);
static void _vala_music_contract_menu_item_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_music_contract_menu_item_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
music_contract_menu_item_get_instance_private (MusicContractMenuItem* self)
{
	return G_STRUCT_MEMBER_P (self, MusicContractMenuItem_private_offset);
}

MusicContractMenuItem*
music_contract_menu_item_construct (GType object_type,
                                    GraniteServicesContract* contract,
                                    GeeCollection* medias)
{
	MusicContractMenuItem * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 37 "../src/Widgets/ContractMenuItem.vala"
	g_return_val_if_fail (contract != NULL, NULL);
#line 37 "../src/Widgets/ContractMenuItem.vala"
	g_return_val_if_fail (medias != NULL, NULL);
#line 38 "../src/Widgets/ContractMenuItem.vala"
	_tmp0_ = granite_services_contract_get_display_name (contract);
#line 38 "../src/Widgets/ContractMenuItem.vala"
	_tmp1_ = _tmp0_;
#line 38 "../src/Widgets/ContractMenuItem.vala"
	self = (MusicContractMenuItem*) g_object_new (object_type, "contract", contract, "medias", medias, "label", _tmp1_, NULL);
#line 38 "../src/Widgets/ContractMenuItem.vala"
	_g_free0 (_tmp1_);
#line 37 "../src/Widgets/ContractMenuItem.vala"
	return self;
#line 117 "ContractMenuItem.c"
}

MusicContractMenuItem*
music_contract_menu_item_new (GraniteServicesContract* contract,
                              GeeCollection* medias)
{
#line 37 "../src/Widgets/ContractMenuItem.vala"
	return music_contract_menu_item_construct (MUSIC_TYPE_CONTRACT_MENU_ITEM, contract, medias);
#line 126 "ContractMenuItem.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 44 "../src/Widgets/ContractMenuItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 134 "ContractMenuItem.c"
}

static void
_vala_array_add25 (GFile** * array,
                   gint* length,
                   gint* size,
                   GFile* value)
{
#line 44 "../src/Widgets/ContractMenuItem.vala"
	if ((*length) == (*size)) {
#line 44 "../src/Widgets/ContractMenuItem.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 44 "../src/Widgets/ContractMenuItem.vala"
		*array = g_renew (GFile*, *array, (*size) + 1);
#line 149 "ContractMenuItem.c"
	}
#line 44 "../src/Widgets/ContractMenuItem.vala"
	(*array)[(*length)++] = value;
#line 44 "../src/Widgets/ContractMenuItem.vala"
	(*array)[*length] = NULL;
#line 155 "ContractMenuItem.c"
}

static void
music_contract_menu_item_real_activate (GtkMenuItem* base)
{
	MusicContractMenuItem * self;
	GFile** files = NULL;
	GFile** _tmp0_;
	gint files_length1;
	gint _files_size_;
	GError* _inner_error0_ = NULL;
#line 41 "../src/Widgets/ContractMenuItem.vala"
	self = (MusicContractMenuItem*) base;
#line 42 "../src/Widgets/ContractMenuItem.vala"
	_tmp0_ = g_new0 (GFile*, 0 + 1);
#line 42 "../src/Widgets/ContractMenuItem.vala"
	files = _tmp0_;
#line 42 "../src/Widgets/ContractMenuItem.vala"
	files_length1 = 0;
#line 42 "../src/Widgets/ContractMenuItem.vala"
	_files_size_ = files_length1;
#line 177 "ContractMenuItem.c"
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
#line 43 "../src/Widgets/ContractMenuItem.vala"
		_tmp1_ = self->priv->_medias;
#line 43 "../src/Widgets/ContractMenuItem.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 43 "../src/Widgets/ContractMenuItem.vala"
		_m_it = _tmp2_;
#line 43 "../src/Widgets/ContractMenuItem.vala"
		while (TRUE) {
#line 190 "ContractMenuItem.c"
			GeeIterator* _tmp3_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			MusicMedia* _tmp6_;
			GFile* _tmp7_;
			GFile* _tmp8_;
			GFile* _tmp9_;
			MusicMedia* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 43 "../src/Widgets/ContractMenuItem.vala"
			_tmp3_ = _m_it;
#line 43 "../src/Widgets/ContractMenuItem.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 43 "../src/Widgets/ContractMenuItem.vala"
				break;
#line 209 "ContractMenuItem.c"
			}
#line 43 "../src/Widgets/ContractMenuItem.vala"
			_tmp4_ = _m_it;
#line 43 "../src/Widgets/ContractMenuItem.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 43 "../src/Widgets/ContractMenuItem.vala"
			m = (MusicMedia*) _tmp5_;
#line 44 "../src/Widgets/ContractMenuItem.vala"
			_tmp6_ = m;
#line 44 "../src/Widgets/ContractMenuItem.vala"
			_tmp7_ = music_media_get_file (_tmp6_);
#line 44 "../src/Widgets/ContractMenuItem.vala"
			_tmp8_ = _tmp7_;
#line 44 "../src/Widgets/ContractMenuItem.vala"
			_tmp9_ = _g_object_ref0 (_tmp8_);
#line 44 "../src/Widgets/ContractMenuItem.vala"
			_vala_array_add25 (&files, &files_length1, &_files_size_, _tmp9_);
#line 45 "../src/Widgets/ContractMenuItem.vala"
			_tmp10_ = m;
#line 45 "../src/Widgets/ContractMenuItem.vala"
			_tmp11_ = music_media_get_uri (_tmp10_);
#line 45 "../src/Widgets/ContractMenuItem.vala"
			_tmp12_ = _tmp11_;
#line 45 "../src/Widgets/ContractMenuItem.vala"
			_tmp13_ = _tmp12_;
#line 45 "../src/Widgets/ContractMenuItem.vala"
			g_debug ("ContractMenuItem.vala:45: Added file to pass to Contractor: %s", _tmp13_);
#line 45 "../src/Widgets/ContractMenuItem.vala"
			_g_free0 (_tmp13_);
#line 43 "../src/Widgets/ContractMenuItem.vala"
			_g_object_unref0 (m);
#line 241 "ContractMenuItem.c"
		}
#line 43 "../src/Widgets/ContractMenuItem.vala"
		_g_object_unref0 (_m_it);
#line 245 "ContractMenuItem.c"
	}
	{
		GraniteServicesContract* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		GraniteServicesContract* _tmp17_;
		GFile** _tmp18_;
		gint _tmp18__length1;
#line 49 "../src/Widgets/ContractMenuItem.vala"
		_tmp14_ = self->priv->_contract;
#line 49 "../src/Widgets/ContractMenuItem.vala"
		_tmp15_ = granite_services_contract_get_display_name (_tmp14_);
#line 49 "../src/Widgets/ContractMenuItem.vala"
		_tmp16_ = _tmp15_;
#line 49 "../src/Widgets/ContractMenuItem.vala"
		g_debug ("ContractMenuItem.vala:49: Executing contract \"%s\"", _tmp16_);
#line 49 "../src/Widgets/ContractMenuItem.vala"
		_g_free0 (_tmp16_);
#line 50 "../src/Widgets/ContractMenuItem.vala"
		_tmp17_ = self->priv->_contract;
#line 50 "../src/Widgets/ContractMenuItem.vala"
		_tmp18_ = files;
#line 50 "../src/Widgets/ContractMenuItem.vala"
		_tmp18__length1 = files_length1;
#line 50 "../src/Widgets/ContractMenuItem.vala"
		granite_services_contract_execute_with_files (_tmp17_, _tmp18_, (gint) _tmp18__length1, &_inner_error0_);
#line 50 "../src/Widgets/ContractMenuItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 274 "ContractMenuItem.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GraniteServicesContract* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		GError* _tmp22_;
		const gchar* _tmp23_;
#line 48 "../src/Widgets/ContractMenuItem.vala"
		err = _inner_error0_;
#line 48 "../src/Widgets/ContractMenuItem.vala"
		_inner_error0_ = NULL;
#line 52 "../src/Widgets/ContractMenuItem.vala"
		_tmp19_ = self->priv->_contract;
#line 52 "../src/Widgets/ContractMenuItem.vala"
		_tmp20_ = granite_services_contract_get_display_name (_tmp19_);
#line 52 "../src/Widgets/ContractMenuItem.vala"
		_tmp21_ = _tmp20_;
#line 52 "../src/Widgets/ContractMenuItem.vala"
		_tmp22_ = err;
#line 52 "../src/Widgets/ContractMenuItem.vala"
		_tmp23_ = _tmp22_->message;
#line 52 "../src/Widgets/ContractMenuItem.vala"
		g_warning ("ContractMenuItem.vala:52: Error executing contract \"%s\": %s", _tmp21_, _tmp23_);
#line 52 "../src/Widgets/ContractMenuItem.vala"
		_g_free0 (_tmp21_);
#line 48 "../src/Widgets/ContractMenuItem.vala"
		_g_error_free0 (err);
#line 307 "ContractMenuItem.c"
	}
	__finally0:
#line 48 "../src/Widgets/ContractMenuItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "../src/Widgets/ContractMenuItem.vala"
		files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_object_unref), NULL);
#line 48 "../src/Widgets/ContractMenuItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "../src/Widgets/ContractMenuItem.vala"
		g_clear_error (&_inner_error0_);
#line 48 "../src/Widgets/ContractMenuItem.vala"
		return;
#line 320 "ContractMenuItem.c"
	}
#line 41 "../src/Widgets/ContractMenuItem.vala"
	files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_object_unref), NULL);
#line 324 "ContractMenuItem.c"
}

GraniteServicesContract*
music_contract_menu_item_get_contract (MusicContractMenuItem* self)
{
	GraniteServicesContract* result;
	GraniteServicesContract* _tmp0_;
#line 34 "../src/Widgets/ContractMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/Widgets/ContractMenuItem.vala"
	_tmp0_ = self->priv->_contract;
#line 34 "../src/Widgets/ContractMenuItem.vala"
	result = _tmp0_;
#line 34 "../src/Widgets/ContractMenuItem.vala"
	return result;
#line 340 "ContractMenuItem.c"
}

void
music_contract_menu_item_set_contract (MusicContractMenuItem* self,
                                       GraniteServicesContract* value)
{
	GraniteServicesContract* old_value;
#line 34 "../src/Widgets/ContractMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Widgets/ContractMenuItem.vala"
	old_value = music_contract_menu_item_get_contract (self);
#line 34 "../src/Widgets/ContractMenuItem.vala"
	if (old_value != value) {
#line 354 "ContractMenuItem.c"
		GraniteServicesContract* _tmp0_;
#line 34 "../src/Widgets/ContractMenuItem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 34 "../src/Widgets/ContractMenuItem.vala"
		_g_object_unref0 (self->priv->_contract);
#line 34 "../src/Widgets/ContractMenuItem.vala"
		self->priv->_contract = _tmp0_;
#line 34 "../src/Widgets/ContractMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, music_contract_menu_item_properties[MUSIC_CONTRACT_MENU_ITEM_CONTRACT_PROPERTY]);
#line 364 "ContractMenuItem.c"
	}
}

GeeCollection*
music_contract_menu_item_get_medias (MusicContractMenuItem* self)
{
	GeeCollection* result;
	GeeCollection* _tmp0_;
#line 35 "../src/Widgets/ContractMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Widgets/ContractMenuItem.vala"
	_tmp0_ = self->priv->_medias;
#line 35 "../src/Widgets/ContractMenuItem.vala"
	result = _tmp0_;
#line 35 "../src/Widgets/ContractMenuItem.vala"
	return result;
#line 381 "ContractMenuItem.c"
}

void
music_contract_menu_item_set_medias (MusicContractMenuItem* self,
                                     GeeCollection* value)
{
	GeeCollection* old_value;
#line 35 "../src/Widgets/ContractMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Widgets/ContractMenuItem.vala"
	old_value = music_contract_menu_item_get_medias (self);
#line 35 "../src/Widgets/ContractMenuItem.vala"
	if (old_value != value) {
#line 395 "ContractMenuItem.c"
		GeeCollection* _tmp0_;
#line 35 "../src/Widgets/ContractMenuItem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 35 "../src/Widgets/ContractMenuItem.vala"
		_g_object_unref0 (self->priv->_medias);
#line 35 "../src/Widgets/ContractMenuItem.vala"
		self->priv->_medias = _tmp0_;
#line 35 "../src/Widgets/ContractMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, music_contract_menu_item_properties[MUSIC_CONTRACT_MENU_ITEM_MEDIAS_PROPERTY]);
#line 405 "ContractMenuItem.c"
	}
}

static void
music_contract_menu_item_class_init (MusicContractMenuItemClass * klass,
                                     gpointer klass_data)
{
#line 33 "../src/Widgets/ContractMenuItem.vala"
	music_contract_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 33 "../src/Widgets/ContractMenuItem.vala"
	g_type_class_adjust_private_offset (klass, &MusicContractMenuItem_private_offset);
#line 33 "../src/Widgets/ContractMenuItem.vala"
	((GtkMenuItemClass *) klass)->activate = (void (*) (GtkMenuItem*)) music_contract_menu_item_real_activate;
#line 33 "../src/Widgets/ContractMenuItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_contract_menu_item_get_property;
#line 33 "../src/Widgets/ContractMenuItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_contract_menu_item_set_property;
#line 33 "../src/Widgets/ContractMenuItem.vala"
	G_OBJECT_CLASS (klass)->finalize = music_contract_menu_item_finalize;
#line 33 "../src/Widgets/ContractMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_CONTRACT_MENU_ITEM_CONTRACT_PROPERTY, music_contract_menu_item_properties[MUSIC_CONTRACT_MENU_ITEM_CONTRACT_PROPERTY] = g_param_spec_object ("contract", "contract", "contract", GRANITE_SERVICES_TYPE_CONTRACT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 33 "../src/Widgets/ContractMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_CONTRACT_MENU_ITEM_MEDIAS_PROPERTY, music_contract_menu_item_properties[MUSIC_CONTRACT_MENU_ITEM_MEDIAS_PROPERTY] = g_param_spec_object ("medias", "medias", "medias", GEE_TYPE_COLLECTION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 429 "ContractMenuItem.c"
}

static void
music_contract_menu_item_instance_init (MusicContractMenuItem * self,
                                        gpointer klass)
{
#line 33 "../src/Widgets/ContractMenuItem.vala"
	self->priv = music_contract_menu_item_get_instance_private (self);
#line 438 "ContractMenuItem.c"
}

static void
music_contract_menu_item_finalize (GObject * obj)
{
	MusicContractMenuItem * self;
#line 33 "../src/Widgets/ContractMenuItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_CONTRACT_MENU_ITEM, MusicContractMenuItem);
#line 34 "../src/Widgets/ContractMenuItem.vala"
	_g_object_unref0 (self->priv->_contract);
#line 35 "../src/Widgets/ContractMenuItem.vala"
	_g_object_unref0 (self->priv->_medias);
#line 33 "../src/Widgets/ContractMenuItem.vala"
	G_OBJECT_CLASS (music_contract_menu_item_parent_class)->finalize (obj);
#line 453 "ContractMenuItem.c"
}

static GType
music_contract_menu_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicContractMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_contract_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicContractMenuItem), 0, (GInstanceInitFunc) music_contract_menu_item_instance_init, NULL };
	GType music_contract_menu_item_type_id;
	music_contract_menu_item_type_id = g_type_register_static (gtk_menu_item_get_type (), "MusicContractMenuItem", &g_define_type_info, 0);
	MusicContractMenuItem_private_offset = g_type_add_instance_private (music_contract_menu_item_type_id, sizeof (MusicContractMenuItemPrivate));
	return music_contract_menu_item_type_id;
}

GType
music_contract_menu_item_get_type (void)
{
	static volatile gsize music_contract_menu_item_type_id__once = 0;
	if (g_once_init_enter (&music_contract_menu_item_type_id__once)) {
		GType music_contract_menu_item_type_id;
		music_contract_menu_item_type_id = music_contract_menu_item_get_type_once ();
		g_once_init_leave (&music_contract_menu_item_type_id__once, music_contract_menu_item_type_id);
	}
	return music_contract_menu_item_type_id__once;
}

static void
_vala_music_contract_menu_item_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	MusicContractMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_CONTRACT_MENU_ITEM, MusicContractMenuItem);
#line 33 "../src/Widgets/ContractMenuItem.vala"
	switch (property_id) {
#line 33 "../src/Widgets/ContractMenuItem.vala"
		case MUSIC_CONTRACT_MENU_ITEM_CONTRACT_PROPERTY:
#line 33 "../src/Widgets/ContractMenuItem.vala"
		g_value_set_object (value, music_contract_menu_item_get_contract (self));
#line 33 "../src/Widgets/ContractMenuItem.vala"
		break;
#line 33 "../src/Widgets/ContractMenuItem.vala"
		case MUSIC_CONTRACT_MENU_ITEM_MEDIAS_PROPERTY:
#line 33 "../src/Widgets/ContractMenuItem.vala"
		g_value_set_object (value, music_contract_menu_item_get_medias (self));
#line 33 "../src/Widgets/ContractMenuItem.vala"
		break;
#line 500 "ContractMenuItem.c"
		default:
#line 33 "../src/Widgets/ContractMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "../src/Widgets/ContractMenuItem.vala"
		break;
#line 506 "ContractMenuItem.c"
	}
}

static void
_vala_music_contract_menu_item_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	MusicContractMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_CONTRACT_MENU_ITEM, MusicContractMenuItem);
#line 33 "../src/Widgets/ContractMenuItem.vala"
	switch (property_id) {
#line 33 "../src/Widgets/ContractMenuItem.vala"
		case MUSIC_CONTRACT_MENU_ITEM_CONTRACT_PROPERTY:
#line 33 "../src/Widgets/ContractMenuItem.vala"
		music_contract_menu_item_set_contract (self, g_value_get_object (value));
#line 33 "../src/Widgets/ContractMenuItem.vala"
		break;
#line 33 "../src/Widgets/ContractMenuItem.vala"
		case MUSIC_CONTRACT_MENU_ITEM_MEDIAS_PROPERTY:
#line 33 "../src/Widgets/ContractMenuItem.vala"
		music_contract_menu_item_set_medias (self, g_value_get_object (value));
#line 33 "../src/Widgets/ContractMenuItem.vala"
		break;
#line 532 "ContractMenuItem.c"
		default:
#line 33 "../src/Widgets/ContractMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "../src/Widgets/ContractMenuItem.vala"
		break;
#line 538 "ContractMenuItem.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

