/* FastGrid.c generated by valac 0.56.0, the Vala compiler
 * generated from FastGrid.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */

#include "music-lib.h"
#include <gtk/gtk.h>
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>

enum  {
	MUSIC_FAST_GRID_0_PROPERTY,
	MUSIC_FAST_GRID_NUM_PROPERTIES
};
static GParamSpec* music_fast_grid_properties[MUSIC_FAST_GRID_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define MUSIC_WIDGETS_TYPE_TILE_RENDERER (music_widgets_tile_renderer_get_type ())
#define MUSIC_WIDGETS_TILE_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_WIDGETS_TYPE_TILE_RENDERER, MusicWidgetsTileRenderer))
#define MUSIC_WIDGETS_TILE_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_WIDGETS_TYPE_TILE_RENDERER, MusicWidgetsTileRendererClass))
#define MUSIC_WIDGETS_IS_TILE_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_WIDGETS_TYPE_TILE_RENDERER))
#define MUSIC_WIDGETS_IS_TILE_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_WIDGETS_TYPE_TILE_RENDERER))
#define MUSIC_WIDGETS_TILE_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_WIDGETS_TYPE_TILE_RENDERER, MusicWidgetsTileRendererClass))

typedef struct _MusicWidgetsTileRenderer MusicWidgetsTileRenderer;
typedef struct _MusicWidgetsTileRendererClass MusicWidgetsTileRendererClass;

struct _MusicFastGridPrivate {
	GtkCellRenderer* cell_renderer;
	MusicFastGridModel* fm;
	GeeHashMap* table;
	GeeHashMap* showing;
};

static gint MusicFastGrid_private_offset;
static gpointer music_fast_grid_parent_class = NULL;

static void music_fast_grid_resort (MusicFastGrid* self);
static void music_fast_grid_quicksort (MusicFastGrid* self,
                                gint start,
                                gint end);
static void music_fast_grid_swap (MusicFastGrid* self,
                           gint a,
                           gint b);
static void music_fast_grid_real_size_allocate (GtkWidget* base,
                                         GtkAllocation* alloc);
static GObject * music_fast_grid_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
VALA_EXTERN MusicWidgetsTileRenderer* music_widgets_tile_renderer_new (void);
VALA_EXTERN MusicWidgetsTileRenderer* music_widgets_tile_renderer_construct (GType object_type);
VALA_EXTERN GType music_widgets_tile_renderer_get_type (void) G_GNUC_CONST ;
static void music_fast_grid_finalize (GObject * obj);
static GType music_fast_grid_get_type_once (void);

static inline gpointer
music_fast_grid_get_instance_private (MusicFastGrid* self)
{
	return G_STRUCT_MEMBER_P (self, MusicFastGrid_private_offset);
}

/** Should not be manipulated by client */
GeeMap*
music_fast_grid_get_table (MusicFastGrid* self)
{
	GeeHashMap* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
	GeeMap* result;
#line 65 "../src/Widgets/FastView/FastGrid.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->table;
#line 66 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = gee_abstract_map_get_read_only_view ((GeeAbstractMap*) _tmp0_);
#line 66 "../src/Widgets/FastView/FastGrid.vala"
	_tmp2_ = _tmp1_;
#line 66 "../src/Widgets/FastView/FastGrid.vala"
	result = _tmp2_;
#line 66 "../src/Widgets/FastView/FastGrid.vala"
	return result;
#line 113 "FastGrid.c"
}

/** Should not be manipulated by client */
GeeMap*
music_fast_grid_get_visible_table (MusicFastGrid* self)
{
	GeeHashMap* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
	GeeMap* result;
#line 70 "../src/Widgets/FastView/FastGrid.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->showing;
#line 71 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = gee_abstract_map_get_read_only_view ((GeeAbstractMap*) _tmp0_);
#line 71 "../src/Widgets/FastView/FastGrid.vala"
	_tmp2_ = _tmp1_;
#line 71 "../src/Widgets/FastView/FastGrid.vala"
	result = _tmp2_;
#line 71 "../src/Widgets/FastView/FastGrid.vala"
	return result;
#line 136 "FastGrid.c"
}

GObject*
music_fast_grid_get_object_from_index (MusicFastGrid* self,
                                       gint index)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GObject* result;
#line 74 "../src/Widgets/FastView/FastGrid.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->showing;
#line 75 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) index));
#line 75 "../src/Widgets/FastView/FastGrid.vala"
	result = (GObject*) _tmp1_;
#line 75 "../src/Widgets/FastView/FastGrid.vala"
	return result;
#line 156 "FastGrid.c"
}

void
music_fast_grid_set_table (MusicFastGrid* self,
                           GeeHashMap* new_table,
                           gboolean do_resort)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 78 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (new_table != NULL);
#line 79 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->table;
#line 79 "../src/Widgets/FastView/FastGrid.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 80 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = self->priv->table;
#line 80 "../src/Widgets/FastView/FastGrid.vala"
	gee_map_set_all ((GeeMap*) _tmp1_, (GeeMap*) new_table);
#line 82 "../src/Widgets/FastView/FastGrid.vala"
	if (do_resort) {
#line 83 "../src/Widgets/FastView/FastGrid.vala"
		music_fast_grid_resort (self);
#line 182 "FastGrid.c"
	} else {
#line 85 "../src/Widgets/FastView/FastGrid.vala"
		music_fast_grid_do_search (self);
#line 186 "FastGrid.c"
	}
}

void
music_fast_grid_remove_objects (MusicFastGrid* self,
                                GeeCollection* objects)
{
	GeeHashMap* to_remove = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp20_;
	GeeHashMap* _tmp21_;
#line 90 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (self != NULL);
#line 90 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (objects != NULL);
#line 91 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 91 "../src/Widgets/FastView/FastGrid.vala"
	to_remove = _tmp0_;
#line 206 "FastGrid.c"
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_tmp1_ = self->priv->table;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_tmp2_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp1_);
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_tmp3_ = _tmp2_;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_tmp4_ = _tmp3_;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_tmp6_ = _tmp5_;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_g_object_unref0 (_tmp4_);
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_entry_it = _tmp6_;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		while (TRUE) {
#line 233 "FastGrid.c"
			GeeIterator* _tmp7_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GeeMapEntry* _tmp10_;
			gconstpointer _tmp11_;
			gconstpointer _tmp12_;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
			_tmp7_ = _entry_it;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 92 "../src/Widgets/FastView/FastGrid.vala"
				break;
#line 247 "FastGrid.c"
			}
#line 92 "../src/Widgets/FastView/FastGrid.vala"
			_tmp8_ = _entry_it;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 92 "../src/Widgets/FastView/FastGrid.vala"
			entry = (GeeMapEntry*) _tmp9_;
#line 93 "../src/Widgets/FastView/FastGrid.vala"
			_tmp10_ = entry;
#line 93 "../src/Widgets/FastView/FastGrid.vala"
			_tmp11_ = gee_map_entry_get_value (_tmp10_);
#line 93 "../src/Widgets/FastView/FastGrid.vala"
			_tmp12_ = _tmp11_;
#line 93 "../src/Widgets/FastView/FastGrid.vala"
			if (gee_collection_contains (objects, (GObject*) _tmp12_)) {
#line 263 "FastGrid.c"
				GeeHashMap* _tmp13_;
				GeeMapEntry* _tmp14_;
				gconstpointer _tmp15_;
				gconstpointer _tmp16_;
				GeeMapEntry* _tmp17_;
				gconstpointer _tmp18_;
				gconstpointer _tmp19_;
#line 94 "../src/Widgets/FastView/FastGrid.vala"
				_tmp13_ = to_remove;
#line 94 "../src/Widgets/FastView/FastGrid.vala"
				_tmp14_ = entry;
#line 94 "../src/Widgets/FastView/FastGrid.vala"
				_tmp15_ = gee_map_entry_get_key (_tmp14_);
#line 94 "../src/Widgets/FastView/FastGrid.vala"
				_tmp16_ = _tmp15_;
#line 94 "../src/Widgets/FastView/FastGrid.vala"
				_tmp17_ = entry;
#line 94 "../src/Widgets/FastView/FastGrid.vala"
				_tmp18_ = gee_map_entry_get_value (_tmp17_);
#line 94 "../src/Widgets/FastView/FastGrid.vala"
				_tmp19_ = _tmp18_;
#line 94 "../src/Widgets/FastView/FastGrid.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, (gpointer) ((gintptr) _tmp16_), (GObject*) _tmp19_);
#line 287 "FastGrid.c"
			}
#line 92 "../src/Widgets/FastView/FastGrid.vala"
			_g_object_unref0 (entry);
#line 291 "FastGrid.c"
		}
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_g_object_unref0 (_entry_it);
#line 295 "FastGrid.c"
	}
#line 98 "../src/Widgets/FastView/FastGrid.vala"
	_tmp20_ = self->priv->table;
#line 98 "../src/Widgets/FastView/FastGrid.vala"
	_tmp21_ = to_remove;
#line 98 "../src/Widgets/FastView/FastGrid.vala"
	gee_map_unset_all ((GeeMap*) _tmp20_, (GeeMap*) _tmp21_);
#line 100 "../src/Widgets/FastView/FastGrid.vala"
	music_fast_grid_do_search (self);
#line 90 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (to_remove);
#line 307 "FastGrid.c"
}

void
music_fast_grid_add_objects (MusicFastGrid* self,
                             GeeCollection* objects)
{
#line 104 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (self != NULL);
#line 104 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (objects != NULL);
#line 318 "FastGrid.c"
	{
		GeeIterator* _o_it = NULL;
		GeeIterator* _tmp0_;
#line 106 "../src/Widgets/FastView/FastGrid.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) objects);
#line 106 "../src/Widgets/FastView/FastGrid.vala"
		_o_it = _tmp0_;
#line 106 "../src/Widgets/FastView/FastGrid.vala"
		while (TRUE) {
#line 328 "FastGrid.c"
			GeeIterator* _tmp1_;
			GObject* o = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GeeHashMap* _tmp4_;
			GeeHashMap* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			GObject* _tmp8_;
#line 106 "../src/Widgets/FastView/FastGrid.vala"
			_tmp1_ = _o_it;
#line 106 "../src/Widgets/FastView/FastGrid.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 106 "../src/Widgets/FastView/FastGrid.vala"
				break;
#line 344 "FastGrid.c"
			}
#line 106 "../src/Widgets/FastView/FastGrid.vala"
			_tmp2_ = _o_it;
#line 106 "../src/Widgets/FastView/FastGrid.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 106 "../src/Widgets/FastView/FastGrid.vala"
			o = (GObject*) _tmp3_;
#line 107 "../src/Widgets/FastView/FastGrid.vala"
			_tmp4_ = self->priv->table;
#line 107 "../src/Widgets/FastView/FastGrid.vala"
			_tmp5_ = self->priv->table;
#line 107 "../src/Widgets/FastView/FastGrid.vala"
			_tmp6_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp5_);
#line 107 "../src/Widgets/FastView/FastGrid.vala"
			_tmp7_ = _tmp6_;
#line 107 "../src/Widgets/FastView/FastGrid.vala"
			_tmp8_ = o;
#line 107 "../src/Widgets/FastView/FastGrid.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, (gpointer) ((gintptr) _tmp7_), _tmp8_);
#line 106 "../src/Widgets/FastView/FastGrid.vala"
			_g_object_unref0 (o);
#line 366 "FastGrid.c"
		}
#line 106 "../src/Widgets/FastView/FastGrid.vala"
		_g_object_unref0 (_o_it);
#line 370 "FastGrid.c"
	}
#line 111 "../src/Widgets/FastView/FastGrid.vala"
	music_fast_grid_resort (self);
#line 374 "FastGrid.c"
}

void
music_fast_grid_do_search (MusicFastGrid* self)
{
	gboolean _tmp0_ = FALSE;
	MusicFastGridViewSearchFunc _tmp1_;
	gpointer _tmp1__target;
	gint old_size = 0;
	GeeHashMap* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GeeHashMap* _tmp5_;
	MusicFastGridViewSearchFunc _tmp6_;
	gpointer _tmp6__target;
	GeeHashMap* _tmp7_;
	GeeHashMap* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
#line 114 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = self->search_func;
#line 115 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1__target = self->search_func_target;
#line 115 "../src/Widgets/FastView/FastGrid.vala"
	if (_tmp1_ == NULL) {
#line 115 "../src/Widgets/FastView/FastGrid.vala"
		_tmp0_ = TRUE;
#line 404 "FastGrid.c"
	} else {
#line 115 "../src/Widgets/FastView/FastGrid.vala"
		_tmp0_ = self->research_needed == FALSE;
#line 408 "FastGrid.c"
	}
#line 115 "../src/Widgets/FastView/FastGrid.vala"
	if (_tmp0_) {
#line 116 "../src/Widgets/FastView/FastGrid.vala"
		return;
#line 414 "FastGrid.c"
	}
#line 119 "../src/Widgets/FastView/FastGrid.vala"
	self->research_needed = FALSE;
#line 120 "../src/Widgets/FastView/FastGrid.vala"
	_tmp2_ = self->priv->showing;
#line 120 "../src/Widgets/FastView/FastGrid.vala"
	_tmp3_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp2_);
#line 120 "../src/Widgets/FastView/FastGrid.vala"
	_tmp4_ = _tmp3_;
#line 120 "../src/Widgets/FastView/FastGrid.vala"
	old_size = _tmp4_;
#line 122 "../src/Widgets/FastView/FastGrid.vala"
	_tmp5_ = self->priv->showing;
#line 122 "../src/Widgets/FastView/FastGrid.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp5_);
#line 123 "../src/Widgets/FastView/FastGrid.vala"
	_tmp6_ = self->search_func;
#line 123 "../src/Widgets/FastView/FastGrid.vala"
	_tmp6__target = self->search_func_target;
#line 123 "../src/Widgets/FastView/FastGrid.vala"
	_tmp7_ = self->priv->showing;
#line 123 "../src/Widgets/FastView/FastGrid.vala"
	_tmp6_ (_tmp7_, _tmp6__target);
#line 125 "../src/Widgets/FastView/FastGrid.vala"
	_tmp8_ = self->priv->showing;
#line 125 "../src/Widgets/FastView/FastGrid.vala"
	_tmp9_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp8_);
#line 125 "../src/Widgets/FastView/FastGrid.vala"
	_tmp10_ = _tmp9_;
#line 125 "../src/Widgets/FastView/FastGrid.vala"
	if (_tmp10_ == old_size) {
#line 446 "FastGrid.c"
		MusicFastGridModel* _tmp11_;
		GeeHashMap* _tmp12_;
#line 126 "../src/Widgets/FastView/FastGrid.vala"
		_tmp11_ = self->priv->fm;
#line 126 "../src/Widgets/FastView/FastGrid.vala"
		_tmp12_ = self->priv->showing;
#line 126 "../src/Widgets/FastView/FastGrid.vala"
		music_fast_grid_model_set_table (_tmp11_, _tmp12_);
#line 127 "../src/Widgets/FastView/FastGrid.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 457 "FastGrid.c"
	} else {
#line 128 "../src/Widgets/FastView/FastGrid.vala"
		if (old_size == 0) {
#line 461 "FastGrid.c"
			MusicFastGridModel* _tmp13_;
			GeeHashMap* _tmp14_;
			MusicFastGridModel* _tmp15_;
#line 129 "../src/Widgets/FastView/FastGrid.vala"
			gtk_icon_view_set_model ((GtkIconView*) self, NULL);
#line 130 "../src/Widgets/FastView/FastGrid.vala"
			_tmp13_ = self->priv->fm;
#line 130 "../src/Widgets/FastView/FastGrid.vala"
			_tmp14_ = self->priv->showing;
#line 130 "../src/Widgets/FastView/FastGrid.vala"
			music_fast_grid_model_set_table (_tmp13_, _tmp14_);
#line 131 "../src/Widgets/FastView/FastGrid.vala"
			_tmp15_ = self->priv->fm;
#line 131 "../src/Widgets/FastView/FastGrid.vala"
			gtk_icon_view_set_model ((GtkIconView*) self, (GtkTreeModel*) _tmp15_);
#line 477 "FastGrid.c"
		} else {
			GeeHashMap* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
#line 132 "../src/Widgets/FastView/FastGrid.vala"
			_tmp16_ = self->priv->showing;
#line 132 "../src/Widgets/FastView/FastGrid.vala"
			_tmp17_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp16_);
#line 132 "../src/Widgets/FastView/FastGrid.vala"
			_tmp18_ = _tmp17_;
#line 132 "../src/Widgets/FastView/FastGrid.vala"
			if (old_size > _tmp18_) {
#line 490 "FastGrid.c"
				MusicFastGridModel* _tmp28_;
				GeeHashMap* _tmp29_;
#line 133 "../src/Widgets/FastView/FastGrid.vala"
				while (TRUE) {
#line 495 "FastGrid.c"
					MusicFastGridModel* _tmp19_;
					GeeHashMap* _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
					GtkTreeIter iter = {0};
					MusicFastGridModel* _tmp23_;
					MusicFastGridModel* _tmp24_;
					GtkTreeIter _tmp25_ = {0};
					MusicFastGridModel* _tmp26_;
					GtkTreeIter _tmp27_;
#line 133 "../src/Widgets/FastView/FastGrid.vala"
					_tmp19_ = self->priv->fm;
#line 133 "../src/Widgets/FastView/FastGrid.vala"
					_tmp20_ = self->priv->showing;
#line 133 "../src/Widgets/FastView/FastGrid.vala"
					_tmp21_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp20_);
#line 133 "../src/Widgets/FastView/FastGrid.vala"
					_tmp22_ = _tmp21_;
#line 133 "../src/Widgets/FastView/FastGrid.vala"
					if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp19_, NULL) > _tmp22_)) {
#line 133 "../src/Widgets/FastView/FastGrid.vala"
						break;
#line 518 "FastGrid.c"
					}
#line 135 "../src/Widgets/FastView/FastGrid.vala"
					_tmp23_ = self->priv->fm;
#line 135 "../src/Widgets/FastView/FastGrid.vala"
					_tmp24_ = self->priv->fm;
#line 135 "../src/Widgets/FastView/FastGrid.vala"
					gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp23_, &_tmp25_, NULL, gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp24_, NULL) - 1);
#line 135 "../src/Widgets/FastView/FastGrid.vala"
					iter = _tmp25_;
#line 136 "../src/Widgets/FastView/FastGrid.vala"
					_tmp26_ = self->priv->fm;
#line 136 "../src/Widgets/FastView/FastGrid.vala"
					_tmp27_ = iter;
#line 136 "../src/Widgets/FastView/FastGrid.vala"
					music_fast_grid_model_remove (_tmp26_, &_tmp27_);
#line 534 "FastGrid.c"
				}
#line 139 "../src/Widgets/FastView/FastGrid.vala"
				_tmp28_ = self->priv->fm;
#line 139 "../src/Widgets/FastView/FastGrid.vala"
				_tmp29_ = self->priv->showing;
#line 139 "../src/Widgets/FastView/FastGrid.vala"
				music_fast_grid_model_set_table (_tmp28_, _tmp29_);
#line 140 "../src/Widgets/FastView/FastGrid.vala"
				gtk_widget_queue_draw ((GtkWidget*) self);
#line 544 "FastGrid.c"
			} else {
				GeeHashMap* _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
#line 141 "../src/Widgets/FastView/FastGrid.vala"
				_tmp30_ = self->priv->showing;
#line 141 "../src/Widgets/FastView/FastGrid.vala"
				_tmp31_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp30_);
#line 141 "../src/Widgets/FastView/FastGrid.vala"
				_tmp32_ = _tmp31_;
#line 141 "../src/Widgets/FastView/FastGrid.vala"
				if (_tmp32_ > old_size) {
#line 557 "FastGrid.c"
					GtkTreeIter iter = {0};
					MusicFastGridModel* _tmp39_;
					GeeHashMap* _tmp40_;
#line 144 "../src/Widgets/FastView/FastGrid.vala"
					while (TRUE) {
#line 563 "FastGrid.c"
						MusicFastGridModel* _tmp33_;
						GeeHashMap* _tmp34_;
						gint _tmp35_;
						gint _tmp36_;
						MusicFastGridModel* _tmp37_;
						GtkTreeIter _tmp38_ = {0};
#line 144 "../src/Widgets/FastView/FastGrid.vala"
						_tmp33_ = self->priv->fm;
#line 144 "../src/Widgets/FastView/FastGrid.vala"
						_tmp34_ = self->priv->showing;
#line 144 "../src/Widgets/FastView/FastGrid.vala"
						_tmp35_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp34_);
#line 144 "../src/Widgets/FastView/FastGrid.vala"
						_tmp36_ = _tmp35_;
#line 144 "../src/Widgets/FastView/FastGrid.vala"
						if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp33_, NULL) < _tmp36_)) {
#line 144 "../src/Widgets/FastView/FastGrid.vala"
							break;
#line 582 "FastGrid.c"
						}
#line 145 "../src/Widgets/FastView/FastGrid.vala"
						_tmp37_ = self->priv->fm;
#line 145 "../src/Widgets/FastView/FastGrid.vala"
						music_fast_grid_model_append (_tmp37_, &_tmp38_);
#line 145 "../src/Widgets/FastView/FastGrid.vala"
						iter = _tmp38_;
#line 590 "FastGrid.c"
					}
#line 148 "../src/Widgets/FastView/FastGrid.vala"
					_tmp39_ = self->priv->fm;
#line 148 "../src/Widgets/FastView/FastGrid.vala"
					_tmp40_ = self->priv->showing;
#line 148 "../src/Widgets/FastView/FastGrid.vala"
					music_fast_grid_model_set_table (_tmp39_, _tmp40_);
#line 149 "../src/Widgets/FastView/FastGrid.vala"
					gtk_widget_queue_draw ((GtkWidget*) self);
#line 600 "FastGrid.c"
				}
			}
		}
	}
}

static void
music_fast_grid_resort (MusicFastGrid* self)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 153 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->table;
#line 154 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 154 "../src/Widgets/FastView/FastGrid.vala"
	_tmp2_ = _tmp1_;
#line 154 "../src/Widgets/FastView/FastGrid.vala"
	music_fast_grid_quicksort (self, 0, _tmp2_ - 1);
#line 155 "../src/Widgets/FastView/FastGrid.vala"
	music_fast_grid_do_search (self);
#line 625 "FastGrid.c"
}

static void
music_fast_grid_swap (MusicFastGrid* self,
                      gint a,
                      gint b)
{
	GObject* temp = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	gpointer _tmp4_;
	GObject* _tmp5_;
	GeeHashMap* _tmp6_;
#line 158 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->table;
#line 159 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) a));
#line 159 "../src/Widgets/FastView/FastGrid.vala"
	temp = (GObject*) _tmp1_;
#line 160 "../src/Widgets/FastView/FastGrid.vala"
	_tmp2_ = self->priv->table;
#line 160 "../src/Widgets/FastView/FastGrid.vala"
	_tmp3_ = self->priv->table;
#line 160 "../src/Widgets/FastView/FastGrid.vala"
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) b));
#line 160 "../src/Widgets/FastView/FastGrid.vala"
	_tmp5_ = (GObject*) _tmp4_;
#line 160 "../src/Widgets/FastView/FastGrid.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) a), _tmp5_);
#line 160 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (_tmp5_);
#line 161 "../src/Widgets/FastView/FastGrid.vala"
	_tmp6_ = self->priv->table;
#line 161 "../src/Widgets/FastView/FastGrid.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, (gpointer) ((gintptr) b), temp);
#line 158 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (temp);
#line 667 "FastGrid.c"
}

static void
music_fast_grid_quicksort (MusicFastGrid* self,
                           gint start,
                           gint end)
{
	GObject* pivot = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	gint i = 0;
	gint j = 0;
#line 164 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (self != NULL);
#line 165 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->table;
#line 165 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) ((start + end) / 2)));
#line 165 "../src/Widgets/FastView/FastGrid.vala"
	pivot = (GObject*) _tmp1_;
#line 166 "../src/Widgets/FastView/FastGrid.vala"
	i = start;
#line 167 "../src/Widgets/FastView/FastGrid.vala"
	j = end;
#line 169 "../src/Widgets/FastView/FastGrid.vala"
	while (TRUE) {
#line 169 "../src/Widgets/FastView/FastGrid.vala"
		if (!(i <= j)) {
#line 169 "../src/Widgets/FastView/FastGrid.vala"
			break;
#line 698 "FastGrid.c"
		}
#line 170 "../src/Widgets/FastView/FastGrid.vala"
		while (TRUE) {
#line 702 "FastGrid.c"
			gboolean _tmp2_ = FALSE;
			gint _tmp8_;
#line 170 "../src/Widgets/FastView/FastGrid.vala"
			if (i < end) {
#line 707 "FastGrid.c"
				MusicFastGridSortCompareFunc _tmp3_;
				gpointer _tmp3__target;
				GeeHashMap* _tmp4_;
				gpointer _tmp5_;
				GObject* _tmp6_;
				GObject* _tmp7_;
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_tmp3_ = self->compare_func;
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_tmp3__target = self->compare_func_target;
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_tmp4_ = self->priv->table;
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, (gpointer) ((gintptr) i));
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_tmp6_ = (GObject*) _tmp5_;
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_tmp7_ = pivot;
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_tmp2_ = _tmp3_ (_tmp6_, _tmp7_, _tmp3__target) < 0;
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_g_object_unref0 (_tmp6_);
#line 730 "FastGrid.c"
			} else {
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_tmp2_ = FALSE;
#line 734 "FastGrid.c"
			}
#line 170 "../src/Widgets/FastView/FastGrid.vala"
			if (!_tmp2_) {
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				break;
#line 740 "FastGrid.c"
			}
#line 170 "../src/Widgets/FastView/FastGrid.vala"
			i = i + 1;
#line 170 "../src/Widgets/FastView/FastGrid.vala"
			_tmp8_ = i;
#line 746 "FastGrid.c"
		}
#line 171 "../src/Widgets/FastView/FastGrid.vala"
		while (TRUE) {
#line 750 "FastGrid.c"
			gboolean _tmp9_ = FALSE;
			gint _tmp15_;
#line 171 "../src/Widgets/FastView/FastGrid.vala"
			if (j > start) {
#line 755 "FastGrid.c"
				MusicFastGridSortCompareFunc _tmp10_;
				gpointer _tmp10__target;
				GeeHashMap* _tmp11_;
				gpointer _tmp12_;
				GObject* _tmp13_;
				GObject* _tmp14_;
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_tmp10_ = self->compare_func;
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_tmp10__target = self->compare_func_target;
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_tmp11_ = self->priv->table;
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, (gpointer) ((gintptr) j));
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_tmp13_ = (GObject*) _tmp12_;
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_tmp14_ = pivot;
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_tmp9_ = _tmp10_ (_tmp13_, _tmp14_, _tmp10__target) > 0;
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_g_object_unref0 (_tmp13_);
#line 778 "FastGrid.c"
			} else {
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_tmp9_ = FALSE;
#line 782 "FastGrid.c"
			}
#line 171 "../src/Widgets/FastView/FastGrid.vala"
			if (!_tmp9_) {
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				break;
#line 788 "FastGrid.c"
			}
#line 171 "../src/Widgets/FastView/FastGrid.vala"
			j = j - 1;
#line 171 "../src/Widgets/FastView/FastGrid.vala"
			_tmp15_ = j;
#line 794 "FastGrid.c"
		}
#line 173 "../src/Widgets/FastView/FastGrid.vala"
		if (i <= j) {
#line 798 "FastGrid.c"
			gint _tmp16_;
			gint _tmp17_;
#line 174 "../src/Widgets/FastView/FastGrid.vala"
			music_fast_grid_swap (self, i, j);
#line 175 "../src/Widgets/FastView/FastGrid.vala"
			i = i + 1;
#line 175 "../src/Widgets/FastView/FastGrid.vala"
			_tmp16_ = i;
#line 175 "../src/Widgets/FastView/FastGrid.vala"
			j = j - 1;
#line 175 "../src/Widgets/FastView/FastGrid.vala"
			_tmp17_ = j;
#line 811 "FastGrid.c"
		}
	}
#line 179 "../src/Widgets/FastView/FastGrid.vala"
	if (start < j) {
#line 180 "../src/Widgets/FastView/FastGrid.vala"
		music_fast_grid_quicksort (self, start, j);
#line 818 "FastGrid.c"
	}
#line 182 "../src/Widgets/FastView/FastGrid.vala"
	if (i < end) {
#line 183 "../src/Widgets/FastView/FastGrid.vala"
		music_fast_grid_quicksort (self, i, end);
#line 824 "FastGrid.c"
	}
#line 164 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (pivot);
#line 828 "FastGrid.c"
}

static void
music_fast_grid_real_size_allocate (GtkWidget* base,
                                    GtkAllocation* alloc)
{
	MusicFastGrid * self;
	GtkRequisition minimum_size = {0};
	GtkRequisition natural_size = {0};
	GtkCellRenderer* _tmp0_;
	GtkRequisition _tmp1_ = {0};
	GtkRequisition _tmp2_ = {0};
	gint item_width = 0;
	GtkRequisition _tmp3_;
	gint total_width = 0;
	GtkAllocation _tmp5_;
	gdouble num = 0.0;
	gint _tmp6_;
	gint _tmp7_;
	gdouble denom = 0.0;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	GtkAllocation _tmp14_;
#line 187 "../src/Widgets/FastView/FastGrid.vala"
	self = (MusicFastGrid*) base;
#line 187 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (alloc != NULL);
#line 190 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->cell_renderer;
#line 190 "../src/Widgets/FastView/FastGrid.vala"
	gtk_cell_renderer_get_preferred_size (_tmp0_, (GtkWidget*) self, &_tmp1_, &_tmp2_);
#line 190 "../src/Widgets/FastView/FastGrid.vala"
	minimum_size = _tmp1_;
#line 190 "../src/Widgets/FastView/FastGrid.vala"
	natural_size = _tmp2_;
#line 191 "../src/Widgets/FastView/FastGrid.vala"
	_tmp3_ = minimum_size;
#line 191 "../src/Widgets/FastView/FastGrid.vala"
	item_width = _tmp3_.width;
#line 193 "../src/Widgets/FastView/FastGrid.vala"
	if (item_width <= 0) {
#line 874 "FastGrid.c"
		GtkAllocation _tmp4_;
#line 194 "../src/Widgets/FastView/FastGrid.vala"
		_tmp4_ = *alloc;
#line 194 "../src/Widgets/FastView/FastGrid.vala"
		GTK_WIDGET_CLASS (music_fast_grid_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_icon_view_get_type (), GtkIconView), &_tmp4_);
#line 880 "FastGrid.c"
	}
#line 197 "../src/Widgets/FastView/FastGrid.vala"
	_tmp5_ = *alloc;
#line 197 "../src/Widgets/FastView/FastGrid.vala"
	total_width = _tmp5_.width;
#line 200 "../src/Widgets/FastView/FastGrid.vala"
	_tmp6_ = gtk_icon_view_get_margin ((GtkIconView*) self);
#line 200 "../src/Widgets/FastView/FastGrid.vala"
	_tmp7_ = _tmp6_;
#line 200 "../src/Widgets/FastView/FastGrid.vala"
	num = (gdouble) (total_width - (2 * _tmp7_));
#line 201 "../src/Widgets/FastView/FastGrid.vala"
	denom = (gdouble) item_width;
#line 202 "../src/Widgets/FastView/FastGrid.vala"
	gtk_icon_view_set_columns ((GtkIconView*) self, (gint) (num / denom));
#line 205 "../src/Widgets/FastView/FastGrid.vala"
	_tmp8_ = gtk_icon_view_get_columns ((GtkIconView*) self);
#line 205 "../src/Widgets/FastView/FastGrid.vala"
	_tmp9_ = _tmp8_;
#line 205 "../src/Widgets/FastView/FastGrid.vala"
	_tmp10_ = gtk_icon_view_get_margin ((GtkIconView*) self);
#line 205 "../src/Widgets/FastView/FastGrid.vala"
	_tmp11_ = _tmp10_;
#line 205 "../src/Widgets/FastView/FastGrid.vala"
	num = (gdouble) ((total_width - (_tmp9_ * item_width)) - (2 * _tmp11_));
#line 206 "../src/Widgets/FastView/FastGrid.vala"
	_tmp12_ = gtk_icon_view_get_columns ((GtkIconView*) self);
#line 206 "../src/Widgets/FastView/FastGrid.vala"
	_tmp13_ = _tmp12_;
#line 206 "../src/Widgets/FastView/FastGrid.vala"
	denom = (gdouble) (_tmp13_ - 1);
#line 207 "../src/Widgets/FastView/FastGrid.vala"
	gtk_icon_view_set_column_spacing ((GtkIconView*) self, (gint) (num / denom));
#line 209 "../src/Widgets/FastView/FastGrid.vala"
	_tmp14_ = *alloc;
#line 209 "../src/Widgets/FastView/FastGrid.vala"
	GTK_WIDGET_CLASS (music_fast_grid_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_icon_view_get_type (), GtkIconView), &_tmp14_);
#line 918 "FastGrid.c"
}

MusicFastGrid*
music_fast_grid_construct (GType object_type)
{
	MusicFastGrid * self = NULL;
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	self = (MusicFastGrid*) g_object_new (object_type, NULL);
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	return self;
#line 929 "FastGrid.c"
}

MusicFastGrid*
music_fast_grid_new (void)
{
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	return music_fast_grid_construct (MUSIC_TYPE_FAST_GRID);
#line 937 "FastGrid.c"
}

static GObject *
music_fast_grid_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicFastGrid * self;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	MusicFastGridModel* _tmp2_;
	GeeHashMap* _tmp3_;
	MusicFastGridModel* _tmp4_;
	MusicWidgetsTileRenderer* _tmp5_;
	GtkCellRenderer* _tmp6_;
	GtkCellRenderer* _tmp7_;
#line 43 "../src/Widgets/FastView/FastGrid.vala"
	parent_class = G_OBJECT_CLASS (music_fast_grid_parent_class);
#line 43 "../src/Widgets/FastView/FastGrid.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 43 "../src/Widgets/FastView/FastGrid.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_FAST_GRID, MusicFastGrid);
#line 44 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 44 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (self->priv->table);
#line 44 "../src/Widgets/FastView/FastGrid.vala"
	self->priv->table = _tmp0_;
#line 45 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 45 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (self->priv->showing);
#line 45 "../src/Widgets/FastView/FastGrid.vala"
	self->priv->showing = _tmp1_;
#line 46 "../src/Widgets/FastView/FastGrid.vala"
	_tmp2_ = music_fast_grid_model_new ();
#line 46 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (self->priv->fm);
#line 46 "../src/Widgets/FastView/FastGrid.vala"
	self->priv->fm = _tmp2_;
#line 48 "../src/Widgets/FastView/FastGrid.vala"
	_tmp3_ = self->priv->table;
#line 48 "../src/Widgets/FastView/FastGrid.vala"
	music_fast_grid_set_table (self, _tmp3_, TRUE);
#line 49 "../src/Widgets/FastView/FastGrid.vala"
	_tmp4_ = self->priv->fm;
#line 49 "../src/Widgets/FastView/FastGrid.vala"
	gtk_icon_view_set_model ((GtkIconView*) self, (GtkTreeModel*) _tmp4_);
#line 51 "../src/Widgets/FastView/FastGrid.vala"
	_tmp5_ = music_widgets_tile_renderer_new ();
#line 51 "../src/Widgets/FastView/FastGrid.vala"
	g_object_ref_sink (_tmp5_);
#line 51 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (self->priv->cell_renderer);
#line 51 "../src/Widgets/FastView/FastGrid.vala"
	self->priv->cell_renderer = (GtkCellRenderer*) _tmp5_;
#line 52 "../src/Widgets/FastView/FastGrid.vala"
	_tmp6_ = self->priv->cell_renderer;
#line 52 "../src/Widgets/FastView/FastGrid.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) self, _tmp6_, FALSE);
#line 53 "../src/Widgets/FastView/FastGrid.vala"
	gtk_icon_view_set_activate_on_single_click ((GtkIconView*) self, FALSE);
#line 54 "../src/Widgets/FastView/FastGrid.vala"
	_tmp7_ = self->priv->cell_renderer;
#line 54 "../src/Widgets/FastView/FastGrid.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) self, _tmp7_, "album", 0);
#line 55 "../src/Widgets/FastView/FastGrid.vala"
	gtk_icon_view_set_tooltip_column ((GtkIconView*) self, 1);
#line 58 "../src/Widgets/FastView/FastGrid.vala"
	gtk_icon_view_set_item_padding ((GtkIconView*) self, 0);
#line 61 "../src/Widgets/FastView/FastGrid.vala"
	gtk_icon_view_set_margin ((GtkIconView*) self, 24);
#line 43 "../src/Widgets/FastView/FastGrid.vala"
	return obj;
#line 1014 "FastGrid.c"
}

static void
music_fast_grid_class_init (MusicFastGridClass * klass,
                            gpointer klass_data)
{
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	music_fast_grid_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	g_type_class_adjust_private_offset (klass, &MusicFastGrid_private_offset);
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, GtkAllocation*)) music_fast_grid_real_size_allocate;
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	G_OBJECT_CLASS (klass)->constructor = music_fast_grid_constructor;
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	G_OBJECT_CLASS (klass)->finalize = music_fast_grid_finalize;
#line 1031 "FastGrid.c"
}

static void
music_fast_grid_instance_init (MusicFastGrid * self,
                               gpointer klass)
{
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	self->priv = music_fast_grid_get_instance_private (self);
#line 31 "../src/Widgets/FastView/FastGrid.vala"
	self->search_func = NULL;
#line 31 "../src/Widgets/FastView/FastGrid.vala"
	self->search_func_target = NULL;
#line 34 "../src/Widgets/FastView/FastGrid.vala"
	self->compare_func = NULL;
#line 34 "../src/Widgets/FastView/FastGrid.vala"
	self->compare_func_target = NULL;
#line 36 "../src/Widgets/FastView/FastGrid.vala"
	self->research_needed = FALSE;
#line 1050 "FastGrid.c"
}

static void
music_fast_grid_finalize (GObject * obj)
{
	MusicFastGrid * self;
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_FAST_GRID, MusicFastGrid);
#line 38 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (self->priv->cell_renderer);
#line 39 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (self->priv->fm);
#line 40 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (self->priv->table);
#line 41 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (self->priv->showing);
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	G_OBJECT_CLASS (music_fast_grid_parent_class)->finalize (obj);
#line 1069 "FastGrid.c"
}

static GType
music_fast_grid_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicFastGridClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_fast_grid_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicFastGrid), 0, (GInstanceInitFunc) music_fast_grid_instance_init, NULL };
	GType music_fast_grid_type_id;
	music_fast_grid_type_id = g_type_register_static (gtk_icon_view_get_type (), "MusicFastGrid", &g_define_type_info, 0);
	MusicFastGrid_private_offset = g_type_add_instance_private (music_fast_grid_type_id, sizeof (MusicFastGridPrivate));
	return music_fast_grid_type_id;
}

GType
music_fast_grid_get_type (void)
{
	static volatile gsize music_fast_grid_type_id__once = 0;
	if (g_once_init_enter (&music_fast_grid_type_id__once)) {
		GType music_fast_grid_type_id;
		music_fast_grid_type_id = music_fast_grid_get_type_once ();
		g_once_init_leave (&music_fast_grid_type_id__once, music_fast_grid_type_id);
	}
	return music_fast_grid_type_id__once;
}

