/* PresetList.c generated by valac 0.56.0, the Vala compiler
 * generated from PresetList.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */

#include "music-lib.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <pango/pango.h>
#include "io.elementary.music-core.h"
#include <gee.h>

#define MUSIC_PRESET_LIST_SEPARATOR_NAME "<separator_item_unique_name>"

enum  {
	MUSIC_PRESET_LIST_0_PROPERTY,
	MUSIC_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY,
	MUSIC_PRESET_LIST_NUM_PROPERTIES
};
static GParamSpec* music_preset_list_properties[MUSIC_PRESET_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	MUSIC_PRESET_LIST_PRESET_SELECTED_SIGNAL,
	MUSIC_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL,
	MUSIC_PRESET_LIST_DELETE_PRESET_CHOSEN_SIGNAL,
	MUSIC_PRESET_LIST_NUM_SIGNALS
};
static guint music_preset_list_signals[MUSIC_PRESET_LIST_NUM_SIGNALS] = {0};

struct _MusicPresetListPrivate {
	gint _ncustompresets;
	gboolean modifying_list;
	gboolean automatic_selected;
	GtkListStore* store;
};

static gint MusicPresetList_private_offset;
static gpointer music_preset_list_parent_class = NULL;
static gchar* music_preset_list_automatic_mode;
static gchar* music_preset_list_automatic_mode = NULL;
static gchar* music_preset_list_delete_preset;
static gchar* music_preset_list_delete_preset = NULL;

static void music_preset_list_set_ncustompresets (MusicPresetList* self,
                                           gint value);
static gboolean __lambda20_ (MusicPresetList* self,
                      GtkTreeModel* model,
                      GtkTreeIter* iter);
static gboolean ___lambda20__gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                                        GtkTreeIter* iter,
                                                        gpointer self);
static void _music_preset_list_list_selection_change_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                     gpointer self);
static gint music_preset_list_get_ncustompresets (MusicPresetList* self);
static void music_preset_list_remove_separator_item (MusicPresetList* self,
                                              gint index);
static void music_preset_list_real_list_selection_change (MusicPresetList* self);
static void music_preset_list_add_delete_preset_option (MusicPresetList* self);
static void music_preset_list_remove_delete_option (MusicPresetList* self);
static void music_preset_list_finalize (GObject * obj);
static GType music_preset_list_get_type_once (void);
static void _vala_music_preset_list_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_music_preset_list_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
music_preset_list_get_instance_private (MusicPresetList* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPresetList_private_offset);
}

static gboolean
__lambda20_ (MusicPresetList* self,
             GtkTreeModel* model,
             GtkTreeIter* iter)
{
	gchar* content = NULL;
	gchar* _tmp0_;
	GtkTreeIter _tmp1_;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	gboolean result;
#line 65 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 65 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 66 "../src/Widgets/PresetList.vala"
	_tmp0_ = g_strdup ("");
#line 66 "../src/Widgets/PresetList.vala"
	content = _tmp0_;
#line 67 "../src/Widgets/PresetList.vala"
	_tmp1_ = *iter;
#line 67 "../src/Widgets/PresetList.vala"
	gtk_tree_model_get (model, &_tmp1_, 1, &_tmp2_, -1);
#line 67 "../src/Widgets/PresetList.vala"
	_g_free0 (content);
#line 67 "../src/Widgets/PresetList.vala"
	content = _tmp2_;
#line 69 "../src/Widgets/PresetList.vala"
	_tmp3_ = content;
#line 69 "../src/Widgets/PresetList.vala"
	result = g_strcmp0 (_tmp3_, MUSIC_PRESET_LIST_SEPARATOR_NAME) == 0;
#line 69 "../src/Widgets/PresetList.vala"
	_g_free0 (content);
#line 69 "../src/Widgets/PresetList.vala"
	return result;
#line 144 "PresetList.c"
}

static gboolean
___lambda20__gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                               GtkTreeIter* iter,
                                               gpointer self)
{
	gboolean result;
	result = __lambda20_ ((MusicPresetList*) self, model, iter);
#line 65 "../src/Widgets/PresetList.vala"
	return result;
#line 156 "PresetList.c"
}

static void
_music_preset_list_list_selection_change_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                gpointer self)
{
#line 78 "../src/Widgets/PresetList.vala"
	music_preset_list_list_selection_change ((MusicPresetList*) self);
#line 165 "PresetList.c"
}

MusicPresetList*
music_preset_list_construct (GType object_type)
{
	MusicPresetList * self = NULL;
	GtkListStore* _tmp0_;
	GtkListStore* _tmp1_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp2_;
	GtkListStore* _tmp3_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_ = {0};
	GtkListStore* _tmp6_;
	GtkTreeIter _tmp7_;
	const gchar* _tmp8_;
#line 55 "../src/Widgets/PresetList.vala"
	self = (MusicPresetList*) g_object_new (object_type, NULL);
#line 56 "../src/Widgets/PresetList.vala"
	music_preset_list_set_ncustompresets (self, 0);
#line 57 "../src/Widgets/PresetList.vala"
	self->priv->modifying_list = FALSE;
#line 58 "../src/Widgets/PresetList.vala"
	self->priv->automatic_selected = FALSE;
#line 60 "../src/Widgets/PresetList.vala"
	_tmp0_ = gtk_list_store_new (2, G_TYPE_OBJECT, G_TYPE_STRING, -1);
#line 60 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (self->priv->store);
#line 60 "../src/Widgets/PresetList.vala"
	self->priv->store = _tmp0_;
#line 62 "../src/Widgets/PresetList.vala"
	_tmp1_ = self->priv->store;
#line 62 "../src/Widgets/PresetList.vala"
	gtk_combo_box_set_model ((GtkComboBox*) self, (GtkTreeModel*) _tmp1_);
#line 63 "../src/Widgets/PresetList.vala"
	gtk_combo_box_set_id_column ((GtkComboBox*) self, 1);
#line 65 "../src/Widgets/PresetList.vala"
	gtk_combo_box_set_row_separator_func ((GtkComboBox*) self, ___lambda20__gtk_tree_view_row_separator_func, g_object_ref (self), g_object_unref);
#line 72 "../src/Widgets/PresetList.vala"
	_tmp2_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 72 "../src/Widgets/PresetList.vala"
	g_object_ref_sink (_tmp2_);
#line 72 "../src/Widgets/PresetList.vala"
	cell = _tmp2_;
#line 73 "../src/Widgets/PresetList.vala"
	g_object_set (cell, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
#line 75 "../src/Widgets/PresetList.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) self, (GtkCellRenderer*) cell, TRUE);
#line 76 "../src/Widgets/PresetList.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) self, (GtkCellRenderer*) cell, "text", 1);
#line 78 "../src/Widgets/PresetList.vala"
	g_signal_connect_object ((GtkComboBox*) self, "changed", (GCallback) _music_preset_list_list_selection_change_gtk_combo_box_changed, self, 0);
#line 80 "../src/Widgets/PresetList.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 82 "../src/Widgets/PresetList.vala"
	_tmp3_ = self->priv->store;
#line 82 "../src/Widgets/PresetList.vala"
	gtk_list_store_clear (_tmp3_);
#line 85 "../src/Widgets/PresetList.vala"
	_tmp4_ = self->priv->store;
#line 85 "../src/Widgets/PresetList.vala"
	gtk_list_store_append (_tmp4_, &_tmp5_);
#line 85 "../src/Widgets/PresetList.vala"
	iter = _tmp5_;
#line 86 "../src/Widgets/PresetList.vala"
	_tmp6_ = self->priv->store;
#line 86 "../src/Widgets/PresetList.vala"
	_tmp7_ = iter;
#line 86 "../src/Widgets/PresetList.vala"
	_tmp8_ = music_preset_list_automatic_mode;
#line 86 "../src/Widgets/PresetList.vala"
	gtk_list_store_set (_tmp6_, &_tmp7_, 0, NULL, 1, _tmp8_, -1);
#line 88 "../src/Widgets/PresetList.vala"
	music_preset_list_add_separator (self);
#line 55 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (cell);
#line 55 "../src/Widgets/PresetList.vala"
	return self;
#line 245 "PresetList.c"
}

MusicPresetList*
music_preset_list_new (void)
{
#line 55 "../src/Widgets/PresetList.vala"
	return music_preset_list_construct (MUSIC_TYPE_PRESET_LIST);
#line 253 "PresetList.c"
}

void
music_preset_list_add_separator (MusicPresetList* self)
{
	GtkTreeIter iter = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
#line 91 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 93 "../src/Widgets/PresetList.vala"
	_tmp0_ = self->priv->store;
#line 93 "../src/Widgets/PresetList.vala"
	gtk_list_store_append (_tmp0_, &_tmp1_);
#line 93 "../src/Widgets/PresetList.vala"
	iter = _tmp1_;
#line 94 "../src/Widgets/PresetList.vala"
	_tmp2_ = self->priv->store;
#line 94 "../src/Widgets/PresetList.vala"
	_tmp3_ = iter;
#line 94 "../src/Widgets/PresetList.vala"
	gtk_list_store_set (_tmp2_, &_tmp3_, 0, NULL, 1, MUSIC_PRESET_LIST_SEPARATOR_NAME, -1);
#line 278 "PresetList.c"
}

void
music_preset_list_add_preset (MusicPresetList* self,
                              MusicEqualizerPreset* ep)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_ = {0};
	GtkListStore* _tmp6_;
	GtkTreeIter _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GtkTreeIter _tmp10_;
#line 97 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/Widgets/PresetList.vala"
	g_return_if_fail (ep != NULL);
#line 98 "../src/Widgets/PresetList.vala"
	self->priv->modifying_list = TRUE;
#line 100 "../src/Widgets/PresetList.vala"
	_tmp0_ = music_equalizer_preset_get_is_default (ep);
#line 100 "../src/Widgets/PresetList.vala"
	_tmp1_ = _tmp0_;
#line 100 "../src/Widgets/PresetList.vala"
	if (!_tmp1_) {
#line 307 "PresetList.c"
		gint _tmp2_;
		gint _tmp3_;
#line 102 "../src/Widgets/PresetList.vala"
		_tmp2_ = self->priv->_ncustompresets;
#line 102 "../src/Widgets/PresetList.vala"
		if (_tmp2_ < 1) {
#line 103 "../src/Widgets/PresetList.vala"
			music_preset_list_add_separator (self);
#line 316 "PresetList.c"
		}
#line 106 "../src/Widgets/PresetList.vala"
		_tmp3_ = self->priv->_ncustompresets;
#line 106 "../src/Widgets/PresetList.vala"
		music_preset_list_set_ncustompresets (self, _tmp3_ + 1);
#line 322 "PresetList.c"
	}
#line 110 "../src/Widgets/PresetList.vala"
	_tmp4_ = self->priv->store;
#line 110 "../src/Widgets/PresetList.vala"
	gtk_list_store_append (_tmp4_, &_tmp5_);
#line 110 "../src/Widgets/PresetList.vala"
	iter = _tmp5_;
#line 111 "../src/Widgets/PresetList.vala"
	_tmp6_ = self->priv->store;
#line 111 "../src/Widgets/PresetList.vala"
	_tmp7_ = iter;
#line 111 "../src/Widgets/PresetList.vala"
	_tmp8_ = music_equalizer_preset_get_name (ep);
#line 111 "../src/Widgets/PresetList.vala"
	_tmp9_ = _tmp8_;
#line 111 "../src/Widgets/PresetList.vala"
	gtk_list_store_set (_tmp6_, &_tmp7_, 0, ep, 1, _tmp9_, -1);
#line 113 "../src/Widgets/PresetList.vala"
	self->priv->modifying_list = FALSE;
#line 114 "../src/Widgets/PresetList.vala"
	self->priv->automatic_selected = FALSE;
#line 116 "../src/Widgets/PresetList.vala"
	_tmp10_ = iter;
#line 116 "../src/Widgets/PresetList.vala"
	gtk_combo_box_set_active_iter ((GtkComboBox*) self, &_tmp10_);
#line 348 "PresetList.c"
}

void
music_preset_list_remove_current_preset (MusicPresetList* self)
{
	GtkTreeIter iter = {0};
	gint _tmp22_;
#line 119 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/Widgets/PresetList.vala"
	self->priv->modifying_list = TRUE;
#line 360 "PresetList.c"
	{
		gint i = 0;
#line 123 "../src/Widgets/PresetList.vala"
		i = 0;
#line 365 "PresetList.c"
		{
			gboolean _tmp0_ = FALSE;
#line 123 "../src/Widgets/PresetList.vala"
			_tmp0_ = TRUE;
#line 123 "../src/Widgets/PresetList.vala"
			while (TRUE) {
#line 372 "PresetList.c"
				GtkListStore* _tmp2_;
				gchar* _tmp3_;
				gchar* _tmp4_;
				GtkTreeIter _tmp5_ = {0};
				gboolean _tmp6_;
				gboolean _tmp7_;
				GObject* o = NULL;
				GtkListStore* _tmp8_;
				GtkTreeIter _tmp9_;
				GObject* _tmp10_ = NULL;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				GObject* _tmp13_;
#line 123 "../src/Widgets/PresetList.vala"
				if (!_tmp0_) {
#line 388 "PresetList.c"
					gint _tmp1_;
#line 123 "../src/Widgets/PresetList.vala"
					i = i + 1;
#line 123 "../src/Widgets/PresetList.vala"
					_tmp1_ = i;
#line 394 "PresetList.c"
				}
#line 123 "../src/Widgets/PresetList.vala"
				_tmp0_ = FALSE;
#line 123 "../src/Widgets/PresetList.vala"
				_tmp2_ = self->priv->store;
#line 123 "../src/Widgets/PresetList.vala"
				_tmp3_ = g_strdup_printf ("%i", i);
#line 123 "../src/Widgets/PresetList.vala"
				_tmp4_ = _tmp3_;
#line 123 "../src/Widgets/PresetList.vala"
				_tmp6_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp2_, &_tmp5_, _tmp4_);
#line 123 "../src/Widgets/PresetList.vala"
				iter = _tmp5_;
#line 123 "../src/Widgets/PresetList.vala"
				_tmp7_ = !_tmp6_;
#line 123 "../src/Widgets/PresetList.vala"
				_g_free0 (_tmp4_);
#line 123 "../src/Widgets/PresetList.vala"
				if (_tmp7_) {
#line 123 "../src/Widgets/PresetList.vala"
					break;
#line 416 "PresetList.c"
				}
#line 125 "../src/Widgets/PresetList.vala"
				_tmp8_ = self->priv->store;
#line 125 "../src/Widgets/PresetList.vala"
				_tmp9_ = iter;
#line 125 "../src/Widgets/PresetList.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp8_, &_tmp9_, 0, &_tmp10_, -1);
#line 125 "../src/Widgets/PresetList.vala"
				_g_object_unref0 (o);
#line 125 "../src/Widgets/PresetList.vala"
				o = _tmp10_;
#line 127 "../src/Widgets/PresetList.vala"
				_tmp13_ = o;
#line 127 "../src/Widgets/PresetList.vala"
				if (_tmp13_ != NULL) {
#line 432 "PresetList.c"
					GObject* _tmp14_;
#line 127 "../src/Widgets/PresetList.vala"
					_tmp14_ = o;
#line 127 "../src/Widgets/PresetList.vala"
					_tmp12_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, MUSIC_TYPE_EQUALIZER_PRESET);
#line 438 "PresetList.c"
				} else {
#line 127 "../src/Widgets/PresetList.vala"
					_tmp12_ = FALSE;
#line 442 "PresetList.c"
				}
#line 127 "../src/Widgets/PresetList.vala"
				if (_tmp12_) {
#line 446 "PresetList.c"
					GObject* _tmp15_;
					MusicEqualizerPreset* _tmp16_;
#line 127 "../src/Widgets/PresetList.vala"
					_tmp15_ = o;
#line 127 "../src/Widgets/PresetList.vala"
					_tmp16_ = self->last_selected_preset;
#line 127 "../src/Widgets/PresetList.vala"
					_tmp11_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, MUSIC_TYPE_EQUALIZER_PRESET, MusicEqualizerPreset) == _tmp16_;
#line 455 "PresetList.c"
				} else {
#line 127 "../src/Widgets/PresetList.vala"
					_tmp11_ = FALSE;
#line 459 "PresetList.c"
				}
#line 127 "../src/Widgets/PresetList.vala"
				if (_tmp11_) {
#line 463 "PresetList.c"
					GObject* _tmp17_;
					gboolean _tmp18_;
					gboolean _tmp19_;
#line 128 "../src/Widgets/PresetList.vala"
					_tmp17_ = o;
#line 128 "../src/Widgets/PresetList.vala"
					_tmp18_ = music_equalizer_preset_get_is_default (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, MUSIC_TYPE_EQUALIZER_PRESET, MusicEqualizerPreset));
#line 128 "../src/Widgets/PresetList.vala"
					_tmp19_ = _tmp18_;
#line 128 "../src/Widgets/PresetList.vala"
					if (!_tmp19_) {
#line 475 "PresetList.c"
						gint _tmp20_;
						GtkListStore* _tmp21_;
#line 129 "../src/Widgets/PresetList.vala"
						_tmp20_ = self->priv->_ncustompresets;
#line 129 "../src/Widgets/PresetList.vala"
						music_preset_list_set_ncustompresets (self, _tmp20_ - 1);
#line 131 "../src/Widgets/PresetList.vala"
						_tmp21_ = self->priv->store;
#line 131 "../src/Widgets/PresetList.vala"
						gtk_list_store_remove (_tmp21_, &iter);
#line 135 "../src/Widgets/PresetList.vala"
						_g_object_unref0 (o);
#line 135 "../src/Widgets/PresetList.vala"
						break;
#line 490 "PresetList.c"
					}
				}
#line 123 "../src/Widgets/PresetList.vala"
				_g_object_unref0 (o);
#line 495 "PresetList.c"
			}
		}
	}
#line 141 "../src/Widgets/PresetList.vala"
	_tmp22_ = self->priv->_ncustompresets;
#line 141 "../src/Widgets/PresetList.vala"
	if (_tmp22_ < 1) {
#line 142 "../src/Widgets/PresetList.vala"
		music_preset_list_remove_separator_item (self, -1);
#line 505 "PresetList.c"
	}
#line 145 "../src/Widgets/PresetList.vala"
	self->priv->modifying_list = FALSE;
#line 147 "../src/Widgets/PresetList.vala"
	music_preset_list_select_automatic_preset (self);
#line 511 "PresetList.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 162 "../src/Widgets/PresetList.vala"
	return self ? g_object_ref (self) : NULL;
#line 519 "PresetList.c"
}

static void
music_preset_list_real_list_selection_change (MusicPresetList* self)
{
	GtkTreeIter it = {0};
	GtkTreeIter _tmp0_ = {0};
	GObject* o = NULL;
	GtkListStore* _tmp1_;
	GtkTreeIter _tmp2_;
	GObject* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	GObject* _tmp5_;
	gchar* option = NULL;
	GtkListStore* _tmp13_;
	GtkTreeIter _tmp14_;
	gchar* _tmp15_ = NULL;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
#line 151 "../src/Widgets/PresetList.vala"
	if (self->priv->modifying_list) {
#line 152 "../src/Widgets/PresetList.vala"
		return;
#line 543 "PresetList.c"
	}
#line 156 "../src/Widgets/PresetList.vala"
	gtk_combo_box_get_active_iter ((GtkComboBox*) self, &_tmp0_);
#line 156 "../src/Widgets/PresetList.vala"
	it = _tmp0_;
#line 159 "../src/Widgets/PresetList.vala"
	_tmp1_ = self->priv->store;
#line 159 "../src/Widgets/PresetList.vala"
	_tmp2_ = it;
#line 159 "../src/Widgets/PresetList.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp1_, &_tmp2_, 0, &_tmp3_, -1);
#line 159 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (o);
#line 159 "../src/Widgets/PresetList.vala"
	o = _tmp3_;
#line 161 "../src/Widgets/PresetList.vala"
	_tmp5_ = o;
#line 161 "../src/Widgets/PresetList.vala"
	if (_tmp5_ != NULL) {
#line 563 "PresetList.c"
		GObject* _tmp6_;
#line 161 "../src/Widgets/PresetList.vala"
		_tmp6_ = o;
#line 161 "../src/Widgets/PresetList.vala"
		_tmp4_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, MUSIC_TYPE_EQUALIZER_PRESET);
#line 569 "PresetList.c"
	} else {
#line 161 "../src/Widgets/PresetList.vala"
		_tmp4_ = FALSE;
#line 573 "PresetList.c"
	}
#line 161 "../src/Widgets/PresetList.vala"
	if (_tmp4_) {
#line 577 "PresetList.c"
		GObject* _tmp7_;
		MusicEqualizerPreset* _tmp8_;
		GObject* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
		GObject* _tmp12_;
#line 162 "../src/Widgets/PresetList.vala"
		_tmp7_ = o;
#line 162 "../src/Widgets/PresetList.vala"
		_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, MUSIC_TYPE_EQUALIZER_PRESET) ? ((MusicEqualizerPreset*) _tmp7_) : NULL);
#line 162 "../src/Widgets/PresetList.vala"
		_g_object_unref0 (self->last_selected_preset);
#line 162 "../src/Widgets/PresetList.vala"
		self->last_selected_preset = _tmp8_;
#line 164 "../src/Widgets/PresetList.vala"
		_tmp9_ = o;
#line 164 "../src/Widgets/PresetList.vala"
		_tmp10_ = music_equalizer_preset_get_is_default (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, MUSIC_TYPE_EQUALIZER_PRESET, MusicEqualizerPreset));
#line 164 "../src/Widgets/PresetList.vala"
		_tmp11_ = _tmp10_;
#line 164 "../src/Widgets/PresetList.vala"
		if (!_tmp11_) {
#line 165 "../src/Widgets/PresetList.vala"
			music_preset_list_add_delete_preset_option (self);
#line 602 "PresetList.c"
		} else {
#line 167 "../src/Widgets/PresetList.vala"
			music_preset_list_remove_delete_option (self);
#line 606 "PresetList.c"
		}
#line 170 "../src/Widgets/PresetList.vala"
		self->priv->automatic_selected = FALSE;
#line 171 "../src/Widgets/PresetList.vala"
		_tmp12_ = o;
#line 171 "../src/Widgets/PresetList.vala"
		g_signal_emit (self, music_preset_list_signals[MUSIC_PRESET_LIST_PRESET_SELECTED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, MUSIC_TYPE_EQUALIZER_PRESET) ? ((MusicEqualizerPreset*) _tmp12_) : NULL);
#line 172 "../src/Widgets/PresetList.vala"
		_g_object_unref0 (o);
#line 172 "../src/Widgets/PresetList.vala"
		return;
#line 618 "PresetList.c"
	}
#line 176 "../src/Widgets/PresetList.vala"
	_tmp13_ = self->priv->store;
#line 176 "../src/Widgets/PresetList.vala"
	_tmp14_ = it;
#line 176 "../src/Widgets/PresetList.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp13_, &_tmp14_, 1, &_tmp15_, -1);
#line 176 "../src/Widgets/PresetList.vala"
	_g_free0 (option);
#line 176 "../src/Widgets/PresetList.vala"
	option = _tmp15_;
#line 178 "../src/Widgets/PresetList.vala"
	_tmp16_ = option;
#line 178 "../src/Widgets/PresetList.vala"
	_tmp17_ = music_preset_list_automatic_mode;
#line 178 "../src/Widgets/PresetList.vala"
	if (g_strcmp0 (_tmp16_, _tmp17_) == 0) {
#line 179 "../src/Widgets/PresetList.vala"
		self->priv->automatic_selected = TRUE;
#line 180 "../src/Widgets/PresetList.vala"
		music_preset_list_remove_delete_option (self);
#line 181 "../src/Widgets/PresetList.vala"
		g_signal_emit (self, music_preset_list_signals[MUSIC_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL], 0);
#line 642 "PresetList.c"
	} else {
		const gchar* _tmp18_;
		const gchar* _tmp19_;
#line 182 "../src/Widgets/PresetList.vala"
		_tmp18_ = option;
#line 182 "../src/Widgets/PresetList.vala"
		_tmp19_ = music_preset_list_delete_preset;
#line 182 "../src/Widgets/PresetList.vala"
		if (g_strcmp0 (_tmp18_, _tmp19_) == 0) {
#line 183 "../src/Widgets/PresetList.vala"
			g_signal_emit (self, music_preset_list_signals[MUSIC_PRESET_LIST_DELETE_PRESET_CHOSEN_SIGNAL], 0);
#line 654 "PresetList.c"
		}
	}
#line 150 "../src/Widgets/PresetList.vala"
	_g_free0 (option);
#line 150 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (o);
#line 661 "PresetList.c"
}

void
music_preset_list_list_selection_change (MusicPresetList* self)
{
	MusicPresetListClass* _klass_;
#line 150 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/Widgets/PresetList.vala"
	_klass_ = MUSIC_PRESET_LIST_GET_CLASS (self);
#line 150 "../src/Widgets/PresetList.vala"
	if (_klass_->list_selection_change) {
#line 150 "../src/Widgets/PresetList.vala"
		_klass_->list_selection_change (self);
#line 676 "PresetList.c"
	}
}

void
music_preset_list_select_automatic_preset (MusicPresetList* self)
{
#line 187 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/Widgets/PresetList.vala"
	self->priv->automatic_selected = TRUE;
#line 189 "../src/Widgets/PresetList.vala"
	g_signal_emit (self, music_preset_list_signals[MUSIC_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL], 0);
#line 190 "../src/Widgets/PresetList.vala"
	gtk_combo_box_set_active ((GtkComboBox*) self, 0);
#line 691 "PresetList.c"
}

void
music_preset_list_select_preset (MusicPresetList* self,
                                 const gchar* preset_name)
{
	gboolean _tmp0_ = FALSE;
#line 193 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 195 "../src/Widgets/PresetList.vala"
	if (preset_name == NULL) {
#line 195 "../src/Widgets/PresetList.vala"
		_tmp0_ = TRUE;
#line 705 "PresetList.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 195 "../src/Widgets/PresetList.vala"
		_tmp1_ = strlen (preset_name);
#line 195 "../src/Widgets/PresetList.vala"
		_tmp2_ = _tmp1_;
#line 195 "../src/Widgets/PresetList.vala"
		_tmp0_ = _tmp2_ < 1;
#line 715 "PresetList.c"
	}
#line 195 "../src/Widgets/PresetList.vala"
	if (!_tmp0_) {
#line 719 "PresetList.c"
		GtkTreeIter iter = {0};
		{
			gint i = 0;
#line 197 "../src/Widgets/PresetList.vala"
			i = 0;
#line 725 "PresetList.c"
			{
				gboolean _tmp3_ = FALSE;
#line 197 "../src/Widgets/PresetList.vala"
				_tmp3_ = TRUE;
#line 197 "../src/Widgets/PresetList.vala"
				while (TRUE) {
#line 732 "PresetList.c"
					GtkListStore* _tmp5_;
					gchar* _tmp6_;
					gchar* _tmp7_;
					GtkTreeIter _tmp8_ = {0};
					gboolean _tmp9_;
					gboolean _tmp10_;
					GObject* o = NULL;
					GtkListStore* _tmp11_;
					GtkTreeIter _tmp12_;
					GObject* _tmp13_ = NULL;
					gboolean _tmp14_ = FALSE;
					gboolean _tmp15_ = FALSE;
					GObject* _tmp16_;
#line 197 "../src/Widgets/PresetList.vala"
					if (!_tmp3_) {
#line 748 "PresetList.c"
						gint _tmp4_;
#line 197 "../src/Widgets/PresetList.vala"
						i = i + 1;
#line 197 "../src/Widgets/PresetList.vala"
						_tmp4_ = i;
#line 754 "PresetList.c"
					}
#line 197 "../src/Widgets/PresetList.vala"
					_tmp3_ = FALSE;
#line 197 "../src/Widgets/PresetList.vala"
					_tmp5_ = self->priv->store;
#line 197 "../src/Widgets/PresetList.vala"
					_tmp6_ = g_strdup_printf ("%i", i);
#line 197 "../src/Widgets/PresetList.vala"
					_tmp7_ = _tmp6_;
#line 197 "../src/Widgets/PresetList.vala"
					_tmp9_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp5_, &_tmp8_, _tmp7_);
#line 197 "../src/Widgets/PresetList.vala"
					iter = _tmp8_;
#line 197 "../src/Widgets/PresetList.vala"
					_tmp10_ = !_tmp9_;
#line 197 "../src/Widgets/PresetList.vala"
					_g_free0 (_tmp7_);
#line 197 "../src/Widgets/PresetList.vala"
					if (_tmp10_) {
#line 197 "../src/Widgets/PresetList.vala"
						break;
#line 776 "PresetList.c"
					}
#line 199 "../src/Widgets/PresetList.vala"
					_tmp11_ = self->priv->store;
#line 199 "../src/Widgets/PresetList.vala"
					_tmp12_ = iter;
#line 199 "../src/Widgets/PresetList.vala"
					gtk_tree_model_get ((GtkTreeModel*) _tmp11_, &_tmp12_, 0, &_tmp13_, -1);
#line 199 "../src/Widgets/PresetList.vala"
					_g_object_unref0 (o);
#line 199 "../src/Widgets/PresetList.vala"
					o = _tmp13_;
#line 201 "../src/Widgets/PresetList.vala"
					_tmp16_ = o;
#line 201 "../src/Widgets/PresetList.vala"
					if (_tmp16_ != NULL) {
#line 792 "PresetList.c"
						GObject* _tmp17_;
#line 201 "../src/Widgets/PresetList.vala"
						_tmp17_ = o;
#line 201 "../src/Widgets/PresetList.vala"
						_tmp15_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, MUSIC_TYPE_EQUALIZER_PRESET);
#line 798 "PresetList.c"
					} else {
#line 201 "../src/Widgets/PresetList.vala"
						_tmp15_ = FALSE;
#line 802 "PresetList.c"
					}
#line 201 "../src/Widgets/PresetList.vala"
					if (_tmp15_) {
#line 806 "PresetList.c"
						GObject* _tmp18_;
						const gchar* _tmp19_;
						const gchar* _tmp20_;
#line 201 "../src/Widgets/PresetList.vala"
						_tmp18_ = o;
#line 201 "../src/Widgets/PresetList.vala"
						_tmp19_ = music_equalizer_preset_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, MUSIC_TYPE_EQUALIZER_PRESET, MusicEqualizerPreset));
#line 201 "../src/Widgets/PresetList.vala"
						_tmp20_ = _tmp19_;
#line 201 "../src/Widgets/PresetList.vala"
						_tmp14_ = g_strcmp0 (_tmp20_, preset_name) == 0;
#line 818 "PresetList.c"
					} else {
#line 201 "../src/Widgets/PresetList.vala"
						_tmp14_ = FALSE;
#line 822 "PresetList.c"
					}
#line 201 "../src/Widgets/PresetList.vala"
					if (_tmp14_) {
#line 826 "PresetList.c"
						GtkTreeIter _tmp21_;
						GObject* _tmp22_;
#line 202 "../src/Widgets/PresetList.vala"
						_tmp21_ = iter;
#line 202 "../src/Widgets/PresetList.vala"
						gtk_combo_box_set_active_iter ((GtkComboBox*) self, &_tmp21_);
#line 203 "../src/Widgets/PresetList.vala"
						self->priv->automatic_selected = FALSE;
#line 204 "../src/Widgets/PresetList.vala"
						_tmp22_ = o;
#line 204 "../src/Widgets/PresetList.vala"
						g_signal_emit (self, music_preset_list_signals[MUSIC_PRESET_LIST_PRESET_SELECTED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_TYPE (_tmp22_, MUSIC_TYPE_EQUALIZER_PRESET) ? ((MusicEqualizerPreset*) _tmp22_) : NULL);
#line 205 "../src/Widgets/PresetList.vala"
						_g_object_unref0 (o);
#line 205 "../src/Widgets/PresetList.vala"
						return;
#line 843 "PresetList.c"
					}
#line 197 "../src/Widgets/PresetList.vala"
					_g_object_unref0 (o);
#line 847 "PresetList.c"
				}
			}
		}
	}
#line 210 "../src/Widgets/PresetList.vala"
	music_preset_list_select_automatic_preset (self);
#line 854 "PresetList.c"
}

MusicEqualizerPreset*
music_preset_list_get_selected_preset (MusicPresetList* self)
{
	GtkTreeIter it = {0};
	GtkTreeIter _tmp0_ = {0};
	GObject* o = NULL;
	GtkListStore* _tmp1_;
	GtkTreeIter _tmp2_;
	GObject* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	GObject* _tmp5_;
	MusicEqualizerPreset* result;
#line 213 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 215 "../src/Widgets/PresetList.vala"
	gtk_combo_box_get_active_iter ((GtkComboBox*) self, &_tmp0_);
#line 215 "../src/Widgets/PresetList.vala"
	it = _tmp0_;
#line 218 "../src/Widgets/PresetList.vala"
	_tmp1_ = self->priv->store;
#line 218 "../src/Widgets/PresetList.vala"
	_tmp2_ = it;
#line 218 "../src/Widgets/PresetList.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp1_, &_tmp2_, 0, &_tmp3_, -1);
#line 218 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (o);
#line 218 "../src/Widgets/PresetList.vala"
	o = _tmp3_;
#line 220 "../src/Widgets/PresetList.vala"
	_tmp5_ = o;
#line 220 "../src/Widgets/PresetList.vala"
	if (_tmp5_ != NULL) {
#line 889 "PresetList.c"
		GObject* _tmp6_;
#line 220 "../src/Widgets/PresetList.vala"
		_tmp6_ = o;
#line 220 "../src/Widgets/PresetList.vala"
		_tmp4_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, MUSIC_TYPE_EQUALIZER_PRESET);
#line 895 "PresetList.c"
	} else {
#line 220 "../src/Widgets/PresetList.vala"
		_tmp4_ = FALSE;
#line 899 "PresetList.c"
	}
#line 220 "../src/Widgets/PresetList.vala"
	if (_tmp4_) {
#line 903 "PresetList.c"
		GObject* _tmp7_;
		MusicEqualizerPreset* _tmp8_;
#line 221 "../src/Widgets/PresetList.vala"
		_tmp7_ = o;
#line 221 "../src/Widgets/PresetList.vala"
		_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, MUSIC_TYPE_EQUALIZER_PRESET) ? ((MusicEqualizerPreset*) _tmp7_) : NULL);
#line 221 "../src/Widgets/PresetList.vala"
		result = _tmp8_;
#line 221 "../src/Widgets/PresetList.vala"
		_g_object_unref0 (o);
#line 221 "../src/Widgets/PresetList.vala"
		return result;
#line 916 "PresetList.c"
	} else {
#line 223 "../src/Widgets/PresetList.vala"
		result = NULL;
#line 223 "../src/Widgets/PresetList.vala"
		_g_object_unref0 (o);
#line 223 "../src/Widgets/PresetList.vala"
		return result;
#line 924 "PresetList.c"
	}
}

GeeCollection*
music_preset_list_get_presets (MusicPresetList* self)
{
	GeeLinkedList* rv = NULL;
	GeeLinkedList* _tmp0_;
	GtkTreeIter iter = {0};
	GeeCollection* result;
#line 227 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 229 "../src/Widgets/PresetList.vala"
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_EQUALIZER_PRESET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 229 "../src/Widgets/PresetList.vala"
	rv = _tmp0_;
#line 941 "PresetList.c"
	{
		gint i = 0;
#line 232 "../src/Widgets/PresetList.vala"
		i = 0;
#line 946 "PresetList.c"
		{
			gboolean _tmp1_ = FALSE;
#line 232 "../src/Widgets/PresetList.vala"
			_tmp1_ = TRUE;
#line 232 "../src/Widgets/PresetList.vala"
			while (TRUE) {
#line 953 "PresetList.c"
				GtkListStore* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				GtkTreeIter _tmp6_ = {0};
				gboolean _tmp7_;
				gboolean _tmp8_;
				GObject* o = NULL;
				GtkListStore* _tmp9_;
				GtkTreeIter _tmp10_;
				GObject* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
				GObject* _tmp13_;
#line 232 "../src/Widgets/PresetList.vala"
				if (!_tmp1_) {
#line 968 "PresetList.c"
					gint _tmp2_;
#line 232 "../src/Widgets/PresetList.vala"
					i = i + 1;
#line 232 "../src/Widgets/PresetList.vala"
					_tmp2_ = i;
#line 974 "PresetList.c"
				}
#line 232 "../src/Widgets/PresetList.vala"
				_tmp1_ = FALSE;
#line 232 "../src/Widgets/PresetList.vala"
				_tmp3_ = self->priv->store;
#line 232 "../src/Widgets/PresetList.vala"
				_tmp4_ = g_strdup_printf ("%i", i);
#line 232 "../src/Widgets/PresetList.vala"
				_tmp5_ = _tmp4_;
#line 232 "../src/Widgets/PresetList.vala"
				_tmp7_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp3_, &_tmp6_, _tmp5_);
#line 232 "../src/Widgets/PresetList.vala"
				iter = _tmp6_;
#line 232 "../src/Widgets/PresetList.vala"
				_tmp8_ = !_tmp7_;
#line 232 "../src/Widgets/PresetList.vala"
				_g_free0 (_tmp5_);
#line 232 "../src/Widgets/PresetList.vala"
				if (_tmp8_) {
#line 232 "../src/Widgets/PresetList.vala"
					break;
#line 996 "PresetList.c"
				}
#line 234 "../src/Widgets/PresetList.vala"
				_tmp9_ = self->priv->store;
#line 234 "../src/Widgets/PresetList.vala"
				_tmp10_ = iter;
#line 234 "../src/Widgets/PresetList.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp9_, &_tmp10_, 0, &_tmp11_, -1);
#line 234 "../src/Widgets/PresetList.vala"
				_g_object_unref0 (o);
#line 234 "../src/Widgets/PresetList.vala"
				o = _tmp11_;
#line 236 "../src/Widgets/PresetList.vala"
				_tmp13_ = o;
#line 236 "../src/Widgets/PresetList.vala"
				if (_tmp13_ != NULL) {
#line 1012 "PresetList.c"
					GObject* _tmp14_;
#line 236 "../src/Widgets/PresetList.vala"
					_tmp14_ = o;
#line 236 "../src/Widgets/PresetList.vala"
					_tmp12_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, MUSIC_TYPE_EQUALIZER_PRESET);
#line 1018 "PresetList.c"
				} else {
#line 236 "../src/Widgets/PresetList.vala"
					_tmp12_ = FALSE;
#line 1022 "PresetList.c"
				}
#line 236 "../src/Widgets/PresetList.vala"
				if (_tmp12_) {
#line 1026 "PresetList.c"
					GeeLinkedList* _tmp15_;
					GObject* _tmp16_;
#line 237 "../src/Widgets/PresetList.vala"
					_tmp15_ = rv;
#line 237 "../src/Widgets/PresetList.vala"
					_tmp16_ = o;
#line 237 "../src/Widgets/PresetList.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, MUSIC_TYPE_EQUALIZER_PRESET) ? ((MusicEqualizerPreset*) _tmp16_) : NULL);
#line 1035 "PresetList.c"
				}
#line 232 "../src/Widgets/PresetList.vala"
				_g_object_unref0 (o);
#line 1039 "PresetList.c"
			}
		}
	}
#line 241 "../src/Widgets/PresetList.vala"
	result = (GeeCollection*) rv;
#line 241 "../src/Widgets/PresetList.vala"
	return result;
#line 1047 "PresetList.c"
}

static void
music_preset_list_remove_delete_option (MusicPresetList* self)
{
	GtkTreeIter iter = {0};
#line 244 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 1056 "PresetList.c"
	{
		gint i = 0;
#line 246 "../src/Widgets/PresetList.vala"
		i = 0;
#line 1061 "PresetList.c"
		{
			gboolean _tmp0_ = FALSE;
#line 246 "../src/Widgets/PresetList.vala"
			_tmp0_ = TRUE;
#line 246 "../src/Widgets/PresetList.vala"
			while (TRUE) {
#line 1068 "PresetList.c"
				GtkListStore* _tmp2_;
				gchar* _tmp3_;
				gchar* _tmp4_;
				GtkTreeIter _tmp5_ = {0};
				gboolean _tmp6_;
				gboolean _tmp7_;
				gchar* text = NULL;
				GtkListStore* _tmp8_;
				GtkTreeIter _tmp9_;
				gchar* _tmp10_ = NULL;
				gboolean _tmp11_ = FALSE;
				const gchar* _tmp12_;
#line 246 "../src/Widgets/PresetList.vala"
				if (!_tmp0_) {
#line 1083 "PresetList.c"
					gint _tmp1_;
#line 246 "../src/Widgets/PresetList.vala"
					i = i + 1;
#line 246 "../src/Widgets/PresetList.vala"
					_tmp1_ = i;
#line 1089 "PresetList.c"
				}
#line 246 "../src/Widgets/PresetList.vala"
				_tmp0_ = FALSE;
#line 246 "../src/Widgets/PresetList.vala"
				_tmp2_ = self->priv->store;
#line 246 "../src/Widgets/PresetList.vala"
				_tmp3_ = g_strdup_printf ("%i", i);
#line 246 "../src/Widgets/PresetList.vala"
				_tmp4_ = _tmp3_;
#line 246 "../src/Widgets/PresetList.vala"
				_tmp6_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp2_, &_tmp5_, _tmp4_);
#line 246 "../src/Widgets/PresetList.vala"
				iter = _tmp5_;
#line 246 "../src/Widgets/PresetList.vala"
				_tmp7_ = !_tmp6_;
#line 246 "../src/Widgets/PresetList.vala"
				_g_free0 (_tmp4_);
#line 246 "../src/Widgets/PresetList.vala"
				if (_tmp7_) {
#line 246 "../src/Widgets/PresetList.vala"
					break;
#line 1111 "PresetList.c"
				}
#line 248 "../src/Widgets/PresetList.vala"
				_tmp8_ = self->priv->store;
#line 248 "../src/Widgets/PresetList.vala"
				_tmp9_ = iter;
#line 248 "../src/Widgets/PresetList.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp8_, &_tmp9_, 1, &_tmp10_, -1);
#line 248 "../src/Widgets/PresetList.vala"
				_g_free0 (text);
#line 248 "../src/Widgets/PresetList.vala"
				text = _tmp10_;
#line 250 "../src/Widgets/PresetList.vala"
				_tmp12_ = text;
#line 250 "../src/Widgets/PresetList.vala"
				if (_tmp12_ != NULL) {
#line 1127 "PresetList.c"
					const gchar* _tmp13_;
					const gchar* _tmp14_;
#line 250 "../src/Widgets/PresetList.vala"
					_tmp13_ = text;
#line 250 "../src/Widgets/PresetList.vala"
					_tmp14_ = music_preset_list_delete_preset;
#line 250 "../src/Widgets/PresetList.vala"
					_tmp11_ = g_strcmp0 (_tmp13_, _tmp14_) == 0;
#line 1136 "PresetList.c"
				} else {
#line 250 "../src/Widgets/PresetList.vala"
					_tmp11_ = FALSE;
#line 1140 "PresetList.c"
				}
#line 250 "../src/Widgets/PresetList.vala"
				if (_tmp11_) {
#line 1144 "PresetList.c"
					GtkListStore* _tmp15_;
#line 252 "../src/Widgets/PresetList.vala"
					_tmp15_ = self->priv->store;
#line 252 "../src/Widgets/PresetList.vala"
					gtk_list_store_remove (_tmp15_, &iter);
#line 257 "../src/Widgets/PresetList.vala"
					music_preset_list_remove_separator_item (self, 1);
#line 1152 "PresetList.c"
				}
#line 246 "../src/Widgets/PresetList.vala"
				_g_free0 (text);
#line 1156 "PresetList.c"
			}
		}
	}
}

static void
music_preset_list_remove_separator_item (MusicPresetList* self,
                                         gint index)
{
	gint count = 0;
	gint nitems = 0;
	GtkListStore* _tmp0_;
	GtkTreeIter iter = {0};
#line 262 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/Widgets/PresetList.vala"
	count = 0;
#line 263 "../src/Widgets/PresetList.vala"
	_tmp0_ = self->priv->store;
#line 263 "../src/Widgets/PresetList.vala"
	nitems = gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp0_, NULL);
#line 1178 "PresetList.c"
	{
		gint i = 0;
#line 266 "../src/Widgets/PresetList.vala"
		i = nitems - 1;
#line 1183 "PresetList.c"
		{
			gboolean _tmp1_ = FALSE;
#line 266 "../src/Widgets/PresetList.vala"
			_tmp1_ = TRUE;
#line 266 "../src/Widgets/PresetList.vala"
			while (TRUE) {
#line 1190 "PresetList.c"
				GtkListStore* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				GtkTreeIter _tmp6_ = {0};
				gboolean _tmp7_;
				gboolean _tmp8_;
				gint _tmp9_;
				gchar* text = NULL;
				GtkListStore* _tmp10_;
				GtkTreeIter _tmp11_;
				gchar* _tmp12_ = NULL;
				gboolean _tmp13_ = FALSE;
				gboolean _tmp14_ = FALSE;
				gboolean _tmp15_ = FALSE;
#line 266 "../src/Widgets/PresetList.vala"
				if (!_tmp1_) {
#line 1207 "PresetList.c"
					gint _tmp2_;
#line 266 "../src/Widgets/PresetList.vala"
					i = i - 1;
#line 266 "../src/Widgets/PresetList.vala"
					_tmp2_ = i;
#line 1213 "PresetList.c"
				}
#line 266 "../src/Widgets/PresetList.vala"
				_tmp1_ = FALSE;
#line 266 "../src/Widgets/PresetList.vala"
				_tmp3_ = self->priv->store;
#line 266 "../src/Widgets/PresetList.vala"
				_tmp4_ = g_strdup_printf ("%i", i);
#line 266 "../src/Widgets/PresetList.vala"
				_tmp5_ = _tmp4_;
#line 266 "../src/Widgets/PresetList.vala"
				_tmp7_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp3_, &_tmp6_, _tmp5_);
#line 266 "../src/Widgets/PresetList.vala"
				iter = _tmp6_;
#line 266 "../src/Widgets/PresetList.vala"
				_tmp8_ = !_tmp7_;
#line 266 "../src/Widgets/PresetList.vala"
				_g_free0 (_tmp5_);
#line 266 "../src/Widgets/PresetList.vala"
				if (_tmp8_) {
#line 266 "../src/Widgets/PresetList.vala"
					break;
#line 1235 "PresetList.c"
				}
#line 267 "../src/Widgets/PresetList.vala"
				_tmp9_ = count;
#line 267 "../src/Widgets/PresetList.vala"
				count = _tmp9_ + 1;
#line 269 "../src/Widgets/PresetList.vala"
				_tmp10_ = self->priv->store;
#line 269 "../src/Widgets/PresetList.vala"
				_tmp11_ = iter;
#line 269 "../src/Widgets/PresetList.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp10_, &_tmp11_, 1, &_tmp12_, -1);
#line 269 "../src/Widgets/PresetList.vala"
				_g_free0 (text);
#line 269 "../src/Widgets/PresetList.vala"
				text = _tmp12_;
#line 271 "../src/Widgets/PresetList.vala"
				if ((nitems - index) == count) {
#line 271 "../src/Widgets/PresetList.vala"
					_tmp15_ = TRUE;
#line 1255 "PresetList.c"
				} else {
#line 271 "../src/Widgets/PresetList.vala"
					_tmp15_ = index == -1;
#line 1259 "PresetList.c"
				}
#line 271 "../src/Widgets/PresetList.vala"
				if (_tmp15_) {
#line 1263 "PresetList.c"
					const gchar* _tmp16_;
#line 271 "../src/Widgets/PresetList.vala"
					_tmp16_ = text;
#line 271 "../src/Widgets/PresetList.vala"
					_tmp14_ = _tmp16_ != NULL;
#line 1269 "PresetList.c"
				} else {
#line 271 "../src/Widgets/PresetList.vala"
					_tmp14_ = FALSE;
#line 1273 "PresetList.c"
				}
#line 271 "../src/Widgets/PresetList.vala"
				if (_tmp14_) {
#line 1277 "PresetList.c"
					const gchar* _tmp17_;
#line 271 "../src/Widgets/PresetList.vala"
					_tmp17_ = text;
#line 271 "../src/Widgets/PresetList.vala"
					_tmp13_ = g_strcmp0 (_tmp17_, MUSIC_PRESET_LIST_SEPARATOR_NAME) == 0;
#line 1283 "PresetList.c"
				} else {
#line 271 "../src/Widgets/PresetList.vala"
					_tmp13_ = FALSE;
#line 1287 "PresetList.c"
				}
#line 271 "../src/Widgets/PresetList.vala"
				if (_tmp13_) {
#line 1291 "PresetList.c"
					GtkListStore* _tmp18_;
#line 273 "../src/Widgets/PresetList.vala"
					_tmp18_ = self->priv->store;
#line 273 "../src/Widgets/PresetList.vala"
					gtk_list_store_remove (_tmp18_, &iter);
#line 277 "../src/Widgets/PresetList.vala"
					_g_free0 (text);
#line 277 "../src/Widgets/PresetList.vala"
					break;
#line 1301 "PresetList.c"
				}
#line 266 "../src/Widgets/PresetList.vala"
				_g_free0 (text);
#line 1305 "PresetList.c"
			}
		}
	}
}

static void
music_preset_list_add_delete_preset_option (MusicPresetList* self)
{
	gboolean already_added = FALSE;
	GtkTreeIter last_iter = {0};
	GtkTreeIter new_iter = {0};
	GtkListStore* _tmp22_;
	GtkTreeIter _tmp23_;
	GtkTreeIter _tmp24_ = {0};
	GtkListStore* _tmp25_;
	GtkTreeIter _tmp26_;
	const gchar* _tmp27_;
	GtkTreeIter _tmp28_;
	GtkListStore* _tmp29_;
	GtkTreeIter _tmp30_;
	GtkTreeIter _tmp31_ = {0};
	GtkListStore* _tmp32_;
	GtkTreeIter _tmp33_;
#line 282 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 283 "../src/Widgets/PresetList.vala"
	already_added = FALSE;
#line 1333 "PresetList.c"
	{
		gint i = 0;
#line 286 "../src/Widgets/PresetList.vala"
		i = 0;
#line 1338 "PresetList.c"
		{
			gboolean _tmp0_ = FALSE;
#line 286 "../src/Widgets/PresetList.vala"
			_tmp0_ = TRUE;
#line 286 "../src/Widgets/PresetList.vala"
			while (TRUE) {
#line 1345 "PresetList.c"
				GtkListStore* _tmp2_;
				gchar* _tmp3_;
				gchar* _tmp4_;
				GtkTreeIter _tmp5_ = {0};
				gboolean _tmp6_;
				gboolean _tmp7_;
				gchar* text = NULL;
				GtkListStore* _tmp8_;
				GtkTreeIter _tmp9_;
				gchar* _tmp10_ = NULL;
				gboolean _tmp11_ = FALSE;
				const gchar* _tmp12_;
#line 286 "../src/Widgets/PresetList.vala"
				if (!_tmp0_) {
#line 1360 "PresetList.c"
					gint _tmp1_;
#line 286 "../src/Widgets/PresetList.vala"
					i = i + 1;
#line 286 "../src/Widgets/PresetList.vala"
					_tmp1_ = i;
#line 1366 "PresetList.c"
				}
#line 286 "../src/Widgets/PresetList.vala"
				_tmp0_ = FALSE;
#line 286 "../src/Widgets/PresetList.vala"
				_tmp2_ = self->priv->store;
#line 286 "../src/Widgets/PresetList.vala"
				_tmp3_ = g_strdup_printf ("%i", i);
#line 286 "../src/Widgets/PresetList.vala"
				_tmp4_ = _tmp3_;
#line 286 "../src/Widgets/PresetList.vala"
				_tmp6_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp2_, &_tmp5_, _tmp4_);
#line 286 "../src/Widgets/PresetList.vala"
				last_iter = _tmp5_;
#line 286 "../src/Widgets/PresetList.vala"
				_tmp7_ = !_tmp6_;
#line 286 "../src/Widgets/PresetList.vala"
				_g_free0 (_tmp4_);
#line 286 "../src/Widgets/PresetList.vala"
				if (_tmp7_) {
#line 286 "../src/Widgets/PresetList.vala"
					break;
#line 1388 "PresetList.c"
				}
#line 288 "../src/Widgets/PresetList.vala"
				_tmp8_ = self->priv->store;
#line 288 "../src/Widgets/PresetList.vala"
				_tmp9_ = last_iter;
#line 288 "../src/Widgets/PresetList.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp8_, &_tmp9_, 1, &_tmp10_, -1);
#line 288 "../src/Widgets/PresetList.vala"
				_g_free0 (text);
#line 288 "../src/Widgets/PresetList.vala"
				text = _tmp10_;
#line 290 "../src/Widgets/PresetList.vala"
				_tmp12_ = text;
#line 290 "../src/Widgets/PresetList.vala"
				if (_tmp12_ != NULL) {
#line 1404 "PresetList.c"
					const gchar* _tmp13_;
#line 290 "../src/Widgets/PresetList.vala"
					_tmp13_ = text;
#line 290 "../src/Widgets/PresetList.vala"
					_tmp11_ = g_strcmp0 (_tmp13_, MUSIC_PRESET_LIST_SEPARATOR_NAME) == 0;
#line 1410 "PresetList.c"
				} else {
#line 290 "../src/Widgets/PresetList.vala"
					_tmp11_ = FALSE;
#line 1414 "PresetList.c"
				}
#line 290 "../src/Widgets/PresetList.vala"
				if (_tmp11_) {
#line 1418 "PresetList.c"
					GtkTreeIter _tmp14_;
					GtkListStore* _tmp15_;
					gboolean _tmp16_;
#line 291 "../src/Widgets/PresetList.vala"
					_tmp14_ = last_iter;
#line 291 "../src/Widgets/PresetList.vala"
					new_iter = _tmp14_;
#line 293 "../src/Widgets/PresetList.vala"
					_tmp15_ = self->priv->store;
#line 293 "../src/Widgets/PresetList.vala"
					_tmp16_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp15_, &new_iter);
#line 293 "../src/Widgets/PresetList.vala"
					if (_tmp16_) {
#line 1432 "PresetList.c"
						GtkListStore* _tmp17_;
						GtkTreeIter _tmp18_;
						gchar* _tmp19_ = NULL;
						const gchar* _tmp20_;
						const gchar* _tmp21_;
#line 294 "../src/Widgets/PresetList.vala"
						_tmp17_ = self->priv->store;
#line 294 "../src/Widgets/PresetList.vala"
						_tmp18_ = new_iter;
#line 294 "../src/Widgets/PresetList.vala"
						gtk_tree_model_get ((GtkTreeModel*) _tmp17_, &_tmp18_, 1, &_tmp19_, -1);
#line 294 "../src/Widgets/PresetList.vala"
						_g_free0 (text);
#line 294 "../src/Widgets/PresetList.vala"
						text = _tmp19_;
#line 295 "../src/Widgets/PresetList.vala"
						_tmp20_ = text;
#line 295 "../src/Widgets/PresetList.vala"
						_tmp21_ = music_preset_list_delete_preset;
#line 295 "../src/Widgets/PresetList.vala"
						already_added = g_strcmp0 (_tmp20_, _tmp21_) == 0;
#line 1454 "PresetList.c"
					}
#line 298 "../src/Widgets/PresetList.vala"
					_g_free0 (text);
#line 298 "../src/Widgets/PresetList.vala"
					break;
#line 1460 "PresetList.c"
				}
#line 286 "../src/Widgets/PresetList.vala"
				_g_free0 (text);
#line 1464 "PresetList.c"
			}
		}
	}
#line 302 "../src/Widgets/PresetList.vala"
	if (already_added) {
#line 303 "../src/Widgets/PresetList.vala"
		return;
#line 1472 "PresetList.c"
	}
#line 307 "../src/Widgets/PresetList.vala"
	_tmp22_ = self->priv->store;
#line 307 "../src/Widgets/PresetList.vala"
	_tmp23_ = last_iter;
#line 307 "../src/Widgets/PresetList.vala"
	gtk_list_store_insert_after (_tmp22_, &_tmp24_, &_tmp23_);
#line 307 "../src/Widgets/PresetList.vala"
	new_iter = _tmp24_;
#line 308 "../src/Widgets/PresetList.vala"
	_tmp25_ = self->priv->store;
#line 308 "../src/Widgets/PresetList.vala"
	_tmp26_ = new_iter;
#line 308 "../src/Widgets/PresetList.vala"
	_tmp27_ = music_preset_list_delete_preset;
#line 308 "../src/Widgets/PresetList.vala"
	gtk_list_store_set (_tmp25_, &_tmp26_, 0, NULL, 1, _tmp27_, -1);
#line 310 "../src/Widgets/PresetList.vala"
	_tmp28_ = new_iter;
#line 310 "../src/Widgets/PresetList.vala"
	last_iter = _tmp28_;
#line 313 "../src/Widgets/PresetList.vala"
	_tmp29_ = self->priv->store;
#line 313 "../src/Widgets/PresetList.vala"
	_tmp30_ = last_iter;
#line 313 "../src/Widgets/PresetList.vala"
	gtk_list_store_insert_after (_tmp29_, &_tmp31_, &_tmp30_);
#line 313 "../src/Widgets/PresetList.vala"
	new_iter = _tmp31_;
#line 314 "../src/Widgets/PresetList.vala"
	_tmp32_ = self->priv->store;
#line 314 "../src/Widgets/PresetList.vala"
	_tmp33_ = new_iter;
#line 314 "../src/Widgets/PresetList.vala"
	gtk_list_store_set (_tmp32_, &_tmp33_, 0, NULL, 1, MUSIC_PRESET_LIST_SEPARATOR_NAME, -1);
#line 1508 "PresetList.c"
}

gboolean
music_preset_list_get_automatic_chosen (MusicPresetList* self)
{
	gboolean result;
#line 35 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/Widgets/PresetList.vala"
	result = self->priv->automatic_selected;
#line 36 "../src/Widgets/PresetList.vala"
	return result;
#line 1521 "PresetList.c"
}

static gint
music_preset_list_get_ncustompresets (MusicPresetList* self)
{
	gint result;
#line 42 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 42 "../src/Widgets/PresetList.vala"
	result = self->priv->_ncustompresets;
#line 42 "../src/Widgets/PresetList.vala"
	return result;
#line 1534 "PresetList.c"
}

static void
music_preset_list_set_ncustompresets (MusicPresetList* self,
                                      gint value)
{
#line 42 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/Widgets/PresetList.vala"
	self->priv->_ncustompresets = value;
#line 1545 "PresetList.c"
}

static void
music_preset_list_class_init (MusicPresetListClass * klass,
                              gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 29 "../src/Widgets/PresetList.vala"
	music_preset_list_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Widgets/PresetList.vala"
	g_type_class_adjust_private_offset (klass, &MusicPresetList_private_offset);
#line 29 "../src/Widgets/PresetList.vala"
	((MusicPresetListClass *) klass)->list_selection_change = (void (*) (MusicPresetList*)) music_preset_list_real_list_selection_change;
#line 29 "../src/Widgets/PresetList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_preset_list_get_property;
#line 29 "../src/Widgets/PresetList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_preset_list_set_property;
#line 29 "../src/Widgets/PresetList.vala"
	G_OBJECT_CLASS (klass)->finalize = music_preset_list_finalize;
#line 29 "../src/Widgets/PresetList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY, music_preset_list_properties[MUSIC_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY] = g_param_spec_boolean ("automatic-chosen", "automatic-chosen", "automatic-chosen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/Widgets/PresetList.vala"
	music_preset_list_signals[MUSIC_PRESET_LIST_PRESET_SELECTED_SIGNAL] = g_signal_new ("preset-selected", MUSIC_TYPE_PRESET_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_EQUALIZER_PRESET);
#line 29 "../src/Widgets/PresetList.vala"
	music_preset_list_signals[MUSIC_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL] = g_signal_new ("automatic-preset-chosen", MUSIC_TYPE_PRESET_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../src/Widgets/PresetList.vala"
	music_preset_list_signals[MUSIC_PRESET_LIST_DELETE_PRESET_CHOSEN_SIGNAL] = g_signal_new ("delete-preset-chosen", MUSIC_TYPE_PRESET_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 52 "../src/Widgets/PresetList.vala"
	_tmp0_ = g_strdup (_ ("Automatic"));
#line 52 "../src/Widgets/PresetList.vala"
	music_preset_list_automatic_mode = _tmp0_;
#line 53 "../src/Widgets/PresetList.vala"
	_tmp1_ = g_strdup (_ ("Delete Current"));
#line 53 "../src/Widgets/PresetList.vala"
	music_preset_list_delete_preset = _tmp1_;
#line 1582 "PresetList.c"
}

static void
music_preset_list_instance_init (MusicPresetList * self,
                                 gpointer klass)
{
#line 29 "../src/Widgets/PresetList.vala"
	self->priv = music_preset_list_get_instance_private (self);
#line 1591 "PresetList.c"
}

static void
music_preset_list_finalize (GObject * obj)
{
	MusicPresetList * self;
#line 29 "../src/Widgets/PresetList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PRESET_LIST, MusicPresetList);
#line 40 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (self->last_selected_preset);
#line 47 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (self->priv->store);
#line 29 "../src/Widgets/PresetList.vala"
	G_OBJECT_CLASS (music_preset_list_parent_class)->finalize (obj);
#line 1606 "PresetList.c"
}

static GType
music_preset_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPresetListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_preset_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPresetList), 0, (GInstanceInitFunc) music_preset_list_instance_init, NULL };
	GType music_preset_list_type_id;
	music_preset_list_type_id = g_type_register_static (gtk_combo_box_get_type (), "MusicPresetList", &g_define_type_info, 0);
	MusicPresetList_private_offset = g_type_add_instance_private (music_preset_list_type_id, sizeof (MusicPresetListPrivate));
	return music_preset_list_type_id;
}

GType
music_preset_list_get_type (void)
{
	static volatile gsize music_preset_list_type_id__once = 0;
	if (g_once_init_enter (&music_preset_list_type_id__once)) {
		GType music_preset_list_type_id;
		music_preset_list_type_id = music_preset_list_get_type_once ();
		g_once_init_leave (&music_preset_list_type_id__once, music_preset_list_type_id);
	}
	return music_preset_list_type_id__once;
}

static void
_vala_music_preset_list_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	MusicPresetList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PRESET_LIST, MusicPresetList);
#line 29 "../src/Widgets/PresetList.vala"
	switch (property_id) {
#line 29 "../src/Widgets/PresetList.vala"
		case MUSIC_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY:
#line 29 "../src/Widgets/PresetList.vala"
		g_value_set_boolean (value, music_preset_list_get_automatic_chosen (self));
#line 29 "../src/Widgets/PresetList.vala"
		break;
#line 1647 "PresetList.c"
		default:
#line 29 "../src/Widgets/PresetList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Widgets/PresetList.vala"
		break;
#line 1653 "PresetList.c"
	}
}

static void
_vala_music_preset_list_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	MusicPresetList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PRESET_LIST, MusicPresetList);
#line 29 "../src/Widgets/PresetList.vala"
	switch (property_id) {
#line 1667 "PresetList.c"
		default:
#line 29 "../src/Widgets/PresetList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Widgets/PresetList.vala"
		break;
#line 1673 "PresetList.c"
	}
}

