/* RatingCellRenderer.c generated by valac 0.56.0, the Vala compiler
 * generated from RatingCellRenderer.vala, do not modify */

/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Lucas Baudin <xapantu@gmail.com>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include "music-lib.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

enum  {
	MUSIC_RATING_CELL_RENDERER_0_PROPERTY,
	MUSIC_RATING_CELL_RENDERER_STAR_SPACING_PROPERTY,
	MUSIC_RATING_CELL_RENDERER_RATING_PROPERTY,
	MUSIC_RATING_CELL_RENDERER_N_STARS_PROPERTY,
	MUSIC_RATING_CELL_RENDERER_NUM_PROPERTIES
};
static GParamSpec* music_rating_cell_renderer_properties[MUSIC_RATING_CELL_RENDERER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	MUSIC_RATING_CELL_RENDERER_RATING_CHANGED_SIGNAL,
	MUSIC_RATING_CELL_RENDERER_NUM_SIGNALS
};
static guint music_rating_cell_renderer_signals[MUSIC_RATING_CELL_RENDERER_NUM_SIGNALS] = {0};

struct _MusicRatingCellRendererPrivate {
	MusicRatingWidgetRenderer* renderer;
	guint _rating;
};

static gint MusicRatingCellRenderer_private_offset;
static gpointer music_rating_cell_renderer_parent_class = NULL;

static void music_rating_cell_renderer_update_pixbuf (MusicRatingCellRenderer* self);
static void music_rating_cell_renderer_real_render (GtkCellRenderer* base,
                                             cairo_t* ctx,
                                             GtkWidget* widget,
                                             GdkRectangle* background_area,
                                             GdkRectangle* cell_area,
                                             GtkCellRendererState flags);
static gboolean music_rating_cell_renderer_real_activate (GtkCellRenderer* base,
                                                   GdkEvent* event,
                                                   GtkWidget* widget,
                                                   const gchar* path,
                                                   GdkRectangle* background_area,
                                                   GdkRectangle* cell_area,
                                                   GtkCellRendererState flags);
static void g_cclosure_user_marshal_VOID__INT_OBJECT_STRING (GClosure * closure,
                                                      GValue * return_value,
                                                      guint n_param_values,
                                                      const GValue * param_values,
                                                      gpointer invocation_hint,
                                                      gpointer marshal_data);
static void music_rating_cell_renderer_finalize (GObject * obj);
static GType music_rating_cell_renderer_get_type_once (void);
static void _vala_music_rating_cell_renderer_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_music_rating_cell_renderer_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);

static inline gpointer
music_rating_cell_renderer_get_instance_private (MusicRatingCellRenderer* self)
{
	return G_STRUCT_MEMBER_P (self, MusicRatingCellRenderer_private_offset);
}

MusicRatingCellRenderer*
music_rating_cell_renderer_construct (GType object_type,
                                      GtkIconSize icon_size)
{
	MusicRatingCellRenderer * self = NULL;
	MusicRatingWidgetRenderer* _tmp0_;
	MusicRatingWidgetRenderer* _tmp1_;
	MusicRatingWidgetRenderer* _tmp2_;
#line 47 "../src/Widgets/Rating/RatingCellRenderer.vala"
	self = (MusicRatingCellRenderer*) g_object_new (object_type, NULL);
#line 48 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_object_set ((GtkCellRenderer*) self, "xalign", 0.0f, NULL);
#line 49 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_object_set ((GtkCellRenderer*) self, "mode", GTK_CELL_RENDERER_MODE_ACTIVATABLE, NULL);
#line 51 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp0_ = music_rating_widget_renderer_new (icon_size, TRUE, NULL);
#line 51 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_g_object_unref0 (self->priv->renderer);
#line 51 "../src/Widgets/Rating/RatingCellRenderer.vala"
	self->priv->renderer = _tmp0_;
#line 54 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp1_ = self->priv->renderer;
#line 54 "../src/Widgets/Rating/RatingCellRenderer.vala"
	music_rating_widget_renderer_set_delayed_render_mode (_tmp1_, TRUE);
#line 57 "../src/Widgets/Rating/RatingCellRenderer.vala"
	music_rating_cell_renderer_set_rating (self, (guint) 1);
#line 58 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp2_ = self->priv->renderer;
#line 58 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_signal_emit_by_name (_tmp2_, "render");
#line 59 "../src/Widgets/Rating/RatingCellRenderer.vala"
	music_rating_cell_renderer_update_pixbuf (self);
#line 47 "../src/Widgets/Rating/RatingCellRenderer.vala"
	return self;
#line 137 "RatingCellRenderer.c"
}

MusicRatingCellRenderer*
music_rating_cell_renderer_new (GtkIconSize icon_size)
{
#line 47 "../src/Widgets/Rating/RatingCellRenderer.vala"
	return music_rating_cell_renderer_construct (MUSIC_TYPE_RATING_CELL_RENDERER, icon_size);
#line 145 "RatingCellRenderer.c"
}

static void
music_rating_cell_renderer_update_pixbuf (MusicRatingCellRenderer* self)
{
	MusicRatingWidgetRenderer* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	GdkPixbuf* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GdkPixbuf* _tmp8_;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
#line 81 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp0_ = self->priv->renderer;
#line 82 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp1_ = music_rating_widget_renderer_get_canvas (_tmp0_);
#line 82 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp2_ = _tmp1_;
#line 82 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_object_set ((GtkCellRendererPixbuf*) self, "pixbuf", _tmp2_, NULL);
#line 83 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_object_get ((GtkCellRendererPixbuf*) self, "pixbuf", &_tmp3_, NULL);
#line 83 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp4_ = _tmp3_;
#line 83 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp5_ = _tmp4_;
#line 83 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp6_ = gdk_pixbuf_get_width (_tmp5_);
#line 83 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp7_ = _tmp6_;
#line 83 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_object_get ((GtkCellRendererPixbuf*) self, "pixbuf", &_tmp8_, NULL);
#line 83 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp9_ = _tmp8_;
#line 83 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp10_ = _tmp9_;
#line 83 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp11_ = gdk_pixbuf_get_height (_tmp10_);
#line 83 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp12_ = _tmp11_;
#line 83 "../src/Widgets/Rating/RatingCellRenderer.vala"
	gtk_cell_renderer_set_fixed_size ((GtkCellRenderer*) self, _tmp7_, _tmp12_);
#line 83 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_g_object_unref0 (_tmp10_);
#line 83 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_g_object_unref0 (_tmp5_);
#line 200 "RatingCellRenderer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 87 "../src/Widgets/Rating/RatingCellRenderer.vala"
	return self ? g_object_ref (self) : NULL;
#line 208 "RatingCellRenderer.c"
}

static void
music_rating_cell_renderer_real_render (GtkCellRenderer* base,
                                        cairo_t* ctx,
                                        GtkWidget* widget,
                                        GdkRectangle* background_area,
                                        GdkRectangle* cell_area,
                                        GtkCellRendererState flags)
{
	MusicRatingCellRenderer * self;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStateFlags state = 0U;
	GtkStyleContext* _tmp2_;
	gint old_n_stars = 0;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	MusicRatingWidgetRenderer* _tmp11_;
	GtkStyleContext* _tmp12_;
	MusicRatingWidgetRenderer* _tmp13_;
	GdkRectangle _tmp14_;
	GdkRectangle _tmp15_;
#line 86 "../src/Widgets/Rating/RatingCellRenderer.vala"
	self = (MusicRatingCellRenderer*) base;
#line 86 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_return_if_fail (ctx != NULL);
#line 86 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_return_if_fail (widget != NULL);
#line 86 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_return_if_fail (background_area != NULL);
#line 86 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_return_if_fail (cell_area != NULL);
#line 87 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp0_ = gtk_widget_get_style_context (widget);
#line 87 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 87 "../src/Widgets/Rating/RatingCellRenderer.vala"
	style_context = _tmp1_;
#line 88 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp2_ = style_context;
#line 88 "../src/Widgets/Rating/RatingCellRenderer.vala"
	state = gtk_style_context_get_state (_tmp2_);
#line 89 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp3_ = music_rating_cell_renderer_get_n_stars (self);
#line 89 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp4_ = _tmp3_;
#line 89 "../src/Widgets/Rating/RatingCellRenderer.vala"
	old_n_stars = _tmp4_;
#line 92 "../src/Widgets/Rating/RatingCellRenderer.vala"
	if (self->priv->_rating == ((guint) 0)) {
#line 92 "../src/Widgets/Rating/RatingCellRenderer.vala"
		_tmp6_ = (state & GTK_STATE_FLAG_SELECTED) != state;
#line 267 "RatingCellRenderer.c"
	} else {
#line 92 "../src/Widgets/Rating/RatingCellRenderer.vala"
		_tmp6_ = FALSE;
#line 271 "RatingCellRenderer.c"
	}
#line 92 "../src/Widgets/Rating/RatingCellRenderer.vala"
	if (_tmp6_) {
#line 92 "../src/Widgets/Rating/RatingCellRenderer.vala"
		_tmp5_ = (state & GTK_STATE_FLAG_PRELIGHT) != state;
#line 277 "RatingCellRenderer.c"
	} else {
#line 92 "../src/Widgets/Rating/RatingCellRenderer.vala"
		_tmp5_ = FALSE;
#line 281 "RatingCellRenderer.c"
	}
#line 92 "../src/Widgets/Rating/RatingCellRenderer.vala"
	if (_tmp5_) {
#line 93 "../src/Widgets/Rating/RatingCellRenderer.vala"
		_g_object_unref0 (style_context);
#line 93 "../src/Widgets/Rating/RatingCellRenderer.vala"
		return;
#line 289 "RatingCellRenderer.c"
	}
#line 97 "../src/Widgets/Rating/RatingCellRenderer.vala"
	if (((guint) 0) < self->priv->_rating) {
#line 97 "../src/Widgets/Rating/RatingCellRenderer.vala"
		_tmp8_ = (state & GTK_STATE_FLAG_SELECTED) != state;
#line 295 "RatingCellRenderer.c"
	} else {
#line 97 "../src/Widgets/Rating/RatingCellRenderer.vala"
		_tmp8_ = FALSE;
#line 299 "RatingCellRenderer.c"
	}
#line 97 "../src/Widgets/Rating/RatingCellRenderer.vala"
	if (_tmp8_) {
#line 97 "../src/Widgets/Rating/RatingCellRenderer.vala"
		_tmp7_ = (state & GTK_STATE_FLAG_PRELIGHT) != state;
#line 305 "RatingCellRenderer.c"
	} else {
#line 97 "../src/Widgets/Rating/RatingCellRenderer.vala"
		_tmp7_ = FALSE;
#line 309 "RatingCellRenderer.c"
	}
#line 97 "../src/Widgets/Rating/RatingCellRenderer.vala"
	if (_tmp7_) {
#line 313 "RatingCellRenderer.c"
		guint _tmp9_;
		guint _tmp10_;
#line 98 "../src/Widgets/Rating/RatingCellRenderer.vala"
		_tmp9_ = music_rating_cell_renderer_get_rating (self);
#line 98 "../src/Widgets/Rating/RatingCellRenderer.vala"
		_tmp10_ = _tmp9_;
#line 98 "../src/Widgets/Rating/RatingCellRenderer.vala"
		music_rating_cell_renderer_set_n_stars (self, (gint) _tmp10_);
#line 322 "RatingCellRenderer.c"
	}
#line 101 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp11_ = self->priv->renderer;
#line 101 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp12_ = style_context;
#line 101 "../src/Widgets/Rating/RatingCellRenderer.vala"
	music_rating_widget_renderer_set_style_context (_tmp11_, _tmp12_);
#line 102 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp13_ = self->priv->renderer;
#line 102 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_signal_emit_by_name (_tmp13_, "render");
#line 103 "../src/Widgets/Rating/RatingCellRenderer.vala"
	music_rating_cell_renderer_update_pixbuf (self);
#line 104 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp14_ = *background_area;
#line 104 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp15_ = *cell_area;
#line 104 "../src/Widgets/Rating/RatingCellRenderer.vala"
	GTK_CELL_RENDERER_CLASS (music_rating_cell_renderer_parent_class)->render ((GtkCellRenderer*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_cell_renderer_pixbuf_get_type (), GtkCellRendererPixbuf), ctx, widget, &_tmp14_, &_tmp15_, flags);
#line 105 "../src/Widgets/Rating/RatingCellRenderer.vala"
	music_rating_cell_renderer_set_n_stars (self, old_n_stars);
#line 86 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_g_object_unref0 (style_context);
#line 346 "RatingCellRenderer.c"
}

static gboolean
music_rating_cell_renderer_real_activate (GtkCellRenderer* base,
                                          GdkEvent* event,
                                          GtkWidget* widget,
                                          const gchar* path,
                                          GdkRectangle* background_area,
                                          GdkRectangle* cell_area,
                                          GtkCellRendererState flags)
{
	MusicRatingCellRenderer * self;
	gint old_rating = 0;
	guint _tmp0_;
	guint _tmp1_;
	gint new_rating = 0;
	MusicRatingWidgetRenderer* _tmp2_;
	GdkEventButton* _tmp3_;
	GdkEventButton* _tmp4_;
	GdkRectangle _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean result;
#line 108 "../src/Widgets/Rating/RatingCellRenderer.vala"
	self = (MusicRatingCellRenderer*) base;
#line 108 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 108 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 108 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 108 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_return_val_if_fail (background_area != NULL, FALSE);
#line 108 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_return_val_if_fail (cell_area != NULL, FALSE);
#line 109 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp0_ = music_rating_cell_renderer_get_rating (self);
#line 109 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp1_ = _tmp0_;
#line 109 "../src/Widgets/Rating/RatingCellRenderer.vala"
	old_rating = (gint) _tmp1_;
#line 110 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp2_ = self->priv->renderer;
#line 110 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp3_ = (GdkEventButton *) (event);
#line 110 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp4_ = _tmp3_;
#line 110 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp5_ = *cell_area;
#line 110 "../src/Widgets/Rating/RatingCellRenderer.vala"
	new_rating = music_rating_widget_renderer_get_new_rating (_tmp2_, _tmp4_->x - _tmp5_.x);
#line 113 "../src/Widgets/Rating/RatingCellRenderer.vala"
	if (new_rating == old_rating) {
#line 113 "../src/Widgets/Rating/RatingCellRenderer.vala"
		_tmp6_ = new_rating > 0;
#line 401 "RatingCellRenderer.c"
	} else {
#line 113 "../src/Widgets/Rating/RatingCellRenderer.vala"
		_tmp6_ = FALSE;
#line 405 "RatingCellRenderer.c"
	}
#line 113 "../src/Widgets/Rating/RatingCellRenderer.vala"
	if (_tmp6_) {
#line 409 "RatingCellRenderer.c"
		gint _tmp7_;
#line 114 "../src/Widgets/Rating/RatingCellRenderer.vala"
		_tmp7_ = new_rating;
#line 114 "../src/Widgets/Rating/RatingCellRenderer.vala"
		new_rating = _tmp7_ - 1;
#line 415 "RatingCellRenderer.c"
	}
#line 117 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_signal_emit (self, music_rating_cell_renderer_signals[MUSIC_RATING_CELL_RENDERER_RATING_CHANGED_SIGNAL], 0, new_rating, widget, path);
#line 119 "../src/Widgets/Rating/RatingCellRenderer.vala"
	result = TRUE;
#line 119 "../src/Widgets/Rating/RatingCellRenderer.vala"
	return result;
#line 423 "RatingCellRenderer.c"
}

gint
music_rating_cell_renderer_get_star_spacing (MusicRatingCellRenderer* self)
{
	gint result;
	MusicRatingWidgetRenderer* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 63 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 63 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp0_ = self->priv->renderer;
#line 63 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp1_ = music_rating_widget_renderer_get_star_spacing (_tmp0_);
#line 63 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp2_ = _tmp1_;
#line 63 "../src/Widgets/Rating/RatingCellRenderer.vala"
	result = _tmp2_;
#line 63 "../src/Widgets/Rating/RatingCellRenderer.vala"
	return result;
#line 445 "RatingCellRenderer.c"
}

void
music_rating_cell_renderer_set_star_spacing (MusicRatingCellRenderer* self,
                                             gint value)
{
	MusicRatingWidgetRenderer* _tmp0_;
#line 64 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp0_ = self->priv->renderer;
#line 64 "../src/Widgets/Rating/RatingCellRenderer.vala"
	music_rating_widget_renderer_set_star_spacing (_tmp0_, value);
#line 64 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_object_notify_by_pspec ((GObject *) self, music_rating_cell_renderer_properties[MUSIC_RATING_CELL_RENDERER_STAR_SPACING_PROPERTY]);
#line 461 "RatingCellRenderer.c"
}

guint
music_rating_cell_renderer_get_rating (MusicRatingCellRenderer* self)
{
	guint result;
#line 69 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 69 "../src/Widgets/Rating/RatingCellRenderer.vala"
	result = self->priv->_rating;
#line 69 "../src/Widgets/Rating/RatingCellRenderer.vala"
	return result;
#line 474 "RatingCellRenderer.c"
}

void
music_rating_cell_renderer_set_rating (MusicRatingCellRenderer* self,
                                       guint value)
{
	MusicRatingWidgetRenderer* _tmp0_;
#line 70 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/Widgets/Rating/RatingCellRenderer.vala"
	self->priv->_rating = value;
#line 72 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp0_ = self->priv->renderer;
#line 72 "../src/Widgets/Rating/RatingCellRenderer.vala"
	music_rating_widget_renderer_set_rating (_tmp0_, self->priv->_rating);
#line 70 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_object_notify_by_pspec ((GObject *) self, music_rating_cell_renderer_properties[MUSIC_RATING_CELL_RENDERER_RATING_PROPERTY]);
#line 492 "RatingCellRenderer.c"
}

gint
music_rating_cell_renderer_get_n_stars (MusicRatingCellRenderer* self)
{
	gint result;
	MusicRatingWidgetRenderer* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 77 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 77 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp0_ = self->priv->renderer;
#line 77 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp1_ = music_rating_widget_renderer_get_n_stars (_tmp0_);
#line 77 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp2_ = _tmp1_;
#line 77 "../src/Widgets/Rating/RatingCellRenderer.vala"
	result = _tmp2_;
#line 77 "../src/Widgets/Rating/RatingCellRenderer.vala"
	return result;
#line 514 "RatingCellRenderer.c"
}

void
music_rating_cell_renderer_set_n_stars (MusicRatingCellRenderer* self,
                                        gint value)
{
	MusicRatingWidgetRenderer* _tmp0_;
#line 78 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_tmp0_ = self->priv->renderer;
#line 78 "../src/Widgets/Rating/RatingCellRenderer.vala"
	music_rating_widget_renderer_set_n_stars (_tmp0_, value);
#line 78 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_object_notify_by_pspec ((GObject *) self, music_rating_cell_renderer_properties[MUSIC_RATING_CELL_RENDERER_N_STARS_PROPERTY]);
#line 530 "RatingCellRenderer.c"
}

static void
g_cclosure_user_marshal_VOID__INT_OBJECT_STRING (GClosure * closure,
                                                 GValue * return_value,
                                                 guint n_param_values,
                                                 const GValue * param_values,
                                                 gpointer invocation_hint,
                                                 gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_OBJECT_STRING) (gpointer data1, gint arg_1, gpointer arg_2, const char* arg_3, gpointer data2);
	register GMarshalFunc_VOID__INT_OBJECT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_return_if_fail (n_param_values == 4);
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		data1 = closure->data;
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		data2 = param_values->data[0].v_pointer;
#line 555 "RatingCellRenderer.c"
	} else {
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		data1 = param_values->data[0].v_pointer;
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		data2 = closure->data;
#line 561 "RatingCellRenderer.c"
	}
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	callback = (GMarshalFunc_VOID__INT_OBJECT_STRING) (marshal_data ? marshal_data : cc->callback);
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_object (param_values + 2), g_value_get_string (param_values + 3), data2);
#line 567 "RatingCellRenderer.c"
}

static void
music_rating_cell_renderer_class_init (MusicRatingCellRendererClass * klass,
                                       gpointer klass_data)
{
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	music_rating_cell_renderer_parent_class = g_type_class_peek_parent (klass);
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_type_class_adjust_private_offset (klass, &MusicRatingCellRenderer_private_offset);
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	((GtkCellRendererClass *) klass)->render = (void (*) (GtkCellRenderer*, cairo_t*, GtkWidget*, GdkRectangle*, GdkRectangle*, GtkCellRendererState)) music_rating_cell_renderer_real_render;
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	((GtkCellRendererClass *) klass)->activate = (gboolean (*) (GtkCellRenderer*, GdkEvent*, GtkWidget*, const gchar*, GdkRectangle*, GdkRectangle*, GtkCellRendererState)) music_rating_cell_renderer_real_activate;
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_rating_cell_renderer_get_property;
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_rating_cell_renderer_set_property;
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	G_OBJECT_CLASS (klass)->finalize = music_rating_cell_renderer_finalize;
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_RATING_CELL_RENDERER_STAR_SPACING_PROPERTY, music_rating_cell_renderer_properties[MUSIC_RATING_CELL_RENDERER_STAR_SPACING_PROPERTY] = g_param_spec_int ("star-spacing", "star-spacing", "star-spacing", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_RATING_CELL_RENDERER_RATING_PROPERTY, music_rating_cell_renderer_properties[MUSIC_RATING_CELL_RENDERER_RATING_PROPERTY] = g_param_spec_uint ("rating", "rating", "rating", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_RATING_CELL_RENDERER_N_STARS_PROPERTY, music_rating_cell_renderer_properties[MUSIC_RATING_CELL_RENDERER_N_STARS_PROPERTY] = g_param_spec_int ("n-stars", "n-stars", "n-stars", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 594 "RatingCellRenderer.c"
	/**
	     * The rating was set. It is only emmited when the rating changes by activating the renderer.
	     */
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	music_rating_cell_renderer_signals[MUSIC_RATING_CELL_RENDERER_RATING_CHANGED_SIGNAL] = g_signal_new ("rating-changed", MUSIC_TYPE_RATING_CELL_RENDERER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_OBJECT_STRING, G_TYPE_NONE, 3, G_TYPE_INT, gtk_widget_get_type (), G_TYPE_STRING);
#line 600 "RatingCellRenderer.c"
}

static void
music_rating_cell_renderer_instance_init (MusicRatingCellRenderer * self,
                                          gpointer klass)
{
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	self->priv = music_rating_cell_renderer_get_instance_private (self);
#line 67 "../src/Widgets/Rating/RatingCellRenderer.vala"
	self->priv->_rating = (guint) 0;
#line 611 "RatingCellRenderer.c"
}

static void
music_rating_cell_renderer_finalize (GObject * obj)
{
	MusicRatingCellRenderer * self;
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRenderer);
#line 45 "../src/Widgets/Rating/RatingCellRenderer.vala"
	_g_object_unref0 (self->priv->renderer);
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	G_OBJECT_CLASS (music_rating_cell_renderer_parent_class)->finalize (obj);
#line 624 "RatingCellRenderer.c"
}

/**
 * This class makes setting the rating from a cell possible. Unlike the other widgets,
 * it only allows doing so by clicking over a star.
 *
 * When the rating changes by activating (i.e. clicking) the cell renderer, it doesn't re-draw itself
 * automatically and/or apply the new rating right away, since there could be client code wanting
 * to check the new value. Instead, it passes the responsability off to the rating_changed signal handler.
 * That signal handler *must* take care of setting the new rating on the proper cell, and only then
 * the new value will take effect.
 */
static GType
music_rating_cell_renderer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicRatingCellRendererClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_rating_cell_renderer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicRatingCellRenderer), 0, (GInstanceInitFunc) music_rating_cell_renderer_instance_init, NULL };
	GType music_rating_cell_renderer_type_id;
	music_rating_cell_renderer_type_id = g_type_register_static (gtk_cell_renderer_pixbuf_get_type (), "MusicRatingCellRenderer", &g_define_type_info, 0);
	MusicRatingCellRenderer_private_offset = g_type_add_instance_private (music_rating_cell_renderer_type_id, sizeof (MusicRatingCellRendererPrivate));
	return music_rating_cell_renderer_type_id;
}

GType
music_rating_cell_renderer_get_type (void)
{
	static volatile gsize music_rating_cell_renderer_type_id__once = 0;
	if (g_once_init_enter (&music_rating_cell_renderer_type_id__once)) {
		GType music_rating_cell_renderer_type_id;
		music_rating_cell_renderer_type_id = music_rating_cell_renderer_get_type_once ();
		g_once_init_leave (&music_rating_cell_renderer_type_id__once, music_rating_cell_renderer_type_id);
	}
	return music_rating_cell_renderer_type_id__once;
}

static void
_vala_music_rating_cell_renderer_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	MusicRatingCellRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRenderer);
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	switch (property_id) {
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		case MUSIC_RATING_CELL_RENDERER_STAR_SPACING_PROPERTY:
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		g_value_set_int (value, music_rating_cell_renderer_get_star_spacing (self));
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		break;
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		case MUSIC_RATING_CELL_RENDERER_RATING_PROPERTY:
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		g_value_set_uint (value, music_rating_cell_renderer_get_rating (self));
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		break;
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		case MUSIC_RATING_CELL_RENDERER_N_STARS_PROPERTY:
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		g_value_set_int (value, music_rating_cell_renderer_get_n_stars (self));
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		break;
#line 687 "RatingCellRenderer.c"
		default:
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		break;
#line 693 "RatingCellRenderer.c"
	}
}

static void
_vala_music_rating_cell_renderer_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	MusicRatingCellRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRenderer);
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
	switch (property_id) {
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		case MUSIC_RATING_CELL_RENDERER_STAR_SPACING_PROPERTY:
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		music_rating_cell_renderer_set_star_spacing (self, g_value_get_int (value));
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		break;
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		case MUSIC_RATING_CELL_RENDERER_RATING_PROPERTY:
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		music_rating_cell_renderer_set_rating (self, g_value_get_uint (value));
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		break;
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		case MUSIC_RATING_CELL_RENDERER_N_STARS_PROPERTY:
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		music_rating_cell_renderer_set_n_stars (self, g_value_get_int (value));
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		break;
#line 725 "RatingCellRenderer.c"
		default:
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 39 "../src/Widgets/Rating/RatingCellRenderer.vala"
		break;
#line 731 "RatingCellRenderer.c"
	}
}

