/* AudioPlayerDevice.c generated by valac 0.56.0, the Vala compiler
 * generated from AudioPlayerDevice.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "audioplayer-device.h"
#include <gio/gio.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "io.elementary.music-core.h"
#include <stdio.h>
#include "music-lib.h"
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>

enum  {
	MUSIC_PLUGINS_AUDIO_PLAYER_DEVICE_0_PROPERTY,
	MUSIC_PLUGINS_AUDIO_PLAYER_DEVICE_NUM_PROPERTIES
};
static GParamSpec* music_plugins_audio_player_device_properties[MUSIC_PLUGINS_AUDIO_PLAYER_DEVICE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData;

struct _MusicPluginsAudioPlayerDevicePrivate {
	GMount* mount;
	GIcon* icon;
	gboolean is_androphone;
	GeeLinkedList* music_folders;
	MusicPluginsAudioPlayerLibrary* library;
};

struct _MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicPluginsAudioPlayerDevice* self;
	GeeLinkedList* _tmp0_;
	GMount* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GFile* file;
	GMount* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GFile* _tmp15_;
	GFile* _tmp16_;
	GFile* _tmp17_;
	GFileInputStream* _tmp18_;
	GFile* _tmp19_;
	GFileInputStream* _tmp20_;
	GDataInputStream* dis;
	GDataInputStream* _tmp21_;
	gchar* line;
	gchar* _tmp22_;
	GDataInputStream* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	gchar* folders_unparsed;
	const gchar* _tmp28_;
	gchar** _tmp29_;
	gchar** _tmp30_;
	gchar** _tmp31_;
	gint _tmp31__length1;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	const gchar* _tmp35_;
	gchar** _tmp36_;
	gchar** _tmp37_;
	gchar** folder_collection;
	gint folder_collection_length1;
	gint _folder_collection_size_;
	gint folder_it;
	gchar* _tmp38_;
	gchar* folder;
	const gchar* _tmp39_;
	gchar* _tmp40_;
	GeeLinkedList* _tmp41_;
	GMount* _tmp42_;
	GFile* _tmp43_;
	GFile* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	GError* e;
	FILE* _tmp52_;
	GError* _tmp53_;
	const gchar* _tmp54_;
	GeeLinkedList* files;
	GeeLinkedList* _tmp55_;
	gint items;
	GeeLinkedList* _folder_list;
	GeeLinkedList* _tmp56_;
	gint _folder_size;
	GeeLinkedList* _tmp57_;
	gint _tmp58_;
	gint _tmp59_;
	gint _folder_index;
	gint _tmp60_;
	gint _tmp61_;
	gchar* _vala1_folder;
	GeeLinkedList* _tmp62_;
	gpointer _tmp63_;
	GFile* music_folder_file;
	const gchar* _tmp64_;
	GFile* _tmp65_;
	GFile* _tmp66_;
	GeeLinkedList* _tmp67_;
	MusicPluginsAudioPlayerLibrary* _tmp68_;
	MusicGStreamerTagger* _tmp69_;
	GeeLinkedList* _tmp70_;
	GeeLinkedList* _tmp71_;
	gint _tmp72_;
	gint _tmp73_;
	MusicPluginsAudioPlayerLibrary* _tmp74_;
	GError* _inner_error0_;
};

static gint MusicPluginsAudioPlayerDevice_private_offset;
static gpointer music_plugins_audio_player_device_parent_class = NULL;
static MusicDeviceIface * music_plugins_audio_player_device_music_device_parent_iface = NULL;
static GType music_plugins_audio_player_device_type_id = 0;

static void music_plugins_audio_player_device_real_finish_initialization (MusicDevice* base);
static void __lambda8_ (MusicPluginsAudioPlayerDevice* self);
static void ___lambda8__music_device_device_unmounted (MusicDevice* _sender,
                                                gpointer self);
static void music_plugins_audio_player_device_finish_initialization_async (MusicPluginsAudioPlayerDevice* self,
                                                                    GAsyncReadyCallback _callback_,
                                                                    gpointer _user_data_);
static void music_plugins_audio_player_device_finish_initialization_finish (MusicPluginsAudioPlayerDevice* self,
                                                                     GAsyncResult* _res_);
static gboolean music_plugins_audio_player_device_real_start_initialization (MusicDevice* base);
static void music_plugins_audio_player_device_finish_initialization_async_data_free (gpointer _data);
static gboolean music_plugins_audio_player_device_finish_initialization_async_co (MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_);
static gboolean __lambda9_ (MusicPluginsAudioPlayerDevice* self);
static gboolean ___lambda9__gsource_func (gpointer self);
static MusicLibrary* music_plugins_audio_player_device_real_get_library (MusicDevice* base);
static gchar* music_plugins_audio_player_device_real_get_empty_device_title (MusicDevice* base);
static gchar* music_plugins_audio_player_device_real_get_empty_device_description (MusicDevice* base);
static gchar* music_plugins_audio_player_device_real_get_content_type (MusicDevice* base);
static gchar* music_plugins_audio_player_device_real_get_display_name (MusicDevice* base);
static void music_plugins_audio_player_device_real_set_display_name (MusicDevice* base,
                                                              const gchar* name);
static gchar* music_plugins_audio_player_device_real_get_fancy_description (MusicDevice* base);
static void music_plugins_audio_player_device_real_set_mount (MusicDevice* base,
                                                       GMount* mount);
static GMount* music_plugins_audio_player_device_real_get_mount (MusicDevice* base);
static gchar* music_plugins_audio_player_device_real_get_uri (MusicDevice* base);
static void music_plugins_audio_player_device_real_set_icon (MusicDevice* base,
                                                      GIcon* icon);
static GIcon* music_plugins_audio_player_device_real_get_icon (MusicDevice* base);
static guint64 music_plugins_audio_player_device_real_get_capacity (MusicDevice* base);
static gchar* music_plugins_audio_player_device_real_get_fancy_capacity (MusicDevice* base);
static guint64 music_plugins_audio_player_device_real_get_used_space (MusicDevice* base);
static guint64 music_plugins_audio_player_device_real_get_free_space (MusicDevice* base);
static void music_plugins_audio_player_device_real_unmount (MusicDevice* base);
static void music_plugins_audio_player_device_real_eject (MusicDevice* base);
static void music_plugins_audio_player_device_real_synchronize (MusicDevice* base);
static gboolean music_plugins_audio_player_device_real_only_use_custom_view (MusicDevice* base);
static GtkWidget* music_plugins_audio_player_device_real_get_custom_view (MusicDevice* base);
static gboolean music_plugins_audio_player_device_real_read_only (MusicDevice* base);
static void music_plugins_audio_player_device_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
music_plugins_audio_player_device_get_instance_private (MusicPluginsAudioPlayerDevice* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPluginsAudioPlayerDevice_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return self ? g_object_ref (self) : NULL;
#line 231 "AudioPlayerDevice.c"
}

MusicPluginsAudioPlayerDevice*
music_plugins_audio_player_device_construct (GType object_type,
                                             GMount* mount,
                                             gboolean is_androphone)
{
	MusicPluginsAudioPlayerDevice * self = NULL;
	GMount* _tmp0_;
	GeeLinkedList* _tmp1_;
	MusicPluginsAudioPlayerLibrary* _tmp2_;
	MusicLibrariesManager* _tmp3_;
	MusicPluginsAudioPlayerLibrary* _tmp4_;
	const gchar* _tmp5_ = NULL;
	GThemedIcon* _tmp6_;
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_val_if_fail (mount != NULL, NULL);
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) g_object_new (object_type, NULL);
#line 39 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = _g_object_ref0 (mount);
#line 39 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->mount);
#line 39 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->mount = _tmp0_;
#line 40 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->is_androphone = is_androphone;
#line 41 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 41 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->music_folders);
#line 41 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->music_folders = _tmp1_;
#line 42 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp2_ = music_plugins_audio_player_library_new (self);
#line 42 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->library);
#line 42 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->library = _tmp2_;
#line 43 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp3_ = music_libraries_manager;
#line 43 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp4_ = self->priv->library;
#line 43 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	music_libraries_manager_add_library (_tmp3_, (MusicLibrary*) _tmp4_);
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (is_androphone) {
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = "phone";
#line 281 "AudioPlayerDevice.c"
	} else {
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = "music-player";
#line 285 "AudioPlayerDevice.c"
	}
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp6_ = (GThemedIcon*) g_themed_icon_new (_tmp5_);
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->icon);
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->icon = (GIcon*) _tmp6_;
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return self;
#line 295 "AudioPlayerDevice.c"
}

MusicPluginsAudioPlayerDevice*
music_plugins_audio_player_device_new (GMount* mount,
                                       gboolean is_androphone)
{
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return music_plugins_audio_player_device_construct (MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, mount, is_androphone);
#line 304 "AudioPlayerDevice.c"
}

static void
__lambda8_ (MusicPluginsAudioPlayerDevice* self)
{
}

static void
___lambda8__music_device_device_unmounted (MusicDevice* _sender,
                                           gpointer self)
{
#line 48 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	__lambda8_ ((MusicPluginsAudioPlayerDevice*) self);
#line 318 "AudioPlayerDevice.c"
}

static void
music_plugins_audio_player_device_real_finish_initialization (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
#line 47 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 48 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_signal_connect_object ((MusicDevice*) self, "device-unmounted", (GCallback) ___lambda8__music_device_device_unmounted, self, 0);
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	music_plugins_audio_player_device_finish_initialization_async (self, NULL, NULL);
#line 331 "AudioPlayerDevice.c"
}

static gboolean
music_plugins_audio_player_device_real_start_initialization (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	gboolean result;
#line 55 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 56 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = TRUE;
#line 56 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 345 "AudioPlayerDevice.c"
}

static void
music_plugins_audio_player_device_finish_initialization_async_data_free (gpointer _data)
{
	MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
	_data_ = _data;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_slice_free (MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData, _data_);
#line 357 "AudioPlayerDevice.c"
}

static void
music_plugins_audio_player_device_finish_initialization_async (MusicPluginsAudioPlayerDevice* self,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_)
{
	MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
	MusicPluginsAudioPlayerDevice* _tmp0_;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_if_fail (self != NULL);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_ = g_slice_new0 (MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_plugins_audio_player_device_finish_initialization_async_data_free);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->self = _tmp0_;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	music_plugins_audio_player_device_finish_initialization_async_co (_data_);
#line 381 "AudioPlayerDevice.c"
}

static void
music_plugins_audio_player_device_finish_initialization_finish (MusicPluginsAudioPlayerDevice* self,
                                                                GAsyncResult* _res_)
{
	MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 391 "AudioPlayerDevice.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 410 "AudioPlayerDevice.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 432 "AudioPlayerDevice.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 436 "AudioPlayerDevice.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 442 "AudioPlayerDevice.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 446 "AudioPlayerDevice.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 450 "AudioPlayerDevice.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 458 "AudioPlayerDevice.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 486 "AudioPlayerDevice.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 495 "AudioPlayerDevice.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 509 "AudioPlayerDevice.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 518 "AudioPlayerDevice.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 532 "AudioPlayerDevice.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 541 "AudioPlayerDevice.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 550 "AudioPlayerDevice.c"
}

static gboolean
__lambda9_ (MusicPluginsAudioPlayerDevice* self)
{
	gboolean result;
#line 100 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = FALSE;
#line 100 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 561 "AudioPlayerDevice.c"
}

static gboolean
___lambda9__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda9_ ((MusicPluginsAudioPlayerDevice*) self);
#line 99 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 571 "AudioPlayerDevice.c"
}

static gboolean
music_plugins_audio_player_device_finish_initialization_async_co (MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_)
{
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	switch (_data_->_state_) {
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		case 0:
#line 581 "AudioPlayerDevice.c"
		goto _state_0;
		default:
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_assert_not_reached ();
#line 586 "AudioPlayerDevice.c"
	}
	_state_0:
#line 60 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_data_->self->priv->is_androphone) {
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp0_ = _data_->self->priv->music_folders;
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp1_ = _data_->self->priv->mount;
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp2_ = g_mount_get_root (_data_->_tmp1_);
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp4_ = g_file_get_uri (_data_->_tmp3_);
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp6_ = g_strconcat (_data_->_tmp5_, "/Music/", NULL);
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp0_, _data_->_tmp7_);
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_data_->_tmp7_);
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_data_->_tmp5_);
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_data_->_tmp3_);
#line 615 "AudioPlayerDevice.c"
	} else {
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp8_ = _data_->self->priv->mount;
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp9_ = g_mount_get_root (_data_->_tmp8_);
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp11_ = g_file_get_uri (_data_->_tmp10_);
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp13_ = g_strconcat (_data_->_tmp12_, "/.is_audio_player", NULL);
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp15_ = g_file_new_for_uri (_data_->_tmp14_);
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp16_ = _data_->_tmp15_;
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_data_->_tmp14_);
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_data_->_tmp12_);
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_data_->_tmp10_);
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->file = _data_->_tmp16_;
#line 643 "AudioPlayerDevice.c"
		{
#line 66 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp17_ = _data_->file;
#line 66 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			if (g_file_query_exists (_data_->_tmp17_, NULL) == TRUE) {
#line 67 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->_tmp19_ = _data_->file;
#line 67 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->_tmp20_ = g_file_read (_data_->_tmp19_, NULL, &_data_->_inner_error0_);
#line 67 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->_tmp18_ = _data_->_tmp20_;
#line 67 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 657 "AudioPlayerDevice.c"
					goto __catch0_g_error;
				}
#line 67 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->_tmp21_ = g_data_input_stream_new ((GInputStream*) _data_->_tmp18_);
#line 67 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->dis = _data_->_tmp21_;
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				while (TRUE) {
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp23_ = _data_->dis;
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp24_ = g_data_input_stream_read_line (_data_->_tmp23_, NULL, NULL, &_data_->_inner_error0_);
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp22_ = _data_->_tmp24_;
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (_data_->line);
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_object_unref0 (_data_->dis);
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_object_unref0 (_data_->_tmp18_);
#line 680 "AudioPlayerDevice.c"
						goto __catch0_g_error;
					}
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp25_ = _data_->_tmp22_;
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp22_ = NULL;
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_g_free0 (_data_->line);
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->line = _data_->_tmp25_;
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp26_ = _data_->line;
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (!(_data_->_tmp26_ != NULL)) {
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (_data_->_tmp22_);
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						break;
#line 699 "AudioPlayerDevice.c"
					}
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp27_ = _data_->line;
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (string_contains (_data_->_tmp27_, "audio_folders=")) {
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp28_ = _data_->line;
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp30_ = _data_->_tmp29_ = g_strsplit (_data_->_tmp28_, "audio_folders=", 2);
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp31_ = _data_->_tmp30_;
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp31__length1 = _vala_array_length (_data_->_tmp29_);
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp32_ = _data_->_tmp31_[1];
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp33_ = g_strdup (_data_->_tmp32_);
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp34_ = _data_->_tmp33_;
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp31_ = (_vala_array_free (_data_->_tmp31_, _data_->_tmp31__length1, (GDestroyNotify) g_free), NULL);
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->folders_unparsed = _data_->_tmp34_;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp35_ = _data_->folders_unparsed;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp37_ = _data_->_tmp36_ = g_strsplit (_data_->_tmp35_, ",", 0);
#line 727 "AudioPlayerDevice.c"
						{
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->folder_collection_length1 = 0;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->_folder_collection_size_ = 0;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->folder_collection = _data_->_tmp37_;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->folder_collection_length1 = _vala_array_length (_data_->_tmp36_);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							for (_data_->folder_it = 0; _data_->folder_it < _data_->folder_collection_length1; _data_->folder_it = _data_->folder_it + 1) {
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
								_data_->_tmp38_ = g_strdup (_data_->folder_collection[_data_->folder_it]);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
								_data_->folder = _data_->_tmp38_;
#line 743 "AudioPlayerDevice.c"
								{
#line 74 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp39_ = _data_->folder;
#line 74 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp40_ = string_replace (_data_->_tmp39_, " ", "");
#line 74 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->folder);
#line 74 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->folder = _data_->_tmp40_;
#line 75 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp41_ = _data_->self->priv->music_folders;
#line 75 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp42_ = _data_->self->priv->mount;
#line 75 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp43_ = g_mount_get_root (_data_->_tmp42_);
#line 75 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp44_ = _data_->_tmp43_;
#line 75 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp45_ = g_file_get_uri (_data_->_tmp44_);
#line 75 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp46_ = _data_->_tmp45_;
#line 75 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp47_ = g_strconcat (_data_->_tmp46_, "/", NULL);
#line 75 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp48_ = _data_->_tmp47_;
#line 75 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp49_ = _data_->folder;
#line 75 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp50_ = g_strconcat (_data_->_tmp48_, _data_->_tmp49_, NULL);
#line 75 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp51_ = _data_->_tmp50_;
#line 75 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp41_, _data_->_tmp51_);
#line 75 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->_tmp51_);
#line 75 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->_tmp48_);
#line 75 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->_tmp46_);
#line 75 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_object_unref0 (_data_->_tmp44_);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->folder);
#line 787 "AudioPlayerDevice.c"
								}
							}
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->folder_collection = (_vala_array_free (_data_->folder_collection, _data_->folder_collection_length1, (GDestroyNotify) g_free), NULL);
#line 792 "AudioPlayerDevice.c"
						}
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (_data_->folders_unparsed);
#line 796 "AudioPlayerDevice.c"
					}
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_g_free0 (_data_->_tmp22_);
#line 800 "AudioPlayerDevice.c"
				}
#line 66 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_free0 (_data_->line);
#line 66 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_object_unref0 (_data_->dis);
#line 66 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_object_unref0 (_data_->_tmp18_);
#line 808 "AudioPlayerDevice.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->e = _data_->_inner_error0_;
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_inner_error0_ = NULL;
#line 81 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp52_ = stderr;
#line 81 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp53_ = _data_->e;
#line 81 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp54_ = _data_->_tmp53_->message;
#line 81 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			fprintf (_data_->_tmp52_, "Error: %s\n", _data_->_tmp54_);
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_error_free0 (_data_->e);
#line 828 "AudioPlayerDevice.c"
		}
		__finally0:
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_object_unref0 (_data_->file);
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_object_unref (_data_->_async_result);
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			return FALSE;
#line 843 "AudioPlayerDevice.c"
		}
#line 60 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_data_->file);
#line 847 "AudioPlayerDevice.c"
	}
#line 85 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp55_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 85 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->files = _data_->_tmp55_;
#line 86 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->items = 0;
#line 855 "AudioPlayerDevice.c"
	{
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp56_ = _data_->self->priv->music_folders;
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_folder_list = _data_->_tmp56_;
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp57_ = _data_->_folder_list;
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp58_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp57_);
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp59_ = _data_->_tmp58_;
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_folder_size = _data_->_tmp59_;
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_folder_index = -1;
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		while (TRUE) {
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_folder_index = _data_->_folder_index + 1;
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp60_ = _data_->_folder_index;
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp61_ = _data_->_folder_size;
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			if (!(_data_->_tmp60_ < _data_->_tmp61_)) {
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				break;
#line 883 "AudioPlayerDevice.c"
			}
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp62_ = _data_->_folder_list;
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp63_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp62_, _data_->_folder_index);
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_vala1_folder = (gchar*) _data_->_tmp63_;
#line 88 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp64_ = _data_->_vala1_folder;
#line 88 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp65_ = g_file_new_for_uri (_data_->_tmp64_);
#line 88 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->music_folder_file = _data_->_tmp65_;
#line 89 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp66_ = _data_->music_folder_file;
#line 89 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp67_ = _data_->files;
#line 89 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->items += music_file_utils_count_music_files (_data_->_tmp66_, (GeeCollection*) _data_->_tmp67_);
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_object_unref0 (_data_->music_folder_file);
#line 87 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_free0 (_data_->_vala1_folder);
#line 907 "AudioPlayerDevice.c"
		}
	}
#line 92 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_debug ("AudioPlayerDevice.vala:92: found %d items to import\n", _data_->items);
#line 93 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp68_ = _data_->self->priv->library;
#line 93 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp69_ = _data_->_tmp68_->tagger;
#line 93 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp70_ = _data_->files;
#line 93 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	music_gstreamer_tagger_discoverer_import_media (_data_->_tmp69_, (GeeCollection*) _data_->_tmp70_);
#line 95 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp71_ = _data_->files;
#line 95 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp72_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp71_);
#line 95 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp73_ = _data_->_tmp72_;
#line 95 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_data_->_tmp73_ == 0) {
#line 96 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp74_ = _data_->self->priv->library;
#line 96 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		music_plugins_audio_player_library_queue_finished (_data_->_tmp74_);
#line 932 "AudioPlayerDevice.c"
	}
#line 99 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda9__gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (_data_->files);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_data_->_state_ != 0) {
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 946 "AudioPlayerDevice.c"
		}
	}
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_object_unref (_data_->_async_result);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return FALSE;
#line 953 "AudioPlayerDevice.c"
}

static MusicLibrary*
music_plugins_audio_player_device_real_get_library (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	MusicPluginsAudioPlayerLibrary* _tmp0_;
	MusicLibrary* _tmp1_;
	MusicLibrary* result;
#line 104 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 105 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->library;
#line 105 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = _g_object_ref0 ((MusicLibrary*) _tmp0_);
#line 105 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp1_;
#line 105 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 973 "AudioPlayerDevice.c"
}

static gchar*
music_plugins_audio_player_device_real_get_empty_device_title (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	gchar* _tmp0_;
	gchar* result;
#line 108 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = g_strdup (_ ("Empty device!"));
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp0_;
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 990 "AudioPlayerDevice.c"
}

static gchar*
music_plugins_audio_player_device_real_get_empty_device_description (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	gchar* _tmp0_;
	gchar* result;
#line 112 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 113 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = g_strdup (_ ("This device does not contain any music."));
#line 113 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp0_;
#line 113 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1007 "AudioPlayerDevice.c"
}

static gchar*
music_plugins_audio_player_device_real_get_content_type (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	gchar* result;
#line 116 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 117 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (self->priv->is_androphone) {
#line 1019 "AudioPlayerDevice.c"
		gchar* _tmp0_;
#line 118 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp0_ = g_strdup ("android");
#line 118 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp0_;
#line 118 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1027 "AudioPlayerDevice.c"
	} else {
		gchar* _tmp1_;
#line 120 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = g_strdup ("audioplayer");
#line 120 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp1_;
#line 120 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1036 "AudioPlayerDevice.c"
	}
}

static gchar*
music_plugins_audio_player_device_real_get_display_name (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (self->priv->is_androphone) {
#line 1050 "AudioPlayerDevice.c"
		GMount* _tmp0_;
		gchar* _tmp1_;
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp0_ = self->priv->mount;
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = g_mount_get_name (_tmp0_);
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp1_;
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1061 "AudioPlayerDevice.c"
	} else {
		GFile* file = NULL;
		GMount* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GFile* _tmp9_;
		GFile* _tmp10_;
		gchar* name = NULL;
		GMount* _tmp11_;
		gchar* _tmp12_;
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = self->priv->mount;
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp3_ = g_mount_get_root (_tmp2_);
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp4_ = _tmp3_;
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = g_file_get_path (_tmp4_);
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp6_ = _tmp5_;
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp7_ = g_strconcat (_tmp6_, "/.is_audio_player", NULL);
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp8_ = _tmp7_;
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp9_ = g_file_new_for_path (_tmp8_);
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp10_ = _tmp9_;
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_tmp8_);
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_tmp6_);
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp4_);
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		file = _tmp10_;
#line 128 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp11_ = self->priv->mount;
#line 128 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp12_ = g_mount_get_name (_tmp11_);
#line 128 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		name = _tmp12_;
#line 1108 "AudioPlayerDevice.c"
		{
			GFile* _tmp13_;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_tmp13_ = file;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			if (g_file_query_exists (_tmp13_, NULL) == TRUE) {
#line 1115 "AudioPlayerDevice.c"
				GFileInputStream* _tmp14_ = NULL;
				GFile* _tmp15_;
				GFileInputStream* _tmp16_;
				GDataInputStream* dis = NULL;
				GDataInputStream* _tmp17_;
				gchar* line = NULL;
#line 131 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_tmp15_ = file;
#line 131 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_tmp16_ = g_file_read (_tmp15_, NULL, &_inner_error0_);
#line 131 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_tmp14_ = _tmp16_;
#line 131 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1130 "AudioPlayerDevice.c"
					goto __catch0_g_error;
				}
#line 131 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_tmp17_ = g_data_input_stream_new ((GInputStream*) _tmp14_);
#line 131 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				dis = _tmp17_;
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				while (TRUE) {
#line 1139 "AudioPlayerDevice.c"
					gchar* _tmp18_ = NULL;
					GDataInputStream* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					const gchar* _tmp22_;
					const gchar* _tmp23_;
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp19_ = dis;
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp20_ = g_data_input_stream_read_line (_tmp19_, NULL, NULL, &_inner_error0_);
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp18_ = _tmp20_;
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (line);
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_object_unref0 (dis);
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_object_unref0 (_tmp14_);
#line 1160 "AudioPlayerDevice.c"
						goto __catch0_g_error;
					}
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp21_ = _tmp18_;
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp18_ = NULL;
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_g_free0 (line);
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					line = _tmp21_;
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp22_ = line;
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (!(_tmp22_ != NULL)) {
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (_tmp18_);
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						break;
#line 1179 "AudioPlayerDevice.c"
					}
#line 135 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp23_ = line;
#line 135 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (string_contains (_tmp23_, "name=")) {
#line 1185 "AudioPlayerDevice.c"
						gchar* names_unparsed = NULL;
						const gchar* _tmp24_;
						gchar** _tmp25_;
						gchar** _tmp26_;
						gchar** _tmp27_;
						gint _tmp27__length1;
						const gchar* _tmp28_;
						gchar* _tmp29_;
						gchar* _tmp30_;
						const gchar* _tmp31_;
						gchar** _tmp32_;
						gchar** _tmp33_;
#line 136 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp24_ = line;
#line 136 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp26_ = _tmp25_ = g_strsplit (_tmp24_, "name=", 2);
#line 136 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp27_ = _tmp26_;
#line 136 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp27__length1 = _vala_array_length (_tmp25_);
#line 136 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp28_ = _tmp27_[1];
#line 136 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp29_ = g_strdup (_tmp28_);
#line 136 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp30_ = _tmp29_;
#line 136 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp27_ = (_vala_array_free (_tmp27_, _tmp27__length1, (GDestroyNotify) g_free), NULL);
#line 136 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						names_unparsed = _tmp30_;
#line 137 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp31_ = names_unparsed;
#line 137 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp33_ = _tmp32_ = g_strsplit (_tmp31_, "\"", 0);
#line 1220 "AudioPlayerDevice.c"
						{
							gchar** names_collection = NULL;
							gint names_collection_length1 = 0;
							gint _names_collection_size_ = 0;
							gint names_it = 0;
#line 137 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							names_collection = _tmp33_;
#line 137 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							names_collection_length1 = _vala_array_length (_tmp32_);
#line 137 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							for (names_it = 0; names_it < names_collection_length1; names_it = names_it + 1) {
#line 1232 "AudioPlayerDevice.c"
								gchar* _tmp34_;
								gchar* names = NULL;
#line 137 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
								_tmp34_ = g_strdup (names_collection[names_it]);
#line 137 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
								names = _tmp34_;
#line 1239 "AudioPlayerDevice.c"
								{
									gboolean _tmp35_ = FALSE;
									const gchar* _tmp36_;
#line 138 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_tmp36_ = names;
#line 138 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									if (_tmp36_ != NULL) {
#line 1247 "AudioPlayerDevice.c"
										const gchar* _tmp37_;
#line 138 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp37_ = names;
#line 138 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp35_ = g_strcmp0 (_tmp37_, "") != 0;
#line 1253 "AudioPlayerDevice.c"
									} else {
#line 138 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp35_ = FALSE;
#line 1257 "AudioPlayerDevice.c"
									}
#line 138 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									if (_tmp35_) {
#line 1261 "AudioPlayerDevice.c"
										const gchar* _tmp38_;
										gchar* _tmp39_;
#line 139 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp38_ = names;
#line 139 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp39_ = g_strdup (_tmp38_);
#line 139 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_g_free0 (name);
#line 139 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										name = _tmp39_;
#line 1272 "AudioPlayerDevice.c"
									}
#line 137 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (names);
#line 1276 "AudioPlayerDevice.c"
								}
							}
#line 137 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							names_collection = (_vala_array_free (names_collection, names_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1281 "AudioPlayerDevice.c"
						}
#line 135 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (names_unparsed);
#line 1285 "AudioPlayerDevice.c"
					}
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_g_free0 (_tmp18_);
#line 1289 "AudioPlayerDevice.c"
				}
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_free0 (line);
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_object_unref0 (dis);
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_object_unref0 (_tmp14_);
#line 1297 "AudioPlayerDevice.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			FILE* _tmp40_;
			GError* _tmp41_;
			const gchar* _tmp42_;
#line 129 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			e = _inner_error0_;
#line 129 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_inner_error0_ = NULL;
#line 146 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_tmp40_ = stderr;
#line 146 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_tmp41_ = e;
#line 146 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_tmp42_ = _tmp41_->message;
#line 146 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			fprintf (_tmp40_, "Error: %s\n", _tmp42_);
#line 129 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_error_free0 (e);
#line 1321 "AudioPlayerDevice.c"
		}
		__finally0:
#line 129 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 129 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_free0 (name);
#line 129 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_object_unref0 (file);
#line 129 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 129 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_clear_error (&_inner_error0_);
#line 129 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			return NULL;
#line 1336 "AudioPlayerDevice.c"
		}
#line 148 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = name;
#line 148 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (file);
#line 148 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1344 "AudioPlayerDevice.c"
	}
}

static void
music_plugins_audio_player_device_real_set_display_name (MusicDevice* base,
                                                         const gchar* name)
{
	MusicPluginsAudioPlayerDevice * self;
#line 152 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 152 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_if_fail (name != NULL);
#line 1357 "AudioPlayerDevice.c"
}

static gchar*
music_plugins_audio_player_device_real_get_fancy_description (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	gchar* result;
#line 156 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 157 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (self->priv->is_androphone) {
#line 1369 "AudioPlayerDevice.c"
		gchar* _tmp0_;
#line 158 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp0_ = g_strdup (_ ("Android Phone"));
#line 158 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp0_;
#line 158 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1377 "AudioPlayerDevice.c"
	} else {
		gchar* _tmp1_;
#line 160 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = g_strdup (_ ("Audio Player"));
#line 160 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp1_;
#line 160 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1386 "AudioPlayerDevice.c"
	}
}

static void
music_plugins_audio_player_device_real_set_mount (MusicDevice* base,
                                                  GMount* mount)
{
	MusicPluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
#line 164 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 164 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_if_fail (mount != NULL);
#line 165 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = _g_object_ref0 (mount);
#line 165 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->mount);
#line 165 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->mount = _tmp0_;
#line 1406 "AudioPlayerDevice.c"
}

static GMount*
music_plugins_audio_player_device_real_get_mount (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
	GMount* _tmp1_;
	GMount* result;
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 169 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->mount;
#line 169 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 169 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp1_;
#line 169 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1426 "AudioPlayerDevice.c"
}

static gchar*
music_plugins_audio_player_device_real_get_uri (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 172 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 173 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->mount;
#line 173 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = g_mount_get_default_location (_tmp0_);
#line 173 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp2_ = _tmp1_;
#line 173 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp3_ = g_file_get_uri (_tmp2_);
#line 173 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp4_ = _tmp3_;
#line 173 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (_tmp2_);
#line 173 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp4_;
#line 173 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1457 "AudioPlayerDevice.c"
}

static void
music_plugins_audio_player_device_real_set_icon (MusicDevice* base,
                                                 GIcon* icon)
{
	MusicPluginsAudioPlayerDevice * self;
	GIcon* _tmp0_;
#line 176 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 176 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_if_fail (icon != NULL);
#line 177 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = _g_object_ref0 (icon);
#line 177 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->icon);
#line 177 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->icon = _tmp0_;
#line 1476 "AudioPlayerDevice.c"
}

static GIcon*
music_plugins_audio_player_device_real_get_icon (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	GIcon* _tmp0_;
	GIcon* _tmp1_;
	GIcon* result;
#line 180 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 181 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->icon;
#line 181 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 181 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp1_;
#line 181 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1496 "AudioPlayerDevice.c"
}

static guint64
music_plugins_audio_player_device_real_get_capacity (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	guint64 rv = 0ULL;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 184 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 185 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	rv = (guint64) 0;
#line 1510 "AudioPlayerDevice.c"
	{
		GFileInfo* file_info = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 188 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp0_ = music_device_get_uri ((MusicDevice*) self);
#line 188 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = _tmp0_;
#line 188 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = g_file_new_for_uri (_tmp1_);
#line 188 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp3_ = _tmp2_;
#line 188 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp4_ = g_file_query_filesystem_info (_tmp3_, "filesystem::*", NULL, &_inner_error0_);
#line 188 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = _tmp4_;
#line 188 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp3_);
#line 188 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_tmp1_);
#line 188 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		file_info = _tmp5_;
#line 188 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "AudioPlayerDevice.c"
			goto __catch0_g_error;
		}
#line 189 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		rv = g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_FILESYSTEM_SIZE);
#line 187 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (file_info);
#line 1546 "AudioPlayerDevice.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 187 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		err = _inner_error0_;
#line 187 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_inner_error0_ = NULL;
#line 191 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp6_ = stdout;
#line 191 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp7_ = err;
#line 191 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp8_ = _tmp7_->message;
#line 191 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		fprintf (_tmp6_, "Error calculating capacity of iPod: %s\n", _tmp8_);
#line 187 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_error_free0 (err);
#line 1569 "AudioPlayerDevice.c"
	}
	__finally0:
#line 187 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1574 "AudioPlayerDevice.c"
		guint64 _tmp9_ = 0ULL;
#line 187 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 187 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_clear_error (&_inner_error0_);
#line 187 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return _tmp9_;
#line 1582 "AudioPlayerDevice.c"
	}
#line 194 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = (guint64) rv;
#line 194 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1588 "AudioPlayerDevice.c"
}

static gchar*
music_plugins_audio_player_device_real_get_fancy_capacity (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	gchar* _tmp0_;
	gchar* result;
#line 197 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 198 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = g_format_size_full (music_device_get_capacity ((MusicDevice*) self), G_FORMAT_SIZE_DEFAULT);
#line 198 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp0_;
#line 198 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1605 "AudioPlayerDevice.c"
}

static guint64
music_plugins_audio_player_device_real_get_used_space (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	guint64 result;
#line 201 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 202 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = music_device_get_capacity ((MusicDevice*) self) - music_device_get_free_space ((MusicDevice*) self);
#line 202 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1619 "AudioPlayerDevice.c"
}

gchar*
music_plugins_audio_player_device_get_music_folder (MusicPluginsAudioPlayerDevice* self)
{
	GeeLinkedList* _tmp0_;
	gpointer _tmp1_;
	gchar* result;
#line 205 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 206 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->music_folders;
#line 206 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
#line 206 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = (gchar*) _tmp1_;
#line 206 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1638 "AudioPlayerDevice.c"
}

static guint64
music_plugins_audio_player_device_real_get_free_space (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	guint64 rv = 0ULL;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 209 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 210 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	rv = (guint64) 0;
#line 1652 "AudioPlayerDevice.c"
	{
		GFileInfo* file_info = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp0_ = music_device_get_uri ((MusicDevice*) self);
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = _tmp0_;
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = g_file_new_for_uri (_tmp1_);
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp3_ = _tmp2_;
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp4_ = g_file_query_filesystem_info (_tmp3_, "filesystem::*", NULL, &_inner_error0_);
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = _tmp4_;
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp3_);
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_tmp1_);
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		file_info = _tmp5_;
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1681 "AudioPlayerDevice.c"
			goto __catch0_g_error;
		}
#line 214 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		rv = g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_FILESYSTEM_FREE);
#line 212 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (file_info);
#line 1688 "AudioPlayerDevice.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 212 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		err = _inner_error0_;
#line 212 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_inner_error0_ = NULL;
#line 216 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp6_ = stdout;
#line 216 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp7_ = err;
#line 216 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp8_ = _tmp7_->message;
#line 216 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		fprintf (_tmp6_, "Error calculating free space on iPod: %s\n", _tmp8_);
#line 212 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_error_free0 (err);
#line 1711 "AudioPlayerDevice.c"
	}
	__finally0:
#line 212 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1716 "AudioPlayerDevice.c"
		guint64 _tmp9_ = 0ULL;
#line 212 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 212 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_clear_error (&_inner_error0_);
#line 212 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return _tmp9_;
#line 1724 "AudioPlayerDevice.c"
	}
#line 219 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = rv;
#line 219 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1730 "AudioPlayerDevice.c"
}

static void
music_plugins_audio_player_device_real_unmount (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
#line 222 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->mount;
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_mount_unmount_with_operation (_tmp0_, G_MOUNT_UNMOUNT_NONE, NULL, NULL, NULL, NULL);
#line 1744 "AudioPlayerDevice.c"
}

static void
music_plugins_audio_player_device_real_eject (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
#line 226 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 227 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->mount;
#line 227 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (g_mount_can_eject (_tmp0_)) {
#line 1758 "AudioPlayerDevice.c"
		GMount* _tmp1_;
		GVolume* _tmp2_;
		GVolume* _tmp3_;
		GDrive* _tmp4_;
		GDrive* _tmp5_;
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = self->priv->mount;
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = g_mount_get_volume (_tmp1_);
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp3_ = _tmp2_;
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp4_ = g_volume_get_drive (_tmp3_);
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = _tmp4_;
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_drive_eject_with_operation (_tmp5_, G_MOUNT_UNMOUNT_NONE, NULL, NULL, NULL, NULL);
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp5_);
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp3_);
#line 1780 "AudioPlayerDevice.c"
	}
}

static void
music_plugins_audio_player_device_real_synchronize (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
#line 232 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 1790 "AudioPlayerDevice.c"
}

static gboolean
music_plugins_audio_player_device_real_only_use_custom_view (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	gboolean result;
#line 236 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 237 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = FALSE;
#line 237 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1804 "AudioPlayerDevice.c"
}

static GtkWidget*
music_plugins_audio_player_device_real_get_custom_view (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	GtkWidget* result;
#line 240 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 241 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = NULL;
#line 241 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1818 "AudioPlayerDevice.c"
}

static gboolean
music_plugins_audio_player_device_real_read_only (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	gboolean result;
#line 244 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (MusicPluginsAudioPlayerDevice*) base;
#line 245 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = FALSE;
#line 245 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1832 "AudioPlayerDevice.c"
}

static void
music_plugins_audio_player_device_class_init (MusicPluginsAudioPlayerDeviceClass * klass,
                                              gpointer klass_data)
{
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	music_plugins_audio_player_device_parent_class = g_type_class_peek_parent (klass);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_type_class_adjust_private_offset (klass, &MusicPluginsAudioPlayerDevice_private_offset);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	G_OBJECT_CLASS (klass)->finalize = music_plugins_audio_player_device_finalize;
#line 1845 "AudioPlayerDevice.c"
}

static void
music_plugins_audio_player_device_music_device_interface_init (MusicDeviceIface * iface,
                                                               gpointer iface_data)
{
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	music_plugins_audio_player_device_music_device_parent_iface = g_type_interface_peek_parent (iface);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->finish_initialization = (void (*) (MusicDevice*)) music_plugins_audio_player_device_real_finish_initialization;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->start_initialization = (gboolean (*) (MusicDevice*)) music_plugins_audio_player_device_real_start_initialization;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_library = (MusicLibrary* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_library;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_empty_device_title = (gchar* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_empty_device_title;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_empty_device_description = (gchar* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_empty_device_description;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_content_type = (gchar* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_content_type;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_display_name = (gchar* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_display_name;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->set_display_name = (void (*) (MusicDevice*, const gchar*)) music_plugins_audio_player_device_real_set_display_name;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_fancy_description = (gchar* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_fancy_description;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->set_mount = (void (*) (MusicDevice*, GMount*)) music_plugins_audio_player_device_real_set_mount;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_mount = (GMount* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_mount;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_uri = (gchar* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_uri;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->set_icon = (void (*) (MusicDevice*, GIcon*)) music_plugins_audio_player_device_real_set_icon;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_icon = (GIcon* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_icon;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_capacity = (guint64 (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_capacity;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_fancy_capacity = (gchar* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_fancy_capacity;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_used_space = (guint64 (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_used_space;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_free_space = (guint64 (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_free_space;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->unmount = (void (*) (MusicDevice*)) music_plugins_audio_player_device_real_unmount;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->eject = (void (*) (MusicDevice*)) music_plugins_audio_player_device_real_eject;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->synchronize = (void (*) (MusicDevice*)) music_plugins_audio_player_device_real_synchronize;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->only_use_custom_view = (gboolean (*) (MusicDevice*)) music_plugins_audio_player_device_real_only_use_custom_view;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_custom_view = (GtkWidget* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_custom_view;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->read_only = (gboolean (*) (MusicDevice*)) music_plugins_audio_player_device_real_read_only;
#line 1902 "AudioPlayerDevice.c"
}

static void
music_plugins_audio_player_device_instance_init (MusicPluginsAudioPlayerDevice * self,
                                                 gpointer klass)
{
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv = music_plugins_audio_player_device_get_instance_private (self);
#line 33 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->is_androphone = FALSE;
#line 1913 "AudioPlayerDevice.c"
}

static void
music_plugins_audio_player_device_finalize (GObject * obj)
{
	MusicPluginsAudioPlayerDevice * self;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, MusicPluginsAudioPlayerDevice);
#line 31 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->mount);
#line 32 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->icon);
#line 34 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->music_folders);
#line 36 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->library);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	G_OBJECT_CLASS (music_plugins_audio_player_device_parent_class)->finalize (obj);
#line 1932 "AudioPlayerDevice.c"
}

GType
music_plugins_audio_player_device_get_type (void)
{
	return music_plugins_audio_player_device_type_id;
}

GType
music_plugins_audio_player_device_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsAudioPlayerDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_audio_player_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsAudioPlayerDevice), 0, (GInstanceInitFunc) music_plugins_audio_player_device_instance_init, NULL };
	static const GInterfaceInfo music_device_info = { (GInterfaceInitFunc) music_plugins_audio_player_device_music_device_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	music_plugins_audio_player_device_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MusicPluginsAudioPlayerDevice", &g_define_type_info, 0);
	g_type_module_add_interface (module, music_plugins_audio_player_device_type_id, MUSIC_TYPE_DEVICE, &music_device_info);
	MusicPluginsAudioPlayerDevice_private_offset = sizeof (MusicPluginsAudioPlayerDevicePrivate);
	return music_plugins_audio_player_device_type_id;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

