/* AudioPlayerDeviceManager.c generated by valac 0.56.0, the Vala compiler
 * generated from AudioPlayerDeviceManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "audioplayer-device.h"
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>

enum  {
	MUSIC_PLUGINS_AUDIO_PLAYER_DEVICE_MANAGER_0_PROPERTY,
	MUSIC_PLUGINS_AUDIO_PLAYER_DEVICE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* music_plugins_audio_player_device_manager_properties[MUSIC_PLUGINS_AUDIO_PLAYER_DEVICE_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MusicPluginsAudioPlayerDeviceManagerPrivate {
	GeeArrayList* devices;
};

static gint MusicPluginsAudioPlayerDeviceManager_private_offset;
static gpointer music_plugins_audio_player_device_manager_parent_class = NULL;
static GType music_plugins_audio_player_device_manager_type_id = 0;

static void _music_plugins_audio_player_device_manager_mount_added_music_device_manager_mount_added (MusicDeviceManager* _sender,
                                                                                              GMount* mount,
                                                                                              gpointer self);
static void _music_plugins_audio_player_device_manager_mount_removed_music_device_manager_mount_removed (MusicDeviceManager* _sender,
                                                                                                  GMount* mount,
                                                                                                  gpointer self);
static void music_plugins_audio_player_device_manager_real_mount_added (MusicPluginsAudioPlayerDeviceManager* self,
                                                                 GMount* mount);
static void ____lambda10_ (MusicPluginsAudioPlayerDeviceManager* self,
                    MusicDevice* d);
static void _____lambda10__music_device_initialized (MusicDevice* _sender,
                                              MusicDevice* d,
                                              gpointer self);
static void music_plugins_audio_player_device_manager_real_mount_changed (MusicPluginsAudioPlayerDeviceManager* self,
                                                                   GMount* mount);
static void music_plugins_audio_player_device_manager_real_mount_pre_unmount (MusicPluginsAudioPlayerDeviceManager* self,
                                                                       GMount* mount);
static void music_plugins_audio_player_device_manager_real_mount_removed (MusicPluginsAudioPlayerDeviceManager* self,
                                                                   GMount* mount);
static void music_plugins_audio_player_device_manager_finalize (GObject * obj);

static inline gpointer
music_plugins_audio_player_device_manager_get_instance_private (MusicPluginsAudioPlayerDeviceManager* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPluginsAudioPlayerDeviceManager_private_offset);
}

static void
_music_plugins_audio_player_device_manager_mount_added_music_device_manager_mount_added (MusicDeviceManager* _sender,
                                                                                         GMount* mount,
                                                                                         gpointer self)
{
#line 36 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	music_plugins_audio_player_device_manager_mount_added ((MusicPluginsAudioPlayerDeviceManager*) self, mount);
#line 92 "AudioPlayerDeviceManager.c"
}

static void
_music_plugins_audio_player_device_manager_mount_removed_music_device_manager_mount_removed (MusicDeviceManager* _sender,
                                                                                             GMount* mount,
                                                                                             gpointer self)
{
#line 37 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	music_plugins_audio_player_device_manager_mount_removed ((MusicPluginsAudioPlayerDeviceManager*) self, mount);
#line 102 "AudioPlayerDeviceManager.c"
}

MusicPluginsAudioPlayerDeviceManager*
music_plugins_audio_player_device_manager_construct (GType object_type)
{
	MusicPluginsAudioPlayerDeviceManager * self = NULL;
	GeeArrayList* _tmp0_;
	MusicDeviceManager* device_manager = NULL;
	MusicDeviceManager* _tmp1_;
	MusicDeviceManager* _tmp2_;
	MusicDeviceManager* _tmp3_;
#line 32 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	self = (MusicPluginsAudioPlayerDeviceManager*) g_object_new (object_type, NULL);
#line 33 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_tmp0_ = gee_array_list_new (MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 33 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_g_object_unref0 (self->priv->devices);
#line 33 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	self->priv->devices = _tmp0_;
#line 35 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_tmp1_ = music_device_manager_get_default ();
#line 35 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	device_manager = _tmp1_;
#line 36 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_tmp2_ = device_manager;
#line 36 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	g_signal_connect_object (_tmp2_, "mount-added", (GCallback) _music_plugins_audio_player_device_manager_mount_added_music_device_manager_mount_added, self, 0);
#line 37 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_tmp3_ = device_manager;
#line 37 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	g_signal_connect_object (_tmp3_, "mount-removed", (GCallback) _music_plugins_audio_player_device_manager_mount_removed_music_device_manager_mount_removed, self, 0);
#line 134 "AudioPlayerDeviceManager.c"
	{
		GeeIterator* _mount_it = NULL;
		MusicDeviceManager* _tmp4_;
		GeeCollection* _tmp5_;
		GeeCollection* _tmp6_;
		GeeIterator* _tmp7_;
		GeeIterator* _tmp8_;
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp4_ = device_manager;
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp5_ = music_device_manager_get_available_mounts (_tmp4_);
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp6_ = _tmp5_;
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp8_ = _tmp7_;
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_g_object_unref0 (_tmp6_);
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_mount_it = _tmp8_;
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		while (TRUE) {
#line 158 "AudioPlayerDeviceManager.c"
			GeeIterator* _tmp9_;
			GMount* mount = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			GMount* _tmp12_;
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp9_ = _mount_it;
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			if (!gee_iterator_next (_tmp9_)) {
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
				break;
#line 170 "AudioPlayerDeviceManager.c"
			}
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp10_ = _mount_it;
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			mount = (GMount*) _tmp11_;
#line 39 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp12_ = mount;
#line 39 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			music_plugins_audio_player_device_manager_mount_added (self, _tmp12_);
#line 182 "AudioPlayerDeviceManager.c"
		}
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_g_object_unref0 (_mount_it);
#line 186 "AudioPlayerDeviceManager.c"
	}
#line 32 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_g_object_unref0 (device_manager);
#line 32 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	return self;
#line 192 "AudioPlayerDeviceManager.c"
}

MusicPluginsAudioPlayerDeviceManager*
music_plugins_audio_player_device_manager_new (void)
{
#line 32 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	return music_plugins_audio_player_device_manager_construct (MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE_MANAGER);
#line 200 "AudioPlayerDeviceManager.c"
}

void
music_plugins_audio_player_device_manager_remove_all (MusicPluginsAudioPlayerDeviceManager* self)
{
	GeeArrayList* _tmp11_;
#line 43 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 209 "AudioPlayerDeviceManager.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp0_;
		gint _dev_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _dev_index = 0;
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp0_ = self->priv->devices;
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_dev_list = _tmp0_;
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp1_ = _dev_list;
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp3_ = _tmp2_;
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_dev_size = _tmp3_;
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_dev_index = -1;
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		while (TRUE) {
#line 234 "AudioPlayerDeviceManager.c"
			gint _tmp4_;
			gint _tmp5_;
			MusicPluginsAudioPlayerDevice* dev = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			MusicDeviceManager* _tmp8_;
			MusicDeviceManager* _tmp9_;
			MusicPluginsAudioPlayerDevice* _tmp10_;
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_dev_index = _dev_index + 1;
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp4_ = _dev_index;
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp5_ = _dev_size;
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
				break;
#line 253 "AudioPlayerDeviceManager.c"
			}
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp6_ = _dev_list;
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _dev_index);
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			dev = (MusicPluginsAudioPlayerDevice*) _tmp7_;
#line 45 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp8_ = music_device_manager_get_default ();
#line 45 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp9_ = _tmp8_;
#line 45 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp10_ = dev;
#line 45 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			g_signal_emit_by_name (_tmp9_, "device-removed", G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, MUSIC_TYPE_DEVICE, MusicDevice));
#line 45 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_g_object_unref0 (_tmp9_);
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_g_object_unref0 (dev);
#line 273 "AudioPlayerDeviceManager.c"
		}
	}
#line 48 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_tmp11_ = gee_array_list_new (MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 48 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_g_object_unref0 (self->priv->devices);
#line 48 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	self->priv->devices = _tmp11_;
#line 282 "AudioPlayerDeviceManager.c"
}

static void
____lambda10_ (MusicPluginsAudioPlayerDeviceManager* self,
               MusicDevice* d)
{
	MusicDeviceManager* _tmp0_;
	MusicDeviceManager* _tmp1_;
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	g_return_if_fail (d != NULL);
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_tmp0_ = music_device_manager_get_default ();
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_tmp1_ = _tmp0_;
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	music_device_manager_device_initialized (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (d, MUSIC_TYPE_DEVICE, MusicDevice));
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_g_object_unref0 (_tmp1_);
#line 301 "AudioPlayerDeviceManager.c"
}

static void
_____lambda10__music_device_initialized (MusicDevice* _sender,
                                         MusicDevice* d,
                                         gpointer self)
{
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	____lambda10_ ((MusicPluginsAudioPlayerDeviceManager*) self, d);
#line 311 "AudioPlayerDeviceManager.c"
}

static void
music_plugins_audio_player_device_manager_real_mount_added (MusicPluginsAudioPlayerDeviceManager* self,
                                                            GMount* mount)
{
	gboolean _tmp16_ = FALSE;
	GFile* _tmp17_;
	GFile* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GFile* _tmp23_;
	GFile* _tmp24_;
	gboolean _tmp25_;
#line 51 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	g_return_if_fail (mount != NULL);
#line 330 "AudioPlayerDeviceManager.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp0_;
		gint _dev_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _dev_index = 0;
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp0_ = self->priv->devices;
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_dev_list = _tmp0_;
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp1_ = _dev_list;
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp3_ = _tmp2_;
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_dev_size = _tmp3_;
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_dev_index = -1;
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		while (TRUE) {
#line 355 "AudioPlayerDeviceManager.c"
			gint _tmp4_;
			gint _tmp5_;
			MusicPluginsAudioPlayerDevice* dev = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			MusicPluginsAudioPlayerDevice* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			GFile* _tmp11_;
			GFile* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gboolean _tmp15_;
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_dev_index = _dev_index + 1;
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp4_ = _dev_index;
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp5_ = _dev_size;
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
				break;
#line 379 "AudioPlayerDeviceManager.c"
			}
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp6_ = _dev_list;
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _dev_index);
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			dev = (MusicPluginsAudioPlayerDevice*) _tmp7_;
#line 53 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp8_ = dev;
#line 53 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp9_ = music_device_get_uri ((MusicDevice*) _tmp8_);
#line 53 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp10_ = _tmp9_;
#line 53 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp11_ = g_mount_get_default_location (mount);
#line 53 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp12_ = _tmp11_;
#line 53 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp13_ = g_file_get_uri (_tmp12_);
#line 53 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp14_ = _tmp13_;
#line 53 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp15_ = g_strcmp0 (_tmp10_, _tmp14_) == 0;
#line 53 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_g_free0 (_tmp14_);
#line 53 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_g_object_unref0 (_tmp12_);
#line 53 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_g_free0 (_tmp10_);
#line 53 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			if (_tmp15_) {
#line 54 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
				_g_object_unref0 (dev);
#line 54 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
				return;
#line 415 "AudioPlayerDeviceManager.c"
			}
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_g_object_unref0 (dev);
#line 419 "AudioPlayerDeviceManager.c"
		}
	}
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_tmp17_ = g_mount_get_default_location (mount);
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_tmp18_ = _tmp17_;
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_tmp19_ = g_file_get_uri (_tmp18_);
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_tmp20_ = _tmp19_;
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_tmp21_ = g_strconcat (_tmp20_, "/Android", NULL);
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_tmp22_ = _tmp21_;
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_tmp23_ = g_file_new_for_uri (_tmp22_);
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_tmp24_ = _tmp23_;
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_tmp25_ = g_file_query_exists (_tmp24_, NULL);
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_g_object_unref0 (_tmp24_);
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_g_free0 (_tmp22_);
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_g_free0 (_tmp20_);
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_g_object_unref0 (_tmp18_);
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	if (_tmp25_) {
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp16_ = TRUE;
#line 452 "AudioPlayerDeviceManager.c"
	} else {
		GFile* _tmp26_;
		GFile* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		GFile* _tmp32_;
		GFile* _tmp33_;
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp26_ = g_mount_get_default_location (mount);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp27_ = _tmp26_;
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp28_ = g_file_get_uri (_tmp27_);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp29_ = _tmp28_;
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp30_ = g_strconcat (_tmp29_, "/.is_audio_player", NULL);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp31_ = _tmp30_;
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp32_ = g_file_new_for_uri (_tmp31_);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp33_ = _tmp32_;
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp16_ = g_file_query_exists (_tmp33_, NULL);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_g_object_unref0 (_tmp33_);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_g_free0 (_tmp31_);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_g_free0 (_tmp29_);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_g_object_unref0 (_tmp27_);
#line 488 "AudioPlayerDeviceManager.c"
	}
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	if (_tmp16_) {
#line 492 "AudioPlayerDeviceManager.c"
		MusicPluginsAudioPlayerDevice* added = NULL;
		GFile* _tmp34_;
		GFile* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		GFile* _tmp40_;
		GFile* _tmp41_;
		MusicPluginsAudioPlayerDevice* _tmp42_;
		MusicPluginsAudioPlayerDevice* _tmp43_;
		MusicPluginsAudioPlayerDevice* _tmp44_;
		GeeArrayList* _tmp45_;
		MusicPluginsAudioPlayerDevice* _tmp46_;
		MusicPluginsAudioPlayerDevice* _tmp47_;
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp34_ = g_mount_get_default_location (mount);
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp35_ = _tmp34_;
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp36_ = g_file_get_uri (_tmp35_);
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp37_ = _tmp36_;
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp38_ = g_strconcat (_tmp37_, "/Android", NULL);
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp39_ = _tmp38_;
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp40_ = g_file_new_for_uri (_tmp39_);
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp41_ = _tmp40_;
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp42_ = music_plugins_audio_player_device_new (mount, g_file_query_exists (_tmp41_, NULL));
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp43_ = _tmp42_;
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_g_object_unref0 (_tmp41_);
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_g_free0 (_tmp39_);
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_g_free0 (_tmp37_);
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_g_object_unref0 (_tmp35_);
#line 61 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		added = _tmp43_;
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp44_ = added;
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		music_device_set_mount ((MusicDevice*) _tmp44_, mount);
#line 66 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp45_ = self->priv->devices;
#line 66 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp46_ = added;
#line 66 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp45_, _tmp46_);
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp47_ = added;
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		if (music_device_start_initialization ((MusicDevice*) _tmp47_)) {
#line 552 "AudioPlayerDeviceManager.c"
			MusicPluginsAudioPlayerDevice* _tmp48_;
			MusicPluginsAudioPlayerDevice* _tmp49_;
#line 69 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp48_ = added;
#line 69 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			music_device_finish_initialization ((MusicDevice*) _tmp48_);
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp49_ = added;
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			g_signal_connect_object ((MusicDevice*) _tmp49_, "initialized", (GCallback) _____lambda10__music_device_initialized, self, 0);
#line 563 "AudioPlayerDeviceManager.c"
		} else {
			MusicPluginsAudioPlayerDevice* _tmp50_;
			GMount* _tmp51_;
			GMount* _tmp52_;
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp50_ = added;
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp51_ = music_device_get_mount ((MusicDevice*) _tmp50_);
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp52_ = _tmp51_;
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			music_plugins_audio_player_device_manager_mount_removed (self, _tmp52_);
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_g_object_unref0 (_tmp52_);
#line 578 "AudioPlayerDeviceManager.c"
		}
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_g_object_unref0 (added);
#line 582 "AudioPlayerDeviceManager.c"
	} else {
		GFile* _tmp53_;
		GFile* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
#line 76 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp53_ = g_mount_get_default_location (mount);
#line 76 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp54_ = _tmp53_;
#line 76 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp55_ = g_file_get_parse_name (_tmp54_);
#line 76 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp56_ = _tmp55_;
#line 76 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		g_debug ("AudioPlayerDeviceManager.vala:76: Found device at %s is not an Audio P" \
"layer or Android Phone. Not using it", _tmp56_);
#line 76 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_g_free0 (_tmp56_);
#line 76 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_g_object_unref0 (_tmp54_);
#line 81 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		return;
#line 604 "AudioPlayerDeviceManager.c"
	}
}

void
music_plugins_audio_player_device_manager_mount_added (MusicPluginsAudioPlayerDeviceManager* self,
                                                       GMount* mount)
{
	MusicPluginsAudioPlayerDeviceManagerClass* _klass_;
#line 51 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 51 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_klass_ = MUSIC_PLUGINS_AUDIO_PLAYER_DEVICE_MANAGER_GET_CLASS (self);
#line 51 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	if (_klass_->mount_added) {
#line 51 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_klass_->mount_added (self, mount);
#line 621 "AudioPlayerDeviceManager.c"
	}
}

static void
music_plugins_audio_player_device_manager_real_mount_changed (MusicPluginsAudioPlayerDeviceManager* self,
                                                              GMount* mount)
{
#line 85 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	g_return_if_fail (mount != NULL);
#line 631 "AudioPlayerDeviceManager.c"
}

void
music_plugins_audio_player_device_manager_mount_changed (MusicPluginsAudioPlayerDeviceManager* self,
                                                         GMount* mount)
{
	MusicPluginsAudioPlayerDeviceManagerClass* _klass_;
#line 85 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 85 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_klass_ = MUSIC_PLUGINS_AUDIO_PLAYER_DEVICE_MANAGER_GET_CLASS (self);
#line 85 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	if (_klass_->mount_changed) {
#line 85 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_klass_->mount_changed (self, mount);
#line 647 "AudioPlayerDeviceManager.c"
	}
}

static void
music_plugins_audio_player_device_manager_real_mount_pre_unmount (MusicPluginsAudioPlayerDeviceManager* self,
                                                                  GMount* mount)
{
#line 89 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	g_return_if_fail (mount != NULL);
#line 657 "AudioPlayerDeviceManager.c"
}

void
music_plugins_audio_player_device_manager_mount_pre_unmount (MusicPluginsAudioPlayerDeviceManager* self,
                                                             GMount* mount)
{
	MusicPluginsAudioPlayerDeviceManagerClass* _klass_;
#line 89 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 89 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_klass_ = MUSIC_PLUGINS_AUDIO_PLAYER_DEVICE_MANAGER_GET_CLASS (self);
#line 89 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	if (_klass_->mount_pre_unmount) {
#line 89 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_klass_->mount_pre_unmount (self, mount);
#line 673 "AudioPlayerDeviceManager.c"
	}
}

static void
music_plugins_audio_player_device_manager_real_mount_removed (MusicPluginsAudioPlayerDeviceManager* self,
                                                              GMount* mount)
{
#line 93 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	g_return_if_fail (mount != NULL);
#line 683 "AudioPlayerDeviceManager.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp0_;
		gint _dev_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _dev_index = 0;
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp0_ = self->priv->devices;
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_dev_list = _tmp0_;
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp1_ = _dev_list;
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_tmp3_ = _tmp2_;
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_dev_size = _tmp3_;
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_dev_index = -1;
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		while (TRUE) {
#line 708 "AudioPlayerDeviceManager.c"
			gint _tmp4_;
			gint _tmp5_;
			MusicPluginsAudioPlayerDevice* dev = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			MusicPluginsAudioPlayerDevice* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			GFile* _tmp11_;
			GFile* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gboolean _tmp15_;
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_dev_index = _dev_index + 1;
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp4_ = _dev_index;
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp5_ = _dev_size;
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
				break;
#line 732 "AudioPlayerDeviceManager.c"
			}
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp6_ = _dev_list;
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _dev_index);
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			dev = (MusicPluginsAudioPlayerDevice*) _tmp7_;
#line 95 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp8_ = dev;
#line 95 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp9_ = music_device_get_uri ((MusicDevice*) _tmp8_);
#line 95 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp10_ = _tmp9_;
#line 95 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp11_ = g_mount_get_default_location (mount);
#line 95 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp12_ = _tmp11_;
#line 95 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp13_ = g_file_get_uri (_tmp12_);
#line 95 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp14_ = _tmp13_;
#line 95 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_tmp15_ = g_strcmp0 (_tmp10_, _tmp14_) == 0;
#line 95 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_g_free0 (_tmp14_);
#line 95 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_g_object_unref0 (_tmp12_);
#line 95 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_g_free0 (_tmp10_);
#line 95 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			if (_tmp15_) {
#line 764 "AudioPlayerDeviceManager.c"
				MusicDeviceManager* _tmp16_;
				MusicDeviceManager* _tmp17_;
				MusicPluginsAudioPlayerDevice* _tmp18_;
				GeeArrayList* _tmp19_;
				MusicPluginsAudioPlayerDevice* _tmp20_;
#line 96 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
				_tmp16_ = music_device_manager_get_default ();
#line 96 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
				_tmp17_ = _tmp16_;
#line 96 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
				_tmp18_ = dev;
#line 96 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
				g_signal_emit_by_name (_tmp17_, "device-removed", G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, MUSIC_TYPE_DEVICE, MusicDevice));
#line 96 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
				_g_object_unref0 (_tmp17_);
#line 99 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
				_tmp19_ = self->priv->devices;
#line 99 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
				_tmp20_ = dev;
#line 99 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
				gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp19_, _tmp20_);
#line 101 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
				_g_object_unref0 (dev);
#line 101 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
				return;
#line 790 "AudioPlayerDeviceManager.c"
			}
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
			_g_object_unref0 (dev);
#line 794 "AudioPlayerDeviceManager.c"
		}
	}
}

void
music_plugins_audio_player_device_manager_mount_removed (MusicPluginsAudioPlayerDeviceManager* self,
                                                         GMount* mount)
{
	MusicPluginsAudioPlayerDeviceManagerClass* _klass_;
#line 93 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 93 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_klass_ = MUSIC_PLUGINS_AUDIO_PLAYER_DEVICE_MANAGER_GET_CLASS (self);
#line 93 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	if (_klass_->mount_removed) {
#line 93 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
		_klass_->mount_removed (self, mount);
#line 812 "AudioPlayerDeviceManager.c"
	}
}

static void
music_plugins_audio_player_device_manager_class_init (MusicPluginsAudioPlayerDeviceManagerClass * klass,
                                                      gpointer klass_data)
{
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	music_plugins_audio_player_device_manager_parent_class = g_type_class_peek_parent (klass);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	g_type_class_adjust_private_offset (klass, &MusicPluginsAudioPlayerDeviceManager_private_offset);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	((MusicPluginsAudioPlayerDeviceManagerClass *) klass)->mount_added = (void (*) (MusicPluginsAudioPlayerDeviceManager*, GMount*)) music_plugins_audio_player_device_manager_real_mount_added;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	((MusicPluginsAudioPlayerDeviceManagerClass *) klass)->mount_changed = (void (*) (MusicPluginsAudioPlayerDeviceManager*, GMount*)) music_plugins_audio_player_device_manager_real_mount_changed;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	((MusicPluginsAudioPlayerDeviceManagerClass *) klass)->mount_pre_unmount = (void (*) (MusicPluginsAudioPlayerDeviceManager*, GMount*)) music_plugins_audio_player_device_manager_real_mount_pre_unmount;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	((MusicPluginsAudioPlayerDeviceManagerClass *) klass)->mount_removed = (void (*) (MusicPluginsAudioPlayerDeviceManager*, GMount*)) music_plugins_audio_player_device_manager_real_mount_removed;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	G_OBJECT_CLASS (klass)->finalize = music_plugins_audio_player_device_manager_finalize;
#line 834 "AudioPlayerDeviceManager.c"
}

static void
music_plugins_audio_player_device_manager_instance_init (MusicPluginsAudioPlayerDeviceManager * self,
                                                         gpointer klass)
{
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	self->priv = music_plugins_audio_player_device_manager_get_instance_private (self);
#line 843 "AudioPlayerDeviceManager.c"
}

static void
music_plugins_audio_player_device_manager_finalize (GObject * obj)
{
	MusicPluginsAudioPlayerDeviceManager * self;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE_MANAGER, MusicPluginsAudioPlayerDeviceManager);
#line 30 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	_g_object_unref0 (self->priv->devices);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDeviceManager.vala"
	G_OBJECT_CLASS (music_plugins_audio_player_device_manager_parent_class)->finalize (obj);
#line 856 "AudioPlayerDeviceManager.c"
}

GType
music_plugins_audio_player_device_manager_get_type (void)
{
	return music_plugins_audio_player_device_manager_type_id;
}

GType
music_plugins_audio_player_device_manager_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsAudioPlayerDeviceManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_audio_player_device_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsAudioPlayerDeviceManager), 0, (GInstanceInitFunc) music_plugins_audio_player_device_manager_instance_init, NULL };
	music_plugins_audio_player_device_manager_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MusicPluginsAudioPlayerDeviceManager", &g_define_type_info, 0);
	MusicPluginsAudioPlayerDeviceManager_private_offset = sizeof (MusicPluginsAudioPlayerDeviceManagerPrivate);
	return music_plugins_audio_player_device_manager_type_id;
}

