/* AudioPlayerLibrary.c generated by valac 0.56.0, the Vala compiler
 * generated from AudioPlayerLibrary.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "audioplayer-device.h"
#include <gee.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "music-lib.h"
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

enum  {
	MUSIC_PLUGINS_AUDIO_PLAYER_LIBRARY_0_PROPERTY,
	MUSIC_PLUGINS_AUDIO_PLAYER_LIBRARY_NUM_PROPERTIES
};
static GParamSpec* music_plugins_audio_player_library_properties[MUSIC_PLUGINS_AUDIO_PLAYER_LIBRARY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block1Data Block1Data;

struct _MusicPluginsAudioPlayerLibraryPrivate {
	MusicPluginsAudioPlayerDevice* device;
	GeeLinkedList* medias;
	GRecMutex __lock_medias;
	GeeLinkedList* searched_medias;
	GRecMutex __lock_searched_medias;
	GeeLinkedList* playlists;
	gboolean operation_cancelled;
	gboolean is_doing_file_operations;
	gboolean queue_is_finished;
	GeeLinkedList* imported_files;
	gboolean is_initialized;
};

struct _Block1Data {
	int _ref_count_;
	MusicPluginsAudioPlayerLibrary* self;
	MusicStaticPlaylist* p;
};

static gint MusicPluginsAudioPlayerLibrary_private_offset;
static gpointer music_plugins_audio_player_library_parent_class = NULL;
static GType music_plugins_audio_player_library_type_id = 0;

static void music_plugins_audio_player_library_media_imported_from_tagger (MusicPluginsAudioPlayerLibrary* self,
                                                                    MusicMedia* m);
static void _music_plugins_audio_player_library_media_imported_from_tagger_music_gstreamer_tagger_media_imported (MusicGStreamerTagger* _sender,
                                                                                                           MusicMedia* m,
                                                                                                           gpointer self);
static void music_plugins_audio_player_library_import_error (MusicPluginsAudioPlayerLibrary* self,
                                                      const gchar* file);
static void _music_plugins_audio_player_library_import_error_music_gstreamer_tagger_import_error (MusicGStreamerTagger* _sender,
                                                                                           const gchar* file_uri,
                                                                                           GError* _error_,
                                                                                           gpointer self);
static void _music_plugins_audio_player_library_queue_finished_music_gstreamer_tagger_queue_finished (MusicGStreamerTagger* _sender,
                                                                                               gpointer self);
static void __lambda4_ (MusicPluginsAudioPlayerLibrary* self);
static void ___lambda4__music_notification_manager_progress_canceled (MusicNotificationManager* _sender,
                                                               gpointer self);
static void music_plugins_audio_player_library_real_initialize_library (MusicLibrary* base);
static void music_plugins_audio_player_library_real_add_files_to_library (MusicLibrary* base,
                                                                   GeeCollection* files);
static GeeCollection* music_plugins_audio_player_library_real_get_medias (MusicLibrary* base);
static GeeCollection* music_plugins_audio_player_library_real_get_playlists (MusicLibrary* base);
static GeeCollection* music_plugins_audio_player_library_real_get_smart_playlists (MusicLibrary* base);
static void music_plugins_audio_player_library_real_search_medias (MusicLibrary* base,
                                                            const gchar* search);
static GeeCollection* music_plugins_audio_player_library_real_get_search_result (MusicLibrary* base);
static void music_plugins_audio_player_library_real_add_media (MusicLibrary* base,
                                                        MusicMedia* m);
static void music_plugins_audio_player_library_real_add_medias (MusicLibrary* base,
                                                         GeeCollection* list);
static gboolean _music_libraries_manager_do_progress_notification_with_timeout_gsource_func (gpointer self);
static MusicMedia* music_plugins_audio_player_library_real_media_from_id (MusicLibrary* base,
                                                                   gint64 id);
static GeeCollection* music_plugins_audio_player_library_real_medias_from_ids (MusicLibrary* base,
                                                                        GeeCollection* ids);
static GeeCollection* music_plugins_audio_player_library_real_medias_from_uris (MusicLibrary* base,
                                                                         GeeCollection* uris);
static MusicMedia* music_plugins_audio_player_library_real_find_media (MusicLibrary* base,
                                                                MusicMedia* to_find);
static MusicMedia* music_plugins_audio_player_library_real_media_from_file (MusicLibrary* base,
                                                                     GFile* file);
static MusicMedia* music_plugins_audio_player_library_real_media_from_uri (MusicLibrary* base,
                                                                    const gchar* uri);
static void music_plugins_audio_player_library_real_update_media (MusicLibrary* base,
                                                           MusicMedia* s,
                                                           gboolean update_meta,
                                                           gboolean record_time);
static void music_plugins_audio_player_library_real_update_medias (MusicLibrary* base,
                                                            GeeCollection* updates,
                                                            gboolean update_meta,
                                                            gboolean record_time);
static void music_plugins_audio_player_library_real_remove_media (MusicLibrary* base,
                                                           MusicMedia* m,
                                                           gboolean trash);
static void music_plugins_audio_player_library_real_remove_medias (MusicLibrary* base,
                                                            GeeCollection* list,
                                                            gboolean trash);
static gboolean music_plugins_audio_player_library_real_support_smart_playlists (MusicLibrary* base);
static void music_plugins_audio_player_library_real_add_smart_playlist (MusicLibrary* base,
                                                                 MusicSmartPlaylist* p);
static void music_plugins_audio_player_library_real_remove_smart_playlist (MusicLibrary* base,
                                                                    gint64 id);
static MusicSmartPlaylist* music_plugins_audio_player_library_real_smart_playlist_from_id (MusicLibrary* base,
                                                                                    gint64 id);
static MusicSmartPlaylist* music_plugins_audio_player_library_real_smart_playlist_from_name (MusicLibrary* base,
                                                                                      const gchar* name);
static gboolean music_plugins_audio_player_library_real_support_playlists (MusicLibrary* base);
static void music_plugins_audio_player_library_real_add_playlist (MusicLibrary* base,
                                                           MusicStaticPlaylist* p);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void music_plugins_audio_player_library_keep_playlist_synchronized (MusicPluginsAudioPlayerLibrary* self,
                                                                    MusicStaticPlaylist* p);
static void __lambda5_ (Block1Data* _data1_);
static void ___lambda5__music_playlist_media_added (MusicPlaylist* _sender,
                                             GeeCollection* media,
                                             gpointer self);
static void __lambda6_ (Block1Data* _data1_);
static void ___lambda6__music_playlist_media_removed (MusicPlaylist* _sender,
                                               GeeCollection* media,
                                               gpointer self);
static void __lambda7_ (Block1Data* _data1_,
                 const gchar* old_name);
static void music_plugins_audio_player_library_remove_playlist_from_name (MusicPluginsAudioPlayerLibrary* self,
                                                                   const gchar* name);
static void ___lambda7__music_playlist_updated (MusicPlaylist* _sender,
                                         const gchar* old_name,
                                         gpointer self);
static void music_plugins_audio_player_library_real_remove_playlist (MusicLibrary* base,
                                                              gint64 id);
static MusicStaticPlaylist* music_plugins_audio_player_library_real_playlist_from_id (MusicLibrary* base,
                                                                               gint64 id);
static MusicStaticPlaylist* music_plugins_audio_player_library_real_playlist_from_name (MusicLibrary* base,
                                                                                 const gchar* name);
static gboolean music_plugins_audio_player_library_real_start_file_operations (MusicLibrary* base,
                                                                        const gchar* message);
static gboolean music_plugins_audio_player_library_real_doing_file_operations (MusicLibrary* base);
static void music_plugins_audio_player_library_real_finish_file_operations (MusicLibrary* base);
static void music_plugins_audio_player_library_finalize (GObject * obj);

static inline gpointer
music_plugins_audio_player_library_get_instance_private (MusicPluginsAudioPlayerLibrary* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPluginsAudioPlayerLibrary_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 47 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return self ? g_object_ref (self) : NULL;
#line 191 "AudioPlayerLibrary.c"
}

static void
_music_plugins_audio_player_library_media_imported_from_tagger_music_gstreamer_tagger_media_imported (MusicGStreamerTagger* _sender,
                                                                                                      MusicMedia* m,
                                                                                                      gpointer self)
{
#line 55 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	music_plugins_audio_player_library_media_imported_from_tagger ((MusicPluginsAudioPlayerLibrary*) self, m);
#line 201 "AudioPlayerLibrary.c"
}

static void
_music_plugins_audio_player_library_import_error_music_gstreamer_tagger_import_error (MusicGStreamerTagger* _sender,
                                                                                      const gchar* file_uri,
                                                                                      GError* _error_,
                                                                                      gpointer self)
{
#line 56 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	music_plugins_audio_player_library_import_error ((MusicPluginsAudioPlayerLibrary*) self, file_uri);
#line 212 "AudioPlayerLibrary.c"
}

static void
_music_plugins_audio_player_library_queue_finished_music_gstreamer_tagger_queue_finished (MusicGStreamerTagger* _sender,
                                                                                          gpointer self)
{
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	music_plugins_audio_player_library_queue_finished ((MusicPluginsAudioPlayerLibrary*) self);
#line 221 "AudioPlayerLibrary.c"
}

static void
__lambda4_ (MusicPluginsAudioPlayerLibrary* self)
{
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->operation_cancelled = TRUE;
#line 229 "AudioPlayerLibrary.c"
}

static void
___lambda4__music_notification_manager_progress_canceled (MusicNotificationManager* _sender,
                                                          gpointer self)
{
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	__lambda4_ ((MusicPluginsAudioPlayerLibrary*) self);
#line 238 "AudioPlayerLibrary.c"
}

MusicPluginsAudioPlayerLibrary*
music_plugins_audio_player_library_construct (GType object_type,
                                              MusicPluginsAudioPlayerDevice* device)
{
	MusicPluginsAudioPlayerLibrary * self = NULL;
	MusicPluginsAudioPlayerDevice* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp2_;
	GeeLinkedList* _tmp3_;
	GeeLinkedList* _tmp4_;
	MusicGStreamerTagger* _tmp5_;
	MusicGStreamerTagger* _tmp6_;
	MusicGStreamerTagger* _tmp7_;
	MusicGStreamerTagger* _tmp8_;
	MusicNotificationManager* _tmp9_;
	MusicNotificationManager* _tmp10_;
#line 46 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 46 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) music_library_construct (object_type);
#line 47 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = _g_object_ref0 (device);
#line 47 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->device);
#line 47 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->device = _tmp0_;
#line 48 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 48 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->medias);
#line 48 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->medias = _tmp1_;
#line 49 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 49 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->searched_medias);
#line 49 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->searched_medias = _tmp2_;
#line 50 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = gee_linked_list_new (MUSIC_TYPE_STATIC_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 50 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->playlists);
#line 50 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->playlists = _tmp3_;
#line 51 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 51 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->imported_files);
#line 51 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->imported_files = _tmp4_;
#line 53 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp5_ = music_gstreamer_tagger_new (NULL);
#line 53 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->tagger);
#line 53 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->tagger = _tmp5_;
#line 55 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp6_ = self->tagger;
#line 55 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_connect_object (_tmp6_, "media-imported", (GCallback) _music_plugins_audio_player_library_media_imported_from_tagger_music_gstreamer_tagger_media_imported, self, 0);
#line 56 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp7_ = self->tagger;
#line 56 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_connect_object (_tmp7_, "import-error", (GCallback) _music_plugins_audio_player_library_import_error_music_gstreamer_tagger_import_error, self, 0);
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp8_ = self->tagger;
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_connect_object (_tmp8_, "queue-finished", (GCallback) _music_plugins_audio_player_library_queue_finished_music_gstreamer_tagger_queue_finished, self, 0);
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp9_ = music_notification_manager_get_default ();
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp10_ = _tmp9_;
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_connect_object (_tmp10_, "progress-canceled", (GCallback) ___lambda4__music_notification_manager_progress_canceled, self, 0);
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (_tmp10_);
#line 46 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return self;
#line 319 "AudioPlayerLibrary.c"
}

MusicPluginsAudioPlayerLibrary*
music_plugins_audio_player_library_new (MusicPluginsAudioPlayerDevice* device)
{
#line 46 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return music_plugins_audio_player_library_construct (MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, device);
#line 327 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_media_imported_from_tagger (MusicPluginsAudioPlayerLibrary* self,
                                                               MusicMedia* m)
{
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (self != NULL);
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (m != NULL);
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	music_media_set_is_temporary (m, TRUE);
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = self->priv->medias;
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, m);
#line 66 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	music_media_set_rowid (m, (gint64) self->medias_rowid);
#line 67 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = self->medias_rowid;
#line 67 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->medias_rowid = _tmp1_ + 1;
#line 69 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (self->priv->queue_is_finished) {
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_signal_emit_by_name ((MusicLibrary*) self, "file-operations-done");
#line 356 "AudioPlayerLibrary.c"
	}
}

static void
music_plugins_audio_player_library_import_error (MusicPluginsAudioPlayerLibrary* self,
                                                 const gchar* file)
{
#line 74 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (self != NULL);
#line 74 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (file != NULL);
#line 368 "AudioPlayerLibrary.c"
}

void
music_plugins_audio_player_library_queue_finished (MusicPluginsAudioPlayerLibrary* self)
{
	MusicLibrariesManager* _tmp0_;
#line 77 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (self != NULL);
#line 78 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->queue_is_finished = TRUE;
#line 79 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = music_libraries_manager;
#line 79 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_->progress = (gdouble) 1;
#line 81 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (self->priv->is_initialized == FALSE) {
#line 385 "AudioPlayerLibrary.c"
		MusicPluginsAudioPlayerDevice* _tmp1_;
		MusicPluginsAudioPlayerDevice* _tmp2_;
#line 82 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		self->priv->is_initialized = TRUE;
#line 83 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp1_ = self->priv->device;
#line 83 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp2_ = self->priv->device;
#line 83 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_signal_emit_by_name ((MusicDevice*) _tmp1_, "initialized", (MusicDevice*) _tmp2_);
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		music_library_search_medias ((MusicLibrary*) self, "");
#line 398 "AudioPlayerLibrary.c"
	}
}

static void
music_plugins_audio_player_library_real_initialize_library (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
#line 88 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 408 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_real_add_files_to_library (MusicLibrary* base,
                                                              GeeCollection* files)
{
	MusicPluginsAudioPlayerLibrary * self;
#line 92 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 92 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (files != NULL);
#line 420 "AudioPlayerLibrary.c"
}

static GeeCollection*
music_plugins_audio_player_library_real_get_medias (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
	GeeLinkedList* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result;
#line 96 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 97 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = self->priv->medias;
#line 97 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = _g_object_ref0 ((GeeCollection*) _tmp0_);
#line 97 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = _tmp1_;
#line 97 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 440 "AudioPlayerLibrary.c"
}

static GeeCollection*
music_plugins_audio_player_library_real_get_playlists (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
	GeeLinkedList* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result;
#line 100 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 101 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = self->priv->playlists;
#line 101 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = _g_object_ref0 ((GeeCollection*) _tmp0_);
#line 101 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = _tmp1_;
#line 101 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 460 "AudioPlayerLibrary.c"
}

static GeeCollection*
music_plugins_audio_player_library_real_get_smart_playlists (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
	GeeLinkedList* _tmp0_;
	GeeCollection* result;
#line 104 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 105 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_SMART_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 105 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = (GeeCollection*) _tmp0_;
#line 105 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 477 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_real_search_medias (MusicLibrary* base,
                                                       const gchar* search)
{
	MusicPluginsAudioPlayerLibrary * self;
	GError* _inner_error0_ = NULL;
#line 108 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 108 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (search != NULL);
#line 490 "AudioPlayerLibrary.c"
	{
		GeeLinkedList* _tmp0_;
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp0_ = self->priv->searched_medias;
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_searched_medias);
#line 497 "AudioPlayerLibrary.c"
		{
			GeeLinkedList* _tmp1_;
			gboolean _tmp2_ = FALSE;
			guint parsed_rating = 0U;
			gchar* parsed_search_string = NULL;
			guint _tmp6_ = 0U;
			gchar* _tmp7_ = NULL;
			gboolean rating_search = FALSE;
#line 110 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp1_ = self->priv->searched_medias;
#line 110 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
#line 112 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			if (g_strcmp0 (search, "") == 0) {
#line 112 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp2_ = TRUE;
#line 514 "AudioPlayerLibrary.c"
			} else {
#line 112 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp2_ = search == NULL;
#line 518 "AudioPlayerLibrary.c"
			}
#line 112 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			if (_tmp2_) {
#line 522 "AudioPlayerLibrary.c"
				GeeLinkedList* _tmp3_;
				GeeLinkedList* _tmp4_;
#line 113 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp3_ = self->priv->searched_medias;
#line 113 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp4_ = self->priv->medias;
#line 113 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				gee_collection_add_all ((GeeCollection*) _tmp3_, (GeeCollection*) _tmp4_);
#line 114 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				g_signal_emit_by_name ((MusicLibrary*) self, "search-finished");
#line 533 "AudioPlayerLibrary.c"
				{
					GeeLinkedList* _tmp5_;
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp5_ = self->priv->searched_medias;
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					g_rec_mutex_unlock (&self->priv->__lock_searched_medias);
#line 540 "AudioPlayerLibrary.c"
				}
#line 115 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				return;
#line 544 "AudioPlayerLibrary.c"
			}
#line 120 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			music_string_base_search_method (search, &_tmp6_, &_tmp7_);
#line 120 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			parsed_rating = _tmp6_;
#line 120 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_free0 (parsed_search_string);
#line 120 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			parsed_search_string = _tmp7_;
#line 121 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			rating_search = parsed_rating > ((guint) 0);
#line 556 "AudioPlayerLibrary.c"
			{
				GeeLinkedList* _tmp8_;
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp8_ = self->priv->medias;
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				g_rec_mutex_lock (&self->priv->__lock_medias);
#line 563 "AudioPlayerLibrary.c"
				{
					{
						GeeLinkedList* _m_list = NULL;
						GeeLinkedList* _tmp9_;
						gint _m_size = 0;
						GeeLinkedList* _tmp10_;
						gint _tmp11_;
						gint _tmp12_;
						gint _m_index = 0;
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp9_ = self->priv->medias;
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_m_list = _tmp9_;
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp10_ = _m_list;
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp10_);
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp12_ = _tmp11_;
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_m_size = _tmp12_;
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_m_index = -1;
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						while (TRUE) {
#line 589 "AudioPlayerLibrary.c"
							gint _tmp13_;
							gint _tmp14_;
							MusicMedia* m = NULL;
							GeeLinkedList* _tmp15_;
							gpointer _tmp16_;
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_m_index = _m_index + 1;
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_tmp13_ = _m_index;
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_tmp14_ = _m_size;
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							if (!(_tmp13_ < _tmp14_)) {
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
								break;
#line 605 "AudioPlayerLibrary.c"
							}
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_tmp15_ = _m_list;
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _m_index);
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							m = (MusicMedia*) _tmp16_;
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							if (rating_search) {
#line 615 "AudioPlayerLibrary.c"
								MusicMedia* _tmp17_;
								guint _tmp18_;
								guint _tmp19_;
#line 126 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
								_tmp17_ = m;
#line 126 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
								_tmp18_ = music_media_get_rating (_tmp17_);
#line 126 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
								_tmp19_ = _tmp18_;
#line 126 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
								if (_tmp19_ == parsed_rating) {
#line 627 "AudioPlayerLibrary.c"
									GeeLinkedList* _tmp20_;
									MusicMedia* _tmp21_;
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
									_tmp20_ = self->priv->searched_medias;
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
									_tmp21_ = m;
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
#line 636 "AudioPlayerLibrary.c"
								}
							} else {
								MusicMedia* _tmp22_;
								const gchar* _tmp23_;
#line 128 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
								_tmp22_ = m;
#line 128 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
								_tmp23_ = parsed_search_string;
#line 128 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
								if (music_search_match_string_to_media (_tmp22_, _tmp23_)) {
#line 647 "AudioPlayerLibrary.c"
									GeeLinkedList* _tmp24_;
									MusicMedia* _tmp25_;
#line 129 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
									_tmp24_ = self->priv->searched_medias;
#line 129 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
									_tmp25_ = m;
#line 129 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, _tmp25_);
#line 656 "AudioPlayerLibrary.c"
								}
							}
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_g_object_unref0 (m);
#line 661 "AudioPlayerLibrary.c"
						}
					}
				}
				__finally1:
				{
					GeeLinkedList* _tmp26_;
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp26_ = self->priv->medias;
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 672 "AudioPlayerLibrary.c"
				}
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_free0 (parsed_search_string);
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					g_clear_error (&_inner_error0_);
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					return;
#line 684 "AudioPlayerLibrary.c"
				}
			}
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_free0 (parsed_search_string);
#line 689 "AudioPlayerLibrary.c"
		}
		__finally0:
		{
			GeeLinkedList* _tmp27_;
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp27_ = self->priv->searched_medias;
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_searched_medias);
#line 698 "AudioPlayerLibrary.c"
		}
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			return;
#line 708 "AudioPlayerLibrary.c"
		}
	}
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_emit_by_name ((MusicLibrary*) self, "search-finished");
#line 713 "AudioPlayerLibrary.c"
}

static GeeCollection*
music_plugins_audio_player_library_real_get_search_result (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
	GeeLinkedList* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result;
#line 137 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 138 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = self->priv->searched_medias;
#line 138 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = _g_object_ref0 ((GeeCollection*) _tmp0_);
#line 138 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = _tmp1_;
#line 138 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 733 "AudioPlayerLibrary.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 755 "AudioPlayerLibrary.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 759 "AudioPlayerLibrary.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 765 "AudioPlayerLibrary.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 769 "AudioPlayerLibrary.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 773 "AudioPlayerLibrary.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 781 "AudioPlayerLibrary.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 809 "AudioPlayerLibrary.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 818 "AudioPlayerLibrary.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 832 "AudioPlayerLibrary.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 841 "AudioPlayerLibrary.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 855 "AudioPlayerLibrary.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 864 "AudioPlayerLibrary.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 873 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_real_add_media (MusicLibrary* base,
                                                   MusicMedia* m)
{
	MusicPluginsAudioPlayerLibrary * self;
	gchar* current_operation = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_ = NULL;
	MusicPluginsAudioPlayerDevice* _tmp12_;
	gchar* _tmp13_;
	MusicLibrariesManager* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GFile* file = NULL;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GFile* _tmp25_;
	GFile* _tmp26_;
	GFile* destination_file = NULL;
	MusicPluginsAudioPlayerDevice* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GFile* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	GFile* _tmp35_;
	GFile* _tmp36_;
	GeeLinkedList* _tmp43_;
	GFile* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	GError* _inner_error0_ = NULL;
#line 141 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 141 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (m != NULL);
#line 142 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (m == NULL) {
#line 143 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return;
#line 933 "AudioPlayerLibrary.c"
	}
#line 146 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = g_strdup (_ ("Adding <b>$NAME</b> by <b>$ARTIST</b> to $DEVICE"));
#line 146 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	current_operation = _tmp0_;
#line 147 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = music_media_get_title (m);
#line 147 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = _tmp2_;
#line 147 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = _tmp3_;
#line 147 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp1_ == NULL) {
#line 147 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp1_ = "";
#line 949 "AudioPlayerLibrary.c"
	}
#line 147 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = current_operation;
#line 147 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp5_ = string_replace (_tmp4_, "$NAME", _tmp1_);
#line 147 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (current_operation);
#line 147 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	current_operation = _tmp5_;
#line 148 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp7_ = music_media_get_artist (m);
#line 148 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp8_ = _tmp7_;
#line 148 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp6_ = _tmp8_;
#line 148 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp6_ == NULL) {
#line 148 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp6_ = "";
#line 969 "AudioPlayerLibrary.c"
	}
#line 148 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp9_ = current_operation;
#line 148 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp10_ = string_replace (_tmp9_, "$ARTIST", _tmp6_);
#line 148 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (current_operation);
#line 148 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	current_operation = _tmp10_;
#line 149 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp12_ = self->priv->device;
#line 149 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp13_ = music_device_get_display_name ((MusicDevice*) _tmp12_);
#line 149 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp11_ = _tmp13_;
#line 149 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp11_ == NULL) {
#line 987 "AudioPlayerLibrary.c"
		gchar* _tmp14_;
#line 149 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp14_ = g_strdup ("");
#line 149 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (_tmp11_);
#line 149 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp11_ = _tmp14_;
#line 995 "AudioPlayerLibrary.c"
	}
#line 149 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp15_ = music_libraries_manager;
#line 149 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp16_ = current_operation;
#line 149 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp17_ = string_replace (_tmp16_, "$DEVICE", _tmp11_);
#line 149 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp15_->current_operation);
#line 149 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp15_->current_operation = _tmp17_;
#line 150 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp18_ = music_media_get_title (m);
#line 150 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp19_ = _tmp18_;
#line 150 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp20_ = music_media_get_artist (m);
#line 150 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp21_ = _tmp20_;
#line 150 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_debug ("AudioPlayerLibrary.vala:150: Adding media %s by %s\n", _tmp19_, _tmp21_);
#line 152 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp22_ = music_media_get_uri (m);
#line 152 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp23_ = _tmp22_;
#line 152 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp24_ = _tmp23_;
#line 152 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp25_ = g_file_new_for_uri (_tmp24_);
#line 152 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp26_ = _tmp25_;
#line 152 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp24_);
#line 152 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	file = _tmp26_;
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp27_ = self->priv->device;
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp28_ = music_plugins_audio_player_device_get_music_folder (_tmp27_);
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp29_ = _tmp28_;
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp30_ = file;
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp31_ = g_file_get_basename (_tmp30_);
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp32_ = _tmp31_;
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp33_ = g_strconcat (_tmp29_, _tmp32_, NULL);
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp34_ = _tmp33_;
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp35_ = g_file_new_for_uri (_tmp34_);
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp36_ = _tmp35_;
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp34_);
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp32_);
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp29_);
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	destination_file = _tmp36_;
#line 1059 "AudioPlayerLibrary.c"
	{
		GFile* _tmp37_;
		GFile* _tmp38_;
#line 156 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp37_ = file;
#line 156 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp38_ = destination_file;
#line 156 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_file_copy (_tmp37_, _tmp38_, G_FILE_COPY_ALL_METADATA, NULL, NULL, NULL, &_inner_error0_);
#line 156 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1071 "AudioPlayerLibrary.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp39_;
		const gchar* _tmp40_;
		GError* _tmp41_;
		const gchar* _tmp42_;
#line 155 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		err = _inner_error0_;
#line 155 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_inner_error0_ = NULL;
#line 158 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp39_ = music_media_get_title (m);
#line 158 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp40_ = _tmp39_;
#line 158 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp41_ = err;
#line 158 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp42_ = _tmp41_->message;
#line 158 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_warning ("AudioPlayerLibrary.vala:158: Failed to copy track %s : %s\n", _tmp40_, _tmp42_);
#line 159 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_error_free0 (err);
#line 159 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (destination_file);
#line 159 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (file);
#line 159 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (_tmp11_);
#line 159 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (current_operation);
#line 159 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return;
#line 1109 "AudioPlayerLibrary.c"
	}
	__finally0:
#line 155 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 155 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (destination_file);
#line 155 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (file);
#line 155 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (_tmp11_);
#line 155 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (current_operation);
#line 155 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 155 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_clear_error (&_inner_error0_);
#line 155 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return;
#line 1128 "AudioPlayerLibrary.c"
	}
#line 162 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp43_ = self->priv->imported_files;
#line 162 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp44_ = destination_file;
#line 162 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp45_ = g_file_get_uri (_tmp44_);
#line 162 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp46_ = _tmp45_;
#line 162 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp43_, _tmp46_);
#line 162 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp46_);
#line 141 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (destination_file);
#line 141 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (file);
#line 141 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp11_);
#line 141 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (current_operation);
#line 1150 "AudioPlayerLibrary.c"
}

static gboolean
_music_libraries_manager_do_progress_notification_with_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = music_libraries_manager_do_progress_notification_with_timeout ((MusicLibrariesManager*) self);
#line 174 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 1160 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_real_add_medias (MusicLibrary* base,
                                                    GeeCollection* list)
{
	MusicPluginsAudioPlayerLibrary * self;
	MusicLibrariesManager* _tmp0_;
	MusicPluginsAudioPlayerDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	MusicLibrariesManager* _tmp5_;
	gint sub_index = 0;
	GeeLinkedList* medias_to_sync = NULL;
	GeeLinkedList* _tmp6_;
	GeeLinkedList* _tmp7_;
	MusicPluginsAudioPlayerDevice* _tmp8_;
	GeeLinkedList* _tmp9_;
	GeeCollection* _tmp10_;
	GeeCollection* _tmp11_;
	GeeLinkedList* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint total_medias = 0;
	GeeLinkedList* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
#line 165 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 165 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (list != NULL);
#line 166 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (music_library_doing_file_operations ((MusicLibrary*) self)) {
#line 167 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_warning ("AudioPlayerLibrary.vala:167: Tried to add when already syncing\n");
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return;
#line 1199 "AudioPlayerLibrary.c"
	}
#line 171 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = music_libraries_manager;
#line 171 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = self->priv->device;
#line 171 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = music_device_get_display_name ((MusicDevice*) _tmp1_);
#line 171 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = _tmp2_;
#line 171 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = g_strdup_printf (_ ("Syncing <b>%s</b>…"), _tmp3_);
#line 171 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp0_->current_operation);
#line 171 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_->current_operation = _tmp4_;
#line 171 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp3_);
#line 173 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->is_doing_file_operations = TRUE;
#line 174 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp5_ = music_libraries_manager;
#line 174 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _music_libraries_manager_do_progress_notification_with_timeout_gsource_func, g_object_ref (_tmp5_), g_object_unref);
#line 175 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	sub_index = 0;
#line 177 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp6_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 177 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	medias_to_sync = _tmp6_;
#line 178 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp7_ = medias_to_sync;
#line 178 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp8_ = self->priv->device;
#line 178 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp9_ = self->priv->medias;
#line 178 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp10_ = music_device_delete_doubles ((MusicDevice*) _tmp8_, list, (GeeCollection*) _tmp9_);
#line 178 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp11_ = _tmp10_;
#line 178 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	gee_collection_add_all ((GeeCollection*) _tmp7_, _tmp11_);
#line 178 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (_tmp11_);
#line 179 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp12_ = medias_to_sync;
#line 179 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 179 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp14_ = _tmp13_;
#line 179 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_message ("AudioPlayerLibrary.vala:179: Found %d medias to add.", _tmp14_);
#line 180 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp15_ = medias_to_sync;
#line 180 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
#line 180 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp17_ = _tmp16_;
#line 180 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	total_medias = _tmp17_;
#line 182 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (total_medias > 0) {
#line 1261 "AudioPlayerLibrary.c"
		MusicPluginsAudioPlayerDevice* _tmp18_;
		GeeLinkedList* _tmp19_;
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp18_ = self->priv->device;
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp19_ = medias_to_sync;
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (music_device_will_fit ((MusicDevice*) _tmp18_, (GeeCollection*) _tmp19_)) {
#line 1270 "AudioPlayerLibrary.c"
			GeeLinkedList* _tmp20_;
			MusicGStreamerTagger* _tmp32_;
			GeeLinkedList* _tmp33_;
#line 184 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp20_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 184 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (self->priv->imported_files);
#line 184 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			self->priv->imported_files = _tmp20_;
#line 1280 "AudioPlayerLibrary.c"
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp21_;
				gint _m_size = 0;
				GeeLinkedList* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				gint _m_index = 0;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp21_ = medias_to_sync;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_list = _tmp21_;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp22_ = _m_list;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp24_ = _tmp23_;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_size = _tmp24_;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_index = -1;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				while (TRUE) {
#line 1305 "AudioPlayerLibrary.c"
					gint _tmp25_;
					gint _tmp26_;
					MusicMedia* m = NULL;
					GeeLinkedList* _tmp27_;
					gpointer _tmp28_;
					MusicMedia* _tmp29_;
					gint _tmp30_;
					MusicLibrariesManager* _tmp31_;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_m_index = _m_index + 1;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp25_ = _m_index;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp26_ = _m_size;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (!(_tmp25_ < _tmp26_)) {
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 1324 "AudioPlayerLibrary.c"
					}
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp27_ = _m_list;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, _m_index);
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					m = (MusicMedia*) _tmp28_;
#line 187 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp29_ = m;
#line 187 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					music_library_add_media ((MusicLibrary*) self, _tmp29_);
#line 188 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					sub_index = sub_index + 1;
#line 188 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp30_ = sub_index;
#line 189 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp31_ = music_libraries_manager;
#line 189 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp31_->progress = (gdouble) (sub_index / total_medias);
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (m);
#line 1346 "AudioPlayerLibrary.c"
				}
			}
#line 192 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp32_ = self->tagger;
#line 192 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp33_ = self->priv->imported_files;
#line 192 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			music_gstreamer_tagger_discoverer_import_media (_tmp32_, (GeeCollection*) _tmp33_);
#line 1355 "AudioPlayerLibrary.c"
		}
	}
#line 195 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (medias_to_sync);
#line 195 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return;
#line 1362 "AudioPlayerLibrary.c"
}

static MusicMedia*
music_plugins_audio_player_library_real_media_from_id (MusicLibrary* base,
                                                       gint64 id)
{
	MusicPluginsAudioPlayerLibrary * self;
	GError* _inner_error0_ = NULL;
	MusicMedia* result;
#line 198 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 1374 "AudioPlayerLibrary.c"
	{
		GeeLinkedList* _tmp0_;
#line 199 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp0_ = self->priv->medias;
#line 199 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_medias);
#line 1381 "AudioPlayerLibrary.c"
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp1_;
				gint _m_size = 0;
				GeeLinkedList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gint _m_index = 0;
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp1_ = self->priv->medias;
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_list = _tmp1_;
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp2_ = _m_list;
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp4_ = _tmp3_;
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_size = _tmp4_;
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_index = -1;
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				while (TRUE) {
#line 1407 "AudioPlayerLibrary.c"
					gint _tmp5_;
					gint _tmp6_;
					MusicMedia* m = NULL;
					GeeLinkedList* _tmp7_;
					gpointer _tmp8_;
					MusicMedia* _tmp9_;
					gint64 _tmp10_;
					gint64 _tmp11_;
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_m_index = _m_index + 1;
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp5_ = _m_index;
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp6_ = _m_size;
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (!(_tmp5_ < _tmp6_)) {
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 1426 "AudioPlayerLibrary.c"
					}
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp7_ = _m_list;
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _m_index);
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					m = (MusicMedia*) _tmp8_;
#line 201 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp9_ = m;
#line 201 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp10_ = music_media_get_rowid (_tmp9_);
#line 201 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp11_ = _tmp10_;
#line 201 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp11_ == id) {
#line 202 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						result = m;
#line 1444 "AudioPlayerLibrary.c"
						{
							GeeLinkedList* _tmp12_;
#line 199 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_tmp12_ = self->priv->medias;
#line 199 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 1451 "AudioPlayerLibrary.c"
						}
#line 202 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						return result;
#line 1455 "AudioPlayerLibrary.c"
					}
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (m);
#line 1459 "AudioPlayerLibrary.c"
				}
			}
		}
		__finally0:
		{
			GeeLinkedList* _tmp13_;
#line 199 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp13_ = self->priv->medias;
#line 199 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 1470 "AudioPlayerLibrary.c"
		}
#line 199 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 199 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 199 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			return NULL;
#line 1480 "AudioPlayerLibrary.c"
		}
	}
#line 206 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = NULL;
#line 206 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 1487 "AudioPlayerLibrary.c"
}

static GeeCollection*
music_plugins_audio_player_library_real_medias_from_ids (MusicLibrary* base,
                                                         GeeCollection* ids)
{
	MusicPluginsAudioPlayerLibrary * self;
	GeeLinkedList* media_collection = NULL;
	GeeLinkedList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeCollection* result;
#line 209 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 209 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_val_if_fail (ids != NULL, NULL);
#line 210 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 210 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	media_collection = _tmp0_;
#line 1507 "AudioPlayerLibrary.c"
	{
		GeeLinkedList* _tmp1_;
#line 212 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp1_ = self->priv->medias;
#line 212 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_medias);
#line 1514 "AudioPlayerLibrary.c"
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp2_;
				gint _m_size = 0;
				GeeLinkedList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _m_index = 0;
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp2_ = self->priv->medias;
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_list = _tmp2_;
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp3_ = _m_list;
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp5_ = _tmp4_;
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_size = _tmp5_;
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_index = -1;
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				while (TRUE) {
#line 1540 "AudioPlayerLibrary.c"
					gint _tmp6_;
					gint _tmp7_;
					MusicMedia* m = NULL;
					GeeLinkedList* _tmp8_;
					gpointer _tmp9_;
					MusicMedia* _tmp10_;
					gint64 _tmp11_;
					gint64 _tmp12_;
					GeeLinkedList* _tmp15_;
					gint _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					gint _tmp19_;
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_m_index = _m_index + 1;
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp6_ = _m_index;
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp7_ = _m_size;
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (!(_tmp6_ < _tmp7_)) {
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 1564 "AudioPlayerLibrary.c"
					}
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp8_ = _m_list;
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _m_index);
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					m = (MusicMedia*) _tmp9_;
#line 214 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp10_ = m;
#line 214 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp11_ = music_media_get_rowid (_tmp10_);
#line 214 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp12_ = _tmp11_;
#line 214 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (gee_collection_contains (ids, &_tmp12_)) {
#line 1580 "AudioPlayerLibrary.c"
						GeeLinkedList* _tmp13_;
						MusicMedia* _tmp14_;
#line 215 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp13_ = media_collection;
#line 215 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp14_ = m;
#line 215 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 1589 "AudioPlayerLibrary.c"
					}
#line 216 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp15_ = media_collection;
#line 216 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
#line 216 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp17_ = _tmp16_;
#line 216 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp18_ = gee_collection_get_size (ids);
#line 216 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp19_ = _tmp18_;
#line 216 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp17_ == _tmp19_) {
#line 217 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_object_unref0 (m);
#line 217 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 1607 "AudioPlayerLibrary.c"
					}
#line 213 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (m);
#line 1611 "AudioPlayerLibrary.c"
				}
			}
		}
		__finally0:
		{
			GeeLinkedList* _tmp20_;
#line 212 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp20_ = self->priv->medias;
#line 212 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 1622 "AudioPlayerLibrary.c"
		}
#line 212 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 212 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (media_collection);
#line 212 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 212 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 212 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			return NULL;
#line 1634 "AudioPlayerLibrary.c"
		}
	}
#line 221 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = (GeeCollection*) media_collection;
#line 221 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 1641 "AudioPlayerLibrary.c"
}

static GeeCollection*
music_plugins_audio_player_library_real_medias_from_uris (MusicLibrary* base,
                                                          GeeCollection* uris)
{
	MusicPluginsAudioPlayerLibrary * self;
	GeeLinkedList* media_collection = NULL;
	GeeLinkedList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeCollection* result;
#line 224 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 224 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_val_if_fail (uris != NULL, NULL);
#line 225 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 225 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	media_collection = _tmp0_;
#line 1661 "AudioPlayerLibrary.c"
	{
		GeeLinkedList* _tmp1_;
#line 227 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp1_ = self->priv->medias;
#line 227 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_medias);
#line 1668 "AudioPlayerLibrary.c"
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp2_;
				gint _m_size = 0;
				GeeLinkedList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _m_index = 0;
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp2_ = self->priv->medias;
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_list = _tmp2_;
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp3_ = _m_list;
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp5_ = _tmp4_;
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_size = _tmp5_;
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_index = -1;
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				while (TRUE) {
#line 1694 "AudioPlayerLibrary.c"
					gint _tmp6_;
					gint _tmp7_;
					MusicMedia* m = NULL;
					GeeLinkedList* _tmp8_;
					gpointer _tmp9_;
					MusicMedia* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					gboolean _tmp14_;
					GeeLinkedList* _tmp17_;
					gint _tmp18_;
					gint _tmp19_;
					gint _tmp20_;
					gint _tmp21_;
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_m_index = _m_index + 1;
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp6_ = _m_index;
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp7_ = _m_size;
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (!(_tmp6_ < _tmp7_)) {
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 1720 "AudioPlayerLibrary.c"
					}
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp8_ = _m_list;
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _m_index);
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					m = (MusicMedia*) _tmp9_;
#line 229 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp10_ = m;
#line 229 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp11_ = music_media_get_uri (_tmp10_);
#line 229 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp12_ = _tmp11_;
#line 229 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp13_ = _tmp12_;
#line 229 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp14_ = gee_collection_contains (uris, _tmp13_);
#line 229 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_free0 (_tmp13_);
#line 229 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp14_) {
#line 1742 "AudioPlayerLibrary.c"
						GeeLinkedList* _tmp15_;
						MusicMedia* _tmp16_;
#line 230 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp15_ = media_collection;
#line 230 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp16_ = m;
#line 230 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 1751 "AudioPlayerLibrary.c"
					}
#line 231 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp17_ = media_collection;
#line 231 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp18_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp17_);
#line 231 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp19_ = _tmp18_;
#line 231 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp20_ = gee_collection_get_size (uris);
#line 231 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp21_ = _tmp20_;
#line 231 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp19_ == _tmp21_) {
#line 232 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_object_unref0 (m);
#line 232 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 1769 "AudioPlayerLibrary.c"
					}
#line 228 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (m);
#line 1773 "AudioPlayerLibrary.c"
				}
			}
		}
		__finally0:
		{
			GeeLinkedList* _tmp22_;
#line 227 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp22_ = self->priv->medias;
#line 227 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 1784 "AudioPlayerLibrary.c"
		}
#line 227 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 227 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (media_collection);
#line 227 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 227 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 227 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			return NULL;
#line 1796 "AudioPlayerLibrary.c"
		}
	}
#line 236 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = (GeeCollection*) media_collection;
#line 236 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 1803 "AudioPlayerLibrary.c"
}

static MusicMedia*
music_plugins_audio_player_library_real_find_media (MusicLibrary* base,
                                                    MusicMedia* to_find)
{
	MusicPluginsAudioPlayerLibrary * self;
	MusicMedia* found = NULL;
	GError* _inner_error0_ = NULL;
	MusicMedia* result;
#line 239 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 239 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_val_if_fail (to_find != NULL, NULL);
#line 240 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	found = NULL;
#line 1820 "AudioPlayerLibrary.c"
	{
		GeeLinkedList* _tmp0_;
#line 241 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp0_ = self->priv->medias;
#line 241 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_medias);
#line 1827 "AudioPlayerLibrary.c"
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp1_;
				gint _m_size = 0;
				GeeLinkedList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gint _m_index = 0;
#line 242 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp1_ = self->priv->medias;
#line 242 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_list = _tmp1_;
#line 242 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp2_ = _m_list;
#line 242 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 242 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp4_ = _tmp3_;
#line 242 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_size = _tmp4_;
#line 242 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_index = -1;
#line 242 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				while (TRUE) {
#line 1853 "AudioPlayerLibrary.c"
					gint _tmp5_;
					gint _tmp6_;
					MusicMedia* m = NULL;
					GeeLinkedList* _tmp7_;
					gpointer _tmp8_;
					gboolean _tmp9_ = FALSE;
					const gchar* _tmp10_;
					const gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					MusicMedia* _tmp14_;
					const gchar* _tmp15_;
					const gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gboolean _tmp19_;
#line 242 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_m_index = _m_index + 1;
#line 242 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp5_ = _m_index;
#line 242 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp6_ = _m_size;
#line 242 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (!(_tmp5_ < _tmp6_)) {
#line 242 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 1880 "AudioPlayerLibrary.c"
					}
#line 242 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp7_ = _m_list;
#line 242 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _m_index);
#line 242 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					m = (MusicMedia*) _tmp8_;
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp10_ = music_media_get_title (to_find);
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp11_ = _tmp10_;
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp12_ = g_utf8_strdown (_tmp11_, (gssize) -1);
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp13_ = _tmp12_;
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp14_ = m;
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp15_ = music_media_get_title (_tmp14_);
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp16_ = _tmp15_;
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp17_ = g_utf8_strdown (_tmp16_, (gssize) -1);
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp18_ = _tmp17_;
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp19_ = g_strcmp0 (_tmp13_, _tmp18_) == 0;
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_free0 (_tmp18_);
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_free0 (_tmp13_);
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp19_) {
#line 1914 "AudioPlayerLibrary.c"
						const gchar* _tmp20_;
						const gchar* _tmp21_;
						gchar* _tmp22_;
						gchar* _tmp23_;
						MusicMedia* _tmp24_;
						const gchar* _tmp25_;
						const gchar* _tmp26_;
						gchar* _tmp27_;
						gchar* _tmp28_;
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp20_ = music_media_get_artist (to_find);
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp21_ = _tmp20_;
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp22_ = g_utf8_strdown (_tmp21_, (gssize) -1);
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp23_ = _tmp22_;
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp24_ = m;
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp25_ = music_media_get_artist (_tmp24_);
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp26_ = _tmp25_;
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp27_ = g_utf8_strdown (_tmp26_, (gssize) -1);
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp28_ = _tmp27_;
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp9_ = g_strcmp0 (_tmp23_, _tmp28_) == 0;
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_free0 (_tmp28_);
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_free0 (_tmp23_);
#line 1948 "AudioPlayerLibrary.c"
					} else {
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp9_ = FALSE;
#line 1952 "AudioPlayerLibrary.c"
					}
#line 243 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp9_) {
#line 1956 "AudioPlayerLibrary.c"
						MusicMedia* _tmp29_;
						MusicMedia* _tmp30_;
#line 244 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp29_ = m;
#line 244 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp30_ = _g_object_ref0 (_tmp29_);
#line 244 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_object_unref0 (found);
#line 244 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						found = _tmp30_;
#line 245 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_object_unref0 (m);
#line 245 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 1971 "AudioPlayerLibrary.c"
					}
#line 242 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (m);
#line 1975 "AudioPlayerLibrary.c"
				}
			}
		}
		__finally0:
		{
			GeeLinkedList* _tmp31_;
#line 241 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp31_ = self->priv->medias;
#line 241 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 1986 "AudioPlayerLibrary.c"
		}
#line 241 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 241 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (found);
#line 241 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 241 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 241 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			return NULL;
#line 1998 "AudioPlayerLibrary.c"
		}
	}
#line 249 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = found;
#line 249 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 2005 "AudioPlayerLibrary.c"
}

static MusicMedia*
music_plugins_audio_player_library_real_media_from_file (MusicLibrary* base,
                                                         GFile* file)
{
	MusicPluginsAudioPlayerLibrary * self;
	GError* _inner_error0_ = NULL;
	MusicMedia* result;
#line 252 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 252 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 2019 "AudioPlayerLibrary.c"
	{
		GeeLinkedList* _tmp0_;
#line 253 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp0_ = self->priv->medias;
#line 253 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_medias);
#line 2026 "AudioPlayerLibrary.c"
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp1_;
				gint _m_size = 0;
				GeeLinkedList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gint _m_index = 0;
#line 254 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp1_ = self->priv->medias;
#line 254 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_list = _tmp1_;
#line 254 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp2_ = _m_list;
#line 254 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 254 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp4_ = _tmp3_;
#line 254 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_size = _tmp4_;
#line 254 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_index = -1;
#line 254 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				while (TRUE) {
#line 2052 "AudioPlayerLibrary.c"
					gint _tmp5_;
					gint _tmp6_;
					MusicMedia* m = NULL;
					GeeLinkedList* _tmp7_;
					gpointer _tmp8_;
					gboolean _tmp9_ = FALSE;
					MusicMedia* _tmp10_;
#line 254 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_m_index = _m_index + 1;
#line 254 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp5_ = _m_index;
#line 254 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp6_ = _m_size;
#line 254 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (!(_tmp5_ < _tmp6_)) {
#line 254 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 2070 "AudioPlayerLibrary.c"
					}
#line 254 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp7_ = _m_list;
#line 254 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _m_index);
#line 254 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					m = (MusicMedia*) _tmp8_;
#line 255 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp10_ = m;
#line 255 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp10_ != NULL) {
#line 2082 "AudioPlayerLibrary.c"
						MusicMedia* _tmp11_;
						GFile* _tmp12_;
						GFile* _tmp13_;
#line 255 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp11_ = m;
#line 255 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp12_ = music_media_get_file (_tmp11_);
#line 255 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp13_ = _tmp12_;
#line 255 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp9_ = g_file_equal (_tmp13_, file);
#line 2094 "AudioPlayerLibrary.c"
					} else {
#line 255 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp9_ = FALSE;
#line 2098 "AudioPlayerLibrary.c"
					}
#line 255 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp9_) {
#line 256 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						result = m;
#line 2104 "AudioPlayerLibrary.c"
						{
							GeeLinkedList* _tmp14_;
#line 253 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_tmp14_ = self->priv->medias;
#line 253 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 2111 "AudioPlayerLibrary.c"
						}
#line 256 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						return result;
#line 2115 "AudioPlayerLibrary.c"
					}
#line 254 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (m);
#line 2119 "AudioPlayerLibrary.c"
				}
			}
		}
		__finally0:
		{
			GeeLinkedList* _tmp15_;
#line 253 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp15_ = self->priv->medias;
#line 253 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 2130 "AudioPlayerLibrary.c"
		}
#line 253 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 253 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 253 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 253 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			return NULL;
#line 2140 "AudioPlayerLibrary.c"
		}
	}
#line 260 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = NULL;
#line 260 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 2147 "AudioPlayerLibrary.c"
}

static MusicMedia*
music_plugins_audio_player_library_real_media_from_uri (MusicLibrary* base,
                                                        const gchar* uri)
{
	MusicPluginsAudioPlayerLibrary * self;
	GError* _inner_error0_ = NULL;
	MusicMedia* result;
#line 263 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 263 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 2161 "AudioPlayerLibrary.c"
	{
		GeeLinkedList* _tmp0_;
#line 264 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp0_ = self->priv->medias;
#line 264 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_medias);
#line 2168 "AudioPlayerLibrary.c"
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp1_;
				gint _m_size = 0;
				GeeLinkedList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gint _m_index = 0;
#line 265 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp1_ = self->priv->medias;
#line 265 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_list = _tmp1_;
#line 265 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp2_ = _m_list;
#line 265 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 265 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp4_ = _tmp3_;
#line 265 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_size = _tmp4_;
#line 265 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_m_index = -1;
#line 265 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				while (TRUE) {
#line 2194 "AudioPlayerLibrary.c"
					gint _tmp5_;
					gint _tmp6_;
					MusicMedia* m = NULL;
					GeeLinkedList* _tmp7_;
					gpointer _tmp8_;
					gboolean _tmp9_ = FALSE;
					MusicMedia* _tmp10_;
#line 265 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_m_index = _m_index + 1;
#line 265 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp5_ = _m_index;
#line 265 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp6_ = _m_size;
#line 265 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (!(_tmp5_ < _tmp6_)) {
#line 265 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						break;
#line 2212 "AudioPlayerLibrary.c"
					}
#line 265 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp7_ = _m_list;
#line 265 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _m_index);
#line 265 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					m = (MusicMedia*) _tmp8_;
#line 266 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp10_ = m;
#line 266 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp10_ != NULL) {
#line 2224 "AudioPlayerLibrary.c"
						MusicMedia* _tmp11_;
						gchar* _tmp12_;
						gchar* _tmp13_;
						gchar* _tmp14_;
#line 266 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp11_ = m;
#line 266 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp12_ = music_media_get_uri (_tmp11_);
#line 266 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp13_ = _tmp12_;
#line 266 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp14_ = _tmp13_;
#line 266 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp9_ = g_strcmp0 (_tmp14_, uri) == 0;
#line 266 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_g_free0 (_tmp14_);
#line 2241 "AudioPlayerLibrary.c"
					} else {
#line 266 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						_tmp9_ = FALSE;
#line 2245 "AudioPlayerLibrary.c"
					}
#line 266 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					if (_tmp9_) {
#line 267 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						result = m;
#line 2251 "AudioPlayerLibrary.c"
						{
							GeeLinkedList* _tmp15_;
#line 264 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							_tmp15_ = self->priv->medias;
#line 264 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
							g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 2258 "AudioPlayerLibrary.c"
						}
#line 267 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
						return result;
#line 2262 "AudioPlayerLibrary.c"
					}
#line 265 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (m);
#line 2266 "AudioPlayerLibrary.c"
				}
			}
		}
		__finally0:
		{
			GeeLinkedList* _tmp16_;
#line 264 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp16_ = self->priv->medias;
#line 264 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 2277 "AudioPlayerLibrary.c"
		}
#line 264 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 264 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 264 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 264 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			return NULL;
#line 2287 "AudioPlayerLibrary.c"
		}
	}
#line 271 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = NULL;
#line 271 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 2294 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_real_update_media (MusicLibrary* base,
                                                      MusicMedia* s,
                                                      gboolean update_meta,
                                                      gboolean record_time)
{
	MusicPluginsAudioPlayerLibrary * self;
#line 274 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 274 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (s != NULL);
#line 2308 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_real_update_medias (MusicLibrary* base,
                                                       GeeCollection* updates,
                                                       gboolean update_meta,
                                                       gboolean record_time)
{
	MusicPluginsAudioPlayerLibrary * self;
#line 278 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 278 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (updates != NULL);
#line 2322 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_real_remove_media (MusicLibrary* base,
                                                      MusicMedia* m,
                                                      gboolean trash)
{
	MusicPluginsAudioPlayerLibrary * self;
	gchar* current_operation = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_ = NULL;
	MusicPluginsAudioPlayerDevice* _tmp12_;
	gchar* _tmp13_;
	MusicLibrariesManager* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gboolean _tmp21_;
	GError* _inner_error0_ = NULL;
#line 282 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 282 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (m != NULL);
#line 283 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = g_strdup (_ ("Removing <b>$NAME</b> by <b>$ARTIST</b> from $DEVICE"));
#line 283 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	current_operation = _tmp0_;
#line 284 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = music_media_get_title (m);
#line 284 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = _tmp2_;
#line 284 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = _tmp3_;
#line 284 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp1_ == NULL) {
#line 284 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp1_ = "";
#line 2372 "AudioPlayerLibrary.c"
	}
#line 284 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = current_operation;
#line 284 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp5_ = string_replace (_tmp4_, "$NAME", _tmp1_);
#line 284 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (current_operation);
#line 284 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	current_operation = _tmp5_;
#line 285 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp7_ = music_media_get_artist (m);
#line 285 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp8_ = _tmp7_;
#line 285 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp6_ = _tmp8_;
#line 285 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp6_ == NULL) {
#line 285 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp6_ = "";
#line 2392 "AudioPlayerLibrary.c"
	}
#line 285 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp9_ = current_operation;
#line 285 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp10_ = string_replace (_tmp9_, "$ARTIST", _tmp6_);
#line 285 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (current_operation);
#line 285 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	current_operation = _tmp10_;
#line 286 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp12_ = self->priv->device;
#line 286 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp13_ = music_device_get_display_name ((MusicDevice*) _tmp12_);
#line 286 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp11_ = _tmp13_;
#line 286 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp11_ == NULL) {
#line 2410 "AudioPlayerLibrary.c"
		gchar* _tmp14_;
#line 286 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp14_ = g_strdup ("");
#line 286 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (_tmp11_);
#line 286 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp11_ = _tmp14_;
#line 2418 "AudioPlayerLibrary.c"
	}
#line 286 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp15_ = music_libraries_manager;
#line 286 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp16_ = current_operation;
#line 286 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp17_ = string_replace (_tmp16_, "$DEVICE", _tmp11_);
#line 286 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp15_->current_operation);
#line 286 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp15_->current_operation = _tmp17_;
#line 288 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp18_ = music_media_get_uri (m);
#line 288 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp19_ = _tmp18_;
#line 288 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp20_ = _tmp19_;
#line 288 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp21_ = _tmp20_ != NULL;
#line 288 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp20_);
#line 288 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp21_) {
#line 2442 "AudioPlayerLibrary.c"
		GFile* file = NULL;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		GFile* _tmp25_;
		GFile* _tmp26_;
		GFile* _tmp27_;
#line 289 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp22_ = music_media_get_uri (m);
#line 289 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp23_ = _tmp22_;
#line 289 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp24_ = _tmp23_;
#line 289 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp25_ = g_file_new_for_uri (_tmp24_);
#line 289 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp26_ = _tmp25_;
#line 289 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (_tmp24_);
#line 289 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		file = _tmp26_;
#line 291 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp27_ = file;
#line 291 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (g_file_query_exists (_tmp27_, NULL)) {
#line 2468 "AudioPlayerLibrary.c"
			GeeArrayList* media_list = NULL;
			GeeArrayList* _tmp28_;
			GeeArrayList* _tmp29_;
			GeeArrayList* _tmp30_;
			GeeLinkedList* _tmp31_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
#line 292 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp28_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 292 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			media_list = _tmp28_;
#line 293 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp29_ = media_list;
#line 293 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, m);
#line 294 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp30_ = media_list;
#line 294 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_signal_emit_by_name ((MusicLibrary*) self, "media-removed", (GeeCollection*) _tmp30_);
#line 295 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp31_ = self->priv->medias;
#line 295 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp31_, m);
#line 2493 "AudioPlayerLibrary.c"
			{
				GFile* _tmp32_;
#line 297 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp32_ = file;
#line 297 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				g_file_delete (_tmp32_, NULL, &_inner_error0_);
#line 297 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2502 "AudioPlayerLibrary.c"
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
				GError* _tmp36_;
				const gchar* _tmp37_;
#line 296 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				err = _inner_error0_;
#line 296 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_inner_error0_ = NULL;
#line 299 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp33_ = music_media_get_uri (m);
#line 299 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp34_ = _tmp33_;
#line 299 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp35_ = _tmp34_;
#line 299 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp36_ = err;
#line 299 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp37_ = _tmp36_->message;
#line 299 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				g_warning ("AudioPlayerLibrary.vala:299: Could not delete File at %s: %s", _tmp35_, _tmp37_);
#line 299 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_free0 (_tmp35_);
#line 300 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_error_free0 (err);
#line 300 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (media_list);
#line 300 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (file);
#line 300 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_free0 (_tmp11_);
#line 300 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_free0 (current_operation);
#line 300 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				return;
#line 2545 "AudioPlayerLibrary.c"
			}
			__finally0:
#line 296 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 296 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (media_list);
#line 296 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (file);
#line 296 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_free0 (_tmp11_);
#line 296 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_free0 (current_operation);
#line 296 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 296 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				g_clear_error (&_inner_error0_);
#line 296 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				return;
#line 2564 "AudioPlayerLibrary.c"
			}
#line 302 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp38_ = music_media_get_uri (m);
#line 302 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp39_ = _tmp38_;
#line 302 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp40_ = _tmp39_;
#line 302 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_debug ("AudioPlayerLibrary.vala:302: Successfully removed music file %s", _tmp40_);
#line 302 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_free0 (_tmp40_);
#line 291 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (media_list);
#line 2578 "AudioPlayerLibrary.c"
		} else {
			gchar* _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
#line 304 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp41_ = music_media_get_uri (m);
#line 304 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp42_ = _tmp41_;
#line 304 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp43_ = _tmp42_;
#line 304 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_warning ("AudioPlayerLibrary.vala:304: File not found, could not delete File at " \
"%s. File may already be deleted", _tmp43_);
#line 304 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_free0 (_tmp43_);
#line 2593 "AudioPlayerLibrary.c"
		}
#line 288 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (file);
#line 2597 "AudioPlayerLibrary.c"
	}
#line 282 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp11_);
#line 282 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (current_operation);
#line 2603 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_real_remove_medias (MusicLibrary* base,
                                                       GeeCollection* list,
                                                       gboolean trash)
{
	MusicPluginsAudioPlayerLibrary * self;
	MusicLibrariesManager* _tmp0_;
	MusicPluginsAudioPlayerDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gint total = 0;
	gint _tmp5_;
	gint _tmp6_;
	MusicLibrariesManager* _tmp7_;
	gint sub_index = 0;
	MusicLibrariesManager* _tmp15_;
#line 309 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 309 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (list != NULL);
#line 310 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (music_library_doing_file_operations ((MusicLibrary*) self)) {
#line 311 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_warning ("AudioPlayerLibrary.vala:311: Tried to add when already syncing\n");
#line 312 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return;
#line 2633 "AudioPlayerLibrary.c"
	}
#line 315 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = music_libraries_manager;
#line 315 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = self->priv->device;
#line 315 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = music_device_get_display_name ((MusicDevice*) _tmp1_);
#line 315 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = _tmp2_;
#line 315 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = g_strdup_printf (_ ("Removing from <b>%s</b>…"), _tmp3_);
#line 315 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp0_->current_operation);
#line 315 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_->current_operation = _tmp4_;
#line 315 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp3_);
#line 317 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp5_ = gee_collection_get_size (list);
#line 317 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp6_ = _tmp5_;
#line 317 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	total = _tmp6_;
#line 318 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp7_ = music_libraries_manager;
#line 318 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _music_libraries_manager_do_progress_notification_with_timeout_gsource_func, g_object_ref (_tmp7_), g_object_unref);
#line 320 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	sub_index = 0;
#line 2663 "AudioPlayerLibrary.c"
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp8_;
#line 321 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp8_ = gee_iterable_iterator ((GeeIterable*) list);
#line 321 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_m_it = _tmp8_;
#line 321 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		while (TRUE) {
#line 2673 "AudioPlayerLibrary.c"
			GeeIterator* _tmp9_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			MusicMedia* _tmp12_;
			gint _tmp13_;
			MusicLibrariesManager* _tmp14_;
#line 321 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp9_ = _m_it;
#line 321 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			if (!gee_iterator_next (_tmp9_)) {
#line 321 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				break;
#line 2687 "AudioPlayerLibrary.c"
			}
#line 321 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp10_ = _m_it;
#line 321 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 321 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			m = (MusicMedia*) _tmp11_;
#line 322 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp12_ = m;
#line 322 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			music_library_remove_media ((MusicLibrary*) self, _tmp12_, TRUE);
#line 323 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			sub_index = sub_index + 1;
#line 323 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp13_ = sub_index;
#line 324 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp14_ = music_libraries_manager;
#line 324 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp14_->progress = (gdouble) (sub_index / total);
#line 321 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (m);
#line 2709 "AudioPlayerLibrary.c"
		}
#line 321 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (_m_it);
#line 2713 "AudioPlayerLibrary.c"
	}
#line 327 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp15_ = music_libraries_manager;
#line 327 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp15_->progress = (gdouble) 1;
#line 328 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_emit_by_name ((MusicLibrary*) self, "file-operations-done");
#line 2721 "AudioPlayerLibrary.c"
}

static gboolean
music_plugins_audio_player_library_real_support_smart_playlists (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
	gboolean result;
#line 331 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 332 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = FALSE;
#line 332 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 2735 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_real_add_smart_playlist (MusicLibrary* base,
                                                            MusicSmartPlaylist* p)
{
	MusicPluginsAudioPlayerLibrary * self;
#line 335 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 335 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (p != NULL);
#line 2747 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_real_remove_smart_playlist (MusicLibrary* base,
                                                               gint64 id)
{
	MusicPluginsAudioPlayerLibrary * self;
#line 339 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 2757 "AudioPlayerLibrary.c"
}

static MusicSmartPlaylist*
music_plugins_audio_player_library_real_smart_playlist_from_id (MusicLibrary* base,
                                                                gint64 id)
{
	MusicPluginsAudioPlayerLibrary * self;
	MusicSmartPlaylist* result;
#line 343 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 344 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = NULL;
#line 344 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 2772 "AudioPlayerLibrary.c"
}

static MusicSmartPlaylist*
music_plugins_audio_player_library_real_smart_playlist_from_name (MusicLibrary* base,
                                                                  const gchar* name)
{
	MusicPluginsAudioPlayerLibrary * self;
	MusicSmartPlaylist* result;
#line 347 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 347 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 348 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = NULL;
#line 348 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 2789 "AudioPlayerLibrary.c"
}

static gboolean
music_plugins_audio_player_library_real_support_playlists (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
	gboolean result;
#line 351 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 352 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = FALSE;
#line 352 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 2803 "AudioPlayerLibrary.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 355 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 355 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return _data1_;
#line 2813 "AudioPlayerLibrary.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 355 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 2823 "AudioPlayerLibrary.c"
		MusicPluginsAudioPlayerLibrary* self;
#line 355 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		self = _data1_->self;
#line 355 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (_data1_->p);
#line 355 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (self);
#line 355 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_slice_free (Block1Data, _data1_);
#line 2833 "AudioPlayerLibrary.c"
	}
}

static void
__lambda5_ (Block1Data* _data1_)
{
	MusicPluginsAudioPlayerLibrary* self;
#line 359 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = _data1_->self;
#line 359 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	music_plugins_audio_player_library_keep_playlist_synchronized (self, _data1_->p);
#line 2845 "AudioPlayerLibrary.c"
}

static void
___lambda5__music_playlist_media_added (MusicPlaylist* _sender,
                                        GeeCollection* media,
                                        gpointer self)
{
#line 359 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	__lambda5_ (self);
#line 2855 "AudioPlayerLibrary.c"
}

static void
__lambda6_ (Block1Data* _data1_)
{
	MusicPluginsAudioPlayerLibrary* self;
#line 360 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = _data1_->self;
#line 360 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	music_plugins_audio_player_library_keep_playlist_synchronized (self, _data1_->p);
#line 2866 "AudioPlayerLibrary.c"
}

static void
___lambda6__music_playlist_media_removed (MusicPlaylist* _sender,
                                          GeeCollection* media,
                                          gpointer self)
{
#line 360 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	__lambda6_ (self);
#line 2876 "AudioPlayerLibrary.c"
}

static void
__lambda7_ (Block1Data* _data1_,
            const gchar* old_name)
{
	MusicPluginsAudioPlayerLibrary* self;
#line 361 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = _data1_->self;
#line 361 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	music_plugins_audio_player_library_remove_playlist_from_name (self, old_name);
#line 361 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	music_plugins_audio_player_library_keep_playlist_synchronized (self, _data1_->p);
#line 2890 "AudioPlayerLibrary.c"
}

static void
___lambda7__music_playlist_updated (MusicPlaylist* _sender,
                                    const gchar* old_name,
                                    gpointer self)
{
#line 361 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	__lambda7_ (self, old_name);
#line 2900 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_real_add_playlist (MusicLibrary* base,
                                                      MusicStaticPlaylist* p)
{
	MusicPluginsAudioPlayerLibrary * self;
	Block1Data* _data1_;
	MusicStaticPlaylist* _tmp0_;
	GeeLinkedList* _tmp1_;
#line 355 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 355 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (p != NULL);
#line 355 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 355 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_data1_->_ref_count_ = 1;
#line 355 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_data1_->self = g_object_ref (self);
#line 355 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = _g_object_ref0 (p);
#line 355 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (_data1_->p);
#line 355 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_data1_->p = _tmp0_;
#line 356 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = self->priv->playlists;
#line 356 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _data1_->p);
#line 357 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_emit_by_name ((MusicLibrary*) self, "playlist-added", _data1_->p);
#line 358 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	music_plugins_audio_player_library_keep_playlist_synchronized (self, _data1_->p);
#line 359 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_connect_data ((MusicPlaylist*) _data1_->p, "media-added", (GCallback) ___lambda5__music_playlist_media_added, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 360 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_connect_data ((MusicPlaylist*) _data1_->p, "media-removed", (GCallback) ___lambda6__music_playlist_media_removed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 361 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_signal_connect_data ((MusicPlaylist*) _data1_->p, "updated", (GCallback) ___lambda7__music_playlist_updated, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 355 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	block1_data_unref (_data1_);
#line 355 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_data1_ = NULL;
#line 2945 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_real_remove_playlist (MusicLibrary* base,
                                                         gint64 id)
{
	MusicPluginsAudioPlayerLibrary * self;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
#line 364 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 365 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = music_library_get_playlists ((MusicLibrary*) self);
#line 365 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = _tmp0_;
#line 365 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = gee_collection_get_size (_tmp1_);
#line 365 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = _tmp2_;
#line 365 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = id < ((gint64) _tmp3_);
#line 365 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (_tmp1_);
#line 365 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp4_) {
#line 2974 "AudioPlayerLibrary.c"
		GeeArrayList* array_v = NULL;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeLinkedList* _tmp7_;
#line 366 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp5_ = gee_array_list_new (MUSIC_TYPE_STATIC_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 366 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		array_v = _tmp5_;
#line 367 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp6_ = array_v;
#line 367 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp7_ = self->priv->playlists;
#line 367 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		gee_array_list_add_all (_tmp6_, (GeeCollection*) _tmp7_);
#line 2989 "AudioPlayerLibrary.c"
		{
			GeeArrayList* _p_list = NULL;
			GeeArrayList* _tmp8_;
			gint _p_size = 0;
			GeeArrayList* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			gint _p_index = 0;
#line 368 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp8_ = array_v;
#line 368 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_p_list = _tmp8_;
#line 368 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp9_ = _p_list;
#line 368 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
#line 368 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp11_ = _tmp10_;
#line 368 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_p_size = _tmp11_;
#line 368 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_p_index = -1;
#line 368 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			while (TRUE) {
#line 3014 "AudioPlayerLibrary.c"
				gint _tmp12_;
				gint _tmp13_;
				MusicStaticPlaylist* p = NULL;
				GeeArrayList* _tmp14_;
				gpointer _tmp15_;
				MusicStaticPlaylist* _tmp16_;
				gint64 _tmp17_;
				gint64 _tmp18_;
#line 368 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_p_index = _p_index + 1;
#line 368 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp12_ = _p_index;
#line 368 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp13_ = _p_size;
#line 368 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				if (!(_tmp12_ < _tmp13_)) {
#line 368 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					break;
#line 3033 "AudioPlayerLibrary.c"
				}
#line 368 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp14_ = _p_list;
#line 368 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, _p_index);
#line 368 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				p = (MusicStaticPlaylist*) _tmp15_;
#line 369 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp16_ = p;
#line 369 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp17_ = music_playlist_get_rowid ((MusicPlaylist*) _tmp16_);
#line 369 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp18_ = _tmp17_;
#line 369 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				if (_tmp18_ == id) {
#line 3049 "AudioPlayerLibrary.c"
					MusicStaticPlaylist* _tmp19_;
					const gchar* _tmp20_;
					const gchar* _tmp21_;
					MusicStaticPlaylist* _tmp22_;
					GeeLinkedList* _tmp23_;
					MusicStaticPlaylist* _tmp24_;
#line 370 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp19_ = p;
#line 370 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp20_ = music_playlist_get_name ((MusicPlaylist*) _tmp19_);
#line 370 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp21_ = _tmp20_;
#line 370 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					music_plugins_audio_player_library_remove_playlist_from_name (self, _tmp21_);
#line 371 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp22_ = p;
#line 371 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					g_signal_emit_by_name ((MusicLibrary*) self, "playlist-removed", _tmp22_);
#line 372 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp23_ = self->priv->playlists;
#line 372 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_tmp24_ = p;
#line 372 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp23_, _tmp24_);
#line 374 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (p);
#line 374 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (array_v);
#line 374 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					return;
#line 3080 "AudioPlayerLibrary.c"
				}
#line 368 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (p);
#line 3084 "AudioPlayerLibrary.c"
			}
		}
#line 365 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (array_v);
#line 3089 "AudioPlayerLibrary.c"
	}
}

static void
music_plugins_audio_player_library_remove_playlist_from_name (MusicPluginsAudioPlayerLibrary* self,
                                                              const gchar* name)
{
	GFile* dest = NULL;
	MusicPluginsAudioPlayerDevice* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GError* _inner_error0_ = NULL;
#line 380 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (self != NULL);
#line 380 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (name != NULL);
#line 381 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = self->priv->device;
#line 381 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = music_plugins_audio_player_device_get_music_folder (_tmp0_);
#line 381 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = _tmp1_;
#line 381 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = string_replace (name, "/", "_");
#line 381 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = _tmp3_;
#line 381 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp5_ = g_strconcat (_tmp4_, ".m3u", NULL);
#line 381 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp6_ = _tmp5_;
#line 381 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp7_ = g_build_path ("/", _tmp2_, "Playlists", _tmp6_, NULL);
#line 381 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp8_ = _tmp7_;
#line 381 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp9_ = g_file_new_for_uri (_tmp8_);
#line 381 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp10_ = _tmp9_;
#line 381 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp8_);
#line 381 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp6_);
#line 381 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp4_);
#line 381 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp2_);
#line 381 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	dest = _tmp10_;
#line 3146 "AudioPlayerLibrary.c"
	{
		GFile* _tmp11_;
#line 391 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp11_ = dest;
#line 391 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (g_file_query_exists (_tmp11_, NULL)) {
#line 3153 "AudioPlayerLibrary.c"
			GFile* _tmp12_;
#line 392 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp12_ = dest;
#line 392 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_file_delete (_tmp12_, NULL, &_inner_error0_);
#line 392 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3161 "AudioPlayerLibrary.c"
				goto __catch0_g_error;
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GFile* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 389 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		err = _inner_error0_;
#line 389 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_inner_error0_ = NULL;
#line 395 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp13_ = dest;
#line 395 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp14_ = g_file_get_path (_tmp13_);
#line 395 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp15_ = _tmp14_;
#line 395 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp16_ = err;
#line 395 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp17_ = _tmp16_->message;
#line 395 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_warning ("AudioPlayerLibrary.vala:395: Could not remove playlist %s to file %s: " \
"%s", name, _tmp15_, _tmp17_);
#line 395 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (_tmp15_);
#line 389 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_error_free0 (err);
#line 3195 "AudioPlayerLibrary.c"
	}
	__finally0:
#line 389 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 389 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (dest);
#line 389 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 389 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_clear_error (&_inner_error0_);
#line 389 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return;
#line 3208 "AudioPlayerLibrary.c"
	}
#line 380 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (dest);
#line 3212 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_keep_playlist_synchronized (MusicPluginsAudioPlayerLibrary* self,
                                                               MusicStaticPlaylist* p)
{
	gchar* content = NULL;
	MusicPluginsAudioPlayerDevice* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	MusicPluginsAudioPlayerDevice* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GFile* dest = NULL;
	MusicPluginsAudioPlayerDevice* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GFile* _tmp25_;
	GFile* _tmp26_;
	GError* _inner_error0_ = NULL;
#line 399 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (self != NULL);
#line 399 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_if_fail (p != NULL);
#line 400 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = self->priv->device;
#line 400 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = music_device_get_uri ((MusicDevice*) _tmp0_);
#line 400 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = _tmp1_;
#line 400 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = music_playlists_utils_get_playlist_m3u_file ((MusicPlaylist*) p, _tmp2_);
#line 400 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = _tmp3_;
#line 400 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp2_);
#line 400 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	content = _tmp4_;
#line 401 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp5_ = content;
#line 401 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp6_ = self->priv->device;
#line 401 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp7_ = music_device_get_uri ((MusicDevice*) _tmp6_);
#line 401 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp8_ = _tmp7_;
#line 401 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp9_ = g_file_new_for_uri (_tmp8_);
#line 401 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp10_ = _tmp9_;
#line 401 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp11_ = g_file_get_path (_tmp10_);
#line 401 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp12_ = _tmp11_;
#line 401 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp13_ = string_replace (_tmp5_, _tmp12_, "");
#line 401 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (content);
#line 401 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	content = _tmp13_;
#line 401 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp12_);
#line 401 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (_tmp10_);
#line 401 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp8_);
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp14_ = self->priv->device;
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp15_ = music_plugins_audio_player_device_get_music_folder (_tmp14_);
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp16_ = _tmp15_;
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp17_ = music_playlist_get_name ((MusicPlaylist*) p);
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp18_ = _tmp17_;
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp19_ = string_replace (_tmp18_, "/", "_");
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp20_ = _tmp19_;
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp21_ = g_strconcat (_tmp20_, ".m3u", NULL);
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp22_ = _tmp21_;
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp23_ = g_build_path ("/", _tmp16_, "Playlists", _tmp22_, NULL);
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp24_ = _tmp23_;
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp25_ = g_file_new_for_uri (_tmp24_);
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp26_ = _tmp25_;
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp24_);
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp22_);
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp20_);
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (_tmp16_);
#line 403 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	dest = _tmp26_;
#line 3331 "AudioPlayerLibrary.c"
	{
		GFile* _tmp27_;
		GFileOutputStream* file_stream = NULL;
		GFile* _tmp29_;
		GFileOutputStream* _tmp30_;
		GDataOutputStream* data_stream = NULL;
		GFileOutputStream* _tmp31_;
		GDataOutputStream* _tmp32_;
		GDataOutputStream* _tmp33_;
		const gchar* _tmp34_;
#line 414 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp27_ = dest;
#line 414 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (g_file_query_exists (_tmp27_, NULL)) {
#line 3346 "AudioPlayerLibrary.c"
			GFile* _tmp28_;
#line 415 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp28_ = dest;
#line 415 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			g_file_delete (_tmp28_, NULL, &_inner_error0_);
#line 415 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3354 "AudioPlayerLibrary.c"
				goto __catch0_g_error;
			}
		}
#line 418 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp29_ = dest;
#line 418 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp30_ = g_file_create (_tmp29_, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 418 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		file_stream = _tmp30_;
#line 418 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3366 "AudioPlayerLibrary.c"
			goto __catch0_g_error;
		}
#line 421 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp31_ = file_stream;
#line 421 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp32_ = g_data_output_stream_new ((GOutputStream*) _tmp31_);
#line 421 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		data_stream = _tmp32_;
#line 422 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp33_ = data_stream;
#line 422 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp34_ = content;
#line 422 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_data_output_stream_put_string (_tmp33_, _tmp34_, NULL, &_inner_error0_);
#line 422 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 422 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (data_stream);
#line 422 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (file_stream);
#line 3387 "AudioPlayerLibrary.c"
			goto __catch0_g_error;
		}
#line 412 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (data_stream);
#line 412 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (file_stream);
#line 3394 "AudioPlayerLibrary.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		GFile* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		GError* _tmp40_;
		const gchar* _tmp41_;
#line 412 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		err = _inner_error0_;
#line 412 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_inner_error0_ = NULL;
#line 424 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp35_ = music_playlist_get_name ((MusicPlaylist*) p);
#line 424 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp36_ = _tmp35_;
#line 424 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp37_ = dest;
#line 424 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp38_ = g_file_get_path (_tmp37_);
#line 424 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp39_ = _tmp38_;
#line 424 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp40_ = err;
#line 424 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp41_ = _tmp40_->message;
#line 424 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_warning ("AudioPlayerLibrary.vala:424: Could not save playlist %s to m3u file %s" \
": %s\n", _tmp36_, _tmp39_, _tmp41_);
#line 424 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (_tmp39_);
#line 412 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_error_free0 (err);
#line 3431 "AudioPlayerLibrary.c"
	}
	__finally0:
#line 412 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 412 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (dest);
#line 412 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_free0 (content);
#line 412 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 412 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		g_clear_error (&_inner_error0_);
#line 412 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return;
#line 3446 "AudioPlayerLibrary.c"
	}
#line 399 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (dest);
#line 399 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_free0 (content);
#line 3452 "AudioPlayerLibrary.c"
}

static MusicStaticPlaylist*
music_plugins_audio_player_library_real_playlist_from_id (MusicLibrary* base,
                                                          gint64 id)
{
	MusicPluginsAudioPlayerLibrary * self;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
	MusicStaticPlaylist* result;
#line 428 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 429 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp0_ = music_library_get_playlists ((MusicLibrary*) self);
#line 429 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp1_ = _tmp0_;
#line 429 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp2_ = gee_collection_get_size (_tmp1_);
#line 429 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp3_ = _tmp2_;
#line 429 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_tmp4_ = id < ((gint64) _tmp3_);
#line 429 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (_tmp1_);
#line 429 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (_tmp4_) {
#line 3482 "AudioPlayerLibrary.c"
		GeeArrayList* array = NULL;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeCollection* _tmp7_;
		GeeCollection* _tmp8_;
#line 430 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp5_ = gee_array_list_new (MUSIC_TYPE_STATIC_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 430 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		array = _tmp5_;
#line 431 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp6_ = array;
#line 431 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp7_ = music_library_get_playlists ((MusicLibrary*) self);
#line 431 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp8_ = _tmp7_;
#line 431 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		gee_array_list_add_all (_tmp6_, _tmp8_);
#line 431 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (_tmp8_);
#line 3502 "AudioPlayerLibrary.c"
		{
			GeeArrayList* _playlist_list = NULL;
			GeeArrayList* _tmp9_;
			gint _playlist_size = 0;
			GeeArrayList* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gint _playlist_index = 0;
#line 433 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp9_ = array;
#line 433 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_playlist_list = _tmp9_;
#line 433 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp10_ = _playlist_list;
#line 433 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp10_);
#line 433 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp12_ = _tmp11_;
#line 433 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_playlist_size = _tmp12_;
#line 433 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_playlist_index = -1;
#line 433 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			while (TRUE) {
#line 3527 "AudioPlayerLibrary.c"
				gint _tmp13_;
				gint _tmp14_;
				MusicStaticPlaylist* playlist = NULL;
				GeeArrayList* _tmp15_;
				gpointer _tmp16_;
				MusicStaticPlaylist* _tmp17_;
				gint64 _tmp18_;
				gint64 _tmp19_;
#line 433 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_playlist_index = _playlist_index + 1;
#line 433 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp13_ = _playlist_index;
#line 433 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp14_ = _playlist_size;
#line 433 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				if (!(_tmp13_ < _tmp14_)) {
#line 433 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					break;
#line 3546 "AudioPlayerLibrary.c"
				}
#line 433 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp15_ = _playlist_list;
#line 433 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _playlist_index);
#line 433 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				playlist = (MusicStaticPlaylist*) _tmp16_;
#line 434 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp17_ = playlist;
#line 434 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp18_ = music_playlist_get_rowid ((MusicPlaylist*) _tmp17_);
#line 434 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_tmp19_ = _tmp18_;
#line 434 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				if (_tmp19_ == id) {
#line 435 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					result = playlist;
#line 435 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					_g_object_unref0 (array);
#line 435 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
					return result;
#line 3568 "AudioPlayerLibrary.c"
				}
#line 433 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (playlist);
#line 3572 "AudioPlayerLibrary.c"
			}
		}
#line 429 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (array);
#line 3577 "AudioPlayerLibrary.c"
	}
#line 440 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = NULL;
#line 440 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 3583 "AudioPlayerLibrary.c"
}

static MusicStaticPlaylist*
music_plugins_audio_player_library_real_playlist_from_name (MusicLibrary* base,
                                                            const gchar* name)
{
	MusicPluginsAudioPlayerLibrary * self;
	MusicStaticPlaylist* result;
#line 443 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 443 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 3596 "AudioPlayerLibrary.c"
	{
		GeeIterator* _playlist_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 444 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp0_ = music_library_get_playlists ((MusicLibrary*) self);
#line 444 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp1_ = _tmp0_;
#line 444 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 444 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_tmp3_ = _tmp2_;
#line 444 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (_tmp1_);
#line 444 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_playlist_it = _tmp3_;
#line 444 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		while (TRUE) {
#line 3617 "AudioPlayerLibrary.c"
			GeeIterator* _tmp4_;
			MusicStaticPlaylist* playlist = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			MusicStaticPlaylist* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
#line 444 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp4_ = _playlist_it;
#line 444 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 444 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				break;
#line 3631 "AudioPlayerLibrary.c"
			}
#line 444 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp5_ = _playlist_it;
#line 444 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 444 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			playlist = (MusicStaticPlaylist*) _tmp6_;
#line 445 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp7_ = playlist;
#line 445 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp8_ = music_playlist_get_name ((MusicPlaylist*) _tmp7_);
#line 445 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_tmp9_ = _tmp8_;
#line 445 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			if (g_strcmp0 (_tmp9_, name) == 0) {
#line 446 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				result = playlist;
#line 446 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				_g_object_unref0 (_playlist_it);
#line 446 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
				return result;
#line 3653 "AudioPlayerLibrary.c"
			}
#line 444 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
			_g_object_unref0 (playlist);
#line 3657 "AudioPlayerLibrary.c"
		}
#line 444 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		_g_object_unref0 (_playlist_it);
#line 3661 "AudioPlayerLibrary.c"
	}
#line 449 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = NULL;
#line 449 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 3667 "AudioPlayerLibrary.c"
}

static gboolean
music_plugins_audio_player_library_real_start_file_operations (MusicLibrary* base,
                                                               const gchar* message)
{
	MusicPluginsAudioPlayerLibrary * self;
	gboolean result;
#line 452 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 453 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	if (music_library_doing_file_operations ((MusicLibrary*) self)) {
#line 454 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		result = TRUE;
#line 454 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return result;
#line 3684 "AudioPlayerLibrary.c"
	} else {
#line 456 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		result = FALSE;
#line 456 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
		return result;
#line 3690 "AudioPlayerLibrary.c"
	}
}

static gboolean
music_plugins_audio_player_library_real_doing_file_operations (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
	gboolean result;
#line 460 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 461 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	result = self->priv->is_doing_file_operations;
#line 461 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	return result;
#line 3705 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_real_finish_file_operations (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
#line 464 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = (MusicPluginsAudioPlayerLibrary*) base;
#line 3714 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_class_init (MusicPluginsAudioPlayerLibraryClass * klass,
                                               gpointer klass_data)
{
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	music_plugins_audio_player_library_parent_class = g_type_class_peek_parent (klass);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_type_class_adjust_private_offset (klass, &MusicPluginsAudioPlayerLibrary_private_offset);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->initialize_library = (void (*) (MusicLibrary*)) music_plugins_audio_player_library_real_initialize_library;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->add_files_to_library = (void (*) (MusicLibrary*, GeeCollection*)) music_plugins_audio_player_library_real_add_files_to_library;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->get_medias = (GeeCollection* (*) (MusicLibrary*)) music_plugins_audio_player_library_real_get_medias;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->get_playlists = (GeeCollection* (*) (MusicLibrary*)) music_plugins_audio_player_library_real_get_playlists;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->get_smart_playlists = (GeeCollection* (*) (MusicLibrary*)) music_plugins_audio_player_library_real_get_smart_playlists;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->search_medias = (void (*) (MusicLibrary*, const gchar*)) music_plugins_audio_player_library_real_search_medias;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->get_search_result = (GeeCollection* (*) (MusicLibrary*)) music_plugins_audio_player_library_real_get_search_result;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->add_media = (void (*) (MusicLibrary*, MusicMedia*)) music_plugins_audio_player_library_real_add_media;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->add_medias = (void (*) (MusicLibrary*, GeeCollection*)) music_plugins_audio_player_library_real_add_medias;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->media_from_id = (MusicMedia* (*) (MusicLibrary*, gint64)) music_plugins_audio_player_library_real_media_from_id;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->medias_from_ids = (GeeCollection* (*) (MusicLibrary*, GeeCollection*)) music_plugins_audio_player_library_real_medias_from_ids;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->medias_from_uris = (GeeCollection* (*) (MusicLibrary*, GeeCollection*)) music_plugins_audio_player_library_real_medias_from_uris;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->find_media = (MusicMedia* (*) (MusicLibrary*, MusicMedia*)) music_plugins_audio_player_library_real_find_media;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->media_from_file = (MusicMedia* (*) (MusicLibrary*, GFile*)) music_plugins_audio_player_library_real_media_from_file;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->media_from_uri = (MusicMedia* (*) (MusicLibrary*, const gchar*)) music_plugins_audio_player_library_real_media_from_uri;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->update_media = (void (*) (MusicLibrary*, MusicMedia*, gboolean, gboolean)) music_plugins_audio_player_library_real_update_media;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->update_medias = (void (*) (MusicLibrary*, GeeCollection*, gboolean, gboolean)) music_plugins_audio_player_library_real_update_medias;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->remove_media = (void (*) (MusicLibrary*, MusicMedia*, gboolean)) music_plugins_audio_player_library_real_remove_media;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->remove_medias = (void (*) (MusicLibrary*, GeeCollection*, gboolean)) music_plugins_audio_player_library_real_remove_medias;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->support_smart_playlists = (gboolean (*) (MusicLibrary*)) music_plugins_audio_player_library_real_support_smart_playlists;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->add_smart_playlist = (void (*) (MusicLibrary*, MusicSmartPlaylist*)) music_plugins_audio_player_library_real_add_smart_playlist;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->remove_smart_playlist = (void (*) (MusicLibrary*, gint64)) music_plugins_audio_player_library_real_remove_smart_playlist;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->smart_playlist_from_id = (MusicSmartPlaylist* (*) (MusicLibrary*, gint64)) music_plugins_audio_player_library_real_smart_playlist_from_id;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->smart_playlist_from_name = (MusicSmartPlaylist* (*) (MusicLibrary*, const gchar*)) music_plugins_audio_player_library_real_smart_playlist_from_name;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->support_playlists = (gboolean (*) (MusicLibrary*)) music_plugins_audio_player_library_real_support_playlists;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->add_playlist = (void (*) (MusicLibrary*, MusicStaticPlaylist*)) music_plugins_audio_player_library_real_add_playlist;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->remove_playlist = (void (*) (MusicLibrary*, gint64)) music_plugins_audio_player_library_real_remove_playlist;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->playlist_from_id = (MusicStaticPlaylist* (*) (MusicLibrary*, gint64)) music_plugins_audio_player_library_real_playlist_from_id;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->playlist_from_name = (MusicStaticPlaylist* (*) (MusicLibrary*, const gchar*)) music_plugins_audio_player_library_real_playlist_from_name;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->start_file_operations = (gboolean (*) (MusicLibrary*, const gchar*)) music_plugins_audio_player_library_real_start_file_operations;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->doing_file_operations = (gboolean (*) (MusicLibrary*)) music_plugins_audio_player_library_real_doing_file_operations;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	((MusicLibraryClass *) klass)->finish_file_operations = (void (*) (MusicLibrary*)) music_plugins_audio_player_library_real_finish_file_operations;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	G_OBJECT_CLASS (klass)->finalize = music_plugins_audio_player_library_finalize;
#line 3791 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_instance_init (MusicPluginsAudioPlayerLibrary * self,
                                                  gpointer klass)
{
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv = music_plugins_audio_player_library_get_instance_private (self);
#line 32 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_rec_mutex_init (&self->priv->__lock_medias);
#line 33 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_rec_mutex_init (&self->priv->__lock_searched_medias);
#line 35 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->operation_cancelled = FALSE;
#line 36 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->is_doing_file_operations = FALSE;
#line 37 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->queue_is_finished = FALSE;
#line 39 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->priv->is_initialized = FALSE;
#line 40 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->medias_rowid = 0;
#line 41 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->playlists_rowid = 0;
#line 42 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self->smartplaylists_rowid = 0;
#line 3818 "AudioPlayerLibrary.c"
}

static void
music_plugins_audio_player_library_finalize (GObject * obj)
{
	MusicPluginsAudioPlayerLibrary * self;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, MusicPluginsAudioPlayerLibrary);
#line 31 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->device);
#line 32 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_rec_mutex_clear (&self->priv->__lock_medias);
#line 32 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->medias);
#line 33 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	g_rec_mutex_clear (&self->priv->__lock_searched_medias);
#line 33 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->searched_medias);
#line 34 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->playlists);
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->priv->imported_files);
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	_g_object_unref0 (self->tagger);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerLibrary.vala"
	G_OBJECT_CLASS (music_plugins_audio_player_library_parent_class)->finalize (obj);
#line 3845 "AudioPlayerLibrary.c"
}

GType
music_plugins_audio_player_library_get_type (void)
{
	return music_plugins_audio_player_library_type_id;
}

GType
music_plugins_audio_player_library_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsAudioPlayerLibraryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_audio_player_library_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsAudioPlayerLibrary), 0, (GInstanceInitFunc) music_plugins_audio_player_library_instance_init, NULL };
	music_plugins_audio_player_library_type_id = g_type_module_register_type (module, MUSIC_TYPE_LIBRARY, "MusicPluginsAudioPlayerLibrary", &g_define_type_info, 0);
	MusicPluginsAudioPlayerLibrary_private_offset = sizeof (MusicPluginsAudioPlayerLibraryPrivate);
	return music_plugins_audio_player_library_type_id;
}

