/* iPodDevice.c generated by valac 0.56.0, the Vala compiler
 * generated from iPodDevice.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "ipod-device.h"
#include <gpod/itdb.h>
#include <gio/gio.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "io.elementary.music-core.h"
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>

enum  {
	MUSIC_PLUGINS_IPOD_DEVICE_0_PROPERTY,
	MUSIC_PLUGINS_IPOD_DEVICE_NUM_PROPERTIES
};
static GParamSpec* music_plugins_ipod_device_properties[MUSIC_PLUGINS_IPOD_DEVICE_NUM_PROPERTIES];
#define _itdb_free0(var) ((var == NULL) ? NULL : (var = (itdb_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MusicPluginsiPodDevicePrivate {
	Itdb_iTunesDB* db;
	GIcon* icon;
	gboolean is_new;
	MusicPluginsiPodLibrary* library;
};

static gint MusicPluginsiPodDevice_private_offset;
static gpointer music_plugins_ipod_device_parent_class = NULL;
static MusicDeviceIface * music_plugins_ipod_device_music_device_parent_iface = NULL;
static GType music_plugins_ipod_device_type_id = 0;

static gboolean music_plugins_ipod_device_real_start_initialization (MusicDevice* base);
static void music_plugins_ipod_device_real_finish_initialization (MusicDevice* base);
static gchar* music_plugins_ipod_device_real_get_empty_device_title (MusicDevice* base);
static gchar* music_plugins_ipod_device_real_get_empty_device_description (MusicDevice* base);
static gchar* music_plugins_ipod_device_real_get_content_type (MusicDevice* base);
static gchar* music_plugins_ipod_device_real_get_display_name (MusicDevice* base);
static void music_plugins_ipod_device_real_set_display_name (MusicDevice* base,
                                                      const gchar* name);
static gchar* music_plugins_ipod_device_real_get_fancy_description (MusicDevice* base);
static void music_plugins_ipod_device_real_set_mount (MusicDevice* base,
                                               GMount* mount);
static GMount* music_plugins_ipod_device_real_get_mount (MusicDevice* base);
static gchar* music_plugins_ipod_device_real_get_uri (MusicDevice* base);
static void music_plugins_ipod_device_real_set_icon (MusicDevice* base,
                                              GIcon* icon);
static GIcon* music_plugins_ipod_device_real_get_icon (MusicDevice* base);
static guint64 music_plugins_ipod_device_real_get_capacity (MusicDevice* base);
static gchar* music_plugins_ipod_device_real_get_fancy_capacity (MusicDevice* base);
static guint64 music_plugins_ipod_device_real_get_used_space (MusicDevice* base);
static guint64 music_plugins_ipod_device_real_get_free_space (MusicDevice* base);
static void music_plugins_ipod_device_real_unmount (MusicDevice* base);
static void music_plugins_ipod_device_real_eject (MusicDevice* base);
static void music_plugins_ipod_device_real_synchronize (MusicDevice* base);
static gboolean music_plugins_ipod_device_real_only_use_custom_view (MusicDevice* base);
static GtkWidget* music_plugins_ipod_device_real_get_custom_view (MusicDevice* base);
static gboolean music_plugins_ipod_device_real_read_only (MusicDevice* base);
static MusicLibrary* music_plugins_ipod_device_real_get_library (MusicDevice* base);
static void music_plugins_ipod_device_finalize (GObject * obj);

static inline gpointer
music_plugins_ipod_device_get_instance_private (MusicPluginsiPodDevice* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPluginsiPodDevice_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 38 "../plugins/Devices/iPod/iPodDevice.vala"
	return self ? g_object_ref (self) : NULL;
#line 106 "iPodDevice.c"
}

MusicPluginsiPodDevice*
music_plugins_ipod_device_construct (GType object_type,
                                     GMount* mount)
{
	MusicPluginsiPodDevice * self = NULL;
	GMount* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_ = NULL;
	GThemedIcon* _tmp6_;
#line 37 "../plugins/Devices/iPod/iPodDevice.vala"
	g_return_val_if_fail (mount != NULL, NULL);
#line 37 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) g_object_new (object_type, NULL);
#line 38 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp0_ = _g_object_ref0 (mount);
#line 38 "../plugins/Devices/iPod/iPodDevice.vala"
	_g_object_unref0 (self->mount);
#line 38 "../plugins/Devices/iPod/iPodDevice.vala"
	self->mount = _tmp0_;
#line 39 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp1_ = g_mount_get_default_location (mount);
#line 39 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp2_ = _tmp1_;
#line 39 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp3_ = g_file_get_parse_name (_tmp2_);
#line 39 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp4_ = _tmp3_;
#line 39 "../plugins/Devices/iPod/iPodDevice.vala"
	self->priv->is_new = g_str_has_prefix (_tmp4_, "afc://");
#line 39 "../plugins/Devices/iPod/iPodDevice.vala"
	_g_free0 (_tmp4_);
#line 39 "../plugins/Devices/iPod/iPodDevice.vala"
	_g_object_unref0 (_tmp2_);
#line 40 "../plugins/Devices/iPod/iPodDevice.vala"
	if (self->priv->is_new) {
#line 40 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp5_ = "phone";
#line 149 "iPodDevice.c"
	} else {
#line 40 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp5_ = "multimedia-player";
#line 153 "iPodDevice.c"
	}
#line 40 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp6_ = (GThemedIcon*) g_themed_icon_new (_tmp5_);
#line 40 "../plugins/Devices/iPod/iPodDevice.vala"
	_g_object_unref0 (self->priv->icon);
#line 40 "../plugins/Devices/iPod/iPodDevice.vala"
	self->priv->icon = (GIcon*) _tmp6_;
#line 37 "../plugins/Devices/iPod/iPodDevice.vala"
	return self;
#line 163 "iPodDevice.c"
}

MusicPluginsiPodDevice*
music_plugins_ipod_device_new (GMount* mount)
{
#line 37 "../plugins/Devices/iPod/iPodDevice.vala"
	return music_plugins_ipod_device_construct (MUSIC_PLUGINS_TYPE_IPOD_DEVICE, mount);
#line 171 "iPodDevice.c"
}

static gboolean
music_plugins_ipod_device_real_start_initialization (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 43 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 182 "iPodDevice.c"
	{
		Itdb_iTunesDB* _tmp0_ = NULL;
		GMount* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		Itdb_iTunesDB* _tmp6_;
		Itdb_iTunesDB* _tmp7_;
		Itdb_iTunesDB* _tmp8_;
		gboolean _tmp9_ = FALSE;
		Itdb_iTunesDB* _tmp10_;
		Itdb_Device* _tmp11_;
		Itdb_IpodInfo* _tmp12_;
		Itdb_iTunesDB* _tmp16_;
		MusicPluginsiPodLibrary* _tmp17_;
		MusicLibrariesManager* _tmp18_;
		MusicPluginsiPodLibrary* _tmp19_;
#line 45 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp1_ = self->mount;
#line 45 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp2_ = g_mount_get_default_location (_tmp1_);
#line 45 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp3_ = _tmp2_;
#line 45 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp4_ = g_file_get_path (_tmp3_);
#line 45 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp5_ = _tmp4_;
#line 45 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp6_ = itdb_parse (_tmp5_, &_inner_error0_);
#line 45 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp7_ = _tmp6_;
#line 45 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_free0 (_tmp5_);
#line 45 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_object_unref0 (_tmp3_);
#line 45 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp0_ = _tmp7_;
#line 45 "../plugins/Devices/iPod/iPodDevice.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 223 "iPodDevice.c"
			goto __catch0_g_error;
		}
#line 45 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp8_ = _tmp0_;
#line 45 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp0_ = NULL;
#line 45 "../plugins/Devices/iPod/iPodDevice.vala"
		_itdb_free0 (self->priv->db);
#line 45 "../plugins/Devices/iPod/iPodDevice.vala"
		self->priv->db = _tmp8_;
#line 47 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp10_ = self->priv->db;
#line 47 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp11_ = _tmp10_->device;
#line 47 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp12_ = itdb_device_get_ipod_info (_tmp11_);
#line 47 "../plugins/Devices/iPod/iPodDevice.vala"
		if (_tmp12_->ipod_model == ITDB_IPOD_MODEL_INVALID) {
#line 47 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp9_ = TRUE;
#line 244 "iPodDevice.c"
		} else {
			Itdb_iTunesDB* _tmp13_;
			Itdb_Device* _tmp14_;
			Itdb_IpodInfo* _tmp15_;
#line 48 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp13_ = self->priv->db;
#line 48 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp14_ = _tmp13_->device;
#line 48 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp15_ = itdb_device_get_ipod_info (_tmp14_);
#line 48 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp9_ = _tmp15_->ipod_model == ITDB_IPOD_MODEL_UNKNOWN;
#line 257 "iPodDevice.c"
		}
#line 46 "../plugins/Devices/iPod/iPodDevice.vala"
		if (_tmp9_) {
#line 50 "../plugins/Devices/iPod/iPodDevice.vala"
			self->is_supported = FALSE;
#line 263 "iPodDevice.c"
		}
#line 53 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp16_ = self->priv->db;
#line 53 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp17_ = music_plugins_ipod_library_new (_tmp16_, (MusicDevice*) self);
#line 53 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_object_unref0 (self->priv->library);
#line 53 "../plugins/Devices/iPod/iPodDevice.vala"
		self->priv->library = _tmp17_;
#line 54 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp18_ = music_libraries_manager;
#line 54 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp19_ = self->priv->library;
#line 54 "../plugins/Devices/iPod/iPodDevice.vala"
		music_libraries_manager_add_library (_tmp18_, (MusicLibrary*) _tmp19_);
#line 44 "../plugins/Devices/iPod/iPodDevice.vala"
		_itdb_free0 (_tmp0_);
#line 281 "iPodDevice.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp20_;
		gchar* _tmp21_;
		GError* _tmp22_;
		const gchar* _tmp23_;
#line 44 "../plugins/Devices/iPod/iPodDevice.vala"
		err = _inner_error0_;
#line 44 "../plugins/Devices/iPod/iPodDevice.vala"
		_inner_error0_ = NULL;
#line 56 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp20_ = music_device_get_uri ((MusicDevice*) self);
#line 56 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp21_ = _tmp20_;
#line 56 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp22_ = err;
#line 56 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp23_ = _tmp22_->message;
#line 56 "../plugins/Devices/iPod/iPodDevice.vala"
		g_critical ("iPodDevice.vala:56: Error parsing db at %s: %s\n", _tmp21_, _tmp23_);
#line 56 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_free0 (_tmp21_);
#line 57 "../plugins/Devices/iPod/iPodDevice.vala"
		result = FALSE;
#line 57 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_error_free0 (err);
#line 57 "../plugins/Devices/iPod/iPodDevice.vala"
		return result;
#line 313 "iPodDevice.c"
	}
	__finally0:
#line 44 "../plugins/Devices/iPod/iPodDevice.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 318 "iPodDevice.c"
		gboolean _tmp24_ = FALSE;
#line 44 "../plugins/Devices/iPod/iPodDevice.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 44 "../plugins/Devices/iPod/iPodDevice.vala"
		g_clear_error (&_inner_error0_);
#line 44 "../plugins/Devices/iPod/iPodDevice.vala"
		return _tmp24_;
#line 326 "iPodDevice.c"
	}
#line 60 "../plugins/Devices/iPod/iPodDevice.vala"
	result = TRUE;
#line 60 "../plugins/Devices/iPod/iPodDevice.vala"
	return result;
#line 332 "iPodDevice.c"
}

static void
music_plugins_ipod_device_real_finish_initialization (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	MusicPluginsiPodLibrary* _tmp0_;
#line 63 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 64 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp0_ = self->priv->library;
#line 64 "../plugins/Devices/iPod/iPodDevice.vala"
	music_plugins_ipod_library_finish_initialization_async (_tmp0_, NULL, NULL);
#line 346 "iPodDevice.c"
}

static gchar*
music_plugins_ipod_device_real_get_empty_device_title (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	gchar* _tmp0_;
	gchar* result;
#line 67 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 68 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp0_ = g_strdup (_ ("Empty device!"));
#line 68 "../plugins/Devices/iPod/iPodDevice.vala"
	result = _tmp0_;
#line 68 "../plugins/Devices/iPod/iPodDevice.vala"
	return result;
#line 363 "iPodDevice.c"
}

static gchar*
music_plugins_ipod_device_real_get_empty_device_description (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	gchar* _tmp0_;
	gchar* result;
#line 71 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 72 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp0_ = g_strdup (_ ("This device does not contain any music."));
#line 72 "../plugins/Devices/iPod/iPodDevice.vala"
	result = _tmp0_;
#line 72 "../plugins/Devices/iPod/iPodDevice.vala"
	return result;
#line 380 "iPodDevice.c"
}

static gchar*
music_plugins_ipod_device_real_get_content_type (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	gchar* result;
#line 75 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 76 "../plugins/Devices/iPod/iPodDevice.vala"
	if (self->priv->is_new) {
#line 392 "iPodDevice.c"
		gchar* _tmp0_;
#line 77 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp0_ = g_strdup ("ipod-new");
#line 77 "../plugins/Devices/iPod/iPodDevice.vala"
		result = _tmp0_;
#line 77 "../plugins/Devices/iPod/iPodDevice.vala"
		return result;
#line 400 "iPodDevice.c"
	} else {
		gchar* _tmp1_;
#line 79 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp1_ = g_strdup ("ipod-old");
#line 79 "../plugins/Devices/iPod/iPodDevice.vala"
		result = _tmp1_;
#line 79 "../plugins/Devices/iPod/iPodDevice.vala"
		return result;
#line 409 "iPodDevice.c"
	}
}

static gchar*
music_plugins_ipod_device_real_get_display_name (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	Itdb_iTunesDB* _tmp0_;
	Itdb_Playlist* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 82 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 83 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp0_ = self->priv->db;
#line 83 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp1_ = itdb_playlist_mpl (_tmp0_);
#line 83 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp2_ = _tmp1_->name;
#line 83 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 83 "../plugins/Devices/iPod/iPodDevice.vala"
	result = _tmp3_;
#line 83 "../plugins/Devices/iPod/iPodDevice.vala"
	return result;
#line 436 "iPodDevice.c"
}

static void
music_plugins_ipod_device_real_set_display_name (MusicDevice* base,
                                                 const gchar* name)
{
	MusicPluginsiPodDevice * self;
	Itdb_iTunesDB* _tmp0_;
	Itdb_Playlist* _tmp1_;
	gchar* _tmp2_;
	MusicDeviceManager* _tmp10_;
	MusicDeviceManager* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 86 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 86 "../plugins/Devices/iPod/iPodDevice.vala"
	g_return_if_fail (name != NULL);
#line 87 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp0_ = self->priv->db;
#line 87 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp1_ = itdb_playlist_mpl (_tmp0_);
#line 87 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp2_ = g_strdup (name);
#line 87 "../plugins/Devices/iPod/iPodDevice.vala"
	_g_free0 (_tmp1_->name);
#line 87 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp1_->name = _tmp2_;
#line 464 "iPodDevice.c"
	{
		GMount* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
#line 89 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp3_ = self->mount;
#line 89 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp4_ = g_mount_get_default_location (_tmp3_);
#line 89 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp5_ = _tmp4_;
#line 89 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp6_ = g_file_set_display_name (_tmp5_, name, NULL, &_inner_error0_);
#line 89 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp7_ = _tmp6_;
#line 89 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_object_unref0 (_tmp7_);
#line 89 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_object_unref0 (_tmp5_);
#line 89 "../plugins/Devices/iPod/iPodDevice.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 487 "iPodDevice.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 88 "../plugins/Devices/iPod/iPodDevice.vala"
		err = _inner_error0_;
#line 88 "../plugins/Devices/iPod/iPodDevice.vala"
		_inner_error0_ = NULL;
#line 91 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp8_ = err;
#line 91 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp9_ = _tmp8_->message;
#line 91 "../plugins/Devices/iPod/iPodDevice.vala"
		g_critical ("iPodDevice.vala:91: Could not set iPod Mount Display Name: %s\n", _tmp9_);
#line 88 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_error_free0 (err);
#line 509 "iPodDevice.c"
	}
	__finally0:
#line 88 "../plugins/Devices/iPod/iPodDevice.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 88 "../plugins/Devices/iPod/iPodDevice.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 88 "../plugins/Devices/iPod/iPodDevice.vala"
		g_clear_error (&_inner_error0_);
#line 88 "../plugins/Devices/iPod/iPodDevice.vala"
		return;
#line 520 "iPodDevice.c"
	}
#line 93 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp10_ = music_device_manager_get_default ();
#line 93 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp11_ = _tmp10_;
#line 93 "../plugins/Devices/iPod/iPodDevice.vala"
	g_signal_emit_by_name (_tmp11_, "device-name-changed", (MusicDevice*) self);
#line 93 "../plugins/Devices/iPod/iPodDevice.vala"
	_g_object_unref0 (_tmp11_);
#line 530 "iPodDevice.c"
}

static gchar*
music_plugins_ipod_device_real_get_fancy_description (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	Itdb_IpodGeneration enum_gen = 0;
	Itdb_iTunesDB* _tmp0_;
	Itdb_Device* _tmp1_;
	Itdb_IpodInfo* _tmp2_;
	gchar* result;
#line 96 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 98 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp0_ = self->priv->db;
#line 98 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp1_ = _tmp0_->device;
#line 98 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp2_ = itdb_device_get_ipod_info (_tmp1_);
#line 98 "../plugins/Devices/iPod/iPodDevice.vala"
	enum_gen = _tmp2_->ipod_generation;
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
	switch (enum_gen) {
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_FIRST:
#line 556 "iPodDevice.c"
		{
			gchar* _tmp3_;
#line 101 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp3_ = g_strdup ("iPod 1G");
#line 101 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp3_;
#line 101 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 565 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_SECOND:
#line 569 "iPodDevice.c"
		{
			gchar* _tmp4_;
#line 103 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp4_ = g_strdup ("iPod 2G");
#line 103 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp4_;
#line 103 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 578 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_THIRD:
#line 582 "iPodDevice.c"
		{
			gchar* _tmp5_;
#line 105 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp5_ = g_strdup ("iPod 3G");
#line 105 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp5_;
#line 105 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 591 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_FOURTH:
#line 595 "iPodDevice.c"
		{
			gchar* _tmp6_;
#line 107 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp6_ = g_strdup ("iPod 4G");
#line 107 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp6_;
#line 107 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 604 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_PHOTO:
#line 608 "iPodDevice.c"
		{
			gchar* _tmp7_;
#line 109 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp7_ = g_strdup ("iPod photo");
#line 109 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp7_;
#line 109 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 617 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_VIDEO_1:
#line 621 "iPodDevice.c"
		{
			gchar* _tmp8_;
#line 111 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp8_ = g_strdup ("iPod video");
#line 111 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp8_;
#line 111 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 630 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_VIDEO_2:
#line 634 "iPodDevice.c"
		{
			gchar* _tmp9_;
#line 113 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp9_ = g_strdup ("iPod video 2G");
#line 113 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp9_;
#line 113 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 643 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_MOBILE:
#line 647 "iPodDevice.c"
		{
			gchar* _tmp10_;
#line 115 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp10_ = g_strdup ("iPod mobile");
#line 115 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp10_;
#line 115 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 656 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_MINI_1:
#line 660 "iPodDevice.c"
		{
			gchar* _tmp11_;
#line 117 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp11_ = g_strdup ("iPod mini");
#line 117 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp11_;
#line 117 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 669 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_MINI_2:
#line 673 "iPodDevice.c"
		{
			gchar* _tmp12_;
#line 119 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp12_ = g_strdup ("iPod mini 2G");
#line 119 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp12_;
#line 119 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 682 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_SHUFFLE_1:
#line 686 "iPodDevice.c"
		{
			gchar* _tmp13_;
#line 121 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp13_ = g_strdup ("iPod shuffle");
#line 121 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp13_;
#line 121 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 695 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_SHUFFLE_2:
#line 699 "iPodDevice.c"
		{
			gchar* _tmp14_;
#line 123 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp14_ = g_strdup ("iPod shuffle 2G");
#line 123 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp14_;
#line 123 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 708 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_SHUFFLE_3:
#line 712 "iPodDevice.c"
		{
			gchar* _tmp15_;
#line 125 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp15_ = g_strdup ("iPod shuffle 3G");
#line 125 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp15_;
#line 125 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 721 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_SHUFFLE_4:
#line 725 "iPodDevice.c"
		{
			gchar* _tmp16_;
#line 127 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp16_ = g_strdup ("iPod shuffle 4G");
#line 127 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp16_;
#line 127 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 734 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_NANO_1:
#line 738 "iPodDevice.c"
		{
			gchar* _tmp17_;
#line 129 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp17_ = g_strdup ("iPod nano");
#line 129 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp17_;
#line 129 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 747 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_NANO_2:
#line 751 "iPodDevice.c"
		{
			gchar* _tmp18_;
#line 131 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp18_ = g_strdup ("iPod nano 2G");
#line 131 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp18_;
#line 131 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 760 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_NANO_3:
#line 764 "iPodDevice.c"
		{
			gchar* _tmp19_;
#line 133 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp19_ = g_strdup ("iPod nano 3G");
#line 133 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp19_;
#line 133 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 773 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_NANO_4:
#line 777 "iPodDevice.c"
		{
			gchar* _tmp20_;
#line 135 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp20_ = g_strdup ("iPod nano 4G");
#line 135 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp20_;
#line 135 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 786 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_NANO_5:
#line 790 "iPodDevice.c"
		{
			gchar* _tmp21_;
#line 137 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp21_ = g_strdup ("iPod nano 5G");
#line 137 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp21_;
#line 137 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 799 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_NANO_6:
#line 803 "iPodDevice.c"
		{
			gchar* _tmp22_;
#line 139 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp22_ = g_strdup ("iPod nano 6G");
#line 139 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp22_;
#line 139 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 812 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_CLASSIC_1:
#line 816 "iPodDevice.c"
		{
			gchar* _tmp23_;
#line 141 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp23_ = g_strdup ("iPod classic");
#line 141 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp23_;
#line 141 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 825 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_CLASSIC_2:
#line 829 "iPodDevice.c"
		{
			gchar* _tmp24_;
#line 143 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp24_ = g_strdup ("iPod classic 2G");
#line 143 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp24_;
#line 143 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 838 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_CLASSIC_3:
#line 842 "iPodDevice.c"
		{
			gchar* _tmp25_;
#line 145 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp25_ = g_strdup ("iPod classic 3G");
#line 145 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp25_;
#line 145 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 851 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_TOUCH_1:
#line 855 "iPodDevice.c"
		{
			gchar* _tmp26_;
#line 147 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp26_ = g_strdup ("iPod touch 1G");
#line 147 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp26_;
#line 147 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 864 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_TOUCH_2:
#line 868 "iPodDevice.c"
		{
			gchar* _tmp27_;
#line 149 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp27_ = g_strdup ("iPod touch 2G");
#line 149 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp27_;
#line 149 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 877 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_TOUCH_3:
#line 881 "iPodDevice.c"
		{
			gchar* _tmp28_;
#line 151 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp28_ = g_strdup ("iPod touch 3G");
#line 151 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp28_;
#line 151 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 890 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_TOUCH_4:
#line 894 "iPodDevice.c"
		{
			gchar* _tmp29_;
#line 153 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp29_ = g_strdup ("iPod touch 4G");
#line 153 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp29_;
#line 153 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 903 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_IPHONE_1:
#line 907 "iPodDevice.c"
		{
			gchar* _tmp30_;
#line 155 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp30_ = g_strdup ("iPhone");
#line 155 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp30_;
#line 155 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 916 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_IPHONE_2:
#line 920 "iPodDevice.c"
		{
			gchar* _tmp31_;
#line 157 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp31_ = g_strdup ("iPhone 2G");
#line 157 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp31_;
#line 157 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 929 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_IPHONE_3:
#line 933 "iPodDevice.c"
		{
			gchar* _tmp32_;
#line 159 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp32_ = g_strdup ("iPhone 3G(S)");
#line 159 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp32_;
#line 159 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 942 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_IPHONE_4:
#line 946 "iPodDevice.c"
		{
			gchar* _tmp33_;
#line 161 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp33_ = g_strdup ("iPhone 4(S)");
#line 161 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp33_;
#line 161 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 955 "iPodDevice.c"
		}
#line 99 "../plugins/Devices/iPod/iPodDevice.vala"
		case ITDB_IPOD_GENERATION_IPAD_1:
#line 959 "iPodDevice.c"
		{
			gchar* _tmp34_;
#line 163 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp34_ = g_strdup ("iPad");
#line 163 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp34_;
#line 163 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 968 "iPodDevice.c"
		}
		default:
		{
			gchar* _tmp35_;
#line 165 "../plugins/Devices/iPod/iPodDevice.vala"
			_tmp35_ = g_strdup ("");
#line 165 "../plugins/Devices/iPod/iPodDevice.vala"
			result = _tmp35_;
#line 165 "../plugins/Devices/iPod/iPodDevice.vala"
			return result;
#line 979 "iPodDevice.c"
		}
	}
}

static void
music_plugins_ipod_device_real_set_mount (MusicDevice* base,
                                          GMount* mount)
{
	MusicPluginsiPodDevice * self;
	GMount* _tmp0_;
#line 169 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 169 "../plugins/Devices/iPod/iPodDevice.vala"
	g_return_if_fail (mount != NULL);
#line 170 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp0_ = _g_object_ref0 (mount);
#line 170 "../plugins/Devices/iPod/iPodDevice.vala"
	_g_object_unref0 (self->mount);
#line 170 "../plugins/Devices/iPod/iPodDevice.vala"
	self->mount = _tmp0_;
#line 1000 "iPodDevice.c"
}

static GMount*
music_plugins_ipod_device_real_get_mount (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	GMount* _tmp0_;
	GMount* _tmp1_;
	GMount* result;
#line 173 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 174 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp0_ = self->mount;
#line 174 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 174 "../plugins/Devices/iPod/iPodDevice.vala"
	result = _tmp1_;
#line 174 "../plugins/Devices/iPod/iPodDevice.vala"
	return result;
#line 1020 "iPodDevice.c"
}

static gchar*
music_plugins_ipod_device_real_get_uri (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	GMount* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 177 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 178 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp0_ = self->mount;
#line 178 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp1_ = g_mount_get_default_location (_tmp0_);
#line 178 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp2_ = _tmp1_;
#line 178 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp3_ = g_file_get_uri (_tmp2_);
#line 178 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp4_ = _tmp3_;
#line 178 "../plugins/Devices/iPod/iPodDevice.vala"
	_g_object_unref0 (_tmp2_);
#line 178 "../plugins/Devices/iPod/iPodDevice.vala"
	result = _tmp4_;
#line 178 "../plugins/Devices/iPod/iPodDevice.vala"
	return result;
#line 1051 "iPodDevice.c"
}

static void
music_plugins_ipod_device_real_set_icon (MusicDevice* base,
                                         GIcon* icon)
{
	MusicPluginsiPodDevice * self;
	GIcon* _tmp0_;
#line 181 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 181 "../plugins/Devices/iPod/iPodDevice.vala"
	g_return_if_fail (icon != NULL);
#line 182 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp0_ = _g_object_ref0 (icon);
#line 182 "../plugins/Devices/iPod/iPodDevice.vala"
	_g_object_unref0 (self->priv->icon);
#line 182 "../plugins/Devices/iPod/iPodDevice.vala"
	self->priv->icon = _tmp0_;
#line 1070 "iPodDevice.c"
}

static GIcon*
music_plugins_ipod_device_real_get_icon (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	GIcon* _tmp0_;
	GIcon* _tmp1_;
	GIcon* result;
#line 185 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 186 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp0_ = self->priv->icon;
#line 186 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 186 "../plugins/Devices/iPod/iPodDevice.vala"
	result = _tmp1_;
#line 186 "../plugins/Devices/iPod/iPodDevice.vala"
	return result;
#line 1090 "iPodDevice.c"
}

static guint64
music_plugins_ipod_device_real_get_capacity (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	guint64 rv = 0ULL;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 189 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 190 "../plugins/Devices/iPod/iPodDevice.vala"
	rv = (guint64) 0;
#line 1104 "iPodDevice.c"
	{
		GFileInfo* file_info = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 192 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp0_ = music_device_get_uri ((MusicDevice*) self);
#line 192 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp1_ = _tmp0_;
#line 192 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp2_ = g_file_new_for_uri (_tmp1_);
#line 192 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp3_ = _tmp2_;
#line 192 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp4_ = g_file_query_filesystem_info (_tmp3_, "filesystem::*", NULL, &_inner_error0_);
#line 192 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp5_ = _tmp4_;
#line 192 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_object_unref0 (_tmp3_);
#line 192 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_free0 (_tmp1_);
#line 192 "../plugins/Devices/iPod/iPodDevice.vala"
		file_info = _tmp5_;
#line 192 "../plugins/Devices/iPod/iPodDevice.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1133 "iPodDevice.c"
			goto __catch0_g_error;
		}
#line 193 "../plugins/Devices/iPod/iPodDevice.vala"
		rv = g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_FILESYSTEM_SIZE);
#line 191 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_object_unref0 (file_info);
#line 1140 "iPodDevice.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 191 "../plugins/Devices/iPod/iPodDevice.vala"
		err = _inner_error0_;
#line 191 "../plugins/Devices/iPod/iPodDevice.vala"
		_inner_error0_ = NULL;
#line 195 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp6_ = err;
#line 195 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp7_ = _tmp6_->message;
#line 195 "../plugins/Devices/iPod/iPodDevice.vala"
		g_critical ("iPodDevice.vala:195: Error calculating capacity of iPod: %s\n", _tmp7_);
#line 191 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_error_free0 (err);
#line 1160 "iPodDevice.c"
	}
	__finally0:
#line 191 "../plugins/Devices/iPod/iPodDevice.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1165 "iPodDevice.c"
		guint64 _tmp8_ = 0ULL;
#line 191 "../plugins/Devices/iPod/iPodDevice.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 191 "../plugins/Devices/iPod/iPodDevice.vala"
		g_clear_error (&_inner_error0_);
#line 191 "../plugins/Devices/iPod/iPodDevice.vala"
		return _tmp8_;
#line 1173 "iPodDevice.c"
	}
#line 198 "../plugins/Devices/iPod/iPodDevice.vala"
	result = rv;
#line 198 "../plugins/Devices/iPod/iPodDevice.vala"
	return result;
#line 1179 "iPodDevice.c"
}

static gchar*
music_plugins_ipod_device_real_get_fancy_capacity (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	gchar* _tmp0_;
	gchar* result;
#line 201 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 202 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp0_ = g_format_size_full (music_device_get_capacity ((MusicDevice*) self), G_FORMAT_SIZE_DEFAULT);
#line 202 "../plugins/Devices/iPod/iPodDevice.vala"
	result = _tmp0_;
#line 202 "../plugins/Devices/iPod/iPodDevice.vala"
	return result;
#line 1196 "iPodDevice.c"
}

static guint64
music_plugins_ipod_device_real_get_used_space (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	guint64 result;
#line 205 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 206 "../plugins/Devices/iPod/iPodDevice.vala"
	result = music_device_get_capacity ((MusicDevice*) self) - music_device_get_free_space ((MusicDevice*) self);
#line 206 "../plugins/Devices/iPod/iPodDevice.vala"
	return result;
#line 1210 "iPodDevice.c"
}

static guint64
music_plugins_ipod_device_real_get_free_space (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	guint64 rv = 0ULL;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 209 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 210 "../plugins/Devices/iPod/iPodDevice.vala"
	rv = (guint64) 0;
#line 1224 "iPodDevice.c"
	{
		GFileInfo* file_info = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 212 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp0_ = music_device_get_uri ((MusicDevice*) self);
#line 212 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp1_ = _tmp0_;
#line 212 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp2_ = g_file_new_for_uri (_tmp1_);
#line 212 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp3_ = _tmp2_;
#line 212 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp4_ = g_file_query_filesystem_info (_tmp3_, "filesystem::*", NULL, &_inner_error0_);
#line 212 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp5_ = _tmp4_;
#line 212 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_object_unref0 (_tmp3_);
#line 212 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_free0 (_tmp1_);
#line 212 "../plugins/Devices/iPod/iPodDevice.vala"
		file_info = _tmp5_;
#line 212 "../plugins/Devices/iPod/iPodDevice.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1253 "iPodDevice.c"
			goto __catch0_g_error;
		}
#line 213 "../plugins/Devices/iPod/iPodDevice.vala"
		rv = g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_FILESYSTEM_FREE);
#line 211 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_object_unref0 (file_info);
#line 1260 "iPodDevice.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 211 "../plugins/Devices/iPod/iPodDevice.vala"
		err = _inner_error0_;
#line 211 "../plugins/Devices/iPod/iPodDevice.vala"
		_inner_error0_ = NULL;
#line 215 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp6_ = err;
#line 215 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp7_ = _tmp6_->message;
#line 215 "../plugins/Devices/iPod/iPodDevice.vala"
		g_critical ("iPodDevice.vala:215: Error calculating free space on iPod: %s\n", _tmp7_);
#line 211 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_error_free0 (err);
#line 1280 "iPodDevice.c"
	}
	__finally0:
#line 211 "../plugins/Devices/iPod/iPodDevice.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1285 "iPodDevice.c"
		guint64 _tmp8_ = 0ULL;
#line 211 "../plugins/Devices/iPod/iPodDevice.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 211 "../plugins/Devices/iPod/iPodDevice.vala"
		g_clear_error (&_inner_error0_);
#line 211 "../plugins/Devices/iPod/iPodDevice.vala"
		return _tmp8_;
#line 1293 "iPodDevice.c"
	}
#line 218 "../plugins/Devices/iPod/iPodDevice.vala"
	result = rv;
#line 218 "../plugins/Devices/iPod/iPodDevice.vala"
	return result;
#line 1299 "iPodDevice.c"
}

static void
music_plugins_ipod_device_real_unmount (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	GMount* _tmp0_;
#line 221 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 222 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp0_ = self->mount;
#line 222 "../plugins/Devices/iPod/iPodDevice.vala"
	g_mount_unmount_with_operation (_tmp0_, G_MOUNT_UNMOUNT_NONE, NULL, NULL, NULL, NULL);
#line 1313 "iPodDevice.c"
}

static void
music_plugins_ipod_device_real_eject (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	GMount* _tmp0_;
#line 225 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 226 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp0_ = self->mount;
#line 226 "../plugins/Devices/iPod/iPodDevice.vala"
	if (g_mount_can_eject (_tmp0_)) {
#line 1327 "iPodDevice.c"
		GMount* _tmp1_;
		GVolume* _tmp2_;
		GVolume* _tmp3_;
		GDrive* _tmp4_;
		GDrive* _tmp5_;
#line 227 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp1_ = self->mount;
#line 227 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp2_ = g_mount_get_volume (_tmp1_);
#line 227 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp3_ = _tmp2_;
#line 227 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp4_ = g_volume_get_drive (_tmp3_);
#line 227 "../plugins/Devices/iPod/iPodDevice.vala"
		_tmp5_ = _tmp4_;
#line 227 "../plugins/Devices/iPod/iPodDevice.vala"
		g_drive_eject_with_operation (_tmp5_, G_MOUNT_UNMOUNT_NONE, NULL, NULL, NULL, NULL);
#line 227 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_object_unref0 (_tmp5_);
#line 227 "../plugins/Devices/iPod/iPodDevice.vala"
		_g_object_unref0 (_tmp3_);
#line 1349 "iPodDevice.c"
	}
}

static void
music_plugins_ipod_device_real_synchronize (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
#line 231 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 1359 "iPodDevice.c"
}

static gboolean
music_plugins_ipod_device_real_only_use_custom_view (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	gboolean result;
#line 235 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 236 "../plugins/Devices/iPod/iPodDevice.vala"
	result = FALSE;
#line 236 "../plugins/Devices/iPod/iPodDevice.vala"
	return result;
#line 1373 "iPodDevice.c"
}

static GtkWidget*
music_plugins_ipod_device_real_get_custom_view (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	GtkWidget* result;
#line 239 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 240 "../plugins/Devices/iPod/iPodDevice.vala"
	result = NULL;
#line 240 "../plugins/Devices/iPod/iPodDevice.vala"
	return result;
#line 1387 "iPodDevice.c"
}

static gboolean
music_plugins_ipod_device_real_read_only (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	gboolean result;
#line 243 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 244 "../plugins/Devices/iPod/iPodDevice.vala"
	result = FALSE;
#line 244 "../plugins/Devices/iPod/iPodDevice.vala"
	return result;
#line 1401 "iPodDevice.c"
}

static MusicLibrary*
music_plugins_ipod_device_real_get_library (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	MusicPluginsiPodLibrary* _tmp0_;
	MusicLibrary* _tmp1_;
	MusicLibrary* result;
#line 247 "../plugins/Devices/iPod/iPodDevice.vala"
	self = (MusicPluginsiPodDevice*) base;
#line 248 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp0_ = self->priv->library;
#line 248 "../plugins/Devices/iPod/iPodDevice.vala"
	_tmp1_ = _g_object_ref0 ((MusicLibrary*) _tmp0_);
#line 248 "../plugins/Devices/iPod/iPodDevice.vala"
	result = _tmp1_;
#line 248 "../plugins/Devices/iPod/iPodDevice.vala"
	return result;
#line 1421 "iPodDevice.c"
}

static void
music_plugins_ipod_device_class_init (MusicPluginsiPodDeviceClass * klass,
                                      gpointer klass_data)
{
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	music_plugins_ipod_device_parent_class = g_type_class_peek_parent (klass);
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	g_type_class_adjust_private_offset (klass, &MusicPluginsiPodDevice_private_offset);
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	G_OBJECT_CLASS (klass)->finalize = music_plugins_ipod_device_finalize;
#line 1434 "iPodDevice.c"
}

static void
music_plugins_ipod_device_music_device_interface_init (MusicDeviceIface * iface,
                                                       gpointer iface_data)
{
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	music_plugins_ipod_device_music_device_parent_iface = g_type_interface_peek_parent (iface);
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->start_initialization = (gboolean (*) (MusicDevice*)) music_plugins_ipod_device_real_start_initialization;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->finish_initialization = (void (*) (MusicDevice*)) music_plugins_ipod_device_real_finish_initialization;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->get_empty_device_title = (gchar* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_empty_device_title;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->get_empty_device_description = (gchar* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_empty_device_description;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->get_content_type = (gchar* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_content_type;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->get_display_name = (gchar* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_display_name;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->set_display_name = (void (*) (MusicDevice*, const gchar*)) music_plugins_ipod_device_real_set_display_name;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->get_fancy_description = (gchar* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_fancy_description;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->set_mount = (void (*) (MusicDevice*, GMount*)) music_plugins_ipod_device_real_set_mount;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->get_mount = (GMount* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_mount;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->get_uri = (gchar* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_uri;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->set_icon = (void (*) (MusicDevice*, GIcon*)) music_plugins_ipod_device_real_set_icon;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->get_icon = (GIcon* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_icon;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->get_capacity = (guint64 (*) (MusicDevice*)) music_plugins_ipod_device_real_get_capacity;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->get_fancy_capacity = (gchar* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_fancy_capacity;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->get_used_space = (guint64 (*) (MusicDevice*)) music_plugins_ipod_device_real_get_used_space;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->get_free_space = (guint64 (*) (MusicDevice*)) music_plugins_ipod_device_real_get_free_space;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->unmount = (void (*) (MusicDevice*)) music_plugins_ipod_device_real_unmount;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->eject = (void (*) (MusicDevice*)) music_plugins_ipod_device_real_eject;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->synchronize = (void (*) (MusicDevice*)) music_plugins_ipod_device_real_synchronize;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->only_use_custom_view = (gboolean (*) (MusicDevice*)) music_plugins_ipod_device_real_only_use_custom_view;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->get_custom_view = (GtkWidget* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_custom_view;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->read_only = (gboolean (*) (MusicDevice*)) music_plugins_ipod_device_real_read_only;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	iface->get_library = (MusicLibrary* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_library;
#line 1491 "iPodDevice.c"
}

static void
music_plugins_ipod_device_instance_init (MusicPluginsiPodDevice * self,
                                         gpointer klass)
{
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	self->priv = music_plugins_ipod_device_get_instance_private (self);
#line 33 "../plugins/Devices/iPod/iPodDevice.vala"
	self->is_supported = TRUE;
#line 34 "../plugins/Devices/iPod/iPodDevice.vala"
	self->priv->is_new = FALSE;
#line 1504 "iPodDevice.c"
}

static void
music_plugins_ipod_device_finalize (GObject * obj)
{
	MusicPluginsiPodDevice * self;
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_IPOD_DEVICE, MusicPluginsiPodDevice);
#line 30 "../plugins/Devices/iPod/iPodDevice.vala"
	_itdb_free0 (self->priv->db);
#line 31 "../plugins/Devices/iPod/iPodDevice.vala"
	_g_object_unref0 (self->mount);
#line 32 "../plugins/Devices/iPod/iPodDevice.vala"
	_g_object_unref0 (self->priv->icon);
#line 35 "../plugins/Devices/iPod/iPodDevice.vala"
	_g_object_unref0 (self->priv->library);
#line 29 "../plugins/Devices/iPod/iPodDevice.vala"
	G_OBJECT_CLASS (music_plugins_ipod_device_parent_class)->finalize (obj);
#line 1523 "iPodDevice.c"
}

GType
music_plugins_ipod_device_get_type (void)
{
	return music_plugins_ipod_device_type_id;
}

GType
music_plugins_ipod_device_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsiPodDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_ipod_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsiPodDevice), 0, (GInstanceInitFunc) music_plugins_ipod_device_instance_init, NULL };
	static const GInterfaceInfo music_device_info = { (GInterfaceInitFunc) music_plugins_ipod_device_music_device_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	music_plugins_ipod_device_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MusicPluginsiPodDevice", &g_define_type_info, 0);
	g_type_module_add_interface (module, music_plugins_ipod_device_type_id, MUSIC_TYPE_DEVICE, &music_device_info);
	MusicPluginsiPodDevice_private_offset = sizeof (MusicPluginsiPodDevicePrivate);
	return music_plugins_ipod_device_type_id;
}

