/* iPodDeviceManager.c generated by valac 0.56.0, the Vala compiler
 * generated from iPodDeviceManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "ipod-device.h"
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include "io.elementary.music-core.h"
#include "music-lib.h"
#include <stdlib.h>
#include <string.h>

enum  {
	MUSIC_PLUGINS_IPOD_DEVICE_MANAGER_0_PROPERTY,
	MUSIC_PLUGINS_IPOD_DEVICE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* music_plugins_ipod_device_manager_properties[MUSIC_PLUGINS_IPOD_DEVICE_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MusicPluginsiPodDeviceManagerPrivate {
	GeeArrayList* devices;
	MusicPluginsiPodStreamer* streamer;
};

static gint MusicPluginsiPodDeviceManager_private_offset;
static gpointer music_plugins_ipod_device_manager_parent_class = NULL;
static GType music_plugins_ipod_device_manager_type_id = 0;

static void _music_plugins_ipod_device_manager_mount_added_music_device_manager_mount_added (MusicDeviceManager* _sender,
                                                                                      GMount* mount,
                                                                                      gpointer self);
static void _music_plugins_ipod_device_manager_mount_removed_music_device_manager_mount_removed (MusicDeviceManager* _sender,
                                                                                          GMount* mount,
                                                                                          gpointer self);
static void music_plugins_ipod_device_manager_real_mount_added (MusicPluginsiPodDeviceManager* self,
                                                         GMount* mount);
static void ____lambda12_ (MusicPluginsiPodDeviceManager* self,
                    MusicDevice* d);
static void _____lambda12__music_device_initialized (MusicDevice* _sender,
                                              MusicDevice* d,
                                              gpointer self);
static void music_plugins_ipod_device_manager_real_mount_changed (MusicPluginsiPodDeviceManager* self,
                                                           GMount* mount);
static void music_plugins_ipod_device_manager_real_mount_pre_unmount (MusicPluginsiPodDeviceManager* self,
                                                               GMount* mount);
static void music_plugins_ipod_device_manager_real_mount_removed (MusicPluginsiPodDeviceManager* self,
                                                           GMount* mount);
static void music_plugins_ipod_device_manager_finalize (GObject * obj);

static inline gpointer
music_plugins_ipod_device_manager_get_instance_private (MusicPluginsiPodDeviceManager* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPluginsiPodDeviceManager_private_offset);
}

static void
_music_plugins_ipod_device_manager_mount_added_music_device_manager_mount_added (MusicDeviceManager* _sender,
                                                                                 GMount* mount,
                                                                                 gpointer self)
{
#line 37 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	music_plugins_ipod_device_manager_mount_added ((MusicPluginsiPodDeviceManager*) self, mount);
#line 94 "iPodDeviceManager.c"
}

static void
_music_plugins_ipod_device_manager_mount_removed_music_device_manager_mount_removed (MusicDeviceManager* _sender,
                                                                                     GMount* mount,
                                                                                     gpointer self)
{
#line 38 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	music_plugins_ipod_device_manager_mount_removed ((MusicPluginsiPodDeviceManager*) self, mount);
#line 104 "iPodDeviceManager.c"
}

MusicPluginsiPodDeviceManager*
music_plugins_ipod_device_manager_construct (GType object_type)
{
	MusicPluginsiPodDeviceManager * self = NULL;
	GeeArrayList* _tmp0_;
	MusicPluginsiPodStreamer* _tmp1_;
	MusicDeviceManager* device_manager = NULL;
	MusicDeviceManager* _tmp2_;
	MusicDeviceManager* _tmp3_;
	MusicDeviceManager* _tmp4_;
	MusicPlaybackManager* _tmp14_;
	MusicPlaybackManager* _tmp15_;
	MusicPluginsiPodStreamer* _tmp16_;
#line 33 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	self = (MusicPluginsiPodDeviceManager*) g_object_new (object_type, NULL);
#line 34 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp0_ = gee_array_list_new (MUSIC_PLUGINS_TYPE_IPOD_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 34 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_g_object_unref0 (self->priv->devices);
#line 34 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	self->priv->devices = _tmp0_;
#line 35 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp1_ = music_plugins_ipod_streamer_new (self);
#line 35 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_g_object_unref0 (self->priv->streamer);
#line 35 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	self->priv->streamer = _tmp1_;
#line 36 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp2_ = music_device_manager_get_default ();
#line 36 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	device_manager = _tmp2_;
#line 37 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp3_ = device_manager;
#line 37 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	g_signal_connect_object (_tmp3_, "mount-added", (GCallback) _music_plugins_ipod_device_manager_mount_added_music_device_manager_mount_added, self, 0);
#line 38 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp4_ = device_manager;
#line 38 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	g_signal_connect_object (_tmp4_, "mount-removed", (GCallback) _music_plugins_ipod_device_manager_mount_removed_music_device_manager_mount_removed, self, 0);
#line 146 "iPodDeviceManager.c"
	{
		GeeIterator* _mount_it = NULL;
		MusicDeviceManager* _tmp5_;
		GeeCollection* _tmp6_;
		GeeCollection* _tmp7_;
		GeeIterator* _tmp8_;
		GeeIterator* _tmp9_;
#line 39 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp5_ = device_manager;
#line 39 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp6_ = music_device_manager_get_available_mounts (_tmp5_);
#line 39 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp7_ = _tmp6_;
#line 39 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 39 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp9_ = _tmp8_;
#line 39 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_g_object_unref0 (_tmp7_);
#line 39 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_mount_it = _tmp9_;
#line 39 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		while (TRUE) {
#line 170 "iPodDeviceManager.c"
			GeeIterator* _tmp10_;
			GMount* mount = NULL;
			GeeIterator* _tmp11_;
			gpointer _tmp12_;
			GMount* _tmp13_;
#line 39 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp10_ = _mount_it;
#line 39 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			if (!gee_iterator_next (_tmp10_)) {
#line 39 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				break;
#line 182 "iPodDeviceManager.c"
			}
#line 39 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp11_ = _mount_it;
#line 39 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp12_ = gee_iterator_get (_tmp11_);
#line 39 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			mount = (GMount*) _tmp12_;
#line 40 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp13_ = mount;
#line 40 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			music_plugins_ipod_device_manager_mount_added (self, _tmp13_);
#line 194 "iPodDeviceManager.c"
		}
#line 39 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_g_object_unref0 (_mount_it);
#line 198 "iPodDeviceManager.c"
	}
#line 43 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp14_ = music_app_get_player ();
#line 43 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp15_ = _tmp14_;
#line 43 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp16_ = self->priv->streamer;
#line 43 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	music_playback_manager_add_playback (_tmp15_, (MusicPlayback*) _tmp16_);
#line 33 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_g_object_unref0 (device_manager);
#line 33 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	return self;
#line 212 "iPodDeviceManager.c"
}

MusicPluginsiPodDeviceManager*
music_plugins_ipod_device_manager_new (void)
{
#line 33 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	return music_plugins_ipod_device_manager_construct (MUSIC_PLUGINS_TYPE_IPOD_DEVICE_MANAGER);
#line 220 "iPodDeviceManager.c"
}

void
music_plugins_ipod_device_manager_remove_all (MusicPluginsiPodDeviceManager* self)
{
	MusicDeviceManager* device_manager = NULL;
	MusicDeviceManager* _tmp0_;
	GeeArrayList* _tmp11_;
#line 46 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 47 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp0_ = music_device_manager_get_default ();
#line 47 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	device_manager = _tmp0_;
#line 235 "iPodDeviceManager.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp1_;
		gint _dev_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _dev_index = 0;
#line 48 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp1_ = self->priv->devices;
#line 48 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_dev_list = _tmp1_;
#line 48 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp2_ = _dev_list;
#line 48 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 48 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp4_ = _tmp3_;
#line 48 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_dev_size = _tmp4_;
#line 48 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_dev_index = -1;
#line 48 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		while (TRUE) {
#line 260 "iPodDeviceManager.c"
			gint _tmp5_;
			gint _tmp6_;
			MusicPluginsiPodDevice* dev = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			MusicDeviceManager* _tmp9_;
			MusicPluginsiPodDevice* _tmp10_;
#line 48 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_dev_index = _dev_index + 1;
#line 48 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp5_ = _dev_index;
#line 48 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp6_ = _dev_size;
#line 48 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 48 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				break;
#line 278 "iPodDeviceManager.c"
			}
#line 48 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp7_ = _dev_list;
#line 48 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _dev_index);
#line 48 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			dev = (MusicPluginsiPodDevice*) _tmp8_;
#line 49 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp9_ = device_manager;
#line 49 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp10_ = dev;
#line 49 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			g_signal_emit_by_name (_tmp9_, "device-removed", G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, MUSIC_TYPE_DEVICE, MusicDevice));
#line 48 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_g_object_unref0 (dev);
#line 294 "iPodDeviceManager.c"
		}
	}
#line 52 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp11_ = gee_array_list_new (MUSIC_PLUGINS_TYPE_IPOD_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 52 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_g_object_unref0 (self->priv->devices);
#line 52 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	self->priv->devices = _tmp11_;
#line 46 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_g_object_unref0 (device_manager);
#line 305 "iPodDeviceManager.c"
}

static void
____lambda12_ (MusicPluginsiPodDeviceManager* self,
               MusicDevice* d)
{
#line 74 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	g_return_if_fail (d != NULL);
#line 75 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	if (G_TYPE_CHECK_INSTANCE_CAST (d, MUSIC_PLUGINS_TYPE_IPOD_DEVICE, MusicPluginsiPodDevice)->is_supported == TRUE) {
#line 316 "iPodDeviceManager.c"
		MusicDeviceManager* _tmp0_;
		MusicDeviceManager* _tmp1_;
#line 76 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp0_ = music_device_manager_get_default ();
#line 76 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp1_ = _tmp0_;
#line 76 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		music_device_manager_device_initialized (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (d, MUSIC_TYPE_DEVICE, MusicDevice));
#line 76 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_g_object_unref0 (_tmp1_);
#line 327 "iPodDeviceManager.c"
	}
}

static void
_____lambda12__music_device_initialized (MusicDevice* _sender,
                                         MusicDevice* d,
                                         gpointer self)
{
#line 74 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	____lambda12_ ((MusicPluginsiPodDeviceManager*) self, d);
#line 338 "iPodDeviceManager.c"
}

static void
music_plugins_ipod_device_manager_real_mount_added (MusicPluginsiPodDeviceManager* self,
                                                    GMount* mount)
{
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	GFile* _tmp19_;
	GFile* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GFile* _tmp25_;
	GFile* _tmp26_;
	gboolean _tmp27_;
#line 55 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	g_return_if_fail (mount != NULL);
#line 359 "iPodDeviceManager.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp0_;
		gint _dev_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _dev_index = 0;
#line 56 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp0_ = self->priv->devices;
#line 56 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_dev_list = _tmp0_;
#line 56 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp1_ = _dev_list;
#line 56 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 56 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp3_ = _tmp2_;
#line 56 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_dev_size = _tmp3_;
#line 56 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_dev_index = -1;
#line 56 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		while (TRUE) {
#line 384 "iPodDeviceManager.c"
			gint _tmp4_;
			gint _tmp5_;
			MusicPluginsiPodDevice* dev = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			MusicPluginsiPodDevice* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			GFile* _tmp11_;
			GFile* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gboolean _tmp15_;
#line 56 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_dev_index = _dev_index + 1;
#line 56 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp4_ = _dev_index;
#line 56 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp5_ = _dev_size;
#line 56 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 56 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				break;
#line 408 "iPodDeviceManager.c"
			}
#line 56 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp6_ = _dev_list;
#line 56 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _dev_index);
#line 56 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			dev = (MusicPluginsiPodDevice*) _tmp7_;
#line 57 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp8_ = dev;
#line 57 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp9_ = music_device_get_uri ((MusicDevice*) _tmp8_);
#line 57 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp10_ = _tmp9_;
#line 57 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp11_ = g_mount_get_default_location (mount);
#line 57 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp12_ = _tmp11_;
#line 57 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp13_ = g_file_get_uri (_tmp12_);
#line 57 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp14_ = _tmp13_;
#line 57 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp15_ = g_strcmp0 (_tmp10_, _tmp14_) == 0;
#line 57 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_g_free0 (_tmp14_);
#line 57 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_g_object_unref0 (_tmp12_);
#line 57 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_g_free0 (_tmp10_);
#line 57 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			if (_tmp15_) {
#line 58 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				_g_object_unref0 (dev);
#line 58 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				return;
#line 444 "iPodDeviceManager.c"
			}
#line 56 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_g_object_unref0 (dev);
#line 448 "iPodDeviceManager.c"
		}
	}
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp19_ = g_mount_get_default_location (mount);
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp20_ = _tmp19_;
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp21_ = g_file_get_uri (_tmp20_);
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp22_ = _tmp21_;
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp23_ = g_strconcat (_tmp22_, "/iTunes_Control", NULL);
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp24_ = _tmp23_;
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp25_ = g_file_new_for_uri (_tmp24_);
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp26_ = _tmp25_;
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp27_ = g_file_query_exists (_tmp26_, NULL);
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_g_object_unref0 (_tmp26_);
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_g_free0 (_tmp24_);
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_g_free0 (_tmp22_);
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_g_object_unref0 (_tmp20_);
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	if (_tmp27_) {
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp18_ = TRUE;
#line 481 "iPodDeviceManager.c"
	} else {
		GFile* _tmp28_;
		GFile* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		GFile* _tmp34_;
		GFile* _tmp35_;
#line 64 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp28_ = g_mount_get_default_location (mount);
#line 64 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp29_ = _tmp28_;
#line 64 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp30_ = g_file_get_uri (_tmp29_);
#line 64 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp31_ = _tmp30_;
#line 64 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp32_ = g_strconcat (_tmp31_, "/iPod_Control", NULL);
#line 64 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp33_ = _tmp32_;
#line 64 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp34_ = g_file_new_for_uri (_tmp33_);
#line 64 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp35_ = _tmp34_;
#line 64 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp18_ = g_file_query_exists (_tmp35_, NULL);
#line 64 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_g_object_unref0 (_tmp35_);
#line 64 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_g_free0 (_tmp33_);
#line 64 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_g_free0 (_tmp31_);
#line 64 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_g_object_unref0 (_tmp29_);
#line 517 "iPodDeviceManager.c"
	}
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	if (_tmp18_) {
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp17_ = TRUE;
#line 523 "iPodDeviceManager.c"
	} else {
		GFile* _tmp36_;
		GFile* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		GFile* _tmp42_;
		GFile* _tmp43_;
#line 65 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp36_ = g_mount_get_default_location (mount);
#line 65 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp37_ = _tmp36_;
#line 65 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp38_ = g_file_get_uri (_tmp37_);
#line 65 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp39_ = _tmp38_;
#line 65 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp40_ = g_strconcat (_tmp39_, "/iTunes/iTunes_Control", NULL);
#line 65 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp41_ = _tmp40_;
#line 65 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp42_ = g_file_new_for_uri (_tmp41_);
#line 65 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp43_ = _tmp42_;
#line 65 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp17_ = g_file_query_exists (_tmp43_, NULL);
#line 65 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_g_object_unref0 (_tmp43_);
#line 65 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_g_free0 (_tmp41_);
#line 65 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_g_free0 (_tmp39_);
#line 65 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_g_object_unref0 (_tmp37_);
#line 559 "iPodDeviceManager.c"
	}
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	if (_tmp17_) {
#line 63 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp16_ = TRUE;
#line 565 "iPodDeviceManager.c"
	} else {
		GFile* _tmp44_;
		GFile* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
#line 66 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp44_ = g_mount_get_default_location (mount);
#line 66 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp45_ = _tmp44_;
#line 66 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp46_ = g_file_get_parse_name (_tmp45_);
#line 66 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp47_ = _tmp46_;
#line 66 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp16_ = g_str_has_prefix (_tmp47_, "afc://");
#line 66 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_g_free0 (_tmp47_);
#line 66 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_g_object_unref0 (_tmp45_);
#line 585 "iPodDeviceManager.c"
	}
#line 62 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	if (_tmp16_) {
#line 589 "iPodDeviceManager.c"
		MusicPluginsiPodDevice* added = NULL;
		MusicPluginsiPodDevice* _tmp48_;
		MusicPluginsiPodDevice* _tmp49_;
		GeeArrayList* _tmp50_;
		MusicPluginsiPodDevice* _tmp51_;
		MusicPluginsiPodDevice* _tmp52_;
#line 68 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp48_ = music_plugins_ipod_device_new (mount);
#line 68 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		added = _tmp48_;
#line 69 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp49_ = added;
#line 69 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		music_device_set_mount ((MusicDevice*) _tmp49_, mount);
#line 70 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp50_ = self->priv->devices;
#line 70 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp51_ = added;
#line 70 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp50_, _tmp51_);
#line 72 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp52_ = added;
#line 72 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		if (music_device_start_initialization ((MusicDevice*) _tmp52_) == TRUE) {
#line 614 "iPodDeviceManager.c"
			MusicPluginsiPodDevice* _tmp53_;
			MusicPluginsiPodDevice* _tmp54_;
#line 73 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp53_ = added;
#line 73 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			music_device_finish_initialization ((MusicDevice*) _tmp53_);
#line 74 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp54_ = added;
#line 74 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			g_signal_connect_object ((MusicDevice*) _tmp54_, "initialized", (GCallback) _____lambda12__music_device_initialized, self, 0);
#line 625 "iPodDeviceManager.c"
		}
#line 62 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_g_object_unref0 (added);
#line 629 "iPodDeviceManager.c"
	} else {
		GFile* _tmp55_;
		GFile* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
#line 81 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp55_ = g_mount_get_default_location (mount);
#line 81 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp56_ = _tmp55_;
#line 81 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp57_ = g_file_get_uri (_tmp56_);
#line 81 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp58_ = _tmp57_;
#line 81 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		g_debug ("iPodDeviceManager.vala:81: Found device at %s is not an iPod. Not usin" \
"g it", _tmp58_);
#line 81 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_g_free0 (_tmp58_);
#line 81 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_g_object_unref0 (_tmp56_);
#line 82 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		return;
#line 651 "iPodDeviceManager.c"
	}
}

void
music_plugins_ipod_device_manager_mount_added (MusicPluginsiPodDeviceManager* self,
                                               GMount* mount)
{
	MusicPluginsiPodDeviceManagerClass* _klass_;
#line 55 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 55 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_klass_ = MUSIC_PLUGINS_IPOD_DEVICE_MANAGER_GET_CLASS (self);
#line 55 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	if (_klass_->mount_added) {
#line 55 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_klass_->mount_added (self, mount);
#line 668 "iPodDeviceManager.c"
	}
}

static void
music_plugins_ipod_device_manager_real_mount_changed (MusicPluginsiPodDeviceManager* self,
                                                      GMount* mount)
{
#line 86 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	g_return_if_fail (mount != NULL);
#line 678 "iPodDeviceManager.c"
}

void
music_plugins_ipod_device_manager_mount_changed (MusicPluginsiPodDeviceManager* self,
                                                 GMount* mount)
{
	MusicPluginsiPodDeviceManagerClass* _klass_;
#line 86 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 86 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_klass_ = MUSIC_PLUGINS_IPOD_DEVICE_MANAGER_GET_CLASS (self);
#line 86 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	if (_klass_->mount_changed) {
#line 86 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_klass_->mount_changed (self, mount);
#line 694 "iPodDeviceManager.c"
	}
}

static void
music_plugins_ipod_device_manager_real_mount_pre_unmount (MusicPluginsiPodDeviceManager* self,
                                                          GMount* mount)
{
#line 90 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	g_return_if_fail (mount != NULL);
#line 704 "iPodDeviceManager.c"
}

void
music_plugins_ipod_device_manager_mount_pre_unmount (MusicPluginsiPodDeviceManager* self,
                                                     GMount* mount)
{
	MusicPluginsiPodDeviceManagerClass* _klass_;
#line 90 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 90 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_klass_ = MUSIC_PLUGINS_IPOD_DEVICE_MANAGER_GET_CLASS (self);
#line 90 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	if (_klass_->mount_pre_unmount) {
#line 90 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_klass_->mount_pre_unmount (self, mount);
#line 720 "iPodDeviceManager.c"
	}
}

static void
music_plugins_ipod_device_manager_real_mount_removed (MusicPluginsiPodDeviceManager* self,
                                                      GMount* mount)
{
	MusicDeviceManager* device_manager = NULL;
	MusicDeviceManager* _tmp0_;
#line 94 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	g_return_if_fail (mount != NULL);
#line 95 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_tmp0_ = music_device_manager_get_default ();
#line 95 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	device_manager = _tmp0_;
#line 736 "iPodDeviceManager.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp1_;
		gint _dev_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _dev_index = 0;
#line 96 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp1_ = self->priv->devices;
#line 96 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_dev_list = _tmp1_;
#line 96 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp2_ = _dev_list;
#line 96 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 96 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp4_ = _tmp3_;
#line 96 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_dev_size = _tmp4_;
#line 96 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_dev_index = -1;
#line 96 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		while (TRUE) {
#line 761 "iPodDeviceManager.c"
			gint _tmp5_;
			gint _tmp6_;
			MusicPluginsiPodDevice* dev = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			MusicPluginsiPodDevice* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			GFile* _tmp12_;
			GFile* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gboolean _tmp16_;
#line 96 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_dev_index = _dev_index + 1;
#line 96 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp5_ = _dev_index;
#line 96 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp6_ = _dev_size;
#line 96 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 96 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				break;
#line 785 "iPodDeviceManager.c"
			}
#line 96 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp7_ = _dev_list;
#line 96 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _dev_index);
#line 96 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			dev = (MusicPluginsiPodDevice*) _tmp8_;
#line 97 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp9_ = dev;
#line 97 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp10_ = music_device_get_uri ((MusicDevice*) _tmp9_);
#line 97 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp11_ = _tmp10_;
#line 97 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp12_ = g_mount_get_default_location (mount);
#line 97 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp13_ = _tmp12_;
#line 97 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp14_ = g_file_get_uri (_tmp13_);
#line 97 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp15_ = _tmp14_;
#line 97 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp16_ = g_strcmp0 (_tmp11_, _tmp15_) == 0;
#line 97 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_g_free0 (_tmp15_);
#line 97 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_g_object_unref0 (_tmp13_);
#line 97 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_g_free0 (_tmp11_);
#line 97 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			if (_tmp16_) {
#line 817 "iPodDeviceManager.c"
				MusicDeviceManager* _tmp17_;
				MusicPluginsiPodDevice* _tmp18_;
				GeeArrayList* _tmp19_;
				MusicPluginsiPodDevice* _tmp20_;
#line 98 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				_tmp17_ = device_manager;
#line 98 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				_tmp18_ = dev;
#line 98 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				g_signal_emit_by_name (_tmp17_, "device-removed", G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, MUSIC_TYPE_DEVICE, MusicDevice));
#line 99 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				_tmp19_ = self->priv->devices;
#line 99 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				_tmp20_ = dev;
#line 99 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp19_, _tmp20_);
#line 101 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				_g_object_unref0 (dev);
#line 101 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				_g_object_unref0 (device_manager);
#line 101 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				return;
#line 840 "iPodDeviceManager.c"
			}
#line 96 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_g_object_unref0 (dev);
#line 844 "iPodDeviceManager.c"
		}
	}
#line 94 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_g_object_unref0 (device_manager);
#line 849 "iPodDeviceManager.c"
}

void
music_plugins_ipod_device_manager_mount_removed (MusicPluginsiPodDeviceManager* self,
                                                 GMount* mount)
{
	MusicPluginsiPodDeviceManagerClass* _klass_;
#line 94 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 94 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_klass_ = MUSIC_PLUGINS_IPOD_DEVICE_MANAGER_GET_CLASS (self);
#line 94 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	if (_klass_->mount_removed) {
#line 94 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_klass_->mount_removed (self, mount);
#line 865 "iPodDeviceManager.c"
	}
}

MusicPluginsiPodDevice*
music_plugins_ipod_device_manager_get_device_for_uri (MusicPluginsiPodDeviceManager* self,
                                                      const gchar* uri)
{
	MusicPluginsiPodDevice* result;
#line 106 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 106 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 878 "iPodDeviceManager.c"
	{
		GeeArrayList* _device_list = NULL;
		GeeArrayList* _tmp0_;
		gint _device_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _device_index = 0;
#line 107 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp0_ = self->priv->devices;
#line 107 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_device_list = _tmp0_;
#line 107 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp1_ = _device_list;
#line 107 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 107 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_tmp3_ = _tmp2_;
#line 107 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_device_size = _tmp3_;
#line 107 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		_device_index = -1;
#line 107 "../plugins/Devices/iPod/iPodDeviceManager.vala"
		while (TRUE) {
#line 903 "iPodDeviceManager.c"
			gint _tmp4_;
			gint _tmp5_;
			MusicPluginsiPodDevice* device = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			MusicPluginsiPodDevice* _tmp8_;
			MusicLibrary* _tmp9_;
			MusicLibrary* _tmp10_;
			MusicMedia* _tmp11_;
			MusicMedia* _tmp12_;
			gboolean _tmp13_;
#line 107 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_device_index = _device_index + 1;
#line 107 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp4_ = _device_index;
#line 107 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp5_ = _device_size;
#line 107 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 107 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				break;
#line 925 "iPodDeviceManager.c"
			}
#line 107 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp6_ = _device_list;
#line 107 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _device_index);
#line 107 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			device = (MusicPluginsiPodDevice*) _tmp7_;
#line 108 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp8_ = device;
#line 108 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp9_ = music_device_get_library ((MusicDevice*) _tmp8_);
#line 108 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp10_ = _tmp9_;
#line 108 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp11_ = music_library_media_from_uri (_tmp10_, uri);
#line 108 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp12_ = _tmp11_;
#line 108 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_tmp13_ = _tmp12_ != NULL;
#line 108 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_g_object_unref0 (_tmp12_);
#line 108 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_g_object_unref0 (_tmp10_);
#line 108 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			if (_tmp13_) {
#line 109 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				result = device;
#line 109 "../plugins/Devices/iPod/iPodDeviceManager.vala"
				return result;
#line 955 "iPodDeviceManager.c"
			}
#line 107 "../plugins/Devices/iPod/iPodDeviceManager.vala"
			_g_object_unref0 (device);
#line 959 "iPodDeviceManager.c"
		}
	}
#line 113 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	result = NULL;
#line 113 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	return result;
#line 966 "iPodDeviceManager.c"
}

static void
music_plugins_ipod_device_manager_class_init (MusicPluginsiPodDeviceManagerClass * klass,
                                              gpointer klass_data)
{
#line 29 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	music_plugins_ipod_device_manager_parent_class = g_type_class_peek_parent (klass);
#line 29 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	g_type_class_adjust_private_offset (klass, &MusicPluginsiPodDeviceManager_private_offset);
#line 29 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	((MusicPluginsiPodDeviceManagerClass *) klass)->mount_added = (void (*) (MusicPluginsiPodDeviceManager*, GMount*)) music_plugins_ipod_device_manager_real_mount_added;
#line 29 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	((MusicPluginsiPodDeviceManagerClass *) klass)->mount_changed = (void (*) (MusicPluginsiPodDeviceManager*, GMount*)) music_plugins_ipod_device_manager_real_mount_changed;
#line 29 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	((MusicPluginsiPodDeviceManagerClass *) klass)->mount_pre_unmount = (void (*) (MusicPluginsiPodDeviceManager*, GMount*)) music_plugins_ipod_device_manager_real_mount_pre_unmount;
#line 29 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	((MusicPluginsiPodDeviceManagerClass *) klass)->mount_removed = (void (*) (MusicPluginsiPodDeviceManager*, GMount*)) music_plugins_ipod_device_manager_real_mount_removed;
#line 29 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	G_OBJECT_CLASS (klass)->finalize = music_plugins_ipod_device_manager_finalize;
#line 987 "iPodDeviceManager.c"
}

static void
music_plugins_ipod_device_manager_instance_init (MusicPluginsiPodDeviceManager * self,
                                                 gpointer klass)
{
#line 29 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	self->priv = music_plugins_ipod_device_manager_get_instance_private (self);
#line 996 "iPodDeviceManager.c"
}

static void
music_plugins_ipod_device_manager_finalize (GObject * obj)
{
	MusicPluginsiPodDeviceManager * self;
#line 29 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_IPOD_DEVICE_MANAGER, MusicPluginsiPodDeviceManager);
#line 30 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_g_object_unref0 (self->priv->devices);
#line 31 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	_g_object_unref0 (self->priv->streamer);
#line 29 "../plugins/Devices/iPod/iPodDeviceManager.vala"
	G_OBJECT_CLASS (music_plugins_ipod_device_manager_parent_class)->finalize (obj);
#line 1011 "iPodDeviceManager.c"
}

GType
music_plugins_ipod_device_manager_get_type (void)
{
	return music_plugins_ipod_device_manager_type_id;
}

GType
music_plugins_ipod_device_manager_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsiPodDeviceManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_ipod_device_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsiPodDeviceManager), 0, (GInstanceInitFunc) music_plugins_ipod_device_manager_instance_init, NULL };
	music_plugins_ipod_device_manager_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MusicPluginsiPodDeviceManager", &g_define_type_info, 0);
	MusicPluginsiPodDeviceManager_private_offset = sizeof (MusicPluginsiPodDeviceManagerPrivate);
	return music_plugins_ipod_device_manager_type_id;
}

