/* iPodMediaHelper.c generated by valac 0.56.0, the Vala compiler
 * generated from iPodMediaHelper.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 */

#include "ipod-device.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gpod/itdb.h>
#include "io.elementary.music-core.h"
#include <time.h>
#include <gobject/gvaluecollector.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MusicPluginsParamSpeciPodMediaHelper MusicPluginsParamSpeciPodMediaHelper;

struct _MusicPluginsParamSpeciPodMediaHelper {
	GParamSpec parent_instance;
};

static gpointer music_plugins_ipod_media_helper_parent_class = NULL;
static GType music_plugins_ipod_media_helper_type_id = 0;

static void music_plugins_ipod_media_helper_finalize (MusicPluginsiPodMediaHelper * obj);

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1481 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1481 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1481 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1482 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1483 "glib-2.0.vapi"
		start = string_length + start;
#line 77 "iPodMediaHelper.c"
	}
#line 1485 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1486 "glib-2.0.vapi"
		end = string_length + end;
#line 83 "iPodMediaHelper.c"
	}
#line 1488 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1488 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 89 "iPodMediaHelper.c"
	} else {
#line 1488 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 93 "iPodMediaHelper.c"
	}
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1489 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1489 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 101 "iPodMediaHelper.c"
	} else {
#line 1489 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 105 "iPodMediaHelper.c"
	}
#line 1489 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1490 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1491 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1491 "glib-2.0.vapi"
	result = _tmp4_;
#line 1491 "glib-2.0.vapi"
	return result;
#line 117 "iPodMediaHelper.c"
}

static gchar*
_vala_itdb_filename_ipod2fs (const gchar* ipod_file)
{
	gchar* retval = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 79 "libgpod-1.0.vapi"
	g_return_val_if_fail (ipod_file != NULL, NULL);
#line 80 "libgpod-1.0.vapi"
	_tmp0_ = g_strdup (ipod_file);
#line 80 "libgpod-1.0.vapi"
	retval = _tmp0_;
#line 81 "libgpod-1.0.vapi"
	itdb_filename_ipod2fs (retval);
#line 82 "libgpod-1.0.vapi"
	result = retval;
#line 82 "libgpod-1.0.vapi"
	return result;
#line 138 "iPodMediaHelper.c"
}

MusicMedia*
music_plugins_ipod_media_helper_media_from_track (const gchar* uri,
                                                  Itdb_Track* track)
{
	MusicMedia* rv = NULL;
	MusicMedia* _tmp8_;
	MusicMedia* _tmp15_;
	MusicMedia* _tmp16_;
	const gchar* _tmp17_;
	MusicMedia* _tmp18_;
	const gchar* _tmp19_;
	MusicMedia* _tmp20_;
	const gchar* _tmp21_;
	MusicMedia* _tmp22_;
	const gchar* _tmp23_;
	MusicMedia* _tmp24_;
	const gchar* _tmp25_;
	MusicMedia* _tmp26_;
	const gchar* _tmp27_;
	MusicMedia* _tmp28_;
	const gchar* _tmp29_;
	MusicMedia* _tmp30_;
	const gchar* _tmp31_;
	MusicMedia* _tmp32_;
	MusicMedia* _tmp33_;
	MusicMedia* _tmp34_;
	MusicMedia* _tmp35_;
	MusicMedia* _tmp36_;
	MusicMedia* _tmp37_;
	MusicMedia* _tmp38_;
	MusicMedia* _tmp39_;
	MusicMedia* _tmp40_;
	MusicMedia* _tmp41_;
	MusicMedia* _tmp42_;
	MusicMedia* _tmp43_;
	MusicMedia* _tmp44_;
	MusicMedia* _tmp45_;
	MusicMedia* _tmp46_;
	MusicMedia* _tmp47_;
	gboolean _tmp48_ = FALSE;
	MusicMedia* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp51_;
	MusicMedia* result;
#line 28 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 28 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	g_return_val_if_fail (track != NULL, NULL);
#line 29 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	rv = NULL;
#line 31 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if (g_str_has_suffix (uri, "/")) {
#line 193 "iPodMediaHelper.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		MusicMedia* _tmp7_;
#line 32 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp0_ = string_slice (uri, (glong) 0, (glong) (g_utf8_strlen (uri, (gssize) -1) - 1));
#line 32 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp1_ = _tmp0_;
#line 32 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp2_ = track->ipod_path;
#line 32 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp3_ = _vala_itdb_filename_ipod2fs (_tmp2_);
#line 32 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp4_ = _tmp3_;
#line 32 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp5_ = g_strconcat (_tmp1_, _tmp4_, NULL);
#line 32 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp6_ = _tmp5_;
#line 32 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp7_ = music_media_new (_tmp6_);
#line 32 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_g_object_unref0 (rv);
#line 32 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		rv = _tmp7_;
#line 32 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_g_free0 (_tmp6_);
#line 32 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_g_free0 (_tmp4_);
#line 32 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_g_free0 (_tmp1_);
#line 228 "iPodMediaHelper.c"
	}
#line 35 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp8_ = rv;
#line 35 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if (_tmp8_ == NULL) {
#line 234 "iPodMediaHelper.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		MusicMedia* _tmp14_;
#line 36 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp9_ = track->ipod_path;
#line 36 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp10_ = _vala_itdb_filename_ipod2fs (_tmp9_);
#line 36 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp11_ = _tmp10_;
#line 36 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp12_ = g_strconcat (uri, _tmp11_, NULL);
#line 36 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp13_ = _tmp12_;
#line 36 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp14_ = music_media_new (_tmp13_);
#line 36 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_g_object_unref0 (rv);
#line 36 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		rv = _tmp14_;
#line 36 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_g_free0 (_tmp13_);
#line 36 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_g_free0 (_tmp11_);
#line 261 "iPodMediaHelper.c"
	}
#line 38 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp15_ = rv;
#line 38 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_is_temporary (_tmp15_, TRUE);
#line 39 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp16_ = rv;
#line 39 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp17_ = track->title;
#line 39 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_title (_tmp16_, _tmp17_);
#line 40 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp18_ = rv;
#line 40 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp19_ = track->artist;
#line 40 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_artist (_tmp18_, _tmp19_);
#line 41 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp20_ = rv;
#line 41 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp21_ = track->albumartist;
#line 41 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_album_artist (_tmp20_, _tmp21_);
#line 42 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp22_ = rv;
#line 42 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp23_ = track->album;
#line 42 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_album (_tmp22_, _tmp23_);
#line 43 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp24_ = rv;
#line 43 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp25_ = track->genre;
#line 43 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_genre (_tmp24_, _tmp25_);
#line 44 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp26_ = rv;
#line 44 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp27_ = track->comment;
#line 44 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_comment (_tmp26_, _tmp27_);
#line 45 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp28_ = rv;
#line 45 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp29_ = track->composer;
#line 45 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_composer (_tmp28_, _tmp29_);
#line 46 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp30_ = rv;
#line 46 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp31_ = track->grouping;
#line 46 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_grouping (_tmp30_, _tmp31_);
#line 47 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp32_ = rv;
#line 47 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_album_number (_tmp32_, (guint) track->cd_nr);
#line 48 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp33_ = rv;
#line 48 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_album_count (_tmp33_, (guint) track->cds);
#line 49 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp34_ = rv;
#line 49 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_track (_tmp34_, (guint) track->track_nr);
#line 50 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp35_ = rv;
#line 50 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_track_count (_tmp35_, (guint) track->tracks);
#line 51 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp36_ = rv;
#line 51 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_bitrate (_tmp36_, (guint) track->bitrate);
#line 52 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp37_ = rv;
#line 52 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_year (_tmp37_, (guint) track->year);
#line 53 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp38_ = rv;
#line 53 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_date_added (_tmp38_, (guint) ((gint) track->time_added));
#line 54 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp39_ = rv;
#line 54 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_last_modified (_tmp39_, (guint) ((gint) track->time_modified));
#line 55 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp40_ = rv;
#line 55 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_last_played (_tmp40_, (guint) ((gint) track->time_played));
#line 56 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp41_ = rv;
#line 56 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_rating (_tmp41_, track->rating * 20);
#line 57 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp42_ = rv;
#line 57 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_play_count (_tmp42_, track->playcount);
#line 58 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp43_ = rv;
#line 58 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_bpm (_tmp43_, (guint) track->BPM);
#line 59 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp44_ = rv;
#line 59 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_skip_count (_tmp44_, track->skipcount);
#line 60 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp45_ = rv;
#line 60 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_length (_tmp45_, (guint) track->tracklen);
#line 61 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp46_ = rv;
#line 61 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_file_size (_tmp46_, (guint64) track->size);
#line 62 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp47_ = rv;
#line 62 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_media_set_resume_pos (_tmp47_, (gint) track->bookmark_time);
#line 64 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp49_ = rv;
#line 64 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp50_ = music_media_get_artist (_tmp49_);
#line 64 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp51_ = _tmp50_;
#line 64 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if (g_strcmp0 (_tmp51_, "") == 0) {
#line 387 "iPodMediaHelper.c"
		MusicMedia* _tmp52_;
		const gchar* _tmp53_;
		const gchar* _tmp54_;
#line 64 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp52_ = rv;
#line 64 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp53_ = music_media_get_album_artist (_tmp52_);
#line 64 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp54_ = _tmp53_;
#line 64 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp48_ = g_strcmp0 (_tmp54_, "") != 0;
#line 399 "iPodMediaHelper.c"
	} else {
#line 64 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp48_ = FALSE;
#line 403 "iPodMediaHelper.c"
	}
#line 64 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if (_tmp48_) {
#line 407 "iPodMediaHelper.c"
		MusicMedia* _tmp55_;
		MusicMedia* _tmp56_;
		const gchar* _tmp57_;
		const gchar* _tmp58_;
#line 65 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp55_ = rv;
#line 65 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp56_ = rv;
#line 65 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp57_ = music_media_get_album_artist (_tmp56_);
#line 65 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp58_ = _tmp57_;
#line 65 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		music_media_set_artist (_tmp55_, _tmp58_);
#line 422 "iPodMediaHelper.c"
	} else {
		gboolean _tmp59_ = FALSE;
		MusicMedia* _tmp60_;
		const gchar* _tmp61_;
		const gchar* _tmp62_;
#line 66 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp60_ = rv;
#line 66 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp61_ = music_media_get_album_artist (_tmp60_);
#line 66 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp62_ = _tmp61_;
#line 66 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		if (g_strcmp0 (_tmp62_, "") == 0) {
#line 436 "iPodMediaHelper.c"
			MusicMedia* _tmp63_;
			const gchar* _tmp64_;
			const gchar* _tmp65_;
#line 66 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_tmp63_ = rv;
#line 66 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_tmp64_ = music_media_get_artist (_tmp63_);
#line 66 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_tmp65_ = _tmp64_;
#line 66 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_tmp59_ = g_strcmp0 (_tmp65_, "") != 0;
#line 448 "iPodMediaHelper.c"
		} else {
#line 66 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_tmp59_ = FALSE;
#line 452 "iPodMediaHelper.c"
		}
#line 66 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		if (_tmp59_) {
#line 456 "iPodMediaHelper.c"
			MusicMedia* _tmp66_;
			MusicMedia* _tmp67_;
			const gchar* _tmp68_;
			const gchar* _tmp69_;
#line 67 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_tmp66_ = rv;
#line 67 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_tmp67_ = rv;
#line 67 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_tmp68_ = music_media_get_artist (_tmp67_);
#line 67 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_tmp69_ = _tmp68_;
#line 67 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			music_media_set_album_artist (_tmp66_, _tmp69_);
#line 471 "iPodMediaHelper.c"
		}
	}
#line 70 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	result = rv;
#line 70 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	return result;
#line 478 "iPodMediaHelper.c"
}

void
music_plugins_ipod_media_helper_update_track (Itdb_Track** t,
                                              MusicMedia* m)
{
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	guint _tmp22_;
	guint _tmp23_;
	guint _tmp24_;
	guint _tmp25_;
	guint _tmp26_;
	guint _tmp27_;
	guint _tmp28_;
	guint _tmp29_;
	guint _tmp30_;
	guint _tmp31_;
	guint _tmp32_;
	guint _tmp33_;
	guint _tmp34_;
	guint _tmp35_;
	guint _tmp36_;
	guint _tmp37_;
	guint _tmp38_;
	guint _tmp39_;
	guint _tmp40_;
	guint _tmp41_;
	guint _tmp42_;
	guint _tmp43_;
	guint _tmp44_;
	guint _tmp45_;
	guint _tmp46_;
	guint _tmp47_;
	guint _tmp48_;
	guint _tmp49_;
	guint64 _tmp50_;
	guint64 _tmp51_;
	const gchar* _tmp52_;
	const gchar* _tmp53_;
	gchar* _tmp54_;
	gint _tmp55_ = 0;
	guint _tmp56_;
	guint _tmp57_;
	gint _tmp58_;
	gint _tmp59_;
	gboolean _tmp60_ = FALSE;
	const gchar* _tmp61_;
#line 73 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	g_return_if_fail (*t != NULL);
#line 73 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	g_return_if_fail (m != NULL);
#line 74 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if ((*t) == NULL) {
#line 75 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		return;
#line 555 "iPodMediaHelper.c"
	}
#line 77 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp0_ = music_media_get_display_title (m);
#line 77 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_g_free0 ((*t)->title);
#line 77 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->title = _tmp0_;
#line 78 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp1_ = music_media_get_artist (m);
#line 78 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp2_ = _tmp1_;
#line 78 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 78 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_g_free0 ((*t)->artist);
#line 78 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->artist = _tmp3_;
#line 79 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp4_ = music_media_get_album_artist (m);
#line 79 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp5_ = _tmp4_;
#line 79 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 79 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_g_free0 ((*t)->albumartist);
#line 79 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->albumartist = _tmp6_;
#line 80 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp7_ = music_media_get_album (m);
#line 80 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp8_ = _tmp7_;
#line 80 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 80 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_g_free0 ((*t)->album);
#line 80 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->album = _tmp9_;
#line 81 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp10_ = music_media_get_genre (m);
#line 81 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp11_ = _tmp10_;
#line 81 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 81 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_g_free0 ((*t)->genre);
#line 81 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->genre = _tmp12_;
#line 82 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp13_ = music_media_get_comment (m);
#line 82 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp14_ = _tmp13_;
#line 82 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 82 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_g_free0 ((*t)->comment);
#line 82 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->comment = _tmp15_;
#line 83 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp16_ = music_media_get_composer (m);
#line 83 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp17_ = _tmp16_;
#line 83 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp18_ = g_strdup (_tmp17_);
#line 83 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_g_free0 ((*t)->composer);
#line 83 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->composer = _tmp18_;
#line 84 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp19_ = music_media_get_grouping (m);
#line 84 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp20_ = _tmp19_;
#line 84 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp21_ = g_strdup (_tmp20_);
#line 84 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_g_free0 ((*t)->grouping);
#line 84 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->grouping = _tmp21_;
#line 85 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp22_ = music_media_get_album_number (m);
#line 85 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp23_ = _tmp22_;
#line 85 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->cd_nr = (gint) _tmp23_;
#line 86 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp24_ = music_media_get_album_count (m);
#line 86 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp25_ = _tmp24_;
#line 86 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->cds = (gint) _tmp25_;
#line 87 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp26_ = music_media_get_track (m);
#line 87 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp27_ = _tmp26_;
#line 87 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->track_nr = (gint) _tmp27_;
#line 88 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp28_ = music_media_get_track_count (m);
#line 88 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp29_ = _tmp28_;
#line 88 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->tracks = (gint) _tmp29_;
#line 89 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp30_ = music_media_get_bitrate (m);
#line 89 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp31_ = _tmp30_;
#line 89 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->bitrate = (gint) _tmp31_;
#line 90 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp32_ = music_media_get_year (m);
#line 90 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp33_ = _tmp32_;
#line 90 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->year = (gint) _tmp33_;
#line 91 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp34_ = music_media_get_last_modified (m);
#line 91 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp35_ = _tmp34_;
#line 91 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->time_modified = (time_t) _tmp35_;
#line 92 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp36_ = music_media_get_last_played (m);
#line 92 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp37_ = _tmp36_;
#line 92 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->time_played = (time_t) _tmp37_;
#line 93 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp38_ = music_media_get_rating (m);
#line 93 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp39_ = _tmp38_;
#line 93 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->rating = _tmp39_ * 20;
#line 94 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp40_ = music_media_get_play_count (m);
#line 94 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp41_ = _tmp40_;
#line 94 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->playcount = _tmp41_;
#line 95 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp42_ = music_media_get_play_count (m);
#line 95 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp43_ = _tmp42_;
#line 95 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->recent_playcount = _tmp43_;
#line 96 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp44_ = music_media_get_bpm (m);
#line 96 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp45_ = _tmp44_;
#line 96 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->BPM = (guint16) _tmp45_;
#line 97 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp46_ = music_media_get_skip_count (m);
#line 97 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp47_ = _tmp46_;
#line 97 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->skipcount = _tmp47_;
#line 98 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp48_ = music_media_get_length (m);
#line 98 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp49_ = _tmp48_;
#line 98 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->tracklen = (gint) _tmp49_;
#line 99 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp50_ = music_media_get_file_size (m);
#line 99 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp51_ = _tmp50_;
#line 99 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->size = (guint32) ((guint) _tmp51_);
#line 100 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->mediatype = (guint) ITDB_MEDIATYPE_AUDIO;
#line 101 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->lyrics_flag = (guint8) 1;
#line 102 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp52_ = music_media_get_lyrics (m);
#line 102 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp53_ = _tmp52_;
#line 102 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp54_ = g_strdup (_tmp53_);
#line 102 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_g_free0 ((*t)->description);
#line 102 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->description = _tmp54_;
#line 103 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp56_ = music_media_get_play_count (m);
#line 103 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp57_ = _tmp56_;
#line 103 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if (_tmp57_ == ((guint) 0)) {
#line 103 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp55_ = 1;
#line 745 "iPodMediaHelper.c"
	} else {
#line 103 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp55_ = 0;
#line 749 "iPodMediaHelper.c"
	}
#line 103 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->mark_unplayed = (guint8) _tmp55_;
#line 104 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp58_ = music_media_get_resume_pos (m);
#line 104 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp59_ = _tmp58_;
#line 104 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	(*t)->bookmark_time = (guint) _tmp59_;
#line 106 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp61_ = (*t)->artist;
#line 106 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if (g_strcmp0 (_tmp61_, "") == 0) {
#line 763 "iPodMediaHelper.c"
		gboolean _tmp62_ = FALSE;
		const gchar* _tmp63_;
#line 106 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp63_ = (*t)->albumartist;
#line 106 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		if (g_strcmp0 (_tmp63_, "") != 0) {
#line 106 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_tmp62_ = TRUE;
#line 772 "iPodMediaHelper.c"
		} else {
			const gchar* _tmp64_;
#line 106 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_tmp64_ = (*t)->albumartist;
#line 106 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_tmp62_ = _tmp64_ != NULL;
#line 779 "iPodMediaHelper.c"
		}
#line 106 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp60_ = _tmp62_;
#line 783 "iPodMediaHelper.c"
	} else {
#line 106 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp60_ = FALSE;
#line 787 "iPodMediaHelper.c"
	}
#line 106 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if (_tmp60_) {
#line 791 "iPodMediaHelper.c"
		const gchar* _tmp65_;
		gchar* _tmp66_;
#line 107 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp65_ = (*t)->albumartist;
#line 107 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp66_ = g_strdup (_tmp65_);
#line 107 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_g_free0 ((*t)->artist);
#line 107 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		(*t)->artist = _tmp66_;
#line 802 "iPodMediaHelper.c"
	} else {
		gboolean _tmp67_ = FALSE;
		const gchar* _tmp68_;
#line 108 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		_tmp68_ = (*t)->albumartist;
#line 108 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		if (g_strcmp0 (_tmp68_, "") == 0) {
#line 810 "iPodMediaHelper.c"
			gboolean _tmp69_ = FALSE;
			const gchar* _tmp70_;
#line 108 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_tmp70_ = (*t)->artist;
#line 108 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			if (g_strcmp0 (_tmp70_, "") != 0) {
#line 108 "../plugins/Devices/iPod/iPodMediaHelper.vala"
				_tmp69_ = TRUE;
#line 819 "iPodMediaHelper.c"
			} else {
				const gchar* _tmp71_;
#line 108 "../plugins/Devices/iPod/iPodMediaHelper.vala"
				_tmp71_ = (*t)->artist;
#line 108 "../plugins/Devices/iPod/iPodMediaHelper.vala"
				_tmp69_ = _tmp71_ != NULL;
#line 826 "iPodMediaHelper.c"
			}
#line 108 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_tmp67_ = _tmp69_;
#line 830 "iPodMediaHelper.c"
		} else {
#line 108 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_tmp67_ = FALSE;
#line 834 "iPodMediaHelper.c"
		}
#line 108 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		if (_tmp67_) {
#line 838 "iPodMediaHelper.c"
			const gchar* _tmp72_;
			gchar* _tmp73_;
#line 109 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_tmp72_ = (*t)->artist;
#line 109 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_tmp73_ = g_strdup (_tmp72_);
#line 109 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			_g_free0 ((*t)->albumartist);
#line 109 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			(*t)->albumartist = _tmp73_;
#line 849 "iPodMediaHelper.c"
		}
	}
}

/**
     * caller *must* set ipod_path
     */
Itdb_Track*
music_plugins_ipod_media_helper_track_from_media (MusicMedia* m)
{
	Itdb_Track* t = NULL;
	Itdb_Track* _tmp0_;
	Itdb_Track* tu = NULL;
	Itdb_Track* result;
#line 115 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	g_return_val_if_fail (m != NULL, NULL);
#line 116 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	_tmp0_ = itdb_track_new ();
#line 116 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	t = _tmp0_;
#line 117 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	tu = t;
#line 118 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_plugins_ipod_media_helper_update_track (&tu, m);
#line 119 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	result = t;
#line 119 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	return result;
#line 878 "iPodMediaHelper.c"
}

MusicPluginsiPodMediaHelper*
music_plugins_ipod_media_helper_construct (GType object_type)
{
	MusicPluginsiPodMediaHelper* self = NULL;
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	self = (MusicPluginsiPodMediaHelper*) g_type_create_instance (object_type);
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	return self;
#line 889 "iPodMediaHelper.c"
}

MusicPluginsiPodMediaHelper*
music_plugins_ipod_media_helper_new (void)
{
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	return music_plugins_ipod_media_helper_construct (MUSIC_PLUGINS_TYPE_IPOD_MEDIA_HELPER);
#line 897 "iPodMediaHelper.c"
}

static void
music_plugins_value_ipod_media_helper_init (GValue* value)
{
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	value->data[0].v_pointer = NULL;
#line 905 "iPodMediaHelper.c"
}

static void
music_plugins_value_ipod_media_helper_free_value (GValue* value)
{
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if (value->data[0].v_pointer) {
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		music_plugins_ipod_media_helper_unref (value->data[0].v_pointer);
#line 915 "iPodMediaHelper.c"
	}
}

static void
music_plugins_value_ipod_media_helper_copy_value (const GValue* src_value,
                                                  GValue* dest_value)
{
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if (src_value->data[0].v_pointer) {
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		dest_value->data[0].v_pointer = music_plugins_ipod_media_helper_ref (src_value->data[0].v_pointer);
#line 927 "iPodMediaHelper.c"
	} else {
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		dest_value->data[0].v_pointer = NULL;
#line 931 "iPodMediaHelper.c"
	}
}

static gpointer
music_plugins_value_ipod_media_helper_peek_pointer (const GValue* value)
{
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	return value->data[0].v_pointer;
#line 940 "iPodMediaHelper.c"
}

static gchar*
music_plugins_value_ipod_media_helper_collect_value (GValue* value,
                                                     guint n_collect_values,
                                                     GTypeCValue* collect_values,
                                                     guint collect_flags)
{
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if (collect_values[0].v_pointer) {
#line 951 "iPodMediaHelper.c"
		MusicPluginsiPodMediaHelper * object;
		object = collect_values[0].v_pointer;
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		if (object->parent_instance.g_class == NULL) {
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 958 "iPodMediaHelper.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 962 "iPodMediaHelper.c"
		}
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		value->data[0].v_pointer = music_plugins_ipod_media_helper_ref (object);
#line 966 "iPodMediaHelper.c"
	} else {
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		value->data[0].v_pointer = NULL;
#line 970 "iPodMediaHelper.c"
	}
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	return NULL;
#line 974 "iPodMediaHelper.c"
}

static gchar*
music_plugins_value_ipod_media_helper_lcopy_value (const GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
	MusicPluginsiPodMediaHelper ** object_p;
	object_p = collect_values[0].v_pointer;
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if (!object_p) {
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 989 "iPodMediaHelper.c"
	}
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if (!value->data[0].v_pointer) {
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		*object_p = NULL;
#line 995 "iPodMediaHelper.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		*object_p = value->data[0].v_pointer;
#line 999 "iPodMediaHelper.c"
	} else {
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		*object_p = music_plugins_ipod_media_helper_ref (value->data[0].v_pointer);
#line 1003 "iPodMediaHelper.c"
	}
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	return NULL;
#line 1007 "iPodMediaHelper.c"
}

GParamSpec*
music_plugins_param_spec_ipod_media_helper (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags)
{
	MusicPluginsParamSpeciPodMediaHelper* spec;
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	g_return_val_if_fail (g_type_is_a (object_type, MUSIC_PLUGINS_TYPE_IPOD_MEDIA_HELPER), NULL);
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	return G_PARAM_SPEC (spec);
#line 1026 "iPodMediaHelper.c"
}

gpointer
music_plugins_value_get_ipod_media_helper (const GValue* value)
{
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, MUSIC_PLUGINS_TYPE_IPOD_MEDIA_HELPER), NULL);
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	return value->data[0].v_pointer;
#line 1036 "iPodMediaHelper.c"
}

void
music_plugins_value_set_ipod_media_helper (GValue* value,
                                           gpointer v_object)
{
	MusicPluginsiPodMediaHelper * old;
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, MUSIC_PLUGINS_TYPE_IPOD_MEDIA_HELPER));
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	old = value->data[0].v_pointer;
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if (v_object) {
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, MUSIC_PLUGINS_TYPE_IPOD_MEDIA_HELPER));
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		value->data[0].v_pointer = v_object;
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		music_plugins_ipod_media_helper_ref (value->data[0].v_pointer);
#line 1058 "iPodMediaHelper.c"
	} else {
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		value->data[0].v_pointer = NULL;
#line 1062 "iPodMediaHelper.c"
	}
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if (old) {
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		music_plugins_ipod_media_helper_unref (old);
#line 1068 "iPodMediaHelper.c"
	}
}

void
music_plugins_value_take_ipod_media_helper (GValue* value,
                                            gpointer v_object)
{
	MusicPluginsiPodMediaHelper * old;
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, MUSIC_PLUGINS_TYPE_IPOD_MEDIA_HELPER));
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	old = value->data[0].v_pointer;
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if (v_object) {
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, MUSIC_PLUGINS_TYPE_IPOD_MEDIA_HELPER));
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		value->data[0].v_pointer = v_object;
#line 1089 "iPodMediaHelper.c"
	} else {
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		value->data[0].v_pointer = NULL;
#line 1093 "iPodMediaHelper.c"
	}
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if (old) {
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		music_plugins_ipod_media_helper_unref (old);
#line 1099 "iPodMediaHelper.c"
	}
}

static void
music_plugins_ipod_media_helper_class_init (MusicPluginsiPodMediaHelperClass * klass,
                                            gpointer klass_data)
{
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	music_plugins_ipod_media_helper_parent_class = g_type_class_peek_parent (klass);
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	((MusicPluginsiPodMediaHelperClass *) klass)->finalize = music_plugins_ipod_media_helper_finalize;
#line 1111 "iPodMediaHelper.c"
}

static void
music_plugins_ipod_media_helper_instance_init (MusicPluginsiPodMediaHelper * self,
                                               gpointer klass)
{
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	self->ref_count = 1;
#line 1120 "iPodMediaHelper.c"
}

static void
music_plugins_ipod_media_helper_finalize (MusicPluginsiPodMediaHelper * obj)
{
	MusicPluginsiPodMediaHelper * self;
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_IPOD_MEDIA_HELPER, MusicPluginsiPodMediaHelper);
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	g_signal_handlers_destroy (self);
#line 1131 "iPodMediaHelper.c"
}

GType
music_plugins_ipod_media_helper_get_type (void)
{
	return music_plugins_ipod_media_helper_type_id;
}

GType
music_plugins_ipod_media_helper_register_type (GTypeModule * module)
{
	static const GTypeValueTable g_define_type_value_table = { music_plugins_value_ipod_media_helper_init, music_plugins_value_ipod_media_helper_free_value, music_plugins_value_ipod_media_helper_copy_value, music_plugins_value_ipod_media_helper_peek_pointer, "p", music_plugins_value_ipod_media_helper_collect_value, "p", music_plugins_value_ipod_media_helper_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsiPodMediaHelperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_ipod_media_helper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsiPodMediaHelper), 0, (GInstanceInitFunc) music_plugins_ipod_media_helper_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	music_plugins_ipod_media_helper_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MusicPluginsiPodMediaHelper", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return music_plugins_ipod_media_helper_type_id;
}

gpointer
music_plugins_ipod_media_helper_ref (gpointer instance)
{
	MusicPluginsiPodMediaHelper * self;
	self = instance;
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	g_atomic_int_inc (&self->ref_count);
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	return instance;
#line 1159 "iPodMediaHelper.c"
}

void
music_plugins_ipod_media_helper_unref (gpointer instance)
{
	MusicPluginsiPodMediaHelper * self;
	self = instance;
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		MUSIC_PLUGINS_IPOD_MEDIA_HELPER_GET_CLASS (self)->finalize (self);
#line 27 "../plugins/Devices/iPod/iPodMediaHelper.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1173 "iPodMediaHelper.c"
	}
}

