/* iPodStreamer.c generated by valac 0.56.0, the Vala compiler
 * generated from iPodStreamer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "ipod-device.h"
#include "io.elementary.music-core.h"
#include "music-lib.h"
#include <glib.h>
#include <glib-object.h>
#include <gst/gst.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gst/pbutils/pbutils.h>
#include <gtk/gtk.h>

enum  {
	MUSIC_PLUGINS_IPOD_STREAMER_0_PROPERTY,
	MUSIC_PLUGINS_IPOD_STREAMER_NUM_PROPERTIES
};
static GParamSpec* music_plugins_ipod_streamer_properties[MUSIC_PLUGINS_IPOD_STREAMER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))

struct _MusicPluginsiPodStreamerPrivate {
	MusicPipeline* pipe;
	MusicInstallGstreamerPluginsDialog* dialog;
	MusicPluginsiPodDeviceManager* dm;
};

static gint MusicPluginsiPodStreamer_private_offset;
static gpointer music_plugins_ipod_streamer_parent_class = NULL;
static MusicPlaybackIface * music_plugins_ipod_streamer_music_playback_parent_iface = NULL;
static GType music_plugins_ipod_streamer_type_id = 0;

static gboolean music_plugins_ipod_streamer_bus_callback (MusicPluginsiPodStreamer* self,
                                                   GstBus* bus,
                                                   GstMessage* message);
static gboolean _music_plugins_ipod_streamer_bus_callback_gst_bus_func (GstBus* bus,
                                                                 GstMessage* message,
                                                                 gpointer self);
static gboolean _music_playback_update_position_gsource_func (gpointer self);
static GeeCollection* music_plugins_ipod_streamer_real_get_supported_uri (MusicPlayback* base);
static gboolean music_plugins_ipod_streamer_real_update_position (MusicPlayback* base);
static void music_plugins_ipod_streamer_real_play (MusicPlayback* base);
static void music_plugins_ipod_streamer_real_pause (MusicPlayback* base);
static void music_plugins_ipod_streamer_real_set_state (MusicPlayback* base,
                                                 GstState s);
static void music_plugins_ipod_streamer_real_set_media (MusicPlayback* base,
                                                 MusicMedia* media);
static void music_plugins_ipod_streamer_real_set_position (MusicPlayback* base,
                                                    gint64 pos);
static gint64 music_plugins_ipod_streamer_real_get_position (MusicPlayback* base);
static gint64 music_plugins_ipod_streamer_real_get_duration (MusicPlayback* base);
static void music_plugins_ipod_streamer_real_set_volume (MusicPlayback* base,
                                                  gdouble val);
static gdouble music_plugins_ipod_streamer_real_get_volume (MusicPlayback* base);
static void music_plugins_ipod_streamer_real_enable_equalizer (MusicPlayback* base);
static void music_plugins_ipod_streamer_real_disable_equalizer (MusicPlayback* base);
static void music_plugins_ipod_streamer_real_set_equalizer_gain (MusicPlayback* base,
                                                          gint index,
                                                          gint val);
static void music_plugins_ipod_streamer_finalize (GObject * obj);

static inline gpointer
music_plugins_ipod_streamer_get_instance_private (MusicPluginsiPodStreamer* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPluginsiPodStreamer_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 38 "../plugins/Devices/iPod/iPodStreamer.vala"
	return self ? g_object_ref (self) : NULL;
#line 110 "iPodStreamer.c"
}

static gboolean
_music_plugins_ipod_streamer_bus_callback_gst_bus_func (GstBus* bus,
                                                        GstMessage* message,
                                                        gpointer self)
{
	gboolean result;
	result = music_plugins_ipod_streamer_bus_callback ((MusicPluginsiPodStreamer*) self, bus, message);
#line 39 "../plugins/Devices/iPod/iPodStreamer.vala"
	return result;
#line 122 "iPodStreamer.c"
}

static gboolean
_music_playback_update_position_gsource_func (gpointer self)
{
	gboolean result;
	result = music_playback_update_position ((MusicPlayback*) self);
#line 40 "../plugins/Devices/iPod/iPodStreamer.vala"
	return result;
#line 132 "iPodStreamer.c"
}

MusicPluginsiPodStreamer*
music_plugins_ipod_streamer_construct (GType object_type,
                                       MusicPluginsiPodDeviceManager* dm)
{
	MusicPluginsiPodStreamer * self = NULL;
	MusicPipeline* _tmp0_;
	MusicPluginsiPodDeviceManager* _tmp1_;
	MusicPipeline* _tmp2_;
	GstBus* _tmp3_;
#line 36 "../plugins/Devices/iPod/iPodStreamer.vala"
	g_return_val_if_fail (dm != NULL, NULL);
#line 36 "../plugins/Devices/iPod/iPodStreamer.vala"
	self = (MusicPluginsiPodStreamer*) g_object_new (object_type, NULL);
#line 37 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp0_ = music_pipeline_new ();
#line 37 "../plugins/Devices/iPod/iPodStreamer.vala"
	_g_object_unref0 (self->priv->pipe);
#line 37 "../plugins/Devices/iPod/iPodStreamer.vala"
	self->priv->pipe = _tmp0_;
#line 38 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp1_ = _g_object_ref0 (dm);
#line 38 "../plugins/Devices/iPod/iPodStreamer.vala"
	_g_object_unref0 (self->priv->dm);
#line 38 "../plugins/Devices/iPod/iPodStreamer.vala"
	self->priv->dm = _tmp1_;
#line 39 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp2_ = self->priv->pipe;
#line 39 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp3_ = _tmp2_->bus;
#line 39 "../plugins/Devices/iPod/iPodStreamer.vala"
	gst_bus_add_watch_full (_tmp3_, G_PRIORITY_DEFAULT, _music_plugins_ipod_streamer_bus_callback_gst_bus_func, g_object_ref (self), g_object_unref);
#line 40 "../plugins/Devices/iPod/iPodStreamer.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _music_playback_update_position_gsource_func, g_object_ref ((MusicPlayback*) self), g_object_unref);
#line 36 "../plugins/Devices/iPod/iPodStreamer.vala"
	return self;
#line 170 "iPodStreamer.c"
}

MusicPluginsiPodStreamer*
music_plugins_ipod_streamer_new (MusicPluginsiPodDeviceManager* dm)
{
#line 36 "../plugins/Devices/iPod/iPodStreamer.vala"
	return music_plugins_ipod_streamer_construct (MUSIC_PLUGINS_TYPE_IPOD_STREAMER, dm);
#line 178 "iPodStreamer.c"
}

static GeeCollection*
music_plugins_ipod_streamer_real_get_supported_uri (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
	GeeLinkedList* uris = NULL;
	GeeLinkedList* _tmp0_;
	GeeCollection* result;
#line 43 "../plugins/Devices/iPod/iPodStreamer.vala"
	self = (MusicPluginsiPodStreamer*) base;
#line 44 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 44 "../plugins/Devices/iPod/iPodStreamer.vala"
	uris = _tmp0_;
#line 45 "../plugins/Devices/iPod/iPodStreamer.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "afc://");
#line 46 "../plugins/Devices/iPod/iPodStreamer.vala"
	result = (GeeCollection*) uris;
#line 46 "../plugins/Devices/iPod/iPodStreamer.vala"
	return result;
#line 200 "iPodStreamer.c"
}

static gboolean
music_plugins_ipod_streamer_real_update_position (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 49 "../plugins/Devices/iPod/iPodStreamer.vala"
	self = (MusicPluginsiPodStreamer*) base;
#line 50 "../plugins/Devices/iPod/iPodStreamer.vala"
	if (self->set_resume_pos) {
#line 50 "../plugins/Devices/iPod/iPodStreamer.vala"
		_tmp0_ = TRUE;
#line 215 "iPodStreamer.c"
	} else {
		gboolean _tmp1_ = FALSE;
		MusicPlaybackManager* _tmp2_;
		MusicPlaybackManager* _tmp3_;
		MusicMedia* _tmp4_;
		MusicMedia* _tmp5_;
#line 50 "../plugins/Devices/iPod/iPodStreamer.vala"
		_tmp2_ = music_app_get_player ();
#line 50 "../plugins/Devices/iPod/iPodStreamer.vala"
		_tmp3_ = _tmp2_;
#line 50 "../plugins/Devices/iPod/iPodStreamer.vala"
		_tmp4_ = music_playback_manager_get_current_media (_tmp3_);
#line 50 "../plugins/Devices/iPod/iPodStreamer.vala"
		_tmp5_ = _tmp4_;
#line 50 "../plugins/Devices/iPod/iPodStreamer.vala"
		if (_tmp5_ != NULL) {
#line 232 "iPodStreamer.c"
			MusicPlaybackManager* _tmp6_;
			MusicPlaybackManager* _tmp7_;
			MusicMedia* _tmp8_;
			MusicMedia* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
#line 50 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp6_ = music_app_get_player ();
#line 50 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp7_ = _tmp6_;
#line 50 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp8_ = music_playback_manager_get_current_media (_tmp7_);
#line 50 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp9_ = _tmp8_;
#line 50 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp10_ = music_media_get_resume_pos (_tmp9_);
#line 50 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp11_ = _tmp10_;
#line 50 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp1_ = music_playback_get_position ((MusicPlayback*) self) >= (((gint64) (_tmp11_ - 1)) * 1000000000);
#line 253 "iPodStreamer.c"
		} else {
#line 50 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp1_ = FALSE;
#line 257 "iPodStreamer.c"
		}
#line 50 "../plugins/Devices/iPod/iPodStreamer.vala"
		_tmp0_ = _tmp1_;
#line 261 "iPodStreamer.c"
	}
#line 50 "../plugins/Devices/iPod/iPodStreamer.vala"
	if (_tmp0_) {
#line 51 "../plugins/Devices/iPod/iPodStreamer.vala"
		self->set_resume_pos = TRUE;
#line 52 "../plugins/Devices/iPod/iPodStreamer.vala"
		g_signal_emit_by_name ((MusicPlayback*) self, "current-position-update", music_playback_get_position ((MusicPlayback*) self));
#line 269 "iPodStreamer.c"
	} else {
		MusicPlaybackManager* _tmp12_;
		MusicPlaybackManager* _tmp13_;
		MusicMedia* _tmp14_;
		MusicMedia* _tmp15_;
#line 53 "../plugins/Devices/iPod/iPodStreamer.vala"
		_tmp12_ = music_app_get_player ();
#line 53 "../plugins/Devices/iPod/iPodStreamer.vala"
		_tmp13_ = _tmp12_;
#line 53 "../plugins/Devices/iPod/iPodStreamer.vala"
		_tmp14_ = music_playback_manager_get_current_media (_tmp13_);
#line 53 "../plugins/Devices/iPod/iPodStreamer.vala"
		_tmp15_ = _tmp14_;
#line 53 "../plugins/Devices/iPod/iPodStreamer.vala"
		if (_tmp15_ != NULL) {
#line 285 "iPodStreamer.c"
			MusicPipeline* _tmp16_;
			GstElement* _tmp17_;
			MusicPlaybackManager* _tmp18_;
			MusicPlaybackManager* _tmp19_;
			MusicMedia* _tmp20_;
			MusicMedia* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
#line 54 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp16_ = self->priv->pipe;
#line 54 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp17_ = _tmp16_->playbin;
#line 54 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp18_ = music_app_get_player ();
#line 54 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp19_ = _tmp18_;
#line 54 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp20_ = music_playback_manager_get_current_media (_tmp19_);
#line 54 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp21_ = _tmp20_;
#line 54 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp22_ = music_media_get_resume_pos (_tmp21_);
#line 54 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp23_ = _tmp22_;
#line 54 "../plugins/Devices/iPod/iPodStreamer.vala"
			gst_element_seek_simple (_tmp17_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp23_) * 1000000000);
#line 312 "iPodStreamer.c"
		}
	}
#line 57 "../plugins/Devices/iPod/iPodStreamer.vala"
	result = TRUE;
#line 57 "../plugins/Devices/iPod/iPodStreamer.vala"
	return result;
#line 319 "iPodStreamer.c"
}

static void
music_plugins_ipod_streamer_real_play (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
#line 61 "../plugins/Devices/iPod/iPodStreamer.vala"
	self = (MusicPluginsiPodStreamer*) base;
#line 62 "../plugins/Devices/iPod/iPodStreamer.vala"
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_PLAYING);
#line 330 "iPodStreamer.c"
}

static void
music_plugins_ipod_streamer_real_pause (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
#line 65 "../plugins/Devices/iPod/iPodStreamer.vala"
	self = (MusicPluginsiPodStreamer*) base;
#line 66 "../plugins/Devices/iPod/iPodStreamer.vala"
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_PAUSED);
#line 341 "iPodStreamer.c"
}

static void
music_plugins_ipod_streamer_real_set_state (MusicPlayback* base,
                                            GstState s)
{
	MusicPluginsiPodStreamer * self;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
#line 69 "../plugins/Devices/iPod/iPodStreamer.vala"
	self = (MusicPluginsiPodStreamer*) base;
#line 70 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp0_ = self->priv->pipe;
#line 70 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 70 "../plugins/Devices/iPod/iPodStreamer.vala"
	gst_element_set_state (_tmp1_, s);
#line 359 "iPodStreamer.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 381 "iPodStreamer.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 385 "iPodStreamer.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 391 "iPodStreamer.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 395 "iPodStreamer.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 399 "iPodStreamer.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 407 "iPodStreamer.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 435 "iPodStreamer.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 444 "iPodStreamer.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 458 "iPodStreamer.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 467 "iPodStreamer.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 481 "iPodStreamer.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 490 "iPodStreamer.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 499 "iPodStreamer.c"
}

static void
music_plugins_ipod_streamer_real_set_media (MusicPlayback* base,
                                            MusicMedia* media)
{
	MusicPluginsiPodStreamer * self;
	MusicPluginsiPodDevice* device = NULL;
	MusicPluginsiPodDeviceManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	MusicPluginsiPodDevice* _tmp4_;
	MusicPluginsiPodDevice* _tmp5_;
	gchar* uri = NULL;
	const gchar* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GMount* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	MusicPipeline* _tmp23_;
	GstElement* _tmp24_;
	gchar* _tmp25_;
	GValue _tmp26_ = {0};
	MusicPlaybackManager* _tmp27_;
	MusicPlaybackManager* _tmp28_;
	MusicMedia* _tmp29_;
	MusicMedia* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	MusicPipeline* _tmp33_;
	GstElement* _tmp34_;
	MusicPlaybackManager* _tmp35_;
	MusicPlaybackManager* _tmp36_;
	MusicMedia* _tmp37_;
	MusicMedia* _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
#line 73 "../plugins/Devices/iPod/iPodStreamer.vala"
	self = (MusicPluginsiPodStreamer*) base;
#line 73 "../plugins/Devices/iPod/iPodStreamer.vala"
	g_return_if_fail (media != NULL);
#line 74 "../plugins/Devices/iPod/iPodStreamer.vala"
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_READY);
#line 75 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp0_ = self->priv->dm;
#line 75 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp1_ = music_media_get_uri (media);
#line 75 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp2_ = _tmp1_;
#line 75 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp3_ = _tmp2_;
#line 75 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp4_ = music_plugins_ipod_device_manager_get_device_for_uri (_tmp0_, _tmp3_);
#line 75 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp5_ = _tmp4_;
#line 75 "../plugins/Devices/iPod/iPodStreamer.vala"
	_g_free0 (_tmp3_);
#line 75 "../plugins/Devices/iPod/iPodStreamer.vala"
	device = _tmp5_;
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp6_ = g_get_home_dir ();
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp7_ = g_file_new_for_path (_tmp6_);
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp8_ = _tmp7_;
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp9_ = g_file_get_uri (_tmp8_);
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp10_ = _tmp9_;
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp11_ = device->mount;
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp12_ = g_mount_get_name (_tmp11_);
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp13_ = _tmp12_;
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp14_ = music_media_get_uri (media);
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp15_ = _tmp14_;
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp16_ = _tmp15_;
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp17_ = music_device_get_uri ((MusicDevice*) device);
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp18_ = _tmp17_;
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp19_ = string_replace (_tmp16_, _tmp18_, "");
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp20_ = _tmp19_;
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp21_ = g_strdup_printf ("%s/.gvfs/%s/%s", _tmp10_, _tmp13_, _tmp20_);
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp22_ = _tmp21_;
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_g_free0 (_tmp20_);
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_g_free0 (_tmp18_);
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_g_free0 (_tmp16_);
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_g_free0 (_tmp13_);
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_g_free0 (_tmp10_);
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	_g_object_unref0 (_tmp8_);
#line 76 "../plugins/Devices/iPod/iPodStreamer.vala"
	uri = _tmp22_;
#line 78 "../plugins/Devices/iPod/iPodStreamer.vala"
	g_debug ("iPodStreamer.vala:78: set uri to %s\n", uri);
#line 79 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp23_ = self->priv->pipe;
#line 79 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp24_ = _tmp23_->playbin;
#line 79 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp25_ = string_replace (uri, "#", "%23");
#line 79 "../plugins/Devices/iPod/iPodStreamer.vala"
	g_value_init (&_tmp26_, G_TYPE_STRING);
#line 79 "../plugins/Devices/iPod/iPodStreamer.vala"
	g_value_take_string (&_tmp26_, _tmp25_);
#line 79 "../plugins/Devices/iPod/iPodStreamer.vala"
	g_object_set_property ((GObject*) _tmp24_, "uri", &_tmp26_);
#line 79 "../plugins/Devices/iPod/iPodStreamer.vala"
	G_IS_VALUE (&_tmp26_) ? (g_value_unset (&_tmp26_), NULL) : NULL;
#line 80 "../plugins/Devices/iPod/iPodStreamer.vala"
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_PLAYING);
#line 81 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp27_ = music_app_get_player ();
#line 81 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp28_ = _tmp27_;
#line 81 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp29_ = music_playback_manager_get_current_media (_tmp28_);
#line 81 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp30_ = _tmp29_;
#line 81 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp31_ = music_media_get_resume_pos (_tmp30_);
#line 81 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp32_ = _tmp31_;
#line 81 "../plugins/Devices/iPod/iPodStreamer.vala"
	g_debug ("iPodStreamer.vala:81: setURI seeking to %d\n", _tmp32_);
#line 82 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp33_ = self->priv->pipe;
#line 82 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp34_ = _tmp33_->playbin;
#line 82 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp35_ = music_app_get_player ();
#line 82 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp36_ = _tmp35_;
#line 82 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp37_ = music_playback_manager_get_current_media (_tmp36_);
#line 82 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp38_ = _tmp37_;
#line 82 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp39_ = music_media_get_resume_pos (_tmp38_);
#line 82 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp40_ = _tmp39_;
#line 82 "../plugins/Devices/iPod/iPodStreamer.vala"
	gst_element_seek_simple (_tmp34_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp40_) * 1000000000);
#line 83 "../plugins/Devices/iPod/iPodStreamer.vala"
	music_playback_play ((MusicPlayback*) self);
#line 73 "../plugins/Devices/iPod/iPodStreamer.vala"
	_g_free0 (uri);
#line 73 "../plugins/Devices/iPod/iPodStreamer.vala"
	_g_object_unref0 (device);
#line 676 "iPodStreamer.c"
}

static void
music_plugins_ipod_streamer_real_set_position (MusicPlayback* base,
                                               gint64 pos)
{
	MusicPluginsiPodStreamer * self;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
#line 86 "../plugins/Devices/iPod/iPodStreamer.vala"
	self = (MusicPluginsiPodStreamer*) base;
#line 87 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp0_ = self->priv->pipe;
#line 87 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 87 "../plugins/Devices/iPod/iPodStreamer.vala"
	gst_element_seek (_tmp1_, 1.0, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, GST_SEEK_TYPE_SET, pos, GST_SEEK_TYPE_NONE, music_playback_get_duration ((MusicPlayback*) self));
#line 694 "iPodStreamer.c"
}

static gint64
music_plugins_ipod_streamer_real_get_position (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
	gint64 rv = 0LL;
	GstFormat f = 0;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
	gint64 result;
#line 93 "../plugins/Devices/iPod/iPodStreamer.vala"
	self = (MusicPluginsiPodStreamer*) base;
#line 94 "../plugins/Devices/iPod/iPodStreamer.vala"
	rv = (gint64) 0;
#line 95 "../plugins/Devices/iPod/iPodStreamer.vala"
	f = GST_FORMAT_TIME;
#line 96 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp0_ = self->priv->pipe;
#line 96 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 96 "../plugins/Devices/iPod/iPodStreamer.vala"
	gst_element_query_position (_tmp1_, f, &_tmp2_);
#line 96 "../plugins/Devices/iPod/iPodStreamer.vala"
	rv = _tmp2_;
#line 97 "../plugins/Devices/iPod/iPodStreamer.vala"
	result = rv;
#line 97 "../plugins/Devices/iPod/iPodStreamer.vala"
	return result;
#line 725 "iPodStreamer.c"
}

static gint64
music_plugins_ipod_streamer_real_get_duration (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
	gint64 rv = 0LL;
	GstFormat f = 0;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
	gint64 result;
#line 100 "../plugins/Devices/iPod/iPodStreamer.vala"
	self = (MusicPluginsiPodStreamer*) base;
#line 101 "../plugins/Devices/iPod/iPodStreamer.vala"
	rv = (gint64) 0;
#line 102 "../plugins/Devices/iPod/iPodStreamer.vala"
	f = GST_FORMAT_TIME;
#line 103 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp0_ = self->priv->pipe;
#line 103 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 103 "../plugins/Devices/iPod/iPodStreamer.vala"
	gst_element_query_duration (_tmp1_, f, &_tmp2_);
#line 103 "../plugins/Devices/iPod/iPodStreamer.vala"
	rv = _tmp2_;
#line 104 "../plugins/Devices/iPod/iPodStreamer.vala"
	result = rv;
#line 104 "../plugins/Devices/iPod/iPodStreamer.vala"
	return result;
#line 756 "iPodStreamer.c"
}

static void
music_plugins_ipod_streamer_real_set_volume (MusicPlayback* base,
                                             gdouble val)
{
	MusicPluginsiPodStreamer * self;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	GValue _tmp2_ = {0};
#line 107 "../plugins/Devices/iPod/iPodStreamer.vala"
	self = (MusicPluginsiPodStreamer*) base;
#line 108 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp0_ = self->priv->pipe;
#line 108 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 108 "../plugins/Devices/iPod/iPodStreamer.vala"
	g_value_init (&_tmp2_, G_TYPE_DOUBLE);
#line 108 "../plugins/Devices/iPod/iPodStreamer.vala"
	g_value_set_double (&_tmp2_, val);
#line 108 "../plugins/Devices/iPod/iPodStreamer.vala"
	g_object_set_property ((GObject*) _tmp1_, "volume", &_tmp2_);
#line 108 "../plugins/Devices/iPod/iPodStreamer.vala"
	G_IS_VALUE (&_tmp2_) ? (g_value_unset (&_tmp2_), NULL) : NULL;
#line 781 "iPodStreamer.c"
}

static gdouble
music_plugins_ipod_streamer_real_get_volume (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
	GValue val = {0};
	GValue _tmp0_ = {0};
	MusicPipeline* _tmp1_;
	GstElement* _tmp2_;
	GValue _tmp3_;
	gdouble result;
#line 111 "../plugins/Devices/iPod/iPodStreamer.vala"
	self = (MusicPluginsiPodStreamer*) base;
#line 112 "../plugins/Devices/iPod/iPodStreamer.vala"
	g_value_init (&_tmp0_, G_TYPE_DOUBLE);
#line 112 "../plugins/Devices/iPod/iPodStreamer.vala"
	val = _tmp0_;
#line 113 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp1_ = self->priv->pipe;
#line 113 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp2_ = _tmp1_->playbin;
#line 113 "../plugins/Devices/iPod/iPodStreamer.vala"
	g_object_get_property ((GObject*) _tmp2_, "volume", &val);
#line 114 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp3_ = val;
#line 114 "../plugins/Devices/iPod/iPodStreamer.vala"
	result = g_value_get_double (&_tmp3_);
#line 114 "../plugins/Devices/iPod/iPodStreamer.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 114 "../plugins/Devices/iPod/iPodStreamer.vala"
	return result;
#line 814 "iPodStreamer.c"
}

static void
music_plugins_ipod_streamer_real_enable_equalizer (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
	MusicPipeline* _tmp0_;
#line 118 "../plugins/Devices/iPod/iPodStreamer.vala"
	self = (MusicPluginsiPodStreamer*) base;
#line 119 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp0_ = self->priv->pipe;
#line 119 "../plugins/Devices/iPod/iPodStreamer.vala"
	music_pipeline_enable_equalizer (_tmp0_);
#line 828 "iPodStreamer.c"
}

static void
music_plugins_ipod_streamer_real_disable_equalizer (MusicPlayback* base)
{
	MusicPluginsiPodStreamer * self;
	MusicPipeline* _tmp0_;
#line 122 "../plugins/Devices/iPod/iPodStreamer.vala"
	self = (MusicPluginsiPodStreamer*) base;
#line 123 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp0_ = self->priv->pipe;
#line 123 "../plugins/Devices/iPod/iPodStreamer.vala"
	music_pipeline_disable_equalizer (_tmp0_);
#line 842 "iPodStreamer.c"
}

static void
music_plugins_ipod_streamer_real_set_equalizer_gain (MusicPlayback* base,
                                                     gint index,
                                                     gint val)
{
	MusicPluginsiPodStreamer * self;
	MusicPipeline* _tmp0_;
	MusicEqualizer* _tmp1_;
#line 126 "../plugins/Devices/iPod/iPodStreamer.vala"
	self = (MusicPluginsiPodStreamer*) base;
#line 127 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp0_ = self->priv->pipe;
#line 127 "../plugins/Devices/iPod/iPodStreamer.vala"
	_tmp1_ = _tmp0_->eq;
#line 127 "../plugins/Devices/iPod/iPodStreamer.vala"
	music_equalizer_set_gain (_tmp1_, index, (gdouble) val);
#line 861 "iPodStreamer.c"
}

static gboolean
music_plugins_ipod_streamer_bus_callback (MusicPluginsiPodStreamer* self,
                                          GstBus* bus,
                                          GstMessage* message)
{
	gboolean result;
#line 131 "../plugins/Devices/iPod/iPodStreamer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 131 "../plugins/Devices/iPod/iPodStreamer.vala"
	g_return_val_if_fail (bus != NULL, FALSE);
#line 131 "../plugins/Devices/iPod/iPodStreamer.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 132 "../plugins/Devices/iPod/iPodStreamer.vala"
	switch (message->type) {
#line 132 "../plugins/Devices/iPod/iPodStreamer.vala"
		case GST_MESSAGE_ERROR:
#line 880 "iPodStreamer.c"
		{
			GError* err = NULL;
			gchar* debug = NULL;
			GError* _tmp0_ = NULL;
			gchar* _tmp1_ = NULL;
			GError* _tmp2_;
			const gchar* _tmp3_;
#line 136 "../plugins/Devices/iPod/iPodStreamer.vala"
			gst_message_parse_error (message, &_tmp0_, &_tmp1_);
#line 136 "../plugins/Devices/iPod/iPodStreamer.vala"
			_g_error_free0 (err);
#line 136 "../plugins/Devices/iPod/iPodStreamer.vala"
			err = _tmp0_;
#line 136 "../plugins/Devices/iPod/iPodStreamer.vala"
			_g_free0 (debug);
#line 136 "../plugins/Devices/iPod/iPodStreamer.vala"
			debug = _tmp1_;
#line 137 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp2_ = err;
#line 137 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp3_ = _tmp2_->message;
#line 137 "../plugins/Devices/iPod/iPodStreamer.vala"
			g_warning ("iPodStreamer.vala:137: Error: %s\n", _tmp3_);
#line 138 "../plugins/Devices/iPod/iPodStreamer.vala"
			g_signal_emit_by_name ((MusicPlayback*) self, "error-occured");
#line 139 "../plugins/Devices/iPod/iPodStreamer.vala"
			_g_free0 (debug);
#line 139 "../plugins/Devices/iPod/iPodStreamer.vala"
			_g_error_free0 (err);
#line 139 "../plugins/Devices/iPod/iPodStreamer.vala"
			break;
#line 912 "iPodStreamer.c"
		}
#line 132 "../plugins/Devices/iPod/iPodStreamer.vala"
		case GST_MESSAGE_ELEMENT:
#line 916 "iPodStreamer.c"
		{
			gboolean _tmp4_ = FALSE;
			gboolean _tmp5_ = FALSE;
			GstStructure* _tmp6_;
#line 141 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp6_ = gst_message_get_structure (message);
#line 141 "../plugins/Devices/iPod/iPodStreamer.vala"
			if (_tmp6_ != NULL) {
#line 141 "../plugins/Devices/iPod/iPodStreamer.vala"
				_tmp5_ = gst_is_missing_plugin_message (message);
#line 927 "iPodStreamer.c"
			} else {
#line 141 "../plugins/Devices/iPod/iPodStreamer.vala"
				_tmp5_ = FALSE;
#line 931 "iPodStreamer.c"
			}
#line 141 "../plugins/Devices/iPod/iPodStreamer.vala"
			if (_tmp5_) {
#line 935 "iPodStreamer.c"
				gboolean _tmp7_ = FALSE;
				MusicInstallGstreamerPluginsDialog* _tmp8_;
#line 141 "../plugins/Devices/iPod/iPodStreamer.vala"
				_tmp8_ = self->priv->dialog;
#line 141 "../plugins/Devices/iPod/iPodStreamer.vala"
				if (_tmp8_ == NULL) {
#line 141 "../plugins/Devices/iPod/iPodStreamer.vala"
					_tmp7_ = TRUE;
#line 944 "iPodStreamer.c"
				} else {
					MusicInstallGstreamerPluginsDialog* _tmp9_;
					gboolean _tmp10_;
					gboolean _tmp11_;
#line 141 "../plugins/Devices/iPod/iPodStreamer.vala"
					_tmp9_ = self->priv->dialog;
#line 141 "../plugins/Devices/iPod/iPodStreamer.vala"
					_tmp10_ = gtk_widget_get_visible ((GtkWidget*) _tmp9_);
#line 141 "../plugins/Devices/iPod/iPodStreamer.vala"
					_tmp11_ = _tmp10_;
#line 141 "../plugins/Devices/iPod/iPodStreamer.vala"
					_tmp7_ = !_tmp11_;
#line 957 "iPodStreamer.c"
				}
#line 141 "../plugins/Devices/iPod/iPodStreamer.vala"
				_tmp4_ = _tmp7_;
#line 961 "iPodStreamer.c"
			} else {
#line 141 "../plugins/Devices/iPod/iPodStreamer.vala"
				_tmp4_ = FALSE;
#line 965 "iPodStreamer.c"
			}
#line 141 "../plugins/Devices/iPod/iPodStreamer.vala"
			if (_tmp4_) {
#line 969 "iPodStreamer.c"
				MusicInstallGstreamerPluginsDialog* _tmp12_;
#line 142 "../plugins/Devices/iPod/iPodStreamer.vala"
				_tmp12_ = music_install_gstreamer_plugins_dialog_new (message);
#line 142 "../plugins/Devices/iPod/iPodStreamer.vala"
				g_object_ref_sink (_tmp12_);
#line 142 "../plugins/Devices/iPod/iPodStreamer.vala"
				_g_object_unref0 (self->priv->dialog);
#line 142 "../plugins/Devices/iPod/iPodStreamer.vala"
				self->priv->dialog = _tmp12_;
#line 979 "iPodStreamer.c"
			}
#line 145 "../plugins/Devices/iPod/iPodStreamer.vala"
			break;
#line 983 "iPodStreamer.c"
		}
#line 132 "../plugins/Devices/iPod/iPodStreamer.vala"
		case GST_MESSAGE_EOS:
#line 987 "iPodStreamer.c"
		{
#line 147 "../plugins/Devices/iPod/iPodStreamer.vala"
			g_signal_emit_by_name ((MusicPlayback*) self, "end-of-stream");
#line 148 "../plugins/Devices/iPod/iPodStreamer.vala"
			break;
#line 993 "iPodStreamer.c"
		}
#line 132 "../plugins/Devices/iPod/iPodStreamer.vala"
		case GST_MESSAGE_STATE_CHANGED:
#line 997 "iPodStreamer.c"
		{
			GstState oldstate = 0;
			GstState newstate = 0;
			GstState pending = 0;
			GstState _tmp13_ = 0;
			GstState _tmp14_ = 0;
			GstState _tmp15_ = 0;
#line 153 "../plugins/Devices/iPod/iPodStreamer.vala"
			gst_message_parse_state_changed (message, &_tmp13_, &_tmp14_, &_tmp15_);
#line 153 "../plugins/Devices/iPod/iPodStreamer.vala"
			oldstate = _tmp13_;
#line 153 "../plugins/Devices/iPod/iPodStreamer.vala"
			newstate = _tmp14_;
#line 153 "../plugins/Devices/iPod/iPodStreamer.vala"
			pending = _tmp15_;
#line 154 "../plugins/Devices/iPod/iPodStreamer.vala"
			if (newstate != GST_STATE_PLAYING) {
#line 155 "../plugins/Devices/iPod/iPodStreamer.vala"
				break;
#line 1017 "iPodStreamer.c"
			}
#line 157 "../plugins/Devices/iPod/iPodStreamer.vala"
			break;
#line 1021 "iPodStreamer.c"
		}
#line 132 "../plugins/Devices/iPod/iPodStreamer.vala"
		case GST_MESSAGE_TAG:
#line 1025 "iPodStreamer.c"
		{
			GstTagList* tag_list = NULL;
			GstTagList* _tmp16_ = NULL;
			GstTagList* _tmp17_;
			GstTagList* _tmp18_;
			gchar* title = NULL;
			gchar* _tmp19_;
			GstTagList* _tmp20_;
			gchar* _tmp21_ = NULL;
#line 160 "../plugins/Devices/iPod/iPodStreamer.vala"
			gst_message_parse_tag (message, &_tmp16_);
#line 160 "../plugins/Devices/iPod/iPodStreamer.vala"
			_gst_tag_list_unref0 (tag_list);
#line 160 "../plugins/Devices/iPod/iPodStreamer.vala"
			tag_list = _tmp16_;
#line 161 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp17_ = tag_list;
#line 161 "../plugins/Devices/iPod/iPodStreamer.vala"
			if (_tmp17_ == NULL) {
#line 162 "../plugins/Devices/iPod/iPodStreamer.vala"
				_gst_tag_list_unref0 (tag_list);
#line 162 "../plugins/Devices/iPod/iPodStreamer.vala"
				break;
#line 1049 "iPodStreamer.c"
			}
#line 165 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp18_ = tag_list;
#line 165 "../plugins/Devices/iPod/iPodStreamer.vala"
			if (gst_tag_list_get_tag_size (_tmp18_, GST_TAG_TITLE) <= ((guint) 0)) {
#line 166 "../plugins/Devices/iPod/iPodStreamer.vala"
				_gst_tag_list_unref0 (tag_list);
#line 166 "../plugins/Devices/iPod/iPodStreamer.vala"
				break;
#line 1059 "iPodStreamer.c"
			}
#line 169 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp19_ = g_strdup ("");
#line 169 "../plugins/Devices/iPod/iPodStreamer.vala"
			title = _tmp19_;
#line 170 "../plugins/Devices/iPod/iPodStreamer.vala"
			_tmp20_ = tag_list;
#line 170 "../plugins/Devices/iPod/iPodStreamer.vala"
			gst_tag_list_get_string (_tmp20_, GST_TAG_TITLE, &_tmp21_);
#line 170 "../plugins/Devices/iPod/iPodStreamer.vala"
			_g_free0 (title);
#line 170 "../plugins/Devices/iPod/iPodStreamer.vala"
			title = _tmp21_;
#line 171 "../plugins/Devices/iPod/iPodStreamer.vala"
			_g_free0 (title);
#line 171 "../plugins/Devices/iPod/iPodStreamer.vala"
			_gst_tag_list_unref0 (tag_list);
#line 171 "../plugins/Devices/iPod/iPodStreamer.vala"
			break;
#line 1079 "iPodStreamer.c"
		}
		default:
		{
#line 173 "../plugins/Devices/iPod/iPodStreamer.vala"
			break;
#line 1085 "iPodStreamer.c"
		}
	}
#line 176 "../plugins/Devices/iPod/iPodStreamer.vala"
	result = TRUE;
#line 176 "../plugins/Devices/iPod/iPodStreamer.vala"
	return result;
#line 1092 "iPodStreamer.c"
}

static void
music_plugins_ipod_streamer_class_init (MusicPluginsiPodStreamerClass * klass,
                                        gpointer klass_data)
{
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	music_plugins_ipod_streamer_parent_class = g_type_class_peek_parent (klass);
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	g_type_class_adjust_private_offset (klass, &MusicPluginsiPodStreamer_private_offset);
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	G_OBJECT_CLASS (klass)->finalize = music_plugins_ipod_streamer_finalize;
#line 1105 "iPodStreamer.c"
}

static void
music_plugins_ipod_streamer_music_playback_interface_init (MusicPlaybackIface * iface,
                                                           gpointer iface_data)
{
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	music_plugins_ipod_streamer_music_playback_parent_iface = g_type_interface_peek_parent (iface);
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	iface->get_supported_uri = (GeeCollection* (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_get_supported_uri;
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	iface->update_position = (gboolean (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_update_position;
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	iface->play = (void (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_play;
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	iface->pause = (void (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_pause;
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	iface->set_state = (void (*) (MusicPlayback*, GstState)) music_plugins_ipod_streamer_real_set_state;
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	iface->set_media = (void (*) (MusicPlayback*, MusicMedia*)) music_plugins_ipod_streamer_real_set_media;
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	iface->set_position = (void (*) (MusicPlayback*, gint64)) music_plugins_ipod_streamer_real_set_position;
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	iface->get_position = (gint64 (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_get_position;
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	iface->get_duration = (gint64 (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_get_duration;
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	iface->set_volume = (void (*) (MusicPlayback*, gdouble)) music_plugins_ipod_streamer_real_set_volume;
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	iface->get_volume = (gdouble (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_get_volume;
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	iface->enable_equalizer = (void (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_enable_equalizer;
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	iface->disable_equalizer = (void (*) (MusicPlayback*)) music_plugins_ipod_streamer_real_disable_equalizer;
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	iface->set_equalizer_gain = (void (*) (MusicPlayback*, gint, gint)) music_plugins_ipod_streamer_real_set_equalizer_gain;
#line 1142 "iPodStreamer.c"
}

static void
music_plugins_ipod_streamer_instance_init (MusicPluginsiPodStreamer * self,
                                           gpointer klass)
{
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	self->priv = music_plugins_ipod_streamer_get_instance_private (self);
#line 1151 "iPodStreamer.c"
}

static void
music_plugins_ipod_streamer_finalize (GObject * obj)
{
	MusicPluginsiPodStreamer * self;
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_IPOD_STREAMER, MusicPluginsiPodStreamer);
#line 30 "../plugins/Devices/iPod/iPodStreamer.vala"
	_g_object_unref0 (self->cdda);
#line 32 "../plugins/Devices/iPod/iPodStreamer.vala"
	_g_object_unref0 (self->priv->pipe);
#line 33 "../plugins/Devices/iPod/iPodStreamer.vala"
	_g_object_unref0 (self->priv->dialog);
#line 34 "../plugins/Devices/iPod/iPodStreamer.vala"
	_g_object_unref0 (self->priv->dm);
#line 29 "../plugins/Devices/iPod/iPodStreamer.vala"
	G_OBJECT_CLASS (music_plugins_ipod_streamer_parent_class)->finalize (obj);
#line 1170 "iPodStreamer.c"
}

GType
music_plugins_ipod_streamer_get_type (void)
{
	return music_plugins_ipod_streamer_type_id;
}

GType
music_plugins_ipod_streamer_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsiPodStreamerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_ipod_streamer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsiPodStreamer), 0, (GInstanceInitFunc) music_plugins_ipod_streamer_instance_init, NULL };
	static const GInterfaceInfo music_playback_info = { (GInterfaceInitFunc) music_plugins_ipod_streamer_music_playback_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	music_plugins_ipod_streamer_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MusicPluginsiPodStreamer", &g_define_type_info, 0);
	g_type_module_add_interface (module, music_plugins_ipod_streamer_type_id, MUSIC_TYPE_PLAYBACK, &music_playback_info);
	MusicPluginsiPodStreamer_private_offset = sizeof (MusicPluginsiPodStreamerPrivate);
	return music_plugins_ipod_streamer_type_id;
}

