/* LocalLibrary.c generated by valac 0.56.0, the Vala compiler
 * generated from LocalLibrary.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 *              Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <glib-object.h>
#include <gee.h>
#include <glib.h>
#include <libgda/libgda.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <handy.h>
#include <time.h>
#include <gtk/gtk.h>

#define MUSIC_LOCAL_LIBRARY_DB_FILE "database_0_3_2"
#define MUSIC_DATABASE_MEDIA_TABLE_NAME "media"
#define MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME "smart_playlists"
#define MUSIC_DATABASE_PLAYLISTS_TABLE_NAME "playlists"
#define MUSIC_DATABASE_PLAYLISTS_ROWID "+2"
#define MUSIC_DATABASE_SMART_PLAYLISTS_ROWID "+5"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_LOCAL_LIBRARY (music_local_library_get_type ())
#define MUSIC_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibrary))
#define MUSIC_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibraryClass))
#define MUSIC_IS_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LOCAL_LIBRARY))
#define MUSIC_IS_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LOCAL_LIBRARY))
#define MUSIC_LOCAL_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibraryClass))

typedef struct _MusicLocalLibrary MusicLocalLibrary;
typedef struct _MusicLocalLibraryClass MusicLocalLibraryClass;
typedef struct _MusicLocalLibraryPrivate MusicLocalLibraryPrivate;

#define MUSIC_TYPE_FILE_OPERATOR (music_file_operator_get_type ())
#define MUSIC_FILE_OPERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_FILE_OPERATOR, MusicFileOperator))
#define MUSIC_FILE_OPERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_FILE_OPERATOR, MusicFileOperatorClass))
#define MUSIC_IS_FILE_OPERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_FILE_OPERATOR))
#define MUSIC_IS_FILE_OPERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_FILE_OPERATOR))
#define MUSIC_FILE_OPERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_FILE_OPERATOR, MusicFileOperatorClass))

typedef struct _MusicFileOperator MusicFileOperator;
typedef struct _MusicFileOperatorClass MusicFileOperatorClass;

#define MUSIC_TYPE_GSTREAMER_TAGGER (music_gstreamer_tagger_get_type ())
#define MUSIC_GSTREAMER_TAGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_GSTREAMER_TAGGER, MusicGStreamerTagger))
#define MUSIC_GSTREAMER_TAGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_GSTREAMER_TAGGER, MusicGStreamerTaggerClass))
#define MUSIC_IS_GSTREAMER_TAGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_GSTREAMER_TAGGER))
#define MUSIC_IS_GSTREAMER_TAGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_GSTREAMER_TAGGER))
#define MUSIC_GSTREAMER_TAGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_GSTREAMER_TAGGER, MusicGStreamerTaggerClass))

typedef struct _MusicGStreamerTagger MusicGStreamerTagger;
typedef struct _MusicGStreamerTaggerClass MusicGStreamerTaggerClass;

#define MUSIC_TYPE_DEVICE_PREFERENCES (music_device_preferences_get_type ())
#define MUSIC_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_DEVICE_PREFERENCES, MusicDevicePreferences))
#define MUSIC_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_DEVICE_PREFERENCES, MusicDevicePreferencesClass))
#define MUSIC_IS_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_DEVICE_PREFERENCES))
#define MUSIC_IS_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_DEVICE_PREFERENCES))
#define MUSIC_DEVICE_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_DEVICE_PREFERENCES, MusicDevicePreferencesClass))

typedef struct _MusicDevicePreferences MusicDevicePreferences;
typedef struct _MusicDevicePreferencesClass MusicDevicePreferencesClass;
enum  {
	MUSIC_LOCAL_LIBRARY_0_PROPERTY,
	MUSIC_LOCAL_LIBRARY_MAIN_DIRECTORY_SET_PROPERTY,
	MUSIC_LOCAL_LIBRARY_CONNECTION_PROPERTY,
	MUSIC_LOCAL_LIBRARY_NUM_PROPERTIES
};
static GParamSpec* music_local_library_properties[MUSIC_LOCAL_LIBRARY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define MUSIC_TYPE_LOCAL_MEDIA (music_local_media_get_type ())
#define MUSIC_LOCAL_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LOCAL_MEDIA, MusicLocalMedia))
#define MUSIC_LOCAL_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LOCAL_MEDIA, MusicLocalMediaClass))
#define MUSIC_IS_LOCAL_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LOCAL_MEDIA))
#define MUSIC_IS_LOCAL_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LOCAL_MEDIA))
#define MUSIC_LOCAL_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LOCAL_MEDIA, MusicLocalMediaClass))

typedef struct _MusicLocalMedia MusicLocalMedia;
typedef struct _MusicLocalMediaClass MusicLocalMediaClass;
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))

#define MUSIC_TYPE_LOCAL_SMART_PLAYLIST (music_local_smart_playlist_get_type ())
#define MUSIC_LOCAL_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylist))
#define MUSIC_LOCAL_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylistClass))
#define MUSIC_IS_LOCAL_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LOCAL_SMART_PLAYLIST))
#define MUSIC_IS_LOCAL_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LOCAL_SMART_PLAYLIST))
#define MUSIC_LOCAL_SMART_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylistClass))

typedef struct _MusicLocalSmartPlaylist MusicLocalSmartPlaylist;
typedef struct _MusicLocalSmartPlaylistClass MusicLocalSmartPlaylistClass;

#define MUSIC_TYPE_LOCAL_STATIC_PLAYLIST (music_local_static_playlist_get_type ())
#define MUSIC_LOCAL_STATIC_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LOCAL_STATIC_PLAYLIST, MusicLocalStaticPlaylist))
#define MUSIC_LOCAL_STATIC_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LOCAL_STATIC_PLAYLIST, MusicLocalStaticPlaylistClass))
#define MUSIC_IS_LOCAL_STATIC_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LOCAL_STATIC_PLAYLIST))
#define MUSIC_IS_LOCAL_STATIC_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LOCAL_STATIC_PLAYLIST))
#define MUSIC_LOCAL_STATIC_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LOCAL_STATIC_PLAYLIST, MusicLocalStaticPlaylistClass))

typedef struct _MusicLocalStaticPlaylist MusicLocalStaticPlaylist;
typedef struct _MusicLocalStaticPlaylistClass MusicLocalStaticPlaylistClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _MusicFileOperatorPrivate MusicFileOperatorPrivate;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

#define MUSIC_TYPE_PLAYBACK_MANAGER (music_playback_manager_get_type ())
#define MUSIC_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager))
#define MUSIC_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))
#define MUSIC_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))

typedef struct _MusicPlaybackManager MusicPlaybackManager;
typedef struct _MusicPlaybackManagerClass MusicPlaybackManagerClass;

#define MUSIC_TYPE_LIBRARY_WINDOW (music_library_window_get_type ())
#define MUSIC_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow))
#define MUSIC_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))
#define MUSIC_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))

typedef struct _MusicLibraryWindow MusicLibraryWindow;
typedef struct _MusicLibraryWindowClass MusicLibraryWindowClass;
typedef struct _MusicLocalLibrarySetMusicFolderData MusicLocalLibrarySetMusicFolderData;
typedef enum  {
	MUSIC_FILE_OPERATOR_IMPORT_TYPE_SET,
	MUSIC_FILE_OPERATOR_IMPORT_TYPE_RESCAN,
	MUSIC_FILE_OPERATOR_IMPORT_TYPE_PLAYLIST,
	MUSIC_FILE_OPERATOR_IMPORT_TYPE_IMPORT
} MusicFileOperatorImportType;

#define MUSIC_FILE_OPERATOR_TYPE_IMPORT_TYPE (music_file_operator_import_type_get_type ())
typedef struct _MusicLocalLibrarySetMusicFolderThreadData MusicLocalLibrarySetMusicFolderThreadData;
typedef struct _MusicLocalLibraryAddFilesToLibraryAsyncData MusicLocalLibraryAddFilesToLibraryAsyncData;
typedef struct _MusicLocalLibraryAddFolderToLibraryAsyncData MusicLocalLibraryAddFolderToLibraryAsyncData;
typedef struct _MusicLocalLibraryRescanMusicFolderAsyncData MusicLocalLibraryRescanMusicFolderAsyncData;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))

#define MUSIC_TYPE_COVER_IMPORT (music_cover_import_get_type ())
#define MUSIC_COVER_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_COVER_IMPORT, MusicCoverImport))
#define MUSIC_COVER_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_COVER_IMPORT, MusicCoverImportClass))
#define MUSIC_IS_COVER_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_COVER_IMPORT))
#define MUSIC_IS_COVER_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_COVER_IMPORT))
#define MUSIC_COVER_IMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_COVER_IMPORT, MusicCoverImportClass))

typedef struct _MusicCoverImport MusicCoverImport;
typedef struct _MusicCoverImportClass MusicCoverImportClass;

struct _MusicLocalLibrary {
	MusicLibrary parent_instance;
	MusicLocalLibraryPrivate * priv;
	MusicStaticPlaylist* p_music;
};

struct _MusicLocalLibraryClass {
	MusicLibraryClass parent_class;
};

struct _MusicLocalLibraryPrivate {
	MusicFileOperator* fo;
	MusicGStreamerTagger* tagger;
	GeeTreeSet* _playlists;
	GRecMutex __lock__playlists;
	GeeTreeSet* _smart_playlists;
	GRecMutex __lock__smart_playlists;
	GeeHashMap* _medias;
	GRecMutex __lock__medias;
	GeeTreeSet* _searched_medias;
	GRecMutex __lock__searched_medias;
	GeeHashMap* album_info;
	GeeHashMap* _dont_show_medias;
	GeeTreeSet* open_media_list;
	gboolean _doing_file_operations;
	GdaConnection* _connection;
	GeeHashMap* preferences;
};

struct _MusicFileOperator {
	GObject parent_instance;
	MusicFileOperatorPrivate * priv;
	MusicGStreamerTagger* tagger;
	GCancellable* cancellable;
	gint index;
	gint item_count;
};

struct _MusicFileOperatorClass {
	GObjectClass parent_class;
};

struct _MusicLocalLibrarySetMusicFolderData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicLocalLibrary* self;
	gchar* folder;
	gchar* m_folder;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gboolean _tmp17_;
	MusicSettingsMain* _tmp18_;
	MusicSettingsMain* _tmp19_;
	MusicPlaybackManager* _tmp20_;
	MusicPlaybackManager* _tmp21_;
	GeeHashMap* _tmp22_;
	GeeCollection* _tmp23_;
	GeeCollection* _tmp24_;
	GeeCollection* _tmp25_;
	MusicLibraryWindow* _tmp26_;
	MusicLibraryWindow* _tmp27_;
	MusicPlaybackManager* _tmp28_;
	MusicPlaybackManager* _tmp29_;
};

struct _MusicLocalLibrarySetMusicFolderThreadData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicLocalLibrary* self;
	gchar* folder;
	GFile* music_folder_file;
	GFile* _tmp0_;
	GeeTreeSet* files;
	GeeTreeSet* _tmp1_;
	gint items;
};

struct _MusicLocalLibraryAddFilesToLibraryAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicLocalLibrary* self;
	GeeCollection* files;
	GeeTreeSet* to_import;
	GeeTreeSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
};

struct _MusicLocalLibraryAddFolderToLibraryAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicLocalLibrary* self;
	GeeCollection* folders;
	GeeTreeSet* files;
	GeeTreeSet* _tmp0_;
	GeeIterator* _folder_it;
	GeeIterator* _tmp1_;
	GeeIterator* _tmp2_;
	gchar* folder;
	GeeIterator* _tmp3_;
	gpointer _tmp4_;
	GFile* file;
	const gchar* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GeeTreeSet* _tmp8_;
	GeeIterator* _m_it;
	GeeCollection* _tmp9_;
	GeeCollection* _tmp10_;
	GeeIterator* _tmp11_;
	GeeIterator* _tmp12_;
	GeeIterator* _tmp13_;
	MusicMedia* m;
	GeeIterator* _tmp14_;
	gpointer _tmp15_;
	GeeTreeSet* _tmp16_;
	MusicMedia* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gboolean _tmp21_;
	GeeTreeSet* _tmp22_;
	MusicMedia* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	GeeTreeSet* _tmp27_;
	gboolean _tmp28_;
	gboolean _tmp29_;
	GeeTreeSet* _tmp30_;
	MusicLibraryWindow* _tmp31_;
	MusicLibraryWindow* _tmp32_;
};

struct _MusicLocalLibraryRescanMusicFolderAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicLocalLibrary* self;
	GeeTreeSet* to_remove;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* files;
	GeeTreeSet* _tmp1_;
	gchar* music_folder_dir;
	MusicSettingsMain* _tmp2_;
	MusicSettingsMain* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gint num_items;
	const gchar* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GeeTreeSet* _tmp11_;
	gint _tmp12_;
	const gchar* _tmp13_;
	GeeIterator* _m_it;
	GeeCollection* _tmp14_;
	GeeCollection* _tmp15_;
	GeeIterator* _tmp16_;
	GeeIterator* _tmp17_;
	GeeIterator* _tmp18_;
	MusicMedia* m;
	GeeIterator* _tmp19_;
	gpointer _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
	MusicMedia* _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	MusicMedia* _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
	MusicMedia* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	const gchar* _tmp33_;
	MusicMedia* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	GFile* _tmp38_;
	GFile* _tmp39_;
	gboolean _tmp40_;
	GeeTreeSet* _tmp41_;
	MusicMedia* _tmp42_;
	GeeTreeSet* _tmp43_;
	MusicMedia* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gboolean _tmp48_;
	GeeTreeSet* _tmp49_;
	MusicMedia* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	GeeTreeSet* _tmp54_;
	MusicFileOperator* _tmp55_;
	GCancellable* _tmp56_;
	GeeTreeSet* _tmp57_;
	gboolean _tmp58_;
	gboolean _tmp59_;
	GeeTreeSet* _tmp60_;
};

static gint MusicLocalLibrary_private_offset;
static gpointer music_local_library_parent_class = NULL;

VALA_EXTERN GType music_local_library_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLocalLibrary, g_object_unref)
VALA_EXTERN GType music_file_operator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicFileOperator, g_object_unref)
VALA_EXTERN GType music_gstreamer_tagger_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicGStreamerTagger, g_object_unref)
VALA_EXTERN GType music_device_preferences_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicDevicePreferences, g_object_unref)
static void music_local_library_real_initialize_library (MusicLibrary* base);
static void music_local_library_init_database (MusicLocalLibrary* self);
VALA_EXTERN void music_file_operator_connect_to_manager (MusicFileOperator* self);
static GeeCollection* music_local_library_get_rowids_from_table (MusicLocalLibrary* self,
                                                          const gchar* table_name);
VALA_EXTERN GType music_local_media_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLocalMedia, g_object_unref)
VALA_EXTERN GdaConnection* music_local_library_get_connection (MusicLocalLibrary* self);
VALA_EXTERN MusicLocalMedia* music_local_media_new (gint64 rowid,
                                        GdaConnection* connection);
VALA_EXTERN MusicLocalMedia* music_local_media_construct (GType object_type,
                                              gint64 rowid,
                                              GdaConnection* connection);
VALA_EXTERN void music_local_smart_playlist_add_defaults (GdaConnection* connection);
VALA_EXTERN GType music_local_smart_playlist_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLocalSmartPlaylist, g_object_unref)
VALA_EXTERN MusicLocalSmartPlaylist* music_local_smart_playlist_new (gint64 rowid,
                                                         GdaConnection* connection);
VALA_EXTERN MusicLocalSmartPlaylist* music_local_smart_playlist_construct (GType object_type,
                                                               gint64 rowid,
                                                               GdaConnection* connection);
VALA_EXTERN GType music_local_static_playlist_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLocalStaticPlaylist, g_object_unref)
VALA_EXTERN MusicLocalStaticPlaylist* music_local_static_playlist_new (gint64 rowid,
                                                           GdaConnection* connection);
VALA_EXTERN MusicLocalStaticPlaylist* music_local_static_playlist_construct (GType object_type,
                                                                 gint64 rowid,
                                                                 GdaConnection* connection);
static void music_local_library_set_connection (MusicLocalLibrary* self,
                                         GdaConnection* value);
VALA_EXTERN void music_database_create_tables (GdaConnection* connection);
VALA_EXTERN gboolean music_local_library_progress_notification_with_timeout (MusicLocalLibrary* self);
VALA_EXTERN void music_local_library_remove_all_static_playlists (MusicLocalLibrary* self);
static gint64* _int64_dup (gint64* self);
static void music_local_library_set_music_folder_data_free (gpointer _data);
VALA_EXTERN void music_local_library_set_music_folder (MusicLocalLibrary* self,
                                           const gchar* folder,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
VALA_EXTERN void music_local_library_set_music_folder_finish (MusicLocalLibrary* self,
                                                  GAsyncResult* _res_);
static gboolean music_local_library_set_music_folder_co (MusicLocalLibrarySetMusicFolderData* _data_);
VALA_EXTERN void music_local_library_clear_medias (MusicLocalLibrary* self);
VALA_EXTERN GType music_playback_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPlaybackManager, g_object_unref)
VALA_EXTERN MusicPlaybackManager* music_app_get_player (void);
VALA_EXTERN void music_playback_manager_unqueue_media (MusicPlaybackManager* self,
                                           GeeCollection* to_unqueue);
VALA_EXTERN GType music_library_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLibraryWindow, g_object_unref)
VALA_EXTERN MusicLibraryWindow* music_app_get_main_window (void);
VALA_EXTERN void music_playback_manager_stop_playback (MusicPlaybackManager* self);
static void music_local_library_set_music_folder_thread (MusicLocalLibrary* self,
                                                  const gchar* folder,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
static void music_local_library_set_music_folder_thread_finish (MusicLocalLibrary* self,
                                                         GAsyncResult* _res_);
static void music_local_library_set_music_folder_thread_data_free (gpointer _data);
static gboolean music_local_library_set_music_folder_thread_co (MusicLocalLibrarySetMusicFolderThreadData* _data_);
VALA_EXTERN GType music_file_operator_import_type_get_type (void) G_GNUC_CONST ;
static void music_local_library_import_files (MusicLocalLibrary* self,
                                       GeeTreeSet* files,
                                       MusicFileOperatorImportType type);
static void music_local_library_real_add_files_to_library (MusicLibrary* base,
                                                    GeeCollection* files);
static void music_local_library_add_files_to_library_async (MusicLocalLibrary* self,
                                                     GeeCollection* files,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static void music_local_library_add_files_to_library_finish (MusicLocalLibrary* self,
                                                      GAsyncResult* _res_);
static void music_local_library_add_files_to_library_async_data_free (gpointer _data);
static gboolean music_local_library_add_files_to_library_async_co (MusicLocalLibraryAddFilesToLibraryAsyncData* _data_);
VALA_EXTERN void music_local_library_add_folder_to_library (MusicLocalLibrary* self,
                                                GeeCollection* folders);
static void music_local_library_add_folder_to_library_async (MusicLocalLibrary* self,
                                                      GeeCollection* folders,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
static void music_local_library_add_folder_to_library_finish (MusicLocalLibrary* self,
                                                       GAsyncResult* _res_);
static void music_local_library_add_folder_to_library_async_data_free (gpointer _data);
static gboolean music_local_library_add_folder_to_library_async_co (MusicLocalLibraryAddFolderToLibraryAsyncData* _data_);
VALA_EXTERN void music_library_window_show_notification (MusicLibraryWindow* self,
                                             const gchar* title,
                                             const gchar* body,
                                             GIcon* icon,
                                             GNotificationPriority priority,
                                             const gchar* context);
VALA_EXTERN void music_local_library_rescan_music_folder (MusicLocalLibrary* self);
static void music_local_library_rescan_music_folder_async (MusicLocalLibrary* self,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
static void music_local_library_rescan_music_folder_finish (MusicLocalLibrary* self,
                                                     GAsyncResult* _res_);
static void music_local_library_rescan_music_folder_async_data_free (gpointer _data);
static gboolean music_local_library_rescan_music_folder_async_co (MusicLocalLibraryRescanMusicFolderAsyncData* _data_);
VALA_EXTERN void music_local_library_play_files (MusicLocalLibrary* self,
                                     GFile** files,
                                     gint files_length1);
static void music_local_library_media_opened_imported (MusicLocalLibrary* self,
                                                MusicMedia* m);
static void _music_local_library_media_opened_imported_music_gstreamer_tagger_media_imported (MusicGStreamerTagger* _sender,
                                                                                       MusicMedia* m,
                                                                                       gpointer self);
static void music_local_library_media_opened_finished (MusicLocalLibrary* self);
static void _music_local_library_media_opened_finished_music_gstreamer_tagger_queue_finished (MusicGStreamerTagger* _sender,
                                                                                       gpointer self);
VALA_EXTERN void music_gstreamer_tagger_discoverer_import_media (MusicGStreamerTagger* self,
                                                     GeeCollection* uris);
VALA_EXTERN void music_file_operator_reset_progress (MusicFileOperator* self,
                                         gint items);
static gboolean _music_local_library_progress_notification_with_timeout_gsource_func (gpointer self);
VALA_EXTERN void music_file_operator_import_files (MusicFileOperator* self,
                                       GeeCollection* files,
                                       MusicFileOperatorImportType type);
VALA_EXTERN void music_playback_manager_queue_media (MusicPlaybackManager* self,
                                         GeeCollection* to_queue);
VALA_EXTERN gboolean music_playback_manager_get_playing (MusicPlaybackManager* self);
VALA_EXTERN void music_playback_manager_play_media (MusicPlaybackManager* self,
                                        MusicMedia* m);
VALA_EXTERN void music_library_window_play_media (MusicLibraryWindow* self,
                                      gboolean inhibit_notifications);
static gboolean music_local_library_real_support_playlists (MusicLibrary* base);
static GeeCollection* music_local_library_real_get_playlists (MusicLibrary* base);
static MusicStaticPlaylist* music_local_library_real_playlist_from_id (MusicLibrary* base,
                                                                gint64 id);
static MusicStaticPlaylist* music_local_library_real_playlist_from_name (MusicLibrary* base,
                                                                  const gchar* name);
static void music_local_library_real_add_playlist (MusicLibrary* base,
                                            MusicStaticPlaylist* p);
static void _vala_GValue_free (GValue* self);
static void music_local_library_real_remove_playlist (MusicLibrary* base,
                                               gint64 id);
static gboolean music_local_library_real_support_smart_playlists (MusicLibrary* base);
static GeeCollection* music_local_library_real_get_smart_playlists (MusicLibrary* base);
static MusicSmartPlaylist* music_local_library_real_smart_playlist_from_id (MusicLibrary* base,
                                                                     gint64 id);
static MusicSmartPlaylist* music_local_library_real_smart_playlist_from_name (MusicLibrary* base,
                                                                       const gchar* name);
static void music_local_library_real_add_smart_playlist (MusicLibrary* base,
                                                  MusicSmartPlaylist* p);
static void music_local_library_real_remove_smart_playlist (MusicLibrary* base,
                                                     gint64 id);
static void music_local_library_real_search_medias (MusicLibrary* base,
                                             const gchar* search);
static void _vala_array_add1 (GdaSqlBuilderId* * array,
                       gint* length,
                       gint* size,
                       GdaSqlBuilderId value);
static gboolean __lambda35_ (MusicLocalLibrary* self);
static gboolean ___lambda35__gsource_func (gpointer self);
static GeeCollection* music_local_library_real_get_search_result (MusicLibrary* base);
static GeeCollection* music_local_library_real_get_medias (MusicLibrary* base);
static void music_local_library_real_update_media (MusicLibrary* base,
                                            MusicMedia* s,
                                            gboolean update_meta,
                                            gboolean record_time);
static void music_local_library_real_update_medias (MusicLibrary* base,
                                             GeeCollection* updates,
                                             gboolean update_meta,
                                             gboolean record_time);
VALA_EXTERN void music_file_operator_save_media (MusicFileOperator* self,
                                     GeeCollection* to_save,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
VALA_EXTERN void music_file_operator_save_media_finish (MusicFileOperator* self,
                                            GAsyncResult* _res_);
static MusicMedia* music_local_library_real_media_from_id (MusicLibrary* base,
                                                    gint64 id);
static MusicMedia* music_local_library_real_find_media (MusicLibrary* base,
                                                 MusicMedia* to_find);
static MusicMedia* music_local_library_real_media_from_file (MusicLibrary* base,
                                                      GFile* file);
static MusicMedia* music_local_library_real_media_from_uri (MusicLibrary* base,
                                                     const gchar* uri);
static GeeCollection* music_local_library_real_medias_from_ids (MusicLibrary* base,
                                                         GeeCollection* ids);
static GeeCollection* music_local_library_real_medias_from_uris (MusicLibrary* base,
                                                          GeeCollection* uris);
static void music_local_library_real_add_media (MusicLibrary* base,
                                         MusicMedia* s);
static void music_local_library_real_add_medias (MusicLibrary* base,
                                          GeeCollection* new_media);
static GeeHashMap* music_local_library_get_local_medias (MusicLocalLibrary* self,
                                                  GeeTreeSet* medias);
VALA_EXTERN GtkSearchEntry* music_library_window_get_search_entry (MusicLibraryWindow* self);
static void music_local_library_real_remove_media (MusicLibrary* base,
                                            MusicMedia* s,
                                            gboolean trash);
static void music_local_library_real_remove_medias (MusicLibrary* base,
                                             GeeCollection* to_remove,
                                             gboolean trash);
VALA_EXTERN MusicMedia* music_playback_manager_get_current_media (MusicPlaybackManager* self);
VALA_EXTERN void music_file_operator_remove_media (MusicFileOperator* self,
                                       GeeCollection* to_remove);
VALA_EXTERN GeeTreeSet* music_local_library_answer_to_device_sync (MusicLocalLibrary* self,
                                                       MusicDevice* device);
VALA_EXTERN MusicDevicePreferences* music_local_library_get_preferences_for_device (MusicLocalLibrary* self,
                                                                        MusicDevice* d);
VALA_EXTERN gboolean music_device_preferences_get_sync_music (MusicDevicePreferences* self);
VALA_EXTERN gboolean music_device_preferences_get_sync_all_music (MusicDevicePreferences* self);
VALA_EXTERN MusicPlaylist* music_device_preferences_get_music_playlist (MusicDevicePreferences* self);
static gboolean music_local_library_real_start_file_operations (MusicLibrary* base,
                                                         const gchar* message);
static gboolean music_local_library_real_doing_file_operations (MusicLibrary* base);
static void music_local_library_real_finish_file_operations (MusicLibrary* base);
VALA_EXTERN MusicDevicePreferences* music_device_preferences_new (MusicDevice* device,
                                                      GdaConnection* connection);
VALA_EXTERN MusicDevicePreferences* music_device_preferences_construct (GType object_type,
                                                            MusicDevice* device,
                                                            GdaConnection* connection);
static guint __lambda32_ (MusicLocalLibrary* self,
                   gint64* x);
static guint ___lambda32__gee_hash_data_func (gconstpointer v,
                                       gpointer self);
static gboolean __lambda33_ (MusicLocalLibrary* self,
                      gint64* a,
                      gint64* b);
static gboolean ___lambda33__gee_equal_data_func (gconstpointer a,
                                           gconstpointer b,
                                           gpointer self);
VALA_EXTERN MusicLocalMedia* music_local_media_new_from_media (GdaConnection* connection,
                                                   MusicMedia* m,
                                                   GError** error);
VALA_EXTERN MusicLocalMedia* music_local_media_construct_from_media (GType object_type,
                                                         GdaConnection* connection,
                                                         MusicMedia* m,
                                                         GError** error);
VALA_EXTERN MusicCoverImport* music_cover_import_new (MusicAlbum* album);
VALA_EXTERN MusicCoverImport* music_cover_import_construct (GType object_type,
                                                MusicAlbum* album);
VALA_EXTERN GType music_cover_import_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicCoverImport, g_object_unref)
static GValue* _g_value_dup (GValue* self);
VALA_EXTERN MusicLocalLibrary* music_local_library_new (void);
VALA_EXTERN MusicLocalLibrary* music_local_library_construct (GType object_type);
VALA_EXTERN gboolean music_local_library_get_main_directory_set (MusicLocalLibrary* self);
static GObject * music_local_library_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static guint _music_local_library___lambda36_ (MusicLocalLibrary* self,
                                        gint64* x);
static guint __music_local_library___lambda36__gee_hash_data_func (gconstpointer v,
                                                            gpointer self);
static gboolean _music_local_library___lambda37_ (MusicLocalLibrary* self,
                                           gint64* a,
                                           gint64* b);
static gboolean __music_local_library___lambda37__gee_equal_data_func (gconstpointer a,
                                                                gconstpointer b,
                                                                gpointer self);
static guint _music_local_library___lambda38_ (MusicLocalLibrary* self,
                                        gint64* x);
static guint __music_local_library___lambda38__gee_hash_data_func (gconstpointer v,
                                                            gpointer self);
static gboolean _music_local_library___lambda39_ (MusicLocalLibrary* self,
                                           gint64* a,
                                           gint64* b);
static gboolean __music_local_library___lambda39__gee_equal_data_func (gconstpointer a,
                                                                gconstpointer b,
                                                                gpointer self);
VALA_EXTERN MusicGStreamerTagger* music_gstreamer_tagger_new (GCancellable* cancellable);
VALA_EXTERN MusicGStreamerTagger* music_gstreamer_tagger_construct (GType object_type,
                                                        GCancellable* cancellable);
VALA_EXTERN MusicFileOperator* music_file_operator_new (void);
VALA_EXTERN MusicFileOperator* music_file_operator_construct (GType object_type);
static void music_local_library_finalize (GObject * obj);
static GType music_local_library_get_type_once (void);
static void _vala_music_local_library_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_music_local_library_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
music_local_library_get_instance_private (MusicLocalLibrary* self)
{
	return G_STRUCT_MEMBER_P (self, MusicLocalLibrary_private_offset);
}

static void
music_local_library_real_initialize_library (MusicLibrary* base)
{
	MusicLocalLibrary * self;
	MusicFileOperator* _tmp0_;
	GeeCollection* media_ids = NULL;
	GeeCollection* _tmp1_;
	GeeCollection* sp_ids = NULL;
	GeeCollection* _tmp46_;
	GeeCollection* _tmp47_;
	gboolean _tmp48_;
	gboolean _tmp49_;
	GeeCollection* p_ids = NULL;
	GeeCollection* _tmp62_;
#line 76 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 77 "../src/LocalBackend/LocalLibrary.vala"
	music_local_library_init_database (self);
#line 78 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = self->priv->fo;
#line 78 "../src/LocalBackend/LocalLibrary.vala"
	music_file_operator_connect_to_manager (_tmp0_);
#line 81 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = music_local_library_get_rowids_from_table (self, MUSIC_DATABASE_MEDIA_TABLE_NAME);
#line 81 "../src/LocalBackend/LocalLibrary.vala"
	media_ids = _tmp1_;
#line 753 "LocalLibrary.c"
	{
		GeeIterator* _media_id_it = NULL;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
#line 82 "../src/LocalBackend/LocalLibrary.vala"
		_tmp2_ = media_ids;
#line 82 "../src/LocalBackend/LocalLibrary.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 82 "../src/LocalBackend/LocalLibrary.vala"
		_media_id_it = _tmp3_;
#line 82 "../src/LocalBackend/LocalLibrary.vala"
		while (TRUE) {
#line 766 "LocalLibrary.c"
			GeeIterator* _tmp4_;
			gint64* media_id = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			MusicLocalMedia* m = NULL;
			gint64* _tmp7_;
			GdaConnection* _tmp8_;
			MusicLocalMedia* _tmp9_;
			MusicLocalMedia* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
			GeeHashMap* _tmp18_;
			MusicLocalMedia* _tmp19_;
			gint64 _tmp20_;
			gint64 _tmp21_;
			MusicLocalMedia* _tmp22_;
			MusicStaticPlaylist* _tmp23_;
			MusicLocalMedia* _tmp24_;
			GeeHashMap* _tmp25_;
			GeeSet* _tmp26_;
			GeeSet* _tmp27_;
			GeeSet* _tmp28_;
			MusicLocalMedia* _tmp29_;
			gboolean _tmp30_;
			MusicLocalMedia* _tmp36_;
			MusicAlbum* _tmp37_;
			MusicAlbum* _tmp38_;
#line 82 "../src/LocalBackend/LocalLibrary.vala"
			_tmp4_ = _media_id_it;
#line 82 "../src/LocalBackend/LocalLibrary.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 82 "../src/LocalBackend/LocalLibrary.vala"
				break;
#line 800 "LocalLibrary.c"
			}
#line 82 "../src/LocalBackend/LocalLibrary.vala"
			_tmp5_ = _media_id_it;
#line 82 "../src/LocalBackend/LocalLibrary.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 82 "../src/LocalBackend/LocalLibrary.vala"
			media_id = (gint64*) _tmp6_;
#line 83 "../src/LocalBackend/LocalLibrary.vala"
			_tmp7_ = media_id;
#line 83 "../src/LocalBackend/LocalLibrary.vala"
			_tmp8_ = self->priv->_connection;
#line 83 "../src/LocalBackend/LocalLibrary.vala"
			_tmp9_ = music_local_media_new (*_tmp7_, _tmp8_);
#line 83 "../src/LocalBackend/LocalLibrary.vala"
			m = _tmp9_;
#line 84 "../src/LocalBackend/LocalLibrary.vala"
			_tmp10_ = m;
#line 84 "../src/LocalBackend/LocalLibrary.vala"
			_tmp11_ = music_media_get_show ((MusicMedia*) _tmp10_);
#line 84 "../src/LocalBackend/LocalLibrary.vala"
			_tmp12_ = _tmp11_;
#line 84 "../src/LocalBackend/LocalLibrary.vala"
			if (!_tmp12_) {
#line 824 "LocalLibrary.c"
				GeeHashMap* _tmp13_;
				MusicLocalMedia* _tmp14_;
				gint64 _tmp15_;
				gint64 _tmp16_;
				MusicLocalMedia* _tmp17_;
#line 85 "../src/LocalBackend/LocalLibrary.vala"
				_tmp13_ = self->priv->_dont_show_medias;
#line 85 "../src/LocalBackend/LocalLibrary.vala"
				_tmp14_ = m;
#line 85 "../src/LocalBackend/LocalLibrary.vala"
				_tmp15_ = music_media_get_rowid ((MusicMedia*) _tmp14_);
#line 85 "../src/LocalBackend/LocalLibrary.vala"
				_tmp16_ = _tmp15_;
#line 85 "../src/LocalBackend/LocalLibrary.vala"
				_tmp17_ = m;
#line 85 "../src/LocalBackend/LocalLibrary.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, &_tmp16_, (MusicMedia*) _tmp17_);
#line 86 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (m);
#line 86 "../src/LocalBackend/LocalLibrary.vala"
				_g_free0 (media_id);
#line 86 "../src/LocalBackend/LocalLibrary.vala"
				continue;
#line 848 "LocalLibrary.c"
			}
#line 89 "../src/LocalBackend/LocalLibrary.vala"
			_tmp18_ = self->priv->_medias;
#line 89 "../src/LocalBackend/LocalLibrary.vala"
			_tmp19_ = m;
#line 89 "../src/LocalBackend/LocalLibrary.vala"
			_tmp20_ = music_media_get_rowid ((MusicMedia*) _tmp19_);
#line 89 "../src/LocalBackend/LocalLibrary.vala"
			_tmp21_ = _tmp20_;
#line 89 "../src/LocalBackend/LocalLibrary.vala"
			_tmp22_ = m;
#line 89 "../src/LocalBackend/LocalLibrary.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp18_, &_tmp21_, (MusicMedia*) _tmp22_);
#line 90 "../src/LocalBackend/LocalLibrary.vala"
			_tmp23_ = self->p_music;
#line 90 "../src/LocalBackend/LocalLibrary.vala"
			_tmp24_ = m;
#line 90 "../src/LocalBackend/LocalLibrary.vala"
			music_playlist_add_media ((MusicPlaylist*) _tmp23_, (MusicMedia*) _tmp24_);
#line 93 "../src/LocalBackend/LocalLibrary.vala"
			_tmp25_ = self->priv->album_info;
#line 93 "../src/LocalBackend/LocalLibrary.vala"
			_tmp26_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp25_);
#line 93 "../src/LocalBackend/LocalLibrary.vala"
			_tmp27_ = _tmp26_;
#line 93 "../src/LocalBackend/LocalLibrary.vala"
			_tmp28_ = _tmp27_;
#line 93 "../src/LocalBackend/LocalLibrary.vala"
			_tmp29_ = m;
#line 93 "../src/LocalBackend/LocalLibrary.vala"
			_tmp30_ = gee_collection_contains ((GeeCollection*) _tmp28_, (gpointer) ((guintptr) music_media_get_album_hashkey ((MusicMedia*) _tmp29_)));
#line 93 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (_tmp28_);
#line 93 "../src/LocalBackend/LocalLibrary.vala"
			if (_tmp30_) {
#line 884 "LocalLibrary.c"
				MusicAlbum* album = NULL;
				GeeHashMap* _tmp31_;
				MusicLocalMedia* _tmp32_;
				gpointer _tmp33_;
				MusicAlbum* _tmp34_;
				MusicLocalMedia* _tmp35_;
#line 94 "../src/LocalBackend/LocalLibrary.vala"
				_tmp31_ = self->priv->album_info;
#line 94 "../src/LocalBackend/LocalLibrary.vala"
				_tmp32_ = m;
#line 94 "../src/LocalBackend/LocalLibrary.vala"
				_tmp33_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp31_, (gpointer) ((guintptr) music_media_get_album_hashkey ((MusicMedia*) _tmp32_)));
#line 94 "../src/LocalBackend/LocalLibrary.vala"
				album = (MusicAlbum*) _tmp33_;
#line 95 "../src/LocalBackend/LocalLibrary.vala"
				_tmp34_ = album;
#line 95 "../src/LocalBackend/LocalLibrary.vala"
				_tmp35_ = m;
#line 95 "../src/LocalBackend/LocalLibrary.vala"
				music_album_add_media (_tmp34_, (MusicMedia*) _tmp35_);
#line 93 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (album);
#line 907 "LocalLibrary.c"
			}
#line 98 "../src/LocalBackend/LocalLibrary.vala"
			_tmp36_ = m;
#line 98 "../src/LocalBackend/LocalLibrary.vala"
			_tmp37_ = music_media_get_album_info ((MusicMedia*) _tmp36_);
#line 98 "../src/LocalBackend/LocalLibrary.vala"
			_tmp38_ = _tmp37_;
#line 98 "../src/LocalBackend/LocalLibrary.vala"
			if (_tmp38_ == NULL) {
#line 917 "LocalLibrary.c"
				MusicAlbum* album = NULL;
				MusicLocalMedia* _tmp39_;
				MusicAlbum* _tmp40_;
				MusicAlbum* _tmp41_;
				MusicLocalMedia* _tmp42_;
				GeeHashMap* _tmp43_;
				MusicAlbum* _tmp44_;
				MusicAlbum* _tmp45_;
#line 99 "../src/LocalBackend/LocalLibrary.vala"
				_tmp39_ = m;
#line 99 "../src/LocalBackend/LocalLibrary.vala"
				_tmp40_ = music_album_new_from_media ((MusicMedia*) _tmp39_);
#line 99 "../src/LocalBackend/LocalLibrary.vala"
				album = _tmp40_;
#line 100 "../src/LocalBackend/LocalLibrary.vala"
				_tmp41_ = album;
#line 100 "../src/LocalBackend/LocalLibrary.vala"
				_tmp42_ = m;
#line 100 "../src/LocalBackend/LocalLibrary.vala"
				music_album_add_media (_tmp41_, (MusicMedia*) _tmp42_);
#line 101 "../src/LocalBackend/LocalLibrary.vala"
				_tmp43_ = self->priv->album_info;
#line 101 "../src/LocalBackend/LocalLibrary.vala"
				_tmp44_ = album;
#line 101 "../src/LocalBackend/LocalLibrary.vala"
				_tmp45_ = album;
#line 101 "../src/LocalBackend/LocalLibrary.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp43_, (gpointer) ((guintptr) music_album_get_hashkey (_tmp44_)), _tmp45_);
#line 98 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (album);
#line 948 "LocalLibrary.c"
			}
#line 82 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (m);
#line 82 "../src/LocalBackend/LocalLibrary.vala"
			_g_free0 (media_id);
#line 954 "LocalLibrary.c"
		}
#line 82 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_media_id_it);
#line 958 "LocalLibrary.c"
	}
#line 106 "../src/LocalBackend/LocalLibrary.vala"
	_tmp46_ = music_local_library_get_rowids_from_table (self, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME);
#line 106 "../src/LocalBackend/LocalLibrary.vala"
	sp_ids = _tmp46_;
#line 107 "../src/LocalBackend/LocalLibrary.vala"
	_tmp47_ = sp_ids;
#line 107 "../src/LocalBackend/LocalLibrary.vala"
	_tmp48_ = gee_collection_get_is_empty (_tmp47_);
#line 107 "../src/LocalBackend/LocalLibrary.vala"
	_tmp49_ = _tmp48_;
#line 107 "../src/LocalBackend/LocalLibrary.vala"
	if (_tmp49_) {
#line 972 "LocalLibrary.c"
		GdaConnection* _tmp50_;
		GeeCollection* _tmp51_;
#line 108 "../src/LocalBackend/LocalLibrary.vala"
		_tmp50_ = self->priv->_connection;
#line 108 "../src/LocalBackend/LocalLibrary.vala"
		music_local_smart_playlist_add_defaults (_tmp50_);
#line 109 "../src/LocalBackend/LocalLibrary.vala"
		_tmp51_ = music_local_library_get_rowids_from_table (self, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME);
#line 109 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (sp_ids);
#line 109 "../src/LocalBackend/LocalLibrary.vala"
		sp_ids = _tmp51_;
#line 985 "LocalLibrary.c"
	}
	{
		GeeIterator* _sp_id_it = NULL;
		GeeCollection* _tmp52_;
		GeeIterator* _tmp53_;
#line 112 "../src/LocalBackend/LocalLibrary.vala"
		_tmp52_ = sp_ids;
#line 112 "../src/LocalBackend/LocalLibrary.vala"
		_tmp53_ = gee_iterable_iterator ((GeeIterable*) _tmp52_);
#line 112 "../src/LocalBackend/LocalLibrary.vala"
		_sp_id_it = _tmp53_;
#line 112 "../src/LocalBackend/LocalLibrary.vala"
		while (TRUE) {
#line 999 "LocalLibrary.c"
			GeeIterator* _tmp54_;
			gint64* sp_id = NULL;
			GeeIterator* _tmp55_;
			gpointer _tmp56_;
			MusicLocalSmartPlaylist* sp = NULL;
			gint64* _tmp57_;
			GdaConnection* _tmp58_;
			MusicLocalSmartPlaylist* _tmp59_;
			GeeTreeSet* _tmp60_;
			MusicLocalSmartPlaylist* _tmp61_;
#line 112 "../src/LocalBackend/LocalLibrary.vala"
			_tmp54_ = _sp_id_it;
#line 112 "../src/LocalBackend/LocalLibrary.vala"
			if (!gee_iterator_next (_tmp54_)) {
#line 112 "../src/LocalBackend/LocalLibrary.vala"
				break;
#line 1016 "LocalLibrary.c"
			}
#line 112 "../src/LocalBackend/LocalLibrary.vala"
			_tmp55_ = _sp_id_it;
#line 112 "../src/LocalBackend/LocalLibrary.vala"
			_tmp56_ = gee_iterator_get (_tmp55_);
#line 112 "../src/LocalBackend/LocalLibrary.vala"
			sp_id = (gint64*) _tmp56_;
#line 113 "../src/LocalBackend/LocalLibrary.vala"
			_tmp57_ = sp_id;
#line 113 "../src/LocalBackend/LocalLibrary.vala"
			_tmp58_ = self->priv->_connection;
#line 113 "../src/LocalBackend/LocalLibrary.vala"
			_tmp59_ = music_local_smart_playlist_new (*_tmp57_, _tmp58_);
#line 113 "../src/LocalBackend/LocalLibrary.vala"
			sp = _tmp59_;
#line 114 "../src/LocalBackend/LocalLibrary.vala"
			_tmp60_ = self->priv->_smart_playlists;
#line 114 "../src/LocalBackend/LocalLibrary.vala"
			_tmp61_ = sp;
#line 114 "../src/LocalBackend/LocalLibrary.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp60_, (MusicSmartPlaylist*) _tmp61_);
#line 112 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (sp);
#line 112 "../src/LocalBackend/LocalLibrary.vala"
			_g_free0 (sp_id);
#line 1042 "LocalLibrary.c"
		}
#line 112 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_sp_id_it);
#line 1046 "LocalLibrary.c"
	}
#line 118 "../src/LocalBackend/LocalLibrary.vala"
	_tmp62_ = music_local_library_get_rowids_from_table (self, MUSIC_DATABASE_PLAYLISTS_TABLE_NAME);
#line 118 "../src/LocalBackend/LocalLibrary.vala"
	p_ids = _tmp62_;
#line 1052 "LocalLibrary.c"
	{
		GeeIterator* _p_id_it = NULL;
		GeeCollection* _tmp63_;
		GeeIterator* _tmp64_;
#line 119 "../src/LocalBackend/LocalLibrary.vala"
		_tmp63_ = p_ids;
#line 119 "../src/LocalBackend/LocalLibrary.vala"
		_tmp64_ = gee_iterable_iterator ((GeeIterable*) _tmp63_);
#line 119 "../src/LocalBackend/LocalLibrary.vala"
		_p_id_it = _tmp64_;
#line 119 "../src/LocalBackend/LocalLibrary.vala"
		while (TRUE) {
#line 1065 "LocalLibrary.c"
			GeeIterator* _tmp65_;
			gint64* p_id = NULL;
			GeeIterator* _tmp66_;
			gpointer _tmp67_;
			MusicLocalStaticPlaylist* p = NULL;
			gint64* _tmp68_;
			GdaConnection* _tmp69_;
			MusicLocalStaticPlaylist* _tmp70_;
			GeeTreeSet* _tmp71_;
			MusicLocalStaticPlaylist* _tmp72_;
#line 119 "../src/LocalBackend/LocalLibrary.vala"
			_tmp65_ = _p_id_it;
#line 119 "../src/LocalBackend/LocalLibrary.vala"
			if (!gee_iterator_next (_tmp65_)) {
#line 119 "../src/LocalBackend/LocalLibrary.vala"
				break;
#line 1082 "LocalLibrary.c"
			}
#line 119 "../src/LocalBackend/LocalLibrary.vala"
			_tmp66_ = _p_id_it;
#line 119 "../src/LocalBackend/LocalLibrary.vala"
			_tmp67_ = gee_iterator_get (_tmp66_);
#line 119 "../src/LocalBackend/LocalLibrary.vala"
			p_id = (gint64*) _tmp67_;
#line 120 "../src/LocalBackend/LocalLibrary.vala"
			_tmp68_ = p_id;
#line 120 "../src/LocalBackend/LocalLibrary.vala"
			_tmp69_ = self->priv->_connection;
#line 120 "../src/LocalBackend/LocalLibrary.vala"
			_tmp70_ = music_local_static_playlist_new (*_tmp68_, _tmp69_);
#line 120 "../src/LocalBackend/LocalLibrary.vala"
			p = _tmp70_;
#line 121 "../src/LocalBackend/LocalLibrary.vala"
			_tmp71_ = self->priv->_playlists;
#line 121 "../src/LocalBackend/LocalLibrary.vala"
			_tmp72_ = p;
#line 121 "../src/LocalBackend/LocalLibrary.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp71_, (MusicStaticPlaylist*) _tmp72_);
#line 119 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (p);
#line 119 "../src/LocalBackend/LocalLibrary.vala"
			_g_free0 (p_id);
#line 1108 "LocalLibrary.c"
		}
#line 119 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_p_id_it);
#line 1112 "LocalLibrary.c"
	}
#line 76 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (p_ids);
#line 76 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (sp_ids);
#line 76 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (media_ids);
#line 1120 "LocalLibrary.c"
}

static void
music_local_library_init_database (MusicLocalLibrary* self)
{
	GFile* database_dir = NULL;
	GFile* _tmp0_;
	GFile* db_file = NULL;
	GFile* _tmp4_;
	gboolean new_db = FALSE;
	GFile* _tmp5_;
	GdaConnection* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 128 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = music_file_utils_get_data_directory ();
#line 129 "../src/LocalBackend/LocalLibrary.vala"
	database_dir = _tmp0_;
#line 1140 "LocalLibrary.c"
	{
#line 131 "../src/LocalBackend/LocalLibrary.vala"
		g_file_make_directory_with_parents (database_dir, NULL, &_inner_error0_);
#line 131 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1146 "LocalLibrary.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp1_;
#line 130 "../src/LocalBackend/LocalLibrary.vala"
		err = _inner_error0_;
#line 130 "../src/LocalBackend/LocalLibrary.vala"
		_inner_error0_ = NULL;
#line 133 "../src/LocalBackend/LocalLibrary.vala"
		_tmp1_ = err;
#line 133 "../src/LocalBackend/LocalLibrary.vala"
		if (g_error_matches (_tmp1_, G_IO_ERROR, G_IO_ERROR_EXISTS) == FALSE) {
#line 1163 "LocalLibrary.c"
			GError* _tmp2_;
			const gchar* _tmp3_;
#line 134 "../src/LocalBackend/LocalLibrary.vala"
			_tmp2_ = err;
#line 134 "../src/LocalBackend/LocalLibrary.vala"
			_tmp3_ = _tmp2_->message;
#line 134 "../src/LocalBackend/LocalLibrary.vala"
			g_error ("LocalLibrary.vala:134: Could not create data directory: %s", _tmp3_);
#line 1172 "LocalLibrary.c"
		}
#line 130 "../src/LocalBackend/LocalLibrary.vala"
		_g_error_free0 (err);
#line 1176 "LocalLibrary.c"
	}
	__finally0:
#line 130 "../src/LocalBackend/LocalLibrary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 130 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (database_dir);
#line 130 "../src/LocalBackend/LocalLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 130 "../src/LocalBackend/LocalLibrary.vala"
		g_clear_error (&_inner_error0_);
#line 130 "../src/LocalBackend/LocalLibrary.vala"
		return;
#line 1189 "LocalLibrary.c"
	}
#line 137 "../src/LocalBackend/LocalLibrary.vala"
	_tmp4_ = g_file_get_child (database_dir, MUSIC_LOCAL_LIBRARY_DB_FILE ".db");
#line 137 "../src/LocalBackend/LocalLibrary.vala"
	db_file = _tmp4_;
#line 138 "../src/LocalBackend/LocalLibrary.vala"
	_tmp5_ = db_file;
#line 138 "../src/LocalBackend/LocalLibrary.vala"
	new_db = !g_file_query_exists (_tmp5_, NULL);
#line 139 "../src/LocalBackend/LocalLibrary.vala"
	if (new_db) {
#line 1201 "LocalLibrary.c"
		{
			GFile* _tmp6_;
			GFileOutputStream* _tmp7_;
			GFileOutputStream* _tmp8_;
#line 141 "../src/LocalBackend/LocalLibrary.vala"
			_tmp6_ = db_file;
#line 141 "../src/LocalBackend/LocalLibrary.vala"
			_tmp7_ = g_file_create (_tmp6_, G_FILE_CREATE_PRIVATE, NULL, &_inner_error0_);
#line 141 "../src/LocalBackend/LocalLibrary.vala"
			_tmp8_ = _tmp7_;
#line 141 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (_tmp8_);
#line 141 "../src/LocalBackend/LocalLibrary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1216 "LocalLibrary.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp9_;
			const gchar* _tmp10_;
#line 140 "../src/LocalBackend/LocalLibrary.vala"
			e = _inner_error0_;
#line 140 "../src/LocalBackend/LocalLibrary.vala"
			_inner_error0_ = NULL;
#line 143 "../src/LocalBackend/LocalLibrary.vala"
			_tmp9_ = e;
#line 143 "../src/LocalBackend/LocalLibrary.vala"
			_tmp10_ = _tmp9_->message;
#line 143 "../src/LocalBackend/LocalLibrary.vala"
			g_critical ("LocalLibrary.vala:143: Error: %s", _tmp10_);
#line 140 "../src/LocalBackend/LocalLibrary.vala"
			_g_error_free0 (e);
#line 1238 "LocalLibrary.c"
		}
		__finally1:
#line 140 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 140 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (db_file);
#line 140 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (database_dir);
#line 140 "../src/LocalBackend/LocalLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 140 "../src/LocalBackend/LocalLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 140 "../src/LocalBackend/LocalLibrary.vala"
			return;
#line 1253 "LocalLibrary.c"
		}
	}
	{
		GdaConnection* _tmp11_ = NULL;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GdaConnection* _tmp16_;
		GdaConnection* _tmp17_;
		GdaConnection* _tmp18_;
#line 148 "../src/LocalBackend/LocalLibrary.vala"
		_tmp12_ = g_file_get_path (database_dir);
#line 148 "../src/LocalBackend/LocalLibrary.vala"
		_tmp13_ = _tmp12_;
#line 148 "../src/LocalBackend/LocalLibrary.vala"
		_tmp14_ = g_strdup_printf ("DB_DIR=%s;DB_NAME=%s", _tmp13_, MUSIC_LOCAL_LIBRARY_DB_FILE);
#line 148 "../src/LocalBackend/LocalLibrary.vala"
		_tmp15_ = _tmp14_;
#line 148 "../src/LocalBackend/LocalLibrary.vala"
		_tmp16_ = gda_connection_new_from_string ("SQLite", _tmp15_, NULL, GDA_CONNECTION_OPTIONS_NONE, &_inner_error0_);
#line 148 "../src/LocalBackend/LocalLibrary.vala"
		_tmp17_ = _tmp16_;
#line 148 "../src/LocalBackend/LocalLibrary.vala"
		_g_free0 (_tmp15_);
#line 148 "../src/LocalBackend/LocalLibrary.vala"
		_g_free0 (_tmp13_);
#line 148 "../src/LocalBackend/LocalLibrary.vala"
		_tmp11_ = _tmp17_;
#line 148 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1285 "LocalLibrary.c"
			goto __catch2_g_error;
		}
#line 148 "../src/LocalBackend/LocalLibrary.vala"
		music_local_library_set_connection (self, _tmp11_);
#line 149 "../src/LocalBackend/LocalLibrary.vala"
		_tmp18_ = self->priv->_connection;
#line 149 "../src/LocalBackend/LocalLibrary.vala"
		gda_connection_open (_tmp18_, &_inner_error0_);
#line 149 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 149 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (_tmp11_);
#line 1298 "LocalLibrary.c"
			goto __catch2_g_error;
		}
#line 147 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_tmp11_);
#line 1303 "LocalLibrary.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp19_;
#line 147 "../src/LocalBackend/LocalLibrary.vala"
		e = _inner_error0_;
#line 147 "../src/LocalBackend/LocalLibrary.vala"
		_inner_error0_ = NULL;
#line 151 "../src/LocalBackend/LocalLibrary.vala"
		_tmp19_ = e->message;
#line 151 "../src/LocalBackend/LocalLibrary.vala"
		g_error ("LocalLibrary.vala:151: %s", _tmp19_);
#line 147 "../src/LocalBackend/LocalLibrary.vala"
		_g_error_free0 (e);
#line 1320 "LocalLibrary.c"
	}
	__finally2:
#line 147 "../src/LocalBackend/LocalLibrary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 147 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (db_file);
#line 147 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (database_dir);
#line 147 "../src/LocalBackend/LocalLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 147 "../src/LocalBackend/LocalLibrary.vala"
		g_clear_error (&_inner_error0_);
#line 147 "../src/LocalBackend/LocalLibrary.vala"
		return;
#line 1335 "LocalLibrary.c"
	}
#line 154 "../src/LocalBackend/LocalLibrary.vala"
	_tmp20_ = self->priv->_connection;
#line 154 "../src/LocalBackend/LocalLibrary.vala"
	music_database_create_tables (_tmp20_);
#line 128 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (db_file);
#line 128 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (database_dir);
#line 1345 "LocalLibrary.c"
}

/************ Library/Collection management stuff ************/
gboolean
music_local_library_progress_notification_with_timeout (MusicLocalLibrary* self)
{
	gboolean _tmp4_ = FALSE;
	MusicFileOperator* _tmp5_;
	MusicFileOperator* _tmp6_;
	gboolean result;
#line 158 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 159 "../src/LocalBackend/LocalLibrary.vala"
	if (self->priv->_doing_file_operations) {
#line 1360 "LocalLibrary.c"
		MusicNotificationManager* _tmp0_;
		MusicNotificationManager* _tmp1_;
		MusicFileOperator* _tmp2_;
		MusicFileOperator* _tmp3_;
#line 160 "../src/LocalBackend/LocalLibrary.vala"
		_tmp0_ = music_notification_manager_get_default ();
#line 160 "../src/LocalBackend/LocalLibrary.vala"
		_tmp1_ = _tmp0_;
#line 160 "../src/LocalBackend/LocalLibrary.vala"
		_tmp2_ = self->priv->fo;
#line 160 "../src/LocalBackend/LocalLibrary.vala"
		_tmp3_ = self->priv->fo;
#line 160 "../src/LocalBackend/LocalLibrary.vala"
		g_signal_emit_by_name (_tmp1_, "update-progress", NULL, ((gdouble) _tmp2_->index) / ((gdouble) _tmp3_->item_count));
#line 160 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_tmp1_);
#line 1377 "LocalLibrary.c"
	}
#line 163 "../src/LocalBackend/LocalLibrary.vala"
	_tmp5_ = self->priv->fo;
#line 163 "../src/LocalBackend/LocalLibrary.vala"
	_tmp6_ = self->priv->fo;
#line 163 "../src/LocalBackend/LocalLibrary.vala"
	if (_tmp5_->index < _tmp6_->item_count) {
#line 163 "../src/LocalBackend/LocalLibrary.vala"
		_tmp4_ = self->priv->_doing_file_operations;
#line 1387 "LocalLibrary.c"
	} else {
#line 163 "../src/LocalBackend/LocalLibrary.vala"
		_tmp4_ = FALSE;
#line 1391 "LocalLibrary.c"
	}
#line 163 "../src/LocalBackend/LocalLibrary.vala"
	if (_tmp4_) {
#line 164 "../src/LocalBackend/LocalLibrary.vala"
		result = TRUE;
#line 164 "../src/LocalBackend/LocalLibrary.vala"
		return result;
#line 1399 "LocalLibrary.c"
	}
#line 166 "../src/LocalBackend/LocalLibrary.vala"
	result = FALSE;
#line 166 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 1405 "LocalLibrary.c"
}

static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
#line 170 "../src/LocalBackend/LocalLibrary.vala"
	dup = g_new0 (gint64, 1);
#line 170 "../src/LocalBackend/LocalLibrary.vala"
	memcpy (dup, self, sizeof (gint64));
#line 170 "../src/LocalBackend/LocalLibrary.vala"
	return dup;
#line 1418 "LocalLibrary.c"
}

void
music_local_library_remove_all_static_playlists (MusicLocalLibrary* self)
{
	GeeTreeSet* list = NULL;
	GeeTreeSet* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 169 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_tree_set_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 170 "../src/LocalBackend/LocalLibrary.vala"
	list = _tmp0_;
#line 1433 "LocalLibrary.c"
	{
		GeeTreeSet* _tmp1_;
#line 171 "../src/LocalBackend/LocalLibrary.vala"
		_tmp1_ = self->priv->_playlists;
#line 171 "../src/LocalBackend/LocalLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock__playlists);
#line 1440 "LocalLibrary.c"
		{
			{
				GeeIterator* _p_it = NULL;
				GeeTreeSet* _tmp2_;
				GeeIterator* _tmp3_;
#line 172 "../src/LocalBackend/LocalLibrary.vala"
				_tmp2_ = self->priv->_playlists;
#line 172 "../src/LocalBackend/LocalLibrary.vala"
				_tmp3_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp2_);
#line 172 "../src/LocalBackend/LocalLibrary.vala"
				_p_it = _tmp3_;
#line 172 "../src/LocalBackend/LocalLibrary.vala"
				while (TRUE) {
#line 1454 "LocalLibrary.c"
					GeeIterator* _tmp4_;
					MusicStaticPlaylist* p = NULL;
					GeeIterator* _tmp5_;
					gpointer _tmp6_;
					MusicStaticPlaylist* _tmp7_;
					gboolean _tmp8_;
					gboolean _tmp9_;
#line 172 "../src/LocalBackend/LocalLibrary.vala"
					_tmp4_ = _p_it;
#line 172 "../src/LocalBackend/LocalLibrary.vala"
					if (!gee_iterator_next (_tmp4_)) {
#line 172 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 1468 "LocalLibrary.c"
					}
#line 172 "../src/LocalBackend/LocalLibrary.vala"
					_tmp5_ = _p_it;
#line 172 "../src/LocalBackend/LocalLibrary.vala"
					_tmp6_ = gee_iterator_get (_tmp5_);
#line 172 "../src/LocalBackend/LocalLibrary.vala"
					p = (MusicStaticPlaylist*) _tmp6_;
#line 173 "../src/LocalBackend/LocalLibrary.vala"
					_tmp7_ = p;
#line 173 "../src/LocalBackend/LocalLibrary.vala"
					_tmp8_ = music_static_playlist_get_read_only (_tmp7_);
#line 173 "../src/LocalBackend/LocalLibrary.vala"
					_tmp9_ = _tmp8_;
#line 173 "../src/LocalBackend/LocalLibrary.vala"
					if (_tmp9_ == FALSE) {
#line 1484 "LocalLibrary.c"
						GeeTreeSet* _tmp10_;
						MusicStaticPlaylist* _tmp11_;
						gint64 _tmp12_;
						gint64 _tmp13_;
#line 174 "../src/LocalBackend/LocalLibrary.vala"
						_tmp10_ = list;
#line 174 "../src/LocalBackend/LocalLibrary.vala"
						_tmp11_ = p;
#line 174 "../src/LocalBackend/LocalLibrary.vala"
						_tmp12_ = music_playlist_get_rowid ((MusicPlaylist*) _tmp11_);
#line 174 "../src/LocalBackend/LocalLibrary.vala"
						_tmp13_ = _tmp12_;
#line 174 "../src/LocalBackend/LocalLibrary.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, &_tmp13_);
#line 1499 "LocalLibrary.c"
					}
#line 172 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (p);
#line 1503 "LocalLibrary.c"
				}
#line 172 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_p_it);
#line 1507 "LocalLibrary.c"
			}
		}
		__finally0:
		{
			GeeTreeSet* _tmp14_;
#line 171 "../src/LocalBackend/LocalLibrary.vala"
			_tmp14_ = self->priv->_playlists;
#line 171 "../src/LocalBackend/LocalLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock__playlists);
#line 1517 "LocalLibrary.c"
		}
#line 171 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 171 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (list);
#line 171 "../src/LocalBackend/LocalLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 171 "../src/LocalBackend/LocalLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 171 "../src/LocalBackend/LocalLibrary.vala"
			return;
#line 1529 "LocalLibrary.c"
		}
	}
	{
		GeeIterator* _id_it = NULL;
		GeeTreeSet* _tmp15_;
		GeeIterator* _tmp16_;
#line 178 "../src/LocalBackend/LocalLibrary.vala"
		_tmp15_ = list;
#line 178 "../src/LocalBackend/LocalLibrary.vala"
		_tmp16_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp15_);
#line 178 "../src/LocalBackend/LocalLibrary.vala"
		_id_it = _tmp16_;
#line 178 "../src/LocalBackend/LocalLibrary.vala"
		while (TRUE) {
#line 1544 "LocalLibrary.c"
			GeeIterator* _tmp17_;
			gint64* id = NULL;
			GeeIterator* _tmp18_;
			gpointer _tmp19_;
			gint64* _tmp20_;
#line 178 "../src/LocalBackend/LocalLibrary.vala"
			_tmp17_ = _id_it;
#line 178 "../src/LocalBackend/LocalLibrary.vala"
			if (!gee_iterator_next (_tmp17_)) {
#line 178 "../src/LocalBackend/LocalLibrary.vala"
				break;
#line 1556 "LocalLibrary.c"
			}
#line 178 "../src/LocalBackend/LocalLibrary.vala"
			_tmp18_ = _id_it;
#line 178 "../src/LocalBackend/LocalLibrary.vala"
			_tmp19_ = gee_iterator_get (_tmp18_);
#line 178 "../src/LocalBackend/LocalLibrary.vala"
			id = (gint64*) _tmp19_;
#line 179 "../src/LocalBackend/LocalLibrary.vala"
			_tmp20_ = id;
#line 179 "../src/LocalBackend/LocalLibrary.vala"
			music_library_remove_playlist ((MusicLibrary*) self, *_tmp20_);
#line 178 "../src/LocalBackend/LocalLibrary.vala"
			_g_free0 (id);
#line 1570 "LocalLibrary.c"
		}
#line 178 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_id_it);
#line 1574 "LocalLibrary.c"
	}
#line 169 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (list);
#line 1578 "LocalLibrary.c"
}

static void
music_local_library_set_music_folder_data_free (gpointer _data)
{
	MusicLocalLibrarySetMusicFolderData* _data_;
	_data_ = _data;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_g_free0 (_data_->folder);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_data_->self);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_slice_free (MusicLocalLibrarySetMusicFolderData, _data_);
#line 1592 "LocalLibrary.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	return self ? g_object_ref (self) : NULL;
#line 1600 "LocalLibrary.c"
}

void
music_local_library_set_music_folder (MusicLocalLibrary* self,
                                      const gchar* folder,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	MusicLocalLibrarySetMusicFolderData* _data_;
	MusicLocalLibrary* _tmp0_;
	gchar* _tmp1_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (folder != NULL);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_ = g_slice_new0 (MusicLocalLibrarySetMusicFolderData);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_local_library_set_music_folder_data_free);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_->self = _tmp0_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = g_strdup (folder);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_g_free0 (_data_->folder);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_->folder = _tmp1_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	music_local_library_set_music_folder_co (_data_);
#line 1634 "LocalLibrary.c"
}

void
music_local_library_set_music_folder_finish (MusicLocalLibrary* self,
                                             GAsyncResult* _res_)
{
	MusicLocalLibrarySetMusicFolderData* _data_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1644 "LocalLibrary.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1666 "LocalLibrary.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1670 "LocalLibrary.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1676 "LocalLibrary.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1680 "LocalLibrary.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1684 "LocalLibrary.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 1692 "LocalLibrary.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1720 "LocalLibrary.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 1729 "LocalLibrary.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1743 "LocalLibrary.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 1752 "LocalLibrary.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 1766 "LocalLibrary.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1775 "LocalLibrary.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 1784 "LocalLibrary.c"
}

static gboolean
music_local_library_set_music_folder_co (MusicLocalLibrarySetMusicFolderData* _data_)
{
#line 183 "../src/LocalBackend/LocalLibrary.vala"
	switch (_data_->_state_) {
#line 183 "../src/LocalBackend/LocalLibrary.vala"
		case 0:
#line 1794 "LocalLibrary.c"
		goto _state_0;
		default:
#line 183 "../src/LocalBackend/LocalLibrary.vala"
		g_assert_not_reached ();
#line 1799 "LocalLibrary.c"
	}
	_state_0:
#line 184 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp0_ = g_strdup (_data_->folder);
#line 184 "../src/LocalBackend/LocalLibrary.vala"
	_data_->m_folder = _data_->_tmp0_;
#line 185 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp1_ = _data_->m_folder;
#line 185 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp2_ = string_replace (_data_->_tmp1_, "/media", "");
#line 185 "../src/LocalBackend/LocalLibrary.vala"
	_g_free0 (_data_->m_folder);
#line 185 "../src/LocalBackend/LocalLibrary.vala"
	_data_->m_folder = _data_->_tmp2_;
#line 186 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp3_ = _data_->m_folder;
#line 186 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp4_ = g_get_home_dir ();
#line 186 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp5_ = g_strconcat (_data_->_tmp4_, "/", NULL);
#line 186 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 186 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp7_ = string_replace (_data_->_tmp3_, _data_->_tmp6_, "");
#line 186 "../src/LocalBackend/LocalLibrary.vala"
	_g_free0 (_data_->m_folder);
#line 186 "../src/LocalBackend/LocalLibrary.vala"
	_data_->m_folder = _data_->_tmp7_;
#line 186 "../src/LocalBackend/LocalLibrary.vala"
	_g_free0 (_data_->_tmp6_);
#line 188 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp8_ = _data_->m_folder;
#line 188 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp9_ = g_markup_escape_text (_data_->_tmp8_, (gssize) -1);
#line 188 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 188 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp11_ = g_strconcat ("<b>", _data_->_tmp10_, NULL);
#line 188 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 188 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp13_ = g_strconcat (_data_->_tmp12_, "</b>", NULL);
#line 188 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 188 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp15_ = g_strdup_printf (_ ("Importing music from %s…"), _data_->_tmp14_);
#line 188 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 188 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp17_ = music_library_start_file_operations ((MusicLibrary*) _data_->self, _data_->_tmp16_);
#line 188 "../src/LocalBackend/LocalLibrary.vala"
	_g_free0 (_data_->_tmp16_);
#line 188 "../src/LocalBackend/LocalLibrary.vala"
	_g_free0 (_data_->_tmp14_);
#line 188 "../src/LocalBackend/LocalLibrary.vala"
	_g_free0 (_data_->_tmp12_);
#line 188 "../src/LocalBackend/LocalLibrary.vala"
	_g_free0 (_data_->_tmp10_);
#line 188 "../src/LocalBackend/LocalLibrary.vala"
	if (_data_->_tmp17_) {
#line 190 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp18_ = music_settings_main_get_default ();
#line 190 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 190 "../src/LocalBackend/LocalLibrary.vala"
		music_settings_main_set_music_folder (_data_->_tmp19_, _data_->folder);
#line 190 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_data_->_tmp19_);
#line 192 "../src/LocalBackend/LocalLibrary.vala"
		music_local_library_remove_all_static_playlists (_data_->self);
#line 194 "../src/LocalBackend/LocalLibrary.vala"
		music_local_library_clear_medias (_data_->self);
#line 196 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp20_ = music_app_get_player ();
#line 196 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp21_ = _data_->_tmp20_;
#line 196 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp22_ = _data_->self->priv->_medias;
#line 196 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp23_ = gee_abstract_map_get_values ((GeeAbstractMap*) _data_->_tmp22_);
#line 196 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp24_ = _data_->_tmp23_;
#line 196 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp25_ = _data_->_tmp24_;
#line 196 "../src/LocalBackend/LocalLibrary.vala"
		music_playback_manager_unqueue_media (_data_->_tmp21_, _data_->_tmp25_);
#line 196 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_data_->_tmp25_);
#line 199 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp26_ = music_app_get_main_window ();
#line 199 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp27_ = _data_->_tmp26_;
#line 199 "../src/LocalBackend/LocalLibrary.vala"
		music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) _data_->_tmp27_, NULL, NULL);
#line 200 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp28_ = music_app_get_player ();
#line 200 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp29_ = _data_->_tmp28_;
#line 200 "../src/LocalBackend/LocalLibrary.vala"
		music_playback_manager_stop_playback (_data_->_tmp29_);
#line 202 "../src/LocalBackend/LocalLibrary.vala"
		music_local_library_set_music_folder_thread (_data_->self, _data_->folder, NULL, NULL);
#line 1902 "LocalLibrary.c"
	}
#line 183 "../src/LocalBackend/LocalLibrary.vala"
	_g_free0 (_data_->m_folder);
#line 183 "../src/LocalBackend/LocalLibrary.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 183 "../src/LocalBackend/LocalLibrary.vala"
	if (_data_->_state_ != 0) {
#line 183 "../src/LocalBackend/LocalLibrary.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 183 "../src/LocalBackend/LocalLibrary.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1914 "LocalLibrary.c"
		}
	}
#line 183 "../src/LocalBackend/LocalLibrary.vala"
	g_object_unref (_data_->_async_result);
#line 183 "../src/LocalBackend/LocalLibrary.vala"
	return FALSE;
#line 1921 "LocalLibrary.c"
}

static void
music_local_library_set_music_folder_thread_data_free (gpointer _data)
{
	MusicLocalLibrarySetMusicFolderThreadData* _data_;
	_data_ = _data;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_g_free0 (_data_->folder);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_data_->self);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_slice_free (MusicLocalLibrarySetMusicFolderThreadData, _data_);
#line 1935 "LocalLibrary.c"
}

static void
music_local_library_set_music_folder_thread (MusicLocalLibrary* self,
                                             const gchar* folder,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	MusicLocalLibrarySetMusicFolderThreadData* _data_;
	MusicLocalLibrary* _tmp0_;
	gchar* _tmp1_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (folder != NULL);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_ = g_slice_new0 (MusicLocalLibrarySetMusicFolderThreadData);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_local_library_set_music_folder_thread_data_free);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_->self = _tmp0_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = g_strdup (folder);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_g_free0 (_data_->folder);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_->folder = _tmp1_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	music_local_library_set_music_folder_thread_co (_data_);
#line 1969 "LocalLibrary.c"
}

static void
music_local_library_set_music_folder_thread_finish (MusicLocalLibrary* self,
                                                    GAsyncResult* _res_)
{
	MusicLocalLibrarySetMusicFolderThreadData* _data_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1979 "LocalLibrary.c"
}

static gboolean
music_local_library_set_music_folder_thread_co (MusicLocalLibrarySetMusicFolderThreadData* _data_)
{
#line 206 "../src/LocalBackend/LocalLibrary.vala"
	switch (_data_->_state_) {
#line 206 "../src/LocalBackend/LocalLibrary.vala"
		case 0:
#line 1989 "LocalLibrary.c"
		goto _state_0;
		default:
#line 206 "../src/LocalBackend/LocalLibrary.vala"
		g_assert_not_reached ();
#line 1994 "LocalLibrary.c"
	}
	_state_0:
#line 207 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp0_ = g_file_new_for_path (_data_->folder);
#line 207 "../src/LocalBackend/LocalLibrary.vala"
	_data_->music_folder_file = _data_->_tmp0_;
#line 208 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp1_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 208 "../src/LocalBackend/LocalLibrary.vala"
	_data_->files = _data_->_tmp1_;
#line 209 "../src/LocalBackend/LocalLibrary.vala"
	_data_->items = music_file_utils_count_music_files (_data_->music_folder_file, (GeeCollection*) _data_->files);
#line 210 "../src/LocalBackend/LocalLibrary.vala"
	g_debug ("LocalLibrary.vala:210: Found %d items to import in %s\n", _data_->items, _data_->folder);
#line 211 "../src/LocalBackend/LocalLibrary.vala"
	music_local_library_import_files (_data_->self, _data_->files, MUSIC_FILE_OPERATOR_IMPORT_TYPE_SET);
#line 206 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_data_->files);
#line 206 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_data_->music_folder_file);
#line 206 "../src/LocalBackend/LocalLibrary.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 206 "../src/LocalBackend/LocalLibrary.vala"
	if (_data_->_state_ != 0) {
#line 206 "../src/LocalBackend/LocalLibrary.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 206 "../src/LocalBackend/LocalLibrary.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2023 "LocalLibrary.c"
		}
	}
#line 206 "../src/LocalBackend/LocalLibrary.vala"
	g_object_unref (_data_->_async_result);
#line 206 "../src/LocalBackend/LocalLibrary.vala"
	return FALSE;
#line 2030 "LocalLibrary.c"
}

static void
music_local_library_real_add_files_to_library (MusicLibrary* base,
                                               GeeCollection* files)
{
	MusicLocalLibrary * self;
#line 214 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 214 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (files != NULL);
#line 215 "../src/LocalBackend/LocalLibrary.vala"
	if (music_library_start_file_operations ((MusicLibrary*) self, _ ("Adding files to library…"))) {
#line 216 "../src/LocalBackend/LocalLibrary.vala"
		music_local_library_add_files_to_library_async (self, files, NULL, NULL);
#line 2046 "LocalLibrary.c"
	}
}

static void
music_local_library_add_files_to_library_async_data_free (gpointer _data)
{
	MusicLocalLibraryAddFilesToLibraryAsyncData* _data_;
	_data_ = _data;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_data_->files);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_data_->self);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_slice_free (MusicLocalLibraryAddFilesToLibraryAsyncData, _data_);
#line 2061 "LocalLibrary.c"
}

static void
music_local_library_add_files_to_library_async (MusicLocalLibrary* self,
                                                GeeCollection* files,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	MusicLocalLibraryAddFilesToLibraryAsyncData* _data_;
	MusicLocalLibrary* _tmp0_;
	GeeCollection* _tmp1_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (files != NULL);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_ = g_slice_new0 (MusicLocalLibraryAddFilesToLibraryAsyncData);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_local_library_add_files_to_library_async_data_free);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_->self = _tmp0_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = _g_object_ref0 (files);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_data_->files);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_->files = _tmp1_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	music_local_library_add_files_to_library_async_co (_data_);
#line 2095 "LocalLibrary.c"
}

static void
music_local_library_add_files_to_library_finish (MusicLocalLibrary* self,
                                                 GAsyncResult* _res_)
{
	MusicLocalLibraryAddFilesToLibraryAsyncData* _data_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2105 "LocalLibrary.c"
}

static gboolean
music_local_library_add_files_to_library_async_co (MusicLocalLibraryAddFilesToLibraryAsyncData* _data_)
{
#line 220 "../src/LocalBackend/LocalLibrary.vala"
	switch (_data_->_state_) {
#line 220 "../src/LocalBackend/LocalLibrary.vala"
		case 0:
#line 2115 "LocalLibrary.c"
		goto _state_0;
		default:
#line 220 "../src/LocalBackend/LocalLibrary.vala"
		g_assert_not_reached ();
#line 2120 "LocalLibrary.c"
	}
	_state_0:
#line 221 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp0_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 221 "../src/LocalBackend/LocalLibrary.vala"
	_data_->to_import = _data_->_tmp0_;
#line 222 "../src/LocalBackend/LocalLibrary.vala"
	gee_collection_add_all ((GeeCollection*) _data_->to_import, _data_->files);
#line 223 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->to_import);
#line 223 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 223 "../src/LocalBackend/LocalLibrary.vala"
	g_debug ("LocalLibrary.vala:223: Found %d items to import\n", _data_->_tmp2_);
#line 224 "../src/LocalBackend/LocalLibrary.vala"
	music_local_library_import_files (_data_->self, _data_->to_import, MUSIC_FILE_OPERATOR_IMPORT_TYPE_IMPORT);
#line 220 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_data_->to_import);
#line 220 "../src/LocalBackend/LocalLibrary.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 220 "../src/LocalBackend/LocalLibrary.vala"
	if (_data_->_state_ != 0) {
#line 220 "../src/LocalBackend/LocalLibrary.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 220 "../src/LocalBackend/LocalLibrary.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2147 "LocalLibrary.c"
		}
	}
#line 220 "../src/LocalBackend/LocalLibrary.vala"
	g_object_unref (_data_->_async_result);
#line 220 "../src/LocalBackend/LocalLibrary.vala"
	return FALSE;
#line 2154 "LocalLibrary.c"
}

void
music_local_library_add_folder_to_library (MusicLocalLibrary* self,
                                           GeeCollection* folders)
{
#line 227 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (self != NULL);
#line 227 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (folders != NULL);
#line 228 "../src/LocalBackend/LocalLibrary.vala"
	if (music_library_start_file_operations ((MusicLibrary*) self, _ ("<b>Importing</b> music to library…"))) {
#line 229 "../src/LocalBackend/LocalLibrary.vala"
		music_local_library_add_folder_to_library_async (self, folders, NULL, NULL);
#line 2169 "LocalLibrary.c"
	}
}

static void
music_local_library_add_folder_to_library_async_data_free (gpointer _data)
{
	MusicLocalLibraryAddFolderToLibraryAsyncData* _data_;
	_data_ = _data;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_data_->folders);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_data_->self);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_slice_free (MusicLocalLibraryAddFolderToLibraryAsyncData, _data_);
#line 2184 "LocalLibrary.c"
}

static void
music_local_library_add_folder_to_library_async (MusicLocalLibrary* self,
                                                 GeeCollection* folders,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	MusicLocalLibraryAddFolderToLibraryAsyncData* _data_;
	MusicLocalLibrary* _tmp0_;
	GeeCollection* _tmp1_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (folders != NULL);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_ = g_slice_new0 (MusicLocalLibraryAddFolderToLibraryAsyncData);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_local_library_add_folder_to_library_async_data_free);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_->self = _tmp0_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = _g_object_ref0 (folders);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_data_->folders);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_->folders = _tmp1_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	music_local_library_add_folder_to_library_async_co (_data_);
#line 2218 "LocalLibrary.c"
}

static void
music_local_library_add_folder_to_library_finish (MusicLocalLibrary* self,
                                                  GAsyncResult* _res_)
{
	MusicLocalLibraryAddFolderToLibraryAsyncData* _data_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2228 "LocalLibrary.c"
}

static gboolean
music_local_library_add_folder_to_library_async_co (MusicLocalLibraryAddFolderToLibraryAsyncData* _data_)
{
#line 233 "../src/LocalBackend/LocalLibrary.vala"
	switch (_data_->_state_) {
#line 233 "../src/LocalBackend/LocalLibrary.vala"
		case 0:
#line 2238 "LocalLibrary.c"
		goto _state_0;
		default:
#line 233 "../src/LocalBackend/LocalLibrary.vala"
		g_assert_not_reached ();
#line 2243 "LocalLibrary.c"
	}
	_state_0:
#line 234 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp0_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 234 "../src/LocalBackend/LocalLibrary.vala"
	_data_->files = _data_->_tmp0_;
#line 2250 "LocalLibrary.c"
	{
#line 235 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp1_ = gee_iterable_iterator ((GeeIterable*) _data_->folders);
#line 235 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_folder_it = _data_->_tmp1_;
#line 235 "../src/LocalBackend/LocalLibrary.vala"
		while (TRUE) {
#line 235 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp2_ = _data_->_folder_it;
#line 235 "../src/LocalBackend/LocalLibrary.vala"
			if (!gee_iterator_next (_data_->_tmp2_)) {
#line 235 "../src/LocalBackend/LocalLibrary.vala"
				break;
#line 2264 "LocalLibrary.c"
			}
#line 235 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp3_ = _data_->_folder_it;
#line 235 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp4_ = gee_iterator_get (_data_->_tmp3_);
#line 235 "../src/LocalBackend/LocalLibrary.vala"
			_data_->folder = (gchar*) _data_->_tmp4_;
#line 236 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp5_ = _data_->folder;
#line 236 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp6_ = g_file_new_for_path (_data_->_tmp5_);
#line 236 "../src/LocalBackend/LocalLibrary.vala"
			_data_->file = _data_->_tmp6_;
#line 237 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp7_ = _data_->file;
#line 237 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp8_ = _data_->files;
#line 237 "../src/LocalBackend/LocalLibrary.vala"
			music_file_utils_count_music_files (_data_->_tmp7_, (GeeCollection*) _data_->_tmp8_);
#line 235 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (_data_->file);
#line 235 "../src/LocalBackend/LocalLibrary.vala"
			_g_free0 (_data_->folder);
#line 2288 "LocalLibrary.c"
		}
#line 235 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_data_->_folder_it);
#line 2292 "LocalLibrary.c"
	}
	{
#line 240 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp9_ = music_library_get_medias ((MusicLibrary*) _data_->self);
#line 240 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 240 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp11_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp10_);
#line 240 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 240 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_data_->_tmp10_);
#line 240 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_m_it = _data_->_tmp12_;
#line 240 "../src/LocalBackend/LocalLibrary.vala"
		while (TRUE) {
#line 240 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp13_ = _data_->_m_it;
#line 240 "../src/LocalBackend/LocalLibrary.vala"
			if (!gee_iterator_next (_data_->_tmp13_)) {
#line 240 "../src/LocalBackend/LocalLibrary.vala"
				break;
#line 2315 "LocalLibrary.c"
			}
#line 240 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp14_ = _data_->_m_it;
#line 240 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp15_ = gee_iterator_get (_data_->_tmp14_);
#line 240 "../src/LocalBackend/LocalLibrary.vala"
			_data_->m = (MusicMedia*) _data_->_tmp15_;
#line 241 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp16_ = _data_->files;
#line 241 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp17_ = _data_->m;
#line 241 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp18_ = music_media_get_uri (_data_->_tmp17_);
#line 241 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp19_ = _data_->_tmp18_;
#line 241 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp20_ = _data_->_tmp19_;
#line 241 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp21_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _data_->_tmp16_, _data_->_tmp20_);
#line 241 "../src/LocalBackend/LocalLibrary.vala"
			_g_free0 (_data_->_tmp20_);
#line 241 "../src/LocalBackend/LocalLibrary.vala"
			if (_data_->_tmp21_) {
#line 242 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp22_ = _data_->files;
#line 242 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp23_ = _data_->m;
#line 242 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp24_ = music_media_get_uri (_data_->_tmp23_);
#line 242 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp25_ = _data_->_tmp24_;
#line 242 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp26_ = _data_->_tmp25_;
#line 242 "../src/LocalBackend/LocalLibrary.vala"
				gee_abstract_collection_remove ((GeeAbstractCollection*) _data_->_tmp22_, _data_->_tmp26_);
#line 242 "../src/LocalBackend/LocalLibrary.vala"
				_g_free0 (_data_->_tmp26_);
#line 2353 "LocalLibrary.c"
			}
#line 240 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (_data_->m);
#line 2357 "LocalLibrary.c"
		}
#line 240 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_data_->_m_it);
#line 2361 "LocalLibrary.c"
	}
#line 245 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp27_ = _data_->files;
#line 245 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp28_ = gee_collection_get_is_empty ((GeeCollection*) _data_->_tmp27_);
#line 245 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp29_ = _data_->_tmp28_;
#line 245 "../src/LocalBackend/LocalLibrary.vala"
	if (!_data_->_tmp29_) {
#line 246 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp30_ = _data_->files;
#line 246 "../src/LocalBackend/LocalLibrary.vala"
		music_local_library_import_files (_data_->self, _data_->_tmp30_, MUSIC_FILE_OPERATOR_IMPORT_TYPE_IMPORT);
#line 2375 "LocalLibrary.c"
	} else {
#line 248 "../src/LocalBackend/LocalLibrary.vala"
		g_debug ("LocalLibrary.vala:248: No new songs to import.\n");
#line 249 "../src/LocalBackend/LocalLibrary.vala"
		music_library_finish_file_operations ((MusicLibrary*) _data_->self);
#line 250 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp31_ = music_app_get_main_window ();
#line 250 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp32_ = _data_->_tmp31_;
#line 250 "../src/LocalBackend/LocalLibrary.vala"
		music_library_window_show_notification (_data_->_tmp32_, _ ("All music files are already in your library"), _ ("No files were imported."), NULL, G_NOTIFICATION_PRIORITY_LOW, "music");
#line 2387 "LocalLibrary.c"
	}
#line 233 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_data_->files);
#line 233 "../src/LocalBackend/LocalLibrary.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 233 "../src/LocalBackend/LocalLibrary.vala"
	if (_data_->_state_ != 0) {
#line 233 "../src/LocalBackend/LocalLibrary.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 233 "../src/LocalBackend/LocalLibrary.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2399 "LocalLibrary.c"
		}
	}
#line 233 "../src/LocalBackend/LocalLibrary.vala"
	g_object_unref (_data_->_async_result);
#line 233 "../src/LocalBackend/LocalLibrary.vala"
	return FALSE;
#line 2406 "LocalLibrary.c"
}

void
music_local_library_rescan_music_folder (MusicLocalLibrary* self)
{
#line 254 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (self != NULL);
#line 255 "../src/LocalBackend/LocalLibrary.vala"
	if (music_library_start_file_operations ((MusicLibrary*) self, _ ("Rescanning music for changes. This may take a while…"))) {
#line 2416 "LocalLibrary.c"
		MusicLibraryWindow* _tmp0_;
		MusicLibraryWindow* _tmp1_;
#line 256 "../src/LocalBackend/LocalLibrary.vala"
		_tmp0_ = music_app_get_main_window ();
#line 256 "../src/LocalBackend/LocalLibrary.vala"
		_tmp1_ = _tmp0_;
#line 256 "../src/LocalBackend/LocalLibrary.vala"
		music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) _tmp1_, NULL, NULL);
#line 257 "../src/LocalBackend/LocalLibrary.vala"
		music_local_library_rescan_music_folder_async (self, NULL, NULL);
#line 2427 "LocalLibrary.c"
	}
}

static void
music_local_library_rescan_music_folder_async_data_free (gpointer _data)
{
	MusicLocalLibraryRescanMusicFolderAsyncData* _data_;
	_data_ = _data;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_data_->self);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_slice_free (MusicLocalLibraryRescanMusicFolderAsyncData, _data_);
#line 2440 "LocalLibrary.c"
}

static void
music_local_library_rescan_music_folder_async (MusicLocalLibrary* self,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	MusicLocalLibraryRescanMusicFolderAsyncData* _data_;
	MusicLocalLibrary* _tmp0_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_ = g_slice_new0 (MusicLocalLibraryRescanMusicFolderAsyncData);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_local_library_rescan_music_folder_async_data_free);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_->self = _tmp0_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	music_local_library_rescan_music_folder_async_co (_data_);
#line 2464 "LocalLibrary.c"
}

static void
music_local_library_rescan_music_folder_finish (MusicLocalLibrary* self,
                                                GAsyncResult* _res_)
{
	MusicLocalLibraryRescanMusicFolderAsyncData* _data_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2474 "LocalLibrary.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 2493 "LocalLibrary.c"
}

static gboolean
music_local_library_rescan_music_folder_async_co (MusicLocalLibraryRescanMusicFolderAsyncData* _data_)
{
#line 261 "../src/LocalBackend/LocalLibrary.vala"
	switch (_data_->_state_) {
#line 261 "../src/LocalBackend/LocalLibrary.vala"
		case 0:
#line 2503 "LocalLibrary.c"
		goto _state_0;
		default:
#line 261 "../src/LocalBackend/LocalLibrary.vala"
		g_assert_not_reached ();
#line 2508 "LocalLibrary.c"
	}
	_state_0:
#line 262 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 262 "../src/LocalBackend/LocalLibrary.vala"
	_data_->to_remove = _data_->_tmp0_;
#line 263 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp1_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 263 "../src/LocalBackend/LocalLibrary.vala"
	_data_->files = _data_->_tmp1_;
#line 265 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp2_ = music_settings_main_get_default ();
#line 265 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 265 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp4_ = music_settings_main_get_music_folder (_data_->_tmp3_);
#line 265 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 265 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp6_ = g_strdup (_data_->_tmp5_);
#line 265 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 265 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_data_->_tmp3_);
#line 265 "../src/LocalBackend/LocalLibrary.vala"
	_data_->music_folder_dir = _data_->_tmp7_;
#line 266 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp8_ = _data_->music_folder_dir;
#line 266 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp9_ = g_file_new_for_path (_data_->_tmp8_);
#line 266 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 266 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp11_ = _data_->files;
#line 266 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp12_ = music_file_utils_count_music_files (_data_->_tmp10_, (GeeCollection*) _data_->_tmp11_);
#line 266 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_data_->_tmp10_);
#line 266 "../src/LocalBackend/LocalLibrary.vala"
	_data_->num_items = _data_->_tmp12_;
#line 267 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp13_ = _data_->music_folder_dir;
#line 267 "../src/LocalBackend/LocalLibrary.vala"
	g_debug ("LocalLibrary.vala:267: Found %d items to import in %s\n", _data_->num_items, _data_->_tmp13_);
#line 2553 "LocalLibrary.c"
	{
#line 269 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp14_ = music_library_get_medias ((MusicLibrary*) _data_->self);
#line 269 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 269 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp16_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp15_);
#line 269 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 269 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_data_->_tmp15_);
#line 269 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_m_it = _data_->_tmp17_;
#line 269 "../src/LocalBackend/LocalLibrary.vala"
		while (TRUE) {
#line 269 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp18_ = _data_->_m_it;
#line 269 "../src/LocalBackend/LocalLibrary.vala"
			if (!gee_iterator_next (_data_->_tmp18_)) {
#line 269 "../src/LocalBackend/LocalLibrary.vala"
				break;
#line 2575 "LocalLibrary.c"
			}
#line 269 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp19_ = _data_->_m_it;
#line 269 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp20_ = gee_iterator_get (_data_->_tmp19_);
#line 269 "../src/LocalBackend/LocalLibrary.vala"
			_data_->m = (MusicMedia*) _data_->_tmp20_;
#line 270 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp23_ = _data_->m;
#line 270 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp24_ = music_media_get_is_temporary (_data_->_tmp23_);
#line 270 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp25_ = _data_->_tmp24_;
#line 270 "../src/LocalBackend/LocalLibrary.vala"
			if (!_data_->_tmp25_) {
#line 270 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp26_ = _data_->m;
#line 270 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp27_ = music_media_get_is_preview (_data_->_tmp26_);
#line 270 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp28_ = _data_->_tmp27_;
#line 270 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp22_ = !_data_->_tmp28_;
#line 2599 "LocalLibrary.c"
			} else {
#line 270 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp22_ = FALSE;
#line 2603 "LocalLibrary.c"
			}
#line 270 "../src/LocalBackend/LocalLibrary.vala"
			if (_data_->_tmp22_) {
#line 270 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp29_ = _data_->m;
#line 270 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp30_ = music_media_get_uri (_data_->_tmp29_);
#line 270 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp31_ = _data_->_tmp30_;
#line 270 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp32_ = _data_->_tmp31_;
#line 270 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp33_ = _data_->music_folder_dir;
#line 270 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp21_ = string_contains (_data_->_tmp32_, _data_->_tmp33_);
#line 270 "../src/LocalBackend/LocalLibrary.vala"
				_g_free0 (_data_->_tmp32_);
#line 2621 "LocalLibrary.c"
			} else {
#line 270 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp21_ = FALSE;
#line 2625 "LocalLibrary.c"
			}
#line 270 "../src/LocalBackend/LocalLibrary.vala"
			if (_data_->_tmp21_) {
#line 271 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp34_ = _data_->m;
#line 271 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp35_ = music_media_get_uri (_data_->_tmp34_);
#line 271 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp36_ = _data_->_tmp35_;
#line 271 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp37_ = _data_->_tmp36_;
#line 271 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp38_ = g_file_new_for_uri (_data_->_tmp37_);
#line 271 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp39_ = _data_->_tmp38_;
#line 271 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp40_ = !g_file_query_exists (_data_->_tmp39_, NULL);
#line 271 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_data_->_tmp39_);
#line 271 "../src/LocalBackend/LocalLibrary.vala"
				_g_free0 (_data_->_tmp37_);
#line 271 "../src/LocalBackend/LocalLibrary.vala"
				if (_data_->_tmp40_) {
#line 272 "../src/LocalBackend/LocalLibrary.vala"
					_data_->_tmp41_ = _data_->to_remove;
#line 272 "../src/LocalBackend/LocalLibrary.vala"
					_data_->_tmp42_ = _data_->m;
#line 272 "../src/LocalBackend/LocalLibrary.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp41_, _data_->_tmp42_);
#line 2655 "LocalLibrary.c"
				}
#line 275 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp43_ = _data_->files;
#line 275 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp44_ = _data_->m;
#line 275 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp45_ = music_media_get_uri (_data_->_tmp44_);
#line 275 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp46_ = _data_->_tmp45_;
#line 275 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp47_ = _data_->_tmp46_;
#line 275 "../src/LocalBackend/LocalLibrary.vala"
				_data_->_tmp48_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _data_->_tmp43_, _data_->_tmp47_);
#line 275 "../src/LocalBackend/LocalLibrary.vala"
				_g_free0 (_data_->_tmp47_);
#line 275 "../src/LocalBackend/LocalLibrary.vala"
				if (_data_->_tmp48_) {
#line 276 "../src/LocalBackend/LocalLibrary.vala"
					_data_->_tmp49_ = _data_->files;
#line 276 "../src/LocalBackend/LocalLibrary.vala"
					_data_->_tmp50_ = _data_->m;
#line 276 "../src/LocalBackend/LocalLibrary.vala"
					_data_->_tmp51_ = music_media_get_uri (_data_->_tmp50_);
#line 276 "../src/LocalBackend/LocalLibrary.vala"
					_data_->_tmp52_ = _data_->_tmp51_;
#line 276 "../src/LocalBackend/LocalLibrary.vala"
					_data_->_tmp53_ = _data_->_tmp52_;
#line 276 "../src/LocalBackend/LocalLibrary.vala"
					gee_abstract_collection_remove ((GeeAbstractCollection*) _data_->_tmp49_, _data_->_tmp53_);
#line 276 "../src/LocalBackend/LocalLibrary.vala"
					_g_free0 (_data_->_tmp53_);
#line 2687 "LocalLibrary.c"
				}
			}
#line 269 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (_data_->m);
#line 2692 "LocalLibrary.c"
		}
#line 269 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_data_->_m_it);
#line 2696 "LocalLibrary.c"
	}
#line 282 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp54_ = _data_->files;
#line 282 "../src/LocalBackend/LocalLibrary.vala"
	music_local_library_import_files (_data_->self, _data_->_tmp54_, MUSIC_FILE_OPERATOR_IMPORT_TYPE_RESCAN);
#line 284 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp55_ = _data_->self->priv->fo;
#line 284 "../src/LocalBackend/LocalLibrary.vala"
	_data_->_tmp56_ = _data_->_tmp55_->cancellable;
#line 284 "../src/LocalBackend/LocalLibrary.vala"
	if (!g_cancellable_is_cancelled (_data_->_tmp56_)) {
#line 285 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp57_ = _data_->to_remove;
#line 285 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp58_ = gee_collection_get_is_empty ((GeeCollection*) _data_->_tmp57_);
#line 285 "../src/LocalBackend/LocalLibrary.vala"
		_data_->_tmp59_ = _data_->_tmp58_;
#line 285 "../src/LocalBackend/LocalLibrary.vala"
		if (!_data_->_tmp59_) {
#line 286 "../src/LocalBackend/LocalLibrary.vala"
			_data_->_tmp60_ = _data_->to_remove;
#line 286 "../src/LocalBackend/LocalLibrary.vala"
			music_library_remove_medias ((MusicLibrary*) _data_->self, (GeeCollection*) _data_->_tmp60_, FALSE);
#line 2720 "LocalLibrary.c"
		}
	}
#line 261 "../src/LocalBackend/LocalLibrary.vala"
	_g_free0 (_data_->music_folder_dir);
#line 261 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_data_->files);
#line 261 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_data_->to_remove);
#line 261 "../src/LocalBackend/LocalLibrary.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 261 "../src/LocalBackend/LocalLibrary.vala"
	if (_data_->_state_ != 0) {
#line 261 "../src/LocalBackend/LocalLibrary.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 261 "../src/LocalBackend/LocalLibrary.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2737 "LocalLibrary.c"
		}
	}
#line 261 "../src/LocalBackend/LocalLibrary.vala"
	g_object_unref (_data_->_async_result);
#line 261 "../src/LocalBackend/LocalLibrary.vala"
	return FALSE;
#line 2744 "LocalLibrary.c"
}

static void
_music_local_library_media_opened_imported_music_gstreamer_tagger_media_imported (MusicGStreamerTagger* _sender,
                                                                                  MusicMedia* m,
                                                                                  gpointer self)
{
#line 292 "../src/LocalBackend/LocalLibrary.vala"
	music_local_library_media_opened_imported ((MusicLocalLibrary*) self, m);
#line 2754 "LocalLibrary.c"
}

static void
_music_local_library_media_opened_finished_music_gstreamer_tagger_queue_finished (MusicGStreamerTagger* _sender,
                                                                                  gpointer self)
{
#line 293 "../src/LocalBackend/LocalLibrary.vala"
	music_local_library_media_opened_finished ((MusicLocalLibrary*) self);
#line 2763 "LocalLibrary.c"
}

void
music_local_library_play_files (MusicLocalLibrary* self,
                                GFile** files,
                                gint files_length1)
{
	MusicGStreamerTagger* _tmp0_;
	MusicGStreamerTagger* _tmp1_;
	GeeTreeSet* files_list = NULL;
	GeeTreeSet* _tmp2_;
	GeeCollection* found = NULL;
	GeeTreeSet* _tmp8_;
	GeeCollection* _tmp9_;
	GeeTreeSet* _tmp20_;
	GeeCollection* _tmp21_;
	GeeTreeSet* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
#line 291 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (self != NULL);
#line 292 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = self->priv->tagger;
#line 292 "../src/LocalBackend/LocalLibrary.vala"
	g_signal_connect_object (_tmp0_, "media-imported", (GCallback) _music_local_library_media_opened_imported_music_gstreamer_tagger_media_imported, self, 0);
#line 293 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = self->priv->tagger;
#line 293 "../src/LocalBackend/LocalLibrary.vala"
	g_signal_connect_object (_tmp1_, "queue-finished", (GCallback) _music_local_library_media_opened_finished_music_gstreamer_tagger_queue_finished, self, 0);
#line 294 "../src/LocalBackend/LocalLibrary.vala"
	_tmp2_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 294 "../src/LocalBackend/LocalLibrary.vala"
	files_list = _tmp2_;
#line 2797 "LocalLibrary.c"
	{
		GFile** file_collection = NULL;
		gint file_collection_length1 = 0;
		gint _file_collection_size_ = 0;
		gint file_it = 0;
#line 295 "../src/LocalBackend/LocalLibrary.vala"
		file_collection = files;
#line 295 "../src/LocalBackend/LocalLibrary.vala"
		file_collection_length1 = files_length1;
#line 295 "../src/LocalBackend/LocalLibrary.vala"
		for (file_it = 0; file_it < file_collection_length1; file_it = file_it + 1) {
#line 2809 "LocalLibrary.c"
			GFile* _tmp3_;
			GFile* file = NULL;
#line 295 "../src/LocalBackend/LocalLibrary.vala"
			_tmp3_ = _g_object_ref0 (file_collection[file_it]);
#line 295 "../src/LocalBackend/LocalLibrary.vala"
			file = _tmp3_;
#line 2816 "LocalLibrary.c"
			{
				GeeTreeSet* _tmp4_;
				GFile* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
#line 296 "../src/LocalBackend/LocalLibrary.vala"
				_tmp4_ = files_list;
#line 296 "../src/LocalBackend/LocalLibrary.vala"
				_tmp5_ = file;
#line 296 "../src/LocalBackend/LocalLibrary.vala"
				_tmp6_ = g_file_get_uri (_tmp5_);
#line 296 "../src/LocalBackend/LocalLibrary.vala"
				_tmp7_ = _tmp6_;
#line 296 "../src/LocalBackend/LocalLibrary.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, _tmp7_);
#line 296 "../src/LocalBackend/LocalLibrary.vala"
				_g_free0 (_tmp7_);
#line 295 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (file);
#line 2836 "LocalLibrary.c"
			}
		}
	}
#line 299 "../src/LocalBackend/LocalLibrary.vala"
	_tmp8_ = files_list;
#line 299 "../src/LocalBackend/LocalLibrary.vala"
	_tmp9_ = music_library_medias_from_uris ((MusicLibrary*) self, (GeeCollection*) _tmp8_);
#line 299 "../src/LocalBackend/LocalLibrary.vala"
	found = _tmp9_;
#line 2846 "LocalLibrary.c"
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp10_;
		GeeIterator* _tmp11_;
#line 300 "../src/LocalBackend/LocalLibrary.vala"
		_tmp10_ = found;
#line 300 "../src/LocalBackend/LocalLibrary.vala"
		_tmp11_ = gee_iterable_iterator ((GeeIterable*) _tmp10_);
#line 300 "../src/LocalBackend/LocalLibrary.vala"
		_m_it = _tmp11_;
#line 300 "../src/LocalBackend/LocalLibrary.vala"
		while (TRUE) {
#line 2859 "LocalLibrary.c"
			GeeIterator* _tmp12_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp13_;
			gpointer _tmp14_;
			GeeTreeSet* _tmp15_;
			MusicMedia* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
#line 300 "../src/LocalBackend/LocalLibrary.vala"
			_tmp12_ = _m_it;
#line 300 "../src/LocalBackend/LocalLibrary.vala"
			if (!gee_iterator_next (_tmp12_)) {
#line 300 "../src/LocalBackend/LocalLibrary.vala"
				break;
#line 2875 "LocalLibrary.c"
			}
#line 300 "../src/LocalBackend/LocalLibrary.vala"
			_tmp13_ = _m_it;
#line 300 "../src/LocalBackend/LocalLibrary.vala"
			_tmp14_ = gee_iterator_get (_tmp13_);
#line 300 "../src/LocalBackend/LocalLibrary.vala"
			m = (MusicMedia*) _tmp14_;
#line 301 "../src/LocalBackend/LocalLibrary.vala"
			_tmp15_ = files_list;
#line 301 "../src/LocalBackend/LocalLibrary.vala"
			_tmp16_ = m;
#line 301 "../src/LocalBackend/LocalLibrary.vala"
			_tmp17_ = music_media_get_uri (_tmp16_);
#line 301 "../src/LocalBackend/LocalLibrary.vala"
			_tmp18_ = _tmp17_;
#line 301 "../src/LocalBackend/LocalLibrary.vala"
			_tmp19_ = _tmp18_;
#line 301 "../src/LocalBackend/LocalLibrary.vala"
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp15_, _tmp19_);
#line 301 "../src/LocalBackend/LocalLibrary.vala"
			_g_free0 (_tmp19_);
#line 300 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (m);
#line 2899 "LocalLibrary.c"
		}
#line 300 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_m_it);
#line 2903 "LocalLibrary.c"
	}
#line 304 "../src/LocalBackend/LocalLibrary.vala"
	_tmp20_ = self->priv->open_media_list;
#line 304 "../src/LocalBackend/LocalLibrary.vala"
	_tmp21_ = found;
#line 304 "../src/LocalBackend/LocalLibrary.vala"
	gee_collection_add_all ((GeeCollection*) _tmp20_, _tmp21_);
#line 305 "../src/LocalBackend/LocalLibrary.vala"
	_tmp22_ = files_list;
#line 305 "../src/LocalBackend/LocalLibrary.vala"
	_tmp23_ = gee_collection_get_is_empty ((GeeCollection*) _tmp22_);
#line 305 "../src/LocalBackend/LocalLibrary.vala"
	_tmp24_ = _tmp23_;
#line 305 "../src/LocalBackend/LocalLibrary.vala"
	if (_tmp24_) {
#line 306 "../src/LocalBackend/LocalLibrary.vala"
		music_local_library_media_opened_finished (self);
#line 2921 "LocalLibrary.c"
	} else {
		MusicGStreamerTagger* _tmp25_;
		GeeTreeSet* _tmp26_;
#line 308 "../src/LocalBackend/LocalLibrary.vala"
		_tmp25_ = self->priv->tagger;
#line 308 "../src/LocalBackend/LocalLibrary.vala"
		_tmp26_ = files_list;
#line 308 "../src/LocalBackend/LocalLibrary.vala"
		music_gstreamer_tagger_discoverer_import_media (_tmp25_, (GeeCollection*) _tmp26_);
#line 2931 "LocalLibrary.c"
	}
#line 291 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (found);
#line 291 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (files_list);
#line 2937 "LocalLibrary.c"
}

static void
music_local_library_media_opened_imported (MusicLocalLibrary* self,
                                           MusicMedia* m)
{
	GeeTreeSet* _tmp0_;
#line 312 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (self != NULL);
#line 312 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (m != NULL);
#line 313 "../src/LocalBackend/LocalLibrary.vala"
	music_media_set_is_temporary (m, TRUE);
#line 314 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = self->priv->open_media_list;
#line 314 "../src/LocalBackend/LocalLibrary.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, m);
#line 2955 "LocalLibrary.c"
}

static gboolean
_music_local_library_progress_notification_with_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = music_local_library_progress_notification_with_timeout ((MusicLocalLibrary*) self);
#line 341 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 2965 "LocalLibrary.c"
}

static void
music_local_library_import_files (MusicLocalLibrary* self,
                                  GeeTreeSet* files,
                                  MusicFileOperatorImportType type)
{
	GeeTreeSet* to_reimport = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp37_;
	gboolean _tmp38_;
#line 317 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (self != NULL);
#line 317 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (files != NULL);
#line 319 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 319 "../src/LocalBackend/LocalLibrary.vala"
	to_reimport = _tmp0_;
#line 2988 "LocalLibrary.c"
	{
		GeeIterator* _m_it = NULL;
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 320 "../src/LocalBackend/LocalLibrary.vala"
		_tmp1_ = self->priv->_dont_show_medias;
#line 320 "../src/LocalBackend/LocalLibrary.vala"
		_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 320 "../src/LocalBackend/LocalLibrary.vala"
		_tmp3_ = _tmp2_;
#line 320 "../src/LocalBackend/LocalLibrary.vala"
		_tmp4_ = _tmp3_;
#line 320 "../src/LocalBackend/LocalLibrary.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 320 "../src/LocalBackend/LocalLibrary.vala"
		_tmp6_ = _tmp5_;
#line 320 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_tmp4_);
#line 320 "../src/LocalBackend/LocalLibrary.vala"
		_m_it = _tmp6_;
#line 320 "../src/LocalBackend/LocalLibrary.vala"
		while (TRUE) {
#line 3015 "LocalLibrary.c"
			GeeIterator* _tmp7_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			MusicMedia* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gboolean _tmp14_;
#line 320 "../src/LocalBackend/LocalLibrary.vala"
			_tmp7_ = _m_it;
#line 320 "../src/LocalBackend/LocalLibrary.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 320 "../src/LocalBackend/LocalLibrary.vala"
				break;
#line 3031 "LocalLibrary.c"
			}
#line 320 "../src/LocalBackend/LocalLibrary.vala"
			_tmp8_ = _m_it;
#line 320 "../src/LocalBackend/LocalLibrary.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 320 "../src/LocalBackend/LocalLibrary.vala"
			m = (MusicMedia*) _tmp9_;
#line 321 "../src/LocalBackend/LocalLibrary.vala"
			_tmp10_ = m;
#line 321 "../src/LocalBackend/LocalLibrary.vala"
			_tmp11_ = music_media_get_uri (_tmp10_);
#line 321 "../src/LocalBackend/LocalLibrary.vala"
			_tmp12_ = _tmp11_;
#line 321 "../src/LocalBackend/LocalLibrary.vala"
			_tmp13_ = _tmp12_;
#line 321 "../src/LocalBackend/LocalLibrary.vala"
			_tmp14_ = gee_abstract_collection_contains ((GeeAbstractCollection*) files, _tmp13_);
#line 321 "../src/LocalBackend/LocalLibrary.vala"
			_g_free0 (_tmp13_);
#line 321 "../src/LocalBackend/LocalLibrary.vala"
			if (_tmp14_) {
#line 3053 "LocalLibrary.c"
				MusicMedia* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
#line 323 "../src/LocalBackend/LocalLibrary.vala"
				if (type != MUSIC_FILE_OPERATOR_IMPORT_TYPE_RESCAN) {
#line 3060 "LocalLibrary.c"
					GeeTreeSet* _tmp15_;
					MusicMedia* _tmp16_;
#line 324 "../src/LocalBackend/LocalLibrary.vala"
					_tmp15_ = to_reimport;
#line 324 "../src/LocalBackend/LocalLibrary.vala"
					_tmp16_ = m;
#line 324 "../src/LocalBackend/LocalLibrary.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 3069 "LocalLibrary.c"
				}
#line 326 "../src/LocalBackend/LocalLibrary.vala"
				_tmp17_ = m;
#line 326 "../src/LocalBackend/LocalLibrary.vala"
				_tmp18_ = music_media_get_uri (_tmp17_);
#line 326 "../src/LocalBackend/LocalLibrary.vala"
				_tmp19_ = _tmp18_;
#line 326 "../src/LocalBackend/LocalLibrary.vala"
				_tmp20_ = _tmp19_;
#line 326 "../src/LocalBackend/LocalLibrary.vala"
				gee_abstract_collection_remove ((GeeAbstractCollection*) files, _tmp20_);
#line 326 "../src/LocalBackend/LocalLibrary.vala"
				_g_free0 (_tmp20_);
#line 3083 "LocalLibrary.c"
			}
#line 320 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (m);
#line 3087 "LocalLibrary.c"
		}
#line 320 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_m_it);
#line 3091 "LocalLibrary.c"
	}
#line 330 "../src/LocalBackend/LocalLibrary.vala"
	_tmp21_ = to_reimport;
#line 330 "../src/LocalBackend/LocalLibrary.vala"
	_tmp22_ = gee_collection_get_is_empty ((GeeCollection*) _tmp21_);
#line 330 "../src/LocalBackend/LocalLibrary.vala"
	_tmp23_ = _tmp22_;
#line 330 "../src/LocalBackend/LocalLibrary.vala"
	if (!_tmp23_) {
#line 3101 "LocalLibrary.c"
		GeeTreeSet* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		GeeTreeSet* _tmp27_;
#line 331 "../src/LocalBackend/LocalLibrary.vala"
		_tmp24_ = to_reimport;
#line 331 "../src/LocalBackend/LocalLibrary.vala"
		_tmp25_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp24_);
#line 331 "../src/LocalBackend/LocalLibrary.vala"
		_tmp26_ = _tmp25_;
#line 331 "../src/LocalBackend/LocalLibrary.vala"
		g_debug ("LocalLibrary.vala:331: Re-Importing %d files\n", _tmp26_);
#line 332 "../src/LocalBackend/LocalLibrary.vala"
		_tmp27_ = to_reimport;
#line 332 "../src/LocalBackend/LocalLibrary.vala"
		music_library_add_medias ((MusicLibrary*) self, (GeeCollection*) _tmp27_);
#line 3118 "LocalLibrary.c"
		{
			GeeIterator* _m_it = NULL;
			GeeTreeSet* _tmp28_;
			GeeIterator* _tmp29_;
#line 333 "../src/LocalBackend/LocalLibrary.vala"
			_tmp28_ = to_reimport;
#line 333 "../src/LocalBackend/LocalLibrary.vala"
			_tmp29_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp28_);
#line 333 "../src/LocalBackend/LocalLibrary.vala"
			_m_it = _tmp29_;
#line 333 "../src/LocalBackend/LocalLibrary.vala"
			while (TRUE) {
#line 3131 "LocalLibrary.c"
				GeeIterator* _tmp30_;
				MusicMedia* m = NULL;
				GeeIterator* _tmp31_;
				gpointer _tmp32_;
				GeeHashMap* _tmp33_;
				MusicMedia* _tmp34_;
				gint64 _tmp35_;
				gint64 _tmp36_;
#line 333 "../src/LocalBackend/LocalLibrary.vala"
				_tmp30_ = _m_it;
#line 333 "../src/LocalBackend/LocalLibrary.vala"
				if (!gee_iterator_next (_tmp30_)) {
#line 333 "../src/LocalBackend/LocalLibrary.vala"
					break;
#line 3146 "LocalLibrary.c"
				}
#line 333 "../src/LocalBackend/LocalLibrary.vala"
				_tmp31_ = _m_it;
#line 333 "../src/LocalBackend/LocalLibrary.vala"
				_tmp32_ = gee_iterator_get (_tmp31_);
#line 333 "../src/LocalBackend/LocalLibrary.vala"
				m = (MusicMedia*) _tmp32_;
#line 334 "../src/LocalBackend/LocalLibrary.vala"
				_tmp33_ = self->priv->_dont_show_medias;
#line 334 "../src/LocalBackend/LocalLibrary.vala"
				_tmp34_ = m;
#line 334 "../src/LocalBackend/LocalLibrary.vala"
				_tmp35_ = music_media_get_rowid (_tmp34_);
#line 334 "../src/LocalBackend/LocalLibrary.vala"
				_tmp36_ = _tmp35_;
#line 334 "../src/LocalBackend/LocalLibrary.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp33_, &_tmp36_, NULL);
#line 333 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (m);
#line 3166 "LocalLibrary.c"
			}
#line 333 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (_m_it);
#line 3170 "LocalLibrary.c"
		}
	}
#line 338 "../src/LocalBackend/LocalLibrary.vala"
	_tmp37_ = gee_collection_get_is_empty ((GeeCollection*) files);
#line 338 "../src/LocalBackend/LocalLibrary.vala"
	_tmp38_ = _tmp37_;
#line 338 "../src/LocalBackend/LocalLibrary.vala"
	if (!_tmp38_) {
#line 3179 "LocalLibrary.c"
		gint _tmp39_;
		gint _tmp40_;
		MusicFileOperator* _tmp41_;
		gint _tmp42_;
		gint _tmp43_;
		MusicFileOperator* _tmp44_;
#line 339 "../src/LocalBackend/LocalLibrary.vala"
		_tmp39_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) files);
#line 339 "../src/LocalBackend/LocalLibrary.vala"
		_tmp40_ = _tmp39_;
#line 339 "../src/LocalBackend/LocalLibrary.vala"
		g_debug ("LocalLibrary.vala:339: Importing %d new songs", _tmp40_);
#line 340 "../src/LocalBackend/LocalLibrary.vala"
		_tmp41_ = self->priv->fo;
#line 340 "../src/LocalBackend/LocalLibrary.vala"
		_tmp42_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) files);
#line 340 "../src/LocalBackend/LocalLibrary.vala"
		_tmp43_ = _tmp42_;
#line 340 "../src/LocalBackend/LocalLibrary.vala"
		music_file_operator_reset_progress (_tmp41_, _tmp43_ - 1);
#line 341 "../src/LocalBackend/LocalLibrary.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, _music_local_library_progress_notification_with_timeout_gsource_func, g_object_ref (self), g_object_unref);
#line 342 "../src/LocalBackend/LocalLibrary.vala"
		_tmp44_ = self->priv->fo;
#line 342 "../src/LocalBackend/LocalLibrary.vala"
		music_file_operator_import_files (_tmp44_, (GeeCollection*) files, type);
#line 3206 "LocalLibrary.c"
	} else {
#line 344 "../src/LocalBackend/LocalLibrary.vala"
		music_library_finish_file_operations ((MusicLibrary*) self);
#line 345 "../src/LocalBackend/LocalLibrary.vala"
		g_debug ("LocalLibrary.vala:345: No new songs to import.");
#line 3212 "LocalLibrary.c"
	}
#line 317 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (to_reimport);
#line 3216 "LocalLibrary.c"
}

static void
music_local_library_media_opened_finished (MusicLocalLibrary* self)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	GeeTreeSet* _tmp2_;
	GeeTreeSet* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeTreeSet* _tmp54_;
#line 349 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (self != NULL);
#line 350 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = music_app_get_player ();
#line 350 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = _tmp0_;
#line 350 "../src/LocalBackend/LocalLibrary.vala"
	_tmp2_ = self->priv->open_media_list;
#line 350 "../src/LocalBackend/LocalLibrary.vala"
	music_playback_manager_queue_media (_tmp1_, (GeeCollection*) _tmp2_);
#line 351 "../src/LocalBackend/LocalLibrary.vala"
	_tmp3_ = self->priv->open_media_list;
#line 351 "../src/LocalBackend/LocalLibrary.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 351 "../src/LocalBackend/LocalLibrary.vala"
	_tmp5_ = _tmp4_;
#line 351 "../src/LocalBackend/LocalLibrary.vala"
	if (_tmp5_ > 0) {
#line 3247 "LocalLibrary.c"
		MusicPlaybackManager* _tmp6_;
		MusicPlaybackManager* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 352 "../src/LocalBackend/LocalLibrary.vala"
		_tmp6_ = music_app_get_player ();
#line 352 "../src/LocalBackend/LocalLibrary.vala"
		_tmp7_ = _tmp6_;
#line 352 "../src/LocalBackend/LocalLibrary.vala"
		_tmp8_ = music_playback_manager_get_playing (_tmp7_);
#line 352 "../src/LocalBackend/LocalLibrary.vala"
		_tmp9_ = _tmp8_;
#line 352 "../src/LocalBackend/LocalLibrary.vala"
		if (!_tmp9_) {
#line 3262 "LocalLibrary.c"
			MusicPlaybackManager* _tmp10_;
			MusicPlaybackManager* _tmp11_;
			GeeTreeSet* _tmp12_;
			gpointer _tmp13_;
			MusicMedia* _tmp14_;
			MusicLibraryWindow* _tmp15_;
			MusicLibraryWindow* _tmp16_;
#line 353 "../src/LocalBackend/LocalLibrary.vala"
			_tmp10_ = music_app_get_player ();
#line 353 "../src/LocalBackend/LocalLibrary.vala"
			_tmp11_ = _tmp10_;
#line 353 "../src/LocalBackend/LocalLibrary.vala"
			_tmp12_ = self->priv->open_media_list;
#line 353 "../src/LocalBackend/LocalLibrary.vala"
			_tmp13_ = gee_abstract_sorted_set_first ((GeeAbstractSortedSet*) _tmp12_);
#line 353 "../src/LocalBackend/LocalLibrary.vala"
			_tmp14_ = (MusicMedia*) _tmp13_;
#line 353 "../src/LocalBackend/LocalLibrary.vala"
			music_playback_manager_play_media (_tmp11_, _tmp14_);
#line 353 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (_tmp14_);
#line 354 "../src/LocalBackend/LocalLibrary.vala"
			_tmp15_ = music_app_get_main_window ();
#line 354 "../src/LocalBackend/LocalLibrary.vala"
			_tmp16_ = _tmp15_;
#line 354 "../src/LocalBackend/LocalLibrary.vala"
			music_library_window_play_media (_tmp16_, FALSE);
#line 3290 "LocalLibrary.c"
		} else {
			gchar* primary_text = NULL;
			gchar* _tmp17_;
			GString* secondary_text = NULL;
			GString* _tmp18_;
			GIcon* icon = NULL;
			GeeTreeSet* _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
			MusicLibraryWindow* _tmp48_;
			MusicLibraryWindow* _tmp49_;
			const gchar* _tmp50_;
			GString* _tmp51_;
			const gchar* _tmp52_;
			GIcon* _tmp53_;
#line 356 "../src/LocalBackend/LocalLibrary.vala"
			_tmp17_ = g_strdup (_ ("Added to your queue:"));
#line 356 "../src/LocalBackend/LocalLibrary.vala"
			primary_text = _tmp17_;
#line 358 "../src/LocalBackend/LocalLibrary.vala"
			_tmp18_ = g_string_new ("");
#line 358 "../src/LocalBackend/LocalLibrary.vala"
			secondary_text = _tmp18_;
#line 359 "../src/LocalBackend/LocalLibrary.vala"
			icon = NULL;
#line 360 "../src/LocalBackend/LocalLibrary.vala"
			_tmp19_ = self->priv->open_media_list;
#line 360 "../src/LocalBackend/LocalLibrary.vala"
			_tmp20_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp19_);
#line 360 "../src/LocalBackend/LocalLibrary.vala"
			_tmp21_ = _tmp20_;
#line 360 "../src/LocalBackend/LocalLibrary.vala"
			if (_tmp21_ == 1) {
#line 3324 "LocalLibrary.c"
				MusicMedia* first = NULL;
				GeeTreeSet* _tmp22_;
				gpointer _tmp23_;
				GString* _tmp24_;
				MusicMedia* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				GString* _tmp28_;
				GString* _tmp29_;
				MusicMedia* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				MusicMedia* _tmp33_;
				MusicAlbum* _tmp34_;
				MusicAlbum* _tmp35_;
				GIcon* _tmp36_;
				GIcon* _tmp37_;
				GIcon* _tmp38_;
#line 361 "../src/LocalBackend/LocalLibrary.vala"
				_tmp22_ = self->priv->open_media_list;
#line 361 "../src/LocalBackend/LocalLibrary.vala"
				_tmp23_ = gee_abstract_sorted_set_first ((GeeAbstractSortedSet*) _tmp22_);
#line 361 "../src/LocalBackend/LocalLibrary.vala"
				first = (MusicMedia*) _tmp23_;
#line 362 "../src/LocalBackend/LocalLibrary.vala"
				_tmp24_ = secondary_text;
#line 362 "../src/LocalBackend/LocalLibrary.vala"
				_tmp25_ = first;
#line 362 "../src/LocalBackend/LocalLibrary.vala"
				_tmp26_ = music_media_get_display_title (_tmp25_);
#line 362 "../src/LocalBackend/LocalLibrary.vala"
				_tmp27_ = _tmp26_;
#line 362 "../src/LocalBackend/LocalLibrary.vala"
				g_string_append (_tmp24_, _tmp27_);
#line 362 "../src/LocalBackend/LocalLibrary.vala"
				_g_free0 (_tmp27_);
#line 363 "../src/LocalBackend/LocalLibrary.vala"
				_tmp28_ = secondary_text;
#line 363 "../src/LocalBackend/LocalLibrary.vala"
				g_string_append (_tmp28_, "\n");
#line 364 "../src/LocalBackend/LocalLibrary.vala"
				_tmp29_ = secondary_text;
#line 364 "../src/LocalBackend/LocalLibrary.vala"
				_tmp30_ = first;
#line 364 "../src/LocalBackend/LocalLibrary.vala"
				_tmp31_ = music_media_get_display_artist (_tmp30_);
#line 364 "../src/LocalBackend/LocalLibrary.vala"
				_tmp32_ = _tmp31_;
#line 364 "../src/LocalBackend/LocalLibrary.vala"
				g_string_append (_tmp29_, _tmp32_);
#line 364 "../src/LocalBackend/LocalLibrary.vala"
				_g_free0 (_tmp32_);
#line 365 "../src/LocalBackend/LocalLibrary.vala"
				_tmp33_ = first;
#line 365 "../src/LocalBackend/LocalLibrary.vala"
				_tmp34_ = music_media_get_album_info (_tmp33_);
#line 365 "../src/LocalBackend/LocalLibrary.vala"
				_tmp35_ = _tmp34_;
#line 365 "../src/LocalBackend/LocalLibrary.vala"
				_tmp36_ = music_album_get_cover_icon (_tmp35_);
#line 365 "../src/LocalBackend/LocalLibrary.vala"
				_tmp37_ = _tmp36_;
#line 365 "../src/LocalBackend/LocalLibrary.vala"
				_tmp38_ = _g_object_ref0 (_tmp37_);
#line 365 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (icon);
#line 365 "../src/LocalBackend/LocalLibrary.vala"
				icon = _tmp38_;
#line 360 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (first);
#line 3395 "LocalLibrary.c"
			} else {
				GString* _tmp39_;
				GeeTreeSet* _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				GeeTreeSet* _tmp43_;
				gint _tmp44_;
				gint _tmp45_;
				gchar* _tmp46_;
				gchar* _tmp47_;
#line 367 "../src/LocalBackend/LocalLibrary.vala"
				_tmp39_ = secondary_text;
#line 367 "../src/LocalBackend/LocalLibrary.vala"
				_tmp40_ = self->priv->open_media_list;
#line 367 "../src/LocalBackend/LocalLibrary.vala"
				_tmp41_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp40_);
#line 367 "../src/LocalBackend/LocalLibrary.vala"
				_tmp42_ = _tmp41_;
#line 367 "../src/LocalBackend/LocalLibrary.vala"
				_tmp43_ = self->priv->open_media_list;
#line 367 "../src/LocalBackend/LocalLibrary.vala"
				_tmp44_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp43_);
#line 367 "../src/LocalBackend/LocalLibrary.vala"
				_tmp45_ = _tmp44_;
#line 367 "../src/LocalBackend/LocalLibrary.vala"
				_tmp46_ = g_strdup_printf (ngettext ("%d Track", "%d Tracks", (gulong) _tmp42_), _tmp45_);
#line 367 "../src/LocalBackend/LocalLibrary.vala"
				_tmp47_ = _tmp46_;
#line 367 "../src/LocalBackend/LocalLibrary.vala"
				g_string_append (_tmp39_, _tmp47_);
#line 367 "../src/LocalBackend/LocalLibrary.vala"
				_g_free0 (_tmp47_);
#line 3428 "LocalLibrary.c"
			}
#line 370 "../src/LocalBackend/LocalLibrary.vala"
			_tmp48_ = music_app_get_main_window ();
#line 370 "../src/LocalBackend/LocalLibrary.vala"
			_tmp49_ = _tmp48_;
#line 370 "../src/LocalBackend/LocalLibrary.vala"
			_tmp50_ = primary_text;
#line 370 "../src/LocalBackend/LocalLibrary.vala"
			_tmp51_ = secondary_text;
#line 370 "../src/LocalBackend/LocalLibrary.vala"
			_tmp52_ = _tmp51_->str;
#line 370 "../src/LocalBackend/LocalLibrary.vala"
			_tmp53_ = icon;
#line 370 "../src/LocalBackend/LocalLibrary.vala"
			music_library_window_show_notification (_tmp49_, _tmp50_, _tmp52_, _tmp53_, G_NOTIFICATION_PRIORITY_NORMAL, "import");
#line 352 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (icon);
#line 352 "../src/LocalBackend/LocalLibrary.vala"
			_g_string_free0 (secondary_text);
#line 352 "../src/LocalBackend/LocalLibrary.vala"
			_g_free0 (primary_text);
#line 3450 "LocalLibrary.c"
		}
	}
#line 374 "../src/LocalBackend/LocalLibrary.vala"
	_tmp54_ = self->priv->open_media_list;
#line 374 "../src/LocalBackend/LocalLibrary.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp54_);
#line 3457 "LocalLibrary.c"
}

static gboolean
music_local_library_real_support_playlists (MusicLibrary* base)
{
	MusicLocalLibrary * self;
	gboolean result;
#line 381 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 382 "../src/LocalBackend/LocalLibrary.vala"
	result = TRUE;
#line 382 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 3471 "LocalLibrary.c"
}

static GeeCollection*
music_local_library_real_get_playlists (MusicLibrary* base)
{
	MusicLocalLibrary * self;
	GeeTreeSet* _result_ = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	GeeCollection* result;
#line 385 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 386 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_STATIC_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 386 "../src/LocalBackend/LocalLibrary.vala"
	_result_ = _tmp0_;
#line 387 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = self->priv->_playlists;
#line 387 "../src/LocalBackend/LocalLibrary.vala"
	gee_collection_add_all ((GeeCollection*) _result_, (GeeCollection*) _tmp1_);
#line 388 "../src/LocalBackend/LocalLibrary.vala"
	result = (GeeCollection*) _result_;
#line 388 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 3496 "LocalLibrary.c"
}

static MusicStaticPlaylist*
music_local_library_real_playlist_from_id (MusicLibrary* base,
                                           gint64 id)
{
	MusicLocalLibrary * self;
	GError* _inner_error0_ = NULL;
	MusicStaticPlaylist* result;
#line 391 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 3508 "LocalLibrary.c"
	{
		GeeTreeSet* _tmp0_;
#line 392 "../src/LocalBackend/LocalLibrary.vala"
		_tmp0_ = self->priv->_playlists;
#line 392 "../src/LocalBackend/LocalLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock__playlists);
#line 3515 "LocalLibrary.c"
		{
			{
				GeeIterator* _p_it = NULL;
				GeeCollection* _tmp1_;
				GeeCollection* _tmp2_;
				GeeIterator* _tmp3_;
				GeeIterator* _tmp4_;
#line 393 "../src/LocalBackend/LocalLibrary.vala"
				_tmp1_ = music_library_get_playlists ((MusicLibrary*) self);
#line 393 "../src/LocalBackend/LocalLibrary.vala"
				_tmp2_ = _tmp1_;
#line 393 "../src/LocalBackend/LocalLibrary.vala"
				_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 393 "../src/LocalBackend/LocalLibrary.vala"
				_tmp4_ = _tmp3_;
#line 393 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_tmp2_);
#line 393 "../src/LocalBackend/LocalLibrary.vala"
				_p_it = _tmp4_;
#line 393 "../src/LocalBackend/LocalLibrary.vala"
				while (TRUE) {
#line 3537 "LocalLibrary.c"
					GeeIterator* _tmp5_;
					MusicStaticPlaylist* p = NULL;
					GeeIterator* _tmp6_;
					gpointer _tmp7_;
					MusicStaticPlaylist* _tmp8_;
					gint64 _tmp9_;
					gint64 _tmp10_;
#line 393 "../src/LocalBackend/LocalLibrary.vala"
					_tmp5_ = _p_it;
#line 393 "../src/LocalBackend/LocalLibrary.vala"
					if (!gee_iterator_next (_tmp5_)) {
#line 393 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 3551 "LocalLibrary.c"
					}
#line 393 "../src/LocalBackend/LocalLibrary.vala"
					_tmp6_ = _p_it;
#line 393 "../src/LocalBackend/LocalLibrary.vala"
					_tmp7_ = gee_iterator_get (_tmp6_);
#line 393 "../src/LocalBackend/LocalLibrary.vala"
					p = (MusicStaticPlaylist*) _tmp7_;
#line 394 "../src/LocalBackend/LocalLibrary.vala"
					_tmp8_ = p;
#line 394 "../src/LocalBackend/LocalLibrary.vala"
					_tmp9_ = music_playlist_get_rowid ((MusicPlaylist*) _tmp8_);
#line 394 "../src/LocalBackend/LocalLibrary.vala"
					_tmp10_ = _tmp9_;
#line 394 "../src/LocalBackend/LocalLibrary.vala"
					if (_tmp10_ == id) {
#line 395 "../src/LocalBackend/LocalLibrary.vala"
						result = p;
#line 395 "../src/LocalBackend/LocalLibrary.vala"
						_g_object_unref0 (_p_it);
#line 3571 "LocalLibrary.c"
						{
							GeeTreeSet* _tmp11_;
#line 392 "../src/LocalBackend/LocalLibrary.vala"
							_tmp11_ = self->priv->_playlists;
#line 392 "../src/LocalBackend/LocalLibrary.vala"
							g_rec_mutex_unlock (&self->priv->__lock__playlists);
#line 3578 "LocalLibrary.c"
						}
#line 395 "../src/LocalBackend/LocalLibrary.vala"
						return result;
#line 3582 "LocalLibrary.c"
					}
#line 393 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (p);
#line 3586 "LocalLibrary.c"
				}
#line 393 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_p_it);
#line 3590 "LocalLibrary.c"
			}
		}
		__finally0:
		{
			GeeTreeSet* _tmp12_;
#line 392 "../src/LocalBackend/LocalLibrary.vala"
			_tmp12_ = self->priv->_playlists;
#line 392 "../src/LocalBackend/LocalLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock__playlists);
#line 3600 "LocalLibrary.c"
		}
#line 392 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 392 "../src/LocalBackend/LocalLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 392 "../src/LocalBackend/LocalLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 392 "../src/LocalBackend/LocalLibrary.vala"
			return NULL;
#line 3610 "LocalLibrary.c"
		}
	}
#line 400 "../src/LocalBackend/LocalLibrary.vala"
	result = NULL;
#line 400 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 3617 "LocalLibrary.c"
}

static MusicStaticPlaylist*
music_local_library_real_playlist_from_name (MusicLibrary* base,
                                             const gchar* name)
{
	MusicLocalLibrary * self;
	MusicStaticPlaylist* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	MusicStaticPlaylist* result;
#line 403 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 403 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 404 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = self->p_music;
#line 404 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = music_playlist_get_name ((MusicPlaylist*) _tmp0_);
#line 404 "../src/LocalBackend/LocalLibrary.vala"
	_tmp2_ = _tmp1_;
#line 404 "../src/LocalBackend/LocalLibrary.vala"
	if (g_strcmp0 (name, _tmp2_) == 0) {
#line 3642 "LocalLibrary.c"
		MusicStaticPlaylist* _tmp3_;
		MusicStaticPlaylist* _tmp4_;
#line 405 "../src/LocalBackend/LocalLibrary.vala"
		_tmp3_ = self->p_music;
#line 405 "../src/LocalBackend/LocalLibrary.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 405 "../src/LocalBackend/LocalLibrary.vala"
		result = _tmp4_;
#line 405 "../src/LocalBackend/LocalLibrary.vala"
		return result;
#line 3653 "LocalLibrary.c"
	}
	{
		GeeTreeSet* _tmp5_;
#line 407 "../src/LocalBackend/LocalLibrary.vala"
		_tmp5_ = self->priv->_playlists;
#line 407 "../src/LocalBackend/LocalLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock__playlists);
#line 3661 "LocalLibrary.c"
		{
			{
				GeeIterator* _p_it = NULL;
				GeeCollection* _tmp6_;
				GeeCollection* _tmp7_;
				GeeIterator* _tmp8_;
				GeeIterator* _tmp9_;
#line 408 "../src/LocalBackend/LocalLibrary.vala"
				_tmp6_ = music_library_get_playlists ((MusicLibrary*) self);
#line 408 "../src/LocalBackend/LocalLibrary.vala"
				_tmp7_ = _tmp6_;
#line 408 "../src/LocalBackend/LocalLibrary.vala"
				_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 408 "../src/LocalBackend/LocalLibrary.vala"
				_tmp9_ = _tmp8_;
#line 408 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_tmp7_);
#line 408 "../src/LocalBackend/LocalLibrary.vala"
				_p_it = _tmp9_;
#line 408 "../src/LocalBackend/LocalLibrary.vala"
				while (TRUE) {
#line 3683 "LocalLibrary.c"
					GeeIterator* _tmp10_;
					MusicStaticPlaylist* p = NULL;
					GeeIterator* _tmp11_;
					gpointer _tmp12_;
					MusicStaticPlaylist* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
#line 408 "../src/LocalBackend/LocalLibrary.vala"
					_tmp10_ = _p_it;
#line 408 "../src/LocalBackend/LocalLibrary.vala"
					if (!gee_iterator_next (_tmp10_)) {
#line 408 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 3697 "LocalLibrary.c"
					}
#line 408 "../src/LocalBackend/LocalLibrary.vala"
					_tmp11_ = _p_it;
#line 408 "../src/LocalBackend/LocalLibrary.vala"
					_tmp12_ = gee_iterator_get (_tmp11_);
#line 408 "../src/LocalBackend/LocalLibrary.vala"
					p = (MusicStaticPlaylist*) _tmp12_;
#line 409 "../src/LocalBackend/LocalLibrary.vala"
					_tmp13_ = p;
#line 409 "../src/LocalBackend/LocalLibrary.vala"
					_tmp14_ = music_playlist_get_name ((MusicPlaylist*) _tmp13_);
#line 409 "../src/LocalBackend/LocalLibrary.vala"
					_tmp15_ = _tmp14_;
#line 409 "../src/LocalBackend/LocalLibrary.vala"
					if (g_strcmp0 (_tmp15_, name) == 0) {
#line 410 "../src/LocalBackend/LocalLibrary.vala"
						result = p;
#line 410 "../src/LocalBackend/LocalLibrary.vala"
						_g_object_unref0 (_p_it);
#line 3717 "LocalLibrary.c"
						{
							GeeTreeSet* _tmp16_;
#line 407 "../src/LocalBackend/LocalLibrary.vala"
							_tmp16_ = self->priv->_playlists;
#line 407 "../src/LocalBackend/LocalLibrary.vala"
							g_rec_mutex_unlock (&self->priv->__lock__playlists);
#line 3724 "LocalLibrary.c"
						}
#line 410 "../src/LocalBackend/LocalLibrary.vala"
						return result;
#line 3728 "LocalLibrary.c"
					}
#line 408 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (p);
#line 3732 "LocalLibrary.c"
				}
#line 408 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_p_it);
#line 3736 "LocalLibrary.c"
			}
		}
		__finally0:
		{
			GeeTreeSet* _tmp17_;
#line 407 "../src/LocalBackend/LocalLibrary.vala"
			_tmp17_ = self->priv->_playlists;
#line 407 "../src/LocalBackend/LocalLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock__playlists);
#line 3746 "LocalLibrary.c"
		}
#line 407 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 407 "../src/LocalBackend/LocalLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 407 "../src/LocalBackend/LocalLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 407 "../src/LocalBackend/LocalLibrary.vala"
			return NULL;
#line 3756 "LocalLibrary.c"
		}
	}
#line 415 "../src/LocalBackend/LocalLibrary.vala"
	result = NULL;
#line 415 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 3763 "LocalLibrary.c"
}

static void
_vala_GValue_free (GValue* self)
{
#line 431 "../src/LocalBackend/LocalLibrary.vala"
	g_boxed_free (G_TYPE_VALUE, self);
#line 3771 "LocalLibrary.c"
}

static void
music_local_library_real_add_playlist (MusicLibrary* base,
                                       MusicStaticPlaylist* p)
{
	MusicLocalLibrary * self;
	gchar* rv = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 418 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 418 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (p != NULL);
#line 419 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = g_strdup ("");
#line 419 "../src/LocalBackend/LocalLibrary.vala"
	rv = _tmp0_;
#line 3790 "LocalLibrary.c"
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp1_;
#line 420 "../src/LocalBackend/LocalLibrary.vala"
		_tmp1_ = music_playlist_iterator ((MusicPlaylist*) p);
#line 420 "../src/LocalBackend/LocalLibrary.vala"
		_m_it = _tmp1_;
#line 420 "../src/LocalBackend/LocalLibrary.vala"
		while (TRUE) {
#line 3800 "LocalLibrary.c"
			GeeIterator* _tmp2_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			const gchar* _tmp5_;
#line 420 "../src/LocalBackend/LocalLibrary.vala"
			_tmp2_ = _m_it;
#line 420 "../src/LocalBackend/LocalLibrary.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 420 "../src/LocalBackend/LocalLibrary.vala"
				break;
#line 3812 "LocalLibrary.c"
			}
#line 420 "../src/LocalBackend/LocalLibrary.vala"
			_tmp3_ = _m_it;
#line 420 "../src/LocalBackend/LocalLibrary.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 420 "../src/LocalBackend/LocalLibrary.vala"
			m = (MusicMedia*) _tmp4_;
#line 421 "../src/LocalBackend/LocalLibrary.vala"
			_tmp5_ = rv;
#line 421 "../src/LocalBackend/LocalLibrary.vala"
			if (g_strcmp0 (_tmp5_, "") == 0) {
#line 3824 "LocalLibrary.c"
				MusicMedia* _tmp6_;
				gint64 _tmp7_;
				gint64 _tmp8_;
				gchar* _tmp9_;
#line 422 "../src/LocalBackend/LocalLibrary.vala"
				_tmp6_ = m;
#line 422 "../src/LocalBackend/LocalLibrary.vala"
				_tmp7_ = music_media_get_rowid (_tmp6_);
#line 422 "../src/LocalBackend/LocalLibrary.vala"
				_tmp8_ = _tmp7_;
#line 422 "../src/LocalBackend/LocalLibrary.vala"
				_tmp9_ = g_strdup_printf ("%lld", _tmp8_);
#line 422 "../src/LocalBackend/LocalLibrary.vala"
				_g_free0 (rv);
#line 422 "../src/LocalBackend/LocalLibrary.vala"
				rv = _tmp9_;
#line 3841 "LocalLibrary.c"
			} else {
				const gchar* _tmp10_;
				MusicMedia* _tmp11_;
				gint64 _tmp12_;
				gint64 _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
#line 424 "../src/LocalBackend/LocalLibrary.vala"
				_tmp10_ = rv;
#line 424 "../src/LocalBackend/LocalLibrary.vala"
				_tmp11_ = m;
#line 424 "../src/LocalBackend/LocalLibrary.vala"
				_tmp12_ = music_media_get_rowid (_tmp11_);
#line 424 "../src/LocalBackend/LocalLibrary.vala"
				_tmp13_ = _tmp12_;
#line 424 "../src/LocalBackend/LocalLibrary.vala"
				_tmp14_ = g_strdup_printf (";%lld", _tmp13_);
#line 424 "../src/LocalBackend/LocalLibrary.vala"
				_tmp15_ = _tmp14_;
#line 424 "../src/LocalBackend/LocalLibrary.vala"
				_tmp16_ = g_strconcat (_tmp10_, _tmp15_, NULL);
#line 424 "../src/LocalBackend/LocalLibrary.vala"
				_g_free0 (rv);
#line 424 "../src/LocalBackend/LocalLibrary.vala"
				rv = _tmp16_;
#line 424 "../src/LocalBackend/LocalLibrary.vala"
				_g_free0 (_tmp15_);
#line 3870 "LocalLibrary.c"
			}
#line 420 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (m);
#line 3874 "LocalLibrary.c"
		}
#line 420 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_m_it);
#line 3878 "LocalLibrary.c"
	}
	{
		GdaSqlBuilder* builder = NULL;
		GdaSqlBuilder* _tmp17_;
		GdaSqlBuilder* _tmp18_;
		GdaSqlBuilder* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		GValue* _tmp22_ = NULL;
		GdaSqlBuilder* _tmp23_;
		const gchar* _tmp24_;
		GValue* _tmp25_ = NULL;
		GdaStatement* statement = NULL;
		GdaSqlBuilder* _tmp26_;
		GdaStatement* _tmp27_;
		GdaSet* last_insert_row = NULL;
		GdaConnection* _tmp28_;
		GdaStatement* _tmp29_;
		GdaSet* _tmp30_ = NULL;
		MusicLocalStaticPlaylist* local_p = NULL;
		GdaSet* _tmp31_;
		GValue _tmp32_;
		GdaConnection* _tmp33_;
		MusicLocalStaticPlaylist* _tmp34_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
#line 429 "../src/LocalBackend/LocalLibrary.vala"
		_tmp17_ = gda_sql_builder_new (GDA_SQL_STATEMENT_INSERT);
#line 429 "../src/LocalBackend/LocalLibrary.vala"
		builder = _tmp17_;
#line 430 "../src/LocalBackend/LocalLibrary.vala"
		_tmp18_ = builder;
#line 430 "../src/LocalBackend/LocalLibrary.vala"
		gda_sql_builder_set_table (_tmp18_, MUSIC_DATABASE_PLAYLISTS_TABLE_NAME);
#line 431 "../src/LocalBackend/LocalLibrary.vala"
		_tmp19_ = builder;
#line 431 "../src/LocalBackend/LocalLibrary.vala"
		_tmp20_ = music_playlist_get_name ((MusicPlaylist*) p);
#line 431 "../src/LocalBackend/LocalLibrary.vala"
		_tmp21_ = _tmp20_;
#line 431 "../src/LocalBackend/LocalLibrary.vala"
		_tmp22_ = g_new0 (GValue, 1);
#line 431 "../src/LocalBackend/LocalLibrary.vala"
		g_value_init (_tmp22_, G_TYPE_STRING);
#line 431 "../src/LocalBackend/LocalLibrary.vala"
		g_value_set_string (_tmp22_, _tmp21_);
#line 431 "../src/LocalBackend/LocalLibrary.vala"
		gda_sql_builder_add_field_value_as_gvalue (_tmp19_, "name", _tmp22_);
#line 431 "../src/LocalBackend/LocalLibrary.vala"
		__vala_GValue_free0 (_tmp22_);
#line 432 "../src/LocalBackend/LocalLibrary.vala"
		_tmp23_ = builder;
#line 432 "../src/LocalBackend/LocalLibrary.vala"
		_tmp24_ = rv;
#line 432 "../src/LocalBackend/LocalLibrary.vala"
		_tmp25_ = g_new0 (GValue, 1);
#line 432 "../src/LocalBackend/LocalLibrary.vala"
		g_value_init (_tmp25_, G_TYPE_STRING);
#line 432 "../src/LocalBackend/LocalLibrary.vala"
		g_value_set_string (_tmp25_, _tmp24_);
#line 432 "../src/LocalBackend/LocalLibrary.vala"
		gda_sql_builder_add_field_value_as_gvalue (_tmp23_, "media", _tmp25_);
#line 432 "../src/LocalBackend/LocalLibrary.vala"
		__vala_GValue_free0 (_tmp25_);
#line 433 "../src/LocalBackend/LocalLibrary.vala"
		_tmp26_ = builder;
#line 433 "../src/LocalBackend/LocalLibrary.vala"
		_tmp27_ = gda_sql_builder_get_statement (_tmp26_, &_inner_error0_);
#line 433 "../src/LocalBackend/LocalLibrary.vala"
		statement = _tmp27_;
#line 433 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 433 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (builder);
#line 3953 "LocalLibrary.c"
			goto __catch0_g_error;
		}
#line 435 "../src/LocalBackend/LocalLibrary.vala"
		_tmp28_ = self->priv->_connection;
#line 435 "../src/LocalBackend/LocalLibrary.vala"
		_tmp29_ = statement;
#line 435 "../src/LocalBackend/LocalLibrary.vala"
		gda_connection_statement_execute_non_select (_tmp28_, _tmp29_, NULL, &_tmp30_, &_inner_error0_);
#line 435 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (last_insert_row);
#line 435 "../src/LocalBackend/LocalLibrary.vala"
		last_insert_row = _tmp30_;
#line 435 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 435 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (last_insert_row);
#line 435 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (statement);
#line 435 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (builder);
#line 3974 "LocalLibrary.c"
			goto __catch0_g_error;
		}
#line 436 "../src/LocalBackend/LocalLibrary.vala"
		_tmp31_ = last_insert_row;
#line 436 "../src/LocalBackend/LocalLibrary.vala"
		_tmp32_ = *gda_set_get_holder_value (_tmp31_, MUSIC_DATABASE_PLAYLISTS_ROWID);
#line 436 "../src/LocalBackend/LocalLibrary.vala"
		_tmp33_ = self->priv->_connection;
#line 436 "../src/LocalBackend/LocalLibrary.vala"
		_tmp34_ = music_local_static_playlist_new (g_value_get_int64 (&_tmp32_), _tmp33_);
#line 436 "../src/LocalBackend/LocalLibrary.vala"
		local_p = _tmp34_;
#line 3987 "LocalLibrary.c"
		{
			GeeTreeSet* _tmp35_;
#line 438 "../src/LocalBackend/LocalLibrary.vala"
			_tmp35_ = self->priv->_playlists;
#line 438 "../src/LocalBackend/LocalLibrary.vala"
			g_rec_mutex_lock (&self->priv->__lock__playlists);
#line 3994 "LocalLibrary.c"
			{
				GeeTreeSet* _tmp36_;
#line 439 "../src/LocalBackend/LocalLibrary.vala"
				_tmp36_ = self->priv->_playlists;
#line 439 "../src/LocalBackend/LocalLibrary.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, (MusicStaticPlaylist*) local_p);
#line 4001 "LocalLibrary.c"
			}
			__finally1:
			{
				GeeTreeSet* _tmp37_;
#line 438 "../src/LocalBackend/LocalLibrary.vala"
				_tmp37_ = self->priv->_playlists;
#line 438 "../src/LocalBackend/LocalLibrary.vala"
				g_rec_mutex_unlock (&self->priv->__lock__playlists);
#line 4010 "LocalLibrary.c"
			}
#line 438 "../src/LocalBackend/LocalLibrary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 438 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (local_p);
#line 438 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (last_insert_row);
#line 438 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (statement);
#line 438 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (builder);
#line 4022 "LocalLibrary.c"
				goto __catch0_g_error;
			}
		}
#line 442 "../src/LocalBackend/LocalLibrary.vala"
		g_signal_emit_by_name ((MusicLibrary*) self, "playlist-added", (MusicStaticPlaylist*) local_p);
#line 443 "../src/LocalBackend/LocalLibrary.vala"
		_tmp38_ = music_playlist_get_name ((MusicPlaylist*) local_p);
#line 443 "../src/LocalBackend/LocalLibrary.vala"
		_tmp39_ = _tmp38_;
#line 443 "../src/LocalBackend/LocalLibrary.vala"
		g_debug ("LocalLibrary.vala:443: playlist %s added", _tmp39_);
#line 428 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (local_p);
#line 428 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (last_insert_row);
#line 428 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (statement);
#line 428 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (builder);
#line 4042 "LocalLibrary.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp40_;
		const gchar* _tmp41_;
#line 428 "../src/LocalBackend/LocalLibrary.vala"
		e = _inner_error0_;
#line 428 "../src/LocalBackend/LocalLibrary.vala"
		_inner_error0_ = NULL;
#line 445 "../src/LocalBackend/LocalLibrary.vala"
		_tmp40_ = e;
#line 445 "../src/LocalBackend/LocalLibrary.vala"
		_tmp41_ = _tmp40_->message;
#line 445 "../src/LocalBackend/LocalLibrary.vala"
		g_critical ("LocalLibrary.vala:445: %s", _tmp41_);
#line 428 "../src/LocalBackend/LocalLibrary.vala"
		_g_error_free0 (e);
#line 4062 "LocalLibrary.c"
	}
	__finally0:
#line 428 "../src/LocalBackend/LocalLibrary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 428 "../src/LocalBackend/LocalLibrary.vala"
		_g_free0 (rv);
#line 428 "../src/LocalBackend/LocalLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 428 "../src/LocalBackend/LocalLibrary.vala"
		g_clear_error (&_inner_error0_);
#line 428 "../src/LocalBackend/LocalLibrary.vala"
		return;
#line 4075 "LocalLibrary.c"
	}
#line 418 "../src/LocalBackend/LocalLibrary.vala"
	_g_free0 (rv);
#line 4079 "LocalLibrary.c"
}

static void
music_local_library_real_remove_playlist (MusicLibrary* base,
                                          gint64 id)
{
	MusicLocalLibrary * self;
	GError* _inner_error0_ = NULL;
#line 449 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 4090 "LocalLibrary.c"
	{
		GeeTreeSet* _tmp0_;
#line 450 "../src/LocalBackend/LocalLibrary.vala"
		_tmp0_ = self->priv->_playlists;
#line 450 "../src/LocalBackend/LocalLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock__playlists);
#line 4097 "LocalLibrary.c"
		{
			{
				GeeIterator* _playlist_it = NULL;
				GeeCollection* _tmp1_;
				GeeCollection* _tmp2_;
				GeeIterator* _tmp3_;
				GeeIterator* _tmp4_;
#line 451 "../src/LocalBackend/LocalLibrary.vala"
				_tmp1_ = music_library_get_playlists ((MusicLibrary*) self);
#line 451 "../src/LocalBackend/LocalLibrary.vala"
				_tmp2_ = _tmp1_;
#line 451 "../src/LocalBackend/LocalLibrary.vala"
				_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 451 "../src/LocalBackend/LocalLibrary.vala"
				_tmp4_ = _tmp3_;
#line 451 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_tmp2_);
#line 451 "../src/LocalBackend/LocalLibrary.vala"
				_playlist_it = _tmp4_;
#line 451 "../src/LocalBackend/LocalLibrary.vala"
				while (TRUE) {
#line 4119 "LocalLibrary.c"
					GeeIterator* _tmp5_;
					MusicStaticPlaylist* playlist = NULL;
					GeeIterator* _tmp6_;
					gpointer _tmp7_;
					MusicStaticPlaylist* _tmp8_;
					gint64 _tmp9_;
					gint64 _tmp10_;
#line 451 "../src/LocalBackend/LocalLibrary.vala"
					_tmp5_ = _playlist_it;
#line 451 "../src/LocalBackend/LocalLibrary.vala"
					if (!gee_iterator_next (_tmp5_)) {
#line 451 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 4133 "LocalLibrary.c"
					}
#line 451 "../src/LocalBackend/LocalLibrary.vala"
					_tmp6_ = _playlist_it;
#line 451 "../src/LocalBackend/LocalLibrary.vala"
					_tmp7_ = gee_iterator_get (_tmp6_);
#line 451 "../src/LocalBackend/LocalLibrary.vala"
					playlist = (MusicStaticPlaylist*) _tmp7_;
#line 452 "../src/LocalBackend/LocalLibrary.vala"
					_tmp8_ = playlist;
#line 452 "../src/LocalBackend/LocalLibrary.vala"
					_tmp9_ = music_playlist_get_rowid ((MusicPlaylist*) _tmp8_);
#line 452 "../src/LocalBackend/LocalLibrary.vala"
					_tmp10_ = _tmp9_;
#line 452 "../src/LocalBackend/LocalLibrary.vala"
					if (_tmp10_ == id) {
#line 4149 "LocalLibrary.c"
						GeeTreeSet* _tmp11_;
						MusicStaticPlaylist* _tmp12_;
						MusicStaticPlaylist* _tmp13_;
#line 453 "../src/LocalBackend/LocalLibrary.vala"
						_tmp11_ = self->priv->_playlists;
#line 453 "../src/LocalBackend/LocalLibrary.vala"
						_tmp12_ = playlist;
#line 453 "../src/LocalBackend/LocalLibrary.vala"
						gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 454 "../src/LocalBackend/LocalLibrary.vala"
						_tmp13_ = playlist;
#line 454 "../src/LocalBackend/LocalLibrary.vala"
						g_signal_emit_by_name ((MusicLibrary*) self, "playlist-removed", _tmp13_);
#line 455 "../src/LocalBackend/LocalLibrary.vala"
						_g_object_unref0 (playlist);
#line 455 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 4167 "LocalLibrary.c"
					}
#line 451 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (playlist);
#line 4171 "LocalLibrary.c"
				}
#line 451 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_playlist_it);
#line 4175 "LocalLibrary.c"
			}
			{
				GdaConnection* _tmp14_;
				GValue _tmp15_ = {0};
#line 460 "../src/LocalBackend/LocalLibrary.vala"
				_tmp14_ = self->priv->_connection;
#line 460 "../src/LocalBackend/LocalLibrary.vala"
				g_value_init (&_tmp15_, G_TYPE_INT64);
#line 460 "../src/LocalBackend/LocalLibrary.vala"
				g_value_set_int64 (&_tmp15_, id);
#line 460 "../src/LocalBackend/LocalLibrary.vala"
				gda_connection_delete_row_from_table (_tmp14_, MUSIC_DATABASE_PLAYLISTS_TABLE_NAME, "rowid", &_tmp15_, &_inner_error0_);
#line 460 "../src/LocalBackend/LocalLibrary.vala"
				G_IS_VALUE (&_tmp15_) ? (g_value_unset (&_tmp15_), NULL) : NULL;
#line 460 "../src/LocalBackend/LocalLibrary.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4192 "LocalLibrary.c"
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* e = NULL;
				GError* _tmp16_;
				const gchar* _tmp17_;
#line 459 "../src/LocalBackend/LocalLibrary.vala"
				e = _inner_error0_;
#line 459 "../src/LocalBackend/LocalLibrary.vala"
				_inner_error0_ = NULL;
#line 462 "../src/LocalBackend/LocalLibrary.vala"
				_tmp16_ = e;
#line 462 "../src/LocalBackend/LocalLibrary.vala"
				_tmp17_ = _tmp16_->message;
#line 462 "../src/LocalBackend/LocalLibrary.vala"
				g_critical ("LocalLibrary.vala:462: %s", _tmp17_);
#line 459 "../src/LocalBackend/LocalLibrary.vala"
				_g_error_free0 (e);
#line 4214 "LocalLibrary.c"
			}
			__finally1:
#line 459 "../src/LocalBackend/LocalLibrary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 459 "../src/LocalBackend/LocalLibrary.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 459 "../src/LocalBackend/LocalLibrary.vala"
				g_clear_error (&_inner_error0_);
#line 459 "../src/LocalBackend/LocalLibrary.vala"
				return;
#line 4225 "LocalLibrary.c"
			}
		}
		__finally0:
		{
			GeeTreeSet* _tmp18_;
#line 450 "../src/LocalBackend/LocalLibrary.vala"
			_tmp18_ = self->priv->_playlists;
#line 450 "../src/LocalBackend/LocalLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock__playlists);
#line 4235 "LocalLibrary.c"
		}
#line 450 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 450 "../src/LocalBackend/LocalLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 450 "../src/LocalBackend/LocalLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 450 "../src/LocalBackend/LocalLibrary.vala"
			return;
#line 4245 "LocalLibrary.c"
		}
	}
}

static gboolean
music_local_library_real_support_smart_playlists (MusicLibrary* base)
{
	MusicLocalLibrary * self;
	gboolean result;
#line 471 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 472 "../src/LocalBackend/LocalLibrary.vala"
	result = TRUE;
#line 472 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 4261 "LocalLibrary.c"
}

static GeeCollection*
music_local_library_real_get_smart_playlists (MusicLibrary* base)
{
	MusicLocalLibrary * self;
	GeeTreeSet* _result_ = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	GeeCollection* result;
#line 475 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 476 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_SMART_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 476 "../src/LocalBackend/LocalLibrary.vala"
	_result_ = _tmp0_;
#line 477 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = self->priv->_smart_playlists;
#line 477 "../src/LocalBackend/LocalLibrary.vala"
	gee_collection_add_all ((GeeCollection*) _result_, (GeeCollection*) _tmp1_);
#line 478 "../src/LocalBackend/LocalLibrary.vala"
	result = (GeeCollection*) _result_;
#line 478 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 4286 "LocalLibrary.c"
}

static MusicSmartPlaylist*
music_local_library_real_smart_playlist_from_id (MusicLibrary* base,
                                                 gint64 id)
{
	MusicLocalLibrary * self;
	GError* _inner_error0_ = NULL;
	MusicSmartPlaylist* result;
#line 481 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 4298 "LocalLibrary.c"
	{
		GeeTreeSet* _tmp0_;
#line 482 "../src/LocalBackend/LocalLibrary.vala"
		_tmp0_ = self->priv->_smart_playlists;
#line 482 "../src/LocalBackend/LocalLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock__smart_playlists);
#line 4305 "LocalLibrary.c"
		{
			{
				GeeIterator* _p_it = NULL;
				GeeCollection* _tmp1_;
				GeeCollection* _tmp2_;
				GeeIterator* _tmp3_;
				GeeIterator* _tmp4_;
#line 483 "../src/LocalBackend/LocalLibrary.vala"
				_tmp1_ = music_library_get_smart_playlists ((MusicLibrary*) self);
#line 483 "../src/LocalBackend/LocalLibrary.vala"
				_tmp2_ = _tmp1_;
#line 483 "../src/LocalBackend/LocalLibrary.vala"
				_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 483 "../src/LocalBackend/LocalLibrary.vala"
				_tmp4_ = _tmp3_;
#line 483 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_tmp2_);
#line 483 "../src/LocalBackend/LocalLibrary.vala"
				_p_it = _tmp4_;
#line 483 "../src/LocalBackend/LocalLibrary.vala"
				while (TRUE) {
#line 4327 "LocalLibrary.c"
					GeeIterator* _tmp5_;
					MusicSmartPlaylist* p = NULL;
					GeeIterator* _tmp6_;
					gpointer _tmp7_;
					MusicSmartPlaylist* _tmp8_;
					gint64 _tmp9_;
					gint64 _tmp10_;
#line 483 "../src/LocalBackend/LocalLibrary.vala"
					_tmp5_ = _p_it;
#line 483 "../src/LocalBackend/LocalLibrary.vala"
					if (!gee_iterator_next (_tmp5_)) {
#line 483 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 4341 "LocalLibrary.c"
					}
#line 483 "../src/LocalBackend/LocalLibrary.vala"
					_tmp6_ = _p_it;
#line 483 "../src/LocalBackend/LocalLibrary.vala"
					_tmp7_ = gee_iterator_get (_tmp6_);
#line 483 "../src/LocalBackend/LocalLibrary.vala"
					p = (MusicSmartPlaylist*) _tmp7_;
#line 484 "../src/LocalBackend/LocalLibrary.vala"
					_tmp8_ = p;
#line 484 "../src/LocalBackend/LocalLibrary.vala"
					_tmp9_ = music_playlist_get_rowid ((MusicPlaylist*) _tmp8_);
#line 484 "../src/LocalBackend/LocalLibrary.vala"
					_tmp10_ = _tmp9_;
#line 484 "../src/LocalBackend/LocalLibrary.vala"
					if (_tmp10_ == id) {
#line 485 "../src/LocalBackend/LocalLibrary.vala"
						result = p;
#line 485 "../src/LocalBackend/LocalLibrary.vala"
						_g_object_unref0 (_p_it);
#line 4361 "LocalLibrary.c"
						{
							GeeTreeSet* _tmp11_;
#line 482 "../src/LocalBackend/LocalLibrary.vala"
							_tmp11_ = self->priv->_smart_playlists;
#line 482 "../src/LocalBackend/LocalLibrary.vala"
							g_rec_mutex_unlock (&self->priv->__lock__smart_playlists);
#line 4368 "LocalLibrary.c"
						}
#line 485 "../src/LocalBackend/LocalLibrary.vala"
						return result;
#line 4372 "LocalLibrary.c"
					}
#line 483 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (p);
#line 4376 "LocalLibrary.c"
				}
#line 483 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_p_it);
#line 4380 "LocalLibrary.c"
			}
		}
		__finally0:
		{
			GeeTreeSet* _tmp12_;
#line 482 "../src/LocalBackend/LocalLibrary.vala"
			_tmp12_ = self->priv->_smart_playlists;
#line 482 "../src/LocalBackend/LocalLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock__smart_playlists);
#line 4390 "LocalLibrary.c"
		}
#line 482 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 482 "../src/LocalBackend/LocalLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 482 "../src/LocalBackend/LocalLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 482 "../src/LocalBackend/LocalLibrary.vala"
			return NULL;
#line 4400 "LocalLibrary.c"
		}
	}
#line 490 "../src/LocalBackend/LocalLibrary.vala"
	result = NULL;
#line 490 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 4407 "LocalLibrary.c"
}

static MusicSmartPlaylist*
music_local_library_real_smart_playlist_from_name (MusicLibrary* base,
                                                   const gchar* name)
{
	MusicLocalLibrary * self;
	GError* _inner_error0_ = NULL;
	MusicSmartPlaylist* result;
#line 493 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 493 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 4421 "LocalLibrary.c"
	{
		GeeTreeSet* _tmp0_;
#line 494 "../src/LocalBackend/LocalLibrary.vala"
		_tmp0_ = self->priv->_smart_playlists;
#line 494 "../src/LocalBackend/LocalLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock__smart_playlists);
#line 4428 "LocalLibrary.c"
		{
			{
				GeeIterator* _p_it = NULL;
				GeeCollection* _tmp1_;
				GeeCollection* _tmp2_;
				GeeIterator* _tmp3_;
				GeeIterator* _tmp4_;
#line 495 "../src/LocalBackend/LocalLibrary.vala"
				_tmp1_ = music_library_get_smart_playlists ((MusicLibrary*) self);
#line 495 "../src/LocalBackend/LocalLibrary.vala"
				_tmp2_ = _tmp1_;
#line 495 "../src/LocalBackend/LocalLibrary.vala"
				_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 495 "../src/LocalBackend/LocalLibrary.vala"
				_tmp4_ = _tmp3_;
#line 495 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_tmp2_);
#line 495 "../src/LocalBackend/LocalLibrary.vala"
				_p_it = _tmp4_;
#line 495 "../src/LocalBackend/LocalLibrary.vala"
				while (TRUE) {
#line 4450 "LocalLibrary.c"
					GeeIterator* _tmp5_;
					MusicSmartPlaylist* p = NULL;
					GeeIterator* _tmp6_;
					gpointer _tmp7_;
					MusicSmartPlaylist* _tmp8_;
					const gchar* _tmp9_;
					const gchar* _tmp10_;
#line 495 "../src/LocalBackend/LocalLibrary.vala"
					_tmp5_ = _p_it;
#line 495 "../src/LocalBackend/LocalLibrary.vala"
					if (!gee_iterator_next (_tmp5_)) {
#line 495 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 4464 "LocalLibrary.c"
					}
#line 495 "../src/LocalBackend/LocalLibrary.vala"
					_tmp6_ = _p_it;
#line 495 "../src/LocalBackend/LocalLibrary.vala"
					_tmp7_ = gee_iterator_get (_tmp6_);
#line 495 "../src/LocalBackend/LocalLibrary.vala"
					p = (MusicSmartPlaylist*) _tmp7_;
#line 496 "../src/LocalBackend/LocalLibrary.vala"
					_tmp8_ = p;
#line 496 "../src/LocalBackend/LocalLibrary.vala"
					_tmp9_ = music_playlist_get_name ((MusicPlaylist*) _tmp8_);
#line 496 "../src/LocalBackend/LocalLibrary.vala"
					_tmp10_ = _tmp9_;
#line 496 "../src/LocalBackend/LocalLibrary.vala"
					if (g_strcmp0 (_tmp10_, name) == 0) {
#line 497 "../src/LocalBackend/LocalLibrary.vala"
						result = p;
#line 497 "../src/LocalBackend/LocalLibrary.vala"
						_g_object_unref0 (_p_it);
#line 4484 "LocalLibrary.c"
						{
							GeeTreeSet* _tmp11_;
#line 494 "../src/LocalBackend/LocalLibrary.vala"
							_tmp11_ = self->priv->_smart_playlists;
#line 494 "../src/LocalBackend/LocalLibrary.vala"
							g_rec_mutex_unlock (&self->priv->__lock__smart_playlists);
#line 4491 "LocalLibrary.c"
						}
#line 497 "../src/LocalBackend/LocalLibrary.vala"
						return result;
#line 4495 "LocalLibrary.c"
					}
#line 495 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (p);
#line 4499 "LocalLibrary.c"
				}
#line 495 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_p_it);
#line 4503 "LocalLibrary.c"
			}
		}
		__finally0:
		{
			GeeTreeSet* _tmp12_;
#line 494 "../src/LocalBackend/LocalLibrary.vala"
			_tmp12_ = self->priv->_smart_playlists;
#line 494 "../src/LocalBackend/LocalLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock__smart_playlists);
#line 4513 "LocalLibrary.c"
		}
#line 494 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 494 "../src/LocalBackend/LocalLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 494 "../src/LocalBackend/LocalLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 494 "../src/LocalBackend/LocalLibrary.vala"
			return NULL;
#line 4523 "LocalLibrary.c"
		}
	}
#line 502 "../src/LocalBackend/LocalLibrary.vala"
	result = NULL;
#line 502 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 4530 "LocalLibrary.c"
}

static void
music_local_library_real_add_smart_playlist (MusicLibrary* base,
                                             MusicSmartPlaylist* p)
{
	MusicLocalLibrary * self;
	GError* _inner_error0_ = NULL;
#line 505 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 505 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (p != NULL);
#line 4543 "LocalLibrary.c"
	{
		GdaSqlBuilder* builder = NULL;
		GdaSqlBuilder* _tmp0_;
		GdaSqlBuilder* _tmp1_;
		GdaSqlBuilder* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		GValue* _tmp5_ = NULL;
		GdaStatement* statement = NULL;
		GdaSqlBuilder* _tmp6_;
		GdaStatement* _tmp7_;
		GdaSet* last_insert_row = NULL;
		GdaConnection* _tmp8_;
		GdaStatement* _tmp9_;
		GdaSet* _tmp10_ = NULL;
		GdaSet* _tmp11_;
#line 507 "../src/LocalBackend/LocalLibrary.vala"
		_tmp0_ = gda_sql_builder_new (GDA_SQL_STATEMENT_INSERT);
#line 507 "../src/LocalBackend/LocalLibrary.vala"
		builder = _tmp0_;
#line 508 "../src/LocalBackend/LocalLibrary.vala"
		_tmp1_ = builder;
#line 508 "../src/LocalBackend/LocalLibrary.vala"
		gda_sql_builder_set_table (_tmp1_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME);
#line 509 "../src/LocalBackend/LocalLibrary.vala"
		_tmp2_ = builder;
#line 509 "../src/LocalBackend/LocalLibrary.vala"
		_tmp3_ = music_playlist_get_name ((MusicPlaylist*) p);
#line 509 "../src/LocalBackend/LocalLibrary.vala"
		_tmp4_ = _tmp3_;
#line 509 "../src/LocalBackend/LocalLibrary.vala"
		_tmp5_ = g_new0 (GValue, 1);
#line 509 "../src/LocalBackend/LocalLibrary.vala"
		g_value_init (_tmp5_, G_TYPE_STRING);
#line 509 "../src/LocalBackend/LocalLibrary.vala"
		g_value_set_string (_tmp5_, _tmp4_);
#line 509 "../src/LocalBackend/LocalLibrary.vala"
		gda_sql_builder_add_field_value_as_gvalue (_tmp2_, "name", _tmp5_);
#line 509 "../src/LocalBackend/LocalLibrary.vala"
		__vala_GValue_free0 (_tmp5_);
#line 510 "../src/LocalBackend/LocalLibrary.vala"
		_tmp6_ = builder;
#line 510 "../src/LocalBackend/LocalLibrary.vala"
		_tmp7_ = gda_sql_builder_get_statement (_tmp6_, &_inner_error0_);
#line 510 "../src/LocalBackend/LocalLibrary.vala"
		statement = _tmp7_;
#line 510 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 510 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (builder);
#line 4594 "LocalLibrary.c"
			goto __catch0_g_error;
		}
#line 512 "../src/LocalBackend/LocalLibrary.vala"
		_tmp8_ = self->priv->_connection;
#line 512 "../src/LocalBackend/LocalLibrary.vala"
		_tmp9_ = statement;
#line 512 "../src/LocalBackend/LocalLibrary.vala"
		gda_connection_statement_execute_non_select (_tmp8_, _tmp9_, NULL, &_tmp10_, &_inner_error0_);
#line 512 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (last_insert_row);
#line 512 "../src/LocalBackend/LocalLibrary.vala"
		last_insert_row = _tmp10_;
#line 512 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 512 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (last_insert_row);
#line 512 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (statement);
#line 512 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (builder);
#line 4615 "LocalLibrary.c"
			goto __catch0_g_error;
		}
#line 513 "../src/LocalBackend/LocalLibrary.vala"
		_tmp11_ = last_insert_row;
#line 513 "../src/LocalBackend/LocalLibrary.vala"
		if (_tmp11_ != NULL) {
#line 4622 "LocalLibrary.c"
			MusicLocalSmartPlaylist* local_sp = NULL;
			GdaSet* _tmp12_;
			GValue _tmp13_;
			GdaConnection* _tmp14_;
			MusicLocalSmartPlaylist* _tmp15_;
			MusicLocalSmartPlaylist* _tmp16_;
			MusicSmartPlaylistConditionalType _tmp17_;
			MusicSmartPlaylistConditionalType _tmp18_;
			MusicLocalSmartPlaylist* _tmp19_;
			gboolean _tmp20_;
			gboolean _tmp21_;
			MusicLocalSmartPlaylist* _tmp22_;
			guint _tmp23_;
			guint _tmp24_;
			MusicLocalSmartPlaylist* _tmp25_;
			GeeCollection* _tmp26_;
			GeeCollection* _tmp27_;
			MusicLocalSmartPlaylist* _tmp32_;
#line 514 "../src/LocalBackend/LocalLibrary.vala"
			_tmp12_ = last_insert_row;
#line 514 "../src/LocalBackend/LocalLibrary.vala"
			_tmp13_ = *gda_set_get_holder_value (_tmp12_, MUSIC_DATABASE_SMART_PLAYLISTS_ROWID);
#line 514 "../src/LocalBackend/LocalLibrary.vala"
			_tmp14_ = self->priv->_connection;
#line 514 "../src/LocalBackend/LocalLibrary.vala"
			_tmp15_ = music_local_smart_playlist_new (g_value_get_int64 (&_tmp13_), _tmp14_);
#line 514 "../src/LocalBackend/LocalLibrary.vala"
			local_sp = _tmp15_;
#line 515 "../src/LocalBackend/LocalLibrary.vala"
			_tmp16_ = local_sp;
#line 515 "../src/LocalBackend/LocalLibrary.vala"
			_tmp17_ = music_smart_playlist_get_conditional (p);
#line 515 "../src/LocalBackend/LocalLibrary.vala"
			_tmp18_ = _tmp17_;
#line 515 "../src/LocalBackend/LocalLibrary.vala"
			music_smart_playlist_set_conditional ((MusicSmartPlaylist*) _tmp16_, _tmp18_);
#line 516 "../src/LocalBackend/LocalLibrary.vala"
			_tmp19_ = local_sp;
#line 516 "../src/LocalBackend/LocalLibrary.vala"
			_tmp20_ = music_smart_playlist_get_limit (p);
#line 516 "../src/LocalBackend/LocalLibrary.vala"
			_tmp21_ = _tmp20_;
#line 516 "../src/LocalBackend/LocalLibrary.vala"
			music_smart_playlist_set_limit ((MusicSmartPlaylist*) _tmp19_, _tmp21_);
#line 517 "../src/LocalBackend/LocalLibrary.vala"
			_tmp22_ = local_sp;
#line 517 "../src/LocalBackend/LocalLibrary.vala"
			_tmp23_ = music_smart_playlist_get_limit_amount (p);
#line 517 "../src/LocalBackend/LocalLibrary.vala"
			_tmp24_ = _tmp23_;
#line 517 "../src/LocalBackend/LocalLibrary.vala"
			music_smart_playlist_set_limit_amount ((MusicSmartPlaylist*) _tmp22_, _tmp24_);
#line 518 "../src/LocalBackend/LocalLibrary.vala"
			_tmp25_ = local_sp;
#line 518 "../src/LocalBackend/LocalLibrary.vala"
			_tmp26_ = music_smart_playlist_get_queries (p);
#line 518 "../src/LocalBackend/LocalLibrary.vala"
			_tmp27_ = _tmp26_;
#line 518 "../src/LocalBackend/LocalLibrary.vala"
			music_smart_playlist_add_queries ((MusicSmartPlaylist*) _tmp25_, _tmp27_);
#line 518 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (_tmp27_);
#line 4685 "LocalLibrary.c"
			{
				GeeTreeSet* _tmp28_;
#line 520 "../src/LocalBackend/LocalLibrary.vala"
				_tmp28_ = self->priv->_smart_playlists;
#line 520 "../src/LocalBackend/LocalLibrary.vala"
				g_rec_mutex_lock (&self->priv->__lock__smart_playlists);
#line 4692 "LocalLibrary.c"
				{
					GeeTreeSet* _tmp29_;
					MusicLocalSmartPlaylist* _tmp30_;
#line 521 "../src/LocalBackend/LocalLibrary.vala"
					_tmp29_ = self->priv->_smart_playlists;
#line 521 "../src/LocalBackend/LocalLibrary.vala"
					_tmp30_ = local_sp;
#line 521 "../src/LocalBackend/LocalLibrary.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, (MusicSmartPlaylist*) _tmp30_);
#line 4702 "LocalLibrary.c"
				}
				__finally1:
				{
					GeeTreeSet* _tmp31_;
#line 520 "../src/LocalBackend/LocalLibrary.vala"
					_tmp31_ = self->priv->_smart_playlists;
#line 520 "../src/LocalBackend/LocalLibrary.vala"
					g_rec_mutex_unlock (&self->priv->__lock__smart_playlists);
#line 4711 "LocalLibrary.c"
				}
#line 520 "../src/LocalBackend/LocalLibrary.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 520 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (local_sp);
#line 520 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (last_insert_row);
#line 520 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (statement);
#line 520 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (builder);
#line 4723 "LocalLibrary.c"
					goto __catch0_g_error;
				}
			}
#line 524 "../src/LocalBackend/LocalLibrary.vala"
			_tmp32_ = local_sp;
#line 524 "../src/LocalBackend/LocalLibrary.vala"
			g_signal_emit_by_name ((MusicLibrary*) self, "smartplaylist-added", (MusicSmartPlaylist*) _tmp32_);
#line 513 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (local_sp);
#line 4733 "LocalLibrary.c"
		}
#line 506 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (last_insert_row);
#line 506 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (statement);
#line 506 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (builder);
#line 4741 "LocalLibrary.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp33_;
		const gchar* _tmp34_;
#line 506 "../src/LocalBackend/LocalLibrary.vala"
		e = _inner_error0_;
#line 506 "../src/LocalBackend/LocalLibrary.vala"
		_inner_error0_ = NULL;
#line 527 "../src/LocalBackend/LocalLibrary.vala"
		_tmp33_ = e;
#line 527 "../src/LocalBackend/LocalLibrary.vala"
		_tmp34_ = _tmp33_->message;
#line 527 "../src/LocalBackend/LocalLibrary.vala"
		g_critical ("LocalLibrary.vala:527: %s", _tmp34_);
#line 506 "../src/LocalBackend/LocalLibrary.vala"
		_g_error_free0 (e);
#line 4761 "LocalLibrary.c"
	}
	__finally0:
#line 506 "../src/LocalBackend/LocalLibrary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 506 "../src/LocalBackend/LocalLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 506 "../src/LocalBackend/LocalLibrary.vala"
		g_clear_error (&_inner_error0_);
#line 506 "../src/LocalBackend/LocalLibrary.vala"
		return;
#line 4772 "LocalLibrary.c"
	}
}

static void
music_local_library_real_remove_smart_playlist (MusicLibrary* base,
                                                gint64 id)
{
	MusicLocalLibrary * self;
	GError* _inner_error0_ = NULL;
#line 531 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 4784 "LocalLibrary.c"
	{
		GeeTreeSet* _tmp0_;
#line 532 "../src/LocalBackend/LocalLibrary.vala"
		_tmp0_ = self->priv->_smart_playlists;
#line 532 "../src/LocalBackend/LocalLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock__smart_playlists);
#line 4791 "LocalLibrary.c"
		{
			{
				GeeIterator* _p_it = NULL;
				GeeCollection* _tmp1_;
				GeeCollection* _tmp2_;
				GeeIterator* _tmp3_;
				GeeIterator* _tmp4_;
#line 533 "../src/LocalBackend/LocalLibrary.vala"
				_tmp1_ = music_library_get_smart_playlists ((MusicLibrary*) self);
#line 533 "../src/LocalBackend/LocalLibrary.vala"
				_tmp2_ = _tmp1_;
#line 533 "../src/LocalBackend/LocalLibrary.vala"
				_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 533 "../src/LocalBackend/LocalLibrary.vala"
				_tmp4_ = _tmp3_;
#line 533 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_tmp2_);
#line 533 "../src/LocalBackend/LocalLibrary.vala"
				_p_it = _tmp4_;
#line 533 "../src/LocalBackend/LocalLibrary.vala"
				while (TRUE) {
#line 4813 "LocalLibrary.c"
					GeeIterator* _tmp5_;
					MusicSmartPlaylist* p = NULL;
					GeeIterator* _tmp6_;
					gpointer _tmp7_;
					MusicSmartPlaylist* _tmp8_;
					gint64 _tmp9_;
					gint64 _tmp10_;
#line 533 "../src/LocalBackend/LocalLibrary.vala"
					_tmp5_ = _p_it;
#line 533 "../src/LocalBackend/LocalLibrary.vala"
					if (!gee_iterator_next (_tmp5_)) {
#line 533 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 4827 "LocalLibrary.c"
					}
#line 533 "../src/LocalBackend/LocalLibrary.vala"
					_tmp6_ = _p_it;
#line 533 "../src/LocalBackend/LocalLibrary.vala"
					_tmp7_ = gee_iterator_get (_tmp6_);
#line 533 "../src/LocalBackend/LocalLibrary.vala"
					p = (MusicSmartPlaylist*) _tmp7_;
#line 534 "../src/LocalBackend/LocalLibrary.vala"
					_tmp8_ = p;
#line 534 "../src/LocalBackend/LocalLibrary.vala"
					_tmp9_ = music_playlist_get_rowid ((MusicPlaylist*) _tmp8_);
#line 534 "../src/LocalBackend/LocalLibrary.vala"
					_tmp10_ = _tmp9_;
#line 534 "../src/LocalBackend/LocalLibrary.vala"
					if (_tmp10_ == id) {
#line 4843 "LocalLibrary.c"
						GeeTreeSet* _tmp11_;
						MusicSmartPlaylist* _tmp12_;
						MusicSmartPlaylist* _tmp13_;
#line 535 "../src/LocalBackend/LocalLibrary.vala"
						_tmp11_ = self->priv->_smart_playlists;
#line 535 "../src/LocalBackend/LocalLibrary.vala"
						_tmp12_ = p;
#line 535 "../src/LocalBackend/LocalLibrary.vala"
						gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 536 "../src/LocalBackend/LocalLibrary.vala"
						_tmp13_ = p;
#line 536 "../src/LocalBackend/LocalLibrary.vala"
						g_signal_emit_by_name ((MusicLibrary*) self, "smartplaylist-removed", _tmp13_);
#line 537 "../src/LocalBackend/LocalLibrary.vala"
						_g_object_unref0 (p);
#line 537 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 4861 "LocalLibrary.c"
					}
#line 533 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (p);
#line 4865 "LocalLibrary.c"
				}
#line 533 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_p_it);
#line 4869 "LocalLibrary.c"
			}
		}
		__finally0:
		{
			GeeTreeSet* _tmp14_;
#line 532 "../src/LocalBackend/LocalLibrary.vala"
			_tmp14_ = self->priv->_smart_playlists;
#line 532 "../src/LocalBackend/LocalLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock__smart_playlists);
#line 4879 "LocalLibrary.c"
		}
#line 532 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 532 "../src/LocalBackend/LocalLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 532 "../src/LocalBackend/LocalLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 532 "../src/LocalBackend/LocalLibrary.vala"
			return;
#line 4889 "LocalLibrary.c"
		}
	}
	{
		GdaConnection* _tmp15_;
		GValue _tmp16_ = {0};
#line 543 "../src/LocalBackend/LocalLibrary.vala"
		_tmp15_ = self->priv->_connection;
#line 543 "../src/LocalBackend/LocalLibrary.vala"
		g_value_init (&_tmp16_, G_TYPE_INT64);
#line 543 "../src/LocalBackend/LocalLibrary.vala"
		g_value_set_int64 (&_tmp16_, id);
#line 543 "../src/LocalBackend/LocalLibrary.vala"
		gda_connection_delete_row_from_table (_tmp15_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "rowid", &_tmp16_, &_inner_error0_);
#line 543 "../src/LocalBackend/LocalLibrary.vala"
		G_IS_VALUE (&_tmp16_) ? (g_value_unset (&_tmp16_), NULL) : NULL;
#line 543 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4907 "LocalLibrary.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 542 "../src/LocalBackend/LocalLibrary.vala"
		e = _inner_error0_;
#line 542 "../src/LocalBackend/LocalLibrary.vala"
		_inner_error0_ = NULL;
#line 545 "../src/LocalBackend/LocalLibrary.vala"
		_tmp17_ = e;
#line 545 "../src/LocalBackend/LocalLibrary.vala"
		_tmp18_ = _tmp17_->message;
#line 545 "../src/LocalBackend/LocalLibrary.vala"
		g_critical ("LocalLibrary.vala:545: %s", _tmp18_);
#line 542 "../src/LocalBackend/LocalLibrary.vala"
		_g_error_free0 (e);
#line 4929 "LocalLibrary.c"
	}
	__finally1:
#line 542 "../src/LocalBackend/LocalLibrary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 542 "../src/LocalBackend/LocalLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 542 "../src/LocalBackend/LocalLibrary.vala"
		g_clear_error (&_inner_error0_);
#line 542 "../src/LocalBackend/LocalLibrary.vala"
		return;
#line 4940 "LocalLibrary.c"
	}
}

/******************** Media stuff ******************/
static void
_vala_array_add1 (GdaSqlBuilderId* * array,
                  gint* length,
                  gint* size,
                  GdaSqlBuilderId value)
{
#line 607 "../src/LocalBackend/LocalLibrary.vala"
	if ((*length) == (*size)) {
#line 607 "../src/LocalBackend/LocalLibrary.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 607 "../src/LocalBackend/LocalLibrary.vala"
		*array = g_renew (GdaSqlBuilderId, *array, *size);
#line 4957 "LocalLibrary.c"
	}
#line 607 "../src/LocalBackend/LocalLibrary.vala"
	(*array)[(*length)++] = value;
#line 4961 "LocalLibrary.c"
}

static gboolean
__lambda35_ (MusicLocalLibrary* self)
{
	gboolean result;
#line 634 "../src/LocalBackend/LocalLibrary.vala"
	g_signal_emit_by_name ((MusicLibrary*) self, "search-finished");
#line 635 "../src/LocalBackend/LocalLibrary.vala"
	result = G_SOURCE_REMOVE;
#line 635 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 4974 "LocalLibrary.c"
}

static gboolean
___lambda35__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda35_ ((MusicLocalLibrary*) self);
#line 633 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 4984 "LocalLibrary.c"
}

static void
music_local_library_real_search_medias (MusicLibrary* base,
                                        const gchar* search)
{
	MusicLocalLibrary * self;
	guint parsed_rating = 0U;
	gchar* parsed_search_string = NULL;
	guint _tmp8_ = 0U;
	gchar* _tmp9_ = NULL;
	GError* _inner_error0_ = NULL;
#line 552 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 552 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (search != NULL);
#line 553 "../src/LocalBackend/LocalLibrary.vala"
	if (g_strcmp0 (search, "") == 0) {
#line 5003 "LocalLibrary.c"
		{
			GeeTreeSet* _tmp0_;
#line 554 "../src/LocalBackend/LocalLibrary.vala"
			_tmp0_ = self->priv->_searched_medias;
#line 554 "../src/LocalBackend/LocalLibrary.vala"
			g_rec_mutex_lock (&self->priv->__lock__searched_medias);
#line 5010 "LocalLibrary.c"
			{
				GeeTreeSet* _tmp1_;
				GeeTreeSet* _tmp2_;
				GeeHashMap* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
				GeeCollection* _tmp6_;
#line 555 "../src/LocalBackend/LocalLibrary.vala"
				_tmp1_ = self->priv->_searched_medias;
#line 555 "../src/LocalBackend/LocalLibrary.vala"
				gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
#line 556 "../src/LocalBackend/LocalLibrary.vala"
				_tmp2_ = self->priv->_searched_medias;
#line 556 "../src/LocalBackend/LocalLibrary.vala"
				_tmp3_ = self->priv->_medias;
#line 556 "../src/LocalBackend/LocalLibrary.vala"
				_tmp4_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp3_);
#line 556 "../src/LocalBackend/LocalLibrary.vala"
				_tmp5_ = _tmp4_;
#line 556 "../src/LocalBackend/LocalLibrary.vala"
				_tmp6_ = _tmp5_;
#line 556 "../src/LocalBackend/LocalLibrary.vala"
				gee_collection_add_all ((GeeCollection*) _tmp2_, _tmp6_);
#line 556 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_tmp6_);
#line 5036 "LocalLibrary.c"
			}
			__finally0:
			{
				GeeTreeSet* _tmp7_;
#line 554 "../src/LocalBackend/LocalLibrary.vala"
				_tmp7_ = self->priv->_searched_medias;
#line 554 "../src/LocalBackend/LocalLibrary.vala"
				g_rec_mutex_unlock (&self->priv->__lock__searched_medias);
#line 5045 "LocalLibrary.c"
			}
#line 554 "../src/LocalBackend/LocalLibrary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 554 "../src/LocalBackend/LocalLibrary.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 554 "../src/LocalBackend/LocalLibrary.vala"
				g_clear_error (&_inner_error0_);
#line 554 "../src/LocalBackend/LocalLibrary.vala"
				return;
#line 5055 "LocalLibrary.c"
			}
		}
#line 558 "../src/LocalBackend/LocalLibrary.vala"
		g_signal_emit_by_name ((MusicLibrary*) self, "search-finished");
#line 559 "../src/LocalBackend/LocalLibrary.vala"
		return;
#line 5062 "LocalLibrary.c"
	}
#line 564 "../src/LocalBackend/LocalLibrary.vala"
	music_string_base_search_method (search, &_tmp8_, &_tmp9_);
#line 564 "../src/LocalBackend/LocalLibrary.vala"
	parsed_rating = _tmp8_;
#line 564 "../src/LocalBackend/LocalLibrary.vala"
	_g_free0 (parsed_search_string);
#line 564 "../src/LocalBackend/LocalLibrary.vala"
	parsed_search_string = _tmp9_;
#line 5072 "LocalLibrary.c"
	{
#line 567 "../src/LocalBackend/LocalLibrary.vala"
		if (parsed_rating > ((guint) 0)) {
#line 5076 "LocalLibrary.c"
			GdaSqlBuilder* sql = NULL;
			GdaSqlBuilder* _tmp10_;
			GdaSqlBuilder* _tmp11_;
			GdaSqlBuilder* _tmp12_;
			GdaSqlBuilderId id_field = 0U;
			GdaSqlBuilder* _tmp13_;
			GdaSqlBuilderId id_value = 0U;
			GdaSqlBuilder* _tmp14_;
			GValue* _tmp15_ = NULL;
			GdaSqlBuilderId _tmp16_;
			GdaSqlBuilderId id_cond = 0U;
			GdaSqlBuilder* _tmp17_;
			GdaSqlBuilder* _tmp18_;
			GdaStatement* statm = NULL;
			GdaSqlBuilder* _tmp19_;
			GdaStatement* _tmp20_;
			GdaDataModel* data_model = NULL;
			GdaConnection* _tmp21_;
			GdaStatement* _tmp22_;
			GdaDataModel* _tmp23_;
			GdaDataModelIter* data_model_iter = NULL;
			GdaDataModel* _tmp24_;
			GdaDataModelIter* _tmp25_;
			GdaDataModelIter* _tmp26_;
			GeeTreeSet* rowids = NULL;
			GeeTreeSet* _tmp27_;
			GeeCollection* meds = NULL;
			GeeTreeSet* _tmp33_;
			GeeCollection* _tmp34_;
#line 568 "../src/LocalBackend/LocalLibrary.vala"
			_tmp10_ = gda_sql_builder_new (GDA_SQL_STATEMENT_SELECT);
#line 568 "../src/LocalBackend/LocalLibrary.vala"
			sql = _tmp10_;
#line 569 "../src/LocalBackend/LocalLibrary.vala"
			_tmp11_ = sql;
#line 569 "../src/LocalBackend/LocalLibrary.vala"
			gda_sql_builder_select_add_target (_tmp11_, MUSIC_DATABASE_MEDIA_TABLE_NAME, NULL);
#line 570 "../src/LocalBackend/LocalLibrary.vala"
			_tmp12_ = sql;
#line 570 "../src/LocalBackend/LocalLibrary.vala"
			gda_sql_builder_select_add_field (_tmp12_, "rowid", NULL, NULL);
#line 571 "../src/LocalBackend/LocalLibrary.vala"
			_tmp13_ = sql;
#line 571 "../src/LocalBackend/LocalLibrary.vala"
			id_field = gda_sql_builder_add_id (_tmp13_, "rating");
#line 572 "../src/LocalBackend/LocalLibrary.vala"
			_tmp14_ = sql;
#line 572 "../src/LocalBackend/LocalLibrary.vala"
			_tmp15_ = g_new0 (GValue, 1);
#line 572 "../src/LocalBackend/LocalLibrary.vala"
			g_value_init (_tmp15_, G_TYPE_UINT);
#line 572 "../src/LocalBackend/LocalLibrary.vala"
			g_value_set_uint (_tmp15_, parsed_rating);
#line 572 "../src/LocalBackend/LocalLibrary.vala"
			_tmp16_ = gda_sql_builder_add_expr_value (_tmp14_, NULL, _tmp15_);
#line 572 "../src/LocalBackend/LocalLibrary.vala"
			__vala_GValue_free0 (_tmp15_);
#line 572 "../src/LocalBackend/LocalLibrary.vala"
			id_value = _tmp16_;
#line 573 "../src/LocalBackend/LocalLibrary.vala"
			_tmp17_ = sql;
#line 573 "../src/LocalBackend/LocalLibrary.vala"
			id_cond = gda_sql_builder_add_cond (_tmp17_, GDA_SQL_OPERATOR_TYPE_GEQ, id_field, id_value, (GdaSqlBuilderId) 0);
#line 574 "../src/LocalBackend/LocalLibrary.vala"
			_tmp18_ = sql;
#line 574 "../src/LocalBackend/LocalLibrary.vala"
			gda_sql_builder_set_where (_tmp18_, id_cond);
#line 576 "../src/LocalBackend/LocalLibrary.vala"
			_tmp19_ = sql;
#line 576 "../src/LocalBackend/LocalLibrary.vala"
			_tmp20_ = gda_sql_builder_get_statement (_tmp19_, &_inner_error0_);
#line 576 "../src/LocalBackend/LocalLibrary.vala"
			statm = _tmp20_;
#line 576 "../src/LocalBackend/LocalLibrary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 576 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (sql);
#line 5154 "LocalLibrary.c"
				goto __catch1_g_error;
			}
#line 577 "../src/LocalBackend/LocalLibrary.vala"
			_tmp21_ = self->priv->_connection;
#line 577 "../src/LocalBackend/LocalLibrary.vala"
			_tmp22_ = statm;
#line 577 "../src/LocalBackend/LocalLibrary.vala"
			_tmp23_ = gda_connection_statement_execute_select (_tmp21_, _tmp22_, NULL, &_inner_error0_);
#line 577 "../src/LocalBackend/LocalLibrary.vala"
			data_model = _tmp23_;
#line 577 "../src/LocalBackend/LocalLibrary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 577 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (statm);
#line 577 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (sql);
#line 5171 "LocalLibrary.c"
				goto __catch1_g_error;
			}
#line 578 "../src/LocalBackend/LocalLibrary.vala"
			_tmp24_ = data_model;
#line 578 "../src/LocalBackend/LocalLibrary.vala"
			_tmp25_ = gda_data_model_create_iter (_tmp24_);
#line 578 "../src/LocalBackend/LocalLibrary.vala"
			data_model_iter = _tmp25_;
#line 579 "../src/LocalBackend/LocalLibrary.vala"
			_tmp26_ = data_model_iter;
#line 579 "../src/LocalBackend/LocalLibrary.vala"
			gda_data_model_iter_move_to_row (_tmp26_, -1);
#line 580 "../src/LocalBackend/LocalLibrary.vala"
			_tmp27_ = gee_tree_set_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 580 "../src/LocalBackend/LocalLibrary.vala"
			rowids = _tmp27_;
#line 581 "../src/LocalBackend/LocalLibrary.vala"
			while (TRUE) {
#line 5190 "LocalLibrary.c"
				GdaDataModelIter* _tmp28_;
				GValue* val = NULL;
				GdaDataModelIter* _tmp29_;
				GeeTreeSet* _tmp30_;
				GValue* _tmp31_;
				gint64 _tmp32_;
#line 581 "../src/LocalBackend/LocalLibrary.vala"
				_tmp28_ = data_model_iter;
#line 581 "../src/LocalBackend/LocalLibrary.vala"
				if (!gda_data_model_iter_move_next (_tmp28_)) {
#line 581 "../src/LocalBackend/LocalLibrary.vala"
					break;
#line 5203 "LocalLibrary.c"
				}
#line 582 "../src/LocalBackend/LocalLibrary.vala"
				_tmp29_ = data_model_iter;
#line 582 "../src/LocalBackend/LocalLibrary.vala"
				val = gda_data_model_iter_get_value_at (_tmp29_, 0);
#line 583 "../src/LocalBackend/LocalLibrary.vala"
				_tmp30_ = rowids;
#line 583 "../src/LocalBackend/LocalLibrary.vala"
				_tmp31_ = val;
#line 583 "../src/LocalBackend/LocalLibrary.vala"
				_tmp32_ = g_value_get_int64 (_tmp31_);
#line 583 "../src/LocalBackend/LocalLibrary.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, &_tmp32_);
#line 5217 "LocalLibrary.c"
			}
#line 586 "../src/LocalBackend/LocalLibrary.vala"
			_tmp33_ = rowids;
#line 586 "../src/LocalBackend/LocalLibrary.vala"
			_tmp34_ = music_library_medias_from_ids ((MusicLibrary*) self, (GeeCollection*) _tmp33_);
#line 586 "../src/LocalBackend/LocalLibrary.vala"
			meds = _tmp34_;
#line 5225 "LocalLibrary.c"
			{
				GeeTreeSet* _tmp35_;
#line 587 "../src/LocalBackend/LocalLibrary.vala"
				_tmp35_ = self->priv->_searched_medias;
#line 587 "../src/LocalBackend/LocalLibrary.vala"
				g_rec_mutex_lock (&self->priv->__lock__searched_medias);
#line 5232 "LocalLibrary.c"
				{
					GeeTreeSet* _tmp36_;
					GeeTreeSet* _tmp37_;
					GeeCollection* _tmp38_;
#line 588 "../src/LocalBackend/LocalLibrary.vala"
					_tmp36_ = self->priv->_searched_medias;
#line 588 "../src/LocalBackend/LocalLibrary.vala"
					gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp36_);
#line 589 "../src/LocalBackend/LocalLibrary.vala"
					_tmp37_ = self->priv->_searched_medias;
#line 589 "../src/LocalBackend/LocalLibrary.vala"
					_tmp38_ = meds;
#line 589 "../src/LocalBackend/LocalLibrary.vala"
					gee_collection_add_all ((GeeCollection*) _tmp37_, _tmp38_);
#line 5247 "LocalLibrary.c"
				}
				__finally2:
				{
					GeeTreeSet* _tmp39_;
#line 587 "../src/LocalBackend/LocalLibrary.vala"
					_tmp39_ = self->priv->_searched_medias;
#line 587 "../src/LocalBackend/LocalLibrary.vala"
					g_rec_mutex_unlock (&self->priv->__lock__searched_medias);
#line 5256 "LocalLibrary.c"
				}
#line 587 "../src/LocalBackend/LocalLibrary.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 587 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (meds);
#line 587 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (rowids);
#line 587 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (data_model_iter);
#line 587 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (data_model);
#line 587 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (statm);
#line 587 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (sql);
#line 5272 "LocalLibrary.c"
					goto __catch1_g_error;
				}
			}
#line 567 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (meds);
#line 567 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (rowids);
#line 567 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (data_model_iter);
#line 567 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (data_model);
#line 567 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (statm);
#line 567 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (sql);
#line 5288 "LocalLibrary.c"
		} else {
			GdaSqlBuilder* sql = NULL;
			GdaSqlBuilder* _tmp40_;
			GdaSqlBuilder* _tmp41_;
			GdaSqlBuilder* _tmp42_;
			GdaSqlBuilderId* ids = NULL;
			gint ids_length1;
			gint _ids_size_;
			gchar** fields = NULL;
			gchar* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			gchar* _tmp50_;
			gchar** _tmp51_;
			gint fields_length1;
			gint _fields_size_;
			gchar** _tmp52_;
			gint _tmp52__length1;
			GdaSqlBuilderId id_cond = 0U;
			GdaSqlBuilder* _tmp71_;
			GdaSqlBuilderId* _tmp72_;
			gint _tmp72__length1;
			GdaSqlBuilder* _tmp73_;
			GdaStatement* statm = NULL;
			GdaSqlBuilder* _tmp74_;
			GdaStatement* _tmp75_;
			GdaDataModel* data_model = NULL;
			GdaConnection* _tmp76_;
			GdaStatement* _tmp77_;
			GdaDataModel* _tmp78_;
			GdaDataModelIter* data_model_iter = NULL;
			GdaDataModel* _tmp79_;
			GdaDataModelIter* _tmp80_;
			GdaDataModelIter* _tmp81_;
			GeeTreeSet* rowids = NULL;
			GeeTreeSet* _tmp82_;
			GeeCollection* meds = NULL;
			GeeTreeSet* _tmp88_;
			GeeCollection* _tmp89_;
#line 592 "../src/LocalBackend/LocalLibrary.vala"
			_tmp40_ = gda_sql_builder_new (GDA_SQL_STATEMENT_SELECT);
#line 592 "../src/LocalBackend/LocalLibrary.vala"
			sql = _tmp40_;
#line 593 "../src/LocalBackend/LocalLibrary.vala"
			_tmp41_ = sql;
#line 593 "../src/LocalBackend/LocalLibrary.vala"
			gda_sql_builder_select_add_target (_tmp41_, MUSIC_DATABASE_MEDIA_TABLE_NAME, NULL);
#line 594 "../src/LocalBackend/LocalLibrary.vala"
			_tmp42_ = sql;
#line 594 "../src/LocalBackend/LocalLibrary.vala"
			gda_sql_builder_select_add_field (_tmp42_, "rowid", NULL, NULL);
#line 595 "../src/LocalBackend/LocalLibrary.vala"
			ids = NULL;
#line 595 "../src/LocalBackend/LocalLibrary.vala"
			ids_length1 = 0;
#line 595 "../src/LocalBackend/LocalLibrary.vala"
			_ids_size_ = ids_length1;
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_tmp43_ = g_strdup ("title");
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_tmp44_ = g_strdup ("artist");
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_tmp45_ = g_strdup ("composer");
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_tmp46_ = g_strdup ("album_artist");
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_tmp47_ = g_strdup ("album");
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_tmp48_ = g_strdup ("grouping");
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_tmp49_ = g_strdup ("comment");
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_tmp50_ = g_strdup ("uri");
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_tmp51_ = g_new0 (gchar*, 8 + 1);
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_tmp51_[0] = _tmp43_;
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_tmp51_[1] = _tmp44_;
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_tmp51_[2] = _tmp45_;
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_tmp51_[3] = _tmp46_;
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_tmp51_[4] = _tmp47_;
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_tmp51_[5] = _tmp48_;
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_tmp51_[6] = _tmp49_;
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_tmp51_[7] = _tmp50_;
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			fields = _tmp51_;
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			fields_length1 = 8;
#line 598 "../src/LocalBackend/LocalLibrary.vala"
			_fields_size_ = fields_length1;
#line 600 "../src/LocalBackend/LocalLibrary.vala"
			_tmp52_ = fields;
#line 600 "../src/LocalBackend/LocalLibrary.vala"
			_tmp52__length1 = fields_length1;
#line 5394 "LocalLibrary.c"
			{
				gchar** field_collection = NULL;
				gint field_collection_length1 = 0;
				gint _field_collection_size_ = 0;
				gint field_it = 0;
#line 600 "../src/LocalBackend/LocalLibrary.vala"
				field_collection = _tmp52_;
#line 600 "../src/LocalBackend/LocalLibrary.vala"
				field_collection_length1 = _tmp52__length1;
#line 600 "../src/LocalBackend/LocalLibrary.vala"
				for (field_it = 0; field_it < field_collection_length1; field_it = field_it + 1) {
#line 5406 "LocalLibrary.c"
					gchar* _tmp53_;
					gchar* field = NULL;
#line 600 "../src/LocalBackend/LocalLibrary.vala"
					_tmp53_ = g_strdup (field_collection[field_it]);
#line 600 "../src/LocalBackend/LocalLibrary.vala"
					field = _tmp53_;
#line 5413 "LocalLibrary.c"
					{
						GdaSqlBuilderId id_field = 0U;
						GdaSqlBuilder* _tmp54_;
						const gchar* _tmp55_;
						GdaSqlBuilderId id_value = 0U;
						GdaSqlBuilder* _tmp56_;
						gchar* _tmp57_;
						gchar* _tmp58_;
						gchar* _tmp59_;
						GValue* _tmp60_ = NULL;
						GdaSqlBuilderId _tmp61_;
						const gchar* _tmp62_;
						GdaSqlBuilder* _tmp70_;
#line 601 "../src/LocalBackend/LocalLibrary.vala"
						_tmp54_ = sql;
#line 601 "../src/LocalBackend/LocalLibrary.vala"
						_tmp55_ = field;
#line 601 "../src/LocalBackend/LocalLibrary.vala"
						id_field = gda_sql_builder_add_id (_tmp54_, _tmp55_);
#line 602 "../src/LocalBackend/LocalLibrary.vala"
						_tmp56_ = sql;
#line 602 "../src/LocalBackend/LocalLibrary.vala"
						_tmp57_ = g_strconcat ("%", search, NULL);
#line 602 "../src/LocalBackend/LocalLibrary.vala"
						_tmp58_ = _tmp57_;
#line 602 "../src/LocalBackend/LocalLibrary.vala"
						_tmp59_ = g_strconcat (_tmp58_, "%", NULL);
#line 602 "../src/LocalBackend/LocalLibrary.vala"
						_tmp60_ = g_new0 (GValue, 1);
#line 602 "../src/LocalBackend/LocalLibrary.vala"
						g_value_init (_tmp60_, G_TYPE_STRING);
#line 602 "../src/LocalBackend/LocalLibrary.vala"
						g_value_take_string (_tmp60_, _tmp59_);
#line 602 "../src/LocalBackend/LocalLibrary.vala"
						_tmp61_ = gda_sql_builder_add_expr_value (_tmp56_, NULL, _tmp60_);
#line 602 "../src/LocalBackend/LocalLibrary.vala"
						__vala_GValue_free0 (_tmp60_);
#line 602 "../src/LocalBackend/LocalLibrary.vala"
						_g_free0 (_tmp58_);
#line 602 "../src/LocalBackend/LocalLibrary.vala"
						id_value = _tmp61_;
#line 603 "../src/LocalBackend/LocalLibrary.vala"
						_tmp62_ = field;
#line 603 "../src/LocalBackend/LocalLibrary.vala"
						if (g_strcmp0 (_tmp62_, "uri") == 0) {
#line 5459 "LocalLibrary.c"
							GdaSqlBuilder* _tmp63_;
							gchar* _tmp64_;
							gchar* _tmp65_;
							gchar* _tmp66_;
							gchar* _tmp67_;
							gchar* _tmp68_;
							GValue* _tmp69_ = NULL;
#line 604 "../src/LocalBackend/LocalLibrary.vala"
							_tmp63_ = sql;
#line 604 "../src/LocalBackend/LocalLibrary.vala"
							_tmp64_ = g_uri_escape_string (search, "/", TRUE);
#line 604 "../src/LocalBackend/LocalLibrary.vala"
							_tmp65_ = _tmp64_;
#line 604 "../src/LocalBackend/LocalLibrary.vala"
							_tmp66_ = g_strconcat ("%", _tmp65_, NULL);
#line 604 "../src/LocalBackend/LocalLibrary.vala"
							_tmp67_ = _tmp66_;
#line 604 "../src/LocalBackend/LocalLibrary.vala"
							_tmp68_ = g_strconcat (_tmp67_, "%", NULL);
#line 604 "../src/LocalBackend/LocalLibrary.vala"
							_tmp69_ = g_new0 (GValue, 1);
#line 604 "../src/LocalBackend/LocalLibrary.vala"
							g_value_init (_tmp69_, G_TYPE_STRING);
#line 604 "../src/LocalBackend/LocalLibrary.vala"
							g_value_take_string (_tmp69_, _tmp68_);
#line 604 "../src/LocalBackend/LocalLibrary.vala"
							id_value = gda_sql_builder_add_expr_value (_tmp63_, NULL, _tmp69_);
#line 604 "../src/LocalBackend/LocalLibrary.vala"
							__vala_GValue_free0 (_tmp69_);
#line 604 "../src/LocalBackend/LocalLibrary.vala"
							_g_free0 (_tmp67_);
#line 604 "../src/LocalBackend/LocalLibrary.vala"
							_g_free0 (_tmp65_);
#line 5493 "LocalLibrary.c"
						}
#line 607 "../src/LocalBackend/LocalLibrary.vala"
						_tmp70_ = sql;
#line 607 "../src/LocalBackend/LocalLibrary.vala"
						_vala_array_add1 (&ids, &ids_length1, &_ids_size_, gda_sql_builder_add_cond (_tmp70_, GDA_SQL_OPERATOR_TYPE_LIKE, id_field, id_value, (GdaSqlBuilderId) 0));
#line 600 "../src/LocalBackend/LocalLibrary.vala"
						_g_free0 (field);
#line 5501 "LocalLibrary.c"
					}
				}
			}
#line 610 "../src/LocalBackend/LocalLibrary.vala"
			_tmp71_ = sql;
#line 610 "../src/LocalBackend/LocalLibrary.vala"
			_tmp72_ = ids;
#line 610 "../src/LocalBackend/LocalLibrary.vala"
			_tmp72__length1 = ids_length1;
#line 610 "../src/LocalBackend/LocalLibrary.vala"
			id_cond = gda_sql_builder_add_cond_v (_tmp71_, GDA_SQL_OPERATOR_TYPE_OR, _tmp72_, (gint) _tmp72__length1);
#line 611 "../src/LocalBackend/LocalLibrary.vala"
			_tmp73_ = sql;
#line 611 "../src/LocalBackend/LocalLibrary.vala"
			gda_sql_builder_set_where (_tmp73_, id_cond);
#line 613 "../src/LocalBackend/LocalLibrary.vala"
			_tmp74_ = sql;
#line 613 "../src/LocalBackend/LocalLibrary.vala"
			_tmp75_ = gda_sql_builder_get_statement (_tmp74_, &_inner_error0_);
#line 613 "../src/LocalBackend/LocalLibrary.vala"
			statm = _tmp75_;
#line 613 "../src/LocalBackend/LocalLibrary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 613 "../src/LocalBackend/LocalLibrary.vala"
				fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 613 "../src/LocalBackend/LocalLibrary.vala"
				ids = (g_free (ids), NULL);
#line 613 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (sql);
#line 5531 "LocalLibrary.c"
				goto __catch1_g_error;
			}
#line 614 "../src/LocalBackend/LocalLibrary.vala"
			_tmp76_ = self->priv->_connection;
#line 614 "../src/LocalBackend/LocalLibrary.vala"
			_tmp77_ = statm;
#line 614 "../src/LocalBackend/LocalLibrary.vala"
			_tmp78_ = gda_connection_statement_execute_select (_tmp76_, _tmp77_, NULL, &_inner_error0_);
#line 614 "../src/LocalBackend/LocalLibrary.vala"
			data_model = _tmp78_;
#line 614 "../src/LocalBackend/LocalLibrary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 614 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (statm);
#line 614 "../src/LocalBackend/LocalLibrary.vala"
				fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 614 "../src/LocalBackend/LocalLibrary.vala"
				ids = (g_free (ids), NULL);
#line 614 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (sql);
#line 5552 "LocalLibrary.c"
				goto __catch1_g_error;
			}
#line 615 "../src/LocalBackend/LocalLibrary.vala"
			_tmp79_ = data_model;
#line 615 "../src/LocalBackend/LocalLibrary.vala"
			_tmp80_ = gda_data_model_create_iter (_tmp79_);
#line 615 "../src/LocalBackend/LocalLibrary.vala"
			data_model_iter = _tmp80_;
#line 616 "../src/LocalBackend/LocalLibrary.vala"
			_tmp81_ = data_model_iter;
#line 616 "../src/LocalBackend/LocalLibrary.vala"
			gda_data_model_iter_move_to_row (_tmp81_, -1);
#line 617 "../src/LocalBackend/LocalLibrary.vala"
			_tmp82_ = gee_tree_set_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 617 "../src/LocalBackend/LocalLibrary.vala"
			rowids = _tmp82_;
#line 618 "../src/LocalBackend/LocalLibrary.vala"
			while (TRUE) {
#line 5571 "LocalLibrary.c"
				GdaDataModelIter* _tmp83_;
				GValue* val = NULL;
				GdaDataModelIter* _tmp84_;
				GeeTreeSet* _tmp85_;
				GValue* _tmp86_;
				gint64 _tmp87_;
#line 618 "../src/LocalBackend/LocalLibrary.vala"
				_tmp83_ = data_model_iter;
#line 618 "../src/LocalBackend/LocalLibrary.vala"
				if (!gda_data_model_iter_move_next (_tmp83_)) {
#line 618 "../src/LocalBackend/LocalLibrary.vala"
					break;
#line 5584 "LocalLibrary.c"
				}
#line 619 "../src/LocalBackend/LocalLibrary.vala"
				_tmp84_ = data_model_iter;
#line 619 "../src/LocalBackend/LocalLibrary.vala"
				val = gda_data_model_iter_get_value_at (_tmp84_, 0);
#line 620 "../src/LocalBackend/LocalLibrary.vala"
				_tmp85_ = rowids;
#line 620 "../src/LocalBackend/LocalLibrary.vala"
				_tmp86_ = val;
#line 620 "../src/LocalBackend/LocalLibrary.vala"
				_tmp87_ = g_value_get_int64 (_tmp86_);
#line 620 "../src/LocalBackend/LocalLibrary.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp85_, &_tmp87_);
#line 5598 "LocalLibrary.c"
			}
#line 623 "../src/LocalBackend/LocalLibrary.vala"
			_tmp88_ = rowids;
#line 623 "../src/LocalBackend/LocalLibrary.vala"
			_tmp89_ = music_library_medias_from_ids ((MusicLibrary*) self, (GeeCollection*) _tmp88_);
#line 623 "../src/LocalBackend/LocalLibrary.vala"
			meds = _tmp89_;
#line 5606 "LocalLibrary.c"
			{
				GeeTreeSet* _tmp90_;
#line 624 "../src/LocalBackend/LocalLibrary.vala"
				_tmp90_ = self->priv->_searched_medias;
#line 624 "../src/LocalBackend/LocalLibrary.vala"
				g_rec_mutex_lock (&self->priv->__lock__searched_medias);
#line 5613 "LocalLibrary.c"
				{
					GeeTreeSet* _tmp91_;
					GeeTreeSet* _tmp92_;
					GeeCollection* _tmp93_;
#line 625 "../src/LocalBackend/LocalLibrary.vala"
					_tmp91_ = self->priv->_searched_medias;
#line 625 "../src/LocalBackend/LocalLibrary.vala"
					gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp91_);
#line 626 "../src/LocalBackend/LocalLibrary.vala"
					_tmp92_ = self->priv->_searched_medias;
#line 626 "../src/LocalBackend/LocalLibrary.vala"
					_tmp93_ = meds;
#line 626 "../src/LocalBackend/LocalLibrary.vala"
					gee_collection_add_all ((GeeCollection*) _tmp92_, _tmp93_);
#line 5628 "LocalLibrary.c"
				}
				__finally3:
				{
					GeeTreeSet* _tmp94_;
#line 624 "../src/LocalBackend/LocalLibrary.vala"
					_tmp94_ = self->priv->_searched_medias;
#line 624 "../src/LocalBackend/LocalLibrary.vala"
					g_rec_mutex_unlock (&self->priv->__lock__searched_medias);
#line 5637 "LocalLibrary.c"
				}
#line 624 "../src/LocalBackend/LocalLibrary.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 624 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (meds);
#line 624 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (rowids);
#line 624 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (data_model_iter);
#line 624 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (data_model);
#line 624 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (statm);
#line 624 "../src/LocalBackend/LocalLibrary.vala"
					fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 624 "../src/LocalBackend/LocalLibrary.vala"
					ids = (g_free (ids), NULL);
#line 624 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (sql);
#line 5657 "LocalLibrary.c"
					goto __catch1_g_error;
				}
			}
#line 567 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (meds);
#line 567 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (rowids);
#line 567 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (data_model_iter);
#line 567 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (data_model);
#line 567 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (statm);
#line 567 "../src/LocalBackend/LocalLibrary.vala"
			fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 567 "../src/LocalBackend/LocalLibrary.vala"
			ids = (g_free (ids), NULL);
#line 567 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (sql);
#line 5677 "LocalLibrary.c"
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp95_;
		const gchar* _tmp96_;
#line 566 "../src/LocalBackend/LocalLibrary.vala"
		e = _inner_error0_;
#line 566 "../src/LocalBackend/LocalLibrary.vala"
		_inner_error0_ = NULL;
#line 630 "../src/LocalBackend/LocalLibrary.vala"
		_tmp95_ = e;
#line 630 "../src/LocalBackend/LocalLibrary.vala"
		_tmp96_ = _tmp95_->message;
#line 630 "../src/LocalBackend/LocalLibrary.vala"
		g_critical ("LocalLibrary.vala:630: Could not search for %s: %s", search, _tmp96_);
#line 566 "../src/LocalBackend/LocalLibrary.vala"
		_g_error_free0 (e);
#line 5698 "LocalLibrary.c"
	}
	__finally1:
#line 566 "../src/LocalBackend/LocalLibrary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 566 "../src/LocalBackend/LocalLibrary.vala"
		_g_free0 (parsed_search_string);
#line 566 "../src/LocalBackend/LocalLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 566 "../src/LocalBackend/LocalLibrary.vala"
		g_clear_error (&_inner_error0_);
#line 566 "../src/LocalBackend/LocalLibrary.vala"
		return;
#line 5711 "LocalLibrary.c"
	}
#line 633 "../src/LocalBackend/LocalLibrary.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda35__gsource_func, g_object_ref (self), g_object_unref);
#line 552 "../src/LocalBackend/LocalLibrary.vala"
	_g_free0 (parsed_search_string);
#line 5717 "LocalLibrary.c"
}

static GeeCollection*
music_local_library_real_get_search_result (MusicLibrary* base)
{
	MusicLocalLibrary * self;
	GeeTreeSet* _result_ = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	GeeCollection* result;
#line 639 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 640 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 640 "../src/LocalBackend/LocalLibrary.vala"
	_result_ = _tmp0_;
#line 641 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = self->priv->_searched_medias;
#line 641 "../src/LocalBackend/LocalLibrary.vala"
	gee_collection_add_all ((GeeCollection*) _result_, (GeeCollection*) _tmp1_);
#line 642 "../src/LocalBackend/LocalLibrary.vala"
	result = (GeeCollection*) _result_;
#line 642 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 5742 "LocalLibrary.c"
}

void
music_local_library_clear_medias (MusicLocalLibrary* self)
{
	GeeLinkedList* unset = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp19_;
#line 645 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (self != NULL);
#line 646 "../src/LocalBackend/LocalLibrary.vala"
	g_message ("LocalLibrary.vala:646: -- Clearing medias");
#line 650 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 650 "../src/LocalBackend/LocalLibrary.vala"
	unset = _tmp0_;
#line 5759 "LocalLibrary.c"
	{
		GeeIterator* _s_it = NULL;
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 651 "../src/LocalBackend/LocalLibrary.vala"
		_tmp1_ = self->priv->_medias;
#line 651 "../src/LocalBackend/LocalLibrary.vala"
		_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 651 "../src/LocalBackend/LocalLibrary.vala"
		_tmp3_ = _tmp2_;
#line 651 "../src/LocalBackend/LocalLibrary.vala"
		_tmp4_ = _tmp3_;
#line 651 "../src/LocalBackend/LocalLibrary.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 651 "../src/LocalBackend/LocalLibrary.vala"
		_tmp6_ = _tmp5_;
#line 651 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_tmp4_);
#line 651 "../src/LocalBackend/LocalLibrary.vala"
		_s_it = _tmp6_;
#line 651 "../src/LocalBackend/LocalLibrary.vala"
		while (TRUE) {
#line 5786 "LocalLibrary.c"
			GeeIterator* _tmp7_;
			MusicMedia* s = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			gboolean _tmp10_ = FALSE;
			MusicMedia* _tmp11_;
			gboolean _tmp12_;
			gboolean _tmp13_;
#line 651 "../src/LocalBackend/LocalLibrary.vala"
			_tmp7_ = _s_it;
#line 651 "../src/LocalBackend/LocalLibrary.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 651 "../src/LocalBackend/LocalLibrary.vala"
				break;
#line 5801 "LocalLibrary.c"
			}
#line 651 "../src/LocalBackend/LocalLibrary.vala"
			_tmp8_ = _s_it;
#line 651 "../src/LocalBackend/LocalLibrary.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 651 "../src/LocalBackend/LocalLibrary.vala"
			s = (MusicMedia*) _tmp9_;
#line 652 "../src/LocalBackend/LocalLibrary.vala"
			_tmp11_ = s;
#line 652 "../src/LocalBackend/LocalLibrary.vala"
			_tmp12_ = music_media_get_is_temporary (_tmp11_);
#line 652 "../src/LocalBackend/LocalLibrary.vala"
			_tmp13_ = _tmp12_;
#line 652 "../src/LocalBackend/LocalLibrary.vala"
			if (!_tmp13_) {
#line 5817 "LocalLibrary.c"
				MusicMedia* _tmp14_;
				gboolean _tmp15_;
				gboolean _tmp16_;
#line 652 "../src/LocalBackend/LocalLibrary.vala"
				_tmp14_ = s;
#line 652 "../src/LocalBackend/LocalLibrary.vala"
				_tmp15_ = music_media_get_is_preview (_tmp14_);
#line 652 "../src/LocalBackend/LocalLibrary.vala"
				_tmp16_ = _tmp15_;
#line 652 "../src/LocalBackend/LocalLibrary.vala"
				_tmp10_ = !_tmp16_;
#line 5829 "LocalLibrary.c"
			} else {
#line 652 "../src/LocalBackend/LocalLibrary.vala"
				_tmp10_ = FALSE;
#line 5833 "LocalLibrary.c"
			}
#line 652 "../src/LocalBackend/LocalLibrary.vala"
			if (_tmp10_) {
#line 5837 "LocalLibrary.c"
				GeeLinkedList* _tmp17_;
				MusicMedia* _tmp18_;
#line 653 "../src/LocalBackend/LocalLibrary.vala"
				_tmp17_ = unset;
#line 653 "../src/LocalBackend/LocalLibrary.vala"
				_tmp18_ = s;
#line 653 "../src/LocalBackend/LocalLibrary.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp18_);
#line 5846 "LocalLibrary.c"
			}
#line 651 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (s);
#line 5850 "LocalLibrary.c"
		}
#line 651 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_s_it);
#line 5854 "LocalLibrary.c"
	}
#line 656 "../src/LocalBackend/LocalLibrary.vala"
	_tmp19_ = unset;
#line 656 "../src/LocalBackend/LocalLibrary.vala"
	music_library_remove_medias ((MusicLibrary*) self, (GeeCollection*) _tmp19_, FALSE);
#line 657 "../src/LocalBackend/LocalLibrary.vala"
	g_debug ("LocalLibrary.vala:657: --- MEDIAS CLEARED ---");
#line 645 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (unset);
#line 5864 "LocalLibrary.c"
}

static GeeCollection*
music_local_library_real_get_medias (MusicLibrary* base)
{
	MusicLocalLibrary * self;
	GeeTreeSet* _result_ = NULL;
	GeeTreeSet* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* result;
#line 660 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 661 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 661 "../src/LocalBackend/LocalLibrary.vala"
	_result_ = _tmp0_;
#line 662 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = self->priv->_medias;
#line 662 "../src/LocalBackend/LocalLibrary.vala"
	_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 662 "../src/LocalBackend/LocalLibrary.vala"
	_tmp3_ = _tmp2_;
#line 662 "../src/LocalBackend/LocalLibrary.vala"
	_tmp4_ = _tmp3_;
#line 662 "../src/LocalBackend/LocalLibrary.vala"
	gee_collection_add_all ((GeeCollection*) _result_, _tmp4_);
#line 662 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_tmp4_);
#line 663 "../src/LocalBackend/LocalLibrary.vala"
	result = (GeeCollection*) _result_;
#line 663 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 5900 "LocalLibrary.c"
}

static void
music_local_library_real_update_media (MusicLibrary* base,
                                       MusicMedia* s,
                                       gboolean update_meta,
                                       gboolean record_time)
{
	MusicLocalLibrary * self;
	GeeTreeSet* one = NULL;
	GeeTreeSet* _tmp0_;
#line 666 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 666 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (s != NULL);
#line 667 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 667 "../src/LocalBackend/LocalLibrary.vala"
	one = _tmp0_;
#line 668 "../src/LocalBackend/LocalLibrary.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) one, s);
#line 669 "../src/LocalBackend/LocalLibrary.vala"
	music_library_update_medias ((MusicLibrary*) self, (GeeCollection*) one, update_meta, record_time);
#line 666 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (one);
#line 5926 "LocalLibrary.c"
}

static void
music_local_library_real_update_medias (MusicLibrary* base,
                                        GeeCollection* updates,
                                        gboolean update_meta,
                                        gboolean record_time)
{
	MusicLocalLibrary * self;
	GeeTreeSet* updated = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	GeeTreeSet* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	GeeTreeSet* _tmp12_;
	GeeBidirSortedSet* _tmp13_;
	GeeBidirSortedSet* _tmp14_;
	GeeBidirSortedSet* _tmp15_;
#line 672 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 672 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (updates != NULL);
#line 673 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 673 "../src/LocalBackend/LocalLibrary.vala"
	updated = _tmp0_;
#line 674 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = updated;
#line 674 "../src/LocalBackend/LocalLibrary.vala"
	gee_collection_add_all ((GeeCollection*) _tmp1_, updates);
#line 675 "../src/LocalBackend/LocalLibrary.vala"
	if (record_time) {
#line 5960 "LocalLibrary.c"
		{
			GeeIterator* _s_it = NULL;
			GeeTreeSet* _tmp2_;
			GeeIterator* _tmp3_;
#line 676 "../src/LocalBackend/LocalLibrary.vala"
			_tmp2_ = updated;
#line 676 "../src/LocalBackend/LocalLibrary.vala"
			_tmp3_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp2_);
#line 676 "../src/LocalBackend/LocalLibrary.vala"
			_s_it = _tmp3_;
#line 676 "../src/LocalBackend/LocalLibrary.vala"
			while (TRUE) {
#line 5973 "LocalLibrary.c"
				GeeIterator* _tmp4_;
				MusicMedia* s = NULL;
				GeeIterator* _tmp5_;
				gpointer _tmp6_;
				MusicMedia* _tmp7_;
				time_t _tmp8_;
#line 676 "../src/LocalBackend/LocalLibrary.vala"
				_tmp4_ = _s_it;
#line 676 "../src/LocalBackend/LocalLibrary.vala"
				if (!gee_iterator_next (_tmp4_)) {
#line 676 "../src/LocalBackend/LocalLibrary.vala"
					break;
#line 5986 "LocalLibrary.c"
				}
#line 676 "../src/LocalBackend/LocalLibrary.vala"
				_tmp5_ = _s_it;
#line 676 "../src/LocalBackend/LocalLibrary.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 676 "../src/LocalBackend/LocalLibrary.vala"
				s = (MusicMedia*) _tmp6_;
#line 677 "../src/LocalBackend/LocalLibrary.vala"
				_tmp7_ = s;
#line 677 "../src/LocalBackend/LocalLibrary.vala"
				_tmp8_ = time (NULL);
#line 677 "../src/LocalBackend/LocalLibrary.vala"
				music_media_set_last_modified (_tmp7_, (guint) ((gint) _tmp8_));
#line 676 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (s);
#line 6002 "LocalLibrary.c"
			}
#line 676 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (_s_it);
#line 6006 "LocalLibrary.c"
		}
	}
#line 681 "../src/LocalBackend/LocalLibrary.vala"
	_tmp9_ = updated;
#line 681 "../src/LocalBackend/LocalLibrary.vala"
	_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
#line 681 "../src/LocalBackend/LocalLibrary.vala"
	_tmp11_ = _tmp10_;
#line 681 "../src/LocalBackend/LocalLibrary.vala"
	g_debug ("LocalLibrary.vala:681: %d media updated", _tmp11_);
#line 682 "../src/LocalBackend/LocalLibrary.vala"
	_tmp12_ = updated;
#line 682 "../src/LocalBackend/LocalLibrary.vala"
	_tmp13_ = gee_abstract_bidir_sorted_set_get_read_only_view ((GeeAbstractBidirSortedSet*) _tmp12_);
#line 682 "../src/LocalBackend/LocalLibrary.vala"
	_tmp14_ = _tmp13_;
#line 682 "../src/LocalBackend/LocalLibrary.vala"
	_tmp15_ = _tmp14_;
#line 682 "../src/LocalBackend/LocalLibrary.vala"
	g_signal_emit_by_name ((MusicLibrary*) self, "media-updated", (GeeCollection*) _tmp15_);
#line 682 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_tmp15_);
#line 684 "../src/LocalBackend/LocalLibrary.vala"
	if (update_meta) {
#line 6031 "LocalLibrary.c"
		MusicFileOperator* _tmp16_;
		GeeTreeSet* _tmp17_;
#line 685 "../src/LocalBackend/LocalLibrary.vala"
		_tmp16_ = self->priv->fo;
#line 685 "../src/LocalBackend/LocalLibrary.vala"
		_tmp17_ = updated;
#line 685 "../src/LocalBackend/LocalLibrary.vala"
		music_file_operator_save_media (_tmp16_, (GeeCollection*) _tmp17_, NULL, NULL);
#line 6040 "LocalLibrary.c"
	}
#line 672 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (updated);
#line 6044 "LocalLibrary.c"
}

/**
     * Used extensively. All other media data stores a media rowid, and then
     * use this to retrieve the media. This is for memory saving and
     * consistency
     */
static MusicMedia*
music_local_library_real_media_from_id (MusicLibrary* base,
                                        gint64 id)
{
	MusicLocalLibrary * self;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	MusicMedia* result;
#line 694 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 695 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = self->priv->_medias;
#line 695 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, &id);
#line 695 "../src/LocalBackend/LocalLibrary.vala"
	result = (MusicMedia*) _tmp1_;
#line 695 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 6070 "LocalLibrary.c"
}

static MusicMedia*
music_local_library_real_find_media (MusicLibrary* base,
                                     MusicMedia* to_find)
{
	MusicLocalLibrary * self;
	MusicMedia* found = NULL;
	GError* _inner_error0_ = NULL;
	MusicMedia* result;
#line 698 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 698 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (to_find != NULL, NULL);
#line 699 "../src/LocalBackend/LocalLibrary.vala"
	found = NULL;
#line 6087 "LocalLibrary.c"
	{
		GeeHashMap* _tmp0_;
#line 700 "../src/LocalBackend/LocalLibrary.vala"
		_tmp0_ = self->priv->_medias;
#line 700 "../src/LocalBackend/LocalLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock__medias);
#line 6094 "LocalLibrary.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp1_;
				GeeCollection* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeIterator* _tmp5_;
				GeeIterator* _tmp6_;
#line 701 "../src/LocalBackend/LocalLibrary.vala"
				_tmp1_ = self->priv->_medias;
#line 701 "../src/LocalBackend/LocalLibrary.vala"
				_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 701 "../src/LocalBackend/LocalLibrary.vala"
				_tmp3_ = _tmp2_;
#line 701 "../src/LocalBackend/LocalLibrary.vala"
				_tmp4_ = _tmp3_;
#line 701 "../src/LocalBackend/LocalLibrary.vala"
				_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 701 "../src/LocalBackend/LocalLibrary.vala"
				_tmp6_ = _tmp5_;
#line 701 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_tmp4_);
#line 701 "../src/LocalBackend/LocalLibrary.vala"
				_m_it = _tmp6_;
#line 701 "../src/LocalBackend/LocalLibrary.vala"
				while (TRUE) {
#line 6122 "LocalLibrary.c"
					GeeIterator* _tmp7_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp8_;
					gpointer _tmp9_;
					gboolean _tmp10_ = FALSE;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					MusicMedia* _tmp15_;
					const gchar* _tmp16_;
					const gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					gboolean _tmp20_;
#line 701 "../src/LocalBackend/LocalLibrary.vala"
					_tmp7_ = _m_it;
#line 701 "../src/LocalBackend/LocalLibrary.vala"
					if (!gee_iterator_next (_tmp7_)) {
#line 701 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 6144 "LocalLibrary.c"
					}
#line 701 "../src/LocalBackend/LocalLibrary.vala"
					_tmp8_ = _m_it;
#line 701 "../src/LocalBackend/LocalLibrary.vala"
					_tmp9_ = gee_iterator_get (_tmp8_);
#line 701 "../src/LocalBackend/LocalLibrary.vala"
					m = (MusicMedia*) _tmp9_;
#line 702 "../src/LocalBackend/LocalLibrary.vala"
					_tmp11_ = music_media_get_title (to_find);
#line 702 "../src/LocalBackend/LocalLibrary.vala"
					_tmp12_ = _tmp11_;
#line 702 "../src/LocalBackend/LocalLibrary.vala"
					_tmp13_ = g_utf8_strdown (_tmp12_, (gssize) -1);
#line 702 "../src/LocalBackend/LocalLibrary.vala"
					_tmp14_ = _tmp13_;
#line 702 "../src/LocalBackend/LocalLibrary.vala"
					_tmp15_ = m;
#line 702 "../src/LocalBackend/LocalLibrary.vala"
					_tmp16_ = music_media_get_title (_tmp15_);
#line 702 "../src/LocalBackend/LocalLibrary.vala"
					_tmp17_ = _tmp16_;
#line 702 "../src/LocalBackend/LocalLibrary.vala"
					_tmp18_ = g_utf8_strdown (_tmp17_, (gssize) -1);
#line 702 "../src/LocalBackend/LocalLibrary.vala"
					_tmp19_ = _tmp18_;
#line 702 "../src/LocalBackend/LocalLibrary.vala"
					_tmp20_ = g_strcmp0 (_tmp14_, _tmp19_) == 0;
#line 702 "../src/LocalBackend/LocalLibrary.vala"
					_g_free0 (_tmp19_);
#line 702 "../src/LocalBackend/LocalLibrary.vala"
					_g_free0 (_tmp14_);
#line 702 "../src/LocalBackend/LocalLibrary.vala"
					if (_tmp20_) {
#line 6178 "LocalLibrary.c"
						const gchar* _tmp21_;
						const gchar* _tmp22_;
						gchar* _tmp23_;
						gchar* _tmp24_;
						MusicMedia* _tmp25_;
						const gchar* _tmp26_;
						const gchar* _tmp27_;
						gchar* _tmp28_;
						gchar* _tmp29_;
#line 702 "../src/LocalBackend/LocalLibrary.vala"
						_tmp21_ = music_media_get_artist (to_find);
#line 702 "../src/LocalBackend/LocalLibrary.vala"
						_tmp22_ = _tmp21_;
#line 702 "../src/LocalBackend/LocalLibrary.vala"
						_tmp23_ = g_utf8_strdown (_tmp22_, (gssize) -1);
#line 702 "../src/LocalBackend/LocalLibrary.vala"
						_tmp24_ = _tmp23_;
#line 702 "../src/LocalBackend/LocalLibrary.vala"
						_tmp25_ = m;
#line 702 "../src/LocalBackend/LocalLibrary.vala"
						_tmp26_ = music_media_get_artist (_tmp25_);
#line 702 "../src/LocalBackend/LocalLibrary.vala"
						_tmp27_ = _tmp26_;
#line 702 "../src/LocalBackend/LocalLibrary.vala"
						_tmp28_ = g_utf8_strdown (_tmp27_, (gssize) -1);
#line 702 "../src/LocalBackend/LocalLibrary.vala"
						_tmp29_ = _tmp28_;
#line 702 "../src/LocalBackend/LocalLibrary.vala"
						_tmp10_ = g_strcmp0 (_tmp24_, _tmp29_) == 0;
#line 702 "../src/LocalBackend/LocalLibrary.vala"
						_g_free0 (_tmp29_);
#line 702 "../src/LocalBackend/LocalLibrary.vala"
						_g_free0 (_tmp24_);
#line 6212 "LocalLibrary.c"
					} else {
#line 702 "../src/LocalBackend/LocalLibrary.vala"
						_tmp10_ = FALSE;
#line 6216 "LocalLibrary.c"
					}
#line 702 "../src/LocalBackend/LocalLibrary.vala"
					if (_tmp10_) {
#line 6220 "LocalLibrary.c"
						MusicMedia* _tmp30_;
						MusicMedia* _tmp31_;
#line 703 "../src/LocalBackend/LocalLibrary.vala"
						_tmp30_ = m;
#line 703 "../src/LocalBackend/LocalLibrary.vala"
						_tmp31_ = _g_object_ref0 (_tmp30_);
#line 703 "../src/LocalBackend/LocalLibrary.vala"
						_g_object_unref0 (found);
#line 703 "../src/LocalBackend/LocalLibrary.vala"
						found = _tmp31_;
#line 704 "../src/LocalBackend/LocalLibrary.vala"
						_g_object_unref0 (m);
#line 704 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 6235 "LocalLibrary.c"
					}
#line 701 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (m);
#line 6239 "LocalLibrary.c"
				}
#line 701 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_m_it);
#line 6243 "LocalLibrary.c"
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp32_;
#line 700 "../src/LocalBackend/LocalLibrary.vala"
			_tmp32_ = self->priv->_medias;
#line 700 "../src/LocalBackend/LocalLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock__medias);
#line 6253 "LocalLibrary.c"
		}
#line 700 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 700 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (found);
#line 700 "../src/LocalBackend/LocalLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 700 "../src/LocalBackend/LocalLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 700 "../src/LocalBackend/LocalLibrary.vala"
			return NULL;
#line 6265 "LocalLibrary.c"
		}
	}
#line 709 "../src/LocalBackend/LocalLibrary.vala"
	result = found;
#line 709 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 6272 "LocalLibrary.c"
}

static MusicMedia*
music_local_library_real_media_from_file (MusicLibrary* base,
                                          GFile* file)
{
	MusicLocalLibrary * self;
	GError* _inner_error0_ = NULL;
	MusicMedia* result;
#line 712 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 712 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 6286 "LocalLibrary.c"
	{
		GeeHashMap* _tmp0_;
#line 713 "../src/LocalBackend/LocalLibrary.vala"
		_tmp0_ = self->priv->_medias;
#line 713 "../src/LocalBackend/LocalLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock__medias);
#line 6293 "LocalLibrary.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp1_;
				GeeCollection* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeIterator* _tmp5_;
				GeeIterator* _tmp6_;
#line 714 "../src/LocalBackend/LocalLibrary.vala"
				_tmp1_ = self->priv->_medias;
#line 714 "../src/LocalBackend/LocalLibrary.vala"
				_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 714 "../src/LocalBackend/LocalLibrary.vala"
				_tmp3_ = _tmp2_;
#line 714 "../src/LocalBackend/LocalLibrary.vala"
				_tmp4_ = _tmp3_;
#line 714 "../src/LocalBackend/LocalLibrary.vala"
				_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 714 "../src/LocalBackend/LocalLibrary.vala"
				_tmp6_ = _tmp5_;
#line 714 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_tmp4_);
#line 714 "../src/LocalBackend/LocalLibrary.vala"
				_m_it = _tmp6_;
#line 714 "../src/LocalBackend/LocalLibrary.vala"
				while (TRUE) {
#line 6321 "LocalLibrary.c"
					GeeIterator* _tmp7_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp8_;
					gpointer _tmp9_;
					gboolean _tmp10_ = FALSE;
					MusicMedia* _tmp11_;
#line 714 "../src/LocalBackend/LocalLibrary.vala"
					_tmp7_ = _m_it;
#line 714 "../src/LocalBackend/LocalLibrary.vala"
					if (!gee_iterator_next (_tmp7_)) {
#line 714 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 6334 "LocalLibrary.c"
					}
#line 714 "../src/LocalBackend/LocalLibrary.vala"
					_tmp8_ = _m_it;
#line 714 "../src/LocalBackend/LocalLibrary.vala"
					_tmp9_ = gee_iterator_get (_tmp8_);
#line 714 "../src/LocalBackend/LocalLibrary.vala"
					m = (MusicMedia*) _tmp9_;
#line 715 "../src/LocalBackend/LocalLibrary.vala"
					_tmp11_ = m;
#line 715 "../src/LocalBackend/LocalLibrary.vala"
					if (_tmp11_ != NULL) {
#line 6346 "LocalLibrary.c"
						MusicMedia* _tmp12_;
						GFile* _tmp13_;
						GFile* _tmp14_;
#line 715 "../src/LocalBackend/LocalLibrary.vala"
						_tmp12_ = m;
#line 715 "../src/LocalBackend/LocalLibrary.vala"
						_tmp13_ = music_media_get_file (_tmp12_);
#line 715 "../src/LocalBackend/LocalLibrary.vala"
						_tmp14_ = _tmp13_;
#line 715 "../src/LocalBackend/LocalLibrary.vala"
						_tmp10_ = g_file_equal (_tmp14_, file);
#line 6358 "LocalLibrary.c"
					} else {
#line 715 "../src/LocalBackend/LocalLibrary.vala"
						_tmp10_ = FALSE;
#line 6362 "LocalLibrary.c"
					}
#line 715 "../src/LocalBackend/LocalLibrary.vala"
					if (_tmp10_) {
#line 716 "../src/LocalBackend/LocalLibrary.vala"
						result = m;
#line 716 "../src/LocalBackend/LocalLibrary.vala"
						_g_object_unref0 (_m_it);
#line 6370 "LocalLibrary.c"
						{
							GeeHashMap* _tmp15_;
#line 713 "../src/LocalBackend/LocalLibrary.vala"
							_tmp15_ = self->priv->_medias;
#line 713 "../src/LocalBackend/LocalLibrary.vala"
							g_rec_mutex_unlock (&self->priv->__lock__medias);
#line 6377 "LocalLibrary.c"
						}
#line 716 "../src/LocalBackend/LocalLibrary.vala"
						return result;
#line 6381 "LocalLibrary.c"
					}
#line 714 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (m);
#line 6385 "LocalLibrary.c"
				}
#line 714 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_m_it);
#line 6389 "LocalLibrary.c"
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp16_;
#line 713 "../src/LocalBackend/LocalLibrary.vala"
			_tmp16_ = self->priv->_medias;
#line 713 "../src/LocalBackend/LocalLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock__medias);
#line 6399 "LocalLibrary.c"
		}
#line 713 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 713 "../src/LocalBackend/LocalLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 713 "../src/LocalBackend/LocalLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 713 "../src/LocalBackend/LocalLibrary.vala"
			return NULL;
#line 6409 "LocalLibrary.c"
		}
	}
#line 720 "../src/LocalBackend/LocalLibrary.vala"
	result = NULL;
#line 720 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 6416 "LocalLibrary.c"
}

static MusicMedia*
music_local_library_real_media_from_uri (MusicLibrary* base,
                                         const gchar* uri)
{
	MusicLocalLibrary * self;
	GError* _inner_error0_ = NULL;
	MusicMedia* result;
#line 723 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 723 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 6430 "LocalLibrary.c"
	{
		GeeHashMap* _tmp0_;
#line 724 "../src/LocalBackend/LocalLibrary.vala"
		_tmp0_ = self->priv->_medias;
#line 724 "../src/LocalBackend/LocalLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock__medias);
#line 6437 "LocalLibrary.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp1_;
				GeeCollection* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeIterator* _tmp5_;
				GeeIterator* _tmp6_;
#line 725 "../src/LocalBackend/LocalLibrary.vala"
				_tmp1_ = self->priv->_medias;
#line 725 "../src/LocalBackend/LocalLibrary.vala"
				_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 725 "../src/LocalBackend/LocalLibrary.vala"
				_tmp3_ = _tmp2_;
#line 725 "../src/LocalBackend/LocalLibrary.vala"
				_tmp4_ = _tmp3_;
#line 725 "../src/LocalBackend/LocalLibrary.vala"
				_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 725 "../src/LocalBackend/LocalLibrary.vala"
				_tmp6_ = _tmp5_;
#line 725 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_tmp4_);
#line 725 "../src/LocalBackend/LocalLibrary.vala"
				_m_it = _tmp6_;
#line 725 "../src/LocalBackend/LocalLibrary.vala"
				while (TRUE) {
#line 6465 "LocalLibrary.c"
					GeeIterator* _tmp7_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp8_;
					gpointer _tmp9_;
					gboolean _tmp10_ = FALSE;
					MusicMedia* _tmp11_;
#line 725 "../src/LocalBackend/LocalLibrary.vala"
					_tmp7_ = _m_it;
#line 725 "../src/LocalBackend/LocalLibrary.vala"
					if (!gee_iterator_next (_tmp7_)) {
#line 725 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 6478 "LocalLibrary.c"
					}
#line 725 "../src/LocalBackend/LocalLibrary.vala"
					_tmp8_ = _m_it;
#line 725 "../src/LocalBackend/LocalLibrary.vala"
					_tmp9_ = gee_iterator_get (_tmp8_);
#line 725 "../src/LocalBackend/LocalLibrary.vala"
					m = (MusicMedia*) _tmp9_;
#line 726 "../src/LocalBackend/LocalLibrary.vala"
					_tmp11_ = m;
#line 726 "../src/LocalBackend/LocalLibrary.vala"
					if (_tmp11_ != NULL) {
#line 6490 "LocalLibrary.c"
						MusicMedia* _tmp12_;
						gchar* _tmp13_;
						gchar* _tmp14_;
						gchar* _tmp15_;
#line 726 "../src/LocalBackend/LocalLibrary.vala"
						_tmp12_ = m;
#line 726 "../src/LocalBackend/LocalLibrary.vala"
						_tmp13_ = music_media_get_uri (_tmp12_);
#line 726 "../src/LocalBackend/LocalLibrary.vala"
						_tmp14_ = _tmp13_;
#line 726 "../src/LocalBackend/LocalLibrary.vala"
						_tmp15_ = _tmp14_;
#line 726 "../src/LocalBackend/LocalLibrary.vala"
						_tmp10_ = g_strcmp0 (_tmp15_, uri) == 0;
#line 726 "../src/LocalBackend/LocalLibrary.vala"
						_g_free0 (_tmp15_);
#line 6507 "LocalLibrary.c"
					} else {
#line 726 "../src/LocalBackend/LocalLibrary.vala"
						_tmp10_ = FALSE;
#line 6511 "LocalLibrary.c"
					}
#line 726 "../src/LocalBackend/LocalLibrary.vala"
					if (_tmp10_) {
#line 727 "../src/LocalBackend/LocalLibrary.vala"
						result = m;
#line 727 "../src/LocalBackend/LocalLibrary.vala"
						_g_object_unref0 (_m_it);
#line 6519 "LocalLibrary.c"
						{
							GeeHashMap* _tmp16_;
#line 724 "../src/LocalBackend/LocalLibrary.vala"
							_tmp16_ = self->priv->_medias;
#line 724 "../src/LocalBackend/LocalLibrary.vala"
							g_rec_mutex_unlock (&self->priv->__lock__medias);
#line 6526 "LocalLibrary.c"
						}
#line 727 "../src/LocalBackend/LocalLibrary.vala"
						return result;
#line 6530 "LocalLibrary.c"
					}
#line 725 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (m);
#line 6534 "LocalLibrary.c"
				}
#line 725 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_m_it);
#line 6538 "LocalLibrary.c"
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp17_;
#line 724 "../src/LocalBackend/LocalLibrary.vala"
			_tmp17_ = self->priv->_medias;
#line 724 "../src/LocalBackend/LocalLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock__medias);
#line 6548 "LocalLibrary.c"
		}
#line 724 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 724 "../src/LocalBackend/LocalLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 724 "../src/LocalBackend/LocalLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 724 "../src/LocalBackend/LocalLibrary.vala"
			return NULL;
#line 6558 "LocalLibrary.c"
		}
	}
#line 731 "../src/LocalBackend/LocalLibrary.vala"
	result = NULL;
#line 731 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 6565 "LocalLibrary.c"
}

static GeeCollection*
music_local_library_real_medias_from_ids (MusicLibrary* base,
                                          GeeCollection* ids)
{
	MusicLocalLibrary * self;
	GeeTreeSet* media_collection = NULL;
	GeeTreeSet* _tmp0_;
	GeeCollection* result;
#line 734 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 734 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (ids != NULL, NULL);
#line 735 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 735 "../src/LocalBackend/LocalLibrary.vala"
	media_collection = _tmp0_;
#line 6584 "LocalLibrary.c"
	{
		GeeIterator* _id_it = NULL;
		GeeIterator* _tmp1_;
#line 736 "../src/LocalBackend/LocalLibrary.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) ids);
#line 736 "../src/LocalBackend/LocalLibrary.vala"
		_id_it = _tmp1_;
#line 736 "../src/LocalBackend/LocalLibrary.vala"
		while (TRUE) {
#line 6594 "LocalLibrary.c"
			GeeIterator* _tmp2_;
			gint64* id = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			MusicMedia* m = NULL;
			GeeHashMap* _tmp5_;
			gint64* _tmp6_;
			gpointer _tmp7_;
			MusicMedia* _tmp8_;
#line 736 "../src/LocalBackend/LocalLibrary.vala"
			_tmp2_ = _id_it;
#line 736 "../src/LocalBackend/LocalLibrary.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 736 "../src/LocalBackend/LocalLibrary.vala"
				break;
#line 6610 "LocalLibrary.c"
			}
#line 736 "../src/LocalBackend/LocalLibrary.vala"
			_tmp3_ = _id_it;
#line 736 "../src/LocalBackend/LocalLibrary.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 736 "../src/LocalBackend/LocalLibrary.vala"
			id = (gint64*) _tmp4_;
#line 737 "../src/LocalBackend/LocalLibrary.vala"
			_tmp5_ = self->priv->_medias;
#line 737 "../src/LocalBackend/LocalLibrary.vala"
			_tmp6_ = id;
#line 737 "../src/LocalBackend/LocalLibrary.vala"
			_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, _tmp6_);
#line 737 "../src/LocalBackend/LocalLibrary.vala"
			m = (MusicMedia*) _tmp7_;
#line 738 "../src/LocalBackend/LocalLibrary.vala"
			_tmp8_ = m;
#line 738 "../src/LocalBackend/LocalLibrary.vala"
			if (_tmp8_ != NULL) {
#line 6630 "LocalLibrary.c"
				GeeTreeSet* _tmp9_;
				MusicMedia* _tmp10_;
#line 739 "../src/LocalBackend/LocalLibrary.vala"
				_tmp9_ = media_collection;
#line 739 "../src/LocalBackend/LocalLibrary.vala"
				_tmp10_ = m;
#line 739 "../src/LocalBackend/LocalLibrary.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp10_);
#line 6639 "LocalLibrary.c"
			}
#line 736 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (m);
#line 736 "../src/LocalBackend/LocalLibrary.vala"
			_g_free0 (id);
#line 6645 "LocalLibrary.c"
		}
#line 736 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_id_it);
#line 6649 "LocalLibrary.c"
	}
#line 743 "../src/LocalBackend/LocalLibrary.vala"
	result = (GeeCollection*) media_collection;
#line 743 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 6655 "LocalLibrary.c"
}

static GeeCollection*
music_local_library_real_medias_from_uris (MusicLibrary* base,
                                           GeeCollection* uris)
{
	MusicLocalLibrary * self;
	GeeLinkedList* media_collection = NULL;
	GeeLinkedList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeCollection* result;
#line 746 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 746 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (uris != NULL, NULL);
#line 747 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 747 "../src/LocalBackend/LocalLibrary.vala"
	media_collection = _tmp0_;
#line 6675 "LocalLibrary.c"
	{
		GeeHashMap* _tmp1_;
#line 748 "../src/LocalBackend/LocalLibrary.vala"
		_tmp1_ = self->priv->_medias;
#line 748 "../src/LocalBackend/LocalLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock__medias);
#line 6682 "LocalLibrary.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
				GeeIterator* _tmp6_;
				GeeIterator* _tmp7_;
#line 749 "../src/LocalBackend/LocalLibrary.vala"
				_tmp2_ = self->priv->_medias;
#line 749 "../src/LocalBackend/LocalLibrary.vala"
				_tmp3_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp2_);
#line 749 "../src/LocalBackend/LocalLibrary.vala"
				_tmp4_ = _tmp3_;
#line 749 "../src/LocalBackend/LocalLibrary.vala"
				_tmp5_ = _tmp4_;
#line 749 "../src/LocalBackend/LocalLibrary.vala"
				_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 749 "../src/LocalBackend/LocalLibrary.vala"
				_tmp7_ = _tmp6_;
#line 749 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_tmp5_);
#line 749 "../src/LocalBackend/LocalLibrary.vala"
				_m_it = _tmp7_;
#line 749 "../src/LocalBackend/LocalLibrary.vala"
				while (TRUE) {
#line 6710 "LocalLibrary.c"
					GeeIterator* _tmp8_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp9_;
					gpointer _tmp10_;
					MusicMedia* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gboolean _tmp15_;
					GeeLinkedList* _tmp18_;
					gint _tmp19_;
					gint _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
#line 749 "../src/LocalBackend/LocalLibrary.vala"
					_tmp8_ = _m_it;
#line 749 "../src/LocalBackend/LocalLibrary.vala"
					if (!gee_iterator_next (_tmp8_)) {
#line 749 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 6731 "LocalLibrary.c"
					}
#line 749 "../src/LocalBackend/LocalLibrary.vala"
					_tmp9_ = _m_it;
#line 749 "../src/LocalBackend/LocalLibrary.vala"
					_tmp10_ = gee_iterator_get (_tmp9_);
#line 749 "../src/LocalBackend/LocalLibrary.vala"
					m = (MusicMedia*) _tmp10_;
#line 750 "../src/LocalBackend/LocalLibrary.vala"
					_tmp11_ = m;
#line 750 "../src/LocalBackend/LocalLibrary.vala"
					_tmp12_ = music_media_get_uri (_tmp11_);
#line 750 "../src/LocalBackend/LocalLibrary.vala"
					_tmp13_ = _tmp12_;
#line 750 "../src/LocalBackend/LocalLibrary.vala"
					_tmp14_ = _tmp13_;
#line 750 "../src/LocalBackend/LocalLibrary.vala"
					_tmp15_ = gee_collection_contains (uris, _tmp14_);
#line 750 "../src/LocalBackend/LocalLibrary.vala"
					_g_free0 (_tmp14_);
#line 750 "../src/LocalBackend/LocalLibrary.vala"
					if (_tmp15_) {
#line 6753 "LocalLibrary.c"
						GeeLinkedList* _tmp16_;
						MusicMedia* _tmp17_;
#line 751 "../src/LocalBackend/LocalLibrary.vala"
						_tmp16_ = media_collection;
#line 751 "../src/LocalBackend/LocalLibrary.vala"
						_tmp17_ = m;
#line 751 "../src/LocalBackend/LocalLibrary.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 6762 "LocalLibrary.c"
					}
#line 752 "../src/LocalBackend/LocalLibrary.vala"
					_tmp18_ = media_collection;
#line 752 "../src/LocalBackend/LocalLibrary.vala"
					_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 752 "../src/LocalBackend/LocalLibrary.vala"
					_tmp20_ = _tmp19_;
#line 752 "../src/LocalBackend/LocalLibrary.vala"
					_tmp21_ = gee_collection_get_size (uris);
#line 752 "../src/LocalBackend/LocalLibrary.vala"
					_tmp22_ = _tmp21_;
#line 752 "../src/LocalBackend/LocalLibrary.vala"
					if (_tmp20_ == _tmp22_) {
#line 753 "../src/LocalBackend/LocalLibrary.vala"
						_g_object_unref0 (m);
#line 753 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 6780 "LocalLibrary.c"
					}
#line 749 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (m);
#line 6784 "LocalLibrary.c"
				}
#line 749 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_m_it);
#line 6788 "LocalLibrary.c"
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp23_;
#line 748 "../src/LocalBackend/LocalLibrary.vala"
			_tmp23_ = self->priv->_medias;
#line 748 "../src/LocalBackend/LocalLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock__medias);
#line 6798 "LocalLibrary.c"
		}
#line 748 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 748 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (media_collection);
#line 748 "../src/LocalBackend/LocalLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 748 "../src/LocalBackend/LocalLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 748 "../src/LocalBackend/LocalLibrary.vala"
			return NULL;
#line 6810 "LocalLibrary.c"
		}
	}
#line 757 "../src/LocalBackend/LocalLibrary.vala"
	result = (GeeCollection*) media_collection;
#line 757 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 6817 "LocalLibrary.c"
}

static void
music_local_library_real_add_media (MusicLibrary* base,
                                    MusicMedia* s)
{
	MusicLocalLibrary * self;
	GeeTreeSet* coll = NULL;
	GeeTreeSet* _tmp0_;
#line 760 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 760 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (s != NULL);
#line 761 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 761 "../src/LocalBackend/LocalLibrary.vala"
	coll = _tmp0_;
#line 762 "../src/LocalBackend/LocalLibrary.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) coll, s);
#line 763 "../src/LocalBackend/LocalLibrary.vala"
	music_library_add_medias ((MusicLibrary*) self, (GeeCollection*) coll);
#line 760 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (coll);
#line 6841 "LocalLibrary.c"
}

static void
music_local_library_real_add_medias (MusicLibrary* base,
                                     GeeCollection* new_media)
{
	MusicLocalLibrary * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GeeTreeSet* medias = NULL;
	GeeTreeSet* _tmp2_;
	GeeTreeSet* _tmp3_;
	GeeHashMap* local_media = NULL;
	GeeTreeSet* _tmp4_;
	GeeHashMap* _tmp5_;
	GeeHashMap* _tmp6_;
	GeeHashMap* _tmp7_;
	MusicLibraryWindow* _tmp8_;
	MusicLibraryWindow* _tmp9_;
	GtkSearchEntry* _tmp10_;
	GtkSearchEntry* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GeeHashMap* _tmp45_;
	GeeCollection* _tmp46_;
	GeeCollection* _tmp47_;
	GeeCollection* _tmp48_;
	GeeCollection* _tmp49_;
	GeeCollection* _tmp50_;
	GeeCollection* _tmp51_;
#line 766 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 766 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (new_media != NULL);
#line 767 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_collection_get_is_empty (new_media);
#line 767 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = _tmp0_;
#line 767 "../src/LocalBackend/LocalLibrary.vala"
	if (_tmp1_) {
#line 768 "../src/LocalBackend/LocalLibrary.vala"
		return;
#line 6884 "LocalLibrary.c"
	}
#line 773 "../src/LocalBackend/LocalLibrary.vala"
	_tmp2_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 773 "../src/LocalBackend/LocalLibrary.vala"
	medias = _tmp2_;
#line 774 "../src/LocalBackend/LocalLibrary.vala"
	_tmp3_ = medias;
#line 774 "../src/LocalBackend/LocalLibrary.vala"
	gee_collection_add_all ((GeeCollection*) _tmp3_, new_media);
#line 777 "../src/LocalBackend/LocalLibrary.vala"
	_tmp4_ = medias;
#line 777 "../src/LocalBackend/LocalLibrary.vala"
	_tmp5_ = music_local_library_get_local_medias (self, _tmp4_);
#line 777 "../src/LocalBackend/LocalLibrary.vala"
	local_media = _tmp5_;
#line 778 "../src/LocalBackend/LocalLibrary.vala"
	_tmp6_ = self->priv->_medias;
#line 778 "../src/LocalBackend/LocalLibrary.vala"
	_tmp7_ = local_media;
#line 778 "../src/LocalBackend/LocalLibrary.vala"
	gee_map_set_all ((GeeMap*) _tmp6_, (GeeMap*) _tmp7_);
#line 781 "../src/LocalBackend/LocalLibrary.vala"
	_tmp8_ = music_app_get_main_window ();
#line 781 "../src/LocalBackend/LocalLibrary.vala"
	_tmp9_ = _tmp8_;
#line 781 "../src/LocalBackend/LocalLibrary.vala"
	_tmp10_ = music_library_window_get_search_entry (_tmp9_);
#line 781 "../src/LocalBackend/LocalLibrary.vala"
	_tmp11_ = _tmp10_;
#line 781 "../src/LocalBackend/LocalLibrary.vala"
	_tmp12_ = gtk_entry_get_text ((GtkEntry*) _tmp11_);
#line 781 "../src/LocalBackend/LocalLibrary.vala"
	_tmp13_ = _tmp12_;
#line 781 "../src/LocalBackend/LocalLibrary.vala"
	if (g_strcmp0 (_tmp13_, "") == 0) {
#line 6920 "LocalLibrary.c"
		GeeTreeSet* _tmp14_;
		GeeHashMap* _tmp15_;
		GeeCollection* _tmp16_;
		GeeCollection* _tmp17_;
		GeeCollection* _tmp18_;
#line 782 "../src/LocalBackend/LocalLibrary.vala"
		_tmp14_ = self->priv->_searched_medias;
#line 782 "../src/LocalBackend/LocalLibrary.vala"
		_tmp15_ = local_media;
#line 782 "../src/LocalBackend/LocalLibrary.vala"
		_tmp16_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp15_);
#line 782 "../src/LocalBackend/LocalLibrary.vala"
		_tmp17_ = _tmp16_;
#line 782 "../src/LocalBackend/LocalLibrary.vala"
		_tmp18_ = _tmp17_;
#line 782 "../src/LocalBackend/LocalLibrary.vala"
		gee_collection_add_all ((GeeCollection*) _tmp14_, _tmp18_);
#line 782 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_tmp18_);
#line 6940 "LocalLibrary.c"
	} else {
		guint parsed_rating = 0U;
		gchar* parsed_search_string = NULL;
		MusicLibraryWindow* _tmp19_;
		MusicLibraryWindow* _tmp20_;
		GtkSearchEntry* _tmp21_;
		GtkSearchEntry* _tmp22_;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		guint _tmp25_ = 0U;
		gchar* _tmp26_ = NULL;
		gboolean rating_search = FALSE;
#line 786 "../src/LocalBackend/LocalLibrary.vala"
		_tmp19_ = music_app_get_main_window ();
#line 786 "../src/LocalBackend/LocalLibrary.vala"
		_tmp20_ = _tmp19_;
#line 786 "../src/LocalBackend/LocalLibrary.vala"
		_tmp21_ = music_library_window_get_search_entry (_tmp20_);
#line 786 "../src/LocalBackend/LocalLibrary.vala"
		_tmp22_ = _tmp21_;
#line 786 "../src/LocalBackend/LocalLibrary.vala"
		_tmp23_ = gtk_entry_get_text ((GtkEntry*) _tmp22_);
#line 786 "../src/LocalBackend/LocalLibrary.vala"
		_tmp24_ = _tmp23_;
#line 786 "../src/LocalBackend/LocalLibrary.vala"
		music_string_base_search_method (_tmp24_, &_tmp25_, &_tmp26_);
#line 786 "../src/LocalBackend/LocalLibrary.vala"
		parsed_rating = _tmp25_;
#line 786 "../src/LocalBackend/LocalLibrary.vala"
		_g_free0 (parsed_search_string);
#line 786 "../src/LocalBackend/LocalLibrary.vala"
		parsed_search_string = _tmp26_;
#line 787 "../src/LocalBackend/LocalLibrary.vala"
		rating_search = parsed_rating > ((guint) 0);
#line 6975 "LocalLibrary.c"
		{
			GeeIterator* _m_it = NULL;
			GeeHashMap* _tmp27_;
			GeeCollection* _tmp28_;
			GeeCollection* _tmp29_;
			GeeCollection* _tmp30_;
			GeeIterator* _tmp31_;
			GeeIterator* _tmp32_;
#line 788 "../src/LocalBackend/LocalLibrary.vala"
			_tmp27_ = local_media;
#line 788 "../src/LocalBackend/LocalLibrary.vala"
			_tmp28_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp27_);
#line 788 "../src/LocalBackend/LocalLibrary.vala"
			_tmp29_ = _tmp28_;
#line 788 "../src/LocalBackend/LocalLibrary.vala"
			_tmp30_ = _tmp29_;
#line 788 "../src/LocalBackend/LocalLibrary.vala"
			_tmp31_ = gee_iterable_iterator ((GeeIterable*) _tmp30_);
#line 788 "../src/LocalBackend/LocalLibrary.vala"
			_tmp32_ = _tmp31_;
#line 788 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (_tmp30_);
#line 788 "../src/LocalBackend/LocalLibrary.vala"
			_m_it = _tmp32_;
#line 788 "../src/LocalBackend/LocalLibrary.vala"
			while (TRUE) {
#line 7002 "LocalLibrary.c"
				GeeIterator* _tmp33_;
				MusicLocalMedia* m = NULL;
				GeeIterator* _tmp34_;
				gpointer _tmp35_;
#line 788 "../src/LocalBackend/LocalLibrary.vala"
				_tmp33_ = _m_it;
#line 788 "../src/LocalBackend/LocalLibrary.vala"
				if (!gee_iterator_next (_tmp33_)) {
#line 788 "../src/LocalBackend/LocalLibrary.vala"
					break;
#line 7013 "LocalLibrary.c"
				}
#line 788 "../src/LocalBackend/LocalLibrary.vala"
				_tmp34_ = _m_it;
#line 788 "../src/LocalBackend/LocalLibrary.vala"
				_tmp35_ = gee_iterator_get (_tmp34_);
#line 788 "../src/LocalBackend/LocalLibrary.vala"
				m = (MusicLocalMedia*) _tmp35_;
#line 789 "../src/LocalBackend/LocalLibrary.vala"
				if (rating_search) {
#line 7023 "LocalLibrary.c"
					MusicLocalMedia* _tmp36_;
					guint _tmp37_;
					guint _tmp38_;
#line 790 "../src/LocalBackend/LocalLibrary.vala"
					_tmp36_ = m;
#line 790 "../src/LocalBackend/LocalLibrary.vala"
					_tmp37_ = music_media_get_rating ((MusicMedia*) _tmp36_);
#line 790 "../src/LocalBackend/LocalLibrary.vala"
					_tmp38_ = _tmp37_;
#line 790 "../src/LocalBackend/LocalLibrary.vala"
					if (_tmp38_ == parsed_rating) {
#line 7035 "LocalLibrary.c"
						GeeTreeSet* _tmp39_;
						MusicLocalMedia* _tmp40_;
#line 791 "../src/LocalBackend/LocalLibrary.vala"
						_tmp39_ = self->priv->_searched_medias;
#line 791 "../src/LocalBackend/LocalLibrary.vala"
						_tmp40_ = m;
#line 791 "../src/LocalBackend/LocalLibrary.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp39_, (MusicMedia*) _tmp40_);
#line 7044 "LocalLibrary.c"
					}
				} else {
					MusicLocalMedia* _tmp41_;
					const gchar* _tmp42_;
#line 792 "../src/LocalBackend/LocalLibrary.vala"
					_tmp41_ = m;
#line 792 "../src/LocalBackend/LocalLibrary.vala"
					_tmp42_ = parsed_search_string;
#line 792 "../src/LocalBackend/LocalLibrary.vala"
					if (music_search_match_string_to_media ((MusicMedia*) _tmp41_, _tmp42_)) {
#line 7055 "LocalLibrary.c"
						GeeTreeSet* _tmp43_;
						MusicLocalMedia* _tmp44_;
#line 793 "../src/LocalBackend/LocalLibrary.vala"
						_tmp43_ = self->priv->_searched_medias;
#line 793 "../src/LocalBackend/LocalLibrary.vala"
						_tmp44_ = m;
#line 793 "../src/LocalBackend/LocalLibrary.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp43_, (MusicMedia*) _tmp44_);
#line 7064 "LocalLibrary.c"
					}
				}
#line 788 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (m);
#line 7069 "LocalLibrary.c"
			}
#line 788 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (_m_it);
#line 7073 "LocalLibrary.c"
		}
#line 781 "../src/LocalBackend/LocalLibrary.vala"
		_g_free0 (parsed_search_string);
#line 7077 "LocalLibrary.c"
	}
#line 798 "../src/LocalBackend/LocalLibrary.vala"
	g_signal_emit_by_name ((MusicLibrary*) self, "search-finished");
#line 802 "../src/LocalBackend/LocalLibrary.vala"
	_tmp45_ = local_media;
#line 802 "../src/LocalBackend/LocalLibrary.vala"
	_tmp46_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp45_);
#line 802 "../src/LocalBackend/LocalLibrary.vala"
	_tmp47_ = _tmp46_;
#line 802 "../src/LocalBackend/LocalLibrary.vala"
	_tmp48_ = _tmp47_;
#line 802 "../src/LocalBackend/LocalLibrary.vala"
	_tmp49_ = gee_collection_get_read_only_view (_tmp48_);
#line 802 "../src/LocalBackend/LocalLibrary.vala"
	_tmp50_ = _tmp49_;
#line 802 "../src/LocalBackend/LocalLibrary.vala"
	_tmp51_ = _tmp50_;
#line 802 "../src/LocalBackend/LocalLibrary.vala"
	g_signal_emit_by_name ((MusicLibrary*) self, "media-added", _tmp51_);
#line 802 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_tmp51_);
#line 802 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_tmp48_);
#line 766 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (local_media);
#line 766 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (medias);
#line 7105 "LocalLibrary.c"
}

static void
music_local_library_real_remove_media (MusicLibrary* base,
                                       MusicMedia* s,
                                       gboolean trash)
{
	MusicLocalLibrary * self;
	GeeTreeSet* coll = NULL;
	GeeTreeSet* _tmp0_;
#line 805 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 805 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (s != NULL);
#line 806 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 806 "../src/LocalBackend/LocalLibrary.vala"
	coll = _tmp0_;
#line 807 "../src/LocalBackend/LocalLibrary.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) coll, s);
#line 808 "../src/LocalBackend/LocalLibrary.vala"
	music_library_remove_medias ((MusicLibrary*) self, (GeeCollection*) coll, trash);
#line 805 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (coll);
#line 7130 "LocalLibrary.c"
}

static void
music_local_library_real_remove_medias (MusicLibrary* base,
                                        GeeCollection* to_remove,
                                        gboolean trash)
{
	MusicLocalLibrary * self;
	GeeTreeSet* remove_treeset = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	GeeTreeSet* _tmp2_;
	MusicPlaybackManager* _tmp3_;
	MusicPlaybackManager* _tmp4_;
	MusicMedia* _tmp5_;
	MusicMedia* _tmp6_;
	GeeTreeSet* _tmp11_;
	GeeBidirSortedSet* _tmp12_;
	GeeBidirSortedSet* _tmp13_;
	GeeBidirSortedSet* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 811 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 811 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (to_remove != NULL);
#line 812 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 812 "../src/LocalBackend/LocalLibrary.vala"
	remove_treeset = _tmp0_;
#line 813 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = remove_treeset;
#line 813 "../src/LocalBackend/LocalLibrary.vala"
	gee_collection_add_all ((GeeCollection*) _tmp1_, to_remove);
#line 815 "../src/LocalBackend/LocalLibrary.vala"
	_tmp2_ = remove_treeset;
#line 815 "../src/LocalBackend/LocalLibrary.vala"
	_tmp3_ = music_app_get_player ();
#line 815 "../src/LocalBackend/LocalLibrary.vala"
	_tmp4_ = _tmp3_;
#line 815 "../src/LocalBackend/LocalLibrary.vala"
	_tmp5_ = music_playback_manager_get_current_media (_tmp4_);
#line 815 "../src/LocalBackend/LocalLibrary.vala"
	_tmp6_ = _tmp5_;
#line 815 "../src/LocalBackend/LocalLibrary.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp2_, _tmp6_)) {
#line 7176 "LocalLibrary.c"
		MusicPlaybackManager* _tmp7_;
		MusicPlaybackManager* _tmp8_;
#line 816 "../src/LocalBackend/LocalLibrary.vala"
		_tmp7_ = music_app_get_player ();
#line 816 "../src/LocalBackend/LocalLibrary.vala"
		_tmp8_ = _tmp7_;
#line 816 "../src/LocalBackend/LocalLibrary.vala"
		music_playback_manager_stop_playback (_tmp8_);
#line 7185 "LocalLibrary.c"
	}
#line 819 "../src/LocalBackend/LocalLibrary.vala"
	if (trash) {
#line 7189 "LocalLibrary.c"
		MusicFileOperator* _tmp9_;
		GeeTreeSet* _tmp10_;
#line 820 "../src/LocalBackend/LocalLibrary.vala"
		_tmp9_ = self->priv->fo;
#line 820 "../src/LocalBackend/LocalLibrary.vala"
		_tmp10_ = remove_treeset;
#line 820 "../src/LocalBackend/LocalLibrary.vala"
		music_file_operator_remove_media (_tmp9_, (GeeCollection*) _tmp10_);
#line 7198 "LocalLibrary.c"
	}
#line 825 "../src/LocalBackend/LocalLibrary.vala"
	_tmp11_ = remove_treeset;
#line 825 "../src/LocalBackend/LocalLibrary.vala"
	_tmp12_ = gee_abstract_bidir_sorted_set_get_read_only_view ((GeeAbstractBidirSortedSet*) _tmp11_);
#line 825 "../src/LocalBackend/LocalLibrary.vala"
	_tmp13_ = _tmp12_;
#line 825 "../src/LocalBackend/LocalLibrary.vala"
	_tmp14_ = _tmp13_;
#line 825 "../src/LocalBackend/LocalLibrary.vala"
	g_signal_emit_by_name ((MusicLibrary*) self, "media-removed", (GeeCollection*) _tmp14_);
#line 825 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_tmp14_);
#line 7212 "LocalLibrary.c"
	{
		GeeHashMap* _tmp15_;
#line 827 "../src/LocalBackend/LocalLibrary.vala"
		_tmp15_ = self->priv->_medias;
#line 827 "../src/LocalBackend/LocalLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock__medias);
#line 7219 "LocalLibrary.c"
		{
			{
				GeeIterator* _s_it = NULL;
				GeeTreeSet* _tmp16_;
				GeeIterator* _tmp17_;
#line 828 "../src/LocalBackend/LocalLibrary.vala"
				_tmp16_ = remove_treeset;
#line 828 "../src/LocalBackend/LocalLibrary.vala"
				_tmp17_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp16_);
#line 828 "../src/LocalBackend/LocalLibrary.vala"
				_s_it = _tmp17_;
#line 828 "../src/LocalBackend/LocalLibrary.vala"
				while (TRUE) {
#line 7233 "LocalLibrary.c"
					GeeIterator* _tmp18_;
					MusicMedia* s = NULL;
					GeeIterator* _tmp19_;
					gpointer _tmp20_;
					GeeTreeSet* _tmp21_;
					MusicMedia* _tmp22_;
					GeeHashMap* _tmp23_;
					MusicMedia* _tmp24_;
					gint64 _tmp25_;
					gint64 _tmp26_;
#line 828 "../src/LocalBackend/LocalLibrary.vala"
					_tmp18_ = _s_it;
#line 828 "../src/LocalBackend/LocalLibrary.vala"
					if (!gee_iterator_next (_tmp18_)) {
#line 828 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 7250 "LocalLibrary.c"
					}
#line 828 "../src/LocalBackend/LocalLibrary.vala"
					_tmp19_ = _s_it;
#line 828 "../src/LocalBackend/LocalLibrary.vala"
					_tmp20_ = gee_iterator_get (_tmp19_);
#line 828 "../src/LocalBackend/LocalLibrary.vala"
					s = (MusicMedia*) _tmp20_;
#line 829 "../src/LocalBackend/LocalLibrary.vala"
					_tmp21_ = self->priv->_searched_medias;
#line 829 "../src/LocalBackend/LocalLibrary.vala"
					_tmp22_ = s;
#line 829 "../src/LocalBackend/LocalLibrary.vala"
					gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp21_, _tmp22_);
#line 830 "../src/LocalBackend/LocalLibrary.vala"
					_tmp23_ = self->priv->_medias;
#line 830 "../src/LocalBackend/LocalLibrary.vala"
					_tmp24_ = s;
#line 830 "../src/LocalBackend/LocalLibrary.vala"
					_tmp25_ = music_media_get_rowid (_tmp24_);
#line 830 "../src/LocalBackend/LocalLibrary.vala"
					_tmp26_ = _tmp25_;
#line 830 "../src/LocalBackend/LocalLibrary.vala"
					gee_abstract_map_unset ((GeeAbstractMap*) _tmp23_, &_tmp26_, NULL);
#line 828 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (s);
#line 7276 "LocalLibrary.c"
				}
#line 828 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_s_it);
#line 7280 "LocalLibrary.c"
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp27_;
#line 827 "../src/LocalBackend/LocalLibrary.vala"
			_tmp27_ = self->priv->_medias;
#line 827 "../src/LocalBackend/LocalLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock__medias);
#line 7290 "LocalLibrary.c"
		}
#line 827 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 827 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (remove_treeset);
#line 827 "../src/LocalBackend/LocalLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 827 "../src/LocalBackend/LocalLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 827 "../src/LocalBackend/LocalLibrary.vala"
			return;
#line 7302 "LocalLibrary.c"
		}
	}
	{
		GeeTreeSet* _tmp28_;
#line 834 "../src/LocalBackend/LocalLibrary.vala"
		_tmp28_ = self->priv->_playlists;
#line 834 "../src/LocalBackend/LocalLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock__playlists);
#line 7311 "LocalLibrary.c"
		{
			{
				GeeIterator* _p_it = NULL;
				GeeCollection* _tmp29_;
				GeeCollection* _tmp30_;
				GeeIterator* _tmp31_;
				GeeIterator* _tmp32_;
#line 835 "../src/LocalBackend/LocalLibrary.vala"
				_tmp29_ = music_library_get_playlists ((MusicLibrary*) self);
#line 835 "../src/LocalBackend/LocalLibrary.vala"
				_tmp30_ = _tmp29_;
#line 835 "../src/LocalBackend/LocalLibrary.vala"
				_tmp31_ = gee_iterable_iterator ((GeeIterable*) _tmp30_);
#line 835 "../src/LocalBackend/LocalLibrary.vala"
				_tmp32_ = _tmp31_;
#line 835 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_tmp30_);
#line 835 "../src/LocalBackend/LocalLibrary.vala"
				_p_it = _tmp32_;
#line 835 "../src/LocalBackend/LocalLibrary.vala"
				while (TRUE) {
#line 7333 "LocalLibrary.c"
					GeeIterator* _tmp33_;
					MusicStaticPlaylist* p = NULL;
					GeeIterator* _tmp34_;
					gpointer _tmp35_;
					MusicStaticPlaylist* _tmp36_;
					GeeTreeSet* _tmp37_;
#line 835 "../src/LocalBackend/LocalLibrary.vala"
					_tmp33_ = _p_it;
#line 835 "../src/LocalBackend/LocalLibrary.vala"
					if (!gee_iterator_next (_tmp33_)) {
#line 835 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 7346 "LocalLibrary.c"
					}
#line 835 "../src/LocalBackend/LocalLibrary.vala"
					_tmp34_ = _p_it;
#line 835 "../src/LocalBackend/LocalLibrary.vala"
					_tmp35_ = gee_iterator_get (_tmp34_);
#line 835 "../src/LocalBackend/LocalLibrary.vala"
					p = (MusicStaticPlaylist*) _tmp35_;
#line 836 "../src/LocalBackend/LocalLibrary.vala"
					_tmp36_ = p;
#line 836 "../src/LocalBackend/LocalLibrary.vala"
					_tmp37_ = remove_treeset;
#line 836 "../src/LocalBackend/LocalLibrary.vala"
					music_playlist_remove_medias ((MusicPlaylist*) _tmp36_, (GeeCollection*) _tmp37_);
#line 835 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (p);
#line 7362 "LocalLibrary.c"
				}
#line 835 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_p_it);
#line 7366 "LocalLibrary.c"
			}
		}
		__finally1:
		{
			GeeTreeSet* _tmp38_;
#line 834 "../src/LocalBackend/LocalLibrary.vala"
			_tmp38_ = self->priv->_playlists;
#line 834 "../src/LocalBackend/LocalLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock__playlists);
#line 7376 "LocalLibrary.c"
		}
#line 834 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 834 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (remove_treeset);
#line 834 "../src/LocalBackend/LocalLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 834 "../src/LocalBackend/LocalLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 834 "../src/LocalBackend/LocalLibrary.vala"
			return;
#line 7388 "LocalLibrary.c"
		}
	}
	{
		GeeIterator* _m_it = NULL;
		GeeTreeSet* _tmp39_;
		GeeIterator* _tmp40_;
#line 839 "../src/LocalBackend/LocalLibrary.vala"
		_tmp39_ = remove_treeset;
#line 839 "../src/LocalBackend/LocalLibrary.vala"
		_tmp40_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp39_);
#line 839 "../src/LocalBackend/LocalLibrary.vala"
		_m_it = _tmp40_;
#line 839 "../src/LocalBackend/LocalLibrary.vala"
		while (TRUE) {
#line 7403 "LocalLibrary.c"
			GeeIterator* _tmp41_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp42_;
			gpointer _tmp43_;
#line 839 "../src/LocalBackend/LocalLibrary.vala"
			_tmp41_ = _m_it;
#line 839 "../src/LocalBackend/LocalLibrary.vala"
			if (!gee_iterator_next (_tmp41_)) {
#line 839 "../src/LocalBackend/LocalLibrary.vala"
				break;
#line 7414 "LocalLibrary.c"
			}
#line 839 "../src/LocalBackend/LocalLibrary.vala"
			_tmp42_ = _m_it;
#line 839 "../src/LocalBackend/LocalLibrary.vala"
			_tmp43_ = gee_iterator_get (_tmp42_);
#line 839 "../src/LocalBackend/LocalLibrary.vala"
			m = (MusicMedia*) _tmp43_;
#line 7422 "LocalLibrary.c"
			{
#line 841 "../src/LocalBackend/LocalLibrary.vala"
				if (trash) {
#line 7426 "LocalLibrary.c"
					GdaConnection* _tmp44_;
					MusicMedia* _tmp45_;
					gint64 _tmp46_;
					gint64 _tmp47_;
					GValue _tmp48_ = {0};
#line 842 "../src/LocalBackend/LocalLibrary.vala"
					_tmp44_ = self->priv->_connection;
#line 842 "../src/LocalBackend/LocalLibrary.vala"
					_tmp45_ = m;
#line 842 "../src/LocalBackend/LocalLibrary.vala"
					_tmp46_ = music_media_get_rowid (_tmp45_);
#line 842 "../src/LocalBackend/LocalLibrary.vala"
					_tmp47_ = _tmp46_;
#line 842 "../src/LocalBackend/LocalLibrary.vala"
					g_value_init (&_tmp48_, G_TYPE_INT64);
#line 842 "../src/LocalBackend/LocalLibrary.vala"
					g_value_set_int64 (&_tmp48_, _tmp47_);
#line 842 "../src/LocalBackend/LocalLibrary.vala"
					gda_connection_delete_row_from_table (_tmp44_, MUSIC_DATABASE_MEDIA_TABLE_NAME, "rowid", &_tmp48_, &_inner_error0_);
#line 842 "../src/LocalBackend/LocalLibrary.vala"
					G_IS_VALUE (&_tmp48_) ? (g_value_unset (&_tmp48_), NULL) : NULL;
#line 842 "../src/LocalBackend/LocalLibrary.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7450 "LocalLibrary.c"
						goto __catch2_g_error;
					}
				} else {
					MusicMedia* _tmp49_;
					GeeHashMap* _tmp50_;
					MusicMedia* _tmp51_;
					gint64 _tmp52_;
					gint64 _tmp53_;
					MusicMedia* _tmp54_;
#line 845 "../src/LocalBackend/LocalLibrary.vala"
					_tmp49_ = m;
#line 845 "../src/LocalBackend/LocalLibrary.vala"
					music_media_set_show (_tmp49_, FALSE);
#line 846 "../src/LocalBackend/LocalLibrary.vala"
					_tmp50_ = self->priv->_dont_show_medias;
#line 846 "../src/LocalBackend/LocalLibrary.vala"
					_tmp51_ = m;
#line 846 "../src/LocalBackend/LocalLibrary.vala"
					_tmp52_ = music_media_get_rowid (_tmp51_);
#line 846 "../src/LocalBackend/LocalLibrary.vala"
					_tmp53_ = _tmp52_;
#line 846 "../src/LocalBackend/LocalLibrary.vala"
					_tmp54_ = m;
#line 846 "../src/LocalBackend/LocalLibrary.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp50_, &_tmp53_, _tmp54_);
#line 7476 "LocalLibrary.c"
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				GError* e = NULL;
				GError* _tmp55_;
				const gchar* _tmp56_;
#line 840 "../src/LocalBackend/LocalLibrary.vala"
				e = _inner_error0_;
#line 840 "../src/LocalBackend/LocalLibrary.vala"
				_inner_error0_ = NULL;
#line 849 "../src/LocalBackend/LocalLibrary.vala"
				_tmp55_ = e;
#line 849 "../src/LocalBackend/LocalLibrary.vala"
				_tmp56_ = _tmp55_->message;
#line 849 "../src/LocalBackend/LocalLibrary.vala"
				g_critical ("LocalLibrary.vala:849: %s", _tmp56_);
#line 840 "../src/LocalBackend/LocalLibrary.vala"
				_g_error_free0 (e);
#line 7497 "LocalLibrary.c"
			}
			__finally2:
#line 840 "../src/LocalBackend/LocalLibrary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 840 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (m);
#line 840 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_m_it);
#line 840 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (remove_treeset);
#line 840 "../src/LocalBackend/LocalLibrary.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 840 "../src/LocalBackend/LocalLibrary.vala"
				g_clear_error (&_inner_error0_);
#line 840 "../src/LocalBackend/LocalLibrary.vala"
				return;
#line 7514 "LocalLibrary.c"
			}
#line 839 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (m);
#line 7518 "LocalLibrary.c"
		}
#line 839 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_m_it);
#line 7522 "LocalLibrary.c"
	}
#line 853 "../src/LocalBackend/LocalLibrary.vala"
	g_signal_emit_by_name ((MusicLibrary*) self, "search-finished");
#line 811 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (remove_treeset);
#line 7528 "LocalLibrary.c"
}

GeeTreeSet*
music_local_library_answer_to_device_sync (MusicLocalLibrary* self,
                                           MusicDevice* device)
{
	GeeTreeSet* medias_to_sync = NULL;
	GeeTreeSet* _tmp0_;
	MusicDevicePreferences* prefs = NULL;
	MusicDevicePreferences* _tmp1_;
	MusicDevicePreferences* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GeeTreeSet* result;
#line 856 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 856 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 857 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 857 "../src/LocalBackend/LocalLibrary.vala"
	medias_to_sync = _tmp0_;
#line 858 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = music_local_library_get_preferences_for_device (self, device);
#line 858 "../src/LocalBackend/LocalLibrary.vala"
	prefs = _tmp1_;
#line 859 "../src/LocalBackend/LocalLibrary.vala"
	_tmp2_ = prefs;
#line 859 "../src/LocalBackend/LocalLibrary.vala"
	_tmp3_ = music_device_preferences_get_sync_music (_tmp2_);
#line 859 "../src/LocalBackend/LocalLibrary.vala"
	_tmp4_ = _tmp3_;
#line 859 "../src/LocalBackend/LocalLibrary.vala"
	if (_tmp4_ == TRUE) {
#line 7563 "LocalLibrary.c"
		MusicDevicePreferences* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 860 "../src/LocalBackend/LocalLibrary.vala"
		_tmp5_ = prefs;
#line 860 "../src/LocalBackend/LocalLibrary.vala"
		_tmp6_ = music_device_preferences_get_sync_all_music (_tmp5_);
#line 860 "../src/LocalBackend/LocalLibrary.vala"
		_tmp7_ = _tmp6_;
#line 860 "../src/LocalBackend/LocalLibrary.vala"
		if (_tmp7_ == TRUE) {
#line 7575 "LocalLibrary.c"
			GeeTreeSet* _tmp8_;
			GeeCollection* _tmp9_;
			GeeCollection* _tmp10_;
#line 861 "../src/LocalBackend/LocalLibrary.vala"
			_tmp8_ = medias_to_sync;
#line 861 "../src/LocalBackend/LocalLibrary.vala"
			_tmp9_ = music_library_get_medias ((MusicLibrary*) self);
#line 861 "../src/LocalBackend/LocalLibrary.vala"
			_tmp10_ = _tmp9_;
#line 861 "../src/LocalBackend/LocalLibrary.vala"
			gee_collection_add_all ((GeeCollection*) _tmp8_, _tmp10_);
#line 861 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (_tmp10_);
#line 7589 "LocalLibrary.c"
		} else {
			GeeTreeSet* _tmp11_;
			MusicDevicePreferences* _tmp12_;
			MusicPlaylist* _tmp13_;
			MusicPlaylist* _tmp14_;
			MusicPlaylist* _tmp15_;
			GeeArrayList* _tmp16_;
			GeeArrayList* _tmp17_;
#line 863 "../src/LocalBackend/LocalLibrary.vala"
			_tmp11_ = medias_to_sync;
#line 863 "../src/LocalBackend/LocalLibrary.vala"
			_tmp12_ = prefs;
#line 863 "../src/LocalBackend/LocalLibrary.vala"
			_tmp13_ = music_device_preferences_get_music_playlist (_tmp12_);
#line 863 "../src/LocalBackend/LocalLibrary.vala"
			_tmp14_ = _tmp13_;
#line 863 "../src/LocalBackend/LocalLibrary.vala"
			_tmp15_ = _tmp14_;
#line 863 "../src/LocalBackend/LocalLibrary.vala"
			_tmp16_ = music_playlist_get_medias (_tmp15_);
#line 863 "../src/LocalBackend/LocalLibrary.vala"
			_tmp17_ = _tmp16_;
#line 863 "../src/LocalBackend/LocalLibrary.vala"
			gee_collection_add_all ((GeeCollection*) _tmp11_, (GeeCollection*) _tmp17_);
#line 863 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (_tmp15_);
#line 7616 "LocalLibrary.c"
		}
	}
#line 867 "../src/LocalBackend/LocalLibrary.vala"
	result = medias_to_sync;
#line 867 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (prefs);
#line 867 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 7625 "LocalLibrary.c"
}

static gboolean
music_local_library_real_start_file_operations (MusicLibrary* base,
                                                const gchar* message)
{
	MusicLocalLibrary * self;
	MusicNotificationManager* _tmp0_;
	MusicNotificationManager* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	MusicLibraryWindow* _tmp3_;
	gboolean result;
#line 870 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 871 "../src/LocalBackend/LocalLibrary.vala"
	if (self->priv->_doing_file_operations) {
#line 872 "../src/LocalBackend/LocalLibrary.vala"
		result = FALSE;
#line 872 "../src/LocalBackend/LocalLibrary.vala"
		return result;
#line 7646 "LocalLibrary.c"
	}
#line 874 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = music_notification_manager_get_default ();
#line 874 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = _tmp0_;
#line 874 "../src/LocalBackend/LocalLibrary.vala"
	g_signal_emit_by_name (_tmp1_, "update-progress", message, 0.0);
#line 874 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_tmp1_);
#line 875 "../src/LocalBackend/LocalLibrary.vala"
	self->priv->_doing_file_operations = TRUE;
#line 876 "../src/LocalBackend/LocalLibrary.vala"
	_tmp2_ = music_app_get_main_window ();
#line 876 "../src/LocalBackend/LocalLibrary.vala"
	_tmp3_ = _tmp2_;
#line 876 "../src/LocalBackend/LocalLibrary.vala"
	music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) _tmp3_, NULL, NULL);
#line 877 "../src/LocalBackend/LocalLibrary.vala"
	g_signal_emit_by_name ((MusicLibrary*) self, "file-operations-started");
#line 878 "../src/LocalBackend/LocalLibrary.vala"
	result = TRUE;
#line 878 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 7670 "LocalLibrary.c"
}

static gboolean
music_local_library_real_doing_file_operations (MusicLibrary* base)
{
	MusicLocalLibrary * self;
	gboolean result;
#line 881 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 882 "../src/LocalBackend/LocalLibrary.vala"
	result = self->priv->_doing_file_operations;
#line 882 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 7684 "LocalLibrary.c"
}

static void
music_local_library_real_finish_file_operations (MusicLibrary* base)
{
	MusicLocalLibrary * self;
	MusicFileOperator* _tmp0_;
	MusicFileOperator* _tmp1_;
	MusicNotificationManager* _tmp2_;
	MusicNotificationManager* _tmp3_;
#line 885 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) base;
#line 886 "../src/LocalBackend/LocalLibrary.vala"
	self->priv->_doing_file_operations = FALSE;
#line 887 "../src/LocalBackend/LocalLibrary.vala"
	g_debug ("LocalLibrary.vala:887: file operations finished or cancelled");
#line 889 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = self->priv->fo;
#line 889 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = self->priv->fo;
#line 889 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_->index = _tmp1_->item_count + 1;
#line 890 "../src/LocalBackend/LocalLibrary.vala"
	_tmp2_ = music_notification_manager_get_default ();
#line 890 "../src/LocalBackend/LocalLibrary.vala"
	_tmp3_ = _tmp2_;
#line 890 "../src/LocalBackend/LocalLibrary.vala"
	g_signal_emit_by_name (_tmp3_, "update-progress", NULL, (gdouble) 1);
#line 890 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_tmp3_);
#line 891 "../src/LocalBackend/LocalLibrary.vala"
	g_signal_emit_by_name ((MusicLibrary*) self, "file-operations-done");
#line 7717 "LocalLibrary.c"
}

MusicDevicePreferences*
music_local_library_get_preferences_for_device (MusicLocalLibrary* self,
                                                MusicDevice* d)
{
	gchar* key = NULL;
	gchar* _tmp0_;
	GeeHashMap* _tmp1_;
	const gchar* _tmp2_;
	MusicDevicePreferences* result;
#line 895 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 895 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (d != NULL, NULL);
#line 896 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = music_device_get_unique_identifier (d);
#line 896 "../src/LocalBackend/LocalLibrary.vala"
	key = _tmp0_;
#line 897 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = self->priv->preferences;
#line 897 "../src/LocalBackend/LocalLibrary.vala"
	_tmp2_ = key;
#line 897 "../src/LocalBackend/LocalLibrary.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, _tmp2_)) {
#line 7743 "LocalLibrary.c"
		GeeHashMap* _tmp3_;
		const gchar* _tmp4_;
		gpointer _tmp5_;
#line 898 "../src/LocalBackend/LocalLibrary.vala"
		_tmp3_ = self->priv->preferences;
#line 898 "../src/LocalBackend/LocalLibrary.vala"
		_tmp4_ = key;
#line 898 "../src/LocalBackend/LocalLibrary.vala"
		_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, _tmp4_);
#line 898 "../src/LocalBackend/LocalLibrary.vala"
		result = (MusicDevicePreferences*) _tmp5_;
#line 898 "../src/LocalBackend/LocalLibrary.vala"
		_g_free0 (key);
#line 898 "../src/LocalBackend/LocalLibrary.vala"
		return result;
#line 7759 "LocalLibrary.c"
	} else {
		MusicDevicePreferences* pref = NULL;
		GdaConnection* _tmp6_;
		MusicDevicePreferences* _tmp7_;
		GeeHashMap* _tmp8_;
		const gchar* _tmp9_;
		MusicDevicePreferences* _tmp10_;
#line 900 "../src/LocalBackend/LocalLibrary.vala"
		_tmp6_ = self->priv->_connection;
#line 900 "../src/LocalBackend/LocalLibrary.vala"
		_tmp7_ = music_device_preferences_new (d, _tmp6_);
#line 900 "../src/LocalBackend/LocalLibrary.vala"
		pref = _tmp7_;
#line 901 "../src/LocalBackend/LocalLibrary.vala"
		_tmp8_ = self->priv->preferences;
#line 901 "../src/LocalBackend/LocalLibrary.vala"
		_tmp9_ = key;
#line 901 "../src/LocalBackend/LocalLibrary.vala"
		_tmp10_ = pref;
#line 901 "../src/LocalBackend/LocalLibrary.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp8_, _tmp9_, _tmp10_);
#line 902 "../src/LocalBackend/LocalLibrary.vala"
		result = pref;
#line 902 "../src/LocalBackend/LocalLibrary.vala"
		_g_free0 (key);
#line 902 "../src/LocalBackend/LocalLibrary.vala"
		return result;
#line 7787 "LocalLibrary.c"
	}
}

/**
     * create or load on database and append to or create album and return in-database Media
     * @param Gee.TreeSet<Media> set of Media
     * @return Gee.HashMap<int64?, LocalMedia> a map of medias in database
     */
static guint
__lambda32_ (MusicLocalLibrary* self,
             gint64* x)
{
	GHashFunc _tmp0_;
	guint result;
#line 912 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = g_int64_hash;
#line 912 "../src/LocalBackend/LocalLibrary.vala"
	result = _tmp0_ (x);
#line 912 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 7808 "LocalLibrary.c"
}

static guint
___lambda32__gee_hash_data_func (gconstpointer v,
                                 gpointer self)
{
	guint result;
	result = __lambda32_ ((MusicLocalLibrary*) self, (gint64*) v);
#line 912 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 7819 "LocalLibrary.c"
}

static gboolean
__lambda33_ (MusicLocalLibrary* self,
             gint64* a,
             gint64* b)
{
	GEqualFunc _tmp0_;
	gboolean result;
#line 912 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = g_int64_equal;
#line 912 "../src/LocalBackend/LocalLibrary.vala"
	result = _tmp0_ (a, b);
#line 912 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 7835 "LocalLibrary.c"
}

static gboolean
___lambda33__gee_equal_data_func (gconstpointer a,
                                  gconstpointer b,
                                  gpointer self)
{
	gboolean result;
	result = __lambda33_ ((MusicLocalLibrary*) self, (gint64*) a, (gint64*) b);
#line 912 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 7847 "LocalLibrary.c"
}

static GeeHashMap*
music_local_library_get_local_medias (MusicLocalLibrary* self,
                                      GeeTreeSet* medias)
{
	GeeHashMap* local_medias = NULL;
	GeeHashMap* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeHashMap* result;
#line 911 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 911 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (medias != NULL, NULL);
#line 912 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, MUSIC_TYPE_LOCAL_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, ___lambda32__gee_hash_data_func, g_object_ref (self), g_object_unref, ___lambda33__gee_equal_data_func, g_object_ref (self), g_object_unref, NULL, NULL, NULL);
#line 912 "../src/LocalBackend/LocalLibrary.vala"
	local_medias = _tmp0_;
#line 7866 "LocalLibrary.c"
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp1_;
#line 914 "../src/LocalBackend/LocalLibrary.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) medias);
#line 914 "../src/LocalBackend/LocalLibrary.vala"
		_media_it = _tmp1_;
#line 914 "../src/LocalBackend/LocalLibrary.vala"
		while (TRUE) {
#line 7876 "LocalLibrary.c"
			GeeIterator* _tmp2_;
			MusicMedia* media = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
#line 914 "../src/LocalBackend/LocalLibrary.vala"
			_tmp2_ = _media_it;
#line 914 "../src/LocalBackend/LocalLibrary.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 914 "../src/LocalBackend/LocalLibrary.vala"
				break;
#line 7887 "LocalLibrary.c"
			}
#line 914 "../src/LocalBackend/LocalLibrary.vala"
			_tmp3_ = _media_it;
#line 914 "../src/LocalBackend/LocalLibrary.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 914 "../src/LocalBackend/LocalLibrary.vala"
			media = (MusicMedia*) _tmp4_;
#line 7895 "LocalLibrary.c"
			{
				MusicLocalMedia* local_m = NULL;
				MusicMedia* _tmp5_;
				gboolean _tmp6_;
				gboolean _tmp7_;
				GeeHashMap* _tmp19_;
				MusicLocalMedia* _tmp20_;
				gint64 _tmp21_;
				gint64 _tmp22_;
				MusicLocalMedia* _tmp23_;
				GeeHashMap* _tmp24_;
				GeeSet* _tmp25_;
				GeeSet* _tmp26_;
				GeeSet* _tmp27_;
				MusicLocalMedia* _tmp28_;
				gboolean _tmp29_;
				MusicLocalMedia* _tmp35_;
				MusicAlbum* _tmp36_;
				MusicAlbum* _tmp37_;
#line 919 "../src/LocalBackend/LocalLibrary.vala"
				_tmp5_ = media;
#line 919 "../src/LocalBackend/LocalLibrary.vala"
				_tmp6_ = music_media_get_show (_tmp5_);
#line 919 "../src/LocalBackend/LocalLibrary.vala"
				_tmp7_ = _tmp6_;
#line 919 "../src/LocalBackend/LocalLibrary.vala"
				if (!_tmp7_) {
#line 7923 "LocalLibrary.c"
					MusicMedia* _tmp8_;
					gint64 _tmp9_;
					gint64 _tmp10_;
					GdaConnection* _tmp11_;
					MusicLocalMedia* _tmp12_;
					MusicLocalMedia* _tmp13_;
#line 920 "../src/LocalBackend/LocalLibrary.vala"
					_tmp8_ = media;
#line 920 "../src/LocalBackend/LocalLibrary.vala"
					_tmp9_ = music_media_get_rowid (_tmp8_);
#line 920 "../src/LocalBackend/LocalLibrary.vala"
					_tmp10_ = _tmp9_;
#line 920 "../src/LocalBackend/LocalLibrary.vala"
					_tmp11_ = self->priv->_connection;
#line 920 "../src/LocalBackend/LocalLibrary.vala"
					_tmp12_ = music_local_media_new (_tmp10_, _tmp11_);
#line 920 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (local_m);
#line 920 "../src/LocalBackend/LocalLibrary.vala"
					local_m = _tmp12_;
#line 921 "../src/LocalBackend/LocalLibrary.vala"
					_tmp13_ = local_m;
#line 921 "../src/LocalBackend/LocalLibrary.vala"
					music_media_set_show ((MusicMedia*) _tmp13_, TRUE);
#line 7948 "LocalLibrary.c"
				} else {
					MusicLocalMedia* _tmp14_ = NULL;
					GdaConnection* _tmp15_;
					MusicMedia* _tmp16_;
					MusicLocalMedia* _tmp17_;
					MusicLocalMedia* _tmp18_;
#line 923 "../src/LocalBackend/LocalLibrary.vala"
					_tmp15_ = self->priv->_connection;
#line 923 "../src/LocalBackend/LocalLibrary.vala"
					_tmp16_ = media;
#line 923 "../src/LocalBackend/LocalLibrary.vala"
					_tmp17_ = music_local_media_new_from_media (_tmp15_, _tmp16_, &_inner_error0_);
#line 923 "../src/LocalBackend/LocalLibrary.vala"
					_tmp14_ = _tmp17_;
#line 923 "../src/LocalBackend/LocalLibrary.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 923 "../src/LocalBackend/LocalLibrary.vala"
						_g_object_unref0 (local_m);
#line 7967 "LocalLibrary.c"
						goto __catch0_g_error;
					}
#line 923 "../src/LocalBackend/LocalLibrary.vala"
					_tmp18_ = _tmp14_;
#line 923 "../src/LocalBackend/LocalLibrary.vala"
					_tmp14_ = NULL;
#line 923 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (local_m);
#line 923 "../src/LocalBackend/LocalLibrary.vala"
					local_m = _tmp18_;
#line 919 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (_tmp14_);
#line 7980 "LocalLibrary.c"
				}
#line 926 "../src/LocalBackend/LocalLibrary.vala"
				_tmp19_ = local_medias;
#line 926 "../src/LocalBackend/LocalLibrary.vala"
				_tmp20_ = local_m;
#line 926 "../src/LocalBackend/LocalLibrary.vala"
				_tmp21_ = music_media_get_rowid ((MusicMedia*) _tmp20_);
#line 926 "../src/LocalBackend/LocalLibrary.vala"
				_tmp22_ = _tmp21_;
#line 926 "../src/LocalBackend/LocalLibrary.vala"
				_tmp23_ = local_m;
#line 926 "../src/LocalBackend/LocalLibrary.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp19_, &_tmp22_, _tmp23_);
#line 928 "../src/LocalBackend/LocalLibrary.vala"
				_tmp24_ = self->priv->album_info;
#line 928 "../src/LocalBackend/LocalLibrary.vala"
				_tmp25_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp24_);
#line 928 "../src/LocalBackend/LocalLibrary.vala"
				_tmp26_ = _tmp25_;
#line 928 "../src/LocalBackend/LocalLibrary.vala"
				_tmp27_ = _tmp26_;
#line 928 "../src/LocalBackend/LocalLibrary.vala"
				_tmp28_ = local_m;
#line 928 "../src/LocalBackend/LocalLibrary.vala"
				_tmp29_ = gee_collection_contains ((GeeCollection*) _tmp27_, (gpointer) ((guintptr) music_media_get_album_hashkey ((MusicMedia*) _tmp28_)));
#line 928 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_tmp27_);
#line 928 "../src/LocalBackend/LocalLibrary.vala"
				if (_tmp29_) {
#line 8010 "LocalLibrary.c"
					MusicAlbum* album = NULL;
					GeeHashMap* _tmp30_;
					MusicLocalMedia* _tmp31_;
					gpointer _tmp32_;
					MusicAlbum* _tmp33_;
					MusicLocalMedia* _tmp34_;
#line 929 "../src/LocalBackend/LocalLibrary.vala"
					_tmp30_ = self->priv->album_info;
#line 929 "../src/LocalBackend/LocalLibrary.vala"
					_tmp31_ = local_m;
#line 929 "../src/LocalBackend/LocalLibrary.vala"
					_tmp32_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp30_, (gpointer) ((guintptr) music_media_get_album_hashkey ((MusicMedia*) _tmp31_)));
#line 929 "../src/LocalBackend/LocalLibrary.vala"
					album = (MusicAlbum*) _tmp32_;
#line 930 "../src/LocalBackend/LocalLibrary.vala"
					_tmp33_ = album;
#line 930 "../src/LocalBackend/LocalLibrary.vala"
					_tmp34_ = local_m;
#line 930 "../src/LocalBackend/LocalLibrary.vala"
					music_album_add_media (_tmp33_, (MusicMedia*) _tmp34_);
#line 928 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (album);
#line 8033 "LocalLibrary.c"
				}
#line 933 "../src/LocalBackend/LocalLibrary.vala"
				_tmp35_ = local_m;
#line 933 "../src/LocalBackend/LocalLibrary.vala"
				_tmp36_ = music_media_get_album_info ((MusicMedia*) _tmp35_);
#line 933 "../src/LocalBackend/LocalLibrary.vala"
				_tmp37_ = _tmp36_;
#line 933 "../src/LocalBackend/LocalLibrary.vala"
				if (_tmp37_ == NULL) {
#line 8043 "LocalLibrary.c"
					MusicAlbum* album = NULL;
					MusicLocalMedia* _tmp38_;
					MusicAlbum* _tmp39_;
					MusicAlbum* _tmp40_;
					MusicLocalMedia* _tmp41_;
					GeeHashMap* _tmp42_;
					MusicAlbum* _tmp43_;
					MusicAlbum* _tmp44_;
					MusicAlbum* _tmp45_;
					GIcon* _tmp46_;
					GIcon* _tmp47_;
#line 934 "../src/LocalBackend/LocalLibrary.vala"
					_tmp38_ = local_m;
#line 934 "../src/LocalBackend/LocalLibrary.vala"
					_tmp39_ = music_album_new_from_media ((MusicMedia*) _tmp38_);
#line 934 "../src/LocalBackend/LocalLibrary.vala"
					album = _tmp39_;
#line 935 "../src/LocalBackend/LocalLibrary.vala"
					_tmp40_ = album;
#line 935 "../src/LocalBackend/LocalLibrary.vala"
					_tmp41_ = local_m;
#line 935 "../src/LocalBackend/LocalLibrary.vala"
					music_album_add_media (_tmp40_, (MusicMedia*) _tmp41_);
#line 936 "../src/LocalBackend/LocalLibrary.vala"
					_tmp42_ = self->priv->album_info;
#line 936 "../src/LocalBackend/LocalLibrary.vala"
					_tmp43_ = album;
#line 936 "../src/LocalBackend/LocalLibrary.vala"
					_tmp44_ = album;
#line 936 "../src/LocalBackend/LocalLibrary.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp42_, (gpointer) ((guintptr) music_album_get_hashkey (_tmp43_)), _tmp44_);
#line 937 "../src/LocalBackend/LocalLibrary.vala"
					_tmp45_ = album;
#line 937 "../src/LocalBackend/LocalLibrary.vala"
					_tmp46_ = music_album_get_cover_icon (_tmp45_);
#line 937 "../src/LocalBackend/LocalLibrary.vala"
					_tmp47_ = _tmp46_;
#line 937 "../src/LocalBackend/LocalLibrary.vala"
					if (_tmp47_ == NULL) {
#line 8083 "LocalLibrary.c"
						MusicAlbum* _tmp48_;
						MusicCoverImport* _tmp49_;
						MusicCoverImport* _tmp50_;
#line 938 "../src/LocalBackend/LocalLibrary.vala"
						_tmp48_ = album;
#line 938 "../src/LocalBackend/LocalLibrary.vala"
						_tmp49_ = music_cover_import_new (_tmp48_);
#line 938 "../src/LocalBackend/LocalLibrary.vala"
						_tmp50_ = _tmp49_;
#line 938 "../src/LocalBackend/LocalLibrary.vala"
						_g_object_unref0 (_tmp50_);
#line 8095 "LocalLibrary.c"
					}
#line 933 "../src/LocalBackend/LocalLibrary.vala"
					_g_object_unref0 (album);
#line 8099 "LocalLibrary.c"
				}
#line 915 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (local_m);
#line 8103 "LocalLibrary.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GError* _tmp51_;
				const gchar* _tmp52_;
#line 915 "../src/LocalBackend/LocalLibrary.vala"
				e = _inner_error0_;
#line 915 "../src/LocalBackend/LocalLibrary.vala"
				_inner_error0_ = NULL;
#line 942 "../src/LocalBackend/LocalLibrary.vala"
				_tmp51_ = e;
#line 942 "../src/LocalBackend/LocalLibrary.vala"
				_tmp52_ = _tmp51_->message;
#line 942 "../src/LocalBackend/LocalLibrary.vala"
				g_warning ("LocalLibrary.vala:942: %s", _tmp52_);
#line 915 "../src/LocalBackend/LocalLibrary.vala"
				_g_error_free0 (e);
#line 8123 "LocalLibrary.c"
			}
			__finally0:
#line 915 "../src/LocalBackend/LocalLibrary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 915 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (media);
#line 915 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (_media_it);
#line 915 "../src/LocalBackend/LocalLibrary.vala"
				_g_object_unref0 (local_medias);
#line 915 "../src/LocalBackend/LocalLibrary.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 915 "../src/LocalBackend/LocalLibrary.vala"
				g_clear_error (&_inner_error0_);
#line 915 "../src/LocalBackend/LocalLibrary.vala"
				return NULL;
#line 8140 "LocalLibrary.c"
			}
#line 914 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (media);
#line 8144 "LocalLibrary.c"
		}
#line 914 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_media_it);
#line 8148 "LocalLibrary.c"
	}
#line 946 "../src/LocalBackend/LocalLibrary.vala"
	result = local_medias;
#line 946 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 8154 "LocalLibrary.c"
}

static GValue*
_g_value_dup (GValue* self)
{
#line 957 "../src/LocalBackend/LocalLibrary.vala"
	return g_boxed_copy (G_TYPE_VALUE, self);
#line 8162 "LocalLibrary.c"
}

static gpointer
__g_value_dup0 (gpointer self)
{
#line 957 "../src/LocalBackend/LocalLibrary.vala"
	return self ? _g_value_dup (self) : NULL;
#line 8170 "LocalLibrary.c"
}

static GeeCollection*
music_local_library_get_rowids_from_table (MusicLocalLibrary* self,
                                           const gchar* table_name)
{
	GeeTreeSet* ids = NULL;
	GeeTreeSet* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeCollection* result;
#line 949 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 949 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (table_name != NULL, NULL);
#line 950 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_tree_set_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 950 "../src/LocalBackend/LocalLibrary.vala"
	ids = _tmp0_;
#line 8189 "LocalLibrary.c"
	{
		GdaSqlBuilder* builder = NULL;
		GdaSqlBuilder* _tmp1_;
		GdaSqlBuilder* _tmp2_;
		GdaSqlBuilder* _tmp3_;
		GdaStatement* _tmp4_ = NULL;
		GdaSqlBuilder* _tmp5_;
		GdaStatement* _tmp6_;
		GdaDataModel* data_model = NULL;
		GdaConnection* _tmp7_;
		GdaDataModel* _tmp8_;
#line 952 "../src/LocalBackend/LocalLibrary.vala"
		_tmp1_ = gda_sql_builder_new (GDA_SQL_STATEMENT_SELECT);
#line 952 "../src/LocalBackend/LocalLibrary.vala"
		builder = _tmp1_;
#line 953 "../src/LocalBackend/LocalLibrary.vala"
		_tmp2_ = builder;
#line 953 "../src/LocalBackend/LocalLibrary.vala"
		gda_sql_builder_select_add_target (_tmp2_, table_name, NULL);
#line 954 "../src/LocalBackend/LocalLibrary.vala"
		_tmp3_ = builder;
#line 954 "../src/LocalBackend/LocalLibrary.vala"
		gda_sql_builder_select_add_field (_tmp3_, "rowid", NULL, NULL);
#line 955 "../src/LocalBackend/LocalLibrary.vala"
		_tmp5_ = builder;
#line 955 "../src/LocalBackend/LocalLibrary.vala"
		_tmp6_ = gda_sql_builder_get_statement (_tmp5_, &_inner_error0_);
#line 955 "../src/LocalBackend/LocalLibrary.vala"
		_tmp4_ = _tmp6_;
#line 955 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 955 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (builder);
#line 8223 "LocalLibrary.c"
			goto __catch0_g_error;
		}
#line 955 "../src/LocalBackend/LocalLibrary.vala"
		_tmp7_ = self->priv->_connection;
#line 955 "../src/LocalBackend/LocalLibrary.vala"
		_tmp8_ = gda_connection_statement_execute_select (_tmp7_, _tmp4_, NULL, &_inner_error0_);
#line 955 "../src/LocalBackend/LocalLibrary.vala"
		data_model = _tmp8_;
#line 955 "../src/LocalBackend/LocalLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 955 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (_tmp4_);
#line 955 "../src/LocalBackend/LocalLibrary.vala"
			_g_object_unref0 (builder);
#line 8238 "LocalLibrary.c"
			goto __catch0_g_error;
		}
		{
			gint i = 0;
#line 956 "../src/LocalBackend/LocalLibrary.vala"
			i = 0;
#line 8245 "LocalLibrary.c"
			{
				gboolean _tmp9_ = FALSE;
#line 956 "../src/LocalBackend/LocalLibrary.vala"
				_tmp9_ = TRUE;
#line 956 "../src/LocalBackend/LocalLibrary.vala"
				while (TRUE) {
#line 8252 "LocalLibrary.c"
					GdaDataModel* _tmp11_;
					GValue* rowid = NULL;
					GdaDataModel* _tmp12_;
					GdaDataModel* _tmp13_;
					GValue* _tmp14_;
					GeeTreeSet* _tmp15_;
					GValue* _tmp16_;
					gint64 _tmp17_;
#line 956 "../src/LocalBackend/LocalLibrary.vala"
					if (!_tmp9_) {
#line 8263 "LocalLibrary.c"
						gint _tmp10_;
#line 956 "../src/LocalBackend/LocalLibrary.vala"
						_tmp10_ = i;
#line 956 "../src/LocalBackend/LocalLibrary.vala"
						i = _tmp10_ + 1;
#line 8269 "LocalLibrary.c"
					}
#line 956 "../src/LocalBackend/LocalLibrary.vala"
					_tmp9_ = FALSE;
#line 956 "../src/LocalBackend/LocalLibrary.vala"
					_tmp11_ = data_model;
#line 956 "../src/LocalBackend/LocalLibrary.vala"
					if (!(i < gda_data_model_get_n_rows (_tmp11_))) {
#line 956 "../src/LocalBackend/LocalLibrary.vala"
						break;
#line 8279 "LocalLibrary.c"
					}
#line 957 "../src/LocalBackend/LocalLibrary.vala"
					_tmp12_ = data_model;
#line 957 "../src/LocalBackend/LocalLibrary.vala"
					_tmp13_ = data_model;
#line 957 "../src/LocalBackend/LocalLibrary.vala"
					_tmp14_ = __g_value_dup0 (gda_data_model_get_value_at (_tmp12_, gda_data_model_get_column_index (_tmp13_, "rowid"), i, &_inner_error0_));
#line 957 "../src/LocalBackend/LocalLibrary.vala"
					rowid = _tmp14_;
#line 957 "../src/LocalBackend/LocalLibrary.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 957 "../src/LocalBackend/LocalLibrary.vala"
						_g_object_unref0 (data_model);
#line 957 "../src/LocalBackend/LocalLibrary.vala"
						_g_object_unref0 (_tmp4_);
#line 957 "../src/LocalBackend/LocalLibrary.vala"
						_g_object_unref0 (builder);
#line 8297 "LocalLibrary.c"
						goto __catch0_g_error;
					}
#line 958 "../src/LocalBackend/LocalLibrary.vala"
					_tmp15_ = ids;
#line 958 "../src/LocalBackend/LocalLibrary.vala"
					_tmp16_ = rowid;
#line 958 "../src/LocalBackend/LocalLibrary.vala"
					_tmp17_ = g_value_get_int64 (_tmp16_);
#line 958 "../src/LocalBackend/LocalLibrary.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, &_tmp17_);
#line 956 "../src/LocalBackend/LocalLibrary.vala"
					__vala_GValue_free0 (rowid);
#line 8310 "LocalLibrary.c"
				}
			}
		}
#line 951 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (data_model);
#line 951 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (_tmp4_);
#line 951 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (builder);
#line 8320 "LocalLibrary.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 951 "../src/LocalBackend/LocalLibrary.vala"
		e = _inner_error0_;
#line 951 "../src/LocalBackend/LocalLibrary.vala"
		_inner_error0_ = NULL;
#line 962 "../src/LocalBackend/LocalLibrary.vala"
		_tmp18_ = e;
#line 962 "../src/LocalBackend/LocalLibrary.vala"
		_tmp19_ = _tmp18_->message;
#line 962 "../src/LocalBackend/LocalLibrary.vala"
		g_critical ("LocalLibrary.vala:962: Could not query table %s : %s", table_name, _tmp19_);
#line 951 "../src/LocalBackend/LocalLibrary.vala"
		_g_error_free0 (e);
#line 8340 "LocalLibrary.c"
	}
	__finally0:
#line 951 "../src/LocalBackend/LocalLibrary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 951 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (ids);
#line 951 "../src/LocalBackend/LocalLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 951 "../src/LocalBackend/LocalLibrary.vala"
		g_clear_error (&_inner_error0_);
#line 951 "../src/LocalBackend/LocalLibrary.vala"
		return NULL;
#line 8353 "LocalLibrary.c"
	}
#line 965 "../src/LocalBackend/LocalLibrary.vala"
	result = (GeeCollection*) ids;
#line 965 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 8359 "LocalLibrary.c"
}

MusicLocalLibrary*
music_local_library_construct (GType object_type)
{
	MusicLocalLibrary * self = NULL;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	self = (MusicLocalLibrary*) music_library_construct (object_type);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	return self;
#line 8370 "LocalLibrary.c"
}

MusicLocalLibrary*
music_local_library_new (void)
{
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	return music_local_library_construct (MUSIC_TYPE_LOCAL_LIBRARY);
#line 8378 "LocalLibrary.c"
}

gboolean
music_local_library_get_main_directory_set (MusicLocalLibrary* self)
{
	gboolean result;
	MusicSettingsMain* _tmp0_;
	MusicSettingsMain* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_;
#line 50 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 50 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = music_settings_main_get_default ();
#line 50 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = _tmp0_;
#line 50 "../src/LocalBackend/LocalLibrary.vala"
	_tmp2_ = music_settings_main_get_music_folder (_tmp1_);
#line 50 "../src/LocalBackend/LocalLibrary.vala"
	_tmp3_ = _tmp2_;
#line 50 "../src/LocalBackend/LocalLibrary.vala"
	_tmp4_ = !music_string_is_empty (_tmp3_, TRUE);
#line 50 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_tmp1_);
#line 50 "../src/LocalBackend/LocalLibrary.vala"
	result = _tmp4_;
#line 50 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 8408 "LocalLibrary.c"
}

GdaConnection*
music_local_library_get_connection (MusicLocalLibrary* self)
{
	GdaConnection* result;
	GdaConnection* _tmp0_;
#line 56 "../src/LocalBackend/LocalLibrary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = self->priv->_connection;
#line 56 "../src/LocalBackend/LocalLibrary.vala"
	result = _tmp0_;
#line 56 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 8424 "LocalLibrary.c"
}

static void
music_local_library_set_connection (MusicLocalLibrary* self,
                                    GdaConnection* value)
{
	GdaConnection* old_value;
#line 56 "../src/LocalBackend/LocalLibrary.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/LocalBackend/LocalLibrary.vala"
	old_value = music_local_library_get_connection (self);
#line 56 "../src/LocalBackend/LocalLibrary.vala"
	if (old_value != value) {
#line 8438 "LocalLibrary.c"
		GdaConnection* _tmp0_;
#line 56 "../src/LocalBackend/LocalLibrary.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 56 "../src/LocalBackend/LocalLibrary.vala"
		_g_object_unref0 (self->priv->_connection);
#line 56 "../src/LocalBackend/LocalLibrary.vala"
		self->priv->_connection = _tmp0_;
#line 56 "../src/LocalBackend/LocalLibrary.vala"
		g_object_notify_by_pspec ((GObject *) self, music_local_library_properties[MUSIC_LOCAL_LIBRARY_CONNECTION_PROPERTY]);
#line 8448 "LocalLibrary.c"
	}
}

static guint
_music_local_library___lambda36_ (MusicLocalLibrary* self,
                                  gint64* x)
{
	GHashFunc _tmp0_;
	guint result;
#line 64 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = g_int64_hash;
#line 64 "../src/LocalBackend/LocalLibrary.vala"
	result = _tmp0_ (x);
#line 64 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 8464 "LocalLibrary.c"
}

static guint
__music_local_library___lambda36__gee_hash_data_func (gconstpointer v,
                                                      gpointer self)
{
	guint result;
	result = _music_local_library___lambda36_ ((MusicLocalLibrary*) self, (gint64*) v);
#line 64 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 8475 "LocalLibrary.c"
}

static gboolean
_music_local_library___lambda37_ (MusicLocalLibrary* self,
                                  gint64* a,
                                  gint64* b)
{
	GEqualFunc _tmp0_;
	gboolean result;
#line 64 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = g_int64_equal;
#line 64 "../src/LocalBackend/LocalLibrary.vala"
	result = _tmp0_ (a, b);
#line 64 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 8491 "LocalLibrary.c"
}

static gboolean
__music_local_library___lambda37__gee_equal_data_func (gconstpointer a,
                                                       gconstpointer b,
                                                       gpointer self)
{
	gboolean result;
	result = _music_local_library___lambda37_ ((MusicLocalLibrary*) self, (gint64*) a, (gint64*) b);
#line 64 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 8503 "LocalLibrary.c"
}

static guint
_music_local_library___lambda38_ (MusicLocalLibrary* self,
                                  gint64* x)
{
	GHashFunc _tmp0_;
	guint result;
#line 65 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = g_int64_hash;
#line 65 "../src/LocalBackend/LocalLibrary.vala"
	result = _tmp0_ (x);
#line 65 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 8518 "LocalLibrary.c"
}

static guint
__music_local_library___lambda38__gee_hash_data_func (gconstpointer v,
                                                      gpointer self)
{
	guint result;
	result = _music_local_library___lambda38_ ((MusicLocalLibrary*) self, (gint64*) v);
#line 65 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 8529 "LocalLibrary.c"
}

static gboolean
_music_local_library___lambda39_ (MusicLocalLibrary* self,
                                  gint64* a,
                                  gint64* b)
{
	GEqualFunc _tmp0_;
	gboolean result;
#line 65 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = g_int64_equal;
#line 65 "../src/LocalBackend/LocalLibrary.vala"
	result = _tmp0_ (a, b);
#line 65 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 8545 "LocalLibrary.c"
}

static gboolean
__music_local_library___lambda39__gee_equal_data_func (gconstpointer a,
                                                       gconstpointer b,
                                                       gpointer self)
{
	gboolean result;
	result = _music_local_library___lambda39_ ((MusicLocalLibrary*) self, (gint64*) a, (gint64*) b);
#line 65 "../src/LocalBackend/LocalLibrary.vala"
	return result;
#line 8557 "LocalLibrary.c"
}

static GObject *
music_local_library_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicLocalLibrary * self;
	MusicLibrariesManager* _tmp0_;
	MusicLibrary* _tmp1_;
	GeeTreeSet* _tmp2_;
	GeeTreeSet* _tmp3_;
	GeeHashMap* _tmp4_;
	GeeHashMap* _tmp5_;
	GeeTreeSet* _tmp6_;
	GeeHashMap* _tmp7_;
	MusicGStreamerTagger* _tmp8_;
	GeeTreeSet* _tmp9_;
	MusicStaticPlaylist* _tmp10_;
	MusicStaticPlaylist* _tmp11_;
	MusicFileOperator* _tmp12_;
#line 60 "../src/LocalBackend/LocalLibrary.vala"
	parent_class = G_OBJECT_CLASS (music_local_library_parent_class);
#line 60 "../src/LocalBackend/LocalLibrary.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 60 "../src/LocalBackend/LocalLibrary.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibrary);
#line 61 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = music_libraries_manager;
#line 61 "../src/LocalBackend/LocalLibrary.vala"
	_tmp1_ = _g_object_ref0 ((MusicLibrary*) self);
#line 61 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (_tmp0_->local_library);
#line 61 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_->local_library = _tmp1_;
#line 62 "../src/LocalBackend/LocalLibrary.vala"
	_tmp2_ = gee_tree_set_new (MUSIC_TYPE_STATIC_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 62 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->_playlists);
#line 62 "../src/LocalBackend/LocalLibrary.vala"
	self->priv->_playlists = _tmp2_;
#line 63 "../src/LocalBackend/LocalLibrary.vala"
	_tmp3_ = gee_tree_set_new (MUSIC_TYPE_SMART_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 63 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->_smart_playlists);
#line 63 "../src/LocalBackend/LocalLibrary.vala"
	self->priv->_smart_playlists = _tmp3_;
#line 64 "../src/LocalBackend/LocalLibrary.vala"
	_tmp4_ = gee_hash_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, __music_local_library___lambda36__gee_hash_data_func, g_object_ref (self), g_object_unref, __music_local_library___lambda37__gee_equal_data_func, g_object_ref (self), g_object_unref, NULL, NULL, NULL);
#line 64 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->_medias);
#line 64 "../src/LocalBackend/LocalLibrary.vala"
	self->priv->_medias = _tmp4_;
#line 65 "../src/LocalBackend/LocalLibrary.vala"
	_tmp5_ = gee_hash_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, __music_local_library___lambda38__gee_hash_data_func, g_object_ref (self), g_object_unref, __music_local_library___lambda39__gee_equal_data_func, g_object_ref (self), g_object_unref, NULL, NULL, NULL);
#line 65 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->_dont_show_medias);
#line 65 "../src/LocalBackend/LocalLibrary.vala"
	self->priv->_dont_show_medias = _tmp5_;
#line 66 "../src/LocalBackend/LocalLibrary.vala"
	_tmp6_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 66 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->_searched_medias);
#line 66 "../src/LocalBackend/LocalLibrary.vala"
	self->priv->_searched_medias = _tmp6_;
#line 67 "../src/LocalBackend/LocalLibrary.vala"
	_tmp7_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, MUSIC_TYPE_ALBUM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 67 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->album_info);
#line 67 "../src/LocalBackend/LocalLibrary.vala"
	self->priv->album_info = _tmp7_;
#line 68 "../src/LocalBackend/LocalLibrary.vala"
	_tmp8_ = music_gstreamer_tagger_new (NULL);
#line 68 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->tagger);
#line 68 "../src/LocalBackend/LocalLibrary.vala"
	self->priv->tagger = _tmp8_;
#line 69 "../src/LocalBackend/LocalLibrary.vala"
	_tmp9_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 69 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->open_media_list);
#line 69 "../src/LocalBackend/LocalLibrary.vala"
	self->priv->open_media_list = _tmp9_;
#line 70 "../src/LocalBackend/LocalLibrary.vala"
	_tmp10_ = music_static_playlist_new ();
#line 70 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->p_music);
#line 70 "../src/LocalBackend/LocalLibrary.vala"
	self->p_music = _tmp10_;
#line 71 "../src/LocalBackend/LocalLibrary.vala"
	_tmp11_ = self->p_music;
#line 71 "../src/LocalBackend/LocalLibrary.vala"
	music_playlist_set_name ((MusicPlaylist*) _tmp11_, MUSIC_MUSIC_PLAYLIST);
#line 73 "../src/LocalBackend/LocalLibrary.vala"
	_tmp12_ = music_file_operator_new ();
#line 73 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->fo);
#line 73 "../src/LocalBackend/LocalLibrary.vala"
	self->priv->fo = _tmp12_;
#line 60 "../src/LocalBackend/LocalLibrary.vala"
	return obj;
#line 8661 "LocalLibrary.c"
}

static void
music_local_library_class_init (MusicLocalLibraryClass * klass,
                                gpointer klass_data)
{
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	music_local_library_parent_class = g_type_class_peek_parent (klass);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_type_class_adjust_private_offset (klass, &MusicLocalLibrary_private_offset);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->initialize_library = (void (*) (MusicLibrary*)) music_local_library_real_initialize_library;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->add_files_to_library = (void (*) (MusicLibrary*, GeeCollection*)) music_local_library_real_add_files_to_library;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->support_playlists = (gboolean (*) (MusicLibrary*)) music_local_library_real_support_playlists;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->get_playlists = (GeeCollection* (*) (MusicLibrary*)) music_local_library_real_get_playlists;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->playlist_from_id = (MusicStaticPlaylist* (*) (MusicLibrary*, gint64)) music_local_library_real_playlist_from_id;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->playlist_from_name = (MusicStaticPlaylist* (*) (MusicLibrary*, const gchar*)) music_local_library_real_playlist_from_name;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->add_playlist = (void (*) (MusicLibrary*, MusicStaticPlaylist*)) music_local_library_real_add_playlist;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->remove_playlist = (void (*) (MusicLibrary*, gint64)) music_local_library_real_remove_playlist;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->support_smart_playlists = (gboolean (*) (MusicLibrary*)) music_local_library_real_support_smart_playlists;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->get_smart_playlists = (GeeCollection* (*) (MusicLibrary*)) music_local_library_real_get_smart_playlists;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->smart_playlist_from_id = (MusicSmartPlaylist* (*) (MusicLibrary*, gint64)) music_local_library_real_smart_playlist_from_id;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->smart_playlist_from_name = (MusicSmartPlaylist* (*) (MusicLibrary*, const gchar*)) music_local_library_real_smart_playlist_from_name;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->add_smart_playlist = (void (*) (MusicLibrary*, MusicSmartPlaylist*)) music_local_library_real_add_smart_playlist;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->remove_smart_playlist = (void (*) (MusicLibrary*, gint64)) music_local_library_real_remove_smart_playlist;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->search_medias = (void (*) (MusicLibrary*, const gchar*)) music_local_library_real_search_medias;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->get_search_result = (GeeCollection* (*) (MusicLibrary*)) music_local_library_real_get_search_result;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->get_medias = (GeeCollection* (*) (MusicLibrary*)) music_local_library_real_get_medias;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->update_media = (void (*) (MusicLibrary*, MusicMedia*, gboolean, gboolean)) music_local_library_real_update_media;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->update_medias = (void (*) (MusicLibrary*, GeeCollection*, gboolean, gboolean)) music_local_library_real_update_medias;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->media_from_id = (MusicMedia* (*) (MusicLibrary*, gint64)) music_local_library_real_media_from_id;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->find_media = (MusicMedia* (*) (MusicLibrary*, MusicMedia*)) music_local_library_real_find_media;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->media_from_file = (MusicMedia* (*) (MusicLibrary*, GFile*)) music_local_library_real_media_from_file;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->media_from_uri = (MusicMedia* (*) (MusicLibrary*, const gchar*)) music_local_library_real_media_from_uri;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->medias_from_ids = (GeeCollection* (*) (MusicLibrary*, GeeCollection*)) music_local_library_real_medias_from_ids;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->medias_from_uris = (GeeCollection* (*) (MusicLibrary*, GeeCollection*)) music_local_library_real_medias_from_uris;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->add_media = (void (*) (MusicLibrary*, MusicMedia*)) music_local_library_real_add_media;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->add_medias = (void (*) (MusicLibrary*, GeeCollection*)) music_local_library_real_add_medias;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->remove_media = (void (*) (MusicLibrary*, MusicMedia*, gboolean)) music_local_library_real_remove_media;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->remove_medias = (void (*) (MusicLibrary*, GeeCollection*, gboolean)) music_local_library_real_remove_medias;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->start_file_operations = (gboolean (*) (MusicLibrary*, const gchar*)) music_local_library_real_start_file_operations;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->doing_file_operations = (gboolean (*) (MusicLibrary*)) music_local_library_real_doing_file_operations;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	((MusicLibraryClass *) klass)->finish_file_operations = (void (*) (MusicLibrary*)) music_local_library_real_finish_file_operations;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_local_library_get_property;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_local_library_set_property;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	G_OBJECT_CLASS (klass)->constructor = music_local_library_constructor;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	G_OBJECT_CLASS (klass)->finalize = music_local_library_finalize;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_LIBRARY_MAIN_DIRECTORY_SET_PROPERTY, music_local_library_properties[MUSIC_LOCAL_LIBRARY_MAIN_DIRECTORY_SET_PROPERTY] = g_param_spec_boolean ("main-directory-set", "main-directory-set", "main-directory-set", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_LIBRARY_CONNECTION_PROPERTY, music_local_library_properties[MUSIC_LOCAL_LIBRARY_CONNECTION_PROPERTY] = g_param_spec_object ("connection", "connection", "connection", gda_connection_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8748 "LocalLibrary.c"
}

static void
music_local_library_instance_init (MusicLocalLibrary * self,
                                   gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	self->priv = music_local_library_get_instance_private (self);
#line 40 "../src/LocalBackend/LocalLibrary.vala"
	g_rec_mutex_init (&self->priv->__lock__playlists);
#line 41 "../src/LocalBackend/LocalLibrary.vala"
	g_rec_mutex_init (&self->priv->__lock__smart_playlists);
#line 42 "../src/LocalBackend/LocalLibrary.vala"
	g_rec_mutex_init (&self->priv->__lock__medias);
#line 43 "../src/LocalBackend/LocalLibrary.vala"
	g_rec_mutex_init (&self->priv->__lock__searched_medias);
#line 54 "../src/LocalBackend/LocalLibrary.vala"
	self->priv->_doing_file_operations = FALSE;
#line 894 "../src/LocalBackend/LocalLibrary.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, MUSIC_TYPE_DEVICE_PREFERENCES, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 894 "../src/LocalBackend/LocalLibrary.vala"
	self->priv->preferences = _tmp0_;
#line 8772 "LocalLibrary.c"
}

static void
music_local_library_finalize (GObject * obj)
{
	MusicLocalLibrary * self;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibrary);
#line 37 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->fo);
#line 38 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->tagger);
#line 40 "../src/LocalBackend/LocalLibrary.vala"
	g_rec_mutex_clear (&self->priv->__lock__playlists);
#line 40 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->_playlists);
#line 41 "../src/LocalBackend/LocalLibrary.vala"
	g_rec_mutex_clear (&self->priv->__lock__smart_playlists);
#line 41 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->_smart_playlists);
#line 42 "../src/LocalBackend/LocalLibrary.vala"
	g_rec_mutex_clear (&self->priv->__lock__medias);
#line 42 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->_medias);
#line 43 "../src/LocalBackend/LocalLibrary.vala"
	g_rec_mutex_clear (&self->priv->__lock__searched_medias);
#line 43 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->_searched_medias);
#line 44 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->album_info);
#line 45 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->_dont_show_medias);
#line 47 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->p_music);
#line 53 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->open_media_list);
#line 56 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->_connection);
#line 894 "../src/LocalBackend/LocalLibrary.vala"
	_g_object_unref0 (self->priv->preferences);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	G_OBJECT_CLASS (music_local_library_parent_class)->finalize (obj);
#line 8815 "LocalLibrary.c"
}

/**
 * This is where all the media stuff happens. Here, media is retrieved
 * from the db, added to the queue, sorted, and more. LibraryWindow is
 * the visual representation of this class
 */
static GType
music_local_library_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicLocalLibraryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_local_library_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicLocalLibrary), 0, (GInstanceInitFunc) music_local_library_instance_init, NULL };
	GType music_local_library_type_id;
	music_local_library_type_id = g_type_register_static (MUSIC_TYPE_LIBRARY, "MusicLocalLibrary", &g_define_type_info, 0);
	MusicLocalLibrary_private_offset = g_type_add_instance_private (music_local_library_type_id, sizeof (MusicLocalLibraryPrivate));
	return music_local_library_type_id;
}

GType
music_local_library_get_type (void)
{
	static volatile gsize music_local_library_type_id__once = 0;
	if (g_once_init_enter (&music_local_library_type_id__once)) {
		GType music_local_library_type_id;
		music_local_library_type_id = music_local_library_get_type_once ();
		g_once_init_leave (&music_local_library_type_id__once, music_local_library_type_id);
	}
	return music_local_library_type_id__once;
}

static void
_vala_music_local_library_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	MusicLocalLibrary * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibrary);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	switch (property_id) {
#line 36 "../src/LocalBackend/LocalLibrary.vala"
		case MUSIC_LOCAL_LIBRARY_MAIN_DIRECTORY_SET_PROPERTY:
#line 36 "../src/LocalBackend/LocalLibrary.vala"
		g_value_set_boolean (value, music_local_library_get_main_directory_set (self));
#line 36 "../src/LocalBackend/LocalLibrary.vala"
		break;
#line 36 "../src/LocalBackend/LocalLibrary.vala"
		case MUSIC_LOCAL_LIBRARY_CONNECTION_PROPERTY:
#line 36 "../src/LocalBackend/LocalLibrary.vala"
		g_value_set_object (value, music_local_library_get_connection (self));
#line 36 "../src/LocalBackend/LocalLibrary.vala"
		break;
#line 8867 "LocalLibrary.c"
		default:
#line 36 "../src/LocalBackend/LocalLibrary.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
		break;
#line 8873 "LocalLibrary.c"
	}
}

static void
_vala_music_local_library_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	MusicLocalLibrary * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibrary);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
	switch (property_id) {
#line 36 "../src/LocalBackend/LocalLibrary.vala"
		case MUSIC_LOCAL_LIBRARY_CONNECTION_PROPERTY:
#line 36 "../src/LocalBackend/LocalLibrary.vala"
		music_local_library_set_connection (self, g_value_get_object (value));
#line 36 "../src/LocalBackend/LocalLibrary.vala"
		break;
#line 8893 "LocalLibrary.c"
		default:
#line 36 "../src/LocalBackend/LocalLibrary.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "../src/LocalBackend/LocalLibrary.vala"
		break;
#line 8899 "LocalLibrary.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

