/* PlaybackManager.c generated by valac 0.56.0, the Vala compiler
 * generated from PlaybackManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gee.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gst/gst.h>
#include <handy.h>
#include <glib/gi18n-lib.h>

#define MUSIC_LIBRARY_WINDOW_ACTION_PLAY "action_play"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_PLAYBACK_MANAGER (music_playback_manager_get_type ())
#define MUSIC_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager))
#define MUSIC_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))
#define MUSIC_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))

typedef struct _MusicPlaybackManager MusicPlaybackManager;
typedef struct _MusicPlaybackManagerClass MusicPlaybackManagerClass;
typedef struct _MusicPlaybackManagerPrivate MusicPlaybackManagerPrivate;

#define MUSIC_TYPE_HISTORY_PLAYLIST (music_history_playlist_get_type ())
#define MUSIC_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_HISTORY_PLAYLIST, MusicHistoryPlaylist))
#define MUSIC_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_HISTORY_PLAYLIST, MusicHistoryPlaylistClass))
#define MUSIC_IS_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_HISTORY_PLAYLIST))
#define MUSIC_IS_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_HISTORY_PLAYLIST))
#define MUSIC_HISTORY_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_HISTORY_PLAYLIST, MusicHistoryPlaylistClass))

typedef struct _MusicHistoryPlaylist MusicHistoryPlaylist;
typedef struct _MusicHistoryPlaylistClass MusicHistoryPlaylistClass;

#define MUSIC_TYPE_STREAMER (music_streamer_get_type ())
#define MUSIC_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_STREAMER, MusicStreamer))
#define MUSIC_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_STREAMER, MusicStreamerClass))
#define MUSIC_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_STREAMER))
#define MUSIC_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_STREAMER))
#define MUSIC_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_STREAMER, MusicStreamerClass))

typedef struct _MusicStreamer MusicStreamer;
typedef struct _MusicStreamerClass MusicStreamerClass;
enum  {
	MUSIC_PLAYBACK_MANAGER_0_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_NUM_PROPERTIES
};
static GParamSpec* music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_NUM_PROPERTIES];
typedef enum  {
	MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_OFF,
	MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_ALL
} MusicPlaybackManagerShuffleMode;

#define MUSIC_PLAYBACK_MANAGER_TYPE_SHUFFLE_MODE (music_playback_manager_shuffle_mode_get_type ())
typedef enum  {
	MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_OFF,
	MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_MEDIA,
	MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALL,
	MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALBUM,
	MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ARTIST
} MusicPlaybackManagerRepeatMode;

#define MUSIC_PLAYBACK_MANAGER_TYPE_REPEAT_MODE (music_playback_manager_repeat_mode_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block11Data Block11Data;
#define _g_free0(var) (var = (g_free (var), NULL))

#define MUSIC_TYPE_LIBRARY_WINDOW (music_library_window_get_type ())
#define MUSIC_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow))
#define MUSIC_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))
#define MUSIC_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))

typedef struct _MusicLibraryWindow MusicLibraryWindow;
typedef struct _MusicLibraryWindowClass MusicLibraryWindowClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	MUSIC_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_NUM_SIGNALS
};
static guint music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_NUM_SIGNALS] = {0};

struct _MusicPlaybackManager {
	GObject parent_instance;
	MusicPlaybackManagerPrivate * priv;
	MusicStaticPlaylist* queue_playlist;
	MusicHistoryPlaylist* history_playlist;
	MusicStreamer* file_player;
	MusicPlayback* player;
};

struct _MusicPlaybackManagerClass {
	GObjectClass parent_class;
};

struct _MusicPlaybackManagerPrivate {
	GeeTreeSet* playbacks;
	GRecMutex __lock_playbacks;
	GeeHashMap* _current;
	GeeHashMap* _current_shuffled;
	gint _current_index;
	gint _current_shuffled_index;
	gboolean _playing;
	gdouble saved_volume;
	gboolean _playing_queued_song;
	MusicMedia* _current_media;
};

struct _Block11Data {
	int _ref_count_;
	MusicPlaybackManager* self;
	MusicMedia* m;
};

static gint MusicPlaybackManager_private_offset;
static gpointer music_playback_manager_parent_class = NULL;

VALA_EXTERN GType music_playback_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPlaybackManager, g_object_unref)
VALA_EXTERN GType music_history_playlist_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicHistoryPlaylist, g_object_unref)
VALA_EXTERN GType music_streamer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicStreamer, g_object_unref)
VALA_EXTERN GType music_playback_manager_shuffle_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType music_playback_manager_repeat_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void music_playback_manager_add_playback (MusicPlaybackManager* self,
                                          MusicPlayback* playback);
VALA_EXTERN void music_playback_manager_queue_media (MusicPlaybackManager* self,
                                         GeeCollection* to_queue);
static void music_playback_manager_add_to_current (MusicPlaybackManager* self,
                                            MusicMedia* m);
static void music_playback_manager_reshuffle (MusicPlaybackManager* self);
VALA_EXTERN void music_playback_manager_unqueue_media (MusicPlaybackManager* self,
                                           GeeCollection* to_unqueue);
VALA_EXTERN MusicMedia* music_playback_manager_get_current_media (MusicPlaybackManager* self);
VALA_EXTERN gint music_playback_manager_get_current_index (MusicPlaybackManager* self);
VALA_EXTERN void music_playback_manager_set_current_index (MusicPlaybackManager* self,
                                               gint value);
static void music_playback_manager_set_current_media (MusicPlaybackManager* self,
                                               MusicMedia* value);
VALA_EXTERN void music_playback_manager_play_media (MusicPlaybackManager* self,
                                        MusicMedia* m);
VALA_EXTERN void music_playback_manager_stop_playback (MusicPlaybackManager* self);
VALA_EXTERN void music_playback_manager_clear_queue (MusicPlaybackManager* self);
VALA_EXTERN MusicMedia* music_playback_manager_media_from_current_index (MusicPlaybackManager* self,
                                                             gint index_in_current);
VALA_EXTERN GSettings* music_app_get_settings (void);
VALA_EXTERN GeeCollection* music_playback_manager_get_current_media_list (MusicPlaybackManager* self);
VALA_EXTERN void music_playback_manager_set_repeat_mode (MusicPlaybackManager* self,
                                             MusicPlaybackManagerRepeatMode mode);
VALA_EXTERN void music_playback_manager_set_shuffle_mode (MusicPlaybackManager* self,
                                              MusicPlaybackManagerShuffleMode mode);
VALA_EXTERN MusicMedia* music_playback_manager_get_next (MusicPlaybackManager* self,
                                             gboolean play);
static MusicLibrary* music_playback_manager_get_library (MusicPlaybackManager* self);
VALA_EXTERN MusicMedia* music_playback_manager_get_previous (MusicPlaybackManager* self,
                                                 gboolean play);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
VALA_EXTERN void music_playback_manager_set_volume (MusicPlaybackManager* self,
                                        gdouble value);
VALA_EXTERN void music_playback_manager_change_gains_thread (MusicPlaybackManager* self);
VALA_EXTERN gboolean music_playback_manager_get_playing (MusicPlaybackManager* self);
VALA_EXTERN GSettings* music_app_get_saved_state (void);
static gboolean __lambda31_ (Block11Data* _data11_);
static gboolean ___lambda31__gsource_func (gpointer self);
VALA_EXTERN GSettings* music_app_get_equalizer_settings (void);
static gboolean music_playback_manager_auto_genre_eq (MusicPlaybackManager* self,
                                               MusicEqualizerPreset* preset);
static void music_playback_manager_set_playing (MusicPlaybackManager* self,
                                         gboolean value);
VALA_EXTERN void music_playback_manager_start_playback (MusicPlaybackManager* self);
VALA_EXTERN GType music_library_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLibraryWindow, g_object_unref)
VALA_EXTERN MusicLibraryWindow* music_app_get_main_window (void);
static GVariant* _variant_new4 (gboolean value);
VALA_EXTERN void music_playback_manager_pause_playback (MusicPlaybackManager* self);
static GVariant* _variant_new5 (gboolean value);
VALA_EXTERN MusicPlaybackManager* music_playback_manager_new (void);
VALA_EXTERN MusicPlaybackManager* music_playback_manager_construct (GType object_type);
VALA_EXTERN gdouble music_playback_manager_get_volume (MusicPlaybackManager* self);
static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data);
static GObject * music_playback_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
VALA_EXTERN MusicHistoryPlaylist* music_history_playlist_new (void);
VALA_EXTERN MusicHistoryPlaylist* music_history_playlist_construct (GType object_type);
VALA_EXTERN MusicStreamer* music_streamer_new (void);
VALA_EXTERN MusicStreamer* music_streamer_construct (GType object_type);
static void music_playback_manager_finalize (GObject * obj);
static GType music_playback_manager_get_type_once (void);
static void _vala_music_playback_manager_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_music_playback_manager_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
music_playback_manager_get_instance_private (MusicPlaybackManager* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPlaybackManager_private_offset);
}

static GType
music_playback_manager_shuffle_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_OFF, "MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_OFF", "off"}, {MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_ALL, "MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_ALL", "all"}, {0, NULL, NULL}};
	GType music_playback_manager_shuffle_mode_type_id;
	music_playback_manager_shuffle_mode_type_id = g_enum_register_static ("MusicPlaybackManagerShuffleMode", values);
	return music_playback_manager_shuffle_mode_type_id;
}

GType
music_playback_manager_shuffle_mode_get_type (void)
{
	static volatile gsize music_playback_manager_shuffle_mode_type_id__once = 0;
	if (g_once_init_enter (&music_playback_manager_shuffle_mode_type_id__once)) {
		GType music_playback_manager_shuffle_mode_type_id;
		music_playback_manager_shuffle_mode_type_id = music_playback_manager_shuffle_mode_get_type_once ();
		g_once_init_leave (&music_playback_manager_shuffle_mode_type_id__once, music_playback_manager_shuffle_mode_type_id);
	}
	return music_playback_manager_shuffle_mode_type_id__once;
}

static GType
music_playback_manager_repeat_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_OFF, "MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_OFF", "off"}, {MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_MEDIA, "MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_MEDIA", "media"}, {MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALL, "MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALL", "all"}, {MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALBUM, "MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALBUM", "album"}, {MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ARTIST, "MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ARTIST", "artist"}, {0, NULL, NULL}};
	GType music_playback_manager_repeat_mode_type_id;
	music_playback_manager_repeat_mode_type_id = g_enum_register_static ("MusicPlaybackManagerRepeatMode", values);
	return music_playback_manager_repeat_mode_type_id;
}

GType
music_playback_manager_repeat_mode_get_type (void)
{
	static volatile gsize music_playback_manager_repeat_mode_type_id__once = 0;
	if (g_once_init_enter (&music_playback_manager_repeat_mode_type_id__once)) {
		GType music_playback_manager_repeat_mode_type_id;
		music_playback_manager_repeat_mode_type_id = music_playback_manager_repeat_mode_get_type_once ();
		g_once_init_leave (&music_playback_manager_repeat_mode_type_id__once, music_playback_manager_repeat_mode_type_id);
	}
	return music_playback_manager_repeat_mode_type_id__once;
}

void
music_playback_manager_add_playback (MusicPlaybackManager* self,
                                     MusicPlayback* playback)
{
	GeeTreeSet* _tmp0_;
#line 128 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/PlaybackManager.vala"
	g_return_if_fail (playback != NULL);
#line 129 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->playbacks;
#line 129 "../src/PlaybackManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, playback);
#line 328 "PlaybackManager.c"
}

void
music_playback_manager_queue_media (MusicPlaybackManager* self,
                                    GeeCollection* to_queue)
{
	gint _tmp0_;
	gint _tmp1_;
	MusicStaticPlaylist* _tmp10_;
#line 132 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 132 "../src/PlaybackManager.vala"
	g_return_if_fail (to_queue != NULL);
#line 133 "../src/PlaybackManager.vala"
	_tmp0_ = gee_collection_get_size (to_queue);
#line 133 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 133 "../src/PlaybackManager.vala"
	if (_tmp1_ < 1) {
#line 134 "../src/PlaybackManager.vala"
		return;
#line 350 "PlaybackManager.c"
	}
	{
		GeeIterator* _q_it = NULL;
		GeeIterator* _tmp2_;
#line 137 "../src/PlaybackManager.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) to_queue);
#line 137 "../src/PlaybackManager.vala"
		_q_it = _tmp2_;
#line 137 "../src/PlaybackManager.vala"
		while (TRUE) {
#line 361 "PlaybackManager.c"
			GeeIterator* _tmp3_;
			MusicMedia* q = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			MusicMedia* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			MusicMedia* _tmp9_;
#line 137 "../src/PlaybackManager.vala"
			_tmp3_ = _q_it;
#line 137 "../src/PlaybackManager.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 137 "../src/PlaybackManager.vala"
				break;
#line 376 "PlaybackManager.c"
			}
#line 137 "../src/PlaybackManager.vala"
			_tmp4_ = _q_it;
#line 137 "../src/PlaybackManager.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 137 "../src/PlaybackManager.vala"
			q = (MusicMedia*) _tmp5_;
#line 138 "../src/PlaybackManager.vala"
			_tmp6_ = q;
#line 138 "../src/PlaybackManager.vala"
			_tmp7_ = music_media_get_title (_tmp6_);
#line 138 "../src/PlaybackManager.vala"
			_tmp8_ = _tmp7_;
#line 138 "../src/PlaybackManager.vala"
			g_debug ("PlaybackManager.vala:138: QUEUED: %s", _tmp8_);
#line 139 "../src/PlaybackManager.vala"
			_tmp9_ = q;
#line 139 "../src/PlaybackManager.vala"
			music_playback_manager_add_to_current (self, _tmp9_);
#line 137 "../src/PlaybackManager.vala"
			_g_object_unref0 (q);
#line 398 "PlaybackManager.c"
		}
#line 137 "../src/PlaybackManager.vala"
		_g_object_unref0 (_q_it);
#line 402 "PlaybackManager.c"
	}
#line 142 "../src/PlaybackManager.vala"
	_tmp10_ = self->queue_playlist;
#line 142 "../src/PlaybackManager.vala"
	music_playlist_add_medias ((MusicPlaylist*) _tmp10_, to_queue);
#line 143 "../src/PlaybackManager.vala"
	music_playback_manager_reshuffle (self);
#line 410 "PlaybackManager.c"
}

void
music_playback_manager_unqueue_media (MusicPlaybackManager* self,
                                      GeeCollection* to_unqueue)
{
	MusicStaticPlaylist* _tmp0_;
	GeeHashMap* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeHashMap* _tmp32_;
#line 146 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 146 "../src/PlaybackManager.vala"
	g_return_if_fail (to_unqueue != NULL);
#line 147 "../src/PlaybackManager.vala"
	_tmp0_ = self->queue_playlist;
#line 147 "../src/PlaybackManager.vala"
	music_playlist_remove_medias ((MusicPlaylist*) _tmp0_, to_unqueue);
#line 149 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current;
#line 149 "../src/PlaybackManager.vala"
	_tmp2_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp1_);
#line 149 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 149 "../src/PlaybackManager.vala"
	_tmp4_ = gee_collection_get_size (to_unqueue);
#line 149 "../src/PlaybackManager.vala"
	_tmp5_ = _tmp4_;
#line 149 "../src/PlaybackManager.vala"
	if ((_tmp3_ - _tmp5_) > 0) {
#line 444 "PlaybackManager.c"
		gboolean current_media_changed = FALSE;
		gboolean _tmp29_ = FALSE;
#line 150 "../src/PlaybackManager.vala"
		current_media_changed = FALSE;
#line 151 "../src/PlaybackManager.vala"
		while (TRUE) {
#line 451 "PlaybackManager.c"
			gboolean _tmp6_ = FALSE;
			MusicMedia* _tmp7_;
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			GeeHashMap* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			GeeHashMap* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
#line 151 "../src/PlaybackManager.vala"
			_tmp7_ = self->priv->_current_media;
#line 151 "../src/PlaybackManager.vala"
			if (_tmp7_ != NULL) {
#line 468 "PlaybackManager.c"
				MusicMedia* _tmp8_;
#line 151 "../src/PlaybackManager.vala"
				_tmp8_ = self->priv->_current_media;
#line 151 "../src/PlaybackManager.vala"
				_tmp6_ = gee_collection_contains (to_unqueue, _tmp8_);
#line 474 "PlaybackManager.c"
			} else {
#line 151 "../src/PlaybackManager.vala"
				_tmp6_ = FALSE;
#line 478 "PlaybackManager.c"
			}
#line 151 "../src/PlaybackManager.vala"
			if (!_tmp6_) {
#line 151 "../src/PlaybackManager.vala"
				break;
#line 484 "PlaybackManager.c"
			}
#line 152 "../src/PlaybackManager.vala"
			current_media_changed = TRUE;
#line 153 "../src/PlaybackManager.vala"
			_tmp9_ = music_playback_manager_get_current_index (self);
#line 153 "../src/PlaybackManager.vala"
			_tmp10_ = _tmp9_;
#line 153 "../src/PlaybackManager.vala"
			music_playback_manager_set_current_index (self, _tmp10_ + 1);
#line 154 "../src/PlaybackManager.vala"
			_tmp11_ = music_playback_manager_get_current_index (self);
#line 154 "../src/PlaybackManager.vala"
			_tmp12_ = _tmp11_;
#line 154 "../src/PlaybackManager.vala"
			_tmp13_ = self->priv->_current;
#line 154 "../src/PlaybackManager.vala"
			_tmp14_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp13_);
#line 154 "../src/PlaybackManager.vala"
			_tmp15_ = _tmp14_;
#line 154 "../src/PlaybackManager.vala"
			if (_tmp12_ >= _tmp15_) {
#line 155 "../src/PlaybackManager.vala"
				music_playback_manager_set_current_index (self, 0);
#line 508 "PlaybackManager.c"
			}
#line 157 "../src/PlaybackManager.vala"
			_tmp16_ = self->priv->_current_shuffled;
#line 157 "../src/PlaybackManager.vala"
			_tmp17_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp16_);
#line 157 "../src/PlaybackManager.vala"
			_tmp18_ = _tmp17_;
#line 157 "../src/PlaybackManager.vala"
			if (_tmp18_ == 0) {
#line 518 "PlaybackManager.c"
				GeeHashMap* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gpointer _tmp22_;
				MusicMedia* _tmp23_;
#line 158 "../src/PlaybackManager.vala"
				_tmp19_ = self->priv->_current;
#line 158 "../src/PlaybackManager.vala"
				_tmp20_ = music_playback_manager_get_current_index (self);
#line 158 "../src/PlaybackManager.vala"
				_tmp21_ = _tmp20_;
#line 158 "../src/PlaybackManager.vala"
				_tmp22_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp19_, (gpointer) ((gintptr) _tmp21_));
#line 158 "../src/PlaybackManager.vala"
				_tmp23_ = (MusicMedia*) _tmp22_;
#line 158 "../src/PlaybackManager.vala"
				music_playback_manager_set_current_media (self, _tmp23_);
#line 158 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp23_);
#line 538 "PlaybackManager.c"
			} else {
				GeeHashMap* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gpointer _tmp27_;
				MusicMedia* _tmp28_;
#line 160 "../src/PlaybackManager.vala"
				_tmp24_ = self->priv->_current_shuffled;
#line 160 "../src/PlaybackManager.vala"
				_tmp25_ = music_playback_manager_get_current_index (self);
#line 160 "../src/PlaybackManager.vala"
				_tmp26_ = _tmp25_;
#line 160 "../src/PlaybackManager.vala"
				_tmp27_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp24_, (gpointer) ((gintptr) _tmp26_));
#line 160 "../src/PlaybackManager.vala"
				_tmp28_ = (MusicMedia*) _tmp27_;
#line 160 "../src/PlaybackManager.vala"
				music_playback_manager_set_current_media (self, _tmp28_);
#line 160 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp28_);
#line 559 "PlaybackManager.c"
			}
		}
#line 164 "../src/PlaybackManager.vala"
		if (current_media_changed) {
#line 564 "PlaybackManager.c"
			MusicMedia* _tmp30_;
#line 164 "../src/PlaybackManager.vala"
			_tmp30_ = self->priv->_current_media;
#line 164 "../src/PlaybackManager.vala"
			_tmp29_ = _tmp30_ != NULL;
#line 570 "PlaybackManager.c"
		} else {
#line 164 "../src/PlaybackManager.vala"
			_tmp29_ = FALSE;
#line 574 "PlaybackManager.c"
		}
#line 164 "../src/PlaybackManager.vala"
		if (_tmp29_) {
#line 578 "PlaybackManager.c"
			MusicMedia* _tmp31_;
#line 165 "../src/PlaybackManager.vala"
			_tmp31_ = self->priv->_current_media;
#line 165 "../src/PlaybackManager.vala"
			music_playback_manager_play_media (self, _tmp31_);
#line 584 "PlaybackManager.c"
		}
	} else {
#line 169 "../src/PlaybackManager.vala"
		music_playback_manager_set_current_media (self, NULL);
#line 170 "../src/PlaybackManager.vala"
		music_playback_manager_stop_playback (self);
#line 591 "PlaybackManager.c"
	}
#line 173 "../src/PlaybackManager.vala"
	_tmp32_ = self->priv->_current;
#line 173 "../src/PlaybackManager.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp32_);
#line 597 "PlaybackManager.c"
	{
		GeeArrayList* _q_list = NULL;
		MusicStaticPlaylist* _tmp33_;
		GeeArrayList* _tmp34_;
		GeeArrayList* _tmp35_;
		gint _q_size = 0;
		GeeArrayList* _tmp36_;
		gint _tmp37_;
		gint _tmp38_;
		gint _q_index = 0;
#line 174 "../src/PlaybackManager.vala"
		_tmp33_ = self->queue_playlist;
#line 174 "../src/PlaybackManager.vala"
		_tmp34_ = music_playlist_get_medias ((MusicPlaylist*) _tmp33_);
#line 174 "../src/PlaybackManager.vala"
		_tmp35_ = _tmp34_;
#line 174 "../src/PlaybackManager.vala"
		_q_list = _tmp35_;
#line 174 "../src/PlaybackManager.vala"
		_tmp36_ = _q_list;
#line 174 "../src/PlaybackManager.vala"
		_tmp37_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp36_);
#line 174 "../src/PlaybackManager.vala"
		_tmp38_ = _tmp37_;
#line 174 "../src/PlaybackManager.vala"
		_q_size = _tmp38_;
#line 174 "../src/PlaybackManager.vala"
		_q_index = -1;
#line 174 "../src/PlaybackManager.vala"
		while (TRUE) {
#line 628 "PlaybackManager.c"
			gint _tmp39_;
			gint _tmp40_;
			MusicMedia* q = NULL;
			GeeArrayList* _tmp41_;
			gpointer _tmp42_;
			MusicMedia* _tmp43_;
			const gchar* _tmp44_;
			const gchar* _tmp45_;
			MusicMedia* _tmp46_;
#line 174 "../src/PlaybackManager.vala"
			_q_index = _q_index + 1;
#line 174 "../src/PlaybackManager.vala"
			_tmp39_ = _q_index;
#line 174 "../src/PlaybackManager.vala"
			_tmp40_ = _q_size;
#line 174 "../src/PlaybackManager.vala"
			if (!(_tmp39_ < _tmp40_)) {
#line 174 "../src/PlaybackManager.vala"
				break;
#line 648 "PlaybackManager.c"
			}
#line 174 "../src/PlaybackManager.vala"
			_tmp41_ = _q_list;
#line 174 "../src/PlaybackManager.vala"
			_tmp42_ = gee_abstract_list_get ((GeeAbstractList*) _tmp41_, _q_index);
#line 174 "../src/PlaybackManager.vala"
			q = (MusicMedia*) _tmp42_;
#line 175 "../src/PlaybackManager.vala"
			_tmp43_ = q;
#line 175 "../src/PlaybackManager.vala"
			_tmp44_ = music_media_get_title (_tmp43_);
#line 175 "../src/PlaybackManager.vala"
			_tmp45_ = _tmp44_;
#line 175 "../src/PlaybackManager.vala"
			g_debug ("PlaybackManager.vala:175: REQUEUED: %s", _tmp45_);
#line 176 "../src/PlaybackManager.vala"
			_tmp46_ = q;
#line 176 "../src/PlaybackManager.vala"
			music_playback_manager_add_to_current (self, _tmp46_);
#line 174 "../src/PlaybackManager.vala"
			_g_object_unref0 (q);
#line 670 "PlaybackManager.c"
		}
	}
#line 179 "../src/PlaybackManager.vala"
	music_playback_manager_reshuffle (self);
#line 675 "PlaybackManager.c"
}

void
music_playback_manager_clear_queue (MusicPlaybackManager* self)
{
	MusicStaticPlaylist* _tmp0_;
	GeeHashMap* _tmp1_;
#line 182 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/PlaybackManager.vala"
	_tmp0_ = self->queue_playlist;
#line 183 "../src/PlaybackManager.vala"
	music_playlist_clear ((MusicPlaylist*) _tmp0_);
#line 184 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current;
#line 184 "../src/PlaybackManager.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp1_);
#line 185 "../src/PlaybackManager.vala"
	music_playback_manager_set_current_index (self, 0);
#line 187 "../src/PlaybackManager.vala"
	music_playback_manager_reshuffle (self);
#line 697 "PlaybackManager.c"
}

MusicMedia*
music_playback_manager_media_from_current_index (MusicPlaybackManager* self,
                                                 gint index_in_current)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	MusicMedia* result;
#line 190 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 191 "../src/PlaybackManager.vala"
	_tmp0_ = music_app_get_settings ();
#line 191 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 191 "../src/PlaybackManager.vala"
	if (g_settings_get_enum (_tmp1_, "shuffle-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_OFF)) {
#line 715 "PlaybackManager.c"
		GeeHashMap* _tmp2_;
		gpointer _tmp3_;
#line 192 "../src/PlaybackManager.vala"
		_tmp2_ = self->priv->_current;
#line 192 "../src/PlaybackManager.vala"
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) index_in_current));
#line 192 "../src/PlaybackManager.vala"
		result = (MusicMedia*) _tmp3_;
#line 192 "../src/PlaybackManager.vala"
		return result;
#line 726 "PlaybackManager.c"
	} else {
		GeeHashMap* _tmp4_;
		gpointer _tmp5_;
#line 194 "../src/PlaybackManager.vala"
		_tmp4_ = self->priv->_current_shuffled;
#line 194 "../src/PlaybackManager.vala"
		_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, (gpointer) ((gintptr) index_in_current));
#line 194 "../src/PlaybackManager.vala"
		result = (MusicMedia*) _tmp5_;
#line 194 "../src/PlaybackManager.vala"
		return result;
#line 738 "PlaybackManager.c"
	}
}

GeeCollection*
music_playback_manager_get_current_media_list (MusicPlaybackManager* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GeeCollection* result;
#line 198 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 199 "../src/PlaybackManager.vala"
	_tmp0_ = music_app_get_settings ();
#line 199 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 199 "../src/PlaybackManager.vala"
	if (g_settings_get_enum (_tmp1_, "shuffle-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_OFF)) {
#line 756 "PlaybackManager.c"
		GeeHashMap* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
#line 200 "../src/PlaybackManager.vala"
		_tmp2_ = self->priv->_current_shuffled;
#line 200 "../src/PlaybackManager.vala"
		_tmp3_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp2_);
#line 200 "../src/PlaybackManager.vala"
		_tmp4_ = _tmp3_;
#line 200 "../src/PlaybackManager.vala"
		result = _tmp4_;
#line 200 "../src/PlaybackManager.vala"
		return result;
#line 770 "PlaybackManager.c"
	} else {
		GeeHashMap* _tmp5_;
		GeeCollection* _tmp6_;
		GeeCollection* _tmp7_;
#line 202 "../src/PlaybackManager.vala"
		_tmp5_ = self->priv->_current;
#line 202 "../src/PlaybackManager.vala"
		_tmp6_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp5_);
#line 202 "../src/PlaybackManager.vala"
		_tmp7_ = _tmp6_;
#line 202 "../src/PlaybackManager.vala"
		result = _tmp7_;
#line 202 "../src/PlaybackManager.vala"
		return result;
#line 785 "PlaybackManager.c"
	}
}

static void
music_playback_manager_add_to_current (MusicPlaybackManager* self,
                                       MusicMedia* m)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 206 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/PlaybackManager.vala"
	g_return_if_fail (m != NULL);
#line 207 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current;
#line 207 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current;
#line 207 "../src/PlaybackManager.vala"
	_tmp2_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp1_);
#line 207 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 207 "../src/PlaybackManager.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) _tmp3_), m);
#line 811 "PlaybackManager.c"
}

void
music_playback_manager_set_repeat_mode (MusicPlaybackManager* self,
                                        MusicPlaybackManagerRepeatMode mode)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 210 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 211 "../src/PlaybackManager.vala"
	_tmp0_ = music_app_get_settings ();
#line 211 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 211 "../src/PlaybackManager.vala"
	if (g_settings_get_enum (_tmp1_, "repeat-mode") != ((gint) mode)) {
#line 828 "PlaybackManager.c"
		GSettings* _tmp2_;
		GSettings* _tmp3_;
#line 212 "../src/PlaybackManager.vala"
		_tmp2_ = music_app_get_settings ();
#line 212 "../src/PlaybackManager.vala"
		_tmp3_ = _tmp2_;
#line 212 "../src/PlaybackManager.vala"
		g_settings_set_enum (_tmp3_, "repeat-mode", (gint) mode);
#line 837 "PlaybackManager.c"
	}
}

void
music_playback_manager_set_shuffle_mode (MusicPlaybackManager* self,
                                         MusicPlaybackManagerShuffleMode mode)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 216 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 217 "../src/PlaybackManager.vala"
	_tmp0_ = music_app_get_settings ();
#line 217 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 217 "../src/PlaybackManager.vala"
	if (g_settings_get_enum (_tmp1_, "shuffle-mode") != ((gint) mode)) {
#line 855 "PlaybackManager.c"
		GSettings* _tmp2_;
		GSettings* _tmp3_;
#line 218 "../src/PlaybackManager.vala"
		_tmp2_ = music_app_get_settings ();
#line 218 "../src/PlaybackManager.vala"
		_tmp3_ = _tmp2_;
#line 218 "../src/PlaybackManager.vala"
		g_settings_set_enum (_tmp3_, "shuffle-mode", (gint) mode);
#line 219 "../src/PlaybackManager.vala"
		music_playback_manager_reshuffle (self);
#line 866 "PlaybackManager.c"
	}
}

/**
    * Regenerate the shuffled queue if needed
    */
static void
music_playback_manager_reshuffle (MusicPlaybackManager* self)
{
	GeeHashMap* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
#line 226 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 227 "../src/PlaybackManager.vala"
	g_debug ("PlaybackManager.vala:227: Reshuffling");
#line 228 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_shuffled;
#line 228 "../src/PlaybackManager.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 229 "../src/PlaybackManager.vala"
	self->priv->_current_shuffled_index = 0;
#line 231 "../src/PlaybackManager.vala"
	_tmp1_ = music_app_get_settings ();
#line 231 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 231 "../src/PlaybackManager.vala"
	if (g_settings_get_enum (_tmp2_, "shuffle-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_OFF)) {
#line 895 "PlaybackManager.c"
		MusicMedia* _tmp3_;
#line 232 "../src/PlaybackManager.vala"
		_tmp3_ = self->priv->_current_media;
#line 232 "../src/PlaybackManager.vala"
		if (_tmp3_ != NULL) {
#line 901 "PlaybackManager.c"
			{
				gint i = 0;
#line 234 "../src/PlaybackManager.vala"
				i = 0;
#line 906 "PlaybackManager.c"
				{
					gboolean _tmp4_ = FALSE;
#line 234 "../src/PlaybackManager.vala"
					_tmp4_ = TRUE;
#line 234 "../src/PlaybackManager.vala"
					while (TRUE) {
#line 913 "PlaybackManager.c"
						GeeHashMap* _tmp6_;
						gint _tmp7_;
						gint _tmp8_;
						GeeHashMap* _tmp9_;
						gpointer _tmp10_;
						MusicMedia* _tmp11_;
						MusicMedia* _tmp12_;
						gboolean _tmp13_;
#line 234 "../src/PlaybackManager.vala"
						if (!_tmp4_) {
#line 924 "PlaybackManager.c"
							gint _tmp5_;
#line 234 "../src/PlaybackManager.vala"
							i = i + 1;
#line 234 "../src/PlaybackManager.vala"
							_tmp5_ = i;
#line 930 "PlaybackManager.c"
						}
#line 234 "../src/PlaybackManager.vala"
						_tmp4_ = FALSE;
#line 234 "../src/PlaybackManager.vala"
						_tmp6_ = self->priv->_current;
#line 234 "../src/PlaybackManager.vala"
						_tmp7_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp6_);
#line 234 "../src/PlaybackManager.vala"
						_tmp8_ = _tmp7_;
#line 234 "../src/PlaybackManager.vala"
						if (!(i < _tmp8_)) {
#line 234 "../src/PlaybackManager.vala"
							break;
#line 944 "PlaybackManager.c"
						}
#line 235 "../src/PlaybackManager.vala"
						_tmp9_ = self->priv->_current;
#line 235 "../src/PlaybackManager.vala"
						_tmp10_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp9_, (gpointer) ((gintptr) i));
#line 235 "../src/PlaybackManager.vala"
						_tmp11_ = (MusicMedia*) _tmp10_;
#line 235 "../src/PlaybackManager.vala"
						_tmp12_ = self->priv->_current_media;
#line 235 "../src/PlaybackManager.vala"
						_tmp13_ = _tmp11_ == _tmp12_;
#line 235 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp11_);
#line 235 "../src/PlaybackManager.vala"
						if (_tmp13_) {
#line 236 "../src/PlaybackManager.vala"
							self->priv->_current_index = i;
#line 237 "../src/PlaybackManager.vala"
							return;
#line 964 "PlaybackManager.c"
						}
					}
				}
			}
		} else {
#line 241 "../src/PlaybackManager.vala"
			self->priv->_current_index = 0;
#line 972 "PlaybackManager.c"
		}
	} else {
		GSettings* _tmp14_;
		GSettings* _tmp15_;
#line 243 "../src/PlaybackManager.vala"
		_tmp14_ = music_app_get_settings ();
#line 243 "../src/PlaybackManager.vala"
		_tmp15_ = _tmp14_;
#line 243 "../src/PlaybackManager.vala"
		if (g_settings_get_enum (_tmp15_, "shuffle-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_ALL)) {
#line 983 "PlaybackManager.c"
			GeeLinkedList* temp = NULL;
			GeeLinkedList* _tmp16_;
			gboolean current_media_found = FALSE;
			gboolean _tmp30_ = FALSE;
			MusicMedia* _tmp31_;
#line 245 "../src/PlaybackManager.vala"
			_tmp16_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 245 "../src/PlaybackManager.vala"
			temp = _tmp16_;
#line 246 "../src/PlaybackManager.vala"
			current_media_found = FALSE;
#line 995 "PlaybackManager.c"
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp17_;
				GeeCollection* _tmp18_;
				GeeCollection* _tmp19_;
				GeeCollection* _tmp20_;
				GeeIterator* _tmp21_;
				GeeIterator* _tmp22_;
#line 247 "../src/PlaybackManager.vala"
				_tmp17_ = self->priv->_current;
#line 247 "../src/PlaybackManager.vala"
				_tmp18_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp17_);
#line 247 "../src/PlaybackManager.vala"
				_tmp19_ = _tmp18_;
#line 247 "../src/PlaybackManager.vala"
				_tmp20_ = _tmp19_;
#line 247 "../src/PlaybackManager.vala"
				_tmp21_ = gee_iterable_iterator ((GeeIterable*) _tmp20_);
#line 247 "../src/PlaybackManager.vala"
				_tmp22_ = _tmp21_;
#line 247 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp20_);
#line 247 "../src/PlaybackManager.vala"
				_m_it = _tmp22_;
#line 247 "../src/PlaybackManager.vala"
				while (TRUE) {
#line 1022 "PlaybackManager.c"
					GeeIterator* _tmp23_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp24_;
					gpointer _tmp25_;
					MusicMedia* _tmp26_;
					MusicMedia* _tmp27_;
#line 247 "../src/PlaybackManager.vala"
					_tmp23_ = _m_it;
#line 247 "../src/PlaybackManager.vala"
					if (!gee_iterator_next (_tmp23_)) {
#line 247 "../src/PlaybackManager.vala"
						break;
#line 1035 "PlaybackManager.c"
					}
#line 247 "../src/PlaybackManager.vala"
					_tmp24_ = _m_it;
#line 247 "../src/PlaybackManager.vala"
					_tmp25_ = gee_iterator_get (_tmp24_);
#line 247 "../src/PlaybackManager.vala"
					m = (MusicMedia*) _tmp25_;
#line 248 "../src/PlaybackManager.vala"
					_tmp26_ = self->priv->_current_media;
#line 248 "../src/PlaybackManager.vala"
					_tmp27_ = m;
#line 248 "../src/PlaybackManager.vala"
					if (_tmp26_ != _tmp27_) {
#line 1049 "PlaybackManager.c"
						GeeLinkedList* _tmp28_;
						MusicMedia* _tmp29_;
#line 249 "../src/PlaybackManager.vala"
						_tmp28_ = temp;
#line 249 "../src/PlaybackManager.vala"
						_tmp29_ = m;
#line 249 "../src/PlaybackManager.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp29_);
#line 1058 "PlaybackManager.c"
					} else {
#line 251 "../src/PlaybackManager.vala"
						current_media_found = TRUE;
#line 1062 "PlaybackManager.c"
					}
#line 247 "../src/PlaybackManager.vala"
					_g_object_unref0 (m);
#line 1066 "PlaybackManager.c"
				}
#line 247 "../src/PlaybackManager.vala"
				_g_object_unref0 (_m_it);
#line 1070 "PlaybackManager.c"
			}
#line 260 "../src/PlaybackManager.vala"
			_tmp31_ = self->priv->_current_media;
#line 260 "../src/PlaybackManager.vala"
			if (_tmp31_ != NULL) {
#line 260 "../src/PlaybackManager.vala"
				_tmp30_ = current_media_found;
#line 1078 "PlaybackManager.c"
			} else {
#line 260 "../src/PlaybackManager.vala"
				_tmp30_ = FALSE;
#line 1082 "PlaybackManager.c"
			}
#line 260 "../src/PlaybackManager.vala"
			if (_tmp30_) {
#line 1086 "PlaybackManager.c"
				GeeHashMap* _tmp32_;
				MusicMedia* _tmp33_;
#line 261 "../src/PlaybackManager.vala"
				_tmp32_ = self->priv->_current_shuffled;
#line 261 "../src/PlaybackManager.vala"
				_tmp33_ = self->priv->_current_media;
#line 261 "../src/PlaybackManager.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp32_, (gpointer) ((gintptr) 0), _tmp33_);
#line 1095 "PlaybackManager.c"
			} else {
				gboolean _tmp34_ = FALSE;
				MusicMedia* _tmp35_;
#line 262 "../src/PlaybackManager.vala"
				_tmp35_ = self->priv->_current_media;
#line 262 "../src/PlaybackManager.vala"
				if (_tmp35_ != NULL) {
#line 1103 "PlaybackManager.c"
					GeeHashMap* _tmp36_;
					gint _tmp37_;
					gint _tmp38_;
#line 262 "../src/PlaybackManager.vala"
					_tmp36_ = self->priv->_current;
#line 262 "../src/PlaybackManager.vala"
					_tmp37_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp36_);
#line 262 "../src/PlaybackManager.vala"
					_tmp38_ = _tmp37_;
#line 262 "../src/PlaybackManager.vala"
					_tmp34_ = _tmp38_ != 0;
#line 1115 "PlaybackManager.c"
				} else {
#line 262 "../src/PlaybackManager.vala"
					_tmp34_ = FALSE;
#line 1119 "PlaybackManager.c"
				}
#line 262 "../src/PlaybackManager.vala"
				if (_tmp34_) {
#line 1123 "PlaybackManager.c"
					GeeHashMap* _tmp39_;
					GeeHashMap* _tmp40_;
					gpointer _tmp41_;
					MusicMedia* _tmp42_;
#line 265 "../src/PlaybackManager.vala"
					_tmp39_ = self->priv->_current_shuffled;
#line 265 "../src/PlaybackManager.vala"
					_tmp40_ = self->priv->_current;
#line 265 "../src/PlaybackManager.vala"
					_tmp41_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp40_, (gpointer) ((gintptr) 0));
#line 265 "../src/PlaybackManager.vala"
					_tmp42_ = (MusicMedia*) _tmp41_;
#line 265 "../src/PlaybackManager.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp39_, (gpointer) ((gintptr) 0), _tmp42_);
#line 265 "../src/PlaybackManager.vala"
					_g_object_unref0 (_tmp42_);
#line 1140 "PlaybackManager.c"
				}
			}
			{
				gint _tmp43_ = 0;
				MusicMedia* _tmp44_;
				gint i = 0;
#line 268 "../src/PlaybackManager.vala"
				_tmp44_ = self->priv->_current_media;
#line 268 "../src/PlaybackManager.vala"
				if (_tmp44_ == NULL) {
#line 268 "../src/PlaybackManager.vala"
					_tmp43_ = 0;
#line 1153 "PlaybackManager.c"
				} else {
#line 268 "../src/PlaybackManager.vala"
					_tmp43_ = 1;
#line 1157 "PlaybackManager.c"
				}
#line 268 "../src/PlaybackManager.vala"
				i = _tmp43_;
#line 1161 "PlaybackManager.c"
				{
					gboolean _tmp45_ = FALSE;
#line 268 "../src/PlaybackManager.vala"
					_tmp45_ = TRUE;
#line 268 "../src/PlaybackManager.vala"
					while (TRUE) {
#line 1168 "PlaybackManager.c"
						GeeHashMap* _tmp47_;
						gint _tmp48_;
						gint _tmp49_;
						gint n_media = 0;
						GeeLinkedList* _tmp50_;
						gint _tmp51_;
						gint _tmp52_;
						gint random = 0;
						GeeHashMap* _tmp53_;
						GeeLinkedList* _tmp54_;
						gpointer _tmp55_;
						MusicMedia* _tmp56_;
						GeeLinkedList* _tmp57_;
						GeeLinkedList* _tmp58_;
						gpointer _tmp59_;
						MusicMedia* _tmp60_;
#line 268 "../src/PlaybackManager.vala"
						if (!_tmp45_) {
#line 1187 "PlaybackManager.c"
							gint _tmp46_;
#line 268 "../src/PlaybackManager.vala"
							_tmp46_ = i;
#line 268 "../src/PlaybackManager.vala"
							i = _tmp46_ + 1;
#line 1193 "PlaybackManager.c"
						}
#line 268 "../src/PlaybackManager.vala"
						_tmp45_ = FALSE;
#line 268 "../src/PlaybackManager.vala"
						_tmp47_ = self->priv->_current;
#line 268 "../src/PlaybackManager.vala"
						_tmp48_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp47_);
#line 268 "../src/PlaybackManager.vala"
						_tmp49_ = _tmp48_;
#line 268 "../src/PlaybackManager.vala"
						if (!(i < _tmp49_)) {
#line 268 "../src/PlaybackManager.vala"
							break;
#line 1207 "PlaybackManager.c"
						}
#line 269 "../src/PlaybackManager.vala"
						_tmp50_ = temp;
#line 269 "../src/PlaybackManager.vala"
						_tmp51_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp50_);
#line 269 "../src/PlaybackManager.vala"
						_tmp52_ = _tmp51_;
#line 269 "../src/PlaybackManager.vala"
						n_media = _tmp52_;
#line 270 "../src/PlaybackManager.vala"
						if (n_media == 0) {
#line 271 "../src/PlaybackManager.vala"
							break;
#line 1221 "PlaybackManager.c"
						}
#line 274 "../src/PlaybackManager.vala"
						random = (gint) g_random_int_range ((gint32) 0, (gint32) n_media);
#line 276 "../src/PlaybackManager.vala"
						_tmp53_ = self->priv->_current_shuffled;
#line 276 "../src/PlaybackManager.vala"
						_tmp54_ = temp;
#line 276 "../src/PlaybackManager.vala"
						_tmp55_ = gee_abstract_list_get ((GeeAbstractList*) _tmp54_, random);
#line 276 "../src/PlaybackManager.vala"
						_tmp56_ = (MusicMedia*) _tmp55_;
#line 276 "../src/PlaybackManager.vala"
						gee_abstract_map_set ((GeeAbstractMap*) _tmp53_, (gpointer) ((gintptr) i), _tmp56_);
#line 276 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp56_);
#line 277 "../src/PlaybackManager.vala"
						_tmp57_ = temp;
#line 277 "../src/PlaybackManager.vala"
						_tmp58_ = temp;
#line 277 "../src/PlaybackManager.vala"
						_tmp59_ = gee_abstract_list_get ((GeeAbstractList*) _tmp58_, random);
#line 277 "../src/PlaybackManager.vala"
						_tmp60_ = (MusicMedia*) _tmp59_;
#line 277 "../src/PlaybackManager.vala"
						gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp57_, _tmp60_);
#line 277 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp60_);
#line 1249 "PlaybackManager.c"
					}
				}
			}
#line 243 "../src/PlaybackManager.vala"
			_g_object_unref0 (temp);
#line 1255 "PlaybackManager.c"
		}
	}
}

MusicMedia*
music_playback_manager_get_next (MusicPlaybackManager* self,
                                 gboolean play)
{
	MusicMedia* rv = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	MusicStaticPlaylist* _tmp152_;
	GeeArrayList* _tmp153_;
	GeeArrayList* _tmp154_;
	MusicMedia* _tmp155_;
	MusicMedia* result;
#line 282 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 283 "../src/PlaybackManager.vala"
	rv = NULL;
#line 285 "../src/PlaybackManager.vala"
	_tmp0_ = music_app_get_settings ();
#line 285 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 285 "../src/PlaybackManager.vala"
	if (g_settings_get_enum (_tmp1_, "shuffle-mode") != ((gint) MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_OFF)) {
#line 1282 "PlaybackManager.c"
		GeeHashMap* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		GeeHashMap* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		MusicMedia* _tmp15_;
#line 286 "../src/PlaybackManager.vala"
		_tmp2_ = self->priv->_current_shuffled;
#line 286 "../src/PlaybackManager.vala"
		_tmp3_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp2_);
#line 286 "../src/PlaybackManager.vala"
		_tmp4_ = _tmp3_;
#line 286 "../src/PlaybackManager.vala"
		g_debug ("PlaybackManager.vala:286: Shuffled size: %d", _tmp4_);
#line 287 "../src/PlaybackManager.vala"
		_tmp5_ = self->priv->_current_shuffled;
#line 287 "../src/PlaybackManager.vala"
		_tmp6_ = gee_map_get_is_empty ((GeeMap*) _tmp5_);
#line 287 "../src/PlaybackManager.vala"
		_tmp7_ = _tmp6_;
#line 287 "../src/PlaybackManager.vala"
		if (_tmp7_) {
#line 1306 "PlaybackManager.c"
			GeeHashMap* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 288 "../src/PlaybackManager.vala"
			_tmp8_ = self->priv->_current;
#line 288 "../src/PlaybackManager.vala"
			_tmp9_ = gee_map_get_is_empty ((GeeMap*) _tmp8_);
#line 288 "../src/PlaybackManager.vala"
			_tmp10_ = _tmp9_;
#line 288 "../src/PlaybackManager.vala"
			if (_tmp10_) {
#line 1318 "PlaybackManager.c"
				MusicLibrary* _tmp11_;
				MusicLibrary* _tmp12_;
				GeeCollection* _tmp13_;
				GeeCollection* _tmp14_;
#line 289 "../src/PlaybackManager.vala"
				_tmp11_ = music_playback_manager_get_library (self);
#line 289 "../src/PlaybackManager.vala"
				_tmp12_ = _tmp11_;
#line 289 "../src/PlaybackManager.vala"
				_tmp13_ = music_library_get_medias (_tmp12_);
#line 289 "../src/PlaybackManager.vala"
				_tmp14_ = _tmp13_;
#line 289 "../src/PlaybackManager.vala"
				music_playback_manager_queue_media (self, _tmp14_);
#line 289 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp14_);
#line 1335 "PlaybackManager.c"
			}
#line 292 "../src/PlaybackManager.vala"
			music_playback_manager_reshuffle (self);
#line 1339 "PlaybackManager.c"
		}
#line 295 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = FALSE;
#line 297 "../src/PlaybackManager.vala"
		_tmp15_ = self->priv->_current_media;
#line 297 "../src/PlaybackManager.vala"
		if (_tmp15_ == NULL) {
#line 1347 "PlaybackManager.c"
			GeeHashMap* _tmp16_;
			gpointer _tmp17_;
#line 298 "../src/PlaybackManager.vala"
			self->priv->_current_shuffled_index = 0;
#line 299 "../src/PlaybackManager.vala"
			_tmp16_ = self->priv->_current_shuffled;
#line 299 "../src/PlaybackManager.vala"
			_tmp17_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp16_, (gpointer) ((gintptr) 0));
#line 299 "../src/PlaybackManager.vala"
			_g_object_unref0 (rv);
#line 299 "../src/PlaybackManager.vala"
			rv = (MusicMedia*) _tmp17_;
#line 1360 "PlaybackManager.c"
		} else {
			GSettings* _tmp18_;
			GSettings* _tmp19_;
#line 300 "../src/PlaybackManager.vala"
			_tmp18_ = music_app_get_settings ();
#line 300 "../src/PlaybackManager.vala"
			_tmp19_ = _tmp18_;
#line 300 "../src/PlaybackManager.vala"
			if (g_settings_get_enum (_tmp19_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_MEDIA)) {
#line 1370 "PlaybackManager.c"
				GeeHashMap* _tmp20_;
				gpointer _tmp21_;
#line 301 "../src/PlaybackManager.vala"
				_tmp20_ = self->priv->_current_shuffled;
#line 301 "../src/PlaybackManager.vala"
				_tmp21_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp20_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 301 "../src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 301 "../src/PlaybackManager.vala"
				rv = (MusicMedia*) _tmp21_;
#line 1381 "PlaybackManager.c"
			} else {
				GeeHashMap* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
#line 302 "../src/PlaybackManager.vala"
				_tmp22_ = self->priv->_current_shuffled;
#line 302 "../src/PlaybackManager.vala"
				_tmp23_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp22_);
#line 302 "../src/PlaybackManager.vala"
				_tmp24_ = _tmp23_;
#line 302 "../src/PlaybackManager.vala"
				if (self->priv->_current_shuffled_index == (_tmp24_ - 1)) {
#line 1394 "PlaybackManager.c"
					GSettings* _tmp25_;
					GSettings* _tmp26_;
					GeeHashMap* _tmp27_;
					gpointer _tmp28_;
#line 303 "../src/PlaybackManager.vala"
					_tmp25_ = music_app_get_settings ();
#line 303 "../src/PlaybackManager.vala"
					_tmp26_ = _tmp25_;
#line 303 "../src/PlaybackManager.vala"
					if (g_settings_get_enum (_tmp26_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALL)) {
#line 304 "../src/PlaybackManager.vala"
						self->priv->_current_shuffled_index = 0;
#line 1407 "PlaybackManager.c"
					} else {
#line 307 "../src/PlaybackManager.vala"
						if (play) {
#line 308 "../src/PlaybackManager.vala"
							music_playback_manager_stop_playback (self);
#line 1413 "PlaybackManager.c"
						}
#line 311 "../src/PlaybackManager.vala"
						result = NULL;
#line 311 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 311 "../src/PlaybackManager.vala"
						return result;
#line 1421 "PlaybackManager.c"
					}
#line 314 "../src/PlaybackManager.vala"
					_tmp27_ = self->priv->_current_shuffled;
#line 314 "../src/PlaybackManager.vala"
					_tmp28_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp27_, (gpointer) ((gintptr) 0));
#line 314 "../src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 314 "../src/PlaybackManager.vala"
					rv = (MusicMedia*) _tmp28_;
#line 1431 "PlaybackManager.c"
				} else {
					gboolean _tmp29_ = FALSE;
#line 315 "../src/PlaybackManager.vala"
					if (self->priv->_current_shuffled_index >= 0) {
#line 1436 "PlaybackManager.c"
						GeeHashMap* _tmp30_;
						gint _tmp31_;
						gint _tmp32_;
#line 315 "../src/PlaybackManager.vala"
						_tmp30_ = self->priv->_current_shuffled;
#line 315 "../src/PlaybackManager.vala"
						_tmp31_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp30_);
#line 315 "../src/PlaybackManager.vala"
						_tmp32_ = _tmp31_;
#line 315 "../src/PlaybackManager.vala"
						_tmp29_ = self->priv->_current_shuffled_index < (_tmp32_ - 1);
#line 1448 "PlaybackManager.c"
					} else {
#line 315 "../src/PlaybackManager.vala"
						_tmp29_ = FALSE;
#line 1452 "PlaybackManager.c"
					}
#line 315 "../src/PlaybackManager.vala"
					if (_tmp29_) {
#line 1456 "PlaybackManager.c"
						MusicMedia* next_current = NULL;
						GeeHashMap* _tmp33_;
						gpointer _tmp34_;
						MusicMedia* now_current = NULL;
						GeeHashMap* _tmp35_;
						gpointer _tmp36_;
						gboolean _tmp37_ = FALSE;
						GSettings* _tmp38_;
						GSettings* _tmp39_;
						GeeHashMap* _tmp76_;
						gpointer _tmp77_;
#line 317 "../src/PlaybackManager.vala"
						_tmp33_ = self->priv->_current_shuffled;
#line 317 "../src/PlaybackManager.vala"
						_tmp34_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp33_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index + 1)));
#line 317 "../src/PlaybackManager.vala"
						next_current = (MusicMedia*) _tmp34_;
#line 318 "../src/PlaybackManager.vala"
						_tmp35_ = self->priv->_current_shuffled;
#line 318 "../src/PlaybackManager.vala"
						_tmp36_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp35_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 318 "../src/PlaybackManager.vala"
						now_current = (MusicMedia*) _tmp36_;
#line 320 "../src/PlaybackManager.vala"
						_tmp38_ = music_app_get_settings ();
#line 320 "../src/PlaybackManager.vala"
						_tmp39_ = _tmp38_;
#line 320 "../src/PlaybackManager.vala"
						if (g_settings_get_enum (_tmp39_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ARTIST)) {
#line 1486 "PlaybackManager.c"
							MusicMedia* _tmp40_;
							const gchar* _tmp41_;
							const gchar* _tmp42_;
							MusicMedia* _tmp43_;
							const gchar* _tmp44_;
							const gchar* _tmp45_;
#line 320 "../src/PlaybackManager.vala"
							_tmp40_ = next_current;
#line 320 "../src/PlaybackManager.vala"
							_tmp41_ = music_media_get_artist (_tmp40_);
#line 320 "../src/PlaybackManager.vala"
							_tmp42_ = _tmp41_;
#line 320 "../src/PlaybackManager.vala"
							_tmp43_ = now_current;
#line 320 "../src/PlaybackManager.vala"
							_tmp44_ = music_media_get_artist (_tmp43_);
#line 320 "../src/PlaybackManager.vala"
							_tmp45_ = _tmp44_;
#line 320 "../src/PlaybackManager.vala"
							_tmp37_ = g_strcmp0 (_tmp42_, _tmp45_) != 0;
#line 1507 "PlaybackManager.c"
						} else {
#line 320 "../src/PlaybackManager.vala"
							_tmp37_ = FALSE;
#line 1511 "PlaybackManager.c"
						}
#line 320 "../src/PlaybackManager.vala"
						if (_tmp37_) {
#line 321 "../src/PlaybackManager.vala"
							while (TRUE) {
#line 1517 "PlaybackManager.c"
								GeeHashMap* _tmp46_;
								gpointer _tmp47_;
								MusicMedia* _tmp48_;
								const gchar* _tmp49_;
								const gchar* _tmp50_;
								MusicMedia* _tmp51_;
								const gchar* _tmp52_;
								const gchar* _tmp53_;
								gboolean _tmp54_;
								gint _tmp55_;
#line 321 "../src/PlaybackManager.vala"
								_tmp46_ = self->priv->_current_shuffled;
#line 321 "../src/PlaybackManager.vala"
								_tmp47_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp46_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
#line 321 "../src/PlaybackManager.vala"
								_tmp48_ = (MusicMedia*) _tmp47_;
#line 321 "../src/PlaybackManager.vala"
								_tmp49_ = music_media_get_artist (_tmp48_);
#line 321 "../src/PlaybackManager.vala"
								_tmp50_ = _tmp49_;
#line 321 "../src/PlaybackManager.vala"
								_tmp51_ = self->priv->_current_media;
#line 321 "../src/PlaybackManager.vala"
								_tmp52_ = music_media_get_artist (_tmp51_);
#line 321 "../src/PlaybackManager.vala"
								_tmp53_ = _tmp52_;
#line 321 "../src/PlaybackManager.vala"
								_tmp54_ = !(g_strcmp0 (_tmp50_, _tmp53_) == 0);
#line 321 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp48_);
#line 321 "../src/PlaybackManager.vala"
								if (_tmp54_) {
#line 321 "../src/PlaybackManager.vala"
									break;
#line 1552 "PlaybackManager.c"
								}
#line 322 "../src/PlaybackManager.vala"
								_tmp55_ = self->priv->_current_shuffled_index;
#line 322 "../src/PlaybackManager.vala"
								self->priv->_current_shuffled_index = _tmp55_ - 1;
#line 1558 "PlaybackManager.c"
							}
						} else {
							gboolean _tmp56_ = FALSE;
							GSettings* _tmp57_;
							GSettings* _tmp58_;
#line 324 "../src/PlaybackManager.vala"
							_tmp57_ = music_app_get_settings ();
#line 324 "../src/PlaybackManager.vala"
							_tmp58_ = _tmp57_;
#line 324 "../src/PlaybackManager.vala"
							if (g_settings_get_enum (_tmp58_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALBUM)) {
#line 1570 "PlaybackManager.c"
								MusicMedia* _tmp59_;
								const gchar* _tmp60_;
								const gchar* _tmp61_;
								MusicMedia* _tmp62_;
								const gchar* _tmp63_;
								const gchar* _tmp64_;
#line 324 "../src/PlaybackManager.vala"
								_tmp59_ = next_current;
#line 324 "../src/PlaybackManager.vala"
								_tmp60_ = music_media_get_album (_tmp59_);
#line 324 "../src/PlaybackManager.vala"
								_tmp61_ = _tmp60_;
#line 324 "../src/PlaybackManager.vala"
								_tmp62_ = now_current;
#line 324 "../src/PlaybackManager.vala"
								_tmp63_ = music_media_get_album (_tmp62_);
#line 324 "../src/PlaybackManager.vala"
								_tmp64_ = _tmp63_;
#line 324 "../src/PlaybackManager.vala"
								_tmp56_ = g_strcmp0 (_tmp61_, _tmp64_) != 0;
#line 1591 "PlaybackManager.c"
							} else {
#line 324 "../src/PlaybackManager.vala"
								_tmp56_ = FALSE;
#line 1595 "PlaybackManager.c"
							}
#line 324 "../src/PlaybackManager.vala"
							if (_tmp56_) {
#line 325 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 1601 "PlaybackManager.c"
									GeeHashMap* _tmp65_;
									gpointer _tmp66_;
									MusicMedia* _tmp67_;
									const gchar* _tmp68_;
									const gchar* _tmp69_;
									MusicMedia* _tmp70_;
									const gchar* _tmp71_;
									const gchar* _tmp72_;
									gboolean _tmp73_;
									gint _tmp74_;
#line 325 "../src/PlaybackManager.vala"
									_tmp65_ = self->priv->_current_shuffled;
#line 325 "../src/PlaybackManager.vala"
									_tmp66_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp65_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
#line 325 "../src/PlaybackManager.vala"
									_tmp67_ = (MusicMedia*) _tmp66_;
#line 325 "../src/PlaybackManager.vala"
									_tmp68_ = music_media_get_album (_tmp67_);
#line 325 "../src/PlaybackManager.vala"
									_tmp69_ = _tmp68_;
#line 325 "../src/PlaybackManager.vala"
									_tmp70_ = self->priv->_current_media;
#line 325 "../src/PlaybackManager.vala"
									_tmp71_ = music_media_get_album (_tmp70_);
#line 325 "../src/PlaybackManager.vala"
									_tmp72_ = _tmp71_;
#line 325 "../src/PlaybackManager.vala"
									_tmp73_ = !(g_strcmp0 (_tmp69_, _tmp72_) == 0);
#line 325 "../src/PlaybackManager.vala"
									_g_object_unref0 (_tmp67_);
#line 325 "../src/PlaybackManager.vala"
									if (_tmp73_) {
#line 325 "../src/PlaybackManager.vala"
										break;
#line 1636 "PlaybackManager.c"
									}
#line 326 "../src/PlaybackManager.vala"
									_tmp74_ = self->priv->_current_shuffled_index;
#line 326 "../src/PlaybackManager.vala"
									self->priv->_current_shuffled_index = _tmp74_ - 1;
#line 1642 "PlaybackManager.c"
								}
							} else {
								gint _tmp75_;
#line 329 "../src/PlaybackManager.vala"
								_tmp75_ = self->priv->_current_shuffled_index;
#line 329 "../src/PlaybackManager.vala"
								self->priv->_current_shuffled_index = _tmp75_ + 1;
#line 1650 "PlaybackManager.c"
							}
						}
#line 332 "../src/PlaybackManager.vala"
						_tmp76_ = self->priv->_current_shuffled;
#line 332 "../src/PlaybackManager.vala"
						_tmp77_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp76_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 332 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 332 "../src/PlaybackManager.vala"
						rv = (MusicMedia*) _tmp77_;
#line 315 "../src/PlaybackManager.vala"
						_g_object_unref0 (now_current);
#line 315 "../src/PlaybackManager.vala"
						_g_object_unref0 (next_current);
#line 1665 "PlaybackManager.c"
					} else {
						GeeHashMap* _tmp78_;
						gpointer _tmp79_;
#line 334 "../src/PlaybackManager.vala"
						self->priv->_current_shuffled_index = 0;
#line 335 "../src/PlaybackManager.vala"
						music_playback_manager_set_shuffle_mode (self, MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_ALL);
#line 336 "../src/PlaybackManager.vala"
						_tmp78_ = self->priv->_current_shuffled;
#line 336 "../src/PlaybackManager.vala"
						_tmp79_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp78_, (gpointer) ((gintptr) 0));
#line 336 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 336 "../src/PlaybackManager.vala"
						rv = (MusicMedia*) _tmp79_;
#line 1681 "PlaybackManager.c"
					}
				}
			}
		}
	} else {
		GeeHashMap* _tmp80_;
		gboolean _tmp81_;
		gboolean _tmp82_;
		MusicMedia* _tmp87_;
#line 339 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = FALSE;
#line 341 "../src/PlaybackManager.vala"
		_tmp80_ = self->priv->_current;
#line 341 "../src/PlaybackManager.vala"
		_tmp81_ = gee_map_get_is_empty ((GeeMap*) _tmp80_);
#line 341 "../src/PlaybackManager.vala"
		_tmp82_ = _tmp81_;
#line 341 "../src/PlaybackManager.vala"
		if (_tmp82_) {
#line 1701 "PlaybackManager.c"
			MusicLibrary* _tmp83_;
			MusicLibrary* _tmp84_;
			GeeCollection* _tmp85_;
			GeeCollection* _tmp86_;
#line 342 "../src/PlaybackManager.vala"
			_tmp83_ = music_playback_manager_get_library (self);
#line 342 "../src/PlaybackManager.vala"
			_tmp84_ = _tmp83_;
#line 342 "../src/PlaybackManager.vala"
			_tmp85_ = music_library_get_medias (_tmp84_);
#line 342 "../src/PlaybackManager.vala"
			_tmp86_ = _tmp85_;
#line 342 "../src/PlaybackManager.vala"
			music_playback_manager_queue_media (self, _tmp86_);
#line 342 "../src/PlaybackManager.vala"
			_g_object_unref0 (_tmp86_);
#line 1718 "PlaybackManager.c"
		}
#line 345 "../src/PlaybackManager.vala"
		_tmp87_ = self->priv->_current_media;
#line 345 "../src/PlaybackManager.vala"
		if (_tmp87_ == NULL) {
#line 1724 "PlaybackManager.c"
			GeeHashMap* _tmp88_;
			gpointer _tmp89_;
#line 346 "../src/PlaybackManager.vala"
			self->priv->_current_index = 0;
#line 347 "../src/PlaybackManager.vala"
			_tmp88_ = self->priv->_current;
#line 347 "../src/PlaybackManager.vala"
			_tmp89_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp88_, (gpointer) ((gintptr) 0));
#line 347 "../src/PlaybackManager.vala"
			_g_object_unref0 (rv);
#line 347 "../src/PlaybackManager.vala"
			rv = (MusicMedia*) _tmp89_;
#line 1737 "PlaybackManager.c"
		} else {
			GSettings* _tmp90_;
			GSettings* _tmp91_;
#line 348 "../src/PlaybackManager.vala"
			_tmp90_ = music_app_get_settings ();
#line 348 "../src/PlaybackManager.vala"
			_tmp91_ = _tmp90_;
#line 348 "../src/PlaybackManager.vala"
			if (g_settings_get_enum (_tmp91_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_MEDIA)) {
#line 1747 "PlaybackManager.c"
				GeeHashMap* _tmp92_;
				gpointer _tmp93_;
#line 349 "../src/PlaybackManager.vala"
				_tmp92_ = self->priv->_current;
#line 349 "../src/PlaybackManager.vala"
				_tmp93_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp92_, (gpointer) ((gintptr) self->priv->_current_index));
#line 349 "../src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 349 "../src/PlaybackManager.vala"
				rv = (MusicMedia*) _tmp93_;
#line 1758 "PlaybackManager.c"
			} else {
				GeeHashMap* _tmp94_;
				gint _tmp95_;
				gint _tmp96_;
#line 350 "../src/PlaybackManager.vala"
				_tmp94_ = self->priv->_current;
#line 350 "../src/PlaybackManager.vala"
				_tmp95_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp94_);
#line 350 "../src/PlaybackManager.vala"
				_tmp96_ = _tmp95_;
#line 350 "../src/PlaybackManager.vala"
				if (self->priv->_current_index == (_tmp96_ - 1)) {
#line 1771 "PlaybackManager.c"
					GSettings* _tmp97_;
					GSettings* _tmp98_;
					GeeHashMap* _tmp99_;
					gpointer _tmp100_;
#line 351 "../src/PlaybackManager.vala"
					_tmp97_ = music_app_get_settings ();
#line 351 "../src/PlaybackManager.vala"
					_tmp98_ = _tmp97_;
#line 351 "../src/PlaybackManager.vala"
					if (g_settings_get_enum (_tmp98_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALL)) {
#line 352 "../src/PlaybackManager.vala"
						self->priv->_current_index = 0;
#line 1784 "PlaybackManager.c"
					} else {
#line 354 "../src/PlaybackManager.vala"
						if (play) {
#line 355 "../src/PlaybackManager.vala"
							music_playback_manager_stop_playback (self);
#line 1790 "PlaybackManager.c"
						}
#line 357 "../src/PlaybackManager.vala"
						result = NULL;
#line 357 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 357 "../src/PlaybackManager.vala"
						return result;
#line 1798 "PlaybackManager.c"
					}
#line 360 "../src/PlaybackManager.vala"
					_tmp99_ = self->priv->_current;
#line 360 "../src/PlaybackManager.vala"
					_tmp100_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp99_, (gpointer) ((gintptr) 0));
#line 360 "../src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 360 "../src/PlaybackManager.vala"
					rv = (MusicMedia*) _tmp100_;
#line 1808 "PlaybackManager.c"
				} else {
					gboolean _tmp101_ = FALSE;
#line 361 "../src/PlaybackManager.vala"
					if (self->priv->_current_index >= 0) {
#line 1813 "PlaybackManager.c"
						GeeHashMap* _tmp102_;
						gint _tmp103_;
						gint _tmp104_;
#line 361 "../src/PlaybackManager.vala"
						_tmp102_ = self->priv->_current;
#line 361 "../src/PlaybackManager.vala"
						_tmp103_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp102_);
#line 361 "../src/PlaybackManager.vala"
						_tmp104_ = _tmp103_;
#line 361 "../src/PlaybackManager.vala"
						_tmp101_ = self->priv->_current_index < (_tmp104_ - 1);
#line 1825 "PlaybackManager.c"
					} else {
#line 361 "../src/PlaybackManager.vala"
						_tmp101_ = FALSE;
#line 1829 "PlaybackManager.c"
					}
#line 361 "../src/PlaybackManager.vala"
					if (_tmp101_) {
#line 1833 "PlaybackManager.c"
						MusicMedia* next_current = NULL;
						GeeHashMap* _tmp105_;
						gpointer _tmp106_;
						MusicMedia* now_current = NULL;
						GeeHashMap* _tmp107_;
						gpointer _tmp108_;
						gboolean _tmp109_ = FALSE;
						GSettings* _tmp110_;
						GSettings* _tmp111_;
						GeeHashMap* _tmp148_;
						gpointer _tmp149_;
#line 363 "../src/PlaybackManager.vala"
						_tmp105_ = self->priv->_current;
#line 363 "../src/PlaybackManager.vala"
						_tmp106_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp105_, (gpointer) ((gintptr) (self->priv->_current_index + 1)));
#line 363 "../src/PlaybackManager.vala"
						next_current = (MusicMedia*) _tmp106_;
#line 364 "../src/PlaybackManager.vala"
						_tmp107_ = self->priv->_current;
#line 364 "../src/PlaybackManager.vala"
						_tmp108_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp107_, (gpointer) ((gintptr) self->priv->_current_index));
#line 364 "../src/PlaybackManager.vala"
						now_current = (MusicMedia*) _tmp108_;
#line 366 "../src/PlaybackManager.vala"
						_tmp110_ = music_app_get_settings ();
#line 366 "../src/PlaybackManager.vala"
						_tmp111_ = _tmp110_;
#line 366 "../src/PlaybackManager.vala"
						if (g_settings_get_enum (_tmp111_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ARTIST)) {
#line 1863 "PlaybackManager.c"
							MusicMedia* _tmp112_;
							const gchar* _tmp113_;
							const gchar* _tmp114_;
							MusicMedia* _tmp115_;
							const gchar* _tmp116_;
							const gchar* _tmp117_;
#line 366 "../src/PlaybackManager.vala"
							_tmp112_ = next_current;
#line 366 "../src/PlaybackManager.vala"
							_tmp113_ = music_media_get_artist (_tmp112_);
#line 366 "../src/PlaybackManager.vala"
							_tmp114_ = _tmp113_;
#line 366 "../src/PlaybackManager.vala"
							_tmp115_ = now_current;
#line 366 "../src/PlaybackManager.vala"
							_tmp116_ = music_media_get_artist (_tmp115_);
#line 366 "../src/PlaybackManager.vala"
							_tmp117_ = _tmp116_;
#line 366 "../src/PlaybackManager.vala"
							_tmp109_ = g_strcmp0 (_tmp114_, _tmp117_) != 0;
#line 1884 "PlaybackManager.c"
						} else {
#line 366 "../src/PlaybackManager.vala"
							_tmp109_ = FALSE;
#line 1888 "PlaybackManager.c"
						}
#line 366 "../src/PlaybackManager.vala"
						if (_tmp109_) {
#line 367 "../src/PlaybackManager.vala"
							while (TRUE) {
#line 1894 "PlaybackManager.c"
								GeeHashMap* _tmp118_;
								gpointer _tmp119_;
								MusicMedia* _tmp120_;
								const gchar* _tmp121_;
								const gchar* _tmp122_;
								MusicMedia* _tmp123_;
								const gchar* _tmp124_;
								const gchar* _tmp125_;
								gboolean _tmp126_;
								gint _tmp127_;
#line 367 "../src/PlaybackManager.vala"
								_tmp118_ = self->priv->_current;
#line 367 "../src/PlaybackManager.vala"
								_tmp119_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp118_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
#line 367 "../src/PlaybackManager.vala"
								_tmp120_ = (MusicMedia*) _tmp119_;
#line 367 "../src/PlaybackManager.vala"
								_tmp121_ = music_media_get_artist (_tmp120_);
#line 367 "../src/PlaybackManager.vala"
								_tmp122_ = _tmp121_;
#line 367 "../src/PlaybackManager.vala"
								_tmp123_ = self->priv->_current_media;
#line 367 "../src/PlaybackManager.vala"
								_tmp124_ = music_media_get_artist (_tmp123_);
#line 367 "../src/PlaybackManager.vala"
								_tmp125_ = _tmp124_;
#line 367 "../src/PlaybackManager.vala"
								_tmp126_ = !(g_strcmp0 (_tmp122_, _tmp125_) == 0);
#line 367 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp120_);
#line 367 "../src/PlaybackManager.vala"
								if (_tmp126_) {
#line 367 "../src/PlaybackManager.vala"
									break;
#line 1929 "PlaybackManager.c"
								}
#line 368 "../src/PlaybackManager.vala"
								_tmp127_ = self->priv->_current_index;
#line 368 "../src/PlaybackManager.vala"
								self->priv->_current_index = _tmp127_ - 1;
#line 1935 "PlaybackManager.c"
							}
						} else {
							gboolean _tmp128_ = FALSE;
							GSettings* _tmp129_;
							GSettings* _tmp130_;
#line 370 "../src/PlaybackManager.vala"
							_tmp129_ = music_app_get_settings ();
#line 370 "../src/PlaybackManager.vala"
							_tmp130_ = _tmp129_;
#line 370 "../src/PlaybackManager.vala"
							if (g_settings_get_enum (_tmp130_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALBUM)) {
#line 1947 "PlaybackManager.c"
								MusicMedia* _tmp131_;
								const gchar* _tmp132_;
								const gchar* _tmp133_;
								MusicMedia* _tmp134_;
								const gchar* _tmp135_;
								const gchar* _tmp136_;
#line 370 "../src/PlaybackManager.vala"
								_tmp131_ = next_current;
#line 370 "../src/PlaybackManager.vala"
								_tmp132_ = music_media_get_album (_tmp131_);
#line 370 "../src/PlaybackManager.vala"
								_tmp133_ = _tmp132_;
#line 370 "../src/PlaybackManager.vala"
								_tmp134_ = now_current;
#line 370 "../src/PlaybackManager.vala"
								_tmp135_ = music_media_get_album (_tmp134_);
#line 370 "../src/PlaybackManager.vala"
								_tmp136_ = _tmp135_;
#line 370 "../src/PlaybackManager.vala"
								_tmp128_ = g_strcmp0 (_tmp133_, _tmp136_) != 0;
#line 1968 "PlaybackManager.c"
							} else {
#line 370 "../src/PlaybackManager.vala"
								_tmp128_ = FALSE;
#line 1972 "PlaybackManager.c"
							}
#line 370 "../src/PlaybackManager.vala"
							if (_tmp128_) {
#line 371 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 1978 "PlaybackManager.c"
									GeeHashMap* _tmp137_;
									gpointer _tmp138_;
									MusicMedia* _tmp139_;
									const gchar* _tmp140_;
									const gchar* _tmp141_;
									MusicMedia* _tmp142_;
									const gchar* _tmp143_;
									const gchar* _tmp144_;
									gboolean _tmp145_;
									gint _tmp146_;
#line 371 "../src/PlaybackManager.vala"
									_tmp137_ = self->priv->_current;
#line 371 "../src/PlaybackManager.vala"
									_tmp138_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp137_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
#line 371 "../src/PlaybackManager.vala"
									_tmp139_ = (MusicMedia*) _tmp138_;
#line 371 "../src/PlaybackManager.vala"
									_tmp140_ = music_media_get_album (_tmp139_);
#line 371 "../src/PlaybackManager.vala"
									_tmp141_ = _tmp140_;
#line 371 "../src/PlaybackManager.vala"
									_tmp142_ = self->priv->_current_media;
#line 371 "../src/PlaybackManager.vala"
									_tmp143_ = music_media_get_album (_tmp142_);
#line 371 "../src/PlaybackManager.vala"
									_tmp144_ = _tmp143_;
#line 371 "../src/PlaybackManager.vala"
									_tmp145_ = !(g_strcmp0 (_tmp141_, _tmp144_) == 0);
#line 371 "../src/PlaybackManager.vala"
									_g_object_unref0 (_tmp139_);
#line 371 "../src/PlaybackManager.vala"
									if (_tmp145_) {
#line 371 "../src/PlaybackManager.vala"
										break;
#line 2013 "PlaybackManager.c"
									}
#line 372 "../src/PlaybackManager.vala"
									_tmp146_ = self->priv->_current_index;
#line 372 "../src/PlaybackManager.vala"
									self->priv->_current_index = _tmp146_ - 1;
#line 2019 "PlaybackManager.c"
								}
							} else {
								gint _tmp147_;
#line 375 "../src/PlaybackManager.vala"
								_tmp147_ = self->priv->_current_index;
#line 375 "../src/PlaybackManager.vala"
								self->priv->_current_index = _tmp147_ + 1;
#line 2027 "PlaybackManager.c"
							}
						}
#line 378 "../src/PlaybackManager.vala"
						_tmp148_ = self->priv->_current;
#line 378 "../src/PlaybackManager.vala"
						_tmp149_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp148_, (gpointer) ((gintptr) self->priv->_current_index));
#line 378 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 378 "../src/PlaybackManager.vala"
						rv = (MusicMedia*) _tmp149_;
#line 361 "../src/PlaybackManager.vala"
						_g_object_unref0 (now_current);
#line 361 "../src/PlaybackManager.vala"
						_g_object_unref0 (next_current);
#line 2042 "PlaybackManager.c"
					} else {
						GeeHashMap* _tmp150_;
						gpointer _tmp151_;
#line 380 "../src/PlaybackManager.vala"
						self->priv->_current_index = 0;
#line 381 "../src/PlaybackManager.vala"
						_tmp150_ = self->priv->_current;
#line 381 "../src/PlaybackManager.vala"
						_tmp151_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp150_, (gpointer) ((gintptr) 0));
#line 381 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 381 "../src/PlaybackManager.vala"
						rv = (MusicMedia*) _tmp151_;
#line 2056 "PlaybackManager.c"
					}
				}
			}
		}
	}
#line 385 "../src/PlaybackManager.vala"
	_tmp152_ = self->queue_playlist;
#line 385 "../src/PlaybackManager.vala"
	_tmp153_ = music_playlist_get_medias ((MusicPlaylist*) _tmp152_);
#line 385 "../src/PlaybackManager.vala"
	_tmp154_ = _tmp153_;
#line 385 "../src/PlaybackManager.vala"
	_tmp155_ = rv;
#line 385 "../src/PlaybackManager.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp154_, _tmp155_)) {
#line 386 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = TRUE;
#line 2074 "PlaybackManager.c"
	}
#line 389 "../src/PlaybackManager.vala"
	if (play) {
#line 2078 "PlaybackManager.c"
		MusicMedia* _tmp156_;
#line 390 "../src/PlaybackManager.vala"
		_tmp156_ = rv;
#line 390 "../src/PlaybackManager.vala"
		music_playback_manager_play_media (self, _tmp156_);
#line 2084 "PlaybackManager.c"
	}
#line 393 "../src/PlaybackManager.vala"
	result = rv;
#line 393 "../src/PlaybackManager.vala"
	return result;
#line 2090 "PlaybackManager.c"
}

MusicMedia*
music_playback_manager_get_previous (MusicPlaybackManager* self,
                                     gboolean play)
{
	MusicMedia* rv = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	MusicStaticPlaylist* _tmp169_;
	GeeArrayList* _tmp170_;
	GeeArrayList* _tmp171_;
	MusicMedia* _tmp172_;
	MusicMedia* result;
#line 397 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 398 "../src/PlaybackManager.vala"
	rv = NULL;
#line 400 "../src/PlaybackManager.vala"
	_tmp0_ = music_app_get_settings ();
#line 400 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 400 "../src/PlaybackManager.vala"
	if (g_settings_get_enum (_tmp1_, "shuffle-mode") != ((gint) MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_OFF)) {
#line 2115 "PlaybackManager.c"
		GeeHashMap* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		MusicMedia* _tmp12_;
#line 401 "../src/PlaybackManager.vala"
		_tmp2_ = self->priv->_current_shuffled;
#line 401 "../src/PlaybackManager.vala"
		_tmp3_ = gee_map_get_is_empty ((GeeMap*) _tmp2_);
#line 401 "../src/PlaybackManager.vala"
		_tmp4_ = _tmp3_;
#line 401 "../src/PlaybackManager.vala"
		if (_tmp4_) {
#line 2128 "PlaybackManager.c"
			GeeHashMap* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 402 "../src/PlaybackManager.vala"
			_tmp5_ = self->priv->_current;
#line 402 "../src/PlaybackManager.vala"
			_tmp6_ = gee_map_get_is_empty ((GeeMap*) _tmp5_);
#line 402 "../src/PlaybackManager.vala"
			_tmp7_ = _tmp6_;
#line 402 "../src/PlaybackManager.vala"
			if (_tmp7_) {
#line 2140 "PlaybackManager.c"
				MusicLibrary* _tmp8_;
				MusicLibrary* _tmp9_;
				GeeCollection* _tmp10_;
				GeeCollection* _tmp11_;
#line 403 "../src/PlaybackManager.vala"
				_tmp8_ = music_playback_manager_get_library (self);
#line 403 "../src/PlaybackManager.vala"
				_tmp9_ = _tmp8_;
#line 403 "../src/PlaybackManager.vala"
				_tmp10_ = music_library_get_medias (_tmp9_);
#line 403 "../src/PlaybackManager.vala"
				_tmp11_ = _tmp10_;
#line 403 "../src/PlaybackManager.vala"
				music_playback_manager_queue_media (self, _tmp11_);
#line 403 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp11_);
#line 2157 "PlaybackManager.c"
			}
#line 406 "../src/PlaybackManager.vala"
			music_playback_manager_reshuffle (self);
#line 2161 "PlaybackManager.c"
		}
#line 409 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = FALSE;
#line 411 "../src/PlaybackManager.vala"
		_tmp12_ = self->priv->_current_media;
#line 411 "../src/PlaybackManager.vala"
		if (_tmp12_ == NULL) {
#line 2169 "PlaybackManager.c"
			GeeHashMap* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			GeeHashMap* _tmp16_;
			gpointer _tmp17_;
#line 412 "../src/PlaybackManager.vala"
			_tmp13_ = self->priv->_current_shuffled;
#line 412 "../src/PlaybackManager.vala"
			_tmp14_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp13_);
#line 412 "../src/PlaybackManager.vala"
			_tmp15_ = _tmp14_;
#line 412 "../src/PlaybackManager.vala"
			self->priv->_current_shuffled_index = _tmp15_ - 1;
#line 413 "../src/PlaybackManager.vala"
			_tmp16_ = self->priv->_current_shuffled;
#line 413 "../src/PlaybackManager.vala"
			_tmp17_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp16_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 413 "../src/PlaybackManager.vala"
			_g_object_unref0 (rv);
#line 413 "../src/PlaybackManager.vala"
			rv = (MusicMedia*) _tmp17_;
#line 2191 "PlaybackManager.c"
		} else {
			GSettings* _tmp18_;
			GSettings* _tmp19_;
#line 414 "../src/PlaybackManager.vala"
			_tmp18_ = music_app_get_settings ();
#line 414 "../src/PlaybackManager.vala"
			_tmp19_ = _tmp18_;
#line 414 "../src/PlaybackManager.vala"
			if (g_settings_get_enum (_tmp19_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_MEDIA)) {
#line 2201 "PlaybackManager.c"
				GeeHashMap* _tmp20_;
				gpointer _tmp21_;
#line 415 "../src/PlaybackManager.vala"
				_tmp20_ = self->priv->_current_shuffled;
#line 415 "../src/PlaybackManager.vala"
				_tmp21_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp20_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 415 "../src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 415 "../src/PlaybackManager.vala"
				rv = (MusicMedia*) _tmp21_;
#line 2212 "PlaybackManager.c"
			} else {
#line 416 "../src/PlaybackManager.vala"
				if (self->priv->_current_shuffled_index == 0) {
#line 2216 "PlaybackManager.c"
					GSettings* _tmp22_;
					GSettings* _tmp23_;
					GeeHashMap* _tmp27_;
					gpointer _tmp28_;
#line 417 "../src/PlaybackManager.vala"
					_tmp22_ = music_app_get_settings ();
#line 417 "../src/PlaybackManager.vala"
					_tmp23_ = _tmp22_;
#line 417 "../src/PlaybackManager.vala"
					if (g_settings_get_enum (_tmp23_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALL)) {
#line 2227 "PlaybackManager.c"
						GeeHashMap* _tmp24_;
						gint _tmp25_;
						gint _tmp26_;
#line 418 "../src/PlaybackManager.vala"
						_tmp24_ = self->priv->_current_shuffled;
#line 418 "../src/PlaybackManager.vala"
						_tmp25_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp24_);
#line 418 "../src/PlaybackManager.vala"
						_tmp26_ = _tmp25_;
#line 418 "../src/PlaybackManager.vala"
						self->priv->_current_shuffled_index = _tmp26_ - 1;
#line 2239 "PlaybackManager.c"
					} else {
#line 420 "../src/PlaybackManager.vala"
						music_playback_manager_stop_playback (self);
#line 421 "../src/PlaybackManager.vala"
						result = NULL;
#line 421 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 421 "../src/PlaybackManager.vala"
						return result;
#line 2249 "PlaybackManager.c"
					}
#line 424 "../src/PlaybackManager.vala"
					_tmp27_ = self->priv->_current_shuffled;
#line 424 "../src/PlaybackManager.vala"
					_tmp28_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp27_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 424 "../src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 424 "../src/PlaybackManager.vala"
					rv = (MusicMedia*) _tmp28_;
#line 2259 "PlaybackManager.c"
				} else {
					gboolean _tmp29_ = FALSE;
#line 425 "../src/PlaybackManager.vala"
					if (self->priv->_current_shuffled_index > 0) {
#line 2264 "PlaybackManager.c"
						GeeHashMap* _tmp30_;
						gint _tmp31_;
						gint _tmp32_;
#line 425 "../src/PlaybackManager.vala"
						_tmp30_ = self->priv->_current_shuffled;
#line 425 "../src/PlaybackManager.vala"
						_tmp31_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp30_);
#line 425 "../src/PlaybackManager.vala"
						_tmp32_ = _tmp31_;
#line 425 "../src/PlaybackManager.vala"
						_tmp29_ = self->priv->_current_shuffled_index < _tmp32_;
#line 2276 "PlaybackManager.c"
					} else {
#line 425 "../src/PlaybackManager.vala"
						_tmp29_ = FALSE;
#line 2280 "PlaybackManager.c"
					}
#line 425 "../src/PlaybackManager.vala"
					if (_tmp29_) {
#line 2284 "PlaybackManager.c"
						gboolean _tmp33_ = FALSE;
						GSettings* _tmp34_;
						GSettings* _tmp35_;
						GeeHashMap* _tmp80_;
						gpointer _tmp81_;
#line 427 "../src/PlaybackManager.vala"
						_tmp34_ = music_app_get_settings ();
#line 427 "../src/PlaybackManager.vala"
						_tmp35_ = _tmp34_;
#line 427 "../src/PlaybackManager.vala"
						if (g_settings_get_enum (_tmp35_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ARTIST)) {
#line 2296 "PlaybackManager.c"
							GeeHashMap* _tmp36_;
							gpointer _tmp37_;
							MusicMedia* _tmp38_;
							const gchar* _tmp39_;
							const gchar* _tmp40_;
							GeeHashMap* _tmp41_;
							gpointer _tmp42_;
							MusicMedia* _tmp43_;
							const gchar* _tmp44_;
							const gchar* _tmp45_;
#line 427 "../src/PlaybackManager.vala"
							_tmp36_ = self->priv->_current_shuffled;
#line 427 "../src/PlaybackManager.vala"
							_tmp37_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp36_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
#line 427 "../src/PlaybackManager.vala"
							_tmp38_ = (MusicMedia*) _tmp37_;
#line 427 "../src/PlaybackManager.vala"
							_tmp39_ = music_media_get_artist (_tmp38_);
#line 427 "../src/PlaybackManager.vala"
							_tmp40_ = _tmp39_;
#line 427 "../src/PlaybackManager.vala"
							_tmp41_ = self->priv->_current_shuffled;
#line 427 "../src/PlaybackManager.vala"
							_tmp42_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp41_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 427 "../src/PlaybackManager.vala"
							_tmp43_ = (MusicMedia*) _tmp42_;
#line 427 "../src/PlaybackManager.vala"
							_tmp44_ = music_media_get_artist (_tmp43_);
#line 427 "../src/PlaybackManager.vala"
							_tmp45_ = _tmp44_;
#line 427 "../src/PlaybackManager.vala"
							_tmp33_ = g_strcmp0 (_tmp40_, _tmp45_) != 0;
#line 427 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp43_);
#line 427 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp38_);
#line 2333 "PlaybackManager.c"
						} else {
#line 427 "../src/PlaybackManager.vala"
							_tmp33_ = FALSE;
#line 2337 "PlaybackManager.c"
						}
#line 427 "../src/PlaybackManager.vala"
						if (_tmp33_) {
#line 428 "../src/PlaybackManager.vala"
							while (TRUE) {
#line 2343 "PlaybackManager.c"
								GeeHashMap* _tmp46_;
								gpointer _tmp47_;
								MusicMedia* _tmp48_;
								const gchar* _tmp49_;
								const gchar* _tmp50_;
								MusicMedia* _tmp51_;
								const gchar* _tmp52_;
								const gchar* _tmp53_;
								gboolean _tmp54_;
								gint _tmp55_;
#line 428 "../src/PlaybackManager.vala"
								_tmp46_ = self->priv->_current_shuffled;
#line 428 "../src/PlaybackManager.vala"
								_tmp47_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp46_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index + 1)));
#line 428 "../src/PlaybackManager.vala"
								_tmp48_ = (MusicMedia*) _tmp47_;
#line 428 "../src/PlaybackManager.vala"
								_tmp49_ = music_media_get_artist (_tmp48_);
#line 428 "../src/PlaybackManager.vala"
								_tmp50_ = _tmp49_;
#line 428 "../src/PlaybackManager.vala"
								_tmp51_ = self->priv->_current_media;
#line 428 "../src/PlaybackManager.vala"
								_tmp52_ = music_media_get_artist (_tmp51_);
#line 428 "../src/PlaybackManager.vala"
								_tmp53_ = _tmp52_;
#line 428 "../src/PlaybackManager.vala"
								_tmp54_ = !(g_strcmp0 (_tmp50_, _tmp53_) == 0);
#line 428 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp48_);
#line 428 "../src/PlaybackManager.vala"
								if (_tmp54_) {
#line 428 "../src/PlaybackManager.vala"
									break;
#line 2378 "PlaybackManager.c"
								}
#line 429 "../src/PlaybackManager.vala"
								self->priv->_current_shuffled_index = self->priv->_current_shuffled_index + 1;
#line 429 "../src/PlaybackManager.vala"
								_tmp55_ = self->priv->_current_shuffled_index;
#line 2384 "PlaybackManager.c"
							}
						} else {
							gboolean _tmp56_ = FALSE;
							GSettings* _tmp57_;
							GSettings* _tmp58_;
#line 430 "../src/PlaybackManager.vala"
							_tmp57_ = music_app_get_settings ();
#line 430 "../src/PlaybackManager.vala"
							_tmp58_ = _tmp57_;
#line 430 "../src/PlaybackManager.vala"
							if (g_settings_get_enum (_tmp58_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALBUM)) {
#line 2396 "PlaybackManager.c"
								GeeHashMap* _tmp59_;
								gpointer _tmp60_;
								MusicMedia* _tmp61_;
								const gchar* _tmp62_;
								const gchar* _tmp63_;
								GeeHashMap* _tmp64_;
								gpointer _tmp65_;
								MusicMedia* _tmp66_;
								const gchar* _tmp67_;
								const gchar* _tmp68_;
#line 430 "../src/PlaybackManager.vala"
								_tmp59_ = self->priv->_current_shuffled;
#line 430 "../src/PlaybackManager.vala"
								_tmp60_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp59_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
#line 430 "../src/PlaybackManager.vala"
								_tmp61_ = (MusicMedia*) _tmp60_;
#line 430 "../src/PlaybackManager.vala"
								_tmp62_ = music_media_get_album (_tmp61_);
#line 430 "../src/PlaybackManager.vala"
								_tmp63_ = _tmp62_;
#line 430 "../src/PlaybackManager.vala"
								_tmp64_ = self->priv->_current_shuffled;
#line 430 "../src/PlaybackManager.vala"
								_tmp65_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp64_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 430 "../src/PlaybackManager.vala"
								_tmp66_ = (MusicMedia*) _tmp65_;
#line 430 "../src/PlaybackManager.vala"
								_tmp67_ = music_media_get_album (_tmp66_);
#line 430 "../src/PlaybackManager.vala"
								_tmp68_ = _tmp67_;
#line 430 "../src/PlaybackManager.vala"
								_tmp56_ = g_strcmp0 (_tmp63_, _tmp68_) != 0;
#line 430 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp66_);
#line 430 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp61_);
#line 2433 "PlaybackManager.c"
							} else {
#line 430 "../src/PlaybackManager.vala"
								_tmp56_ = FALSE;
#line 2437 "PlaybackManager.c"
							}
#line 430 "../src/PlaybackManager.vala"
							if (_tmp56_) {
#line 431 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 2443 "PlaybackManager.c"
									GeeHashMap* _tmp69_;
									gpointer _tmp70_;
									MusicMedia* _tmp71_;
									const gchar* _tmp72_;
									const gchar* _tmp73_;
									MusicMedia* _tmp74_;
									const gchar* _tmp75_;
									const gchar* _tmp76_;
									gboolean _tmp77_;
									gint _tmp78_;
#line 431 "../src/PlaybackManager.vala"
									_tmp69_ = self->priv->_current_shuffled;
#line 431 "../src/PlaybackManager.vala"
									_tmp70_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp69_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index + 1)));
#line 431 "../src/PlaybackManager.vala"
									_tmp71_ = (MusicMedia*) _tmp70_;
#line 431 "../src/PlaybackManager.vala"
									_tmp72_ = music_media_get_album (_tmp71_);
#line 431 "../src/PlaybackManager.vala"
									_tmp73_ = _tmp72_;
#line 431 "../src/PlaybackManager.vala"
									_tmp74_ = self->priv->_current_media;
#line 431 "../src/PlaybackManager.vala"
									_tmp75_ = music_media_get_album (_tmp74_);
#line 431 "../src/PlaybackManager.vala"
									_tmp76_ = _tmp75_;
#line 431 "../src/PlaybackManager.vala"
									_tmp77_ = !(g_strcmp0 (_tmp73_, _tmp76_) == 0);
#line 431 "../src/PlaybackManager.vala"
									_g_object_unref0 (_tmp71_);
#line 431 "../src/PlaybackManager.vala"
									if (_tmp77_) {
#line 431 "../src/PlaybackManager.vala"
										break;
#line 2478 "PlaybackManager.c"
									}
#line 432 "../src/PlaybackManager.vala"
									self->priv->_current_shuffled_index = self->priv->_current_shuffled_index + 1;
#line 432 "../src/PlaybackManager.vala"
									_tmp78_ = self->priv->_current_shuffled_index;
#line 2484 "PlaybackManager.c"
								}
							} else {
								gint _tmp79_;
#line 434 "../src/PlaybackManager.vala"
								self->priv->_current_shuffled_index = self->priv->_current_shuffled_index - 1;
#line 434 "../src/PlaybackManager.vala"
								_tmp79_ = self->priv->_current_shuffled_index;
#line 2492 "PlaybackManager.c"
							}
						}
#line 436 "../src/PlaybackManager.vala"
						_tmp80_ = self->priv->_current_shuffled;
#line 436 "../src/PlaybackManager.vala"
						_tmp81_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp80_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 436 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 436 "../src/PlaybackManager.vala"
						rv = (MusicMedia*) _tmp81_;
#line 2503 "PlaybackManager.c"
					} else {
						GeeHashMap* _tmp82_;
						gint _tmp83_;
						gint _tmp84_;
						GeeHashMap* _tmp85_;
						gpointer _tmp86_;
#line 438 "../src/PlaybackManager.vala"
						_tmp82_ = self->priv->_current_shuffled;
#line 438 "../src/PlaybackManager.vala"
						_tmp83_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp82_);
#line 438 "../src/PlaybackManager.vala"
						_tmp84_ = _tmp83_;
#line 438 "../src/PlaybackManager.vala"
						self->priv->_current_shuffled_index = _tmp84_ - 1;
#line 439 "../src/PlaybackManager.vala"
						_tmp85_ = self->priv->_current_shuffled;
#line 439 "../src/PlaybackManager.vala"
						_tmp86_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp85_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 439 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 439 "../src/PlaybackManager.vala"
						rv = (MusicMedia*) _tmp86_;
#line 2526 "PlaybackManager.c"
					}
				}
			}
		}
	} else {
		GeeHashMap* _tmp87_;
		gboolean _tmp88_;
		gboolean _tmp89_;
		MusicMedia* _tmp94_;
#line 442 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = FALSE;
#line 444 "../src/PlaybackManager.vala"
		_tmp87_ = self->priv->_current;
#line 444 "../src/PlaybackManager.vala"
		_tmp88_ = gee_map_get_is_empty ((GeeMap*) _tmp87_);
#line 444 "../src/PlaybackManager.vala"
		_tmp89_ = _tmp88_;
#line 444 "../src/PlaybackManager.vala"
		if (_tmp89_) {
#line 2546 "PlaybackManager.c"
			MusicLibrary* _tmp90_;
			MusicLibrary* _tmp91_;
			GeeCollection* _tmp92_;
			GeeCollection* _tmp93_;
#line 445 "../src/PlaybackManager.vala"
			_tmp90_ = music_playback_manager_get_library (self);
#line 445 "../src/PlaybackManager.vala"
			_tmp91_ = _tmp90_;
#line 445 "../src/PlaybackManager.vala"
			_tmp92_ = music_library_get_medias (_tmp91_);
#line 445 "../src/PlaybackManager.vala"
			_tmp93_ = _tmp92_;
#line 445 "../src/PlaybackManager.vala"
			music_playback_manager_queue_media (self, _tmp93_);
#line 445 "../src/PlaybackManager.vala"
			_g_object_unref0 (_tmp93_);
#line 2563 "PlaybackManager.c"
		}
#line 448 "../src/PlaybackManager.vala"
		_tmp94_ = self->priv->_current_media;
#line 448 "../src/PlaybackManager.vala"
		if (_tmp94_ == NULL) {
#line 2569 "PlaybackManager.c"
			GeeHashMap* _tmp95_;
			gint _tmp96_;
			gint _tmp97_;
			GeeHashMap* _tmp98_;
			gpointer _tmp99_;
#line 449 "../src/PlaybackManager.vala"
			_tmp95_ = self->priv->_current;
#line 449 "../src/PlaybackManager.vala"
			_tmp96_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp95_);
#line 449 "../src/PlaybackManager.vala"
			_tmp97_ = _tmp96_;
#line 449 "../src/PlaybackManager.vala"
			self->priv->_current_index = _tmp97_ - 1;
#line 450 "../src/PlaybackManager.vala"
			_tmp98_ = self->priv->_current;
#line 450 "../src/PlaybackManager.vala"
			_tmp99_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp98_, (gpointer) ((gintptr) self->priv->_current_index));
#line 450 "../src/PlaybackManager.vala"
			_g_object_unref0 (rv);
#line 450 "../src/PlaybackManager.vala"
			rv = (MusicMedia*) _tmp99_;
#line 2591 "PlaybackManager.c"
		} else {
			GSettings* _tmp100_;
			GSettings* _tmp101_;
#line 451 "../src/PlaybackManager.vala"
			_tmp100_ = music_app_get_settings ();
#line 451 "../src/PlaybackManager.vala"
			_tmp101_ = _tmp100_;
#line 451 "../src/PlaybackManager.vala"
			if (g_settings_get_enum (_tmp101_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_MEDIA)) {
#line 2601 "PlaybackManager.c"
				GeeHashMap* _tmp102_;
				gpointer _tmp103_;
#line 452 "../src/PlaybackManager.vala"
				_tmp102_ = self->priv->_current;
#line 452 "../src/PlaybackManager.vala"
				_tmp103_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp102_, (gpointer) ((gintptr) self->priv->_current_index));
#line 452 "../src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 452 "../src/PlaybackManager.vala"
				rv = (MusicMedia*) _tmp103_;
#line 2612 "PlaybackManager.c"
			} else {
#line 453 "../src/PlaybackManager.vala"
				if (self->priv->_current_index == 0) {
#line 2616 "PlaybackManager.c"
					GSettings* _tmp104_;
					GSettings* _tmp105_;
					GeeHashMap* _tmp109_;
					gpointer _tmp110_;
#line 454 "../src/PlaybackManager.vala"
					_tmp104_ = music_app_get_settings ();
#line 454 "../src/PlaybackManager.vala"
					_tmp105_ = _tmp104_;
#line 454 "../src/PlaybackManager.vala"
					if (g_settings_get_enum (_tmp105_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALL)) {
#line 2627 "PlaybackManager.c"
						GeeHashMap* _tmp106_;
						gint _tmp107_;
						gint _tmp108_;
#line 455 "../src/PlaybackManager.vala"
						_tmp106_ = self->priv->_current;
#line 455 "../src/PlaybackManager.vala"
						_tmp107_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp106_);
#line 455 "../src/PlaybackManager.vala"
						_tmp108_ = _tmp107_;
#line 455 "../src/PlaybackManager.vala"
						self->priv->_current_index = _tmp108_ - 1;
#line 2639 "PlaybackManager.c"
					} else {
#line 457 "../src/PlaybackManager.vala"
						music_playback_manager_stop_playback (self);
#line 458 "../src/PlaybackManager.vala"
						result = NULL;
#line 458 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 458 "../src/PlaybackManager.vala"
						return result;
#line 2649 "PlaybackManager.c"
					}
#line 461 "../src/PlaybackManager.vala"
					_tmp109_ = self->priv->_current;
#line 461 "../src/PlaybackManager.vala"
					_tmp110_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp109_, (gpointer) ((gintptr) self->priv->_current_index));
#line 461 "../src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 461 "../src/PlaybackManager.vala"
					rv = (MusicMedia*) _tmp110_;
#line 2659 "PlaybackManager.c"
				} else {
					gboolean _tmp111_ = FALSE;
#line 462 "../src/PlaybackManager.vala"
					if (self->priv->_current_index > 0) {
#line 2664 "PlaybackManager.c"
						GeeHashMap* _tmp112_;
						gint _tmp113_;
						gint _tmp114_;
#line 462 "../src/PlaybackManager.vala"
						_tmp112_ = self->priv->_current;
#line 462 "../src/PlaybackManager.vala"
						_tmp113_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp112_);
#line 462 "../src/PlaybackManager.vala"
						_tmp114_ = _tmp113_;
#line 462 "../src/PlaybackManager.vala"
						_tmp111_ = self->priv->_current_index < _tmp114_;
#line 2676 "PlaybackManager.c"
					} else {
#line 462 "../src/PlaybackManager.vala"
						_tmp111_ = FALSE;
#line 2680 "PlaybackManager.c"
					}
#line 462 "../src/PlaybackManager.vala"
					if (_tmp111_) {
#line 2684 "PlaybackManager.c"
						gboolean _tmp115_ = FALSE;
						GSettings* _tmp116_;
						GSettings* _tmp117_;
						GeeHashMap* _tmp162_;
						gpointer _tmp163_;
#line 464 "../src/PlaybackManager.vala"
						_tmp116_ = music_app_get_settings ();
#line 464 "../src/PlaybackManager.vala"
						_tmp117_ = _tmp116_;
#line 464 "../src/PlaybackManager.vala"
						if (g_settings_get_enum (_tmp117_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ARTIST)) {
#line 2696 "PlaybackManager.c"
							GeeHashMap* _tmp118_;
							gpointer _tmp119_;
							MusicMedia* _tmp120_;
							const gchar* _tmp121_;
							const gchar* _tmp122_;
							GeeHashMap* _tmp123_;
							gpointer _tmp124_;
							MusicMedia* _tmp125_;
							const gchar* _tmp126_;
							const gchar* _tmp127_;
#line 464 "../src/PlaybackManager.vala"
							_tmp118_ = self->priv->_current;
#line 464 "../src/PlaybackManager.vala"
							_tmp119_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp118_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
#line 464 "../src/PlaybackManager.vala"
							_tmp120_ = (MusicMedia*) _tmp119_;
#line 464 "../src/PlaybackManager.vala"
							_tmp121_ = music_media_get_artist (_tmp120_);
#line 464 "../src/PlaybackManager.vala"
							_tmp122_ = _tmp121_;
#line 464 "../src/PlaybackManager.vala"
							_tmp123_ = self->priv->_current;
#line 464 "../src/PlaybackManager.vala"
							_tmp124_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp123_, (gpointer) ((gintptr) self->priv->_current_index));
#line 464 "../src/PlaybackManager.vala"
							_tmp125_ = (MusicMedia*) _tmp124_;
#line 464 "../src/PlaybackManager.vala"
							_tmp126_ = music_media_get_artist (_tmp125_);
#line 464 "../src/PlaybackManager.vala"
							_tmp127_ = _tmp126_;
#line 464 "../src/PlaybackManager.vala"
							_tmp115_ = g_strcmp0 (_tmp122_, _tmp127_) != 0;
#line 464 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp125_);
#line 464 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp120_);
#line 2733 "PlaybackManager.c"
						} else {
#line 464 "../src/PlaybackManager.vala"
							_tmp115_ = FALSE;
#line 2737 "PlaybackManager.c"
						}
#line 464 "../src/PlaybackManager.vala"
						if (_tmp115_) {
#line 465 "../src/PlaybackManager.vala"
							while (TRUE) {
#line 2743 "PlaybackManager.c"
								GeeHashMap* _tmp128_;
								gpointer _tmp129_;
								MusicMedia* _tmp130_;
								const gchar* _tmp131_;
								const gchar* _tmp132_;
								MusicMedia* _tmp133_;
								const gchar* _tmp134_;
								const gchar* _tmp135_;
								gboolean _tmp136_;
								gint _tmp137_;
#line 465 "../src/PlaybackManager.vala"
								_tmp128_ = self->priv->_current;
#line 465 "../src/PlaybackManager.vala"
								_tmp129_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp128_, (gpointer) ((gintptr) (self->priv->_current_index + 1)));
#line 465 "../src/PlaybackManager.vala"
								_tmp130_ = (MusicMedia*) _tmp129_;
#line 465 "../src/PlaybackManager.vala"
								_tmp131_ = music_media_get_artist (_tmp130_);
#line 465 "../src/PlaybackManager.vala"
								_tmp132_ = _tmp131_;
#line 465 "../src/PlaybackManager.vala"
								_tmp133_ = self->priv->_current_media;
#line 465 "../src/PlaybackManager.vala"
								_tmp134_ = music_media_get_artist (_tmp133_);
#line 465 "../src/PlaybackManager.vala"
								_tmp135_ = _tmp134_;
#line 465 "../src/PlaybackManager.vala"
								_tmp136_ = !(g_strcmp0 (_tmp132_, _tmp135_) == 0);
#line 465 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp130_);
#line 465 "../src/PlaybackManager.vala"
								if (_tmp136_) {
#line 465 "../src/PlaybackManager.vala"
									break;
#line 2778 "PlaybackManager.c"
								}
#line 466 "../src/PlaybackManager.vala"
								_tmp137_ = self->priv->_current_index;
#line 466 "../src/PlaybackManager.vala"
								self->priv->_current_index = _tmp137_ + 1;
#line 2784 "PlaybackManager.c"
							}
						} else {
							gboolean _tmp138_ = FALSE;
							GSettings* _tmp139_;
							GSettings* _tmp140_;
#line 467 "../src/PlaybackManager.vala"
							_tmp139_ = music_app_get_settings ();
#line 467 "../src/PlaybackManager.vala"
							_tmp140_ = _tmp139_;
#line 467 "../src/PlaybackManager.vala"
							if (g_settings_get_enum (_tmp140_, "repeat-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALBUM)) {
#line 2796 "PlaybackManager.c"
								GeeHashMap* _tmp141_;
								gpointer _tmp142_;
								MusicMedia* _tmp143_;
								const gchar* _tmp144_;
								const gchar* _tmp145_;
								GeeHashMap* _tmp146_;
								gpointer _tmp147_;
								MusicMedia* _tmp148_;
								const gchar* _tmp149_;
								const gchar* _tmp150_;
#line 467 "../src/PlaybackManager.vala"
								_tmp141_ = self->priv->_current;
#line 467 "../src/PlaybackManager.vala"
								_tmp142_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp141_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
#line 467 "../src/PlaybackManager.vala"
								_tmp143_ = (MusicMedia*) _tmp142_;
#line 467 "../src/PlaybackManager.vala"
								_tmp144_ = music_media_get_album (_tmp143_);
#line 467 "../src/PlaybackManager.vala"
								_tmp145_ = _tmp144_;
#line 467 "../src/PlaybackManager.vala"
								_tmp146_ = self->priv->_current;
#line 467 "../src/PlaybackManager.vala"
								_tmp147_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp146_, (gpointer) ((gintptr) self->priv->_current_index));
#line 467 "../src/PlaybackManager.vala"
								_tmp148_ = (MusicMedia*) _tmp147_;
#line 467 "../src/PlaybackManager.vala"
								_tmp149_ = music_media_get_album (_tmp148_);
#line 467 "../src/PlaybackManager.vala"
								_tmp150_ = _tmp149_;
#line 467 "../src/PlaybackManager.vala"
								_tmp138_ = g_strcmp0 (_tmp145_, _tmp150_) != 0;
#line 467 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp148_);
#line 467 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp143_);
#line 2833 "PlaybackManager.c"
							} else {
#line 467 "../src/PlaybackManager.vala"
								_tmp138_ = FALSE;
#line 2837 "PlaybackManager.c"
							}
#line 467 "../src/PlaybackManager.vala"
							if (_tmp138_) {
#line 468 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 2843 "PlaybackManager.c"
									GeeHashMap* _tmp151_;
									gpointer _tmp152_;
									MusicMedia* _tmp153_;
									const gchar* _tmp154_;
									const gchar* _tmp155_;
									MusicMedia* _tmp156_;
									const gchar* _tmp157_;
									const gchar* _tmp158_;
									gboolean _tmp159_;
									gint _tmp160_;
#line 468 "../src/PlaybackManager.vala"
									_tmp151_ = self->priv->_current;
#line 468 "../src/PlaybackManager.vala"
									_tmp152_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp151_, (gpointer) ((gintptr) (self->priv->_current_index + 1)));
#line 468 "../src/PlaybackManager.vala"
									_tmp153_ = (MusicMedia*) _tmp152_;
#line 468 "../src/PlaybackManager.vala"
									_tmp154_ = music_media_get_album (_tmp153_);
#line 468 "../src/PlaybackManager.vala"
									_tmp155_ = _tmp154_;
#line 468 "../src/PlaybackManager.vala"
									_tmp156_ = self->priv->_current_media;
#line 468 "../src/PlaybackManager.vala"
									_tmp157_ = music_media_get_album (_tmp156_);
#line 468 "../src/PlaybackManager.vala"
									_tmp158_ = _tmp157_;
#line 468 "../src/PlaybackManager.vala"
									_tmp159_ = !(g_strcmp0 (_tmp155_, _tmp158_) == 0);
#line 468 "../src/PlaybackManager.vala"
									_g_object_unref0 (_tmp153_);
#line 468 "../src/PlaybackManager.vala"
									if (_tmp159_) {
#line 468 "../src/PlaybackManager.vala"
										break;
#line 2878 "PlaybackManager.c"
									}
#line 469 "../src/PlaybackManager.vala"
									_tmp160_ = self->priv->_current_index;
#line 469 "../src/PlaybackManager.vala"
									self->priv->_current_index = _tmp160_ + 1;
#line 2884 "PlaybackManager.c"
								}
							} else {
								gint _tmp161_;
#line 471 "../src/PlaybackManager.vala"
								_tmp161_ = self->priv->_current_index;
#line 471 "../src/PlaybackManager.vala"
								self->priv->_current_index = _tmp161_ - 1;
#line 2892 "PlaybackManager.c"
							}
						}
#line 474 "../src/PlaybackManager.vala"
						_tmp162_ = self->priv->_current;
#line 474 "../src/PlaybackManager.vala"
						_tmp163_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp162_, (gpointer) ((gintptr) self->priv->_current_index));
#line 474 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 474 "../src/PlaybackManager.vala"
						rv = (MusicMedia*) _tmp163_;
#line 2903 "PlaybackManager.c"
					} else {
						GeeHashMap* _tmp164_;
						gint _tmp165_;
						gint _tmp166_;
						GeeHashMap* _tmp167_;
						gpointer _tmp168_;
#line 476 "../src/PlaybackManager.vala"
						_tmp164_ = self->priv->_current;
#line 476 "../src/PlaybackManager.vala"
						_tmp165_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp164_);
#line 476 "../src/PlaybackManager.vala"
						_tmp166_ = _tmp165_;
#line 476 "../src/PlaybackManager.vala"
						self->priv->_current_index = _tmp166_ - 1;
#line 477 "../src/PlaybackManager.vala"
						_tmp167_ = self->priv->_current;
#line 477 "../src/PlaybackManager.vala"
						_tmp168_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp167_, (gpointer) ((gintptr) self->priv->_current_index));
#line 477 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 477 "../src/PlaybackManager.vala"
						rv = (MusicMedia*) _tmp168_;
#line 2926 "PlaybackManager.c"
					}
				}
			}
		}
	}
#line 481 "../src/PlaybackManager.vala"
	_tmp169_ = self->queue_playlist;
#line 481 "../src/PlaybackManager.vala"
	_tmp170_ = music_playlist_get_medias ((MusicPlaylist*) _tmp169_);
#line 481 "../src/PlaybackManager.vala"
	_tmp171_ = _tmp170_;
#line 481 "../src/PlaybackManager.vala"
	_tmp172_ = rv;
#line 481 "../src/PlaybackManager.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp171_, _tmp172_)) {
#line 482 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = TRUE;
#line 2944 "PlaybackManager.c"
	}
#line 485 "../src/PlaybackManager.vala"
	if (play) {
#line 2948 "PlaybackManager.c"
		MusicMedia* _tmp173_;
#line 486 "../src/PlaybackManager.vala"
		_tmp173_ = rv;
#line 486 "../src/PlaybackManager.vala"
		music_playback_manager_play_media (self, _tmp173_);
#line 2954 "PlaybackManager.c"
	}
#line 489 "../src/PlaybackManager.vala"
	result = rv;
#line 489 "../src/PlaybackManager.vala"
	return result;
#line 2960 "PlaybackManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 492 "../src/PlaybackManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 2968 "PlaybackManager.c"
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 492 "../src/PlaybackManager.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 492 "../src/PlaybackManager.vala"
	return _data11_;
#line 2978 "PlaybackManager.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 492 "../src/PlaybackManager.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 2988 "PlaybackManager.c"
		MusicPlaybackManager* self;
#line 492 "../src/PlaybackManager.vala"
		self = _data11_->self;
#line 492 "../src/PlaybackManager.vala"
		_g_object_unref0 (_data11_->m);
#line 492 "../src/PlaybackManager.vala"
		_g_object_unref0 (self);
#line 492 "../src/PlaybackManager.vala"
		g_slice_free (Block11Data, _data11_);
#line 2998 "PlaybackManager.c"
	}
}

static gboolean
__lambda31_ (Block11Data* _data11_)
{
	MusicPlaybackManager* self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 573 "../src/PlaybackManager.vala"
	self = _data11_->self;
#line 574 "../src/PlaybackManager.vala"
	if (_data11_->m != NULL) {
#line 3012 "PlaybackManager.c"
		MusicMedia* _tmp1_;
#line 574 "../src/PlaybackManager.vala"
		_tmp1_ = self->priv->_current_media;
#line 574 "../src/PlaybackManager.vala"
		_tmp0_ = _tmp1_ == _data11_->m;
#line 3018 "PlaybackManager.c"
	} else {
#line 574 "../src/PlaybackManager.vala"
		_tmp0_ = FALSE;
#line 3022 "PlaybackManager.c"
	}
#line 574 "../src/PlaybackManager.vala"
	if (_tmp0_) {
#line 3026 "PlaybackManager.c"
		MusicHistoryPlaylist* _tmp2_;
		guint player_duration_s = 0U;
		MusicPlayback* _tmp3_;
#line 575 "../src/PlaybackManager.vala"
		_tmp2_ = self->history_playlist;
#line 575 "../src/PlaybackManager.vala"
		music_playlist_add_media ((MusicPlaylist*) _tmp2_, _data11_->m);
#line 577 "../src/PlaybackManager.vala"
		_tmp3_ = self->player;
#line 577 "../src/PlaybackManager.vala"
		player_duration_s = (guint) (music_playback_get_duration (_tmp3_) / MUSIC_TIME_UTILS_NANO_INV);
#line 578 "../src/PlaybackManager.vala"
		if (player_duration_s > ((guint) 1)) {
#line 3040 "PlaybackManager.c"
			gint delta_s = 0;
			guint _tmp4_;
			guint _tmp5_;
#line 579 "../src/PlaybackManager.vala"
			_tmp4_ = music_media_get_length (_data11_->m);
#line 579 "../src/PlaybackManager.vala"
			_tmp5_ = _tmp4_;
#line 579 "../src/PlaybackManager.vala"
			delta_s = ((gint) player_duration_s) - ((gint) (_tmp5_ / MUSIC_TIME_UTILS_MILI_INV));
#line 580 "../src/PlaybackManager.vala"
			if (fabs ((gdouble) delta_s) > ((gdouble) 3)) {
#line 3052 "PlaybackManager.c"
				MusicLibrary* _tmp6_;
				MusicLibrary* _tmp7_;
#line 581 "../src/PlaybackManager.vala"
				music_media_set_length (_data11_->m, (guint) (player_duration_s * MUSIC_TIME_UTILS_MILI_INV));
#line 582 "../src/PlaybackManager.vala"
				_tmp6_ = music_playback_manager_get_library (self);
#line 582 "../src/PlaybackManager.vala"
				_tmp7_ = _tmp6_;
#line 582 "../src/PlaybackManager.vala"
				music_library_update_media (_tmp7_, _data11_->m, FALSE, FALSE);
#line 3063 "PlaybackManager.c"
			}
		}
	}
#line 587 "../src/PlaybackManager.vala"
	result = FALSE;
#line 587 "../src/PlaybackManager.vala"
	return result;
#line 3071 "PlaybackManager.c"
}

static gboolean
___lambda31__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda31_ (self);
#line 573 "../src/PlaybackManager.vala"
	return result;
#line 3081 "PlaybackManager.c"
}

void
music_playback_manager_play_media (MusicPlaybackManager* self,
                                   MusicMedia* m)
{
	Block11Data* _data11_;
	MusicMedia* _tmp0_;
	gint64 old_id = 0LL;
	MusicMedia* _tmp1_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean found = FALSE;
	GFile* _tmp41_;
	GFile* _tmp42_;
	MusicPlayback* _tmp52_;
	gboolean _tmp53_;
	gboolean _tmp55_ = FALSE;
	gint64 _tmp56_;
	gint64 _tmp57_;
	GError* _inner_error0_ = NULL;
#line 492 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 492 "../src/PlaybackManager.vala"
	g_return_if_fail (m != NULL);
#line 492 "../src/PlaybackManager.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 492 "../src/PlaybackManager.vala"
	_data11_->_ref_count_ = 1;
#line 492 "../src/PlaybackManager.vala"
	_data11_->self = g_object_ref (self);
#line 492 "../src/PlaybackManager.vala"
	_tmp0_ = _g_object_ref0 (m);
#line 492 "../src/PlaybackManager.vala"
	_g_object_unref0 (_data11_->m);
#line 492 "../src/PlaybackManager.vala"
	_data11_->m = _tmp0_;
#line 493 "../src/PlaybackManager.vala"
	old_id = (gint64) -1;
#line 496 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current_media;
#line 496 "../src/PlaybackManager.vala"
	if (_tmp1_ != NULL) {
#line 3125 "PlaybackManager.c"
		MusicMedia* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
#line 497 "../src/PlaybackManager.vala"
		_tmp2_ = self->priv->_current_media;
#line 497 "../src/PlaybackManager.vala"
		_tmp3_ = music_media_get_rowid (_tmp2_);
#line 497 "../src/PlaybackManager.vala"
		_tmp4_ = _tmp3_;
#line 497 "../src/PlaybackManager.vala"
		old_id = _tmp4_;
#line 3137 "PlaybackManager.c"
	}
#line 499 "../src/PlaybackManager.vala"
	music_playback_manager_set_current_media (self, _data11_->m);
#line 503 "../src/PlaybackManager.vala"
	_tmp5_ = music_media_get_location_unknown (_data11_->m);
#line 503 "../src/PlaybackManager.vala"
	_tmp6_ = _tmp5_;
#line 503 "../src/PlaybackManager.vala"
	if (_tmp6_) {
#line 3147 "PlaybackManager.c"
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		gboolean _tmp12_;
#line 504 "../src/PlaybackManager.vala"
		_tmp7_ = music_media_get_uri (_data11_->m);
#line 504 "../src/PlaybackManager.vala"
		_tmp8_ = _tmp7_;
#line 504 "../src/PlaybackManager.vala"
		_tmp9_ = _tmp8_;
#line 504 "../src/PlaybackManager.vala"
		_tmp10_ = g_file_new_for_uri (_tmp9_);
#line 504 "../src/PlaybackManager.vala"
		_tmp11_ = _tmp10_;
#line 504 "../src/PlaybackManager.vala"
		_tmp12_ = g_file_query_exists (_tmp11_, NULL);
#line 504 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp11_);
#line 504 "../src/PlaybackManager.vala"
		_g_free0 (_tmp9_);
#line 504 "../src/PlaybackManager.vala"
		if (_tmp12_) {
#line 505 "../src/PlaybackManager.vala"
			music_media_set_location_unknown (_data11_->m, FALSE);
#line 506 "../src/PlaybackManager.vala"
			music_media_set_unique_status_image (_data11_->m, NULL);
#line 3176 "PlaybackManager.c"
		} else {
#line 509 "../src/PlaybackManager.vala"
			music_playback_manager_stop_playback (self);
#line 510 "../src/PlaybackManager.vala"
			block11_data_unref (_data11_);
#line 510 "../src/PlaybackManager.vala"
			_data11_ = NULL;
#line 510 "../src/PlaybackManager.vala"
			return;
#line 3186 "PlaybackManager.c"
		}
	}
#line 514 "../src/PlaybackManager.vala"
	found = FALSE;
#line 3191 "PlaybackManager.c"
	{
		GeeTreeSet* _tmp13_;
#line 515 "../src/PlaybackManager.vala"
		_tmp13_ = self->priv->playbacks;
#line 515 "../src/PlaybackManager.vala"
		g_rec_mutex_lock (&self->priv->__lock_playbacks);
#line 3198 "PlaybackManager.c"
		{
			{
				GeeIterator* _playback_it = NULL;
				GeeTreeSet* _tmp14_;
				GeeIterator* _tmp15_;
#line 516 "../src/PlaybackManager.vala"
				_tmp14_ = self->priv->playbacks;
#line 516 "../src/PlaybackManager.vala"
				_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp14_);
#line 516 "../src/PlaybackManager.vala"
				_playback_it = _tmp15_;
#line 516 "../src/PlaybackManager.vala"
				while (TRUE) {
#line 3212 "PlaybackManager.c"
					GeeIterator* _tmp16_;
					MusicPlayback* playback = NULL;
					GeeIterator* _tmp17_;
					gpointer _tmp18_;
#line 516 "../src/PlaybackManager.vala"
					_tmp16_ = _playback_it;
#line 516 "../src/PlaybackManager.vala"
					if (!gee_iterator_next (_tmp16_)) {
#line 516 "../src/PlaybackManager.vala"
						break;
#line 3223 "PlaybackManager.c"
					}
#line 516 "../src/PlaybackManager.vala"
					_tmp17_ = _playback_it;
#line 516 "../src/PlaybackManager.vala"
					_tmp18_ = gee_iterator_get (_tmp17_);
#line 516 "../src/PlaybackManager.vala"
					playback = (MusicPlayback*) _tmp18_;
#line 3231 "PlaybackManager.c"
					{
						GeeIterator* _supported_uri_it = NULL;
						MusicPlayback* _tmp19_;
						GeeCollection* _tmp20_;
						GeeCollection* _tmp21_;
						GeeIterator* _tmp22_;
						GeeIterator* _tmp23_;
#line 517 "../src/PlaybackManager.vala"
						_tmp19_ = playback;
#line 517 "../src/PlaybackManager.vala"
						_tmp20_ = music_playback_get_supported_uri (_tmp19_);
#line 517 "../src/PlaybackManager.vala"
						_tmp21_ = _tmp20_;
#line 517 "../src/PlaybackManager.vala"
						_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
#line 517 "../src/PlaybackManager.vala"
						_tmp23_ = _tmp22_;
#line 517 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp21_);
#line 517 "../src/PlaybackManager.vala"
						_supported_uri_it = _tmp23_;
#line 517 "../src/PlaybackManager.vala"
						while (TRUE) {
#line 3255 "PlaybackManager.c"
							GeeIterator* _tmp24_;
							gchar* supported_uri = NULL;
							GeeIterator* _tmp25_;
							gpointer _tmp26_;
							gchar* _tmp27_;
							gchar* _tmp28_;
							gchar* _tmp29_;
							const gchar* _tmp30_;
							gboolean _tmp31_;
#line 517 "../src/PlaybackManager.vala"
							_tmp24_ = _supported_uri_it;
#line 517 "../src/PlaybackManager.vala"
							if (!gee_iterator_next (_tmp24_)) {
#line 517 "../src/PlaybackManager.vala"
								break;
#line 3271 "PlaybackManager.c"
							}
#line 517 "../src/PlaybackManager.vala"
							_tmp25_ = _supported_uri_it;
#line 517 "../src/PlaybackManager.vala"
							_tmp26_ = gee_iterator_get (_tmp25_);
#line 517 "../src/PlaybackManager.vala"
							supported_uri = (gchar*) _tmp26_;
#line 518 "../src/PlaybackManager.vala"
							_tmp27_ = music_media_get_uri (_data11_->m);
#line 518 "../src/PlaybackManager.vala"
							_tmp28_ = _tmp27_;
#line 518 "../src/PlaybackManager.vala"
							_tmp29_ = _tmp28_;
#line 518 "../src/PlaybackManager.vala"
							_tmp30_ = supported_uri;
#line 518 "../src/PlaybackManager.vala"
							_tmp31_ = g_str_has_prefix (_tmp29_, _tmp30_);
#line 518 "../src/PlaybackManager.vala"
							_g_free0 (_tmp29_);
#line 518 "../src/PlaybackManager.vala"
							if (_tmp31_) {
#line 3293 "PlaybackManager.c"
								MusicPlayback* _tmp32_;
								MusicPlayback* _tmp33_;
								MusicPlayback* _tmp34_;
								MusicPlayback* _tmp35_;
#line 519 "../src/PlaybackManager.vala"
								_tmp32_ = self->player;
#line 519 "../src/PlaybackManager.vala"
								self->priv->saved_volume = music_playback_get_volume (_tmp32_);
#line 520 "../src/PlaybackManager.vala"
								g_signal_emit (self, music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL], 0);
#line 521 "../src/PlaybackManager.vala"
								_tmp33_ = self->player;
#line 521 "../src/PlaybackManager.vala"
								music_playback_set_state (_tmp33_, GST_STATE_NULL);
#line 522 "../src/PlaybackManager.vala"
								found = TRUE;
#line 523 "../src/PlaybackManager.vala"
								_tmp34_ = playback;
#line 523 "../src/PlaybackManager.vala"
								_tmp35_ = _g_object_ref0 (_tmp34_);
#line 523 "../src/PlaybackManager.vala"
								_g_object_unref0 (self->player);
#line 523 "../src/PlaybackManager.vala"
								self->player = _tmp35_;
#line 524 "../src/PlaybackManager.vala"
								music_playback_manager_set_volume (self, self->priv->saved_volume);
#line 525 "../src/PlaybackManager.vala"
								g_signal_emit (self, music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL], 0);
#line 526 "../src/PlaybackManager.vala"
								_g_free0 (supported_uri);
#line 526 "../src/PlaybackManager.vala"
								break;
#line 3326 "PlaybackManager.c"
							}
#line 517 "../src/PlaybackManager.vala"
							_g_free0 (supported_uri);
#line 3330 "PlaybackManager.c"
						}
#line 517 "../src/PlaybackManager.vala"
						_g_object_unref0 (_supported_uri_it);
#line 3334 "PlaybackManager.c"
					}
#line 529 "../src/PlaybackManager.vala"
					if (found == TRUE) {
#line 530 "../src/PlaybackManager.vala"
						break;
#line 3340 "PlaybackManager.c"
					}
				}
#line 516 "../src/PlaybackManager.vala"
				_g_object_unref0 (_playback_it);
#line 3345 "PlaybackManager.c"
			}
		}
		__finally0:
		{
			GeeTreeSet* _tmp36_;
#line 515 "../src/PlaybackManager.vala"
			_tmp36_ = self->priv->playbacks;
#line 515 "../src/PlaybackManager.vala"
			g_rec_mutex_unlock (&self->priv->__lock_playbacks);
#line 3355 "PlaybackManager.c"
		}
#line 515 "../src/PlaybackManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 515 "../src/PlaybackManager.vala"
			block11_data_unref (_data11_);
#line 515 "../src/PlaybackManager.vala"
			_data11_ = NULL;
#line 515 "../src/PlaybackManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 515 "../src/PlaybackManager.vala"
			g_clear_error (&_inner_error0_);
#line 515 "../src/PlaybackManager.vala"
			return;
#line 3369 "PlaybackManager.c"
		}
	}
#line 534 "../src/PlaybackManager.vala"
	if (!found) {
#line 3374 "PlaybackManager.c"
		GThemedIcon* _tmp37_;
		GThemedIcon* _tmp38_;
		MusicMedia* _tmp39_;
		MusicMedia* _tmp40_;
#line 535 "../src/PlaybackManager.vala"
		_tmp37_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
#line 535 "../src/PlaybackManager.vala"
		_tmp38_ = _tmp37_;
#line 535 "../src/PlaybackManager.vala"
		music_media_set_unique_status_image (_data11_->m, (GIcon*) _tmp38_);
#line 535 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp38_);
#line 536 "../src/PlaybackManager.vala"
		_tmp39_ = music_playback_manager_get_next (self, TRUE);
#line 536 "../src/PlaybackManager.vala"
		_tmp40_ = _tmp39_;
#line 536 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp40_);
#line 537 "../src/PlaybackManager.vala"
		block11_data_unref (_data11_);
#line 537 "../src/PlaybackManager.vala"
		_data11_ = NULL;
#line 537 "../src/PlaybackManager.vala"
		return;
#line 3399 "PlaybackManager.c"
	}
#line 541 "../src/PlaybackManager.vala"
	_tmp41_ = music_media_get_file (_data11_->m);
#line 541 "../src/PlaybackManager.vala"
	_tmp42_ = _tmp41_;
#line 541 "../src/PlaybackManager.vala"
	if (!g_file_query_exists (_tmp42_, NULL)) {
#line 3407 "PlaybackManager.c"
		GThemedIcon* _tmp43_;
		GThemedIcon* _tmp44_;
		MusicMedia* _tmp45_;
		MusicMedia* _tmp46_;
#line 542 "../src/PlaybackManager.vala"
		_tmp43_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
#line 542 "../src/PlaybackManager.vala"
		_tmp44_ = _tmp43_;
#line 542 "../src/PlaybackManager.vala"
		music_media_set_unique_status_image (_data11_->m, (GIcon*) _tmp44_);
#line 542 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp44_);
#line 543 "../src/PlaybackManager.vala"
		music_media_set_location_unknown (_data11_->m, TRUE);
#line 545 "../src/PlaybackManager.vala"
		_tmp45_ = music_playback_manager_get_next (self, TRUE);
#line 545 "../src/PlaybackManager.vala"
		_tmp46_ = _tmp45_;
#line 545 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp46_);
#line 546 "../src/PlaybackManager.vala"
		block11_data_unref (_data11_);
#line 546 "../src/PlaybackManager.vala"
		_data11_ = NULL;
#line 546 "../src/PlaybackManager.vala"
		return;
#line 3434 "PlaybackManager.c"
	} else {
		gboolean _tmp47_ = FALSE;
		gboolean _tmp48_;
		gboolean _tmp49_;
#line 548 "../src/PlaybackManager.vala"
		_tmp48_ = music_media_get_location_unknown (_data11_->m);
#line 548 "../src/PlaybackManager.vala"
		_tmp49_ = _tmp48_;
#line 548 "../src/PlaybackManager.vala"
		if (_tmp49_) {
#line 3445 "PlaybackManager.c"
			GIcon* _tmp50_;
			GIcon* _tmp51_;
#line 548 "../src/PlaybackManager.vala"
			_tmp50_ = music_media_get_unique_status_image (_data11_->m);
#line 548 "../src/PlaybackManager.vala"
			_tmp51_ = _tmp50_;
#line 548 "../src/PlaybackManager.vala"
			_tmp47_ = _tmp51_ != NULL;
#line 3454 "PlaybackManager.c"
		} else {
#line 548 "../src/PlaybackManager.vala"
			_tmp47_ = FALSE;
#line 3458 "PlaybackManager.c"
		}
#line 548 "../src/PlaybackManager.vala"
		if (_tmp47_) {
#line 549 "../src/PlaybackManager.vala"
			music_media_set_unique_status_image (_data11_->m, NULL);
#line 550 "../src/PlaybackManager.vala"
			music_media_set_location_unknown (_data11_->m, FALSE);
#line 3466 "PlaybackManager.c"
		}
	}
#line 554 "../src/PlaybackManager.vala"
	music_playback_manager_change_gains_thread (self);
#line 556 "../src/PlaybackManager.vala"
	_tmp52_ = self->player;
#line 556 "../src/PlaybackManager.vala"
	music_playback_set_media (_tmp52_, _data11_->m);
#line 559 "../src/PlaybackManager.vala"
	_tmp53_ = self->priv->_playing;
#line 559 "../src/PlaybackManager.vala"
	if (!_tmp53_) {
#line 3479 "PlaybackManager.c"
		MusicPlayback* _tmp54_;
#line 560 "../src/PlaybackManager.vala"
		_tmp54_ = self->player;
#line 560 "../src/PlaybackManager.vala"
		music_playback_pause (_tmp54_);
#line 3485 "PlaybackManager.c"
	}
#line 564 "../src/PlaybackManager.vala"
	_tmp56_ = music_media_get_rowid (_data11_->m);
#line 564 "../src/PlaybackManager.vala"
	_tmp57_ = _tmp56_;
#line 564 "../src/PlaybackManager.vala"
	if (_tmp57_ >= ((gint64) 0)) {
#line 3493 "PlaybackManager.c"
		MusicSettingsMain* _tmp58_;
		MusicSettingsMain* _tmp59_;
#line 564 "../src/PlaybackManager.vala"
		_tmp58_ = music_settings_main_get_default ();
#line 564 "../src/PlaybackManager.vala"
		_tmp59_ = _tmp58_;
#line 564 "../src/PlaybackManager.vala"
		_tmp55_ = !music_settings_main_privacy_mode_enabled (_tmp59_);
#line 564 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp59_);
#line 3504 "PlaybackManager.c"
	} else {
#line 564 "../src/PlaybackManager.vala"
		_tmp55_ = FALSE;
#line 3508 "PlaybackManager.c"
	}
#line 564 "../src/PlaybackManager.vala"
	if (_tmp55_) {
#line 3512 "PlaybackManager.c"
		GSettings* _tmp60_;
		GSettings* _tmp61_;
		gint64 _tmp62_;
		gint64 _tmp63_;
#line 565 "../src/PlaybackManager.vala"
		_tmp60_ = music_app_get_saved_state ();
#line 565 "../src/PlaybackManager.vala"
		_tmp61_ = _tmp60_;
#line 565 "../src/PlaybackManager.vala"
		_tmp62_ = music_media_get_rowid (_data11_->m);
#line 565 "../src/PlaybackManager.vala"
		_tmp63_ = _tmp62_;
#line 565 "../src/PlaybackManager.vala"
		g_settings_set_int64 (_tmp61_, "last-media-playing", _tmp63_);
#line 3527 "PlaybackManager.c"
	}
#line 568 "../src/PlaybackManager.vala"
	if (_data11_->m != NULL) {
#line 569 "../src/PlaybackManager.vala"
		g_signal_emit (self, music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL], 0, _data11_->m);
#line 3533 "PlaybackManager.c"
	}
#line 573 "../src/PlaybackManager.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, ___lambda31__gsource_func, block11_data_ref (_data11_), block11_data_unref);
#line 492 "../src/PlaybackManager.vala"
	block11_data_unref (_data11_);
#line 492 "../src/PlaybackManager.vala"
	_data11_ = NULL;
#line 3541 "PlaybackManager.c"
}

void
music_playback_manager_change_gains_thread (MusicPlaybackManager* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 591 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 592 "../src/PlaybackManager.vala"
	_tmp0_ = music_app_get_equalizer_settings ();
#line 592 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 592 "../src/PlaybackManager.vala"
	if (g_settings_get_boolean (_tmp1_, "equalizer-enabled")) {
#line 3557 "PlaybackManager.c"
		gchar** custom_presets = NULL;
		GSettings* _tmp2_;
		GSettings* _tmp3_;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gint custom_presets_length1;
		gint _custom_presets_size_;
		gchar** _tmp6_;
		gint _tmp6__length1;
#line 593 "../src/PlaybackManager.vala"
		_tmp2_ = music_app_get_equalizer_settings ();
#line 593 "../src/PlaybackManager.vala"
		_tmp3_ = _tmp2_;
#line 593 "../src/PlaybackManager.vala"
		_tmp5_ = _tmp4_ = g_settings_get_strv (_tmp3_, "custom-presets");
#line 593 "../src/PlaybackManager.vala"
		custom_presets = _tmp5_;
#line 593 "../src/PlaybackManager.vala"
		custom_presets_length1 = _vala_array_length (_tmp4_);
#line 593 "../src/PlaybackManager.vala"
		_custom_presets_size_ = custom_presets_length1;
#line 594 "../src/PlaybackManager.vala"
		_tmp6_ = custom_presets;
#line 594 "../src/PlaybackManager.vala"
		_tmp6__length1 = custom_presets_length1;
#line 594 "../src/PlaybackManager.vala"
		if (_tmp6_ != NULL) {
#line 3585 "PlaybackManager.c"
			{
				gint i = 0;
#line 595 "../src/PlaybackManager.vala"
				i = 0;
#line 3590 "PlaybackManager.c"
				{
					gboolean _tmp7_ = FALSE;
#line 595 "../src/PlaybackManager.vala"
					_tmp7_ = TRUE;
#line 595 "../src/PlaybackManager.vala"
					while (TRUE) {
#line 3597 "PlaybackManager.c"
						gchar** _tmp9_;
						gint _tmp9__length1;
						MusicEqualizerPreset* preset = NULL;
						gchar** _tmp10_;
						gint _tmp10__length1;
						const gchar* _tmp11_;
						MusicEqualizerPreset* _tmp12_;
						MusicEqualizerPreset* _tmp13_;
#line 595 "../src/PlaybackManager.vala"
						if (!_tmp7_) {
#line 3608 "PlaybackManager.c"
							gint _tmp8_;
#line 595 "../src/PlaybackManager.vala"
							_tmp8_ = i;
#line 595 "../src/PlaybackManager.vala"
							i = _tmp8_ + 1;
#line 3614 "PlaybackManager.c"
						}
#line 595 "../src/PlaybackManager.vala"
						_tmp7_ = FALSE;
#line 595 "../src/PlaybackManager.vala"
						_tmp9_ = custom_presets;
#line 595 "../src/PlaybackManager.vala"
						_tmp9__length1 = custom_presets_length1;
#line 595 "../src/PlaybackManager.vala"
						if (!(i < _tmp9__length1)) {
#line 595 "../src/PlaybackManager.vala"
							break;
#line 3626 "PlaybackManager.c"
						}
#line 596 "../src/PlaybackManager.vala"
						_tmp10_ = custom_presets;
#line 596 "../src/PlaybackManager.vala"
						_tmp10__length1 = custom_presets_length1;
#line 596 "../src/PlaybackManager.vala"
						_tmp11_ = _tmp10_[i];
#line 596 "../src/PlaybackManager.vala"
						_tmp12_ = music_equalizer_preset_new_from_string (_tmp11_);
#line 596 "../src/PlaybackManager.vala"
						preset = _tmp12_;
#line 597 "../src/PlaybackManager.vala"
						_tmp13_ = preset;
#line 597 "../src/PlaybackManager.vala"
						if (music_playback_manager_auto_genre_eq (self, _tmp13_)) {
#line 598 "../src/PlaybackManager.vala"
							_g_object_unref0 (preset);
#line 598 "../src/PlaybackManager.vala"
							custom_presets = (_vala_array_free (custom_presets, custom_presets_length1, (GDestroyNotify) g_free), NULL);
#line 598 "../src/PlaybackManager.vala"
							return;
#line 3648 "PlaybackManager.c"
						}
#line 595 "../src/PlaybackManager.vala"
						_g_object_unref0 (preset);
#line 3652 "PlaybackManager.c"
					}
				}
			}
		}
		{
			GeeIterator* _preset_it = NULL;
			GeeCollection* _tmp14_;
			GeeCollection* _tmp15_;
			GeeIterator* _tmp16_;
			GeeIterator* _tmp17_;
#line 603 "../src/PlaybackManager.vala"
			_tmp14_ = music_equalizer_get_default_presets ();
#line 603 "../src/PlaybackManager.vala"
			_tmp15_ = _tmp14_;
#line 603 "../src/PlaybackManager.vala"
			_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
#line 603 "../src/PlaybackManager.vala"
			_tmp17_ = _tmp16_;
#line 603 "../src/PlaybackManager.vala"
			_g_object_unref0 (_tmp15_);
#line 603 "../src/PlaybackManager.vala"
			_preset_it = _tmp17_;
#line 603 "../src/PlaybackManager.vala"
			while (TRUE) {
#line 3677 "PlaybackManager.c"
				GeeIterator* _tmp18_;
				MusicEqualizerPreset* preset = NULL;
				GeeIterator* _tmp19_;
				gpointer _tmp20_;
				MusicEqualizerPreset* _tmp21_;
#line 603 "../src/PlaybackManager.vala"
				_tmp18_ = _preset_it;
#line 603 "../src/PlaybackManager.vala"
				if (!gee_iterator_next (_tmp18_)) {
#line 603 "../src/PlaybackManager.vala"
					break;
#line 3689 "PlaybackManager.c"
				}
#line 603 "../src/PlaybackManager.vala"
				_tmp19_ = _preset_it;
#line 603 "../src/PlaybackManager.vala"
				_tmp20_ = gee_iterator_get (_tmp19_);
#line 603 "../src/PlaybackManager.vala"
				preset = (MusicEqualizerPreset*) _tmp20_;
#line 604 "../src/PlaybackManager.vala"
				_tmp21_ = preset;
#line 604 "../src/PlaybackManager.vala"
				if (music_playback_manager_auto_genre_eq (self, _tmp21_)) {
#line 605 "../src/PlaybackManager.vala"
					_g_object_unref0 (preset);
#line 605 "../src/PlaybackManager.vala"
					_g_object_unref0 (_preset_it);
#line 605 "../src/PlaybackManager.vala"
					custom_presets = (_vala_array_free (custom_presets, custom_presets_length1, (GDestroyNotify) g_free), NULL);
#line 605 "../src/PlaybackManager.vala"
					return;
#line 3709 "PlaybackManager.c"
				}
#line 603 "../src/PlaybackManager.vala"
				_g_object_unref0 (preset);
#line 3713 "PlaybackManager.c"
			}
#line 603 "../src/PlaybackManager.vala"
			_g_object_unref0 (_preset_it);
#line 3717 "PlaybackManager.c"
		}
#line 592 "../src/PlaybackManager.vala"
		custom_presets = (_vala_array_free (custom_presets, custom_presets_length1, (GDestroyNotify) g_free), NULL);
#line 3721 "PlaybackManager.c"
	}
	{
		gint i = 0;
#line 610 "../src/PlaybackManager.vala"
		i = 0;
#line 3727 "PlaybackManager.c"
		{
			gboolean _tmp22_ = FALSE;
#line 610 "../src/PlaybackManager.vala"
			_tmp22_ = TRUE;
#line 610 "../src/PlaybackManager.vala"
			while (TRUE) {
#line 3734 "PlaybackManager.c"
				MusicPlayback* _tmp24_;
#line 610 "../src/PlaybackManager.vala"
				if (!_tmp22_) {
#line 3738 "PlaybackManager.c"
					gint _tmp23_;
#line 610 "../src/PlaybackManager.vala"
					i = i + 1;
#line 610 "../src/PlaybackManager.vala"
					_tmp23_ = i;
#line 3744 "PlaybackManager.c"
				}
#line 610 "../src/PlaybackManager.vala"
				_tmp22_ = FALSE;
#line 610 "../src/PlaybackManager.vala"
				if (!(i < 10)) {
#line 610 "../src/PlaybackManager.vala"
					break;
#line 3752 "PlaybackManager.c"
				}
#line 611 "../src/PlaybackManager.vala"
				_tmp24_ = self->player;
#line 611 "../src/PlaybackManager.vala"
				music_playback_set_equalizer_gain (_tmp24_, i, 0);
#line 3758 "PlaybackManager.c"
			}
		}
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 3780 "PlaybackManager.c"
}

static gboolean
music_playback_manager_auto_genre_eq (MusicPlaybackManager* self,
                                      MusicEqualizerPreset* preset)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 615 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 615 "../src/PlaybackManager.vala"
	g_return_val_if_fail (preset != NULL, FALSE);
#line 616 "../src/PlaybackManager.vala"
	if (preset != NULL) {
#line 3795 "PlaybackManager.c"
		MusicMedia* _tmp1_;
#line 616 "../src/PlaybackManager.vala"
		_tmp1_ = self->priv->_current_media;
#line 616 "../src/PlaybackManager.vala"
		_tmp0_ = _tmp1_ != NULL;
#line 3801 "PlaybackManager.c"
	} else {
#line 616 "../src/PlaybackManager.vala"
		_tmp0_ = FALSE;
#line 3805 "PlaybackManager.c"
	}
#line 616 "../src/PlaybackManager.vala"
	if (_tmp0_) {
#line 3809 "PlaybackManager.c"
		gchar* preset_name = NULL;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* media_genre = NULL;
		MusicMedia* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gboolean _tmp9_ = FALSE;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gboolean match_genre = FALSE;
		gboolean automatic_enabled = FALSE;
		GSettings* _tmp14_;
		GSettings* _tmp15_;
		gchar* selected_preset = NULL;
		GSettings* _tmp16_;
		GSettings* _tmp17_;
		gchar* _tmp18_;
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
#line 617 "../src/PlaybackManager.vala"
		_tmp2_ = music_equalizer_preset_get_name (preset);
#line 617 "../src/PlaybackManager.vala"
		_tmp3_ = _tmp2_;
#line 617 "../src/PlaybackManager.vala"
		_tmp4_ = g_utf8_strdown (_tmp3_, (gssize) -1);
#line 617 "../src/PlaybackManager.vala"
		preset_name = _tmp4_;
#line 618 "../src/PlaybackManager.vala"
		_tmp5_ = self->priv->_current_media;
#line 618 "../src/PlaybackManager.vala"
		_tmp6_ = music_media_get_genre (_tmp5_);
#line 618 "../src/PlaybackManager.vala"
		_tmp7_ = _tmp6_;
#line 618 "../src/PlaybackManager.vala"
		_tmp8_ = g_utf8_strdown (_tmp7_, (gssize) -1);
#line 618 "../src/PlaybackManager.vala"
		media_genre = _tmp8_;
#line 620 "../src/PlaybackManager.vala"
		_tmp10_ = media_genre;
#line 620 "../src/PlaybackManager.vala"
		_tmp11_ = preset_name;
#line 620 "../src/PlaybackManager.vala"
		if (string_contains (_tmp10_, _tmp11_)) {
#line 620 "../src/PlaybackManager.vala"
			_tmp9_ = TRUE;
#line 3858 "PlaybackManager.c"
		} else {
			const gchar* _tmp12_;
			const gchar* _tmp13_;
#line 620 "../src/PlaybackManager.vala"
			_tmp12_ = preset_name;
#line 620 "../src/PlaybackManager.vala"
			_tmp13_ = media_genre;
#line 620 "../src/PlaybackManager.vala"
			_tmp9_ = string_contains (_tmp12_, _tmp13_);
#line 3868 "PlaybackManager.c"
		}
#line 620 "../src/PlaybackManager.vala"
		match_genre = _tmp9_;
#line 622 "../src/PlaybackManager.vala"
		_tmp14_ = music_app_get_equalizer_settings ();
#line 622 "../src/PlaybackManager.vala"
		_tmp15_ = _tmp14_;
#line 622 "../src/PlaybackManager.vala"
		automatic_enabled = g_settings_get_boolean (_tmp15_, "auto-switch-preset");
#line 623 "../src/PlaybackManager.vala"
		_tmp16_ = music_app_get_equalizer_settings ();
#line 623 "../src/PlaybackManager.vala"
		_tmp17_ = _tmp16_;
#line 623 "../src/PlaybackManager.vala"
		_tmp18_ = g_settings_get_string (_tmp17_, "selected-preset");
#line 623 "../src/PlaybackManager.vala"
		selected_preset = _tmp18_;
#line 624 "../src/PlaybackManager.vala"
		if (automatic_enabled) {
#line 624 "../src/PlaybackManager.vala"
			_tmp20_ = match_genre;
#line 3890 "PlaybackManager.c"
		} else {
#line 624 "../src/PlaybackManager.vala"
			_tmp20_ = FALSE;
#line 3894 "PlaybackManager.c"
		}
#line 624 "../src/PlaybackManager.vala"
		if (_tmp20_) {
#line 624 "../src/PlaybackManager.vala"
			_tmp19_ = TRUE;
#line 3900 "PlaybackManager.c"
		} else {
			gboolean _tmp21_ = FALSE;
#line 625 "../src/PlaybackManager.vala"
			if (!automatic_enabled) {
#line 3905 "PlaybackManager.c"
				const gchar* _tmp22_;
				const gchar* _tmp23_;
				const gchar* _tmp24_;
#line 625 "../src/PlaybackManager.vala"
				_tmp22_ = music_equalizer_preset_get_name (preset);
#line 625 "../src/PlaybackManager.vala"
				_tmp23_ = _tmp22_;
#line 625 "../src/PlaybackManager.vala"
				_tmp24_ = selected_preset;
#line 625 "../src/PlaybackManager.vala"
				_tmp21_ = g_strcmp0 (_tmp23_, _tmp24_) == 0;
#line 3917 "PlaybackManager.c"
			} else {
#line 625 "../src/PlaybackManager.vala"
				_tmp21_ = FALSE;
#line 3921 "PlaybackManager.c"
			}
#line 625 "../src/PlaybackManager.vala"
			_tmp19_ = _tmp21_;
#line 3925 "PlaybackManager.c"
		}
#line 624 "../src/PlaybackManager.vala"
		if (_tmp19_) {
#line 3929 "PlaybackManager.c"
			{
				gint i = 0;
#line 626 "../src/PlaybackManager.vala"
				i = 0;
#line 3934 "PlaybackManager.c"
				{
					gboolean _tmp25_ = FALSE;
#line 626 "../src/PlaybackManager.vala"
					_tmp25_ = TRUE;
#line 626 "../src/PlaybackManager.vala"
					while (TRUE) {
#line 3941 "PlaybackManager.c"
						MusicPlayback* _tmp27_;
#line 626 "../src/PlaybackManager.vala"
						if (!_tmp25_) {
#line 3945 "PlaybackManager.c"
							gint _tmp26_;
#line 626 "../src/PlaybackManager.vala"
							_tmp26_ = i;
#line 626 "../src/PlaybackManager.vala"
							i = _tmp26_ + 1;
#line 3951 "PlaybackManager.c"
						}
#line 626 "../src/PlaybackManager.vala"
						_tmp25_ = FALSE;
#line 626 "../src/PlaybackManager.vala"
						if (!(i < 10)) {
#line 626 "../src/PlaybackManager.vala"
							break;
#line 3959 "PlaybackManager.c"
						}
#line 627 "../src/PlaybackManager.vala"
						_tmp27_ = self->player;
#line 627 "../src/PlaybackManager.vala"
						music_playback_set_equalizer_gain (_tmp27_, i, music_equalizer_preset_get_gain (preset, i));
#line 3965 "PlaybackManager.c"
					}
				}
			}
#line 630 "../src/PlaybackManager.vala"
			result = TRUE;
#line 630 "../src/PlaybackManager.vala"
			_g_free0 (selected_preset);
#line 630 "../src/PlaybackManager.vala"
			_g_free0 (media_genre);
#line 630 "../src/PlaybackManager.vala"
			_g_free0 (preset_name);
#line 630 "../src/PlaybackManager.vala"
			return result;
#line 3979 "PlaybackManager.c"
		}
#line 616 "../src/PlaybackManager.vala"
		_g_free0 (selected_preset);
#line 616 "../src/PlaybackManager.vala"
		_g_free0 (media_genre);
#line 616 "../src/PlaybackManager.vala"
		_g_free0 (preset_name);
#line 3987 "PlaybackManager.c"
	}
#line 634 "../src/PlaybackManager.vala"
	result = FALSE;
#line 634 "../src/PlaybackManager.vala"
	return result;
#line 3993 "PlaybackManager.c"
}

void
music_playback_manager_stop_playback (MusicPlaybackManager* self)
{
	MusicPlayback* _tmp0_;
	gint64 was_playing = 0LL;
	MusicMedia* _tmp1_;
	MusicSettingsMain* _tmp5_;
	MusicSettingsMain* _tmp6_;
	gboolean _tmp7_;
#line 637 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 638 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 638 "../src/PlaybackManager.vala"
	music_playback_pause (_tmp0_);
#line 639 "../src/PlaybackManager.vala"
	music_playback_manager_set_playing (self, FALSE);
#line 641 "../src/PlaybackManager.vala"
	was_playing = (gint64) 0;
#line 642 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current_media;
#line 642 "../src/PlaybackManager.vala"
	if (_tmp1_ != NULL) {
#line 4019 "PlaybackManager.c"
		MusicMedia* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
#line 643 "../src/PlaybackManager.vala"
		_tmp2_ = self->priv->_current_media;
#line 643 "../src/PlaybackManager.vala"
		_tmp3_ = music_media_get_rowid (_tmp2_);
#line 643 "../src/PlaybackManager.vala"
		_tmp4_ = _tmp3_;
#line 643 "../src/PlaybackManager.vala"
		was_playing = _tmp4_;
#line 4031 "PlaybackManager.c"
	}
#line 646 "../src/PlaybackManager.vala"
	_tmp5_ = music_settings_main_get_default ();
#line 646 "../src/PlaybackManager.vala"
	_tmp6_ = _tmp5_;
#line 646 "../src/PlaybackManager.vala"
	_tmp7_ = !music_settings_main_privacy_mode_enabled (_tmp6_);
#line 646 "../src/PlaybackManager.vala"
	_g_object_unref0 (_tmp6_);
#line 646 "../src/PlaybackManager.vala"
	if (_tmp7_) {
#line 4043 "PlaybackManager.c"
		GSettings* _tmp8_;
		GSettings* _tmp9_;
#line 647 "../src/PlaybackManager.vala"
		_tmp8_ = music_app_get_saved_state ();
#line 647 "../src/PlaybackManager.vala"
		_tmp9_ = _tmp8_;
#line 647 "../src/PlaybackManager.vala"
		g_settings_set_int64 (_tmp9_, "last-media-playing", (gint64) 0);
#line 4052 "PlaybackManager.c"
	}
#line 649 "../src/PlaybackManager.vala"
	music_playback_manager_set_current_media (self, NULL);
#line 651 "../src/PlaybackManager.vala"
	g_signal_emit (self, music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL], 0, was_playing);
#line 4058 "PlaybackManager.c"
}

static GVariant*
_variant_new4 (gboolean value)
{
#line 657 "../src/PlaybackManager.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 4066 "PlaybackManager.c"
}

void
music_playback_manager_start_playback (MusicPlaybackManager* self)
{
	MusicPlayback* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	GAction* _tmp3_;
	GVariant* _tmp4_;
#line 654 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 655 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 655 "../src/PlaybackManager.vala"
	music_playback_play (_tmp0_);
#line 656 "../src/PlaybackManager.vala"
	music_playback_manager_set_playing (self, TRUE);
#line 657 "../src/PlaybackManager.vala"
	_tmp1_ = music_app_get_main_window ();
#line 657 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 657 "../src/PlaybackManager.vala"
	_tmp3_ = g_action_map_lookup_action ((GActionMap*) _tmp2_, MUSIC_LIBRARY_WINDOW_ACTION_PLAY);
#line 657 "../src/PlaybackManager.vala"
	_tmp4_ = _variant_new4 (TRUE);
#line 657 "../src/PlaybackManager.vala"
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_simple_action_get_type (), GSimpleAction), _tmp4_);
#line 657 "../src/PlaybackManager.vala"
	_g_variant_unref0 (_tmp4_);
#line 658 "../src/PlaybackManager.vala"
	g_signal_emit (self, music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL], 0);
#line 4099 "PlaybackManager.c"
}

static GVariant*
_variant_new5 (gboolean value)
{
#line 664 "../src/PlaybackManager.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 4107 "PlaybackManager.c"
}

void
music_playback_manager_pause_playback (MusicPlaybackManager* self)
{
	MusicPlayback* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	GAction* _tmp3_;
	GVariant* _tmp4_;
#line 661 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 662 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 662 "../src/PlaybackManager.vala"
	music_playback_pause (_tmp0_);
#line 663 "../src/PlaybackManager.vala"
	music_playback_manager_set_playing (self, FALSE);
#line 664 "../src/PlaybackManager.vala"
	_tmp1_ = music_app_get_main_window ();
#line 664 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 664 "../src/PlaybackManager.vala"
	_tmp3_ = g_action_map_lookup_action ((GActionMap*) _tmp2_, MUSIC_LIBRARY_WINDOW_ACTION_PLAY);
#line 664 "../src/PlaybackManager.vala"
	_tmp4_ = _variant_new5 (FALSE);
#line 664 "../src/PlaybackManager.vala"
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_simple_action_get_type (), GSimpleAction), _tmp4_);
#line 664 "../src/PlaybackManager.vala"
	_g_variant_unref0 (_tmp4_);
#line 4138 "PlaybackManager.c"
}

MusicPlaybackManager*
music_playback_manager_construct (GType object_type)
{
	MusicPlaybackManager * self = NULL;
#line 35 "../src/PlaybackManager.vala"
	self = (MusicPlaybackManager*) g_object_new (object_type, NULL);
#line 35 "../src/PlaybackManager.vala"
	return self;
#line 4149 "PlaybackManager.c"
}

MusicPlaybackManager*
music_playback_manager_new (void)
{
#line 35 "../src/PlaybackManager.vala"
	return music_playback_manager_construct (MUSIC_TYPE_PLAYBACK_MANAGER);
#line 4157 "PlaybackManager.c"
}

static MusicLibrary*
music_playback_manager_get_library (MusicPlaybackManager* self)
{
	MusicLibrary* result;
	MusicLibrariesManager* _tmp0_;
	MusicLibrary* _tmp1_;
#line 59 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "../src/PlaybackManager.vala"
	_tmp0_ = music_libraries_manager;
#line 59 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_->local_library;
#line 59 "../src/PlaybackManager.vala"
	result = _tmp1_;
#line 59 "../src/PlaybackManager.vala"
	return result;
#line 4176 "PlaybackManager.c"
}

gint
music_playback_manager_get_current_index (MusicPlaybackManager* self)
{
	gint result;
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 63 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 64 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_shuffled;
#line 64 "../src/PlaybackManager.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 64 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 64 "../src/PlaybackManager.vala"
	if (_tmp2_ == 0) {
#line 65 "../src/PlaybackManager.vala"
		result = self->priv->_current_index;
#line 65 "../src/PlaybackManager.vala"
		return result;
#line 4200 "PlaybackManager.c"
	} else {
#line 67 "../src/PlaybackManager.vala"
		result = self->priv->_current_shuffled_index;
#line 67 "../src/PlaybackManager.vala"
		return result;
#line 4206 "PlaybackManager.c"
	}
}

void
music_playback_manager_set_current_index (MusicPlaybackManager* self,
                                          gint value)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 70 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/PlaybackManager.vala"
	g_debug ("PlaybackManager.vala:71: Current index: %d", value);
#line 72 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_shuffled;
#line 72 "../src/PlaybackManager.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 72 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 72 "../src/PlaybackManager.vala"
	if (_tmp2_ == 0) {
#line 73 "../src/PlaybackManager.vala"
		self->priv->_current_index = value;
#line 4231 "PlaybackManager.c"
	} else {
#line 75 "../src/PlaybackManager.vala"
		self->priv->_current_shuffled_index = value;
#line 4235 "PlaybackManager.c"
	}
#line 70 "../src/PlaybackManager.vala"
	g_object_notify_by_pspec ((GObject *) self, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY]);
#line 4239 "PlaybackManager.c"
}

gboolean
music_playback_manager_get_playing (MusicPlaybackManager* self)
{
	gboolean result;
#line 82 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 82 "../src/PlaybackManager.vala"
	result = self->priv->_playing;
#line 82 "../src/PlaybackManager.vala"
	return result;
#line 4252 "PlaybackManager.c"
}

static void
music_playback_manager_set_playing (MusicPlaybackManager* self,
                                    gboolean value)
{
	gboolean old_value;
#line 82 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/PlaybackManager.vala"
	old_value = music_playback_manager_get_playing (self);
#line 82 "../src/PlaybackManager.vala"
	if (old_value != value) {
#line 82 "../src/PlaybackManager.vala"
		self->priv->_playing = value;
#line 82 "../src/PlaybackManager.vala"
		g_object_notify_by_pspec ((GObject *) self, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY]);
#line 4270 "PlaybackManager.c"
	}
}

gdouble
music_playback_manager_get_volume (MusicPlaybackManager* self)
{
	gdouble result;
	MusicPlayback* _tmp0_;
#line 86 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 87 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 87 "../src/PlaybackManager.vala"
	result = music_playback_get_volume (_tmp0_);
#line 87 "../src/PlaybackManager.vala"
	return result;
#line 4287 "PlaybackManager.c"
}

void
music_playback_manager_set_volume (MusicPlaybackManager* self,
                                   gdouble value)
{
	MusicPlayback* _tmp0_;
#line 89 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 90 "../src/PlaybackManager.vala"
	self->priv->saved_volume = value;
#line 91 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 91 "../src/PlaybackManager.vala"
	music_playback_set_volume (_tmp0_, value);
#line 89 "../src/PlaybackManager.vala"
	g_object_notify_by_pspec ((GObject *) self, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY]);
#line 4305 "PlaybackManager.c"
}

MusicMedia*
music_playback_manager_get_current_media (MusicPlaybackManager* self)
{
	MusicMedia* result;
	MusicMedia* _tmp0_;
#line 99 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 99 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_media;
#line 99 "../src/PlaybackManager.vala"
	result = _tmp0_;
#line 99 "../src/PlaybackManager.vala"
	return result;
#line 4321 "PlaybackManager.c"
}

static void
music_playback_manager_set_current_media (MusicPlaybackManager* self,
                                          MusicMedia* value)
{
	MusicMedia* old_value;
#line 99 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/PlaybackManager.vala"
	old_value = music_playback_manager_get_current_media (self);
#line 99 "../src/PlaybackManager.vala"
	if (old_value != value) {
#line 4335 "PlaybackManager.c"
		MusicMedia* _tmp0_;
#line 99 "../src/PlaybackManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 99 "../src/PlaybackManager.vala"
		_g_object_unref0 (self->priv->_current_media);
#line 99 "../src/PlaybackManager.vala"
		self->priv->_current_media = _tmp0_;
#line 99 "../src/PlaybackManager.vala"
		g_object_notify_by_pspec ((GObject *) self, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY]);
#line 4345 "PlaybackManager.c"
	}
}

static void
g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                     GValue * return_value,
                                     guint n_param_values,
                                     const GValue * param_values,
                                     gpointer invocation_hint,
                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT64) (gpointer data1, gint64 arg_1, gpointer data2);
	register GMarshalFunc_VOID__INT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 35 "../src/PlaybackManager.vala"
	g_return_if_fail (n_param_values == 2);
#line 35 "../src/PlaybackManager.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 35 "../src/PlaybackManager.vala"
		data1 = closure->data;
#line 35 "../src/PlaybackManager.vala"
		data2 = param_values->data[0].v_pointer;
#line 4371 "PlaybackManager.c"
	} else {
#line 35 "../src/PlaybackManager.vala"
		data1 = param_values->data[0].v_pointer;
#line 35 "../src/PlaybackManager.vala"
		data2 = closure->data;
#line 4377 "PlaybackManager.c"
	}
#line 35 "../src/PlaybackManager.vala"
	callback = (GMarshalFunc_VOID__INT64) (marshal_data ? marshal_data : cc->callback);
#line 35 "../src/PlaybackManager.vala"
	callback (data1, g_value_get_int64 (param_values + 1), data2);
#line 4383 "PlaybackManager.c"
}

static GObject *
music_playback_manager_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicPlaybackManager * self;
	MusicHistoryPlaylist* _tmp0_;
	MusicStaticPlaylist* _tmp1_;
	MusicStaticPlaylist* _tmp2_;
	MusicStaticPlaylist* _tmp3_;
	MusicStaticPlaylist* _tmp4_;
	MusicStaticPlaylist* _tmp5_;
	MusicStaticPlaylist* _tmp6_;
	GThemedIcon* _tmp7_;
	MusicStreamer* _tmp8_;
	GeeTreeSet* _tmp9_;
	MusicStreamer* _tmp10_;
	MusicStreamer* _tmp11_;
	MusicPlayback* _tmp12_;
#line 114 "../src/PlaybackManager.vala"
	parent_class = G_OBJECT_CLASS (music_playback_manager_parent_class);
#line 114 "../src/PlaybackManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 114 "../src/PlaybackManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager);
#line 115 "../src/PlaybackManager.vala"
	_tmp0_ = music_history_playlist_new ();
#line 115 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->history_playlist);
#line 115 "../src/PlaybackManager.vala"
	self->history_playlist = _tmp0_;
#line 116 "../src/PlaybackManager.vala"
	_tmp1_ = music_static_playlist_new ();
#line 116 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->queue_playlist);
#line 116 "../src/PlaybackManager.vala"
	self->queue_playlist = _tmp1_;
#line 117 "../src/PlaybackManager.vala"
	_tmp2_ = self->queue_playlist;
#line 117 "../src/PlaybackManager.vala"
	music_playlist_set_name ((MusicPlaylist*) _tmp2_, C_ ("Name of the playlist", "Queue"));
#line 118 "../src/PlaybackManager.vala"
	_tmp3_ = self->queue_playlist;
#line 118 "../src/PlaybackManager.vala"
	music_static_playlist_set_read_only (_tmp3_, TRUE);
#line 119 "../src/PlaybackManager.vala"
	_tmp4_ = self->queue_playlist;
#line 119 "../src/PlaybackManager.vala"
	music_static_playlist_set_allow_duplicate (_tmp4_, TRUE);
#line 120 "../src/PlaybackManager.vala"
	_tmp5_ = self->queue_playlist;
#line 120 "../src/PlaybackManager.vala"
	music_static_playlist_set_show_badge (_tmp5_, TRUE);
#line 121 "../src/PlaybackManager.vala"
	_tmp6_ = self->queue_playlist;
#line 121 "../src/PlaybackManager.vala"
	_tmp7_ = (GThemedIcon*) g_themed_icon_new ("playlist-queue");
#line 121 "../src/PlaybackManager.vala"
	_g_object_unref0 (((MusicPlaylist*) _tmp6_)->icon);
#line 121 "../src/PlaybackManager.vala"
	((MusicPlaylist*) _tmp6_)->icon = (GIcon*) _tmp7_;
#line 123 "../src/PlaybackManager.vala"
	_tmp8_ = music_streamer_new ();
#line 123 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->file_player);
#line 123 "../src/PlaybackManager.vala"
	self->file_player = _tmp8_;
#line 124 "../src/PlaybackManager.vala"
	_tmp9_ = self->priv->playbacks;
#line 124 "../src/PlaybackManager.vala"
	_tmp10_ = self->file_player;
#line 124 "../src/PlaybackManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, (MusicPlayback*) _tmp10_);
#line 125 "../src/PlaybackManager.vala"
	_tmp11_ = self->file_player;
#line 125 "../src/PlaybackManager.vala"
	_tmp12_ = _g_object_ref0 ((MusicPlayback*) _tmp11_);
#line 125 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->player);
#line 125 "../src/PlaybackManager.vala"
	self->player = _tmp12_;
#line 114 "../src/PlaybackManager.vala"
	return obj;
#line 4471 "PlaybackManager.c"
}

static void
music_playback_manager_class_init (MusicPlaybackManagerClass * klass,
                                   gpointer klass_data)
{
#line 35 "../src/PlaybackManager.vala"
	music_playback_manager_parent_class = g_type_class_peek_parent (klass);
#line 35 "../src/PlaybackManager.vala"
	g_type_class_adjust_private_offset (klass, &MusicPlaybackManager_private_offset);
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_playback_manager_get_property;
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_playback_manager_set_property;
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->constructor = music_playback_manager_constructor;
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->finalize = music_playback_manager_finalize;
#line 35 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY] = g_param_spec_int ("current-index", "current-index", "current-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY] = g_param_spec_boolean ("playing", "playing", "playing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY] = g_param_spec_object ("current-media", "current-media", "current-media", MUSIC_TYPE_MEDIA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../src/PlaybackManager.vala"
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL] = g_signal_new ("changing-player", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 35 "../src/PlaybackManager.vala"
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL] = g_signal_new ("media-played", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_MEDIA);
#line 35 "../src/PlaybackManager.vala"
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL] = g_signal_new ("playback-stopped", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64, G_TYPE_NONE, 1, G_TYPE_INT64);
#line 35 "../src/PlaybackManager.vala"
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL] = g_signal_new ("playback-started", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 35 "../src/PlaybackManager.vala"
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL] = g_signal_new ("player-changed", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 35 "../src/PlaybackManager.vala"
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL] = g_signal_new ("queue-cleared", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4510 "PlaybackManager.c"
}

static void
music_playback_manager_instance_init (MusicPlaybackManager * self,
                                      gpointer klass)
{
	GeeTreeSet* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
#line 35 "../src/PlaybackManager.vala"
	self->priv = music_playback_manager_get_instance_private (self);
#line 47 "../src/PlaybackManager.vala"
	g_rec_mutex_init (&self->priv->__lock_playbacks);
#line 47 "../src/PlaybackManager.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_PLAYBACK, NULL, NULL, NULL, NULL, NULL);
#line 47 "../src/PlaybackManager.vala"
	self->priv->playbacks = _tmp0_;
#line 50 "../src/PlaybackManager.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 50 "../src/PlaybackManager.vala"
	self->priv->_current = _tmp1_;
#line 53 "../src/PlaybackManager.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 53 "../src/PlaybackManager.vala"
	self->priv->_current_shuffled = _tmp2_;
#line 82 "../src/PlaybackManager.vala"
	self->priv->_playing = FALSE;
#line 84 "../src/PlaybackManager.vala"
	self->priv->saved_volume = (gdouble) 1;
#line 4540 "PlaybackManager.c"
}

static void
music_playback_manager_finalize (GObject * obj)
{
	MusicPlaybackManager * self;
#line 35 "../src/PlaybackManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager);
#line 47 "../src/PlaybackManager.vala"
	g_rec_mutex_clear (&self->priv->__lock_playbacks);
#line 47 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->playbacks);
#line 50 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_current);
#line 53 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_current_shuffled);
#line 55 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->queue_playlist);
#line 56 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->history_playlist);
#line 97 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->file_player);
#line 98 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->player);
#line 99 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_current_media);
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (music_playback_manager_parent_class)->finalize (obj);
#line 4569 "PlaybackManager.c"
}

/**
* Manages song playback, queue, repeating and shuffling
*
* Finds the appropriate {@link Music.Playback} to play a media
*/
static GType
music_playback_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPlaybackManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_playback_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPlaybackManager), 0, (GInstanceInitFunc) music_playback_manager_instance_init, NULL };
	GType music_playback_manager_type_id;
	music_playback_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicPlaybackManager", &g_define_type_info, 0);
	MusicPlaybackManager_private_offset = g_type_add_instance_private (music_playback_manager_type_id, sizeof (MusicPlaybackManagerPrivate));
	return music_playback_manager_type_id;
}

GType
music_playback_manager_get_type (void)
{
	static volatile gsize music_playback_manager_type_id__once = 0;
	if (g_once_init_enter (&music_playback_manager_type_id__once)) {
		GType music_playback_manager_type_id;
		music_playback_manager_type_id = music_playback_manager_get_type_once ();
		g_once_init_leave (&music_playback_manager_type_id__once, music_playback_manager_type_id);
	}
	return music_playback_manager_type_id__once;
}

static void
_vala_music_playback_manager_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	MusicPlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager);
#line 35 "../src/PlaybackManager.vala"
	switch (property_id) {
#line 35 "../src/PlaybackManager.vala"
		case MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		g_value_set_int (value, music_playback_manager_get_current_index (self));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		g_value_set_boolean (value, music_playback_manager_get_playing (self));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		g_value_set_double (value, music_playback_manager_get_volume (self));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		g_value_set_object (value, music_playback_manager_get_current_media (self));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 4633 "PlaybackManager.c"
		default:
#line 35 "../src/PlaybackManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../src/PlaybackManager.vala"
		break;
#line 4639 "PlaybackManager.c"
	}
}

static void
_vala_music_playback_manager_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	MusicPlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager);
#line 35 "../src/PlaybackManager.vala"
	switch (property_id) {
#line 35 "../src/PlaybackManager.vala"
		case MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		music_playback_manager_set_current_index (self, g_value_get_int (value));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		music_playback_manager_set_playing (self, g_value_get_boolean (value));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		music_playback_manager_set_volume (self, g_value_get_double (value));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		music_playback_manager_set_current_media (self, g_value_get_object (value));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 4677 "PlaybackManager.c"
		default:
#line 35 "../src/PlaybackManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../src/PlaybackManager.vala"
		break;
#line 4683 "PlaybackManager.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

