/* LibraryWindow.c generated by valac 0.56.0, the Vala compiler
 * generated from LibraryWindow.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include "music-lib.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include "io.elementary.music-core.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <handy.h>
#include <libgda/libgda.h>
#include <float.h>
#include <math.h>
#include <time.h>

enum  {
	MUSIC_LIBRARY_WINDOW_0_PROPERTY,
	MUSIC_LIBRARY_WINDOW_INITIALIZATION_FINISHED_PROPERTY,
	MUSIC_LIBRARY_WINDOW_NEWLY_CREATED_PLAYLIST_PROPERTY,
	MUSIC_LIBRARY_WINDOW_SOURCE_LIST_VIEW_PROPERTY,
	MUSIC_LIBRARY_WINDOW_VIEW_STACK_PROPERTY,
	MUSIC_LIBRARY_WINDOW_VIEW_SELECTOR_PROPERTY,
	MUSIC_LIBRARY_WINDOW_SEARCH_ENTRY_PROPERTY,
	MUSIC_LIBRARY_WINDOW_STATUSBAR_PROPERTY,
	MUSIC_LIBRARY_WINDOW_LIBRARY_MANAGER_PROPERTY,
	MUSIC_LIBRARY_WINDOW_NUM_PROPERTIES
};
static GParamSpec* music_library_window_properties[MUSIC_LIBRARY_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _MusicLibraryWindowShowNotificationFromMediaAsyncData MusicLibraryWindowShowNotificationFromMediaAsyncData;
typedef struct _MusicLibraryWindowNotifyCurrentMediaAsyncData MusicLibraryWindowNotifyCurrentMediaAsyncData;
typedef struct _Block4Data Block4Data;
typedef struct _MusicLibraryWindowUpdateSensitivitiesData MusicLibraryWindowUpdateSensitivitiesData;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _Block10Data Block10Data;
enum  {
	MUSIC_LIBRARY_WINDOW_PLAY_PAUSE_CHANGED_SIGNAL,
	MUSIC_LIBRARY_WINDOW_NUM_SIGNALS
};
static guint music_library_window_signals[MUSIC_LIBRARY_WINDOW_NUM_SIGNALS] = {0};

struct _MusicLibraryWindowPrivate {
	gboolean _initialization_finished;
	gboolean _newly_created_playlist;
	MusicSourceListView* _source_list_view;
	MusicViewStack* _view_stack;
	MusicWidgetsViewSelector* _view_selector;
	GtkSearchEntry* _search_entry;
	MusicWidgetsStatusBar* _statusbar;
	gboolean _media_considered_played;
	gboolean _added_to_play_count;
	gboolean _media_considered_previewed;
	gboolean _media_half_played_sended;
	gboolean _search_field_has_focus;
	guint configure_id;
	GCancellable* notification_cancellable;
	MusicPreferencesWindow* preferences;
	MusicSettingsMain* main_settings;
	MusicTopDisplay* top_display;
	GRecMutex __lock_match_playlists;
	GeeHashMap* match_devices;
	GRecMutex __lock_match_devices;
	GeeHashMap* match_playlist_entry;
	gboolean update_sensitivities_pending;
};

struct _Block3Data {
	int _ref_count_;
	MusicLibraryWindow* self;
	GtkButton* play_button;
};

struct _MusicLibraryWindowShowNotificationFromMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicLibraryWindow* self;
	MusicMedia* media;
	GCancellable* _tmp0_;
	GCancellable* _tmp1_;
	GCancellable* _tmp2_;
	gchar* primary_text;
	gchar* _tmp3_;
	GString* secondary_text;
	GString* _tmp4_;
	GString* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GString* _tmp8_;
	GString* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GCancellable* _tmp12_;
	const gchar* _tmp13_;
	GString* _tmp14_;
	const gchar* _tmp15_;
	MusicAlbum* _tmp16_;
	MusicAlbum* _tmp17_;
	GIcon* _tmp18_;
	GIcon* _tmp19_;
};

struct _MusicLibraryWindowNotifyCurrentMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicLibraryWindow* self;
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	MusicPlaybackManager* _tmp4_;
	MusicPlaybackManager* _tmp5_;
	MusicMedia* _tmp6_;
	MusicMedia* _tmp7_;
};

struct _Block4Data {
	int _ref_count_;
	MusicLibraryWindow* self;
	MusicPlaylist* p;
};

struct _MusicLibraryWindowUpdateSensitivitiesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicLibraryWindow* self;
};

struct _Block5Data {
	int _ref_count_;
	MusicLibraryWindow* self;
	MusicDevice* d;
};

struct _Block6Data {
	int _ref_count_;
	Block5Data * _data5_;
	MusicSourceListEntry* entry;
};

struct _Block7Data {
	int _ref_count_;
	MusicLibraryWindow* self;
	MusicSourceListEntry* entry;
};

struct _Block8Data {
	int _ref_count_;
	MusicLibraryWindow* self;
	MusicPlaylistViewWrapper* view;
	MusicSmartPlaylist* p;
};

struct _Block9Data {
	int _ref_count_;
	MusicLibraryWindow* self;
	MusicMedia* m;
};

struct _Block10Data {
	int _ref_count_;
	MusicLibraryWindow* self;
	gchar* folder;
};

static gint MusicLibraryWindow_private_offset;
static gpointer music_library_window_parent_class = NULL;
static MusicLibraryWindowInterfaceIface * music_library_window_music_library_window_interface_parent_iface = NULL;

static void _music_library_window_action_import_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static void music_library_window_action_play (MusicLibraryWindow* self);
static void _music_library_window_action_play_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void music_library_window_action_play_next (MusicLibraryWindow* self);
static void _music_library_window_action_play_next_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void music_library_window_action_play_previous (MusicLibraryWindow* self);
static void _music_library_window_action_play_previous_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self);
static void music_library_window_action_quit (MusicLibraryWindow* self);
static void _music_library_window_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void music_library_window_action_search (MusicLibraryWindow* self);
static void _music_library_window_action_search_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static void music_library_window_action_view_albums (MusicLibraryWindow* self);
static void _music_library_window_action_view_albums_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self);
static void music_library_window_action_view_columns (MusicLibraryWindow* self);
static void _music_library_window_action_view_columns_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self);
static void music_library_window_action_view_list (MusicLibraryWindow* self);
static void _music_library_window_action_view_list_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static gboolean music_library_window_real_key_press_event (GtkWidget* base,
                                                    GdkEventKey* event);
static gboolean music_library_window_get_search_field_has_focus (MusicLibraryWindow* self);
static gboolean _vala_unichar_array_contains (gunichar * stack,
                                       gssize stack_length,
                                       const gunichar needle);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void music_library_window_on_quit (MusicLibraryWindow* self);
static void _music_library_window_on_quit_gtk_widget_destroy (GtkWidget* _sender,
                                                       gpointer self);
static void music_library_window_edit_preferences_click (MusicLibraryWindow* self);
static void _music_library_window_edit_preferences_click_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                          gpointer self);
static void music_library_window_set_search_entry (MusicLibraryWindow* self,
                                            GtkSearchEntry* value);
static void music_library_window_set_view_selector (MusicLibraryWindow* self,
                                             MusicWidgetsViewSelector* value);
static void music_library_window_set_view_stack (MusicLibraryWindow* self,
                                          MusicViewStack* value);
static void music_library_window_set_source_list_view (MusicLibraryWindow* self,
                                                MusicSourceListView* value);
static void music_library_window_set_statusbar (MusicLibraryWindow* self,
                                         MusicWidgetsStatusBar* value);
static void __lambda134_ (Block3Data* _data3_,
                   const gchar* name,
                   GVariant* new_state);
static void ___lambda134__g_action_group_action_state_changed (GActionGroup* _sender,
                                                        const gchar* action_name,
                                                        GVariant* state,
                                                        gpointer self);
static void __lambda135_ (MusicLibraryWindow* self);
static void ___lambda135__music_library_search_finished (MusicLibrary* _sender,
                                                  gpointer self);
static void __lambda136_ (MusicLibraryWindow* self,
                   MusicLibrary* lib);
static void __lambda137_ (MusicLibraryWindow* self);
static void ___lambda137__music_library_search_finished (MusicLibrary* _sender,
                                                  gpointer self);
static void ___lambda136__music_libraries_manager_library_added (MusicLibrariesManager* _sender,
                                                          MusicLibrary* library,
                                                          gpointer self);
static void __lambda138_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda138__music_source_list_view_selection_changed (MusicSourceListView* _sender,
                                                             GtkGrid* view,
                                                             gpointer self);
static void __lambda139_ (MusicLibraryWindow* self);
static void music_library_window_set_search_field_has_focus (MusicLibraryWindow* self,
                                                      gboolean value);
static void ___lambda139__music_source_list_view_activated (MusicSourceListView* _sender,
                                                     gpointer self);
static void __lambda140_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda140__music_source_list_view_item_action_activated (MusicSourceListView* _sender,
                                                                 GtkGrid* view,
                                                                 gpointer self);
static void music_library_window_playlist_name_edited (MusicLibraryWindow* self,
                                                GtkGrid* view_wrapper,
                                                const gchar* new_name);
static void _music_library_window_playlist_name_edited_music_source_list_view_edited (MusicSourceListView* _sender,
                                                                               GtkGrid* view,
                                                                               const gchar* new_name,
                                                                               gpointer self);
static void __lambda143_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda143__music_source_list_view_playlist_rename_clicked (MusicSourceListView* _sender,
                                                                   GtkGrid* view,
                                                                   gpointer self);
static void __lambda144_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda144__music_source_list_view_playlist_edit_clicked (MusicSourceListView* _sender,
                                                                 GtkGrid* view,
                                                                 gpointer self);
static void __lambda145_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda145__music_source_list_view_playlist_remove_clicked (MusicSourceListView* _sender,
                                                                   GtkGrid* view,
                                                                   gpointer self);
static void __lambda146_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda146__music_source_list_view_device_import_clicked (MusicSourceListView* _sender,
                                                                 GtkGrid* view,
                                                                 gpointer self);
static void __lambda147_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda147__music_source_list_view_device_new_playlist_clicked (MusicSourceListView* _sender,
                                                                       GtkGrid* view,
                                                                       gpointer self);
static void __lambda148_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda148__music_source_list_view_device_sync_clicked (MusicSourceListView* _sender,
                                                               GtkGrid* view,
                                                               gpointer self);
static void __lambda149_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda149__music_source_list_view_device_eject_clicked (MusicSourceListView* _sender,
                                                                GtkGrid* view,
                                                                gpointer self);
static void __lambda150_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda150__music_source_list_view_playlist_remove_clicked (MusicSourceListView* _sender,
                                                                   GtkGrid* view,
                                                                   gpointer self);
static void __lambda151_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda151__music_source_list_view_playlist_save_clicked (MusicSourceListView* _sender,
                                                                 GtkGrid* view,
                                                                 gpointer self);
static void __lambda152_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda152__music_source_list_view_playlist_export_clicked (MusicSourceListView* _sender,
                                                                   GtkGrid* view,
                                                                   gpointer self);
static void __lambda153_ (MusicLibraryWindow* self,
                   GtkGrid* view,
                   gchar** uris,
                   gint uris_length1);
static void ___lambda153__music_source_list_view_playlist_media_added (MusicSourceListView* _sender,
                                                                GtkGrid* view,
                                                                gchar** uris,
                                                                gint uris_length1,
                                                                gpointer self);
static void __lambda154_ (MusicLibraryWindow* self);
static void ___lambda154__music_source_list_view_playlist_import_clicked (MusicSourceListView* _sender,
                                                                   gpointer self);
static void music_library_window_load_playlists (MusicLibraryWindow* self);
static void music_library_window_update_sensitivities_sync (MusicLibraryWindow* self);
static void music_library_window_set_initialization_finished (MusicLibraryWindow* self,
                                                       gboolean value);
static void music_library_window_search_entry_activate (MusicLibraryWindow* self);
static void _music_library_window_search_entry_activate_gtk_entry_activate (GtkEntry* _sender,
                                                                     gpointer self);
static void __lambda162_ (MusicLibraryWindow* self);
static void ___lambda162__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                    gpointer self);
static void music_library_window_show_playlist_view (MusicLibraryWindow* self,
                                              MusicPlaylist* p);
static void music_library_window_show_notification_from_media_async_data_free (gpointer _data);
static void music_library_window_show_notification_from_media_async (MusicLibraryWindow* self,
                                                              MusicMedia* media,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_);
static void music_library_window_show_notification_from_media_finish (MusicLibraryWindow* self,
                                                               GAsyncResult* _res_);
static gboolean music_library_window_show_notification_from_media_async_co (MusicLibraryWindowShowNotificationFromMediaAsyncData* _data_);
static void music_library_window_notify_current_media_async_data_free (gpointer _data);
static void music_library_window_notify_current_media_async (MusicLibraryWindow* self,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
static void music_library_window_notify_current_media_finish (MusicLibraryWindow* self,
                                                       GAsyncResult* _res_);
static gboolean music_library_window_notify_current_media_async_co (MusicLibraryWindowNotifyCurrentMediaAsyncData* _data_);
static void music_library_window_notify_current_media_async_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_);
static void music_library_window_set_active_view (MusicLibraryWindow* self,
                                           MusicViewWrapper* view);
static void music_library_window_add_smartplaylist (MusicLibraryWindow* self,
                                             MusicSmartPlaylist* smartplaylist,
                                             MusicLibrary* library,
                                             MusicSourceListExpandableItem* entry);
static void music_library_window_add_playlist (MusicLibraryWindow* self,
                                        MusicStaticPlaylist* playlist,
                                        MusicLibrary* library,
                                        MusicSourceListExpandableItem* entry);
static void music_library_window_update_badge_on_playlist_update (MusicLibraryWindow* self,
                                                           MusicPlaylist* p,
                                                           MusicSourceListEntry* entry);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda157_ (Block4Data* _data4_,
                   GeeCollection* s);
static void music_library_window_update_playlist_badge (MusicLibraryWindow* self,
                                                 MusicPlaylist* playlist);
static void ___lambda157__music_playlist_media_added (MusicPlaylist* _sender,
                                               GeeCollection* media,
                                               gpointer self);
static void __lambda158_ (Block4Data* _data4_,
                   GeeCollection* s);
static void ___lambda158__music_playlist_media_removed (MusicPlaylist* _sender,
                                                 GeeCollection* media,
                                                 gpointer self);
static void __lambda159_ (Block4Data* _data4_,
                   MusicPlaylist* s);
static void ___lambda159__music_playlist_cleared (MusicPlaylist* _sender,
                                           gpointer self);
static void music_library_window_real_update_sensitivities_data_free (gpointer _data);
static void music_library_window_real_update_sensitivities (MusicLibraryWindowInterface* base,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static gboolean music_library_window_real_update_sensitivities_co (MusicLibraryWindowUpdateSensitivitiesData* _data_);
static GVariant* _variant_new1 (gboolean value);
static GVariant* _variant_new2 (gboolean value);
static void music_library_window_change_device_name (MusicLibraryWindow* self,
                                              MusicDevice* device);
static void music_library_window_remove_device (MusicLibraryWindow* self,
                                         MusicDevice* device);
static void music_library_window_create_device_source_list (MusicLibraryWindow* self,
                                                     MusicDevice* d);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void music_library_window_create_playlist_source_list (MusicLibraryWindow* self,
                                                       MusicStaticPlaylist* p,
                                                       MusicSourceListExpandableItem* into_expandable,
                                                       MusicLibrary* library);
static void _____lambda163_ (Block6Data* _data6_,
                      MusicStaticPlaylist* np);
static void ______lambda163__music_library_playlist_added (MusicLibrary* _sender,
                                                    MusicStaticPlaylist* playlist,
                                                    gpointer self);
static void _____lambda164_ (MusicLibraryWindow* self,
                      MusicStaticPlaylist* np);
static void music_library_window_remove_playlist (MusicLibraryWindow* self,
                                           MusicStaticPlaylist* playlist);
static void ______lambda164__music_library_playlist_removed (MusicLibrary* _sender,
                                                      MusicStaticPlaylist* playlist,
                                                      gpointer self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static gboolean ___lambda160_ (Block7Data* _data7_);
static gboolean ____lambda160__gsource_func (gpointer self);
static void music_library_window_create_smartplaylist_source_list (MusicLibraryWindow* self,
                                                            MusicSmartPlaylist* p,
                                                            MusicSourceListExpandableItem* into_expandable,
                                                            MusicLibrary* library);
static void music_library_window_remove_smartplaylist (MusicLibraryWindow* self,
                                                MusicSmartPlaylist* smartplaylist);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda155_ (MusicLibraryWindow* self,
                   MusicPlaylist* playlist);
static void ___lambda155__music_playlist_view_wrapper_button_clicked (MusicPlaylistViewWrapper* _sender,
                                                               MusicPlaylist* p,
                                                               gpointer self);
static void __lambda156_ (Block8Data* _data8_,
                   const gchar* old_name);
static void ___lambda156__music_playlist_updated (MusicPlaylist* _sender,
                                           const gchar* old_name,
                                           gpointer self);
static void music_library_window_media_played (MusicLibraryWindow* self,
                                        MusicMedia* m);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void music_library_window_set_media_considered_previewed (MusicLibraryWindow* self,
                                                          gboolean value);
static void music_library_window_set_media_considered_played (MusicLibraryWindow* self,
                                                       gboolean value);
static void music_library_window_set_added_to_play_count (MusicLibraryWindow* self,
                                                   gboolean value);
static void music_library_window_set_media_half_played_sended (MusicLibraryWindow* self,
                                                        gboolean value);
static gboolean __lambda165_ (Block9Data* _data9_);
static void* ___lambda166_ (MusicLibraryWindow* self);
static gpointer ____lambda166__gthread_func (gpointer self);
static gboolean ___lambda165__gsource_func (gpointer self);
static void music_library_window_real_playback_stopped (MusicLibraryWindow* self,
                                                 gint64 was_playing);
static GVariant* _variant_new3 (gboolean value);
static void music_library_window_real_play_media (MusicLibraryWindow* self,
                                           gboolean inhibit_notifications);
static void music_library_window_real_play_next_media (MusicLibraryWindow* self,
                                                gboolean inhibit_notifications);
static gboolean music_library_window_get_added_to_play_count (MusicLibraryWindow* self);
static void music_library_window_real_play_previous_media (MusicLibraryWindow* self,
                                                    gboolean inhibit_notifications);
static void music_library_window_real_action_import (MusicLibraryWindow* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void ___lambda122_ (Block10Data* _data10_,
                    gboolean cont);
static void ____lambda122__music_set_music_folder_confirmation_finished (MusicSetMusicFolderConfirmation* _sender,
                                                                  gboolean response,
                                                                  gpointer self);
static void music_library_window_real_end_of_stream (MusicLibraryWindow* self);
static void music_library_window_real_error_occured (MusicLibraryWindow* self);
static void music_library_window_real_current_position_update (MusicLibraryWindow* self,
                                                        gint64 position);
static gboolean music_library_window_get_media_considered_previewed (MusicLibraryWindow* self);
static gboolean music_library_window_get_media_considered_played (MusicLibraryWindow* self);
static gboolean music_library_window_get_media_half_played_sended (MusicLibraryWindow* self);
static void music_library_window_real_drag_received (MusicLibraryWindow* self,
                                              GdkDragContext* context,
                                              gint x,
                                              gint y,
                                              GtkSelectionData* data,
                                              guint info,
                                              guint timestamp);
static void music_library_window_show_alert (MusicLibraryWindow* self,
                                      const gchar* title,
                                      const gchar* message);
static gboolean music_library_window_real_delete_event (GtkWidget* base,
                                                 GdkEventAny* event);
static gboolean music_library_window_real_configure_event (GtkWidget* base,
                                                    GdkEventConfigure* event);
static gboolean ___lambda167_ (MusicLibraryWindow* self);
static gboolean ____lambda167__gsource_func (gpointer self);
static GObject * music_library_window_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void _music_library_window_interface_update_sensitivities_music_library_media_added (MusicLibrary* _sender,
                                                                                     GeeCollection* medias,
                                                                                     gpointer self);
static void _music_library_window_interface_update_sensitivities_music_library_media_removed (MusicLibrary* _sender,
                                                                                       GeeCollection* medias,
                                                                                       gpointer self);
static void _music_library_window___lambda168_ (MusicLibraryWindow* self,
                                         MusicStaticPlaylist* p);
static void __music_library_window___lambda168__music_library_playlist_added (MusicLibrary* _sender,
                                                                       MusicStaticPlaylist* playlist,
                                                                       gpointer self);
static void _music_library_window___lambda169_ (MusicLibraryWindow* self,
                                         MusicStaticPlaylist* p);
static void __music_library_window___lambda169__music_library_playlist_removed (MusicLibrary* _sender,
                                                                         MusicStaticPlaylist* playlist,
                                                                         gpointer self);
static void _music_library_window___lambda170_ (MusicLibraryWindow* self,
                                         MusicSmartPlaylist* p);
static void __music_library_window___lambda170__music_library_smartplaylist_added (MusicLibrary* _sender,
                                                                            MusicSmartPlaylist* smartplaylist,
                                                                            gpointer self);
static void _music_library_window___lambda171_ (MusicLibraryWindow* self,
                                         MusicSmartPlaylist* p);
static void __music_library_window___lambda171__music_library_smartplaylist_removed (MusicLibrary* _sender,
                                                                              MusicSmartPlaylist* smartplaylist,
                                                                              gpointer self);
static void _music_library_window___lambda172_ (MusicLibraryWindow* self,
                                         MusicDevice* item);
static void __music_library_window___lambda172__music_device_manager_device_added (MusicDeviceManager* _sender,
                                                                            MusicDevice* d,
                                                                            gpointer self);
static void _music_library_window_change_device_name_music_device_manager_device_name_changed (MusicDeviceManager* _sender,
                                                                                        MusicDevice* d,
                                                                                        gpointer self);
static void _music_library_window_remove_device_music_device_manager_device_removed (MusicDeviceManager* _sender,
                                                                              MusicDevice* d,
                                                                              gpointer self);
static void _music_library_window_end_of_stream_music_playback_end_of_stream (MusicPlayback* _sender,
                                                                       gpointer self);
static void _music_library_window_current_position_update_music_playback_current_position_update (MusicPlayback* _sender,
                                                                                           gint64 position,
                                                                                           gpointer self);
static void _music_library_window_error_occured_music_playback_error_occured (MusicPlayback* _sender,
                                                                       gpointer self);
static void _music_library_window_media_played_music_playback_manager_media_played (MusicPlaybackManager* _sender,
                                                                             MusicMedia* played_media,
                                                                             gpointer self);
static void _music_library_window_playback_stopped_music_playback_manager_playback_stopped (MusicPlaybackManager* _sender,
                                                                                     gint64 was_playing,
                                                                                     gpointer self);
static void _music_library_window___lambda173_ (MusicLibraryWindow* self);
static void __music_library_window___lambda173__music_playback_manager_changing_player (MusicPlaybackManager* _sender,
                                                                                 gpointer self);
static void _music_library_window___lambda174_ (MusicLibraryWindow* self);
static void __music_library_window___lambda174__music_playback_manager_player_changed (MusicPlaybackManager* _sender,
                                                                                gpointer self);
static void _music_library_window_show_alert_music_notification_manager_show_alert (MusicNotificationManager* _sender,
                                                                             const gchar* title,
                                                                             const gchar* message,
                                                                             gpointer self);
static void _music_library_window___lambda175_ (MusicLibraryWindow* self,
                                         MusicStaticPlaylist* playlist);
static void __music_library_window___lambda175__music_libraries_manager_add_headless_playlist (MusicLibrariesManager* _sender,
                                                                                        MusicStaticPlaylist* playlist,
                                                                                        gpointer self);
static void music_library_window_finalize (GObject * obj);
static GType music_library_window_get_type_once (void);
static void _vala_music_library_window_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_music_library_window_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GActionEntry MUSIC_LIBRARY_WINDOW_ACTION_ENTRIES[9] = {{MUSIC_LIBRARY_WINDOW_ACTION_IMPORT, _music_library_window_action_import_gsimple_action_activate_callback}, {MUSIC_LIBRARY_WINDOW_ACTION_PLAY, _music_library_window_action_play_gsimple_action_activate_callback, NULL, "false"}, {MUSIC_LIBRARY_WINDOW_ACTION_PLAY_NEXT, _music_library_window_action_play_next_gsimple_action_activate_callback}, {MUSIC_LIBRARY_WINDOW_ACTION_PLAY_PREVIOUS, _music_library_window_action_play_previous_gsimple_action_activate_callback}, {MUSIC_LIBRARY_WINDOW_ACTION_QUIT, _music_library_window_action_quit_gsimple_action_activate_callback}, {MUSIC_LIBRARY_WINDOW_ACTION_SEARCH, _music_library_window_action_search_gsimple_action_activate_callback}, {MUSIC_LIBRARY_WINDOW_ACTION_VIEW_ALBUMS, _music_library_window_action_view_albums_gsimple_action_activate_callback}, {MUSIC_LIBRARY_WINDOW_ACTION_VIEW_COLUMNS, _music_library_window_action_view_columns_gsimple_action_activate_callback}, {MUSIC_LIBRARY_WINDOW_ACTION_VIEW_LIST, _music_library_window_action_view_list_gsimple_action_activate_callback}};

static inline gpointer
music_library_window_get_instance_private (MusicLibraryWindow* self)
{
	return G_STRUCT_MEMBER_P (self, MusicLibraryWindow_private_offset);
}

static void
_music_library_window_action_import_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
#line 71 "../src/LibraryWindow.vala"
	music_library_window_action_import ((MusicLibraryWindow*) self);
#line 659 "LibraryWindow.c"
}

static void
_music_library_window_action_play_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
#line 71 "../src/LibraryWindow.vala"
	music_library_window_action_play ((MusicLibraryWindow*) self);
#line 669 "LibraryWindow.c"
}

static void
_music_library_window_action_play_next_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
#line 71 "../src/LibraryWindow.vala"
	music_library_window_action_play_next ((MusicLibraryWindow*) self);
#line 679 "LibraryWindow.c"
}

static void
_music_library_window_action_play_previous_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self)
{
#line 71 "../src/LibraryWindow.vala"
	music_library_window_action_play_previous ((MusicLibraryWindow*) self);
#line 689 "LibraryWindow.c"
}

static void
_music_library_window_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
#line 71 "../src/LibraryWindow.vala"
	music_library_window_action_quit ((MusicLibraryWindow*) self);
#line 699 "LibraryWindow.c"
}

static void
_music_library_window_action_search_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
#line 71 "../src/LibraryWindow.vala"
	music_library_window_action_search ((MusicLibraryWindow*) self);
#line 709 "LibraryWindow.c"
}

static void
_music_library_window_action_view_albums_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self)
{
#line 71 "../src/LibraryWindow.vala"
	music_library_window_action_view_albums ((MusicLibraryWindow*) self);
#line 719 "LibraryWindow.c"
}

static void
_music_library_window_action_view_columns_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self)
{
#line 71 "../src/LibraryWindow.vala"
	music_library_window_action_view_columns ((MusicLibraryWindow*) self);
#line 729 "LibraryWindow.c"
}

static void
_music_library_window_action_view_list_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
#line 71 "../src/LibraryWindow.vala"
	music_library_window_action_view_list ((MusicLibraryWindow*) self);
#line 739 "LibraryWindow.c"
}

MusicLibraryWindow*
music_library_window_construct (GType object_type,
                                GtkApplication* application)
{
	MusicLibraryWindow * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar* _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
#line 83 "../src/LibraryWindow.vala"
	g_return_val_if_fail (application != NULL, NULL);
#line 84 "../src/LibraryWindow.vala"
	self = (MusicLibraryWindow*) g_object_new (object_type, "application", application, NULL);
#line 86 "../src/LibraryWindow.vala"
	_tmp0_ = g_strdup ("<Control>q");
#line 86 "../src/LibraryWindow.vala"
	_tmp1_ = g_strdup ("<Control>w");
#line 86 "../src/LibraryWindow.vala"
	_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 86 "../src/LibraryWindow.vala"
	_tmp2_[0] = _tmp0_;
#line 86 "../src/LibraryWindow.vala"
	_tmp2_[1] = _tmp1_;
#line 86 "../src/LibraryWindow.vala"
	_tmp3_ = _tmp2_;
#line 86 "../src/LibraryWindow.vala"
	_tmp3__length1 = 2;
#line 86 "../src/LibraryWindow.vala"
	gtk_application_set_accels_for_action (application, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_QUIT, _tmp3_);
#line 86 "../src/LibraryWindow.vala"
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 87 "../src/LibraryWindow.vala"
	_tmp4_ = g_strdup ("<Control>f");
#line 87 "../src/LibraryWindow.vala"
	_tmp5_ = g_new0 (gchar*, 1 + 1);
#line 87 "../src/LibraryWindow.vala"
	_tmp5_[0] = _tmp4_;
#line 87 "../src/LibraryWindow.vala"
	_tmp6_ = _tmp5_;
#line 87 "../src/LibraryWindow.vala"
	_tmp6__length1 = 1;
#line 87 "../src/LibraryWindow.vala"
	gtk_application_set_accels_for_action (application, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_SEARCH, _tmp6_);
#line 87 "../src/LibraryWindow.vala"
	_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
#line 88 "../src/LibraryWindow.vala"
	_tmp7_ = g_strdup ("<Control>1");
#line 88 "../src/LibraryWindow.vala"
	_tmp8_ = g_new0 (gchar*, 1 + 1);
#line 88 "../src/LibraryWindow.vala"
	_tmp8_[0] = _tmp7_;
#line 88 "../src/LibraryWindow.vala"
	_tmp9_ = _tmp8_;
#line 88 "../src/LibraryWindow.vala"
	_tmp9__length1 = 1;
#line 88 "../src/LibraryWindow.vala"
	gtk_application_set_accels_for_action (application, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_VIEW_ALBUMS, _tmp9_);
#line 88 "../src/LibraryWindow.vala"
	_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
#line 89 "../src/LibraryWindow.vala"
	_tmp10_ = g_strdup ("<Control>2");
#line 89 "../src/LibraryWindow.vala"
	_tmp11_ = g_new0 (gchar*, 1 + 1);
#line 89 "../src/LibraryWindow.vala"
	_tmp11_[0] = _tmp10_;
#line 89 "../src/LibraryWindow.vala"
	_tmp12_ = _tmp11_;
#line 89 "../src/LibraryWindow.vala"
	_tmp12__length1 = 1;
#line 89 "../src/LibraryWindow.vala"
	gtk_application_set_accels_for_action (application, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_VIEW_LIST, _tmp12_);
#line 89 "../src/LibraryWindow.vala"
	_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_free), NULL);
#line 90 "../src/LibraryWindow.vala"
	_tmp13_ = g_strdup ("<Control>3");
#line 90 "../src/LibraryWindow.vala"
	_tmp14_ = g_new0 (gchar*, 1 + 1);
#line 90 "../src/LibraryWindow.vala"
	_tmp14_[0] = _tmp13_;
#line 90 "../src/LibraryWindow.vala"
	_tmp15_ = _tmp14_;
#line 90 "../src/LibraryWindow.vala"
	_tmp15__length1 = 1;
#line 90 "../src/LibraryWindow.vala"
	gtk_application_set_accels_for_action (application, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_VIEW_COLUMNS, _tmp15_);
#line 90 "../src/LibraryWindow.vala"
	_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
#line 83 "../src/LibraryWindow.vala"
	return self;
#line 848 "LibraryWindow.c"
}

MusicLibraryWindow*
music_library_window_new (GtkApplication* application)
{
#line 83 "../src/LibraryWindow.vala"
	return music_library_window_construct (MUSIC_TYPE_LIBRARY_WINDOW, application);
#line 856 "LibraryWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 164 "../src/LibraryWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 864 "LibraryWindow.c"
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1262 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1263 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1263 "glib-2.0.vapi"
	return result;
#line 878 "LibraryWindow.c"
}

static gboolean
_vala_unichar_array_contains (gunichar * stack,
                              gssize stack_length,
                              const gunichar needle)
{
	gssize i;
#line 184 "../src/LibraryWindow.vala"
	for (i = 0; i < stack_length; i++) {
#line 184 "../src/LibraryWindow.vala"
		if (needle == stack[i]) {
#line 184 "../src/LibraryWindow.vala"
			return TRUE;
#line 893 "LibraryWindow.c"
		}
	}
#line 184 "../src/LibraryWindow.vala"
	return FALSE;
#line 898 "LibraryWindow.c"
}

static gboolean
music_library_window_real_key_press_event (GtkWidget* base,
                                           GdkEventKey* event)
{
	MusicLibraryWindow * self;
	GtkWidget* focus_widget = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkWidget* _tmp3_;
	GdkModifierType modifiers = 0U;
	gboolean modifiers_active = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean result;
#line 162 "../src/LibraryWindow.vala"
	self = (MusicLibraryWindow*) base;
#line 162 "../src/LibraryWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 164 "../src/LibraryWindow.vala"
	_tmp0_ = gtk_window_get_focus ((GtkWindow*) self);
#line 164 "../src/LibraryWindow.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 164 "../src/LibraryWindow.vala"
	focus_widget = _tmp1_;
#line 165 "../src/LibraryWindow.vala"
	_tmp3_ = focus_widget;
#line 165 "../src/LibraryWindow.vala"
	if (_tmp3_ != NULL) {
#line 929 "LibraryWindow.c"
		GtkWidget* _tmp4_;
#line 165 "../src/LibraryWindow.vala"
		_tmp4_ = focus_widget;
#line 165 "../src/LibraryWindow.vala"
		_tmp2_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gtk_editable_get_type ());
#line 935 "LibraryWindow.c"
	} else {
#line 165 "../src/LibraryWindow.vala"
		_tmp2_ = FALSE;
#line 939 "LibraryWindow.c"
	}
#line 165 "../src/LibraryWindow.vala"
	if (_tmp2_) {
#line 166 "../src/LibraryWindow.vala"
		result = GTK_WIDGET_CLASS (music_library_window_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), event);
#line 166 "../src/LibraryWindow.vala"
		_g_object_unref0 (focus_widget);
#line 166 "../src/LibraryWindow.vala"
		return result;
#line 949 "LibraryWindow.c"
	}
#line 168 "../src/LibraryWindow.vala"
	modifiers = gtk_accelerator_get_default_mod_mask ();
#line 169 "../src/LibraryWindow.vala"
	modifiers_active = (event->state & modifiers) != 0;
#line 171 "../src/LibraryWindow.vala"
	if (!modifiers_active) {
#line 957 "LibraryWindow.c"
		gboolean _tmp6_;
#line 171 "../src/LibraryWindow.vala"
		_tmp6_ = self->priv->_search_field_has_focus;
#line 171 "../src/LibraryWindow.vala"
		_tmp5_ = _tmp6_;
#line 963 "LibraryWindow.c"
	} else {
#line 171 "../src/LibraryWindow.vala"
		_tmp5_ = FALSE;
#line 967 "LibraryWindow.c"
	}
#line 171 "../src/LibraryWindow.vala"
	if (_tmp5_) {
#line 971 "LibraryWindow.c"
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		gunichar typed_unichar = 0U;
		const gchar* _tmp15_;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
#line 172 "../src/LibraryWindow.vala"
		if (event->keyval == GDK_KEY_space) {
#line 980 "LibraryWindow.c"
			GtkSearchEntry* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
#line 172 "../src/LibraryWindow.vala"
			_tmp9_ = self->priv->_search_entry;
#line 172 "../src/LibraryWindow.vala"
			g_object_get ((GtkWidget*) _tmp9_, "has-focus", &_tmp10_, NULL);
#line 172 "../src/LibraryWindow.vala"
			_tmp11_ = _tmp10_;
#line 172 "../src/LibraryWindow.vala"
			_tmp8_ = !_tmp11_;
#line 992 "LibraryWindow.c"
		} else {
#line 172 "../src/LibraryWindow.vala"
			_tmp8_ = FALSE;
#line 996 "LibraryWindow.c"
		}
#line 172 "../src/LibraryWindow.vala"
		if (_tmp8_) {
#line 1000 "LibraryWindow.c"
			MusicSourceListView* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
#line 172 "../src/LibraryWindow.vala"
			_tmp12_ = self->priv->_source_list_view;
#line 172 "../src/LibraryWindow.vala"
			_tmp13_ = granite_widgets_source_list_get_editing ((GraniteWidgetsSourceList*) _tmp12_);
#line 172 "../src/LibraryWindow.vala"
			_tmp14_ = _tmp13_;
#line 172 "../src/LibraryWindow.vala"
			_tmp7_ = !_tmp14_;
#line 1012 "LibraryWindow.c"
		} else {
#line 172 "../src/LibraryWindow.vala"
			_tmp7_ = FALSE;
#line 1016 "LibraryWindow.c"
		}
#line 172 "../src/LibraryWindow.vala"
		if (_tmp7_) {
#line 173 "../src/LibraryWindow.vala"
			music_library_window_play_media (self, FALSE);
#line 174 "../src/LibraryWindow.vala"
			result = TRUE;
#line 174 "../src/LibraryWindow.vala"
			_g_object_unref0 (focus_widget);
#line 174 "../src/LibraryWindow.vala"
			return result;
#line 1028 "LibraryWindow.c"
		}
#line 177 "../src/LibraryWindow.vala"
		_tmp15_ = event->string;
#line 177 "../src/LibraryWindow.vala"
		typed_unichar = string_get_char (_tmp15_, (glong) 0);
#line 179 "../src/LibraryWindow.vala"
		if (g_unichar_validate (typed_unichar)) {
#line 1036 "LibraryWindow.c"
			GtkSearchEntry* _tmp18_;
			gboolean _tmp19_;
			gboolean _tmp20_;
#line 179 "../src/LibraryWindow.vala"
			_tmp18_ = self->priv->_search_entry;
#line 179 "../src/LibraryWindow.vala"
			_tmp19_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp18_);
#line 179 "../src/LibraryWindow.vala"
			_tmp20_ = _tmp19_;
#line 179 "../src/LibraryWindow.vala"
			_tmp17_ = _tmp20_;
#line 1048 "LibraryWindow.c"
		} else {
#line 179 "../src/LibraryWindow.vala"
			_tmp17_ = FALSE;
#line 1052 "LibraryWindow.c"
		}
#line 179 "../src/LibraryWindow.vala"
		if (_tmp17_) {
#line 1056 "LibraryWindow.c"
			GtkSearchEntry* _tmp21_;
			gboolean _tmp22_;
			gboolean _tmp23_;
#line 179 "../src/LibraryWindow.vala"
			_tmp21_ = self->priv->_search_entry;
#line 179 "../src/LibraryWindow.vala"
			g_object_get ((GtkWidget*) _tmp21_, "has-focus", &_tmp22_, NULL);
#line 179 "../src/LibraryWindow.vala"
			_tmp23_ = _tmp22_;
#line 179 "../src/LibraryWindow.vala"
			_tmp16_ = !_tmp23_;
#line 1068 "LibraryWindow.c"
		} else {
#line 179 "../src/LibraryWindow.vala"
			_tmp16_ = FALSE;
#line 1072 "LibraryWindow.c"
		}
#line 179 "../src/LibraryWindow.vala"
		if (_tmp16_) {
#line 1076 "LibraryWindow.c"
			gunichar* special_chars = NULL;
			gunichar* _tmp24_;
			gint special_chars_length1;
			gint _special_chars_size_;
			gboolean _tmp25_ = FALSE;
#line 180 "../src/LibraryWindow.vala"
			_tmp24_ = g_new0 (gunichar, 27);
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[0] = (gunichar) '&';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[1] = (gunichar) '.';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[2] = (gunichar) '-';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[3] = (gunichar) '\\';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[4] = (gunichar) '%';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[5] = (gunichar) '(';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[6] = (gunichar) ')';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[7] = (gunichar) '=';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[8] = (gunichar) '@';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[9] = (gunichar) '#';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[10] = (gunichar) '+';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[11] = (gunichar) '<';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[12] = (gunichar) '>';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[13] = (gunichar) ';';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[14] = (gunichar) ':';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[15] = 191U;
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[16] = (gunichar) '?';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[17] = 161U;
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[18] = (gunichar) '_';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[19] = 168U;
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[20] = (gunichar) '*';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[21] = (gunichar) '$';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[22] = (gunichar) '"';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[23] = (gunichar) '[';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[24] = (gunichar) ']';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[25] = (gunichar) '!';
#line 180 "../src/LibraryWindow.vala"
			_tmp24_[26] = (gunichar) '~';
#line 180 "../src/LibraryWindow.vala"
			special_chars = _tmp24_;
#line 180 "../src/LibraryWindow.vala"
			special_chars_length1 = 27;
#line 180 "../src/LibraryWindow.vala"
			_special_chars_size_ = special_chars_length1;
#line 184 "../src/LibraryWindow.vala"
			if (g_unichar_isalnum (typed_unichar)) {
#line 184 "../src/LibraryWindow.vala"
				_tmp25_ = TRUE;
#line 1148 "LibraryWindow.c"
			} else {
				gunichar* _tmp26_;
				gint _tmp26__length1;
#line 184 "../src/LibraryWindow.vala"
				_tmp26_ = special_chars;
#line 184 "../src/LibraryWindow.vala"
				_tmp26__length1 = special_chars_length1;
#line 184 "../src/LibraryWindow.vala"
				_tmp25_ = _vala_unichar_array_contains (_tmp26_, _tmp26__length1, typed_unichar);
#line 1158 "LibraryWindow.c"
			}
#line 184 "../src/LibraryWindow.vala"
			if (_tmp25_) {
#line 185 "../src/LibraryWindow.vala"
				music_library_window_action_search (self);
#line 1164 "LibraryWindow.c"
			}
#line 179 "../src/LibraryWindow.vala"
			special_chars = (g_free (special_chars), NULL);
#line 1168 "LibraryWindow.c"
		}
	}
#line 190 "../src/LibraryWindow.vala"
	result = GTK_WIDGET_CLASS (music_library_window_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), event);
#line 190 "../src/LibraryWindow.vala"
	_g_object_unref0 (focus_widget);
#line 190 "../src/LibraryWindow.vala"
	return result;
#line 1177 "LibraryWindow.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 193 "../src/LibraryWindow.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 193 "../src/LibraryWindow.vala"
	return _data3_;
#line 1187 "LibraryWindow.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 193 "../src/LibraryWindow.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1197 "LibraryWindow.c"
		MusicLibraryWindow* self;
#line 193 "../src/LibraryWindow.vala"
		self = _data3_->self;
#line 193 "../src/LibraryWindow.vala"
		_g_object_unref0 (_data3_->play_button);
#line 193 "../src/LibraryWindow.vala"
		_g_object_unref0 (self);
#line 193 "../src/LibraryWindow.vala"
		g_slice_free (Block3Data, _data3_);
#line 1207 "LibraryWindow.c"
	}
}

static void
_music_library_window_on_quit_gtk_widget_destroy (GtkWidget* _sender,
                                                  gpointer self)
{
#line 213 "../src/LibraryWindow.vala"
	music_library_window_on_quit ((MusicLibraryWindow*) self);
#line 1217 "LibraryWindow.c"
}

static void
_music_library_window_edit_preferences_click_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                     gpointer self)
{
#line 220 "../src/LibraryWindow.vala"
	music_library_window_edit_preferences_click ((MusicLibraryWindow*) self);
#line 1226 "LibraryWindow.c"
}

static void
__lambda134_ (Block3Data* _data3_,
              const gchar* name,
              GVariant* new_state)
{
	MusicLibraryWindow* self;
#line 304 "../src/LibraryWindow.vala"
	self = _data3_->self;
#line 304 "../src/LibraryWindow.vala"
	g_return_if_fail (name != NULL);
#line 304 "../src/LibraryWindow.vala"
	g_return_if_fail (new_state != NULL);
#line 305 "../src/LibraryWindow.vala"
	if (g_strcmp0 (name, MUSIC_LIBRARY_WINDOW_ACTION_PLAY) == 0) {
#line 306 "../src/LibraryWindow.vala"
		if (g_variant_get_boolean (new_state) == FALSE) {
#line 1245 "LibraryWindow.c"
			GtkButton* _tmp0_;
			GtkImage* _tmp1_;
			GtkImage* _tmp2_;
			GtkButton* _tmp3_;
#line 307 "../src/LibraryWindow.vala"
			_tmp0_ = _data3_->play_button;
#line 307 "../src/LibraryWindow.vala"
			_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-start-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 307 "../src/LibraryWindow.vala"
			g_object_ref_sink (_tmp1_);
#line 307 "../src/LibraryWindow.vala"
			_tmp2_ = _tmp1_;
#line 307 "../src/LibraryWindow.vala"
			gtk_button_set_image (_tmp0_, (GtkWidget*) _tmp2_);
#line 307 "../src/LibraryWindow.vala"
			_g_object_unref0 (_tmp2_);
#line 311 "../src/LibraryWindow.vala"
			_tmp3_ = _data3_->play_button;
#line 311 "../src/LibraryWindow.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, _ ("Play"));
#line 1266 "LibraryWindow.c"
		} else {
			GtkButton* _tmp4_;
			GtkImage* _tmp5_;
			GtkImage* _tmp6_;
			GtkButton* _tmp7_;
#line 313 "../src/LibraryWindow.vala"
			_tmp4_ = _data3_->play_button;
#line 313 "../src/LibraryWindow.vala"
			_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-pause-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 313 "../src/LibraryWindow.vala"
			g_object_ref_sink (_tmp5_);
#line 313 "../src/LibraryWindow.vala"
			_tmp6_ = _tmp5_;
#line 313 "../src/LibraryWindow.vala"
			gtk_button_set_image (_tmp4_, (GtkWidget*) _tmp6_);
#line 313 "../src/LibraryWindow.vala"
			_g_object_unref0 (_tmp6_);
#line 317 "../src/LibraryWindow.vala"
			_tmp7_ = _data3_->play_button;
#line 317 "../src/LibraryWindow.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp7_, _ ("Pause"));
#line 1288 "LibraryWindow.c"
		}
	}
}

static void
___lambda134__g_action_group_action_state_changed (GActionGroup* _sender,
                                                   const gchar* action_name,
                                                   GVariant* state,
                                                   gpointer self)
{
#line 304 "../src/LibraryWindow.vala"
	__lambda134_ (self, action_name, state);
#line 1301 "LibraryWindow.c"
}

static void
__lambda135_ (MusicLibraryWindow* self)
{
	MusicViewStack* _tmp0_;
#line 323 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->_view_stack;
#line 323 "../src/LibraryWindow.vala"
	music_view_stack_hide_alert (_tmp0_);
#line 1312 "LibraryWindow.c"
}

static void
___lambda135__music_library_search_finished (MusicLibrary* _sender,
                                             gpointer self)
{
#line 322 "../src/LibraryWindow.vala"
	__lambda135_ ((MusicLibraryWindow*) self);
#line 1321 "LibraryWindow.c"
}

static void
__lambda137_ (MusicLibraryWindow* self)
{
	MusicViewStack* _tmp0_;
#line 328 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->_view_stack;
#line 328 "../src/LibraryWindow.vala"
	music_view_stack_hide_alert (_tmp0_);
#line 1332 "LibraryWindow.c"
}

static void
___lambda137__music_library_search_finished (MusicLibrary* _sender,
                                             gpointer self)
{
#line 327 "../src/LibraryWindow.vala"
	__lambda137_ ((MusicLibraryWindow*) self);
#line 1341 "LibraryWindow.c"
}

static void
__lambda136_ (MusicLibraryWindow* self,
              MusicLibrary* lib)
{
#line 326 "../src/LibraryWindow.vala"
	g_return_if_fail (lib != NULL);
#line 327 "../src/LibraryWindow.vala"
	g_signal_connect_object (lib, "search-finished", (GCallback) ___lambda137__music_library_search_finished, self, 0);
#line 1352 "LibraryWindow.c"
}

static void
___lambda136__music_libraries_manager_library_added (MusicLibrariesManager* _sender,
                                                     MusicLibrary* library,
                                                     gpointer self)
{
#line 326 "../src/LibraryWindow.vala"
	__lambda136_ ((MusicLibraryWindow*) self, library);
#line 1362 "LibraryWindow.c"
}

static void
__lambda138_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
	MusicViewStack* _tmp0_;
#line 332 "../src/LibraryWindow.vala"
	g_return_if_fail (view != NULL);
#line 333 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->_view_stack;
#line 333 "../src/LibraryWindow.vala"
	gtk_stack_set_visible_child ((GtkStack*) _tmp0_, (GtkWidget*) view);
#line 1376 "LibraryWindow.c"
}

static void
___lambda138__music_source_list_view_selection_changed (MusicSourceListView* _sender,
                                                        GtkGrid* view,
                                                        gpointer self)
{
#line 332 "../src/LibraryWindow.vala"
	__lambda138_ ((MusicLibraryWindow*) self, view);
#line 1386 "LibraryWindow.c"
}

static void
__lambda139_ (MusicLibraryWindow* self)
{
#line 337 "../src/LibraryWindow.vala"
	music_library_window_set_search_field_has_focus (self, FALSE);
#line 1394 "LibraryWindow.c"
}

static void
___lambda139__music_source_list_view_activated (MusicSourceListView* _sender,
                                                gpointer self)
{
#line 336 "../src/LibraryWindow.vala"
	__lambda139_ ((MusicLibraryWindow*) self);
#line 1403 "LibraryWindow.c"
}

static void
__lambda140_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
#line 340 "../src/LibraryWindow.vala"
	g_return_if_fail (view != NULL);
#line 341 "../src/LibraryWindow.vala"
	if (MUSIC_IS_DEVICE_VIEW (view)) {
#line 1414 "LibraryWindow.c"
		MusicDevice* _tmp0_;
		MusicDevice* _tmp1_;
#line 342 "../src/LibraryWindow.vala"
		_tmp0_ = music_device_view_get_device (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_DEVICE_VIEW, MusicDeviceView));
#line 342 "../src/LibraryWindow.vala"
		_tmp1_ = _tmp0_;
#line 342 "../src/LibraryWindow.vala"
		music_device_eject (_tmp1_);
#line 1423 "LibraryWindow.c"
	}
}

static void
___lambda140__music_source_list_view_item_action_activated (MusicSourceListView* _sender,
                                                            GtkGrid* view,
                                                            gpointer self)
{
#line 340 "../src/LibraryWindow.vala"
	__lambda140_ ((MusicLibraryWindow*) self, view);
#line 1434 "LibraryWindow.c"
}

static void
_music_library_window_playlist_name_edited_music_source_list_view_edited (MusicSourceListView* _sender,
                                                                          GtkGrid* view,
                                                                          const gchar* new_name,
                                                                          gpointer self)
{
#line 345 "../src/LibraryWindow.vala"
	music_library_window_playlist_name_edited ((MusicLibraryWindow*) self, view, new_name);
#line 1445 "LibraryWindow.c"
}

static void
__lambda143_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
#line 347 "../src/LibraryWindow.vala"
	g_return_if_fail (view != NULL);
#line 348 "../src/LibraryWindow.vala"
	if (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view)) {
#line 349 "../src/LibraryWindow.vala"
		music_library_window_set_search_field_has_focus (self, FALSE);
#line 1458 "LibraryWindow.c"
	}
}

static void
___lambda143__music_source_list_view_playlist_rename_clicked (MusicSourceListView* _sender,
                                                              GtkGrid* view,
                                                              gpointer self)
{
#line 347 "../src/LibraryWindow.vala"
	__lambda143_ ((MusicLibraryWindow*) self, view);
#line 1469 "LibraryWindow.c"
}

static void
__lambda144_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
#line 353 "../src/LibraryWindow.vala"
	g_return_if_fail (view != NULL);
#line 354 "../src/LibraryWindow.vala"
	if (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view)) {
#line 1480 "LibraryWindow.c"
		MusicPlaylist* p = NULL;
		MusicPlaylist* _tmp0_;
		MusicPlaylist* _tmp1_;
		MusicPlaylist* _tmp2_;
		MusicPlaylist* _tmp3_;
#line 355 "../src/LibraryWindow.vala"
		_tmp0_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapper));
#line 355 "../src/LibraryWindow.vala"
		_tmp1_ = _tmp0_;
#line 355 "../src/LibraryWindow.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 355 "../src/LibraryWindow.vala"
		p = _tmp2_;
#line 356 "../src/LibraryWindow.vala"
		_tmp3_ = p;
#line 356 "../src/LibraryWindow.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, MUSIC_TYPE_SMART_PLAYLIST)) {
#line 1498 "LibraryWindow.c"
			MusicPlaylist* _tmp4_;
#line 357 "../src/LibraryWindow.vala"
			_tmp4_ = p;
#line 357 "../src/LibraryWindow.vala"
			music_library_window_show_smart_playlist_dialog (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist));
#line 1504 "LibraryWindow.c"
		}
#line 354 "../src/LibraryWindow.vala"
		_g_object_unref0 (p);
#line 1508 "LibraryWindow.c"
	}
}

static void
___lambda144__music_source_list_view_playlist_edit_clicked (MusicSourceListView* _sender,
                                                            GtkGrid* view,
                                                            gpointer self)
{
#line 353 "../src/LibraryWindow.vala"
	__lambda144_ ((MusicLibraryWindow*) self, view);
#line 1519 "LibraryWindow.c"
}

static void
__lambda145_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
#line 362 "../src/LibraryWindow.vala"
	g_return_if_fail (view != NULL);
#line 363 "../src/LibraryWindow.vala"
	if (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view)) {
#line 1530 "LibraryWindow.c"
		MusicPlaylistViewWrapper* playlistview = NULL;
		MusicPlaylistViewWrapper* _tmp0_;
		MusicPlaylistViewWrapper* _tmp1_;
		MusicViewWrapperHint _tmp2_;
		MusicViewWrapperHint _tmp3_;
#line 364 "../src/LibraryWindow.vala"
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapper));
#line 364 "../src/LibraryWindow.vala"
		playlistview = _tmp0_;
#line 365 "../src/LibraryWindow.vala"
		_tmp1_ = playlistview;
#line 365 "../src/LibraryWindow.vala"
		_tmp2_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp1_);
#line 365 "../src/LibraryWindow.vala"
		_tmp3_ = _tmp2_;
#line 365 "../src/LibraryWindow.vala"
		if (_tmp3_ == MUSIC_VIEW_WRAPPER_HINT_PLAYLIST) {
#line 1548 "LibraryWindow.c"
			MusicPlaylistViewWrapper* _tmp4_;
			MusicLibrary* _tmp5_;
			MusicLibrary* _tmp6_;
			MusicPlaylistViewWrapper* _tmp7_;
			MusicPlaylist* _tmp8_;
			MusicPlaylist* _tmp9_;
			gint64 _tmp10_;
			gint64 _tmp11_;
#line 366 "../src/LibraryWindow.vala"
			_tmp4_ = playlistview;
#line 366 "../src/LibraryWindow.vala"
			_tmp5_ = music_view_wrapper_get_library ((MusicViewWrapper*) _tmp4_);
#line 366 "../src/LibraryWindow.vala"
			_tmp6_ = _tmp5_;
#line 366 "../src/LibraryWindow.vala"
			_tmp7_ = playlistview;
#line 366 "../src/LibraryWindow.vala"
			_tmp8_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp7_);
#line 366 "../src/LibraryWindow.vala"
			_tmp9_ = _tmp8_;
#line 366 "../src/LibraryWindow.vala"
			_tmp10_ = music_playlist_get_rowid (_tmp9_);
#line 366 "../src/LibraryWindow.vala"
			_tmp11_ = _tmp10_;
#line 366 "../src/LibraryWindow.vala"
			music_library_remove_playlist (_tmp6_, _tmp11_);
#line 1575 "LibraryWindow.c"
		} else {
			MusicPlaylistViewWrapper* _tmp12_;
			MusicViewWrapperHint _tmp13_;
			MusicViewWrapperHint _tmp14_;
#line 367 "../src/LibraryWindow.vala"
			_tmp12_ = playlistview;
#line 367 "../src/LibraryWindow.vala"
			_tmp13_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp12_);
#line 367 "../src/LibraryWindow.vala"
			_tmp14_ = _tmp13_;
#line 367 "../src/LibraryWindow.vala"
			if (_tmp14_ == MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST) {
#line 1588 "LibraryWindow.c"
				MusicPlaylistViewWrapper* _tmp15_;
				MusicLibrary* _tmp16_;
				MusicLibrary* _tmp17_;
				MusicPlaylistViewWrapper* _tmp18_;
				MusicPlaylist* _tmp19_;
				MusicPlaylist* _tmp20_;
				gint64 _tmp21_;
				gint64 _tmp22_;
#line 368 "../src/LibraryWindow.vala"
				_tmp15_ = playlistview;
#line 368 "../src/LibraryWindow.vala"
				_tmp16_ = music_view_wrapper_get_library ((MusicViewWrapper*) _tmp15_);
#line 368 "../src/LibraryWindow.vala"
				_tmp17_ = _tmp16_;
#line 368 "../src/LibraryWindow.vala"
				_tmp18_ = playlistview;
#line 368 "../src/LibraryWindow.vala"
				_tmp19_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp18_);
#line 368 "../src/LibraryWindow.vala"
				_tmp20_ = _tmp19_;
#line 368 "../src/LibraryWindow.vala"
				_tmp21_ = music_playlist_get_rowid (_tmp20_);
#line 368 "../src/LibraryWindow.vala"
				_tmp22_ = _tmp21_;
#line 368 "../src/LibraryWindow.vala"
				music_library_remove_smart_playlist (_tmp17_, _tmp22_);
#line 1615 "LibraryWindow.c"
			}
		}
#line 363 "../src/LibraryWindow.vala"
		_g_object_unref0 (playlistview);
#line 1620 "LibraryWindow.c"
	}
}

static void
___lambda145__music_source_list_view_playlist_remove_clicked (MusicSourceListView* _sender,
                                                              GtkGrid* view,
                                                              gpointer self)
{
#line 362 "../src/LibraryWindow.vala"
	__lambda145_ ((MusicLibraryWindow*) self, view);
#line 1631 "LibraryWindow.c"
}

static void
__lambda146_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
#line 373 "../src/LibraryWindow.vala"
	g_return_if_fail (view != NULL);
#line 374 "../src/LibraryWindow.vala"
	if (MUSIC_IS_DEVICE_VIEW_WRAPPER (view)) {
#line 1642 "LibraryWindow.c"
		{
			GeeIterator* _device_it = NULL;
			MusicDeviceManager* _tmp0_;
			MusicDeviceManager* _tmp1_;
			GeeCollection* _tmp2_;
			GeeCollection* _tmp3_;
			GeeIterator* _tmp4_;
			GeeIterator* _tmp5_;
#line 375 "../src/LibraryWindow.vala"
			_tmp0_ = music_device_manager_get_default ();
#line 375 "../src/LibraryWindow.vala"
			_tmp1_ = _tmp0_;
#line 375 "../src/LibraryWindow.vala"
			_tmp2_ = music_device_manager_get_initialized_devices (_tmp1_);
#line 375 "../src/LibraryWindow.vala"
			_tmp3_ = _tmp2_;
#line 375 "../src/LibraryWindow.vala"
			_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 375 "../src/LibraryWindow.vala"
			_tmp5_ = _tmp4_;
#line 375 "../src/LibraryWindow.vala"
			_g_object_unref0 (_tmp3_);
#line 375 "../src/LibraryWindow.vala"
			_g_object_unref0 (_tmp1_);
#line 375 "../src/LibraryWindow.vala"
			_device_it = _tmp5_;
#line 375 "../src/LibraryWindow.vala"
			while (TRUE) {
#line 1671 "LibraryWindow.c"
				GeeIterator* _tmp6_;
				MusicDevice* device = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				MusicDevice* _tmp9_;
				MusicDevice* _tmp10_;
				MusicDevice* _tmp11_;
#line 375 "../src/LibraryWindow.vala"
				_tmp6_ = _device_it;
#line 375 "../src/LibraryWindow.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 375 "../src/LibraryWindow.vala"
					break;
#line 1685 "LibraryWindow.c"
				}
#line 375 "../src/LibraryWindow.vala"
				_tmp7_ = _device_it;
#line 375 "../src/LibraryWindow.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 375 "../src/LibraryWindow.vala"
				device = (MusicDevice*) _tmp8_;
#line 376 "../src/LibraryWindow.vala"
				_tmp9_ = music_device_view_wrapper_get_d (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper));
#line 376 "../src/LibraryWindow.vala"
				_tmp10_ = _tmp9_;
#line 376 "../src/LibraryWindow.vala"
				_tmp11_ = device;
#line 376 "../src/LibraryWindow.vala"
				if (_tmp10_ == _tmp11_) {
#line 1701 "LibraryWindow.c"
					MusicLibrariesManager* _tmp12_;
					MusicDevice* _tmp13_;
					MusicLibrary* _tmp14_;
					MusicLibrary* _tmp15_;
					GeeCollection* _tmp16_;
					GeeCollection* _tmp17_;
#line 377 "../src/LibraryWindow.vala"
					_tmp12_ = music_libraries_manager;
#line 377 "../src/LibraryWindow.vala"
					_tmp13_ = device;
#line 377 "../src/LibraryWindow.vala"
					_tmp14_ = music_device_get_library (_tmp13_);
#line 377 "../src/LibraryWindow.vala"
					_tmp15_ = _tmp14_;
#line 377 "../src/LibraryWindow.vala"
					_tmp16_ = music_library_get_medias (_tmp15_);
#line 377 "../src/LibraryWindow.vala"
					_tmp17_ = _tmp16_;
#line 377 "../src/LibraryWindow.vala"
					music_libraries_manager_transfer_to_local_library (_tmp12_, _tmp17_);
#line 377 "../src/LibraryWindow.vala"
					_g_object_unref0 (_tmp17_);
#line 377 "../src/LibraryWindow.vala"
					_g_object_unref0 (_tmp15_);
#line 378 "../src/LibraryWindow.vala"
					break;
#line 1728 "LibraryWindow.c"
				}
			}
#line 375 "../src/LibraryWindow.vala"
			_g_object_unref0 (_device_it);
#line 1733 "LibraryWindow.c"
		}
	}
}

static void
___lambda146__music_source_list_view_device_import_clicked (MusicSourceListView* _sender,
                                                            GtkGrid* view,
                                                            gpointer self)
{
#line 373 "../src/LibraryWindow.vala"
	__lambda146_ ((MusicLibraryWindow*) self, view);
#line 1745 "LibraryWindow.c"
}

static void
__lambda147_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
#line 384 "../src/LibraryWindow.vala"
	g_return_if_fail (view != NULL);
#line 385 "../src/LibraryWindow.vala"
	if (MUSIC_IS_DEVICE_VIEW_WRAPPER (view)) {
#line 1756 "LibraryWindow.c"
		{
			GeeIterator* _device_it = NULL;
			MusicDeviceManager* _tmp0_;
			MusicDeviceManager* _tmp1_;
			GeeCollection* _tmp2_;
			GeeCollection* _tmp3_;
			GeeIterator* _tmp4_;
			GeeIterator* _tmp5_;
#line 386 "../src/LibraryWindow.vala"
			_tmp0_ = music_device_manager_get_default ();
#line 386 "../src/LibraryWindow.vala"
			_tmp1_ = _tmp0_;
#line 386 "../src/LibraryWindow.vala"
			_tmp2_ = music_device_manager_get_initialized_devices (_tmp1_);
#line 386 "../src/LibraryWindow.vala"
			_tmp3_ = _tmp2_;
#line 386 "../src/LibraryWindow.vala"
			_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 386 "../src/LibraryWindow.vala"
			_tmp5_ = _tmp4_;
#line 386 "../src/LibraryWindow.vala"
			_g_object_unref0 (_tmp3_);
#line 386 "../src/LibraryWindow.vala"
			_g_object_unref0 (_tmp1_);
#line 386 "../src/LibraryWindow.vala"
			_device_it = _tmp5_;
#line 386 "../src/LibraryWindow.vala"
			while (TRUE) {
#line 1785 "LibraryWindow.c"
				GeeIterator* _tmp6_;
				MusicDevice* device = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				MusicDevice* _tmp9_;
				MusicDevice* _tmp10_;
				MusicDevice* _tmp11_;
#line 386 "../src/LibraryWindow.vala"
				_tmp6_ = _device_it;
#line 386 "../src/LibraryWindow.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 386 "../src/LibraryWindow.vala"
					break;
#line 1799 "LibraryWindow.c"
				}
#line 386 "../src/LibraryWindow.vala"
				_tmp7_ = _device_it;
#line 386 "../src/LibraryWindow.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 386 "../src/LibraryWindow.vala"
				device = (MusicDevice*) _tmp8_;
#line 387 "../src/LibraryWindow.vala"
				_tmp9_ = music_device_view_wrapper_get_d (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper));
#line 387 "../src/LibraryWindow.vala"
				_tmp10_ = _tmp9_;
#line 387 "../src/LibraryWindow.vala"
				_tmp11_ = device;
#line 387 "../src/LibraryWindow.vala"
				if (_tmp10_ == _tmp11_) {
#line 1815 "LibraryWindow.c"
					MusicDevice* _tmp12_;
					MusicLibrary* _tmp13_;
					MusicLibrary* _tmp14_;
#line 388 "../src/LibraryWindow.vala"
					_tmp12_ = device;
#line 388 "../src/LibraryWindow.vala"
					_tmp13_ = music_device_get_library (_tmp12_);
#line 388 "../src/LibraryWindow.vala"
					_tmp14_ = _tmp13_;
#line 388 "../src/LibraryWindow.vala"
					music_library_window_create_new_playlist (self, _tmp14_);
#line 388 "../src/LibraryWindow.vala"
					_g_object_unref0 (_tmp14_);
#line 389 "../src/LibraryWindow.vala"
					break;
#line 1831 "LibraryWindow.c"
				}
			}
#line 386 "../src/LibraryWindow.vala"
			_g_object_unref0 (_device_it);
#line 1836 "LibraryWindow.c"
		}
	}
}

static void
___lambda147__music_source_list_view_device_new_playlist_clicked (MusicSourceListView* _sender,
                                                                  GtkGrid* view,
                                                                  gpointer self)
{
#line 384 "../src/LibraryWindow.vala"
	__lambda147_ ((MusicLibraryWindow*) self, view);
#line 1848 "LibraryWindow.c"
}

static void
__lambda148_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
#line 395 "../src/LibraryWindow.vala"
	g_return_if_fail (view != NULL);
#line 396 "../src/LibraryWindow.vala"
	if (MUSIC_IS_DEVICE_VIEW_WRAPPER (view)) {
#line 1859 "LibraryWindow.c"
		{
			GeeIterator* _device_it = NULL;
			MusicDeviceManager* _tmp0_;
			MusicDeviceManager* _tmp1_;
			GeeCollection* _tmp2_;
			GeeCollection* _tmp3_;
			GeeIterator* _tmp4_;
			GeeIterator* _tmp5_;
#line 397 "../src/LibraryWindow.vala"
			_tmp0_ = music_device_manager_get_default ();
#line 397 "../src/LibraryWindow.vala"
			_tmp1_ = _tmp0_;
#line 397 "../src/LibraryWindow.vala"
			_tmp2_ = music_device_manager_get_initialized_devices (_tmp1_);
#line 397 "../src/LibraryWindow.vala"
			_tmp3_ = _tmp2_;
#line 397 "../src/LibraryWindow.vala"
			_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 397 "../src/LibraryWindow.vala"
			_tmp5_ = _tmp4_;
#line 397 "../src/LibraryWindow.vala"
			_g_object_unref0 (_tmp3_);
#line 397 "../src/LibraryWindow.vala"
			_g_object_unref0 (_tmp1_);
#line 397 "../src/LibraryWindow.vala"
			_device_it = _tmp5_;
#line 397 "../src/LibraryWindow.vala"
			while (TRUE) {
#line 1888 "LibraryWindow.c"
				GeeIterator* _tmp6_;
				MusicDevice* device = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				MusicDevice* _tmp9_;
				MusicDevice* _tmp10_;
				MusicDevice* _tmp11_;
#line 397 "../src/LibraryWindow.vala"
				_tmp6_ = _device_it;
#line 397 "../src/LibraryWindow.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 397 "../src/LibraryWindow.vala"
					break;
#line 1902 "LibraryWindow.c"
				}
#line 397 "../src/LibraryWindow.vala"
				_tmp7_ = _device_it;
#line 397 "../src/LibraryWindow.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 397 "../src/LibraryWindow.vala"
				device = (MusicDevice*) _tmp8_;
#line 398 "../src/LibraryWindow.vala"
				_tmp9_ = music_device_view_wrapper_get_d (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper));
#line 398 "../src/LibraryWindow.vala"
				_tmp10_ = _tmp9_;
#line 398 "../src/LibraryWindow.vala"
				_tmp11_ = device;
#line 398 "../src/LibraryWindow.vala"
				if (_tmp10_ == _tmp11_) {
#line 1918 "LibraryWindow.c"
					MusicDevice* _tmp12_;
#line 399 "../src/LibraryWindow.vala"
					_tmp12_ = device;
#line 399 "../src/LibraryWindow.vala"
					music_device_synchronize (_tmp12_);
#line 400 "../src/LibraryWindow.vala"
					break;
#line 1926 "LibraryWindow.c"
				}
			}
#line 397 "../src/LibraryWindow.vala"
			_g_object_unref0 (_device_it);
#line 1931 "LibraryWindow.c"
		}
	}
}

static void
___lambda148__music_source_list_view_device_sync_clicked (MusicSourceListView* _sender,
                                                          GtkGrid* view,
                                                          gpointer self)
{
#line 395 "../src/LibraryWindow.vala"
	__lambda148_ ((MusicLibraryWindow*) self, view);
#line 1943 "LibraryWindow.c"
}

static void
__lambda149_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
#line 406 "../src/LibraryWindow.vala"
	g_return_if_fail (view != NULL);
#line 407 "../src/LibraryWindow.vala"
	if (MUSIC_IS_DEVICE_VIEW_WRAPPER (view)) {
#line 1954 "LibraryWindow.c"
		{
			GeeIterator* _device_it = NULL;
			MusicDeviceManager* _tmp0_;
			MusicDeviceManager* _tmp1_;
			GeeCollection* _tmp2_;
			GeeCollection* _tmp3_;
			GeeIterator* _tmp4_;
			GeeIterator* _tmp5_;
#line 408 "../src/LibraryWindow.vala"
			_tmp0_ = music_device_manager_get_default ();
#line 408 "../src/LibraryWindow.vala"
			_tmp1_ = _tmp0_;
#line 408 "../src/LibraryWindow.vala"
			_tmp2_ = music_device_manager_get_initialized_devices (_tmp1_);
#line 408 "../src/LibraryWindow.vala"
			_tmp3_ = _tmp2_;
#line 408 "../src/LibraryWindow.vala"
			_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 408 "../src/LibraryWindow.vala"
			_tmp5_ = _tmp4_;
#line 408 "../src/LibraryWindow.vala"
			_g_object_unref0 (_tmp3_);
#line 408 "../src/LibraryWindow.vala"
			_g_object_unref0 (_tmp1_);
#line 408 "../src/LibraryWindow.vala"
			_device_it = _tmp5_;
#line 408 "../src/LibraryWindow.vala"
			while (TRUE) {
#line 1983 "LibraryWindow.c"
				GeeIterator* _tmp6_;
				MusicDevice* device = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				MusicDevice* _tmp9_;
				MusicDevice* _tmp10_;
				MusicDevice* _tmp11_;
#line 408 "../src/LibraryWindow.vala"
				_tmp6_ = _device_it;
#line 408 "../src/LibraryWindow.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 408 "../src/LibraryWindow.vala"
					break;
#line 1997 "LibraryWindow.c"
				}
#line 408 "../src/LibraryWindow.vala"
				_tmp7_ = _device_it;
#line 408 "../src/LibraryWindow.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 408 "../src/LibraryWindow.vala"
				device = (MusicDevice*) _tmp8_;
#line 409 "../src/LibraryWindow.vala"
				_tmp9_ = music_device_view_wrapper_get_d (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper));
#line 409 "../src/LibraryWindow.vala"
				_tmp10_ = _tmp9_;
#line 409 "../src/LibraryWindow.vala"
				_tmp11_ = device;
#line 409 "../src/LibraryWindow.vala"
				if (_tmp10_ == _tmp11_) {
#line 2013 "LibraryWindow.c"
					MusicDevice* _tmp12_;
#line 410 "../src/LibraryWindow.vala"
					_tmp12_ = device;
#line 410 "../src/LibraryWindow.vala"
					music_device_eject (_tmp12_);
#line 411 "../src/LibraryWindow.vala"
					break;
#line 2021 "LibraryWindow.c"
				}
			}
#line 408 "../src/LibraryWindow.vala"
			_g_object_unref0 (_device_it);
#line 2026 "LibraryWindow.c"
		}
	}
}

static void
___lambda149__music_source_list_view_device_eject_clicked (MusicSourceListView* _sender,
                                                           GtkGrid* view,
                                                           gpointer self)
{
#line 406 "../src/LibraryWindow.vala"
	__lambda149_ ((MusicLibraryWindow*) self, view);
#line 2038 "LibraryWindow.c"
}

static void
__lambda150_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
#line 417 "../src/LibraryWindow.vala"
	g_return_if_fail (view != NULL);
#line 418 "../src/LibraryWindow.vala"
	if (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view)) {
#line 2049 "LibraryWindow.c"
		MusicPlaylistViewWrapper* playlistview = NULL;
		MusicPlaylistViewWrapper* _tmp0_;
		MusicPlaylistViewWrapper* _tmp1_;
		MusicViewWrapperHint _tmp2_;
		MusicViewWrapperHint _tmp3_;
#line 419 "../src/LibraryWindow.vala"
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapper));
#line 419 "../src/LibraryWindow.vala"
		playlistview = _tmp0_;
#line 420 "../src/LibraryWindow.vala"
		_tmp1_ = playlistview;
#line 420 "../src/LibraryWindow.vala"
		_tmp2_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp1_);
#line 420 "../src/LibraryWindow.vala"
		_tmp3_ = _tmp2_;
#line 420 "../src/LibraryWindow.vala"
		if (_tmp3_ == MUSIC_VIEW_WRAPPER_HINT_PLAYLIST) {
#line 2067 "LibraryWindow.c"
			MusicPlaylistViewWrapper* _tmp4_;
			MusicLibrary* _tmp5_;
			MusicLibrary* _tmp6_;
			MusicPlaylistViewWrapper* _tmp7_;
			MusicPlaylist* _tmp8_;
			MusicPlaylist* _tmp9_;
			gint64 _tmp10_;
			gint64 _tmp11_;
#line 421 "../src/LibraryWindow.vala"
			_tmp4_ = playlistview;
#line 421 "../src/LibraryWindow.vala"
			_tmp5_ = music_view_wrapper_get_library ((MusicViewWrapper*) _tmp4_);
#line 421 "../src/LibraryWindow.vala"
			_tmp6_ = _tmp5_;
#line 421 "../src/LibraryWindow.vala"
			_tmp7_ = playlistview;
#line 421 "../src/LibraryWindow.vala"
			_tmp8_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp7_);
#line 421 "../src/LibraryWindow.vala"
			_tmp9_ = _tmp8_;
#line 421 "../src/LibraryWindow.vala"
			_tmp10_ = music_playlist_get_rowid (_tmp9_);
#line 421 "../src/LibraryWindow.vala"
			_tmp11_ = _tmp10_;
#line 421 "../src/LibraryWindow.vala"
			music_library_remove_playlist (_tmp6_, _tmp11_);
#line 2094 "LibraryWindow.c"
		} else {
			MusicPlaylistViewWrapper* _tmp12_;
			MusicViewWrapperHint _tmp13_;
			MusicViewWrapperHint _tmp14_;
#line 422 "../src/LibraryWindow.vala"
			_tmp12_ = playlistview;
#line 422 "../src/LibraryWindow.vala"
			_tmp13_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp12_);
#line 422 "../src/LibraryWindow.vala"
			_tmp14_ = _tmp13_;
#line 422 "../src/LibraryWindow.vala"
			if (_tmp14_ == MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST) {
#line 2107 "LibraryWindow.c"
				MusicPlaylistViewWrapper* _tmp15_;
				MusicLibrary* _tmp16_;
				MusicLibrary* _tmp17_;
				MusicPlaylistViewWrapper* _tmp18_;
				MusicPlaylist* _tmp19_;
				MusicPlaylist* _tmp20_;
				gint64 _tmp21_;
				gint64 _tmp22_;
#line 423 "../src/LibraryWindow.vala"
				_tmp15_ = playlistview;
#line 423 "../src/LibraryWindow.vala"
				_tmp16_ = music_view_wrapper_get_library ((MusicViewWrapper*) _tmp15_);
#line 423 "../src/LibraryWindow.vala"
				_tmp17_ = _tmp16_;
#line 423 "../src/LibraryWindow.vala"
				_tmp18_ = playlistview;
#line 423 "../src/LibraryWindow.vala"
				_tmp19_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp18_);
#line 423 "../src/LibraryWindow.vala"
				_tmp20_ = _tmp19_;
#line 423 "../src/LibraryWindow.vala"
				_tmp21_ = music_playlist_get_rowid (_tmp20_);
#line 423 "../src/LibraryWindow.vala"
				_tmp22_ = _tmp21_;
#line 423 "../src/LibraryWindow.vala"
				music_library_remove_smart_playlist (_tmp17_, _tmp22_);
#line 2134 "LibraryWindow.c"
			}
		}
#line 418 "../src/LibraryWindow.vala"
		_g_object_unref0 (playlistview);
#line 2139 "LibraryWindow.c"
	}
}

static void
___lambda150__music_source_list_view_playlist_remove_clicked (MusicSourceListView* _sender,
                                                              GtkGrid* view,
                                                              gpointer self)
{
#line 417 "../src/LibraryWindow.vala"
	__lambda150_ ((MusicLibraryWindow*) self, view);
#line 2150 "LibraryWindow.c"
}

static void
__lambda151_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
#line 428 "../src/LibraryWindow.vala"
	g_return_if_fail (view != NULL);
#line 429 "../src/LibraryWindow.vala"
	if (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view)) {
#line 2161 "LibraryWindow.c"
		MusicPlaylistViewWrapper* playlistview = NULL;
		MusicPlaylistViewWrapper* _tmp0_;
		MusicPlaylistViewWrapper* _tmp1_;
		MusicViewWrapperHint _tmp2_;
		MusicViewWrapperHint _tmp3_;
		MusicPlaylist* playlist = NULL;
		MusicPlaylistViewWrapper* _tmp4_;
		MusicPlaylist* _tmp5_;
		MusicPlaylist* _tmp6_;
		MusicPlaylist* _tmp7_;
		MusicPlaylist* _tmp8_;
#line 430 "../src/LibraryWindow.vala"
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapper));
#line 430 "../src/LibraryWindow.vala"
		playlistview = _tmp0_;
#line 431 "../src/LibraryWindow.vala"
		_tmp1_ = playlistview;
#line 431 "../src/LibraryWindow.vala"
		_tmp2_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp1_);
#line 431 "../src/LibraryWindow.vala"
		_tmp3_ = _tmp2_;
#line 431 "../src/LibraryWindow.vala"
		if (_tmp3_ != MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
#line 432 "../src/LibraryWindow.vala"
			_g_object_unref0 (playlistview);
#line 432 "../src/LibraryWindow.vala"
			return;
#line 2189 "LibraryWindow.c"
		}
#line 433 "../src/LibraryWindow.vala"
		_tmp4_ = playlistview;
#line 433 "../src/LibraryWindow.vala"
		_tmp5_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp4_);
#line 433 "../src/LibraryWindow.vala"
		_tmp6_ = _tmp5_;
#line 433 "../src/LibraryWindow.vala"
		_tmp7_ = _g_object_ref0 (_tmp6_);
#line 433 "../src/LibraryWindow.vala"
		playlist = _tmp7_;
#line 434 "../src/LibraryWindow.vala"
		_tmp8_ = playlist;
#line 434 "../src/LibraryWindow.vala"
		if (_tmp8_ != NULL) {
#line 2205 "LibraryWindow.c"
			MusicStaticPlaylist* new_playlist = NULL;
			MusicStaticPlaylist* _tmp9_;
			MusicStaticPlaylist* _tmp10_;
			MusicLocalLibrary* _tmp11_;
			MusicLocalLibrary* _tmp12_;
			GeeCollection* _tmp13_;
			GeeCollection* _tmp14_;
			MusicPlaylist* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			MusicStaticPlaylist* _tmp20_;
			MusicPlaylist* _tmp21_;
			GeeArrayList* _tmp22_;
			GeeArrayList* _tmp23_;
			MusicLocalLibrary* _tmp24_;
			MusicLocalLibrary* _tmp25_;
			MusicStaticPlaylist* _tmp26_;
#line 435 "../src/LibraryWindow.vala"
			_tmp9_ = music_static_playlist_new ();
#line 435 "../src/LibraryWindow.vala"
			new_playlist = _tmp9_;
#line 436 "../src/LibraryWindow.vala"
			_tmp10_ = new_playlist;
#line 436 "../src/LibraryWindow.vala"
			_tmp11_ = music_library_window_get_library_manager (self);
#line 436 "../src/LibraryWindow.vala"
			_tmp12_ = _tmp11_;
#line 436 "../src/LibraryWindow.vala"
			_tmp13_ = music_library_get_playlists ((MusicLibrary*) _tmp12_);
#line 436 "../src/LibraryWindow.vala"
			_tmp14_ = _tmp13_;
#line 436 "../src/LibraryWindow.vala"
			_tmp15_ = playlist;
#line 436 "../src/LibraryWindow.vala"
			_tmp16_ = music_playlist_get_name (_tmp15_);
#line 436 "../src/LibraryWindow.vala"
			_tmp17_ = _tmp16_;
#line 436 "../src/LibraryWindow.vala"
			_tmp18_ = music_playlists_utils_get_new_playlist_name (_tmp14_, _tmp17_);
#line 436 "../src/LibraryWindow.vala"
			_tmp19_ = _tmp18_;
#line 436 "../src/LibraryWindow.vala"
			music_playlist_set_name ((MusicPlaylist*) _tmp10_, _tmp19_);
#line 436 "../src/LibraryWindow.vala"
			_g_free0 (_tmp19_);
#line 436 "../src/LibraryWindow.vala"
			_g_object_unref0 (_tmp14_);
#line 440 "../src/LibraryWindow.vala"
			_tmp20_ = new_playlist;
#line 440 "../src/LibraryWindow.vala"
			_tmp21_ = playlist;
#line 440 "../src/LibraryWindow.vala"
			_tmp22_ = music_playlist_get_medias (_tmp21_);
#line 440 "../src/LibraryWindow.vala"
			_tmp23_ = _tmp22_;
#line 440 "../src/LibraryWindow.vala"
			music_playlist_add_medias ((MusicPlaylist*) _tmp20_, (GeeCollection*) _tmp23_);
#line 441 "../src/LibraryWindow.vala"
			_tmp24_ = music_library_window_get_library_manager (self);
#line 441 "../src/LibraryWindow.vala"
			_tmp25_ = _tmp24_;
#line 441 "../src/LibraryWindow.vala"
			_tmp26_ = new_playlist;
#line 441 "../src/LibraryWindow.vala"
			music_library_add_playlist ((MusicLibrary*) _tmp25_, _tmp26_);
#line 434 "../src/LibraryWindow.vala"
			_g_object_unref0 (new_playlist);
#line 2275 "LibraryWindow.c"
		}
#line 429 "../src/LibraryWindow.vala"
		_g_object_unref0 (playlist);
#line 429 "../src/LibraryWindow.vala"
		_g_object_unref0 (playlistview);
#line 2281 "LibraryWindow.c"
	}
}

static void
___lambda151__music_source_list_view_playlist_save_clicked (MusicSourceListView* _sender,
                                                            GtkGrid* view,
                                                            gpointer self)
{
#line 428 "../src/LibraryWindow.vala"
	__lambda151_ ((MusicLibraryWindow*) self, view);
#line 2292 "LibraryWindow.c"
}

static void
__lambda152_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
#line 446 "../src/LibraryWindow.vala"
	g_return_if_fail (view != NULL);
#line 447 "../src/LibraryWindow.vala"
	if (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view)) {
#line 2303 "LibraryWindow.c"
		MusicPlaylistViewWrapper* playlistview = NULL;
		MusicPlaylistViewWrapper* _tmp0_;
		MusicPlaylistViewWrapper* _tmp1_;
		MusicViewWrapperHint _tmp2_;
		MusicViewWrapperHint _tmp3_;
#line 448 "../src/LibraryWindow.vala"
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapper));
#line 448 "../src/LibraryWindow.vala"
		playlistview = _tmp0_;
#line 449 "../src/LibraryWindow.vala"
		_tmp1_ = playlistview;
#line 449 "../src/LibraryWindow.vala"
		_tmp2_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp1_);
#line 449 "../src/LibraryWindow.vala"
		_tmp3_ = _tmp2_;
#line 449 "../src/LibraryWindow.vala"
		switch (_tmp3_) {
#line 449 "../src/LibraryWindow.vala"
			case MUSIC_VIEW_WRAPPER_HINT_PLAYLIST:
#line 449 "../src/LibraryWindow.vala"
			case MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST:
#line 2325 "LibraryWindow.c"
			{
				MusicPlaylistViewWrapper* _tmp4_;
				MusicPlaylist* _tmp5_;
				MusicPlaylist* _tmp6_;
#line 452 "../src/LibraryWindow.vala"
				_tmp4_ = playlistview;
#line 452 "../src/LibraryWindow.vala"
				_tmp5_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp4_);
#line 452 "../src/LibraryWindow.vala"
				_tmp6_ = _tmp5_;
#line 452 "../src/LibraryWindow.vala"
				music_playlists_utils_export_playlist (_tmp6_);
#line 453 "../src/LibraryWindow.vala"
				break;
#line 2340 "LibraryWindow.c"
			}
#line 449 "../src/LibraryWindow.vala"
			case MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST:
#line 2344 "LibraryWindow.c"
			{
				MusicPlaylistViewWrapper* _tmp7_;
				MusicPlaylist* _tmp8_;
				MusicPlaylist* _tmp9_;
#line 455 "../src/LibraryWindow.vala"
				_tmp7_ = playlistview;
#line 455 "../src/LibraryWindow.vala"
				_tmp8_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp7_);
#line 455 "../src/LibraryWindow.vala"
				_tmp9_ = _tmp8_;
#line 455 "../src/LibraryWindow.vala"
				music_playlists_utils_export_playlist (_tmp9_);
#line 456 "../src/LibraryWindow.vala"
				break;
#line 2359 "LibraryWindow.c"
			}
			default:
#line 449 "../src/LibraryWindow.vala"
			break;
#line 2364 "LibraryWindow.c"
		}
#line 447 "../src/LibraryWindow.vala"
		_g_object_unref0 (playlistview);
#line 2368 "LibraryWindow.c"
	}
}

static void
___lambda152__music_source_list_view_playlist_export_clicked (MusicSourceListView* _sender,
                                                              GtkGrid* view,
                                                              gpointer self)
{
#line 446 "../src/LibraryWindow.vala"
	__lambda152_ ((MusicLibraryWindow*) self, view);
#line 2379 "LibraryWindow.c"
}

static void
__lambda153_ (MusicLibraryWindow* self,
              GtkGrid* view,
              gchar** uris,
              gint uris_length1)
{
#line 461 "../src/LibraryWindow.vala"
	g_return_if_fail (view != NULL);
#line 462 "../src/LibraryWindow.vala"
	if (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view)) {
#line 2392 "LibraryWindow.c"
		MusicPlaylistViewWrapper* playlistview = NULL;
		MusicPlaylistViewWrapper* _tmp0_;
		MusicPlaylistViewWrapper* _tmp1_;
		MusicViewWrapperHint _tmp2_;
		MusicViewWrapperHint _tmp3_;
#line 463 "../src/LibraryWindow.vala"
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapper));
#line 463 "../src/LibraryWindow.vala"
		playlistview = _tmp0_;
#line 464 "../src/LibraryWindow.vala"
		_tmp1_ = playlistview;
#line 464 "../src/LibraryWindow.vala"
		_tmp2_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp1_);
#line 464 "../src/LibraryWindow.vala"
		_tmp3_ = _tmp2_;
#line 464 "../src/LibraryWindow.vala"
		if (_tmp3_ == MUSIC_VIEW_WRAPPER_HINT_PLAYLIST) {
#line 2410 "LibraryWindow.c"
			MusicLibrary* library = NULL;
			MusicPlaylistViewWrapper* _tmp4_;
			MusicLibrary* _tmp5_;
			MusicLibrary* _tmp6_;
			MusicLibrary* _tmp7_;
			MusicPlaylist* playlist = NULL;
			MusicPlaylistViewWrapper* _tmp8_;
			MusicPlaylist* _tmp9_;
			MusicPlaylist* _tmp10_;
			MusicPlaylist* _tmp11_;
			MusicPlaylist* _tmp12_;
			GeeHashSet* uri_set = NULL;
			GeeHashSet* _tmp13_;
			GeeCollection* media_list = NULL;
			MusicLibrary* _tmp17_;
			GeeHashSet* _tmp18_;
			GeeCollection* _tmp19_;
			MusicPlaylist* _tmp20_;
			GeeCollection* _tmp21_;
#line 465 "../src/LibraryWindow.vala"
			_tmp4_ = playlistview;
#line 465 "../src/LibraryWindow.vala"
			_tmp5_ = music_view_wrapper_get_library ((MusicViewWrapper*) _tmp4_);
#line 465 "../src/LibraryWindow.vala"
			_tmp6_ = _tmp5_;
#line 465 "../src/LibraryWindow.vala"
			_tmp7_ = _g_object_ref0 (_tmp6_);
#line 465 "../src/LibraryWindow.vala"
			library = _tmp7_;
#line 466 "../src/LibraryWindow.vala"
			_tmp8_ = playlistview;
#line 466 "../src/LibraryWindow.vala"
			_tmp9_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp8_);
#line 466 "../src/LibraryWindow.vala"
			_tmp10_ = _tmp9_;
#line 466 "../src/LibraryWindow.vala"
			_tmp11_ = _g_object_ref0 (_tmp10_);
#line 466 "../src/LibraryWindow.vala"
			playlist = _tmp11_;
#line 467 "../src/LibraryWindow.vala"
			_tmp12_ = playlist;
#line 467 "../src/LibraryWindow.vala"
			if (_tmp12_ == NULL) {
#line 468 "../src/LibraryWindow.vala"
				_g_object_unref0 (playlist);
#line 468 "../src/LibraryWindow.vala"
				_g_object_unref0 (library);
#line 468 "../src/LibraryWindow.vala"
				_g_object_unref0 (playlistview);
#line 468 "../src/LibraryWindow.vala"
				return;
#line 2462 "LibraryWindow.c"
			}
#line 470 "../src/LibraryWindow.vala"
			_tmp13_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 470 "../src/LibraryWindow.vala"
			uri_set = _tmp13_;
#line 2468 "LibraryWindow.c"
			{
				gchar** uri_collection = NULL;
				gint uri_collection_length1 = 0;
				gint _uri_collection_size_ = 0;
				gint uri_it = 0;
#line 471 "../src/LibraryWindow.vala"
				uri_collection = uris;
#line 471 "../src/LibraryWindow.vala"
				uri_collection_length1 = uris_length1;
#line 471 "../src/LibraryWindow.vala"
				for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
#line 2480 "LibraryWindow.c"
					gchar* _tmp14_;
					gchar* uri = NULL;
#line 471 "../src/LibraryWindow.vala"
					_tmp14_ = g_strdup (uri_collection[uri_it]);
#line 471 "../src/LibraryWindow.vala"
					uri = _tmp14_;
#line 2487 "LibraryWindow.c"
					{
						GeeHashSet* _tmp15_;
						const gchar* _tmp16_;
#line 472 "../src/LibraryWindow.vala"
						_tmp15_ = uri_set;
#line 472 "../src/LibraryWindow.vala"
						_tmp16_ = uri;
#line 472 "../src/LibraryWindow.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 471 "../src/LibraryWindow.vala"
						_g_free0 (uri);
#line 2499 "LibraryWindow.c"
					}
				}
			}
#line 474 "../src/LibraryWindow.vala"
			_tmp17_ = library;
#line 474 "../src/LibraryWindow.vala"
			_tmp18_ = uri_set;
#line 474 "../src/LibraryWindow.vala"
			_tmp19_ = music_library_medias_from_uris (_tmp17_, (GeeCollection*) _tmp18_);
#line 474 "../src/LibraryWindow.vala"
			media_list = _tmp19_;
#line 475 "../src/LibraryWindow.vala"
			_tmp20_ = playlist;
#line 475 "../src/LibraryWindow.vala"
			_tmp21_ = media_list;
#line 475 "../src/LibraryWindow.vala"
			music_playlist_add_medias (_tmp20_, _tmp21_);
#line 464 "../src/LibraryWindow.vala"
			_g_object_unref0 (media_list);
#line 464 "../src/LibraryWindow.vala"
			_g_object_unref0 (uri_set);
#line 464 "../src/LibraryWindow.vala"
			_g_object_unref0 (playlist);
#line 464 "../src/LibraryWindow.vala"
			_g_object_unref0 (library);
#line 2525 "LibraryWindow.c"
		}
#line 462 "../src/LibraryWindow.vala"
		_g_object_unref0 (playlistview);
#line 2529 "LibraryWindow.c"
	}
}

static void
___lambda153__music_source_list_view_playlist_media_added (MusicSourceListView* _sender,
                                                           GtkGrid* view,
                                                           gchar** uris,
                                                           gint uris_length1,
                                                           gpointer self)
{
#line 461 "../src/LibraryWindow.vala"
	__lambda153_ ((MusicLibraryWindow*) self, view, uris, uris_length1);
#line 2542 "LibraryWindow.c"
}

static void
__lambda154_ (MusicLibraryWindow* self)
{
	GError* _inner_error0_ = NULL;
	{
		GeeHashMap* _tmp0_ = NULL;
		GeeHashMap* _tmp1_;
		MusicLocalLibrary* _tmp2_;
		MusicLocalLibrary* _tmp3_;
#line 483 "../src/LibraryWindow.vala"
		_tmp1_ = music_playlists_utils_get_playlists_to_import ("Playlist", &_inner_error0_);
#line 483 "../src/LibraryWindow.vala"
		_tmp0_ = _tmp1_;
#line 483 "../src/LibraryWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2560 "LibraryWindow.c"
			goto __catch0_g_error;
		}
#line 482 "../src/LibraryWindow.vala"
		_tmp2_ = music_library_window_get_library_manager (self);
#line 482 "../src/LibraryWindow.vala"
		_tmp3_ = _tmp2_;
#line 482 "../src/LibraryWindow.vala"
		music_playlists_utils_import_from_playlist_file_info (_tmp0_, (MusicLibrary*) _tmp3_);
#line 486 "../src/LibraryWindow.vala"
		music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) self, NULL, NULL);
#line 481 "../src/LibraryWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 2573 "LibraryWindow.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 481 "../src/LibraryWindow.vala"
		e = _inner_error0_;
#line 481 "../src/LibraryWindow.vala"
		_inner_error0_ = NULL;
#line 488 "../src/LibraryWindow.vala"
		_tmp4_ = e;
#line 488 "../src/LibraryWindow.vala"
		_tmp5_ = _tmp4_->message;
#line 488 "../src/LibraryWindow.vala"
		g_warning ("LibraryWindow.vala:488: %s", _tmp5_);
#line 481 "../src/LibraryWindow.vala"
		_g_error_free0 (e);
#line 2593 "LibraryWindow.c"
	}
	__finally0:
#line 481 "../src/LibraryWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 481 "../src/LibraryWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 481 "../src/LibraryWindow.vala"
		g_clear_error (&_inner_error0_);
#line 481 "../src/LibraryWindow.vala"
		return;
#line 2604 "LibraryWindow.c"
	}
}

static void
___lambda154__music_source_list_view_playlist_import_clicked (MusicSourceListView* _sender,
                                                              gpointer self)
{
#line 480 "../src/LibraryWindow.vala"
	__lambda154_ ((MusicLibraryWindow*) self);
#line 2614 "LibraryWindow.c"
}

static void
_music_library_window_search_entry_activate_gtk_entry_activate (GtkEntry* _sender,
                                                                gpointer self)
{
#line 502 "../src/LibraryWindow.vala"
	music_library_window_search_entry_activate ((MusicLibraryWindow*) self);
#line 2623 "LibraryWindow.c"
}

static void
__lambda162_ (MusicLibraryWindow* self)
{
	GtkSearchEntry* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
#line 504 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->_search_entry;
#line 504 "../src/LibraryWindow.vala"
	_tmp1_ = gtk_entry_get_text_length ((GtkEntry*) _tmp0_);
#line 504 "../src/LibraryWindow.vala"
	_tmp2_ = _tmp1_;
#line 504 "../src/LibraryWindow.vala"
	if (_tmp2_ != ((guint) 1)) {
#line 2640 "LibraryWindow.c"
		MusicLibrariesManager* _tmp3_;
		GtkSearchEntry* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 505 "../src/LibraryWindow.vala"
		_tmp3_ = music_libraries_manager;
#line 505 "../src/LibraryWindow.vala"
		_tmp4_ = self->priv->_search_entry;
#line 505 "../src/LibraryWindow.vala"
		_tmp5_ = gtk_entry_get_text ((GtkEntry*) _tmp4_);
#line 505 "../src/LibraryWindow.vala"
		_tmp6_ = _tmp5_;
#line 505 "../src/LibraryWindow.vala"
		music_libraries_manager_search_for_string (_tmp3_, _tmp6_);
#line 2655 "LibraryWindow.c"
	}
}

static void
___lambda162__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                               gpointer self)
{
#line 503 "../src/LibraryWindow.vala"
	__lambda162_ ((MusicLibraryWindow*) self);
#line 2665 "LibraryWindow.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 2684 "LibraryWindow.c"
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result;
#line 770 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 771 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, _base);
#line 771 "glib-2.0.vapi"
	return result;
#line 2698 "LibraryWindow.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 2720 "LibraryWindow.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 2724 "LibraryWindow.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 2730 "LibraryWindow.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 2734 "LibraryWindow.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 2738 "LibraryWindow.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 2746 "LibraryWindow.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2774 "LibraryWindow.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 2783 "LibraryWindow.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2797 "LibraryWindow.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 2806 "LibraryWindow.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 2820 "LibraryWindow.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 2829 "LibraryWindow.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 2838 "LibraryWindow.c"
}

void
music_library_window_build_ui (MusicLibraryWindow* self)
{
	Block3Data* _data3_;
	GtkApplication* _tmp0_;
	GtkApplication* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint window_x = 0;
	gint window_y = 0;
	gint window_width = 0;
	gint window_height = 0;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	gboolean _tmp12_ = FALSE;
	GSettings* _tmp13_;
	GSettings* _tmp14_;
	GtkMenuItem* import_menuitem = NULL;
	GtkMenuItem* _tmp15_;
	GtkMenuItem* _tmp16_;
	GtkMenuItem* preferences_menuitem = NULL;
	GtkMenuItem* _tmp17_;
	GtkMenuItem* _tmp18_;
	GtkMenu* menu = NULL;
	GtkMenu* _tmp19_;
	GtkMenu* _tmp20_;
	GtkMenuItem* _tmp21_;
	GtkMenu* _tmp22_;
	GtkSeparatorMenuItem* _tmp23_;
	GtkSeparatorMenuItem* _tmp24_;
	GtkMenu* _tmp25_;
	GtkMenuItem* _tmp26_;
	GtkMenu* _tmp27_;
	GtkMenuButton* menu_button = NULL;
	GtkMenuButton* _tmp28_;
	GtkMenuButton* _tmp29_;
	GtkImage* _tmp30_;
	GtkImage* _tmp31_;
	GtkMenuButton* _tmp32_;
	GtkMenu* _tmp33_;
	GtkMenuButton* _tmp34_;
	GtkButton* previous_button = NULL;
	GtkButton* _tmp35_;
	GtkButton* _tmp36_;
	GtkButton* _tmp37_;
	GtkButton* _tmp38_;
	GtkButton* _tmp39_;
	GtkButton* _tmp40_;
	GtkButton* next_button = NULL;
	GtkButton* _tmp41_;
	GtkButton* _tmp42_;
	GtkButton* _tmp43_;
	GtkSearchEntry* _tmp44_;
	GtkSearchEntry* _tmp45_;
	GtkSearchEntry* _tmp46_;
	GtkSearchEntry* _tmp47_;
	MusicWidgetsViewSelector* _tmp48_;
	MusicWidgetsViewSelector* _tmp49_;
	MusicWidgetsViewSelector* _tmp50_;
	MusicWidgetsViewSelector* _tmp51_;
	MusicWidgetsViewSelector* _tmp52_;
	MusicTopDisplay* _tmp53_;
	MusicTopDisplay* _tmp54_;
	MusicTopDisplay* _tmp55_;
	HdyHeaderBar* headerbar = NULL;
	HdyHeaderBar* _tmp56_;
	HdyHeaderBar* _tmp57_;
	HdyHeaderBar* _tmp58_;
	GtkButton* _tmp59_;
	HdyHeaderBar* _tmp60_;
	GtkButton* _tmp61_;
	HdyHeaderBar* _tmp62_;
	GtkButton* _tmp63_;
	HdyHeaderBar* _tmp64_;
	MusicWidgetsViewSelector* _tmp65_;
	HdyHeaderBar* _tmp66_;
	GtkMenuButton* _tmp67_;
	HdyHeaderBar* _tmp68_;
	GtkSearchEntry* _tmp69_;
	HdyHeaderBar* _tmp70_;
	HdyHeaderBar* _tmp71_;
	MusicTopDisplay* _tmp72_;
	HdyHeaderBar* _tmp73_;
	MusicViewStack* _tmp74_;
	MusicViewStack* _tmp75_;
	MusicSourceListView* _tmp76_;
	MusicSourceListView* _tmp77_;
	MusicWidgetsStatusBar* _tmp78_;
	MusicWidgetsStatusBar* _tmp79_;
	GtkGrid* sidebar_grid = NULL;
	GtkGrid* _tmp80_;
	GtkGrid* _tmp81_;
	GtkGrid* _tmp82_;
	GtkStyleContext* _tmp83_;
	GtkGrid* _tmp84_;
	MusicSourceListView* _tmp85_;
	GtkGrid* _tmp86_;
	MusicWidgetsStatusBar* _tmp87_;
	GtkPaned* main_hpaned = NULL;
	GtkPaned* _tmp88_;
	GtkPaned* _tmp89_;
	GtkGrid* _tmp90_;
	GtkPaned* _tmp91_;
	MusicViewStack* _tmp92_;
	GtkPaned* _tmp93_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp94_;
	GtkGrid* _tmp95_;
	HdyHeaderBar* _tmp96_;
	GtkGrid* _tmp97_;
	GtkPaned* _tmp98_;
	GtkGrid* _tmp99_;
	GtkGrid* _tmp100_;
	GSettings* _tmp101_;
	GSettings* _tmp102_;
	GtkPaned* _tmp103_;
	MusicLocalLibrary* _tmp104_;
	MusicLocalLibrary* _tmp105_;
	MusicLibrariesManager* _tmp106_;
	MusicSourceListView* _tmp107_;
	MusicSourceListView* _tmp108_;
	MusicSourceListView* _tmp109_;
	MusicSourceListView* _tmp110_;
	MusicSourceListView* _tmp111_;
	MusicSourceListView* _tmp112_;
	MusicSourceListView* _tmp113_;
	MusicSourceListView* _tmp114_;
	MusicSourceListView* _tmp115_;
	MusicSourceListView* _tmp116_;
	MusicSourceListView* _tmp117_;
	MusicSourceListView* _tmp118_;
	MusicSourceListView* _tmp119_;
	MusicSourceListView* _tmp120_;
	MusicSourceListView* _tmp121_;
	MusicSourceListView* _tmp122_;
	MusicWidgetsViewSelector* _tmp123_;
	GSettings* _tmp124_;
	GSettings* _tmp125_;
	MusicLocalLibrary* _tmp126_;
	MusicLocalLibrary* _tmp127_;
	gchar* search_string = NULL;
	GSettings* _tmp128_;
	GSettings* _tmp129_;
	gchar* _tmp130_;
	GtkSearchEntry* _tmp131_;
	GtkSearchEntry* _tmp132_;
	GtkSearchEntry* _tmp133_;
	const gchar* _tmp134_;
	gint64 last_playing_id = 0LL;
	GSettings* _tmp135_;
	GSettings* _tmp136_;
	MusicLibrariesManager* _tmp148_;
	const gchar* _tmp149_;
	gchar* last_playlist_playing = NULL;
	GSettings* _tmp150_;
	GSettings* _tmp151_;
	gchar* _tmp152_;
	const gchar* _tmp153_;
#line 193 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 193 "../src/LibraryWindow.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 193 "../src/LibraryWindow.vala"
	_data3_->_ref_count_ = 1;
#line 193 "../src/LibraryWindow.vala"
	_data3_->self = g_object_ref (self);
#line 194 "../src/LibraryWindow.vala"
	g_object_set ((GtkWidget*) self, "height-request", 350, NULL);
#line 195 "../src/LibraryWindow.vala"
	g_object_set ((GtkWidget*) self, "width-request", 400, NULL);
#line 196 "../src/LibraryWindow.vala"
	_tmp0_ = gtk_window_get_application ((GtkWindow*) self);
#line 196 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 196 "../src/LibraryWindow.vala"
	_tmp2_ = g_application_get_application_id ((GApplication*) _tmp1_);
#line 196 "../src/LibraryWindow.vala"
	_tmp3_ = _tmp2_;
#line 196 "../src/LibraryWindow.vala"
	gtk_window_set_icon_name ((GtkWindow*) self, _tmp3_);
#line 197 "../src/LibraryWindow.vala"
	gtk_window_set_title ((GtkWindow*) self, _ ("Music"));
#line 200 "../src/LibraryWindow.vala"
	_tmp4_ = music_app_get_saved_state ();
#line 200 "../src/LibraryWindow.vala"
	_tmp5_ = _tmp4_;
#line 200 "../src/LibraryWindow.vala"
	g_settings_get (_tmp5_, "window-position", "(ii)", &_tmp6_, &_tmp7_);
#line 200 "../src/LibraryWindow.vala"
	window_x = _tmp6_;
#line 200 "../src/LibraryWindow.vala"
	window_y = _tmp7_;
#line 201 "../src/LibraryWindow.vala"
	_tmp8_ = music_app_get_saved_state ();
#line 201 "../src/LibraryWindow.vala"
	_tmp9_ = _tmp8_;
#line 201 "../src/LibraryWindow.vala"
	g_settings_get (_tmp9_, "window-size", "(ii)", &_tmp10_, &_tmp11_);
#line 201 "../src/LibraryWindow.vala"
	window_width = _tmp10_;
#line 201 "../src/LibraryWindow.vala"
	window_height = _tmp11_;
#line 203 "../src/LibraryWindow.vala"
	gtk_window_set_default_size ((GtkWindow*) self, window_width, window_height);
#line 205 "../src/LibraryWindow.vala"
	if (window_x != -1) {
#line 205 "../src/LibraryWindow.vala"
		_tmp12_ = TRUE;
#line 3055 "LibraryWindow.c"
	} else {
#line 205 "../src/LibraryWindow.vala"
		_tmp12_ = window_y != -1;
#line 3059 "LibraryWindow.c"
	}
#line 205 "../src/LibraryWindow.vala"
	if (_tmp12_) {
#line 206 "../src/LibraryWindow.vala"
		gtk_window_move ((GtkWindow*) self, window_x, window_y);
#line 3065 "LibraryWindow.c"
	}
#line 209 "../src/LibraryWindow.vala"
	_tmp13_ = music_app_get_saved_state ();
#line 209 "../src/LibraryWindow.vala"
	_tmp14_ = _tmp13_;
#line 209 "../src/LibraryWindow.vala"
	if (g_settings_get_boolean (_tmp14_, "window-maximized")) {
#line 210 "../src/LibraryWindow.vala"
		gtk_window_maximize ((GtkWindow*) self);
#line 3075 "LibraryWindow.c"
	}
#line 213 "../src/LibraryWindow.vala"
	g_signal_connect_object ((GtkWidget*) self, "destroy", (GCallback) _music_library_window_on_quit_gtk_widget_destroy, self, 0);
#line 216 "../src/LibraryWindow.vala"
	_tmp15_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Import to Library…"));
#line 216 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp15_);
#line 216 "../src/LibraryWindow.vala"
	import_menuitem = _tmp15_;
#line 217 "../src/LibraryWindow.vala"
	_tmp16_ = import_menuitem;
#line 217 "../src/LibraryWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp16_, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_IMPORT);
#line 219 "../src/LibraryWindow.vala"
	_tmp17_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Preferences"));
#line 219 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp17_);
#line 219 "../src/LibraryWindow.vala"
	preferences_menuitem = _tmp17_;
#line 220 "../src/LibraryWindow.vala"
	_tmp18_ = preferences_menuitem;
#line 220 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp18_, "activate", (GCallback) _music_library_window_edit_preferences_click_gtk_menu_item_activate, self, 0);
#line 222 "../src/LibraryWindow.vala"
	_tmp19_ = (GtkMenu*) gtk_menu_new ();
#line 222 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp19_);
#line 222 "../src/LibraryWindow.vala"
	menu = _tmp19_;
#line 223 "../src/LibraryWindow.vala"
	_tmp20_ = menu;
#line 223 "../src/LibraryWindow.vala"
	_tmp21_ = import_menuitem;
#line 223 "../src/LibraryWindow.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp20_, _tmp21_);
#line 224 "../src/LibraryWindow.vala"
	_tmp22_ = menu;
#line 224 "../src/LibraryWindow.vala"
	_tmp23_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 224 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp23_);
#line 224 "../src/LibraryWindow.vala"
	_tmp24_ = _tmp23_;
#line 224 "../src/LibraryWindow.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp22_, (GtkMenuItem*) _tmp24_);
#line 224 "../src/LibraryWindow.vala"
	_g_object_unref0 (_tmp24_);
#line 225 "../src/LibraryWindow.vala"
	_tmp25_ = menu;
#line 225 "../src/LibraryWindow.vala"
	_tmp26_ = preferences_menuitem;
#line 225 "../src/LibraryWindow.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp25_, _tmp26_);
#line 226 "../src/LibraryWindow.vala"
	_tmp27_ = menu;
#line 226 "../src/LibraryWindow.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp27_);
#line 228 "../src/LibraryWindow.vala"
	_tmp28_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 228 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp28_);
#line 228 "../src/LibraryWindow.vala"
	menu_button = _tmp28_;
#line 229 "../src/LibraryWindow.vala"
	_tmp29_ = menu_button;
#line 229 "../src/LibraryWindow.vala"
	_tmp30_ = (GtkImage*) gtk_image_new_from_icon_name ("open-menu", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 229 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp30_);
#line 229 "../src/LibraryWindow.vala"
	_tmp31_ = _tmp30_;
#line 229 "../src/LibraryWindow.vala"
	gtk_button_set_image ((GtkButton*) _tmp29_, (GtkWidget*) _tmp31_);
#line 229 "../src/LibraryWindow.vala"
	_g_object_unref0 (_tmp31_);
#line 230 "../src/LibraryWindow.vala"
	_tmp32_ = menu_button;
#line 230 "../src/LibraryWindow.vala"
	_tmp33_ = menu;
#line 230 "../src/LibraryWindow.vala"
	gtk_menu_button_set_popup (_tmp32_, _tmp33_);
#line 231 "../src/LibraryWindow.vala"
	_tmp34_ = menu_button;
#line 231 "../src/LibraryWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp34_, GTK_ALIGN_CENTER);
#line 233 "../src/LibraryWindow.vala"
	_tmp35_ = (GtkButton*) gtk_button_new_from_icon_name ("media-skip-backward-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 233 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp35_);
#line 233 "../src/LibraryWindow.vala"
	previous_button = _tmp35_;
#line 237 "../src/LibraryWindow.vala"
	_tmp36_ = previous_button;
#line 237 "../src/LibraryWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp36_, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_PLAY_PREVIOUS);
#line 238 "../src/LibraryWindow.vala"
	_tmp37_ = previous_button;
#line 238 "../src/LibraryWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp37_, _ ("Previous"));
#line 240 "../src/LibraryWindow.vala"
	_tmp38_ = (GtkButton*) gtk_button_new_from_icon_name ("media-playback-start-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 240 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp38_);
#line 240 "../src/LibraryWindow.vala"
	_data3_->play_button = _tmp38_;
#line 244 "../src/LibraryWindow.vala"
	_tmp39_ = _data3_->play_button;
#line 244 "../src/LibraryWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp39_, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_PLAY);
#line 245 "../src/LibraryWindow.vala"
	_tmp40_ = _data3_->play_button;
#line 245 "../src/LibraryWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp40_, _ ("Play"));
#line 247 "../src/LibraryWindow.vala"
	_tmp41_ = (GtkButton*) gtk_button_new_from_icon_name ("media-skip-forward-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 247 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp41_);
#line 247 "../src/LibraryWindow.vala"
	next_button = _tmp41_;
#line 251 "../src/LibraryWindow.vala"
	_tmp42_ = next_button;
#line 251 "../src/LibraryWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp42_, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_PLAY_NEXT);
#line 252 "../src/LibraryWindow.vala"
	_tmp43_ = next_button;
#line 252 "../src/LibraryWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp43_, _ ("Next"));
#line 254 "../src/LibraryWindow.vala"
	_tmp44_ = (GtkSearchEntry*) gtk_search_entry_new ();
#line 254 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp44_);
#line 254 "../src/LibraryWindow.vala"
	_tmp45_ = _tmp44_;
#line 254 "../src/LibraryWindow.vala"
	music_library_window_set_search_entry (self, _tmp45_);
#line 254 "../src/LibraryWindow.vala"
	_g_object_unref0 (_tmp45_);
#line 255 "../src/LibraryWindow.vala"
	_tmp46_ = self->priv->_search_entry;
#line 255 "../src/LibraryWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp46_, GTK_ALIGN_CENTER);
#line 256 "../src/LibraryWindow.vala"
	_tmp47_ = self->priv->_search_entry;
#line 256 "../src/LibraryWindow.vala"
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp47_, _ ("Search Music"));
#line 258 "../src/LibraryWindow.vala"
	_tmp48_ = music_widgets_view_selector_new ();
#line 258 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp48_);
#line 258 "../src/LibraryWindow.vala"
	_tmp49_ = _tmp48_;
#line 258 "../src/LibraryWindow.vala"
	music_library_window_set_view_selector (self, _tmp49_);
#line 258 "../src/LibraryWindow.vala"
	_g_object_unref0 (_tmp49_);
#line 259 "../src/LibraryWindow.vala"
	_tmp50_ = self->priv->_view_selector;
#line 259 "../src/LibraryWindow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp50_, 12);
#line 260 "../src/LibraryWindow.vala"
	_tmp51_ = self->priv->_view_selector;
#line 260 "../src/LibraryWindow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp51_, 6);
#line 261 "../src/LibraryWindow.vala"
	_tmp52_ = self->priv->_view_selector;
#line 261 "../src/LibraryWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp52_, GTK_ALIGN_CENTER);
#line 263 "../src/LibraryWindow.vala"
	_tmp53_ = music_top_display_new ();
#line 263 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp53_);
#line 263 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->priv->top_display);
#line 263 "../src/LibraryWindow.vala"
	self->priv->top_display = _tmp53_;
#line 264 "../src/LibraryWindow.vala"
	_tmp54_ = self->priv->top_display;
#line 264 "../src/LibraryWindow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp54_, 30);
#line 265 "../src/LibraryWindow.vala"
	_tmp55_ = self->priv->top_display;
#line 265 "../src/LibraryWindow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp55_, 30);
#line 267 "../src/LibraryWindow.vala"
	_tmp56_ = (HdyHeaderBar*) hdy_header_bar_new ();
#line 267 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp56_);
#line 267 "../src/LibraryWindow.vala"
	headerbar = _tmp56_;
#line 268 "../src/LibraryWindow.vala"
	_tmp57_ = headerbar;
#line 268 "../src/LibraryWindow.vala"
	hdy_header_bar_set_show_close_button (_tmp57_, TRUE);
#line 269 "../src/LibraryWindow.vala"
	_tmp58_ = headerbar;
#line 269 "../src/LibraryWindow.vala"
	_tmp59_ = previous_button;
#line 269 "../src/LibraryWindow.vala"
	hdy_header_bar_pack_start (_tmp58_, (GtkWidget*) _tmp59_);
#line 270 "../src/LibraryWindow.vala"
	_tmp60_ = headerbar;
#line 270 "../src/LibraryWindow.vala"
	_tmp61_ = _data3_->play_button;
#line 270 "../src/LibraryWindow.vala"
	hdy_header_bar_pack_start (_tmp60_, (GtkWidget*) _tmp61_);
#line 271 "../src/LibraryWindow.vala"
	_tmp62_ = headerbar;
#line 271 "../src/LibraryWindow.vala"
	_tmp63_ = next_button;
#line 271 "../src/LibraryWindow.vala"
	hdy_header_bar_pack_start (_tmp62_, (GtkWidget*) _tmp63_);
#line 272 "../src/LibraryWindow.vala"
	_tmp64_ = headerbar;
#line 272 "../src/LibraryWindow.vala"
	_tmp65_ = self->priv->_view_selector;
#line 272 "../src/LibraryWindow.vala"
	hdy_header_bar_pack_start (_tmp64_, (GtkWidget*) _tmp65_);
#line 273 "../src/LibraryWindow.vala"
	_tmp66_ = headerbar;
#line 273 "../src/LibraryWindow.vala"
	_tmp67_ = menu_button;
#line 273 "../src/LibraryWindow.vala"
	hdy_header_bar_pack_end (_tmp66_, (GtkWidget*) _tmp67_);
#line 274 "../src/LibraryWindow.vala"
	_tmp68_ = headerbar;
#line 274 "../src/LibraryWindow.vala"
	_tmp69_ = self->priv->_search_entry;
#line 274 "../src/LibraryWindow.vala"
	hdy_header_bar_pack_end (_tmp68_, (GtkWidget*) _tmp69_);
#line 275 "../src/LibraryWindow.vala"
	_tmp70_ = headerbar;
#line 275 "../src/LibraryWindow.vala"
	hdy_header_bar_set_title (_tmp70_, _ ("Music"));
#line 276 "../src/LibraryWindow.vala"
	_tmp71_ = headerbar;
#line 276 "../src/LibraryWindow.vala"
	_tmp72_ = self->priv->top_display;
#line 276 "../src/LibraryWindow.vala"
	hdy_header_bar_set_custom_title (_tmp71_, (GtkWidget*) _tmp72_);
#line 277 "../src/LibraryWindow.vala"
	_tmp73_ = headerbar;
#line 277 "../src/LibraryWindow.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp73_);
#line 279 "../src/LibraryWindow.vala"
	_tmp74_ = music_view_stack_new ();
#line 279 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp74_);
#line 279 "../src/LibraryWindow.vala"
	_tmp75_ = _tmp74_;
#line 279 "../src/LibraryWindow.vala"
	music_library_window_set_view_stack (self, _tmp75_);
#line 279 "../src/LibraryWindow.vala"
	_g_object_unref0 (_tmp75_);
#line 280 "../src/LibraryWindow.vala"
	_tmp76_ = music_source_list_view_new ();
#line 280 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp76_);
#line 280 "../src/LibraryWindow.vala"
	_tmp77_ = _tmp76_;
#line 280 "../src/LibraryWindow.vala"
	music_library_window_set_source_list_view (self, _tmp77_);
#line 280 "../src/LibraryWindow.vala"
	_g_object_unref0 (_tmp77_);
#line 282 "../src/LibraryWindow.vala"
	_tmp78_ = music_widgets_status_bar_new ();
#line 282 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp78_);
#line 282 "../src/LibraryWindow.vala"
	_tmp79_ = _tmp78_;
#line 282 "../src/LibraryWindow.vala"
	music_library_window_set_statusbar (self, _tmp79_);
#line 282 "../src/LibraryWindow.vala"
	_g_object_unref0 (_tmp79_);
#line 284 "../src/LibraryWindow.vala"
	_tmp80_ = (GtkGrid*) gtk_grid_new ();
#line 284 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp80_);
#line 284 "../src/LibraryWindow.vala"
	sidebar_grid = _tmp80_;
#line 285 "../src/LibraryWindow.vala"
	_tmp81_ = sidebar_grid;
#line 285 "../src/LibraryWindow.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp81_, GTK_ORIENTATION_VERTICAL);
#line 286 "../src/LibraryWindow.vala"
	_tmp82_ = sidebar_grid;
#line 286 "../src/LibraryWindow.vala"
	_tmp83_ = gtk_widget_get_style_context ((GtkWidget*) _tmp82_);
#line 286 "../src/LibraryWindow.vala"
	gtk_style_context_add_class (_tmp83_, GTK_STYLE_CLASS_SIDEBAR);
#line 287 "../src/LibraryWindow.vala"
	_tmp84_ = sidebar_grid;
#line 287 "../src/LibraryWindow.vala"
	_tmp85_ = self->priv->_source_list_view;
#line 287 "../src/LibraryWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp84_, (GtkWidget*) _tmp85_);
#line 288 "../src/LibraryWindow.vala"
	_tmp86_ = sidebar_grid;
#line 288 "../src/LibraryWindow.vala"
	_tmp87_ = self->priv->_statusbar;
#line 288 "../src/LibraryWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp86_, (GtkWidget*) _tmp87_);
#line 290 "../src/LibraryWindow.vala"
	_tmp88_ = (GtkPaned*) gtk_paned_new (GTK_ORIENTATION_HORIZONTAL);
#line 290 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp88_);
#line 290 "../src/LibraryWindow.vala"
	main_hpaned = _tmp88_;
#line 291 "../src/LibraryWindow.vala"
	_tmp89_ = main_hpaned;
#line 291 "../src/LibraryWindow.vala"
	_tmp90_ = sidebar_grid;
#line 291 "../src/LibraryWindow.vala"
	gtk_paned_pack1 (_tmp89_, (GtkWidget*) _tmp90_, FALSE, FALSE);
#line 292 "../src/LibraryWindow.vala"
	_tmp91_ = main_hpaned;
#line 292 "../src/LibraryWindow.vala"
	_tmp92_ = self->priv->_view_stack;
#line 292 "../src/LibraryWindow.vala"
	gtk_paned_pack2 (_tmp91_, (GtkWidget*) _tmp92_, TRUE, FALSE);
#line 293 "../src/LibraryWindow.vala"
	_tmp93_ = main_hpaned;
#line 293 "../src/LibraryWindow.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp93_);
#line 295 "../src/LibraryWindow.vala"
	_tmp94_ = (GtkGrid*) gtk_grid_new ();
#line 295 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp94_);
#line 295 "../src/LibraryWindow.vala"
	grid = _tmp94_;
#line 296 "../src/LibraryWindow.vala"
	_tmp95_ = grid;
#line 296 "../src/LibraryWindow.vala"
	_tmp96_ = headerbar;
#line 296 "../src/LibraryWindow.vala"
	gtk_grid_attach (_tmp95_, (GtkWidget*) _tmp96_, 0, 0, 1, 1);
#line 297 "../src/LibraryWindow.vala"
	_tmp97_ = grid;
#line 297 "../src/LibraryWindow.vala"
	_tmp98_ = main_hpaned;
#line 297 "../src/LibraryWindow.vala"
	gtk_grid_attach (_tmp97_, (GtkWidget*) _tmp98_, 0, 1, 1, 1);
#line 298 "../src/LibraryWindow.vala"
	_tmp99_ = grid;
#line 298 "../src/LibraryWindow.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp99_);
#line 300 "../src/LibraryWindow.vala"
	_tmp100_ = grid;
#line 300 "../src/LibraryWindow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp100_);
#line 302 "../src/LibraryWindow.vala"
	_tmp101_ = music_app_get_saved_state ();
#line 302 "../src/LibraryWindow.vala"
	_tmp102_ = _tmp101_;
#line 302 "../src/LibraryWindow.vala"
	_tmp103_ = main_hpaned;
#line 302 "../src/LibraryWindow.vala"
	g_settings_bind (_tmp102_, "sidebar-width", (GObject*) _tmp103_, "position", G_SETTINGS_BIND_DEFAULT);
#line 304 "../src/LibraryWindow.vala"
	g_signal_connect_data ((GActionGroup*) self, "action-state-changed", (GCallback) ___lambda134__g_action_group_action_state_changed, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 322 "../src/LibraryWindow.vala"
	_tmp104_ = music_library_window_get_library_manager (self);
#line 322 "../src/LibraryWindow.vala"
	_tmp105_ = _tmp104_;
#line 322 "../src/LibraryWindow.vala"
	g_signal_connect_object ((MusicLibrary*) _tmp105_, "search-finished", (GCallback) ___lambda135__music_library_search_finished, self, 0);
#line 326 "../src/LibraryWindow.vala"
	_tmp106_ = music_libraries_manager;
#line 326 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp106_, "library-added", (GCallback) ___lambda136__music_libraries_manager_library_added, self, 0);
#line 332 "../src/LibraryWindow.vala"
	_tmp107_ = self->priv->_source_list_view;
#line 332 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp107_, "selection-changed", (GCallback) ___lambda138__music_source_list_view_selection_changed, self, 0);
#line 336 "../src/LibraryWindow.vala"
	_tmp108_ = self->priv->_source_list_view;
#line 336 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp108_, "activated", (GCallback) ___lambda139__music_source_list_view_activated, self, 0);
#line 340 "../src/LibraryWindow.vala"
	_tmp109_ = self->priv->_source_list_view;
#line 340 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp109_, "item-action-activated", (GCallback) ___lambda140__music_source_list_view_item_action_activated, self, 0);
#line 345 "../src/LibraryWindow.vala"
	_tmp110_ = self->priv->_source_list_view;
#line 345 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp110_, "edited", (GCallback) _music_library_window_playlist_name_edited_music_source_list_view_edited, self, 0);
#line 347 "../src/LibraryWindow.vala"
	_tmp111_ = self->priv->_source_list_view;
#line 347 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp111_, "playlist-rename-clicked", (GCallback) ___lambda143__music_source_list_view_playlist_rename_clicked, self, 0);
#line 353 "../src/LibraryWindow.vala"
	_tmp112_ = self->priv->_source_list_view;
#line 353 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp112_, "playlist-edit-clicked", (GCallback) ___lambda144__music_source_list_view_playlist_edit_clicked, self, 0);
#line 362 "../src/LibraryWindow.vala"
	_tmp113_ = self->priv->_source_list_view;
#line 362 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp113_, "playlist-remove-clicked", (GCallback) ___lambda145__music_source_list_view_playlist_remove_clicked, self, 0);
#line 373 "../src/LibraryWindow.vala"
	_tmp114_ = self->priv->_source_list_view;
#line 373 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp114_, "device-import-clicked", (GCallback) ___lambda146__music_source_list_view_device_import_clicked, self, 0);
#line 384 "../src/LibraryWindow.vala"
	_tmp115_ = self->priv->_source_list_view;
#line 384 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp115_, "device-new-playlist-clicked", (GCallback) ___lambda147__music_source_list_view_device_new_playlist_clicked, self, 0);
#line 395 "../src/LibraryWindow.vala"
	_tmp116_ = self->priv->_source_list_view;
#line 395 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp116_, "device-sync-clicked", (GCallback) ___lambda148__music_source_list_view_device_sync_clicked, self, 0);
#line 406 "../src/LibraryWindow.vala"
	_tmp117_ = self->priv->_source_list_view;
#line 406 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp117_, "device-eject-clicked", (GCallback) ___lambda149__music_source_list_view_device_eject_clicked, self, 0);
#line 417 "../src/LibraryWindow.vala"
	_tmp118_ = self->priv->_source_list_view;
#line 417 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp118_, "playlist-remove-clicked", (GCallback) ___lambda150__music_source_list_view_playlist_remove_clicked, self, 0);
#line 428 "../src/LibraryWindow.vala"
	_tmp119_ = self->priv->_source_list_view;
#line 428 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp119_, "playlist-save-clicked", (GCallback) ___lambda151__music_source_list_view_playlist_save_clicked, self, 0);
#line 446 "../src/LibraryWindow.vala"
	_tmp120_ = self->priv->_source_list_view;
#line 446 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp120_, "playlist-export-clicked", (GCallback) ___lambda152__music_source_list_view_playlist_export_clicked, self, 0);
#line 461 "../src/LibraryWindow.vala"
	_tmp121_ = self->priv->_source_list_view;
#line 461 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp121_, "playlist-media-added", (GCallback) ___lambda153__music_source_list_view_playlist_media_added, self, 0);
#line 480 "../src/LibraryWindow.vala"
	_tmp122_ = self->priv->_source_list_view;
#line 480 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp122_, "playlist-import-clicked", (GCallback) ___lambda154__music_source_list_view_playlist_import_clicked, self, 0);
#line 492 "../src/LibraryWindow.vala"
	music_library_window_load_playlists (self);
#line 493 "../src/LibraryWindow.vala"
	music_library_window_update_sensitivities_sync (self);
#line 495 "../src/LibraryWindow.vala"
	_tmp123_ = self->priv->_view_selector;
#line 495 "../src/LibraryWindow.vala"
	_tmp124_ = music_app_get_saved_state ();
#line 495 "../src/LibraryWindow.vala"
	_tmp125_ = _tmp124_;
#line 495 "../src/LibraryWindow.vala"
	music_widgets_view_selector_set_selected (_tmp123_, (MusicWidgetsViewSelectorMode) g_settings_get_int (_tmp125_, "view-mode"));
#line 497 "../src/LibraryWindow.vala"
	_tmp126_ = music_library_window_get_library_manager (self);
#line 497 "../src/LibraryWindow.vala"
	_tmp127_ = _tmp126_;
#line 497 "../src/LibraryWindow.vala"
	music_local_library_rescan_music_folder (_tmp127_);
#line 498 "../src/LibraryWindow.vala"
	music_library_window_set_initialization_finished (self, TRUE);
#line 500 "../src/LibraryWindow.vala"
	_tmp128_ = music_app_get_saved_state ();
#line 500 "../src/LibraryWindow.vala"
	_tmp129_ = _tmp128_;
#line 500 "../src/LibraryWindow.vala"
	_tmp130_ = g_settings_get_string (_tmp129_, "search-string");
#line 500 "../src/LibraryWindow.vala"
	search_string = _tmp130_;
#line 502 "../src/LibraryWindow.vala"
	_tmp131_ = self->priv->_search_entry;
#line 502 "../src/LibraryWindow.vala"
	g_signal_connect_object ((GtkEntry*) _tmp131_, "activate", (GCallback) _music_library_window_search_entry_activate_gtk_entry_activate, self, 0);
#line 503 "../src/LibraryWindow.vala"
	_tmp132_ = self->priv->_search_entry;
#line 503 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp132_, "search-changed", (GCallback) ___lambda162__gtk_search_entry_search_changed, self, 0);
#line 508 "../src/LibraryWindow.vala"
	_tmp133_ = self->priv->_search_entry;
#line 508 "../src/LibraryWindow.vala"
	_tmp134_ = search_string;
#line 508 "../src/LibraryWindow.vala"
	gtk_entry_set_text ((GtkEntry*) _tmp133_, _tmp134_);
#line 510 "../src/LibraryWindow.vala"
	_tmp135_ = music_app_get_saved_state ();
#line 510 "../src/LibraryWindow.vala"
	_tmp136_ = _tmp135_;
#line 510 "../src/LibraryWindow.vala"
	last_playing_id = g_settings_get_int64 (_tmp136_, "last-media-playing");
#line 511 "../src/LibraryWindow.vala"
	if (last_playing_id >= ((gint64) 0)) {
#line 3559 "LibraryWindow.c"
		MusicMedia* last_playing_media = NULL;
		MusicLocalLibrary* _tmp137_;
		MusicLocalLibrary* _tmp138_;
		MusicMedia* _tmp139_;
		gboolean _tmp140_ = FALSE;
		MusicMedia* _tmp141_;
#line 512 "../src/LibraryWindow.vala"
		_tmp137_ = music_library_window_get_library_manager (self);
#line 512 "../src/LibraryWindow.vala"
		_tmp138_ = _tmp137_;
#line 512 "../src/LibraryWindow.vala"
		_tmp139_ = music_library_media_from_id ((MusicLibrary*) _tmp138_, last_playing_id);
#line 512 "../src/LibraryWindow.vala"
		last_playing_media = _tmp139_;
#line 513 "../src/LibraryWindow.vala"
		_tmp141_ = last_playing_media;
#line 513 "../src/LibraryWindow.vala"
		if (_tmp141_ != NULL) {
#line 3578 "LibraryWindow.c"
			MusicMedia* _tmp142_;
			GFile* _tmp143_;
			GFile* _tmp144_;
#line 513 "../src/LibraryWindow.vala"
			_tmp142_ = last_playing_media;
#line 513 "../src/LibraryWindow.vala"
			_tmp143_ = music_media_get_file (_tmp142_);
#line 513 "../src/LibraryWindow.vala"
			_tmp144_ = _tmp143_;
#line 513 "../src/LibraryWindow.vala"
			_tmp140_ = g_file_query_exists (_tmp144_, NULL);
#line 3590 "LibraryWindow.c"
		} else {
#line 513 "../src/LibraryWindow.vala"
			_tmp140_ = FALSE;
#line 3594 "LibraryWindow.c"
		}
#line 513 "../src/LibraryWindow.vala"
		if (_tmp140_) {
#line 3598 "LibraryWindow.c"
			MusicPlaybackManager* _tmp145_;
			MusicPlaybackManager* _tmp146_;
			MusicMedia* _tmp147_;
#line 514 "../src/LibraryWindow.vala"
			_tmp145_ = music_app_get_player ();
#line 514 "../src/LibraryWindow.vala"
			_tmp146_ = _tmp145_;
#line 514 "../src/LibraryWindow.vala"
			_tmp147_ = last_playing_media;
#line 514 "../src/LibraryWindow.vala"
			music_playback_manager_play_media (_tmp146_, _tmp147_);
#line 3610 "LibraryWindow.c"
		}
#line 511 "../src/LibraryWindow.vala"
		_g_object_unref0 (last_playing_media);
#line 3614 "LibraryWindow.c"
	}
#line 517 "../src/LibraryWindow.vala"
	_tmp148_ = music_libraries_manager;
#line 517 "../src/LibraryWindow.vala"
	_tmp149_ = search_string;
#line 517 "../src/LibraryWindow.vala"
	music_libraries_manager_search_for_string (_tmp148_, _tmp149_);
#line 519 "../src/LibraryWindow.vala"
	_tmp150_ = music_app_get_saved_state ();
#line 519 "../src/LibraryWindow.vala"
	_tmp151_ = _tmp150_;
#line 519 "../src/LibraryWindow.vala"
	_tmp152_ = g_settings_get_string (_tmp151_, "last-playlist-playing");
#line 519 "../src/LibraryWindow.vala"
	last_playlist_playing = _tmp152_;
#line 522 "../src/LibraryWindow.vala"
	_tmp153_ = last_playlist_playing;
#line 522 "../src/LibraryWindow.vala"
	if (g_strcmp0 (_tmp153_, "") != 0) {
#line 3634 "LibraryWindow.c"
		MusicPlaylist* p = NULL;
		const gchar* _tmp154_;
		MusicPlaylist* _tmp169_;
#line 523 "../src/LibraryWindow.vala"
		p = NULL;
#line 524 "../src/LibraryWindow.vala"
		_tmp154_ = last_playlist_playing;
#line 524 "../src/LibraryWindow.vala"
		if (string_contains (_tmp154_, "s")) {
#line 3644 "LibraryWindow.c"
			gint64 rowid = 0LL;
			const gchar* _tmp155_;
			gchar* _tmp156_;
			gchar* _tmp157_;
			gint64 _tmp158_;
			MusicLocalLibrary* _tmp159_;
			MusicLocalLibrary* _tmp160_;
			MusicSmartPlaylist* _tmp161_;
#line 525 "../src/LibraryWindow.vala"
			_tmp155_ = last_playlist_playing;
#line 525 "../src/LibraryWindow.vala"
			_tmp156_ = string_replace (_tmp155_, "s", "");
#line 525 "../src/LibraryWindow.vala"
			_tmp157_ = _tmp156_;
#line 525 "../src/LibraryWindow.vala"
			_tmp158_ = int64_parse (_tmp157_, (guint) 0);
#line 525 "../src/LibraryWindow.vala"
			_g_free0 (_tmp157_);
#line 525 "../src/LibraryWindow.vala"
			rowid = _tmp158_;
#line 526 "../src/LibraryWindow.vala"
			_tmp159_ = music_library_window_get_library_manager (self);
#line 526 "../src/LibraryWindow.vala"
			_tmp160_ = _tmp159_;
#line 526 "../src/LibraryWindow.vala"
			_tmp161_ = music_library_smart_playlist_from_id ((MusicLibrary*) _tmp160_, rowid);
#line 526 "../src/LibraryWindow.vala"
			_g_object_unref0 (p);
#line 526 "../src/LibraryWindow.vala"
			p = (MusicPlaylist*) _tmp161_;
#line 3675 "LibraryWindow.c"
		} else {
			gint64 rowid = 0LL;
			const gchar* _tmp162_;
			gchar* _tmp163_;
			gchar* _tmp164_;
			gint64 _tmp165_;
			MusicLocalLibrary* _tmp166_;
			MusicLocalLibrary* _tmp167_;
			MusicStaticPlaylist* _tmp168_;
#line 528 "../src/LibraryWindow.vala"
			_tmp162_ = last_playlist_playing;
#line 528 "../src/LibraryWindow.vala"
			_tmp163_ = string_replace (_tmp162_, "p", "");
#line 528 "../src/LibraryWindow.vala"
			_tmp164_ = _tmp163_;
#line 528 "../src/LibraryWindow.vala"
			_tmp165_ = int64_parse (_tmp164_, (guint) 0);
#line 528 "../src/LibraryWindow.vala"
			_g_free0 (_tmp164_);
#line 528 "../src/LibraryWindow.vala"
			rowid = _tmp165_;
#line 529 "../src/LibraryWindow.vala"
			_tmp166_ = music_library_window_get_library_manager (self);
#line 529 "../src/LibraryWindow.vala"
			_tmp167_ = _tmp166_;
#line 529 "../src/LibraryWindow.vala"
			_tmp168_ = music_library_playlist_from_id ((MusicLibrary*) _tmp167_, rowid);
#line 529 "../src/LibraryWindow.vala"
			_g_object_unref0 (p);
#line 529 "../src/LibraryWindow.vala"
			p = (MusicPlaylist*) _tmp168_;
#line 3707 "LibraryWindow.c"
		}
#line 532 "../src/LibraryWindow.vala"
		_tmp169_ = p;
#line 532 "../src/LibraryWindow.vala"
		if (_tmp169_ != NULL) {
#line 3713 "LibraryWindow.c"
			MusicPlaylist* _tmp170_;
#line 533 "../src/LibraryWindow.vala"
			_tmp170_ = p;
#line 533 "../src/LibraryWindow.vala"
			music_library_window_show_playlist_view (self, _tmp170_);
#line 3719 "LibraryWindow.c"
		} else {
			MusicLocalLibrary* _tmp171_;
			MusicLocalLibrary* _tmp172_;
			MusicStaticPlaylist* _tmp173_;
#line 535 "../src/LibraryWindow.vala"
			_tmp171_ = music_library_window_get_library_manager (self);
#line 535 "../src/LibraryWindow.vala"
			_tmp172_ = _tmp171_;
#line 535 "../src/LibraryWindow.vala"
			_tmp173_ = _tmp172_->p_music;
#line 535 "../src/LibraryWindow.vala"
			music_library_window_show_playlist_view (self, (MusicPlaylist*) _tmp173_);
#line 3732 "LibraryWindow.c"
		}
#line 522 "../src/LibraryWindow.vala"
		_g_object_unref0 (p);
#line 3736 "LibraryWindow.c"
	} else {
		MusicLocalLibrary* _tmp174_;
		MusicLocalLibrary* _tmp175_;
		MusicStaticPlaylist* _tmp176_;
#line 538 "../src/LibraryWindow.vala"
		_tmp174_ = music_library_window_get_library_manager (self);
#line 538 "../src/LibraryWindow.vala"
		_tmp175_ = _tmp174_;
#line 538 "../src/LibraryWindow.vala"
		_tmp176_ = _tmp175_->p_music;
#line 538 "../src/LibraryWindow.vala"
		music_library_window_show_playlist_view (self, (MusicPlaylist*) _tmp176_);
#line 3749 "LibraryWindow.c"
	}
#line 193 "../src/LibraryWindow.vala"
	_g_free0 (last_playlist_playing);
#line 193 "../src/LibraryWindow.vala"
	_g_free0 (search_string);
#line 193 "../src/LibraryWindow.vala"
	_g_object_unref0 (grid);
#line 193 "../src/LibraryWindow.vala"
	_g_object_unref0 (main_hpaned);
#line 193 "../src/LibraryWindow.vala"
	_g_object_unref0 (sidebar_grid);
#line 193 "../src/LibraryWindow.vala"
	_g_object_unref0 (headerbar);
#line 193 "../src/LibraryWindow.vala"
	_g_object_unref0 (next_button);
#line 193 "../src/LibraryWindow.vala"
	_g_object_unref0 (previous_button);
#line 193 "../src/LibraryWindow.vala"
	_g_object_unref0 (menu_button);
#line 193 "../src/LibraryWindow.vala"
	_g_object_unref0 (menu);
#line 193 "../src/LibraryWindow.vala"
	_g_object_unref0 (preferences_menuitem);
#line 193 "../src/LibraryWindow.vala"
	_g_object_unref0 (import_menuitem);
#line 193 "../src/LibraryWindow.vala"
	block3_data_unref (_data3_);
#line 193 "../src/LibraryWindow.vala"
	_data3_ = NULL;
#line 3779 "LibraryWindow.c"
}

/**
     * Notifications
     */
void
music_library_window_show_notification (MusicLibraryWindow* self,
                                        const gchar* title,
                                        const gchar* body,
                                        GIcon* icon,
                                        GNotificationPriority priority,
                                        const gchar* context)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GNotification* notification = NULL;
	GNotification* _tmp2_;
	GNotification* _tmp3_;
	GNotification* _tmp4_;
	GNotification* _tmp11_;
	GApplication* _tmp12_;
	GNotification* _tmp13_;
#line 547 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 547 "../src/LibraryWindow.vala"
	g_return_if_fail (title != NULL);
#line 547 "../src/LibraryWindow.vala"
	g_return_if_fail (body != NULL);
#line 547 "../src/LibraryWindow.vala"
	g_return_if_fail (context != NULL);
#line 555 "../src/LibraryWindow.vala"
	g_object_get ((GtkWindow*) self, "is-active", &_tmp0_, NULL);
#line 555 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 555 "../src/LibraryWindow.vala"
	if (_tmp1_) {
#line 556 "../src/LibraryWindow.vala"
		return;
#line 3818 "LibraryWindow.c"
	}
#line 559 "../src/LibraryWindow.vala"
	_tmp2_ = g_notification_new (title);
#line 559 "../src/LibraryWindow.vala"
	notification = _tmp2_;
#line 560 "../src/LibraryWindow.vala"
	_tmp3_ = notification;
#line 560 "../src/LibraryWindow.vala"
	g_notification_set_body (_tmp3_, body);
#line 561 "../src/LibraryWindow.vala"
	_tmp4_ = notification;
#line 561 "../src/LibraryWindow.vala"
	g_notification_set_priority (_tmp4_, priority);
#line 562 "../src/LibraryWindow.vala"
	if (icon != NULL) {
#line 3834 "LibraryWindow.c"
		GNotification* _tmp5_;
#line 563 "../src/LibraryWindow.vala"
		_tmp5_ = notification;
#line 563 "../src/LibraryWindow.vala"
		g_notification_set_icon (_tmp5_, icon);
#line 3840 "LibraryWindow.c"
	} else {
		GNotification* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		GThemedIcon* _tmp9_;
		GThemedIcon* _tmp10_;
#line 565 "../src/LibraryWindow.vala"
		_tmp6_ = notification;
#line 565 "../src/LibraryWindow.vala"
		_tmp7_ = gtk_window_get_icon_name ((GtkWindow*) self);
#line 565 "../src/LibraryWindow.vala"
		_tmp8_ = _tmp7_;
#line 565 "../src/LibraryWindow.vala"
		_tmp9_ = (GThemedIcon*) g_themed_icon_new (_tmp8_);
#line 565 "../src/LibraryWindow.vala"
		_tmp10_ = _tmp9_;
#line 565 "../src/LibraryWindow.vala"
		g_notification_set_icon (_tmp6_, (GIcon*) _tmp10_);
#line 565 "../src/LibraryWindow.vala"
		_g_object_unref0 (_tmp10_);
#line 3861 "LibraryWindow.c"
	}
#line 568 "../src/LibraryWindow.vala"
	_tmp11_ = notification;
#line 568 "../src/LibraryWindow.vala"
	g_notification_set_default_action (_tmp11_, "app.present");
#line 569 "../src/LibraryWindow.vala"
	_tmp12_ = g_application_get_default ();
#line 569 "../src/LibraryWindow.vala"
	_tmp13_ = notification;
#line 569 "../src/LibraryWindow.vala"
	g_application_send_notification (_tmp12_, context, _tmp13_);
#line 547 "../src/LibraryWindow.vala"
	_g_object_unref0 (notification);
#line 3875 "LibraryWindow.c"
}

static void
music_library_window_show_notification_from_media_async_data_free (gpointer _data)
{
	MusicLibraryWindowShowNotificationFromMediaAsyncData* _data_;
	_data_ = _data;
#line 30 "../src/LibraryWindow.vala"
	_g_object_unref0 (_data_->media);
#line 30 "../src/LibraryWindow.vala"
	_g_object_unref0 (_data_->self);
#line 30 "../src/LibraryWindow.vala"
	g_slice_free (MusicLibraryWindowShowNotificationFromMediaAsyncData, _data_);
#line 3889 "LibraryWindow.c"
}

static void
music_library_window_show_notification_from_media_async (MusicLibraryWindow* self,
                                                         MusicMedia* media,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_)
{
	MusicLibraryWindowShowNotificationFromMediaAsyncData* _data_;
	MusicLibraryWindow* _tmp0_;
	MusicMedia* _tmp1_;
#line 30 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/LibraryWindow.vala"
	g_return_if_fail (media != NULL);
#line 30 "../src/LibraryWindow.vala"
	_data_ = g_slice_new0 (MusicLibraryWindowShowNotificationFromMediaAsyncData);
#line 30 "../src/LibraryWindow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 30 "../src/LibraryWindow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_library_window_show_notification_from_media_async_data_free);
#line 30 "../src/LibraryWindow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 30 "../src/LibraryWindow.vala"
	_data_->self = _tmp0_;
#line 30 "../src/LibraryWindow.vala"
	_tmp1_ = _g_object_ref0 (media);
#line 30 "../src/LibraryWindow.vala"
	_g_object_unref0 (_data_->media);
#line 30 "../src/LibraryWindow.vala"
	_data_->media = _tmp1_;
#line 30 "../src/LibraryWindow.vala"
	music_library_window_show_notification_from_media_async_co (_data_);
#line 3923 "LibraryWindow.c"
}

static void
music_library_window_show_notification_from_media_finish (MusicLibraryWindow* self,
                                                          GAsyncResult* _res_)
{
	MusicLibraryWindowShowNotificationFromMediaAsyncData* _data_;
#line 30 "../src/LibraryWindow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3933 "LibraryWindow.c"
}

static gboolean
music_library_window_show_notification_from_media_async_co (MusicLibraryWindowShowNotificationFromMediaAsyncData* _data_)
{
#line 572 "../src/LibraryWindow.vala"
	switch (_data_->_state_) {
#line 572 "../src/LibraryWindow.vala"
		case 0:
#line 3943 "LibraryWindow.c"
		goto _state_0;
		default:
#line 572 "../src/LibraryWindow.vala"
		g_assert_not_reached ();
#line 3948 "LibraryWindow.c"
	}
	_state_0:
#line 573 "../src/LibraryWindow.vala"
	if (_data_->media == NULL) {
#line 574 "../src/LibraryWindow.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 574 "../src/LibraryWindow.vala"
		if (_data_->_state_ != 0) {
#line 574 "../src/LibraryWindow.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 574 "../src/LibraryWindow.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3961 "LibraryWindow.c"
			}
		}
#line 574 "../src/LibraryWindow.vala"
		g_object_unref (_data_->_async_result);
#line 574 "../src/LibraryWindow.vala"
		return FALSE;
#line 3968 "LibraryWindow.c"
	}
#line 576 "../src/LibraryWindow.vala"
	_data_->_tmp0_ = _data_->self->priv->notification_cancellable;
#line 576 "../src/LibraryWindow.vala"
	if (_data_->_tmp0_ != NULL) {
#line 577 "../src/LibraryWindow.vala"
		_data_->_tmp1_ = _data_->self->priv->notification_cancellable;
#line 577 "../src/LibraryWindow.vala"
		g_cancellable_cancel (_data_->_tmp1_);
#line 3978 "LibraryWindow.c"
	}
#line 579 "../src/LibraryWindow.vala"
	_data_->_tmp2_ = g_cancellable_new ();
#line 579 "../src/LibraryWindow.vala"
	_g_object_unref0 (_data_->self->priv->notification_cancellable);
#line 579 "../src/LibraryWindow.vala"
	_data_->self->priv->notification_cancellable = _data_->_tmp2_;
#line 581 "../src/LibraryWindow.vala"
	_data_->_tmp3_ = music_media_get_display_title (_data_->media);
#line 581 "../src/LibraryWindow.vala"
	_data_->primary_text = _data_->_tmp3_;
#line 583 "../src/LibraryWindow.vala"
	_data_->_tmp4_ = g_string_new ("");
#line 583 "../src/LibraryWindow.vala"
	_data_->secondary_text = _data_->_tmp4_;
#line 584 "../src/LibraryWindow.vala"
	_data_->_tmp5_ = _data_->secondary_text;
#line 584 "../src/LibraryWindow.vala"
	_data_->_tmp6_ = music_media_get_display_artist (_data_->media);
#line 584 "../src/LibraryWindow.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 584 "../src/LibraryWindow.vala"
	g_string_append (_data_->_tmp5_, _data_->_tmp7_);
#line 584 "../src/LibraryWindow.vala"
	_g_free0 (_data_->_tmp7_);
#line 585 "../src/LibraryWindow.vala"
	_data_->_tmp8_ = _data_->secondary_text;
#line 585 "../src/LibraryWindow.vala"
	g_string_append (_data_->_tmp8_, "\n");
#line 586 "../src/LibraryWindow.vala"
	_data_->_tmp9_ = _data_->secondary_text;
#line 586 "../src/LibraryWindow.vala"
	_data_->_tmp10_ = music_media_get_display_album (_data_->media);
#line 586 "../src/LibraryWindow.vala"
	_data_->_tmp11_ = _data_->_tmp10_;
#line 586 "../src/LibraryWindow.vala"
	g_string_append (_data_->_tmp9_, _data_->_tmp11_);
#line 586 "../src/LibraryWindow.vala"
	_g_free0 (_data_->_tmp11_);
#line 587 "../src/LibraryWindow.vala"
	_data_->_tmp12_ = _data_->self->priv->notification_cancellable;
#line 587 "../src/LibraryWindow.vala"
	if (!g_cancellable_is_cancelled (_data_->_tmp12_)) {
#line 588 "../src/LibraryWindow.vala"
		_data_->_tmp13_ = _data_->primary_text;
#line 588 "../src/LibraryWindow.vala"
		_data_->_tmp14_ = _data_->secondary_text;
#line 588 "../src/LibraryWindow.vala"
		_data_->_tmp15_ = _data_->_tmp14_->str;
#line 588 "../src/LibraryWindow.vala"
		_data_->_tmp16_ = music_media_get_album_info (_data_->media);
#line 588 "../src/LibraryWindow.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 588 "../src/LibraryWindow.vala"
		_data_->_tmp18_ = music_album_get_cover_icon (_data_->_tmp17_);
#line 588 "../src/LibraryWindow.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 588 "../src/LibraryWindow.vala"
		music_library_window_show_notification (_data_->self, _data_->_tmp13_, _data_->_tmp15_, _data_->_tmp19_, G_NOTIFICATION_PRIORITY_LOW, "music");
#line 4038 "LibraryWindow.c"
	}
#line 572 "../src/LibraryWindow.vala"
	_g_string_free0 (_data_->secondary_text);
#line 572 "../src/LibraryWindow.vala"
	_g_free0 (_data_->primary_text);
#line 572 "../src/LibraryWindow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 572 "../src/LibraryWindow.vala"
	if (_data_->_state_ != 0) {
#line 572 "../src/LibraryWindow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 572 "../src/LibraryWindow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4052 "LibraryWindow.c"
		}
	}
#line 572 "../src/LibraryWindow.vala"
	g_object_unref (_data_->_async_result);
#line 572 "../src/LibraryWindow.vala"
	return FALSE;
#line 4059 "LibraryWindow.c"
}

static void
music_library_window_notify_current_media_async_data_free (gpointer _data)
{
	MusicLibraryWindowNotifyCurrentMediaAsyncData* _data_;
	_data_ = _data;
#line 30 "../src/LibraryWindow.vala"
	_g_object_unref0 (_data_->self);
#line 30 "../src/LibraryWindow.vala"
	g_slice_free (MusicLibraryWindowNotifyCurrentMediaAsyncData, _data_);
#line 4071 "LibraryWindow.c"
}

static void
music_library_window_notify_current_media_async (MusicLibraryWindow* self,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	MusicLibraryWindowNotifyCurrentMediaAsyncData* _data_;
	MusicLibraryWindow* _tmp0_;
#line 30 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/LibraryWindow.vala"
	_data_ = g_slice_new0 (MusicLibraryWindowNotifyCurrentMediaAsyncData);
#line 30 "../src/LibraryWindow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 30 "../src/LibraryWindow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_library_window_notify_current_media_async_data_free);
#line 30 "../src/LibraryWindow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 30 "../src/LibraryWindow.vala"
	_data_->self = _tmp0_;
#line 30 "../src/LibraryWindow.vala"
	music_library_window_notify_current_media_async_co (_data_);
#line 4095 "LibraryWindow.c"
}

static void
music_library_window_notify_current_media_finish (MusicLibraryWindow* self,
                                                  GAsyncResult* _res_)
{
	MusicLibraryWindowNotifyCurrentMediaAsyncData* _data_;
#line 30 "../src/LibraryWindow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4105 "LibraryWindow.c"
}

static void
music_library_window_notify_current_media_async_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_)
{
	MusicLibraryWindowNotifyCurrentMediaAsyncData* _data_;
#line 594 "../src/LibraryWindow.vala"
	_data_ = _user_data_;
#line 594 "../src/LibraryWindow.vala"
	_data_->_source_object_ = source_object;
#line 594 "../src/LibraryWindow.vala"
	_data_->_res_ = _res_;
#line 594 "../src/LibraryWindow.vala"
	music_library_window_notify_current_media_async_co (_data_);
#line 4122 "LibraryWindow.c"
}

static gboolean
music_library_window_notify_current_media_async_co (MusicLibraryWindowNotifyCurrentMediaAsyncData* _data_)
{
#line 592 "../src/LibraryWindow.vala"
	switch (_data_->_state_) {
#line 592 "../src/LibraryWindow.vala"
		case 0:
#line 4132 "LibraryWindow.c"
		goto _state_0;
#line 592 "../src/LibraryWindow.vala"
		case 1:
#line 4136 "LibraryWindow.c"
		goto _state_1;
		default:
#line 592 "../src/LibraryWindow.vala"
		g_assert_not_reached ();
#line 4141 "LibraryWindow.c"
	}
	_state_0:
#line 593 "../src/LibraryWindow.vala"
	_data_->_tmp0_ = music_app_get_player ();
#line 593 "../src/LibraryWindow.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 593 "../src/LibraryWindow.vala"
	_data_->_tmp2_ = music_playback_manager_get_current_media (_data_->_tmp1_);
#line 593 "../src/LibraryWindow.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 593 "../src/LibraryWindow.vala"
	if (_data_->_tmp3_ != NULL) {
#line 594 "../src/LibraryWindow.vala"
		_data_->_tmp4_ = music_app_get_player ();
#line 594 "../src/LibraryWindow.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 594 "../src/LibraryWindow.vala"
		_data_->_tmp6_ = music_playback_manager_get_current_media (_data_->_tmp5_);
#line 594 "../src/LibraryWindow.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 594 "../src/LibraryWindow.vala"
		_data_->_state_ = 1;
#line 594 "../src/LibraryWindow.vala"
		music_library_window_show_notification_from_media_async (_data_->self, _data_->_tmp7_, music_library_window_notify_current_media_async_ready, _data_);
#line 594 "../src/LibraryWindow.vala"
		return FALSE;
#line 4168 "LibraryWindow.c"
		_state_1:
#line 594 "../src/LibraryWindow.vala"
		music_library_window_show_notification_from_media_finish (_data_->self, _data_->_res_);
#line 4172 "LibraryWindow.c"
	}
#line 592 "../src/LibraryWindow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 592 "../src/LibraryWindow.vala"
	if (_data_->_state_ != 0) {
#line 592 "../src/LibraryWindow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 592 "../src/LibraryWindow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4182 "LibraryWindow.c"
		}
	}
#line 592 "../src/LibraryWindow.vala"
	g_object_unref (_data_->_async_result);
#line 592 "../src/LibraryWindow.vala"
	return FALSE;
#line 4189 "LibraryWindow.c"
}

/**
     * Sets the given view as the active item
     */
static void
music_library_window_set_active_view (MusicLibraryWindow* self,
                                      MusicViewWrapper* view)
{
	gboolean _tmp0_;
	MusicViewStack* _tmp1_;
#line 601 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 601 "../src/LibraryWindow.vala"
	g_return_if_fail (view != NULL);
#line 602 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->_initialization_finished;
#line 602 "../src/LibraryWindow.vala"
	if (!_tmp0_) {
#line 603 "../src/LibraryWindow.vala"
		return;
#line 4211 "LibraryWindow.c"
	}
#line 605 "../src/LibraryWindow.vala"
	_tmp1_ = self->priv->_view_stack;
#line 605 "../src/LibraryWindow.vala"
	gtk_stack_set_visible_child ((GtkStack*) _tmp1_, (GtkWidget*) view);
#line 607 "../src/LibraryWindow.vala"
	if (MUSIC_IS_VIEW_WRAPPER (view)) {
#line 608 "../src/LibraryWindow.vala"
		music_view_wrapper_set_as_current_view (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper));
#line 4221 "LibraryWindow.c"
	}
}

static void
music_library_window_load_playlists (MusicLibraryWindow* self)
{
	MusicLibrariesManager* _tmp24_;
	MusicPlaybackManager* _tmp25_;
	MusicPlaybackManager* _tmp26_;
	MusicStaticPlaylist* _tmp27_;
	MusicLibrariesManager* _tmp28_;
	MusicPlaybackManager* _tmp29_;
	MusicPlaybackManager* _tmp30_;
	MusicHistoryPlaylist* _tmp31_;
	MusicTreeViewSetup* music_tvs = NULL;
	MusicLocalLibrary* _tmp32_;
	MusicLocalLibrary* _tmp33_;
	GdaConnection* _tmp34_;
	GdaConnection* _tmp35_;
	MusicTreeViewSetup* _tmp36_;
	MusicMusicViewWrapper* music_view_wrapper = NULL;
	MusicLocalLibrary* _tmp37_;
	MusicLocalLibrary* _tmp38_;
	MusicTopDisplay* _tmp39_;
	MusicMusicViewWrapper* _tmp40_;
	MusicViewStack* _tmp41_;
	MusicSourceListEntry* entry = NULL;
	MusicSourceListView* _tmp42_;
	GThemedIcon* _tmp43_;
	GThemedIcon* _tmp44_;
	MusicSourceListEntry* _tmp45_;
	MusicSourceListEntry* _tmp46_;
	GeeHashMap* _tmp47_;
	MusicLocalLibrary* _tmp48_;
	MusicLocalLibrary* _tmp49_;
	MusicStaticPlaylist* _tmp50_;
	GeeHashMap* _tmp51_;
	MusicLocalLibrary* _tmp52_;
	MusicLocalLibrary* _tmp53_;
	MusicStaticPlaylist* _tmp54_;
#line 611 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 612 "../src/LibraryWindow.vala"
	g_debug ("LibraryWindow.vala:612: Loading playlists");
#line 4266 "LibraryWindow.c"
	{
		GeeIterator* _p_it = NULL;
		MusicLocalLibrary* _tmp0_;
		MusicLocalLibrary* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 614 "../src/LibraryWindow.vala"
		_tmp0_ = music_library_window_get_library_manager (self);
#line 614 "../src/LibraryWindow.vala"
		_tmp1_ = _tmp0_;
#line 614 "../src/LibraryWindow.vala"
		_tmp2_ = music_library_get_smart_playlists ((MusicLibrary*) _tmp1_);
#line 614 "../src/LibraryWindow.vala"
		_tmp3_ = _tmp2_;
#line 614 "../src/LibraryWindow.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 614 "../src/LibraryWindow.vala"
		_tmp5_ = _tmp4_;
#line 614 "../src/LibraryWindow.vala"
		_g_object_unref0 (_tmp3_);
#line 614 "../src/LibraryWindow.vala"
		_p_it = _tmp5_;
#line 614 "../src/LibraryWindow.vala"
		while (TRUE) {
#line 4293 "LibraryWindow.c"
			GeeIterator* _tmp6_;
			MusicSmartPlaylist* p = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			MusicSmartPlaylist* _tmp9_;
			MusicLocalLibrary* _tmp10_;
			MusicLocalLibrary* _tmp11_;
#line 614 "../src/LibraryWindow.vala"
			_tmp6_ = _p_it;
#line 614 "../src/LibraryWindow.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 614 "../src/LibraryWindow.vala"
				break;
#line 4307 "LibraryWindow.c"
			}
#line 614 "../src/LibraryWindow.vala"
			_tmp7_ = _p_it;
#line 614 "../src/LibraryWindow.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 614 "../src/LibraryWindow.vala"
			p = (MusicSmartPlaylist*) _tmp8_;
#line 615 "../src/LibraryWindow.vala"
			_tmp9_ = p;
#line 615 "../src/LibraryWindow.vala"
			_tmp10_ = music_library_window_get_library_manager (self);
#line 615 "../src/LibraryWindow.vala"
			_tmp11_ = _tmp10_;
#line 615 "../src/LibraryWindow.vala"
			music_library_window_add_smartplaylist (self, _tmp9_, (MusicLibrary*) _tmp11_, NULL);
#line 614 "../src/LibraryWindow.vala"
			_g_object_unref0 (p);
#line 4325 "LibraryWindow.c"
		}
#line 614 "../src/LibraryWindow.vala"
		_g_object_unref0 (_p_it);
#line 4329 "LibraryWindow.c"
	}
	{
		GeeIterator* _p_it = NULL;
		MusicLocalLibrary* _tmp12_;
		MusicLocalLibrary* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeIterator* _tmp16_;
		GeeIterator* _tmp17_;
#line 618 "../src/LibraryWindow.vala"
		_tmp12_ = music_library_window_get_library_manager (self);
#line 618 "../src/LibraryWindow.vala"
		_tmp13_ = _tmp12_;
#line 618 "../src/LibraryWindow.vala"
		_tmp14_ = music_library_get_playlists ((MusicLibrary*) _tmp13_);
#line 618 "../src/LibraryWindow.vala"
		_tmp15_ = _tmp14_;
#line 618 "../src/LibraryWindow.vala"
		_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
#line 618 "../src/LibraryWindow.vala"
		_tmp17_ = _tmp16_;
#line 618 "../src/LibraryWindow.vala"
		_g_object_unref0 (_tmp15_);
#line 618 "../src/LibraryWindow.vala"
		_p_it = _tmp17_;
#line 618 "../src/LibraryWindow.vala"
		while (TRUE) {
#line 4357 "LibraryWindow.c"
			GeeIterator* _tmp18_;
			MusicStaticPlaylist* p = NULL;
			GeeIterator* _tmp19_;
			gpointer _tmp20_;
			MusicStaticPlaylist* _tmp21_;
			MusicLocalLibrary* _tmp22_;
			MusicLocalLibrary* _tmp23_;
#line 618 "../src/LibraryWindow.vala"
			_tmp18_ = _p_it;
#line 618 "../src/LibraryWindow.vala"
			if (!gee_iterator_next (_tmp18_)) {
#line 618 "../src/LibraryWindow.vala"
				break;
#line 4371 "LibraryWindow.c"
			}
#line 618 "../src/LibraryWindow.vala"
			_tmp19_ = _p_it;
#line 618 "../src/LibraryWindow.vala"
			_tmp20_ = gee_iterator_get (_tmp19_);
#line 618 "../src/LibraryWindow.vala"
			p = (MusicStaticPlaylist*) _tmp20_;
#line 619 "../src/LibraryWindow.vala"
			_tmp21_ = p;
#line 619 "../src/LibraryWindow.vala"
			_tmp22_ = music_library_window_get_library_manager (self);
#line 619 "../src/LibraryWindow.vala"
			_tmp23_ = _tmp22_;
#line 619 "../src/LibraryWindow.vala"
			music_library_window_add_playlist (self, _tmp21_, (MusicLibrary*) _tmp23_, NULL);
#line 618 "../src/LibraryWindow.vala"
			_g_object_unref0 (p);
#line 4389 "LibraryWindow.c"
		}
#line 618 "../src/LibraryWindow.vala"
		_g_object_unref0 (_p_it);
#line 4393 "LibraryWindow.c"
	}
#line 622 "../src/LibraryWindow.vala"
	_tmp24_ = music_libraries_manager;
#line 622 "../src/LibraryWindow.vala"
	_tmp25_ = music_app_get_player ();
#line 622 "../src/LibraryWindow.vala"
	_tmp26_ = _tmp25_;
#line 622 "../src/LibraryWindow.vala"
	_tmp27_ = _tmp26_->queue_playlist;
#line 622 "../src/LibraryWindow.vala"
	g_signal_emit_by_name (_tmp24_, "add-headless-playlist", _tmp27_);
#line 623 "../src/LibraryWindow.vala"
	_tmp28_ = music_libraries_manager;
#line 623 "../src/LibraryWindow.vala"
	_tmp29_ = music_app_get_player ();
#line 623 "../src/LibraryWindow.vala"
	_tmp30_ = _tmp29_;
#line 623 "../src/LibraryWindow.vala"
	_tmp31_ = _tmp30_->history_playlist;
#line 623 "../src/LibraryWindow.vala"
	g_signal_emit_by_name (_tmp28_, "add-headless-playlist", (MusicStaticPlaylist*) _tmp31_);
#line 626 "../src/LibraryWindow.vala"
	_tmp32_ = music_library_window_get_library_manager (self);
#line 626 "../src/LibraryWindow.vala"
	_tmp33_ = _tmp32_;
#line 626 "../src/LibraryWindow.vala"
	_tmp34_ = music_local_library_get_connection (_tmp33_);
#line 626 "../src/LibraryWindow.vala"
	_tmp35_ = _tmp34_;
#line 626 "../src/LibraryWindow.vala"
	_tmp36_ = music_tree_view_setup_new (MUSIC_VIEW_WRAPPER_HINT_MUSIC, "library:main", _tmp35_);
#line 626 "../src/LibraryWindow.vala"
	music_tvs = _tmp36_;
#line 627 "../src/LibraryWindow.vala"
	_tmp37_ = music_library_window_get_library_manager (self);
#line 627 "../src/LibraryWindow.vala"
	_tmp38_ = _tmp37_;
#line 627 "../src/LibraryWindow.vala"
	_tmp39_ = self->priv->top_display;
#line 627 "../src/LibraryWindow.vala"
	_tmp40_ = music_music_view_wrapper_new (music_tvs, (MusicLibrary*) _tmp38_, _tmp39_);
#line 627 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp40_);
#line 627 "../src/LibraryWindow.vala"
	music_view_wrapper = _tmp40_;
#line 628 "../src/LibraryWindow.vala"
	_tmp41_ = self->priv->_view_stack;
#line 628 "../src/LibraryWindow.vala"
	music_view_stack_add_view (_tmp41_, (GtkWidget*) music_view_wrapper);
#line 629 "../src/LibraryWindow.vala"
	_tmp42_ = self->priv->_source_list_view;
#line 629 "../src/LibraryWindow.vala"
	_tmp43_ = (GThemedIcon*) g_themed_icon_new ("library-music");
#line 629 "../src/LibraryWindow.vala"
	_tmp44_ = _tmp43_;
#line 629 "../src/LibraryWindow.vala"
	_tmp45_ = music_source_list_view_add_item (_tmp42_, (GtkGrid*) music_view_wrapper, _ ("Music"), MUSIC_VIEW_WRAPPER_HINT_MUSIC, (GIcon*) _tmp44_, NULL, NULL, NULL);
#line 629 "../src/LibraryWindow.vala"
	_tmp46_ = _tmp45_;
#line 629 "../src/LibraryWindow.vala"
	_g_object_unref0 (_tmp44_);
#line 629 "../src/LibraryWindow.vala"
	entry = _tmp46_;
#line 635 "../src/LibraryWindow.vala"
	_tmp47_ = self->priv->match_playlist_entry;
#line 635 "../src/LibraryWindow.vala"
	_tmp48_ = music_library_window_get_library_manager (self);
#line 635 "../src/LibraryWindow.vala"
	_tmp49_ = _tmp48_;
#line 635 "../src/LibraryWindow.vala"
	_tmp50_ = _tmp49_->p_music;
#line 635 "../src/LibraryWindow.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp47_, (MusicPlaylist*) _tmp50_, entry);
#line 636 "../src/LibraryWindow.vala"
	_tmp51_ = self->match_playlists;
#line 636 "../src/LibraryWindow.vala"
	_tmp52_ = music_library_window_get_library_manager (self);
#line 636 "../src/LibraryWindow.vala"
	_tmp53_ = _tmp52_;
#line 636 "../src/LibraryWindow.vala"
	_tmp54_ = _tmp53_->p_music;
#line 636 "../src/LibraryWindow.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp51_, (MusicPlaylist*) _tmp54_, (MusicViewWrapper*) music_view_wrapper);
#line 638 "../src/LibraryWindow.vala"
	g_debug ("LibraryWindow.vala:638: Finished loading playlists");
#line 611 "../src/LibraryWindow.vala"
	_g_object_unref0 (entry);
#line 611 "../src/LibraryWindow.vala"
	_g_object_unref0 (music_view_wrapper);
#line 611 "../src/LibraryWindow.vala"
	_g_object_unref0 (music_tvs);
#line 4485 "LibraryWindow.c"
}

/**
     * SourceList Configuration
     */
static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 646 "../src/LibraryWindow.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 646 "../src/LibraryWindow.vala"
	return _data4_;
#line 4498 "LibraryWindow.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 646 "../src/LibraryWindow.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 4508 "LibraryWindow.c"
		MusicLibraryWindow* self;
#line 646 "../src/LibraryWindow.vala"
		self = _data4_->self;
#line 646 "../src/LibraryWindow.vala"
		_g_object_unref0 (_data4_->p);
#line 646 "../src/LibraryWindow.vala"
		_g_object_unref0 (self);
#line 646 "../src/LibraryWindow.vala"
		g_slice_free (Block4Data, _data4_);
#line 4518 "LibraryWindow.c"
	}
}

static void
__lambda157_ (Block4Data* _data4_,
              GeeCollection* s)
{
	MusicLibraryWindow* self;
#line 647 "../src/LibraryWindow.vala"
	self = _data4_->self;
#line 647 "../src/LibraryWindow.vala"
	g_return_if_fail (s != NULL);
#line 647 "../src/LibraryWindow.vala"
	music_library_window_update_playlist_badge (self, _data4_->p);
#line 4533 "LibraryWindow.c"
}

static void
___lambda157__music_playlist_media_added (MusicPlaylist* _sender,
                                          GeeCollection* media,
                                          gpointer self)
{
#line 647 "../src/LibraryWindow.vala"
	__lambda157_ (self, media);
#line 4543 "LibraryWindow.c"
}

static void
__lambda158_ (Block4Data* _data4_,
              GeeCollection* s)
{
	MusicLibraryWindow* self;
#line 648 "../src/LibraryWindow.vala"
	self = _data4_->self;
#line 648 "../src/LibraryWindow.vala"
	g_return_if_fail (s != NULL);
#line 648 "../src/LibraryWindow.vala"
	music_library_window_update_playlist_badge (self, _data4_->p);
#line 4557 "LibraryWindow.c"
}

static void
___lambda158__music_playlist_media_removed (MusicPlaylist* _sender,
                                            GeeCollection* media,
                                            gpointer self)
{
#line 648 "../src/LibraryWindow.vala"
	__lambda158_ (self, media);
#line 4567 "LibraryWindow.c"
}

static void
__lambda159_ (Block4Data* _data4_,
              MusicPlaylist* s)
{
	MusicLibraryWindow* self;
#line 649 "../src/LibraryWindow.vala"
	self = _data4_->self;
#line 649 "../src/LibraryWindow.vala"
	g_return_if_fail (s != NULL);
#line 649 "../src/LibraryWindow.vala"
	music_library_window_update_playlist_badge (self, _data4_->p);
#line 4581 "LibraryWindow.c"
}

static void
___lambda159__music_playlist_cleared (MusicPlaylist* _sender,
                                      gpointer self)
{
#line 649 "../src/LibraryWindow.vala"
	__lambda159_ (self, _sender);
#line 4590 "LibraryWindow.c"
}

static void
music_library_window_update_badge_on_playlist_update (MusicLibraryWindow* self,
                                                      MusicPlaylist* p,
                                                      MusicSourceListEntry* entry)
{
	Block4Data* _data4_;
	MusicPlaylist* _tmp0_;
#line 646 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 646 "../src/LibraryWindow.vala"
	g_return_if_fail (p != NULL);
#line 646 "../src/LibraryWindow.vala"
	g_return_if_fail (entry != NULL);
#line 646 "../src/LibraryWindow.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 646 "../src/LibraryWindow.vala"
	_data4_->_ref_count_ = 1;
#line 646 "../src/LibraryWindow.vala"
	_data4_->self = g_object_ref (self);
#line 646 "../src/LibraryWindow.vala"
	_tmp0_ = _g_object_ref0 (p);
#line 646 "../src/LibraryWindow.vala"
	_g_object_unref0 (_data4_->p);
#line 646 "../src/LibraryWindow.vala"
	_data4_->p = _tmp0_;
#line 647 "../src/LibraryWindow.vala"
	g_signal_connect_data (_data4_->p, "media-added", (GCallback) ___lambda157__music_playlist_media_added, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 648 "../src/LibraryWindow.vala"
	g_signal_connect_data (_data4_->p, "media-removed", (GCallback) ___lambda158__music_playlist_media_removed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 649 "../src/LibraryWindow.vala"
	g_signal_connect_data (_data4_->p, "cleared", (GCallback) ___lambda159__music_playlist_cleared, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 646 "../src/LibraryWindow.vala"
	block4_data_unref (_data4_);
#line 646 "../src/LibraryWindow.vala"
	_data4_ = NULL;
#line 4628 "LibraryWindow.c"
}

static void
music_library_window_update_playlist_badge (MusicLibraryWindow* self,
                                            MusicPlaylist* playlist)
{
	MusicSourceListEntry* entry = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	gint media_count = 0;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* new_badge = NULL;
	gchar* _tmp9_;
	MusicSourceListEntry* _tmp10_;
#line 652 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 652 "../src/LibraryWindow.vala"
	g_return_if_fail (playlist != NULL);
#line 653 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->match_playlist_entry;
#line 653 "../src/LibraryWindow.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, playlist);
#line 653 "../src/LibraryWindow.vala"
	entry = (MusicSourceListEntry*) _tmp1_;
#line 654 "../src/LibraryWindow.vala"
	_tmp2_ = music_playlist_get_medias (playlist);
#line 654 "../src/LibraryWindow.vala"
	_tmp3_ = _tmp2_;
#line 654 "../src/LibraryWindow.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 654 "../src/LibraryWindow.vala"
	_tmp5_ = _tmp4_;
#line 654 "../src/LibraryWindow.vala"
	media_count = _tmp5_;
#line 655 "../src/LibraryWindow.vala"
	if (media_count > 0) {
#line 4669 "LibraryWindow.c"
		gchar* _tmp7_;
#line 655 "../src/LibraryWindow.vala"
		_tmp7_ = g_strdup_printf ("%i", media_count);
#line 655 "../src/LibraryWindow.vala"
		_g_free0 (_tmp6_);
#line 655 "../src/LibraryWindow.vala"
		_tmp6_ = _tmp7_;
#line 4677 "LibraryWindow.c"
	} else {
		gchar* _tmp8_;
#line 655 "../src/LibraryWindow.vala"
		_tmp8_ = g_strdup ("");
#line 655 "../src/LibraryWindow.vala"
		_g_free0 (_tmp6_);
#line 655 "../src/LibraryWindow.vala"
		_tmp6_ = _tmp8_;
#line 4686 "LibraryWindow.c"
	}
#line 655 "../src/LibraryWindow.vala"
	_tmp9_ = g_strdup (_tmp6_);
#line 655 "../src/LibraryWindow.vala"
	new_badge = _tmp9_;
#line 656 "../src/LibraryWindow.vala"
	_tmp10_ = entry;
#line 656 "../src/LibraryWindow.vala"
	granite_widgets_source_list_item_set_badge ((GraniteWidgetsSourceListItem*) _tmp10_, new_badge);
#line 652 "../src/LibraryWindow.vala"
	_g_free0 (new_badge);
#line 652 "../src/LibraryWindow.vala"
	_g_free0 (_tmp6_);
#line 652 "../src/LibraryWindow.vala"
	_g_object_unref0 (entry);
#line 4702 "LibraryWindow.c"
}

static void
music_library_window_real_update_sensitivities_data_free (gpointer _data)
{
	MusicLibraryWindowUpdateSensitivitiesData* _data_;
	_data_ = _data;
#line 30 "../src/LibraryWindow.vala"
	_g_object_unref0 (_data_->self);
#line 30 "../src/LibraryWindow.vala"
	g_slice_free (MusicLibraryWindowUpdateSensitivitiesData, _data_);
#line 4714 "LibraryWindow.c"
}

static void
music_library_window_real_update_sensitivities (MusicLibraryWindowInterface* base,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	MusicLibraryWindow * self;
	MusicLibraryWindowUpdateSensitivitiesData* _data_;
	MusicLibraryWindow* _tmp0_;
#line 30 "../src/LibraryWindow.vala"
	self = (MusicLibraryWindow*) base;
#line 30 "../src/LibraryWindow.vala"
	_data_ = g_slice_new0 (MusicLibraryWindowUpdateSensitivitiesData);
#line 30 "../src/LibraryWindow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 30 "../src/LibraryWindow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_library_window_real_update_sensitivities_data_free);
#line 30 "../src/LibraryWindow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 30 "../src/LibraryWindow.vala"
	_data_->self = _tmp0_;
#line 30 "../src/LibraryWindow.vala"
	music_library_window_real_update_sensitivities_co (_data_);
#line 4739 "LibraryWindow.c"
}

static void
music_library_window_update_sensitivities_finish (MusicLibraryWindowInterface* base,
                                                  GAsyncResult* _res_)
{
	MusicLibraryWindowUpdateSensitivitiesData* _data_;
#line 30 "../src/LibraryWindow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4749 "LibraryWindow.c"
}

static gboolean
music_library_window_real_update_sensitivities_co (MusicLibraryWindowUpdateSensitivitiesData* _data_)
{
#line 665 "../src/LibraryWindow.vala"
	switch (_data_->_state_) {
#line 665 "../src/LibraryWindow.vala"
		case 0:
#line 4759 "LibraryWindow.c"
		goto _state_0;
		default:
#line 665 "../src/LibraryWindow.vala"
		g_assert_not_reached ();
#line 4764 "LibraryWindow.c"
	}
	_state_0:
#line 666 "../src/LibraryWindow.vala"
	if (_data_->self->priv->update_sensitivities_pending) {
#line 667 "../src/LibraryWindow.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 667 "../src/LibraryWindow.vala"
		if (_data_->_state_ != 0) {
#line 667 "../src/LibraryWindow.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 667 "../src/LibraryWindow.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4777 "LibraryWindow.c"
			}
		}
#line 667 "../src/LibraryWindow.vala"
		g_object_unref (_data_->_async_result);
#line 667 "../src/LibraryWindow.vala"
		return FALSE;
#line 4784 "LibraryWindow.c"
	}
#line 669 "../src/LibraryWindow.vala"
	_data_->self->priv->update_sensitivities_pending = TRUE;
#line 670 "../src/LibraryWindow.vala"
	music_library_window_update_sensitivities_sync (_data_->self);
#line 671 "../src/LibraryWindow.vala"
	_data_->self->priv->update_sensitivities_pending = FALSE;
#line 665 "../src/LibraryWindow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 665 "../src/LibraryWindow.vala"
	if (_data_->_state_ != 0) {
#line 665 "../src/LibraryWindow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 665 "../src/LibraryWindow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4800 "LibraryWindow.c"
		}
	}
#line 665 "../src/LibraryWindow.vala"
	g_object_unref (_data_->_async_result);
#line 665 "../src/LibraryWindow.vala"
	return FALSE;
#line 4807 "LibraryWindow.c"
}

static GVariant*
_variant_new1 (gboolean value)
{
#line 692 "../src/LibraryWindow.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 4815 "LibraryWindow.c"
}

static GVariant*
_variant_new2 (gboolean value)
{
#line 694 "../src/LibraryWindow.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 4823 "LibraryWindow.c"
}

static void
music_library_window_update_sensitivities_sync (MusicLibraryWindow* self)
{
	gboolean folder_set = FALSE;
	MusicLocalLibrary* _tmp0_;
	MusicLocalLibrary* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean have_media = FALSE;
	MusicLocalLibrary* _tmp4_;
	MusicLocalLibrary* _tmp5_;
	GeeCollection* _tmp6_;
	GeeCollection* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gboolean _tmp10_;
	gboolean doing_ops = FALSE;
	MusicLocalLibrary* _tmp11_;
	MusicLocalLibrary* _tmp12_;
	gboolean media_active = FALSE;
	MusicPlaybackManager* _tmp13_;
	MusicPlaybackManager* _tmp14_;
	MusicMedia* _tmp15_;
	MusicMedia* _tmp16_;
	gboolean media_available = FALSE;
	MusicPlaybackManager* _tmp17_;
	MusicPlaybackManager* _tmp18_;
	GeeCollection* _tmp19_;
	GeeCollection* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_ = FALSE;
	GAction* _tmp25_;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	GAction* _tmp28_;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	GAction* _tmp31_;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp33_ = FALSE;
	GAction* _tmp34_;
	MusicSourceListView* _tmp35_;
	gboolean _tmp36_ = FALSE;
	MusicWidgetsStatusBar* _tmp37_;
	gboolean _tmp38_ = FALSE;
#line 673 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 674 "../src/LibraryWindow.vala"
	g_debug ("LibraryWindow.vala:674: UPDATE SENSITIVITIES");
#line 676 "../src/LibraryWindow.vala"
	_tmp0_ = music_library_window_get_library_manager (self);
#line 676 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 676 "../src/LibraryWindow.vala"
	_tmp2_ = music_local_library_get_main_directory_set (_tmp1_);
#line 676 "../src/LibraryWindow.vala"
	_tmp3_ = _tmp2_;
#line 676 "../src/LibraryWindow.vala"
	folder_set = _tmp3_;
#line 677 "../src/LibraryWindow.vala"
	_tmp4_ = music_library_window_get_library_manager (self);
#line 677 "../src/LibraryWindow.vala"
	_tmp5_ = _tmp4_;
#line 677 "../src/LibraryWindow.vala"
	_tmp6_ = music_library_get_medias ((MusicLibrary*) _tmp5_);
#line 677 "../src/LibraryWindow.vala"
	_tmp7_ = _tmp6_;
#line 677 "../src/LibraryWindow.vala"
	_tmp8_ = gee_collection_get_size (_tmp7_);
#line 677 "../src/LibraryWindow.vala"
	_tmp9_ = _tmp8_;
#line 677 "../src/LibraryWindow.vala"
	_tmp10_ = _tmp9_ > 0;
#line 677 "../src/LibraryWindow.vala"
	_g_object_unref0 (_tmp7_);
#line 677 "../src/LibraryWindow.vala"
	have_media = _tmp10_;
#line 678 "../src/LibraryWindow.vala"
	_tmp11_ = music_library_window_get_library_manager (self);
#line 678 "../src/LibraryWindow.vala"
	_tmp12_ = _tmp11_;
#line 678 "../src/LibraryWindow.vala"
	doing_ops = music_library_doing_file_operations ((MusicLibrary*) _tmp12_);
#line 679 "../src/LibraryWindow.vala"
	_tmp13_ = music_app_get_player ();
#line 679 "../src/LibraryWindow.vala"
	_tmp14_ = _tmp13_;
#line 679 "../src/LibraryWindow.vala"
	_tmp15_ = music_playback_manager_get_current_media (_tmp14_);
#line 679 "../src/LibraryWindow.vala"
	_tmp16_ = _tmp15_;
#line 679 "../src/LibraryWindow.vala"
	media_active = _tmp16_ != NULL;
#line 680 "../src/LibraryWindow.vala"
	_tmp17_ = music_app_get_player ();
#line 680 "../src/LibraryWindow.vala"
	_tmp18_ = _tmp17_;
#line 680 "../src/LibraryWindow.vala"
	_tmp19_ = music_playback_manager_get_current_media_list (_tmp18_);
#line 680 "../src/LibraryWindow.vala"
	_tmp20_ = _tmp19_;
#line 680 "../src/LibraryWindow.vala"
	_tmp21_ = gee_collection_get_size (_tmp20_);
#line 680 "../src/LibraryWindow.vala"
	_tmp22_ = _tmp21_;
#line 680 "../src/LibraryWindow.vala"
	_tmp23_ = _tmp22_ > 0;
#line 680 "../src/LibraryWindow.vala"
	_g_object_unref0 (_tmp20_);
#line 680 "../src/LibraryWindow.vala"
	media_available = _tmp23_;
#line 682 "../src/LibraryWindow.vala"
	if (!doing_ops) {
#line 682 "../src/LibraryWindow.vala"
		_tmp24_ = folder_set;
#line 4943 "LibraryWindow.c"
	} else {
#line 682 "../src/LibraryWindow.vala"
		_tmp24_ = FALSE;
#line 4947 "LibraryWindow.c"
	}
#line 682 "../src/LibraryWindow.vala"
	_tmp25_ = g_action_map_lookup_action ((GActionMap*) self, MUSIC_LIBRARY_WINDOW_ACTION_IMPORT);
#line 682 "../src/LibraryWindow.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, g_simple_action_get_type (), GSimpleAction), _tmp24_);
#line 683 "../src/LibraryWindow.vala"
	if (media_active) {
#line 683 "../src/LibraryWindow.vala"
		_tmp27_ = TRUE;
#line 4957 "LibraryWindow.c"
	} else {
#line 683 "../src/LibraryWindow.vala"
		_tmp27_ = media_available;
#line 4961 "LibraryWindow.c"
	}
#line 683 "../src/LibraryWindow.vala"
	if (_tmp27_) {
#line 683 "../src/LibraryWindow.vala"
		_tmp26_ = TRUE;
#line 4967 "LibraryWindow.c"
	} else {
#line 683 "../src/LibraryWindow.vala"
		_tmp26_ = have_media;
#line 4971 "LibraryWindow.c"
	}
#line 683 "../src/LibraryWindow.vala"
	_tmp28_ = g_action_map_lookup_action ((GActionMap*) self, MUSIC_LIBRARY_WINDOW_ACTION_PLAY);
#line 683 "../src/LibraryWindow.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, g_simple_action_get_type (), GSimpleAction), _tmp26_);
#line 684 "../src/LibraryWindow.vala"
	if (media_active) {
#line 684 "../src/LibraryWindow.vala"
		_tmp30_ = TRUE;
#line 4981 "LibraryWindow.c"
	} else {
#line 684 "../src/LibraryWindow.vala"
		_tmp30_ = media_available;
#line 4985 "LibraryWindow.c"
	}
#line 684 "../src/LibraryWindow.vala"
	if (_tmp30_) {
#line 684 "../src/LibraryWindow.vala"
		_tmp29_ = TRUE;
#line 4991 "LibraryWindow.c"
	} else {
#line 684 "../src/LibraryWindow.vala"
		_tmp29_ = have_media;
#line 4995 "LibraryWindow.c"
	}
#line 684 "../src/LibraryWindow.vala"
	_tmp31_ = g_action_map_lookup_action ((GActionMap*) self, MUSIC_LIBRARY_WINDOW_ACTION_PLAY_NEXT);
#line 684 "../src/LibraryWindow.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, g_simple_action_get_type (), GSimpleAction), _tmp29_);
#line 685 "../src/LibraryWindow.vala"
	if (media_active) {
#line 685 "../src/LibraryWindow.vala"
		_tmp33_ = TRUE;
#line 5005 "LibraryWindow.c"
	} else {
#line 685 "../src/LibraryWindow.vala"
		_tmp33_ = media_available;
#line 5009 "LibraryWindow.c"
	}
#line 685 "../src/LibraryWindow.vala"
	if (_tmp33_) {
#line 685 "../src/LibraryWindow.vala"
		_tmp32_ = TRUE;
#line 5015 "LibraryWindow.c"
	} else {
#line 685 "../src/LibraryWindow.vala"
		_tmp32_ = have_media;
#line 5019 "LibraryWindow.c"
	}
#line 685 "../src/LibraryWindow.vala"
	_tmp34_ = g_action_map_lookup_action ((GActionMap*) self, MUSIC_LIBRARY_WINDOW_ACTION_PLAY_PREVIOUS);
#line 685 "../src/LibraryWindow.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, g_simple_action_get_type (), GSimpleAction), _tmp32_);
#line 688 "../src/LibraryWindow.vala"
	_tmp35_ = self->priv->_source_list_view;
#line 688 "../src/LibraryWindow.vala"
	music_source_list_view_change_playlist_category_visibility (_tmp35_, have_media);
#line 689 "../src/LibraryWindow.vala"
	if (folder_set) {
#line 689 "../src/LibraryWindow.vala"
		_tmp36_ = have_media;
#line 5033 "LibraryWindow.c"
	} else {
#line 689 "../src/LibraryWindow.vala"
		_tmp36_ = FALSE;
#line 5037 "LibraryWindow.c"
	}
#line 689 "../src/LibraryWindow.vala"
	_tmp37_ = self->priv->_statusbar;
#line 689 "../src/LibraryWindow.vala"
	music_widgets_status_bar_set_playlist_menubutton_sensitive (_tmp37_, _tmp36_);
#line 691 "../src/LibraryWindow.vala"
	if (!media_active) {
#line 691 "../src/LibraryWindow.vala"
		_tmp38_ = TRUE;
#line 5047 "LibraryWindow.c"
	} else {
		gboolean _tmp39_ = FALSE;
#line 691 "../src/LibraryWindow.vala"
		if (have_media) {
#line 5052 "LibraryWindow.c"
			MusicPlaybackManager* _tmp40_;
			MusicPlaybackManager* _tmp41_;
			gboolean _tmp42_;
			gboolean _tmp43_;
#line 691 "../src/LibraryWindow.vala"
			_tmp40_ = music_app_get_player ();
#line 691 "../src/LibraryWindow.vala"
			_tmp41_ = _tmp40_;
#line 691 "../src/LibraryWindow.vala"
			_tmp42_ = music_playback_manager_get_playing (_tmp41_);
#line 691 "../src/LibraryWindow.vala"
			_tmp43_ = _tmp42_;
#line 691 "../src/LibraryWindow.vala"
			_tmp39_ = !_tmp43_;
#line 5067 "LibraryWindow.c"
		} else {
#line 691 "../src/LibraryWindow.vala"
			_tmp39_ = FALSE;
#line 5071 "LibraryWindow.c"
		}
#line 691 "../src/LibraryWindow.vala"
		_tmp38_ = _tmp39_;
#line 5075 "LibraryWindow.c"
	}
#line 691 "../src/LibraryWindow.vala"
	if (_tmp38_) {
#line 5079 "LibraryWindow.c"
		GAction* _tmp44_;
		GVariant* _tmp45_;
#line 692 "../src/LibraryWindow.vala"
		_tmp44_ = g_action_map_lookup_action ((GActionMap*) self, MUSIC_LIBRARY_WINDOW_ACTION_PLAY);
#line 692 "../src/LibraryWindow.vala"
		_tmp45_ = _variant_new1 (FALSE);
#line 692 "../src/LibraryWindow.vala"
		g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, g_simple_action_get_type (), GSimpleAction), _tmp45_);
#line 692 "../src/LibraryWindow.vala"
		_g_variant_unref0 (_tmp45_);
#line 5090 "LibraryWindow.c"
	} else {
		GAction* _tmp46_;
		GVariant* _tmp47_;
#line 694 "../src/LibraryWindow.vala"
		_tmp46_ = g_action_map_lookup_action ((GActionMap*) self, MUSIC_LIBRARY_WINDOW_ACTION_PLAY);
#line 694 "../src/LibraryWindow.vala"
		_tmp47_ = _variant_new2 (TRUE);
#line 694 "../src/LibraryWindow.vala"
		g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, g_simple_action_get_type (), GSimpleAction), _tmp47_);
#line 694 "../src/LibraryWindow.vala"
		_g_variant_unref0 (_tmp47_);
#line 5102 "LibraryWindow.c"
	}
}

/**
     * Devices
     */
static void
music_library_window_change_device_name (MusicLibraryWindow* self,
                                         MusicDevice* device)
{
	MusicDeviceView* view = NULL;
	GeeHashMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gpointer _tmp3_;
	MusicDeviceView* _tmp4_;
	MusicSourceListView* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 702 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 702 "../src/LibraryWindow.vala"
	g_return_if_fail (device != NULL);
#line 703 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->match_devices;
#line 703 "../src/LibraryWindow.vala"
	_tmp1_ = music_device_get_unique_identifier (device);
#line 703 "../src/LibraryWindow.vala"
	_tmp2_ = _tmp1_;
#line 703 "../src/LibraryWindow.vala"
	_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp2_);
#line 703 "../src/LibraryWindow.vala"
	_tmp4_ = (MusicDeviceView*) _tmp3_;
#line 703 "../src/LibraryWindow.vala"
	_g_free0 (_tmp2_);
#line 703 "../src/LibraryWindow.vala"
	view = _tmp4_;
#line 704 "../src/LibraryWindow.vala"
	_tmp5_ = self->priv->_source_list_view;
#line 704 "../src/LibraryWindow.vala"
	_tmp6_ = music_device_get_display_name (device);
#line 704 "../src/LibraryWindow.vala"
	_tmp7_ = _tmp6_;
#line 704 "../src/LibraryWindow.vala"
	music_source_list_view_change_device_name (_tmp5_, view, _tmp7_);
#line 704 "../src/LibraryWindow.vala"
	_g_free0 (_tmp7_);
#line 702 "../src/LibraryWindow.vala"
	_g_object_unref0 (view);
#line 5152 "LibraryWindow.c"
}

static void
music_library_window_remove_device (MusicLibraryWindow* self,
                                    MusicDevice* device)
{
	GeeHashMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	MusicDeviceView* view = NULL;
	GeeHashMap* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gpointer _tmp7_;
	MusicDeviceView* _tmp8_;
	GeeHashMap* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	MusicViewStack* _tmp23_;
	MusicDeviceView* _tmp24_;
#line 707 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 707 "../src/LibraryWindow.vala"
	g_return_if_fail (device != NULL);
#line 708 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->match_devices;
#line 708 "../src/LibraryWindow.vala"
	_tmp1_ = music_device_get_unique_identifier (device);
#line 708 "../src/LibraryWindow.vala"
	_tmp2_ = _tmp1_;
#line 708 "../src/LibraryWindow.vala"
	_tmp3_ = !gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp2_);
#line 708 "../src/LibraryWindow.vala"
	_g_free0 (_tmp2_);
#line 708 "../src/LibraryWindow.vala"
	if (_tmp3_) {
#line 709 "../src/LibraryWindow.vala"
		return;
#line 5192 "LibraryWindow.c"
	}
#line 712 "../src/LibraryWindow.vala"
	_tmp4_ = self->priv->match_devices;
#line 712 "../src/LibraryWindow.vala"
	_tmp5_ = music_device_get_unique_identifier (device);
#line 712 "../src/LibraryWindow.vala"
	_tmp6_ = _tmp5_;
#line 712 "../src/LibraryWindow.vala"
	_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, _tmp6_);
#line 712 "../src/LibraryWindow.vala"
	_tmp8_ = (MusicDeviceView*) _tmp7_;
#line 712 "../src/LibraryWindow.vala"
	_g_free0 (_tmp6_);
#line 712 "../src/LibraryWindow.vala"
	view = _tmp8_;
#line 5208 "LibraryWindow.c"
	{
		GeeIterator* _subview_it = NULL;
		MusicSourceListView* _tmp9_;
		MusicDeviceView* _tmp10_;
		GeeCollection* _tmp11_;
		GeeCollection* _tmp12_;
		GeeIterator* _tmp13_;
		GeeIterator* _tmp14_;
#line 714 "../src/LibraryWindow.vala"
		_tmp9_ = self->priv->_source_list_view;
#line 714 "../src/LibraryWindow.vala"
		_tmp10_ = view;
#line 714 "../src/LibraryWindow.vala"
		_tmp11_ = music_source_list_view_remove_device (_tmp9_, _tmp10_);
#line 714 "../src/LibraryWindow.vala"
		_tmp12_ = _tmp11_;
#line 714 "../src/LibraryWindow.vala"
		_tmp13_ = gee_iterable_iterator ((GeeIterable*) _tmp12_);
#line 714 "../src/LibraryWindow.vala"
		_tmp14_ = _tmp13_;
#line 714 "../src/LibraryWindow.vala"
		_g_object_unref0 (_tmp12_);
#line 714 "../src/LibraryWindow.vala"
		_subview_it = _tmp14_;
#line 714 "../src/LibraryWindow.vala"
		while (TRUE) {
#line 5235 "LibraryWindow.c"
			GeeIterator* _tmp15_;
			GtkGrid* subview = NULL;
			GeeIterator* _tmp16_;
			gpointer _tmp17_;
			MusicViewStack* _tmp18_;
			GtkGrid* _tmp19_;
#line 714 "../src/LibraryWindow.vala"
			_tmp15_ = _subview_it;
#line 714 "../src/LibraryWindow.vala"
			if (!gee_iterator_next (_tmp15_)) {
#line 714 "../src/LibraryWindow.vala"
				break;
#line 5248 "LibraryWindow.c"
			}
#line 714 "../src/LibraryWindow.vala"
			_tmp16_ = _subview_it;
#line 714 "../src/LibraryWindow.vala"
			_tmp17_ = gee_iterator_get (_tmp16_);
#line 714 "../src/LibraryWindow.vala"
			subview = (GtkGrid*) _tmp17_;
#line 715 "../src/LibraryWindow.vala"
			_tmp18_ = self->priv->_view_stack;
#line 715 "../src/LibraryWindow.vala"
			_tmp19_ = subview;
#line 715 "../src/LibraryWindow.vala"
			music_view_stack_remove_view (_tmp18_, (GtkWidget*) _tmp19_);
#line 714 "../src/LibraryWindow.vala"
			_g_object_unref0 (subview);
#line 5264 "LibraryWindow.c"
		}
#line 714 "../src/LibraryWindow.vala"
		_g_object_unref0 (_subview_it);
#line 5268 "LibraryWindow.c"
	}
#line 718 "../src/LibraryWindow.vala"
	_tmp20_ = self->priv->match_devices;
#line 718 "../src/LibraryWindow.vala"
	_tmp21_ = music_device_get_unique_identifier (device);
#line 718 "../src/LibraryWindow.vala"
	_tmp22_ = _tmp21_;
#line 718 "../src/LibraryWindow.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp20_, _tmp22_, NULL);
#line 718 "../src/LibraryWindow.vala"
	_g_free0 (_tmp22_);
#line 719 "../src/LibraryWindow.vala"
	_tmp23_ = self->priv->_view_stack;
#line 719 "../src/LibraryWindow.vala"
	_tmp24_ = view;
#line 719 "../src/LibraryWindow.vala"
	music_view_stack_remove_view (_tmp23_, (GtkWidget*) _tmp24_);
#line 707 "../src/LibraryWindow.vala"
	_g_object_unref0 (view);
#line 5288 "LibraryWindow.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 722 "../src/LibraryWindow.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 722 "../src/LibraryWindow.vala"
	return _data5_;
#line 5298 "LibraryWindow.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 722 "../src/LibraryWindow.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 5308 "LibraryWindow.c"
		MusicLibraryWindow* self;
#line 722 "../src/LibraryWindow.vala"
		self = _data5_->self;
#line 722 "../src/LibraryWindow.vala"
		_g_object_unref0 (_data5_->d);
#line 722 "../src/LibraryWindow.vala"
		_g_object_unref0 (self);
#line 722 "../src/LibraryWindow.vala"
		g_slice_free (Block5Data, _data5_);
#line 5318 "LibraryWindow.c"
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 723 "../src/LibraryWindow.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 723 "../src/LibraryWindow.vala"
	return _data6_;
#line 5329 "LibraryWindow.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 723 "../src/LibraryWindow.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 5339 "LibraryWindow.c"
		MusicLibraryWindow* self;
#line 723 "../src/LibraryWindow.vala"
		self = _data6_->_data5_->self;
#line 723 "../src/LibraryWindow.vala"
		_g_object_unref0 (_data6_->entry);
#line 723 "../src/LibraryWindow.vala"
		block5_data_unref (_data6_->_data5_);
#line 723 "../src/LibraryWindow.vala"
		_data6_->_data5_ = NULL;
#line 723 "../src/LibraryWindow.vala"
		g_slice_free (Block6Data, _data6_);
#line 5351 "LibraryWindow.c"
	}
}

static void
_____lambda163_ (Block6Data* _data6_,
                 MusicStaticPlaylist* np)
{
	Block5Data* _data5_;
	MusicLibraryWindow* self;
	MusicLibrary* _tmp0_;
	MusicLibrary* _tmp1_;
	MusicSourceListEntry* _tmp2_;
#line 756 "../src/LibraryWindow.vala"
	_data5_ = _data6_->_data5_;
#line 756 "../src/LibraryWindow.vala"
	self = _data5_->self;
#line 756 "../src/LibraryWindow.vala"
	g_return_if_fail (np != NULL);
#line 756 "../src/LibraryWindow.vala"
	_tmp0_ = music_device_get_library (_data5_->d);
#line 756 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 756 "../src/LibraryWindow.vala"
	_tmp2_ = _data6_->entry;
#line 756 "../src/LibraryWindow.vala"
	music_library_window_add_playlist (self, np, _tmp1_, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem));
#line 756 "../src/LibraryWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 5380 "LibraryWindow.c"
}

static void
______lambda163__music_library_playlist_added (MusicLibrary* _sender,
                                               MusicStaticPlaylist* playlist,
                                               gpointer self)
{
#line 756 "../src/LibraryWindow.vala"
	_____lambda163_ (self, playlist);
#line 5390 "LibraryWindow.c"
}

static void
_____lambda164_ (MusicLibraryWindow* self,
                 MusicStaticPlaylist* np)
{
#line 757 "../src/LibraryWindow.vala"
	g_return_if_fail (np != NULL);
#line 757 "../src/LibraryWindow.vala"
	music_library_window_remove_playlist (self, np);
#line 5401 "LibraryWindow.c"
}

static void
______lambda164__music_library_playlist_removed (MusicLibrary* _sender,
                                                 MusicStaticPlaylist* playlist,
                                                 gpointer self)
{
#line 757 "../src/LibraryWindow.vala"
	_____lambda164_ ((MusicLibraryWindow*) self, playlist);
#line 5411 "LibraryWindow.c"
}

static void
music_library_window_create_device_source_list (MusicLibraryWindow* self,
                                                MusicDevice* d)
{
	Block5Data* _data5_;
	MusicDevice* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 722 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 722 "../src/LibraryWindow.vala"
	g_return_if_fail (d != NULL);
#line 722 "../src/LibraryWindow.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 722 "../src/LibraryWindow.vala"
	_data5_->_ref_count_ = 1;
#line 722 "../src/LibraryWindow.vala"
	_data5_->self = g_object_ref (self);
#line 722 "../src/LibraryWindow.vala"
	_tmp0_ = _g_object_ref0 (d);
#line 722 "../src/LibraryWindow.vala"
	_g_object_unref0 (_data5_->d);
#line 722 "../src/LibraryWindow.vala"
	_data5_->d = _tmp0_;
#line 5437 "LibraryWindow.c"
	{
		GeeHashMap* _tmp1_;
#line 723 "../src/LibraryWindow.vala"
		_tmp1_ = self->priv->match_devices;
#line 723 "../src/LibraryWindow.vala"
		g_rec_mutex_lock (&self->priv->__lock_match_devices);
#line 5444 "LibraryWindow.c"
		{
			Block6Data* _data6_;
			MusicDevicePreferences* pref = NULL;
			MusicLocalLibrary* _tmp2_;
			MusicLocalLibrary* _tmp3_;
			MusicDevicePreferences* _tmp4_;
			MusicDeviceView* dv = NULL;
			MusicDevicePreferences* _tmp5_;
			MusicDeviceView* _tmp6_;
			MusicViewStack* _tmp7_;
			MusicDeviceView* _tmp8_;
			GeeHashMap* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			MusicDeviceView* _tmp12_;
#line 723 "../src/LibraryWindow.vala"
			_data6_ = g_slice_new0 (Block6Data);
#line 723 "../src/LibraryWindow.vala"
			_data6_->_ref_count_ = 1;
#line 723 "../src/LibraryWindow.vala"
			_data6_->_data5_ = block5_data_ref (_data5_);
#line 725 "../src/LibraryWindow.vala"
			_tmp2_ = music_library_window_get_library_manager (self);
#line 725 "../src/LibraryWindow.vala"
			_tmp3_ = _tmp2_;
#line 725 "../src/LibraryWindow.vala"
			_tmp4_ = music_local_library_get_preferences_for_device (_tmp3_, _data5_->d);
#line 725 "../src/LibraryWindow.vala"
			pref = _tmp4_;
#line 726 "../src/LibraryWindow.vala"
			_tmp5_ = pref;
#line 726 "../src/LibraryWindow.vala"
			_tmp6_ = music_device_view_new (_data5_->d, _tmp5_);
#line 726 "../src/LibraryWindow.vala"
			g_object_ref_sink (_tmp6_);
#line 726 "../src/LibraryWindow.vala"
			dv = _tmp6_;
#line 727 "../src/LibraryWindow.vala"
			_tmp7_ = self->priv->_view_stack;
#line 727 "../src/LibraryWindow.vala"
			_tmp8_ = dv;
#line 727 "../src/LibraryWindow.vala"
			music_view_stack_add_view (_tmp7_, (GtkWidget*) _tmp8_);
#line 728 "../src/LibraryWindow.vala"
			_tmp9_ = self->priv->match_devices;
#line 728 "../src/LibraryWindow.vala"
			_tmp10_ = music_device_get_unique_identifier (_data5_->d);
#line 728 "../src/LibraryWindow.vala"
			_tmp11_ = _tmp10_;
#line 728 "../src/LibraryWindow.vala"
			_tmp12_ = dv;
#line 728 "../src/LibraryWindow.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, _tmp11_, _tmp12_);
#line 728 "../src/LibraryWindow.vala"
			_g_free0 (_tmp11_);
#line 729 "../src/LibraryWindow.vala"
			if (music_device_only_use_custom_view (_data5_->d)) {
#line 5502 "LibraryWindow.c"
				MusicLibrary* _tmp13_;
				MusicLibrary* _tmp14_;
				GeeCollection* _tmp15_;
				GeeCollection* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				MusicSourceListView* _tmp19_;
				MusicDeviceView* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				GIcon* _tmp23_;
				GIcon* _tmp24_;
				GThemedIcon* _tmp25_;
				GThemedIcon* _tmp26_;
				MusicSourceListEntry* _tmp27_;
#line 730 "../src/LibraryWindow.vala"
				_tmp13_ = music_device_get_library (_data5_->d);
#line 730 "../src/LibraryWindow.vala"
				_tmp14_ = _tmp13_;
#line 730 "../src/LibraryWindow.vala"
				_tmp15_ = music_library_get_medias (_tmp14_);
#line 730 "../src/LibraryWindow.vala"
				_tmp16_ = _tmp15_;
#line 730 "../src/LibraryWindow.vala"
				_tmp17_ = gee_collection_get_size (_tmp16_);
#line 730 "../src/LibraryWindow.vala"
				_tmp18_ = _tmp17_;
#line 730 "../src/LibraryWindow.vala"
				g_message ("LibraryWindow.vala:730: new custom device (probably a CD) added with %" \
"d songs.\n", _tmp18_);
#line 730 "../src/LibraryWindow.vala"
				_g_object_unref0 (_tmp16_);
#line 730 "../src/LibraryWindow.vala"
				_g_object_unref0 (_tmp14_);
#line 735 "../src/LibraryWindow.vala"
				_tmp19_ = self->priv->_source_list_view;
#line 735 "../src/LibraryWindow.vala"
				_tmp20_ = dv;
#line 735 "../src/LibraryWindow.vala"
				_tmp21_ = music_device_get_display_name (_data5_->d);
#line 735 "../src/LibraryWindow.vala"
				_tmp22_ = _tmp21_;
#line 735 "../src/LibraryWindow.vala"
				_tmp23_ = music_device_get_icon (_data5_->d);
#line 735 "../src/LibraryWindow.vala"
				_tmp24_ = _tmp23_;
#line 735 "../src/LibraryWindow.vala"
				_tmp25_ = (GThemedIcon*) g_themed_icon_new ("media-eject-symbolic");
#line 735 "../src/LibraryWindow.vala"
				_tmp26_ = _tmp25_;
#line 735 "../src/LibraryWindow.vala"
				_tmp27_ = music_source_list_view_add_item (_tmp19_, (GtkGrid*) _tmp20_, _tmp22_, MUSIC_VIEW_WRAPPER_HINT_DEVICE, _tmp24_, (GIcon*) _tmp26_, NULL, (GObject*) _data5_->d);
#line 735 "../src/LibraryWindow.vala"
				_g_object_unref0 (_data6_->entry);
#line 735 "../src/LibraryWindow.vala"
				_data6_->entry = _tmp27_;
#line 735 "../src/LibraryWindow.vala"
				_g_object_unref0 (_tmp26_);
#line 735 "../src/LibraryWindow.vala"
				_g_object_unref0 (_tmp24_);
#line 735 "../src/LibraryWindow.vala"
				_g_free0 (_tmp22_);
#line 5564 "LibraryWindow.c"
			} else {
				MusicLibrary* _tmp28_;
				MusicLibrary* _tmp29_;
				GeeCollection* _tmp30_;
				GeeCollection* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				MusicTreeViewSetup* tvs = NULL;
				MusicTreeViewSetup* _tmp34_;
				MusicDeviceViewWrapper* music_view_wrapper = NULL;
				MusicTreeViewSetup* _tmp35_;
				MusicLibrary* _tmp36_;
				MusicLibrary* _tmp37_;
				MusicDeviceViewWrapper* _tmp38_;
				MusicDeviceViewWrapper* _tmp39_;
				MusicViewStack* _tmp40_;
				MusicDeviceViewWrapper* _tmp41_;
				MusicSourceListView* _tmp42_;
				MusicDeviceView* _tmp43_;
				gchar* _tmp44_;
				gchar* _tmp45_;
				GIcon* _tmp46_;
				GIcon* _tmp47_;
				GThemedIcon* _tmp48_;
				GThemedIcon* _tmp49_;
				MusicSourceListEntry* _tmp50_;
				MusicSourceListView* _tmp51_;
				MusicDeviceViewWrapper* _tmp52_;
				GThemedIcon* _tmp53_;
				GThemedIcon* _tmp54_;
				MusicSourceListEntry* _tmp55_;
				MusicSourceListEntry* _tmp56_;
				MusicSourceListEntry* _tmp57_;
				MusicLibrary* _tmp58_;
				MusicLibrary* _tmp59_;
				gboolean _tmp60_;
#line 745 "../src/LibraryWindow.vala"
				_tmp28_ = music_device_get_library (_data5_->d);
#line 745 "../src/LibraryWindow.vala"
				_tmp29_ = _tmp28_;
#line 745 "../src/LibraryWindow.vala"
				_tmp30_ = music_library_get_medias (_tmp29_);
#line 745 "../src/LibraryWindow.vala"
				_tmp31_ = _tmp30_;
#line 745 "../src/LibraryWindow.vala"
				_tmp32_ = gee_collection_get_size (_tmp31_);
#line 745 "../src/LibraryWindow.vala"
				_tmp33_ = _tmp32_;
#line 745 "../src/LibraryWindow.vala"
				g_debug ("LibraryWindow.vala:745: adding device view with %d\n", _tmp33_);
#line 745 "../src/LibraryWindow.vala"
				_g_object_unref0 (_tmp31_);
#line 745 "../src/LibraryWindow.vala"
				_g_object_unref0 (_tmp29_);
#line 746 "../src/LibraryWindow.vala"
				_tmp34_ = music_tree_view_setup_new (MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO, NULL, NULL);
#line 746 "../src/LibraryWindow.vala"
				tvs = _tmp34_;
#line 747 "../src/LibraryWindow.vala"
				_tmp35_ = tvs;
#line 747 "../src/LibraryWindow.vala"
				_tmp36_ = music_device_get_library (_data5_->d);
#line 747 "../src/LibraryWindow.vala"
				_tmp37_ = _tmp36_;
#line 747 "../src/LibraryWindow.vala"
				_tmp38_ = music_device_view_wrapper_new (_tmp35_, _data5_->d, _tmp37_);
#line 747 "../src/LibraryWindow.vala"
				g_object_ref_sink (_tmp38_);
#line 747 "../src/LibraryWindow.vala"
				_tmp39_ = _tmp38_;
#line 747 "../src/LibraryWindow.vala"
				_g_object_unref0 (_tmp37_);
#line 747 "../src/LibraryWindow.vala"
				music_view_wrapper = _tmp39_;
#line 749 "../src/LibraryWindow.vala"
				_tmp40_ = self->priv->_view_stack;
#line 749 "../src/LibraryWindow.vala"
				_tmp41_ = music_view_wrapper;
#line 749 "../src/LibraryWindow.vala"
				music_view_stack_add_view (_tmp40_, (GtkWidget*) _tmp41_);
#line 750 "../src/LibraryWindow.vala"
				_tmp42_ = self->priv->_source_list_view;
#line 750 "../src/LibraryWindow.vala"
				_tmp43_ = dv;
#line 750 "../src/LibraryWindow.vala"
				_tmp44_ = music_device_get_display_name (_data5_->d);
#line 750 "../src/LibraryWindow.vala"
				_tmp45_ = _tmp44_;
#line 750 "../src/LibraryWindow.vala"
				_tmp46_ = music_device_get_icon (_data5_->d);
#line 750 "../src/LibraryWindow.vala"
				_tmp47_ = _tmp46_;
#line 750 "../src/LibraryWindow.vala"
				_tmp48_ = (GThemedIcon*) g_themed_icon_new ("media-eject-symbolic");
#line 750 "../src/LibraryWindow.vala"
				_tmp49_ = _tmp48_;
#line 750 "../src/LibraryWindow.vala"
				_tmp50_ = music_source_list_view_add_item (_tmp42_, (GtkGrid*) _tmp43_, _tmp45_, MUSIC_VIEW_WRAPPER_HINT_DEVICE, _tmp47_, (GIcon*) _tmp49_, NULL, (GObject*) _data5_->d);
#line 750 "../src/LibraryWindow.vala"
				_g_object_unref0 (_data6_->entry);
#line 750 "../src/LibraryWindow.vala"
				_data6_->entry = _tmp50_;
#line 750 "../src/LibraryWindow.vala"
				_g_object_unref0 (_tmp49_);
#line 750 "../src/LibraryWindow.vala"
				_g_object_unref0 (_tmp47_);
#line 750 "../src/LibraryWindow.vala"
				_g_free0 (_tmp45_);
#line 751 "../src/LibraryWindow.vala"
				_tmp51_ = self->priv->_source_list_view;
#line 751 "../src/LibraryWindow.vala"
				_tmp52_ = music_view_wrapper;
#line 751 "../src/LibraryWindow.vala"
				_tmp53_ = (GThemedIcon*) g_themed_icon_new ("library-music");
#line 751 "../src/LibraryWindow.vala"
				_tmp54_ = _tmp53_;
#line 751 "../src/LibraryWindow.vala"
				_tmp55_ = _data6_->entry;
#line 751 "../src/LibraryWindow.vala"
				_tmp56_ = music_source_list_view_add_item (_tmp51_, (GtkGrid*) _tmp52_, _ ("Music"), MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO, (GIcon*) _tmp54_, NULL, MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (_tmp55_) ? ((MusicSourceListExpandableItem*) _tmp55_) : NULL, (GObject*) _data5_->d);
#line 751 "../src/LibraryWindow.vala"
				_tmp57_ = _tmp56_;
#line 751 "../src/LibraryWindow.vala"
				_g_object_unref0 (_tmp57_);
#line 751 "../src/LibraryWindow.vala"
				_g_object_unref0 (_tmp54_);
#line 752 "../src/LibraryWindow.vala"
				_tmp58_ = music_device_get_library (_data5_->d);
#line 752 "../src/LibraryWindow.vala"
				_tmp59_ = _tmp58_;
#line 752 "../src/LibraryWindow.vala"
				_tmp60_ = music_library_support_playlists (_tmp59_) == TRUE;
#line 752 "../src/LibraryWindow.vala"
				_g_object_unref0 (_tmp59_);
#line 752 "../src/LibraryWindow.vala"
				if (_tmp60_) {
#line 5701 "LibraryWindow.c"
					MusicLibrary* _tmp74_;
					MusicLibrary* _tmp75_;
					MusicLibrary* _tmp76_;
					MusicLibrary* _tmp77_;
					{
						GeeIterator* _p_it = NULL;
						MusicLibrary* _tmp61_;
						MusicLibrary* _tmp62_;
						GeeCollection* _tmp63_;
						GeeCollection* _tmp64_;
						GeeIterator* _tmp65_;
						GeeIterator* _tmp66_;
#line 753 "../src/LibraryWindow.vala"
						_tmp61_ = music_device_get_library (_data5_->d);
#line 753 "../src/LibraryWindow.vala"
						_tmp62_ = _tmp61_;
#line 753 "../src/LibraryWindow.vala"
						_tmp63_ = music_library_get_playlists (_tmp62_);
#line 753 "../src/LibraryWindow.vala"
						_tmp64_ = _tmp63_;
#line 753 "../src/LibraryWindow.vala"
						_tmp65_ = gee_iterable_iterator ((GeeIterable*) _tmp64_);
#line 753 "../src/LibraryWindow.vala"
						_tmp66_ = _tmp65_;
#line 753 "../src/LibraryWindow.vala"
						_g_object_unref0 (_tmp64_);
#line 753 "../src/LibraryWindow.vala"
						_g_object_unref0 (_tmp62_);
#line 753 "../src/LibraryWindow.vala"
						_p_it = _tmp66_;
#line 753 "../src/LibraryWindow.vala"
						while (TRUE) {
#line 5734 "LibraryWindow.c"
							GeeIterator* _tmp67_;
							MusicStaticPlaylist* p = NULL;
							GeeIterator* _tmp68_;
							gpointer _tmp69_;
							MusicStaticPlaylist* _tmp70_;
							MusicSourceListEntry* _tmp71_;
							MusicLibrary* _tmp72_;
							MusicLibrary* _tmp73_;
#line 753 "../src/LibraryWindow.vala"
							_tmp67_ = _p_it;
#line 753 "../src/LibraryWindow.vala"
							if (!gee_iterator_next (_tmp67_)) {
#line 753 "../src/LibraryWindow.vala"
								break;
#line 5749 "LibraryWindow.c"
							}
#line 753 "../src/LibraryWindow.vala"
							_tmp68_ = _p_it;
#line 753 "../src/LibraryWindow.vala"
							_tmp69_ = gee_iterator_get (_tmp68_);
#line 753 "../src/LibraryWindow.vala"
							p = (MusicStaticPlaylist*) _tmp69_;
#line 754 "../src/LibraryWindow.vala"
							_tmp70_ = p;
#line 754 "../src/LibraryWindow.vala"
							_tmp71_ = _data6_->entry;
#line 754 "../src/LibraryWindow.vala"
							_tmp72_ = music_device_get_library (_data5_->d);
#line 754 "../src/LibraryWindow.vala"
							_tmp73_ = _tmp72_;
#line 754 "../src/LibraryWindow.vala"
							music_library_window_create_playlist_source_list (self, _tmp70_, G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem), _tmp73_);
#line 754 "../src/LibraryWindow.vala"
							_g_object_unref0 (_tmp73_);
#line 753 "../src/LibraryWindow.vala"
							_g_object_unref0 (p);
#line 5771 "LibraryWindow.c"
						}
#line 753 "../src/LibraryWindow.vala"
						_g_object_unref0 (_p_it);
#line 5775 "LibraryWindow.c"
					}
#line 756 "../src/LibraryWindow.vala"
					_tmp74_ = music_device_get_library (_data5_->d);
#line 756 "../src/LibraryWindow.vala"
					_tmp75_ = _tmp74_;
#line 756 "../src/LibraryWindow.vala"
					g_signal_connect_data (_tmp75_, "playlist-added", (GCallback) ______lambda163__music_library_playlist_added, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 756 "../src/LibraryWindow.vala"
					_g_object_unref0 (_tmp75_);
#line 757 "../src/LibraryWindow.vala"
					_tmp76_ = music_device_get_library (_data5_->d);
#line 757 "../src/LibraryWindow.vala"
					_tmp77_ = _tmp76_;
#line 757 "../src/LibraryWindow.vala"
					g_signal_connect_object (_tmp77_, "playlist-removed", (GCallback) ______lambda164__music_library_playlist_removed, self, 0);
#line 757 "../src/LibraryWindow.vala"
					_g_object_unref0 (_tmp77_);
#line 5793 "LibraryWindow.c"
				}
#line 729 "../src/LibraryWindow.vala"
				_g_object_unref0 (music_view_wrapper);
#line 729 "../src/LibraryWindow.vala"
				_g_object_unref0 (tvs);
#line 5799 "LibraryWindow.c"
			}
#line 723 "../src/LibraryWindow.vala"
			_g_object_unref0 (dv);
#line 723 "../src/LibraryWindow.vala"
			_g_object_unref0 (pref);
#line 723 "../src/LibraryWindow.vala"
			block6_data_unref (_data6_);
#line 723 "../src/LibraryWindow.vala"
			_data6_ = NULL;
#line 5809 "LibraryWindow.c"
		}
		__finally0:
		{
			GeeHashMap* _tmp78_;
#line 723 "../src/LibraryWindow.vala"
			_tmp78_ = self->priv->match_devices;
#line 723 "../src/LibraryWindow.vala"
			g_rec_mutex_unlock (&self->priv->__lock_match_devices);
#line 5818 "LibraryWindow.c"
		}
#line 723 "../src/LibraryWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 723 "../src/LibraryWindow.vala"
			block5_data_unref (_data5_);
#line 723 "../src/LibraryWindow.vala"
			_data5_ = NULL;
#line 723 "../src/LibraryWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 723 "../src/LibraryWindow.vala"
			g_clear_error (&_inner_error0_);
#line 723 "../src/LibraryWindow.vala"
			return;
#line 5832 "LibraryWindow.c"
		}
	}
#line 722 "../src/LibraryWindow.vala"
	block5_data_unref (_data5_);
#line 722 "../src/LibraryWindow.vala"
	_data5_ = NULL;
#line 5839 "LibraryWindow.c"
}

/**
     * StaticPlaylists
     */
static void
music_library_window_add_playlist (MusicLibraryWindow* self,
                                   MusicStaticPlaylist* playlist,
                                   MusicLibrary* library,
                                   MusicSourceListExpandableItem* entry)
{
#line 766 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 766 "../src/LibraryWindow.vala"
	g_return_if_fail (playlist != NULL);
#line 767 "../src/LibraryWindow.vala"
	music_library_window_create_playlist_source_list (self, playlist, entry, library);
#line 5857 "LibraryWindow.c"
}

static void
music_library_window_remove_playlist (MusicLibraryWindow* self,
                                      MusicStaticPlaylist* playlist)
{
	MusicViewWrapper* view = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	MusicViewStack* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 770 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 770 "../src/LibraryWindow.vala"
	g_return_if_fail (playlist != NULL);
#line 771 "../src/LibraryWindow.vala"
	_tmp0_ = self->match_playlists;
#line 771 "../src/LibraryWindow.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (MusicPlaylist*) playlist);
#line 771 "../src/LibraryWindow.vala"
	view = (MusicViewWrapper*) _tmp1_;
#line 5879 "LibraryWindow.c"
	{
		GeeHashMap* _tmp2_;
#line 772 "../src/LibraryWindow.vala"
		_tmp2_ = self->match_playlists;
#line 772 "../src/LibraryWindow.vala"
		g_rec_mutex_lock (&self->priv->__lock_match_playlists);
#line 5886 "LibraryWindow.c"
		{
			MusicSourceListView* _tmp3_;
			GeeHashMap* _tmp4_;
			GeeHashMap* _tmp5_;
#line 773 "../src/LibraryWindow.vala"
			_tmp3_ = self->priv->_source_list_view;
#line 773 "../src/LibraryWindow.vala"
			music_source_list_view_remove_playlist (_tmp3_, view);
#line 774 "../src/LibraryWindow.vala"
			_tmp4_ = self->priv->match_playlist_entry;
#line 774 "../src/LibraryWindow.vala"
			gee_abstract_map_unset ((GeeAbstractMap*) _tmp4_, (MusicPlaylist*) playlist, NULL);
#line 775 "../src/LibraryWindow.vala"
			_tmp5_ = self->match_playlists;
#line 775 "../src/LibraryWindow.vala"
			gee_abstract_map_unset ((GeeAbstractMap*) _tmp5_, (MusicPlaylist*) playlist, NULL);
#line 5903 "LibraryWindow.c"
		}
		__finally0:
		{
			GeeHashMap* _tmp6_;
#line 772 "../src/LibraryWindow.vala"
			_tmp6_ = self->match_playlists;
#line 772 "../src/LibraryWindow.vala"
			g_rec_mutex_unlock (&self->priv->__lock_match_playlists);
#line 5912 "LibraryWindow.c"
		}
#line 772 "../src/LibraryWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 772 "../src/LibraryWindow.vala"
			_g_object_unref0 (view);
#line 772 "../src/LibraryWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 772 "../src/LibraryWindow.vala"
			g_clear_error (&_inner_error0_);
#line 772 "../src/LibraryWindow.vala"
			return;
#line 5924 "LibraryWindow.c"
		}
	}
#line 778 "../src/LibraryWindow.vala"
	_tmp7_ = self->priv->_view_stack;
#line 778 "../src/LibraryWindow.vala"
	music_view_stack_remove_view (_tmp7_, (GtkWidget*) view);
#line 770 "../src/LibraryWindow.vala"
	_g_object_unref0 (view);
#line 5933 "LibraryWindow.c"
}

void
music_library_window_create_new_playlist (MusicLibraryWindow* self,
                                          MusicLibrary* library)
{
	MusicStaticPlaylist* playlist = NULL;
	MusicStaticPlaylist* _tmp0_;
	MusicLocalLibrary* _tmp1_;
	MusicLocalLibrary* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 781 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 782 "../src/LibraryWindow.vala"
	_tmp0_ = music_static_playlist_new ();
#line 782 "../src/LibraryWindow.vala"
	playlist = _tmp0_;
#line 783 "../src/LibraryWindow.vala"
	_tmp1_ = music_library_window_get_library_manager (self);
#line 783 "../src/LibraryWindow.vala"
	_tmp2_ = _tmp1_;
#line 783 "../src/LibraryWindow.vala"
	_tmp3_ = music_library_get_playlists ((MusicLibrary*) _tmp2_);
#line 783 "../src/LibraryWindow.vala"
	_tmp4_ = _tmp3_;
#line 783 "../src/LibraryWindow.vala"
	_tmp5_ = music_playlists_utils_get_new_playlist_name (_tmp4_, NULL);
#line 783 "../src/LibraryWindow.vala"
	_tmp6_ = _tmp5_;
#line 783 "../src/LibraryWindow.vala"
	music_playlist_set_name ((MusicPlaylist*) playlist, _tmp6_);
#line 783 "../src/LibraryWindow.vala"
	_g_free0 (_tmp6_);
#line 783 "../src/LibraryWindow.vala"
	_g_object_unref0 (_tmp4_);
#line 784 "../src/LibraryWindow.vala"
	music_library_window_set_newly_created_playlist (self, TRUE);
#line 785 "../src/LibraryWindow.vala"
	music_library_add_playlist (library, playlist);
#line 781 "../src/LibraryWindow.vala"
	_g_object_unref0 (playlist);
#line 5978 "LibraryWindow.c"
}

static void
music_library_window_show_playlist_view (MusicLibraryWindow* self,
                                         MusicPlaylist* p)
{
	GeeHashMap* _tmp0_;
#line 788 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 788 "../src/LibraryWindow.vala"
	g_return_if_fail (p != NULL);
#line 789 "../src/LibraryWindow.vala"
	_tmp0_ = self->match_playlists;
#line 789 "../src/LibraryWindow.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, p)) {
#line 5994 "LibraryWindow.c"
		MusicSourceListView* _tmp1_;
		GeeHashMap* _tmp2_;
		gpointer _tmp3_;
		MusicSourceListEntry* _tmp4_;
		GeeHashMap* _tmp5_;
		gpointer _tmp6_;
		MusicViewWrapper* _tmp7_;
#line 790 "../src/LibraryWindow.vala"
		_tmp1_ = self->priv->_source_list_view;
#line 790 "../src/LibraryWindow.vala"
		_tmp2_ = self->priv->match_playlist_entry;
#line 790 "../src/LibraryWindow.vala"
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, p);
#line 790 "../src/LibraryWindow.vala"
		_tmp4_ = (MusicSourceListEntry*) _tmp3_;
#line 790 "../src/LibraryWindow.vala"
		granite_widgets_source_list_set_selected ((GraniteWidgetsSourceList*) _tmp1_, (GraniteWidgetsSourceListItem*) _tmp4_);
#line 790 "../src/LibraryWindow.vala"
		_g_object_unref0 (_tmp4_);
#line 791 "../src/LibraryWindow.vala"
		_tmp5_ = self->match_playlists;
#line 791 "../src/LibraryWindow.vala"
		_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, p);
#line 791 "../src/LibraryWindow.vala"
		_tmp7_ = (MusicViewWrapper*) _tmp6_;
#line 791 "../src/LibraryWindow.vala"
		music_library_window_set_active_view (self, _tmp7_);
#line 791 "../src/LibraryWindow.vala"
		_g_object_unref0 (_tmp7_);
#line 6024 "LibraryWindow.c"
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 795 "../src/LibraryWindow.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 795 "../src/LibraryWindow.vala"
	return _data7_;
#line 6035 "LibraryWindow.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 795 "../src/LibraryWindow.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 6045 "LibraryWindow.c"
		MusicLibraryWindow* self;
#line 795 "../src/LibraryWindow.vala"
		self = _data7_->self;
#line 795 "../src/LibraryWindow.vala"
		_g_object_unref0 (_data7_->entry);
#line 795 "../src/LibraryWindow.vala"
		_g_object_unref0 (self);
#line 795 "../src/LibraryWindow.vala"
		g_slice_free (Block7Data, _data7_);
#line 6055 "LibraryWindow.c"
	}
}

static gboolean
___lambda160_ (Block7Data* _data7_)
{
	MusicLibraryWindow* self;
	MusicSourceListView* _tmp0_;
	MusicSourceListEntry* _tmp1_;
	gboolean result;
#line 836 "../src/LibraryWindow.vala"
	self = _data7_->self;
#line 837 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->_source_list_view;
#line 837 "../src/LibraryWindow.vala"
	_tmp1_ = _data7_->entry;
#line 837 "../src/LibraryWindow.vala"
	granite_widgets_source_list_start_editing_item ((GraniteWidgetsSourceList*) _tmp0_, (GraniteWidgetsSourceListItem*) _tmp1_);
#line 838 "../src/LibraryWindow.vala"
	result = FALSE;
#line 838 "../src/LibraryWindow.vala"
	return result;
#line 6078 "LibraryWindow.c"
}

static gboolean
____lambda160__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda160_ (self);
#line 836 "../src/LibraryWindow.vala"
	return result;
#line 6088 "LibraryWindow.c"
}

static void
music_library_window_create_playlist_source_list (MusicLibraryWindow* self,
                                                  MusicStaticPlaylist* p,
                                                  MusicSourceListExpandableItem* into_expandable,
                                                  MusicLibrary* library)
{
	Block7Data* _data7_;
	MusicViewWrapperHint hint = 0;
	gboolean _tmp0_;
	gboolean _tmp1_;
	MusicTreeViewSetup* tvs = NULL;
	MusicPlaylistViewWrapper* view = NULL;
	MusicTreeViewSetup* _tmp28_;
	MusicPlaylistViewWrapper* _tmp29_;
	MusicViewStack* _tmp30_;
	MusicPlaylistViewWrapper* _tmp31_;
	MusicSourceListView* _tmp32_;
	MusicPlaylistViewWrapper* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	GIcon* _tmp36_;
	MusicSourceListEntry* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	MusicPlaybackManager* _tmp41_;
	MusicPlaybackManager* _tmp42_;
	MusicStaticPlaylist* _tmp43_;
	GeeHashMap* _tmp53_;
	MusicSourceListEntry* _tmp54_;
	GeeHashMap* _tmp55_;
	MusicPlaylistViewWrapper* _tmp56_;
	gboolean _tmp57_ = FALSE;
	gboolean _tmp58_;
#line 795 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 795 "../src/LibraryWindow.vala"
	g_return_if_fail (p != NULL);
#line 795 "../src/LibraryWindow.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 795 "../src/LibraryWindow.vala"
	_data7_->_ref_count_ = 1;
#line 795 "../src/LibraryWindow.vala"
	_data7_->self = g_object_ref (self);
#line 796 "../src/LibraryWindow.vala"
	hint = MUSIC_VIEW_WRAPPER_HINT_PLAYLIST;
#line 797 "../src/LibraryWindow.vala"
	_tmp0_ = music_static_playlist_get_read_only (p);
#line 797 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 797 "../src/LibraryWindow.vala"
	if (_tmp1_ == TRUE) {
#line 798 "../src/LibraryWindow.vala"
		hint = MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST;
#line 6144 "LibraryWindow.c"
	}
#line 801 "../src/LibraryWindow.vala"
	tvs = NULL;
#line 802 "../src/LibraryWindow.vala"
	if (MUSIC_IS_LOCAL_STATIC_PLAYLIST (p)) {
#line 6150 "LibraryWindow.c"
		gint64 _tmp2_;
		gint64 _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		MusicLocalLibrary* _tmp6_;
		MusicLocalLibrary* _tmp7_;
		GdaConnection* _tmp8_;
		GdaConnection* _tmp9_;
		MusicTreeViewSetup* _tmp10_;
#line 803 "../src/LibraryWindow.vala"
		_tmp2_ = music_playlist_get_rowid ((MusicPlaylist*) p);
#line 803 "../src/LibraryWindow.vala"
		_tmp3_ = _tmp2_;
#line 803 "../src/LibraryWindow.vala"
		_tmp4_ = g_strdup_printf ("library:p%lld", _tmp3_);
#line 803 "../src/LibraryWindow.vala"
		_tmp5_ = _tmp4_;
#line 803 "../src/LibraryWindow.vala"
		_tmp6_ = music_library_window_get_library_manager (self);
#line 803 "../src/LibraryWindow.vala"
		_tmp7_ = _tmp6_;
#line 803 "../src/LibraryWindow.vala"
		_tmp8_ = music_local_library_get_connection (_tmp7_);
#line 803 "../src/LibraryWindow.vala"
		_tmp9_ = _tmp8_;
#line 803 "../src/LibraryWindow.vala"
		_tmp10_ = music_tree_view_setup_new (hint, _tmp5_, _tmp9_);
#line 803 "../src/LibraryWindow.vala"
		_g_object_unref0 (tvs);
#line 803 "../src/LibraryWindow.vala"
		tvs = _tmp10_;
#line 803 "../src/LibraryWindow.vala"
		_g_free0 (_tmp5_);
#line 6184 "LibraryWindow.c"
	} else {
		MusicPlaybackManager* _tmp11_;
		MusicPlaybackManager* _tmp12_;
		MusicStaticPlaylist* _tmp13_;
#line 804 "../src/LibraryWindow.vala"
		_tmp11_ = music_app_get_player ();
#line 804 "../src/LibraryWindow.vala"
		_tmp12_ = _tmp11_;
#line 804 "../src/LibraryWindow.vala"
		_tmp13_ = _tmp12_->queue_playlist;
#line 804 "../src/LibraryWindow.vala"
		if (p == _tmp13_) {
#line 6197 "LibraryWindow.c"
			MusicLocalLibrary* _tmp14_;
			MusicLocalLibrary* _tmp15_;
			GdaConnection* _tmp16_;
			GdaConnection* _tmp17_;
			MusicTreeViewSetup* _tmp18_;
#line 805 "../src/LibraryWindow.vala"
			_tmp14_ = music_library_window_get_library_manager (self);
#line 805 "../src/LibraryWindow.vala"
			_tmp15_ = _tmp14_;
#line 805 "../src/LibraryWindow.vala"
			_tmp16_ = music_local_library_get_connection (_tmp15_);
#line 805 "../src/LibraryWindow.vala"
			_tmp17_ = _tmp16_;
#line 805 "../src/LibraryWindow.vala"
			_tmp18_ = music_tree_view_setup_new (MUSIC_VIEW_WRAPPER_HINT_QUEUE, "library:queue", _tmp17_);
#line 805 "../src/LibraryWindow.vala"
			_g_object_unref0 (tvs);
#line 805 "../src/LibraryWindow.vala"
			tvs = _tmp18_;
#line 6217 "LibraryWindow.c"
		} else {
			MusicPlaybackManager* _tmp19_;
			MusicPlaybackManager* _tmp20_;
			MusicHistoryPlaylist* _tmp21_;
#line 806 "../src/LibraryWindow.vala"
			_tmp19_ = music_app_get_player ();
#line 806 "../src/LibraryWindow.vala"
			_tmp20_ = _tmp19_;
#line 806 "../src/LibraryWindow.vala"
			_tmp21_ = _tmp20_->history_playlist;
#line 806 "../src/LibraryWindow.vala"
			if (p == G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist)) {
#line 6230 "LibraryWindow.c"
				MusicLocalLibrary* _tmp22_;
				MusicLocalLibrary* _tmp23_;
				GdaConnection* _tmp24_;
				GdaConnection* _tmp25_;
				MusicTreeViewSetup* _tmp26_;
#line 807 "../src/LibraryWindow.vala"
				_tmp22_ = music_library_window_get_library_manager (self);
#line 807 "../src/LibraryWindow.vala"
				_tmp23_ = _tmp22_;
#line 807 "../src/LibraryWindow.vala"
				_tmp24_ = music_local_library_get_connection (_tmp23_);
#line 807 "../src/LibraryWindow.vala"
				_tmp25_ = _tmp24_;
#line 807 "../src/LibraryWindow.vala"
				_tmp26_ = music_tree_view_setup_new (hint, "library:history", _tmp25_);
#line 807 "../src/LibraryWindow.vala"
				_g_object_unref0 (tvs);
#line 807 "../src/LibraryWindow.vala"
				tvs = _tmp26_;
#line 6250 "LibraryWindow.c"
			} else {
				MusicTreeViewSetup* _tmp27_;
#line 809 "../src/LibraryWindow.vala"
				_tmp27_ = music_tree_view_setup_new (hint, NULL, NULL);
#line 809 "../src/LibraryWindow.vala"
				_g_object_unref0 (tvs);
#line 809 "../src/LibraryWindow.vala"
				tvs = _tmp27_;
#line 6259 "LibraryWindow.c"
			}
		}
	}
#line 812 "../src/LibraryWindow.vala"
	_tmp28_ = tvs;
#line 812 "../src/LibraryWindow.vala"
	_tmp29_ = music_playlist_view_wrapper_new ((MusicPlaylist*) p, hint, _tmp28_, library);
#line 812 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp29_);
#line 812 "../src/LibraryWindow.vala"
	view = _tmp29_;
#line 813 "../src/LibraryWindow.vala"
	_tmp30_ = self->priv->_view_stack;
#line 813 "../src/LibraryWindow.vala"
	_tmp31_ = view;
#line 813 "../src/LibraryWindow.vala"
	music_view_stack_add_view (_tmp30_, (GtkWidget*) _tmp31_);
#line 814 "../src/LibraryWindow.vala"
	_tmp32_ = self->priv->_source_list_view;
#line 814 "../src/LibraryWindow.vala"
	_tmp33_ = view;
#line 814 "../src/LibraryWindow.vala"
	_tmp34_ = music_playlist_get_name ((MusicPlaylist*) p);
#line 814 "../src/LibraryWindow.vala"
	_tmp35_ = _tmp34_;
#line 814 "../src/LibraryWindow.vala"
	_tmp36_ = ((MusicPlaylist*) p)->icon;
#line 814 "../src/LibraryWindow.vala"
	_tmp37_ = music_source_list_view_add_item (_tmp32_, (GtkGrid*) _tmp33_, _tmp35_, hint, _tmp36_, NULL, into_expandable, NULL);
#line 814 "../src/LibraryWindow.vala"
	_data7_->entry = _tmp37_;
#line 815 "../src/LibraryWindow.vala"
	_tmp38_ = music_static_playlist_get_show_badge (p);
#line 815 "../src/LibraryWindow.vala"
	_tmp39_ = _tmp38_;
#line 815 "../src/LibraryWindow.vala"
	if (_tmp39_ == TRUE) {
#line 6297 "LibraryWindow.c"
		MusicSourceListEntry* _tmp40_;
#line 816 "../src/LibraryWindow.vala"
		_tmp40_ = _data7_->entry;
#line 816 "../src/LibraryWindow.vala"
		music_library_window_update_badge_on_playlist_update (self, (MusicPlaylist*) p, _tmp40_);
#line 6303 "LibraryWindow.c"
	}
#line 819 "../src/LibraryWindow.vala"
	_tmp41_ = music_app_get_player ();
#line 819 "../src/LibraryWindow.vala"
	_tmp42_ = _tmp41_;
#line 819 "../src/LibraryWindow.vala"
	_tmp43_ = _tmp42_->queue_playlist;
#line 819 "../src/LibraryWindow.vala"
	if (p == _tmp43_) {
#line 6313 "LibraryWindow.c"
		MusicPlaylistViewWrapper* _tmp44_;
		MusicPlaybackManager* _tmp45_;
		MusicPlaybackManager* _tmp46_;
		GeeArrayList* _tmp47_;
		GeeArrayList* _tmp48_;
#line 820 "../src/LibraryWindow.vala"
		_tmp44_ = view;
#line 820 "../src/LibraryWindow.vala"
		music_playlist_view_wrapper_set_no_media_alert_message (_tmp44_, _ ("No songs in Queue"), _ ("To add songs to the queue, use the <b>secondary click</b> on an item a" \
"nd choose <b>Queue</b>. When a song finishes, the queued songs will be" \
" played first before the next song in the currently playing list."));
#line 821 "../src/LibraryWindow.vala"
		_tmp45_ = music_app_get_player ();
#line 821 "../src/LibraryWindow.vala"
		_tmp46_ = _tmp45_;
#line 821 "../src/LibraryWindow.vala"
		_tmp47_ = music_playlist_get_medias ((MusicPlaylist*) p);
#line 821 "../src/LibraryWindow.vala"
		_tmp48_ = _tmp47_;
#line 821 "../src/LibraryWindow.vala"
		music_playback_manager_queue_media (_tmp46_, (GeeCollection*) _tmp48_);
#line 6333 "LibraryWindow.c"
	} else {
		MusicPlaybackManager* _tmp49_;
		MusicPlaybackManager* _tmp50_;
		MusicHistoryPlaylist* _tmp51_;
#line 822 "../src/LibraryWindow.vala"
		_tmp49_ = music_app_get_player ();
#line 822 "../src/LibraryWindow.vala"
		_tmp50_ = _tmp49_;
#line 822 "../src/LibraryWindow.vala"
		_tmp51_ = _tmp50_->history_playlist;
#line 822 "../src/LibraryWindow.vala"
		if (p == G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist)) {
#line 6346 "LibraryWindow.c"
			MusicPlaylistViewWrapper* _tmp52_;
#line 823 "../src/LibraryWindow.vala"
			_tmp52_ = view;
#line 823 "../src/LibraryWindow.vala"
			music_playlist_view_wrapper_set_no_media_alert_message (_tmp52_, _ ("No songs in History"), _ ("After a part of a song has been played, it is added to the history lis" \
"t.\n" \
"You can use this list to see all the songs you have played during the " \
"current session."));
#line 6352 "LibraryWindow.c"
		}
	}
#line 826 "../src/LibraryWindow.vala"
	_tmp53_ = self->priv->match_playlist_entry;
#line 826 "../src/LibraryWindow.vala"
	_tmp54_ = _data7_->entry;
#line 826 "../src/LibraryWindow.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp53_, (MusicPlaylist*) p, _tmp54_);
#line 827 "../src/LibraryWindow.vala"
	_tmp55_ = self->match_playlists;
#line 827 "../src/LibraryWindow.vala"
	_tmp56_ = view;
#line 827 "../src/LibraryWindow.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp55_, (MusicPlaylist*) p, (MusicViewWrapper*) _tmp56_);
#line 829 "../src/LibraryWindow.vala"
	_tmp58_ = self->priv->_newly_created_playlist;
#line 829 "../src/LibraryWindow.vala"
	if (_tmp58_ == TRUE) {
#line 6371 "LibraryWindow.c"
		gboolean _tmp59_;
		gboolean _tmp60_;
#line 829 "../src/LibraryWindow.vala"
		_tmp59_ = music_static_playlist_get_read_only (p);
#line 829 "../src/LibraryWindow.vala"
		_tmp60_ = _tmp59_;
#line 829 "../src/LibraryWindow.vala"
		_tmp57_ = _tmp60_ == FALSE;
#line 6380 "LibraryWindow.c"
	} else {
#line 829 "../src/LibraryWindow.vala"
		_tmp57_ = FALSE;
#line 6384 "LibraryWindow.c"
	}
#line 829 "../src/LibraryWindow.vala"
	if (_tmp57_) {
#line 830 "../src/LibraryWindow.vala"
		music_library_window_set_newly_created_playlist (self, FALSE);
#line 831 "../src/LibraryWindow.vala"
		music_library_window_show_playlist_view (self, (MusicPlaylist*) p);
#line 836 "../src/LibraryWindow.vala"
		g_idle_add_full (G_PRIORITY_LOW, ____lambda160__gsource_func, block7_data_ref (_data7_), block7_data_unref);
#line 6394 "LibraryWindow.c"
	}
#line 795 "../src/LibraryWindow.vala"
	_g_object_unref0 (view);
#line 795 "../src/LibraryWindow.vala"
	_g_object_unref0 (tvs);
#line 795 "../src/LibraryWindow.vala"
	block7_data_unref (_data7_);
#line 795 "../src/LibraryWindow.vala"
	_data7_ = NULL;
#line 6404 "LibraryWindow.c"
}

/**
     * SmartPlaylists
     */
static void
music_library_window_add_smartplaylist (MusicLibraryWindow* self,
                                        MusicSmartPlaylist* smartplaylist,
                                        MusicLibrary* library,
                                        MusicSourceListExpandableItem* entry)
{
	MusicLocalLibrary* _tmp0_;
	MusicLocalLibrary* _tmp1_;
#line 847 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 847 "../src/LibraryWindow.vala"
	g_return_if_fail (smartplaylist != NULL);
#line 848 "../src/LibraryWindow.vala"
	_tmp0_ = music_library_window_get_library_manager (self);
#line 848 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 848 "../src/LibraryWindow.vala"
	music_library_window_create_smartplaylist_source_list (self, smartplaylist, NULL, (MusicLibrary*) _tmp1_);
#line 6428 "LibraryWindow.c"
}

static void
music_library_window_remove_smartplaylist (MusicLibraryWindow* self,
                                           MusicSmartPlaylist* smartplaylist)
{
	MusicViewWrapper* view = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	MusicViewStack* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 851 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 851 "../src/LibraryWindow.vala"
	g_return_if_fail (smartplaylist != NULL);
#line 852 "../src/LibraryWindow.vala"
	_tmp0_ = self->match_playlists;
#line 852 "../src/LibraryWindow.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (MusicPlaylist*) smartplaylist);
#line 852 "../src/LibraryWindow.vala"
	view = (MusicViewWrapper*) _tmp1_;
#line 6450 "LibraryWindow.c"
	{
		GeeHashMap* _tmp2_;
#line 853 "../src/LibraryWindow.vala"
		_tmp2_ = self->match_playlists;
#line 853 "../src/LibraryWindow.vala"
		g_rec_mutex_lock (&self->priv->__lock_match_playlists);
#line 6457 "LibraryWindow.c"
		{
			GeeHashMap* _tmp3_;
			MusicSourceListView* _tmp4_;
			GeeHashMap* _tmp5_;
#line 854 "../src/LibraryWindow.vala"
			_tmp3_ = self->match_playlists;
#line 854 "../src/LibraryWindow.vala"
			gee_abstract_map_unset ((GeeAbstractMap*) _tmp3_, (MusicPlaylist*) smartplaylist, NULL);
#line 855 "../src/LibraryWindow.vala"
			_tmp4_ = self->priv->_source_list_view;
#line 855 "../src/LibraryWindow.vala"
			music_source_list_view_remove_playlist (_tmp4_, view);
#line 856 "../src/LibraryWindow.vala"
			_tmp5_ = self->match_playlists;
#line 856 "../src/LibraryWindow.vala"
			gee_abstract_map_unset ((GeeAbstractMap*) _tmp5_, (MusicPlaylist*) smartplaylist, NULL);
#line 6474 "LibraryWindow.c"
		}
		__finally0:
		{
			GeeHashMap* _tmp6_;
#line 853 "../src/LibraryWindow.vala"
			_tmp6_ = self->match_playlists;
#line 853 "../src/LibraryWindow.vala"
			g_rec_mutex_unlock (&self->priv->__lock_match_playlists);
#line 6483 "LibraryWindow.c"
		}
#line 853 "../src/LibraryWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 853 "../src/LibraryWindow.vala"
			_g_object_unref0 (view);
#line 853 "../src/LibraryWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 853 "../src/LibraryWindow.vala"
			g_clear_error (&_inner_error0_);
#line 853 "../src/LibraryWindow.vala"
			return;
#line 6495 "LibraryWindow.c"
		}
	}
#line 859 "../src/LibraryWindow.vala"
	_tmp7_ = self->priv->_view_stack;
#line 859 "../src/LibraryWindow.vala"
	music_view_stack_remove_view (_tmp7_, (GtkWidget*) view);
#line 851 "../src/LibraryWindow.vala"
	_g_object_unref0 (view);
#line 6504 "LibraryWindow.c"
}

static void
music_library_window_playlist_name_edited (MusicLibraryWindow* self,
                                           GtkGrid* view_wrapper,
                                           const gchar* new_name)
{
#line 862 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 862 "../src/LibraryWindow.vala"
	g_return_if_fail (view_wrapper != NULL);
#line 862 "../src/LibraryWindow.vala"
	g_return_if_fail (new_name != NULL);
#line 863 "../src/LibraryWindow.vala"
	music_library_window_set_search_field_has_focus (self, TRUE);
#line 864 "../src/LibraryWindow.vala"
	if (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view_wrapper)) {
#line 6522 "LibraryWindow.c"
		MusicPlaylistViewWrapper* view = NULL;
		MusicPlaylistViewWrapper* _tmp0_;
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		MusicPlaylistViewWrapper* _tmp3_;
		MusicViewWrapperHint _tmp4_;
		MusicViewWrapperHint _tmp5_;
#line 865 "../src/LibraryWindow.vala"
		_tmp0_ = _g_object_ref0 (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view_wrapper) ? ((MusicPlaylistViewWrapper*) view_wrapper) : NULL);
#line 865 "../src/LibraryWindow.vala"
		view = _tmp0_;
#line 866 "../src/LibraryWindow.vala"
		_tmp3_ = view;
#line 866 "../src/LibraryWindow.vala"
		_tmp4_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp3_);
#line 866 "../src/LibraryWindow.vala"
		_tmp5_ = _tmp4_;
#line 866 "../src/LibraryWindow.vala"
		if (_tmp5_ == MUSIC_VIEW_WRAPPER_HINT_PLAYLIST) {
#line 866 "../src/LibraryWindow.vala"
			_tmp2_ = TRUE;
#line 6544 "LibraryWindow.c"
		} else {
			MusicPlaylistViewWrapper* _tmp6_;
			MusicViewWrapperHint _tmp7_;
			MusicViewWrapperHint _tmp8_;
#line 866 "../src/LibraryWindow.vala"
			_tmp6_ = view;
#line 866 "../src/LibraryWindow.vala"
			_tmp7_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp6_);
#line 866 "../src/LibraryWindow.vala"
			_tmp8_ = _tmp7_;
#line 866 "../src/LibraryWindow.vala"
			_tmp2_ = _tmp8_ == MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST;
#line 6557 "LibraryWindow.c"
		}
#line 866 "../src/LibraryWindow.vala"
		if (_tmp2_) {
#line 866 "../src/LibraryWindow.vala"
			_tmp1_ = TRUE;
#line 6563 "LibraryWindow.c"
		} else {
			MusicPlaylistViewWrapper* _tmp9_;
			MusicViewWrapperHint _tmp10_;
			MusicViewWrapperHint _tmp11_;
#line 866 "../src/LibraryWindow.vala"
			_tmp9_ = view;
#line 866 "../src/LibraryWindow.vala"
			_tmp10_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp9_);
#line 866 "../src/LibraryWindow.vala"
			_tmp11_ = _tmp10_;
#line 866 "../src/LibraryWindow.vala"
			_tmp1_ = _tmp11_ == MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST;
#line 6576 "LibraryWindow.c"
		}
#line 866 "../src/LibraryWindow.vala"
		if (_tmp1_) {
#line 6580 "LibraryWindow.c"
			{
				GeeIterator* _entry_it = NULL;
				GeeHashMap* _tmp12_;
				GeeSet* _tmp13_;
				GeeSet* _tmp14_;
				GeeSet* _tmp15_;
				GeeIterator* _tmp16_;
				GeeIterator* _tmp17_;
#line 867 "../src/LibraryWindow.vala"
				_tmp12_ = self->match_playlists;
#line 867 "../src/LibraryWindow.vala"
				_tmp13_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp12_);
#line 867 "../src/LibraryWindow.vala"
				_tmp14_ = _tmp13_;
#line 867 "../src/LibraryWindow.vala"
				_tmp15_ = _tmp14_;
#line 867 "../src/LibraryWindow.vala"
				_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
#line 867 "../src/LibraryWindow.vala"
				_tmp17_ = _tmp16_;
#line 867 "../src/LibraryWindow.vala"
				_g_object_unref0 (_tmp15_);
#line 867 "../src/LibraryWindow.vala"
				_entry_it = _tmp17_;
#line 867 "../src/LibraryWindow.vala"
				while (TRUE) {
#line 6607 "LibraryWindow.c"
					GeeIterator* _tmp18_;
					GeeMapEntry* entry = NULL;
					GeeIterator* _tmp19_;
					gpointer _tmp20_;
					GeeMapEntry* _tmp21_;
					gconstpointer _tmp22_;
					gconstpointer _tmp23_;
					MusicPlaylistViewWrapper* _tmp24_;
					MusicPlaylist* _tmp25_;
					MusicPlaylist* _tmp26_;
#line 867 "../src/LibraryWindow.vala"
					_tmp18_ = _entry_it;
#line 867 "../src/LibraryWindow.vala"
					if (!gee_iterator_next (_tmp18_)) {
#line 867 "../src/LibraryWindow.vala"
						break;
#line 6624 "LibraryWindow.c"
					}
#line 867 "../src/LibraryWindow.vala"
					_tmp19_ = _entry_it;
#line 867 "../src/LibraryWindow.vala"
					_tmp20_ = gee_iterator_get (_tmp19_);
#line 867 "../src/LibraryWindow.vala"
					entry = (GeeMapEntry*) _tmp20_;
#line 868 "../src/LibraryWindow.vala"
					_tmp21_ = entry;
#line 868 "../src/LibraryWindow.vala"
					_tmp22_ = gee_map_entry_get_key (_tmp21_);
#line 868 "../src/LibraryWindow.vala"
					_tmp23_ = _tmp22_;
#line 868 "../src/LibraryWindow.vala"
					_tmp24_ = view;
#line 868 "../src/LibraryWindow.vala"
					_tmp25_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp24_);
#line 868 "../src/LibraryWindow.vala"
					_tmp26_ = _tmp25_;
#line 868 "../src/LibraryWindow.vala"
					if (((MusicPlaylist*) _tmp23_) == _tmp26_) {
#line 6646 "LibraryWindow.c"
						GeeMapEntry* _tmp27_;
						gconstpointer _tmp28_;
						gconstpointer _tmp29_;
						const gchar* _tmp30_;
						const gchar* _tmp31_;
#line 869 "../src/LibraryWindow.vala"
						_tmp27_ = entry;
#line 869 "../src/LibraryWindow.vala"
						_tmp28_ = gee_map_entry_get_key (_tmp27_);
#line 869 "../src/LibraryWindow.vala"
						_tmp29_ = _tmp28_;
#line 869 "../src/LibraryWindow.vala"
						_tmp30_ = music_playlist_get_name ((MusicPlaylist*) _tmp29_);
#line 869 "../src/LibraryWindow.vala"
						_tmp31_ = _tmp30_;
#line 869 "../src/LibraryWindow.vala"
						if (g_strcmp0 (_tmp31_, new_name) != 0) {
#line 6664 "LibraryWindow.c"
							GeeMapEntry* _tmp32_;
							gconstpointer _tmp33_;
							gconstpointer _tmp34_;
#line 870 "../src/LibraryWindow.vala"
							_tmp32_ = entry;
#line 870 "../src/LibraryWindow.vala"
							_tmp33_ = gee_map_entry_get_key (_tmp32_);
#line 870 "../src/LibraryWindow.vala"
							_tmp34_ = _tmp33_;
#line 870 "../src/LibraryWindow.vala"
							music_playlist_set_name ((MusicPlaylist*) _tmp34_, new_name);
#line 871 "../src/LibraryWindow.vala"
							_g_object_unref0 (entry);
#line 871 "../src/LibraryWindow.vala"
							_g_object_unref0 (_entry_it);
#line 871 "../src/LibraryWindow.vala"
							_g_object_unref0 (view);
#line 871 "../src/LibraryWindow.vala"
							return;
#line 6684 "LibraryWindow.c"
						}
					}
#line 867 "../src/LibraryWindow.vala"
					_g_object_unref0 (entry);
#line 6689 "LibraryWindow.c"
				}
#line 867 "../src/LibraryWindow.vala"
				_g_object_unref0 (_entry_it);
#line 6693 "LibraryWindow.c"
			}
		}
#line 864 "../src/LibraryWindow.vala"
		_g_object_unref0 (view);
#line 6698 "LibraryWindow.c"
	}
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 879 "../src/LibraryWindow.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 879 "../src/LibraryWindow.vala"
	return _data8_;
#line 6709 "LibraryWindow.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 879 "../src/LibraryWindow.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 6719 "LibraryWindow.c"
		MusicLibraryWindow* self;
#line 879 "../src/LibraryWindow.vala"
		self = _data8_->self;
#line 879 "../src/LibraryWindow.vala"
		_g_object_unref0 (_data8_->view);
#line 879 "../src/LibraryWindow.vala"
		_g_object_unref0 (_data8_->p);
#line 879 "../src/LibraryWindow.vala"
		_g_object_unref0 (self);
#line 879 "../src/LibraryWindow.vala"
		g_slice_free (Block8Data, _data8_);
#line 6731 "LibraryWindow.c"
	}
}

static void
__lambda155_ (MusicLibraryWindow* self,
              MusicPlaylist* playlist)
{
#line 888 "../src/LibraryWindow.vala"
	g_return_if_fail (playlist != NULL);
#line 889 "../src/LibraryWindow.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (playlist, MUSIC_TYPE_SMART_PLAYLIST)) {
#line 890 "../src/LibraryWindow.vala"
		music_library_window_show_smart_playlist_dialog (self, G_TYPE_CHECK_INSTANCE_CAST (playlist, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist));
#line 6745 "LibraryWindow.c"
	}
}

static void
___lambda155__music_playlist_view_wrapper_button_clicked (MusicPlaylistViewWrapper* _sender,
                                                          MusicPlaylist* p,
                                                          gpointer self)
{
#line 888 "../src/LibraryWindow.vala"
	__lambda155_ ((MusicLibraryWindow*) self, p);
#line 6756 "LibraryWindow.c"
}

static void
__lambda156_ (Block8Data* _data8_,
              const gchar* old_name)
{
	MusicLibraryWindow* self;
#line 896 "../src/LibraryWindow.vala"
	self = _data8_->self;
#line 897 "../src/LibraryWindow.vala"
	if (old_name != NULL) {
#line 6768 "LibraryWindow.c"
		MusicSourceListView* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 898 "../src/LibraryWindow.vala"
		_tmp0_ = self->priv->_source_list_view;
#line 898 "../src/LibraryWindow.vala"
		_tmp1_ = music_playlist_get_name ((MusicPlaylist*) _data8_->p);
#line 898 "../src/LibraryWindow.vala"
		_tmp2_ = _tmp1_;
#line 898 "../src/LibraryWindow.vala"
		music_source_list_view_change_playlist_name (_tmp0_, (MusicViewWrapper*) _data8_->view, _tmp2_);
#line 6780 "LibraryWindow.c"
	}
}

static void
___lambda156__music_playlist_updated (MusicPlaylist* _sender,
                                      const gchar* old_name,
                                      gpointer self)
{
#line 896 "../src/LibraryWindow.vala"
	__lambda156_ (self, old_name);
#line 6791 "LibraryWindow.c"
}

static void
music_library_window_create_smartplaylist_source_list (MusicLibraryWindow* self,
                                                       MusicSmartPlaylist* p,
                                                       MusicSourceListExpandableItem* into_expandable,
                                                       MusicLibrary* library)
{
	Block8Data* _data8_;
	MusicSmartPlaylist* _tmp0_;
	MusicTreeViewSetup* tvs = NULL;
	MusicTreeViewSetup* _tmp11_;
	MusicLocalLibrary* _tmp12_;
	MusicLocalLibrary* _tmp13_;
	MusicPlaylistViewWrapper* _tmp14_;
	MusicViewStack* _tmp15_;
	MusicSourceListEntry* entry = NULL;
	MusicSourceListView* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	GIcon* _tmp19_;
	MusicSourceListEntry* _tmp20_;
	gboolean _tmp25_;
	GError* _inner_error0_ = NULL;
#line 879 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 879 "../src/LibraryWindow.vala"
	g_return_if_fail (p != NULL);
#line 879 "../src/LibraryWindow.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 879 "../src/LibraryWindow.vala"
	_data8_->_ref_count_ = 1;
#line 879 "../src/LibraryWindow.vala"
	_data8_->self = g_object_ref (self);
#line 879 "../src/LibraryWindow.vala"
	_tmp0_ = _g_object_ref0 (p);
#line 879 "../src/LibraryWindow.vala"
	_g_object_unref0 (_data8_->p);
#line 879 "../src/LibraryWindow.vala"
	_data8_->p = _tmp0_;
#line 880 "../src/LibraryWindow.vala"
	tvs = NULL;
#line 881 "../src/LibraryWindow.vala"
	if (MUSIC_IS_LOCAL_SMART_PLAYLIST (_data8_->p)) {
#line 6836 "LibraryWindow.c"
		gint64 _tmp1_;
		gint64 _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		MusicLocalLibrary* _tmp5_;
		MusicLocalLibrary* _tmp6_;
		GdaConnection* _tmp7_;
		GdaConnection* _tmp8_;
		MusicTreeViewSetup* _tmp9_;
#line 882 "../src/LibraryWindow.vala"
		_tmp1_ = music_playlist_get_rowid ((MusicPlaylist*) _data8_->p);
#line 882 "../src/LibraryWindow.vala"
		_tmp2_ = _tmp1_;
#line 882 "../src/LibraryWindow.vala"
		_tmp3_ = g_strdup_printf ("library:s%lld", _tmp2_);
#line 882 "../src/LibraryWindow.vala"
		_tmp4_ = _tmp3_;
#line 882 "../src/LibraryWindow.vala"
		_tmp5_ = music_library_window_get_library_manager (self);
#line 882 "../src/LibraryWindow.vala"
		_tmp6_ = _tmp5_;
#line 882 "../src/LibraryWindow.vala"
		_tmp7_ = music_local_library_get_connection (_tmp6_);
#line 882 "../src/LibraryWindow.vala"
		_tmp8_ = _tmp7_;
#line 882 "../src/LibraryWindow.vala"
		_tmp9_ = music_tree_view_setup_new (MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST, _tmp4_, _tmp8_);
#line 882 "../src/LibraryWindow.vala"
		_g_object_unref0 (tvs);
#line 882 "../src/LibraryWindow.vala"
		tvs = _tmp9_;
#line 882 "../src/LibraryWindow.vala"
		_g_free0 (_tmp4_);
#line 6870 "LibraryWindow.c"
	} else {
		MusicTreeViewSetup* _tmp10_;
#line 884 "../src/LibraryWindow.vala"
		_tmp10_ = music_tree_view_setup_new (MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST, NULL, NULL);
#line 884 "../src/LibraryWindow.vala"
		_g_object_unref0 (tvs);
#line 884 "../src/LibraryWindow.vala"
		tvs = _tmp10_;
#line 6879 "LibraryWindow.c"
	}
#line 887 "../src/LibraryWindow.vala"
	_tmp11_ = tvs;
#line 887 "../src/LibraryWindow.vala"
	_tmp12_ = music_library_window_get_library_manager (self);
#line 887 "../src/LibraryWindow.vala"
	_tmp13_ = _tmp12_;
#line 887 "../src/LibraryWindow.vala"
	_tmp14_ = music_playlist_view_wrapper_new ((MusicPlaylist*) _data8_->p, MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST, _tmp11_, (MusicLibrary*) _tmp13_);
#line 887 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp14_);
#line 887 "../src/LibraryWindow.vala"
	_data8_->view = _tmp14_;
#line 888 "../src/LibraryWindow.vala"
	g_signal_connect_object (_data8_->view, "button-clicked", (GCallback) ___lambda155__music_playlist_view_wrapper_button_clicked, self, 0);
#line 894 "../src/LibraryWindow.vala"
	_tmp15_ = self->priv->_view_stack;
#line 894 "../src/LibraryWindow.vala"
	music_view_stack_add_view (_tmp15_, (GtkWidget*) _data8_->view);
#line 895 "../src/LibraryWindow.vala"
	_tmp16_ = self->priv->_source_list_view;
#line 895 "../src/LibraryWindow.vala"
	_tmp17_ = music_playlist_get_name ((MusicPlaylist*) _data8_->p);
#line 895 "../src/LibraryWindow.vala"
	_tmp18_ = _tmp17_;
#line 895 "../src/LibraryWindow.vala"
	_tmp19_ = ((MusicPlaylist*) _data8_->p)->icon;
#line 895 "../src/LibraryWindow.vala"
	_tmp20_ = music_source_list_view_add_item (_tmp16_, (GtkGrid*) _data8_->view, _tmp18_, MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST, _tmp19_, NULL, NULL, NULL);
#line 895 "../src/LibraryWindow.vala"
	entry = _tmp20_;
#line 896 "../src/LibraryWindow.vala"
	g_signal_connect_data ((MusicPlaylist*) _data8_->p, "updated", (GCallback) ___lambda156__music_playlist_updated, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 6913 "LibraryWindow.c"
	{
		GeeHashMap* _tmp21_;
#line 901 "../src/LibraryWindow.vala"
		_tmp21_ = self->match_playlists;
#line 901 "../src/LibraryWindow.vala"
		g_rec_mutex_lock (&self->priv->__lock_match_playlists);
#line 6920 "LibraryWindow.c"
		{
			GeeHashMap* _tmp22_;
			GeeHashMap* _tmp23_;
#line 902 "../src/LibraryWindow.vala"
			_tmp22_ = self->priv->match_playlist_entry;
#line 902 "../src/LibraryWindow.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp22_, (MusicPlaylist*) _data8_->p, entry);
#line 903 "../src/LibraryWindow.vala"
			_tmp23_ = self->match_playlists;
#line 903 "../src/LibraryWindow.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp23_, (MusicPlaylist*) _data8_->p, (MusicViewWrapper*) _data8_->view);
#line 6932 "LibraryWindow.c"
		}
		__finally0:
		{
			GeeHashMap* _tmp24_;
#line 901 "../src/LibraryWindow.vala"
			_tmp24_ = self->match_playlists;
#line 901 "../src/LibraryWindow.vala"
			g_rec_mutex_unlock (&self->priv->__lock_match_playlists);
#line 6941 "LibraryWindow.c"
		}
#line 901 "../src/LibraryWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 901 "../src/LibraryWindow.vala"
			_g_object_unref0 (entry);
#line 901 "../src/LibraryWindow.vala"
			_g_object_unref0 (tvs);
#line 901 "../src/LibraryWindow.vala"
			block8_data_unref (_data8_);
#line 901 "../src/LibraryWindow.vala"
			_data8_ = NULL;
#line 901 "../src/LibraryWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 901 "../src/LibraryWindow.vala"
			g_clear_error (&_inner_error0_);
#line 901 "../src/LibraryWindow.vala"
			return;
#line 6959 "LibraryWindow.c"
		}
	}
#line 906 "../src/LibraryWindow.vala"
	_tmp25_ = self->priv->_newly_created_playlist;
#line 906 "../src/LibraryWindow.vala"
	if (_tmp25_ == TRUE) {
#line 907 "../src/LibraryWindow.vala"
		music_library_window_set_newly_created_playlist (self, FALSE);
#line 908 "../src/LibraryWindow.vala"
		music_library_window_show_playlist_view (self, (MusicPlaylist*) _data8_->p);
#line 6970 "LibraryWindow.c"
	}
#line 879 "../src/LibraryWindow.vala"
	_g_object_unref0 (entry);
#line 879 "../src/LibraryWindow.vala"
	_g_object_unref0 (tvs);
#line 879 "../src/LibraryWindow.vala"
	block8_data_unref (_data8_);
#line 879 "../src/LibraryWindow.vala"
	_data8_ = NULL;
#line 6980 "LibraryWindow.c"
}

/**
     * Dialogs from the interface
     */
void
music_library_window_show_smart_playlist_dialog (MusicLibraryWindow* self,
                                                 MusicSmartPlaylist* smartplaylist)
{
	MusicSmartPlaylistEditor* spe = NULL;
	MusicLocalLibrary* _tmp0_;
	MusicLocalLibrary* _tmp1_;
	MusicSmartPlaylistEditor* _tmp2_;
	MusicSmartPlaylistEditor* _tmp3_;
#line 916 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 917 "../src/LibraryWindow.vala"
	spe = NULL;
#line 918 "../src/LibraryWindow.vala"
	_tmp0_ = music_library_window_get_library_manager (self);
#line 918 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 918 "../src/LibraryWindow.vala"
	_tmp2_ = music_smart_playlist_editor_new (smartplaylist, (MusicLibrary*) _tmp1_);
#line 918 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp2_);
#line 918 "../src/LibraryWindow.vala"
	_g_object_unref0 (spe);
#line 918 "../src/LibraryWindow.vala"
	spe = _tmp2_;
#line 919 "../src/LibraryWindow.vala"
	_tmp3_ = spe;
#line 919 "../src/LibraryWindow.vala"
	gtk_widget_show ((GtkWidget*) _tmp3_);
#line 916 "../src/LibraryWindow.vala"
	_g_object_unref0 (spe);
#line 7017 "LibraryWindow.c"
}

/** This should be used whenever a call to play a new media is made
     *
     * XXX: this doesn't belong here, but to the playback manager
     * @param s The media that is now playing
     */
static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 927 "../src/LibraryWindow.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 927 "../src/LibraryWindow.vala"
	return _data9_;
#line 7032 "LibraryWindow.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 927 "../src/LibraryWindow.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 7042 "LibraryWindow.c"
		MusicLibraryWindow* self;
#line 927 "../src/LibraryWindow.vala"
		self = _data9_->self;
#line 927 "../src/LibraryWindow.vala"
		_g_object_unref0 (_data9_->m);
#line 927 "../src/LibraryWindow.vala"
		_g_object_unref0 (self);
#line 927 "../src/LibraryWindow.vala"
		g_slice_free (Block9Data, _data9_);
#line 7052 "LibraryWindow.c"
	}
}

static void*
___lambda166_ (MusicLibraryWindow* self)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	void* result;
#line 942 "../src/LibraryWindow.vala"
	_tmp0_ = music_app_get_player ();
#line 942 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 942 "../src/LibraryWindow.vala"
	_tmp2_ = music_playback_manager_get_current_media (_tmp1_);
#line 942 "../src/LibraryWindow.vala"
	_tmp3_ = _tmp2_;
#line 942 "../src/LibraryWindow.vala"
	g_signal_emit_by_name ((MusicLibraryWindowInterface*) self, "update-media-info", _tmp3_);
#line 943 "../src/LibraryWindow.vala"
	result = NULL;
#line 943 "../src/LibraryWindow.vala"
	return result;
#line 7078 "LibraryWindow.c"
}

static gpointer
____lambda166__gthread_func (gpointer self)
{
	gpointer result;
	result = ___lambda166_ ((MusicLibraryWindow*) self);
#line 941 "../src/LibraryWindow.vala"
	g_object_unref (self);
#line 941 "../src/LibraryWindow.vala"
	return result;
#line 7090 "LibraryWindow.c"
}

static gboolean
__lambda165_ (Block9Data* _data9_)
{
	MusicLibraryWindow* self;
	gboolean _tmp0_ = FALSE;
	MusicPlaybackManager* _tmp1_;
	MusicPlaybackManager* _tmp2_;
	MusicMedia* _tmp3_;
	MusicMedia* _tmp4_;
	gboolean result;
#line 939 "../src/LibraryWindow.vala"
	self = _data9_->self;
#line 940 "../src/LibraryWindow.vala"
	_tmp1_ = music_app_get_player ();
#line 940 "../src/LibraryWindow.vala"
	_tmp2_ = _tmp1_;
#line 940 "../src/LibraryWindow.vala"
	_tmp3_ = music_playback_manager_get_current_media (_tmp2_);
#line 940 "../src/LibraryWindow.vala"
	_tmp4_ = _tmp3_;
#line 940 "../src/LibraryWindow.vala"
	if (_tmp4_ != NULL) {
#line 7115 "LibraryWindow.c"
		MusicPlaybackManager* _tmp5_;
		MusicPlaybackManager* _tmp6_;
		MusicMedia* _tmp7_;
		MusicMedia* _tmp8_;
#line 940 "../src/LibraryWindow.vala"
		_tmp5_ = music_app_get_player ();
#line 940 "../src/LibraryWindow.vala"
		_tmp6_ = _tmp5_;
#line 940 "../src/LibraryWindow.vala"
		_tmp7_ = music_playback_manager_get_current_media (_tmp6_);
#line 940 "../src/LibraryWindow.vala"
		_tmp8_ = _tmp7_;
#line 940 "../src/LibraryWindow.vala"
		_tmp0_ = _tmp8_ == _data9_->m;
#line 7130 "LibraryWindow.c"
	} else {
#line 940 "../src/LibraryWindow.vala"
		_tmp0_ = FALSE;
#line 7134 "LibraryWindow.c"
	}
#line 940 "../src/LibraryWindow.vala"
	if (_tmp0_) {
#line 7138 "LibraryWindow.c"
		GThread* _tmp9_;
		GThread* _tmp10_;
#line 941 "../src/LibraryWindow.vala"
		_tmp9_ = g_thread_new (NULL, ____lambda166__gthread_func, g_object_ref (self));
#line 941 "../src/LibraryWindow.vala"
		_tmp10_ = _tmp9_;
#line 941 "../src/LibraryWindow.vala"
		_g_thread_unref0 (_tmp10_);
#line 7147 "LibraryWindow.c"
	}
#line 947 "../src/LibraryWindow.vala"
	result = FALSE;
#line 947 "../src/LibraryWindow.vala"
	return result;
#line 7153 "LibraryWindow.c"
}

static gboolean
___lambda165__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda165_ (self);
#line 939 "../src/LibraryWindow.vala"
	return result;
#line 7163 "LibraryWindow.c"
}

static void
music_library_window_media_played (MusicLibraryWindow* self,
                                   MusicMedia* m)
{
	Block9Data* _data9_;
	MusicMedia* _tmp0_;
	MusicTopDisplay* _tmp1_;
#line 927 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 927 "../src/LibraryWindow.vala"
	g_return_if_fail (m != NULL);
#line 927 "../src/LibraryWindow.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 927 "../src/LibraryWindow.vala"
	_data9_->_ref_count_ = 1;
#line 927 "../src/LibraryWindow.vala"
	_data9_->self = g_object_ref (self);
#line 927 "../src/LibraryWindow.vala"
	_tmp0_ = _g_object_ref0 (m);
#line 927 "../src/LibraryWindow.vala"
	_g_object_unref0 (_data9_->m);
#line 927 "../src/LibraryWindow.vala"
	_data9_->m = _tmp0_;
#line 929 "../src/LibraryWindow.vala"
	_tmp1_ = self->priv->top_display;
#line 929 "../src/LibraryWindow.vala"
	music_top_display_update_media (_tmp1_);
#line 932 "../src/LibraryWindow.vala"
	music_library_window_set_media_considered_previewed (self, FALSE);
#line 933 "../src/LibraryWindow.vala"
	music_library_window_set_media_considered_played (self, FALSE);
#line 934 "../src/LibraryWindow.vala"
	music_library_window_set_added_to_play_count (self, FALSE);
#line 935 "../src/LibraryWindow.vala"
	music_library_window_set_media_half_played_sended (self, FALSE);
#line 937 "../src/LibraryWindow.vala"
	music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) self, NULL, NULL);
#line 939 "../src/LibraryWindow.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 3000, ___lambda165__gsource_func, block9_data_ref (_data9_), block9_data_unref);
#line 927 "../src/LibraryWindow.vala"
	block9_data_unref (_data9_);
#line 927 "../src/LibraryWindow.vala"
	_data9_ = NULL;
#line 7209 "LibraryWindow.c"
}

static GVariant*
_variant_new3 (gboolean value)
{
#line 953 "../src/LibraryWindow.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 7217 "LibraryWindow.c"
}

static void
music_library_window_real_playback_stopped (MusicLibraryWindow* self,
                                            gint64 was_playing)
{
	GAction* _tmp0_;
	GVariant* _tmp1_;
#line 953 "../src/LibraryWindow.vala"
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, MUSIC_LIBRARY_WINDOW_ACTION_PLAY);
#line 953 "../src/LibraryWindow.vala"
	_tmp1_ = _variant_new3 (FALSE);
#line 953 "../src/LibraryWindow.vala"
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction), _tmp1_);
#line 953 "../src/LibraryWindow.vala"
	_g_variant_unref0 (_tmp1_);
#line 955 "../src/LibraryWindow.vala"
	music_library_window_set_media_considered_previewed (self, FALSE);
#line 956 "../src/LibraryWindow.vala"
	music_library_window_set_media_considered_played (self, FALSE);
#line 957 "../src/LibraryWindow.vala"
	music_library_window_set_added_to_play_count (self, FALSE);
#line 959 "../src/LibraryWindow.vala"
	music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) self, NULL, NULL);
#line 961 "../src/LibraryWindow.vala"
	g_debug ("LibraryWindow.vala:961: playback stopped");
#line 7244 "LibraryWindow.c"
}

void
music_library_window_playback_stopped (MusicLibraryWindow* self,
                                       gint64 was_playing)
{
	MusicLibraryWindowClass* _klass_;
#line 952 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 952 "../src/LibraryWindow.vala"
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
#line 952 "../src/LibraryWindow.vala"
	if (_klass_->playback_stopped) {
#line 952 "../src/LibraryWindow.vala"
		_klass_->playback_stopped (self, was_playing);
#line 7260 "LibraryWindow.c"
	}
}

static void
music_library_window_real_play_media (MusicLibraryWindow* self,
                                      gboolean inhibit_notifications)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
#line 965 "../src/LibraryWindow.vala"
	_tmp0_ = music_app_get_player ();
#line 965 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 965 "../src/LibraryWindow.vala"
	_tmp2_ = music_playback_manager_get_current_media (_tmp1_);
#line 965 "../src/LibraryWindow.vala"
	_tmp3_ = _tmp2_;
#line 965 "../src/LibraryWindow.vala"
	if (_tmp3_ == NULL) {
#line 7282 "LibraryWindow.c"
		MusicPlaybackManager* _tmp4_;
		MusicPlaybackManager* _tmp5_;
		MusicMedia* _tmp6_;
		MusicMedia* _tmp7_;
		MusicPlaybackManager* _tmp8_;
		MusicPlaybackManager* _tmp9_;
#line 966 "../src/LibraryWindow.vala"
		g_debug ("LibraryWindow.vala:966: No media is currently playing. Starting from t" \
"he top\n");
#line 968 "../src/LibraryWindow.vala"
		_tmp4_ = music_app_get_player ();
#line 968 "../src/LibraryWindow.vala"
		_tmp5_ = _tmp4_;
#line 968 "../src/LibraryWindow.vala"
		_tmp6_ = music_playback_manager_get_next (_tmp5_, TRUE);
#line 968 "../src/LibraryWindow.vala"
		_tmp7_ = _tmp6_;
#line 968 "../src/LibraryWindow.vala"
		_g_object_unref0 (_tmp7_);
#line 969 "../src/LibraryWindow.vala"
		_tmp8_ = music_app_get_player ();
#line 969 "../src/LibraryWindow.vala"
		_tmp9_ = _tmp8_;
#line 969 "../src/LibraryWindow.vala"
		music_playback_manager_start_playback (_tmp9_);
#line 971 "../src/LibraryWindow.vala"
		if (!inhibit_notifications) {
#line 972 "../src/LibraryWindow.vala"
			music_library_window_notify_current_media_async (self, NULL, NULL);
#line 7311 "LibraryWindow.c"
		}
	} else {
		MusicPlaybackManager* _tmp10_;
		MusicPlaybackManager* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
#line 975 "../src/LibraryWindow.vala"
		_tmp10_ = music_app_get_player ();
#line 975 "../src/LibraryWindow.vala"
		_tmp11_ = _tmp10_;
#line 975 "../src/LibraryWindow.vala"
		_tmp12_ = music_playback_manager_get_playing (_tmp11_);
#line 975 "../src/LibraryWindow.vala"
		_tmp13_ = _tmp12_;
#line 975 "../src/LibraryWindow.vala"
		if (_tmp13_) {
#line 7328 "LibraryWindow.c"
			MusicPlaybackManager* _tmp14_;
			MusicPlaybackManager* _tmp15_;
#line 976 "../src/LibraryWindow.vala"
			_tmp14_ = music_app_get_player ();
#line 976 "../src/LibraryWindow.vala"
			_tmp15_ = _tmp14_;
#line 976 "../src/LibraryWindow.vala"
			music_playback_manager_pause_playback (_tmp15_);
#line 7337 "LibraryWindow.c"
		} else {
			MusicPlaybackManager* _tmp16_;
			MusicPlaybackManager* _tmp17_;
#line 978 "../src/LibraryWindow.vala"
			_tmp16_ = music_app_get_player ();
#line 978 "../src/LibraryWindow.vala"
			_tmp17_ = _tmp16_;
#line 978 "../src/LibraryWindow.vala"
			music_playback_manager_start_playback (_tmp17_);
#line 7347 "LibraryWindow.c"
		}
	}
#line 982 "../src/LibraryWindow.vala"
	g_signal_emit (self, music_library_window_signals[MUSIC_LIBRARY_WINDOW_PLAY_PAUSE_CHANGED_SIGNAL], 0);
#line 7352 "LibraryWindow.c"
}

void
music_library_window_play_media (MusicLibraryWindow* self,
                                 gboolean inhibit_notifications)
{
	MusicLibraryWindowClass* _klass_;
#line 964 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 964 "../src/LibraryWindow.vala"
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
#line 964 "../src/LibraryWindow.vala"
	if (_klass_->play_media) {
#line 964 "../src/LibraryWindow.vala"
		_klass_->play_media (self, inhibit_notifications);
#line 7368 "LibraryWindow.c"
	}
}

static void
music_library_window_real_play_next_media (MusicLibraryWindow* self,
                                           gboolean inhibit_notifications)
{
	gboolean _tmp0_;
	MusicMedia* m = NULL;
	MusicPlaybackManager* _tmp7_;
	MusicPlaybackManager* _tmp8_;
	MusicMedia* _tmp9_;
	MusicMedia* _tmp10_;
#line 987 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->_added_to_play_count;
#line 987 "../src/LibraryWindow.vala"
	if (!_tmp0_) {
#line 7386 "LibraryWindow.c"
		MusicPlaybackManager* _tmp1_;
		MusicPlaybackManager* _tmp2_;
		MusicMedia* _tmp3_;
		MusicMedia* _tmp4_;
		guint _tmp5_;
		guint _tmp6_;
#line 988 "../src/LibraryWindow.vala"
		_tmp1_ = music_app_get_player ();
#line 988 "../src/LibraryWindow.vala"
		_tmp2_ = _tmp1_;
#line 988 "../src/LibraryWindow.vala"
		_tmp3_ = music_playback_manager_get_current_media (_tmp2_);
#line 988 "../src/LibraryWindow.vala"
		_tmp4_ = _tmp3_;
#line 988 "../src/LibraryWindow.vala"
		_tmp5_ = music_media_get_skip_count (_tmp4_);
#line 988 "../src/LibraryWindow.vala"
		_tmp6_ = _tmp5_;
#line 988 "../src/LibraryWindow.vala"
		music_media_set_skip_count (_tmp4_, _tmp6_ + 1);
#line 7407 "LibraryWindow.c"
	}
#line 991 "../src/LibraryWindow.vala"
	_tmp7_ = music_app_get_player ();
#line 991 "../src/LibraryWindow.vala"
	_tmp8_ = _tmp7_;
#line 991 "../src/LibraryWindow.vala"
	_tmp9_ = music_playback_manager_get_next (_tmp8_, TRUE);
#line 991 "../src/LibraryWindow.vala"
	m = _tmp9_;
#line 994 "../src/LibraryWindow.vala"
	_tmp10_ = m;
#line 994 "../src/LibraryWindow.vala"
	if (_tmp10_ == NULL) {
#line 7421 "LibraryWindow.c"
		MusicPlaybackManager* _tmp11_;
		MusicPlaybackManager* _tmp12_;
#line 995 "../src/LibraryWindow.vala"
		_tmp11_ = music_app_get_player ();
#line 995 "../src/LibraryWindow.vala"
		_tmp12_ = _tmp11_;
#line 995 "../src/LibraryWindow.vala"
		music_playback_manager_stop_playback (_tmp12_);
#line 996 "../src/LibraryWindow.vala"
		music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) self, NULL, NULL);
#line 997 "../src/LibraryWindow.vala"
		_g_object_unref0 (m);
#line 997 "../src/LibraryWindow.vala"
		return;
#line 7436 "LibraryWindow.c"
	}
#line 1000 "../src/LibraryWindow.vala"
	if (!inhibit_notifications) {
#line 1001 "../src/LibraryWindow.vala"
		music_library_window_notify_current_media_async (self, NULL, NULL);
#line 7442 "LibraryWindow.c"
	}
#line 985 "../src/LibraryWindow.vala"
	_g_object_unref0 (m);
#line 7446 "LibraryWindow.c"
}

void
music_library_window_play_next_media (MusicLibraryWindow* self,
                                      gboolean inhibit_notifications)
{
	MusicLibraryWindowClass* _klass_;
#line 985 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 985 "../src/LibraryWindow.vala"
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
#line 985 "../src/LibraryWindow.vala"
	if (_klass_->play_next_media) {
#line 985 "../src/LibraryWindow.vala"
		_klass_->play_next_media (self, inhibit_notifications);
#line 7462 "LibraryWindow.c"
	}
}

static void
music_library_window_real_play_previous_media (MusicLibraryWindow* self,
                                               gboolean inhibit_notifications)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicPlayback* _tmp2_;
#line 1006 "../src/LibraryWindow.vala"
	_tmp0_ = music_app_get_player ();
#line 1006 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 1006 "../src/LibraryWindow.vala"
	_tmp2_ = _tmp1_->player;
#line 1006 "../src/LibraryWindow.vala"
	if (music_playback_get_position (_tmp2_) < 5000000000LL) {
#line 7481 "LibraryWindow.c"
		gboolean play = FALSE;
		MusicMedia* prev = NULL;
		MusicPlaybackManager* _tmp3_;
		MusicPlaybackManager* _tmp4_;
		MusicMedia* _tmp5_;
		MusicMedia* _tmp6_;
#line 1007 "../src/LibraryWindow.vala"
		play = TRUE;
#line 1008 "../src/LibraryWindow.vala"
		_tmp3_ = music_app_get_player ();
#line 1008 "../src/LibraryWindow.vala"
		_tmp4_ = _tmp3_;
#line 1008 "../src/LibraryWindow.vala"
		_tmp5_ = music_playback_manager_get_previous (_tmp4_, TRUE);
#line 1008 "../src/LibraryWindow.vala"
		prev = _tmp5_;
#line 1011 "../src/LibraryWindow.vala"
		_tmp6_ = prev;
#line 1011 "../src/LibraryWindow.vala"
		if (_tmp6_ == NULL) {
#line 7502 "LibraryWindow.c"
			MusicPlaybackManager* _tmp7_;
			MusicPlaybackManager* _tmp8_;
#line 1012 "../src/LibraryWindow.vala"
			_tmp7_ = music_app_get_player ();
#line 1012 "../src/LibraryWindow.vala"
			_tmp8_ = _tmp7_;
#line 1012 "../src/LibraryWindow.vala"
			music_playback_manager_stop_playback (_tmp8_);
#line 1013 "../src/LibraryWindow.vala"
			music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) self, NULL, NULL);
#line 1014 "../src/LibraryWindow.vala"
			_g_object_unref0 (prev);
#line 1014 "../src/LibraryWindow.vala"
			return;
#line 7517 "LibraryWindow.c"
		} else {
			gboolean _tmp9_ = FALSE;
#line 1015 "../src/LibraryWindow.vala"
			if (play) {
#line 1015 "../src/LibraryWindow.vala"
				_tmp9_ = !inhibit_notifications;
#line 7524 "LibraryWindow.c"
			} else {
#line 1015 "../src/LibraryWindow.vala"
				_tmp9_ = FALSE;
#line 7528 "LibraryWindow.c"
			}
#line 1015 "../src/LibraryWindow.vala"
			if (_tmp9_) {
#line 1016 "../src/LibraryWindow.vala"
				music_library_window_notify_current_media_async (self, NULL, NULL);
#line 7534 "LibraryWindow.c"
			}
		}
#line 1006 "../src/LibraryWindow.vala"
		_g_object_unref0 (prev);
#line 7539 "LibraryWindow.c"
	} else {
		MusicTopDisplay* _tmp10_;
#line 1019 "../src/LibraryWindow.vala"
		_tmp10_ = self->priv->top_display;
#line 1019 "../src/LibraryWindow.vala"
		music_top_display_change_value (_tmp10_, GTK_SCROLL_NONE, (gdouble) 0);
#line 7546 "LibraryWindow.c"
	}
}

void
music_library_window_play_previous_media (MusicLibraryWindow* self,
                                          gboolean inhibit_notifications)
{
	MusicLibraryWindowClass* _klass_;
#line 1005 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1005 "../src/LibraryWindow.vala"
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
#line 1005 "../src/LibraryWindow.vala"
	if (_klass_->play_previous_media) {
#line 1005 "../src/LibraryWindow.vala"
		_klass_->play_previous_media (self, inhibit_notifications);
#line 7563 "LibraryWindow.c"
	}
}

static void
_g_free0_ (gpointer var)
{
#line 1037 "../src/LibraryWindow.vala"
	var = (g_free (var), NULL);
#line 7572 "LibraryWindow.c"
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 1037 "../src/LibraryWindow.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 7580 "LibraryWindow.c"
}

static void
music_library_window_real_action_import (MusicLibraryWindow* self)
{
	MusicLocalLibrary* _tmp0_;
	MusicLocalLibrary* _tmp1_;
#line 1024 "../src/LibraryWindow.vala"
	_tmp0_ = music_library_window_get_library_manager (self);
#line 1024 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 1024 "../src/LibraryWindow.vala"
	if (!music_library_doing_file_operations ((MusicLibrary*) _tmp1_)) {
#line 7594 "LibraryWindow.c"
		GtkFileChooserNative* file_chooser = NULL;
		GtkFileChooserNative* _tmp2_;
		GtkFileChooserNative* _tmp3_;
		GtkFileChooserNative* _tmp4_;
		GeeTreeSet* folders = NULL;
		GeeTreeSet* _tmp5_;
		GtkFileChooserNative* _tmp6_;
		GtkFileChooserNative* _tmp12_;
		GeeTreeSet* _tmp13_;
		gboolean _tmp14_;
		gboolean _tmp15_;
		MusicSettingsMain* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		GFile* _tmp19_;
		GFile* _tmp20_;
		gboolean _tmp21_;
#line 1025 "../src/LibraryWindow.vala"
		_tmp2_ = gtk_file_chooser_native_new (_ ("Import Music"), (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, _ ("Open"), _ ("Cancel"));
#line 1025 "../src/LibraryWindow.vala"
		file_chooser = _tmp2_;
#line 1032 "../src/LibraryWindow.vala"
		_tmp3_ = file_chooser;
#line 1032 "../src/LibraryWindow.vala"
		gtk_file_chooser_set_select_multiple ((GtkFileChooser*) _tmp3_, TRUE);
#line 1033 "../src/LibraryWindow.vala"
		_tmp4_ = file_chooser;
#line 1033 "../src/LibraryWindow.vala"
		gtk_file_chooser_set_local_only ((GtkFileChooser*) _tmp4_, TRUE);
#line 1035 "../src/LibraryWindow.vala"
		_tmp5_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 1035 "../src/LibraryWindow.vala"
		folders = _tmp5_;
#line 1036 "../src/LibraryWindow.vala"
		_tmp6_ = file_chooser;
#line 1036 "../src/LibraryWindow.vala"
		if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp6_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 7632 "LibraryWindow.c"
			GtkFileChooserNative* _tmp7_;
			GSList* _tmp8_;
#line 1037 "../src/LibraryWindow.vala"
			_tmp7_ = file_chooser;
#line 1037 "../src/LibraryWindow.vala"
			_tmp8_ = gtk_file_chooser_get_filenames ((GtkFileChooser*) _tmp7_);
#line 7639 "LibraryWindow.c"
			{
				GSList* folder_collection = NULL;
				GSList* folder_it = NULL;
#line 1037 "../src/LibraryWindow.vala"
				folder_collection = _tmp8_;
#line 1037 "../src/LibraryWindow.vala"
				for (folder_it = folder_collection; folder_it != NULL; folder_it = folder_it->next) {
#line 7647 "LibraryWindow.c"
					gchar* _tmp9_;
					gchar* folder = NULL;
#line 1037 "../src/LibraryWindow.vala"
					_tmp9_ = g_strdup ((const gchar*) folder_it->data);
#line 1037 "../src/LibraryWindow.vala"
					folder = _tmp9_;
#line 7654 "LibraryWindow.c"
					{
						GeeTreeSet* _tmp10_;
						const gchar* _tmp11_;
#line 1038 "../src/LibraryWindow.vala"
						_tmp10_ = folders;
#line 1038 "../src/LibraryWindow.vala"
						_tmp11_ = folder;
#line 1038 "../src/LibraryWindow.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 1037 "../src/LibraryWindow.vala"
						_g_free0 (folder);
#line 7666 "LibraryWindow.c"
					}
				}
#line 1037 "../src/LibraryWindow.vala"
				(folder_collection == NULL) ? NULL : (folder_collection = (_g_slist_free__g_free0_ (folder_collection), NULL));
#line 7671 "LibraryWindow.c"
			}
		}
#line 1042 "../src/LibraryWindow.vala"
		_tmp12_ = file_chooser;
#line 1042 "../src/LibraryWindow.vala"
		gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp12_);
#line 1045 "../src/LibraryWindow.vala"
		_tmp13_ = folders;
#line 1045 "../src/LibraryWindow.vala"
		_tmp14_ = gee_collection_get_is_empty ((GeeCollection*) _tmp13_);
#line 1045 "../src/LibraryWindow.vala"
		_tmp15_ = _tmp14_;
#line 1045 "../src/LibraryWindow.vala"
		if (_tmp15_) {
#line 1046 "../src/LibraryWindow.vala"
			_g_object_unref0 (folders);
#line 1046 "../src/LibraryWindow.vala"
			_g_object_unref0 (file_chooser);
#line 1046 "../src/LibraryWindow.vala"
			return;
#line 7692 "LibraryWindow.c"
		}
#line 1048 "../src/LibraryWindow.vala"
		_tmp16_ = self->priv->main_settings;
#line 1048 "../src/LibraryWindow.vala"
		_tmp17_ = music_settings_main_get_music_folder (_tmp16_);
#line 1048 "../src/LibraryWindow.vala"
		_tmp18_ = _tmp17_;
#line 1048 "../src/LibraryWindow.vala"
		_tmp19_ = g_file_new_for_path (_tmp18_);
#line 1048 "../src/LibraryWindow.vala"
		_tmp20_ = _tmp19_;
#line 1048 "../src/LibraryWindow.vala"
		_tmp21_ = g_file_query_exists (_tmp20_, NULL);
#line 1048 "../src/LibraryWindow.vala"
		_g_object_unref0 (_tmp20_);
#line 1048 "../src/LibraryWindow.vala"
		if (_tmp21_) {
#line 7710 "LibraryWindow.c"
			MusicLocalLibrary* _tmp22_;
			MusicLocalLibrary* _tmp23_;
			GeeTreeSet* _tmp24_;
#line 1049 "../src/LibraryWindow.vala"
			_tmp22_ = music_library_window_get_library_manager (self);
#line 1049 "../src/LibraryWindow.vala"
			_tmp23_ = _tmp22_;
#line 1049 "../src/LibraryWindow.vala"
			_tmp24_ = folders;
#line 1049 "../src/LibraryWindow.vala"
			music_local_library_add_folder_to_library (_tmp23_, (GeeCollection*) _tmp24_);
#line 1050 "../src/LibraryWindow.vala"
			music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) self, NULL, NULL);
#line 7724 "LibraryWindow.c"
		}
#line 1024 "../src/LibraryWindow.vala"
		_g_object_unref0 (folders);
#line 1024 "../src/LibraryWindow.vala"
		_g_object_unref0 (file_chooser);
#line 7730 "LibraryWindow.c"
	} else {
#line 1053 "../src/LibraryWindow.vala"
		g_debug ("LibraryWindow.vala:1053: Can't add to library.. already doing file ope" \
"rations\n");
#line 7734 "LibraryWindow.c"
	}
}

void
music_library_window_action_import (MusicLibraryWindow* self)
{
	MusicLibraryWindowClass* _klass_;
#line 1023 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1023 "../src/LibraryWindow.vala"
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
#line 1023 "../src/LibraryWindow.vala"
	if (_klass_->action_import) {
#line 1023 "../src/LibraryWindow.vala"
		_klass_->action_import (self);
#line 7750 "LibraryWindow.c"
	}
}

static void
music_library_window_action_play (MusicLibraryWindow* self)
{
#line 1057 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1058 "../src/LibraryWindow.vala"
	music_library_window_play_media (self, FALSE);
#line 7761 "LibraryWindow.c"
}

static void
music_library_window_action_play_next (MusicLibraryWindow* self)
{
#line 1061 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1062 "../src/LibraryWindow.vala"
	music_library_window_play_next_media (self, FALSE);
#line 7771 "LibraryWindow.c"
}

static void
music_library_window_action_play_previous (MusicLibraryWindow* self)
{
#line 1065 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1066 "../src/LibraryWindow.vala"
	music_library_window_play_previous_media (self, FALSE);
#line 7781 "LibraryWindow.c"
}

static void
music_library_window_action_quit (MusicLibraryWindow* self)
{
#line 1069 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1070 "../src/LibraryWindow.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 7791 "LibraryWindow.c"
}

static void
music_library_window_action_search (MusicLibraryWindow* self)
{
	GtkSearchEntry* _tmp0_;
#line 1073 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1074 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->_search_entry;
#line 1074 "../src/LibraryWindow.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
#line 7804 "LibraryWindow.c"
}

static void
music_library_window_action_view_albums (MusicLibraryWindow* self)
{
	MusicWidgetsViewSelector* _tmp0_;
#line 1077 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1078 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->_view_selector;
#line 1078 "../src/LibraryWindow.vala"
	music_widgets_view_selector_set_selected (_tmp0_, MUSIC_WIDGETS_VIEW_SELECTOR_MODE_GRID);
#line 7817 "LibraryWindow.c"
}

static void
music_library_window_action_view_columns (MusicLibraryWindow* self)
{
	MusicWidgetsViewSelector* _tmp0_;
#line 1081 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1082 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->_view_selector;
#line 1082 "../src/LibraryWindow.vala"
	music_widgets_view_selector_set_selected (_tmp0_, MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN);
#line 7830 "LibraryWindow.c"
}

static void
music_library_window_action_view_list (MusicLibraryWindow* self)
{
	MusicWidgetsViewSelector* _tmp0_;
#line 1085 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1086 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->_view_selector;
#line 1086 "../src/LibraryWindow.vala"
	music_widgets_view_selector_set_selected (_tmp0_, MUSIC_WIDGETS_VIEW_SELECTOR_MODE_LIST);
#line 7843 "LibraryWindow.c"
}

static void
music_library_window_edit_preferences_click (MusicLibraryWindow* self)
{
	MusicPreferencesWindow* _tmp0_;
	MusicPreferencesWindow* _tmp2_;
	MusicPreferencesWindow* _tmp3_;
#line 1089 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1090 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->preferences;
#line 1090 "../src/LibraryWindow.vala"
	if (_tmp0_ == NULL) {
#line 7858 "LibraryWindow.c"
		MusicPreferencesWindow* _tmp1_;
#line 1091 "../src/LibraryWindow.vala"
		_tmp1_ = music_preferences_window_new ();
#line 1091 "../src/LibraryWindow.vala"
		g_object_ref_sink (_tmp1_);
#line 1091 "../src/LibraryWindow.vala"
		_g_object_unref0 (self->priv->preferences);
#line 1091 "../src/LibraryWindow.vala"
		self->priv->preferences = _tmp1_;
#line 7868 "LibraryWindow.c"
	}
#line 1092 "../src/LibraryWindow.vala"
	_tmp2_ = self->priv->preferences;
#line 1092 "../src/LibraryWindow.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp2_);
#line 1093 "../src/LibraryWindow.vala"
	_tmp3_ = self->priv->preferences;
#line 1093 "../src/LibraryWindow.vala"
	gtk_dialog_run ((GtkDialog*) _tmp3_);
#line 1094 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->priv->preferences);
#line 1094 "../src/LibraryWindow.vala"
	self->priv->preferences = NULL;
#line 7882 "LibraryWindow.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 1097 "../src/LibraryWindow.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 1097 "../src/LibraryWindow.vala"
	return _data10_;
#line 7892 "LibraryWindow.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 1097 "../src/LibraryWindow.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 7902 "LibraryWindow.c"
		MusicLibraryWindow* self;
#line 1097 "../src/LibraryWindow.vala"
		self = _data10_->self;
#line 1097 "../src/LibraryWindow.vala"
		_g_free0 (_data10_->folder);
#line 1097 "../src/LibraryWindow.vala"
		_g_object_unref0 (self);
#line 1097 "../src/LibraryWindow.vala"
		g_slice_free (Block10Data, _data10_);
#line 7912 "LibraryWindow.c"
	}
}

static void
___lambda122_ (Block10Data* _data10_,
               gboolean cont)
{
	MusicLibraryWindow* self;
#line 1109 "../src/LibraryWindow.vala"
	self = _data10_->self;
#line 1110 "../src/LibraryWindow.vala"
	if (cont) {
#line 7925 "LibraryWindow.c"
		MusicLocalLibrary* _tmp0_;
		MusicLocalLibrary* _tmp1_;
#line 1111 "../src/LibraryWindow.vala"
		_tmp0_ = music_library_window_get_library_manager (self);
#line 1111 "../src/LibraryWindow.vala"
		_tmp1_ = _tmp0_;
#line 1111 "../src/LibraryWindow.vala"
		music_local_library_set_music_folder (_tmp1_, _data10_->folder, NULL, NULL);
#line 7934 "LibraryWindow.c"
	}
}

static void
____lambda122__music_set_music_folder_confirmation_finished (MusicSetMusicFolderConfirmation* _sender,
                                                             gboolean response,
                                                             gpointer self)
{
#line 1109 "../src/LibraryWindow.vala"
	___lambda122_ (self, response);
#line 7945 "LibraryWindow.c"
}

void
music_library_window_set_music_folder (MusicLibraryWindow* self,
                                       const gchar* folder)
{
	Block10Data* _data10_;
	gchar* _tmp0_;
	MusicLocalLibrary* _tmp1_;
	MusicLocalLibrary* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp14_ = FALSE;
	MusicLocalLibrary* _tmp15_;
	MusicLocalLibrary* _tmp16_;
	GeeCollection* _tmp17_;
	GeeCollection* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
#line 1097 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1097 "../src/LibraryWindow.vala"
	g_return_if_fail (folder != NULL);
#line 1097 "../src/LibraryWindow.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 1097 "../src/LibraryWindow.vala"
	_data10_->_ref_count_ = 1;
#line 1097 "../src/LibraryWindow.vala"
	_data10_->self = g_object_ref (self);
#line 1097 "../src/LibraryWindow.vala"
	_tmp0_ = g_strdup (folder);
#line 1097 "../src/LibraryWindow.vala"
	_g_free0 (_data10_->folder);
#line 1097 "../src/LibraryWindow.vala"
	_data10_->folder = _tmp0_;
#line 1098 "../src/LibraryWindow.vala"
	_tmp1_ = music_library_window_get_library_manager (self);
#line 1098 "../src/LibraryWindow.vala"
	_tmp2_ = _tmp1_;
#line 1098 "../src/LibraryWindow.vala"
	if (music_library_doing_file_operations ((MusicLibrary*) _tmp2_)) {
#line 1099 "../src/LibraryWindow.vala"
		block10_data_unref (_data10_);
#line 1099 "../src/LibraryWindow.vala"
		_data10_ = NULL;
#line 1099 "../src/LibraryWindow.vala"
		return;
#line 7993 "LibraryWindow.c"
	}
#line 1103 "../src/LibraryWindow.vala"
	if (g_strcmp0 (_data10_->folder, "") == 0) {
#line 1103 "../src/LibraryWindow.vala"
		_tmp3_ = TRUE;
#line 7999 "LibraryWindow.c"
	} else {
		gboolean _tmp4_ = FALSE;
		MusicSettingsMain* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 1103 "../src/LibraryWindow.vala"
		_tmp5_ = self->priv->main_settings;
#line 1103 "../src/LibraryWindow.vala"
		_tmp6_ = music_settings_main_get_music_folder (_tmp5_);
#line 1103 "../src/LibraryWindow.vala"
		_tmp7_ = _tmp6_;
#line 1103 "../src/LibraryWindow.vala"
		if (g_strcmp0 (_data10_->folder, _tmp7_) == 0) {
#line 8013 "LibraryWindow.c"
			MusicLocalLibrary* _tmp8_;
			MusicLocalLibrary* _tmp9_;
			GeeCollection* _tmp10_;
			GeeCollection* _tmp11_;
			gboolean _tmp12_;
			gboolean _tmp13_;
#line 1103 "../src/LibraryWindow.vala"
			_tmp8_ = music_library_window_get_library_manager (self);
#line 1103 "../src/LibraryWindow.vala"
			_tmp9_ = _tmp8_;
#line 1103 "../src/LibraryWindow.vala"
			_tmp10_ = music_library_get_medias ((MusicLibrary*) _tmp9_);
#line 1103 "../src/LibraryWindow.vala"
			_tmp11_ = _tmp10_;
#line 1103 "../src/LibraryWindow.vala"
			_tmp12_ = gee_collection_get_is_empty (_tmp11_);
#line 1103 "../src/LibraryWindow.vala"
			_tmp13_ = _tmp12_;
#line 1103 "../src/LibraryWindow.vala"
			_tmp4_ = !_tmp13_;
#line 1103 "../src/LibraryWindow.vala"
			_g_object_unref0 (_tmp11_);
#line 8036 "LibraryWindow.c"
		} else {
#line 1103 "../src/LibraryWindow.vala"
			_tmp4_ = FALSE;
#line 8040 "LibraryWindow.c"
		}
#line 1103 "../src/LibraryWindow.vala"
		_tmp3_ = _tmp4_;
#line 8044 "LibraryWindow.c"
	}
#line 1103 "../src/LibraryWindow.vala"
	if (_tmp3_) {
#line 1104 "../src/LibraryWindow.vala"
		block10_data_unref (_data10_);
#line 1104 "../src/LibraryWindow.vala"
		_data10_ = NULL;
#line 1104 "../src/LibraryWindow.vala"
		return;
#line 8054 "LibraryWindow.c"
	}
#line 1107 "../src/LibraryWindow.vala"
	_tmp15_ = music_library_window_get_library_manager (self);
#line 1107 "../src/LibraryWindow.vala"
	_tmp16_ = _tmp15_;
#line 1107 "../src/LibraryWindow.vala"
	_tmp17_ = music_library_get_medias ((MusicLibrary*) _tmp16_);
#line 1107 "../src/LibraryWindow.vala"
	_tmp18_ = _tmp17_;
#line 1107 "../src/LibraryWindow.vala"
	_tmp19_ = gee_collection_get_is_empty (_tmp18_);
#line 1107 "../src/LibraryWindow.vala"
	_tmp20_ = _tmp19_;
#line 1107 "../src/LibraryWindow.vala"
	_tmp21_ = !_tmp20_;
#line 1107 "../src/LibraryWindow.vala"
	_g_object_unref0 (_tmp18_);
#line 1107 "../src/LibraryWindow.vala"
	if (_tmp21_) {
#line 1107 "../src/LibraryWindow.vala"
		_tmp14_ = TRUE;
#line 8076 "LibraryWindow.c"
	} else {
		MusicLocalLibrary* _tmp22_;
		MusicLocalLibrary* _tmp23_;
#line 1107 "../src/LibraryWindow.vala"
		_tmp22_ = music_library_window_get_library_manager (self);
#line 1107 "../src/LibraryWindow.vala"
		_tmp23_ = _tmp22_;
#line 1107 "../src/LibraryWindow.vala"
		_tmp14_ = music_library_playlist_count_without_read_only ((MusicLibrary*) _tmp23_) > 0;
#line 8086 "LibraryWindow.c"
	}
#line 1107 "../src/LibraryWindow.vala"
	if (_tmp14_) {
#line 8090 "LibraryWindow.c"
		MusicSetMusicFolderConfirmation* smfc = NULL;
		MusicSetMusicFolderConfirmation* _tmp24_;
		MusicSetMusicFolderConfirmation* _tmp25_;
#line 1108 "../src/LibraryWindow.vala"
		_tmp24_ = music_set_music_folder_confirmation_new (_data10_->folder);
#line 1108 "../src/LibraryWindow.vala"
		g_object_ref_sink (_tmp24_);
#line 1108 "../src/LibraryWindow.vala"
		smfc = _tmp24_;
#line 1109 "../src/LibraryWindow.vala"
		_tmp25_ = smfc;
#line 1109 "../src/LibraryWindow.vala"
		g_signal_connect_data (_tmp25_, "finished", (GCallback) ____lambda122__music_set_music_folder_confirmation_finished, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 1107 "../src/LibraryWindow.vala"
		_g_object_unref0 (smfc);
#line 8106 "LibraryWindow.c"
	} else {
		MusicLocalLibrary* _tmp26_;
		MusicLocalLibrary* _tmp27_;
#line 1115 "../src/LibraryWindow.vala"
		_tmp26_ = music_library_window_get_library_manager (self);
#line 1115 "../src/LibraryWindow.vala"
		_tmp27_ = _tmp26_;
#line 1115 "../src/LibraryWindow.vala"
		music_local_library_set_music_folder (_tmp27_, _data10_->folder, NULL, NULL);
#line 8116 "LibraryWindow.c"
	}
#line 1097 "../src/LibraryWindow.vala"
	block10_data_unref (_data10_);
#line 1097 "../src/LibraryWindow.vala"
	_data10_ = NULL;
#line 8122 "LibraryWindow.c"
}

static void
music_library_window_real_end_of_stream (MusicLibraryWindow* self)
{
#line 1120 "../src/LibraryWindow.vala"
	music_library_window_play_next_media (self, FALSE);
#line 8130 "LibraryWindow.c"
}

void
music_library_window_end_of_stream (MusicLibraryWindow* self)
{
	MusicLibraryWindowClass* _klass_;
#line 1119 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1119 "../src/LibraryWindow.vala"
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
#line 1119 "../src/LibraryWindow.vala"
	if (_klass_->end_of_stream) {
#line 1119 "../src/LibraryWindow.vala"
		_klass_->end_of_stream (self);
#line 8145 "LibraryWindow.c"
	}
}

static void
music_library_window_real_error_occured (MusicLibraryWindow* self)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
#line 1124 "../src/LibraryWindow.vala"
	_tmp0_ = music_app_get_player ();
#line 1124 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 1124 "../src/LibraryWindow.vala"
	_tmp2_ = music_playback_manager_get_current_media (_tmp1_);
#line 1124 "../src/LibraryWindow.vala"
	_tmp3_ = _tmp2_;
#line 1124 "../src/LibraryWindow.vala"
	if (_tmp3_ != NULL) {
#line 1125 "../src/LibraryWindow.vala"
		music_library_window_play_media (self, FALSE);
#line 8168 "LibraryWindow.c"
	}
}

void
music_library_window_error_occured (MusicLibraryWindow* self)
{
	MusicLibraryWindowClass* _klass_;
#line 1123 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1123 "../src/LibraryWindow.vala"
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
#line 1123 "../src/LibraryWindow.vala"
	if (_klass_->error_occured) {
#line 1123 "../src/LibraryWindow.vala"
		_klass_->error_occured (self);
#line 8184 "LibraryWindow.c"
	}
}

static void
music_library_window_real_current_position_update (MusicLibraryWindow* self,
                                                   gint64 position)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	gdouble sec = 0.0;
	gdouble media_length = 0.0;
	MusicPlaybackManager* _tmp4_;
	MusicPlaybackManager* _tmp5_;
	MusicMedia* _tmp6_;
	MusicMedia* _tmp7_;
	guint _tmp8_;
	guint _tmp9_;
	MusicPlaybackManager* _tmp10_;
	MusicPlaybackManager* _tmp11_;
	MusicStreamer* _tmp12_;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp55_ = FALSE;
	gboolean _tmp61_ = FALSE;
#line 1130 "../src/LibraryWindow.vala"
	_tmp0_ = music_app_get_player ();
#line 1130 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 1130 "../src/LibraryWindow.vala"
	_tmp2_ = music_playback_manager_get_current_media (_tmp1_);
#line 1130 "../src/LibraryWindow.vala"
	_tmp3_ = _tmp2_;
#line 1130 "../src/LibraryWindow.vala"
	if (_tmp3_ == NULL) {
#line 1131 "../src/LibraryWindow.vala"
		return;
#line 8223 "LibraryWindow.c"
	}
#line 1133 "../src/LibraryWindow.vala"
	sec = ((gdouble) position) / 1000000000;
#line 1134 "../src/LibraryWindow.vala"
	_tmp4_ = music_app_get_player ();
#line 1134 "../src/LibraryWindow.vala"
	_tmp5_ = _tmp4_;
#line 1134 "../src/LibraryWindow.vala"
	_tmp6_ = music_playback_manager_get_current_media (_tmp5_);
#line 1134 "../src/LibraryWindow.vala"
	_tmp7_ = _tmp6_;
#line 1134 "../src/LibraryWindow.vala"
	_tmp8_ = music_media_get_length (_tmp7_);
#line 1134 "../src/LibraryWindow.vala"
	_tmp9_ = _tmp8_;
#line 1134 "../src/LibraryWindow.vala"
	media_length = ((gdouble) _tmp9_) / 1000;
#line 1136 "../src/LibraryWindow.vala"
	_tmp10_ = music_app_get_player ();
#line 1136 "../src/LibraryWindow.vala"
	_tmp11_ = _tmp10_;
#line 1136 "../src/LibraryWindow.vala"
	_tmp12_ = _tmp11_->file_player;
#line 1136 "../src/LibraryWindow.vala"
	if (_tmp12_->set_resume_pos) {
#line 8249 "LibraryWindow.c"
		MusicPlaybackManager* _tmp13_;
		MusicPlaybackManager* _tmp14_;
		MusicMedia* _tmp15_;
		MusicMedia* _tmp16_;
#line 1137 "../src/LibraryWindow.vala"
		_tmp13_ = music_app_get_player ();
#line 1137 "../src/LibraryWindow.vala"
		_tmp14_ = _tmp13_;
#line 1137 "../src/LibraryWindow.vala"
		_tmp15_ = music_playback_manager_get_current_media (_tmp14_);
#line 1137 "../src/LibraryWindow.vala"
		_tmp16_ = _tmp15_;
#line 1137 "../src/LibraryWindow.vala"
		music_media_set_resume_pos (_tmp16_, (gint) sec);
#line 8264 "LibraryWindow.c"
	}
#line 1140 "../src/LibraryWindow.vala"
	if (sec > ((gdouble) 3)) {
#line 8268 "LibraryWindow.c"
		gboolean _tmp18_;
#line 1140 "../src/LibraryWindow.vala"
		_tmp18_ = self->priv->_media_considered_previewed;
#line 1140 "../src/LibraryWindow.vala"
		_tmp17_ = !_tmp18_;
#line 8274 "LibraryWindow.c"
	} else {
#line 1140 "../src/LibraryWindow.vala"
		_tmp17_ = FALSE;
#line 8278 "LibraryWindow.c"
	}
#line 1140 "../src/LibraryWindow.vala"
	if (_tmp17_) {
#line 8282 "LibraryWindow.c"
		MusicPlaybackManager* _tmp19_;
		MusicPlaybackManager* _tmp20_;
		MusicMedia* _tmp21_;
		MusicMedia* _tmp22_;
#line 1141 "../src/LibraryWindow.vala"
		music_library_window_set_media_considered_previewed (self, TRUE);
#line 1142 "../src/LibraryWindow.vala"
		_tmp19_ = music_app_get_player ();
#line 1142 "../src/LibraryWindow.vala"
		_tmp20_ = _tmp19_;
#line 1142 "../src/LibraryWindow.vala"
		_tmp21_ = music_playback_manager_get_current_media (_tmp20_);
#line 1142 "../src/LibraryWindow.vala"
		_tmp22_ = _tmp21_;
#line 1142 "../src/LibraryWindow.vala"
		g_signal_emit_by_name ((MusicLibraryWindowInterface*) self, "update-media-info", _tmp22_);
#line 8299 "LibraryWindow.c"
	}
#line 1146 "../src/LibraryWindow.vala"
	if (sec > ((gdouble) 30)) {
#line 8303 "LibraryWindow.c"
		gboolean _tmp24_;
#line 1146 "../src/LibraryWindow.vala"
		_tmp24_ = self->priv->_media_considered_played;
#line 1146 "../src/LibraryWindow.vala"
		_tmp23_ = !_tmp24_;
#line 8309 "LibraryWindow.c"
	} else {
#line 1146 "../src/LibraryWindow.vala"
		_tmp23_ = FALSE;
#line 8313 "LibraryWindow.c"
	}
#line 1146 "../src/LibraryWindow.vala"
	if (_tmp23_) {
#line 8317 "LibraryWindow.c"
		MusicPlaybackManager* _tmp25_;
		MusicPlaybackManager* _tmp26_;
		MusicMedia* _tmp27_;
		MusicMedia* _tmp28_;
		time_t _tmp29_;
		MusicLocalLibrary* _tmp30_;
		MusicLocalLibrary* _tmp31_;
		MusicPlaybackManager* _tmp32_;
		MusicPlaybackManager* _tmp33_;
		MusicMedia* _tmp34_;
		MusicMedia* _tmp35_;
		MusicPlaybackManager* _tmp36_;
		MusicPlaybackManager* _tmp37_;
		MusicHistoryPlaylist* _tmp38_;
		GeeArrayList* _tmp39_;
		GeeArrayList* _tmp40_;
		MusicPlaybackManager* _tmp41_;
		MusicPlaybackManager* _tmp42_;
		MusicMedia* _tmp43_;
		MusicMedia* _tmp44_;
#line 1147 "../src/LibraryWindow.vala"
		music_library_window_set_media_considered_played (self, TRUE);
#line 1148 "../src/LibraryWindow.vala"
		_tmp25_ = music_app_get_player ();
#line 1148 "../src/LibraryWindow.vala"
		_tmp26_ = _tmp25_;
#line 1148 "../src/LibraryWindow.vala"
		_tmp27_ = music_playback_manager_get_current_media (_tmp26_);
#line 1148 "../src/LibraryWindow.vala"
		_tmp28_ = _tmp27_;
#line 1148 "../src/LibraryWindow.vala"
		_tmp29_ = time (NULL);
#line 1148 "../src/LibraryWindow.vala"
		music_media_set_last_played (_tmp28_, (guint) ((gint) _tmp29_));
#line 1150 "../src/LibraryWindow.vala"
		_tmp30_ = music_library_window_get_library_manager (self);
#line 1150 "../src/LibraryWindow.vala"
		_tmp31_ = _tmp30_;
#line 1150 "../src/LibraryWindow.vala"
		_tmp32_ = music_app_get_player ();
#line 1150 "../src/LibraryWindow.vala"
		_tmp33_ = _tmp32_;
#line 1150 "../src/LibraryWindow.vala"
		_tmp34_ = music_playback_manager_get_current_media (_tmp33_);
#line 1150 "../src/LibraryWindow.vala"
		_tmp35_ = _tmp34_;
#line 1150 "../src/LibraryWindow.vala"
		music_library_update_media ((MusicLibrary*) _tmp31_, _tmp35_, FALSE, FALSE);
#line 1153 "../src/LibraryWindow.vala"
		_tmp36_ = music_app_get_player ();
#line 1153 "../src/LibraryWindow.vala"
		_tmp37_ = _tmp36_;
#line 1153 "../src/LibraryWindow.vala"
		_tmp38_ = _tmp37_->history_playlist;
#line 1153 "../src/LibraryWindow.vala"
		_tmp39_ = music_playlist_get_medias ((MusicPlaylist*) _tmp38_);
#line 1153 "../src/LibraryWindow.vala"
		_tmp40_ = _tmp39_;
#line 1153 "../src/LibraryWindow.vala"
		_tmp41_ = music_app_get_player ();
#line 1153 "../src/LibraryWindow.vala"
		_tmp42_ = _tmp41_;
#line 1153 "../src/LibraryWindow.vala"
		_tmp43_ = music_playback_manager_get_current_media (_tmp42_);
#line 1153 "../src/LibraryWindow.vala"
		_tmp44_ = _tmp43_;
#line 1153 "../src/LibraryWindow.vala"
		if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp40_, _tmp44_)) {
#line 8386 "LibraryWindow.c"
			GeeTreeSet* temp_media = NULL;
			GeeTreeSet* _tmp45_;
			GeeTreeSet* _tmp46_;
			MusicPlaybackManager* _tmp47_;
			MusicPlaybackManager* _tmp48_;
			MusicMedia* _tmp49_;
			MusicMedia* _tmp50_;
			MusicPlaybackManager* _tmp51_;
			MusicPlaybackManager* _tmp52_;
			MusicHistoryPlaylist* _tmp53_;
			GeeTreeSet* _tmp54_;
#line 1154 "../src/LibraryWindow.vala"
			_tmp45_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1154 "../src/LibraryWindow.vala"
			temp_media = _tmp45_;
#line 1155 "../src/LibraryWindow.vala"
			_tmp46_ = temp_media;
#line 1155 "../src/LibraryWindow.vala"
			_tmp47_ = music_app_get_player ();
#line 1155 "../src/LibraryWindow.vala"
			_tmp48_ = _tmp47_;
#line 1155 "../src/LibraryWindow.vala"
			_tmp49_ = music_playback_manager_get_current_media (_tmp48_);
#line 1155 "../src/LibraryWindow.vala"
			_tmp50_ = _tmp49_;
#line 1155 "../src/LibraryWindow.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp46_, _tmp50_);
#line 1156 "../src/LibraryWindow.vala"
			_tmp51_ = music_app_get_player ();
#line 1156 "../src/LibraryWindow.vala"
			_tmp52_ = _tmp51_;
#line 1156 "../src/LibraryWindow.vala"
			_tmp53_ = _tmp52_->history_playlist;
#line 1156 "../src/LibraryWindow.vala"
			_tmp54_ = temp_media;
#line 1156 "../src/LibraryWindow.vala"
			music_playlist_add_medias ((MusicPlaylist*) _tmp53_, (GeeCollection*) _tmp54_);
#line 1153 "../src/LibraryWindow.vala"
			_g_object_unref0 (temp_media);
#line 8426 "LibraryWindow.c"
		}
	}
#line 1160 "../src/LibraryWindow.vala"
	if ((sec / media_length) > 0.50) {
#line 8431 "LibraryWindow.c"
		gboolean _tmp56_;
#line 1160 "../src/LibraryWindow.vala"
		_tmp56_ = self->priv->_media_half_played_sended;
#line 1160 "../src/LibraryWindow.vala"
		_tmp55_ = _tmp56_ == FALSE;
#line 8437 "LibraryWindow.c"
	} else {
#line 1160 "../src/LibraryWindow.vala"
		_tmp55_ = FALSE;
#line 8441 "LibraryWindow.c"
	}
#line 1160 "../src/LibraryWindow.vala"
	if (_tmp55_) {
#line 8445 "LibraryWindow.c"
		MusicPlaybackManager* _tmp57_;
		MusicPlaybackManager* _tmp58_;
		MusicMedia* _tmp59_;
		MusicMedia* _tmp60_;
#line 1161 "../src/LibraryWindow.vala"
		_tmp57_ = music_app_get_player ();
#line 1161 "../src/LibraryWindow.vala"
		_tmp58_ = _tmp57_;
#line 1161 "../src/LibraryWindow.vala"
		_tmp59_ = music_playback_manager_get_current_media (_tmp58_);
#line 1161 "../src/LibraryWindow.vala"
		_tmp60_ = _tmp59_;
#line 1161 "../src/LibraryWindow.vala"
		g_signal_emit_by_name ((MusicLibraryWindowInterface*) self, "media-half-played", _tmp60_);
#line 1162 "../src/LibraryWindow.vala"
		music_library_window_set_media_half_played_sended (self, TRUE);
#line 8462 "LibraryWindow.c"
	}
#line 1166 "../src/LibraryWindow.vala"
	if ((sec / media_length) > 0.80) {
#line 8466 "LibraryWindow.c"
		gboolean _tmp62_;
#line 1166 "../src/LibraryWindow.vala"
		_tmp62_ = self->priv->_added_to_play_count;
#line 1166 "../src/LibraryWindow.vala"
		_tmp61_ = !_tmp62_;
#line 8472 "LibraryWindow.c"
	} else {
#line 1166 "../src/LibraryWindow.vala"
		_tmp61_ = FALSE;
#line 8476 "LibraryWindow.c"
	}
#line 1166 "../src/LibraryWindow.vala"
	if (_tmp61_) {
#line 8480 "LibraryWindow.c"
		MusicPlaybackManager* _tmp63_;
		MusicPlaybackManager* _tmp64_;
		MusicMedia* _tmp65_;
		MusicMedia* _tmp66_;
		guint _tmp67_;
		guint _tmp68_;
		MusicLocalLibrary* _tmp69_;
		MusicLocalLibrary* _tmp70_;
		MusicPlaybackManager* _tmp71_;
		MusicPlaybackManager* _tmp72_;
		MusicMedia* _tmp73_;
		MusicMedia* _tmp74_;
#line 1167 "../src/LibraryWindow.vala"
		music_library_window_set_added_to_play_count (self, TRUE);
#line 1168 "../src/LibraryWindow.vala"
		_tmp63_ = music_app_get_player ();
#line 1168 "../src/LibraryWindow.vala"
		_tmp64_ = _tmp63_;
#line 1168 "../src/LibraryWindow.vala"
		_tmp65_ = music_playback_manager_get_current_media (_tmp64_);
#line 1168 "../src/LibraryWindow.vala"
		_tmp66_ = _tmp65_;
#line 1168 "../src/LibraryWindow.vala"
		_tmp67_ = music_media_get_play_count (_tmp66_);
#line 1168 "../src/LibraryWindow.vala"
		_tmp68_ = _tmp67_;
#line 1168 "../src/LibraryWindow.vala"
		music_media_set_play_count (_tmp66_, _tmp68_ + 1);
#line 1169 "../src/LibraryWindow.vala"
		_tmp69_ = music_library_window_get_library_manager (self);
#line 1169 "../src/LibraryWindow.vala"
		_tmp70_ = _tmp69_;
#line 1169 "../src/LibraryWindow.vala"
		_tmp71_ = music_app_get_player ();
#line 1169 "../src/LibraryWindow.vala"
		_tmp72_ = _tmp71_;
#line 1169 "../src/LibraryWindow.vala"
		_tmp73_ = music_playback_manager_get_current_media (_tmp72_);
#line 1169 "../src/LibraryWindow.vala"
		_tmp74_ = _tmp73_;
#line 1169 "../src/LibraryWindow.vala"
		music_library_update_media ((MusicLibrary*) _tmp70_, _tmp74_, FALSE, FALSE);
#line 8523 "LibraryWindow.c"
	}
}

void
music_library_window_current_position_update (MusicLibraryWindow* self,
                                              gint64 position)
{
	MusicLibraryWindowClass* _klass_;
#line 1129 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1129 "../src/LibraryWindow.vala"
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
#line 1129 "../src/LibraryWindow.vala"
	if (_klass_->current_position_update) {
#line 1129 "../src/LibraryWindow.vala"
		_klass_->current_position_update (self, position);
#line 8540 "LibraryWindow.c"
	}
}

static void
music_library_window_search_entry_activate (MusicLibraryWindow* self)
{
	GtkWidget* vw = NULL;
	MusicViewStack* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GtkWidget* _tmp5_;
#line 1173 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1174 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->_view_stack;
#line 1174 "../src/LibraryWindow.vala"
	_tmp1_ = gtk_stack_get_visible_child ((GtkStack*) _tmp0_);
#line 1174 "../src/LibraryWindow.vala"
	_tmp2_ = _tmp1_;
#line 1174 "../src/LibraryWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 1174 "../src/LibraryWindow.vala"
	vw = _tmp3_;
#line 1176 "../src/LibraryWindow.vala"
	_tmp5_ = vw;
#line 1176 "../src/LibraryWindow.vala"
	if (_tmp5_ != NULL) {
#line 8570 "LibraryWindow.c"
		GtkWidget* _tmp6_;
#line 1176 "../src/LibraryWindow.vala"
		_tmp6_ = vw;
#line 1176 "../src/LibraryWindow.vala"
		_tmp4_ = MUSIC_IS_VIEW_WRAPPER (_tmp6_);
#line 8576 "LibraryWindow.c"
	} else {
#line 1176 "../src/LibraryWindow.vala"
		_tmp4_ = FALSE;
#line 8580 "LibraryWindow.c"
	}
#line 1176 "../src/LibraryWindow.vala"
	if (_tmp4_) {
#line 8584 "LibraryWindow.c"
		GtkWidget* _tmp7_;
		gboolean _tmp8_;
#line 1177 "../src/LibraryWindow.vala"
		_tmp7_ = vw;
#line 1177 "../src/LibraryWindow.vala"
		_tmp8_ = FALSE;
#line 1177 "../src/LibraryWindow.vala"
		music_view_wrapper_play_first_media (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper), &_tmp8_);
#line 8593 "LibraryWindow.c"
	}
#line 1173 "../src/LibraryWindow.vala"
	_g_object_unref0 (vw);
#line 8597 "LibraryWindow.c"
}

static void
music_library_window_real_drag_received (MusicLibraryWindow* self,
                                         GdkDragContext* context,
                                         gint x,
                                         gint y,
                                         GtkSelectionData* data,
                                         guint info,
                                         guint timestamp)
{
	GeeTreeSet* files_dragged = NULL;
	GeeTreeSet* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	MusicLocalLibrary* _tmp10_;
	MusicLocalLibrary* _tmp11_;
	GeeTreeSet* _tmp12_;
#line 1181 "../src/LibraryWindow.vala"
	g_return_if_fail (context != NULL);
#line 1181 "../src/LibraryWindow.vala"
	g_return_if_fail (data != NULL);
#line 1182 "../src/LibraryWindow.vala"
	_tmp0_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 1182 "../src/LibraryWindow.vala"
	files_dragged = _tmp0_;
#line 1184 "../src/LibraryWindow.vala"
	g_debug ("LibraryWindow.vala:1184: dragged\n");
#line 1186 "../src/LibraryWindow.vala"
	_tmp2_ = _tmp1_ = gtk_selection_data_get_uris (data);
#line 8628 "LibraryWindow.c"
	{
		gchar** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
#line 1186 "../src/LibraryWindow.vala"
		uri_collection = _tmp2_;
#line 1186 "../src/LibraryWindow.vala"
		uri_collection_length1 = _vala_array_length (_tmp1_);
#line 1186 "../src/LibraryWindow.vala"
		for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
#line 8640 "LibraryWindow.c"
			gchar* _tmp3_;
			gchar* uri = NULL;
#line 1186 "../src/LibraryWindow.vala"
			_tmp3_ = g_strdup (uri_collection[uri_it]);
#line 1186 "../src/LibraryWindow.vala"
			uri = _tmp3_;
#line 8647 "LibraryWindow.c"
			{
				GeeTreeSet* _tmp4_;
				const gchar* _tmp5_;
				GFile* _tmp6_;
				GFile* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 1187 "../src/LibraryWindow.vala"
				_tmp4_ = files_dragged;
#line 1187 "../src/LibraryWindow.vala"
				_tmp5_ = uri;
#line 1187 "../src/LibraryWindow.vala"
				_tmp6_ = g_file_new_for_uri (_tmp5_);
#line 1187 "../src/LibraryWindow.vala"
				_tmp7_ = _tmp6_;
#line 1187 "../src/LibraryWindow.vala"
				_tmp8_ = g_file_get_path (_tmp7_);
#line 1187 "../src/LibraryWindow.vala"
				_tmp9_ = _tmp8_;
#line 1187 "../src/LibraryWindow.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, _tmp9_);
#line 1187 "../src/LibraryWindow.vala"
				_g_free0 (_tmp9_);
#line 1187 "../src/LibraryWindow.vala"
				_g_object_unref0 (_tmp7_);
#line 1186 "../src/LibraryWindow.vala"
				_g_free0 (uri);
#line 8675 "LibraryWindow.c"
			}
		}
#line 1186 "../src/LibraryWindow.vala"
		uri_collection = (_vala_array_free (uri_collection, uri_collection_length1, (GDestroyNotify) g_free), NULL);
#line 8680 "LibraryWindow.c"
	}
#line 1190 "../src/LibraryWindow.vala"
	_tmp10_ = music_library_window_get_library_manager (self);
#line 1190 "../src/LibraryWindow.vala"
	_tmp11_ = _tmp10_;
#line 1190 "../src/LibraryWindow.vala"
	_tmp12_ = files_dragged;
#line 1190 "../src/LibraryWindow.vala"
	music_library_add_files_to_library ((MusicLibrary*) _tmp11_, (GeeCollection*) _tmp12_);
#line 1181 "../src/LibraryWindow.vala"
	_g_object_unref0 (files_dragged);
#line 8692 "LibraryWindow.c"
}

void
music_library_window_drag_received (MusicLibraryWindow* self,
                                    GdkDragContext* context,
                                    gint x,
                                    gint y,
                                    GtkSelectionData* data,
                                    guint info,
                                    guint timestamp)
{
	MusicLibraryWindowClass* _klass_;
#line 1181 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1181 "../src/LibraryWindow.vala"
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
#line 1181 "../src/LibraryWindow.vala"
	if (_klass_->drag_received) {
#line 1181 "../src/LibraryWindow.vala"
		_klass_->drag_received (self, context, x, y, data, info, timestamp);
#line 8713 "LibraryWindow.c"
	}
}

static void
music_library_window_show_alert (MusicLibraryWindow* self,
                                 const gchar* title,
                                 const gchar* message)
{
	GraniteMessageDialog* dialog = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
	GraniteMessageDialog* _tmp2_;
	GraniteMessageDialog* _tmp3_;
#line 1193 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1193 "../src/LibraryWindow.vala"
	g_return_if_fail (title != NULL);
#line 1193 "../src/LibraryWindow.vala"
	g_return_if_fail (message != NULL);
#line 1194 "../src/LibraryWindow.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("dialog-warning");
#line 1194 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 1194 "../src/LibraryWindow.vala"
	_tmp2_ = granite_message_dialog_new (title, message, (GIcon*) _tmp1_, GTK_BUTTONS_CLOSE);
#line 1194 "../src/LibraryWindow.vala"
	g_object_ref_sink (_tmp2_);
#line 1194 "../src/LibraryWindow.vala"
	_tmp3_ = _tmp2_;
#line 1194 "../src/LibraryWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 1194 "../src/LibraryWindow.vala"
	dialog = _tmp3_;
#line 1200 "../src/LibraryWindow.vala"
	gtk_window_set_transient_for ((GtkWindow*) dialog, (GtkWindow*) self);
#line 1202 "../src/LibraryWindow.vala"
	gtk_dialog_run ((GtkDialog*) dialog);
#line 1203 "../src/LibraryWindow.vala"
	gtk_widget_destroy ((GtkWidget*) dialog);
#line 1193 "../src/LibraryWindow.vala"
	_g_object_unref0 (dialog);
#line 8755 "LibraryWindow.c"
}

static void
music_library_window_on_quit (MusicLibraryWindow* self)
{
	MusicSettingsMain* _tmp0_;
	MusicPlaybackManager* _tmp28_;
	MusicPlaybackManager* _tmp29_;
	MusicPlayback* _tmp30_;
	GSettings* _tmp31_;
	GSettings* _tmp32_;
	MusicWidgetsViewSelector* _tmp33_;
	MusicWidgetsViewSelectorMode _tmp34_;
	MusicWidgetsViewSelectorMode _tmp35_;
#line 1206 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 1207 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->main_settings;
#line 1207 "../src/LibraryWindow.vala"
	if (!music_settings_main_privacy_mode_enabled (_tmp0_)) {
#line 8776 "LibraryWindow.c"
		GSettings* _tmp1_;
		GSettings* _tmp2_;
		MusicPlaybackManager* _tmp3_;
		MusicPlaybackManager* _tmp4_;
		MusicPlayback* _tmp5_;
		MusicPlaybackManager* _tmp6_;
		MusicPlaybackManager* _tmp7_;
		MusicMedia* _tmp8_;
		MusicMedia* _tmp9_;
		GSettings* _tmp23_;
		GSettings* _tmp24_;
		GtkSearchEntry* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
#line 1209 "../src/LibraryWindow.vala"
		_tmp1_ = music_app_get_saved_state ();
#line 1209 "../src/LibraryWindow.vala"
		_tmp2_ = _tmp1_;
#line 1209 "../src/LibraryWindow.vala"
		_tmp3_ = music_app_get_player ();
#line 1209 "../src/LibraryWindow.vala"
		_tmp4_ = _tmp3_;
#line 1209 "../src/LibraryWindow.vala"
		_tmp5_ = _tmp4_->player;
#line 1209 "../src/LibraryWindow.vala"
		g_settings_set_int (_tmp2_, "last-media-position", (gint) (((gdouble) music_playback_get_position (_tmp5_)) / MUSIC_TIME_UTILS_NANO_INV));
#line 1210 "../src/LibraryWindow.vala"
		_tmp6_ = music_app_get_player ();
#line 1210 "../src/LibraryWindow.vala"
		_tmp7_ = _tmp6_;
#line 1210 "../src/LibraryWindow.vala"
		_tmp8_ = music_playback_manager_get_current_media (_tmp7_);
#line 1210 "../src/LibraryWindow.vala"
		_tmp9_ = _tmp8_;
#line 1210 "../src/LibraryWindow.vala"
		if (_tmp9_ != NULL) {
#line 8813 "LibraryWindow.c"
			MusicPlaybackManager* _tmp10_;
			MusicPlaybackManager* _tmp11_;
			MusicMedia* _tmp12_;
			MusicMedia* _tmp13_;
			MusicPlaybackManager* _tmp14_;
			MusicPlaybackManager* _tmp15_;
			MusicPlayback* _tmp16_;
			MusicLocalLibrary* _tmp17_;
			MusicLocalLibrary* _tmp18_;
			MusicPlaybackManager* _tmp19_;
			MusicPlaybackManager* _tmp20_;
			MusicMedia* _tmp21_;
			MusicMedia* _tmp22_;
#line 1211 "../src/LibraryWindow.vala"
			_tmp10_ = music_app_get_player ();
#line 1211 "../src/LibraryWindow.vala"
			_tmp11_ = _tmp10_;
#line 1211 "../src/LibraryWindow.vala"
			_tmp12_ = music_playback_manager_get_current_media (_tmp11_);
#line 1211 "../src/LibraryWindow.vala"
			_tmp13_ = _tmp12_;
#line 1211 "../src/LibraryWindow.vala"
			_tmp14_ = music_app_get_player ();
#line 1211 "../src/LibraryWindow.vala"
			_tmp15_ = _tmp14_;
#line 1211 "../src/LibraryWindow.vala"
			_tmp16_ = _tmp15_->player;
#line 1211 "../src/LibraryWindow.vala"
			music_media_set_resume_pos (_tmp13_, (gint) (((gdouble) music_playback_get_position (_tmp16_)) / MUSIC_TIME_UTILS_NANO_INV));
#line 1212 "../src/LibraryWindow.vala"
			_tmp17_ = music_library_window_get_library_manager (self);
#line 1212 "../src/LibraryWindow.vala"
			_tmp18_ = _tmp17_;
#line 1212 "../src/LibraryWindow.vala"
			_tmp19_ = music_app_get_player ();
#line 1212 "../src/LibraryWindow.vala"
			_tmp20_ = _tmp19_;
#line 1212 "../src/LibraryWindow.vala"
			_tmp21_ = music_playback_manager_get_current_media (_tmp20_);
#line 1212 "../src/LibraryWindow.vala"
			_tmp22_ = _tmp21_;
#line 1212 "../src/LibraryWindow.vala"
			music_library_update_media ((MusicLibrary*) _tmp18_, _tmp22_, FALSE, FALSE);
#line 8857 "LibraryWindow.c"
		}
#line 1215 "../src/LibraryWindow.vala"
		_tmp23_ = music_app_get_saved_state ();
#line 1215 "../src/LibraryWindow.vala"
		_tmp24_ = _tmp23_;
#line 1215 "../src/LibraryWindow.vala"
		_tmp25_ = self->priv->_search_entry;
#line 1215 "../src/LibraryWindow.vala"
		_tmp26_ = gtk_entry_get_text ((GtkEntry*) _tmp25_);
#line 1215 "../src/LibraryWindow.vala"
		_tmp27_ = _tmp26_;
#line 1215 "../src/LibraryWindow.vala"
		g_settings_set_string (_tmp24_, "search-string", _tmp27_);
#line 8871 "LibraryWindow.c"
	}
#line 1217 "../src/LibraryWindow.vala"
	_tmp28_ = music_app_get_player ();
#line 1217 "../src/LibraryWindow.vala"
	_tmp29_ = _tmp28_;
#line 1217 "../src/LibraryWindow.vala"
	_tmp30_ = _tmp29_->player;
#line 1217 "../src/LibraryWindow.vala"
	music_playback_pause (_tmp30_);
#line 1219 "../src/LibraryWindow.vala"
	_tmp31_ = music_app_get_saved_state ();
#line 1219 "../src/LibraryWindow.vala"
	_tmp32_ = _tmp31_;
#line 1219 "../src/LibraryWindow.vala"
	_tmp33_ = self->priv->_view_selector;
#line 1219 "../src/LibraryWindow.vala"
	_tmp34_ = music_widgets_view_selector_get_selected (_tmp33_);
#line 1219 "../src/LibraryWindow.vala"
	_tmp35_ = _tmp34_;
#line 1219 "../src/LibraryWindow.vala"
	g_settings_set_int (_tmp32_, "view-mode", (gint) _tmp35_);
#line 8893 "LibraryWindow.c"
}

/**
     * Called when the user tries to quit the application using a mechanism provided
     * by the desktop shell (close button, quicklists, etc.)
     *
     * This doesn't apply to calls to App.instance.quit ()
     */
static gboolean
music_library_window_real_delete_event (GtkWidget* base,
                                        GdkEventAny* event)
{
	MusicLibraryWindow * self;
	gboolean _tmp0_ = FALSE;
	MusicPlaybackManager* _tmp1_;
	MusicPlaybackManager* _tmp2_;
	MusicMedia* _tmp3_;
	MusicMedia* _tmp4_;
	gboolean playing = FALSE;
	gboolean _tmp9_ = FALSE;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	gboolean result;
#line 1228 "../src/LibraryWindow.vala"
	self = (MusicLibraryWindow*) base;
#line 1228 "../src/LibraryWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1229 "../src/LibraryWindow.vala"
	_tmp1_ = music_app_get_player ();
#line 1229 "../src/LibraryWindow.vala"
	_tmp2_ = _tmp1_;
#line 1229 "../src/LibraryWindow.vala"
	_tmp3_ = music_playback_manager_get_current_media (_tmp2_);
#line 1229 "../src/LibraryWindow.vala"
	_tmp4_ = _tmp3_;
#line 1229 "../src/LibraryWindow.vala"
	if (_tmp4_ != NULL) {
#line 8931 "LibraryWindow.c"
		MusicPlaybackManager* _tmp5_;
		MusicPlaybackManager* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 1229 "../src/LibraryWindow.vala"
		_tmp5_ = music_app_get_player ();
#line 1229 "../src/LibraryWindow.vala"
		_tmp6_ = _tmp5_;
#line 1229 "../src/LibraryWindow.vala"
		_tmp7_ = music_playback_manager_get_playing (_tmp6_);
#line 1229 "../src/LibraryWindow.vala"
		_tmp8_ = _tmp7_;
#line 1229 "../src/LibraryWindow.vala"
		_tmp0_ = _tmp8_;
#line 8946 "LibraryWindow.c"
	} else {
#line 1229 "../src/LibraryWindow.vala"
		_tmp0_ = FALSE;
#line 8950 "LibraryWindow.c"
	}
#line 1229 "../src/LibraryWindow.vala"
	playing = _tmp0_;
#line 1232 "../src/LibraryWindow.vala"
	_tmp10_ = music_app_get_settings ();
#line 1232 "../src/LibraryWindow.vala"
	_tmp11_ = _tmp10_;
#line 1232 "../src/LibraryWindow.vala"
	if (!g_settings_get_boolean (_tmp11_, "close-while-playing")) {
#line 1232 "../src/LibraryWindow.vala"
		_tmp9_ = playing;
#line 8962 "LibraryWindow.c"
	} else {
#line 1232 "../src/LibraryWindow.vala"
		_tmp9_ = FALSE;
#line 8966 "LibraryWindow.c"
	}
#line 1232 "../src/LibraryWindow.vala"
	if (_tmp9_) {
#line 1233 "../src/LibraryWindow.vala"
		gtk_widget_hide ((GtkWidget*) self);
#line 1235 "../src/LibraryWindow.vala"
		result = TRUE;
#line 1235 "../src/LibraryWindow.vala"
		return result;
#line 8976 "LibraryWindow.c"
	}
#line 1238 "../src/LibraryWindow.vala"
	result = FALSE;
#line 1238 "../src/LibraryWindow.vala"
	return result;
#line 8982 "LibraryWindow.c"
}

static gboolean
___lambda167_ (MusicLibraryWindow* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean result;
#line 1245 "../src/LibraryWindow.vala"
	self->priv->configure_id = (guint) 0;
#line 1247 "../src/LibraryWindow.vala"
	_tmp0_ = music_app_get_saved_state ();
#line 1247 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 1247 "../src/LibraryWindow.vala"
	g_object_get ((GtkWindow*) self, "is-maximized", &_tmp2_, NULL);
#line 1247 "../src/LibraryWindow.vala"
	_tmp3_ = _tmp2_;
#line 1247 "../src/LibraryWindow.vala"
	g_settings_set_boolean (_tmp1_, "window-maximized", _tmp3_);
#line 1249 "../src/LibraryWindow.vala"
	g_object_get ((GtkWindow*) self, "is-maximized", &_tmp4_, NULL);
#line 1249 "../src/LibraryWindow.vala"
	_tmp5_ = _tmp4_;
#line 1249 "../src/LibraryWindow.vala"
	if (!_tmp5_) {
#line 9013 "LibraryWindow.c"
		gint width = 0;
		gint height = 0;
		gint root_x = 0;
		gint root_y = 0;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		GSettings* _tmp10_;
		GSettings* _tmp11_;
		GSettings* _tmp12_;
		GSettings* _tmp13_;
#line 1251 "../src/LibraryWindow.vala"
		gtk_window_get_position ((GtkWindow*) self, &_tmp6_, &_tmp7_);
#line 1251 "../src/LibraryWindow.vala"
		root_x = _tmp6_;
#line 1251 "../src/LibraryWindow.vala"
		root_y = _tmp7_;
#line 1252 "../src/LibraryWindow.vala"
		gtk_window_get_size ((GtkWindow*) self, &_tmp8_, &_tmp9_);
#line 1252 "../src/LibraryWindow.vala"
		width = _tmp8_;
#line 1252 "../src/LibraryWindow.vala"
		height = _tmp9_;
#line 1254 "../src/LibraryWindow.vala"
		_tmp10_ = music_app_get_saved_state ();
#line 1254 "../src/LibraryWindow.vala"
		_tmp11_ = _tmp10_;
#line 1254 "../src/LibraryWindow.vala"
		g_settings_set (_tmp11_, "window-position", "(ii)", root_x, root_y);
#line 1255 "../src/LibraryWindow.vala"
		_tmp12_ = music_app_get_saved_state ();
#line 1255 "../src/LibraryWindow.vala"
		_tmp13_ = _tmp12_;
#line 1255 "../src/LibraryWindow.vala"
		g_settings_set (_tmp13_, "window-size", "(ii)", width, height);
#line 9050 "LibraryWindow.c"
	}
#line 1258 "../src/LibraryWindow.vala"
	result = G_SOURCE_REMOVE;
#line 1258 "../src/LibraryWindow.vala"
	return result;
#line 9056 "LibraryWindow.c"
}

static gboolean
____lambda167__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda167_ ((MusicLibraryWindow*) self);
#line 1244 "../src/LibraryWindow.vala"
	return result;
#line 9066 "LibraryWindow.c"
}

static gboolean
music_library_window_real_configure_event (GtkWidget* base,
                                           GdkEventConfigure* event)
{
	MusicLibraryWindow * self;
	gboolean result;
#line 1241 "../src/LibraryWindow.vala"
	self = (MusicLibraryWindow*) base;
#line 1241 "../src/LibraryWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1242 "../src/LibraryWindow.vala"
	if (self->priv->configure_id == ((guint) 0)) {
#line 1244 "../src/LibraryWindow.vala"
		self->priv->configure_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, ____lambda167__gsource_func, g_object_ref (self), g_object_unref);
#line 9083 "LibraryWindow.c"
	}
#line 1262 "../src/LibraryWindow.vala"
	result = GTK_WIDGET_CLASS (music_library_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), event);
#line 1262 "../src/LibraryWindow.vala"
	return result;
#line 9089 "LibraryWindow.c"
}

gboolean
music_library_window_get_initialization_finished (MusicLibraryWindow* self)
{
	gboolean result;
#line 33 "../src/LibraryWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "../src/LibraryWindow.vala"
	result = self->priv->_initialization_finished;
#line 33 "../src/LibraryWindow.vala"
	return result;
#line 9102 "LibraryWindow.c"
}

static void
music_library_window_set_initialization_finished (MusicLibraryWindow* self,
                                                  gboolean value)
{
	gboolean old_value;
#line 33 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/LibraryWindow.vala"
	old_value = music_library_window_get_initialization_finished (self);
#line 33 "../src/LibraryWindow.vala"
	if (old_value != value) {
#line 33 "../src/LibraryWindow.vala"
		self->priv->_initialization_finished = value;
#line 33 "../src/LibraryWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, music_library_window_properties[MUSIC_LIBRARY_WINDOW_INITIALIZATION_FINISHED_PROPERTY]);
#line 9120 "LibraryWindow.c"
	}
}

gboolean
music_library_window_get_newly_created_playlist (MusicLibraryWindow* self)
{
	gboolean result;
#line 34 "../src/LibraryWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "../src/LibraryWindow.vala"
	result = self->priv->_newly_created_playlist;
#line 34 "../src/LibraryWindow.vala"
	return result;
#line 9134 "LibraryWindow.c"
}

void
music_library_window_set_newly_created_playlist (MusicLibraryWindow* self,
                                                 gboolean value)
{
	gboolean old_value;
#line 34 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/LibraryWindow.vala"
	old_value = music_library_window_get_newly_created_playlist (self);
#line 34 "../src/LibraryWindow.vala"
	if (old_value != value) {
#line 34 "../src/LibraryWindow.vala"
		self->priv->_newly_created_playlist = value;
#line 34 "../src/LibraryWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, music_library_window_properties[MUSIC_LIBRARY_WINDOW_NEWLY_CREATED_PLAYLIST_PROPERTY]);
#line 9152 "LibraryWindow.c"
	}
}

MusicSourceListView*
music_library_window_get_source_list_view (MusicLibraryWindow* self)
{
	MusicSourceListView* result;
	MusicSourceListView* _tmp0_;
#line 36 "../src/LibraryWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->_source_list_view;
#line 36 "../src/LibraryWindow.vala"
	result = _tmp0_;
#line 36 "../src/LibraryWindow.vala"
	return result;
#line 9169 "LibraryWindow.c"
}

static void
music_library_window_set_source_list_view (MusicLibraryWindow* self,
                                           MusicSourceListView* value)
{
	MusicSourceListView* old_value;
#line 36 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/LibraryWindow.vala"
	old_value = music_library_window_get_source_list_view (self);
#line 36 "../src/LibraryWindow.vala"
	if (old_value != value) {
#line 9183 "LibraryWindow.c"
		MusicSourceListView* _tmp0_;
#line 36 "../src/LibraryWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 36 "../src/LibraryWindow.vala"
		_g_object_unref0 (self->priv->_source_list_view);
#line 36 "../src/LibraryWindow.vala"
		self->priv->_source_list_view = _tmp0_;
#line 36 "../src/LibraryWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, music_library_window_properties[MUSIC_LIBRARY_WINDOW_SOURCE_LIST_VIEW_PROPERTY]);
#line 9193 "LibraryWindow.c"
	}
}

MusicViewStack*
music_library_window_get_view_stack (MusicLibraryWindow* self)
{
	MusicViewStack* result;
	MusicViewStack* _tmp0_;
#line 37 "../src/LibraryWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->_view_stack;
#line 37 "../src/LibraryWindow.vala"
	result = _tmp0_;
#line 37 "../src/LibraryWindow.vala"
	return result;
#line 9210 "LibraryWindow.c"
}

static void
music_library_window_set_view_stack (MusicLibraryWindow* self,
                                     MusicViewStack* value)
{
	MusicViewStack* old_value;
#line 37 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/LibraryWindow.vala"
	old_value = music_library_window_get_view_stack (self);
#line 37 "../src/LibraryWindow.vala"
	if (old_value != value) {
#line 9224 "LibraryWindow.c"
		MusicViewStack* _tmp0_;
#line 37 "../src/LibraryWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 37 "../src/LibraryWindow.vala"
		_g_object_unref0 (self->priv->_view_stack);
#line 37 "../src/LibraryWindow.vala"
		self->priv->_view_stack = _tmp0_;
#line 37 "../src/LibraryWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, music_library_window_properties[MUSIC_LIBRARY_WINDOW_VIEW_STACK_PROPERTY]);
#line 9234 "LibraryWindow.c"
	}
}

MusicWidgetsViewSelector*
music_library_window_get_view_selector (MusicLibraryWindow* self)
{
	MusicWidgetsViewSelector* result;
	MusicWidgetsViewSelector* _tmp0_;
#line 38 "../src/LibraryWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->_view_selector;
#line 38 "../src/LibraryWindow.vala"
	result = _tmp0_;
#line 38 "../src/LibraryWindow.vala"
	return result;
#line 9251 "LibraryWindow.c"
}

static void
music_library_window_set_view_selector (MusicLibraryWindow* self,
                                        MusicWidgetsViewSelector* value)
{
	MusicWidgetsViewSelector* old_value;
#line 38 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/LibraryWindow.vala"
	old_value = music_library_window_get_view_selector (self);
#line 38 "../src/LibraryWindow.vala"
	if (old_value != value) {
#line 9265 "LibraryWindow.c"
		MusicWidgetsViewSelector* _tmp0_;
#line 38 "../src/LibraryWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 38 "../src/LibraryWindow.vala"
		_g_object_unref0 (self->priv->_view_selector);
#line 38 "../src/LibraryWindow.vala"
		self->priv->_view_selector = _tmp0_;
#line 38 "../src/LibraryWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, music_library_window_properties[MUSIC_LIBRARY_WINDOW_VIEW_SELECTOR_PROPERTY]);
#line 9275 "LibraryWindow.c"
	}
}

GtkSearchEntry*
music_library_window_get_search_entry (MusicLibraryWindow* self)
{
	GtkSearchEntry* result;
	GtkSearchEntry* _tmp0_;
#line 39 "../src/LibraryWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->_search_entry;
#line 39 "../src/LibraryWindow.vala"
	result = _tmp0_;
#line 39 "../src/LibraryWindow.vala"
	return result;
#line 9292 "LibraryWindow.c"
}

static void
music_library_window_set_search_entry (MusicLibraryWindow* self,
                                       GtkSearchEntry* value)
{
	GtkSearchEntry* old_value;
#line 39 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/LibraryWindow.vala"
	old_value = music_library_window_get_search_entry (self);
#line 39 "../src/LibraryWindow.vala"
	if (old_value != value) {
#line 9306 "LibraryWindow.c"
		GtkSearchEntry* _tmp0_;
#line 39 "../src/LibraryWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 39 "../src/LibraryWindow.vala"
		_g_object_unref0 (self->priv->_search_entry);
#line 39 "../src/LibraryWindow.vala"
		self->priv->_search_entry = _tmp0_;
#line 39 "../src/LibraryWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, music_library_window_properties[MUSIC_LIBRARY_WINDOW_SEARCH_ENTRY_PROPERTY]);
#line 9316 "LibraryWindow.c"
	}
}

MusicWidgetsStatusBar*
music_library_window_get_statusbar (MusicLibraryWindow* self)
{
	MusicWidgetsStatusBar* result;
	MusicWidgetsStatusBar* _tmp0_;
#line 40 "../src/LibraryWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../src/LibraryWindow.vala"
	_tmp0_ = self->priv->_statusbar;
#line 40 "../src/LibraryWindow.vala"
	result = _tmp0_;
#line 40 "../src/LibraryWindow.vala"
	return result;
#line 9333 "LibraryWindow.c"
}

static void
music_library_window_set_statusbar (MusicLibraryWindow* self,
                                    MusicWidgetsStatusBar* value)
{
	MusicWidgetsStatusBar* old_value;
#line 40 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/LibraryWindow.vala"
	old_value = music_library_window_get_statusbar (self);
#line 40 "../src/LibraryWindow.vala"
	if (old_value != value) {
#line 9347 "LibraryWindow.c"
		MusicWidgetsStatusBar* _tmp0_;
#line 40 "../src/LibraryWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 40 "../src/LibraryWindow.vala"
		_g_object_unref0 (self->priv->_statusbar);
#line 40 "../src/LibraryWindow.vala"
		self->priv->_statusbar = _tmp0_;
#line 40 "../src/LibraryWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, music_library_window_properties[MUSIC_LIBRARY_WINDOW_STATUSBAR_PROPERTY]);
#line 9357 "LibraryWindow.c"
	}
}

MusicLocalLibrary*
music_library_window_get_library_manager (MusicLibraryWindow* self)
{
	MusicLocalLibrary* result;
	MusicLibrariesManager* _tmp0_;
	MusicLibrary* _tmp1_;
#line 41 "../src/LibraryWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/LibraryWindow.vala"
	_tmp0_ = music_libraries_manager;
#line 41 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_->local_library;
#line 41 "../src/LibraryWindow.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibrary);
#line 41 "../src/LibraryWindow.vala"
	return result;
#line 9377 "LibraryWindow.c"
}

static gboolean
music_library_window_get_media_considered_played (MusicLibraryWindow* self)
{
	gboolean result;
#line 43 "../src/LibraryWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "../src/LibraryWindow.vala"
	result = self->priv->_media_considered_played;
#line 43 "../src/LibraryWindow.vala"
	return result;
#line 9390 "LibraryWindow.c"
}

static void
music_library_window_set_media_considered_played (MusicLibraryWindow* self,
                                                  gboolean value)
{
#line 43 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/LibraryWindow.vala"
	self->priv->_media_considered_played = value;
#line 9401 "LibraryWindow.c"
}

static gboolean
music_library_window_get_added_to_play_count (MusicLibraryWindow* self)
{
	gboolean result;
#line 44 "../src/LibraryWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 44 "../src/LibraryWindow.vala"
	result = self->priv->_added_to_play_count;
#line 44 "../src/LibraryWindow.vala"
	return result;
#line 9414 "LibraryWindow.c"
}

static void
music_library_window_set_added_to_play_count (MusicLibraryWindow* self,
                                              gboolean value)
{
#line 44 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/LibraryWindow.vala"
	self->priv->_added_to_play_count = value;
#line 9425 "LibraryWindow.c"
}

static gboolean
music_library_window_get_media_considered_previewed (MusicLibraryWindow* self)
{
	gboolean result;
#line 45 "../src/LibraryWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 45 "../src/LibraryWindow.vala"
	result = self->priv->_media_considered_previewed;
#line 45 "../src/LibraryWindow.vala"
	return result;
#line 9438 "LibraryWindow.c"
}

static void
music_library_window_set_media_considered_previewed (MusicLibraryWindow* self,
                                                     gboolean value)
{
#line 45 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/LibraryWindow.vala"
	self->priv->_media_considered_previewed = value;
#line 9449 "LibraryWindow.c"
}

static gboolean
music_library_window_get_media_half_played_sended (MusicLibraryWindow* self)
{
	gboolean result;
#line 46 "../src/LibraryWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 46 "../src/LibraryWindow.vala"
	result = self->priv->_media_half_played_sended;
#line 46 "../src/LibraryWindow.vala"
	return result;
#line 9462 "LibraryWindow.c"
}

static void
music_library_window_set_media_half_played_sended (MusicLibraryWindow* self,
                                                   gboolean value)
{
#line 46 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/LibraryWindow.vala"
	self->priv->_media_half_played_sended = value;
#line 9473 "LibraryWindow.c"
}

static gboolean
music_library_window_get_search_field_has_focus (MusicLibraryWindow* self)
{
	gboolean result;
#line 47 "../src/LibraryWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 47 "../src/LibraryWindow.vala"
	result = self->priv->_search_field_has_focus;
#line 47 "../src/LibraryWindow.vala"
	return result;
#line 9486 "LibraryWindow.c"
}

static void
music_library_window_set_search_field_has_focus (MusicLibraryWindow* self,
                                                 gboolean value)
{
#line 47 "../src/LibraryWindow.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/LibraryWindow.vala"
	self->priv->_search_field_has_focus = value;
#line 9497 "LibraryWindow.c"
}

static void
_music_library_window_interface_update_sensitivities_music_library_media_added (MusicLibrary* _sender,
                                                                                GeeCollection* medias,
                                                                                gpointer self)
{
#line 100 "../src/LibraryWindow.vala"
	music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) self, NULL, NULL);
#line 9507 "LibraryWindow.c"
}

static void
_music_library_window_interface_update_sensitivities_music_library_media_removed (MusicLibrary* _sender,
                                                                                  GeeCollection* medias,
                                                                                  gpointer self)
{
#line 101 "../src/LibraryWindow.vala"
	music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) self, NULL, NULL);
#line 9517 "LibraryWindow.c"
}

static void
_music_library_window___lambda168_ (MusicLibraryWindow* self,
                                    MusicStaticPlaylist* p)
{
	MusicLocalLibrary* _tmp0_;
	MusicLocalLibrary* _tmp1_;
#line 103 "../src/LibraryWindow.vala"
	g_return_if_fail (p != NULL);
#line 103 "../src/LibraryWindow.vala"
	_tmp0_ = music_library_window_get_library_manager (self);
#line 103 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 103 "../src/LibraryWindow.vala"
	music_library_window_add_playlist (self, p, (MusicLibrary*) _tmp1_, NULL);
#line 9534 "LibraryWindow.c"
}

static void
__music_library_window___lambda168__music_library_playlist_added (MusicLibrary* _sender,
                                                                  MusicStaticPlaylist* playlist,
                                                                  gpointer self)
{
#line 103 "../src/LibraryWindow.vala"
	_music_library_window___lambda168_ ((MusicLibraryWindow*) self, playlist);
#line 9544 "LibraryWindow.c"
}

static void
_music_library_window___lambda169_ (MusicLibraryWindow* self,
                                    MusicStaticPlaylist* p)
{
#line 104 "../src/LibraryWindow.vala"
	g_return_if_fail (p != NULL);
#line 104 "../src/LibraryWindow.vala"
	music_library_window_remove_playlist (self, p);
#line 9555 "LibraryWindow.c"
}

static void
__music_library_window___lambda169__music_library_playlist_removed (MusicLibrary* _sender,
                                                                    MusicStaticPlaylist* playlist,
                                                                    gpointer self)
{
#line 104 "../src/LibraryWindow.vala"
	_music_library_window___lambda169_ ((MusicLibraryWindow*) self, playlist);
#line 9565 "LibraryWindow.c"
}

static void
_music_library_window___lambda170_ (MusicLibraryWindow* self,
                                    MusicSmartPlaylist* p)
{
	MusicLocalLibrary* _tmp0_;
	MusicLocalLibrary* _tmp1_;
#line 106 "../src/LibraryWindow.vala"
	g_return_if_fail (p != NULL);
#line 106 "../src/LibraryWindow.vala"
	_tmp0_ = music_library_window_get_library_manager (self);
#line 106 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 106 "../src/LibraryWindow.vala"
	music_library_window_add_smartplaylist (self, p, (MusicLibrary*) _tmp1_, NULL);
#line 9582 "LibraryWindow.c"
}

static void
__music_library_window___lambda170__music_library_smartplaylist_added (MusicLibrary* _sender,
                                                                       MusicSmartPlaylist* smartplaylist,
                                                                       gpointer self)
{
#line 106 "../src/LibraryWindow.vala"
	_music_library_window___lambda170_ ((MusicLibraryWindow*) self, smartplaylist);
#line 9592 "LibraryWindow.c"
}

static void
_music_library_window___lambda171_ (MusicLibraryWindow* self,
                                    MusicSmartPlaylist* p)
{
#line 107 "../src/LibraryWindow.vala"
	g_return_if_fail (p != NULL);
#line 107 "../src/LibraryWindow.vala"
	music_library_window_remove_smartplaylist (self, p);
#line 9603 "LibraryWindow.c"
}

static void
__music_library_window___lambda171__music_library_smartplaylist_removed (MusicLibrary* _sender,
                                                                         MusicSmartPlaylist* smartplaylist,
                                                                         gpointer self)
{
#line 107 "../src/LibraryWindow.vala"
	_music_library_window___lambda171_ ((MusicLibraryWindow*) self, smartplaylist);
#line 9613 "LibraryWindow.c"
}

static void
_music_library_window___lambda172_ (MusicLibraryWindow* self,
                                    MusicDevice* item)
{
#line 110 "../src/LibraryWindow.vala"
	g_return_if_fail (item != NULL);
#line 110 "../src/LibraryWindow.vala"
	music_library_window_create_device_source_list (self, item);
#line 9624 "LibraryWindow.c"
}

static void
__music_library_window___lambda172__music_device_manager_device_added (MusicDeviceManager* _sender,
                                                                       MusicDevice* d,
                                                                       gpointer self)
{
#line 110 "../src/LibraryWindow.vala"
	_music_library_window___lambda172_ ((MusicLibraryWindow*) self, d);
#line 9634 "LibraryWindow.c"
}

static void
_music_library_window_change_device_name_music_device_manager_device_name_changed (MusicDeviceManager* _sender,
                                                                                   MusicDevice* d,
                                                                                   gpointer self)
{
#line 111 "../src/LibraryWindow.vala"
	music_library_window_change_device_name ((MusicLibraryWindow*) self, d);
#line 9644 "LibraryWindow.c"
}

static void
_music_library_window_remove_device_music_device_manager_device_removed (MusicDeviceManager* _sender,
                                                                         MusicDevice* d,
                                                                         gpointer self)
{
#line 112 "../src/LibraryWindow.vala"
	music_library_window_remove_device ((MusicLibraryWindow*) self, d);
#line 9654 "LibraryWindow.c"
}

static void
_music_library_window_end_of_stream_music_playback_end_of_stream (MusicPlayback* _sender,
                                                                  gpointer self)
{
#line 114 "../src/LibraryWindow.vala"
	music_library_window_end_of_stream ((MusicLibraryWindow*) self);
#line 9663 "LibraryWindow.c"
}

static void
_music_library_window_current_position_update_music_playback_current_position_update (MusicPlayback* _sender,
                                                                                      gint64 position,
                                                                                      gpointer self)
{
#line 115 "../src/LibraryWindow.vala"
	music_library_window_current_position_update ((MusicLibraryWindow*) self, position);
#line 9673 "LibraryWindow.c"
}

static void
_music_library_window_error_occured_music_playback_error_occured (MusicPlayback* _sender,
                                                                  gpointer self)
{
#line 116 "../src/LibraryWindow.vala"
	music_library_window_error_occured ((MusicLibraryWindow*) self);
#line 9682 "LibraryWindow.c"
}

static void
_music_library_window_media_played_music_playback_manager_media_played (MusicPlaybackManager* _sender,
                                                                        MusicMedia* played_media,
                                                                        gpointer self)
{
#line 117 "../src/LibraryWindow.vala"
	music_library_window_media_played ((MusicLibraryWindow*) self, played_media);
#line 9692 "LibraryWindow.c"
}

static void
_music_library_window_playback_stopped_music_playback_manager_playback_stopped (MusicPlaybackManager* _sender,
                                                                                gint64 was_playing,
                                                                                gpointer self)
{
#line 118 "../src/LibraryWindow.vala"
	music_library_window_playback_stopped ((MusicLibraryWindow*) self, was_playing);
#line 9702 "LibraryWindow.c"
}

static void
_music_library_window___lambda173_ (MusicLibraryWindow* self)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicPlayback* _tmp2_;
	guint _tmp3_;
	MusicPlaybackManager* _tmp4_;
	MusicPlaybackManager* _tmp5_;
	MusicPlayback* _tmp6_;
	guint _tmp7_;
	MusicPlaybackManager* _tmp8_;
	MusicPlaybackManager* _tmp9_;
	MusicPlayback* _tmp10_;
	guint _tmp11_;
#line 120 "../src/LibraryWindow.vala"
	_tmp0_ = music_app_get_player ();
#line 120 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 120 "../src/LibraryWindow.vala"
	_tmp2_ = _tmp1_->player;
#line 120 "../src/LibraryWindow.vala"
	g_signal_parse_name ("end-of-stream", MUSIC_TYPE_PLAYBACK, &_tmp3_, NULL, FALSE);
#line 120 "../src/LibraryWindow.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _music_library_window_end_of_stream_music_playback_end_of_stream, self);
#line 121 "../src/LibraryWindow.vala"
	_tmp4_ = music_app_get_player ();
#line 121 "../src/LibraryWindow.vala"
	_tmp5_ = _tmp4_;
#line 121 "../src/LibraryWindow.vala"
	_tmp6_ = _tmp5_->player;
#line 121 "../src/LibraryWindow.vala"
	g_signal_parse_name ("current-position-update", MUSIC_TYPE_PLAYBACK, &_tmp7_, NULL, FALSE);
#line 121 "../src/LibraryWindow.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _music_library_window_current_position_update_music_playback_current_position_update, self);
#line 122 "../src/LibraryWindow.vala"
	_tmp8_ = music_app_get_player ();
#line 122 "../src/LibraryWindow.vala"
	_tmp9_ = _tmp8_;
#line 122 "../src/LibraryWindow.vala"
	_tmp10_ = _tmp9_->player;
#line 122 "../src/LibraryWindow.vala"
	g_signal_parse_name ("error-occured", MUSIC_TYPE_PLAYBACK, &_tmp11_, NULL, FALSE);
#line 122 "../src/LibraryWindow.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _music_library_window_error_occured_music_playback_error_occured, self);
#line 9750 "LibraryWindow.c"
}

static void
__music_library_window___lambda173__music_playback_manager_changing_player (MusicPlaybackManager* _sender,
                                                                            gpointer self)
{
#line 119 "../src/LibraryWindow.vala"
	_music_library_window___lambda173_ ((MusicLibraryWindow*) self);
#line 9759 "LibraryWindow.c"
}

static void
_music_library_window___lambda174_ (MusicLibraryWindow* self)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicPlayback* _tmp2_;
	MusicPlaybackManager* _tmp3_;
	MusicPlaybackManager* _tmp4_;
	MusicPlayback* _tmp5_;
	MusicPlaybackManager* _tmp6_;
	MusicPlaybackManager* _tmp7_;
	MusicPlayback* _tmp8_;
#line 125 "../src/LibraryWindow.vala"
	_tmp0_ = music_app_get_player ();
#line 125 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 125 "../src/LibraryWindow.vala"
	_tmp2_ = _tmp1_->player;
#line 125 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp2_, "end-of-stream", (GCallback) _music_library_window_end_of_stream_music_playback_end_of_stream, self, 0);
#line 126 "../src/LibraryWindow.vala"
	_tmp3_ = music_app_get_player ();
#line 126 "../src/LibraryWindow.vala"
	_tmp4_ = _tmp3_;
#line 126 "../src/LibraryWindow.vala"
	_tmp5_ = _tmp4_->player;
#line 126 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp5_, "current-position-update", (GCallback) _music_library_window_current_position_update_music_playback_current_position_update, self, 0);
#line 127 "../src/LibraryWindow.vala"
	_tmp6_ = music_app_get_player ();
#line 127 "../src/LibraryWindow.vala"
	_tmp7_ = _tmp6_;
#line 127 "../src/LibraryWindow.vala"
	_tmp8_ = _tmp7_->player;
#line 127 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp8_, "error-occured", (GCallback) _music_library_window_error_occured_music_playback_error_occured, self, 0);
#line 9798 "LibraryWindow.c"
}

static void
__music_library_window___lambda174__music_playback_manager_player_changed (MusicPlaybackManager* _sender,
                                                                           gpointer self)
{
#line 124 "../src/LibraryWindow.vala"
	_music_library_window___lambda174_ ((MusicLibraryWindow*) self);
#line 9807 "LibraryWindow.c"
}

static void
_music_library_window_show_alert_music_notification_manager_show_alert (MusicNotificationManager* _sender,
                                                                        const gchar* title,
                                                                        const gchar* message,
                                                                        gpointer self)
{
#line 130 "../src/LibraryWindow.vala"
	music_library_window_show_alert ((MusicLibraryWindow*) self, title, message);
#line 9818 "LibraryWindow.c"
}

static void
_music_library_window___lambda175_ (MusicLibraryWindow* self,
                                    MusicStaticPlaylist* playlist)
{
	MusicLocalLibrary* _tmp0_;
	MusicLocalLibrary* _tmp1_;
#line 136 "../src/LibraryWindow.vala"
	g_return_if_fail (playlist != NULL);
#line 137 "../src/LibraryWindow.vala"
	_tmp0_ = music_library_window_get_library_manager (self);
#line 137 "../src/LibraryWindow.vala"
	_tmp1_ = _tmp0_;
#line 137 "../src/LibraryWindow.vala"
	music_library_window_add_playlist (self, playlist, (MusicLibrary*) _tmp1_, NULL);
#line 9835 "LibraryWindow.c"
}

static void
__music_library_window___lambda175__music_libraries_manager_add_headless_playlist (MusicLibrariesManager* _sender,
                                                                                   MusicStaticPlaylist* playlist,
                                                                                   gpointer self)
{
#line 136 "../src/LibraryWindow.vala"
	_music_library_window___lambda175_ ((MusicLibraryWindow*) self, playlist);
#line 9845 "LibraryWindow.c"
}

static GObject *
music_library_window_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicLibraryWindow * self;
	MusicSettingsMain* _tmp0_;
	MusicLocalLibrary* _tmp1_;
	MusicLocalLibrary* _tmp2_;
	MusicLocalLibrary* _tmp3_;
	MusicLocalLibrary* _tmp4_;
	MusicLocalLibrary* _tmp5_;
	MusicLocalLibrary* _tmp6_;
	MusicLocalLibrary* _tmp7_;
	MusicLocalLibrary* _tmp8_;
	MusicLocalLibrary* _tmp9_;
	MusicLocalLibrary* _tmp10_;
	MusicLocalLibrary* _tmp11_;
	MusicLocalLibrary* _tmp12_;
	MusicDeviceManager* device_manager = NULL;
	MusicDeviceManager* _tmp13_;
	MusicDeviceManager* _tmp14_;
	MusicDeviceManager* _tmp15_;
	MusicDeviceManager* _tmp16_;
	MusicPlaybackManager* _tmp17_;
	MusicPlaybackManager* _tmp18_;
	MusicPlayback* _tmp19_;
	MusicPlaybackManager* _tmp20_;
	MusicPlaybackManager* _tmp21_;
	MusicPlayback* _tmp22_;
	MusicPlaybackManager* _tmp23_;
	MusicPlaybackManager* _tmp24_;
	MusicPlayback* _tmp25_;
	MusicPlaybackManager* _tmp26_;
	MusicPlaybackManager* _tmp27_;
	MusicPlaybackManager* _tmp28_;
	MusicPlaybackManager* _tmp29_;
	MusicPlaybackManager* _tmp30_;
	MusicPlaybackManager* _tmp31_;
	MusicPlaybackManager* _tmp32_;
	MusicPlaybackManager* _tmp33_;
	MusicNotificationManager* _tmp34_;
	MusicNotificationManager* _tmp35_;
	GeeHashMap* _tmp36_;
	GeeHashMap* _tmp37_;
	GeeHashMap* _tmp38_;
	MusicLibrariesManager* _tmp39_;
	MusicLocalLibrary* _tmp40_;
	MusicLocalLibrary* _tmp41_;
	GeeCollection* _tmp42_;
	GeeCollection* _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	gboolean _tmp46_;
#line 93 "../src/LibraryWindow.vala"
	parent_class = G_OBJECT_CLASS (music_library_window_parent_class);
#line 93 "../src/LibraryWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 93 "../src/LibraryWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow);
#line 94 "../src/LibraryWindow.vala"
	hdy_init ();
#line 96 "../src/LibraryWindow.vala"
	g_action_map_add_action_entries ((GActionMap*) self, MUSIC_LIBRARY_WINDOW_ACTION_ENTRIES, (gint) G_N_ELEMENTS (MUSIC_LIBRARY_WINDOW_ACTION_ENTRIES), self);
#line 98 "../src/LibraryWindow.vala"
	_tmp0_ = music_settings_main_get_default ();
#line 98 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->priv->main_settings);
#line 98 "../src/LibraryWindow.vala"
	self->priv->main_settings = _tmp0_;
#line 100 "../src/LibraryWindow.vala"
	_tmp1_ = music_library_window_get_library_manager (self);
#line 100 "../src/LibraryWindow.vala"
	_tmp2_ = _tmp1_;
#line 100 "../src/LibraryWindow.vala"
	g_signal_connect_object ((MusicLibrary*) _tmp2_, "media-added", (GCallback) _music_library_window_interface_update_sensitivities_music_library_media_added, (MusicLibraryWindowInterface*) self, 0);
#line 101 "../src/LibraryWindow.vala"
	_tmp3_ = music_library_window_get_library_manager (self);
#line 101 "../src/LibraryWindow.vala"
	_tmp4_ = _tmp3_;
#line 101 "../src/LibraryWindow.vala"
	g_signal_connect_object ((MusicLibrary*) _tmp4_, "media-removed", (GCallback) _music_library_window_interface_update_sensitivities_music_library_media_removed, (MusicLibraryWindowInterface*) self, 0);
#line 103 "../src/LibraryWindow.vala"
	_tmp5_ = music_library_window_get_library_manager (self);
#line 103 "../src/LibraryWindow.vala"
	_tmp6_ = _tmp5_;
#line 103 "../src/LibraryWindow.vala"
	g_signal_connect_object ((MusicLibrary*) _tmp6_, "playlist-added", (GCallback) __music_library_window___lambda168__music_library_playlist_added, self, 0);
#line 104 "../src/LibraryWindow.vala"
	_tmp7_ = music_library_window_get_library_manager (self);
#line 104 "../src/LibraryWindow.vala"
	_tmp8_ = _tmp7_;
#line 104 "../src/LibraryWindow.vala"
	g_signal_connect_object ((MusicLibrary*) _tmp8_, "playlist-removed", (GCallback) __music_library_window___lambda169__music_library_playlist_removed, self, 0);
#line 106 "../src/LibraryWindow.vala"
	_tmp9_ = music_library_window_get_library_manager (self);
#line 106 "../src/LibraryWindow.vala"
	_tmp10_ = _tmp9_;
#line 106 "../src/LibraryWindow.vala"
	g_signal_connect_object ((MusicLibrary*) _tmp10_, "smartplaylist-added", (GCallback) __music_library_window___lambda170__music_library_smartplaylist_added, self, 0);
#line 107 "../src/LibraryWindow.vala"
	_tmp11_ = music_library_window_get_library_manager (self);
#line 107 "../src/LibraryWindow.vala"
	_tmp12_ = _tmp11_;
#line 107 "../src/LibraryWindow.vala"
	g_signal_connect_object ((MusicLibrary*) _tmp12_, "smartplaylist-removed", (GCallback) __music_library_window___lambda171__music_library_smartplaylist_removed, self, 0);
#line 109 "../src/LibraryWindow.vala"
	_tmp13_ = music_device_manager_get_default ();
#line 109 "../src/LibraryWindow.vala"
	device_manager = _tmp13_;
#line 110 "../src/LibraryWindow.vala"
	_tmp14_ = device_manager;
#line 110 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp14_, "device-added", (GCallback) __music_library_window___lambda172__music_device_manager_device_added, self, 0);
#line 111 "../src/LibraryWindow.vala"
	_tmp15_ = device_manager;
#line 111 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp15_, "device-name-changed", (GCallback) _music_library_window_change_device_name_music_device_manager_device_name_changed, self, 0);
#line 112 "../src/LibraryWindow.vala"
	_tmp16_ = device_manager;
#line 112 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp16_, "device-removed", (GCallback) _music_library_window_remove_device_music_device_manager_device_removed, self, 0);
#line 114 "../src/LibraryWindow.vala"
	_tmp17_ = music_app_get_player ();
#line 114 "../src/LibraryWindow.vala"
	_tmp18_ = _tmp17_;
#line 114 "../src/LibraryWindow.vala"
	_tmp19_ = _tmp18_->player;
#line 114 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp19_, "end-of-stream", (GCallback) _music_library_window_end_of_stream_music_playback_end_of_stream, self, 0);
#line 115 "../src/LibraryWindow.vala"
	_tmp20_ = music_app_get_player ();
#line 115 "../src/LibraryWindow.vala"
	_tmp21_ = _tmp20_;
#line 115 "../src/LibraryWindow.vala"
	_tmp22_ = _tmp21_->player;
#line 115 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp22_, "current-position-update", (GCallback) _music_library_window_current_position_update_music_playback_current_position_update, self, 0);
#line 116 "../src/LibraryWindow.vala"
	_tmp23_ = music_app_get_player ();
#line 116 "../src/LibraryWindow.vala"
	_tmp24_ = _tmp23_;
#line 116 "../src/LibraryWindow.vala"
	_tmp25_ = _tmp24_->player;
#line 116 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp25_, "error-occured", (GCallback) _music_library_window_error_occured_music_playback_error_occured, self, 0);
#line 117 "../src/LibraryWindow.vala"
	_tmp26_ = music_app_get_player ();
#line 117 "../src/LibraryWindow.vala"
	_tmp27_ = _tmp26_;
#line 117 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp27_, "media-played", (GCallback) _music_library_window_media_played_music_playback_manager_media_played, self, G_CONNECT_AFTER);
#line 118 "../src/LibraryWindow.vala"
	_tmp28_ = music_app_get_player ();
#line 118 "../src/LibraryWindow.vala"
	_tmp29_ = _tmp28_;
#line 118 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp29_, "playback-stopped", (GCallback) _music_library_window_playback_stopped_music_playback_manager_playback_stopped, self, 0);
#line 119 "../src/LibraryWindow.vala"
	_tmp30_ = music_app_get_player ();
#line 119 "../src/LibraryWindow.vala"
	_tmp31_ = _tmp30_;
#line 119 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp31_, "changing-player", (GCallback) __music_library_window___lambda173__music_playback_manager_changing_player, self, 0);
#line 124 "../src/LibraryWindow.vala"
	_tmp32_ = music_app_get_player ();
#line 124 "../src/LibraryWindow.vala"
	_tmp33_ = _tmp32_;
#line 124 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp33_, "player-changed", (GCallback) __music_library_window___lambda174__music_playback_manager_player_changed, self, 0);
#line 130 "../src/LibraryWindow.vala"
	_tmp34_ = music_notification_manager_get_default ();
#line 130 "../src/LibraryWindow.vala"
	_tmp35_ = _tmp34_;
#line 130 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp35_, "show-alert", (GCallback) _music_library_window_show_alert_music_notification_manager_show_alert, self, 0);
#line 130 "../src/LibraryWindow.vala"
	_g_object_unref0 (_tmp35_);
#line 132 "../src/LibraryWindow.vala"
	_tmp36_ = gee_hash_map_new (MUSIC_TYPE_PLAYLIST, NULL, NULL, MUSIC_TYPE_VIEW_WRAPPER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 132 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->match_playlists);
#line 132 "../src/LibraryWindow.vala"
	self->match_playlists = _tmp36_;
#line 133 "../src/LibraryWindow.vala"
	_tmp37_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, MUSIC_TYPE_DEVICE_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 133 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->priv->match_devices);
#line 133 "../src/LibraryWindow.vala"
	self->priv->match_devices = _tmp37_;
#line 134 "../src/LibraryWindow.vala"
	_tmp38_ = gee_hash_map_new (MUSIC_TYPE_PLAYLIST, NULL, NULL, MUSIC_TYPE_SOURCE_LIST_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 134 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->priv->match_playlist_entry);
#line 134 "../src/LibraryWindow.vala"
	self->priv->match_playlist_entry = _tmp38_;
#line 136 "../src/LibraryWindow.vala"
	_tmp39_ = music_libraries_manager;
#line 136 "../src/LibraryWindow.vala"
	g_signal_connect_object (_tmp39_, "add-headless-playlist", (GCallback) __music_library_window___lambda175__music_libraries_manager_add_headless_playlist, self, 0);
#line 141 "../src/LibraryWindow.vala"
	_tmp40_ = music_library_window_get_library_manager (self);
#line 141 "../src/LibraryWindow.vala"
	_tmp41_ = _tmp40_;
#line 141 "../src/LibraryWindow.vala"
	_tmp42_ = music_library_get_medias ((MusicLibrary*) _tmp41_);
#line 141 "../src/LibraryWindow.vala"
	_tmp43_ = _tmp42_;
#line 141 "../src/LibraryWindow.vala"
	_tmp44_ = gee_collection_get_size (_tmp43_);
#line 141 "../src/LibraryWindow.vala"
	_tmp45_ = _tmp44_;
#line 141 "../src/LibraryWindow.vala"
	_tmp46_ = _tmp45_ > 0;
#line 141 "../src/LibraryWindow.vala"
	_g_object_unref0 (_tmp43_);
#line 141 "../src/LibraryWindow.vala"
	if (_tmp46_) {
#line 10068 "LibraryWindow.c"
		MusicPlaybackManager* _tmp47_;
		MusicPlaybackManager* _tmp48_;
		gint last_media_position = 0;
		GSettings* _tmp49_;
		GSettings* _tmp50_;
		gboolean _tmp51_ = FALSE;
		MusicPlaybackManager* _tmp52_;
		MusicPlaybackManager* _tmp53_;
		MusicMedia* _tmp54_;
		MusicMedia* _tmp55_;
#line 142 "../src/LibraryWindow.vala"
		_tmp47_ = music_app_get_player ();
#line 142 "../src/LibraryWindow.vala"
		_tmp48_ = _tmp47_;
#line 142 "../src/LibraryWindow.vala"
		music_playback_manager_clear_queue (_tmp48_);
#line 144 "../src/LibraryWindow.vala"
		_tmp49_ = music_app_get_saved_state ();
#line 144 "../src/LibraryWindow.vala"
		_tmp50_ = _tmp49_;
#line 144 "../src/LibraryWindow.vala"
		last_media_position = g_settings_get_int (_tmp50_, "last-media-position");
#line 147 "../src/LibraryWindow.vala"
		if (last_media_position > 5) {
#line 148 "../src/LibraryWindow.vala"
			music_library_window_set_media_considered_previewed (self, TRUE);
#line 150 "../src/LibraryWindow.vala"
			if (last_media_position > 30) {
#line 151 "../src/LibraryWindow.vala"
				music_library_window_set_media_considered_played (self, TRUE);
#line 10099 "LibraryWindow.c"
			}
		}
#line 155 "../src/LibraryWindow.vala"
		_tmp52_ = music_app_get_player ();
#line 155 "../src/LibraryWindow.vala"
		_tmp53_ = _tmp52_;
#line 155 "../src/LibraryWindow.vala"
		_tmp54_ = music_playback_manager_get_current_media (_tmp53_);
#line 155 "../src/LibraryWindow.vala"
		_tmp55_ = _tmp54_;
#line 155 "../src/LibraryWindow.vala"
		if (_tmp55_ != NULL) {
#line 10112 "LibraryWindow.c"
			MusicPlaybackManager* _tmp56_;
			MusicPlaybackManager* _tmp57_;
			MusicMedia* _tmp58_;
			MusicMedia* _tmp59_;
			guint _tmp60_;
			guint _tmp61_;
#line 156 "../src/LibraryWindow.vala"
			_tmp56_ = music_app_get_player ();
#line 156 "../src/LibraryWindow.vala"
			_tmp57_ = _tmp56_;
#line 156 "../src/LibraryWindow.vala"
			_tmp58_ = music_playback_manager_get_current_media (_tmp57_);
#line 156 "../src/LibraryWindow.vala"
			_tmp59_ = _tmp58_;
#line 156 "../src/LibraryWindow.vala"
			_tmp60_ = music_media_get_length (_tmp59_);
#line 156 "../src/LibraryWindow.vala"
			_tmp61_ = _tmp60_;
#line 156 "../src/LibraryWindow.vala"
			_tmp51_ = ((gdouble) (last_media_position / ((gdouble) _tmp61_))) > 0.90;
#line 10133 "LibraryWindow.c"
		} else {
#line 155 "../src/LibraryWindow.vala"
			_tmp51_ = FALSE;
#line 10137 "LibraryWindow.c"
		}
#line 155 "../src/LibraryWindow.vala"
		if (_tmp51_) {
#line 157 "../src/LibraryWindow.vala"
			music_library_window_set_added_to_play_count (self, TRUE);
#line 10143 "LibraryWindow.c"
		}
	}
#line 93 "../src/LibraryWindow.vala"
	_g_object_unref0 (device_manager);
#line 93 "../src/LibraryWindow.vala"
	return obj;
#line 10150 "LibraryWindow.c"
}

static void
music_library_window_class_init (MusicLibraryWindowClass * klass,
                                 gpointer klass_data)
{
#line 30 "../src/LibraryWindow.vala"
	music_library_window_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/LibraryWindow.vala"
	g_type_class_adjust_private_offset (klass, &MusicLibraryWindow_private_offset);
#line 30 "../src/LibraryWindow.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) music_library_window_real_key_press_event;
#line 30 "../src/LibraryWindow.vala"
	((MusicLibraryWindowClass *) klass)->playback_stopped = (void (*) (MusicLibraryWindow*, gint64)) music_library_window_real_playback_stopped;
#line 30 "../src/LibraryWindow.vala"
	((MusicLibraryWindowClass *) klass)->play_media = (void (*) (MusicLibraryWindow*, gboolean)) music_library_window_real_play_media;
#line 30 "../src/LibraryWindow.vala"
	((MusicLibraryWindowClass *) klass)->play_next_media = (void (*) (MusicLibraryWindow*, gboolean)) music_library_window_real_play_next_media;
#line 30 "../src/LibraryWindow.vala"
	((MusicLibraryWindowClass *) klass)->play_previous_media = (void (*) (MusicLibraryWindow*, gboolean)) music_library_window_real_play_previous_media;
#line 30 "../src/LibraryWindow.vala"
	((MusicLibraryWindowClass *) klass)->action_import = (void (*) (MusicLibraryWindow*)) music_library_window_real_action_import;
#line 30 "../src/LibraryWindow.vala"
	((MusicLibraryWindowClass *) klass)->end_of_stream = (void (*) (MusicLibraryWindow*)) music_library_window_real_end_of_stream;
#line 30 "../src/LibraryWindow.vala"
	((MusicLibraryWindowClass *) klass)->error_occured = (void (*) (MusicLibraryWindow*)) music_library_window_real_error_occured;
#line 30 "../src/LibraryWindow.vala"
	((MusicLibraryWindowClass *) klass)->current_position_update = (void (*) (MusicLibraryWindow*, gint64)) music_library_window_real_current_position_update;
#line 30 "../src/LibraryWindow.vala"
	((MusicLibraryWindowClass *) klass)->drag_received = (void (*) (MusicLibraryWindow*, GdkDragContext*, gint, gint, GtkSelectionData*, guint, guint)) music_library_window_real_drag_received;
#line 30 "../src/LibraryWindow.vala"
	((GtkWidgetClass *) klass)->delete_event = (gboolean (*) (GtkWidget*, GdkEventAny*)) music_library_window_real_delete_event;
#line 30 "../src/LibraryWindow.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) music_library_window_real_configure_event;
#line 30 "../src/LibraryWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_library_window_get_property;
#line 30 "../src/LibraryWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_library_window_set_property;
#line 30 "../src/LibraryWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = music_library_window_constructor;
#line 30 "../src/LibraryWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = music_library_window_finalize;
#line 30 "../src/LibraryWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIBRARY_WINDOW_INITIALIZATION_FINISHED_PROPERTY, music_library_window_properties[MUSIC_LIBRARY_WINDOW_INITIALIZATION_FINISHED_PROPERTY] = g_param_spec_boolean ("initialization-finished", "initialization-finished", "initialization-finished", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/LibraryWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIBRARY_WINDOW_NEWLY_CREATED_PLAYLIST_PROPERTY, music_library_window_properties[MUSIC_LIBRARY_WINDOW_NEWLY_CREATED_PLAYLIST_PROPERTY] = g_param_spec_boolean ("newly-created-playlist", "newly-created-playlist", "newly-created-playlist", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/LibraryWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIBRARY_WINDOW_SOURCE_LIST_VIEW_PROPERTY, music_library_window_properties[MUSIC_LIBRARY_WINDOW_SOURCE_LIST_VIEW_PROPERTY] = g_param_spec_object ("source-list-view", "source-list-view", "source-list-view", MUSIC_TYPE_SOURCE_LIST_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/LibraryWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIBRARY_WINDOW_VIEW_STACK_PROPERTY, music_library_window_properties[MUSIC_LIBRARY_WINDOW_VIEW_STACK_PROPERTY] = g_param_spec_object ("view-stack", "view-stack", "view-stack", MUSIC_TYPE_VIEW_STACK, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/LibraryWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIBRARY_WINDOW_VIEW_SELECTOR_PROPERTY, music_library_window_properties[MUSIC_LIBRARY_WINDOW_VIEW_SELECTOR_PROPERTY] = g_param_spec_object ("view-selector", "view-selector", "view-selector", MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/LibraryWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIBRARY_WINDOW_SEARCH_ENTRY_PROPERTY, music_library_window_properties[MUSIC_LIBRARY_WINDOW_SEARCH_ENTRY_PROPERTY] = g_param_spec_object ("search-entry", "search-entry", "search-entry", gtk_search_entry_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/LibraryWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIBRARY_WINDOW_STATUSBAR_PROPERTY, music_library_window_properties[MUSIC_LIBRARY_WINDOW_STATUSBAR_PROPERTY] = g_param_spec_object ("statusbar", "statusbar", "statusbar", MUSIC_WIDGETS_TYPE_STATUS_BAR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/LibraryWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIBRARY_WINDOW_LIBRARY_MANAGER_PROPERTY, music_library_window_properties[MUSIC_LIBRARY_WINDOW_LIBRARY_MANAGER_PROPERTY] = g_param_spec_object ("library-manager", "library-manager", "library-manager", MUSIC_TYPE_LOCAL_LIBRARY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/LibraryWindow.vala"
	music_library_window_signals[MUSIC_LIBRARY_WINDOW_PLAY_PAUSE_CHANGED_SIGNAL] = g_signal_new ("play-pause-changed", MUSIC_TYPE_LIBRARY_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 10211 "LibraryWindow.c"
}

static void
music_library_window_music_library_window_interface_interface_init (MusicLibraryWindowInterfaceIface * iface,
                                                                    gpointer iface_data)
{
#line 30 "../src/LibraryWindow.vala"
	music_library_window_music_library_window_interface_parent_iface = g_type_interface_peek_parent (iface);
#line 30 "../src/LibraryWindow.vala"
	iface->update_sensitivities = (void (*) (MusicLibraryWindowInterface*, GAsyncReadyCallback, gpointer)) music_library_window_real_update_sensitivities;
#line 30 "../src/LibraryWindow.vala"
	iface->update_sensitivities_finish = (void (*) (MusicLibraryWindowInterface*, GAsyncResult*)) music_library_window_update_sensitivities_finish;
#line 10224 "LibraryWindow.c"
}

static void
music_library_window_instance_init (MusicLibraryWindow * self,
                                    gpointer klass)
{
#line 30 "../src/LibraryWindow.vala"
	self->priv = music_library_window_get_instance_private (self);
#line 33 "../src/LibraryWindow.vala"
	self->priv->_initialization_finished = FALSE;
#line 34 "../src/LibraryWindow.vala"
	self->priv->_newly_created_playlist = FALSE;
#line 43 "../src/LibraryWindow.vala"
	self->priv->_media_considered_played = FALSE;
#line 44 "../src/LibraryWindow.vala"
	self->priv->_added_to_play_count = FALSE;
#line 45 "../src/LibraryWindow.vala"
	self->priv->_media_considered_previewed = FALSE;
#line 46 "../src/LibraryWindow.vala"
	self->priv->_media_half_played_sended = FALSE;
#line 47 "../src/LibraryWindow.vala"
	self->priv->_search_field_has_focus = TRUE;
#line 52 "../src/LibraryWindow.vala"
	self->priv->preferences = NULL;
#line 56 "../src/LibraryWindow.vala"
	g_rec_mutex_init (&self->priv->__lock_match_playlists);
#line 57 "../src/LibraryWindow.vala"
	g_rec_mutex_init (&self->priv->__lock_match_devices);
#line 663 "../src/LibraryWindow.vala"
	self->priv->update_sensitivities_pending = FALSE;
#line 10255 "LibraryWindow.c"
}

static void
music_library_window_finalize (GObject * obj)
{
	MusicLibraryWindow * self;
#line 30 "../src/LibraryWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow);
#line 36 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->priv->_source_list_view);
#line 37 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->priv->_view_stack);
#line 38 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->priv->_view_selector);
#line 39 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->priv->_search_entry);
#line 40 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->priv->_statusbar);
#line 51 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->priv->notification_cancellable);
#line 52 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->priv->preferences);
#line 53 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->priv->main_settings);
#line 54 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->priv->top_display);
#line 56 "../src/LibraryWindow.vala"
	g_rec_mutex_clear (&self->priv->__lock_match_playlists);
#line 56 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->match_playlists);
#line 57 "../src/LibraryWindow.vala"
	g_rec_mutex_clear (&self->priv->__lock_match_devices);
#line 57 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->priv->match_devices);
#line 58 "../src/LibraryWindow.vala"
	_g_object_unref0 (self->priv->match_playlist_entry);
#line 30 "../src/LibraryWindow.vala"
	G_OBJECT_CLASS (music_library_window_parent_class)->finalize (obj);
#line 10294 "LibraryWindow.c"
}

static GType
music_library_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicLibraryWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_library_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicLibraryWindow), 0, (GInstanceInitFunc) music_library_window_instance_init, NULL };
	static const GInterfaceInfo music_library_window_interface_info = { (GInterfaceInitFunc) music_library_window_music_library_window_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_library_window_type_id;
	music_library_window_type_id = g_type_register_static (hdy_application_window_get_type (), "MusicLibraryWindow", &g_define_type_info, 0);
	g_type_add_interface_static (music_library_window_type_id, MUSIC_TYPE_LIBRARY_WINDOW_INTERFACE, &music_library_window_interface_info);
	MusicLibraryWindow_private_offset = g_type_add_instance_private (music_library_window_type_id, sizeof (MusicLibraryWindowPrivate));
	return music_library_window_type_id;
}

GType
music_library_window_get_type (void)
{
	static volatile gsize music_library_window_type_id__once = 0;
	if (g_once_init_enter (&music_library_window_type_id__once)) {
		GType music_library_window_type_id;
		music_library_window_type_id = music_library_window_get_type_once ();
		g_once_init_leave (&music_library_window_type_id__once, music_library_window_type_id);
	}
	return music_library_window_type_id__once;
}

static void
_vala_music_library_window_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	MusicLibraryWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow);
#line 30 "../src/LibraryWindow.vala"
	switch (property_id) {
#line 30 "../src/LibraryWindow.vala"
		case MUSIC_LIBRARY_WINDOW_INITIALIZATION_FINISHED_PROPERTY:
#line 30 "../src/LibraryWindow.vala"
		g_value_set_boolean (value, music_library_window_get_initialization_finished (self));
#line 30 "../src/LibraryWindow.vala"
		break;
#line 30 "../src/LibraryWindow.vala"
		case MUSIC_LIBRARY_WINDOW_NEWLY_CREATED_PLAYLIST_PROPERTY:
#line 30 "../src/LibraryWindow.vala"
		g_value_set_boolean (value, music_library_window_get_newly_created_playlist (self));
#line 30 "../src/LibraryWindow.vala"
		break;
#line 30 "../src/LibraryWindow.vala"
		case MUSIC_LIBRARY_WINDOW_SOURCE_LIST_VIEW_PROPERTY:
#line 30 "../src/LibraryWindow.vala"
		g_value_set_object (value, music_library_window_get_source_list_view (self));
#line 30 "../src/LibraryWindow.vala"
		break;
#line 30 "../src/LibraryWindow.vala"
		case MUSIC_LIBRARY_WINDOW_VIEW_STACK_PROPERTY:
#line 30 "../src/LibraryWindow.vala"
		g_value_set_object (value, music_library_window_get_view_stack (self));
#line 30 "../src/LibraryWindow.vala"
		break;
#line 30 "../src/LibraryWindow.vala"
		case MUSIC_LIBRARY_WINDOW_VIEW_SELECTOR_PROPERTY:
#line 30 "../src/LibraryWindow.vala"
		g_value_set_object (value, music_library_window_get_view_selector (self));
#line 30 "../src/LibraryWindow.vala"
		break;
#line 30 "../src/LibraryWindow.vala"
		case MUSIC_LIBRARY_WINDOW_SEARCH_ENTRY_PROPERTY:
#line 30 "../src/LibraryWindow.vala"
		g_value_set_object (value, music_library_window_get_search_entry (self));
#line 30 "../src/LibraryWindow.vala"
		break;
#line 30 "../src/LibraryWindow.vala"
		case MUSIC_LIBRARY_WINDOW_STATUSBAR_PROPERTY:
#line 30 "../src/LibraryWindow.vala"
		g_value_set_object (value, music_library_window_get_statusbar (self));
#line 30 "../src/LibraryWindow.vala"
		break;
#line 30 "../src/LibraryWindow.vala"
		case MUSIC_LIBRARY_WINDOW_LIBRARY_MANAGER_PROPERTY:
#line 30 "../src/LibraryWindow.vala"
		g_value_set_object (value, music_library_window_get_library_manager (self));
#line 30 "../src/LibraryWindow.vala"
		break;
#line 10379 "LibraryWindow.c"
		default:
#line 30 "../src/LibraryWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/LibraryWindow.vala"
		break;
#line 10385 "LibraryWindow.c"
	}
}

static void
_vala_music_library_window_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	MusicLibraryWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow);
#line 30 "../src/LibraryWindow.vala"
	switch (property_id) {
#line 30 "../src/LibraryWindow.vala"
		case MUSIC_LIBRARY_WINDOW_INITIALIZATION_FINISHED_PROPERTY:
#line 30 "../src/LibraryWindow.vala"
		music_library_window_set_initialization_finished (self, g_value_get_boolean (value));
#line 30 "../src/LibraryWindow.vala"
		break;
#line 30 "../src/LibraryWindow.vala"
		case MUSIC_LIBRARY_WINDOW_NEWLY_CREATED_PLAYLIST_PROPERTY:
#line 30 "../src/LibraryWindow.vala"
		music_library_window_set_newly_created_playlist (self, g_value_get_boolean (value));
#line 30 "../src/LibraryWindow.vala"
		break;
#line 30 "../src/LibraryWindow.vala"
		case MUSIC_LIBRARY_WINDOW_SOURCE_LIST_VIEW_PROPERTY:
#line 30 "../src/LibraryWindow.vala"
		music_library_window_set_source_list_view (self, g_value_get_object (value));
#line 30 "../src/LibraryWindow.vala"
		break;
#line 30 "../src/LibraryWindow.vala"
		case MUSIC_LIBRARY_WINDOW_VIEW_STACK_PROPERTY:
#line 30 "../src/LibraryWindow.vala"
		music_library_window_set_view_stack (self, g_value_get_object (value));
#line 30 "../src/LibraryWindow.vala"
		break;
#line 30 "../src/LibraryWindow.vala"
		case MUSIC_LIBRARY_WINDOW_VIEW_SELECTOR_PROPERTY:
#line 30 "../src/LibraryWindow.vala"
		music_library_window_set_view_selector (self, g_value_get_object (value));
#line 30 "../src/LibraryWindow.vala"
		break;
#line 30 "../src/LibraryWindow.vala"
		case MUSIC_LIBRARY_WINDOW_SEARCH_ENTRY_PROPERTY:
#line 30 "../src/LibraryWindow.vala"
		music_library_window_set_search_entry (self, g_value_get_object (value));
#line 30 "../src/LibraryWindow.vala"
		break;
#line 30 "../src/LibraryWindow.vala"
		case MUSIC_LIBRARY_WINDOW_STATUSBAR_PROPERTY:
#line 30 "../src/LibraryWindow.vala"
		music_library_window_set_statusbar (self, g_value_get_object (value));
#line 30 "../src/LibraryWindow.vala"
		break;
#line 10441 "LibraryWindow.c"
		default:
#line 30 "../src/LibraryWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/LibraryWindow.vala"
		break;
#line 10447 "LibraryWindow.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

