/* SourceListView.c generated by valac 0.56.0, the Vala compiler
 * generated from SourceListView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/* Add an interface so that SourceListItem and SourceListExpandableItem still share a common*/
/* ancestor that is compatible with the SourceList widget.*/

#include "music-lib.h"
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include "io.elementary.music-core.h"
#include <gee.h>

enum  {
	MUSIC_SOURCE_LIST_ITEM_0_PROPERTY,
	MUSIC_SOURCE_LIST_ITEM_VIEW_PROPERTY,
	MUSIC_SOURCE_LIST_ITEM_HINT_PROPERTY,
	MUSIC_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY,
	MUSIC_SOURCE_LIST_ITEM_NUM_PROPERTIES
};
static GParamSpec* music_source_list_item_properties[MUSIC_SOURCE_LIST_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	MUSIC_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_ITEM_PLAYLIST_EDIT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_ITEM_PLAYLIST_SAVE_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_ITEM_PLAYLIST_EXPORT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_ITEM_PLAYLIST_MEDIA_ADDED_SIGNAL,
	MUSIC_SOURCE_LIST_ITEM_NUM_SIGNALS
};
static guint music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_NUM_SIGNALS] = {0};
enum  {
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_0_PROPERTY,
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY,
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_NUM_PROPERTIES
};
static GParamSpec* music_source_list_expandable_item_properties[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_NUM_PROPERTIES];
typedef struct _Block32Data Block32Data;
enum  {
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_IMPORT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_EJECT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_SYNC_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_NUM_SIGNALS
};
static guint music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_NUM_SIGNALS] = {0};
enum  {
	MUSIC_PLAY_LIST_CATEGORY_0_PROPERTY,
	MUSIC_PLAY_LIST_CATEGORY_NUM_PROPERTIES
};
static GParamSpec* music_play_list_category_properties[MUSIC_PLAY_LIST_CATEGORY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	MUSIC_PLAY_LIST_CATEGORY_PLAYLIST_IMPORT_CLICKED_SIGNAL,
	MUSIC_PLAY_LIST_CATEGORY_NUM_SIGNALS
};
static guint music_play_list_category_signals[MUSIC_PLAY_LIST_CATEGORY_NUM_SIGNALS] = {0};
enum  {
	MUSIC_SOURCE_LIST_ROOT_0_PROPERTY,
	MUSIC_SOURCE_LIST_ROOT_NUM_PROPERTIES
};
static GParamSpec* music_source_list_root_properties[MUSIC_SOURCE_LIST_ROOT_NUM_PROPERTIES];
enum  {
	MUSIC_SOURCE_LIST_VIEW_0_PROPERTY,
	MUSIC_SOURCE_LIST_VIEW_NUM_PROPERTIES
};
static GParamSpec* music_source_list_view_properties[MUSIC_SOURCE_LIST_VIEW_NUM_PROPERTIES];
typedef struct _Block33Data Block33Data;
enum  {
	MUSIC_SOURCE_LIST_VIEW_EDITED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_ITEM_ACTION_ACTIVATED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_ACTIVATED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_PLAYLIST_RENAME_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_PLAYLIST_EDIT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_PLAYLIST_REMOVE_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_PLAYLIST_SAVE_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_PLAYLIST_EXPORT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_PLAYLIST_IMPORT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_PLAYLIST_MEDIA_ADDED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_DEVICE_IMPORT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_DEVICE_EJECT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_DEVICE_SYNC_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_NUM_SIGNALS
};
static guint music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_NUM_SIGNALS] = {0};

struct _MusicSourceListItemPrivate {
	GtkGrid* _view;
	MusicViewWrapperHint _hint;
	GIcon* _activatable_icon;
	GtkMenu* playlist_menu;
};

struct _MusicSourceListExpandableItemPrivate {
	GtkGrid* _view;
	GtkMenu* device_menu;
};

struct _Block32Data {
	int _ref_count_;
	MusicSourceListExpandableItem* self;
	GtkGrid* view;
};

struct _MusicPlayListCategoryPrivate {
	GtkMenu* playlist_menu;
};

struct _MusicSourceListViewPrivate {
	GraniteWidgetsSourceListExpandableItem* library_category;
	GraniteWidgetsSourceListExpandableItem* devices_category;
	GraniteWidgetsSourceListExpandableItem* network_category;
	MusicPlayListCategory* playlists_category;
};

struct _Block33Data {
	int _ref_count_;
	MusicSourceListView* self;
	MusicSourceListItem* sourcelist_item;
	MusicSourceListExpandableItem* expandable_item;
};

static gint MusicSourceListItem_private_offset;
static gpointer music_source_list_item_parent_class = NULL;
static MusicSourceListEntryIface * music_source_list_item_music_source_list_entry_parent_iface = NULL;
static GraniteWidgetsSourceListDragDestIface * music_source_list_item_granite_widgets_source_list_drag_dest_parent_iface = NULL;
static gint MusicSourceListExpandableItem_private_offset;
static gpointer music_source_list_expandable_item_parent_class = NULL;
static MusicSourceListEntryIface * music_source_list_expandable_item_music_source_list_entry_parent_iface = NULL;
static gint MusicPlayListCategory_private_offset;
static gpointer music_play_list_category_parent_class = NULL;
static GraniteWidgetsSourceListSortableIface * music_play_list_category_granite_widgets_source_list_sortable_parent_iface = NULL;
static gpointer music_source_list_root_parent_class = NULL;
static GraniteWidgetsSourceListSortableIface * music_source_list_root_granite_widgets_source_list_sortable_parent_iface = NULL;
static gint MusicSourceListView_private_offset;
static gpointer music_source_list_view_parent_class = NULL;

static GType music_source_list_entry_get_type_once (void);
static GtkMenu* music_source_list_item_real_get_context_menu (GraniteWidgetsSourceListItem* base);
static gboolean music_source_list_item_real_data_drop_possible (GraniteWidgetsSourceListDragDest* base,
                                                         GdkDragContext* context,
                                                         GtkSelectionData* data);
static GdkDragAction music_source_list_item_real_data_received (GraniteWidgetsSourceListDragDest* base,
                                                         GdkDragContext* context,
                                                         GtkSelectionData* data);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_BOXED_INT (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data);
static GObject * music_source_list_item_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _music_source_list_item____lambda77_ (MusicSourceListItem* self);
static void __music_source_list_item____lambda77__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _music_source_list_item____lambda78_ (MusicSourceListItem* self);
static void __music_source_list_item____lambda78__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _music_source_list_item____lambda79_ (MusicSourceListItem* self);
static void __music_source_list_item____lambda79__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _music_source_list_item____lambda80_ (MusicSourceListItem* self);
static void __music_source_list_item____lambda80__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _music_source_list_item____lambda81_ (MusicSourceListItem* self);
static void __music_source_list_item____lambda81__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _music_source_list_item____lambda82_ (MusicSourceListItem* self);
static void __music_source_list_item____lambda82__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _music_source_list_item___lambda83_ (MusicSourceListItem* self);
static void __music_source_list_item___lambda83__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                  gpointer self);
static void music_source_list_item_finalize (GObject * obj);
static GType music_source_list_item_get_type_once (void);
static void _vala_music_source_list_item_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_music_source_list_item_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static Block32Data* block32_data_ref (Block32Data* _data32_);
static void block32_data_unref (void * _userdata_);
static void ___lambda88_ (Block32Data* _data32_);
static void ____lambda88__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda89_ (Block32Data* _data32_);
static void ____lambda89__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void _____lambda90_ (Block32Data* _data32_);
static void ______lambda90__gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self);
static void _____lambda91_ (Block32Data* _data32_);
static void ______lambda91__gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self);
static void _____lambda92_ (Block32Data* _data32_);
static void ______lambda92__gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self);
static GtkMenu* music_source_list_expandable_item_real_get_context_menu (GraniteWidgetsSourceListItem* base);
static void music_source_list_expandable_item_finalize (GObject * obj);
static GType music_source_list_expandable_item_get_type_once (void);
static void _vala_music_source_list_expandable_item_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec);
static void _vala_music_source_list_expandable_item_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec);
static GtkMenu* music_play_list_category_real_get_context_menu (GraniteWidgetsSourceListItem* base);
static gboolean music_play_list_category_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base);
static gint music_play_list_category_real_compare (GraniteWidgetsSourceListSortable* base,
                                            GraniteWidgetsSourceListItem* a,
                                            GraniteWidgetsSourceListItem* b);
static GObject * music_play_list_category_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _music_play_list_category___lambda84_ (MusicPlayListCategory* self);
static void __music_play_list_category___lambda84__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                    gpointer self);
static void _music_play_list_category___lambda85_ (MusicPlayListCategory* self);
static void __music_play_list_category___lambda85__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                    gpointer self);
static void _music_play_list_category___lambda86_ (MusicPlayListCategory* self);
static void __music_play_list_category___lambda86__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                    gpointer self);
static void music_play_list_category_finalize (GObject * obj);
static GType music_play_list_category_get_type_once (void);
static gboolean music_source_list_root_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base);
static gint music_source_list_root_real_compare (GraniteWidgetsSourceListSortable* base,
                                          GraniteWidgetsSourceListItem* a,
                                          GraniteWidgetsSourceListItem* b);
static GType music_source_list_root_get_type_once (void);
static void __lambda87_ (MusicSourceListView* self);
static void ___lambda87__music_play_list_category_playlist_import_clicked (MusicPlayListCategory* _sender,
                                                                    gpointer self);
static Block33Data* block33_data_ref (Block33Data* _data33_);
static void block33_data_unref (void * _userdata_);
static void __lambda93_ (MusicSourceListView* self);
static void ___lambda93__granite_widgets_source_list_item_activated (GraniteWidgetsSourceListItem* _sender,
                                                              gpointer self);
static void __lambda94_ (Block33Data* _data33_,
                  const gchar* new_name);
static void ___lambda94__granite_widgets_source_list_item_edited (GraniteWidgetsSourceListItem* _sender,
                                                           const gchar* new_name,
                                                           gpointer self);
static void __lambda95_ (Block33Data* _data33_,
                  GraniteWidgetsSourceListItem* sl);
static void ___lambda95__granite_widgets_source_list_item_action_activated (GraniteWidgetsSourceListItem* _sender,
                                                                     gpointer self);
static void __lambda96_ (MusicSourceListView* self,
                  GtkGrid* view,
                  MusicSourceListItem* item);
static void ___lambda96__music_source_list_item_playlist_rename_clicked (MusicSourceListItem* _sender,
                                                                  GtkGrid* view,
                                                                  MusicSourceListItem* item,
                                                                  gpointer self);
static void __lambda97_ (MusicSourceListView* self,
                  GtkGrid* view);
static void ___lambda97__music_source_list_item_playlist_edit_clicked (MusicSourceListItem* _sender,
                                                                GtkGrid* view,
                                                                gpointer self);
static void __lambda98_ (MusicSourceListView* self,
                  GtkGrid* view);
static void ___lambda98__music_source_list_item_playlist_remove_clicked (MusicSourceListItem* _sender,
                                                                  GtkGrid* view,
                                                                  gpointer self);
static void __lambda99_ (MusicSourceListView* self,
                  GtkGrid* view);
static void ___lambda99__music_source_list_item_playlist_save_clicked (MusicSourceListItem* _sender,
                                                                GtkGrid* view,
                                                                gpointer self);
static void __lambda100_ (MusicSourceListView* self,
                   GtkGrid* view);
static void ___lambda100__music_source_list_item_playlist_export_clicked (MusicSourceListItem* _sender,
                                                                   GtkGrid* view,
                                                                   gpointer self);
static void __lambda101_ (MusicSourceListView* self,
                   GtkGrid* view,
                   gchar** uris,
                   gint uris_length1);
static void ___lambda101__music_source_list_item_playlist_media_added (MusicSourceListItem* _sender,
                                                                GtkGrid* view,
                                                                gchar** media,
                                                                gint media_length1,
                                                                gpointer self);
static void __lambda102_ (Block33Data* _data33_,
                   GtkGrid* view);
static GtkGrid* music_source_list_view_get_device_from_item (MusicSourceListView* self,
                                                      MusicSourceListExpandableItem* item);
static void ___lambda102__music_source_list_expandable_item_device_import_clicked (MusicSourceListExpandableItem* _sender,
                                                                            GtkGrid* view,
                                                                            gpointer self);
static void __lambda103_ (MusicSourceListView* self,
                   GtkGrid* view);
static void ___lambda103__music_source_list_expandable_item_device_eject_clicked (MusicSourceListExpandableItem* _sender,
                                                                           GtkGrid* view,
                                                                           gpointer self);
static void __lambda104_ (MusicSourceListView* self,
                   GtkGrid* view);
static void ___lambda104__music_source_list_expandable_item_device_sync_clicked (MusicSourceListExpandableItem* _sender,
                                                                          GtkGrid* view,
                                                                          gpointer self);
static void __lambda105_ (MusicSourceListView* self,
                   GtkGrid* view);
static void ___lambda105__music_source_list_expandable_item_device_new_playlist_clicked (MusicSourceListExpandableItem* _sender,
                                                                                  GtkGrid* view,
                                                                                  gpointer self);
static void __lambda106_ (MusicSourceListView* self,
                   GtkGrid* view);
static void ___lambda106__music_source_list_expandable_item_device_new_smartplaylist_clicked (MusicSourceListExpandableItem* _sender,
                                                                                       GtkGrid* view,
                                                                                       gpointer self);
static void music_source_list_view_real_item_selected (GraniteWidgetsSourceList* base,
                                                GraniteWidgetsSourceListItem* item);
static void music_source_list_view_enumerate_children_items (MusicSourceListView* self,
                                                      MusicSourceListExpandableItem* exp_item,
                                                      GeeTreeSet** pages);
static void music_source_list_view_enumerate_children_pages (MusicSourceListView* self,
                                                      MusicSourceListExpandableItem* exp_item,
                                                      GeeTreeSet** pages);
static void g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void music_source_list_view_finalize (GObject * obj);
static GType music_source_list_view_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static void
music_source_list_entry_default_init (MusicSourceListEntryIface * iface,
                                      gpointer iface_data)
{
}

static GType
music_source_list_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicSourceListEntryIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_source_list_entry_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType music_source_list_entry_type_id;
	music_source_list_entry_type_id = g_type_register_static (G_TYPE_INTERFACE, "MusicSourceListEntry", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (music_source_list_entry_type_id, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
	return music_source_list_entry_type_id;
}

GType
music_source_list_entry_get_type (void)
{
	static volatile gsize music_source_list_entry_type_id__once = 0;
	if (g_once_init_enter (&music_source_list_entry_type_id__once)) {
		GType music_source_list_entry_type_id;
		music_source_list_entry_type_id = music_source_list_entry_get_type_once ();
		g_once_init_leave (&music_source_list_entry_type_id__once, music_source_list_entry_type_id);
	}
	return music_source_list_entry_type_id__once;
}

static inline gpointer
music_source_list_item_get_instance_private (MusicSourceListItem* self)
{
	return G_STRUCT_MEMBER_P (self, MusicSourceListItem_private_offset);
}

MusicSourceListItem*
music_source_list_item_construct (GType object_type,
                                  GtkGrid* view,
                                  const gchar* name,
                                  MusicViewWrapperHint hint,
                                  GIcon* icon,
                                  GIcon* activatable_icon)
{
	MusicSourceListItem * self = NULL;
#line 51 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 51 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 51 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 52 "../src/Widgets/SourceListView.vala"
	self = (MusicSourceListItem*) g_object_new (object_type, "activatable-icon", activatable_icon, "hint", hint, "icon", icon, "name", name, "view", view, NULL);
#line 51 "../src/Widgets/SourceListView.vala"
	return self;
#line 440 "SourceListView.c"
}

MusicSourceListItem*
music_source_list_item_new (GtkGrid* view,
                            const gchar* name,
                            MusicViewWrapperHint hint,
                            GIcon* icon,
                            GIcon* activatable_icon)
{
#line 51 "../src/Widgets/SourceListView.vala"
	return music_source_list_item_construct (MUSIC_TYPE_SOURCE_LIST_ITEM, view, name, hint, icon, activatable_icon);
#line 452 "SourceListView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 117 "../src/Widgets/SourceListView.vala"
	return self ? g_object_ref (self) : NULL;
#line 460 "SourceListView.c"
}

static GtkMenu*
music_source_list_item_real_get_context_menu (GraniteWidgetsSourceListItem* base)
{
	MusicSourceListItem * self;
	GtkMenu* _tmp0_;
	GtkMenu* result;
#line 112 "../src/Widgets/SourceListView.vala"
	self = (MusicSourceListItem*) base;
#line 113 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->playlist_menu;
#line 113 "../src/Widgets/SourceListView.vala"
	if (_tmp0_ != NULL) {
#line 475 "SourceListView.c"
		GtkMenu* _tmp1_;
		GtkWidget* _tmp2_;
		GtkMenu* _tmp4_;
		GtkMenu* _tmp5_;
#line 114 "../src/Widgets/SourceListView.vala"
		_tmp1_ = self->priv->playlist_menu;
#line 114 "../src/Widgets/SourceListView.vala"
		_tmp2_ = gtk_menu_get_attach_widget (_tmp1_);
#line 114 "../src/Widgets/SourceListView.vala"
		if (_tmp2_ != NULL) {
#line 486 "SourceListView.c"
			GtkMenu* _tmp3_;
#line 115 "../src/Widgets/SourceListView.vala"
			_tmp3_ = self->priv->playlist_menu;
#line 115 "../src/Widgets/SourceListView.vala"
			gtk_menu_detach (_tmp3_);
#line 492 "SourceListView.c"
		}
#line 117 "../src/Widgets/SourceListView.vala"
		_tmp4_ = self->priv->playlist_menu;
#line 117 "../src/Widgets/SourceListView.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 117 "../src/Widgets/SourceListView.vala"
		result = _tmp5_;
#line 117 "../src/Widgets/SourceListView.vala"
		return result;
#line 502 "SourceListView.c"
	}
#line 119 "../src/Widgets/SourceListView.vala"
	result = NULL;
#line 119 "../src/Widgets/SourceListView.vala"
	return result;
#line 508 "SourceListView.c"
}

static gboolean
music_source_list_item_real_data_drop_possible (GraniteWidgetsSourceListDragDest* base,
                                                GdkDragContext* context,
                                                GtkSelectionData* data)
{
	MusicSourceListItem * self;
	gboolean _tmp0_ = FALSE;
	MusicViewWrapperHint _tmp1_;
	gboolean result;
#line 122 "../src/Widgets/SourceListView.vala"
	self = (MusicSourceListItem*) base;
#line 122 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 122 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (data != NULL, FALSE);
#line 124 "../src/Widgets/SourceListView.vala"
	_tmp1_ = self->priv->_hint;
#line 124 "../src/Widgets/SourceListView.vala"
	if (_tmp1_ == MUSIC_VIEW_WRAPPER_HINT_PLAYLIST) {
#line 125 "../src/Widgets/SourceListView.vala"
		_tmp0_ = gtk_selection_data_get_target (data) == gdk_atom_intern_static_string ("text/uri-list");
#line 532 "SourceListView.c"
	} else {
#line 124 "../src/Widgets/SourceListView.vala"
		_tmp0_ = FALSE;
#line 536 "SourceListView.c"
	}
#line 124 "../src/Widgets/SourceListView.vala"
	result = _tmp0_;
#line 124 "../src/Widgets/SourceListView.vala"
	return result;
#line 542 "SourceListView.c"
}

static GdkDragAction
music_source_list_item_real_data_received (GraniteWidgetsSourceListDragDest* base,
                                           GdkDragContext* context,
                                           GtkSelectionData* data)
{
	MusicSourceListItem * self;
	GtkGrid* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GdkDragAction result;
#line 128 "../src/Widgets/SourceListView.vala"
	self = (MusicSourceListItem*) base;
#line 128 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (context != NULL, 0U);
#line 128 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (data != NULL, 0U);
#line 129 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 129 "../src/Widgets/SourceListView.vala"
	_tmp2_ = _tmp1_ = gtk_selection_data_get_uris (data);
#line 129 "../src/Widgets/SourceListView.vala"
	_tmp3_ = _tmp2_;
#line 129 "../src/Widgets/SourceListView.vala"
	_tmp3__length1 = _vala_array_length (_tmp1_);
#line 129 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_MEDIA_ADDED_SIGNAL], 0, _tmp0_, _tmp3_, (gint) _vala_array_length (_tmp1_));
#line 129 "../src/Widgets/SourceListView.vala"
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 130 "../src/Widgets/SourceListView.vala"
	result = GDK_ACTION_COPY;
#line 130 "../src/Widgets/SourceListView.vala"
	return result;
#line 579 "SourceListView.c"
}

GtkGrid*
music_source_list_item_get_view (MusicSourceListItem* self)
{
	GtkGrid* result;
	GtkGrid* _tmp0_;
#line 45 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 45 "../src/Widgets/SourceListView.vala"
	result = _tmp0_;
#line 45 "../src/Widgets/SourceListView.vala"
	return result;
#line 595 "SourceListView.c"
}

static void
music_source_list_item_set_view (MusicSourceListItem* self,
                                 GtkGrid* value)
{
	GtkGrid* old_value;
#line 45 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/Widgets/SourceListView.vala"
	old_value = music_source_list_item_get_view (self);
#line 45 "../src/Widgets/SourceListView.vala"
	if (old_value != value) {
#line 609 "SourceListView.c"
		GtkGrid* _tmp0_;
#line 45 "../src/Widgets/SourceListView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 45 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->_view);
#line 45 "../src/Widgets/SourceListView.vala"
		self->priv->_view = _tmp0_;
#line 45 "../src/Widgets/SourceListView.vala"
		g_object_notify_by_pspec ((GObject *) self, music_source_list_item_properties[MUSIC_SOURCE_LIST_ITEM_VIEW_PROPERTY]);
#line 619 "SourceListView.c"
	}
}

MusicViewWrapperHint
music_source_list_item_get_hint (MusicSourceListItem* self)
{
	MusicViewWrapperHint result;
#line 46 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 46 "../src/Widgets/SourceListView.vala"
	result = self->priv->_hint;
#line 46 "../src/Widgets/SourceListView.vala"
	return result;
#line 633 "SourceListView.c"
}

static void
music_source_list_item_set_hint (MusicSourceListItem* self,
                                 MusicViewWrapperHint value)
{
	MusicViewWrapperHint old_value;
#line 46 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/Widgets/SourceListView.vala"
	old_value = music_source_list_item_get_hint (self);
#line 46 "../src/Widgets/SourceListView.vala"
	if (old_value != value) {
#line 46 "../src/Widgets/SourceListView.vala"
		self->priv->_hint = value;
#line 46 "../src/Widgets/SourceListView.vala"
		g_object_notify_by_pspec ((GObject *) self, music_source_list_item_properties[MUSIC_SOURCE_LIST_ITEM_HINT_PROPERTY]);
#line 651 "SourceListView.c"
	}
}

GIcon*
music_source_list_item_get_activatable_icon (MusicSourceListItem* self)
{
	GIcon* result;
	GIcon* _tmp0_;
#line 47 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_activatable_icon;
#line 47 "../src/Widgets/SourceListView.vala"
	result = _tmp0_;
#line 47 "../src/Widgets/SourceListView.vala"
	return result;
#line 668 "SourceListView.c"
}

static void
music_source_list_item_set_activatable_icon (MusicSourceListItem* self,
                                             GIcon* value)
{
	GIcon* old_value;
#line 47 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/Widgets/SourceListView.vala"
	old_value = music_source_list_item_get_activatable_icon (self);
#line 47 "../src/Widgets/SourceListView.vala"
	if (old_value != value) {
#line 682 "SourceListView.c"
		GIcon* _tmp0_;
#line 47 "../src/Widgets/SourceListView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 47 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->_activatable_icon);
#line 47 "../src/Widgets/SourceListView.vala"
		self->priv->_activatable_icon = _tmp0_;
#line 47 "../src/Widgets/SourceListView.vala"
		g_object_notify_by_pspec ((GObject *) self, music_source_list_item_properties[MUSIC_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY]);
#line 692 "SourceListView.c"
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 37 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (n_param_values == 3);
#line 37 "../src/Widgets/SourceListView.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 37 "../src/Widgets/SourceListView.vala"
		data1 = closure->data;
#line 37 "../src/Widgets/SourceListView.vala"
		data2 = param_values->data[0].v_pointer;
#line 718 "SourceListView.c"
	} else {
#line 37 "../src/Widgets/SourceListView.vala"
		data1 = param_values->data[0].v_pointer;
#line 37 "../src/Widgets/SourceListView.vala"
		data2 = closure->data;
#line 724 "SourceListView.c"
	}
#line 37 "../src/Widgets/SourceListView.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 37 "../src/Widgets/SourceListView.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 730 "SourceListView.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_BOXED_INT (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_BOXED_INT) (gpointer data1, gpointer arg_1, gpointer arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOXED_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 37 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (n_param_values == 4);
#line 37 "../src/Widgets/SourceListView.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 37 "../src/Widgets/SourceListView.vala"
		data1 = closure->data;
#line 37 "../src/Widgets/SourceListView.vala"
		data2 = param_values->data[0].v_pointer;
#line 755 "SourceListView.c"
	} else {
#line 37 "../src/Widgets/SourceListView.vala"
		data1 = param_values->data[0].v_pointer;
#line 37 "../src/Widgets/SourceListView.vala"
		data2 = closure->data;
#line 761 "SourceListView.c"
	}
#line 37 "../src/Widgets/SourceListView.vala"
	callback = (GMarshalFunc_VOID__OBJECT_BOXED_INT) (marshal_data ? marshal_data : cc->callback);
#line 37 "../src/Widgets/SourceListView.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boxed (param_values + 2), g_value_get_int (param_values + 3), data2);
#line 767 "SourceListView.c"
}

static void
_music_source_list_item____lambda77_ (MusicSourceListItem* self)
{
	GtkGrid* _tmp0_;
#line 71 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 71 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL], 0, _tmp0_, self);
#line 778 "SourceListView.c"
}

static void
__music_source_list_item____lambda77__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
#line 70 "../src/Widgets/SourceListView.vala"
	_music_source_list_item____lambda77_ ((MusicSourceListItem*) self);
#line 787 "SourceListView.c"
}

static void
_music_source_list_item____lambda78_ (MusicSourceListItem* self)
{
	GtkGrid* _tmp0_;
#line 74 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 74 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL], 0, _tmp0_);
#line 798 "SourceListView.c"
}

static void
__music_source_list_item____lambda78__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
#line 73 "../src/Widgets/SourceListView.vala"
	_music_source_list_item____lambda78_ ((MusicSourceListItem*) self);
#line 807 "SourceListView.c"
}

static void
_music_source_list_item____lambda79_ (MusicSourceListItem* self)
{
	GtkGrid* _tmp0_;
#line 85 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 85 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL], 0, _tmp0_, self);
#line 818 "SourceListView.c"
}

static void
__music_source_list_item____lambda79__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
#line 84 "../src/Widgets/SourceListView.vala"
	_music_source_list_item____lambda79_ ((MusicSourceListItem*) self);
#line 827 "SourceListView.c"
}

static void
_music_source_list_item____lambda80_ (MusicSourceListItem* self)
{
	GtkGrid* _tmp0_;
#line 88 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 88 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_EDIT_CLICKED_SIGNAL], 0, _tmp0_);
#line 838 "SourceListView.c"
}

static void
__music_source_list_item____lambda80__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
#line 87 "../src/Widgets/SourceListView.vala"
	_music_source_list_item____lambda80_ ((MusicSourceListItem*) self);
#line 847 "SourceListView.c"
}

static void
_music_source_list_item____lambda81_ (MusicSourceListItem* self)
{
	GtkGrid* _tmp0_;
#line 91 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 91 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL], 0, _tmp0_);
#line 858 "SourceListView.c"
}

static void
__music_source_list_item____lambda81__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
#line 90 "../src/Widgets/SourceListView.vala"
	_music_source_list_item____lambda81_ ((MusicSourceListItem*) self);
#line 867 "SourceListView.c"
}

static void
_music_source_list_item____lambda82_ (MusicSourceListItem* self)
{
	GtkGrid* _tmp0_;
#line 98 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 98 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_SAVE_CLICKED_SIGNAL], 0, _tmp0_);
#line 878 "SourceListView.c"
}

static void
__music_source_list_item____lambda82__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
#line 97 "../src/Widgets/SourceListView.vala"
	_music_source_list_item____lambda82_ ((MusicSourceListItem*) self);
#line 887 "SourceListView.c"
}

static void
_music_source_list_item___lambda83_ (MusicSourceListItem* self)
{
	GtkGrid* _tmp0_;
#line 105 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 105 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_EXPORT_CLICKED_SIGNAL], 0, _tmp0_);
#line 898 "SourceListView.c"
}

static void
__music_source_list_item___lambda83__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                             gpointer self)
{
#line 104 "../src/Widgets/SourceListView.vala"
	_music_source_list_item___lambda83_ ((MusicSourceListItem*) self);
#line 907 "SourceListView.c"
}

static GObject *
music_source_list_item_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicSourceListItem * self;
	GtkMenu* _tmp0_;
	MusicViewWrapperHint _tmp1_;
	GtkMenuItem* playlist_export = NULL;
	GtkMenuItem* _tmp26_;
	GtkMenuItem* _tmp27_;
	GtkMenu* _tmp28_;
	GtkMenuItem* _tmp29_;
	GtkMenu* _tmp30_;
#line 61 "../src/Widgets/SourceListView.vala"
	parent_class = G_OBJECT_CLASS (music_source_list_item_parent_class);
#line 61 "../src/Widgets/SourceListView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 61 "../src/Widgets/SourceListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem);
#line 62 "../src/Widgets/SourceListView.vala"
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
#line 62 "../src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp0_);
#line 62 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlist_menu);
#line 62 "../src/Widgets/SourceListView.vala"
	self->priv->playlist_menu = _tmp0_;
#line 64 "../src/Widgets/SourceListView.vala"
	_tmp1_ = self->priv->_hint;
#line 64 "../src/Widgets/SourceListView.vala"
	switch (_tmp1_) {
#line 64 "../src/Widgets/SourceListView.vala"
		case MUSIC_VIEW_WRAPPER_HINT_PLAYLIST:
#line 946 "SourceListView.c"
		{
			GtkMenuItem* playlist_rename = NULL;
			GtkMenuItem* _tmp2_;
			GtkMenuItem* playlist_remove = NULL;
			GtkMenuItem* _tmp3_;
			GtkMenu* _tmp4_;
			GtkMenuItem* _tmp5_;
			GtkMenu* _tmp6_;
			GtkMenuItem* _tmp7_;
			GtkMenuItem* _tmp8_;
			GtkMenuItem* _tmp9_;
#line 66 "../src/Widgets/SourceListView.vala"
			_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Rename"));
#line 66 "../src/Widgets/SourceListView.vala"
			g_object_ref_sink (_tmp2_);
#line 66 "../src/Widgets/SourceListView.vala"
			playlist_rename = _tmp2_;
#line 67 "../src/Widgets/SourceListView.vala"
			_tmp3_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Remove"));
#line 67 "../src/Widgets/SourceListView.vala"
			g_object_ref_sink (_tmp3_);
#line 67 "../src/Widgets/SourceListView.vala"
			playlist_remove = _tmp3_;
#line 68 "../src/Widgets/SourceListView.vala"
			_tmp4_ = self->priv->playlist_menu;
#line 68 "../src/Widgets/SourceListView.vala"
			_tmp5_ = playlist_rename;
#line 68 "../src/Widgets/SourceListView.vala"
			gtk_menu_shell_append ((GtkMenuShell*) _tmp4_, _tmp5_);
#line 69 "../src/Widgets/SourceListView.vala"
			_tmp6_ = self->priv->playlist_menu;
#line 69 "../src/Widgets/SourceListView.vala"
			_tmp7_ = playlist_remove;
#line 69 "../src/Widgets/SourceListView.vala"
			gtk_menu_shell_append ((GtkMenuShell*) _tmp6_, _tmp7_);
#line 70 "../src/Widgets/SourceListView.vala"
			_tmp8_ = playlist_rename;
#line 70 "../src/Widgets/SourceListView.vala"
			g_signal_connect_object (_tmp8_, "activate", (GCallback) __music_source_list_item____lambda77__gtk_menu_item_activate, self, 0);
#line 73 "../src/Widgets/SourceListView.vala"
			_tmp9_ = playlist_remove;
#line 73 "../src/Widgets/SourceListView.vala"
			g_signal_connect_object (_tmp9_, "activate", (GCallback) __music_source_list_item____lambda78__gtk_menu_item_activate, self, 0);
#line 76 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist_remove);
#line 76 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist_rename);
#line 76 "../src/Widgets/SourceListView.vala"
			break;
#line 996 "SourceListView.c"
		}
#line 64 "../src/Widgets/SourceListView.vala"
		case MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST:
#line 1000 "SourceListView.c"
		{
			GtkMenuItem* playlist_rename = NULL;
			GtkMenuItem* _tmp10_;
			GtkMenuItem* playlist_edit = NULL;
			GtkMenuItem* _tmp11_;
			GtkMenuItem* playlist_remove = NULL;
			GtkMenuItem* _tmp12_;
			GtkMenu* _tmp13_;
			GtkMenuItem* _tmp14_;
			GtkMenu* _tmp15_;
			GtkMenuItem* _tmp16_;
			GtkMenu* _tmp17_;
			GtkMenuItem* _tmp18_;
			GtkMenuItem* _tmp19_;
			GtkMenuItem* _tmp20_;
			GtkMenuItem* _tmp21_;
#line 78 "../src/Widgets/SourceListView.vala"
			_tmp10_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Rename"));
#line 78 "../src/Widgets/SourceListView.vala"
			g_object_ref_sink (_tmp10_);
#line 78 "../src/Widgets/SourceListView.vala"
			playlist_rename = _tmp10_;
#line 79 "../src/Widgets/SourceListView.vala"
			_tmp11_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Edit…"));
#line 79 "../src/Widgets/SourceListView.vala"
			g_object_ref_sink (_tmp11_);
#line 79 "../src/Widgets/SourceListView.vala"
			playlist_edit = _tmp11_;
#line 80 "../src/Widgets/SourceListView.vala"
			_tmp12_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Remove"));
#line 80 "../src/Widgets/SourceListView.vala"
			g_object_ref_sink (_tmp12_);
#line 80 "../src/Widgets/SourceListView.vala"
			playlist_remove = _tmp12_;
#line 81 "../src/Widgets/SourceListView.vala"
			_tmp13_ = self->priv->playlist_menu;
#line 81 "../src/Widgets/SourceListView.vala"
			_tmp14_ = playlist_rename;
#line 81 "../src/Widgets/SourceListView.vala"
			gtk_menu_shell_append ((GtkMenuShell*) _tmp13_, _tmp14_);
#line 82 "../src/Widgets/SourceListView.vala"
			_tmp15_ = self->priv->playlist_menu;
#line 82 "../src/Widgets/SourceListView.vala"
			_tmp16_ = playlist_edit;
#line 82 "../src/Widgets/SourceListView.vala"
			gtk_menu_shell_append ((GtkMenuShell*) _tmp15_, _tmp16_);
#line 83 "../src/Widgets/SourceListView.vala"
			_tmp17_ = self->priv->playlist_menu;
#line 83 "../src/Widgets/SourceListView.vala"
			_tmp18_ = playlist_remove;
#line 83 "../src/Widgets/SourceListView.vala"
			gtk_menu_shell_append ((GtkMenuShell*) _tmp17_, _tmp18_);
#line 84 "../src/Widgets/SourceListView.vala"
			_tmp19_ = playlist_rename;
#line 84 "../src/Widgets/SourceListView.vala"
			g_signal_connect_object (_tmp19_, "activate", (GCallback) __music_source_list_item____lambda79__gtk_menu_item_activate, self, 0);
#line 87 "../src/Widgets/SourceListView.vala"
			_tmp20_ = playlist_edit;
#line 87 "../src/Widgets/SourceListView.vala"
			g_signal_connect_object (_tmp20_, "activate", (GCallback) __music_source_list_item____lambda80__gtk_menu_item_activate, self, 0);
#line 90 "../src/Widgets/SourceListView.vala"
			_tmp21_ = playlist_remove;
#line 90 "../src/Widgets/SourceListView.vala"
			g_signal_connect_object (_tmp21_, "activate", (GCallback) __music_source_list_item____lambda81__gtk_menu_item_activate, self, 0);
#line 93 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist_remove);
#line 93 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist_edit);
#line 93 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist_rename);
#line 93 "../src/Widgets/SourceListView.vala"
			break;
#line 1073 "SourceListView.c"
		}
#line 64 "../src/Widgets/SourceListView.vala"
		case MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST:
#line 1077 "SourceListView.c"
		{
			GtkMenuItem* playlist_save = NULL;
			GtkMenuItem* _tmp22_;
			GtkMenu* _tmp23_;
			GtkMenuItem* _tmp24_;
			GtkMenuItem* _tmp25_;
#line 95 "../src/Widgets/SourceListView.vala"
			_tmp22_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Save as Playlist"));
#line 95 "../src/Widgets/SourceListView.vala"
			g_object_ref_sink (_tmp22_);
#line 95 "../src/Widgets/SourceListView.vala"
			playlist_save = _tmp22_;
#line 96 "../src/Widgets/SourceListView.vala"
			_tmp23_ = self->priv->playlist_menu;
#line 96 "../src/Widgets/SourceListView.vala"
			_tmp24_ = playlist_save;
#line 96 "../src/Widgets/SourceListView.vala"
			gtk_menu_shell_append ((GtkMenuShell*) _tmp23_, _tmp24_);
#line 97 "../src/Widgets/SourceListView.vala"
			_tmp25_ = playlist_save;
#line 97 "../src/Widgets/SourceListView.vala"
			g_signal_connect_object (_tmp25_, "activate", (GCallback) __music_source_list_item____lambda82__gtk_menu_item_activate, self, 0);
#line 100 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist_save);
#line 100 "../src/Widgets/SourceListView.vala"
			break;
#line 1104 "SourceListView.c"
		}
		default:
#line 64 "../src/Widgets/SourceListView.vala"
		break;
#line 1109 "SourceListView.c"
	}
#line 103 "../src/Widgets/SourceListView.vala"
	_tmp26_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Export…"));
#line 103 "../src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp26_);
#line 103 "../src/Widgets/SourceListView.vala"
	playlist_export = _tmp26_;
#line 104 "../src/Widgets/SourceListView.vala"
	_tmp27_ = playlist_export;
#line 104 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp27_, "activate", (GCallback) __music_source_list_item___lambda83__gtk_menu_item_activate, self, 0);
#line 108 "../src/Widgets/SourceListView.vala"
	_tmp28_ = self->priv->playlist_menu;
#line 108 "../src/Widgets/SourceListView.vala"
	_tmp29_ = playlist_export;
#line 108 "../src/Widgets/SourceListView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp28_, _tmp29_);
#line 109 "../src/Widgets/SourceListView.vala"
	_tmp30_ = self->priv->playlist_menu;
#line 109 "../src/Widgets/SourceListView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp30_);
#line 61 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (playlist_export);
#line 61 "../src/Widgets/SourceListView.vala"
	return obj;
#line 1135 "SourceListView.c"
}

static void
music_source_list_item_class_init (MusicSourceListItemClass * klass,
                                   gpointer klass_data)
{
#line 37 "../src/Widgets/SourceListView.vala"
	music_source_list_item_parent_class = g_type_class_peek_parent (klass);
#line 37 "../src/Widgets/SourceListView.vala"
	g_type_class_adjust_private_offset (klass, &MusicSourceListItem_private_offset);
#line 37 "../src/Widgets/SourceListView.vala"
	((GraniteWidgetsSourceListItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListItem*)) music_source_list_item_real_get_context_menu;
#line 37 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_source_list_item_get_property;
#line 37 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_source_list_item_set_property;
#line 37 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->constructor = music_source_list_item_constructor;
#line 37 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->finalize = music_source_list_item_finalize;
#line 37 "../src/Widgets/SourceListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SOURCE_LIST_ITEM_VIEW_PROPERTY, music_source_list_item_properties[MUSIC_SOURCE_LIST_ITEM_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", gtk_grid_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 37 "../src/Widgets/SourceListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SOURCE_LIST_ITEM_HINT_PROPERTY, music_source_list_item_properties[MUSIC_SOURCE_LIST_ITEM_HINT_PROPERTY] = g_param_spec_enum ("hint", "hint", "hint", MUSIC_VIEW_WRAPPER_TYPE_HINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 37 "../src/Widgets/SourceListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY, music_source_list_item_properties[MUSIC_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY] = g_param_spec_object ("activatable-icon", "activatable-icon", "activatable-icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 37 "../src/Widgets/SourceListView.vala"
	music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL] = g_signal_new ("playlist-rename-clicked", MUSIC_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, gtk_grid_get_type (), MUSIC_TYPE_SOURCE_LIST_ITEM);
#line 37 "../src/Widgets/SourceListView.vala"
	music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_EDIT_CLICKED_SIGNAL] = g_signal_new ("playlist-edit-clicked", MUSIC_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 37 "../src/Widgets/SourceListView.vala"
	music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL] = g_signal_new ("playlist-remove-clicked", MUSIC_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 37 "../src/Widgets/SourceListView.vala"
	music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_SAVE_CLICKED_SIGNAL] = g_signal_new ("playlist-save-clicked", MUSIC_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 37 "../src/Widgets/SourceListView.vala"
	music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_EXPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-export-clicked", MUSIC_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 37 "../src/Widgets/SourceListView.vala"
	music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_MEDIA_ADDED_SIGNAL] = g_signal_new ("playlist-media-added", MUSIC_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOXED_INT, G_TYPE_NONE, 3, gtk_grid_get_type (), G_TYPE_STRV, G_TYPE_INT);
#line 1174 "SourceListView.c"
}

static void
music_source_list_item_music_source_list_entry_interface_init (MusicSourceListEntryIface * iface,
                                                               gpointer iface_data)
{
#line 37 "../src/Widgets/SourceListView.vala"
	music_source_list_item_music_source_list_entry_parent_iface = g_type_interface_peek_parent (iface);
#line 1183 "SourceListView.c"
}

static void
music_source_list_item_granite_widgets_source_list_drag_dest_interface_init (GraniteWidgetsSourceListDragDestIface * iface,
                                                                             gpointer iface_data)
{
#line 37 "../src/Widgets/SourceListView.vala"
	music_source_list_item_granite_widgets_source_list_drag_dest_parent_iface = g_type_interface_peek_parent (iface);
#line 37 "../src/Widgets/SourceListView.vala"
	iface->data_drop_possible = (gboolean (*) (GraniteWidgetsSourceListDragDest*, GdkDragContext*, GtkSelectionData*)) music_source_list_item_real_data_drop_possible;
#line 37 "../src/Widgets/SourceListView.vala"
	iface->data_received = (GdkDragAction (*) (GraniteWidgetsSourceListDragDest*, GdkDragContext*, GtkSelectionData*)) music_source_list_item_real_data_received;
#line 1196 "SourceListView.c"
}

static void
music_source_list_item_instance_init (MusicSourceListItem * self,
                                      gpointer klass)
{
#line 37 "../src/Widgets/SourceListView.vala"
	self->priv = music_source_list_item_get_instance_private (self);
#line 1205 "SourceListView.c"
}

static void
music_source_list_item_finalize (GObject * obj)
{
	MusicSourceListItem * self;
#line 37 "../src/Widgets/SourceListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem);
#line 45 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->_view);
#line 47 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->_activatable_icon);
#line 49 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlist_menu);
#line 37 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (music_source_list_item_parent_class)->finalize (obj);
#line 1222 "SourceListView.c"
}

/**
 * SourceList item. It stores the number of the corresponding page in the notebook widget.
 */
static GType
music_source_list_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicSourceListItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_source_list_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicSourceListItem), 0, (GInstanceInitFunc) music_source_list_item_instance_init, NULL };
	static const GInterfaceInfo music_source_list_entry_info = { (GInterfaceInitFunc) music_source_list_item_music_source_list_entry_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo granite_widgets_source_list_drag_dest_info = { (GInterfaceInitFunc) music_source_list_item_granite_widgets_source_list_drag_dest_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_source_list_item_type_id;
	music_source_list_item_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, "MusicSourceListItem", &g_define_type_info, 0);
	g_type_add_interface_static (music_source_list_item_type_id, MUSIC_TYPE_SOURCE_LIST_ENTRY, &music_source_list_entry_info);
	g_type_add_interface_static (music_source_list_item_type_id, GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST, &granite_widgets_source_list_drag_dest_info);
	MusicSourceListItem_private_offset = g_type_add_instance_private (music_source_list_item_type_id, sizeof (MusicSourceListItemPrivate));
	return music_source_list_item_type_id;
}

GType
music_source_list_item_get_type (void)
{
	static volatile gsize music_source_list_item_type_id__once = 0;
	if (g_once_init_enter (&music_source_list_item_type_id__once)) {
		GType music_source_list_item_type_id;
		music_source_list_item_type_id = music_source_list_item_get_type_once ();
		g_once_init_leave (&music_source_list_item_type_id__once, music_source_list_item_type_id);
	}
	return music_source_list_item_type_id__once;
}

static void
_vala_music_source_list_item_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	MusicSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem);
#line 37 "../src/Widgets/SourceListView.vala"
	switch (property_id) {
#line 37 "../src/Widgets/SourceListView.vala"
		case MUSIC_SOURCE_LIST_ITEM_VIEW_PROPERTY:
#line 37 "../src/Widgets/SourceListView.vala"
		g_value_set_object (value, music_source_list_item_get_view (self));
#line 37 "../src/Widgets/SourceListView.vala"
		break;
#line 37 "../src/Widgets/SourceListView.vala"
		case MUSIC_SOURCE_LIST_ITEM_HINT_PROPERTY:
#line 37 "../src/Widgets/SourceListView.vala"
		g_value_set_enum (value, music_source_list_item_get_hint (self));
#line 37 "../src/Widgets/SourceListView.vala"
		break;
#line 37 "../src/Widgets/SourceListView.vala"
		case MUSIC_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY:
#line 37 "../src/Widgets/SourceListView.vala"
		g_value_set_object (value, music_source_list_item_get_activatable_icon (self));
#line 37 "../src/Widgets/SourceListView.vala"
		break;
#line 1282 "SourceListView.c"
		default:
#line 37 "../src/Widgets/SourceListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "../src/Widgets/SourceListView.vala"
		break;
#line 1288 "SourceListView.c"
	}
}

static void
_vala_music_source_list_item_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	MusicSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem);
#line 37 "../src/Widgets/SourceListView.vala"
	switch (property_id) {
#line 37 "../src/Widgets/SourceListView.vala"
		case MUSIC_SOURCE_LIST_ITEM_VIEW_PROPERTY:
#line 37 "../src/Widgets/SourceListView.vala"
		music_source_list_item_set_view (self, g_value_get_object (value));
#line 37 "../src/Widgets/SourceListView.vala"
		break;
#line 37 "../src/Widgets/SourceListView.vala"
		case MUSIC_SOURCE_LIST_ITEM_HINT_PROPERTY:
#line 37 "../src/Widgets/SourceListView.vala"
		music_source_list_item_set_hint (self, g_value_get_enum (value));
#line 37 "../src/Widgets/SourceListView.vala"
		break;
#line 37 "../src/Widgets/SourceListView.vala"
		case MUSIC_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY:
#line 37 "../src/Widgets/SourceListView.vala"
		music_source_list_item_set_activatable_icon (self, g_value_get_object (value));
#line 37 "../src/Widgets/SourceListView.vala"
		break;
#line 1320 "SourceListView.c"
		default:
#line 37 "../src/Widgets/SourceListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "../src/Widgets/SourceListView.vala"
		break;
#line 1326 "SourceListView.c"
	}
}

static inline gpointer
music_source_list_expandable_item_get_instance_private (MusicSourceListExpandableItem* self)
{
	return G_STRUCT_MEMBER_P (self, MusicSourceListExpandableItem_private_offset);
}

static Block32Data*
block32_data_ref (Block32Data* _data32_)
{
#line 146 "../src/Widgets/SourceListView.vala"
	g_atomic_int_inc (&_data32_->_ref_count_);
#line 146 "../src/Widgets/SourceListView.vala"
	return _data32_;
#line 1343 "SourceListView.c"
}

static void
block32_data_unref (void * _userdata_)
{
	Block32Data* _data32_;
	_data32_ = (Block32Data*) _userdata_;
#line 146 "../src/Widgets/SourceListView.vala"
	if (g_atomic_int_dec_and_test (&_data32_->_ref_count_)) {
#line 1353 "SourceListView.c"
		MusicSourceListExpandableItem* self;
#line 146 "../src/Widgets/SourceListView.vala"
		self = _data32_->self;
#line 146 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_data32_->view);
#line 146 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (self);
#line 146 "../src/Widgets/SourceListView.vala"
		g_slice_free (Block32Data, _data32_);
#line 1363 "SourceListView.c"
	}
}

static void
___lambda88_ (Block32Data* _data32_)
{
	MusicSourceListExpandableItem* self;
#line 158 "../src/Widgets/SourceListView.vala"
	self = _data32_->self;
#line 159 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_IMPORT_CLICKED_SIGNAL], 0, _data32_->view);
#line 1375 "SourceListView.c"
}

static void
____lambda88__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 158 "../src/Widgets/SourceListView.vala"
	___lambda88_ (self);
#line 1384 "SourceListView.c"
}

static void
___lambda89_ (Block32Data* _data32_)
{
	MusicSourceListExpandableItem* self;
#line 167 "../src/Widgets/SourceListView.vala"
	self = _data32_->self;
#line 168 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_EJECT_CLICKED_SIGNAL], 0, _data32_->view);
#line 1395 "SourceListView.c"
}

static void
____lambda89__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 167 "../src/Widgets/SourceListView.vala"
	___lambda89_ (self);
#line 1404 "SourceListView.c"
}

static void
_____lambda90_ (Block32Data* _data32_)
{
	MusicSourceListExpandableItem* self;
#line 177 "../src/Widgets/SourceListView.vala"
	self = _data32_->self;
#line 178 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL], 0, _data32_->view);
#line 1415 "SourceListView.c"
}

static void
______lambda90__gtk_menu_item_activate (GtkMenuItem* _sender,
                                        gpointer self)
{
#line 177 "../src/Widgets/SourceListView.vala"
	_____lambda90_ (self);
#line 1424 "SourceListView.c"
}

static void
_____lambda91_ (Block32Data* _data32_)
{
	MusicSourceListExpandableItem* self;
#line 185 "../src/Widgets/SourceListView.vala"
	self = _data32_->self;
#line 186 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL], 0, _data32_->view);
#line 1435 "SourceListView.c"
}

static void
______lambda91__gtk_menu_item_activate (GtkMenuItem* _sender,
                                        gpointer self)
{
#line 185 "../src/Widgets/SourceListView.vala"
	_____lambda91_ (self);
#line 1444 "SourceListView.c"
}

static void
_____lambda92_ (Block32Data* _data32_)
{
	MusicSourceListExpandableItem* self;
#line 193 "../src/Widgets/SourceListView.vala"
	self = _data32_->self;
#line 194 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_SYNC_CLICKED_SIGNAL], 0, _data32_->view);
#line 1455 "SourceListView.c"
}

static void
______lambda92__gtk_menu_item_activate (GtkMenuItem* _sender,
                                        gpointer self)
{
#line 193 "../src/Widgets/SourceListView.vala"
	_____lambda92_ (self);
#line 1464 "SourceListView.c"
}

MusicSourceListExpandableItem*
music_source_list_expandable_item_construct (GType object_type,
                                             GtkGrid* view,
                                             const gchar* name,
                                             MusicViewWrapperHint hint,
                                             GIcon* icon,
                                             GIcon* activatable_icon,
                                             GObject* give_more_information)
{
	MusicSourceListExpandableItem * self = NULL;
	Block32Data* _data32_;
	GtkGrid* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp28_;
#line 146 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 146 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 146 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 146 "../src/Widgets/SourceListView.vala"
	_data32_ = g_slice_new0 (Block32Data);
#line 146 "../src/Widgets/SourceListView.vala"
	_data32_->_ref_count_ = 1;
#line 146 "../src/Widgets/SourceListView.vala"
	_tmp0_ = _g_object_ref0 (view);
#line 146 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (_data32_->view);
#line 146 "../src/Widgets/SourceListView.vala"
	_data32_->view = _tmp0_;
#line 147 "../src/Widgets/SourceListView.vala"
	self = (MusicSourceListExpandableItem*) granite_widgets_source_list_expandable_item_construct (object_type, name);
#line 147 "../src/Widgets/SourceListView.vala"
	_data32_->self = g_object_ref (self);
#line 148 "../src/Widgets/SourceListView.vala"
	music_source_list_expandable_item_set_view (self, _data32_->view);
#line 149 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_item_set_icon ((GraniteWidgetsSourceListItem*) self, icon);
#line 150 "../src/Widgets/SourceListView.vala"
	self->hint = hint;
#line 151 "../src/Widgets/SourceListView.vala"
	if (activatable_icon != NULL) {
#line 152 "../src/Widgets/SourceListView.vala"
		granite_widgets_source_list_item_set_activatable ((GraniteWidgetsSourceListItem*) self, activatable_icon);
#line 1511 "SourceListView.c"
	}
#line 154 "../src/Widgets/SourceListView.vala"
	_tmp1_ = (GtkMenu*) gtk_menu_new ();
#line 154 "../src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp1_);
#line 154 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->device_menu);
#line 154 "../src/Widgets/SourceListView.vala"
	self->priv->device_menu = _tmp1_;
#line 156 "../src/Widgets/SourceListView.vala"
	if (hint == MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO) {
#line 1523 "SourceListView.c"
		GtkMenuItem* import_menuitem = NULL;
		GtkMenuItem* _tmp2_;
		GtkMenuItem* _tmp3_;
		GtkMenu* _tmp4_;
		GtkMenuItem* _tmp5_;
#line 157 "../src/Widgets/SourceListView.vala"
		_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Import to Library"));
#line 157 "../src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp2_);
#line 157 "../src/Widgets/SourceListView.vala"
		import_menuitem = _tmp2_;
#line 158 "../src/Widgets/SourceListView.vala"
		_tmp3_ = import_menuitem;
#line 158 "../src/Widgets/SourceListView.vala"
		g_signal_connect_data (_tmp3_, "activate", (GCallback) ____lambda88__gtk_menu_item_activate, block32_data_ref (_data32_), (GClosureNotify) block32_data_unref, 0);
#line 162 "../src/Widgets/SourceListView.vala"
		_tmp4_ = self->priv->device_menu;
#line 162 "../src/Widgets/SourceListView.vala"
		_tmp5_ = import_menuitem;
#line 162 "../src/Widgets/SourceListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp4_, _tmp5_);
#line 156 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (import_menuitem);
#line 1547 "SourceListView.c"
	}
#line 165 "../src/Widgets/SourceListView.vala"
	if (hint == MUSIC_VIEW_WRAPPER_HINT_DEVICE) {
#line 1551 "SourceListView.c"
		GtkMenuItem* eject_menuitem = NULL;
		GtkMenuItem* _tmp6_;
		GtkMenuItem* _tmp7_;
		GtkMenu* _tmp26_;
		GtkMenuItem* _tmp27_;
#line 166 "../src/Widgets/SourceListView.vala"
		_tmp6_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Eject"));
#line 166 "../src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp6_);
#line 166 "../src/Widgets/SourceListView.vala"
		eject_menuitem = _tmp6_;
#line 167 "../src/Widgets/SourceListView.vala"
		_tmp7_ = eject_menuitem;
#line 167 "../src/Widgets/SourceListView.vala"
		g_signal_connect_data (_tmp7_, "activate", (GCallback) ____lambda89__gtk_menu_item_activate, block32_data_ref (_data32_), (GClosureNotify) block32_data_unref, 0);
#line 171 "../src/Widgets/SourceListView.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (give_more_information, MUSIC_TYPE_DEVICE)) {
#line 1569 "SourceListView.c"
			MusicDevice* device = NULL;
			MusicDevice* _tmp8_;
			MusicLibrary* device_library = NULL;
			MusicDevice* _tmp9_;
			MusicLibrary* _tmp10_;
			MusicLibrary* _tmp11_;
			MusicLibrary* _tmp16_;
			MusicDevice* _tmp21_;
#line 172 "../src/Widgets/SourceListView.vala"
			_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (give_more_information, MUSIC_TYPE_DEVICE, MusicDevice));
#line 172 "../src/Widgets/SourceListView.vala"
			device = _tmp8_;
#line 173 "../src/Widgets/SourceListView.vala"
			_tmp9_ = device;
#line 173 "../src/Widgets/SourceListView.vala"
			_tmp10_ = music_device_get_library (_tmp9_);
#line 173 "../src/Widgets/SourceListView.vala"
			device_library = _tmp10_;
#line 175 "../src/Widgets/SourceListView.vala"
			_tmp11_ = device_library;
#line 175 "../src/Widgets/SourceListView.vala"
			if (music_library_support_playlists (_tmp11_)) {
#line 1592 "SourceListView.c"
				GtkMenuItem* add_playlist_menuitem = NULL;
				GtkMenuItem* _tmp12_;
				GtkMenuItem* _tmp13_;
				GtkMenu* _tmp14_;
				GtkMenuItem* _tmp15_;
#line 176 "../src/Widgets/SourceListView.vala"
				_tmp12_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Playlist"));
#line 176 "../src/Widgets/SourceListView.vala"
				g_object_ref_sink (_tmp12_);
#line 176 "../src/Widgets/SourceListView.vala"
				add_playlist_menuitem = _tmp12_;
#line 177 "../src/Widgets/SourceListView.vala"
				_tmp13_ = add_playlist_menuitem;
#line 177 "../src/Widgets/SourceListView.vala"
				g_signal_connect_data (_tmp13_, "activate", (GCallback) ______lambda90__gtk_menu_item_activate, block32_data_ref (_data32_), (GClosureNotify) block32_data_unref, 0);
#line 180 "../src/Widgets/SourceListView.vala"
				_tmp14_ = self->priv->device_menu;
#line 180 "../src/Widgets/SourceListView.vala"
				_tmp15_ = add_playlist_menuitem;
#line 180 "../src/Widgets/SourceListView.vala"
				gtk_menu_shell_append ((GtkMenuShell*) _tmp14_, _tmp15_);
#line 175 "../src/Widgets/SourceListView.vala"
				_g_object_unref0 (add_playlist_menuitem);
#line 1616 "SourceListView.c"
			}
#line 183 "../src/Widgets/SourceListView.vala"
			_tmp16_ = device_library;
#line 183 "../src/Widgets/SourceListView.vala"
			if (music_library_support_smart_playlists (_tmp16_)) {
#line 1622 "SourceListView.c"
				GtkMenuItem* add_smart_playlist_menuitem = NULL;
				GtkMenuItem* _tmp17_;
				GtkMenuItem* _tmp18_;
				GtkMenu* _tmp19_;
				GtkMenuItem* _tmp20_;
#line 184 "../src/Widgets/SourceListView.vala"
				_tmp17_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Smart Playlist"));
#line 184 "../src/Widgets/SourceListView.vala"
				g_object_ref_sink (_tmp17_);
#line 184 "../src/Widgets/SourceListView.vala"
				add_smart_playlist_menuitem = _tmp17_;
#line 185 "../src/Widgets/SourceListView.vala"
				_tmp18_ = add_smart_playlist_menuitem;
#line 185 "../src/Widgets/SourceListView.vala"
				g_signal_connect_data (_tmp18_, "activate", (GCallback) ______lambda91__gtk_menu_item_activate, block32_data_ref (_data32_), (GClosureNotify) block32_data_unref, 0);
#line 188 "../src/Widgets/SourceListView.vala"
				_tmp19_ = self->priv->device_menu;
#line 188 "../src/Widgets/SourceListView.vala"
				_tmp20_ = add_smart_playlist_menuitem;
#line 188 "../src/Widgets/SourceListView.vala"
				gtk_menu_shell_append ((GtkMenuShell*) _tmp19_, _tmp20_);
#line 183 "../src/Widgets/SourceListView.vala"
				_g_object_unref0 (add_smart_playlist_menuitem);
#line 1646 "SourceListView.c"
			}
#line 191 "../src/Widgets/SourceListView.vala"
			_tmp21_ = device;
#line 191 "../src/Widgets/SourceListView.vala"
			if (music_device_read_only (_tmp21_) == FALSE) {
#line 1652 "SourceListView.c"
				GtkMenuItem* sync_menuitem = NULL;
				GtkMenuItem* _tmp22_;
				GtkMenuItem* _tmp23_;
				GtkMenu* _tmp24_;
				GtkMenuItem* _tmp25_;
#line 192 "../src/Widgets/SourceListView.vala"
				_tmp22_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Sync"));
#line 192 "../src/Widgets/SourceListView.vala"
				g_object_ref_sink (_tmp22_);
#line 192 "../src/Widgets/SourceListView.vala"
				sync_menuitem = _tmp22_;
#line 193 "../src/Widgets/SourceListView.vala"
				_tmp23_ = sync_menuitem;
#line 193 "../src/Widgets/SourceListView.vala"
				g_signal_connect_data (_tmp23_, "activate", (GCallback) ______lambda92__gtk_menu_item_activate, block32_data_ref (_data32_), (GClosureNotify) block32_data_unref, 0);
#line 196 "../src/Widgets/SourceListView.vala"
				_tmp24_ = self->priv->device_menu;
#line 196 "../src/Widgets/SourceListView.vala"
				_tmp25_ = sync_menuitem;
#line 196 "../src/Widgets/SourceListView.vala"
				gtk_menu_shell_append ((GtkMenuShell*) _tmp24_, _tmp25_);
#line 191 "../src/Widgets/SourceListView.vala"
				_g_object_unref0 (sync_menuitem);
#line 1676 "SourceListView.c"
			}
#line 171 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (device_library);
#line 171 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 1682 "SourceListView.c"
		}
#line 199 "../src/Widgets/SourceListView.vala"
		_tmp26_ = self->priv->device_menu;
#line 199 "../src/Widgets/SourceListView.vala"
		_tmp27_ = eject_menuitem;
#line 199 "../src/Widgets/SourceListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp26_, _tmp27_);
#line 165 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (eject_menuitem);
#line 1692 "SourceListView.c"
	}
#line 202 "../src/Widgets/SourceListView.vala"
	_tmp28_ = self->priv->device_menu;
#line 202 "../src/Widgets/SourceListView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp28_);
#line 146 "../src/Widgets/SourceListView.vala"
	block32_data_unref (_data32_);
#line 146 "../src/Widgets/SourceListView.vala"
	_data32_ = NULL;
#line 146 "../src/Widgets/SourceListView.vala"
	return self;
#line 1704 "SourceListView.c"
}

MusicSourceListExpandableItem*
music_source_list_expandable_item_new (GtkGrid* view,
                                       const gchar* name,
                                       MusicViewWrapperHint hint,
                                       GIcon* icon,
                                       GIcon* activatable_icon,
                                       GObject* give_more_information)
{
#line 146 "../src/Widgets/SourceListView.vala"
	return music_source_list_expandable_item_construct (MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, view, name, hint, icon, activatable_icon, give_more_information);
#line 1717 "SourceListView.c"
}

static GtkMenu*
music_source_list_expandable_item_real_get_context_menu (GraniteWidgetsSourceListItem* base)
{
	MusicSourceListExpandableItem * self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* result;
#line 205 "../src/Widgets/SourceListView.vala"
	self = (MusicSourceListExpandableItem*) base;
#line 206 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->device_menu;
#line 206 "../src/Widgets/SourceListView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 206 "../src/Widgets/SourceListView.vala"
	result = _tmp1_;
#line 206 "../src/Widgets/SourceListView.vala"
	return result;
#line 1737 "SourceListView.c"
}

GtkGrid*
music_source_list_expandable_item_get_view (MusicSourceListExpandableItem* self)
{
	GtkGrid* result;
	GtkGrid* _tmp0_;
#line 135 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 135 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 135 "../src/Widgets/SourceListView.vala"
	result = _tmp0_;
#line 135 "../src/Widgets/SourceListView.vala"
	return result;
#line 1753 "SourceListView.c"
}

void
music_source_list_expandable_item_set_view (MusicSourceListExpandableItem* self,
                                            GtkGrid* value)
{
	GtkGrid* old_value;
#line 135 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 135 "../src/Widgets/SourceListView.vala"
	old_value = music_source_list_expandable_item_get_view (self);
#line 135 "../src/Widgets/SourceListView.vala"
	if (old_value != value) {
#line 1767 "SourceListView.c"
		GtkGrid* _tmp0_;
#line 135 "../src/Widgets/SourceListView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 135 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->_view);
#line 135 "../src/Widgets/SourceListView.vala"
		self->priv->_view = _tmp0_;
#line 135 "../src/Widgets/SourceListView.vala"
		g_object_notify_by_pspec ((GObject *) self, music_source_list_expandable_item_properties[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY]);
#line 1777 "SourceListView.c"
	}
}

static void
music_source_list_expandable_item_class_init (MusicSourceListExpandableItemClass * klass,
                                              gpointer klass_data)
{
#line 134 "../src/Widgets/SourceListView.vala"
	music_source_list_expandable_item_parent_class = g_type_class_peek_parent (klass);
#line 134 "../src/Widgets/SourceListView.vala"
	g_type_class_adjust_private_offset (klass, &MusicSourceListExpandableItem_private_offset);
#line 134 "../src/Widgets/SourceListView.vala"
	((GraniteWidgetsSourceListItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListItem*)) music_source_list_expandable_item_real_get_context_menu;
#line 134 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_source_list_expandable_item_get_property;
#line 134 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_source_list_expandable_item_set_property;
#line 134 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->finalize = music_source_list_expandable_item_finalize;
#line 134 "../src/Widgets/SourceListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY, music_source_list_expandable_item_properties[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", gtk_grid_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 134 "../src/Widgets/SourceListView.vala"
	music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_IMPORT_CLICKED_SIGNAL] = g_signal_new ("device-import-clicked", MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 134 "../src/Widgets/SourceListView.vala"
	music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_EJECT_CLICKED_SIGNAL] = g_signal_new ("device-eject-clicked", MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 134 "../src/Widgets/SourceListView.vala"
	music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_SYNC_CLICKED_SIGNAL] = g_signal_new ("device-sync-clicked", MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 134 "../src/Widgets/SourceListView.vala"
	music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-playlist-clicked", MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 134 "../src/Widgets/SourceListView.vala"
	music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-smartplaylist-clicked", MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 1809 "SourceListView.c"
}

static void
music_source_list_expandable_item_music_source_list_entry_interface_init (MusicSourceListEntryIface * iface,
                                                                          gpointer iface_data)
{
#line 134 "../src/Widgets/SourceListView.vala"
	music_source_list_expandable_item_music_source_list_entry_parent_iface = g_type_interface_peek_parent (iface);
#line 1818 "SourceListView.c"
}

static void
music_source_list_expandable_item_instance_init (MusicSourceListExpandableItem * self,
                                                 gpointer klass)
{
#line 134 "../src/Widgets/SourceListView.vala"
	self->priv = music_source_list_expandable_item_get_instance_private (self);
#line 1827 "SourceListView.c"
}

static void
music_source_list_expandable_item_finalize (GObject * obj)
{
	MusicSourceListExpandableItem * self;
#line 134 "../src/Widgets/SourceListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem);
#line 135 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->_view);
#line 138 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->device_menu);
#line 134 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (music_source_list_expandable_item_parent_class)->finalize (obj);
#line 1842 "SourceListView.c"
}

static GType
music_source_list_expandable_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicSourceListExpandableItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_source_list_expandable_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicSourceListExpandableItem), 0, (GInstanceInitFunc) music_source_list_expandable_item_instance_init, NULL };
	static const GInterfaceInfo music_source_list_entry_info = { (GInterfaceInitFunc) music_source_list_expandable_item_music_source_list_entry_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_source_list_expandable_item_type_id;
	music_source_list_expandable_item_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, "MusicSourceListExpandableItem", &g_define_type_info, 0);
	g_type_add_interface_static (music_source_list_expandable_item_type_id, MUSIC_TYPE_SOURCE_LIST_ENTRY, &music_source_list_entry_info);
	MusicSourceListExpandableItem_private_offset = g_type_add_instance_private (music_source_list_expandable_item_type_id, sizeof (MusicSourceListExpandableItemPrivate));
	return music_source_list_expandable_item_type_id;
}

GType
music_source_list_expandable_item_get_type (void)
{
	static volatile gsize music_source_list_expandable_item_type_id__once = 0;
	if (g_once_init_enter (&music_source_list_expandable_item_type_id__once)) {
		GType music_source_list_expandable_item_type_id;
		music_source_list_expandable_item_type_id = music_source_list_expandable_item_get_type_once ();
		g_once_init_leave (&music_source_list_expandable_item_type_id__once, music_source_list_expandable_item_type_id);
	}
	return music_source_list_expandable_item_type_id__once;
}

static void
_vala_music_source_list_expandable_item_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec)
{
	MusicSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem);
#line 134 "../src/Widgets/SourceListView.vala"
	switch (property_id) {
#line 134 "../src/Widgets/SourceListView.vala"
		case MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY:
#line 134 "../src/Widgets/SourceListView.vala"
		g_value_set_object (value, music_source_list_expandable_item_get_view (self));
#line 134 "../src/Widgets/SourceListView.vala"
		break;
#line 1885 "SourceListView.c"
		default:
#line 134 "../src/Widgets/SourceListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 134 "../src/Widgets/SourceListView.vala"
		break;
#line 1891 "SourceListView.c"
	}
}

static void
_vala_music_source_list_expandable_item_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec)
{
	MusicSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem);
#line 134 "../src/Widgets/SourceListView.vala"
	switch (property_id) {
#line 134 "../src/Widgets/SourceListView.vala"
		case MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY:
#line 134 "../src/Widgets/SourceListView.vala"
		music_source_list_expandable_item_set_view (self, g_value_get_object (value));
#line 134 "../src/Widgets/SourceListView.vala"
		break;
#line 1911 "SourceListView.c"
		default:
#line 134 "../src/Widgets/SourceListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 134 "../src/Widgets/SourceListView.vala"
		break;
#line 1917 "SourceListView.c"
	}
}

static inline gpointer
music_play_list_category_get_instance_private (MusicPlayListCategory* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPlayListCategory_private_offset);
}

MusicPlayListCategory*
music_play_list_category_construct (GType object_type,
                                    const gchar* name)
{
	MusicPlayListCategory * self = NULL;
#line 214 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 215 "../src/Widgets/SourceListView.vala"
	self = (MusicPlayListCategory*) g_object_new (object_type, "name", name, NULL);
#line 214 "../src/Widgets/SourceListView.vala"
	return self;
#line 1938 "SourceListView.c"
}

MusicPlayListCategory*
music_play_list_category_new (const gchar* name)
{
#line 214 "../src/Widgets/SourceListView.vala"
	return music_play_list_category_construct (MUSIC_TYPE_PLAY_LIST_CATEGORY, name);
#line 1946 "SourceListView.c"
}

static GtkMenu*
music_play_list_category_real_get_context_menu (GraniteWidgetsSourceListItem* base)
{
	MusicPlayListCategory * self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* result;
#line 242 "../src/Widgets/SourceListView.vala"
	self = (MusicPlayListCategory*) base;
#line 243 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->playlist_menu;
#line 243 "../src/Widgets/SourceListView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 243 "../src/Widgets/SourceListView.vala"
	result = _tmp1_;
#line 243 "../src/Widgets/SourceListView.vala"
	return result;
#line 1966 "SourceListView.c"
}

static gboolean
music_play_list_category_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base)
{
	MusicPlayListCategory * self;
	gboolean result;
#line 247 "../src/Widgets/SourceListView.vala"
	self = (MusicPlayListCategory*) base;
#line 248 "../src/Widgets/SourceListView.vala"
	result = TRUE;
#line 248 "../src/Widgets/SourceListView.vala"
	return result;
#line 1980 "SourceListView.c"
}

static gint
music_play_list_category_real_compare (GraniteWidgetsSourceListSortable* base,
                                       GraniteWidgetsSourceListItem* a,
                                       GraniteWidgetsSourceListItem* b)
{
	MusicPlayListCategory * self;
	MusicSourceListItem* item_a = NULL;
	MusicSourceListItem* _tmp0_;
	MusicSourceListItem* item_b = NULL;
	MusicSourceListItem* _tmp1_;
	gboolean _tmp2_ = FALSE;
	MusicSourceListItem* _tmp3_;
	MusicSourceListItem* _tmp5_;
	MusicViewWrapperHint _tmp6_;
	MusicViewWrapperHint _tmp7_;
	MusicSourceListItem* _tmp23_;
	MusicViewWrapperHint _tmp24_;
	MusicViewWrapperHint _tmp25_;
	MusicSourceListItem* _tmp35_;
	MusicViewWrapperHint _tmp36_;
	MusicViewWrapperHint _tmp37_;
	gint result;
#line 251 "../src/Widgets/SourceListView.vala"
	self = (MusicPlayListCategory*) base;
#line 251 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 251 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 252 "../src/Widgets/SourceListView.vala"
	_tmp0_ = _g_object_ref0 (MUSIC_IS_SOURCE_LIST_ITEM (a) ? ((MusicSourceListItem*) a) : NULL);
#line 252 "../src/Widgets/SourceListView.vala"
	item_a = _tmp0_;
#line 253 "../src/Widgets/SourceListView.vala"
	_tmp1_ = _g_object_ref0 (MUSIC_IS_SOURCE_LIST_ITEM (b) ? ((MusicSourceListItem*) b) : NULL);
#line 253 "../src/Widgets/SourceListView.vala"
	item_b = _tmp1_;
#line 255 "../src/Widgets/SourceListView.vala"
	_tmp3_ = item_a;
#line 255 "../src/Widgets/SourceListView.vala"
	if (_tmp3_ == NULL) {
#line 255 "../src/Widgets/SourceListView.vala"
		_tmp2_ = TRUE;
#line 2025 "SourceListView.c"
	} else {
		MusicSourceListItem* _tmp4_;
#line 255 "../src/Widgets/SourceListView.vala"
		_tmp4_ = item_b;
#line 255 "../src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp4_ == NULL;
#line 2032 "SourceListView.c"
	}
#line 255 "../src/Widgets/SourceListView.vala"
	if (_tmp2_) {
#line 256 "../src/Widgets/SourceListView.vala"
		result = 0;
#line 256 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_b);
#line 256 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_a);
#line 256 "../src/Widgets/SourceListView.vala"
		return result;
#line 2044 "SourceListView.c"
	}
#line 258 "../src/Widgets/SourceListView.vala"
	_tmp5_ = item_a;
#line 258 "../src/Widgets/SourceListView.vala"
	_tmp6_ = music_source_list_item_get_hint (_tmp5_);
#line 258 "../src/Widgets/SourceListView.vala"
	_tmp7_ = _tmp6_;
#line 258 "../src/Widgets/SourceListView.vala"
	if (_tmp7_ == MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
#line 2054 "SourceListView.c"
		MusicSourceListItem* _tmp8_;
		MusicViewWrapperHint _tmp9_;
		MusicViewWrapperHint _tmp10_;
#line 260 "../src/Widgets/SourceListView.vala"
		_tmp8_ = item_b;
#line 260 "../src/Widgets/SourceListView.vala"
		_tmp9_ = music_source_list_item_get_hint (_tmp8_);
#line 260 "../src/Widgets/SourceListView.vala"
		_tmp10_ = _tmp9_;
#line 260 "../src/Widgets/SourceListView.vala"
		if (_tmp10_ == MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
#line 2066 "SourceListView.c"
			GCompareFunc _tmp11_;
			MusicSourceListItem* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			MusicSourceListItem* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			gint _tmp22_;
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp11_ = ((GCompareFunc) g_strcmp0);
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp12_ = item_a;
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp13_ = granite_widgets_source_list_item_get_name ((GraniteWidgetsSourceListItem*) _tmp12_);
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp14_ = _tmp13_;
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp15_ = g_utf8_collate_key (_tmp14_, (gssize) -1);
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp16_ = _tmp15_;
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp17_ = item_b;
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp18_ = granite_widgets_source_list_item_get_name ((GraniteWidgetsSourceListItem*) _tmp17_);
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp19_ = _tmp18_;
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp20_ = g_utf8_collate_key (_tmp19_, (gssize) -1);
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp21_ = _tmp20_;
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp22_ = _tmp11_ (_tmp16_, _tmp21_);
#line 261 "../src/Widgets/SourceListView.vala"
			_g_free0 (_tmp21_);
#line 261 "../src/Widgets/SourceListView.vala"
			_g_free0 (_tmp16_);
#line 261 "../src/Widgets/SourceListView.vala"
			result = _tmp22_;
#line 261 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_b);
#line 261 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_a);
#line 261 "../src/Widgets/SourceListView.vala"
			return result;
#line 2115 "SourceListView.c"
		}
#line 264 "../src/Widgets/SourceListView.vala"
		result = -1;
#line 264 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_b);
#line 264 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_a);
#line 264 "../src/Widgets/SourceListView.vala"
		return result;
#line 2125 "SourceListView.c"
	}
#line 267 "../src/Widgets/SourceListView.vala"
	_tmp23_ = item_a;
#line 267 "../src/Widgets/SourceListView.vala"
	_tmp24_ = music_source_list_item_get_hint (_tmp23_);
#line 267 "../src/Widgets/SourceListView.vala"
	_tmp25_ = _tmp24_;
#line 267 "../src/Widgets/SourceListView.vala"
	if (_tmp25_ == MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST) {
#line 2135 "SourceListView.c"
		MusicSourceListItem* _tmp26_;
		MusicViewWrapperHint _tmp27_;
		MusicViewWrapperHint _tmp28_;
		MusicSourceListItem* _tmp29_;
		MusicViewWrapperHint _tmp30_;
		MusicViewWrapperHint _tmp31_;
		MusicSourceListItem* _tmp32_;
		MusicViewWrapperHint _tmp33_;
		MusicViewWrapperHint _tmp34_;
#line 269 "../src/Widgets/SourceListView.vala"
		_tmp26_ = item_b;
#line 269 "../src/Widgets/SourceListView.vala"
		_tmp27_ = music_source_list_item_get_hint (_tmp26_);
#line 269 "../src/Widgets/SourceListView.vala"
		_tmp28_ = _tmp27_;
#line 269 "../src/Widgets/SourceListView.vala"
		if (_tmp28_ == MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
#line 270 "../src/Widgets/SourceListView.vala"
			result = 1;
#line 270 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_b);
#line 270 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_a);
#line 270 "../src/Widgets/SourceListView.vala"
			return result;
#line 2161 "SourceListView.c"
		}
#line 273 "../src/Widgets/SourceListView.vala"
		_tmp29_ = item_b;
#line 273 "../src/Widgets/SourceListView.vala"
		_tmp30_ = music_source_list_item_get_hint (_tmp29_);
#line 273 "../src/Widgets/SourceListView.vala"
		_tmp31_ = _tmp30_;
#line 273 "../src/Widgets/SourceListView.vala"
		if (_tmp31_ == MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST) {
#line 274 "../src/Widgets/SourceListView.vala"
			result = 0;
#line 274 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_b);
#line 274 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_a);
#line 274 "../src/Widgets/SourceListView.vala"
			return result;
#line 2179 "SourceListView.c"
		}
#line 277 "../src/Widgets/SourceListView.vala"
		_tmp32_ = item_b;
#line 277 "../src/Widgets/SourceListView.vala"
		_tmp33_ = music_source_list_item_get_hint (_tmp32_);
#line 277 "../src/Widgets/SourceListView.vala"
		_tmp34_ = _tmp33_;
#line 277 "../src/Widgets/SourceListView.vala"
		if (_tmp34_ == MUSIC_VIEW_WRAPPER_HINT_PLAYLIST) {
#line 278 "../src/Widgets/SourceListView.vala"
			result = -1;
#line 278 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_b);
#line 278 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_a);
#line 278 "../src/Widgets/SourceListView.vala"
			return result;
#line 2197 "SourceListView.c"
		}
	}
#line 281 "../src/Widgets/SourceListView.vala"
	_tmp35_ = item_a;
#line 281 "../src/Widgets/SourceListView.vala"
	_tmp36_ = music_source_list_item_get_hint (_tmp35_);
#line 281 "../src/Widgets/SourceListView.vala"
	_tmp37_ = _tmp36_;
#line 281 "../src/Widgets/SourceListView.vala"
	if (_tmp37_ == MUSIC_VIEW_WRAPPER_HINT_PLAYLIST) {
#line 2208 "SourceListView.c"
		MusicSourceListItem* _tmp38_;
		MusicViewWrapperHint _tmp39_;
		MusicViewWrapperHint _tmp40_;
#line 283 "../src/Widgets/SourceListView.vala"
		_tmp38_ = item_b;
#line 283 "../src/Widgets/SourceListView.vala"
		_tmp39_ = music_source_list_item_get_hint (_tmp38_);
#line 283 "../src/Widgets/SourceListView.vala"
		_tmp40_ = _tmp39_;
#line 283 "../src/Widgets/SourceListView.vala"
		if (_tmp40_ == MUSIC_VIEW_WRAPPER_HINT_PLAYLIST) {
#line 284 "../src/Widgets/SourceListView.vala"
			result = 0;
#line 284 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_b);
#line 284 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_a);
#line 284 "../src/Widgets/SourceListView.vala"
			return result;
#line 2228 "SourceListView.c"
		}
#line 287 "../src/Widgets/SourceListView.vala"
		result = 1;
#line 287 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_b);
#line 287 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_a);
#line 287 "../src/Widgets/SourceListView.vala"
		return result;
#line 2238 "SourceListView.c"
	}
#line 290 "../src/Widgets/SourceListView.vala"
	result = 0;
#line 290 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (item_b);
#line 290 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (item_a);
#line 290 "../src/Widgets/SourceListView.vala"
	return result;
#line 2248 "SourceListView.c"
}

static void
_music_play_list_category___lambda84_ (MusicPlayListCategory* self)
{
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	MusicLocalLibrary* _tmp2_;
	MusicLocalLibrary* _tmp3_;
#line 230 "../src/Widgets/SourceListView.vala"
	_tmp0_ = music_app_get_main_window ();
#line 230 "../src/Widgets/SourceListView.vala"
	_tmp1_ = _tmp0_;
#line 230 "../src/Widgets/SourceListView.vala"
	_tmp2_ = music_library_window_get_library_manager (self);
#line 230 "../src/Widgets/SourceListView.vala"
	_tmp3_ = _tmp2_;
#line 230 "../src/Widgets/SourceListView.vala"
	music_library_window_create_new_playlist (_tmp1_, (MusicLibrary*) _tmp3_);
#line 2268 "SourceListView.c"
}

static void
__music_play_list_category___lambda84__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self)
{
#line 229 "../src/Widgets/SourceListView.vala"
	_music_play_list_category___lambda84_ ((MusicPlayListCategory*) self);
#line 2277 "SourceListView.c"
}

static void
_music_play_list_category___lambda85_ (MusicPlayListCategory* self)
{
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
#line 234 "../src/Widgets/SourceListView.vala"
	_tmp0_ = music_app_get_main_window ();
#line 234 "../src/Widgets/SourceListView.vala"
	_tmp1_ = _tmp0_;
#line 234 "../src/Widgets/SourceListView.vala"
	music_library_window_show_smart_playlist_dialog (_tmp1_, NULL);
#line 2291 "SourceListView.c"
}

static void
__music_play_list_category___lambda85__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self)
{
#line 233 "../src/Widgets/SourceListView.vala"
	_music_play_list_category___lambda85_ ((MusicPlayListCategory*) self);
#line 2300 "SourceListView.c"
}

static void
_music_play_list_category___lambda86_ (MusicPlayListCategory* self)
{
#line 238 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_play_list_category_signals[MUSIC_PLAY_LIST_CATEGORY_PLAYLIST_IMPORT_CLICKED_SIGNAL], 0);
#line 2308 "SourceListView.c"
}

static void
__music_play_list_category___lambda86__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self)
{
#line 237 "../src/Widgets/SourceListView.vala"
	_music_play_list_category___lambda86_ ((MusicPlayListCategory*) self);
#line 2317 "SourceListView.c"
}

static GObject *
music_play_list_category_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicPlayListCategory * self;
	GtkMenuItem* playlist_new = NULL;
	GtkMenuItem* _tmp0_;
	GtkMenuItem* smart_playlist_new = NULL;
	GtkMenuItem* _tmp1_;
	GtkMenuItem* playlist_import = NULL;
	GtkMenuItem* _tmp2_;
	GtkMenu* _tmp3_;
	GtkMenu* _tmp4_;
	GtkMenuItem* _tmp5_;
	GtkMenu* _tmp6_;
	GtkMenuItem* _tmp7_;
	GtkMenu* _tmp8_;
	GtkMenuItem* _tmp9_;
	GtkMenu* _tmp10_;
	GtkMenuItem* _tmp11_;
	GtkMenuItem* _tmp12_;
	GtkMenuItem* _tmp13_;
#line 218 "../src/Widgets/SourceListView.vala"
	parent_class = G_OBJECT_CLASS (music_play_list_category_parent_class);
#line 218 "../src/Widgets/SourceListView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 218 "../src/Widgets/SourceListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PLAY_LIST_CATEGORY, MusicPlayListCategory);
#line 219 "../src/Widgets/SourceListView.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Playlist"));
#line 219 "../src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp0_);
#line 219 "../src/Widgets/SourceListView.vala"
	playlist_new = _tmp0_;
#line 220 "../src/Widgets/SourceListView.vala"
	_tmp1_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Smart Playlist"));
#line 220 "../src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp1_);
#line 220 "../src/Widgets/SourceListView.vala"
	smart_playlist_new = _tmp1_;
#line 221 "../src/Widgets/SourceListView.vala"
	_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Import Playlists"));
#line 221 "../src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp2_);
#line 221 "../src/Widgets/SourceListView.vala"
	playlist_import = _tmp2_;
#line 223 "../src/Widgets/SourceListView.vala"
	_tmp3_ = (GtkMenu*) gtk_menu_new ();
#line 223 "../src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp3_);
#line 223 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlist_menu);
#line 223 "../src/Widgets/SourceListView.vala"
	self->priv->playlist_menu = _tmp3_;
#line 224 "../src/Widgets/SourceListView.vala"
	_tmp4_ = self->priv->playlist_menu;
#line 224 "../src/Widgets/SourceListView.vala"
	_tmp5_ = playlist_new;
#line 224 "../src/Widgets/SourceListView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp4_, _tmp5_);
#line 225 "../src/Widgets/SourceListView.vala"
	_tmp6_ = self->priv->playlist_menu;
#line 225 "../src/Widgets/SourceListView.vala"
	_tmp7_ = smart_playlist_new;
#line 225 "../src/Widgets/SourceListView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp6_, _tmp7_);
#line 226 "../src/Widgets/SourceListView.vala"
	_tmp8_ = self->priv->playlist_menu;
#line 226 "../src/Widgets/SourceListView.vala"
	_tmp9_ = playlist_import;
#line 226 "../src/Widgets/SourceListView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp8_, _tmp9_);
#line 227 "../src/Widgets/SourceListView.vala"
	_tmp10_ = self->priv->playlist_menu;
#line 227 "../src/Widgets/SourceListView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp10_);
#line 229 "../src/Widgets/SourceListView.vala"
	_tmp11_ = playlist_new;
#line 229 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp11_, "activate", (GCallback) __music_play_list_category___lambda84__gtk_menu_item_activate, self, 0);
#line 233 "../src/Widgets/SourceListView.vala"
	_tmp12_ = smart_playlist_new;
#line 233 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp12_, "activate", (GCallback) __music_play_list_category___lambda85__gtk_menu_item_activate, self, 0);
#line 237 "../src/Widgets/SourceListView.vala"
	_tmp13_ = playlist_import;
#line 237 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp13_, "activate", (GCallback) __music_play_list_category___lambda86__gtk_menu_item_activate, self, 0);
#line 218 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (playlist_import);
#line 218 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (smart_playlist_new);
#line 218 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (playlist_new);
#line 218 "../src/Widgets/SourceListView.vala"
	return obj;
#line 2419 "SourceListView.c"
}

static void
music_play_list_category_class_init (MusicPlayListCategoryClass * klass,
                                     gpointer klass_data)
{
#line 210 "../src/Widgets/SourceListView.vala"
	music_play_list_category_parent_class = g_type_class_peek_parent (klass);
#line 210 "../src/Widgets/SourceListView.vala"
	g_type_class_adjust_private_offset (klass, &MusicPlayListCategory_private_offset);
#line 210 "../src/Widgets/SourceListView.vala"
	((GraniteWidgetsSourceListItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListItem*)) music_play_list_category_real_get_context_menu;
#line 210 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->constructor = music_play_list_category_constructor;
#line 210 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->finalize = music_play_list_category_finalize;
#line 210 "../src/Widgets/SourceListView.vala"
	music_play_list_category_signals[MUSIC_PLAY_LIST_CATEGORY_PLAYLIST_IMPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-import-clicked", MUSIC_TYPE_PLAY_LIST_CATEGORY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2438 "SourceListView.c"
}

static void
music_play_list_category_granite_widgets_source_list_sortable_interface_init (GraniteWidgetsSourceListSortableIface * iface,
                                                                              gpointer iface_data)
{
#line 210 "../src/Widgets/SourceListView.vala"
	music_play_list_category_granite_widgets_source_list_sortable_parent_iface = g_type_interface_peek_parent (iface);
#line 210 "../src/Widgets/SourceListView.vala"
	iface->allow_dnd_sorting = (gboolean (*) (GraniteWidgetsSourceListSortable*)) music_play_list_category_real_allow_dnd_sorting;
#line 210 "../src/Widgets/SourceListView.vala"
	iface->compare = (gint (*) (GraniteWidgetsSourceListSortable*, GraniteWidgetsSourceListItem*, GraniteWidgetsSourceListItem*)) music_play_list_category_real_compare;
#line 2451 "SourceListView.c"
}

static void
music_play_list_category_instance_init (MusicPlayListCategory * self,
                                        gpointer klass)
{
#line 210 "../src/Widgets/SourceListView.vala"
	self->priv = music_play_list_category_get_instance_private (self);
#line 2460 "SourceListView.c"
}

static void
music_play_list_category_finalize (GObject * obj)
{
	MusicPlayListCategory * self;
#line 210 "../src/Widgets/SourceListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PLAY_LIST_CATEGORY, MusicPlayListCategory);
#line 211 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlist_menu);
#line 210 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (music_play_list_category_parent_class)->finalize (obj);
#line 2473 "SourceListView.c"
}

static GType
music_play_list_category_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPlayListCategoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_play_list_category_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPlayListCategory), 0, (GInstanceInitFunc) music_play_list_category_instance_init, NULL };
	static const GInterfaceInfo granite_widgets_source_list_sortable_info = { (GInterfaceInitFunc) music_play_list_category_granite_widgets_source_list_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_play_list_category_type_id;
	music_play_list_category_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, "MusicPlayListCategory", &g_define_type_info, 0);
	g_type_add_interface_static (music_play_list_category_type_id, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE, &granite_widgets_source_list_sortable_info);
	MusicPlayListCategory_private_offset = g_type_add_instance_private (music_play_list_category_type_id, sizeof (MusicPlayListCategoryPrivate));
	return music_play_list_category_type_id;
}

GType
music_play_list_category_get_type (void)
{
	static volatile gsize music_play_list_category_type_id__once = 0;
	if (g_once_init_enter (&music_play_list_category_type_id__once)) {
		GType music_play_list_category_type_id;
		music_play_list_category_type_id = music_play_list_category_get_type_once ();
		g_once_init_leave (&music_play_list_category_type_id__once, music_play_list_category_type_id);
	}
	return music_play_list_category_type_id__once;
}

MusicSourceListRoot*
music_source_list_root_construct (GType object_type)
{
	MusicSourceListRoot * self = NULL;
#line 296 "../src/Widgets/SourceListView.vala"
	self = (MusicSourceListRoot*) granite_widgets_source_list_expandable_item_construct (object_type, "SourceListRoot");
#line 295 "../src/Widgets/SourceListView.vala"
	return self;
#line 2508 "SourceListView.c"
}

MusicSourceListRoot*
music_source_list_root_new (void)
{
#line 295 "../src/Widgets/SourceListView.vala"
	return music_source_list_root_construct (MUSIC_TYPE_SOURCE_LIST_ROOT);
#line 2516 "SourceListView.c"
}

static gboolean
music_source_list_root_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base)
{
	MusicSourceListRoot * self;
	gboolean result;
#line 299 "../src/Widgets/SourceListView.vala"
	self = (MusicSourceListRoot*) base;
#line 300 "../src/Widgets/SourceListView.vala"
	result = TRUE;
#line 300 "../src/Widgets/SourceListView.vala"
	return result;
#line 2530 "SourceListView.c"
}

static gint
music_source_list_root_real_compare (GraniteWidgetsSourceListSortable* base,
                                     GraniteWidgetsSourceListItem* a,
                                     GraniteWidgetsSourceListItem* b)
{
	MusicSourceListRoot * self;
	gint result;
#line 303 "../src/Widgets/SourceListView.vala"
	self = (MusicSourceListRoot*) base;
#line 303 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 303 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 304 "../src/Widgets/SourceListView.vala"
	result = 0;
#line 304 "../src/Widgets/SourceListView.vala"
	return result;
#line 2550 "SourceListView.c"
}

static void
music_source_list_root_class_init (MusicSourceListRootClass * klass,
                                   gpointer klass_data)
{
#line 294 "../src/Widgets/SourceListView.vala"
	music_source_list_root_parent_class = g_type_class_peek_parent (klass);
#line 2559 "SourceListView.c"
}

static void
music_source_list_root_granite_widgets_source_list_sortable_interface_init (GraniteWidgetsSourceListSortableIface * iface,
                                                                            gpointer iface_data)
{
#line 294 "../src/Widgets/SourceListView.vala"
	music_source_list_root_granite_widgets_source_list_sortable_parent_iface = g_type_interface_peek_parent (iface);
#line 294 "../src/Widgets/SourceListView.vala"
	iface->allow_dnd_sorting = (gboolean (*) (GraniteWidgetsSourceListSortable*)) music_source_list_root_real_allow_dnd_sorting;
#line 294 "../src/Widgets/SourceListView.vala"
	iface->compare = (gint (*) (GraniteWidgetsSourceListSortable*, GraniteWidgetsSourceListItem*, GraniteWidgetsSourceListItem*)) music_source_list_root_real_compare;
#line 2572 "SourceListView.c"
}

static void
music_source_list_root_instance_init (MusicSourceListRoot * self,
                                      gpointer klass)
{
}

static GType
music_source_list_root_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicSourceListRootClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_source_list_root_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicSourceListRoot), 0, (GInstanceInitFunc) music_source_list_root_instance_init, NULL };
	static const GInterfaceInfo granite_widgets_source_list_sortable_info = { (GInterfaceInitFunc) music_source_list_root_granite_widgets_source_list_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_source_list_root_type_id;
	music_source_list_root_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, "MusicSourceListRoot", &g_define_type_info, 0);
	g_type_add_interface_static (music_source_list_root_type_id, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE, &granite_widgets_source_list_sortable_info);
	return music_source_list_root_type_id;
}

GType
music_source_list_root_get_type (void)
{
	static volatile gsize music_source_list_root_type_id__once = 0;
	if (g_once_init_enter (&music_source_list_root_type_id__once)) {
		GType music_source_list_root_type_id;
		music_source_list_root_type_id = music_source_list_root_get_type_once ();
		g_once_init_leave (&music_source_list_root_type_id__once, music_source_list_root_type_id);
	}
	return music_source_list_root_type_id__once;
}

static inline gpointer
music_source_list_view_get_instance_private (MusicSourceListView* self)
{
	return G_STRUCT_MEMBER_P (self, MusicSourceListView_private_offset);
}

static void
__lambda87_ (MusicSourceListView* self)
{
#line 342 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_IMPORT_CLICKED_SIGNAL], 0);
#line 2615 "SourceListView.c"
}

static void
___lambda87__music_play_list_category_playlist_import_clicked (MusicPlayListCategory* _sender,
                                                               gpointer self)
{
#line 342 "../src/Widgets/SourceListView.vala"
	__lambda87_ ((MusicSourceListView*) self);
#line 2624 "SourceListView.c"
}

MusicSourceListView*
music_source_list_view_construct (GType object_type)
{
	MusicSourceListView * self = NULL;
	MusicSourceListRoot* _tmp0_;
	MusicSourceListRoot* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
	GraniteWidgetsSourceListExpandableItem* _tmp4_;
	MusicPlayListCategory* _tmp5_;
	MusicPlayListCategory* _tmp6_;
	GraniteWidgetsSourceListExpandableItem* _tmp7_;
	GraniteWidgetsSourceListExpandableItem* _tmp8_;
	GraniteWidgetsSourceListExpandableItem* _tmp9_;
	GraniteWidgetsSourceListExpandableItem* _tmp10_;
	GraniteWidgetsSourceListExpandableItem* _tmp11_;
	GraniteWidgetsSourceListExpandableItem* _tmp12_;
	GraniteWidgetsSourceListExpandableItem* _tmp13_;
	GraniteWidgetsSourceListExpandableItem* _tmp14_;
	GraniteWidgetsSourceListExpandableItem* _tmp15_;
	GraniteWidgetsSourceListExpandableItem* _tmp16_;
	GraniteWidgetsSourceListExpandableItem* _tmp17_;
	MusicPlayListCategory* _tmp18_;
	GraniteWidgetsSourceListExpandableItem* _tmp19_;
	GraniteWidgetsSourceListExpandableItem* _tmp20_;
	GtkTargetEntry uri_list_entry = {0};
	GtkTargetEntry _tmp21_ = {0};
	GtkTargetEntry _tmp22_;
	GtkTargetEntry* _tmp23_;
	GtkTargetEntry* _tmp24_;
	gint _tmp24__length1;
#line 335 "../src/Widgets/SourceListView.vala"
	_tmp0_ = music_source_list_root_new ();
#line 335 "../src/Widgets/SourceListView.vala"
	_tmp1_ = _tmp0_;
#line 335 "../src/Widgets/SourceListView.vala"
	self = (MusicSourceListView*) granite_widgets_source_list_construct (object_type, (GraniteWidgetsSourceListExpandableItem*) _tmp1_);
#line 335 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (_tmp1_);
#line 338 "../src/Widgets/SourceListView.vala"
	_tmp2_ = granite_widgets_source_list_expandable_item_new (_ ("Library"));
#line 338 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->library_category);
#line 338 "../src/Widgets/SourceListView.vala"
	self->priv->library_category = _tmp2_;
#line 339 "../src/Widgets/SourceListView.vala"
	_tmp3_ = granite_widgets_source_list_expandable_item_new (_ ("Devices"));
#line 339 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->devices_category);
#line 339 "../src/Widgets/SourceListView.vala"
	self->priv->devices_category = _tmp3_;
#line 340 "../src/Widgets/SourceListView.vala"
	_tmp4_ = granite_widgets_source_list_expandable_item_new (_ ("Network"));
#line 340 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->network_category);
#line 340 "../src/Widgets/SourceListView.vala"
	self->priv->network_category = _tmp4_;
#line 341 "../src/Widgets/SourceListView.vala"
	_tmp5_ = music_play_list_category_new (_ ("Playlists"));
#line 341 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlists_category);
#line 341 "../src/Widgets/SourceListView.vala"
	self->priv->playlists_category = _tmp5_;
#line 342 "../src/Widgets/SourceListView.vala"
	_tmp6_ = self->priv->playlists_category;
#line 342 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp6_, "playlist-import-clicked", (GCallback) ___lambda87__music_play_list_category_playlist_import_clicked, self, 0);
#line 343 "../src/Widgets/SourceListView.vala"
	_tmp7_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 343 "../src/Widgets/SourceListView.vala"
	_tmp8_ = _tmp7_;
#line 343 "../src/Widgets/SourceListView.vala"
	_tmp9_ = self->priv->library_category;
#line 343 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_expandable_item_add (_tmp8_, (GraniteWidgetsSourceListItem*) _tmp9_);
#line 344 "../src/Widgets/SourceListView.vala"
	_tmp10_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 344 "../src/Widgets/SourceListView.vala"
	_tmp11_ = _tmp10_;
#line 344 "../src/Widgets/SourceListView.vala"
	_tmp12_ = self->priv->devices_category;
#line 344 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_expandable_item_add (_tmp11_, (GraniteWidgetsSourceListItem*) _tmp12_);
#line 345 "../src/Widgets/SourceListView.vala"
	_tmp13_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 345 "../src/Widgets/SourceListView.vala"
	_tmp14_ = _tmp13_;
#line 345 "../src/Widgets/SourceListView.vala"
	_tmp15_ = self->priv->network_category;
#line 345 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_expandable_item_add (_tmp14_, (GraniteWidgetsSourceListItem*) _tmp15_);
#line 346 "../src/Widgets/SourceListView.vala"
	_tmp16_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 346 "../src/Widgets/SourceListView.vala"
	_tmp17_ = _tmp16_;
#line 346 "../src/Widgets/SourceListView.vala"
	_tmp18_ = self->priv->playlists_category;
#line 346 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_expandable_item_add (_tmp17_, (GraniteWidgetsSourceListItem*) _tmp18_);
#line 347 "../src/Widgets/SourceListView.vala"
	_tmp19_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 347 "../src/Widgets/SourceListView.vala"
	_tmp20_ = _tmp19_;
#line 347 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_expandable_item_expand_all (_tmp20_, FALSE, FALSE);
#line 349 "../src/Widgets/SourceListView.vala"
	_tmp21_.target = "text/uri-list";
#line 349 "../src/Widgets/SourceListView.vala"
	_tmp21_.flags = (guint) GTK_TARGET_SAME_APP;
#line 349 "../src/Widgets/SourceListView.vala"
	_tmp21_.info = (guint) 0;
#line 349 "../src/Widgets/SourceListView.vala"
	uri_list_entry = _tmp21_;
#line 350 "../src/Widgets/SourceListView.vala"
	_tmp22_ = uri_list_entry;
#line 350 "../src/Widgets/SourceListView.vala"
	_tmp23_ = g_new0 (GtkTargetEntry, 1);
#line 350 "../src/Widgets/SourceListView.vala"
	_tmp23_[0] = _tmp22_;
#line 350 "../src/Widgets/SourceListView.vala"
	_tmp24_ = _tmp23_;
#line 350 "../src/Widgets/SourceListView.vala"
	_tmp24__length1 = 1;
#line 350 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_enable_drag_dest ((GraniteWidgetsSourceList*) self, _tmp24_, (gint) 1, GDK_ACTION_COPY);
#line 350 "../src/Widgets/SourceListView.vala"
	_tmp24_ = (g_free (_tmp24_), NULL);
#line 334 "../src/Widgets/SourceListView.vala"
	return self;
#line 2756 "SourceListView.c"
}

MusicSourceListView*
music_source_list_view_new (void)
{
#line 334 "../src/Widgets/SourceListView.vala"
	return music_source_list_view_construct (MUSIC_TYPE_SOURCE_LIST_VIEW);
#line 2764 "SourceListView.c"
}

/**
     * Change the visibility of each category
     */
void
music_source_list_view_change_playlist_category_visibility (MusicSourceListView* self,
                                                            gboolean visible)
{
	MusicPlayListCategory* _tmp0_;
#line 357 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 358 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->playlists_category;
#line 358 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_item_set_visible ((GraniteWidgetsSourceListItem*) _tmp0_, visible);
#line 2781 "SourceListView.c"
}

/**
     * Adds an item to the sidebar for the ViewWrapper object.
     * It chooses the appropiate category based on the object's hint property.
     *
     * TODO: Change ViewWrapper.Hint to core values.
     */
static Block33Data*
block33_data_ref (Block33Data* _data33_)
{
#line 367 "../src/Widgets/SourceListView.vala"
	g_atomic_int_inc (&_data33_->_ref_count_);
#line 367 "../src/Widgets/SourceListView.vala"
	return _data33_;
#line 2797 "SourceListView.c"
}

static void
block33_data_unref (void * _userdata_)
{
	Block33Data* _data33_;
	_data33_ = (Block33Data*) _userdata_;
#line 367 "../src/Widgets/SourceListView.vala"
	if (g_atomic_int_dec_and_test (&_data33_->_ref_count_)) {
#line 2807 "SourceListView.c"
		MusicSourceListView* self;
#line 367 "../src/Widgets/SourceListView.vala"
		self = _data33_->self;
#line 367 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_data33_->expandable_item);
#line 367 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_data33_->sourcelist_item);
#line 367 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (self);
#line 367 "../src/Widgets/SourceListView.vala"
		g_slice_free (Block33Data, _data33_);
#line 2819 "SourceListView.c"
	}
}

static void
__lambda93_ (MusicSourceListView* self)
{
#line 386 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_ACTIVATED_SIGNAL], 0);
#line 2828 "SourceListView.c"
}

static void
___lambda93__granite_widgets_source_list_item_activated (GraniteWidgetsSourceListItem* _sender,
                                                         gpointer self)
{
#line 386 "../src/Widgets/SourceListView.vala"
	__lambda93_ ((MusicSourceListView*) self);
#line 2837 "SourceListView.c"
}

static void
__lambda94_ (Block33Data* _data33_,
             const gchar* new_name)
{
	MusicSourceListView* self;
	MusicSourceListItem* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
#line 387 "../src/Widgets/SourceListView.vala"
	self = _data33_->self;
#line 387 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (new_name != NULL);
#line 387 "../src/Widgets/SourceListView.vala"
	_tmp0_ = _data33_->sourcelist_item;
#line 387 "../src/Widgets/SourceListView.vala"
	_tmp1_ = music_source_list_item_get_view (_tmp0_);
#line 387 "../src/Widgets/SourceListView.vala"
	_tmp2_ = _tmp1_;
#line 387 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_EDITED_SIGNAL], 0, _tmp2_, new_name);
#line 2860 "SourceListView.c"
}

static void
___lambda94__granite_widgets_source_list_item_edited (GraniteWidgetsSourceListItem* _sender,
                                                      const gchar* new_name,
                                                      gpointer self)
{
#line 387 "../src/Widgets/SourceListView.vala"
	__lambda94_ (self, new_name);
#line 2870 "SourceListView.c"
}

static void
__lambda95_ (Block33Data* _data33_,
             GraniteWidgetsSourceListItem* sl)
{
	MusicSourceListView* self;
	MusicSourceListItem* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
#line 388 "../src/Widgets/SourceListView.vala"
	self = _data33_->self;
#line 388 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (sl != NULL);
#line 388 "../src/Widgets/SourceListView.vala"
	_tmp0_ = _data33_->sourcelist_item;
#line 388 "../src/Widgets/SourceListView.vala"
	_tmp1_ = music_source_list_item_get_view (_tmp0_);
#line 388 "../src/Widgets/SourceListView.vala"
	_tmp2_ = _tmp1_;
#line 388 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_ITEM_ACTION_ACTIVATED_SIGNAL], 0, _tmp2_);
#line 2893 "SourceListView.c"
}

static void
___lambda95__granite_widgets_source_list_item_action_activated (GraniteWidgetsSourceListItem* _sender,
                                                                gpointer self)
{
#line 388 "../src/Widgets/SourceListView.vala"
	__lambda95_ (self, _sender);
#line 2902 "SourceListView.c"
}

static void
__lambda96_ (MusicSourceListView* self,
             GtkGrid* view,
             MusicSourceListItem* item)
{
#line 389 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 389 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (item != NULL);
#line 390 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_RENAME_CLICKED_SIGNAL], 0, view);
#line 391 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_start_editing_item ((GraniteWidgetsSourceList*) self, (GraniteWidgetsSourceListItem*) item);
#line 2918 "SourceListView.c"
}

static void
___lambda96__music_source_list_item_playlist_rename_clicked (MusicSourceListItem* _sender,
                                                             GtkGrid* view,
                                                             MusicSourceListItem* item,
                                                             gpointer self)
{
#line 389 "../src/Widgets/SourceListView.vala"
	__lambda96_ ((MusicSourceListView*) self, view, item);
#line 2929 "SourceListView.c"
}

static void
__lambda97_ (MusicSourceListView* self,
             GtkGrid* view)
{
#line 393 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 393 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_EDIT_CLICKED_SIGNAL], 0, view);
#line 2940 "SourceListView.c"
}

static void
___lambda97__music_source_list_item_playlist_edit_clicked (MusicSourceListItem* _sender,
                                                           GtkGrid* view,
                                                           gpointer self)
{
#line 393 "../src/Widgets/SourceListView.vala"
	__lambda97_ ((MusicSourceListView*) self, view);
#line 2950 "SourceListView.c"
}

static void
__lambda98_ (MusicSourceListView* self,
             GtkGrid* view)
{
#line 394 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 394 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_REMOVE_CLICKED_SIGNAL], 0, view);
#line 2961 "SourceListView.c"
}

static void
___lambda98__music_source_list_item_playlist_remove_clicked (MusicSourceListItem* _sender,
                                                             GtkGrid* view,
                                                             gpointer self)
{
#line 394 "../src/Widgets/SourceListView.vala"
	__lambda98_ ((MusicSourceListView*) self, view);
#line 2971 "SourceListView.c"
}

static void
__lambda99_ (MusicSourceListView* self,
             GtkGrid* view)
{
#line 395 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 395 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_SAVE_CLICKED_SIGNAL], 0, view);
#line 2982 "SourceListView.c"
}

static void
___lambda99__music_source_list_item_playlist_save_clicked (MusicSourceListItem* _sender,
                                                           GtkGrid* view,
                                                           gpointer self)
{
#line 395 "../src/Widgets/SourceListView.vala"
	__lambda99_ ((MusicSourceListView*) self, view);
#line 2992 "SourceListView.c"
}

static void
__lambda100_ (MusicSourceListView* self,
              GtkGrid* view)
{
#line 396 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 396 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_EXPORT_CLICKED_SIGNAL], 0, view);
#line 3003 "SourceListView.c"
}

static void
___lambda100__music_source_list_item_playlist_export_clicked (MusicSourceListItem* _sender,
                                                              GtkGrid* view,
                                                              gpointer self)
{
#line 396 "../src/Widgets/SourceListView.vala"
	__lambda100_ ((MusicSourceListView*) self, view);
#line 3013 "SourceListView.c"
}

static void
__lambda101_ (MusicSourceListView* self,
              GtkGrid* view,
              gchar** uris,
              gint uris_length1)
{
#line 397 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 397 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_MEDIA_ADDED_SIGNAL], 0, view, uris, (gint) uris_length1);
#line 3026 "SourceListView.c"
}

static void
___lambda101__music_source_list_item_playlist_media_added (MusicSourceListItem* _sender,
                                                           GtkGrid* view,
                                                           gchar** media,
                                                           gint media_length1,
                                                           gpointer self)
{
#line 397 "../src/Widgets/SourceListView.vala"
	__lambda101_ ((MusicSourceListView*) self, view, media, media_length1);
#line 3038 "SourceListView.c"
}

static void
__lambda102_ (Block33Data* _data33_,
              GtkGrid* view)
{
	MusicSourceListView* self;
	MusicSourceListExpandableItem* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
#line 399 "../src/Widgets/SourceListView.vala"
	self = _data33_->self;
#line 399 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 399 "../src/Widgets/SourceListView.vala"
	_tmp0_ = _data33_->expandable_item;
#line 399 "../src/Widgets/SourceListView.vala"
	_tmp1_ = music_source_list_view_get_device_from_item (self, _tmp0_);
#line 399 "../src/Widgets/SourceListView.vala"
	_tmp2_ = _tmp1_;
#line 399 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_IMPORT_CLICKED_SIGNAL], 0, _tmp2_);
#line 399 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (_tmp2_);
#line 3063 "SourceListView.c"
}

static void
___lambda102__music_source_list_expandable_item_device_import_clicked (MusicSourceListExpandableItem* _sender,
                                                                       GtkGrid* view,
                                                                       gpointer self)
{
#line 399 "../src/Widgets/SourceListView.vala"
	__lambda102_ (self, view);
#line 3073 "SourceListView.c"
}

static void
__lambda103_ (MusicSourceListView* self,
              GtkGrid* view)
{
#line 400 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 400 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_EJECT_CLICKED_SIGNAL], 0, view);
#line 3084 "SourceListView.c"
}

static void
___lambda103__music_source_list_expandable_item_device_eject_clicked (MusicSourceListExpandableItem* _sender,
                                                                      GtkGrid* view,
                                                                      gpointer self)
{
#line 400 "../src/Widgets/SourceListView.vala"
	__lambda103_ ((MusicSourceListView*) self, view);
#line 3094 "SourceListView.c"
}

static void
__lambda104_ (MusicSourceListView* self,
              GtkGrid* view)
{
#line 401 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 401 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_SYNC_CLICKED_SIGNAL], 0, view);
#line 3105 "SourceListView.c"
}

static void
___lambda104__music_source_list_expandable_item_device_sync_clicked (MusicSourceListExpandableItem* _sender,
                                                                     GtkGrid* view,
                                                                     gpointer self)
{
#line 401 "../src/Widgets/SourceListView.vala"
	__lambda104_ ((MusicSourceListView*) self, view);
#line 3115 "SourceListView.c"
}

static void
__lambda105_ (MusicSourceListView* self,
              GtkGrid* view)
{
#line 402 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 402 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL], 0, view);
#line 3126 "SourceListView.c"
}

static void
___lambda105__music_source_list_expandable_item_device_new_playlist_clicked (MusicSourceListExpandableItem* _sender,
                                                                             GtkGrid* view,
                                                                             gpointer self)
{
#line 402 "../src/Widgets/SourceListView.vala"
	__lambda105_ ((MusicSourceListView*) self, view);
#line 3136 "SourceListView.c"
}

static void
__lambda106_ (MusicSourceListView* self,
              GtkGrid* view)
{
#line 403 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 403 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL], 0, view);
#line 3147 "SourceListView.c"
}

static void
___lambda106__music_source_list_expandable_item_device_new_smartplaylist_clicked (MusicSourceListExpandableItem* _sender,
                                                                                  GtkGrid* view,
                                                                                  gpointer self)
{
#line 403 "../src/Widgets/SourceListView.vala"
	__lambda106_ ((MusicSourceListView*) self, view);
#line 3157 "SourceListView.c"
}

MusicSourceListEntry*
music_source_list_view_add_item (MusicSourceListView* self,
                                 GtkGrid* view,
                                 const gchar* name,
                                 MusicViewWrapperHint hint,
                                 GIcon* icon,
                                 GIcon* activatable_icon,
                                 MusicSourceListExpandableItem* into_expandable,
                                 GObject* give_more_information)
{
	Block33Data* _data33_;
	MusicSourceListItem* _tmp0_;
	MusicSourceListExpandableItem* _tmp1_;
	MusicSourceListItem* _tmp5_;
	MusicSourceListItem* _tmp6_;
	MusicSourceListExpandableItem* _tmp7_;
	MusicSourceListItem* _tmp8_;
	MusicSourceListItem* _tmp9_;
	MusicSourceListItem* _tmp10_;
	MusicSourceListItem* _tmp11_;
	MusicSourceListItem* _tmp12_;
	MusicSourceListItem* _tmp13_;
	MusicSourceListExpandableItem* _tmp14_;
	MusicSourceListExpandableItem* _tmp15_;
	MusicSourceListExpandableItem* _tmp16_;
	MusicSourceListExpandableItem* _tmp17_;
	MusicSourceListExpandableItem* _tmp18_;
	MusicSourceListEntry* result;
#line 367 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 367 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 367 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 367 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 367 "../src/Widgets/SourceListView.vala"
	_data33_ = g_slice_new0 (Block33Data);
#line 367 "../src/Widgets/SourceListView.vala"
	_data33_->_ref_count_ = 1;
#line 367 "../src/Widgets/SourceListView.vala"
	_data33_->self = g_object_ref (self);
#line 375 "../src/Widgets/SourceListView.vala"
	_tmp0_ = music_source_list_item_new (view, name, hint, icon, activatable_icon);
#line 375 "../src/Widgets/SourceListView.vala"
	_data33_->sourcelist_item = _tmp0_;
#line 376 "../src/Widgets/SourceListView.vala"
	_tmp1_ = music_source_list_expandable_item_new (view, name, hint, icon, activatable_icon, give_more_information);
#line 376 "../src/Widgets/SourceListView.vala"
	_data33_->expandable_item = _tmp1_;
#line 378 "../src/Widgets/SourceListView.vala"
	if (hint == MUSIC_VIEW_WRAPPER_HINT_DEVICE) {
#line 3212 "SourceListView.c"
		MusicSourceListExpandableItem* _tmp2_;
		MusicSourceListExpandableItem* _tmp3_;
#line 379 "../src/Widgets/SourceListView.vala"
		_tmp2_ = _data33_->expandable_item;
#line 379 "../src/Widgets/SourceListView.vala"
		granite_widgets_source_list_expandable_item_set_collapsible ((GraniteWidgetsSourceListExpandableItem*) _tmp2_, FALSE);
#line 380 "../src/Widgets/SourceListView.vala"
		_tmp3_ = _data33_->expandable_item;
#line 380 "../src/Widgets/SourceListView.vala"
		granite_widgets_source_list_item_set_icon ((GraniteWidgetsSourceListItem*) _tmp3_, icon);
#line 381 "../src/Widgets/SourceListView.vala"
		if (activatable_icon != NULL) {
#line 3225 "SourceListView.c"
			MusicSourceListExpandableItem* _tmp4_;
#line 382 "../src/Widgets/SourceListView.vala"
			_tmp4_ = _data33_->expandable_item;
#line 382 "../src/Widgets/SourceListView.vala"
			granite_widgets_source_list_item_set_activatable ((GraniteWidgetsSourceListItem*) _tmp4_, activatable_icon);
#line 3231 "SourceListView.c"
		}
	}
#line 386 "../src/Widgets/SourceListView.vala"
	_tmp5_ = _data33_->sourcelist_item;
#line 386 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object ((GraniteWidgetsSourceListItem*) _tmp5_, "activated", (GCallback) ___lambda93__granite_widgets_source_list_item_activated, self, 0);
#line 387 "../src/Widgets/SourceListView.vala"
	_tmp6_ = _data33_->sourcelist_item;
#line 387 "../src/Widgets/SourceListView.vala"
	g_signal_connect_data ((GraniteWidgetsSourceListItem*) _tmp6_, "edited", (GCallback) ___lambda94__granite_widgets_source_list_item_edited, block33_data_ref (_data33_), (GClosureNotify) block33_data_unref, 0);
#line 388 "../src/Widgets/SourceListView.vala"
	_tmp7_ = _data33_->expandable_item;
#line 388 "../src/Widgets/SourceListView.vala"
	g_signal_connect_data ((GraniteWidgetsSourceListItem*) _tmp7_, "action-activated", (GCallback) ___lambda95__granite_widgets_source_list_item_action_activated, block33_data_ref (_data33_), (GClosureNotify) block33_data_unref, 0);
#line 389 "../src/Widgets/SourceListView.vala"
	_tmp8_ = _data33_->sourcelist_item;
#line 389 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp8_, "playlist-rename-clicked", (GCallback) ___lambda96__music_source_list_item_playlist_rename_clicked, self, 0);
#line 393 "../src/Widgets/SourceListView.vala"
	_tmp9_ = _data33_->sourcelist_item;
#line 393 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp9_, "playlist-edit-clicked", (GCallback) ___lambda97__music_source_list_item_playlist_edit_clicked, self, 0);
#line 394 "../src/Widgets/SourceListView.vala"
	_tmp10_ = _data33_->sourcelist_item;
#line 394 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp10_, "playlist-remove-clicked", (GCallback) ___lambda98__music_source_list_item_playlist_remove_clicked, self, 0);
#line 395 "../src/Widgets/SourceListView.vala"
	_tmp11_ = _data33_->sourcelist_item;
#line 395 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp11_, "playlist-save-clicked", (GCallback) ___lambda99__music_source_list_item_playlist_save_clicked, self, 0);
#line 396 "../src/Widgets/SourceListView.vala"
	_tmp12_ = _data33_->sourcelist_item;
#line 396 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp12_, "playlist-export-clicked", (GCallback) ___lambda100__music_source_list_item_playlist_export_clicked, self, 0);
#line 397 "../src/Widgets/SourceListView.vala"
	_tmp13_ = _data33_->sourcelist_item;
#line 397 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp13_, "playlist-media-added", (GCallback) ___lambda101__music_source_list_item_playlist_media_added, self, 0);
#line 399 "../src/Widgets/SourceListView.vala"
	_tmp14_ = _data33_->expandable_item;
#line 399 "../src/Widgets/SourceListView.vala"
	g_signal_connect_data (_tmp14_, "device-import-clicked", (GCallback) ___lambda102__music_source_list_expandable_item_device_import_clicked, block33_data_ref (_data33_), (GClosureNotify) block33_data_unref, 0);
#line 400 "../src/Widgets/SourceListView.vala"
	_tmp15_ = _data33_->expandable_item;
#line 400 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp15_, "device-eject-clicked", (GCallback) ___lambda103__music_source_list_expandable_item_device_eject_clicked, self, 0);
#line 401 "../src/Widgets/SourceListView.vala"
	_tmp16_ = _data33_->expandable_item;
#line 401 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp16_, "device-sync-clicked", (GCallback) ___lambda104__music_source_list_expandable_item_device_sync_clicked, self, 0);
#line 402 "../src/Widgets/SourceListView.vala"
	_tmp17_ = _data33_->expandable_item;
#line 402 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp17_, "device-new-playlist-clicked", (GCallback) ___lambda105__music_source_list_expandable_item_device_new_playlist_clicked, self, 0);
#line 403 "../src/Widgets/SourceListView.vala"
	_tmp18_ = _data33_->expandable_item;
#line 403 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp18_, "device-new-smartplaylist-clicked", (GCallback) ___lambda106__music_source_list_expandable_item_device_new_smartplaylist_clicked, self, 0);
#line 405 "../src/Widgets/SourceListView.vala"
	switch (hint) {
#line 405 "../src/Widgets/SourceListView.vala"
		case MUSIC_VIEW_WRAPPER_HINT_MUSIC:
#line 3294 "SourceListView.c"
		{
#line 407 "../src/Widgets/SourceListView.vala"
			if (into_expandable == NULL) {
#line 3298 "SourceListView.c"
				GraniteWidgetsSourceListExpandableItem* _tmp19_;
				MusicSourceListItem* _tmp20_;
#line 408 "../src/Widgets/SourceListView.vala"
				_tmp19_ = self->priv->library_category;
#line 408 "../src/Widgets/SourceListView.vala"
				_tmp20_ = _data33_->sourcelist_item;
#line 408 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add (_tmp19_, (GraniteWidgetsSourceListItem*) _tmp20_);
#line 3307 "SourceListView.c"
			} else {
				MusicSourceListItem* _tmp21_;
#line 410 "../src/Widgets/SourceListView.vala"
				_tmp21_ = _data33_->sourcelist_item;
#line 410 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp21_);
#line 3314 "SourceListView.c"
			}
#line 412 "../src/Widgets/SourceListView.vala"
			break;
#line 3318 "SourceListView.c"
		}
#line 405 "../src/Widgets/SourceListView.vala"
		case MUSIC_VIEW_WRAPPER_HINT_PLAYLIST:
#line 3322 "SourceListView.c"
		{
#line 414 "../src/Widgets/SourceListView.vala"
			if (into_expandable == NULL) {
#line 3326 "SourceListView.c"
				MusicSourceListItem* _tmp22_;
				MusicPlayListCategory* _tmp23_;
				MusicSourceListItem* _tmp24_;
#line 415 "../src/Widgets/SourceListView.vala"
				_tmp22_ = _data33_->sourcelist_item;
#line 415 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp22_, TRUE);
#line 416 "../src/Widgets/SourceListView.vala"
				_tmp23_ = self->priv->playlists_category;
#line 416 "../src/Widgets/SourceListView.vala"
				_tmp24_ = _data33_->sourcelist_item;
#line 416 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp23_, (GraniteWidgetsSourceListItem*) _tmp24_);
#line 3340 "SourceListView.c"
			} else {
				MusicSourceListItem* _tmp25_;
				MusicSourceListItem* _tmp26_;
#line 418 "../src/Widgets/SourceListView.vala"
				_tmp25_ = _data33_->sourcelist_item;
#line 418 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp25_, TRUE);
#line 419 "../src/Widgets/SourceListView.vala"
				_tmp26_ = _data33_->sourcelist_item;
#line 419 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp26_);
#line 3352 "SourceListView.c"
			}
#line 421 "../src/Widgets/SourceListView.vala"
			break;
#line 3356 "SourceListView.c"
		}
#line 405 "../src/Widgets/SourceListView.vala"
		case MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST:
#line 3360 "SourceListView.c"
		{
#line 423 "../src/Widgets/SourceListView.vala"
			if (into_expandable == NULL) {
#line 3364 "SourceListView.c"
				MusicSourceListItem* _tmp27_;
				MusicPlayListCategory* _tmp28_;
				MusicSourceListItem* _tmp29_;
#line 424 "../src/Widgets/SourceListView.vala"
				_tmp27_ = _data33_->sourcelist_item;
#line 424 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp27_, FALSE);
#line 425 "../src/Widgets/SourceListView.vala"
				_tmp28_ = self->priv->playlists_category;
#line 425 "../src/Widgets/SourceListView.vala"
				_tmp29_ = _data33_->sourcelist_item;
#line 425 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp28_, (GraniteWidgetsSourceListItem*) _tmp29_);
#line 3378 "SourceListView.c"
			} else {
				MusicSourceListItem* _tmp30_;
				MusicSourceListItem* _tmp31_;
#line 427 "../src/Widgets/SourceListView.vala"
				_tmp30_ = _data33_->sourcelist_item;
#line 427 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp30_, FALSE);
#line 428 "../src/Widgets/SourceListView.vala"
				_tmp31_ = _data33_->sourcelist_item;
#line 428 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp31_);
#line 3390 "SourceListView.c"
			}
#line 430 "../src/Widgets/SourceListView.vala"
			break;
#line 3394 "SourceListView.c"
		}
#line 405 "../src/Widgets/SourceListView.vala"
		case MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST:
#line 3398 "SourceListView.c"
		{
#line 432 "../src/Widgets/SourceListView.vala"
			if (into_expandable == NULL) {
#line 3402 "SourceListView.c"
				MusicSourceListItem* _tmp32_;
				MusicPlayListCategory* _tmp33_;
				MusicSourceListItem* _tmp34_;
#line 433 "../src/Widgets/SourceListView.vala"
				_tmp32_ = _data33_->sourcelist_item;
#line 433 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp32_, TRUE);
#line 434 "../src/Widgets/SourceListView.vala"
				_tmp33_ = self->priv->playlists_category;
#line 434 "../src/Widgets/SourceListView.vala"
				_tmp34_ = _data33_->sourcelist_item;
#line 434 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp33_, (GraniteWidgetsSourceListItem*) _tmp34_);
#line 3416 "SourceListView.c"
			} else {
				MusicSourceListItem* _tmp35_;
#line 436 "../src/Widgets/SourceListView.vala"
				_tmp35_ = _data33_->sourcelist_item;
#line 436 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp35_);
#line 3423 "SourceListView.c"
			}
#line 438 "../src/Widgets/SourceListView.vala"
			break;
#line 3427 "SourceListView.c"
		}
#line 405 "../src/Widgets/SourceListView.vala"
		case MUSIC_VIEW_WRAPPER_HINT_DEVICE:
#line 3431 "SourceListView.c"
		{
#line 440 "../src/Widgets/SourceListView.vala"
			if (into_expandable == NULL) {
#line 3435 "SourceListView.c"
				GraniteWidgetsSourceListExpandableItem* _tmp36_;
				MusicSourceListExpandableItem* _tmp37_;
#line 441 "../src/Widgets/SourceListView.vala"
				_tmp36_ = self->priv->devices_category;
#line 441 "../src/Widgets/SourceListView.vala"
				_tmp37_ = _data33_->expandable_item;
#line 441 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add (_tmp36_, (GraniteWidgetsSourceListItem*) _tmp37_);
#line 3444 "SourceListView.c"
			} else {
				MusicSourceListExpandableItem* _tmp38_;
#line 443 "../src/Widgets/SourceListView.vala"
				_tmp38_ = _data33_->expandable_item;
#line 443 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp38_);
#line 3451 "SourceListView.c"
			}
#line 445 "../src/Widgets/SourceListView.vala"
			break;
#line 3455 "SourceListView.c"
		}
#line 405 "../src/Widgets/SourceListView.vala"
		case MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO:
#line 3459 "SourceListView.c"
		{
#line 447 "../src/Widgets/SourceListView.vala"
			if (into_expandable == NULL) {
#line 3463 "SourceListView.c"
				GraniteWidgetsSourceListExpandableItem* _tmp39_;
				MusicSourceListExpandableItem* _tmp40_;
#line 448 "../src/Widgets/SourceListView.vala"
				_tmp39_ = self->priv->devices_category;
#line 448 "../src/Widgets/SourceListView.vala"
				_tmp40_ = _data33_->expandable_item;
#line 448 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add (_tmp39_, (GraniteWidgetsSourceListItem*) _tmp40_);
#line 3472 "SourceListView.c"
			} else {
				MusicSourceListExpandableItem* _tmp41_;
#line 450 "../src/Widgets/SourceListView.vala"
				_tmp41_ = _data33_->expandable_item;
#line 450 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp41_);
#line 3479 "SourceListView.c"
			}
#line 452 "../src/Widgets/SourceListView.vala"
			break;
#line 3483 "SourceListView.c"
		}
#line 405 "../src/Widgets/SourceListView.vala"
		case MUSIC_VIEW_WRAPPER_HINT_NETWORK_DEVICE:
#line 3487 "SourceListView.c"
		{
#line 454 "../src/Widgets/SourceListView.vala"
			if (into_expandable == NULL) {
#line 3491 "SourceListView.c"
				GraniteWidgetsSourceListExpandableItem* _tmp42_;
				MusicSourceListItem* _tmp43_;
#line 455 "../src/Widgets/SourceListView.vala"
				_tmp42_ = self->priv->network_category;
#line 455 "../src/Widgets/SourceListView.vala"
				_tmp43_ = _data33_->sourcelist_item;
#line 455 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add (_tmp42_, (GraniteWidgetsSourceListItem*) _tmp43_);
#line 3500 "SourceListView.c"
			} else {
				MusicSourceListItem* _tmp44_;
#line 457 "../src/Widgets/SourceListView.vala"
				_tmp44_ = _data33_->sourcelist_item;
#line 457 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp44_);
#line 3507 "SourceListView.c"
			}
#line 459 "../src/Widgets/SourceListView.vala"
			break;
#line 3511 "SourceListView.c"
		}
		default:
		{
#line 461 "../src/Widgets/SourceListView.vala"
			break;
#line 3517 "SourceListView.c"
		}
	}
#line 464 "../src/Widgets/SourceListView.vala"
	if (hint == MUSIC_VIEW_WRAPPER_HINT_DEVICE) {
#line 3522 "SourceListView.c"
		MusicSourceListExpandableItem* _tmp45_;
		MusicSourceListEntry* _tmp46_;
#line 465 "../src/Widgets/SourceListView.vala"
		_tmp45_ = _data33_->expandable_item;
#line 465 "../src/Widgets/SourceListView.vala"
		_tmp46_ = _g_object_ref0 ((MusicSourceListEntry*) _tmp45_);
#line 465 "../src/Widgets/SourceListView.vala"
		result = _tmp46_;
#line 465 "../src/Widgets/SourceListView.vala"
		block33_data_unref (_data33_);
#line 465 "../src/Widgets/SourceListView.vala"
		_data33_ = NULL;
#line 465 "../src/Widgets/SourceListView.vala"
		return result;
#line 3537 "SourceListView.c"
	} else {
		MusicSourceListItem* _tmp47_;
		MusicSourceListEntry* _tmp48_;
#line 467 "../src/Widgets/SourceListView.vala"
		_tmp47_ = _data33_->sourcelist_item;
#line 467 "../src/Widgets/SourceListView.vala"
		_tmp48_ = _g_object_ref0 ((MusicSourceListEntry*) _tmp47_);
#line 467 "../src/Widgets/SourceListView.vala"
		result = _tmp48_;
#line 467 "../src/Widgets/SourceListView.vala"
		block33_data_unref (_data33_);
#line 467 "../src/Widgets/SourceListView.vala"
		_data33_ = NULL;
#line 467 "../src/Widgets/SourceListView.vala"
		return result;
#line 3553 "SourceListView.c"
	}
}

static void
music_source_list_view_real_item_selected (GraniteWidgetsSourceList* base,
                                           GraniteWidgetsSourceListItem* item)
{
	MusicSourceListView * self;
#line 471 "../src/Widgets/SourceListView.vala"
	self = (MusicSourceListView*) base;
#line 472 "../src/Widgets/SourceListView.vala"
	if (MUSIC_IS_SOURCE_LIST_ITEM (item)) {
#line 3566 "SourceListView.c"
		MusicSourceListItem* sidebar_item = NULL;
		MusicSourceListItem* _tmp0_;
		MusicSourceListItem* _tmp1_;
		GtkGrid* _tmp2_;
		GtkGrid* _tmp3_;
#line 473 "../src/Widgets/SourceListView.vala"
		_tmp0_ = _g_object_ref0 (MUSIC_IS_SOURCE_LIST_ITEM (item) ? ((MusicSourceListItem*) item) : NULL);
#line 473 "../src/Widgets/SourceListView.vala"
		sidebar_item = _tmp0_;
#line 474 "../src/Widgets/SourceListView.vala"
		_tmp1_ = sidebar_item;
#line 474 "../src/Widgets/SourceListView.vala"
		_tmp2_ = music_source_list_item_get_view (_tmp1_);
#line 474 "../src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 474 "../src/Widgets/SourceListView.vala"
		g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL], 0, _tmp3_);
#line 472 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (sidebar_item);
#line 3586 "SourceListView.c"
	} else {
#line 475 "../src/Widgets/SourceListView.vala"
		if (MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (item)) {
#line 3590 "SourceListView.c"
			MusicSourceListExpandableItem* sidebar_item = NULL;
			MusicSourceListExpandableItem* _tmp4_;
			MusicSourceListExpandableItem* _tmp5_;
			GtkGrid* _tmp6_;
			GtkGrid* _tmp7_;
#line 476 "../src/Widgets/SourceListView.vala"
			_tmp4_ = _g_object_ref0 (MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (item) ? ((MusicSourceListExpandableItem*) item) : NULL);
#line 476 "../src/Widgets/SourceListView.vala"
			sidebar_item = _tmp4_;
#line 477 "../src/Widgets/SourceListView.vala"
			_tmp5_ = sidebar_item;
#line 477 "../src/Widgets/SourceListView.vala"
			_tmp6_ = music_source_list_expandable_item_get_view (_tmp5_);
#line 477 "../src/Widgets/SourceListView.vala"
			_tmp7_ = _tmp6_;
#line 477 "../src/Widgets/SourceListView.vala"
			g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL], 0, _tmp7_);
#line 475 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (sidebar_item);
#line 3610 "SourceListView.c"
		}
	}
}

void
music_source_list_view_remove_playlist (MusicSourceListView* self,
                                        MusicViewWrapper* view)
{
	GeeTreeSet* items = NULL;
	GeeTreeSet* _tmp15_;
#line 482 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 482 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 3625 "SourceListView.c"
	{
		GeeIterator* _playlist_it = NULL;
		MusicPlayListCategory* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 483 "../src/Widgets/SourceListView.vala"
		_tmp0_ = self->priv->playlists_category;
#line 483 "../src/Widgets/SourceListView.vala"
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) _tmp0_);
#line 483 "../src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 483 "../src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 483 "../src/Widgets/SourceListView.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 483 "../src/Widgets/SourceListView.vala"
		_tmp5_ = _tmp4_;
#line 483 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp3_);
#line 483 "../src/Widgets/SourceListView.vala"
		_playlist_it = _tmp5_;
#line 483 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 3652 "SourceListView.c"
			GeeIterator* _tmp6_;
			GraniteWidgetsSourceListItem* playlist = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GraniteWidgetsSourceListItem* _tmp9_;
#line 483 "../src/Widgets/SourceListView.vala"
			_tmp6_ = _playlist_it;
#line 483 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 483 "../src/Widgets/SourceListView.vala"
				break;
#line 3664 "SourceListView.c"
			}
#line 483 "../src/Widgets/SourceListView.vala"
			_tmp7_ = _playlist_it;
#line 483 "../src/Widgets/SourceListView.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 483 "../src/Widgets/SourceListView.vala"
			playlist = (GraniteWidgetsSourceListItem*) _tmp8_;
#line 484 "../src/Widgets/SourceListView.vala"
			_tmp9_ = playlist;
#line 484 "../src/Widgets/SourceListView.vala"
			if (MUSIC_IS_SOURCE_LIST_ITEM (_tmp9_)) {
#line 3676 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp10_;
				GtkGrid* _tmp11_;
				GtkGrid* _tmp12_;
#line 485 "../src/Widgets/SourceListView.vala"
				_tmp10_ = playlist;
#line 485 "../src/Widgets/SourceListView.vala"
				_tmp11_ = music_source_list_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem));
#line 485 "../src/Widgets/SourceListView.vala"
				_tmp12_ = _tmp11_;
#line 485 "../src/Widgets/SourceListView.vala"
				if (G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid) == _tmp12_) {
#line 3688 "SourceListView.c"
					MusicPlayListCategory* _tmp13_;
					GraniteWidgetsSourceListItem* _tmp14_;
#line 486 "../src/Widgets/SourceListView.vala"
					_tmp13_ = self->priv->playlists_category;
#line 486 "../src/Widgets/SourceListView.vala"
					_tmp14_ = playlist;
#line 486 "../src/Widgets/SourceListView.vala"
					granite_widgets_source_list_expandable_item_remove ((GraniteWidgetsSourceListExpandableItem*) _tmp13_, _tmp14_);
#line 487 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (playlist);
#line 487 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (_playlist_it);
#line 487 "../src/Widgets/SourceListView.vala"
					return;
#line 3703 "SourceListView.c"
				}
			}
#line 483 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist);
#line 3708 "SourceListView.c"
		}
#line 483 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_playlist_it);
#line 3712 "SourceListView.c"
	}
#line 491 "../src/Widgets/SourceListView.vala"
	_tmp15_ = gee_tree_set_new (MUSIC_TYPE_SOURCE_LIST_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 491 "../src/Widgets/SourceListView.vala"
	items = _tmp15_;
#line 3718 "SourceListView.c"
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp16_;
		GeeCollection* _tmp17_;
		GeeCollection* _tmp18_;
		GeeCollection* _tmp19_;
		GeeIterator* _tmp20_;
		GeeIterator* _tmp21_;
#line 492 "../src/Widgets/SourceListView.vala"
		_tmp16_ = self->priv->devices_category;
#line 492 "../src/Widgets/SourceListView.vala"
		_tmp17_ = granite_widgets_source_list_expandable_item_get_children (_tmp16_);
#line 492 "../src/Widgets/SourceListView.vala"
		_tmp18_ = _tmp17_;
#line 492 "../src/Widgets/SourceListView.vala"
		_tmp19_ = _tmp18_;
#line 492 "../src/Widgets/SourceListView.vala"
		_tmp20_ = gee_iterable_iterator ((GeeIterable*) _tmp19_);
#line 492 "../src/Widgets/SourceListView.vala"
		_tmp21_ = _tmp20_;
#line 492 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp19_);
#line 492 "../src/Widgets/SourceListView.vala"
		_device_it = _tmp21_;
#line 492 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 3745 "SourceListView.c"
			GeeIterator* _tmp22_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp23_;
			gpointer _tmp24_;
			GraniteWidgetsSourceListItem* _tmp25_;
#line 492 "../src/Widgets/SourceListView.vala"
			_tmp22_ = _device_it;
#line 492 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp22_)) {
#line 492 "../src/Widgets/SourceListView.vala"
				break;
#line 3757 "SourceListView.c"
			}
#line 492 "../src/Widgets/SourceListView.vala"
			_tmp23_ = _device_it;
#line 492 "../src/Widgets/SourceListView.vala"
			_tmp24_ = gee_iterator_get (_tmp23_);
#line 492 "../src/Widgets/SourceListView.vala"
			device = (GraniteWidgetsSourceListItem*) _tmp24_;
#line 493 "../src/Widgets/SourceListView.vala"
			_tmp25_ = device;
#line 493 "../src/Widgets/SourceListView.vala"
			if (MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (_tmp25_)) {
#line 3769 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp26_;
#line 494 "../src/Widgets/SourceListView.vala"
				_tmp26_ = device;
#line 494 "../src/Widgets/SourceListView.vala"
				music_source_list_view_enumerate_children_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem), &items);
#line 3775 "SourceListView.c"
				{
					GeeIterator* _item_it = NULL;
					GeeTreeSet* _tmp27_;
					GeeIterator* _tmp28_;
#line 495 "../src/Widgets/SourceListView.vala"
					_tmp27_ = items;
#line 495 "../src/Widgets/SourceListView.vala"
					_tmp28_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp27_);
#line 495 "../src/Widgets/SourceListView.vala"
					_item_it = _tmp28_;
#line 495 "../src/Widgets/SourceListView.vala"
					while (TRUE) {
#line 3788 "SourceListView.c"
						GeeIterator* _tmp29_;
						MusicSourceListItem* item = NULL;
						GeeIterator* _tmp30_;
						gpointer _tmp31_;
						MusicSourceListItem* _tmp32_;
						GtkGrid* _tmp33_;
						GtkGrid* _tmp34_;
#line 495 "../src/Widgets/SourceListView.vala"
						_tmp29_ = _item_it;
#line 495 "../src/Widgets/SourceListView.vala"
						if (!gee_iterator_next (_tmp29_)) {
#line 495 "../src/Widgets/SourceListView.vala"
							break;
#line 3802 "SourceListView.c"
						}
#line 495 "../src/Widgets/SourceListView.vala"
						_tmp30_ = _item_it;
#line 495 "../src/Widgets/SourceListView.vala"
						_tmp31_ = gee_iterator_get (_tmp30_);
#line 495 "../src/Widgets/SourceListView.vala"
						item = (MusicSourceListItem*) _tmp31_;
#line 496 "../src/Widgets/SourceListView.vala"
						_tmp32_ = item;
#line 496 "../src/Widgets/SourceListView.vala"
						_tmp33_ = music_source_list_item_get_view (_tmp32_);
#line 496 "../src/Widgets/SourceListView.vala"
						_tmp34_ = _tmp33_;
#line 496 "../src/Widgets/SourceListView.vala"
						if (_tmp34_ == G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid)) {
#line 3818 "SourceListView.c"
							MusicSourceListItem* _tmp35_;
							GraniteWidgetsSourceListExpandableItem* _tmp36_;
							GraniteWidgetsSourceListExpandableItem* _tmp37_;
							MusicSourceListItem* _tmp38_;
#line 497 "../src/Widgets/SourceListView.vala"
							_tmp35_ = item;
#line 497 "../src/Widgets/SourceListView.vala"
							_tmp36_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) _tmp35_);
#line 497 "../src/Widgets/SourceListView.vala"
							_tmp37_ = _tmp36_;
#line 497 "../src/Widgets/SourceListView.vala"
							_tmp38_ = item;
#line 497 "../src/Widgets/SourceListView.vala"
							granite_widgets_source_list_expandable_item_remove (_tmp37_, (GraniteWidgetsSourceListItem*) _tmp38_);
#line 498 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (item);
#line 498 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (_item_it);
#line 498 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (device);
#line 498 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (_device_it);
#line 498 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (items);
#line 498 "../src/Widgets/SourceListView.vala"
							return;
#line 3845 "SourceListView.c"
						}
#line 495 "../src/Widgets/SourceListView.vala"
						_g_object_unref0 (item);
#line 3849 "SourceListView.c"
					}
#line 495 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (_item_it);
#line 3853 "SourceListView.c"
				}
			}
#line 492 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 3858 "SourceListView.c"
		}
#line 492 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_device_it);
#line 3862 "SourceListView.c"
	}
#line 482 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (items);
#line 3866 "SourceListView.c"
}

GeeCollection*
music_source_list_view_remove_device (MusicSourceListView* self,
                                      MusicDeviceView* view)
{
	GeeTreeSet* pages = NULL;
	GeeTreeSet* _tmp0_;
	GeeCollection* result;
#line 506 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 506 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 507 "../src/Widgets/SourceListView.vala"
	_tmp0_ = gee_tree_set_new (gtk_grid_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 507 "../src/Widgets/SourceListView.vala"
	pages = _tmp0_;
#line 3884 "SourceListView.c"
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 508 "../src/Widgets/SourceListView.vala"
		_tmp1_ = self->priv->devices_category;
#line 508 "../src/Widgets/SourceListView.vala"
		_tmp2_ = granite_widgets_source_list_expandable_item_get_children (_tmp1_);
#line 508 "../src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 508 "../src/Widgets/SourceListView.vala"
		_tmp4_ = _tmp3_;
#line 508 "../src/Widgets/SourceListView.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 508 "../src/Widgets/SourceListView.vala"
		_tmp6_ = _tmp5_;
#line 508 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp4_);
#line 508 "../src/Widgets/SourceListView.vala"
		_device_it = _tmp6_;
#line 508 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 3911 "SourceListView.c"
			GeeIterator* _tmp7_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GraniteWidgetsSourceListItem* _tmp10_;
#line 508 "../src/Widgets/SourceListView.vala"
			_tmp7_ = _device_it;
#line 508 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 508 "../src/Widgets/SourceListView.vala"
				break;
#line 3923 "SourceListView.c"
			}
#line 508 "../src/Widgets/SourceListView.vala"
			_tmp8_ = _device_it;
#line 508 "../src/Widgets/SourceListView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 508 "../src/Widgets/SourceListView.vala"
			device = (GraniteWidgetsSourceListItem*) _tmp9_;
#line 509 "../src/Widgets/SourceListView.vala"
			_tmp10_ = device;
#line 509 "../src/Widgets/SourceListView.vala"
			if (MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (_tmp10_)) {
#line 3935 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp11_;
				GtkGrid* _tmp12_;
				GtkGrid* _tmp13_;
#line 510 "../src/Widgets/SourceListView.vala"
				_tmp11_ = device;
#line 510 "../src/Widgets/SourceListView.vala"
				_tmp12_ = music_source_list_expandable_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem));
#line 510 "../src/Widgets/SourceListView.vala"
				_tmp13_ = _tmp12_;
#line 510 "../src/Widgets/SourceListView.vala"
				if (G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid) == _tmp13_) {
#line 3947 "SourceListView.c"
					GraniteWidgetsSourceListItem* _tmp14_;
					GraniteWidgetsSourceListExpandableItem* _tmp15_;
					GraniteWidgetsSourceListItem* _tmp16_;
#line 511 "../src/Widgets/SourceListView.vala"
					_tmp14_ = device;
#line 511 "../src/Widgets/SourceListView.vala"
					music_source_list_view_enumerate_children_pages (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem), &pages);
#line 512 "../src/Widgets/SourceListView.vala"
					_tmp15_ = self->priv->devices_category;
#line 512 "../src/Widgets/SourceListView.vala"
					_tmp16_ = device;
#line 512 "../src/Widgets/SourceListView.vala"
					granite_widgets_source_list_expandable_item_remove (_tmp15_, _tmp16_);
#line 513 "../src/Widgets/SourceListView.vala"
					result = (GeeCollection*) pages;
#line 513 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (device);
#line 513 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (_device_it);
#line 513 "../src/Widgets/SourceListView.vala"
					return result;
#line 3969 "SourceListView.c"
				}
			}
#line 508 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 3974 "SourceListView.c"
		}
#line 508 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_device_it);
#line 3978 "SourceListView.c"
	}
#line 517 "../src/Widgets/SourceListView.vala"
	result = (GeeCollection*) pages;
#line 517 "../src/Widgets/SourceListView.vala"
	return result;
#line 3984 "SourceListView.c"
}

static GtkGrid*
music_source_list_view_get_device_from_item (MusicSourceListView* self,
                                             MusicSourceListExpandableItem* item)
{
	GtkGrid* result;
#line 521 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 521 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 3996 "SourceListView.c"
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 522 "../src/Widgets/SourceListView.vala"
		_tmp0_ = self->priv->devices_category;
#line 522 "../src/Widgets/SourceListView.vala"
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children (_tmp0_);
#line 522 "../src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 522 "../src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 522 "../src/Widgets/SourceListView.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 522 "../src/Widgets/SourceListView.vala"
		_tmp5_ = _tmp4_;
#line 522 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp3_);
#line 522 "../src/Widgets/SourceListView.vala"
		_device_it = _tmp5_;
#line 522 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4023 "SourceListView.c"
			GeeIterator* _tmp6_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GraniteWidgetsSourceListExpandableItem* _tmp9_;
			GraniteWidgetsSourceListExpandableItem* _tmp10_;
			GraniteWidgetsSourceListItem* _tmp11_;
#line 522 "../src/Widgets/SourceListView.vala"
			_tmp6_ = _device_it;
#line 522 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 522 "../src/Widgets/SourceListView.vala"
				break;
#line 4037 "SourceListView.c"
			}
#line 522 "../src/Widgets/SourceListView.vala"
			_tmp7_ = _device_it;
#line 522 "../src/Widgets/SourceListView.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 522 "../src/Widgets/SourceListView.vala"
			device = (GraniteWidgetsSourceListItem*) _tmp8_;
#line 523 "../src/Widgets/SourceListView.vala"
			_tmp9_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) item);
#line 523 "../src/Widgets/SourceListView.vala"
			_tmp10_ = _tmp9_;
#line 523 "../src/Widgets/SourceListView.vala"
			_tmp11_ = device;
#line 523 "../src/Widgets/SourceListView.vala"
			if (_tmp10_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem)) {
#line 4053 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp12_;
#line 524 "../src/Widgets/SourceListView.vala"
				_tmp12_ = device;
#line 524 "../src/Widgets/SourceListView.vala"
				if (MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (_tmp12_)) {
#line 4059 "SourceListView.c"
					GraniteWidgetsSourceListItem* _tmp13_;
					GtkGrid* _tmp14_;
					GtkGrid* _tmp15_;
					GtkGrid* _tmp16_;
#line 525 "../src/Widgets/SourceListView.vala"
					_tmp13_ = device;
#line 525 "../src/Widgets/SourceListView.vala"
					_tmp14_ = music_source_list_expandable_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem));
#line 525 "../src/Widgets/SourceListView.vala"
					_tmp15_ = _tmp14_;
#line 525 "../src/Widgets/SourceListView.vala"
					_tmp16_ = _g_object_ref0 (_tmp15_);
#line 525 "../src/Widgets/SourceListView.vala"
					result = _tmp16_;
#line 525 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (device);
#line 525 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (_device_it);
#line 525 "../src/Widgets/SourceListView.vala"
					return result;
#line 4080 "SourceListView.c"
				}
			}
#line 522 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 4085 "SourceListView.c"
		}
#line 522 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_device_it);
#line 4089 "SourceListView.c"
	}
#line 529 "../src/Widgets/SourceListView.vala"
	result = NULL;
#line 529 "../src/Widgets/SourceListView.vala"
	return result;
#line 4095 "SourceListView.c"
}

static void
music_source_list_view_enumerate_children_pages (MusicSourceListView* self,
                                                 MusicSourceListExpandableItem* exp_item,
                                                 GeeTreeSet** pages)
{
#line 532 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 532 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (exp_item != NULL);
#line 532 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (*pages != NULL);
#line 4109 "SourceListView.c"
	{
		GeeIterator* _views_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 533 "../src/Widgets/SourceListView.vala"
		_tmp0_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) G_TYPE_CHECK_INSTANCE_CAST (exp_item, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem));
#line 533 "../src/Widgets/SourceListView.vala"
		_tmp1_ = _tmp0_;
#line 533 "../src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 533 "../src/Widgets/SourceListView.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 533 "../src/Widgets/SourceListView.vala"
		_tmp4_ = _tmp3_;
#line 533 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp2_);
#line 533 "../src/Widgets/SourceListView.vala"
		_views_it = _tmp4_;
#line 533 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4133 "SourceListView.c"
			GeeIterator* _tmp5_;
			GraniteWidgetsSourceListItem* views = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GraniteWidgetsSourceListItem* _tmp8_;
#line 533 "../src/Widgets/SourceListView.vala"
			_tmp5_ = _views_it;
#line 533 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 533 "../src/Widgets/SourceListView.vala"
				break;
#line 4145 "SourceListView.c"
			}
#line 533 "../src/Widgets/SourceListView.vala"
			_tmp6_ = _views_it;
#line 533 "../src/Widgets/SourceListView.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 533 "../src/Widgets/SourceListView.vala"
			views = (GraniteWidgetsSourceListItem*) _tmp7_;
#line 534 "../src/Widgets/SourceListView.vala"
			_tmp8_ = views;
#line 534 "../src/Widgets/SourceListView.vala"
			if (MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (_tmp8_)) {
#line 4157 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp9_;
				GtkGrid* _tmp10_;
				GtkGrid* _tmp11_;
				GraniteWidgetsSourceListItem* _tmp12_;
#line 535 "../src/Widgets/SourceListView.vala"
				_tmp9_ = views;
#line 535 "../src/Widgets/SourceListView.vala"
				_tmp10_ = music_source_list_expandable_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem));
#line 535 "../src/Widgets/SourceListView.vala"
				_tmp11_ = _tmp10_;
#line 535 "../src/Widgets/SourceListView.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) (*pages), _tmp11_);
#line 536 "../src/Widgets/SourceListView.vala"
				_tmp12_ = views;
#line 536 "../src/Widgets/SourceListView.vala"
				music_source_list_view_enumerate_children_pages (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem), pages);
#line 4174 "SourceListView.c"
			} else {
				GraniteWidgetsSourceListItem* _tmp13_;
#line 537 "../src/Widgets/SourceListView.vala"
				_tmp13_ = views;
#line 537 "../src/Widgets/SourceListView.vala"
				if (MUSIC_IS_SOURCE_LIST_ITEM (_tmp13_)) {
#line 4181 "SourceListView.c"
					GraniteWidgetsSourceListItem* _tmp14_;
					GtkGrid* _tmp15_;
					GtkGrid* _tmp16_;
#line 538 "../src/Widgets/SourceListView.vala"
					_tmp14_ = views;
#line 538 "../src/Widgets/SourceListView.vala"
					_tmp15_ = music_source_list_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem));
#line 538 "../src/Widgets/SourceListView.vala"
					_tmp16_ = _tmp15_;
#line 538 "../src/Widgets/SourceListView.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) (*pages), _tmp16_);
#line 4193 "SourceListView.c"
				}
			}
#line 533 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (views);
#line 4198 "SourceListView.c"
		}
#line 533 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_views_it);
#line 4202 "SourceListView.c"
	}
}

static void
music_source_list_view_enumerate_children_items (MusicSourceListView* self,
                                                 MusicSourceListExpandableItem* exp_item,
                                                 GeeTreeSet** pages)
{
#line 543 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 543 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (exp_item != NULL);
#line 543 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (*pages != NULL);
#line 4217 "SourceListView.c"
	{
		GeeIterator* _views_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 544 "../src/Widgets/SourceListView.vala"
		_tmp0_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) G_TYPE_CHECK_INSTANCE_CAST (exp_item, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem));
#line 544 "../src/Widgets/SourceListView.vala"
		_tmp1_ = _tmp0_;
#line 544 "../src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 544 "../src/Widgets/SourceListView.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 544 "../src/Widgets/SourceListView.vala"
		_tmp4_ = _tmp3_;
#line 544 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp2_);
#line 544 "../src/Widgets/SourceListView.vala"
		_views_it = _tmp4_;
#line 544 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4241 "SourceListView.c"
			GeeIterator* _tmp5_;
			GraniteWidgetsSourceListItem* views = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GraniteWidgetsSourceListItem* _tmp8_;
#line 544 "../src/Widgets/SourceListView.vala"
			_tmp5_ = _views_it;
#line 544 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 544 "../src/Widgets/SourceListView.vala"
				break;
#line 4253 "SourceListView.c"
			}
#line 544 "../src/Widgets/SourceListView.vala"
			_tmp6_ = _views_it;
#line 544 "../src/Widgets/SourceListView.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 544 "../src/Widgets/SourceListView.vala"
			views = (GraniteWidgetsSourceListItem*) _tmp7_;
#line 545 "../src/Widgets/SourceListView.vala"
			_tmp8_ = views;
#line 545 "../src/Widgets/SourceListView.vala"
			if (MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (_tmp8_)) {
#line 4265 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp9_;
#line 546 "../src/Widgets/SourceListView.vala"
				_tmp9_ = views;
#line 546 "../src/Widgets/SourceListView.vala"
				music_source_list_view_enumerate_children_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem), pages);
#line 4271 "SourceListView.c"
			} else {
				GraniteWidgetsSourceListItem* _tmp10_;
#line 547 "../src/Widgets/SourceListView.vala"
				_tmp10_ = views;
#line 547 "../src/Widgets/SourceListView.vala"
				if (MUSIC_IS_SOURCE_LIST_ITEM (_tmp10_)) {
#line 4278 "SourceListView.c"
					GraniteWidgetsSourceListItem* _tmp11_;
#line 548 "../src/Widgets/SourceListView.vala"
					_tmp11_ = views;
#line 548 "../src/Widgets/SourceListView.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) (*pages), G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem));
#line 4284 "SourceListView.c"
				}
			}
#line 544 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (views);
#line 4289 "SourceListView.c"
		}
#line 544 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_views_it);
#line 4293 "SourceListView.c"
	}
}

void
music_source_list_view_change_playlist_name (MusicSourceListView* self,
                                             MusicViewWrapper* view,
                                             const gchar* new_name)
{
	GeeTreeSet* items = NULL;
	GeeTreeSet* _tmp14_;
#line 554 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 554 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 554 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (new_name != NULL);
#line 4310 "SourceListView.c"
	{
		GeeIterator* _playlist_it = NULL;
		MusicPlayListCategory* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 555 "../src/Widgets/SourceListView.vala"
		_tmp0_ = self->priv->playlists_category;
#line 555 "../src/Widgets/SourceListView.vala"
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) _tmp0_);
#line 555 "../src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 555 "../src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 555 "../src/Widgets/SourceListView.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 555 "../src/Widgets/SourceListView.vala"
		_tmp5_ = _tmp4_;
#line 555 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp3_);
#line 555 "../src/Widgets/SourceListView.vala"
		_playlist_it = _tmp5_;
#line 555 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4337 "SourceListView.c"
			GeeIterator* _tmp6_;
			GraniteWidgetsSourceListItem* playlist = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GraniteWidgetsSourceListItem* _tmp9_;
#line 555 "../src/Widgets/SourceListView.vala"
			_tmp6_ = _playlist_it;
#line 555 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 555 "../src/Widgets/SourceListView.vala"
				break;
#line 4349 "SourceListView.c"
			}
#line 555 "../src/Widgets/SourceListView.vala"
			_tmp7_ = _playlist_it;
#line 555 "../src/Widgets/SourceListView.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 555 "../src/Widgets/SourceListView.vala"
			playlist = (GraniteWidgetsSourceListItem*) _tmp8_;
#line 556 "../src/Widgets/SourceListView.vala"
			_tmp9_ = playlist;
#line 556 "../src/Widgets/SourceListView.vala"
			if (MUSIC_IS_SOURCE_LIST_ITEM (_tmp9_)) {
#line 4361 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp10_;
				GtkGrid* _tmp11_;
				GtkGrid* _tmp12_;
#line 557 "../src/Widgets/SourceListView.vala"
				_tmp10_ = playlist;
#line 557 "../src/Widgets/SourceListView.vala"
				_tmp11_ = music_source_list_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem));
#line 557 "../src/Widgets/SourceListView.vala"
				_tmp12_ = _tmp11_;
#line 557 "../src/Widgets/SourceListView.vala"
				if (G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid) == _tmp12_) {
#line 4373 "SourceListView.c"
					GraniteWidgetsSourceListItem* _tmp13_;
#line 558 "../src/Widgets/SourceListView.vala"
					_tmp13_ = playlist;
#line 558 "../src/Widgets/SourceListView.vala"
					granite_widgets_source_list_item_set_name ((GraniteWidgetsSourceListItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem), new_name);
#line 559 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (playlist);
#line 559 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (_playlist_it);
#line 559 "../src/Widgets/SourceListView.vala"
					return;
#line 4385 "SourceListView.c"
				}
			}
#line 555 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist);
#line 4390 "SourceListView.c"
		}
#line 555 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_playlist_it);
#line 4394 "SourceListView.c"
	}
#line 563 "../src/Widgets/SourceListView.vala"
	_tmp14_ = gee_tree_set_new (MUSIC_TYPE_SOURCE_LIST_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 563 "../src/Widgets/SourceListView.vala"
	items = _tmp14_;
#line 4400 "SourceListView.c"
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp15_;
		GeeCollection* _tmp16_;
		GeeCollection* _tmp17_;
		GeeCollection* _tmp18_;
		GeeIterator* _tmp19_;
		GeeIterator* _tmp20_;
#line 564 "../src/Widgets/SourceListView.vala"
		_tmp15_ = self->priv->devices_category;
#line 564 "../src/Widgets/SourceListView.vala"
		_tmp16_ = granite_widgets_source_list_expandable_item_get_children (_tmp15_);
#line 564 "../src/Widgets/SourceListView.vala"
		_tmp17_ = _tmp16_;
#line 564 "../src/Widgets/SourceListView.vala"
		_tmp18_ = _tmp17_;
#line 564 "../src/Widgets/SourceListView.vala"
		_tmp19_ = gee_iterable_iterator ((GeeIterable*) _tmp18_);
#line 564 "../src/Widgets/SourceListView.vala"
		_tmp20_ = _tmp19_;
#line 564 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp18_);
#line 564 "../src/Widgets/SourceListView.vala"
		_device_it = _tmp20_;
#line 564 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4427 "SourceListView.c"
			GeeIterator* _tmp21_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp22_;
			gpointer _tmp23_;
			GraniteWidgetsSourceListItem* _tmp24_;
#line 564 "../src/Widgets/SourceListView.vala"
			_tmp21_ = _device_it;
#line 564 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp21_)) {
#line 564 "../src/Widgets/SourceListView.vala"
				break;
#line 4439 "SourceListView.c"
			}
#line 564 "../src/Widgets/SourceListView.vala"
			_tmp22_ = _device_it;
#line 564 "../src/Widgets/SourceListView.vala"
			_tmp23_ = gee_iterator_get (_tmp22_);
#line 564 "../src/Widgets/SourceListView.vala"
			device = (GraniteWidgetsSourceListItem*) _tmp23_;
#line 565 "../src/Widgets/SourceListView.vala"
			_tmp24_ = device;
#line 565 "../src/Widgets/SourceListView.vala"
			if (MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (_tmp24_)) {
#line 4451 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp25_;
#line 566 "../src/Widgets/SourceListView.vala"
				_tmp25_ = device;
#line 566 "../src/Widgets/SourceListView.vala"
				music_source_list_view_enumerate_children_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem), &items);
#line 4457 "SourceListView.c"
				{
					GeeIterator* _item_it = NULL;
					GeeTreeSet* _tmp26_;
					GeeIterator* _tmp27_;
#line 567 "../src/Widgets/SourceListView.vala"
					_tmp26_ = items;
#line 567 "../src/Widgets/SourceListView.vala"
					_tmp27_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp26_);
#line 567 "../src/Widgets/SourceListView.vala"
					_item_it = _tmp27_;
#line 567 "../src/Widgets/SourceListView.vala"
					while (TRUE) {
#line 4470 "SourceListView.c"
						GeeIterator* _tmp28_;
						MusicSourceListItem* item = NULL;
						GeeIterator* _tmp29_;
						gpointer _tmp30_;
						MusicSourceListItem* _tmp31_;
						GtkGrid* _tmp32_;
						GtkGrid* _tmp33_;
#line 567 "../src/Widgets/SourceListView.vala"
						_tmp28_ = _item_it;
#line 567 "../src/Widgets/SourceListView.vala"
						if (!gee_iterator_next (_tmp28_)) {
#line 567 "../src/Widgets/SourceListView.vala"
							break;
#line 4484 "SourceListView.c"
						}
#line 567 "../src/Widgets/SourceListView.vala"
						_tmp29_ = _item_it;
#line 567 "../src/Widgets/SourceListView.vala"
						_tmp30_ = gee_iterator_get (_tmp29_);
#line 567 "../src/Widgets/SourceListView.vala"
						item = (MusicSourceListItem*) _tmp30_;
#line 568 "../src/Widgets/SourceListView.vala"
						_tmp31_ = item;
#line 568 "../src/Widgets/SourceListView.vala"
						_tmp32_ = music_source_list_item_get_view (_tmp31_);
#line 568 "../src/Widgets/SourceListView.vala"
						_tmp33_ = _tmp32_;
#line 568 "../src/Widgets/SourceListView.vala"
						if (_tmp33_ == G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid)) {
#line 4500 "SourceListView.c"
							MusicSourceListItem* _tmp34_;
#line 569 "../src/Widgets/SourceListView.vala"
							_tmp34_ = item;
#line 569 "../src/Widgets/SourceListView.vala"
							granite_widgets_source_list_item_set_name ((GraniteWidgetsSourceListItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem), new_name);
#line 570 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (item);
#line 570 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (_item_it);
#line 570 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (device);
#line 570 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (_device_it);
#line 570 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (items);
#line 570 "../src/Widgets/SourceListView.vala"
							return;
#line 4518 "SourceListView.c"
						}
#line 567 "../src/Widgets/SourceListView.vala"
						_g_object_unref0 (item);
#line 4522 "SourceListView.c"
					}
#line 567 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (_item_it);
#line 4526 "SourceListView.c"
				}
			}
#line 564 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 4531 "SourceListView.c"
		}
#line 564 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_device_it);
#line 4535 "SourceListView.c"
	}
#line 554 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (items);
#line 4539 "SourceListView.c"
}

void
music_source_list_view_change_device_name (MusicSourceListView* self,
                                           MusicDeviceView* view,
                                           const gchar* new_name)
{
#line 578 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 578 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 578 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (new_name != NULL);
#line 4553 "SourceListView.c"
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 579 "../src/Widgets/SourceListView.vala"
		_tmp0_ = self->priv->devices_category;
#line 579 "../src/Widgets/SourceListView.vala"
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children (_tmp0_);
#line 579 "../src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 579 "../src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 579 "../src/Widgets/SourceListView.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 579 "../src/Widgets/SourceListView.vala"
		_tmp5_ = _tmp4_;
#line 579 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp3_);
#line 579 "../src/Widgets/SourceListView.vala"
		_device_it = _tmp5_;
#line 579 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4580 "SourceListView.c"
			GeeIterator* _tmp6_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GraniteWidgetsSourceListItem* _tmp9_;
#line 579 "../src/Widgets/SourceListView.vala"
			_tmp6_ = _device_it;
#line 579 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 579 "../src/Widgets/SourceListView.vala"
				break;
#line 4592 "SourceListView.c"
			}
#line 579 "../src/Widgets/SourceListView.vala"
			_tmp7_ = _device_it;
#line 579 "../src/Widgets/SourceListView.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 579 "../src/Widgets/SourceListView.vala"
			device = (GraniteWidgetsSourceListItem*) _tmp8_;
#line 580 "../src/Widgets/SourceListView.vala"
			_tmp9_ = device;
#line 580 "../src/Widgets/SourceListView.vala"
			if (MUSIC_IS_SOURCE_LIST_ITEM (_tmp9_)) {
#line 4604 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp10_;
				GtkGrid* _tmp11_;
				GtkGrid* _tmp12_;
#line 581 "../src/Widgets/SourceListView.vala"
				_tmp10_ = device;
#line 581 "../src/Widgets/SourceListView.vala"
				_tmp11_ = music_source_list_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem));
#line 581 "../src/Widgets/SourceListView.vala"
				_tmp12_ = _tmp11_;
#line 581 "../src/Widgets/SourceListView.vala"
				if (G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid) == _tmp12_) {
#line 4616 "SourceListView.c"
					GraniteWidgetsSourceListItem* _tmp13_;
#line 582 "../src/Widgets/SourceListView.vala"
					_tmp13_ = device;
#line 582 "../src/Widgets/SourceListView.vala"
					granite_widgets_source_list_item_set_name ((GraniteWidgetsSourceListItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem), new_name);
#line 583 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (device);
#line 583 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (_device_it);
#line 583 "../src/Widgets/SourceListView.vala"
					return;
#line 4628 "SourceListView.c"
				}
			}
#line 579 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 4633 "SourceListView.c"
		}
#line 579 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_device_it);
#line 4637 "SourceListView.c"
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_STRING) (gpointer data1, gpointer arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 308 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (n_param_values == 3);
#line 308 "../src/Widgets/SourceListView.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 308 "../src/Widgets/SourceListView.vala"
		data1 = closure->data;
#line 308 "../src/Widgets/SourceListView.vala"
		data2 = param_values->data[0].v_pointer;
#line 4663 "SourceListView.c"
	} else {
#line 308 "../src/Widgets/SourceListView.vala"
		data1 = param_values->data[0].v_pointer;
#line 308 "../src/Widgets/SourceListView.vala"
		data2 = closure->data;
#line 4669 "SourceListView.c"
	}
#line 308 "../src/Widgets/SourceListView.vala"
	callback = (GMarshalFunc_VOID__OBJECT_STRING) (marshal_data ? marshal_data : cc->callback);
#line 308 "../src/Widgets/SourceListView.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 4675 "SourceListView.c"
}

static void
music_source_list_view_class_init (MusicSourceListViewClass * klass,
                                   gpointer klass_data)
{
#line 308 "../src/Widgets/SourceListView.vala"
	music_source_list_view_parent_class = g_type_class_peek_parent (klass);
#line 308 "../src/Widgets/SourceListView.vala"
	g_type_class_adjust_private_offset (klass, &MusicSourceListView_private_offset);
#line 308 "../src/Widgets/SourceListView.vala"
	((GraniteWidgetsSourceListClass *) klass)->item_selected = (void (*) (GraniteWidgetsSourceList*, GraniteWidgetsSourceListItem*)) music_source_list_view_real_item_selected;
#line 308 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->finalize = music_source_list_view_finalize;
#line 308 "../src/Widgets/SourceListView.vala"
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_EDITED_SIGNAL] = g_signal_new ("edited", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_STRING, G_TYPE_NONE, 2, gtk_grid_get_type (), G_TYPE_STRING);
#line 308 "../src/Widgets/SourceListView.vala"
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_ITEM_ACTION_ACTIVATED_SIGNAL] = g_signal_new ("item-action-activated", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_ACTIVATED_SIGNAL] = g_signal_new ("activated", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 308 "../src/Widgets/SourceListView.vala"
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_RENAME_CLICKED_SIGNAL] = g_signal_new ("playlist-rename-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_EDIT_CLICKED_SIGNAL] = g_signal_new ("playlist-edit-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_REMOVE_CLICKED_SIGNAL] = g_signal_new ("playlist-remove-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_SAVE_CLICKED_SIGNAL] = g_signal_new ("playlist-save-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_EXPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-export-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_IMPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-import-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 308 "../src/Widgets/SourceListView.vala"
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_MEDIA_ADDED_SIGNAL] = g_signal_new ("playlist-media-added", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOXED_INT, G_TYPE_NONE, 3, gtk_grid_get_type (), G_TYPE_STRV, G_TYPE_INT);
#line 308 "../src/Widgets/SourceListView.vala"
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_IMPORT_CLICKED_SIGNAL] = g_signal_new ("device-import-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_EJECT_CLICKED_SIGNAL] = g_signal_new ("device-eject-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_SYNC_CLICKED_SIGNAL] = g_signal_new ("device-sync-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-playlist-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-smartplaylist-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 4722 "SourceListView.c"
}

static void
music_source_list_view_instance_init (MusicSourceListView * self,
                                      gpointer klass)
{
#line 308 "../src/Widgets/SourceListView.vala"
	self->priv = music_source_list_view_get_instance_private (self);
#line 4731 "SourceListView.c"
}

static void
music_source_list_view_finalize (GObject * obj)
{
	MusicSourceListView * self;
#line 308 "../src/Widgets/SourceListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_SOURCE_LIST_VIEW, MusicSourceListView);
#line 310 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->library_category);
#line 311 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->devices_category);
#line 312 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->network_category);
#line 313 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlists_category);
#line 308 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (music_source_list_view_parent_class)->finalize (obj);
#line 4750 "SourceListView.c"
}

static GType
music_source_list_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicSourceListViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_source_list_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicSourceListView), 0, (GInstanceInitFunc) music_source_list_view_instance_init, NULL };
	GType music_source_list_view_type_id;
	music_source_list_view_type_id = g_type_register_static (GRANITE_WIDGETS_TYPE_SOURCE_LIST, "MusicSourceListView", &g_define_type_info, 0);
	MusicSourceListView_private_offset = g_type_add_instance_private (music_source_list_view_type_id, sizeof (MusicSourceListViewPrivate));
	return music_source_list_view_type_id;
}

GType
music_source_list_view_get_type (void)
{
	static volatile gsize music_source_list_view_type_id__once = 0;
	if (g_once_init_enter (&music_source_list_view_type_id__once)) {
		GType music_source_list_view_type_id;
		music_source_list_view_type_id = music_source_list_view_get_type_once ();
		g_once_init_leave (&music_source_list_view_type_id__once, music_source_list_view_type_id);
	}
	return music_source_list_view_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

