/* iPodLibrary.c generated by valac 0.56.0, the Vala compiler
 * generated from iPodLibrary.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "ipod-device.h"
#include <gpod/itdb.h>
#include <gee.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

enum  {
	MUSIC_PLUGINS_IPOD_LIBRARY_0_PROPERTY,
	MUSIC_PLUGINS_IPOD_LIBRARY_NUM_PROPERTIES
};
static GParamSpec* music_plugins_ipod_library_properties[MUSIC_PLUGINS_IPOD_LIBRARY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
typedef struct _MusicPluginsIpodLibraryFinishInitializationAsyncData MusicPluginsIpodLibraryFinishInitializationAsyncData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _itdb_track_free0(var) ((var == NULL) ? NULL : (var = (itdb_track_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _MusicPluginsIpodLibraryAddMediasAsyncData MusicPluginsIpodLibraryAddMediasAsyncData;
typedef struct _MusicPluginsIpodLibraryRemoveMediasAsyncData MusicPluginsIpodLibraryRemoveMediasAsyncData;
typedef struct _Block2Data Block2Data;
#define _itdb_playlist_free0(var) ((var == NULL) ? NULL : (var = (itdb_playlist_free (var), NULL)))

struct _MusicPluginsiPodLibraryPrivate {
	Itdb_iTunesDB* db;
	GeeHashMap* medias;
	GRecMutex __lock_medias;
	GeeLinkedList* searched_medias;
	GRecMutex __lock_searched_medias;
	GeeHashMap* playlists;
	GeeHashMap* smart_playlists;
	MusicDevice* device;
	gboolean operation_cancelled;
	gboolean is_doing_file_operations;
};

struct _Block1Data {
	int _ref_count_;
	MusicPluginsiPodLibrary* self;
	MusicPlaylist* playlist;
};

struct _MusicPluginsIpodLibraryFinishInitializationAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicPluginsiPodLibrary* self;
	gint i;
	gboolean _tmp0_;
	gint _tmp1_;
	Itdb_iTunesDB* _tmp2_;
	GList* _tmp3_;
	Itdb_Track* t;
	Itdb_iTunesDB* _tmp4_;
	GList* _tmp5_;
	gconstpointer _tmp6_;
	MusicMedia* m;
	MusicDevice* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	Itdb_Track* _tmp10_;
	MusicMedia* _tmp11_;
	MusicMedia* _tmp12_;
	gboolean _tmp13_;
	MusicMedia* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	GeeHashMap* _tmp17_;
	Itdb_Track* _tmp18_;
	MusicMedia* _tmp19_;
	GeeHashMap* _tmp20_;
	Itdb_Track* _tmp21_;
	MusicMedia* _tmp22_;
	Itdb_iTunesDB* _tmp23_;
	GList* _tmp24_;
	GList* p_collection;
	GList* p_it;
	Itdb_Playlist* p;
	Block1Data* _data1_;
	Itdb_Playlist* _tmp25_;
	GeeHashMap* _tmp26_;
	MusicPlaylist* _tmp27_;
	MusicPlaylist* _tmp28_;
	MusicPlaylist* _tmp29_;
	GeeHashMap* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	GeeHashMap* _tmp33_;
	Itdb_Playlist* _tmp34_;
	MusicPlaylist* _tmp35_;
	MusicPlaylist* _tmp36_;
	MusicPlaylist* _tmp37_;
	MusicPlaylist* _tmp38_;
	MusicPlaylist* _tmp39_;
	GeeHashMap* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	GeeHashMap* _tmp43_;
	Itdb_Playlist* _tmp44_;
	MusicPlaylist* _tmp45_;
};

struct _MusicPluginsIpodLibraryAddMediasAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicPluginsiPodLibrary* self;
	GeeCollection* to_add;
	gboolean error_occurred;
	Itdb_iTunesDB* _tmp0_;
	gint total;
	gint _tmp1_;
	gint _tmp2_;
	gint index;
	GeeIterator* _m_it;
	GeeIterator* _tmp3_;
	GeeIterator* _tmp4_;
	MusicMedia* m;
	GeeIterator* _tmp5_;
	gpointer _tmp6_;
	MusicMedia* _tmp7_;
	gint _tmp8_;
	MusicLibrariesManager* _tmp9_;
	MusicLibrariesManager* _tmp10_;
	gchar* _tmp11_;
	Itdb_iTunesDB* _tmp12_;
	GError* err;
	GError* _tmp13_;
	const gchar* _tmp14_;
	MusicLibrariesManager* _tmp15_;
	Itdb_iTunesDB* _tmp16_;
	MusicLibrariesManager* _tmp17_;
	gchar* _tmp18_;
	Itdb_iTunesDB* _tmp19_;
	GError* _vala1_err;
	GError* _tmp20_;
	const gchar* _tmp21_;
	Itdb_iTunesDB* _tmp22_;
	MusicLibrariesManager* _tmp23_;
	GError* _inner_error0_;
};

struct _MusicPluginsIpodLibraryRemoveMediasAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicPluginsiPodLibrary* self;
	GeeCollection* list;
	gboolean error_occurred;
	gint total;
	gint _tmp0_;
	gint _tmp1_;
	gint index;
	Itdb_iTunesDB* _tmp2_;
	GeeHashMap* removed;
	GeeHashMap* _tmp3_;
	GeeIterator* _e_it;
	GeeHashMap* _tmp4_;
	GeeSet* _tmp5_;
	GeeSet* _tmp6_;
	GeeSet* _tmp7_;
	GeeIterator* _tmp8_;
	GeeIterator* _tmp9_;
	GeeIterator* _tmp10_;
	GeeMapEntry* e;
	GeeIterator* _tmp11_;
	gpointer _tmp12_;
	GeeIterator* _m_it;
	GeeIterator* _tmp13_;
	GeeIterator* _tmp14_;
	MusicMedia* m;
	GeeIterator* _tmp15_;
	gpointer _tmp16_;
	MusicMedia* _tmp17_;
	GeeMapEntry* _tmp18_;
	gconstpointer _tmp19_;
	gconstpointer _tmp20_;
	Itdb_Track* t;
	GeeMapEntry* _tmp21_;
	gconstpointer _tmp22_;
	gconstpointer _tmp23_;
	Itdb_Track* _tmp24_;
	GeeHashMap* _tmp25_;
	Itdb_Track* _tmp26_;
	GeeMapEntry* _tmp27_;
	gconstpointer _tmp28_;
	gconstpointer _tmp29_;
	gint _tmp30_;
	MusicLibrariesManager* _tmp31_;
	GeeIterator* _track_it;
	GeeHashMap* _tmp32_;
	GeeSet* _tmp33_;
	GeeSet* _tmp34_;
	GeeSet* _tmp35_;
	GeeIterator* _tmp36_;
	GeeIterator* _tmp37_;
	GeeIterator* _tmp38_;
	Itdb_Track* track;
	GeeIterator* _tmp39_;
	gpointer _tmp40_;
	Itdb_Track* _tmp41_;
	GeeHashMap* _tmp42_;
	GeeHashMap* _tmp43_;
	MusicLibrariesManager* _tmp44_;
	gchar* _tmp45_;
	Itdb_iTunesDB* _tmp46_;
	GError* err;
	GError* _tmp47_;
	const gchar* _tmp48_;
	MusicLibrariesManager* _tmp49_;
	Itdb_iTunesDB* _tmp50_;
	MusicLibrariesManager* _tmp51_;
	gchar* _tmp52_;
	Itdb_iTunesDB* _tmp53_;
	GError* _vala1_err;
	GError* _tmp54_;
	const gchar* _tmp55_;
	Itdb_iTunesDB* _tmp56_;
	MusicLibrariesManager* _tmp57_;
	GError* _inner_error0_;
};

struct _Block2Data {
	int _ref_count_;
	MusicPluginsiPodLibrary* self;
	MusicStaticPlaylist* p;
};

static gint MusicPluginsiPodLibrary_private_offset;
static gpointer music_plugins_ipod_library_parent_class = NULL;
static GType music_plugins_ipod_library_type_id = 0;

static void __lambda4_ (MusicPluginsiPodLibrary* self);
static void ___lambda4__music_notification_manager_progress_canceled (MusicNotificationManager* _sender,
                                                               gpointer self);
static void music_plugins_ipod_library_real_initialize_library (MusicLibrary* base);
static void music_plugins_ipod_library_finish_initialization_async_data_free (gpointer _data);
static gboolean music_plugins_ipod_library_finish_initialization_async_co (MusicPluginsIpodLibraryFinishInitializationAsyncData* _data_);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void _____lambda5_ (Block1Data* _data1_,
                    GeeCollection* list);
static void music_plugins_ipod_library_keep_playlist_synchronized (MusicPluginsiPodLibrary* self,
                                                            MusicStaticPlaylist* p,
                                                            GeeCollection* m,
                                                            gboolean to_add);
static void ______lambda5__music_playlist_media_added (MusicPlaylist* _sender,
                                                GeeCollection* media,
                                                gpointer self);
static void _____lambda6_ (Block1Data* _data1_,
                    GeeCollection* list);
static void ______lambda6__music_playlist_media_removed (MusicPlaylist* _sender,
                                                  GeeCollection* media,
                                                  gpointer self);
static gboolean __lambda7_ (MusicPluginsiPodLibrary* self);
static gboolean ___lambda7__gsource_func (gpointer self);
static void music_plugins_ipod_library_real_add_files_to_library (MusicLibrary* base,
                                                           GeeCollection* files);
static void music_plugins_ipod_library_real_search_medias (MusicLibrary* base,
                                                    const gchar* search);
static GeeCollection* music_plugins_ipod_library_real_get_search_result (MusicLibrary* base);
static GeeCollection* music_plugins_ipod_library_real_get_medias (MusicLibrary* base);
static GeeCollection* music_plugins_ipod_library_real_get_playlists (MusicLibrary* base);
static GeeCollection* music_plugins_ipod_library_real_get_smart_playlists (MusicLibrary* base);
static void music_plugins_ipod_library_real_add_media (MusicLibrary* base,
                                                MusicMedia* s);
static void music_plugins_ipod_library_remove_media_from_ipod (MusicPluginsiPodLibrary* self,
                                                        Itdb_Track* t);
static void music_plugins_ipod_library_real_add_medias (MusicLibrary* base,
                                                 GeeCollection* list);
static gboolean _music_libraries_manager_do_progress_notification_with_timeout_gsource_func (gpointer self);
static void music_plugins_ipod_library_add_medias_async (MusicPluginsiPodLibrary* self,
                                                  GeeCollection* to_add,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
static void music_plugins_ipod_library_add_medias_finish (MusicPluginsiPodLibrary* self,
                                                   GAsyncResult* _res_);
static void music_plugins_ipod_library_add_medias_async_data_free (gpointer _data);
static gboolean music_plugins_ipod_library_add_medias_async_co (MusicPluginsIpodLibraryAddMediasAsyncData* _data_);
static gboolean __lambda8_ (MusicPluginsiPodLibrary* self);
static gboolean ___lambda8__gsource_func (gpointer self);
static MusicMedia* music_plugins_ipod_library_real_media_from_id (MusicLibrary* base,
                                                           gint64 id);
static GeeCollection* music_plugins_ipod_library_real_medias_from_ids (MusicLibrary* base,
                                                                GeeCollection* ids);
static GeeCollection* music_plugins_ipod_library_real_medias_from_uris (MusicLibrary* base,
                                                                 GeeCollection* uris);
static MusicMedia* music_plugins_ipod_library_real_find_media (MusicLibrary* base,
                                                        MusicMedia* to_find);
static MusicMedia* music_plugins_ipod_library_real_media_from_file (MusicLibrary* base,
                                                             GFile* file);
static MusicMedia* music_plugins_ipod_library_real_media_from_uri (MusicLibrary* base,
                                                            const gchar* uri);
static void music_plugins_ipod_library_real_update_media (MusicLibrary* base,
                                                   MusicMedia* s,
                                                   gboolean update_meta,
                                                   gboolean record_time);
static void music_plugins_ipod_library_real_update_medias (MusicLibrary* base,
                                                    GeeCollection* updates,
                                                    gboolean update_meta,
                                                    gboolean record_time);
static void music_plugins_ipod_library_real_remove_media (MusicLibrary* base,
                                                   MusicMedia* s,
                                                   gboolean trash);
static void music_plugins_ipod_library_real_remove_medias (MusicLibrary* base,
                                                    GeeCollection* to_remove,
                                                    gboolean trash);
static void music_plugins_ipod_library_remove_medias_async (MusicPluginsiPodLibrary* self,
                                                     GeeCollection* list,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static void music_plugins_ipod_library_remove_medias_finish (MusicPluginsiPodLibrary* self,
                                                      GAsyncResult* _res_);
static void music_plugins_ipod_library_remove_medias_async_data_free (gpointer _data);
static gboolean music_plugins_ipod_library_remove_medias_async_co (MusicPluginsIpodLibraryRemoveMediasAsyncData* _data_);
static gboolean __lambda9_ (MusicPluginsiPodLibrary* self);
static gboolean ___lambda9__gsource_func (gpointer self);
static void music_plugins_ipod_library_real_add_smart_playlist (MusicLibrary* base,
                                                         MusicSmartPlaylist* p);
static gboolean music_plugins_ipod_library_real_support_smart_playlists (MusicLibrary* base);
static void music_plugins_ipod_library_real_remove_smart_playlist (MusicLibrary* base,
                                                            gint64 id);
static MusicSmartPlaylist* music_plugins_ipod_library_real_smart_playlist_from_id (MusicLibrary* base,
                                                                            gint64 id);
static MusicSmartPlaylist* music_plugins_ipod_library_real_smart_playlist_from_name (MusicLibrary* base,
                                                                              const gchar* name);
static gboolean music_plugins_ipod_library_real_support_playlists (MusicLibrary* base);
static void music_plugins_ipod_library_real_add_playlist (MusicLibrary* base,
                                                   MusicStaticPlaylist* p);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda10_ (Block2Data* _data2_,
                  GeeCollection* list);
static void ___lambda10__music_playlist_media_added (MusicPlaylist* _sender,
                                              GeeCollection* media,
                                              gpointer self);
static void __lambda11_ (Block2Data* _data2_,
                  GeeCollection* list);
static void ___lambda11__music_playlist_media_removed (MusicPlaylist* _sender,
                                                GeeCollection* media,
                                                gpointer self);
static void music_plugins_ipod_library_real_remove_playlist (MusicLibrary* base,
                                                      gint64 id);
static MusicStaticPlaylist* music_plugins_ipod_library_real_playlist_from_id (MusicLibrary* base,
                                                                       gint64 id);
static MusicStaticPlaylist* music_plugins_ipod_library_real_playlist_from_name (MusicLibrary* base,
                                                                         const gchar* name);
static gboolean music_plugins_ipod_library_real_start_file_operations (MusicLibrary* base,
                                                                const gchar* message);
static gboolean music_plugins_ipod_library_real_doing_file_operations (MusicLibrary* base);
static void music_plugins_ipod_library_real_finish_file_operations (MusicLibrary* base);
static void music_plugins_ipod_library_cleanup_files (MusicPluginsiPodLibrary* self,
                                               GFile* music_folder,
                                               GeeLinkedList* used_uris);
static void music_plugins_ipod_library_finalize (GObject * obj);

static inline gpointer
music_plugins_ipod_library_get_instance_private (MusicPluginsiPodLibrary* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPluginsiPodLibrary_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../plugins/Devices/iPod/iPodLibrary.vala"
	return self ? g_object_ref (self) : NULL;
#line 412 "iPodLibrary.c"
}

static void
__lambda4_ (MusicPluginsiPodLibrary* self)
{
#line 48 "../plugins/Devices/iPod/iPodLibrary.vala"
	self->priv->operation_cancelled = TRUE;
#line 420 "iPodLibrary.c"
}

static void
___lambda4__music_notification_manager_progress_canceled (MusicNotificationManager* _sender,
                                                          gpointer self)
{
#line 47 "../plugins/Devices/iPod/iPodLibrary.vala"
	__lambda4_ ((MusicPluginsiPodLibrary*) self);
#line 429 "iPodLibrary.c"
}

MusicPluginsiPodLibrary*
music_plugins_ipod_library_construct (GType object_type,
                                      Itdb_iTunesDB* db,
                                      MusicDevice* device)
{
	MusicPluginsiPodLibrary * self = NULL;
	MusicDevice* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeLinkedList* _tmp4_;
	MusicNotificationManager* _tmp5_;
	MusicNotificationManager* _tmp6_;
#line 39 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_val_if_fail (db != NULL, NULL);
#line 39 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 39 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) music_library_construct (object_type);
#line 40 "../plugins/Devices/iPod/iPodLibrary.vala"
	self->priv->db = db;
#line 41 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = _g_object_ref0 (device);
#line 41 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (self->priv->device);
#line 41 "../plugins/Devices/iPod/iPodLibrary.vala"
	self->priv->device = _tmp0_;
#line 42 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_POINTER, NULL, NULL, MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 42 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (self->priv->medias);
#line 42 "../plugins/Devices/iPod/iPodLibrary.vala"
	self->priv->medias = _tmp1_;
#line 43 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_POINTER, NULL, NULL, MUSIC_TYPE_STATIC_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 43 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (self->priv->playlists);
#line 43 "../plugins/Devices/iPod/iPodLibrary.vala"
	self->priv->playlists = _tmp2_;
#line 44 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp3_ = gee_hash_map_new (G_TYPE_POINTER, NULL, NULL, MUSIC_TYPE_SMART_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 44 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (self->priv->smart_playlists);
#line 44 "../plugins/Devices/iPod/iPodLibrary.vala"
	self->priv->smart_playlists = _tmp3_;
#line 45 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp4_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 45 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (self->priv->searched_medias);
#line 45 "../plugins/Devices/iPod/iPodLibrary.vala"
	self->priv->searched_medias = _tmp4_;
#line 47 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp5_ = music_notification_manager_get_default ();
#line 47 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp6_ = _tmp5_;
#line 47 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_signal_connect_object (_tmp6_, "progress-canceled", (GCallback) ___lambda4__music_notification_manager_progress_canceled, self, 0);
#line 47 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (_tmp6_);
#line 39 "../plugins/Devices/iPod/iPodLibrary.vala"
	return self;
#line 493 "iPodLibrary.c"
}

MusicPluginsiPodLibrary*
music_plugins_ipod_library_new (Itdb_iTunesDB* db,
                                MusicDevice* device)
{
#line 39 "../plugins/Devices/iPod/iPodLibrary.vala"
	return music_plugins_ipod_library_construct (MUSIC_PLUGINS_TYPE_IPOD_LIBRARY, db, device);
#line 502 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_real_initialize_library (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
#line 52 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 511 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_finish_initialization_async_data_free (gpointer _data)
{
	MusicPluginsIpodLibraryFinishInitializationAsyncData* _data_;
	_data_ = _data;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_slice_free (MusicPluginsIpodLibraryFinishInitializationAsyncData, _data_);
#line 523 "iPodLibrary.c"
}

void
music_plugins_ipod_library_finish_initialization_async (MusicPluginsiPodLibrary* self,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_)
{
	MusicPluginsIpodLibraryFinishInitializationAsyncData* _data_;
	MusicPluginsiPodLibrary* _tmp0_;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (self != NULL);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_ = g_slice_new0 (MusicPluginsIpodLibraryFinishInitializationAsyncData);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_plugins_ipod_library_finish_initialization_async_data_free);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->self = _tmp0_;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	music_plugins_ipod_library_finish_initialization_async_co (_data_);
#line 547 "iPodLibrary.c"
}

void
music_plugins_ipod_library_finish_initialization_finish (MusicPluginsiPodLibrary* self,
                                                         GAsyncResult* _res_)
{
	MusicPluginsIpodLibraryFinishInitializationAsyncData* _data_;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 557 "iPodLibrary.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 67 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 67 "../plugins/Devices/iPod/iPodLibrary.vala"
	return _data1_;
#line 567 "iPodLibrary.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 67 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 577 "iPodLibrary.c"
		MusicPluginsiPodLibrary* self;
#line 67 "../plugins/Devices/iPod/iPodLibrary.vala"
		self = _data1_->self;
#line 67 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_data1_->playlist);
#line 67 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (self);
#line 67 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_slice_free (Block1Data, _data1_);
#line 587 "iPodLibrary.c"
	}
}

static void
_____lambda5_ (Block1Data* _data1_,
               GeeCollection* list)
{
	MusicPluginsiPodLibrary* self;
	MusicPlaylist* _tmp0_;
#line 74 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = _data1_->self;
#line 74 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (list != NULL);
#line 75 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = _data1_->playlist;
#line 75 "../plugins/Devices/iPod/iPodLibrary.vala"
	music_plugins_ipod_library_keep_playlist_synchronized (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist), list, TRUE);
#line 605 "iPodLibrary.c"
}

static void
______lambda5__music_playlist_media_added (MusicPlaylist* _sender,
                                           GeeCollection* media,
                                           gpointer self)
{
#line 74 "../plugins/Devices/iPod/iPodLibrary.vala"
	_____lambda5_ (self, media);
#line 615 "iPodLibrary.c"
}

static void
_____lambda6_ (Block1Data* _data1_,
               GeeCollection* list)
{
	MusicPluginsiPodLibrary* self;
	MusicPlaylist* _tmp0_;
#line 78 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = _data1_->self;
#line 78 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (list != NULL);
#line 79 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = _data1_->playlist;
#line 79 "../plugins/Devices/iPod/iPodLibrary.vala"
	music_plugins_ipod_library_keep_playlist_synchronized (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist), list, FALSE);
#line 632 "iPodLibrary.c"
}

static void
______lambda6__music_playlist_media_removed (MusicPlaylist* _sender,
                                             GeeCollection* media,
                                             gpointer self)
{
#line 78 "../plugins/Devices/iPod/iPodLibrary.vala"
	_____lambda6_ (self, media);
#line 642 "iPodLibrary.c"
}

static gboolean
__lambda7_ (MusicPluginsiPodLibrary* self)
{
	MusicDevice* _tmp0_;
	MusicDevice* _tmp1_;
	gboolean result;
#line 88 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = self->priv->device;
#line 88 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp1_ = self->priv->device;
#line 88 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_signal_emit_by_name (_tmp0_, "initialized", _tmp1_);
#line 89 "../plugins/Devices/iPod/iPodLibrary.vala"
	music_library_search_medias ((MusicLibrary*) self, "");
#line 91 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = FALSE;
#line 91 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 663 "iPodLibrary.c"
}

static gboolean
___lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda7_ ((MusicPluginsiPodLibrary*) self);
#line 87 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 673 "iPodLibrary.c"
}

static gboolean
music_plugins_ipod_library_finish_initialization_async_co (MusicPluginsIpodLibraryFinishInitializationAsyncData* _data_)
{
#line 56 "../plugins/Devices/iPod/iPodLibrary.vala"
	switch (_data_->_state_) {
#line 56 "../plugins/Devices/iPod/iPodLibrary.vala"
		case 0:
#line 683 "iPodLibrary.c"
		goto _state_0;
		default:
#line 56 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_assert_not_reached ();
#line 688 "iPodLibrary.c"
	}
	_state_0:
	{
#line 58 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->i = 0;
#line 694 "iPodLibrary.c"
		{
#line 58 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp0_ = TRUE;
#line 58 "../plugins/Devices/iPod/iPodLibrary.vala"
			while (TRUE) {
#line 58 "../plugins/Devices/iPod/iPodLibrary.vala"
				if (!_data_->_tmp0_) {
#line 58 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->i = _data_->i + 1;
#line 58 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp1_ = _data_->i;
#line 706 "iPodLibrary.c"
				}
#line 58 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp0_ = FALSE;
#line 58 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp2_ = _data_->self->priv->db;
#line 58 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp3_ = _data_->_tmp2_->tracks;
#line 58 "../plugins/Devices/iPod/iPodLibrary.vala"
				if (!(((guint) _data_->i) < g_list_length (_data_->_tmp3_))) {
#line 58 "../plugins/Devices/iPod/iPodLibrary.vala"
					break;
#line 718 "iPodLibrary.c"
				}
#line 59 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp4_ = _data_->self->priv->db;
#line 59 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp5_ = _data_->_tmp4_->tracks;
#line 59 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp6_ = g_list_nth_data (_data_->_tmp5_, (guint) _data_->i);
#line 59 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->t = (Itdb_Track*) _data_->_tmp6_;
#line 60 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp7_ = _data_->self->priv->device;
#line 60 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp8_ = music_device_get_uri (_data_->_tmp7_);
#line 60 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp9_ = _data_->_tmp8_;
#line 60 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp10_ = _data_->t;
#line 60 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp11_ = music_plugins_ipod_media_helper_media_from_track (_data_->_tmp9_, _data_->_tmp10_);
#line 60 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp12_ = _data_->_tmp11_;
#line 60 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_free0 (_data_->_tmp9_);
#line 60 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->m = _data_->_tmp12_;
#line 62 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp14_ = _data_->m;
#line 62 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp15_ = music_media_get_file_exists (_data_->_tmp14_);
#line 62 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp16_ = _data_->_tmp15_;
#line 62 "../plugins/Devices/iPod/iPodLibrary.vala"
				if (_data_->_tmp16_) {
#line 62 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp17_ = _data_->self->priv->medias;
#line 62 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp18_ = _data_->t;
#line 62 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp19_ = _data_->m;
#line 62 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp13_ = !gee_abstract_map_has ((GeeAbstractMap*) _data_->_tmp17_, _data_->_tmp18_, _data_->_tmp19_);
#line 760 "iPodLibrary.c"
				} else {
#line 62 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp13_ = FALSE;
#line 764 "iPodLibrary.c"
				}
#line 62 "../plugins/Devices/iPod/iPodLibrary.vala"
				if (_data_->_tmp13_) {
#line 63 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp20_ = _data_->self->priv->medias;
#line 63 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp21_ = _data_->t;
#line 63 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp22_ = _data_->m;
#line 63 "../plugins/Devices/iPod/iPodLibrary.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp20_, _data_->_tmp21_, _data_->_tmp22_);
#line 776 "iPodLibrary.c"
				}
#line 58 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (_data_->m);
#line 780 "iPodLibrary.c"
			}
		}
	}
#line 67 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->_tmp23_ = _data_->self->priv->db;
#line 67 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->_tmp24_ = _data_->_tmp23_->playlists;
#line 788 "iPodLibrary.c"
	{
#line 67 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->p_collection = _data_->_tmp24_;
#line 67 "../plugins/Devices/iPod/iPodLibrary.vala"
		for (_data_->p_it = _data_->p_collection; _data_->p_it != NULL; _data_->p_it = _data_->p_it->next) {
#line 67 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->p = (Itdb_Playlist*) _data_->p_it->data;
#line 796 "iPodLibrary.c"
			{
#line 67 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_data1_ = g_slice_new0 (Block1Data);
#line 67 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_data1_->_ref_count_ = 1;
#line 67 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_data1_->self = g_object_ref (_data_->self);
#line 68 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp25_ = _data_->p;
#line 68 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp26_ = _data_->self->priv->medias;
#line 68 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp27_ = music_plugins_ipod_playlist_helper_get_playlist_from_gpod_playlist (_data_->_tmp25_, _data_->_tmp26_);
#line 68 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_data1_->playlist = _data_->_tmp27_;
#line 70 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp28_ = _data_->_data1_->playlist;
#line 70 "../plugins/Devices/iPod/iPodLibrary.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp28_, MUSIC_TYPE_STATIC_PLAYLIST)) {
#line 71 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp29_ = _data_->_data1_->playlist;
#line 71 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp30_ = _data_->self->priv->playlists;
#line 71 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp31_ = gee_abstract_map_get_size ((GeeAbstractMap*) _data_->_tmp30_);
#line 71 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp32_ = _data_->_tmp31_;
#line 71 "../plugins/Devices/iPod/iPodLibrary.vala"
					music_playlist_set_rowid (_data_->_tmp29_, (gint64) _data_->_tmp32_);
#line 72 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp33_ = _data_->self->priv->playlists;
#line 72 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp34_ = _data_->p;
#line 72 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp35_ = _data_->_data1_->playlist;
#line 72 "../plugins/Devices/iPod/iPodLibrary.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp33_, _data_->_tmp34_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp35_, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist));
#line 74 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp36_ = _data_->_data1_->playlist;
#line 74 "../plugins/Devices/iPod/iPodLibrary.vala"
					g_signal_connect_data (_data_->_tmp36_, "media-added", (GCallback) ______lambda5__music_playlist_media_added, block1_data_ref (_data_->_data1_), (GClosureNotify) block1_data_unref, 0);
#line 78 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp37_ = _data_->_data1_->playlist;
#line 78 "../plugins/Devices/iPod/iPodLibrary.vala"
					g_signal_connect_data (_data_->_tmp37_, "media-removed", (GCallback) ______lambda6__music_playlist_media_removed, block1_data_ref (_data_->_data1_), (GClosureNotify) block1_data_unref, 0);
#line 842 "iPodLibrary.c"
				} else {
#line 81 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp38_ = _data_->_data1_->playlist;
#line 81 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp38_, MUSIC_TYPE_SMART_PLAYLIST)) {
#line 82 "../plugins/Devices/iPod/iPodLibrary.vala"
						_data_->_tmp39_ = _data_->_data1_->playlist;
#line 82 "../plugins/Devices/iPod/iPodLibrary.vala"
						_data_->_tmp40_ = _data_->self->priv->smart_playlists;
#line 82 "../plugins/Devices/iPod/iPodLibrary.vala"
						_data_->_tmp41_ = gee_abstract_map_get_size ((GeeAbstractMap*) _data_->_tmp40_);
#line 82 "../plugins/Devices/iPod/iPodLibrary.vala"
						_data_->_tmp42_ = _data_->_tmp41_;
#line 82 "../plugins/Devices/iPod/iPodLibrary.vala"
						music_playlist_set_rowid (_data_->_tmp39_, (gint64) _data_->_tmp42_);
#line 83 "../plugins/Devices/iPod/iPodLibrary.vala"
						_data_->_tmp43_ = _data_->self->priv->smart_playlists;
#line 83 "../plugins/Devices/iPod/iPodLibrary.vala"
						_data_->_tmp44_ = _data_->p;
#line 83 "../plugins/Devices/iPod/iPodLibrary.vala"
						_data_->_tmp45_ = _data_->_data1_->playlist;
#line 83 "../plugins/Devices/iPod/iPodLibrary.vala"
						gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp43_, _data_->_tmp44_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp45_, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist));
#line 866 "iPodLibrary.c"
					}
				}
#line 67 "../plugins/Devices/iPod/iPodLibrary.vala"
				block1_data_unref (_data_->_data1_);
#line 67 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_data1_ = NULL;
#line 873 "iPodLibrary.c"
			}
		}
	}
#line 87 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda7__gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 56 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 56 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (_data_->_state_ != 0) {
#line 56 "../plugins/Devices/iPod/iPodLibrary.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 56 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 887 "iPodLibrary.c"
		}
	}
#line 56 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_object_unref (_data_->_async_result);
#line 56 "../plugins/Devices/iPod/iPodLibrary.vala"
	return FALSE;
#line 894 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_real_add_files_to_library (MusicLibrary* base,
                                                      GeeCollection* files)
{
	MusicPluginsiPodLibrary * self;
#line 95 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 95 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (files != NULL);
#line 906 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_real_search_medias (MusicLibrary* base,
                                               const gchar* search)
{
	MusicPluginsiPodLibrary * self;
	GError* _inner_error0_ = NULL;
#line 99 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 99 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (search != NULL);
#line 919 "iPodLibrary.c"
	{
		GeeLinkedList* _tmp0_;
#line 100 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp0_ = self->priv->searched_medias;
#line 100 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_searched_medias);
#line 926 "iPodLibrary.c"
		{
			GeeLinkedList* _tmp1_;
			gboolean _tmp2_ = FALSE;
			guint parsed_rating = 0U;
			gchar* parsed_search_string = NULL;
			guint _tmp9_ = 0U;
			gchar* _tmp10_ = NULL;
			gboolean rating_search = FALSE;
#line 101 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp1_ = self->priv->searched_medias;
#line 101 "../plugins/Devices/iPod/iPodLibrary.vala"
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
#line 103 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (g_strcmp0 (search, "") == 0) {
#line 103 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp2_ = TRUE;
#line 943 "iPodLibrary.c"
			} else {
#line 103 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp2_ = search == NULL;
#line 947 "iPodLibrary.c"
			}
#line 103 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (_tmp2_) {
#line 951 "iPodLibrary.c"
				GeeLinkedList* _tmp3_;
				GeeHashMap* _tmp4_;
				GeeCollection* _tmp5_;
				GeeCollection* _tmp6_;
				GeeCollection* _tmp7_;
#line 104 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp3_ = self->priv->searched_medias;
#line 104 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp4_ = self->priv->medias;
#line 104 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp5_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp4_);
#line 104 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp6_ = _tmp5_;
#line 104 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp7_ = _tmp6_;
#line 104 "../plugins/Devices/iPod/iPodLibrary.vala"
				gee_collection_add_all ((GeeCollection*) _tmp3_, _tmp7_);
#line 104 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (_tmp7_);
#line 105 "../plugins/Devices/iPod/iPodLibrary.vala"
				g_signal_emit_by_name ((MusicLibrary*) self, "search-finished");
#line 973 "iPodLibrary.c"
				{
					GeeLinkedList* _tmp8_;
#line 100 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp8_ = self->priv->searched_medias;
#line 100 "../plugins/Devices/iPod/iPodLibrary.vala"
					g_rec_mutex_unlock (&self->priv->__lock_searched_medias);
#line 980 "iPodLibrary.c"
				}
#line 106 "../plugins/Devices/iPod/iPodLibrary.vala"
				return;
#line 984 "iPodLibrary.c"
			}
#line 111 "../plugins/Devices/iPod/iPodLibrary.vala"
			music_string_base_search_method (search, &_tmp9_, &_tmp10_);
#line 111 "../plugins/Devices/iPod/iPodLibrary.vala"
			parsed_rating = _tmp9_;
#line 111 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_free0 (parsed_search_string);
#line 111 "../plugins/Devices/iPod/iPodLibrary.vala"
			parsed_search_string = _tmp10_;
#line 112 "../plugins/Devices/iPod/iPodLibrary.vala"
			rating_search = parsed_rating > ((guint) 0);
#line 996 "iPodLibrary.c"
			{
				GeeHashMap* _tmp11_;
#line 114 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp11_ = self->priv->medias;
#line 114 "../plugins/Devices/iPod/iPodLibrary.vala"
				g_rec_mutex_lock (&self->priv->__lock_medias);
#line 1003 "iPodLibrary.c"
				{
					{
						GeeIterator* _m_it = NULL;
						GeeHashMap* _tmp12_;
						GeeCollection* _tmp13_;
						GeeCollection* _tmp14_;
						GeeCollection* _tmp15_;
						GeeIterator* _tmp16_;
						GeeIterator* _tmp17_;
#line 115 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp12_ = self->priv->medias;
#line 115 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp13_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp12_);
#line 115 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp14_ = _tmp13_;
#line 115 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp15_ = _tmp14_;
#line 115 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
#line 115 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp17_ = _tmp16_;
#line 115 "../plugins/Devices/iPod/iPodLibrary.vala"
						_g_object_unref0 (_tmp15_);
#line 115 "../plugins/Devices/iPod/iPodLibrary.vala"
						_m_it = _tmp17_;
#line 115 "../plugins/Devices/iPod/iPodLibrary.vala"
						while (TRUE) {
#line 1031 "iPodLibrary.c"
							GeeIterator* _tmp18_;
							MusicMedia* m = NULL;
							GeeIterator* _tmp19_;
							gpointer _tmp20_;
#line 115 "../plugins/Devices/iPod/iPodLibrary.vala"
							_tmp18_ = _m_it;
#line 115 "../plugins/Devices/iPod/iPodLibrary.vala"
							if (!gee_iterator_next (_tmp18_)) {
#line 115 "../plugins/Devices/iPod/iPodLibrary.vala"
								break;
#line 1042 "iPodLibrary.c"
							}
#line 115 "../plugins/Devices/iPod/iPodLibrary.vala"
							_tmp19_ = _m_it;
#line 115 "../plugins/Devices/iPod/iPodLibrary.vala"
							_tmp20_ = gee_iterator_get (_tmp19_);
#line 115 "../plugins/Devices/iPod/iPodLibrary.vala"
							m = (MusicMedia*) _tmp20_;
#line 116 "../plugins/Devices/iPod/iPodLibrary.vala"
							if (rating_search) {
#line 1052 "iPodLibrary.c"
								MusicMedia* _tmp21_;
								guint _tmp22_;
								guint _tmp23_;
#line 117 "../plugins/Devices/iPod/iPodLibrary.vala"
								_tmp21_ = m;
#line 117 "../plugins/Devices/iPod/iPodLibrary.vala"
								_tmp22_ = music_media_get_rating (_tmp21_);
#line 117 "../plugins/Devices/iPod/iPodLibrary.vala"
								_tmp23_ = _tmp22_;
#line 117 "../plugins/Devices/iPod/iPodLibrary.vala"
								if (_tmp23_ == parsed_rating) {
#line 1064 "iPodLibrary.c"
									GeeLinkedList* _tmp24_;
									MusicMedia* _tmp25_;
#line 118 "../plugins/Devices/iPod/iPodLibrary.vala"
									_tmp24_ = self->priv->searched_medias;
#line 118 "../plugins/Devices/iPod/iPodLibrary.vala"
									_tmp25_ = m;
#line 118 "../plugins/Devices/iPod/iPodLibrary.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, _tmp25_);
#line 1073 "iPodLibrary.c"
								}
							} else {
								MusicMedia* _tmp26_;
								const gchar* _tmp27_;
#line 120 "../plugins/Devices/iPod/iPodLibrary.vala"
								_tmp26_ = m;
#line 120 "../plugins/Devices/iPod/iPodLibrary.vala"
								_tmp27_ = parsed_search_string;
#line 120 "../plugins/Devices/iPod/iPodLibrary.vala"
								if (music_search_match_string_to_media (_tmp26_, _tmp27_)) {
#line 1084 "iPodLibrary.c"
									GeeLinkedList* _tmp28_;
									MusicMedia* _tmp29_;
#line 121 "../plugins/Devices/iPod/iPodLibrary.vala"
									_tmp28_ = self->priv->searched_medias;
#line 121 "../plugins/Devices/iPod/iPodLibrary.vala"
									_tmp29_ = m;
#line 121 "../plugins/Devices/iPod/iPodLibrary.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp29_);
#line 1093 "iPodLibrary.c"
								}
							}
#line 115 "../plugins/Devices/iPod/iPodLibrary.vala"
							_g_object_unref0 (m);
#line 1098 "iPodLibrary.c"
						}
#line 115 "../plugins/Devices/iPod/iPodLibrary.vala"
						_g_object_unref0 (_m_it);
#line 1102 "iPodLibrary.c"
					}
				}
				__finally1:
				{
					GeeHashMap* _tmp30_;
#line 114 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp30_ = self->priv->medias;
#line 114 "../plugins/Devices/iPod/iPodLibrary.vala"
					g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 1112 "iPodLibrary.c"
				}
#line 114 "../plugins/Devices/iPod/iPodLibrary.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 114 "../plugins/Devices/iPod/iPodLibrary.vala"
					_g_free0 (parsed_search_string);
#line 114 "../plugins/Devices/iPod/iPodLibrary.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 114 "../plugins/Devices/iPod/iPodLibrary.vala"
					g_clear_error (&_inner_error0_);
#line 114 "../plugins/Devices/iPod/iPodLibrary.vala"
					return;
#line 1124 "iPodLibrary.c"
				}
			}
#line 100 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_free0 (parsed_search_string);
#line 1129 "iPodLibrary.c"
		}
		__finally0:
		{
			GeeLinkedList* _tmp31_;
#line 100 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp31_ = self->priv->searched_medias;
#line 100 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_searched_medias);
#line 1138 "iPodLibrary.c"
		}
#line 100 "../plugins/Devices/iPod/iPodLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 100 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 100 "../plugins/Devices/iPod/iPodLibrary.vala"
			return;
#line 1148 "iPodLibrary.c"
		}
	}
#line 127 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_signal_emit_by_name ((MusicLibrary*) self, "search-finished");
#line 1153 "iPodLibrary.c"
}

static GeeCollection*
music_plugins_ipod_library_real_get_search_result (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
	GeeLinkedList* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result;
#line 130 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 131 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = self->priv->searched_medias;
#line 131 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp1_ = _g_object_ref0 ((GeeCollection*) _tmp0_);
#line 131 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = _tmp1_;
#line 131 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 1173 "iPodLibrary.c"
}

static GeeCollection*
music_plugins_ipod_library_real_get_medias (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* result;
#line 134 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 135 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = self->priv->medias;
#line 135 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
#line 135 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp2_ = _tmp1_;
#line 135 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = _tmp2_;
#line 135 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 1196 "iPodLibrary.c"
}

static GeeCollection*
music_plugins_ipod_library_real_get_playlists (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* result;
#line 138 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 139 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = self->priv->playlists;
#line 139 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
#line 139 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp2_ = _tmp1_;
#line 139 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = _tmp2_;
#line 139 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 1219 "iPodLibrary.c"
}

static GeeCollection*
music_plugins_ipod_library_real_get_smart_playlists (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* result;
#line 142 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 143 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = self->priv->smart_playlists;
#line 143 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
#line 143 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp2_ = _tmp1_;
#line 143 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = _tmp2_;
#line 143 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 1242 "iPodLibrary.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1264 "iPodLibrary.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1268 "iPodLibrary.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1274 "iPodLibrary.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1278 "iPodLibrary.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1282 "iPodLibrary.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 1290 "iPodLibrary.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1318 "iPodLibrary.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 1327 "iPodLibrary.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1341 "iPodLibrary.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 1350 "iPodLibrary.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 1364 "iPodLibrary.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1373 "iPodLibrary.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 1382 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_real_add_media (MusicLibrary* base,
                                           MusicMedia* s)
{
	MusicPluginsiPodLibrary * self;
	Itdb_Track* t = NULL;
	Itdb_Track* _tmp0_;
	GIcon* icon = NULL;
	MusicAlbum* _tmp1_;
	MusicAlbum* _tmp2_;
	GIcon* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp5_;
	GIcon* _tmp6_;
	gchar* current_operation = NULL;
	gchar* _tmp16_;
	const gchar* _tmp17_ = NULL;
	Itdb_Track* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_ = NULL;
	Itdb_Track* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_ = NULL;
	MusicDevice* _tmp28_;
	gchar* _tmp29_;
	MusicLibrariesManager* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	Itdb_Track* _tmp34_;
	const gchar* _tmp35_;
	Itdb_Track* _tmp36_;
	const gchar* _tmp37_;
	Itdb_iTunesDB* _tmp38_;
	Itdb_Track* _tmp39_;
	Itdb_Track* added = NULL;
	Itdb_iTunesDB* _tmp40_;
	GList* _tmp41_;
	Itdb_iTunesDB* _tmp42_;
	GList* _tmp43_;
	gconstpointer _tmp44_;
	gboolean _tmp45_ = FALSE;
	Itdb_Track* _tmp46_;
	Itdb_Playlist* mpl = NULL;
	Itdb_iTunesDB* _tmp51_;
	Itdb_Playlist* _tmp52_;
	Itdb_Playlist* _tmp53_;
	Itdb_Track* _tmp54_;
	gboolean success = FALSE;
	GError* _inner_error0_ = NULL;
#line 146 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 146 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (s != NULL);
#line 147 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (s == NULL) {
#line 148 "../plugins/Devices/iPod/iPodLibrary.vala"
		return;
#line 1446 "iPodLibrary.c"
	}
#line 150 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = music_plugins_ipod_media_helper_track_from_media (s);
#line 150 "../plugins/Devices/iPod/iPodLibrary.vala"
	t = _tmp0_;
#line 151 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp1_ = music_media_get_album_info (s);
#line 151 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp2_ = _tmp1_;
#line 151 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp3_ = music_album_get_cover_icon (_tmp2_);
#line 151 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp4_ = _tmp3_;
#line 151 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 151 "../plugins/Devices/iPod/iPodLibrary.vala"
	icon = _tmp5_;
#line 152 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp6_ = icon;
#line 152 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (_tmp6_ != NULL) {
#line 1468 "iPodLibrary.c"
		GtkIconInfo* icon_info = NULL;
		GtkIconTheme* _tmp7_;
		GIcon* _tmp8_;
		GtkIconInfo* _tmp9_;
#line 153 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp7_ = gtk_icon_theme_get_default ();
#line 153 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp8_ = icon;
#line 153 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp9_ = gtk_icon_theme_lookup_by_gicon (_tmp7_, _tmp8_, 128, GTK_ICON_LOOKUP_GENERIC_FALLBACK);
#line 153 "../plugins/Devices/iPod/iPodLibrary.vala"
		icon_info = _tmp9_;
#line 1481 "iPodLibrary.c"
		{
			GdkPixbuf* pixbuf = NULL;
			GtkIconInfo* _tmp10_;
			GdkPixbuf* _tmp11_;
			Itdb_Track* _tmp12_;
			GdkPixbuf* _tmp13_;
#line 160 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp10_ = icon_info;
#line 160 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp11_ = gtk_icon_info_load_icon (_tmp10_, &_inner_error0_);
#line 160 "../plugins/Devices/iPod/iPodLibrary.vala"
			pixbuf = _tmp11_;
#line 160 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1496 "iPodLibrary.c"
				goto __catch0_g_error;
			}
#line 161 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp12_ = t;
#line 161 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp13_ = pixbuf;
#line 161 "../plugins/Devices/iPod/iPodLibrary.vala"
			itdb_track_set_thumbnails_from_pixbuf (_tmp12_, _tmp13_);
#line 159 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_object_unref0 (pixbuf);
#line 1507 "iPodLibrary.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp14_;
			const gchar* _tmp15_;
#line 159 "../plugins/Devices/iPod/iPodLibrary.vala"
			e = _inner_error0_;
#line 159 "../plugins/Devices/iPod/iPodLibrary.vala"
			_inner_error0_ = NULL;
#line 163 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp14_ = e;
#line 163 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp15_ = _tmp14_->message;
#line 163 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_critical ("iPodLibrary.vala:163: %s", _tmp15_);
#line 159 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_error_free0 (e);
#line 1527 "iPodLibrary.c"
		}
		__finally0:
#line 159 "../plugins/Devices/iPod/iPodLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 159 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_object_unref0 (icon_info);
#line 159 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_object_unref0 (icon);
#line 159 "../plugins/Devices/iPod/iPodLibrary.vala"
			_itdb_track_free0 (t);
#line 159 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 159 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 159 "../plugins/Devices/iPod/iPodLibrary.vala"
			return;
#line 1544 "iPodLibrary.c"
		}
#line 152 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (icon_info);
#line 1548 "iPodLibrary.c"
	}
#line 167 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp16_ = g_strdup (_ ("Adding <b>$NAME</b> by <b>$ARTIST</b> to $DEVICE"));
#line 167 "../plugins/Devices/iPod/iPodLibrary.vala"
	current_operation = _tmp16_;
#line 168 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp18_ = t;
#line 168 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp19_ = _tmp18_->title;
#line 168 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp17_ = _tmp19_;
#line 168 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (_tmp17_ == NULL) {
#line 168 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp17_ = "";
#line 1564 "iPodLibrary.c"
	}
#line 168 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp20_ = current_operation;
#line 168 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp21_ = string_replace (_tmp20_, "$NAME", _tmp17_);
#line 168 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_free0 (current_operation);
#line 168 "../plugins/Devices/iPod/iPodLibrary.vala"
	current_operation = _tmp21_;
#line 169 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp23_ = t;
#line 169 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp24_ = _tmp23_->artist;
#line 169 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp22_ = _tmp24_;
#line 169 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (_tmp22_ == NULL) {
#line 169 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp22_ = "";
#line 1584 "iPodLibrary.c"
	}
#line 169 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp25_ = current_operation;
#line 169 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp26_ = string_replace (_tmp25_, "$ARTIST", _tmp22_);
#line 169 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_free0 (current_operation);
#line 169 "../plugins/Devices/iPod/iPodLibrary.vala"
	current_operation = _tmp26_;
#line 170 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp28_ = self->priv->device;
#line 170 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp29_ = music_device_get_display_name (_tmp28_);
#line 170 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp27_ = _tmp29_;
#line 170 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (_tmp27_ == NULL) {
#line 1602 "iPodLibrary.c"
		gchar* _tmp30_;
#line 170 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp30_ = g_strdup ("");
#line 170 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_free0 (_tmp27_);
#line 170 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp27_ = _tmp30_;
#line 1610 "iPodLibrary.c"
	}
#line 170 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp31_ = music_libraries_manager;
#line 170 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp32_ = current_operation;
#line 170 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp33_ = string_replace (_tmp32_, "$DEVICE", _tmp27_);
#line 170 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_free0 (_tmp31_->current_operation);
#line 170 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp31_->current_operation = _tmp33_;
#line 171 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp34_ = t;
#line 171 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp35_ = _tmp34_->title;
#line 171 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp36_ = t;
#line 171 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp37_ = _tmp36_->artist;
#line 171 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_debug ("iPodLibrary.vala:171: Adding media %s by %s\n", _tmp35_, _tmp37_);
#line 172 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp38_ = self->priv->db;
#line 172 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp39_ = t;
#line 172 "../plugins/Devices/iPod/iPodLibrary.vala"
	t = NULL;
#line 172 "../plugins/Devices/iPod/iPodLibrary.vala"
	itdb_track_add (_tmp38_, _tmp39_, (gint32) -1);
#line 173 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp40_ = self->priv->db;
#line 173 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp41_ = _tmp40_->tracks;
#line 173 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp42_ = self->priv->db;
#line 173 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp43_ = _tmp42_->tracks;
#line 173 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp44_ = g_list_nth_data (_tmp41_, g_list_length (_tmp43_) - 1);
#line 173 "../plugins/Devices/iPod/iPodLibrary.vala"
	added = (Itdb_Track*) _tmp44_;
#line 175 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp46_ = added;
#line 175 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (_tmp46_ == NULL) {
#line 175 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp45_ = TRUE;
#line 1658 "iPodLibrary.c"
	} else {
		Itdb_Track* _tmp47_;
		const gchar* _tmp48_;
		const gchar* _tmp49_;
		const gchar* _tmp50_;
#line 175 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp47_ = added;
#line 175 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp48_ = _tmp47_->title;
#line 175 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp49_ = music_media_get_title (s);
#line 175 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp50_ = _tmp49_;
#line 175 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp45_ = g_strcmp0 (_tmp48_, _tmp50_) != 0;
#line 1674 "iPodLibrary.c"
	}
#line 175 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (_tmp45_) {
#line 176 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_warning ("iPodLibrary.vala:176: Track was not properly appended. Returning.\n");
#line 177 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_free0 (_tmp27_);
#line 177 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_free0 (current_operation);
#line 177 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (icon);
#line 177 "../plugins/Devices/iPod/iPodLibrary.vala"
		_itdb_track_free0 (t);
#line 177 "../plugins/Devices/iPod/iPodLibrary.vala"
		return;
#line 1690 "iPodLibrary.c"
	}
#line 180 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp51_ = self->priv->db;
#line 180 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp52_ = itdb_playlist_mpl (_tmp51_);
#line 180 "../plugins/Devices/iPod/iPodLibrary.vala"
	mpl = _tmp52_;
#line 181 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp53_ = mpl;
#line 181 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp54_ = added;
#line 181 "../plugins/Devices/iPod/iPodLibrary.vala"
	itdb_playlist_add_track (_tmp53_, _tmp54_, (gint32) -1);
#line 183 "../plugins/Devices/iPod/iPodLibrary.vala"
	success = FALSE;
#line 1706 "iPodLibrary.c"
	{
		gboolean _tmp55_ = FALSE;
		Itdb_Track* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
		gchar* _tmp59_;
		GFile* _tmp60_;
		GFile* _tmp61_;
		gchar* _tmp62_;
		gchar* _tmp63_;
		gboolean _tmp64_;
		Itdb_Track* _tmp65_;
		const gchar* _tmp66_;
#line 185 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp56_ = added;
#line 185 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp57_ = music_media_get_uri (s);
#line 185 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp58_ = _tmp57_;
#line 185 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp59_ = _tmp58_;
#line 185 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp60_ = g_file_new_for_uri (_tmp59_);
#line 185 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp61_ = _tmp60_;
#line 185 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp62_ = g_file_get_path (_tmp61_);
#line 185 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp63_ = _tmp62_;
#line 185 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp64_ = itdb_cp_track_to_ipod (_tmp56_, _tmp63_, &_inner_error0_);
#line 185 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_free0 (_tmp63_);
#line 185 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_tmp61_);
#line 185 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_free0 (_tmp59_);
#line 185 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp55_ = _tmp64_;
#line 185 "../plugins/Devices/iPod/iPodLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1748 "iPodLibrary.c"
			goto __catch1_g_error;
		}
#line 185 "../plugins/Devices/iPod/iPodLibrary.vala"
		success = _tmp55_;
#line 186 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp65_ = added;
#line 186 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp66_ = _tmp65_->title;
#line 186 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_debug ("iPodLibrary.vala:186: Copied media %s to ipod\n", _tmp66_);
#line 1759 "iPodLibrary.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp67_;
		const gchar* _tmp68_;
		GError* _tmp69_;
		const gchar* _tmp70_;
#line 184 "../plugins/Devices/iPod/iPodLibrary.vala"
		err = _inner_error0_;
#line 184 "../plugins/Devices/iPod/iPodLibrary.vala"
		_inner_error0_ = NULL;
#line 188 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp67_ = music_media_get_title (s);
#line 188 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp68_ = _tmp67_;
#line 188 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp69_ = err;
#line 188 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp70_ = _tmp69_->message;
#line 188 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_warning ("iPodLibrary.vala:188: Error adding/copying song %s to iPod: %s\n", _tmp68_, _tmp70_);
#line 184 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_error_free0 (err);
#line 1785 "iPodLibrary.c"
	}
	__finally1:
#line 184 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 184 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_free0 (_tmp27_);
#line 184 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_free0 (current_operation);
#line 184 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (icon);
#line 184 "../plugins/Devices/iPod/iPodLibrary.vala"
		_itdb_track_free0 (t);
#line 184 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 184 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_clear_error (&_inner_error0_);
#line 184 "../plugins/Devices/iPod/iPodLibrary.vala"
		return;
#line 1804 "iPodLibrary.c"
	}
#line 191 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (success) {
#line 1808 "iPodLibrary.c"
		MusicMedia* on_ipod = NULL;
		MusicDevice* _tmp71_;
		gchar* _tmp72_;
		gchar* _tmp73_;
		Itdb_Track* _tmp74_;
		MusicMedia* _tmp75_;
		MusicMedia* _tmp76_;
		GeeHashMap* _tmp77_;
		Itdb_Track* _tmp78_;
		MusicMedia* _tmp79_;
#line 192 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp71_ = self->priv->device;
#line 192 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp72_ = music_device_get_uri (_tmp71_);
#line 192 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp73_ = _tmp72_;
#line 192 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp74_ = added;
#line 192 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp75_ = music_plugins_ipod_media_helper_media_from_track (_tmp73_, _tmp74_);
#line 192 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp76_ = _tmp75_;
#line 192 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_free0 (_tmp73_);
#line 192 "../plugins/Devices/iPod/iPodLibrary.vala"
		on_ipod = _tmp76_;
#line 193 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp77_ = self->priv->medias;
#line 193 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp78_ = added;
#line 193 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp79_ = on_ipod;
#line 193 "../plugins/Devices/iPod/iPodLibrary.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp77_, _tmp78_, _tmp79_);
#line 191 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (on_ipod);
#line 1845 "iPodLibrary.c"
	} else {
		Itdb_Track* _tmp80_;
		const gchar* _tmp81_;
		Itdb_Track* _tmp82_;
#line 195 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp80_ = added;
#line 195 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp81_ = _tmp80_->title;
#line 195 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_warning ("iPodLibrary.vala:195: Failed to copy track %s to iPod. Removing it fro" \
"m database.\n", _tmp81_);
#line 196 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp82_ = added;
#line 196 "../plugins/Devices/iPod/iPodLibrary.vala"
		music_plugins_ipod_library_remove_media_from_ipod (self, _tmp82_);
#line 1860 "iPodLibrary.c"
	}
#line 146 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_free0 (_tmp27_);
#line 146 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_free0 (current_operation);
#line 146 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (icon);
#line 146 "../plugins/Devices/iPod/iPodLibrary.vala"
	_itdb_track_free0 (t);
#line 1870 "iPodLibrary.c"
}

static gboolean
_music_libraries_manager_do_progress_notification_with_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = music_libraries_manager_do_progress_notification_with_timeout ((MusicLibrariesManager*) self);
#line 218 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 1880 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_real_add_medias (MusicLibrary* base,
                                            GeeCollection* list)
{
	MusicPluginsiPodLibrary * self;
	GeeLinkedList* new_list = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	GeeCollection* _tmp6_;
	gboolean fits = FALSE;
	MusicDevice* _tmp7_;
	GeeLinkedList* _tmp8_;
	MusicLibrariesManager* _tmp9_;
	MusicDevice* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	MusicLibrariesManager* _tmp14_;
#line 200 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 200 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (list != NULL);
#line 201 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (self->priv->is_doing_file_operations) {
#line 202 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_warning ("iPodLibrary.vala:202: Tried to add when already syncing\n");
#line 203 "../plugins/Devices/iPod/iPodLibrary.vala"
		return;
#line 1915 "iPodLibrary.c"
	}
#line 207 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 207 "../plugins/Devices/iPod/iPodLibrary.vala"
	new_list = _tmp0_;
#line 208 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp1_ = new_list;
#line 208 "../plugins/Devices/iPod/iPodLibrary.vala"
	gee_collection_add_all ((GeeCollection*) _tmp1_, list);
#line 209 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp2_ = new_list;
#line 209 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp3_ = self->priv->medias;
#line 209 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp4_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp3_);
#line 209 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp5_ = _tmp4_;
#line 209 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp6_ = _tmp5_;
#line 209 "../plugins/Devices/iPod/iPodLibrary.vala"
	gee_collection_add_all ((GeeCollection*) _tmp2_, _tmp6_);
#line 209 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (_tmp6_);
#line 210 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp7_ = self->priv->device;
#line 210 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp8_ = new_list;
#line 210 "../plugins/Devices/iPod/iPodLibrary.vala"
	fits = music_device_will_fit (_tmp7_, (GeeCollection*) _tmp8_);
#line 211 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (!fits) {
#line 212 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_warning ("iPodLibrary.vala:212: Tried to sync medias that will not fit\n");
#line 213 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (new_list);
#line 213 "../plugins/Devices/iPod/iPodLibrary.vala"
		return;
#line 1953 "iPodLibrary.c"
	}
#line 216 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp9_ = music_libraries_manager;
#line 216 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp10_ = self->priv->device;
#line 216 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp11_ = music_device_get_display_name (_tmp10_);
#line 216 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp12_ = _tmp11_;
#line 216 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp13_ = g_strdup_printf (_ ("Syncing <b>%s</b>…"), _tmp12_);
#line 216 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_free0 (_tmp9_->current_operation);
#line 216 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp9_->current_operation = _tmp13_;
#line 216 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_free0 (_tmp12_);
#line 217 "../plugins/Devices/iPod/iPodLibrary.vala"
	self->priv->is_doing_file_operations = TRUE;
#line 218 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp14_ = music_libraries_manager;
#line 218 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _music_libraries_manager_do_progress_notification_with_timeout_gsource_func, g_object_ref (_tmp14_), g_object_unref);
#line 219 "../plugins/Devices/iPod/iPodLibrary.vala"
	music_plugins_ipod_library_add_medias_async (self, list, NULL, NULL);
#line 200 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (new_list);
#line 1981 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_add_medias_async_data_free (gpointer _data)
{
	MusicPluginsIpodLibraryAddMediasAsyncData* _data_;
	_data_ = _data;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (_data_->to_add);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_slice_free (MusicPluginsIpodLibraryAddMediasAsyncData, _data_);
#line 1995 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_add_medias_async (MusicPluginsiPodLibrary* self,
                                             GeeCollection* to_add,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	MusicPluginsIpodLibraryAddMediasAsyncData* _data_;
	MusicPluginsiPodLibrary* _tmp0_;
	GeeCollection* _tmp1_;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (self != NULL);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (to_add != NULL);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_ = g_slice_new0 (MusicPluginsIpodLibraryAddMediasAsyncData);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_plugins_ipod_library_add_medias_async_data_free);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->self = _tmp0_;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp1_ = _g_object_ref0 (to_add);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (_data_->to_add);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->to_add = _tmp1_;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	music_plugins_ipod_library_add_medias_async_co (_data_);
#line 2029 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_add_medias_finish (MusicPluginsiPodLibrary* self,
                                              GAsyncResult* _res_)
{
	MusicPluginsIpodLibraryAddMediasAsyncData* _data_;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2039 "iPodLibrary.c"
}

static gboolean
__lambda8_ (MusicPluginsiPodLibrary* self)
{
	gboolean result;
#line 262 "../plugins/Devices/iPod/iPodLibrary.vala"
	self->priv->is_doing_file_operations = FALSE;
#line 263 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_signal_emit_by_name ((MusicLibrary*) self, "file-operations-done");
#line 264 "../plugins/Devices/iPod/iPodLibrary.vala"
	self->priv->operation_cancelled = FALSE;
#line 265 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = FALSE;
#line 265 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 2056 "iPodLibrary.c"
}

static gboolean
___lambda8__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda8_ ((MusicPluginsiPodLibrary*) self);
#line 261 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 2066 "iPodLibrary.c"
}

static gboolean
music_plugins_ipod_library_add_medias_async_co (MusicPluginsIpodLibraryAddMediasAsyncData* _data_)
{
#line 222 "../plugins/Devices/iPod/iPodLibrary.vala"
	switch (_data_->_state_) {
#line 222 "../plugins/Devices/iPod/iPodLibrary.vala"
		case 0:
#line 2076 "iPodLibrary.c"
		goto _state_0;
		default:
#line 222 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_assert_not_reached ();
#line 2081 "iPodLibrary.c"
	}
	_state_0:
#line 223 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->error_occurred = FALSE;
#line 224 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->_tmp0_ = _data_->self->priv->db;
#line 224 "../plugins/Devices/iPod/iPodLibrary.vala"
	itdb_start_sync (_data_->_tmp0_);
#line 225 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->_tmp1_ = gee_collection_get_size (_data_->to_add);
#line 225 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 225 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->total = _data_->_tmp2_;
#line 226 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->index = 0;
#line 2098 "iPodLibrary.c"
	{
#line 229 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp3_ = gee_iterable_iterator ((GeeIterable*) _data_->to_add);
#line 229 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_m_it = _data_->_tmp3_;
#line 229 "../plugins/Devices/iPod/iPodLibrary.vala"
		while (TRUE) {
#line 229 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp4_ = _data_->_m_it;
#line 229 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (!gee_iterator_next (_data_->_tmp4_)) {
#line 229 "../plugins/Devices/iPod/iPodLibrary.vala"
				break;
#line 2112 "iPodLibrary.c"
			}
#line 229 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp5_ = _data_->_m_it;
#line 229 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp6_ = gee_iterator_get (_data_->_tmp5_);
#line 229 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->m = (MusicMedia*) _data_->_tmp6_;
#line 230 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (!_data_->self->priv->operation_cancelled) {
#line 231 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp7_ = _data_->m;
#line 231 "../plugins/Devices/iPod/iPodLibrary.vala"
				music_library_add_media ((MusicLibrary*) _data_->self, _data_->_tmp7_);
#line 232 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->index = _data_->index + 1;
#line 232 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp8_ = _data_->index;
#line 233 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp9_ = music_libraries_manager;
#line 233 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp9_->progress = (gdouble) (_data_->index / _data_->total);
#line 2134 "iPodLibrary.c"
			}
#line 229 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_object_unref0 (_data_->m);
#line 2138 "iPodLibrary.c"
		}
#line 229 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_data_->_m_it);
#line 2142 "iPodLibrary.c"
	}
#line 237 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (!_data_->self->priv->operation_cancelled) {
#line 238 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp10_ = music_libraries_manager;
#line 238 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp11_ = g_strdup (_ ("Finishing sync process…"));
#line 238 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_free0 (_data_->_tmp10_->current_operation);
#line 238 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp10_->current_operation = _data_->_tmp11_;
#line 2154 "iPodLibrary.c"
		{
#line 240 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp12_ = _data_->self->priv->db;
#line 240 "../plugins/Devices/iPod/iPodLibrary.vala"
			itdb_write (_data_->_tmp12_, &_data_->_inner_error0_);
#line 240 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2162 "iPodLibrary.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 239 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->err = _data_->_inner_error0_;
#line 239 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_inner_error0_ = NULL;
#line 242 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp13_ = _data_->err;
#line 242 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp14_ = _data_->_tmp13_->message;
#line 242 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_critical ("iPodLibrary.vala:242: Error when writing iPod database. iPod contents " \
"may be incorrect: %s\n", _data_->_tmp14_);
#line 243 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->error_occurred = TRUE;
#line 244 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->self->priv->operation_cancelled = TRUE;
#line 239 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_error_free0 (_data_->err);
#line 2185 "iPodLibrary.c"
		}
		__finally0:
#line 239 "../plugins/Devices/iPod/iPodLibrary.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 239 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 239 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 239 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_object_unref (_data_->_async_result);
#line 239 "../plugins/Devices/iPod/iPodLibrary.vala"
			return FALSE;
#line 2198 "iPodLibrary.c"
		}
#line 247 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp15_ = music_libraries_manager;
#line 247 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp15_->progress = (gdouble) 1;
#line 248 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp16_ = _data_->self->priv->db;
#line 248 "../plugins/Devices/iPod/iPodLibrary.vala"
		itdb_stop_sync (_data_->_tmp16_);
#line 2208 "iPodLibrary.c"
	} else {
#line 250 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp17_ = music_libraries_manager;
#line 250 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp18_ = g_strdup (_ ("Cancelling Sync…"));
#line 250 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_free0 (_data_->_tmp17_->current_operation);
#line 250 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp17_->current_operation = _data_->_tmp18_;
#line 2218 "iPodLibrary.c"
		{
#line 252 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp19_ = _data_->self->priv->db;
#line 252 "../plugins/Devices/iPod/iPodLibrary.vala"
			itdb_write (_data_->_tmp19_, &_data_->_inner_error0_);
#line 252 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2226 "iPodLibrary.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 251 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_vala1_err = _data_->_inner_error0_;
#line 251 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_inner_error0_ = NULL;
#line 254 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp20_ = _data_->_vala1_err;
#line 254 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp21_ = _data_->_tmp20_->message;
#line 254 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_critical ("iPodLibrary.vala:254: Error when writing iPod database. iPod contents " \
"may be incorrect: %s\n", _data_->_tmp21_);
#line 251 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_error_free0 (_data_->_vala1_err);
#line 2245 "iPodLibrary.c"
		}
		__finally1:
#line 251 "../plugins/Devices/iPod/iPodLibrary.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 251 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 251 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 251 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_object_unref (_data_->_async_result);
#line 251 "../plugins/Devices/iPod/iPodLibrary.vala"
			return FALSE;
#line 2258 "iPodLibrary.c"
		}
#line 257 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp22_ = _data_->self->priv->db;
#line 257 "../plugins/Devices/iPod/iPodLibrary.vala"
		itdb_stop_sync (_data_->_tmp22_);
#line 258 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp23_ = music_libraries_manager;
#line 258 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp23_->progress = (gdouble) 1;
#line 2268 "iPodLibrary.c"
	}
#line 261 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda8__gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 222 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 222 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (_data_->_state_ != 0) {
#line 222 "../plugins/Devices/iPod/iPodLibrary.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 222 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2280 "iPodLibrary.c"
		}
	}
#line 222 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_object_unref (_data_->_async_result);
#line 222 "../plugins/Devices/iPod/iPodLibrary.vala"
	return FALSE;
#line 2287 "iPodLibrary.c"
}

static MusicMedia*
music_plugins_ipod_library_real_media_from_id (MusicLibrary* base,
                                               gint64 id)
{
	MusicPluginsiPodLibrary * self;
	MusicMedia* result;
#line 269 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 270 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = NULL;
#line 270 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 2302 "iPodLibrary.c"
}

static GeeCollection*
music_plugins_ipod_library_real_medias_from_ids (MusicLibrary* base,
                                                 GeeCollection* ids)
{
	MusicPluginsiPodLibrary * self;
	GeeLinkedList* media_collection = NULL;
	GeeLinkedList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeCollection* result;
#line 273 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 273 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_val_if_fail (ids != NULL, NULL);
#line 274 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 274 "../plugins/Devices/iPod/iPodLibrary.vala"
	media_collection = _tmp0_;
#line 2322 "iPodLibrary.c"
	{
		GeeHashMap* _tmp1_;
#line 275 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp1_ = self->priv->medias;
#line 275 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_medias);
#line 2329 "iPodLibrary.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
				GeeIterator* _tmp6_;
				GeeIterator* _tmp7_;
#line 276 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp2_ = self->priv->medias;
#line 276 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp3_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp2_);
#line 276 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp4_ = _tmp3_;
#line 276 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp5_ = _tmp4_;
#line 276 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 276 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp7_ = _tmp6_;
#line 276 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (_tmp5_);
#line 276 "../plugins/Devices/iPod/iPodLibrary.vala"
				_m_it = _tmp7_;
#line 276 "../plugins/Devices/iPod/iPodLibrary.vala"
				while (TRUE) {
#line 2357 "iPodLibrary.c"
					GeeIterator* _tmp8_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp9_;
					gpointer _tmp10_;
					MusicMedia* _tmp11_;
					gint64 _tmp12_;
					gint64 _tmp13_;
					GeeLinkedList* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					gint _tmp19_;
					gint _tmp20_;
#line 276 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp8_ = _m_it;
#line 276 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (!gee_iterator_next (_tmp8_)) {
#line 276 "../plugins/Devices/iPod/iPodLibrary.vala"
						break;
#line 2376 "iPodLibrary.c"
					}
#line 276 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp9_ = _m_it;
#line 276 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp10_ = gee_iterator_get (_tmp9_);
#line 276 "../plugins/Devices/iPod/iPodLibrary.vala"
					m = (MusicMedia*) _tmp10_;
#line 277 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp11_ = m;
#line 277 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp12_ = music_media_get_rowid (_tmp11_);
#line 277 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp13_ = _tmp12_;
#line 277 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (gee_collection_contains (ids, &_tmp13_)) {
#line 2392 "iPodLibrary.c"
						GeeLinkedList* _tmp14_;
						MusicMedia* _tmp15_;
#line 278 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp14_ = media_collection;
#line 278 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp15_ = m;
#line 278 "../plugins/Devices/iPod/iPodLibrary.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 2401 "iPodLibrary.c"
					}
#line 281 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp16_ = media_collection;
#line 281 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp17_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp16_);
#line 281 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp18_ = _tmp17_;
#line 281 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp19_ = gee_collection_get_size (ids);
#line 281 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp20_ = _tmp19_;
#line 281 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (_tmp18_ == _tmp20_) {
#line 282 "../plugins/Devices/iPod/iPodLibrary.vala"
						_g_object_unref0 (m);
#line 282 "../plugins/Devices/iPod/iPodLibrary.vala"
						break;
#line 2419 "iPodLibrary.c"
					}
#line 276 "../plugins/Devices/iPod/iPodLibrary.vala"
					_g_object_unref0 (m);
#line 2423 "iPodLibrary.c"
				}
#line 276 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (_m_it);
#line 2427 "iPodLibrary.c"
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp21_;
#line 275 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp21_ = self->priv->medias;
#line 275 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 2437 "iPodLibrary.c"
		}
#line 275 "../plugins/Devices/iPod/iPodLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 275 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_object_unref0 (media_collection);
#line 275 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 275 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 275 "../plugins/Devices/iPod/iPodLibrary.vala"
			return NULL;
#line 2449 "iPodLibrary.c"
		}
	}
#line 287 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = (GeeCollection*) media_collection;
#line 287 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 2456 "iPodLibrary.c"
}

static GeeCollection*
music_plugins_ipod_library_real_medias_from_uris (MusicLibrary* base,
                                                  GeeCollection* uris)
{
	MusicPluginsiPodLibrary * self;
	GeeLinkedList* media_collection = NULL;
	GeeLinkedList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeCollection* result;
#line 290 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 290 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_val_if_fail (uris != NULL, NULL);
#line 291 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 291 "../plugins/Devices/iPod/iPodLibrary.vala"
	media_collection = _tmp0_;
#line 2476 "iPodLibrary.c"
	{
		GeeHashMap* _tmp1_;
#line 292 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp1_ = self->priv->medias;
#line 292 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_medias);
#line 2483 "iPodLibrary.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
				GeeIterator* _tmp6_;
				GeeIterator* _tmp7_;
#line 293 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp2_ = self->priv->medias;
#line 293 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp3_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp2_);
#line 293 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp4_ = _tmp3_;
#line 293 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp5_ = _tmp4_;
#line 293 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 293 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp7_ = _tmp6_;
#line 293 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (_tmp5_);
#line 293 "../plugins/Devices/iPod/iPodLibrary.vala"
				_m_it = _tmp7_;
#line 293 "../plugins/Devices/iPod/iPodLibrary.vala"
				while (TRUE) {
#line 2511 "iPodLibrary.c"
					GeeIterator* _tmp8_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp9_;
					gpointer _tmp10_;
					MusicMedia* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gboolean _tmp15_;
					GeeLinkedList* _tmp18_;
					gint _tmp19_;
					gint _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
#line 293 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp8_ = _m_it;
#line 293 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (!gee_iterator_next (_tmp8_)) {
#line 293 "../plugins/Devices/iPod/iPodLibrary.vala"
						break;
#line 2532 "iPodLibrary.c"
					}
#line 293 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp9_ = _m_it;
#line 293 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp10_ = gee_iterator_get (_tmp9_);
#line 293 "../plugins/Devices/iPod/iPodLibrary.vala"
					m = (MusicMedia*) _tmp10_;
#line 294 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp11_ = m;
#line 294 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp12_ = music_media_get_uri (_tmp11_);
#line 294 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp13_ = _tmp12_;
#line 294 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp14_ = _tmp13_;
#line 294 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp15_ = gee_collection_contains (uris, _tmp14_);
#line 294 "../plugins/Devices/iPod/iPodLibrary.vala"
					_g_free0 (_tmp14_);
#line 294 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (_tmp15_) {
#line 2554 "iPodLibrary.c"
						GeeLinkedList* _tmp16_;
						MusicMedia* _tmp17_;
#line 295 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp16_ = media_collection;
#line 295 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp17_ = m;
#line 295 "../plugins/Devices/iPod/iPodLibrary.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 2563 "iPodLibrary.c"
					}
#line 298 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp18_ = media_collection;
#line 298 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 298 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp20_ = _tmp19_;
#line 298 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp21_ = gee_collection_get_size (uris);
#line 298 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp22_ = _tmp21_;
#line 298 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (_tmp20_ == _tmp22_) {
#line 299 "../plugins/Devices/iPod/iPodLibrary.vala"
						_g_object_unref0 (m);
#line 299 "../plugins/Devices/iPod/iPodLibrary.vala"
						break;
#line 2581 "iPodLibrary.c"
					}
#line 293 "../plugins/Devices/iPod/iPodLibrary.vala"
					_g_object_unref0 (m);
#line 2585 "iPodLibrary.c"
				}
#line 293 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (_m_it);
#line 2589 "iPodLibrary.c"
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp23_;
#line 292 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp23_ = self->priv->medias;
#line 292 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 2599 "iPodLibrary.c"
		}
#line 292 "../plugins/Devices/iPod/iPodLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 292 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_object_unref0 (media_collection);
#line 292 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 292 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 292 "../plugins/Devices/iPod/iPodLibrary.vala"
			return NULL;
#line 2611 "iPodLibrary.c"
		}
	}
#line 304 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = (GeeCollection*) media_collection;
#line 304 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 2618 "iPodLibrary.c"
}

static MusicMedia*
music_plugins_ipod_library_real_find_media (MusicLibrary* base,
                                            MusicMedia* to_find)
{
	MusicPluginsiPodLibrary * self;
	MusicMedia* found = NULL;
	GError* _inner_error0_ = NULL;
	MusicMedia* result;
#line 307 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 307 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_val_if_fail (to_find != NULL, NULL);
#line 308 "../plugins/Devices/iPod/iPodLibrary.vala"
	found = NULL;
#line 2635 "iPodLibrary.c"
	{
		GeeHashMap* _tmp0_;
#line 309 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp0_ = self->priv->medias;
#line 309 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_medias);
#line 2642 "iPodLibrary.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp1_;
				GeeCollection* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeIterator* _tmp5_;
				GeeIterator* _tmp6_;
#line 310 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp1_ = self->priv->medias;
#line 310 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 310 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp3_ = _tmp2_;
#line 310 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp4_ = _tmp3_;
#line 310 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 310 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp6_ = _tmp5_;
#line 310 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (_tmp4_);
#line 310 "../plugins/Devices/iPod/iPodLibrary.vala"
				_m_it = _tmp6_;
#line 310 "../plugins/Devices/iPod/iPodLibrary.vala"
				while (TRUE) {
#line 2670 "iPodLibrary.c"
					GeeIterator* _tmp7_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp8_;
					gpointer _tmp9_;
					gboolean _tmp10_ = FALSE;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					MusicMedia* _tmp15_;
					const gchar* _tmp16_;
					const gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					gboolean _tmp20_;
#line 310 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp7_ = _m_it;
#line 310 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (!gee_iterator_next (_tmp7_)) {
#line 310 "../plugins/Devices/iPod/iPodLibrary.vala"
						break;
#line 2692 "iPodLibrary.c"
					}
#line 310 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp8_ = _m_it;
#line 310 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp9_ = gee_iterator_get (_tmp8_);
#line 310 "../plugins/Devices/iPod/iPodLibrary.vala"
					m = (MusicMedia*) _tmp9_;
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp11_ = music_media_get_title (to_find);
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp12_ = _tmp11_;
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp13_ = g_utf8_strdown (_tmp12_, (gssize) -1);
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp14_ = _tmp13_;
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp15_ = m;
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp16_ = music_media_get_title (_tmp15_);
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp17_ = _tmp16_;
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp18_ = g_utf8_strdown (_tmp17_, (gssize) -1);
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp19_ = _tmp18_;
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp20_ = g_strcmp0 (_tmp14_, _tmp19_) == 0;
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
					_g_free0 (_tmp19_);
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
					_g_free0 (_tmp14_);
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (_tmp20_) {
#line 2726 "iPodLibrary.c"
						const gchar* _tmp21_;
						const gchar* _tmp22_;
						gchar* _tmp23_;
						gchar* _tmp24_;
						MusicMedia* _tmp25_;
						const gchar* _tmp26_;
						const gchar* _tmp27_;
						gchar* _tmp28_;
						gchar* _tmp29_;
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp21_ = music_media_get_artist (to_find);
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp22_ = _tmp21_;
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp23_ = g_utf8_strdown (_tmp22_, (gssize) -1);
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp24_ = _tmp23_;
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp25_ = m;
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp26_ = music_media_get_artist (_tmp25_);
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp27_ = _tmp26_;
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp28_ = g_utf8_strdown (_tmp27_, (gssize) -1);
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp29_ = _tmp28_;
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp10_ = g_strcmp0 (_tmp24_, _tmp29_) == 0;
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
						_g_free0 (_tmp29_);
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
						_g_free0 (_tmp24_);
#line 2760 "iPodLibrary.c"
					} else {
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp10_ = FALSE;
#line 2764 "iPodLibrary.c"
					}
#line 311 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (_tmp10_) {
#line 2768 "iPodLibrary.c"
						MusicMedia* _tmp30_;
						MusicMedia* _tmp31_;
#line 312 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp30_ = m;
#line 312 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp31_ = _g_object_ref0 (_tmp30_);
#line 312 "../plugins/Devices/iPod/iPodLibrary.vala"
						_g_object_unref0 (found);
#line 312 "../plugins/Devices/iPod/iPodLibrary.vala"
						found = _tmp31_;
#line 313 "../plugins/Devices/iPod/iPodLibrary.vala"
						_g_object_unref0 (m);
#line 313 "../plugins/Devices/iPod/iPodLibrary.vala"
						break;
#line 2783 "iPodLibrary.c"
					}
#line 310 "../plugins/Devices/iPod/iPodLibrary.vala"
					_g_object_unref0 (m);
#line 2787 "iPodLibrary.c"
				}
#line 310 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (_m_it);
#line 2791 "iPodLibrary.c"
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp32_;
#line 309 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp32_ = self->priv->medias;
#line 309 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 2801 "iPodLibrary.c"
		}
#line 309 "../plugins/Devices/iPod/iPodLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 309 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_object_unref0 (found);
#line 309 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 309 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 309 "../plugins/Devices/iPod/iPodLibrary.vala"
			return NULL;
#line 2813 "iPodLibrary.c"
		}
	}
#line 318 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = found;
#line 318 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 2820 "iPodLibrary.c"
}

static MusicMedia*
music_plugins_ipod_library_real_media_from_file (MusicLibrary* base,
                                                 GFile* file)
{
	MusicPluginsiPodLibrary * self;
	GError* _inner_error0_ = NULL;
	MusicMedia* result;
#line 321 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 321 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 2834 "iPodLibrary.c"
	{
		GeeHashMap* _tmp0_;
#line 322 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp0_ = self->priv->medias;
#line 322 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_medias);
#line 2841 "iPodLibrary.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp1_;
				GeeCollection* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeIterator* _tmp5_;
				GeeIterator* _tmp6_;
#line 323 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp1_ = self->priv->medias;
#line 323 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 323 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp3_ = _tmp2_;
#line 323 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp4_ = _tmp3_;
#line 323 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 323 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp6_ = _tmp5_;
#line 323 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (_tmp4_);
#line 323 "../plugins/Devices/iPod/iPodLibrary.vala"
				_m_it = _tmp6_;
#line 323 "../plugins/Devices/iPod/iPodLibrary.vala"
				while (TRUE) {
#line 2869 "iPodLibrary.c"
					GeeIterator* _tmp7_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp8_;
					gpointer _tmp9_;
					gboolean _tmp10_ = FALSE;
					MusicMedia* _tmp11_;
#line 323 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp7_ = _m_it;
#line 323 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (!gee_iterator_next (_tmp7_)) {
#line 323 "../plugins/Devices/iPod/iPodLibrary.vala"
						break;
#line 2882 "iPodLibrary.c"
					}
#line 323 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp8_ = _m_it;
#line 323 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp9_ = gee_iterator_get (_tmp8_);
#line 323 "../plugins/Devices/iPod/iPodLibrary.vala"
					m = (MusicMedia*) _tmp9_;
#line 324 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp11_ = m;
#line 324 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (_tmp11_ != NULL) {
#line 2894 "iPodLibrary.c"
						MusicMedia* _tmp12_;
						GFile* _tmp13_;
						GFile* _tmp14_;
#line 324 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp12_ = m;
#line 324 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp13_ = music_media_get_file (_tmp12_);
#line 324 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp14_ = _tmp13_;
#line 324 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp10_ = g_file_equal (_tmp14_, file);
#line 2906 "iPodLibrary.c"
					} else {
#line 324 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp10_ = FALSE;
#line 2910 "iPodLibrary.c"
					}
#line 324 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (_tmp10_) {
#line 325 "../plugins/Devices/iPod/iPodLibrary.vala"
						result = m;
#line 325 "../plugins/Devices/iPod/iPodLibrary.vala"
						_g_object_unref0 (_m_it);
#line 2918 "iPodLibrary.c"
						{
							GeeHashMap* _tmp15_;
#line 322 "../plugins/Devices/iPod/iPodLibrary.vala"
							_tmp15_ = self->priv->medias;
#line 322 "../plugins/Devices/iPod/iPodLibrary.vala"
							g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 2925 "iPodLibrary.c"
						}
#line 325 "../plugins/Devices/iPod/iPodLibrary.vala"
						return result;
#line 2929 "iPodLibrary.c"
					}
#line 323 "../plugins/Devices/iPod/iPodLibrary.vala"
					_g_object_unref0 (m);
#line 2933 "iPodLibrary.c"
				}
#line 323 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (_m_it);
#line 2937 "iPodLibrary.c"
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp16_;
#line 322 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp16_ = self->priv->medias;
#line 322 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 2947 "iPodLibrary.c"
		}
#line 322 "../plugins/Devices/iPod/iPodLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 322 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 322 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 322 "../plugins/Devices/iPod/iPodLibrary.vala"
			return NULL;
#line 2957 "iPodLibrary.c"
		}
	}
#line 330 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = NULL;
#line 330 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 2964 "iPodLibrary.c"
}

static MusicMedia*
music_plugins_ipod_library_real_media_from_uri (MusicLibrary* base,
                                                const gchar* uri)
{
	MusicPluginsiPodLibrary * self;
	GError* _inner_error0_ = NULL;
	MusicMedia* result;
#line 333 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 333 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 2978 "iPodLibrary.c"
	{
		GeeHashMap* _tmp0_;
#line 334 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp0_ = self->priv->medias;
#line 334 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_rec_mutex_lock (&self->priv->__lock_medias);
#line 2985 "iPodLibrary.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp1_;
				GeeCollection* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeIterator* _tmp5_;
				GeeIterator* _tmp6_;
#line 335 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp1_ = self->priv->medias;
#line 335 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 335 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp3_ = _tmp2_;
#line 335 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp4_ = _tmp3_;
#line 335 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 335 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp6_ = _tmp5_;
#line 335 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (_tmp4_);
#line 335 "../plugins/Devices/iPod/iPodLibrary.vala"
				_m_it = _tmp6_;
#line 335 "../plugins/Devices/iPod/iPodLibrary.vala"
				while (TRUE) {
#line 3013 "iPodLibrary.c"
					GeeIterator* _tmp7_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp8_;
					gpointer _tmp9_;
					gboolean _tmp10_ = FALSE;
					MusicMedia* _tmp11_;
#line 335 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp7_ = _m_it;
#line 335 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (!gee_iterator_next (_tmp7_)) {
#line 335 "../plugins/Devices/iPod/iPodLibrary.vala"
						break;
#line 3026 "iPodLibrary.c"
					}
#line 335 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp8_ = _m_it;
#line 335 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp9_ = gee_iterator_get (_tmp8_);
#line 335 "../plugins/Devices/iPod/iPodLibrary.vala"
					m = (MusicMedia*) _tmp9_;
#line 336 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp11_ = m;
#line 336 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (_tmp11_ != NULL) {
#line 3038 "iPodLibrary.c"
						MusicMedia* _tmp12_;
						gchar* _tmp13_;
						gchar* _tmp14_;
						gchar* _tmp15_;
#line 336 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp12_ = m;
#line 336 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp13_ = music_media_get_uri (_tmp12_);
#line 336 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp14_ = _tmp13_;
#line 336 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp15_ = _tmp14_;
#line 336 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp10_ = g_strcmp0 (_tmp15_, uri) == 0;
#line 336 "../plugins/Devices/iPod/iPodLibrary.vala"
						_g_free0 (_tmp15_);
#line 3055 "iPodLibrary.c"
					} else {
#line 336 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp10_ = FALSE;
#line 3059 "iPodLibrary.c"
					}
#line 336 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (_tmp10_) {
#line 337 "../plugins/Devices/iPod/iPodLibrary.vala"
						result = m;
#line 337 "../plugins/Devices/iPod/iPodLibrary.vala"
						_g_object_unref0 (_m_it);
#line 3067 "iPodLibrary.c"
						{
							GeeHashMap* _tmp16_;
#line 334 "../plugins/Devices/iPod/iPodLibrary.vala"
							_tmp16_ = self->priv->medias;
#line 334 "../plugins/Devices/iPod/iPodLibrary.vala"
							g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 3074 "iPodLibrary.c"
						}
#line 337 "../plugins/Devices/iPod/iPodLibrary.vala"
						return result;
#line 3078 "iPodLibrary.c"
					}
#line 335 "../plugins/Devices/iPod/iPodLibrary.vala"
					_g_object_unref0 (m);
#line 3082 "iPodLibrary.c"
				}
#line 335 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (_m_it);
#line 3086 "iPodLibrary.c"
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp17_;
#line 334 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp17_ = self->priv->medias;
#line 334 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_rec_mutex_unlock (&self->priv->__lock_medias);
#line 3096 "iPodLibrary.c"
		}
#line 334 "../plugins/Devices/iPod/iPodLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 334 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 334 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_clear_error (&_inner_error0_);
#line 334 "../plugins/Devices/iPod/iPodLibrary.vala"
			return NULL;
#line 3106 "iPodLibrary.c"
		}
	}
#line 342 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = NULL;
#line 342 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 3113 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_real_update_media (MusicLibrary* base,
                                              MusicMedia* s,
                                              gboolean update_meta,
                                              gboolean record_time)
{
	MusicPluginsiPodLibrary * self;
#line 345 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 345 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (s != NULL);
#line 3127 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_real_update_medias (MusicLibrary* base,
                                               GeeCollection* updates,
                                               gboolean update_meta,
                                               gboolean record_time)
{
	MusicPluginsiPodLibrary * self;
#line 349 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 349 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (updates != NULL);
#line 3141 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_real_remove_media (MusicLibrary* base,
                                              MusicMedia* s,
                                              gboolean trash)
{
	MusicPluginsiPodLibrary * self;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
#line 353 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 353 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (s != NULL);
#line 354 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 354 "../plugins/Devices/iPod/iPodLibrary.vala"
	list = _tmp0_;
#line 355 "../plugins/Devices/iPod/iPodLibrary.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) list, s);
#line 356 "../plugins/Devices/iPod/iPodLibrary.vala"
	music_library_remove_medias ((MusicLibrary*) self, (GeeCollection*) list, trash);
#line 353 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (list);
#line 3166 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_real_remove_medias (MusicLibrary* base,
                                               GeeCollection* to_remove,
                                               gboolean trash)
{
	MusicPluginsiPodLibrary * self;
	MusicLibrariesManager* _tmp0_;
	MusicDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	MusicLibrariesManager* _tmp5_;
#line 359 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 359 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (to_remove != NULL);
#line 360 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (self->priv->is_doing_file_operations) {
#line 361 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_warning ("iPodLibrary.vala:361: Tried to add when already syncing\n");
#line 363 "../plugins/Devices/iPod/iPodLibrary.vala"
		return;
#line 3191 "iPodLibrary.c"
	}
#line 366 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = music_libraries_manager;
#line 366 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp1_ = self->priv->device;
#line 366 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp2_ = music_device_get_display_name (_tmp1_);
#line 366 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp3_ = _tmp2_;
#line 366 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp4_ = g_strdup_printf (_ ("Removing from <b>%s</b>…"), _tmp3_);
#line 366 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_free0 (_tmp0_->current_operation);
#line 366 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_->current_operation = _tmp4_;
#line 366 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_free0 (_tmp3_);
#line 367 "../plugins/Devices/iPod/iPodLibrary.vala"
	self->priv->is_doing_file_operations = TRUE;
#line 368 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp5_ = music_libraries_manager;
#line 368 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _music_libraries_manager_do_progress_notification_with_timeout_gsource_func, g_object_ref (_tmp5_), g_object_unref);
#line 369 "../plugins/Devices/iPod/iPodLibrary.vala"
	music_plugins_ipod_library_remove_medias_async (self, to_remove, NULL, NULL);
#line 371 "../plugins/Devices/iPod/iPodLibrary.vala"
	return;
#line 3219 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_remove_medias_async_data_free (gpointer _data)
{
	MusicPluginsIpodLibraryRemoveMediasAsyncData* _data_;
	_data_ = _data;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (_data_->list);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_slice_free (MusicPluginsIpodLibraryRemoveMediasAsyncData, _data_);
#line 3233 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_remove_medias_async (MusicPluginsiPodLibrary* self,
                                                GeeCollection* list,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	MusicPluginsIpodLibraryRemoveMediasAsyncData* _data_;
	MusicPluginsiPodLibrary* _tmp0_;
	GeeCollection* _tmp1_;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (self != NULL);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (list != NULL);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_ = g_slice_new0 (MusicPluginsIpodLibraryRemoveMediasAsyncData);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_plugins_ipod_library_remove_medias_async_data_free);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->self = _tmp0_;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp1_ = _g_object_ref0 (list);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (_data_->list);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->list = _tmp1_;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	music_plugins_ipod_library_remove_medias_async_co (_data_);
#line 3267 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_remove_medias_finish (MusicPluginsiPodLibrary* self,
                                                 GAsyncResult* _res_)
{
	MusicPluginsIpodLibraryRemoveMediasAsyncData* _data_;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3277 "iPodLibrary.c"
}

static gboolean
__lambda9_ (MusicPluginsiPodLibrary* self)
{
	gboolean result;
#line 429 "../plugins/Devices/iPod/iPodLibrary.vala"
	self->priv->is_doing_file_operations = FALSE;
#line 430 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_signal_emit_by_name ((MusicLibrary*) self, "file-operations-done");
#line 431 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = FALSE;
#line 431 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 3292 "iPodLibrary.c"
}

static gboolean
___lambda9__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda9_ ((MusicPluginsiPodLibrary*) self);
#line 428 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 3302 "iPodLibrary.c"
}

static gboolean
music_plugins_ipod_library_remove_medias_async_co (MusicPluginsIpodLibraryRemoveMediasAsyncData* _data_)
{
#line 374 "../plugins/Devices/iPod/iPodLibrary.vala"
	switch (_data_->_state_) {
#line 374 "../plugins/Devices/iPod/iPodLibrary.vala"
		case 0:
#line 3312 "iPodLibrary.c"
		goto _state_0;
		default:
#line 374 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_assert_not_reached ();
#line 3317 "iPodLibrary.c"
	}
	_state_0:
#line 375 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->error_occurred = FALSE;
#line 376 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->_tmp0_ = gee_collection_get_size (_data_->list);
#line 376 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 376 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->total = _data_->_tmp1_;
#line 377 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->index = 0;
#line 378 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->_tmp2_ = _data_->self->priv->db;
#line 378 "../plugins/Devices/iPod/iPodLibrary.vala"
	itdb_start_sync (_data_->_tmp2_);
#line 380 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->_tmp3_ = gee_hash_map_new (G_TYPE_POINTER, NULL, NULL, MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 380 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->removed = _data_->_tmp3_;
#line 3338 "iPodLibrary.c"
	{
#line 381 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp4_ = _data_->self->priv->medias;
#line 381 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp5_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _data_->_tmp4_);
#line 381 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 381 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 381 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp8_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp7_);
#line 381 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 381 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_data_->_tmp7_);
#line 381 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_e_it = _data_->_tmp9_;
#line 381 "../plugins/Devices/iPod/iPodLibrary.vala"
		while (TRUE) {
#line 381 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp10_ = _data_->_e_it;
#line 381 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (!gee_iterator_next (_data_->_tmp10_)) {
#line 381 "../plugins/Devices/iPod/iPodLibrary.vala"
				break;
#line 3364 "iPodLibrary.c"
			}
#line 381 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp11_ = _data_->_e_it;
#line 381 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp12_ = gee_iterator_get (_data_->_tmp11_);
#line 381 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->e = (GeeMapEntry*) _data_->_tmp12_;
#line 3372 "iPodLibrary.c"
			{
#line 382 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_tmp13_ = gee_iterable_iterator ((GeeIterable*) _data_->list);
#line 382 "../plugins/Devices/iPod/iPodLibrary.vala"
				_data_->_m_it = _data_->_tmp13_;
#line 382 "../plugins/Devices/iPod/iPodLibrary.vala"
				while (TRUE) {
#line 382 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp14_ = _data_->_m_it;
#line 382 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (!gee_iterator_next (_data_->_tmp14_)) {
#line 382 "../plugins/Devices/iPod/iPodLibrary.vala"
						break;
#line 3386 "iPodLibrary.c"
					}
#line 382 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp15_ = _data_->_m_it;
#line 382 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->_tmp16_ = gee_iterator_get (_data_->_tmp15_);
#line 382 "../plugins/Devices/iPod/iPodLibrary.vala"
					_data_->m = (MusicMedia*) _data_->_tmp16_;
#line 383 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (!_data_->self->priv->operation_cancelled) {
#line 385 "../plugins/Devices/iPod/iPodLibrary.vala"
						_data_->_tmp17_ = _data_->m;
#line 385 "../plugins/Devices/iPod/iPodLibrary.vala"
						_data_->_tmp18_ = _data_->e;
#line 385 "../plugins/Devices/iPod/iPodLibrary.vala"
						_data_->_tmp19_ = gee_map_entry_get_value (_data_->_tmp18_);
#line 385 "../plugins/Devices/iPod/iPodLibrary.vala"
						_data_->_tmp20_ = _data_->_tmp19_;
#line 385 "../plugins/Devices/iPod/iPodLibrary.vala"
						if (_data_->_tmp17_ == ((MusicMedia*) _data_->_tmp20_)) {
#line 386 "../plugins/Devices/iPod/iPodLibrary.vala"
							_data_->_tmp21_ = _data_->e;
#line 386 "../plugins/Devices/iPod/iPodLibrary.vala"
							_data_->_tmp22_ = gee_map_entry_get_key (_data_->_tmp21_);
#line 386 "../plugins/Devices/iPod/iPodLibrary.vala"
							_data_->_tmp23_ = _data_->_tmp22_;
#line 386 "../plugins/Devices/iPod/iPodLibrary.vala"
							_data_->t = (Itdb_Track*) _data_->_tmp23_;
#line 387 "../plugins/Devices/iPod/iPodLibrary.vala"
							_data_->_tmp24_ = _data_->t;
#line 387 "../plugins/Devices/iPod/iPodLibrary.vala"
							if (_data_->_tmp24_ != NULL) {
#line 388 "../plugins/Devices/iPod/iPodLibrary.vala"
								_data_->_tmp25_ = _data_->removed;
#line 388 "../plugins/Devices/iPod/iPodLibrary.vala"
								_data_->_tmp26_ = _data_->t;
#line 388 "../plugins/Devices/iPod/iPodLibrary.vala"
								_data_->_tmp27_ = _data_->e;
#line 388 "../plugins/Devices/iPod/iPodLibrary.vala"
								_data_->_tmp28_ = gee_map_entry_get_value (_data_->_tmp27_);
#line 388 "../plugins/Devices/iPod/iPodLibrary.vala"
								_data_->_tmp29_ = _data_->_tmp28_;
#line 388 "../plugins/Devices/iPod/iPodLibrary.vala"
								gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp25_, _data_->_tmp26_, (MusicMedia*) _data_->_tmp29_);
#line 3430 "iPodLibrary.c"
							}
						}
					}
#line 382 "../plugins/Devices/iPod/iPodLibrary.vala"
					_g_object_unref0 (_data_->m);
#line 3436 "iPodLibrary.c"
				}
#line 382 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (_data_->_m_it);
#line 3440 "iPodLibrary.c"
			}
#line 394 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->index = _data_->index + 1;
#line 394 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp30_ = _data_->index;
#line 395 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp31_ = music_libraries_manager;
#line 395 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp31_->progress = (gdouble) (_data_->index / _data_->total);
#line 381 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_object_unref0 (_data_->e);
#line 3452 "iPodLibrary.c"
		}
#line 381 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_data_->_e_it);
#line 3456 "iPodLibrary.c"
	}
	{
#line 398 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp32_ = _data_->removed;
#line 398 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp33_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _data_->_tmp32_);
#line 398 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp34_ = _data_->_tmp33_;
#line 398 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp35_ = _data_->_tmp34_;
#line 398 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp36_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp35_);
#line 398 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp37_ = _data_->_tmp36_;
#line 398 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_data_->_tmp35_);
#line 398 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_track_it = _data_->_tmp37_;
#line 398 "../plugins/Devices/iPod/iPodLibrary.vala"
		while (TRUE) {
#line 398 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp38_ = _data_->_track_it;
#line 398 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (!gee_iterator_next (_data_->_tmp38_)) {
#line 398 "../plugins/Devices/iPod/iPodLibrary.vala"
				break;
#line 3483 "iPodLibrary.c"
			}
#line 398 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp39_ = _data_->_track_it;
#line 398 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp40_ = gee_iterator_get (_data_->_tmp39_);
#line 398 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->track = (Itdb_Track*) _data_->_tmp40_;
#line 399 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp41_ = _data_->track;
#line 399 "../plugins/Devices/iPod/iPodLibrary.vala"
			music_plugins_ipod_library_remove_media_from_ipod (_data_->self, _data_->_tmp41_);
#line 3495 "iPodLibrary.c"
		}
#line 398 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_data_->_track_it);
#line 3499 "iPodLibrary.c"
	}
#line 402 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->_tmp42_ = _data_->self->priv->medias;
#line 402 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data_->_tmp43_ = _data_->removed;
#line 402 "../plugins/Devices/iPod/iPodLibrary.vala"
	gee_map_unset_all ((GeeMap*) _data_->_tmp42_, (GeeMap*) _data_->_tmp43_);
#line 403 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (!_data_->self->priv->operation_cancelled) {
#line 404 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp44_ = music_libraries_manager;
#line 404 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp45_ = g_strdup (_ ("Finishing sync process…"));
#line 404 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_free0 (_data_->_tmp44_->current_operation);
#line 404 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp44_->current_operation = _data_->_tmp45_;
#line 3517 "iPodLibrary.c"
		{
#line 406 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp46_ = _data_->self->priv->db;
#line 406 "../plugins/Devices/iPod/iPodLibrary.vala"
			itdb_write (_data_->_tmp46_, &_data_->_inner_error0_);
#line 406 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3525 "iPodLibrary.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 405 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->err = _data_->_inner_error0_;
#line 405 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_inner_error0_ = NULL;
#line 408 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp47_ = _data_->err;
#line 408 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp48_ = _data_->_tmp47_->message;
#line 408 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_critical ("iPodLibrary.vala:408: Error when writing iPod database. iPod contents " \
"may be incorrect: %s", _data_->_tmp48_);
#line 409 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->error_occurred = TRUE;
#line 410 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->self->priv->operation_cancelled = TRUE;
#line 405 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_error_free0 (_data_->err);
#line 3548 "iPodLibrary.c"
		}
		__finally0:
#line 405 "../plugins/Devices/iPod/iPodLibrary.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 405 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_object_unref0 (_data_->removed);
#line 405 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 405 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 405 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_object_unref (_data_->_async_result);
#line 405 "../plugins/Devices/iPod/iPodLibrary.vala"
			return FALSE;
#line 3563 "iPodLibrary.c"
		}
#line 413 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp49_ = music_libraries_manager;
#line 413 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp49_->progress = (gdouble) 1;
#line 414 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp50_ = _data_->self->priv->db;
#line 414 "../plugins/Devices/iPod/iPodLibrary.vala"
		itdb_stop_sync (_data_->_tmp50_);
#line 3573 "iPodLibrary.c"
	} else {
#line 416 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp51_ = music_libraries_manager;
#line 416 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp52_ = g_strdup (_ ("Cancelling Sync…"));
#line 416 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_free0 (_data_->_tmp51_->current_operation);
#line 416 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp51_->current_operation = _data_->_tmp52_;
#line 3583 "iPodLibrary.c"
		{
#line 418 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp53_ = _data_->self->priv->db;
#line 418 "../plugins/Devices/iPod/iPodLibrary.vala"
			itdb_write (_data_->_tmp53_, &_data_->_inner_error0_);
#line 418 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3591 "iPodLibrary.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 417 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_vala1_err = _data_->_inner_error0_;
#line 417 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_inner_error0_ = NULL;
#line 420 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp54_ = _data_->_vala1_err;
#line 420 "../plugins/Devices/iPod/iPodLibrary.vala"
			_data_->_tmp55_ = _data_->_tmp54_->message;
#line 420 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_critical ("iPodLibrary.vala:420: Error when writing iPod database. iPod contents " \
"may be incorrect: %s", _data_->_tmp55_);
#line 417 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_error_free0 (_data_->_vala1_err);
#line 3610 "iPodLibrary.c"
		}
		__finally1:
#line 417 "../plugins/Devices/iPod/iPodLibrary.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 417 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_object_unref0 (_data_->removed);
#line 417 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 417 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 417 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_object_unref (_data_->_async_result);
#line 417 "../plugins/Devices/iPod/iPodLibrary.vala"
			return FALSE;
#line 3625 "iPodLibrary.c"
		}
#line 423 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp56_ = _data_->self->priv->db;
#line 423 "../plugins/Devices/iPod/iPodLibrary.vala"
		itdb_stop_sync (_data_->_tmp56_);
#line 424 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp57_ = music_libraries_manager;
#line 424 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->_tmp57_->progress = (gdouble) 1;
#line 425 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data_->self->priv->operation_cancelled = FALSE;
#line 3637 "iPodLibrary.c"
	}
#line 428 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda9__gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 374 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (_data_->removed);
#line 374 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 374 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (_data_->_state_ != 0) {
#line 374 "../plugins/Devices/iPod/iPodLibrary.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 374 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3651 "iPodLibrary.c"
		}
	}
#line 374 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_object_unref (_data_->_async_result);
#line 374 "../plugins/Devices/iPod/iPodLibrary.vala"
	return FALSE;
#line 3658 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_real_add_smart_playlist (MusicLibrary* base,
                                                    MusicSmartPlaylist* p)
{
	MusicPluginsiPodLibrary * self;
#line 435 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 435 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (p != NULL);
#line 3670 "iPodLibrary.c"
}

static gboolean
music_plugins_ipod_library_real_support_smart_playlists (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
	gboolean result;
#line 439 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 440 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = FALSE;
#line 440 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 3684 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_real_remove_smart_playlist (MusicLibrary* base,
                                                       gint64 id)
{
	MusicPluginsiPodLibrary * self;
#line 443 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 3694 "iPodLibrary.c"
}

static MusicSmartPlaylist*
music_plugins_ipod_library_real_smart_playlist_from_id (MusicLibrary* base,
                                                        gint64 id)
{
	MusicPluginsiPodLibrary * self;
	MusicSmartPlaylist* result;
#line 447 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 448 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = NULL;
#line 448 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 3709 "iPodLibrary.c"
}

static MusicSmartPlaylist*
music_plugins_ipod_library_real_smart_playlist_from_name (MusicLibrary* base,
                                                          const gchar* name)
{
	MusicPluginsiPodLibrary * self;
	MusicSmartPlaylist* result;
#line 451 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 451 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 452 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = NULL;
#line 452 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 3726 "iPodLibrary.c"
}

static gboolean
music_plugins_ipod_library_real_support_playlists (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
	gboolean result;
#line 455 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 456 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = TRUE;
#line 456 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 3740 "iPodLibrary.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
	return _data2_;
#line 3750 "iPodLibrary.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 3760 "iPodLibrary.c"
		MusicPluginsiPodLibrary* self;
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
		self = _data2_->self;
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_data2_->p);
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (self);
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_slice_free (Block2Data, _data2_);
#line 3770 "iPodLibrary.c"
	}
}

static void
__lambda10_ (Block2Data* _data2_,
             GeeCollection* list)
{
	MusicPluginsiPodLibrary* self;
#line 472 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = _data2_->self;
#line 472 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (list != NULL);
#line 472 "../plugins/Devices/iPod/iPodLibrary.vala"
	music_plugins_ipod_library_keep_playlist_synchronized (self, _data2_->p, list, TRUE);
#line 3785 "iPodLibrary.c"
}

static void
___lambda10__music_playlist_media_added (MusicPlaylist* _sender,
                                         GeeCollection* media,
                                         gpointer self)
{
#line 472 "../plugins/Devices/iPod/iPodLibrary.vala"
	__lambda10_ (self, media);
#line 3795 "iPodLibrary.c"
}

static void
__lambda11_ (Block2Data* _data2_,
             GeeCollection* list)
{
	MusicPluginsiPodLibrary* self;
#line 473 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = _data2_->self;
#line 473 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (list != NULL);
#line 473 "../plugins/Devices/iPod/iPodLibrary.vala"
	music_plugins_ipod_library_keep_playlist_synchronized (self, _data2_->p, list, FALSE);
#line 3809 "iPodLibrary.c"
}

static void
___lambda11__music_playlist_media_removed (MusicPlaylist* _sender,
                                           GeeCollection* media,
                                           gpointer self)
{
#line 473 "../plugins/Devices/iPod/iPodLibrary.vala"
	__lambda11_ (self, media);
#line 3819 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_real_add_playlist (MusicLibrary* base,
                                              MusicStaticPlaylist* p)
{
	MusicPluginsiPodLibrary * self;
	Block2Data* _data2_;
	MusicStaticPlaylist* _tmp0_;
	Itdb_Playlist* playlist = NULL;
	GeeHashMap* _tmp1_;
	Itdb_iTunesDB* _tmp2_;
	Itdb_Playlist* _tmp3_;
	Itdb_iTunesDB* _tmp4_;
	Itdb_iTunesDB* _tmp5_;
	Itdb_Playlist* _tmp6_;
	Itdb_iTunesDB* _tmp10_;
	GeeHashMap* _tmp11_;
	Itdb_Playlist* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (p != NULL);
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data2_->_ref_count_ = 1;
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data2_->self = g_object_ref (self);
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = _g_object_ref0 (p);
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (_data2_->p);
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data2_->p = _tmp0_;
#line 460 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp1_ = self->priv->medias;
#line 460 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp2_ = self->priv->db;
#line 460 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp3_ = music_plugins_ipod_playlist_helper_get_gpod_playlist_from_playlist ((MusicPlaylist*) _data2_->p, _tmp1_, _tmp2_);
#line 460 "../plugins/Devices/iPod/iPodLibrary.vala"
	playlist = _tmp3_;
#line 461 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp4_ = self->priv->db;
#line 461 "../plugins/Devices/iPod/iPodLibrary.vala"
	itdb_start_sync (_tmp4_);
#line 462 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp5_ = self->priv->db;
#line 462 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp6_ = playlist;
#line 462 "../plugins/Devices/iPod/iPodLibrary.vala"
	playlist = NULL;
#line 462 "../plugins/Devices/iPod/iPodLibrary.vala"
	itdb_playlist_add (_tmp5_, _tmp6_, (gint32) -1);
#line 3876 "iPodLibrary.c"
	{
		Itdb_iTunesDB* _tmp7_;
#line 464 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp7_ = self->priv->db;
#line 464 "../plugins/Devices/iPod/iPodLibrary.vala"
		itdb_write (_tmp7_, &_inner_error0_);
#line 464 "../plugins/Devices/iPod/iPodLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3885 "iPodLibrary.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 463 "../plugins/Devices/iPod/iPodLibrary.vala"
		err = _inner_error0_;
#line 463 "../plugins/Devices/iPod/iPodLibrary.vala"
		_inner_error0_ = NULL;
#line 466 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp8_ = err;
#line 466 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp9_ = _tmp8_->message;
#line 466 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_critical ("iPodLibrary.vala:466: Error when writing iPod database. iPod contents " \
"may be incorrect: %s", _tmp9_);
#line 463 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_error_free0 (err);
#line 3907 "iPodLibrary.c"
	}
	__finally0:
#line 463 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 463 "../plugins/Devices/iPod/iPodLibrary.vala"
		_itdb_playlist_free0 (playlist);
#line 463 "../plugins/Devices/iPod/iPodLibrary.vala"
		block2_data_unref (_data2_);
#line 463 "../plugins/Devices/iPod/iPodLibrary.vala"
		_data2_ = NULL;
#line 463 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 463 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_clear_error (&_inner_error0_);
#line 463 "../plugins/Devices/iPod/iPodLibrary.vala"
		return;
#line 3924 "iPodLibrary.c"
	}
#line 469 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp10_ = self->priv->db;
#line 469 "../plugins/Devices/iPod/iPodLibrary.vala"
	itdb_stop_sync (_tmp10_);
#line 470 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp11_ = self->priv->playlists;
#line 470 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp12_ = playlist;
#line 470 "../plugins/Devices/iPod/iPodLibrary.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp11_, _tmp12_, _data2_->p);
#line 471 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_signal_emit_by_name ((MusicLibrary*) self, "playlist-added", _data2_->p);
#line 472 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_signal_connect_data ((MusicPlaylist*) _data2_->p, "media-added", (GCallback) ___lambda10__music_playlist_media_added, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 473 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_signal_connect_data ((MusicPlaylist*) _data2_->p, "media-removed", (GCallback) ___lambda11__music_playlist_media_removed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
	_itdb_playlist_free0 (playlist);
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
	block2_data_unref (_data2_);
#line 459 "../plugins/Devices/iPod/iPodLibrary.vala"
	_data2_ = NULL;
#line 3948 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_real_remove_playlist (MusicLibrary* base,
                                                 gint64 id)
{
	MusicPluginsiPodLibrary * self;
	Itdb_Playlist* to_unset = NULL;
	Itdb_Playlist* _tmp20_;
	Itdb_iTunesDB* _tmp23_;
	Itdb_Playlist* _tmp24_;
	Itdb_iTunesDB* _tmp28_;
	GError* _inner_error0_ = NULL;
#line 476 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 477 "../plugins/Devices/iPod/iPodLibrary.vala"
	to_unset = NULL;
#line 3966 "iPodLibrary.c"
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 478 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp0_ = self->priv->playlists;
#line 478 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp1_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp0_);
#line 478 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp2_ = _tmp1_;
#line 478 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp3_ = _tmp2_;
#line 478 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 478 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp5_ = _tmp4_;
#line 478 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_tmp3_);
#line 478 "../plugins/Devices/iPod/iPodLibrary.vala"
		_entry_it = _tmp5_;
#line 478 "../plugins/Devices/iPod/iPodLibrary.vala"
		while (TRUE) {
#line 3993 "iPodLibrary.c"
			GeeIterator* _tmp6_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeMapEntry* _tmp9_;
			gconstpointer _tmp10_;
			gconstpointer _tmp11_;
			gint64 _tmp12_;
			gint64 _tmp13_;
#line 478 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp6_ = _entry_it;
#line 478 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 478 "../plugins/Devices/iPod/iPodLibrary.vala"
				break;
#line 4009 "iPodLibrary.c"
			}
#line 478 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp7_ = _entry_it;
#line 478 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 478 "../plugins/Devices/iPod/iPodLibrary.vala"
			entry = (GeeMapEntry*) _tmp8_;
#line 479 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp9_ = entry;
#line 479 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp10_ = gee_map_entry_get_value (_tmp9_);
#line 479 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp11_ = _tmp10_;
#line 479 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp12_ = music_playlist_get_rowid ((MusicPlaylist*) ((MusicStaticPlaylist*) _tmp11_));
#line 479 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp13_ = _tmp12_;
#line 479 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (_tmp13_ == id) {
#line 4029 "iPodLibrary.c"
				GeeMapEntry* _tmp14_;
				gconstpointer _tmp15_;
				gconstpointer _tmp16_;
				GeeMapEntry* _tmp17_;
				gconstpointer _tmp18_;
				gconstpointer _tmp19_;
#line 480 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp14_ = entry;
#line 480 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp15_ = gee_map_entry_get_value (_tmp14_);
#line 480 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp16_ = _tmp15_;
#line 480 "../plugins/Devices/iPod/iPodLibrary.vala"
				g_signal_emit_by_name ((MusicLibrary*) self, "playlist-removed", (MusicStaticPlaylist*) _tmp16_);
#line 481 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp17_ = entry;
#line 481 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp18_ = gee_map_entry_get_key (_tmp17_);
#line 481 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp19_ = _tmp18_;
#line 481 "../plugins/Devices/iPod/iPodLibrary.vala"
				to_unset = (Itdb_Playlist*) _tmp19_;
#line 4052 "iPodLibrary.c"
			}
#line 478 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_object_unref0 (entry);
#line 4056 "iPodLibrary.c"
		}
#line 478 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_entry_it);
#line 4060 "iPodLibrary.c"
	}
#line 485 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp20_ = to_unset;
#line 485 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (_tmp20_ != NULL) {
#line 4066 "iPodLibrary.c"
		GeeHashMap* _tmp21_;
		Itdb_Playlist* _tmp22_;
#line 486 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp21_ = self->priv->playlists;
#line 486 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp22_ = to_unset;
#line 486 "../plugins/Devices/iPod/iPodLibrary.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp21_, _tmp22_, NULL);
#line 4075 "iPodLibrary.c"
	}
#line 488 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp23_ = self->priv->db;
#line 488 "../plugins/Devices/iPod/iPodLibrary.vala"
	itdb_start_sync (_tmp23_);
#line 489 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp24_ = to_unset;
#line 489 "../plugins/Devices/iPod/iPodLibrary.vala"
	itdb_playlist_remove (_tmp24_);
#line 4085 "iPodLibrary.c"
	{
		Itdb_iTunesDB* _tmp25_;
#line 491 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp25_ = self->priv->db;
#line 491 "../plugins/Devices/iPod/iPodLibrary.vala"
		itdb_write (_tmp25_, &_inner_error0_);
#line 491 "../plugins/Devices/iPod/iPodLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4094 "iPodLibrary.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp26_;
		const gchar* _tmp27_;
#line 490 "../plugins/Devices/iPod/iPodLibrary.vala"
		err = _inner_error0_;
#line 490 "../plugins/Devices/iPod/iPodLibrary.vala"
		_inner_error0_ = NULL;
#line 493 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp26_ = err;
#line 493 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp27_ = _tmp26_->message;
#line 493 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_critical ("iPodLibrary.vala:493: Error when writing iPod database. iPod contents " \
"may be incorrect: %s", _tmp27_);
#line 490 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_error_free0 (err);
#line 4116 "iPodLibrary.c"
	}
	__finally0:
#line 490 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 490 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 490 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_clear_error (&_inner_error0_);
#line 490 "../plugins/Devices/iPod/iPodLibrary.vala"
		return;
#line 4127 "iPodLibrary.c"
	}
#line 496 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp28_ = self->priv->db;
#line 496 "../plugins/Devices/iPod/iPodLibrary.vala"
	itdb_stop_sync (_tmp28_);
#line 4133 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_keep_playlist_synchronized (MusicPluginsiPodLibrary* self,
                                                       MusicStaticPlaylist* p,
                                                       GeeCollection* m,
                                                       gboolean to_add)
{
	Itdb_Playlist* pl = NULL;
	Itdb_Playlist* _tmp15_;
	Itdb_iTunesDB* _tmp16_;
	Itdb_iTunesDB* _tmp38_;
	GError* _inner_error0_ = NULL;
#line 499 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (self != NULL);
#line 499 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (p != NULL);
#line 499 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (m != NULL);
#line 500 "../plugins/Devices/iPod/iPodLibrary.vala"
	pl = NULL;
#line 4155 "iPodLibrary.c"
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 501 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp0_ = self->priv->playlists;
#line 501 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp1_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp0_);
#line 501 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp2_ = _tmp1_;
#line 501 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp3_ = _tmp2_;
#line 501 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 501 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp5_ = _tmp4_;
#line 501 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_tmp3_);
#line 501 "../plugins/Devices/iPod/iPodLibrary.vala"
		_entry_it = _tmp5_;
#line 501 "../plugins/Devices/iPod/iPodLibrary.vala"
		while (TRUE) {
#line 4182 "iPodLibrary.c"
			GeeIterator* _tmp6_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeMapEntry* _tmp9_;
			gconstpointer _tmp10_;
			gconstpointer _tmp11_;
#line 501 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp6_ = _entry_it;
#line 501 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 501 "../plugins/Devices/iPod/iPodLibrary.vala"
				break;
#line 4196 "iPodLibrary.c"
			}
#line 501 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp7_ = _entry_it;
#line 501 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 501 "../plugins/Devices/iPod/iPodLibrary.vala"
			entry = (GeeMapEntry*) _tmp8_;
#line 502 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp9_ = entry;
#line 502 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp10_ = gee_map_entry_get_value (_tmp9_);
#line 502 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp11_ = _tmp10_;
#line 502 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (((MusicStaticPlaylist*) _tmp11_) == p) {
#line 4212 "iPodLibrary.c"
				GeeMapEntry* _tmp12_;
				gconstpointer _tmp13_;
				gconstpointer _tmp14_;
#line 503 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp12_ = entry;
#line 503 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp13_ = gee_map_entry_get_key (_tmp12_);
#line 503 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp14_ = _tmp13_;
#line 503 "../plugins/Devices/iPod/iPodLibrary.vala"
				pl = (Itdb_Playlist*) _tmp14_;
#line 4224 "iPodLibrary.c"
			}
#line 501 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_object_unref0 (entry);
#line 4228 "iPodLibrary.c"
		}
#line 501 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_entry_it);
#line 4232 "iPodLibrary.c"
	}
#line 507 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp15_ = pl;
#line 507 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (_tmp15_ == NULL) {
#line 508 "../plugins/Devices/iPod/iPodLibrary.vala"
		return;
#line 4240 "iPodLibrary.c"
	}
#line 511 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp16_ = self->priv->db;
#line 511 "../plugins/Devices/iPod/iPodLibrary.vala"
	itdb_start_sync (_tmp16_);
#line 4246 "iPodLibrary.c"
	{
		GeeIterator* _t_it = NULL;
		GeeHashMap* _tmp17_;
		GeeCollection* _tmp18_;
		GeeCollection* _tmp19_;
		GeeIterator* _tmp20_;
		GeeIterator* _tmp21_;
#line 512 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp17_ = self->priv->medias;
#line 512 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp18_ = music_plugins_ipod_playlist_helper_get_gpod_tracks_from_medias (m, _tmp17_);
#line 512 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp19_ = _tmp18_;
#line 512 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp20_ = gee_iterable_iterator ((GeeIterable*) _tmp19_);
#line 512 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp21_ = _tmp20_;
#line 512 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_tmp19_);
#line 512 "../plugins/Devices/iPod/iPodLibrary.vala"
		_t_it = _tmp21_;
#line 512 "../plugins/Devices/iPod/iPodLibrary.vala"
		while (TRUE) {
#line 4270 "iPodLibrary.c"
			GeeIterator* _tmp22_;
			Itdb_Track* t = NULL;
			GeeIterator* _tmp23_;
			gpointer _tmp24_;
			gboolean _tmp25_ = FALSE;
			Itdb_Playlist* _tmp26_;
			Itdb_Track* _tmp27_;
#line 512 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp22_ = _t_it;
#line 512 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (!gee_iterator_next (_tmp22_)) {
#line 512 "../plugins/Devices/iPod/iPodLibrary.vala"
				break;
#line 4284 "iPodLibrary.c"
			}
#line 512 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp23_ = _t_it;
#line 512 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp24_ = gee_iterator_get (_tmp23_);
#line 512 "../plugins/Devices/iPod/iPodLibrary.vala"
			t = (Itdb_Track*) _tmp24_;
#line 513 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp26_ = pl;
#line 513 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp27_ = t;
#line 513 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (!itdb_playlist_contains_track (_tmp26_, _tmp27_)) {
#line 513 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp25_ = to_add == TRUE;
#line 4300 "iPodLibrary.c"
			} else {
#line 513 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp25_ = FALSE;
#line 4304 "iPodLibrary.c"
			}
#line 513 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (_tmp25_) {
#line 4308 "iPodLibrary.c"
				Itdb_Playlist* _tmp28_;
				Itdb_Track* _tmp29_;
#line 514 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp28_ = pl;
#line 514 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp29_ = t;
#line 514 "../plugins/Devices/iPod/iPodLibrary.vala"
				itdb_playlist_add_track (_tmp28_, _tmp29_, (gint32) -1);
#line 4317 "iPodLibrary.c"
			} else {
				gboolean _tmp30_ = FALSE;
				Itdb_Playlist* _tmp31_;
				Itdb_Track* _tmp32_;
#line 515 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp31_ = pl;
#line 515 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp32_ = t;
#line 515 "../plugins/Devices/iPod/iPodLibrary.vala"
				if (itdb_playlist_contains_track (_tmp31_, _tmp32_)) {
#line 515 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp30_ = to_add == FALSE;
#line 4330 "iPodLibrary.c"
				} else {
#line 515 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp30_ = FALSE;
#line 4334 "iPodLibrary.c"
				}
#line 515 "../plugins/Devices/iPod/iPodLibrary.vala"
				if (_tmp30_) {
#line 4338 "iPodLibrary.c"
					Itdb_Playlist* _tmp33_;
					Itdb_Track* _tmp34_;
#line 516 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp33_ = pl;
#line 516 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp34_ = t;
#line 516 "../plugins/Devices/iPod/iPodLibrary.vala"
					itdb_playlist_remove_track (_tmp33_, _tmp34_);
#line 4347 "iPodLibrary.c"
				}
			}
		}
#line 512 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_t_it);
#line 4353 "iPodLibrary.c"
	}
	{
		Itdb_iTunesDB* _tmp35_;
#line 521 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp35_ = self->priv->db;
#line 521 "../plugins/Devices/iPod/iPodLibrary.vala"
		itdb_write (_tmp35_, &_inner_error0_);
#line 521 "../plugins/Devices/iPod/iPodLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4363 "iPodLibrary.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp36_;
		const gchar* _tmp37_;
#line 520 "../plugins/Devices/iPod/iPodLibrary.vala"
		err = _inner_error0_;
#line 520 "../plugins/Devices/iPod/iPodLibrary.vala"
		_inner_error0_ = NULL;
#line 523 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp36_ = err;
#line 523 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp37_ = _tmp36_->message;
#line 523 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_critical ("iPodLibrary.vala:523: Error when writing iPod database. iPod contents " \
"may be incorrect: %s", _tmp37_);
#line 520 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_error_free0 (err);
#line 4385 "iPodLibrary.c"
	}
	__finally0:
#line 520 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 520 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 520 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_clear_error (&_inner_error0_);
#line 520 "../plugins/Devices/iPod/iPodLibrary.vala"
		return;
#line 4396 "iPodLibrary.c"
	}
#line 526 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp38_ = self->priv->db;
#line 526 "../plugins/Devices/iPod/iPodLibrary.vala"
	itdb_stop_sync (_tmp38_);
#line 4402 "iPodLibrary.c"
}

static MusicStaticPlaylist*
music_plugins_ipod_library_real_playlist_from_id (MusicLibrary* base,
                                                  gint64 id)
{
	MusicPluginsiPodLibrary * self;
	MusicStaticPlaylist* result;
#line 529 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 4413 "iPodLibrary.c"
	{
		GeeIterator* _p_it = NULL;
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 530 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp0_ = self->priv->playlists;
#line 530 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
#line 530 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp2_ = _tmp1_;
#line 530 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp3_ = _tmp2_;
#line 530 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 530 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp5_ = _tmp4_;
#line 530 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_tmp3_);
#line 530 "../plugins/Devices/iPod/iPodLibrary.vala"
		_p_it = _tmp5_;
#line 530 "../plugins/Devices/iPod/iPodLibrary.vala"
		while (TRUE) {
#line 4440 "iPodLibrary.c"
			GeeIterator* _tmp6_;
			MusicStaticPlaylist* p = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			MusicStaticPlaylist* _tmp9_;
			gint64 _tmp10_;
			gint64 _tmp11_;
#line 530 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp6_ = _p_it;
#line 530 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 530 "../plugins/Devices/iPod/iPodLibrary.vala"
				break;
#line 4454 "iPodLibrary.c"
			}
#line 530 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp7_ = _p_it;
#line 530 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 530 "../plugins/Devices/iPod/iPodLibrary.vala"
			p = (MusicStaticPlaylist*) _tmp8_;
#line 531 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp9_ = p;
#line 531 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp10_ = music_playlist_get_rowid ((MusicPlaylist*) _tmp9_);
#line 531 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp11_ = _tmp10_;
#line 531 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (_tmp11_ == id) {
#line 532 "../plugins/Devices/iPod/iPodLibrary.vala"
				result = p;
#line 532 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (_p_it);
#line 532 "../plugins/Devices/iPod/iPodLibrary.vala"
				return result;
#line 4476 "iPodLibrary.c"
			}
#line 530 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_object_unref0 (p);
#line 4480 "iPodLibrary.c"
		}
#line 530 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_p_it);
#line 4484 "iPodLibrary.c"
	}
#line 536 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = NULL;
#line 536 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 4490 "iPodLibrary.c"
}

static MusicStaticPlaylist*
music_plugins_ipod_library_real_playlist_from_name (MusicLibrary* base,
                                                    const gchar* name)
{
	MusicPluginsiPodLibrary * self;
	MusicStaticPlaylist* result;
#line 539 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 539 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 4503 "iPodLibrary.c"
	{
		GeeIterator* _playlist_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 540 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp0_ = music_library_get_playlists ((MusicLibrary*) self);
#line 540 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp1_ = _tmp0_;
#line 540 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 540 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp3_ = _tmp2_;
#line 540 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_tmp1_);
#line 540 "../plugins/Devices/iPod/iPodLibrary.vala"
		_playlist_it = _tmp3_;
#line 540 "../plugins/Devices/iPod/iPodLibrary.vala"
		while (TRUE) {
#line 4524 "iPodLibrary.c"
			GeeIterator* _tmp4_;
			MusicStaticPlaylist* playlist = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			MusicStaticPlaylist* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
#line 540 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp4_ = _playlist_it;
#line 540 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 540 "../plugins/Devices/iPod/iPodLibrary.vala"
				break;
#line 4538 "iPodLibrary.c"
			}
#line 540 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp5_ = _playlist_it;
#line 540 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 540 "../plugins/Devices/iPod/iPodLibrary.vala"
			playlist = (MusicStaticPlaylist*) _tmp6_;
#line 541 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp7_ = playlist;
#line 541 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp8_ = music_playlist_get_name ((MusicPlaylist*) _tmp7_);
#line 541 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp9_ = _tmp8_;
#line 541 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (g_strcmp0 (_tmp9_, name) == 0) {
#line 542 "../plugins/Devices/iPod/iPodLibrary.vala"
				result = playlist;
#line 542 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (_playlist_it);
#line 542 "../plugins/Devices/iPod/iPodLibrary.vala"
				return result;
#line 4560 "iPodLibrary.c"
			}
#line 540 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_object_unref0 (playlist);
#line 4564 "iPodLibrary.c"
		}
#line 540 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (_playlist_it);
#line 4568 "iPodLibrary.c"
	}
#line 545 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = NULL;
#line 545 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 4574 "iPodLibrary.c"
}

static gboolean
music_plugins_ipod_library_real_start_file_operations (MusicLibrary* base,
                                                       const gchar* message)
{
	MusicPluginsiPodLibrary * self;
	gboolean result;
#line 548 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 549 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = TRUE;
#line 549 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 4589 "iPodLibrary.c"
}

static gboolean
music_plugins_ipod_library_real_doing_file_operations (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
	gboolean result;
#line 552 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 553 "../plugins/Devices/iPod/iPodLibrary.vala"
	result = TRUE;
#line 553 "../plugins/Devices/iPod/iPodLibrary.vala"
	return result;
#line 4603 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_real_finish_file_operations (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
#line 556 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = (MusicPluginsiPodLibrary*) base;
#line 4612 "iPodLibrary.c"
}

static gchar*
_vala_itdb_filename_ipod2fs (const gchar* ipod_file)
{
	gchar* retval = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 79 "libgpod-1.0.vapi"
	g_return_val_if_fail (ipod_file != NULL, NULL);
#line 80 "libgpod-1.0.vapi"
	_tmp0_ = g_strdup (ipod_file);
#line 80 "libgpod-1.0.vapi"
	retval = _tmp0_;
#line 81 "libgpod-1.0.vapi"
	itdb_filename_ipod2fs (retval);
#line 82 "libgpod-1.0.vapi"
	result = retval;
#line 82 "libgpod-1.0.vapi"
	return result;
#line 4633 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_remove_media_from_ipod (MusicPluginsiPodLibrary* self,
                                                   Itdb_Track* t)
{
	gchar* current_operation = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	MusicDevice* _tmp10_;
	gchar* _tmp11_;
	MusicLibrariesManager* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	GError* _inner_error0_ = NULL;
#line 560 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (self != NULL);
#line 560 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (t != NULL);
#line 561 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp0_ = g_strdup (_ ("Removing <b>$NAME</b> by <b>$ARTIST</b> from $DEVICE"));
#line 561 "../plugins/Devices/iPod/iPodLibrary.vala"
	current_operation = _tmp0_;
#line 562 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp2_ = t->title;
#line 562 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp1_ = _tmp2_;
#line 562 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (_tmp1_ == NULL) {
#line 562 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp1_ = "";
#line 4674 "iPodLibrary.c"
	}
#line 562 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp3_ = current_operation;
#line 562 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp4_ = string_replace (_tmp3_, "$NAME", _tmp1_);
#line 562 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_free0 (current_operation);
#line 562 "../plugins/Devices/iPod/iPodLibrary.vala"
	current_operation = _tmp4_;
#line 563 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp6_ = t->artist;
#line 563 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp5_ = _tmp6_;
#line 563 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (_tmp5_ == NULL) {
#line 563 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp5_ = "";
#line 4692 "iPodLibrary.c"
	}
#line 563 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp7_ = current_operation;
#line 563 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp8_ = string_replace (_tmp7_, "$ARTIST", _tmp5_);
#line 563 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_free0 (current_operation);
#line 563 "../plugins/Devices/iPod/iPodLibrary.vala"
	current_operation = _tmp8_;
#line 564 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp10_ = self->priv->device;
#line 564 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp11_ = music_device_get_display_name (_tmp10_);
#line 564 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp9_ = _tmp11_;
#line 564 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (_tmp9_ == NULL) {
#line 4710 "iPodLibrary.c"
		gchar* _tmp12_;
#line 564 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp12_ = g_strdup ("");
#line 564 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_free0 (_tmp9_);
#line 564 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp9_ = _tmp12_;
#line 4718 "iPodLibrary.c"
	}
#line 564 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp13_ = music_libraries_manager;
#line 564 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp14_ = current_operation;
#line 564 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp15_ = string_replace (_tmp14_, "$DEVICE", _tmp9_);
#line 564 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_free0 (_tmp13_->current_operation);
#line 564 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp13_->current_operation = _tmp15_;
#line 566 "../plugins/Devices/iPod/iPodLibrary.vala"
	_tmp16_ = t->ipod_path;
#line 566 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (_tmp16_ != NULL) {
#line 4734 "iPodLibrary.c"
		gchar* uri = NULL;
		MusicDevice* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		GFile* file = NULL;
		const gchar* _tmp25_;
		GFile* _tmp26_;
		GFile* _tmp27_;
#line 567 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp17_ = self->priv->device;
#line 567 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp18_ = music_device_get_uri (_tmp17_);
#line 567 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp19_ = _tmp18_;
#line 567 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp20_ = t->ipod_path;
#line 567 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp21_ = _vala_itdb_filename_ipod2fs (_tmp20_);
#line 567 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp22_ = _tmp21_;
#line 567 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp23_ = g_strconcat (_tmp19_, _tmp22_, NULL);
#line 567 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp24_ = _tmp23_;
#line 567 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_free0 (_tmp22_);
#line 567 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_free0 (_tmp19_);
#line 567 "../plugins/Devices/iPod/iPodLibrary.vala"
		uri = _tmp24_;
#line 568 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp25_ = uri;
#line 568 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp26_ = g_file_new_for_uri (_tmp25_);
#line 568 "../plugins/Devices/iPod/iPodLibrary.vala"
		file = _tmp26_;
#line 569 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp27_ = file;
#line 569 "../plugins/Devices/iPod/iPodLibrary.vala"
		if (g_file_query_exists (_tmp27_, NULL)) {
#line 4780 "iPodLibrary.c"
			{
				Itdb_iTunesDB* _tmp28_;
				Itdb_iTunesDB* _tmp33_;
				GList* _tmp34_;
				Itdb_iTunesDB* _tmp37_;
				GList* _tmp38_;
				GeeArrayList* media_list = NULL;
				GeeArrayList* _tmp41_;
				GeeArrayList* _tmp42_;
				GeeHashMap* _tmp43_;
				gpointer _tmp44_;
				MusicMedia* _tmp45_;
				GeeArrayList* _tmp46_;
				GeeHashMap* _tmp47_;
				GFile* _tmp48_;
				const gchar* _tmp49_;
#line 572 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp28_ = self->priv->db;
#line 572 "../plugins/Devices/iPod/iPodLibrary.vala"
				if (itdb_playlists_number (_tmp28_) != ((guint) 0)) {
#line 4801 "iPodLibrary.c"
					Itdb_iTunesDB* _tmp29_;
					Itdb_Playlist* _tmp30_;
					Itdb_iTunesDB* _tmp31_;
					Itdb_Playlist* _tmp32_;
#line 573 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp29_ = self->priv->db;
#line 573 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp30_ = itdb_playlist_mpl (_tmp29_);
#line 573 "../plugins/Devices/iPod/iPodLibrary.vala"
					itdb_playlist_remove_track (_tmp30_, t);
#line 574 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp31_ = self->priv->db;
#line 574 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp32_ = itdb_playlist_podcasts (_tmp31_);
#line 574 "../plugins/Devices/iPod/iPodLibrary.vala"
					itdb_playlist_remove_track (_tmp32_, t);
#line 4818 "iPodLibrary.c"
				}
#line 577 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp33_ = self->priv->db;
#line 577 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp34_ = _tmp33_->playlists;
#line 4824 "iPodLibrary.c"
				{
					GList* p_collection = NULL;
					GList* p_it = NULL;
#line 577 "../plugins/Devices/iPod/iPodLibrary.vala"
					p_collection = _tmp34_;
#line 577 "../plugins/Devices/iPod/iPodLibrary.vala"
					for (p_it = p_collection; p_it != NULL; p_it = p_it->next) {
#line 4832 "iPodLibrary.c"
						Itdb_Playlist* p = NULL;
#line 577 "../plugins/Devices/iPod/iPodLibrary.vala"
						p = (Itdb_Playlist*) p_it->data;
#line 4836 "iPodLibrary.c"
						{
							Itdb_Playlist* _tmp35_;
#line 578 "../plugins/Devices/iPod/iPodLibrary.vala"
							_tmp35_ = p;
#line 578 "../plugins/Devices/iPod/iPodLibrary.vala"
							if (itdb_playlist_contains_track (_tmp35_, t)) {
#line 4843 "iPodLibrary.c"
								Itdb_Playlist* _tmp36_;
#line 579 "../plugins/Devices/iPod/iPodLibrary.vala"
								_tmp36_ = p;
#line 579 "../plugins/Devices/iPod/iPodLibrary.vala"
								itdb_playlist_remove_track (_tmp36_, t);
#line 4849 "iPodLibrary.c"
							}
						}
					}
				}
#line 582 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp37_ = self->priv->db;
#line 582 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp38_ = _tmp37_->playlists;
#line 4858 "iPodLibrary.c"
				{
					GList* p_collection = NULL;
					GList* p_it = NULL;
#line 582 "../plugins/Devices/iPod/iPodLibrary.vala"
					p_collection = _tmp38_;
#line 582 "../plugins/Devices/iPod/iPodLibrary.vala"
					for (p_it = p_collection; p_it != NULL; p_it = p_it->next) {
#line 4866 "iPodLibrary.c"
						Itdb_Playlist* p = NULL;
#line 582 "../plugins/Devices/iPod/iPodLibrary.vala"
						p = (Itdb_Playlist*) p_it->data;
#line 4870 "iPodLibrary.c"
						{
							Itdb_Playlist* _tmp39_;
#line 583 "../plugins/Devices/iPod/iPodLibrary.vala"
							_tmp39_ = p;
#line 583 "../plugins/Devices/iPod/iPodLibrary.vala"
							if (itdb_playlist_contains_track (_tmp39_, t)) {
#line 4877 "iPodLibrary.c"
								Itdb_Playlist* _tmp40_;
#line 584 "../plugins/Devices/iPod/iPodLibrary.vala"
								_tmp40_ = p;
#line 584 "../plugins/Devices/iPod/iPodLibrary.vala"
								itdb_playlist_remove_track (_tmp40_, t);
#line 4883 "iPodLibrary.c"
							}
						}
					}
				}
#line 588 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp41_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 588 "../plugins/Devices/iPod/iPodLibrary.vala"
				media_list = _tmp41_;
#line 589 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp42_ = media_list;
#line 589 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp43_ = self->priv->medias;
#line 589 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp44_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp43_, t);
#line 589 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp45_ = (MusicMedia*) _tmp44_;
#line 589 "../plugins/Devices/iPod/iPodLibrary.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp42_, _tmp45_);
#line 589 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (_tmp45_);
#line 590 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp46_ = media_list;
#line 590 "../plugins/Devices/iPod/iPodLibrary.vala"
				g_signal_emit_by_name ((MusicLibrary*) self, "media-removed", (GeeCollection*) _tmp46_);
#line 591 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp47_ = self->priv->medias;
#line 591 "../plugins/Devices/iPod/iPodLibrary.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp47_, t, NULL);
#line 592 "../plugins/Devices/iPod/iPodLibrary.vala"
				itdb_track_remove (t);
#line 593 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp48_ = file;
#line 593 "../plugins/Devices/iPod/iPodLibrary.vala"
				g_file_delete (_tmp48_, NULL, &_inner_error0_);
#line 593 "../plugins/Devices/iPod/iPodLibrary.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 593 "../plugins/Devices/iPod/iPodLibrary.vala"
					_g_object_unref0 (media_list);
#line 4922 "iPodLibrary.c"
					goto __catch0_g_error;
				}
#line 594 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp49_ = uri;
#line 594 "../plugins/Devices/iPod/iPodLibrary.vala"
				g_warning ("iPodLibrary.vala:594: Successfully removed music file %s from iPod Dis" \
"k", _tmp49_);
#line 570 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (media_list);
#line 4931 "iPodLibrary.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				const gchar* _tmp50_;
				GError* _tmp51_;
				const gchar* _tmp52_;
#line 570 "../plugins/Devices/iPod/iPodLibrary.vala"
				err = _inner_error0_;
#line 570 "../plugins/Devices/iPod/iPodLibrary.vala"
				_inner_error0_ = NULL;
#line 596 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp50_ = uri;
#line 596 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp51_ = err;
#line 596 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp52_ = _tmp51_->message;
#line 596 "../plugins/Devices/iPod/iPodLibrary.vala"
				g_warning ("iPodLibrary.vala:596: Could not delete iPod File at %s. Unused file wi" \
"ll remain on iPod: %s", _tmp50_, _tmp52_);
#line 570 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_error_free0 (err);
#line 4954 "iPodLibrary.c"
			}
			__finally0:
#line 570 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 570 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (file);
#line 570 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_free0 (uri);
#line 570 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_free0 (_tmp9_);
#line 570 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_free0 (current_operation);
#line 570 "../plugins/Devices/iPod/iPodLibrary.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 570 "../plugins/Devices/iPod/iPodLibrary.vala"
				g_clear_error (&_inner_error0_);
#line 570 "../plugins/Devices/iPod/iPodLibrary.vala"
				return;
#line 4973 "iPodLibrary.c"
			}
		} else {
			const gchar* _tmp53_;
#line 599 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp53_ = uri;
#line 599 "../plugins/Devices/iPod/iPodLibrary.vala"
			g_warning ("iPodLibrary.vala:599: File not found, could not delete iPod File at %s" \
". File may already be deleted", _tmp53_);
#line 4981 "iPodLibrary.c"
		}
#line 566 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (file);
#line 566 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_free0 (uri);
#line 4987 "iPodLibrary.c"
	}
#line 560 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_free0 (_tmp9_);
#line 560 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_free0 (current_operation);
#line 4993 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_cleanup_files (MusicPluginsiPodLibrary* self,
                                          GFile* music_folder,
                                          GeeLinkedList* used_uris)
{
	GFileInfo* file_info = NULL;
	GError* _inner_error0_ = NULL;
#line 604 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (self != NULL);
#line 604 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (music_folder != NULL);
#line 604 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_return_if_fail (used_uris != NULL);
#line 605 "../plugins/Devices/iPod/iPodLibrary.vala"
	file_info = NULL;
#line 5011 "iPodLibrary.c"
	{
		GFileEnumerator* enumerator = NULL;
		GFileEnumerator* _tmp0_;
#line 607 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp0_ = g_file_enumerate_children (music_folder, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE, 0, NULL, &_inner_error0_);
#line 607 "../plugins/Devices/iPod/iPodLibrary.vala"
		enumerator = _tmp0_;
#line 607 "../plugins/Devices/iPod/iPodLibrary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5021 "iPodLibrary.c"
			goto __catch0_g_error;
		}
#line 611 "../plugins/Devices/iPod/iPodLibrary.vala"
		while (TRUE) {
#line 5026 "iPodLibrary.c"
			GFileInfo* _tmp1_ = NULL;
			GFileEnumerator* _tmp2_;
			GFileInfo* _tmp3_;
			GFileInfo* _tmp4_;
			GFileInfo* _tmp5_;
			gchar* file_uri = NULL;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			GFileInfo* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gboolean _tmp14_ = FALSE;
			GFileInfo* _tmp15_;
#line 611 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp2_ = enumerator;
#line 611 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp3_ = g_file_enumerator_next_file (_tmp2_, NULL, &_inner_error0_);
#line 611 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp1_ = _tmp3_;
#line 611 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 611 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (enumerator);
#line 5053 "iPodLibrary.c"
				goto __catch0_g_error;
			}
#line 611 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp4_ = _tmp1_;
#line 611 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp1_ = NULL;
#line 611 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_object_unref0 (file_info);
#line 611 "../plugins/Devices/iPod/iPodLibrary.vala"
			file_info = _tmp4_;
#line 611 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp5_ = file_info;
#line 611 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (!(_tmp5_ != NULL)) {
#line 611 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (_tmp1_);
#line 611 "../plugins/Devices/iPod/iPodLibrary.vala"
				break;
#line 5072 "iPodLibrary.c"
			}
#line 612 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp6_ = g_file_get_uri (music_folder);
#line 612 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp7_ = _tmp6_;
#line 612 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp8_ = g_strconcat (_tmp7_, "/", NULL);
#line 612 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp9_ = _tmp8_;
#line 612 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp10_ = file_info;
#line 612 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp11_ = g_file_info_get_name (_tmp10_);
#line 612 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp12_ = g_strconcat (_tmp9_, _tmp11_, NULL);
#line 612 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp13_ = _tmp12_;
#line 612 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_free0 (_tmp9_);
#line 612 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_free0 (_tmp7_);
#line 612 "../plugins/Devices/iPod/iPodLibrary.vala"
			file_uri = _tmp13_;
#line 613 "../plugins/Devices/iPod/iPodLibrary.vala"
			_tmp15_ = file_info;
#line 613 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (g_file_info_get_file_type (_tmp15_) == G_FILE_TYPE_REGULAR) {
#line 5100 "iPodLibrary.c"
				const gchar* _tmp16_;
#line 613 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp16_ = file_uri;
#line 613 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp14_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) used_uris, _tmp16_);
#line 5106 "iPodLibrary.c"
			} else {
#line 613 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp14_ = FALSE;
#line 5110 "iPodLibrary.c"
			}
#line 613 "../plugins/Devices/iPod/iPodLibrary.vala"
			if (_tmp14_) {
#line 5114 "iPodLibrary.c"
				const gchar* _tmp17_;
				GFile* file = NULL;
				const gchar* _tmp18_;
				GFile* _tmp19_;
				GFile* _tmp20_;
#line 614 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp17_ = file_uri;
#line 614 "../plugins/Devices/iPod/iPodLibrary.vala"
				g_message ("iPodLibrary.vala:614: Deleting unused file %s\n", _tmp17_);
#line 615 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp18_ = file_uri;
#line 615 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp19_ = g_file_new_for_uri (_tmp18_);
#line 615 "../plugins/Devices/iPod/iPodLibrary.vala"
				file = _tmp19_;
#line 616 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp20_ = file;
#line 616 "../plugins/Devices/iPod/iPodLibrary.vala"
				g_file_delete (_tmp20_, NULL, &_inner_error0_);
#line 616 "../plugins/Devices/iPod/iPodLibrary.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 616 "../plugins/Devices/iPod/iPodLibrary.vala"
					_g_object_unref0 (file);
#line 616 "../plugins/Devices/iPod/iPodLibrary.vala"
					_g_free0 (file_uri);
#line 616 "../plugins/Devices/iPod/iPodLibrary.vala"
					_g_object_unref0 (_tmp1_);
#line 616 "../plugins/Devices/iPod/iPodLibrary.vala"
					_g_object_unref0 (enumerator);
#line 5144 "iPodLibrary.c"
					goto __catch0_g_error;
				}
#line 613 "../plugins/Devices/iPod/iPodLibrary.vala"
				_g_object_unref0 (file);
#line 5149 "iPodLibrary.c"
			} else {
				GFileInfo* _tmp21_;
#line 617 "../plugins/Devices/iPod/iPodLibrary.vala"
				_tmp21_ = file_info;
#line 617 "../plugins/Devices/iPod/iPodLibrary.vala"
				if (g_file_info_get_file_type (_tmp21_) == G_FILE_TYPE_REGULAR) {
#line 5156 "iPodLibrary.c"
					const gchar* _tmp22_;
#line 618 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp22_ = file_uri;
#line 618 "../plugins/Devices/iPod/iPodLibrary.vala"
					gee_abstract_collection_remove ((GeeAbstractCollection*) used_uris, _tmp22_);
#line 5162 "iPodLibrary.c"
				} else {
					GFileInfo* _tmp23_;
#line 619 "../plugins/Devices/iPod/iPodLibrary.vala"
					_tmp23_ = file_info;
#line 619 "../plugins/Devices/iPod/iPodLibrary.vala"
					if (g_file_info_get_file_type (_tmp23_) == G_FILE_TYPE_DIRECTORY) {
#line 5169 "iPodLibrary.c"
						const gchar* _tmp24_;
						GFile* _tmp25_;
						GFile* _tmp26_;
#line 620 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp24_ = file_uri;
#line 620 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp25_ = g_file_new_for_uri (_tmp24_);
#line 620 "../plugins/Devices/iPod/iPodLibrary.vala"
						_tmp26_ = _tmp25_;
#line 620 "../plugins/Devices/iPod/iPodLibrary.vala"
						music_plugins_ipod_library_cleanup_files (self, _tmp26_, used_uris);
#line 620 "../plugins/Devices/iPod/iPodLibrary.vala"
						_g_object_unref0 (_tmp26_);
#line 5183 "iPodLibrary.c"
					}
				}
			}
#line 611 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_free0 (file_uri);
#line 611 "../plugins/Devices/iPod/iPodLibrary.vala"
			_g_object_unref0 (_tmp1_);
#line 5191 "iPodLibrary.c"
		}
#line 606 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (enumerator);
#line 5195 "iPodLibrary.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
#line 606 "../plugins/Devices/iPod/iPodLibrary.vala"
		err = _inner_error0_;
#line 606 "../plugins/Devices/iPod/iPodLibrary.vala"
		_inner_error0_ = NULL;
#line 624 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp27_ = err;
#line 624 "../plugins/Devices/iPod/iPodLibrary.vala"
		_tmp28_ = _tmp27_->message;
#line 624 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_critical ("iPodLibrary.vala:624: Could not pre-scan music folder. Progress percen" \
"tage may be off: %s", _tmp28_);
#line 606 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_error_free0 (err);
#line 5215 "iPodLibrary.c"
	}
	__finally0:
#line 606 "../plugins/Devices/iPod/iPodLibrary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 606 "../plugins/Devices/iPod/iPodLibrary.vala"
		_g_object_unref0 (file_info);
#line 606 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 606 "../plugins/Devices/iPod/iPodLibrary.vala"
		g_clear_error (&_inner_error0_);
#line 606 "../plugins/Devices/iPod/iPodLibrary.vala"
		return;
#line 5228 "iPodLibrary.c"
	}
#line 604 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (file_info);
#line 5232 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_class_init (MusicPluginsiPodLibraryClass * klass,
                                       gpointer klass_data)
{
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	music_plugins_ipod_library_parent_class = g_type_class_peek_parent (klass);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_type_class_adjust_private_offset (klass, &MusicPluginsiPodLibrary_private_offset);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->initialize_library = (void (*) (MusicLibrary*)) music_plugins_ipod_library_real_initialize_library;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->add_files_to_library = (void (*) (MusicLibrary*, GeeCollection*)) music_plugins_ipod_library_real_add_files_to_library;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->search_medias = (void (*) (MusicLibrary*, const gchar*)) music_plugins_ipod_library_real_search_medias;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->get_search_result = (GeeCollection* (*) (MusicLibrary*)) music_plugins_ipod_library_real_get_search_result;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->get_medias = (GeeCollection* (*) (MusicLibrary*)) music_plugins_ipod_library_real_get_medias;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->get_playlists = (GeeCollection* (*) (MusicLibrary*)) music_plugins_ipod_library_real_get_playlists;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->get_smart_playlists = (GeeCollection* (*) (MusicLibrary*)) music_plugins_ipod_library_real_get_smart_playlists;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->add_media = (void (*) (MusicLibrary*, MusicMedia*)) music_plugins_ipod_library_real_add_media;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->add_medias = (void (*) (MusicLibrary*, GeeCollection*)) music_plugins_ipod_library_real_add_medias;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->media_from_id = (MusicMedia* (*) (MusicLibrary*, gint64)) music_plugins_ipod_library_real_media_from_id;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->medias_from_ids = (GeeCollection* (*) (MusicLibrary*, GeeCollection*)) music_plugins_ipod_library_real_medias_from_ids;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->medias_from_uris = (GeeCollection* (*) (MusicLibrary*, GeeCollection*)) music_plugins_ipod_library_real_medias_from_uris;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->find_media = (MusicMedia* (*) (MusicLibrary*, MusicMedia*)) music_plugins_ipod_library_real_find_media;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->media_from_file = (MusicMedia* (*) (MusicLibrary*, GFile*)) music_plugins_ipod_library_real_media_from_file;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->media_from_uri = (MusicMedia* (*) (MusicLibrary*, const gchar*)) music_plugins_ipod_library_real_media_from_uri;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->update_media = (void (*) (MusicLibrary*, MusicMedia*, gboolean, gboolean)) music_plugins_ipod_library_real_update_media;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->update_medias = (void (*) (MusicLibrary*, GeeCollection*, gboolean, gboolean)) music_plugins_ipod_library_real_update_medias;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->remove_media = (void (*) (MusicLibrary*, MusicMedia*, gboolean)) music_plugins_ipod_library_real_remove_media;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->remove_medias = (void (*) (MusicLibrary*, GeeCollection*, gboolean)) music_plugins_ipod_library_real_remove_medias;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->add_smart_playlist = (void (*) (MusicLibrary*, MusicSmartPlaylist*)) music_plugins_ipod_library_real_add_smart_playlist;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->support_smart_playlists = (gboolean (*) (MusicLibrary*)) music_plugins_ipod_library_real_support_smart_playlists;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->remove_smart_playlist = (void (*) (MusicLibrary*, gint64)) music_plugins_ipod_library_real_remove_smart_playlist;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->smart_playlist_from_id = (MusicSmartPlaylist* (*) (MusicLibrary*, gint64)) music_plugins_ipod_library_real_smart_playlist_from_id;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->smart_playlist_from_name = (MusicSmartPlaylist* (*) (MusicLibrary*, const gchar*)) music_plugins_ipod_library_real_smart_playlist_from_name;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->support_playlists = (gboolean (*) (MusicLibrary*)) music_plugins_ipod_library_real_support_playlists;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->add_playlist = (void (*) (MusicLibrary*, MusicStaticPlaylist*)) music_plugins_ipod_library_real_add_playlist;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->remove_playlist = (void (*) (MusicLibrary*, gint64)) music_plugins_ipod_library_real_remove_playlist;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->playlist_from_id = (MusicStaticPlaylist* (*) (MusicLibrary*, gint64)) music_plugins_ipod_library_real_playlist_from_id;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->playlist_from_name = (MusicStaticPlaylist* (*) (MusicLibrary*, const gchar*)) music_plugins_ipod_library_real_playlist_from_name;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->start_file_operations = (gboolean (*) (MusicLibrary*, const gchar*)) music_plugins_ipod_library_real_start_file_operations;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->doing_file_operations = (gboolean (*) (MusicLibrary*)) music_plugins_ipod_library_real_doing_file_operations;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	((MusicLibraryClass *) klass)->finish_file_operations = (void (*) (MusicLibrary*)) music_plugins_ipod_library_real_finish_file_operations;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	G_OBJECT_CLASS (klass)->finalize = music_plugins_ipod_library_finalize;
#line 5309 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_instance_init (MusicPluginsiPodLibrary * self,
                                          gpointer klass)
{
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	self->priv = music_plugins_ipod_library_get_instance_private (self);
#line 31 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_rec_mutex_init (&self->priv->__lock_medias);
#line 32 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_rec_mutex_init (&self->priv->__lock_searched_medias);
#line 36 "../plugins/Devices/iPod/iPodLibrary.vala"
	self->priv->operation_cancelled = FALSE;
#line 37 "../plugins/Devices/iPod/iPodLibrary.vala"
	self->priv->is_doing_file_operations = FALSE;
#line 5326 "iPodLibrary.c"
}

static void
music_plugins_ipod_library_finalize (GObject * obj)
{
	MusicPluginsiPodLibrary * self;
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_IPOD_LIBRARY, MusicPluginsiPodLibrary);
#line 31 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_rec_mutex_clear (&self->priv->__lock_medias);
#line 31 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (self->priv->medias);
#line 32 "../plugins/Devices/iPod/iPodLibrary.vala"
	g_rec_mutex_clear (&self->priv->__lock_searched_medias);
#line 32 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (self->priv->searched_medias);
#line 33 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (self->priv->playlists);
#line 34 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (self->priv->smart_playlists);
#line 35 "../plugins/Devices/iPod/iPodLibrary.vala"
	_g_object_unref0 (self->priv->device);
#line 29 "../plugins/Devices/iPod/iPodLibrary.vala"
	G_OBJECT_CLASS (music_plugins_ipod_library_parent_class)->finalize (obj);
#line 5351 "iPodLibrary.c"
}

GType
music_plugins_ipod_library_get_type (void)
{
	return music_plugins_ipod_library_type_id;
}

GType
music_plugins_ipod_library_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsiPodLibraryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_ipod_library_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsiPodLibrary), 0, (GInstanceInitFunc) music_plugins_ipod_library_instance_init, NULL };
	music_plugins_ipod_library_type_id = g_type_module_register_type (module, MUSIC_TYPE_LIBRARY, "MusicPluginsiPodLibrary", &g_define_type_info, 0);
	MusicPluginsiPodLibrary_private_offset = sizeof (MusicPluginsiPodLibraryPrivate);
	return music_plugins_ipod_library_type_id;
}

